#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 4386
#define SYMBOL_COUNT 156
#define ALIAS_COUNT 2
#define TOKEN_COUNT 97
#define EXTERNAL_TOKEN_COUNT 15
#define MAX_ALIAS_SEQUENCE_LENGTH 8

enum {
  sym_heredoc_start = 1,
  sym__simple_heredoc_body = 2,
  sym__heredoc_body_beginning = 3,
  sym__heredoc_body_middle = 4,
  sym__heredoc_body_end = 5,
  sym_file_descriptor = 6,
  sym__empty_value = 7,
  sym__concat = 8,
  sym_variable_name = 9,
  sym_regex = 10,
  anon_sym_for = 11,
  anon_sym_in = 12,
  anon_sym_LPAREN_LPAREN = 13,
  anon_sym_RPAREN_RPAREN = 14,
  anon_sym_SEMI = 15,
  anon_sym_while = 16,
  anon_sym_do = 17,
  anon_sym_done = 18,
  anon_sym_if = 19,
  anon_sym_then = 20,
  anon_sym_fi = 21,
  anon_sym_elif = 22,
  anon_sym_else = 23,
  anon_sym_case = 24,
  anon_sym_esac = 25,
  anon_sym_PIPE = 26,
  anon_sym_RPAREN = 27,
  anon_sym_SEMI_SEMI = 28,
  anon_sym_function = 29,
  anon_sym_LPAREN = 30,
  anon_sym_LBRACE = 31,
  anon_sym_RBRACE = 32,
  anon_sym_PIPE_AMP = 33,
  anon_sym_AMP_AMP = 34,
  anon_sym_PIPE_PIPE = 35,
  anon_sym_BANG = 36,
  anon_sym_LBRACK = 37,
  anon_sym_RBRACK = 38,
  anon_sym_LBRACK_LBRACK = 39,
  anon_sym_RBRACK_RBRACK = 40,
  anon_sym_declare = 41,
  anon_sym_typeset = 42,
  anon_sym_export = 43,
  anon_sym_readonly = 44,
  anon_sym_local = 45,
  anon_sym_unset = 46,
  anon_sym_unsetenv = 47,
  anon_sym_EQ_TILDE = 48,
  anon_sym_EQ_EQ = 49,
  anon_sym_EQ = 50,
  anon_sym_PLUS_EQ = 51,
  anon_sym_LT = 52,
  anon_sym_GT = 53,
  anon_sym_GT_GT = 54,
  anon_sym_AMP_GT = 55,
  anon_sym_AMP_GT_GT = 56,
  anon_sym_LT_AMP = 57,
  anon_sym_GT_AMP = 58,
  anon_sym_LT_LT = 59,
  anon_sym_LT_LT_DASH = 60,
  anon_sym_LT_LT_LT = 61,
  anon_sym_BANG_EQ = 62,
  anon_sym_PLUS = 63,
  anon_sym_DASH = 64,
  anon_sym_DASH_EQ = 65,
  anon_sym_LT_EQ = 66,
  anon_sym_GT_EQ = 67,
  anon_sym_PLUS_PLUS = 68,
  anon_sym_DASH_DASH = 69,
  sym__special_character = 70,
  anon_sym_DQUOTE = 71,
  anon_sym_DOLLAR = 72,
  sym__string_content = 73,
  sym_raw_string = 74,
  anon_sym_POUND = 75,
  anon_sym_DOLLAR_LBRACE = 76,
  anon_sym_SLASH = 77,
  anon_sym_COLON = 78,
  anon_sym_COLON_QMARK = 79,
  anon_sym_COLON_DASH = 80,
  anon_sym_PERCENT = 81,
  anon_sym_DOLLAR_LPAREN = 82,
  anon_sym_BQUOTE = 83,
  anon_sym_LT_LPAREN = 84,
  anon_sym_GT_LPAREN = 85,
  sym_comment = 86,
  aux_sym_SLASH_BSLASHw_PLUS_SLASH = 87,
  anon_sym_STAR = 88,
  anon_sym_AT = 89,
  anon_sym_QMARK = 90,
  anon_sym_0 = 91,
  anon_sym__ = 92,
  sym_word = 93,
  sym_test_operator = 94,
  anon_sym_LF = 95,
  anon_sym_AMP = 96,
  sym_program = 97,
  sym__statements = 98,
  sym__terminated_statement = 99,
  sym_redirected_statement = 100,
  sym_for_statement = 101,
  sym_c_style_for_statement = 102,
  sym_while_statement = 103,
  sym_do_group = 104,
  sym_if_statement = 105,
  sym_elif_clause = 106,
  sym_else_clause = 107,
  sym_case_statement = 108,
  sym_case_item = 109,
  sym_last_case_item = 110,
  sym_function_definition = 111,
  sym_compound_statement = 112,
  sym_subshell = 113,
  sym_pipeline = 114,
  sym_list = 115,
  sym_negated_command = 116,
  sym_test_command = 117,
  sym_declaration_command = 118,
  sym_unset_command = 119,
  sym_command = 120,
  sym_command_name = 121,
  sym_variable_assignment = 122,
  sym_subscript = 123,
  sym_file_redirect = 124,
  sym_heredoc_redirect = 125,
  sym_heredoc_body = 126,
  sym_herestring_redirect = 127,
  sym__expression = 128,
  sym_binary_expression = 129,
  sym_unary_expression = 130,
  sym_postfix_expression = 131,
  sym_parenthesized_expression = 132,
  sym_concatenation = 133,
  sym_string = 134,
  sym_array = 135,
  sym_simple_expansion = 136,
  sym_string_expansion = 137,
  sym_expansion = 138,
  sym_command_substitution = 139,
  sym_process_substitution = 140,
  aux_sym__statements_repeat1 = 141,
  aux_sym_redirected_statement_repeat1 = 142,
  aux_sym_for_statement_repeat1 = 143,
  aux_sym_if_statement_repeat1 = 144,
  aux_sym_case_statement_repeat1 = 145,
  aux_sym_case_item_repeat1 = 146,
  aux_sym_declaration_command_repeat1 = 147,
  aux_sym_unset_command_repeat1 = 148,
  aux_sym_command_repeat1 = 149,
  aux_sym_command_repeat2 = 150,
  aux_sym_heredoc_body_repeat1 = 151,
  aux_sym__literal_repeat1 = 152,
  aux_sym_concatenation_repeat1 = 153,
  aux_sym_string_repeat1 = 154,
  aux_sym_expansion_repeat1 = 155,
  alias_sym_special_variable_name = 156,
  alias_sym_word = 157,
};

static const char *ts_symbol_names[] = {
  [sym_heredoc_start] = "heredoc_start",
  [sym__simple_heredoc_body] = "_simple_heredoc_body",
  [sym__heredoc_body_beginning] = "_heredoc_body_beginning",
  [sym__heredoc_body_middle] = "_heredoc_body_middle",
  [sym__heredoc_body_end] = "_heredoc_body_end",
  [sym_file_descriptor] = "file_descriptor",
  [sym__empty_value] = "_empty_value",
  [sym__concat] = "_concat",
  [sym_variable_name] = "variable_name",
  [sym_regex] = "regex",
  [ts_builtin_sym_end] = "END",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_LPAREN_LPAREN] = "((",
  [anon_sym_RPAREN_RPAREN] = "))",
  [anon_sym_SEMI] = ";",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_done] = "done",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_fi] = "fi",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_case] = "case",
  [anon_sym_esac] = "esac",
  [anon_sym_PIPE] = "|",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SEMI_SEMI] = ";;",
  [anon_sym_function] = "function",
  [anon_sym_LPAREN] = "(",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_PIPE_AMP] = "|&",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_BANG] = "!",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym_declare] = "declare",
  [anon_sym_typeset] = "typeset",
  [anon_sym_export] = "export",
  [anon_sym_readonly] = "readonly",
  [anon_sym_local] = "local",
  [anon_sym_unset] = "unset",
  [anon_sym_unsetenv] = "unsetenv",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_GT] = "&>",
  [anon_sym_AMP_GT_GT] = "&>>",
  [anon_sym_LT_AMP] = "<&",
  [anon_sym_GT_AMP] = ">&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_LT_LT_DASH] = "<<-",
  [anon_sym_LT_LT_LT] = "<<<",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [sym__special_character] = "_special_character",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_DOLLAR] = "$",
  [sym__string_content] = "_string_content",
  [sym_raw_string] = "raw_string",
  [anon_sym_POUND] = "#",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH] = "/",
  [anon_sym_COLON] = ":",
  [anon_sym_COLON_QMARK] = ":?",
  [anon_sym_COLON_DASH] = ":-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_LT_LPAREN] = "<(",
  [anon_sym_GT_LPAREN] = ">(",
  [sym_comment] = "comment",
  [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = "variable_name",
  [anon_sym_STAR] = "special_variable_name",
  [anon_sym_AT] = "special_variable_name",
  [anon_sym_QMARK] = "special_variable_name",
  [anon_sym_0] = "special_variable_name",
  [anon_sym__] = "special_variable_name",
  [sym_word] = "word",
  [sym_test_operator] = "test_operator",
  [anon_sym_LF] = "\n",
  [anon_sym_AMP] = "&",
  [sym_program] = "program",
  [sym__statements] = "_statements",
  [sym__terminated_statement] = "_terminated_statement",
  [sym_redirected_statement] = "redirected_statement",
  [sym_for_statement] = "for_statement",
  [sym_c_style_for_statement] = "c_style_for_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_group] = "do_group",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_case_statement] = "case_statement",
  [sym_case_item] = "case_item",
  [sym_last_case_item] = "case_item",
  [sym_function_definition] = "function_definition",
  [sym_compound_statement] = "compound_statement",
  [sym_subshell] = "subshell",
  [sym_pipeline] = "pipeline",
  [sym_list] = "list",
  [sym_negated_command] = "negated_command",
  [sym_test_command] = "test_command",
  [sym_declaration_command] = "declaration_command",
  [sym_unset_command] = "unset_command",
  [sym_command] = "command",
  [sym_command_name] = "command_name",
  [sym_variable_assignment] = "variable_assignment",
  [sym_subscript] = "subscript",
  [sym_file_redirect] = "file_redirect",
  [sym_heredoc_redirect] = "heredoc_redirect",
  [sym_heredoc_body] = "heredoc_body",
  [sym_herestring_redirect] = "herestring_redirect",
  [sym__expression] = "_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_postfix_expression] = "postfix_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_concatenation] = "concatenation",
  [sym_string] = "string",
  [sym_array] = "array",
  [sym_simple_expansion] = "simple_expansion",
  [sym_string_expansion] = "string_expansion",
  [sym_expansion] = "expansion",
  [sym_command_substitution] = "command_substitution",
  [sym_process_substitution] = "process_substitution",
  [aux_sym__statements_repeat1] = "_statements_repeat1",
  [aux_sym_redirected_statement_repeat1] = "redirected_statement_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_case_item_repeat1] = "case_item_repeat1",
  [aux_sym_declaration_command_repeat1] = "declaration_command_repeat1",
  [aux_sym_unset_command_repeat1] = "unset_command_repeat1",
  [aux_sym_command_repeat1] = "command_repeat1",
  [aux_sym_command_repeat2] = "command_repeat2",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym__literal_repeat1] = "_literal_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_expansion_repeat1] = "expansion_repeat1",
  [alias_sym_special_variable_name] = "special_variable_name",
  [alias_sym_word] = "word",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym_heredoc_start] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_heredoc_body] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_beginning] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_middle] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_end] = {
    .visible = false,
    .named = true,
  },
  [sym_file_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_value] = {
    .visible = false,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_done] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_esac] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsetenv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [sym__special_character] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_raw_string] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__] = {
    .visible = true,
    .named = true,
  },
  [sym_word] = {
    .visible = true,
    .named = true,
  },
  [sym_test_operator] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__statements] = {
    .visible = false,
    .named = true,
  },
  [sym__terminated_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_redirected_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_c_style_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_group] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_last_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_pipeline] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_negated_command] = {
    .visible = true,
    .named = true,
  },
  [sym_test_command] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_command] = {
    .visible = true,
    .named = true,
  },
  [sym_unset_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command_name] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_file_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [sym_herestring_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_postfix_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_string_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_command_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_process_substitution] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_redirected_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_item_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unset_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expansion_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_special_variable_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_word] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[8][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_word,
  },
  [2] = {
    [1] = alias_sym_word,
  },
  [3] = {
    [1] = alias_sym_special_variable_name,
  },
  [4] = {
    [2] = alias_sym_word,
  },
  [5] = {
    [2] = alias_sym_special_variable_name,
  },
  [6] = {
    [3] = alias_sym_word,
  },
  [7] = {
    [4] = alias_sym_word,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(11);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(21);
      if (lookahead == '+')
        ADVANCE(22);
      if (lookahead == '-')
        ADVANCE(25);
      if (lookahead == '/')
        ADVANCE(29);
      if (lookahead == '0')
        ADVANCE(30);
      if (lookahead == ':')
        ADVANCE(31);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(36);
      if (lookahead == '=')
        ADVANCE(43);
      if (lookahead == '>')
        ADVANCE(46);
      if (lookahead == '?')
        ADVANCE(51);
      if (lookahead == '@')
        ADVANCE(52);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(55);
      if (lookahead == ']')
        ADVANCE(56);
      if (lookahead == '_')
        ADVANCE(58);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(60);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == 'i')
        ADVANCE(71);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      ADVANCE(5);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 4:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(5);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '{')
        ADVANCE(10);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(13);
      if (lookahead == '>')
        ADVANCE(14);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_AMP_GT);
      if (lookahead == '>')
        ADVANCE(15);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_AMP_GT_GT);
      END_STATE();
    case 16:
      if (lookahead == '\'')
        ADVANCE(17);
      if (lookahead != 0)
        ADVANCE(16);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(sym_raw_string);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '(')
        ADVANCE(19);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_LPAREN_LPAREN);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(23);
      if (lookahead == '=')
        ADVANCE(24);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(26);
      if (lookahead == '=')
        ADVANCE(27);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(28);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '`' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(sym_test_operator);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(28);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_0);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(32);
      if (lookahead == '?')
        ADVANCE(33);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '?' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == ';')
        ADVANCE(35);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_SEMI_SEMI);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(37);
      if (lookahead == '(')
        ADVANCE(38);
      if (lookahead == '<')
        ADVANCE(39);
      if (lookahead == '=')
        ADVANCE(42);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_LT_AMP);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '-')
        ADVANCE(40);
      if (lookahead == '<')
        ADVANCE(41);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_LT_LT_LT);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(44);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == '~')
        ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(5);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(47);
      if (lookahead == '(')
        ADVANCE(48);
      if (lookahead == '=')
        ADVANCE(49);
      if (lookahead == '>')
        ADVANCE(50);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_GT_AMP);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[')
        ADVANCE(54);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 55:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == ']')
        ADVANCE(57);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'l')
        ADVANCE(61);
      if (lookahead == 's')
        ADVANCE(66);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'i')
        ADVANCE(62);
      if (lookahead == 's')
        ADVANCE(64);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'f')
        ADVANCE(63);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_elif);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'e')
        ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'a')
        ADVANCE(67);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'c')
        ADVANCE(68);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'i')
        ADVANCE(70);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_fi);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'n')
        ADVANCE(72);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(75);
      if (lookahead == '|')
        ADVANCE(76);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_PIPE_AMP);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 78:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(83);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(78);
      if ((lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(79);
      END_STATE();
    case 80:
      if (lookahead == '>')
        ADVANCE(14);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(37);
      if (lookahead == '(')
        ADVANCE(38);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(47);
      if (lookahead == '(')
        ADVANCE(48);
      if (lookahead == '>')
        ADVANCE(50);
      END_STATE();
    case 83:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(78);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym__special_character);
      END_STATE();
    case 85:
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '+')
        ADVANCE(86);
      if (lookahead == ';')
        ADVANCE(88);
      if (lookahead == '=')
        ADVANCE(89);
      if (lookahead == '[')
        ADVANCE(90);
      if (lookahead == '\\')
        SKIP(91);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(85);
      END_STATE();
    case 86:
      if (lookahead == '=')
        ADVANCE(87);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 88:
      if (lookahead == ';')
        ADVANCE(35);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 91:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(85);
      END_STATE();
    case 92:
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '(')
        ADVANCE(93);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(94);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(92);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 93:
      if (lookahead == '(')
        ADVANCE(19);
      END_STATE();
    case 94:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(92);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 96:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(101);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(96);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(28);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '`' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 99:
      if (lookahead == '(')
        ADVANCE(38);
      END_STATE();
    case 100:
      if (lookahead == '(')
        ADVANCE(48);
      END_STATE();
    case 101:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(96);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 102:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(103);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(102);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 103:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(102);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 104:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(105);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(104);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 105:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(104);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 106:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(107);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(106);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 107:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(106);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 108:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(110);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(108);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(37);
      if (lookahead == '(')
        ADVANCE(38);
      if (lookahead == '<')
        ADVANCE(39);
      END_STATE();
    case 110:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(108);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 112:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(114);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(112);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '=')
        ADVANCE(44);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == '~')
        ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < ';' || lookahead > '>') &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(5);
      END_STATE();
    case 114:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(112);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 115:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(116);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\\')
        ADVANCE(120);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(121);
      if (lookahead != 0)
        ADVANCE(117);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(117);
      if (lookahead == '\\')
        ADVANCE(119);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(116);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\\')
        ADVANCE(118);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(117);
      END_STATE();
    case 118:
      if (lookahead == '\n')
        ADVANCE(117);
      if (lookahead != 0)
        ADVANCE(117);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n')
        ADVANCE(117);
      if (lookahead != 0)
        ADVANCE(116);
      END_STATE();
    case 120:
      if (lookahead == '\n')
        ADVANCE(121);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(121);
      if (lookahead != 0)
        ADVANCE(117);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '#')
        ADVANCE(116);
      if (lookahead == '\\')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(121);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(117);
      END_STATE();
    case 122:
      if (lookahead == '!')
        ADVANCE(123);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(124);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(125);
      if (lookahead == '-')
        ADVANCE(126);
      if (lookahead == '0')
        ADVANCE(127);
      if (lookahead == '?')
        ADVANCE(128);
      if (lookahead == '@')
        ADVANCE(129);
      if (lookahead == '\\')
        SKIP(130);
      if (lookahead == '_')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(122);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 130:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(122);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 132:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(133);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(132);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 133:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(132);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 134:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '\\')
        SKIP(135);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(134);
      END_STATE();
    case 135:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(134);
      END_STATE();
    case 136:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '\\')
        SKIP(139);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(136);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(37);
      if (lookahead == '<')
        ADVANCE(39);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(47);
      if (lookahead == '>')
        ADVANCE(50);
      END_STATE();
    case 139:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(136);
      END_STATE();
    case 140:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(141);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(140);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 141:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(140);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 142:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(143);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(142);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 143:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(142);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 144:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(145);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(144);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 145:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(144);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 146:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(148);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(146);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 148:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(146);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 149:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(150);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == 'i')
        ADVANCE(151);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(149);
      END_STATE();
    case 150:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(149);
      END_STATE();
    case 151:
      if (lookahead == 'n')
        ADVANCE(152);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 153:
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(156);
      if (lookahead == ')')
        ADVANCE(157);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(170);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(171);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(153);
      END_STATE();
    case 154:
      if (lookahead == '=')
        ADVANCE(155);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 156:
      if (lookahead == '&')
        ADVANCE(13);
      END_STATE();
    case 157:
      if (lookahead == ')')
        ADVANCE(158);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_RPAREN_RPAREN);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(160);
      if (lookahead == '=')
        ADVANCE(87);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(162);
      if (lookahead == '=')
        ADVANCE(163);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(164);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_test_operator);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(164);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=')
        ADVANCE(42);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(167);
      if (lookahead == '~')
        ADVANCE(168);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(49);
      END_STATE();
    case 170:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(153);
      END_STATE();
    case 171:
      if (lookahead == '|')
        ADVANCE(76);
      END_STATE();
    case 172:
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == '\\')
        SKIP(173);
      if (lookahead == 'd')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(172);
      END_STATE();
    case 173:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(172);
      END_STATE();
    case 174:
      if (lookahead == 'o')
        ADVANCE(175);
      END_STATE();
    case 175:
      if (lookahead == 'n')
        ADVANCE(176);
      END_STATE();
    case 176:
      if (lookahead == 'e')
        ADVANCE(177);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_done);
      END_STATE();
    case 178:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(179);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(178);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 179:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(178);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 180:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(181);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(180);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 181:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(180);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 182:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(183);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(182);
      END_STATE();
    case 183:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(182);
      END_STATE();
    case 184:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(185);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(184);
      if ((lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 185:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(184);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 186:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '\\')
        SKIP(187);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'd')
        ADVANCE(174);
      if (lookahead == 'e')
        ADVANCE(188);
      if (lookahead == 'f')
        ADVANCE(197);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(186);
      END_STATE();
    case 187:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(186);
      END_STATE();
    case 188:
      if (lookahead == 'l')
        ADVANCE(189);
      if (lookahead == 's')
        ADVANCE(194);
      END_STATE();
    case 189:
      if (lookahead == 'i')
        ADVANCE(190);
      if (lookahead == 's')
        ADVANCE(192);
      END_STATE();
    case 190:
      if (lookahead == 'f')
        ADVANCE(191);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 192:
      if (lookahead == 'e')
        ADVANCE(193);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 194:
      if (lookahead == 'a')
        ADVANCE(195);
      END_STATE();
    case 195:
      if (lookahead == 'c')
        ADVANCE(196);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_esac);
      END_STATE();
    case 197:
      if (lookahead == 'i')
        ADVANCE(198);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_fi);
      END_STATE();
    case 199:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(200);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(199);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 200:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(199);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 201:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(202);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(201);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 202:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(201);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 203:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(204);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(203);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 204:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(203);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 205:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(206);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(205);
      END_STATE();
    case 206:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(205);
      END_STATE();
    case 207:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(208);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(207);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 208:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(207);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 209:
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(156);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(210);
      if (lookahead == ']')
        ADVANCE(211);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(171);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(209);
      END_STATE();
    case 210:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(209);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 212:
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(156);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(213);
      if (lookahead == ']')
        ADVANCE(214);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(171);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(212);
      END_STATE();
    case 213:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(212);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym__special_character);
      if (lookahead == ']')
        ADVANCE(57);
      END_STATE();
    case 215:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(216);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(215);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 216:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(215);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 217:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(124);
      if (lookahead == '*')
        ADVANCE(125);
      if (lookahead == '-')
        ADVANCE(126);
      if (lookahead == '0')
        ADVANCE(218);
      if (lookahead == '?')
        ADVANCE(128);
      if (lookahead == '@')
        ADVANCE(129);
      if (lookahead == '\\')
        ADVANCE(220);
      if (lookahead == '_')
        ADVANCE(222);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(221);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(219);
      if (lookahead != 0 &&
          (lookahead < '_' || lookahead > 'z'))
        ADVANCE(117);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(219);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(219);
      END_STATE();
    case 220:
      if (lookahead == '\n')
        ADVANCE(221);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(221);
      if (lookahead != 0)
        ADVANCE(117);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '*')
        ADVANCE(125);
      if (lookahead == '-')
        ADVANCE(126);
      if (lookahead == '0')
        ADVANCE(218);
      if (lookahead == '?')
        ADVANCE(128);
      if (lookahead == '@')
        ADVANCE(129);
      if (lookahead == '\\')
        ADVANCE(220);
      if (lookahead == '_')
        ADVANCE(222);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(221);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(219);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '_' || lookahead > 'z'))
        ADVANCE(117);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(219);
      END_STATE();
    case 223:
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(124);
      if (lookahead == '*')
        ADVANCE(125);
      if (lookahead == '-')
        ADVANCE(126);
      if (lookahead == '0')
        ADVANCE(127);
      if (lookahead == '?')
        ADVANCE(128);
      if (lookahead == '@')
        ADVANCE(129);
      if (lookahead == '\\')
        SKIP(224);
      if (lookahead == '_')
        ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(223);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(95);
      END_STATE();
    case 224:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(223);
      END_STATE();
    case 225:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(11);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '-')
        ADVANCE(226);
      if (lookahead == '/')
        ADVANCE(29);
      if (lookahead == ':')
        ADVANCE(31);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '=')
        ADVANCE(227);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(228);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(225);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 228:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(225);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 229:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(230);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(229);
      END_STATE();
    case 230:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(229);
      END_STATE();
    case 231:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '\\')
        SKIP(232);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'd')
        ADVANCE(174);
      if (lookahead == 'e')
        ADVANCE(188);
      if (lookahead == 'f')
        ADVANCE(197);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(231);
      END_STATE();
    case 232:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(231);
      END_STATE();
    case 233:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(88);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(234);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(233);
      if ((lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 234:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(233);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 235:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '\\')
        SKIP(236);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(235);
      END_STATE();
    case 236:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(235);
      END_STATE();
    case 237:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(238);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(237);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 238:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(237);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 239:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(240);
      if (lookahead == ']')
        ADVANCE(211);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(239);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 240:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(239);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 241:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(242);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(243);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(171);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(241);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(13);
      END_STATE();
    case 243:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(241);
      END_STATE();
    case 244:
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(156);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(245);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(171);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(244);
      END_STATE();
    case 245:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(244);
      END_STATE();
    case 246:
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(156);
      if (lookahead == ')')
        ADVANCE(157);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '\\')
        SKIP(247);
      if (lookahead == ']')
        ADVANCE(248);
      if (lookahead == '|')
        ADVANCE(171);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(246);
      END_STATE();
    case 247:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(246);
      END_STATE();
    case 248:
      if (lookahead == ']')
        ADVANCE(57);
      END_STATE();
    case 249:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(250);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'd')
        ADVANCE(251);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(249);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 250:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(249);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'o')
        ADVANCE(252);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'n')
        ADVANCE(253);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'e')
        ADVANCE(254);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_done);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 255:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(256);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(257);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(255);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 256:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(255);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'l')
        ADVANCE(61);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 258:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '\\')
        SKIP(259);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(258);
      END_STATE();
    case 259:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(258);
      END_STATE();
    case 260:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(261);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(260);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 261:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(260);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 262:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(11);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '-')
        ADVANCE(226);
      if (lookahead == ':')
        ADVANCE(31);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '=')
        ADVANCE(227);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(263);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(77);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(262);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 263:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(262);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 264:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(265);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(264);
      END_STATE();
    case 265:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(264);
      END_STATE();
    case 266:
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '+')
        ADVANCE(86);
      if (lookahead == '=')
        ADVANCE(89);
      if (lookahead == '\\')
        SKIP(267);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(266);
      END_STATE();
    case 267:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(266);
      END_STATE();
    case 268:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ')')
        ADVANCE(157);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(269);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(268);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 269:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(268);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 270:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(271);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(270);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 271:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(270);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 272:
      if (lookahead == '!')
        ADVANCE(154);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(156);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '+')
        ADVANCE(159);
      if (lookahead == '-')
        ADVANCE(161);
      if (lookahead == '<')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(166);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(273);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(274);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(272);
      END_STATE();
    case 273:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(272);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(76);
      END_STATE();
    case 275:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(276);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'd')
        ADVANCE(277);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(275);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 276:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(275);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'o')
        ADVANCE(278);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'n')
        ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'e')
        ADVANCE(280);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_done);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 281:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(282);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'd')
        ADVANCE(251);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(281);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 282:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(281);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 283:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(284);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'd')
        ADVANCE(251);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(283);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 284:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(283);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 285:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(286);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == 'd')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(285);
      END_STATE();
    case 286:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(285);
      END_STATE();
    case 287:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(288);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'd')
        ADVANCE(251);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(287);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 288:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(287);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 289:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(290);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(289);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 290:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(289);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 291:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(292);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(293);
      if (lookahead == 'f')
        ADVANCE(299);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(291);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 292:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(291);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'l')
        ADVANCE(294);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'i')
        ADVANCE(295);
      if (lookahead == 's')
        ADVANCE(297);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'f')
        ADVANCE(296);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_elif);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'e')
        ADVANCE(298);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'i')
        ADVANCE(300);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_fi);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 301:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(302);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(257);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(301);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 302:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(301);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 303:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(304);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(257);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(303);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 304:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(303);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 305:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(306);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == 'e')
        ADVANCE(307);
      if (lookahead == 'f')
        ADVANCE(197);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(305);
      END_STATE();
    case 306:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(305);
      END_STATE();
    case 307:
      if (lookahead == 'l')
        ADVANCE(189);
      END_STATE();
    case 308:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(309);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(257);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(308);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 309:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(308);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 310:
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(99);
      if (lookahead == '>')
        ADVANCE(100);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(311);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(312);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(310);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 311:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(310);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 's')
        ADVANCE(66);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 313:
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == ';')
        ADVANCE(314);
      if (lookahead == '\\')
        ADVANCE(315);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(313);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 315:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(313);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 316:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '\\')
        SKIP(317);
      if (lookahead == 'd')
        ADVANCE(174);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(316);
      END_STATE();
    case 317:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(316);
      END_STATE();
    case 318:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(319);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'f')
        ADVANCE(299);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(318);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 319:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(318);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 320:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(321);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(320);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 321:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(320);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 322:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(323);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(322);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 323:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(322);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 324:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(325);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == 'f')
        ADVANCE(197);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(324);
      END_STATE();
    case 325:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(324);
      END_STATE();
    case 326:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(327);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'f')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(326);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 327:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(326);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 328:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '\\')
        SKIP(329);
      if (lookahead == 'e')
        ADVANCE(307);
      if (lookahead == 'f')
        ADVANCE(197);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(328);
      END_STATE();
    case 329:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(328);
      END_STATE();
    case 330:
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == ')')
        ADVANCE(20);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(331);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(332);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(330);
      END_STATE();
    case 331:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(330);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 333:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(334);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == 'e')
        ADVANCE(335);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(333);
      END_STATE();
    case 334:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(333);
      END_STATE();
    case 335:
      if (lookahead == 's')
        ADVANCE(194);
      END_STATE();
    case 336:
      if (lookahead == '!')
        ADVANCE(3);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(80);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(88);
      if (lookahead == '<')
        ADVANCE(81);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(53);
      if (lookahead == '\\')
        ADVANCE(337);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(312);
      if (lookahead == '{')
        ADVANCE(73);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(336);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 337:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(336);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 338:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(137);
      if (lookahead == '>')
        ADVANCE(138);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        SKIP(339);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == 'd')
        ADVANCE(174);
      if (lookahead == 'e')
        ADVANCE(188);
      if (lookahead == 'f')
        ADVANCE(197);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(338);
      END_STATE();
    case 339:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(338);
      END_STATE();
    case 340:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(341);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(342);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(340);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 341:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(340);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 's')
        ADVANCE(343);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'a')
        ADVANCE(344);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(4);
      if (lookahead == 'c')
        ADVANCE(345);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(5);
      END_STATE();
    case 346:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(347);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(312);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(346);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 347:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(346);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 348:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == '(')
        ADVANCE(97);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '=')
        ADVANCE(113);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(349);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(312);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(348);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 349:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(348);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 350:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(6);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(12);
      if (lookahead == '\'')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '<')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(84);
      if (lookahead == '\\')
        ADVANCE(351);
      if (lookahead == ']')
        ADVANCE(84);
      if (lookahead == '`')
        ADVANCE(59);
      if (lookahead == 'e')
        ADVANCE(312);
      if (lookahead == '{')
        ADVANCE(84);
      if (lookahead == '|')
        ADVANCE(74);
      if (lookahead == '}')
        ADVANCE(84);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(350);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(5);
      END_STATE();
    case 351:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(350);
      if (lookahead != 0)
        ADVANCE(5);
      END_STATE();
    case 352:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(79);
      if (lookahead == '&')
        ADVANCE(147);
      if (lookahead == ';')
        ADVANCE(34);
      if (lookahead == '\\')
        SKIP(353);
      if (lookahead == 'e')
        ADVANCE(335);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(352);
      END_STATE();
    case 353:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(352);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'c')
        ADVANCE(1);
      if (lookahead == 'd')
        ADVANCE(5);
      if (lookahead == 'e')
        ADVANCE(13);
      if (lookahead == 'f')
        ADVANCE(19);
      if (lookahead == 'i')
        ADVANCE(29);
      if (lookahead == 'l')
        ADVANCE(31);
      if (lookahead == 'r')
        ADVANCE(36);
      if (lookahead == 't')
        ADVANCE(44);
      if (lookahead == 'u')
        ADVANCE(54);
      if (lookahead == 'w')
        ADVANCE(62);
      END_STATE();
    case 1:
      if (lookahead == 'a')
        ADVANCE(2);
      END_STATE();
    case 2:
      if (lookahead == 's')
        ADVANCE(3);
      END_STATE();
    case 3:
      if (lookahead == 'e')
        ADVANCE(4);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 5:
      if (lookahead == 'e')
        ADVANCE(6);
      if (lookahead == 'o')
        ADVANCE(12);
      END_STATE();
    case 6:
      if (lookahead == 'c')
        ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == 'l')
        ADVANCE(8);
      END_STATE();
    case 8:
      if (lookahead == 'a')
        ADVANCE(9);
      END_STATE();
    case 9:
      if (lookahead == 'r')
        ADVANCE(10);
      END_STATE();
    case 10:
      if (lookahead == 'e')
        ADVANCE(11);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 13:
      if (lookahead == 'x')
        ADVANCE(14);
      END_STATE();
    case 14:
      if (lookahead == 'p')
        ADVANCE(15);
      END_STATE();
    case 15:
      if (lookahead == 'o')
        ADVANCE(16);
      END_STATE();
    case 16:
      if (lookahead == 'r')
        ADVANCE(17);
      END_STATE();
    case 17:
      if (lookahead == 't')
        ADVANCE(18);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 19:
      if (lookahead == 'o')
        ADVANCE(20);
      if (lookahead == 'u')
        ADVANCE(22);
      END_STATE();
    case 20:
      if (lookahead == 'r')
        ADVANCE(21);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 22:
      if (lookahead == 'n')
        ADVANCE(23);
      END_STATE();
    case 23:
      if (lookahead == 'c')
        ADVANCE(24);
      END_STATE();
    case 24:
      if (lookahead == 't')
        ADVANCE(25);
      END_STATE();
    case 25:
      if (lookahead == 'i')
        ADVANCE(26);
      END_STATE();
    case 26:
      if (lookahead == 'o')
        ADVANCE(27);
      END_STATE();
    case 27:
      if (lookahead == 'n')
        ADVANCE(28);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 29:
      if (lookahead == 'f')
        ADVANCE(30);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 31:
      if (lookahead == 'o')
        ADVANCE(32);
      END_STATE();
    case 32:
      if (lookahead == 'c')
        ADVANCE(33);
      END_STATE();
    case 33:
      if (lookahead == 'a')
        ADVANCE(34);
      END_STATE();
    case 34:
      if (lookahead == 'l')
        ADVANCE(35);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_local);
      END_STATE();
    case 36:
      if (lookahead == 'e')
        ADVANCE(37);
      END_STATE();
    case 37:
      if (lookahead == 'a')
        ADVANCE(38);
      END_STATE();
    case 38:
      if (lookahead == 'd')
        ADVANCE(39);
      END_STATE();
    case 39:
      if (lookahead == 'o')
        ADVANCE(40);
      END_STATE();
    case 40:
      if (lookahead == 'n')
        ADVANCE(41);
      END_STATE();
    case 41:
      if (lookahead == 'l')
        ADVANCE(42);
      END_STATE();
    case 42:
      if (lookahead == 'y')
        ADVANCE(43);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 44:
      if (lookahead == 'h')
        ADVANCE(45);
      if (lookahead == 'y')
        ADVANCE(48);
      END_STATE();
    case 45:
      if (lookahead == 'e')
        ADVANCE(46);
      END_STATE();
    case 46:
      if (lookahead == 'n')
        ADVANCE(47);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 48:
      if (lookahead == 'p')
        ADVANCE(49);
      END_STATE();
    case 49:
      if (lookahead == 'e')
        ADVANCE(50);
      END_STATE();
    case 50:
      if (lookahead == 's')
        ADVANCE(51);
      END_STATE();
    case 51:
      if (lookahead == 'e')
        ADVANCE(52);
      END_STATE();
    case 52:
      if (lookahead == 't')
        ADVANCE(53);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_typeset);
      END_STATE();
    case 54:
      if (lookahead == 'n')
        ADVANCE(55);
      END_STATE();
    case 55:
      if (lookahead == 's')
        ADVANCE(56);
      END_STATE();
    case 56:
      if (lookahead == 'e')
        ADVANCE(57);
      END_STATE();
    case 57:
      if (lookahead == 't')
        ADVANCE(58);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_unset);
      if (lookahead == 'e')
        ADVANCE(59);
      END_STATE();
    case 59:
      if (lookahead == 'n')
        ADVANCE(60);
      END_STATE();
    case 60:
      if (lookahead == 'v')
        ADVANCE(61);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_unsetenv);
      END_STATE();
    case 62:
      if (lookahead == 'h')
        ADVANCE(63);
      END_STATE();
    case 63:
      if (lookahead == 'i')
        ADVANCE(64);
      END_STATE();
    case 64:
      if (lookahead == 'l')
        ADVANCE(65);
      END_STATE();
    case 65:
      if (lookahead == 'e')
        ADVANCE(66);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 78, .external_lex_state = 2},
  [2] = {.lex_state = 78},
  [3] = {.lex_state = 85},
  [4] = {.lex_state = 92},
  [5] = {.lex_state = 96},
  [6] = {.lex_state = 78, .external_lex_state = 2},
  [7] = {.lex_state = 78, .external_lex_state = 2},
  [8] = {.lex_state = 102},
  [9] = {.lex_state = 102},
  [10] = {.lex_state = 78, .external_lex_state = 2},
  [11] = {.lex_state = 104, .external_lex_state = 3},
  [12] = {.lex_state = 106, .external_lex_state = 2},
  [13] = {.lex_state = 96},
  [14] = {.lex_state = 96},
  [15] = {.lex_state = 108, .external_lex_state = 4},
  [16] = {.lex_state = 108, .external_lex_state = 5},
  [17] = {.lex_state = 102},
  [18] = {.lex_state = 112, .external_lex_state = 6},
  [19] = {.lex_state = 115},
  [20] = {.lex_state = 122},
  [21] = {.lex_state = 112, .external_lex_state = 6},
  [22] = {.lex_state = 122, .external_lex_state = 7},
  [23] = {.lex_state = 78, .external_lex_state = 2},
  [24] = {.lex_state = 78, .external_lex_state = 2},
  [25] = {.lex_state = 78, .external_lex_state = 2},
  [26] = {.lex_state = 132, .external_lex_state = 6},
  [27] = {.lex_state = 134},
  [28] = {.lex_state = 134},
  [29] = {.lex_state = 136, .external_lex_state = 5},
  [30] = {.lex_state = 112, .external_lex_state = 5},
  [31] = {.lex_state = 140, .external_lex_state = 4},
  [32] = {.lex_state = 85},
  [33] = {.lex_state = 142, .external_lex_state = 5},
  [34] = {.lex_state = 78, .external_lex_state = 2},
  [35] = {.lex_state = 102, .external_lex_state = 2},
  [36] = {.lex_state = 112, .external_lex_state = 5},
  [37] = {.lex_state = 102},
  [38] = {.lex_state = 102},
  [39] = {.lex_state = 144, .external_lex_state = 8},
  [40] = {.lex_state = 146, .external_lex_state = 9},
  [41] = {.lex_state = 149, .external_lex_state = 9},
  [42] = {.lex_state = 96},
  [43] = {.lex_state = 96},
  [44] = {.lex_state = 153, .external_lex_state = 10},
  [45] = {.lex_state = 115},
  [46] = {.lex_state = 122},
  [47] = {.lex_state = 153, .external_lex_state = 10},
  [48] = {.lex_state = 122, .external_lex_state = 7},
  [49] = {.lex_state = 78, .external_lex_state = 2},
  [50] = {.lex_state = 78, .external_lex_state = 2},
  [51] = {.lex_state = 78, .external_lex_state = 2},
  [52] = {.lex_state = 153},
  [53] = {.lex_state = 153},
  [54] = {.lex_state = 85},
  [55] = {.lex_state = 92},
  [56] = {.lex_state = 96},
  [57] = {.lex_state = 78, .external_lex_state = 2},
  [58] = {.lex_state = 78, .external_lex_state = 2},
  [59] = {.lex_state = 102},
  [60] = {.lex_state = 102},
  [61] = {.lex_state = 78, .external_lex_state = 2},
  [62] = {.lex_state = 104, .external_lex_state = 3},
  [63] = {.lex_state = 106, .external_lex_state = 2},
  [64] = {.lex_state = 96},
  [65] = {.lex_state = 96},
  [66] = {.lex_state = 108, .external_lex_state = 11},
  [67] = {.lex_state = 108, .external_lex_state = 12},
  [68] = {.lex_state = 112, .external_lex_state = 13},
  [69] = {.lex_state = 115},
  [70] = {.lex_state = 122},
  [71] = {.lex_state = 112, .external_lex_state = 13},
  [72] = {.lex_state = 122, .external_lex_state = 7},
  [73] = {.lex_state = 78, .external_lex_state = 2},
  [74] = {.lex_state = 78, .external_lex_state = 2},
  [75] = {.lex_state = 78, .external_lex_state = 2},
  [76] = {.lex_state = 132, .external_lex_state = 13},
  [77] = {.lex_state = 102},
  [78] = {.lex_state = 136, .external_lex_state = 12},
  [79] = {.lex_state = 112, .external_lex_state = 12},
  [80] = {.lex_state = 140, .external_lex_state = 11},
  [81] = {.lex_state = 85},
  [82] = {.lex_state = 112, .external_lex_state = 12},
  [83] = {.lex_state = 102, .external_lex_state = 2},
  [84] = {.lex_state = 112, .external_lex_state = 12},
  [85] = {.lex_state = 102},
  [86] = {.lex_state = 149, .external_lex_state = 14},
  [87] = {.lex_state = 115},
  [88] = {.lex_state = 122},
  [89] = {.lex_state = 149, .external_lex_state = 14},
  [90] = {.lex_state = 122, .external_lex_state = 7},
  [91] = {.lex_state = 78, .external_lex_state = 2},
  [92] = {.lex_state = 78, .external_lex_state = 2},
  [93] = {.lex_state = 78, .external_lex_state = 2},
  [94] = {.lex_state = 149, .external_lex_state = 9},
  [95] = {.lex_state = 149, .external_lex_state = 9},
  [96] = {.lex_state = 172},
  [97] = {.lex_state = 85},
  [98] = {.lex_state = 106, .external_lex_state = 2},
  [99] = {.lex_state = 178, .external_lex_state = 4},
  [100] = {.lex_state = 178, .external_lex_state = 5},
  [101] = {.lex_state = 142, .external_lex_state = 6},
  [102] = {.lex_state = 142, .external_lex_state = 6},
  [103] = {.lex_state = 180, .external_lex_state = 6},
  [104] = {.lex_state = 85},
  [105] = {.lex_state = 182, .external_lex_state = 5},
  [106] = {.lex_state = 142, .external_lex_state = 5},
  [107] = {.lex_state = 184, .external_lex_state = 4},
  [108] = {.lex_state = 85},
  [109] = {.lex_state = 78, .external_lex_state = 2},
  [110] = {.lex_state = 102, .external_lex_state = 2},
  [111] = {.lex_state = 142, .external_lex_state = 5},
  [112] = {.lex_state = 85},
  [113] = {.lex_state = 92},
  [114] = {.lex_state = 96},
  [115] = {.lex_state = 78, .external_lex_state = 2},
  [116] = {.lex_state = 78, .external_lex_state = 2},
  [117] = {.lex_state = 102},
  [118] = {.lex_state = 102},
  [119] = {.lex_state = 78, .external_lex_state = 2},
  [120] = {.lex_state = 104, .external_lex_state = 3},
  [121] = {.lex_state = 186, .external_lex_state = 5},
  [122] = {.lex_state = 106, .external_lex_state = 2},
  [123] = {.lex_state = 96},
  [124] = {.lex_state = 96},
  [125] = {.lex_state = 199, .external_lex_state = 15},
  [126] = {.lex_state = 199, .external_lex_state = 16},
  [127] = {.lex_state = 201, .external_lex_state = 17},
  [128] = {.lex_state = 115},
  [129] = {.lex_state = 122},
  [130] = {.lex_state = 201, .external_lex_state = 17},
  [131] = {.lex_state = 122, .external_lex_state = 7},
  [132] = {.lex_state = 78, .external_lex_state = 2},
  [133] = {.lex_state = 78, .external_lex_state = 2},
  [134] = {.lex_state = 78, .external_lex_state = 2},
  [135] = {.lex_state = 203, .external_lex_state = 17},
  [136] = {.lex_state = 92, .external_lex_state = 18},
  [137] = {.lex_state = 205, .external_lex_state = 16},
  [138] = {.lex_state = 201, .external_lex_state = 16},
  [139] = {.lex_state = 207, .external_lex_state = 15},
  [140] = {.lex_state = 85},
  [141] = {.lex_state = 201, .external_lex_state = 16},
  [142] = {.lex_state = 78, .external_lex_state = 2},
  [143] = {.lex_state = 102, .external_lex_state = 2},
  [144] = {.lex_state = 201, .external_lex_state = 16},
  [145] = {.lex_state = 85},
  [146] = {.lex_state = 186, .external_lex_state = 5},
  [147] = {.lex_state = 85},
  [148] = {.lex_state = 96},
  [149] = {.lex_state = 96},
  [150] = {.lex_state = 209, .external_lex_state = 19},
  [151] = {.lex_state = 115},
  [152] = {.lex_state = 122},
  [153] = {.lex_state = 209, .external_lex_state = 19},
  [154] = {.lex_state = 122, .external_lex_state = 7},
  [155] = {.lex_state = 78, .external_lex_state = 2},
  [156] = {.lex_state = 78, .external_lex_state = 2},
  [157] = {.lex_state = 78, .external_lex_state = 2},
  [158] = {.lex_state = 209, .external_lex_state = 20},
  [159] = {.lex_state = 209, .external_lex_state = 20},
  [160] = {.lex_state = 96},
  [161] = {.lex_state = 212, .external_lex_state = 10},
  [162] = {.lex_state = 212, .external_lex_state = 10},
  [163] = {.lex_state = 212},
  [164] = {.lex_state = 212},
  [165] = {.lex_state = 85},
  [166] = {.lex_state = 108, .external_lex_state = 21},
  [167] = {.lex_state = 115},
  [168] = {.lex_state = 122},
  [169] = {.lex_state = 108, .external_lex_state = 21},
  [170] = {.lex_state = 122, .external_lex_state = 7},
  [171] = {.lex_state = 78, .external_lex_state = 2},
  [172] = {.lex_state = 78, .external_lex_state = 2},
  [173] = {.lex_state = 78, .external_lex_state = 2},
  [174] = {.lex_state = 85},
  [175] = {.lex_state = 108, .external_lex_state = 4},
  [176] = {.lex_state = 108, .external_lex_state = 4},
  [177] = {.lex_state = 108, .external_lex_state = 6},
  [178] = {.lex_state = 115},
  [179] = {.lex_state = 122},
  [180] = {.lex_state = 108, .external_lex_state = 6},
  [181] = {.lex_state = 122, .external_lex_state = 7},
  [182] = {.lex_state = 78, .external_lex_state = 2},
  [183] = {.lex_state = 78, .external_lex_state = 2},
  [184] = {.lex_state = 78, .external_lex_state = 2},
  [185] = {.lex_state = 108, .external_lex_state = 5},
  [186] = {.lex_state = 108, .external_lex_state = 5},
  [187] = {.lex_state = 102, .external_lex_state = 22},
  [188] = {.lex_state = 115},
  [189] = {.lex_state = 122},
  [190] = {.lex_state = 102, .external_lex_state = 22},
  [191] = {.lex_state = 122, .external_lex_state = 7},
  [192] = {.lex_state = 78, .external_lex_state = 2},
  [193] = {.lex_state = 78, .external_lex_state = 2},
  [194] = {.lex_state = 78, .external_lex_state = 2},
  [195] = {.lex_state = 215, .external_lex_state = 2},
  [196] = {.lex_state = 102, .external_lex_state = 2},
  [197] = {.lex_state = 102},
  [198] = {.lex_state = 112, .external_lex_state = 6},
  [199] = {.lex_state = 142, .external_lex_state = 6},
  [200] = {.lex_state = 217},
  [201] = {.lex_state = 115, .external_lex_state = 10},
  [202] = {.lex_state = 122, .external_lex_state = 7},
  [203] = {.lex_state = 78, .external_lex_state = 2},
  [204] = {.lex_state = 78, .external_lex_state = 2},
  [205] = {.lex_state = 115},
  [206] = {.lex_state = 142, .external_lex_state = 6},
  [207] = {.lex_state = 142, .external_lex_state = 6},
  [208] = {.lex_state = 142, .external_lex_state = 6},
  [209] = {.lex_state = 85},
  [210] = {.lex_state = 223, .external_lex_state = 7},
  [211] = {.lex_state = 225, .external_lex_state = 18},
  [212] = {.lex_state = 225, .external_lex_state = 18},
  [213] = {.lex_state = 78},
  [214] = {.lex_state = 102},
  [215] = {.lex_state = 85},
  [216] = {.lex_state = 215, .external_lex_state = 2},
  [217] = {.lex_state = 85},
  [218] = {.lex_state = 106, .external_lex_state = 2},
  [219] = {.lex_state = 108, .external_lex_state = 4},
  [220] = {.lex_state = 108, .external_lex_state = 5},
  [221] = {.lex_state = 112, .external_lex_state = 6},
  [222] = {.lex_state = 112, .external_lex_state = 6},
  [223] = {.lex_state = 132, .external_lex_state = 6},
  [224] = {.lex_state = 78},
  [225] = {.lex_state = 229, .external_lex_state = 5},
  [226] = {.lex_state = 112, .external_lex_state = 5},
  [227] = {.lex_state = 140, .external_lex_state = 4},
  [228] = {.lex_state = 85},
  [229] = {.lex_state = 78, .external_lex_state = 2},
  [230] = {.lex_state = 102, .external_lex_state = 2},
  [231] = {.lex_state = 112, .external_lex_state = 5},
  [232] = {.lex_state = 85},
  [233] = {.lex_state = 85},
  [234] = {.lex_state = 231, .external_lex_state = 9},
  [235] = {.lex_state = 96, .external_lex_state = 23},
  [236] = {.lex_state = 78},
  [237] = {.lex_state = 233, .external_lex_state = 2},
  [238] = {.lex_state = 78, .external_lex_state = 2},
  [239] = {.lex_state = 78, .external_lex_state = 2},
  [240] = {.lex_state = 102},
  [241] = {.lex_state = 78, .external_lex_state = 24},
  [242] = {.lex_state = 102},
  [243] = {.lex_state = 235, .external_lex_state = 9},
  [244] = {.lex_state = 136, .external_lex_state = 5},
  [245] = {.lex_state = 237, .external_lex_state = 25},
  [246] = {.lex_state = 112, .external_lex_state = 6},
  [247] = {.lex_state = 112, .external_lex_state = 5},
  [248] = {.lex_state = 112, .external_lex_state = 5},
  [249] = {.lex_state = 136, .external_lex_state = 5},
  [250] = {.lex_state = 140, .external_lex_state = 4},
  [251] = {.lex_state = 78, .external_lex_state = 2},
  [252] = {.lex_state = 112, .external_lex_state = 5},
  [253] = {.lex_state = 102, .external_lex_state = 2},
  [254] = {.lex_state = 142, .external_lex_state = 5},
  [255] = {.lex_state = 112, .external_lex_state = 5},
  [256] = {.lex_state = 102, .external_lex_state = 22},
  [257] = {.lex_state = 215, .external_lex_state = 2},
  [258] = {.lex_state = 102, .external_lex_state = 2},
  [259] = {.lex_state = 239, .external_lex_state = 19},
  [260] = {.lex_state = 239, .external_lex_state = 19},
  [261] = {.lex_state = 239, .external_lex_state = 19},
  [262] = {.lex_state = 239, .external_lex_state = 19},
  [263] = {.lex_state = 184, .external_lex_state = 4},
  [264] = {.lex_state = 215},
  [265] = {.lex_state = 140, .external_lex_state = 21},
  [266] = {.lex_state = 115},
  [267] = {.lex_state = 122},
  [268] = {.lex_state = 140, .external_lex_state = 21},
  [269] = {.lex_state = 122, .external_lex_state = 7},
  [270] = {.lex_state = 78, .external_lex_state = 2},
  [271] = {.lex_state = 78, .external_lex_state = 2},
  [272] = {.lex_state = 78, .external_lex_state = 2},
  [273] = {.lex_state = 140, .external_lex_state = 4},
  [274] = {.lex_state = 146, .external_lex_state = 9},
  [275] = {.lex_state = 96},
  [276] = {.lex_state = 96},
  [277] = {.lex_state = 241, .external_lex_state = 14},
  [278] = {.lex_state = 115},
  [279] = {.lex_state = 122},
  [280] = {.lex_state = 241, .external_lex_state = 14},
  [281] = {.lex_state = 122, .external_lex_state = 7},
  [282] = {.lex_state = 78, .external_lex_state = 2},
  [283] = {.lex_state = 78, .external_lex_state = 2},
  [284] = {.lex_state = 78, .external_lex_state = 2},
  [285] = {.lex_state = 241, .external_lex_state = 9},
  [286] = {.lex_state = 241, .external_lex_state = 9},
  [287] = {.lex_state = 102},
  [288] = {.lex_state = 102},
  [289] = {.lex_state = 96},
  [290] = {.lex_state = 96},
  [291] = {.lex_state = 244, .external_lex_state = 10},
  [292] = {.lex_state = 115},
  [293] = {.lex_state = 122},
  [294] = {.lex_state = 244, .external_lex_state = 10},
  [295] = {.lex_state = 122, .external_lex_state = 7},
  [296] = {.lex_state = 78, .external_lex_state = 2},
  [297] = {.lex_state = 78, .external_lex_state = 2},
  [298] = {.lex_state = 78, .external_lex_state = 2},
  [299] = {.lex_state = 244},
  [300] = {.lex_state = 244},
  [301] = {.lex_state = 153},
  [302] = {.lex_state = 102},
  [303] = {.lex_state = 153, .external_lex_state = 10},
  [304] = {.lex_state = 246, .external_lex_state = 10},
  [305] = {.lex_state = 217},
  [306] = {.lex_state = 115},
  [307] = {.lex_state = 246, .external_lex_state = 10},
  [308] = {.lex_state = 246, .external_lex_state = 10},
  [309] = {.lex_state = 246, .external_lex_state = 10},
  [310] = {.lex_state = 85},
  [311] = {.lex_state = 223, .external_lex_state = 7},
  [312] = {.lex_state = 225, .external_lex_state = 18},
  [313] = {.lex_state = 225, .external_lex_state = 18},
  [314] = {.lex_state = 85},
  [315] = {.lex_state = 215, .external_lex_state = 2},
  [316] = {.lex_state = 78},
  [317] = {.lex_state = 85},
  [318] = {.lex_state = 186, .external_lex_state = 5},
  [319] = {.lex_state = 96},
  [320] = {.lex_state = 96, .external_lex_state = 25},
  [321] = {.lex_state = 246},
  [322] = {.lex_state = 153},
  [323] = {.lex_state = 153},
  [324] = {.lex_state = 144, .external_lex_state = 8},
  [325] = {.lex_state = 146, .external_lex_state = 9},
  [326] = {.lex_state = 149, .external_lex_state = 9},
  [327] = {.lex_state = 153},
  [328] = {.lex_state = 102},
  [329] = {.lex_state = 102},
  [330] = {.lex_state = 149, .external_lex_state = 14},
  [331] = {.lex_state = 149, .external_lex_state = 9},
  [332] = {.lex_state = 149, .external_lex_state = 9},
  [333] = {.lex_state = 172},
  [334] = {.lex_state = 85},
  [335] = {.lex_state = 136, .external_lex_state = 12},
  [336] = {.lex_state = 92, .external_lex_state = 18},
  [337] = {.lex_state = 136, .external_lex_state = 12},
  [338] = {.lex_state = 209, .external_lex_state = 20},
  [339] = {.lex_state = 212},
  [340] = {.lex_state = 85},
  [341] = {.lex_state = 108, .external_lex_state = 26},
  [342] = {.lex_state = 115},
  [343] = {.lex_state = 122},
  [344] = {.lex_state = 108, .external_lex_state = 26},
  [345] = {.lex_state = 122, .external_lex_state = 7},
  [346] = {.lex_state = 78, .external_lex_state = 2},
  [347] = {.lex_state = 78, .external_lex_state = 2},
  [348] = {.lex_state = 78, .external_lex_state = 2},
  [349] = {.lex_state = 85},
  [350] = {.lex_state = 108, .external_lex_state = 11},
  [351] = {.lex_state = 108, .external_lex_state = 11},
  [352] = {.lex_state = 108, .external_lex_state = 13},
  [353] = {.lex_state = 115},
  [354] = {.lex_state = 122},
  [355] = {.lex_state = 108, .external_lex_state = 13},
  [356] = {.lex_state = 122, .external_lex_state = 7},
  [357] = {.lex_state = 78, .external_lex_state = 2},
  [358] = {.lex_state = 78, .external_lex_state = 2},
  [359] = {.lex_state = 78, .external_lex_state = 2},
  [360] = {.lex_state = 108, .external_lex_state = 12},
  [361] = {.lex_state = 108, .external_lex_state = 12},
  [362] = {.lex_state = 102},
  [363] = {.lex_state = 112, .external_lex_state = 13},
  [364] = {.lex_state = 112, .external_lex_state = 13},
  [365] = {.lex_state = 217},
  [366] = {.lex_state = 115},
  [367] = {.lex_state = 112, .external_lex_state = 13},
  [368] = {.lex_state = 112, .external_lex_state = 13},
  [369] = {.lex_state = 112, .external_lex_state = 13},
  [370] = {.lex_state = 85},
  [371] = {.lex_state = 223, .external_lex_state = 7},
  [372] = {.lex_state = 225, .external_lex_state = 18},
  [373] = {.lex_state = 225, .external_lex_state = 18},
  [374] = {.lex_state = 85},
  [375] = {.lex_state = 215, .external_lex_state = 2},
  [376] = {.lex_state = 78},
  [377] = {.lex_state = 85},
  [378] = {.lex_state = 85},
  [379] = {.lex_state = 249, .external_lex_state = 2},
  [380] = {.lex_state = 186, .external_lex_state = 5},
  [381] = {.lex_state = 78},
  [382] = {.lex_state = 102},
  [383] = {.lex_state = 78, .external_lex_state = 2},
  [384] = {.lex_state = 78, .external_lex_state = 2},
  [385] = {.lex_state = 102},
  [386] = {.lex_state = 78, .external_lex_state = 24},
  [387] = {.lex_state = 102},
  [388] = {.lex_state = 136, .external_lex_state = 12},
  [389] = {.lex_state = 237, .external_lex_state = 25},
  [390] = {.lex_state = 112, .external_lex_state = 13},
  [391] = {.lex_state = 112, .external_lex_state = 12},
  [392] = {.lex_state = 112, .external_lex_state = 12},
  [393] = {.lex_state = 112, .external_lex_state = 12},
  [394] = {.lex_state = 112, .external_lex_state = 12},
  [395] = {.lex_state = 112, .external_lex_state = 12},
  [396] = {.lex_state = 255, .external_lex_state = 2},
  [397] = {.lex_state = 102},
  [398] = {.lex_state = 149, .external_lex_state = 14},
  [399] = {.lex_state = 149, .external_lex_state = 14},
  [400] = {.lex_state = 217},
  [401] = {.lex_state = 115},
  [402] = {.lex_state = 149, .external_lex_state = 14},
  [403] = {.lex_state = 149, .external_lex_state = 14},
  [404] = {.lex_state = 149, .external_lex_state = 14},
  [405] = {.lex_state = 146, .external_lex_state = 9},
  [406] = {.lex_state = 149},
  [407] = {.lex_state = 85},
  [408] = {.lex_state = 223, .external_lex_state = 7},
  [409] = {.lex_state = 225, .external_lex_state = 18},
  [410] = {.lex_state = 225, .external_lex_state = 18},
  [411] = {.lex_state = 85},
  [412] = {.lex_state = 215, .external_lex_state = 2},
  [413] = {.lex_state = 78},
  [414] = {.lex_state = 85},
  [415] = {.lex_state = 146, .external_lex_state = 9},
  [416] = {.lex_state = 149},
  [417] = {.lex_state = 149, .external_lex_state = 9},
  [418] = {.lex_state = 149, .external_lex_state = 9},
  [419] = {.lex_state = 85},
  [420] = {.lex_state = 186, .external_lex_state = 5},
  [421] = {.lex_state = 144, .external_lex_state = 8},
  [422] = {.lex_state = 85},
  [423] = {.lex_state = 178, .external_lex_state = 21},
  [424] = {.lex_state = 178, .external_lex_state = 21},
  [425] = {.lex_state = 85},
  [426] = {.lex_state = 178, .external_lex_state = 4},
  [427] = {.lex_state = 178, .external_lex_state = 4},
  [428] = {.lex_state = 178, .external_lex_state = 6},
  [429] = {.lex_state = 178, .external_lex_state = 6},
  [430] = {.lex_state = 178, .external_lex_state = 5},
  [431] = {.lex_state = 178, .external_lex_state = 5},
  [432] = {.lex_state = 142, .external_lex_state = 6},
  [433] = {.lex_state = 186, .external_lex_state = 5},
  [434] = {.lex_state = 78},
  [435] = {.lex_state = 78, .external_lex_state = 2},
  [436] = {.lex_state = 78, .external_lex_state = 2},
  [437] = {.lex_state = 102},
  [438] = {.lex_state = 102},
  [439] = {.lex_state = 182, .external_lex_state = 5},
  [440] = {.lex_state = 237, .external_lex_state = 25},
  [441] = {.lex_state = 142, .external_lex_state = 6},
  [442] = {.lex_state = 142, .external_lex_state = 5},
  [443] = {.lex_state = 142, .external_lex_state = 5},
  [444] = {.lex_state = 182, .external_lex_state = 5},
  [445] = {.lex_state = 184, .external_lex_state = 4},
  [446] = {.lex_state = 142, .external_lex_state = 5},
  [447] = {.lex_state = 142, .external_lex_state = 5},
  [448] = {.lex_state = 144, .external_lex_state = 8},
  [449] = {.lex_state = 146, .external_lex_state = 9},
  [450] = {.lex_state = 149, .external_lex_state = 9},
  [451] = {.lex_state = 153},
  [452] = {.lex_state = 102},
  [453] = {.lex_state = 102},
  [454] = {.lex_state = 149, .external_lex_state = 14},
  [455] = {.lex_state = 149, .external_lex_state = 9},
  [456] = {.lex_state = 149, .external_lex_state = 9},
  [457] = {.lex_state = 172},
  [458] = {.lex_state = 85},
  [459] = {.lex_state = 205, .external_lex_state = 16},
  [460] = {.lex_state = 92, .external_lex_state = 18},
  [461] = {.lex_state = 205, .external_lex_state = 16},
  [462] = {.lex_state = 209, .external_lex_state = 20},
  [463] = {.lex_state = 212},
  [464] = {.lex_state = 85},
  [465] = {.lex_state = 199, .external_lex_state = 27},
  [466] = {.lex_state = 115},
  [467] = {.lex_state = 122},
  [468] = {.lex_state = 199, .external_lex_state = 27},
  [469] = {.lex_state = 122, .external_lex_state = 7},
  [470] = {.lex_state = 78, .external_lex_state = 2},
  [471] = {.lex_state = 78, .external_lex_state = 2},
  [472] = {.lex_state = 78, .external_lex_state = 2},
  [473] = {.lex_state = 85},
  [474] = {.lex_state = 199, .external_lex_state = 15},
  [475] = {.lex_state = 199, .external_lex_state = 15},
  [476] = {.lex_state = 199, .external_lex_state = 17},
  [477] = {.lex_state = 115},
  [478] = {.lex_state = 122},
  [479] = {.lex_state = 199, .external_lex_state = 17},
  [480] = {.lex_state = 122, .external_lex_state = 7},
  [481] = {.lex_state = 78, .external_lex_state = 2},
  [482] = {.lex_state = 78, .external_lex_state = 2},
  [483] = {.lex_state = 78, .external_lex_state = 2},
  [484] = {.lex_state = 199, .external_lex_state = 16},
  [485] = {.lex_state = 199, .external_lex_state = 16},
  [486] = {.lex_state = 102},
  [487] = {.lex_state = 201, .external_lex_state = 17},
  [488] = {.lex_state = 201, .external_lex_state = 17},
  [489] = {.lex_state = 217},
  [490] = {.lex_state = 115},
  [491] = {.lex_state = 201, .external_lex_state = 17},
  [492] = {.lex_state = 201, .external_lex_state = 17},
  [493] = {.lex_state = 201, .external_lex_state = 17},
  [494] = {.lex_state = 85},
  [495] = {.lex_state = 223, .external_lex_state = 7},
  [496] = {.lex_state = 225, .external_lex_state = 18},
  [497] = {.lex_state = 225, .external_lex_state = 18},
  [498] = {.lex_state = 85},
  [499] = {.lex_state = 215, .external_lex_state = 2},
  [500] = {.lex_state = 78},
  [501] = {.lex_state = 85},
  [502] = {.lex_state = 85},
  [503] = {.lex_state = 186, .external_lex_state = 5},
  [504] = {.lex_state = 258, .external_lex_state = 28},
  [505] = {.lex_state = 96, .external_lex_state = 23},
  [506] = {.lex_state = 78},
  [507] = {.lex_state = 104, .external_lex_state = 3},
  [508] = {.lex_state = 78, .external_lex_state = 2},
  [509] = {.lex_state = 78, .external_lex_state = 2},
  [510] = {.lex_state = 102},
  [511] = {.lex_state = 78, .external_lex_state = 24},
  [512] = {.lex_state = 102},
  [513] = {.lex_state = 258, .external_lex_state = 28},
  [514] = {.lex_state = 205, .external_lex_state = 16},
  [515] = {.lex_state = 237, .external_lex_state = 25},
  [516] = {.lex_state = 201, .external_lex_state = 17},
  [517] = {.lex_state = 201, .external_lex_state = 16},
  [518] = {.lex_state = 201, .external_lex_state = 16},
  [519] = {.lex_state = 205, .external_lex_state = 16},
  [520] = {.lex_state = 207, .external_lex_state = 15},
  [521] = {.lex_state = 201, .external_lex_state = 16},
  [522] = {.lex_state = 201, .external_lex_state = 16},
  [523] = {.lex_state = 201, .external_lex_state = 16},
  [524] = {.lex_state = 144, .external_lex_state = 8},
  [525] = {.lex_state = 244},
  [526] = {.lex_state = 209, .external_lex_state = 20},
  [527] = {.lex_state = 102},
  [528] = {.lex_state = 209, .external_lex_state = 19},
  [529] = {.lex_state = 209, .external_lex_state = 19},
  [530] = {.lex_state = 217},
  [531] = {.lex_state = 115},
  [532] = {.lex_state = 209, .external_lex_state = 19},
  [533] = {.lex_state = 209, .external_lex_state = 19},
  [534] = {.lex_state = 209, .external_lex_state = 19},
  [535] = {.lex_state = 85},
  [536] = {.lex_state = 223, .external_lex_state = 7},
  [537] = {.lex_state = 225, .external_lex_state = 18},
  [538] = {.lex_state = 225, .external_lex_state = 18},
  [539] = {.lex_state = 85},
  [540] = {.lex_state = 215, .external_lex_state = 2},
  [541] = {.lex_state = 78},
  [542] = {.lex_state = 85},
  [543] = {.lex_state = 96},
  [544] = {.lex_state = 96, .external_lex_state = 25},
  [545] = {.lex_state = 209, .external_lex_state = 20},
  [546] = {.lex_state = 209, .external_lex_state = 20},
  [547] = {.lex_state = 209, .external_lex_state = 20},
  [548] = {.lex_state = 212},
  [549] = {.lex_state = 212, .external_lex_state = 10},
  [550] = {.lex_state = 96},
  [551] = {.lex_state = 96, .external_lex_state = 25},
  [552] = {.lex_state = 212},
  [553] = {.lex_state = 212},
  [554] = {.lex_state = 144, .external_lex_state = 8},
  [555] = {.lex_state = 102},
  [556] = {.lex_state = 108, .external_lex_state = 21},
  [557] = {.lex_state = 178, .external_lex_state = 21},
  [558] = {.lex_state = 217},
  [559] = {.lex_state = 115},
  [560] = {.lex_state = 178, .external_lex_state = 21},
  [561] = {.lex_state = 178, .external_lex_state = 21},
  [562] = {.lex_state = 178, .external_lex_state = 21},
  [563] = {.lex_state = 85},
  [564] = {.lex_state = 223, .external_lex_state = 7},
  [565] = {.lex_state = 225, .external_lex_state = 18},
  [566] = {.lex_state = 225, .external_lex_state = 18},
  [567] = {.lex_state = 85},
  [568] = {.lex_state = 215, .external_lex_state = 2},
  [569] = {.lex_state = 78},
  [570] = {.lex_state = 85},
  [571] = {.lex_state = 108, .external_lex_state = 4},
  [572] = {.lex_state = 178, .external_lex_state = 4},
  [573] = {.lex_state = 108, .external_lex_state = 4},
  [574] = {.lex_state = 102},
  [575] = {.lex_state = 108, .external_lex_state = 6},
  [576] = {.lex_state = 178, .external_lex_state = 6},
  [577] = {.lex_state = 217},
  [578] = {.lex_state = 115},
  [579] = {.lex_state = 178, .external_lex_state = 6},
  [580] = {.lex_state = 178, .external_lex_state = 6},
  [581] = {.lex_state = 178, .external_lex_state = 6},
  [582] = {.lex_state = 85},
  [583] = {.lex_state = 223, .external_lex_state = 7},
  [584] = {.lex_state = 225, .external_lex_state = 18},
  [585] = {.lex_state = 225, .external_lex_state = 18},
  [586] = {.lex_state = 85},
  [587] = {.lex_state = 215, .external_lex_state = 2},
  [588] = {.lex_state = 78},
  [589] = {.lex_state = 85},
  [590] = {.lex_state = 108, .external_lex_state = 5},
  [591] = {.lex_state = 178, .external_lex_state = 5},
  [592] = {.lex_state = 108, .external_lex_state = 5},
  [593] = {.lex_state = 102},
  [594] = {.lex_state = 102, .external_lex_state = 22},
  [595] = {.lex_state = 215, .external_lex_state = 22},
  [596] = {.lex_state = 217},
  [597] = {.lex_state = 115},
  [598] = {.lex_state = 215, .external_lex_state = 22},
  [599] = {.lex_state = 215, .external_lex_state = 22},
  [600] = {.lex_state = 215, .external_lex_state = 22},
  [601] = {.lex_state = 85},
  [602] = {.lex_state = 223, .external_lex_state = 7},
  [603] = {.lex_state = 225, .external_lex_state = 18},
  [604] = {.lex_state = 225, .external_lex_state = 18},
  [605] = {.lex_state = 85},
  [606] = {.lex_state = 215, .external_lex_state = 2},
  [607] = {.lex_state = 78},
  [608] = {.lex_state = 85},
  [609] = {.lex_state = 215, .external_lex_state = 2},
  [610] = {.lex_state = 102, .external_lex_state = 2},
  [611] = {.lex_state = 142, .external_lex_state = 6},
  [612] = {.lex_state = 112, .external_lex_state = 6},
  [613] = {.lex_state = 115, .external_lex_state = 10},
  [614] = {.lex_state = 142, .external_lex_state = 6},
  [615] = {.lex_state = 115, .external_lex_state = 10},
  [616] = {.lex_state = 115, .external_lex_state = 10},
  [617] = {.lex_state = 115},
  [618] = {.lex_state = 85},
  [619] = {.lex_state = 223, .external_lex_state = 7},
  [620] = {.lex_state = 225, .external_lex_state = 18},
  [621] = {.lex_state = 225, .external_lex_state = 18},
  [622] = {.lex_state = 85},
  [623] = {.lex_state = 215, .external_lex_state = 2},
  [624] = {.lex_state = 78},
  [625] = {.lex_state = 217},
  [626] = {.lex_state = 115},
  [627] = {.lex_state = 102},
  [628] = {.lex_state = 260, .external_lex_state = 18},
  [629] = {.lex_state = 85},
  [630] = {.lex_state = 225, .external_lex_state = 18},
  [631] = {.lex_state = 225, .external_lex_state = 18},
  [632] = {.lex_state = 142, .external_lex_state = 6},
  [633] = {.lex_state = 262, .external_lex_state = 29},
  [634] = {.lex_state = 115},
  [635] = {.lex_state = 122},
  [636] = {.lex_state = 262, .external_lex_state = 29},
  [637] = {.lex_state = 122, .external_lex_state = 7},
  [638] = {.lex_state = 262, .external_lex_state = 30},
  [639] = {.lex_state = 78, .external_lex_state = 2},
  [640] = {.lex_state = 78, .external_lex_state = 2},
  [641] = {.lex_state = 78, .external_lex_state = 2},
  [642] = {.lex_state = 262, .external_lex_state = 18},
  [643] = {.lex_state = 262, .external_lex_state = 18},
  [644] = {.lex_state = 142, .external_lex_state = 6},
  [645] = {.lex_state = 262, .external_lex_state = 30},
  [646] = {.lex_state = 262, .external_lex_state = 18},
  [647] = {.lex_state = 102},
  [648] = {.lex_state = 215, .external_lex_state = 22},
  [649] = {.lex_state = 215, .external_lex_state = 22},
  [650] = {.lex_state = 215, .external_lex_state = 2},
  [651] = {.lex_state = 142, .external_lex_state = 6},
  [652] = {.lex_state = 144, .external_lex_state = 8},
  [653] = {.lex_state = 85},
  [654] = {.lex_state = 108, .external_lex_state = 21},
  [655] = {.lex_state = 108, .external_lex_state = 21},
  [656] = {.lex_state = 85},
  [657] = {.lex_state = 108, .external_lex_state = 4},
  [658] = {.lex_state = 108, .external_lex_state = 4},
  [659] = {.lex_state = 108, .external_lex_state = 6},
  [660] = {.lex_state = 108, .external_lex_state = 6},
  [661] = {.lex_state = 108, .external_lex_state = 5},
  [662] = {.lex_state = 108, .external_lex_state = 5},
  [663] = {.lex_state = 112, .external_lex_state = 6},
  [664] = {.lex_state = 78},
  [665] = {.lex_state = 78, .external_lex_state = 2},
  [666] = {.lex_state = 78, .external_lex_state = 2},
  [667] = {.lex_state = 78, .external_lex_state = 2},
  [668] = {.lex_state = 102},
  [669] = {.lex_state = 102},
  [670] = {.lex_state = 146, .external_lex_state = 9},
  [671] = {.lex_state = 229, .external_lex_state = 5},
  [672] = {.lex_state = 237, .external_lex_state = 25},
  [673] = {.lex_state = 112, .external_lex_state = 6},
  [674] = {.lex_state = 112, .external_lex_state = 5},
  [675] = {.lex_state = 112, .external_lex_state = 5},
  [676] = {.lex_state = 229, .external_lex_state = 5},
  [677] = {.lex_state = 140, .external_lex_state = 4},
  [678] = {.lex_state = 112, .external_lex_state = 5},
  [679] = {.lex_state = 112, .external_lex_state = 5},
  [680] = {.lex_state = 142, .external_lex_state = 6},
  [681] = {.lex_state = 78},
  [682] = {.lex_state = 231, .external_lex_state = 9},
  [683] = {.lex_state = 122},
  [684] = {.lex_state = 122, .external_lex_state = 7},
  [685] = {.lex_state = 78, .external_lex_state = 2},
  [686] = {.lex_state = 78, .external_lex_state = 2},
  [687] = {.lex_state = 96, .external_lex_state = 23},
  [688] = {.lex_state = 102},
  [689] = {.lex_state = 136, .external_lex_state = 5},
  [690] = {.lex_state = 140, .external_lex_state = 4},
  [691] = {.lex_state = 136, .external_lex_state = 5},
  [692] = {.lex_state = 140, .external_lex_state = 4},
  [693] = {.lex_state = 264, .external_lex_state = 6},
  [694] = {.lex_state = 136, .external_lex_state = 6},
  [695] = {.lex_state = 186, .external_lex_state = 5},
  [696] = {.lex_state = 264, .external_lex_state = 5},
  [697] = {.lex_state = 186, .external_lex_state = 5},
  [698] = {.lex_state = 136, .external_lex_state = 6},
  [699] = {.lex_state = 186, .external_lex_state = 5},
  [700] = {.lex_state = 264, .external_lex_state = 5},
  [701] = {.lex_state = 233, .external_lex_state = 2},
  [702] = {.lex_state = 136, .external_lex_state = 5},
  [703] = {.lex_state = 142, .external_lex_state = 5},
  [704] = {.lex_state = 112, .external_lex_state = 6},
  [705] = {.lex_state = 112, .external_lex_state = 5},
  [706] = {.lex_state = 112, .external_lex_state = 5},
  [707] = {.lex_state = 233, .external_lex_state = 2},
  [708] = {.lex_state = 235, .external_lex_state = 9},
  [709] = {.lex_state = 106, .external_lex_state = 2},
  [710] = {.lex_state = 108, .external_lex_state = 4},
  [711] = {.lex_state = 108, .external_lex_state = 5},
  [712] = {.lex_state = 136, .external_lex_state = 5},
  [713] = {.lex_state = 112, .external_lex_state = 5},
  [714] = {.lex_state = 140, .external_lex_state = 4},
  [715] = {.lex_state = 102, .external_lex_state = 2},
  [716] = {.lex_state = 112, .external_lex_state = 5},
  [717] = {.lex_state = 239, .external_lex_state = 19},
  [718] = {.lex_state = 239, .external_lex_state = 20},
  [719] = {.lex_state = 266, .external_lex_state = 10},
  [720] = {.lex_state = 209, .external_lex_state = 20},
  [721] = {.lex_state = 209, .external_lex_state = 20},
  [722] = {.lex_state = 266, .external_lex_state = 10},
  [723] = {.lex_state = 239, .external_lex_state = 19},
  [724] = {.lex_state = 239, .external_lex_state = 19},
  [725] = {.lex_state = 184, .external_lex_state = 4},
  [726] = {.lex_state = 215, .external_lex_state = 10},
  [727] = {.lex_state = 115},
  [728] = {.lex_state = 122},
  [729] = {.lex_state = 215, .external_lex_state = 10},
  [730] = {.lex_state = 122, .external_lex_state = 7},
  [731] = {.lex_state = 78, .external_lex_state = 2},
  [732] = {.lex_state = 78, .external_lex_state = 2},
  [733] = {.lex_state = 78, .external_lex_state = 2},
  [734] = {.lex_state = 215},
  [735] = {.lex_state = 215},
  [736] = {.lex_state = 102},
  [737] = {.lex_state = 140, .external_lex_state = 21},
  [738] = {.lex_state = 184, .external_lex_state = 21},
  [739] = {.lex_state = 217},
  [740] = {.lex_state = 115},
  [741] = {.lex_state = 184, .external_lex_state = 21},
  [742] = {.lex_state = 184, .external_lex_state = 21},
  [743] = {.lex_state = 184, .external_lex_state = 21},
  [744] = {.lex_state = 85},
  [745] = {.lex_state = 223, .external_lex_state = 7},
  [746] = {.lex_state = 225, .external_lex_state = 18},
  [747] = {.lex_state = 225, .external_lex_state = 18},
  [748] = {.lex_state = 85},
  [749] = {.lex_state = 215, .external_lex_state = 2},
  [750] = {.lex_state = 78},
  [751] = {.lex_state = 85},
  [752] = {.lex_state = 184, .external_lex_state = 4},
  [753] = {.lex_state = 140, .external_lex_state = 4},
  [754] = {.lex_state = 268},
  [755] = {.lex_state = 241, .external_lex_state = 9},
  [756] = {.lex_state = 244},
  [757] = {.lex_state = 241, .external_lex_state = 9},
  [758] = {.lex_state = 102},
  [759] = {.lex_state = 241, .external_lex_state = 14},
  [760] = {.lex_state = 241, .external_lex_state = 14},
  [761] = {.lex_state = 217},
  [762] = {.lex_state = 115},
  [763] = {.lex_state = 241, .external_lex_state = 14},
  [764] = {.lex_state = 241, .external_lex_state = 14},
  [765] = {.lex_state = 241, .external_lex_state = 14},
  [766] = {.lex_state = 85},
  [767] = {.lex_state = 223, .external_lex_state = 7},
  [768] = {.lex_state = 225, .external_lex_state = 18},
  [769] = {.lex_state = 225, .external_lex_state = 18},
  [770] = {.lex_state = 85},
  [771] = {.lex_state = 215, .external_lex_state = 2},
  [772] = {.lex_state = 78},
  [773] = {.lex_state = 85},
  [774] = {.lex_state = 146, .external_lex_state = 9},
  [775] = {.lex_state = 96},
  [776] = {.lex_state = 96, .external_lex_state = 25},
  [777] = {.lex_state = 241, .external_lex_state = 9},
  [778] = {.lex_state = 241, .external_lex_state = 9},
  [779] = {.lex_state = 241, .external_lex_state = 9},
  [780] = {.lex_state = 270, .external_lex_state = 14},
  [781] = {.lex_state = 115},
  [782] = {.lex_state = 122},
  [783] = {.lex_state = 270, .external_lex_state = 14},
  [784] = {.lex_state = 122, .external_lex_state = 7},
  [785] = {.lex_state = 78, .external_lex_state = 2},
  [786] = {.lex_state = 78, .external_lex_state = 2},
  [787] = {.lex_state = 78, .external_lex_state = 2},
  [788] = {.lex_state = 270, .external_lex_state = 9},
  [789] = {.lex_state = 270, .external_lex_state = 9},
  [790] = {.lex_state = 186, .external_lex_state = 5},
  [791] = {.lex_state = 244},
  [792] = {.lex_state = 244},
  [793] = {.lex_state = 102},
  [794] = {.lex_state = 244, .external_lex_state = 10},
  [795] = {.lex_state = 272, .external_lex_state = 10},
  [796] = {.lex_state = 217},
  [797] = {.lex_state = 115},
  [798] = {.lex_state = 272, .external_lex_state = 10},
  [799] = {.lex_state = 272, .external_lex_state = 10},
  [800] = {.lex_state = 272, .external_lex_state = 10},
  [801] = {.lex_state = 85},
  [802] = {.lex_state = 223, .external_lex_state = 7},
  [803] = {.lex_state = 225, .external_lex_state = 18},
  [804] = {.lex_state = 225, .external_lex_state = 18},
  [805] = {.lex_state = 85},
  [806] = {.lex_state = 215, .external_lex_state = 2},
  [807] = {.lex_state = 78},
  [808] = {.lex_state = 85},
  [809] = {.lex_state = 246},
  [810] = {.lex_state = 96},
  [811] = {.lex_state = 96, .external_lex_state = 25},
  [812] = {.lex_state = 244},
  [813] = {.lex_state = 272},
  [814] = {.lex_state = 244},
  [815] = {.lex_state = 246, .external_lex_state = 10},
  [816] = {.lex_state = 153, .external_lex_state = 10},
  [817] = {.lex_state = 246, .external_lex_state = 10},
  [818] = {.lex_state = 217},
  [819] = {.lex_state = 260, .external_lex_state = 18},
  [820] = {.lex_state = 85},
  [821] = {.lex_state = 225, .external_lex_state = 18},
  [822] = {.lex_state = 225, .external_lex_state = 18},
  [823] = {.lex_state = 246, .external_lex_state = 10},
  [824] = {.lex_state = 262, .external_lex_state = 30},
  [825] = {.lex_state = 262, .external_lex_state = 18},
  [826] = {.lex_state = 246, .external_lex_state = 10},
  [827] = {.lex_state = 262, .external_lex_state = 30},
  [828] = {.lex_state = 262, .external_lex_state = 18},
  [829] = {.lex_state = 246, .external_lex_state = 10},
  [830] = {.lex_state = 246, .external_lex_state = 10},
  [831] = {.lex_state = 246},
  [832] = {.lex_state = 246},
  [833] = {.lex_state = 140, .external_lex_state = 11},
  [834] = {.lex_state = 215},
  [835] = {.lex_state = 140, .external_lex_state = 26},
  [836] = {.lex_state = 115},
  [837] = {.lex_state = 122},
  [838] = {.lex_state = 140, .external_lex_state = 26},
  [839] = {.lex_state = 122, .external_lex_state = 7},
  [840] = {.lex_state = 78, .external_lex_state = 2},
  [841] = {.lex_state = 78, .external_lex_state = 2},
  [842] = {.lex_state = 78, .external_lex_state = 2},
  [843] = {.lex_state = 140, .external_lex_state = 11},
  [844] = {.lex_state = 146, .external_lex_state = 9},
  [845] = {.lex_state = 241, .external_lex_state = 9},
  [846] = {.lex_state = 102},
  [847] = {.lex_state = 102},
  [848] = {.lex_state = 136, .external_lex_state = 12},
  [849] = {.lex_state = 249, .external_lex_state = 2},
  [850] = {.lex_state = 136, .external_lex_state = 12},
  [851] = {.lex_state = 255, .external_lex_state = 2},
  [852] = {.lex_state = 146, .external_lex_state = 9},
  [853] = {.lex_state = 149},
  [854] = {.lex_state = 146, .external_lex_state = 9},
  [855] = {.lex_state = 149},
  [856] = {.lex_state = 85},
  [857] = {.lex_state = 136, .external_lex_state = 12},
  [858] = {.lex_state = 136, .external_lex_state = 12},
  [859] = {.lex_state = 136, .external_lex_state = 12},
  [860] = {.lex_state = 144, .external_lex_state = 8},
  [861] = {.lex_state = 102},
  [862] = {.lex_state = 108, .external_lex_state = 26},
  [863] = {.lex_state = 108, .external_lex_state = 26},
  [864] = {.lex_state = 217},
  [865] = {.lex_state = 115},
  [866] = {.lex_state = 108, .external_lex_state = 26},
  [867] = {.lex_state = 108, .external_lex_state = 26},
  [868] = {.lex_state = 108, .external_lex_state = 26},
  [869] = {.lex_state = 85},
  [870] = {.lex_state = 223, .external_lex_state = 7},
  [871] = {.lex_state = 225, .external_lex_state = 18},
  [872] = {.lex_state = 225, .external_lex_state = 18},
  [873] = {.lex_state = 85},
  [874] = {.lex_state = 215, .external_lex_state = 2},
  [875] = {.lex_state = 78},
  [876] = {.lex_state = 85},
  [877] = {.lex_state = 108, .external_lex_state = 11},
  [878] = {.lex_state = 108, .external_lex_state = 11},
  [879] = {.lex_state = 108, .external_lex_state = 11},
  [880] = {.lex_state = 102},
  [881] = {.lex_state = 108, .external_lex_state = 13},
  [882] = {.lex_state = 108, .external_lex_state = 13},
  [883] = {.lex_state = 217},
  [884] = {.lex_state = 115},
  [885] = {.lex_state = 108, .external_lex_state = 13},
  [886] = {.lex_state = 108, .external_lex_state = 13},
  [887] = {.lex_state = 108, .external_lex_state = 13},
  [888] = {.lex_state = 85},
  [889] = {.lex_state = 223, .external_lex_state = 7},
  [890] = {.lex_state = 225, .external_lex_state = 18},
  [891] = {.lex_state = 225, .external_lex_state = 18},
  [892] = {.lex_state = 85},
  [893] = {.lex_state = 215, .external_lex_state = 2},
  [894] = {.lex_state = 78},
  [895] = {.lex_state = 85},
  [896] = {.lex_state = 108, .external_lex_state = 12},
  [897] = {.lex_state = 108, .external_lex_state = 12},
  [898] = {.lex_state = 108, .external_lex_state = 12},
  [899] = {.lex_state = 112, .external_lex_state = 13},
  [900] = {.lex_state = 112, .external_lex_state = 13},
  [901] = {.lex_state = 112, .external_lex_state = 13},
  [902] = {.lex_state = 217},
  [903] = {.lex_state = 260, .external_lex_state = 18},
  [904] = {.lex_state = 85},
  [905] = {.lex_state = 225, .external_lex_state = 18},
  [906] = {.lex_state = 225, .external_lex_state = 18},
  [907] = {.lex_state = 112, .external_lex_state = 13},
  [908] = {.lex_state = 262, .external_lex_state = 30},
  [909] = {.lex_state = 262, .external_lex_state = 18},
  [910] = {.lex_state = 112, .external_lex_state = 13},
  [911] = {.lex_state = 262, .external_lex_state = 30},
  [912] = {.lex_state = 262, .external_lex_state = 18},
  [913] = {.lex_state = 112, .external_lex_state = 13},
  [914] = {.lex_state = 112, .external_lex_state = 13},
  [915] = {.lex_state = 78},
  [916] = {.lex_state = 85},
  [917] = {.lex_state = 186, .external_lex_state = 5},
  [918] = {.lex_state = 106, .external_lex_state = 2},
  [919] = {.lex_state = 275, .external_lex_state = 4},
  [920] = {.lex_state = 275, .external_lex_state = 5},
  [921] = {.lex_state = 281, .external_lex_state = 6},
  [922] = {.lex_state = 115},
  [923] = {.lex_state = 122},
  [924] = {.lex_state = 281, .external_lex_state = 6},
  [925] = {.lex_state = 122, .external_lex_state = 7},
  [926] = {.lex_state = 78, .external_lex_state = 2},
  [927] = {.lex_state = 78, .external_lex_state = 2},
  [928] = {.lex_state = 78, .external_lex_state = 2},
  [929] = {.lex_state = 283, .external_lex_state = 6},
  [930] = {.lex_state = 172},
  [931] = {.lex_state = 285, .external_lex_state = 5},
  [932] = {.lex_state = 281, .external_lex_state = 5},
  [933] = {.lex_state = 287, .external_lex_state = 4},
  [934] = {.lex_state = 85},
  [935] = {.lex_state = 281, .external_lex_state = 5},
  [936] = {.lex_state = 78, .external_lex_state = 2},
  [937] = {.lex_state = 102, .external_lex_state = 2},
  [938] = {.lex_state = 281, .external_lex_state = 5},
  [939] = {.lex_state = 102},
  [940] = {.lex_state = 136, .external_lex_state = 12},
  [941] = {.lex_state = 140, .external_lex_state = 11},
  [942] = {.lex_state = 136, .external_lex_state = 12},
  [943] = {.lex_state = 140, .external_lex_state = 11},
  [944] = {.lex_state = 140, .external_lex_state = 13},
  [945] = {.lex_state = 136, .external_lex_state = 13},
  [946] = {.lex_state = 136, .external_lex_state = 12},
  [947] = {.lex_state = 140, .external_lex_state = 12},
  [948] = {.lex_state = 136, .external_lex_state = 12},
  [949] = {.lex_state = 136, .external_lex_state = 13},
  [950] = {.lex_state = 136, .external_lex_state = 12},
  [951] = {.lex_state = 140, .external_lex_state = 12},
  [952] = {.lex_state = 136, .external_lex_state = 12},
  [953] = {.lex_state = 112, .external_lex_state = 12},
  [954] = {.lex_state = 112, .external_lex_state = 13},
  [955] = {.lex_state = 112, .external_lex_state = 12},
  [956] = {.lex_state = 112, .external_lex_state = 12},
  [957] = {.lex_state = 112, .external_lex_state = 12},
  [958] = {.lex_state = 85},
  [959] = {.lex_state = 186, .external_lex_state = 5},
  [960] = {.lex_state = 78, .external_lex_state = 2},
  [961] = {.lex_state = 289, .external_lex_state = 2},
  [962] = {.lex_state = 106, .external_lex_state = 2},
  [963] = {.lex_state = 291, .external_lex_state = 4},
  [964] = {.lex_state = 291, .external_lex_state = 5},
  [965] = {.lex_state = 301, .external_lex_state = 6},
  [966] = {.lex_state = 115},
  [967] = {.lex_state = 122},
  [968] = {.lex_state = 301, .external_lex_state = 6},
  [969] = {.lex_state = 122, .external_lex_state = 7},
  [970] = {.lex_state = 78, .external_lex_state = 2},
  [971] = {.lex_state = 78, .external_lex_state = 2},
  [972] = {.lex_state = 78, .external_lex_state = 2},
  [973] = {.lex_state = 303, .external_lex_state = 6},
  [974] = {.lex_state = 305},
  [975] = {.lex_state = 305, .external_lex_state = 5},
  [976] = {.lex_state = 305},
  [977] = {.lex_state = 301, .external_lex_state = 5},
  [978] = {.lex_state = 308, .external_lex_state = 4},
  [979] = {.lex_state = 85},
  [980] = {.lex_state = 301, .external_lex_state = 5},
  [981] = {.lex_state = 78, .external_lex_state = 2},
  [982] = {.lex_state = 305},
  [983] = {.lex_state = 102, .external_lex_state = 2},
  [984] = {.lex_state = 301, .external_lex_state = 5},
  [985] = {.lex_state = 149, .external_lex_state = 14},
  [986] = {.lex_state = 149, .external_lex_state = 14},
  [987] = {.lex_state = 149, .external_lex_state = 14},
  [988] = {.lex_state = 217},
  [989] = {.lex_state = 310},
  [990] = {.lex_state = 146, .external_lex_state = 9},
  [991] = {.lex_state = 260, .external_lex_state = 18},
  [992] = {.lex_state = 85},
  [993] = {.lex_state = 225, .external_lex_state = 18},
  [994] = {.lex_state = 225, .external_lex_state = 18},
  [995] = {.lex_state = 149, .external_lex_state = 14},
  [996] = {.lex_state = 262, .external_lex_state = 30},
  [997] = {.lex_state = 262, .external_lex_state = 18},
  [998] = {.lex_state = 149, .external_lex_state = 14},
  [999] = {.lex_state = 262, .external_lex_state = 30},
  [1000] = {.lex_state = 262, .external_lex_state = 18},
  [1001] = {.lex_state = 149, .external_lex_state = 14},
  [1002] = {.lex_state = 149, .external_lex_state = 14},
  [1003] = {.lex_state = 310},
  [1004] = {.lex_state = 146, .external_lex_state = 9},
  [1005] = {.lex_state = 78},
  [1006] = {.lex_state = 184, .external_lex_state = 21},
  [1007] = {.lex_state = 184, .external_lex_state = 21},
  [1008] = {.lex_state = 184, .external_lex_state = 4},
  [1009] = {.lex_state = 144, .external_lex_state = 8},
  [1010] = {.lex_state = 178, .external_lex_state = 21},
  [1011] = {.lex_state = 178, .external_lex_state = 4},
  [1012] = {.lex_state = 178, .external_lex_state = 4},
  [1013] = {.lex_state = 178, .external_lex_state = 6},
  [1014] = {.lex_state = 178, .external_lex_state = 5},
  [1015] = {.lex_state = 178, .external_lex_state = 5},
  [1016] = {.lex_state = 142, .external_lex_state = 6},
  [1017] = {.lex_state = 102},
  [1018] = {.lex_state = 182, .external_lex_state = 5},
  [1019] = {.lex_state = 184, .external_lex_state = 4},
  [1020] = {.lex_state = 182, .external_lex_state = 5},
  [1021] = {.lex_state = 184, .external_lex_state = 4},
  [1022] = {.lex_state = 182, .external_lex_state = 6},
  [1023] = {.lex_state = 182, .external_lex_state = 6},
  [1024] = {.lex_state = 182, .external_lex_state = 5},
  [1025] = {.lex_state = 182, .external_lex_state = 6},
  [1026] = {.lex_state = 182, .external_lex_state = 5},
  [1027] = {.lex_state = 182, .external_lex_state = 5},
  [1028] = {.lex_state = 142, .external_lex_state = 6},
  [1029] = {.lex_state = 142, .external_lex_state = 5},
  [1030] = {.lex_state = 142, .external_lex_state = 5},
  [1031] = {.lex_state = 142, .external_lex_state = 5},
  [1032] = {.lex_state = 207, .external_lex_state = 15},
  [1033] = {.lex_state = 215},
  [1034] = {.lex_state = 207, .external_lex_state = 27},
  [1035] = {.lex_state = 115},
  [1036] = {.lex_state = 122},
  [1037] = {.lex_state = 207, .external_lex_state = 27},
  [1038] = {.lex_state = 122, .external_lex_state = 7},
  [1039] = {.lex_state = 78, .external_lex_state = 2},
  [1040] = {.lex_state = 78, .external_lex_state = 2},
  [1041] = {.lex_state = 78, .external_lex_state = 2},
  [1042] = {.lex_state = 207, .external_lex_state = 15},
  [1043] = {.lex_state = 146, .external_lex_state = 9},
  [1044] = {.lex_state = 241, .external_lex_state = 9},
  [1045] = {.lex_state = 102},
  [1046] = {.lex_state = 102},
  [1047] = {.lex_state = 205, .external_lex_state = 16},
  [1048] = {.lex_state = 249, .external_lex_state = 2},
  [1049] = {.lex_state = 205, .external_lex_state = 16},
  [1050] = {.lex_state = 255, .external_lex_state = 2},
  [1051] = {.lex_state = 146, .external_lex_state = 9},
  [1052] = {.lex_state = 149},
  [1053] = {.lex_state = 146, .external_lex_state = 9},
  [1054] = {.lex_state = 149},
  [1055] = {.lex_state = 85},
  [1056] = {.lex_state = 205, .external_lex_state = 16},
  [1057] = {.lex_state = 205, .external_lex_state = 16},
  [1058] = {.lex_state = 205, .external_lex_state = 16},
  [1059] = {.lex_state = 144, .external_lex_state = 8},
  [1060] = {.lex_state = 102},
  [1061] = {.lex_state = 199, .external_lex_state = 27},
  [1062] = {.lex_state = 199, .external_lex_state = 27},
  [1063] = {.lex_state = 217},
  [1064] = {.lex_state = 115},
  [1065] = {.lex_state = 199, .external_lex_state = 27},
  [1066] = {.lex_state = 199, .external_lex_state = 27},
  [1067] = {.lex_state = 199, .external_lex_state = 27},
  [1068] = {.lex_state = 85},
  [1069] = {.lex_state = 223, .external_lex_state = 7},
  [1070] = {.lex_state = 225, .external_lex_state = 18},
  [1071] = {.lex_state = 225, .external_lex_state = 18},
  [1072] = {.lex_state = 85},
  [1073] = {.lex_state = 215, .external_lex_state = 2},
  [1074] = {.lex_state = 78},
  [1075] = {.lex_state = 85},
  [1076] = {.lex_state = 199, .external_lex_state = 15},
  [1077] = {.lex_state = 199, .external_lex_state = 15},
  [1078] = {.lex_state = 199, .external_lex_state = 15},
  [1079] = {.lex_state = 102},
  [1080] = {.lex_state = 199, .external_lex_state = 17},
  [1081] = {.lex_state = 199, .external_lex_state = 17},
  [1082] = {.lex_state = 217},
  [1083] = {.lex_state = 115},
  [1084] = {.lex_state = 199, .external_lex_state = 17},
  [1085] = {.lex_state = 199, .external_lex_state = 17},
  [1086] = {.lex_state = 199, .external_lex_state = 17},
  [1087] = {.lex_state = 85},
  [1088] = {.lex_state = 223, .external_lex_state = 7},
  [1089] = {.lex_state = 225, .external_lex_state = 18},
  [1090] = {.lex_state = 225, .external_lex_state = 18},
  [1091] = {.lex_state = 85},
  [1092] = {.lex_state = 215, .external_lex_state = 2},
  [1093] = {.lex_state = 78},
  [1094] = {.lex_state = 85},
  [1095] = {.lex_state = 199, .external_lex_state = 16},
  [1096] = {.lex_state = 199, .external_lex_state = 16},
  [1097] = {.lex_state = 199, .external_lex_state = 16},
  [1098] = {.lex_state = 201, .external_lex_state = 17},
  [1099] = {.lex_state = 201, .external_lex_state = 17},
  [1100] = {.lex_state = 201, .external_lex_state = 17},
  [1101] = {.lex_state = 217},
  [1102] = {.lex_state = 260, .external_lex_state = 18},
  [1103] = {.lex_state = 85},
  [1104] = {.lex_state = 225, .external_lex_state = 18},
  [1105] = {.lex_state = 225, .external_lex_state = 18},
  [1106] = {.lex_state = 201, .external_lex_state = 17},
  [1107] = {.lex_state = 262, .external_lex_state = 30},
  [1108] = {.lex_state = 262, .external_lex_state = 18},
  [1109] = {.lex_state = 201, .external_lex_state = 17},
  [1110] = {.lex_state = 262, .external_lex_state = 30},
  [1111] = {.lex_state = 262, .external_lex_state = 18},
  [1112] = {.lex_state = 201, .external_lex_state = 17},
  [1113] = {.lex_state = 201, .external_lex_state = 17},
  [1114] = {.lex_state = 78},
  [1115] = {.lex_state = 258, .external_lex_state = 28},
  [1116] = {.lex_state = 96, .external_lex_state = 23},
  [1117] = {.lex_state = 102},
  [1118] = {.lex_state = 205, .external_lex_state = 16},
  [1119] = {.lex_state = 207, .external_lex_state = 15},
  [1120] = {.lex_state = 205, .external_lex_state = 16},
  [1121] = {.lex_state = 207, .external_lex_state = 15},
  [1122] = {.lex_state = 205, .external_lex_state = 17},
  [1123] = {.lex_state = 205, .external_lex_state = 17},
  [1124] = {.lex_state = 205, .external_lex_state = 16},
  [1125] = {.lex_state = 205, .external_lex_state = 16},
  [1126] = {.lex_state = 205, .external_lex_state = 16},
  [1127] = {.lex_state = 205, .external_lex_state = 17},
  [1128] = {.lex_state = 205, .external_lex_state = 16},
  [1129] = {.lex_state = 205, .external_lex_state = 16},
  [1130] = {.lex_state = 104, .external_lex_state = 3},
  [1131] = {.lex_state = 205, .external_lex_state = 16},
  [1132] = {.lex_state = 201, .external_lex_state = 16},
  [1133] = {.lex_state = 201, .external_lex_state = 17},
  [1134] = {.lex_state = 201, .external_lex_state = 16},
  [1135] = {.lex_state = 201, .external_lex_state = 16},
  [1136] = {.lex_state = 104, .external_lex_state = 3},
  [1137] = {.lex_state = 258, .external_lex_state = 28},
  [1138] = {.lex_state = 201, .external_lex_state = 16},
  [1139] = {.lex_state = 102, .external_lex_state = 2},
  [1140] = {.lex_state = 215},
  [1141] = {.lex_state = 102, .external_lex_state = 22},
  [1142] = {.lex_state = 102, .external_lex_state = 2},
  [1143] = {.lex_state = 209, .external_lex_state = 20},
  [1144] = {.lex_state = 209, .external_lex_state = 19},
  [1145] = {.lex_state = 209, .external_lex_state = 19},
  [1146] = {.lex_state = 209, .external_lex_state = 19},
  [1147] = {.lex_state = 217},
  [1148] = {.lex_state = 260, .external_lex_state = 18},
  [1149] = {.lex_state = 85},
  [1150] = {.lex_state = 225, .external_lex_state = 18},
  [1151] = {.lex_state = 225, .external_lex_state = 18},
  [1152] = {.lex_state = 209, .external_lex_state = 19},
  [1153] = {.lex_state = 262, .external_lex_state = 30},
  [1154] = {.lex_state = 262, .external_lex_state = 18},
  [1155] = {.lex_state = 209, .external_lex_state = 19},
  [1156] = {.lex_state = 262, .external_lex_state = 30},
  [1157] = {.lex_state = 262, .external_lex_state = 18},
  [1158] = {.lex_state = 209, .external_lex_state = 19},
  [1159] = {.lex_state = 209, .external_lex_state = 19},
  [1160] = {.lex_state = 209, .external_lex_state = 20},
  [1161] = {.lex_state = 209, .external_lex_state = 20},
  [1162] = {.lex_state = 212, .external_lex_state = 10},
  [1163] = {.lex_state = 178, .external_lex_state = 4},
  [1164] = {.lex_state = 215},
  [1165] = {.lex_state = 108, .external_lex_state = 21},
  [1166] = {.lex_state = 108, .external_lex_state = 4},
  [1167] = {.lex_state = 178, .external_lex_state = 21},
  [1168] = {.lex_state = 108, .external_lex_state = 21},
  [1169] = {.lex_state = 178, .external_lex_state = 21},
  [1170] = {.lex_state = 217},
  [1171] = {.lex_state = 260, .external_lex_state = 18},
  [1172] = {.lex_state = 85},
  [1173] = {.lex_state = 225, .external_lex_state = 18},
  [1174] = {.lex_state = 225, .external_lex_state = 18},
  [1175] = {.lex_state = 178, .external_lex_state = 21},
  [1176] = {.lex_state = 262, .external_lex_state = 30},
  [1177] = {.lex_state = 262, .external_lex_state = 18},
  [1178] = {.lex_state = 178, .external_lex_state = 21},
  [1179] = {.lex_state = 262, .external_lex_state = 30},
  [1180] = {.lex_state = 262, .external_lex_state = 18},
  [1181] = {.lex_state = 178, .external_lex_state = 21},
  [1182] = {.lex_state = 178, .external_lex_state = 21},
  [1183] = {.lex_state = 178, .external_lex_state = 6},
  [1184] = {.lex_state = 108, .external_lex_state = 6},
  [1185] = {.lex_state = 178, .external_lex_state = 6},
  [1186] = {.lex_state = 217},
  [1187] = {.lex_state = 260, .external_lex_state = 18},
  [1188] = {.lex_state = 85},
  [1189] = {.lex_state = 225, .external_lex_state = 18},
  [1190] = {.lex_state = 225, .external_lex_state = 18},
  [1191] = {.lex_state = 178, .external_lex_state = 6},
  [1192] = {.lex_state = 262, .external_lex_state = 30},
  [1193] = {.lex_state = 262, .external_lex_state = 18},
  [1194] = {.lex_state = 178, .external_lex_state = 6},
  [1195] = {.lex_state = 262, .external_lex_state = 30},
  [1196] = {.lex_state = 262, .external_lex_state = 18},
  [1197] = {.lex_state = 178, .external_lex_state = 6},
  [1198] = {.lex_state = 178, .external_lex_state = 6},
  [1199] = {.lex_state = 215, .external_lex_state = 22},
  [1200] = {.lex_state = 102, .external_lex_state = 22},
  [1201] = {.lex_state = 215, .external_lex_state = 22},
  [1202] = {.lex_state = 217},
  [1203] = {.lex_state = 260, .external_lex_state = 18},
  [1204] = {.lex_state = 85},
  [1205] = {.lex_state = 225, .external_lex_state = 18},
  [1206] = {.lex_state = 225, .external_lex_state = 18},
  [1207] = {.lex_state = 215, .external_lex_state = 22},
  [1208] = {.lex_state = 262, .external_lex_state = 30},
  [1209] = {.lex_state = 262, .external_lex_state = 18},
  [1210] = {.lex_state = 215, .external_lex_state = 22},
  [1211] = {.lex_state = 262, .external_lex_state = 30},
  [1212] = {.lex_state = 262, .external_lex_state = 18},
  [1213] = {.lex_state = 215, .external_lex_state = 22},
  [1214] = {.lex_state = 215, .external_lex_state = 22},
  [1215] = {.lex_state = 115},
  [1216] = {.lex_state = 260, .external_lex_state = 18},
  [1217] = {.lex_state = 85},
  [1218] = {.lex_state = 225, .external_lex_state = 18},
  [1219] = {.lex_state = 225, .external_lex_state = 18},
  [1220] = {.lex_state = 115, .external_lex_state = 10},
  [1221] = {.lex_state = 262, .external_lex_state = 30},
  [1222] = {.lex_state = 262, .external_lex_state = 18},
  [1223] = {.lex_state = 115, .external_lex_state = 10},
  [1224] = {.lex_state = 262, .external_lex_state = 30},
  [1225] = {.lex_state = 262, .external_lex_state = 18},
  [1226] = {.lex_state = 115, .external_lex_state = 10},
  [1227] = {.lex_state = 142, .external_lex_state = 6},
  [1228] = {.lex_state = 217},
  [1229] = {.lex_state = 239, .external_lex_state = 19},
  [1230] = {.lex_state = 239, .external_lex_state = 19},
  [1231] = {.lex_state = 239, .external_lex_state = 19},
  [1232] = {.lex_state = 142, .external_lex_state = 6},
  [1233] = {.lex_state = 92, .external_lex_state = 29},
  [1234] = {.lex_state = 115},
  [1235] = {.lex_state = 122},
  [1236] = {.lex_state = 92, .external_lex_state = 29},
  [1237] = {.lex_state = 122, .external_lex_state = 7},
  [1238] = {.lex_state = 78, .external_lex_state = 2},
  [1239] = {.lex_state = 78, .external_lex_state = 2},
  [1240] = {.lex_state = 78, .external_lex_state = 2},
  [1241] = {.lex_state = 92, .external_lex_state = 18},
  [1242] = {.lex_state = 92, .external_lex_state = 18},
  [1243] = {.lex_state = 260, .external_lex_state = 18},
  [1244] = {.lex_state = 142, .external_lex_state = 6},
  [1245] = {.lex_state = 262, .external_lex_state = 30},
  [1246] = {.lex_state = 262, .external_lex_state = 18},
  [1247] = {.lex_state = 262, .external_lex_state = 30},
  [1248] = {.lex_state = 262, .external_lex_state = 18},
  [1249] = {.lex_state = 102},
  [1250] = {.lex_state = 262, .external_lex_state = 29},
  [1251] = {.lex_state = 262, .external_lex_state = 29},
  [1252] = {.lex_state = 217},
  [1253] = {.lex_state = 115},
  [1254] = {.lex_state = 262, .external_lex_state = 29},
  [1255] = {.lex_state = 262, .external_lex_state = 29},
  [1256] = {.lex_state = 262, .external_lex_state = 29},
  [1257] = {.lex_state = 85},
  [1258] = {.lex_state = 223, .external_lex_state = 7},
  [1259] = {.lex_state = 225, .external_lex_state = 18},
  [1260] = {.lex_state = 225, .external_lex_state = 18},
  [1261] = {.lex_state = 262, .external_lex_state = 18},
  [1262] = {.lex_state = 142, .external_lex_state = 6},
  [1263] = {.lex_state = 262, .external_lex_state = 18},
  [1264] = {.lex_state = 85},
  [1265] = {.lex_state = 215, .external_lex_state = 2},
  [1266] = {.lex_state = 78},
  [1267] = {.lex_state = 85},
  [1268] = {.lex_state = 262, .external_lex_state = 18},
  [1269] = {.lex_state = 262, .external_lex_state = 18},
  [1270] = {.lex_state = 262, .external_lex_state = 18},
  [1271] = {.lex_state = 262, .external_lex_state = 18},
  [1272] = {.lex_state = 215, .external_lex_state = 22},
  [1273] = {.lex_state = 215, .external_lex_state = 2},
  [1274] = {.lex_state = 215, .external_lex_state = 22},
  [1275] = {.lex_state = 215, .external_lex_state = 2},
  [1276] = {.lex_state = 140, .external_lex_state = 21},
  [1277] = {.lex_state = 140, .external_lex_state = 21},
  [1278] = {.lex_state = 140, .external_lex_state = 4},
  [1279] = {.lex_state = 144, .external_lex_state = 8},
  [1280] = {.lex_state = 108, .external_lex_state = 21},
  [1281] = {.lex_state = 108, .external_lex_state = 4},
  [1282] = {.lex_state = 108, .external_lex_state = 4},
  [1283] = {.lex_state = 108, .external_lex_state = 6},
  [1284] = {.lex_state = 108, .external_lex_state = 5},
  [1285] = {.lex_state = 108, .external_lex_state = 5},
  [1286] = {.lex_state = 112, .external_lex_state = 6},
  [1287] = {.lex_state = 102},
  [1288] = {.lex_state = 229, .external_lex_state = 5},
  [1289] = {.lex_state = 140, .external_lex_state = 4},
  [1290] = {.lex_state = 229, .external_lex_state = 5},
  [1291] = {.lex_state = 140, .external_lex_state = 4},
  [1292] = {.lex_state = 229, .external_lex_state = 6},
  [1293] = {.lex_state = 229, .external_lex_state = 6},
  [1294] = {.lex_state = 229, .external_lex_state = 5},
  [1295] = {.lex_state = 229, .external_lex_state = 6},
  [1296] = {.lex_state = 229, .external_lex_state = 5},
  [1297] = {.lex_state = 78, .external_lex_state = 2},
  [1298] = {.lex_state = 229, .external_lex_state = 5},
  [1299] = {.lex_state = 112, .external_lex_state = 6},
  [1300] = {.lex_state = 112, .external_lex_state = 5},
  [1301] = {.lex_state = 112, .external_lex_state = 5},
  [1302] = {.lex_state = 78, .external_lex_state = 2},
  [1303] = {.lex_state = 146, .external_lex_state = 9},
  [1304] = {.lex_state = 112, .external_lex_state = 5},
  [1305] = {.lex_state = 186, .external_lex_state = 5},
  [1306] = {.lex_state = 96, .external_lex_state = 23},
  [1307] = {.lex_state = 96, .external_lex_state = 23},
  [1308] = {.lex_state = 85},
  [1309] = {.lex_state = 223, .external_lex_state = 7},
  [1310] = {.lex_state = 225, .external_lex_state = 18},
  [1311] = {.lex_state = 225, .external_lex_state = 18},
  [1312] = {.lex_state = 85},
  [1313] = {.lex_state = 215, .external_lex_state = 2},
  [1314] = {.lex_state = 78},
  [1315] = {.lex_state = 231, .external_lex_state = 9},
  [1316] = {.lex_state = 96, .external_lex_state = 23},
  [1317] = {.lex_state = 136, .external_lex_state = 6},
  [1318] = {.lex_state = 186, .external_lex_state = 5},
  [1319] = {.lex_state = 264, .external_lex_state = 5},
  [1320] = {.lex_state = 136, .external_lex_state = 6},
  [1321] = {.lex_state = 264, .external_lex_state = 5},
  [1322] = {.lex_state = 233, .external_lex_state = 2},
  [1323] = {.lex_state = 108, .external_lex_state = 4},
  [1324] = {.lex_state = 108, .external_lex_state = 5},
  [1325] = {.lex_state = 78},
  [1326] = {.lex_state = 78, .external_lex_state = 2},
  [1327] = {.lex_state = 78, .external_lex_state = 2},
  [1328] = {.lex_state = 78, .external_lex_state = 2},
  [1329] = {.lex_state = 102},
  [1330] = {.lex_state = 102},
  [1331] = {.lex_state = 146, .external_lex_state = 9},
  [1332] = {.lex_state = 136, .external_lex_state = 5},
  [1333] = {.lex_state = 112, .external_lex_state = 5},
  [1334] = {.lex_state = 112, .external_lex_state = 5},
  [1335] = {.lex_state = 239, .external_lex_state = 19},
  [1336] = {.lex_state = 266, .external_lex_state = 10},
  [1337] = {.lex_state = 85},
  [1338] = {.lex_state = 266, .external_lex_state = 10},
  [1339] = {.lex_state = 85},
  [1340] = {.lex_state = 102},
  [1341] = {.lex_state = 215, .external_lex_state = 10},
  [1342] = {.lex_state = 215, .external_lex_state = 10},
  [1343] = {.lex_state = 217},
  [1344] = {.lex_state = 115},
  [1345] = {.lex_state = 215, .external_lex_state = 10},
  [1346] = {.lex_state = 215, .external_lex_state = 10},
  [1347] = {.lex_state = 215, .external_lex_state = 10},
  [1348] = {.lex_state = 85},
  [1349] = {.lex_state = 223, .external_lex_state = 7},
  [1350] = {.lex_state = 225, .external_lex_state = 18},
  [1351] = {.lex_state = 225, .external_lex_state = 18},
  [1352] = {.lex_state = 85},
  [1353] = {.lex_state = 215, .external_lex_state = 2},
  [1354] = {.lex_state = 78},
  [1355] = {.lex_state = 85},
  [1356] = {.lex_state = 184, .external_lex_state = 4},
  [1357] = {.lex_state = 215},
  [1358] = {.lex_state = 215},
  [1359] = {.lex_state = 215},
  [1360] = {.lex_state = 184, .external_lex_state = 21},
  [1361] = {.lex_state = 140, .external_lex_state = 21},
  [1362] = {.lex_state = 184, .external_lex_state = 21},
  [1363] = {.lex_state = 217},
  [1364] = {.lex_state = 260, .external_lex_state = 18},
  [1365] = {.lex_state = 85},
  [1366] = {.lex_state = 225, .external_lex_state = 18},
  [1367] = {.lex_state = 225, .external_lex_state = 18},
  [1368] = {.lex_state = 184, .external_lex_state = 21},
  [1369] = {.lex_state = 262, .external_lex_state = 30},
  [1370] = {.lex_state = 262, .external_lex_state = 18},
  [1371] = {.lex_state = 184, .external_lex_state = 21},
  [1372] = {.lex_state = 262, .external_lex_state = 30},
  [1373] = {.lex_state = 262, .external_lex_state = 18},
  [1374] = {.lex_state = 184, .external_lex_state = 21},
  [1375] = {.lex_state = 184, .external_lex_state = 21},
  [1376] = {.lex_state = 313},
  [1377] = {.lex_state = 153},
  [1378] = {.lex_state = 268},
  [1379] = {.lex_state = 241, .external_lex_state = 9},
  [1380] = {.lex_state = 241, .external_lex_state = 14},
  [1381] = {.lex_state = 241, .external_lex_state = 14},
  [1382] = {.lex_state = 241, .external_lex_state = 14},
  [1383] = {.lex_state = 217},
  [1384] = {.lex_state = 260, .external_lex_state = 18},
  [1385] = {.lex_state = 85},
  [1386] = {.lex_state = 225, .external_lex_state = 18},
  [1387] = {.lex_state = 225, .external_lex_state = 18},
  [1388] = {.lex_state = 241, .external_lex_state = 14},
  [1389] = {.lex_state = 262, .external_lex_state = 30},
  [1390] = {.lex_state = 262, .external_lex_state = 18},
  [1391] = {.lex_state = 241, .external_lex_state = 14},
  [1392] = {.lex_state = 262, .external_lex_state = 30},
  [1393] = {.lex_state = 262, .external_lex_state = 18},
  [1394] = {.lex_state = 241, .external_lex_state = 14},
  [1395] = {.lex_state = 241, .external_lex_state = 14},
  [1396] = {.lex_state = 241, .external_lex_state = 9},
  [1397] = {.lex_state = 241, .external_lex_state = 9},
  [1398] = {.lex_state = 241, .external_lex_state = 9},
  [1399] = {.lex_state = 102},
  [1400] = {.lex_state = 270, .external_lex_state = 14},
  [1401] = {.lex_state = 270, .external_lex_state = 14},
  [1402] = {.lex_state = 217},
  [1403] = {.lex_state = 115},
  [1404] = {.lex_state = 270, .external_lex_state = 14},
  [1405] = {.lex_state = 270, .external_lex_state = 14},
  [1406] = {.lex_state = 270, .external_lex_state = 14},
  [1407] = {.lex_state = 85},
  [1408] = {.lex_state = 223, .external_lex_state = 7},
  [1409] = {.lex_state = 225, .external_lex_state = 18},
  [1410] = {.lex_state = 225, .external_lex_state = 18},
  [1411] = {.lex_state = 85},
  [1412] = {.lex_state = 215, .external_lex_state = 2},
  [1413] = {.lex_state = 78},
  [1414] = {.lex_state = 85},
  [1415] = {.lex_state = 102},
  [1416] = {.lex_state = 270, .external_lex_state = 9},
  [1417] = {.lex_state = 270, .external_lex_state = 9},
  [1418] = {.lex_state = 270, .external_lex_state = 9},
  [1419] = {.lex_state = 244},
  [1420] = {.lex_state = 272, .external_lex_state = 10},
  [1421] = {.lex_state = 244, .external_lex_state = 10},
  [1422] = {.lex_state = 272, .external_lex_state = 10},
  [1423] = {.lex_state = 217},
  [1424] = {.lex_state = 260, .external_lex_state = 18},
  [1425] = {.lex_state = 85},
  [1426] = {.lex_state = 225, .external_lex_state = 18},
  [1427] = {.lex_state = 225, .external_lex_state = 18},
  [1428] = {.lex_state = 272, .external_lex_state = 10},
  [1429] = {.lex_state = 262, .external_lex_state = 30},
  [1430] = {.lex_state = 262, .external_lex_state = 18},
  [1431] = {.lex_state = 272, .external_lex_state = 10},
  [1432] = {.lex_state = 262, .external_lex_state = 30},
  [1433] = {.lex_state = 262, .external_lex_state = 18},
  [1434] = {.lex_state = 272, .external_lex_state = 10},
  [1435] = {.lex_state = 272, .external_lex_state = 10},
  [1436] = {.lex_state = 244},
  [1437] = {.lex_state = 244},
  [1438] = {.lex_state = 246, .external_lex_state = 10},
  [1439] = {.lex_state = 246, .external_lex_state = 10},
  [1440] = {.lex_state = 92, .external_lex_state = 29},
  [1441] = {.lex_state = 92, .external_lex_state = 18},
  [1442] = {.lex_state = 92, .external_lex_state = 18},
  [1443] = {.lex_state = 260, .external_lex_state = 18},
  [1444] = {.lex_state = 246, .external_lex_state = 10},
  [1445] = {.lex_state = 262, .external_lex_state = 30},
  [1446] = {.lex_state = 262, .external_lex_state = 18},
  [1447] = {.lex_state = 262, .external_lex_state = 30},
  [1448] = {.lex_state = 262, .external_lex_state = 18},
  [1449] = {.lex_state = 262, .external_lex_state = 18},
  [1450] = {.lex_state = 246, .external_lex_state = 10},
  [1451] = {.lex_state = 262, .external_lex_state = 18},
  [1452] = {.lex_state = 262, .external_lex_state = 18},
  [1453] = {.lex_state = 140, .external_lex_state = 11},
  [1454] = {.lex_state = 215},
  [1455] = {.lex_state = 102},
  [1456] = {.lex_state = 140, .external_lex_state = 26},
  [1457] = {.lex_state = 140, .external_lex_state = 26},
  [1458] = {.lex_state = 217},
  [1459] = {.lex_state = 115},
  [1460] = {.lex_state = 140, .external_lex_state = 26},
  [1461] = {.lex_state = 140, .external_lex_state = 26},
  [1462] = {.lex_state = 140, .external_lex_state = 26},
  [1463] = {.lex_state = 85},
  [1464] = {.lex_state = 223, .external_lex_state = 7},
  [1465] = {.lex_state = 225, .external_lex_state = 18},
  [1466] = {.lex_state = 225, .external_lex_state = 18},
  [1467] = {.lex_state = 85},
  [1468] = {.lex_state = 215, .external_lex_state = 2},
  [1469] = {.lex_state = 78},
  [1470] = {.lex_state = 85},
  [1471] = {.lex_state = 140, .external_lex_state = 11},
  [1472] = {.lex_state = 140, .external_lex_state = 11},
  [1473] = {.lex_state = 268},
  [1474] = {.lex_state = 241, .external_lex_state = 9},
  [1475] = {.lex_state = 146, .external_lex_state = 9},
  [1476] = {.lex_state = 270, .external_lex_state = 9},
  [1477] = {.lex_state = 136, .external_lex_state = 12},
  [1478] = {.lex_state = 136, .external_lex_state = 12},
  [1479] = {.lex_state = 172},
  [1480] = {.lex_state = 136, .external_lex_state = 12},
  [1481] = {.lex_state = 305},
  [1482] = {.lex_state = 305},
  [1483] = {.lex_state = 305},
  [1484] = {.lex_state = 310},
  [1485] = {.lex_state = 146, .external_lex_state = 9},
  [1486] = {.lex_state = 310},
  [1487] = {.lex_state = 146, .external_lex_state = 9},
  [1488] = {.lex_state = 78},
  [1489] = {.lex_state = 108, .external_lex_state = 11},
  [1490] = {.lex_state = 215},
  [1491] = {.lex_state = 108, .external_lex_state = 26},
  [1492] = {.lex_state = 108, .external_lex_state = 11},
  [1493] = {.lex_state = 108, .external_lex_state = 26},
  [1494] = {.lex_state = 108, .external_lex_state = 26},
  [1495] = {.lex_state = 108, .external_lex_state = 26},
  [1496] = {.lex_state = 217},
  [1497] = {.lex_state = 260, .external_lex_state = 18},
  [1498] = {.lex_state = 85},
  [1499] = {.lex_state = 225, .external_lex_state = 18},
  [1500] = {.lex_state = 225, .external_lex_state = 18},
  [1501] = {.lex_state = 108, .external_lex_state = 26},
  [1502] = {.lex_state = 262, .external_lex_state = 30},
  [1503] = {.lex_state = 262, .external_lex_state = 18},
  [1504] = {.lex_state = 108, .external_lex_state = 26},
  [1505] = {.lex_state = 262, .external_lex_state = 30},
  [1506] = {.lex_state = 262, .external_lex_state = 18},
  [1507] = {.lex_state = 108, .external_lex_state = 26},
  [1508] = {.lex_state = 108, .external_lex_state = 26},
  [1509] = {.lex_state = 108, .external_lex_state = 13},
  [1510] = {.lex_state = 108, .external_lex_state = 13},
  [1511] = {.lex_state = 108, .external_lex_state = 13},
  [1512] = {.lex_state = 217},
  [1513] = {.lex_state = 260, .external_lex_state = 18},
  [1514] = {.lex_state = 85},
  [1515] = {.lex_state = 225, .external_lex_state = 18},
  [1516] = {.lex_state = 225, .external_lex_state = 18},
  [1517] = {.lex_state = 108, .external_lex_state = 13},
  [1518] = {.lex_state = 262, .external_lex_state = 30},
  [1519] = {.lex_state = 262, .external_lex_state = 18},
  [1520] = {.lex_state = 108, .external_lex_state = 13},
  [1521] = {.lex_state = 262, .external_lex_state = 30},
  [1522] = {.lex_state = 262, .external_lex_state = 18},
  [1523] = {.lex_state = 108, .external_lex_state = 13},
  [1524] = {.lex_state = 108, .external_lex_state = 13},
  [1525] = {.lex_state = 112, .external_lex_state = 13},
  [1526] = {.lex_state = 112, .external_lex_state = 13},
  [1527] = {.lex_state = 92, .external_lex_state = 29},
  [1528] = {.lex_state = 92, .external_lex_state = 18},
  [1529] = {.lex_state = 92, .external_lex_state = 18},
  [1530] = {.lex_state = 260, .external_lex_state = 18},
  [1531] = {.lex_state = 112, .external_lex_state = 13},
  [1532] = {.lex_state = 262, .external_lex_state = 30},
  [1533] = {.lex_state = 262, .external_lex_state = 18},
  [1534] = {.lex_state = 262, .external_lex_state = 30},
  [1535] = {.lex_state = 262, .external_lex_state = 18},
  [1536] = {.lex_state = 262, .external_lex_state = 18},
  [1537] = {.lex_state = 112, .external_lex_state = 13},
  [1538] = {.lex_state = 262, .external_lex_state = 18},
  [1539] = {.lex_state = 262, .external_lex_state = 18},
  [1540] = {.lex_state = 136, .external_lex_state = 12},
  [1541] = {.lex_state = 144, .external_lex_state = 8},
  [1542] = {.lex_state = 85},
  [1543] = {.lex_state = 275, .external_lex_state = 21},
  [1544] = {.lex_state = 115},
  [1545] = {.lex_state = 122},
  [1546] = {.lex_state = 275, .external_lex_state = 21},
  [1547] = {.lex_state = 122, .external_lex_state = 7},
  [1548] = {.lex_state = 78, .external_lex_state = 2},
  [1549] = {.lex_state = 78, .external_lex_state = 2},
  [1550] = {.lex_state = 78, .external_lex_state = 2},
  [1551] = {.lex_state = 85},
  [1552] = {.lex_state = 275, .external_lex_state = 4},
  [1553] = {.lex_state = 275, .external_lex_state = 4},
  [1554] = {.lex_state = 275, .external_lex_state = 6},
  [1555] = {.lex_state = 115},
  [1556] = {.lex_state = 122},
  [1557] = {.lex_state = 275, .external_lex_state = 6},
  [1558] = {.lex_state = 122, .external_lex_state = 7},
  [1559] = {.lex_state = 78, .external_lex_state = 2},
  [1560] = {.lex_state = 78, .external_lex_state = 2},
  [1561] = {.lex_state = 78, .external_lex_state = 2},
  [1562] = {.lex_state = 275, .external_lex_state = 5},
  [1563] = {.lex_state = 275, .external_lex_state = 5},
  [1564] = {.lex_state = 102},
  [1565] = {.lex_state = 281, .external_lex_state = 6},
  [1566] = {.lex_state = 281, .external_lex_state = 6},
  [1567] = {.lex_state = 217},
  [1568] = {.lex_state = 115},
  [1569] = {.lex_state = 281, .external_lex_state = 6},
  [1570] = {.lex_state = 281, .external_lex_state = 6},
  [1571] = {.lex_state = 281, .external_lex_state = 6},
  [1572] = {.lex_state = 85},
  [1573] = {.lex_state = 223, .external_lex_state = 7},
  [1574] = {.lex_state = 225, .external_lex_state = 18},
  [1575] = {.lex_state = 225, .external_lex_state = 18},
  [1576] = {.lex_state = 85},
  [1577] = {.lex_state = 215, .external_lex_state = 2},
  [1578] = {.lex_state = 78},
  [1579] = {.lex_state = 85},
  [1580] = {.lex_state = 186, .external_lex_state = 5},
  [1581] = {.lex_state = 78},
  [1582] = {.lex_state = 249, .external_lex_state = 2},
  [1583] = {.lex_state = 78, .external_lex_state = 2},
  [1584] = {.lex_state = 78, .external_lex_state = 2},
  [1585] = {.lex_state = 102},
  [1586] = {.lex_state = 102},
  [1587] = {.lex_state = 316, .external_lex_state = 9},
  [1588] = {.lex_state = 285, .external_lex_state = 5},
  [1589] = {.lex_state = 237, .external_lex_state = 25},
  [1590] = {.lex_state = 281, .external_lex_state = 6},
  [1591] = {.lex_state = 281, .external_lex_state = 5},
  [1592] = {.lex_state = 281, .external_lex_state = 5},
  [1593] = {.lex_state = 285, .external_lex_state = 5},
  [1594] = {.lex_state = 287, .external_lex_state = 4},
  [1595] = {.lex_state = 281, .external_lex_state = 5},
  [1596] = {.lex_state = 281, .external_lex_state = 5},
  [1597] = {.lex_state = 281, .external_lex_state = 5},
  [1598] = {.lex_state = 136, .external_lex_state = 13},
  [1599] = {.lex_state = 136, .external_lex_state = 12},
  [1600] = {.lex_state = 140, .external_lex_state = 12},
  [1601] = {.lex_state = 136, .external_lex_state = 13},
  [1602] = {.lex_state = 140, .external_lex_state = 12},
  [1603] = {.lex_state = 144, .external_lex_state = 8},
  [1604] = {.lex_state = 102},
  [1605] = {.lex_state = 85},
  [1606] = {.lex_state = 106, .external_lex_state = 2},
  [1607] = {.lex_state = 318, .external_lex_state = 4},
  [1608] = {.lex_state = 318, .external_lex_state = 5},
  [1609] = {.lex_state = 320, .external_lex_state = 6},
  [1610] = {.lex_state = 115},
  [1611] = {.lex_state = 122},
  [1612] = {.lex_state = 320, .external_lex_state = 6},
  [1613] = {.lex_state = 122, .external_lex_state = 7},
  [1614] = {.lex_state = 78, .external_lex_state = 2},
  [1615] = {.lex_state = 78, .external_lex_state = 2},
  [1616] = {.lex_state = 78, .external_lex_state = 2},
  [1617] = {.lex_state = 322, .external_lex_state = 6},
  [1618] = {.lex_state = 305},
  [1619] = {.lex_state = 324, .external_lex_state = 5},
  [1620] = {.lex_state = 320, .external_lex_state = 5},
  [1621] = {.lex_state = 326, .external_lex_state = 4},
  [1622] = {.lex_state = 85},
  [1623] = {.lex_state = 320, .external_lex_state = 5},
  [1624] = {.lex_state = 78, .external_lex_state = 2},
  [1625] = {.lex_state = 102, .external_lex_state = 2},
  [1626] = {.lex_state = 320, .external_lex_state = 5},
  [1627] = {.lex_state = 85},
  [1628] = {.lex_state = 291, .external_lex_state = 21},
  [1629] = {.lex_state = 115},
  [1630] = {.lex_state = 122},
  [1631] = {.lex_state = 291, .external_lex_state = 21},
  [1632] = {.lex_state = 122, .external_lex_state = 7},
  [1633] = {.lex_state = 78, .external_lex_state = 2},
  [1634] = {.lex_state = 78, .external_lex_state = 2},
  [1635] = {.lex_state = 78, .external_lex_state = 2},
  [1636] = {.lex_state = 85},
  [1637] = {.lex_state = 291, .external_lex_state = 4},
  [1638] = {.lex_state = 291, .external_lex_state = 4},
  [1639] = {.lex_state = 291, .external_lex_state = 6},
  [1640] = {.lex_state = 115},
  [1641] = {.lex_state = 122},
  [1642] = {.lex_state = 291, .external_lex_state = 6},
  [1643] = {.lex_state = 122, .external_lex_state = 7},
  [1644] = {.lex_state = 78, .external_lex_state = 2},
  [1645] = {.lex_state = 78, .external_lex_state = 2},
  [1646] = {.lex_state = 78, .external_lex_state = 2},
  [1647] = {.lex_state = 291, .external_lex_state = 5},
  [1648] = {.lex_state = 291, .external_lex_state = 5},
  [1649] = {.lex_state = 102},
  [1650] = {.lex_state = 301, .external_lex_state = 6},
  [1651] = {.lex_state = 301, .external_lex_state = 6},
  [1652] = {.lex_state = 217},
  [1653] = {.lex_state = 115},
  [1654] = {.lex_state = 301, .external_lex_state = 6},
  [1655] = {.lex_state = 301, .external_lex_state = 6},
  [1656] = {.lex_state = 301, .external_lex_state = 6},
  [1657] = {.lex_state = 85},
  [1658] = {.lex_state = 223, .external_lex_state = 7},
  [1659] = {.lex_state = 225, .external_lex_state = 18},
  [1660] = {.lex_state = 225, .external_lex_state = 18},
  [1661] = {.lex_state = 85},
  [1662] = {.lex_state = 215, .external_lex_state = 2},
  [1663] = {.lex_state = 78},
  [1664] = {.lex_state = 85},
  [1665] = {.lex_state = 186, .external_lex_state = 5},
  [1666] = {.lex_state = 305},
  [1667] = {.lex_state = 305},
  [1668] = {.lex_state = 78},
  [1669] = {.lex_state = 255, .external_lex_state = 2},
  [1670] = {.lex_state = 78, .external_lex_state = 2},
  [1671] = {.lex_state = 78, .external_lex_state = 2},
  [1672] = {.lex_state = 102},
  [1673] = {.lex_state = 102},
  [1674] = {.lex_state = 328, .external_lex_state = 9},
  [1675] = {.lex_state = 305, .external_lex_state = 5},
  [1676] = {.lex_state = 237, .external_lex_state = 25},
  [1677] = {.lex_state = 301, .external_lex_state = 6},
  [1678] = {.lex_state = 301, .external_lex_state = 5},
  [1679] = {.lex_state = 301, .external_lex_state = 5},
  [1680] = {.lex_state = 305, .external_lex_state = 5},
  [1681] = {.lex_state = 308, .external_lex_state = 4},
  [1682] = {.lex_state = 305},
  [1683] = {.lex_state = 301, .external_lex_state = 5},
  [1684] = {.lex_state = 301, .external_lex_state = 5},
  [1685] = {.lex_state = 301, .external_lex_state = 5},
  [1686] = {.lex_state = 149, .external_lex_state = 14},
  [1687] = {.lex_state = 186, .external_lex_state = 5},
  [1688] = {.lex_state = 330, .external_lex_state = 10},
  [1689] = {.lex_state = 330, .external_lex_state = 10},
  [1690] = {.lex_state = 333},
  [1691] = {.lex_state = 330},
  [1692] = {.lex_state = 102},
  [1693] = {.lex_state = 330},
  [1694] = {.lex_state = 310},
  [1695] = {.lex_state = 149, .external_lex_state = 14},
  [1696] = {.lex_state = 92, .external_lex_state = 29},
  [1697] = {.lex_state = 92, .external_lex_state = 18},
  [1698] = {.lex_state = 92, .external_lex_state = 18},
  [1699] = {.lex_state = 260, .external_lex_state = 18},
  [1700] = {.lex_state = 149, .external_lex_state = 14},
  [1701] = {.lex_state = 262, .external_lex_state = 30},
  [1702] = {.lex_state = 262, .external_lex_state = 18},
  [1703] = {.lex_state = 262, .external_lex_state = 30},
  [1704] = {.lex_state = 262, .external_lex_state = 18},
  [1705] = {.lex_state = 262, .external_lex_state = 18},
  [1706] = {.lex_state = 149, .external_lex_state = 14},
  [1707] = {.lex_state = 262, .external_lex_state = 18},
  [1708] = {.lex_state = 262, .external_lex_state = 18},
  [1709] = {.lex_state = 186, .external_lex_state = 5},
  [1710] = {.lex_state = 333},
  [1711] = {.lex_state = 102},
  [1712] = {.lex_state = 310},
  [1713] = {.lex_state = 186, .external_lex_state = 5},
  [1714] = {.lex_state = 184, .external_lex_state = 21},
  [1715] = {.lex_state = 184, .external_lex_state = 4},
  [1716] = {.lex_state = 178, .external_lex_state = 21},
  [1717] = {.lex_state = 178, .external_lex_state = 4},
  [1718] = {.lex_state = 178, .external_lex_state = 21},
  [1719] = {.lex_state = 178, .external_lex_state = 6},
  [1720] = {.lex_state = 182, .external_lex_state = 6},
  [1721] = {.lex_state = 182, .external_lex_state = 5},
  [1722] = {.lex_state = 182, .external_lex_state = 6},
  [1723] = {.lex_state = 182, .external_lex_state = 5},
  [1724] = {.lex_state = 207, .external_lex_state = 15},
  [1725] = {.lex_state = 215},
  [1726] = {.lex_state = 102},
  [1727] = {.lex_state = 207, .external_lex_state = 27},
  [1728] = {.lex_state = 207, .external_lex_state = 27},
  [1729] = {.lex_state = 217},
  [1730] = {.lex_state = 115},
  [1731] = {.lex_state = 207, .external_lex_state = 27},
  [1732] = {.lex_state = 207, .external_lex_state = 27},
  [1733] = {.lex_state = 207, .external_lex_state = 27},
  [1734] = {.lex_state = 85},
  [1735] = {.lex_state = 223, .external_lex_state = 7},
  [1736] = {.lex_state = 225, .external_lex_state = 18},
  [1737] = {.lex_state = 225, .external_lex_state = 18},
  [1738] = {.lex_state = 85},
  [1739] = {.lex_state = 215, .external_lex_state = 2},
  [1740] = {.lex_state = 78},
  [1741] = {.lex_state = 85},
  [1742] = {.lex_state = 207, .external_lex_state = 15},
  [1743] = {.lex_state = 207, .external_lex_state = 15},
  [1744] = {.lex_state = 268},
  [1745] = {.lex_state = 241, .external_lex_state = 9},
  [1746] = {.lex_state = 146, .external_lex_state = 9},
  [1747] = {.lex_state = 270, .external_lex_state = 9},
  [1748] = {.lex_state = 205, .external_lex_state = 16},
  [1749] = {.lex_state = 205, .external_lex_state = 16},
  [1750] = {.lex_state = 172},
  [1751] = {.lex_state = 205, .external_lex_state = 16},
  [1752] = {.lex_state = 305},
  [1753] = {.lex_state = 305},
  [1754] = {.lex_state = 305},
  [1755] = {.lex_state = 310},
  [1756] = {.lex_state = 146, .external_lex_state = 9},
  [1757] = {.lex_state = 310},
  [1758] = {.lex_state = 146, .external_lex_state = 9},
  [1759] = {.lex_state = 78},
  [1760] = {.lex_state = 199, .external_lex_state = 15},
  [1761] = {.lex_state = 215},
  [1762] = {.lex_state = 199, .external_lex_state = 27},
  [1763] = {.lex_state = 199, .external_lex_state = 15},
  [1764] = {.lex_state = 199, .external_lex_state = 27},
  [1765] = {.lex_state = 199, .external_lex_state = 27},
  [1766] = {.lex_state = 199, .external_lex_state = 27},
  [1767] = {.lex_state = 217},
  [1768] = {.lex_state = 260, .external_lex_state = 18},
  [1769] = {.lex_state = 85},
  [1770] = {.lex_state = 225, .external_lex_state = 18},
  [1771] = {.lex_state = 225, .external_lex_state = 18},
  [1772] = {.lex_state = 199, .external_lex_state = 27},
  [1773] = {.lex_state = 262, .external_lex_state = 30},
  [1774] = {.lex_state = 262, .external_lex_state = 18},
  [1775] = {.lex_state = 199, .external_lex_state = 27},
  [1776] = {.lex_state = 262, .external_lex_state = 30},
  [1777] = {.lex_state = 262, .external_lex_state = 18},
  [1778] = {.lex_state = 199, .external_lex_state = 27},
  [1779] = {.lex_state = 199, .external_lex_state = 27},
  [1780] = {.lex_state = 199, .external_lex_state = 17},
  [1781] = {.lex_state = 199, .external_lex_state = 17},
  [1782] = {.lex_state = 199, .external_lex_state = 17},
  [1783] = {.lex_state = 217},
  [1784] = {.lex_state = 260, .external_lex_state = 18},
  [1785] = {.lex_state = 85},
  [1786] = {.lex_state = 225, .external_lex_state = 18},
  [1787] = {.lex_state = 225, .external_lex_state = 18},
  [1788] = {.lex_state = 199, .external_lex_state = 17},
  [1789] = {.lex_state = 262, .external_lex_state = 30},
  [1790] = {.lex_state = 262, .external_lex_state = 18},
  [1791] = {.lex_state = 199, .external_lex_state = 17},
  [1792] = {.lex_state = 262, .external_lex_state = 30},
  [1793] = {.lex_state = 262, .external_lex_state = 18},
  [1794] = {.lex_state = 199, .external_lex_state = 17},
  [1795] = {.lex_state = 199, .external_lex_state = 17},
  [1796] = {.lex_state = 201, .external_lex_state = 17},
  [1797] = {.lex_state = 201, .external_lex_state = 17},
  [1798] = {.lex_state = 92, .external_lex_state = 29},
  [1799] = {.lex_state = 92, .external_lex_state = 18},
  [1800] = {.lex_state = 92, .external_lex_state = 18},
  [1801] = {.lex_state = 260, .external_lex_state = 18},
  [1802] = {.lex_state = 201, .external_lex_state = 17},
  [1803] = {.lex_state = 262, .external_lex_state = 30},
  [1804] = {.lex_state = 262, .external_lex_state = 18},
  [1805] = {.lex_state = 262, .external_lex_state = 30},
  [1806] = {.lex_state = 262, .external_lex_state = 18},
  [1807] = {.lex_state = 262, .external_lex_state = 18},
  [1808] = {.lex_state = 201, .external_lex_state = 17},
  [1809] = {.lex_state = 262, .external_lex_state = 18},
  [1810] = {.lex_state = 262, .external_lex_state = 18},
  [1811] = {.lex_state = 205, .external_lex_state = 16},
  [1812] = {.lex_state = 258, .external_lex_state = 28},
  [1813] = {.lex_state = 205, .external_lex_state = 17},
  [1814] = {.lex_state = 205, .external_lex_state = 16},
  [1815] = {.lex_state = 205, .external_lex_state = 16},
  [1816] = {.lex_state = 205, .external_lex_state = 17},
  [1817] = {.lex_state = 205, .external_lex_state = 16},
  [1818] = {.lex_state = 104, .external_lex_state = 3},
  [1819] = {.lex_state = 102, .external_lex_state = 2},
  [1820] = {.lex_state = 215},
  [1821] = {.lex_state = 209, .external_lex_state = 19},
  [1822] = {.lex_state = 209, .external_lex_state = 19},
  [1823] = {.lex_state = 92, .external_lex_state = 29},
  [1824] = {.lex_state = 92, .external_lex_state = 18},
  [1825] = {.lex_state = 92, .external_lex_state = 18},
  [1826] = {.lex_state = 260, .external_lex_state = 18},
  [1827] = {.lex_state = 209, .external_lex_state = 19},
  [1828] = {.lex_state = 262, .external_lex_state = 30},
  [1829] = {.lex_state = 262, .external_lex_state = 18},
  [1830] = {.lex_state = 262, .external_lex_state = 30},
  [1831] = {.lex_state = 262, .external_lex_state = 18},
  [1832] = {.lex_state = 262, .external_lex_state = 18},
  [1833] = {.lex_state = 209, .external_lex_state = 19},
  [1834] = {.lex_state = 262, .external_lex_state = 18},
  [1835] = {.lex_state = 262, .external_lex_state = 18},
  [1836] = {.lex_state = 178, .external_lex_state = 4},
  [1837] = {.lex_state = 215},
  [1838] = {.lex_state = 178, .external_lex_state = 21},
  [1839] = {.lex_state = 178, .external_lex_state = 21},
  [1840] = {.lex_state = 92, .external_lex_state = 29},
  [1841] = {.lex_state = 92, .external_lex_state = 18},
  [1842] = {.lex_state = 92, .external_lex_state = 18},
  [1843] = {.lex_state = 260, .external_lex_state = 18},
  [1844] = {.lex_state = 178, .external_lex_state = 21},
  [1845] = {.lex_state = 262, .external_lex_state = 30},
  [1846] = {.lex_state = 262, .external_lex_state = 18},
  [1847] = {.lex_state = 262, .external_lex_state = 30},
  [1848] = {.lex_state = 262, .external_lex_state = 18},
  [1849] = {.lex_state = 262, .external_lex_state = 18},
  [1850] = {.lex_state = 178, .external_lex_state = 21},
  [1851] = {.lex_state = 262, .external_lex_state = 18},
  [1852] = {.lex_state = 262, .external_lex_state = 18},
  [1853] = {.lex_state = 178, .external_lex_state = 6},
  [1854] = {.lex_state = 178, .external_lex_state = 6},
  [1855] = {.lex_state = 92, .external_lex_state = 29},
  [1856] = {.lex_state = 92, .external_lex_state = 18},
  [1857] = {.lex_state = 92, .external_lex_state = 18},
  [1858] = {.lex_state = 260, .external_lex_state = 18},
  [1859] = {.lex_state = 178, .external_lex_state = 6},
  [1860] = {.lex_state = 262, .external_lex_state = 30},
  [1861] = {.lex_state = 262, .external_lex_state = 18},
  [1862] = {.lex_state = 262, .external_lex_state = 30},
  [1863] = {.lex_state = 262, .external_lex_state = 18},
  [1864] = {.lex_state = 262, .external_lex_state = 18},
  [1865] = {.lex_state = 178, .external_lex_state = 6},
  [1866] = {.lex_state = 262, .external_lex_state = 18},
  [1867] = {.lex_state = 262, .external_lex_state = 18},
  [1868] = {.lex_state = 215, .external_lex_state = 22},
  [1869] = {.lex_state = 215, .external_lex_state = 22},
  [1870] = {.lex_state = 92, .external_lex_state = 29},
  [1871] = {.lex_state = 92, .external_lex_state = 18},
  [1872] = {.lex_state = 92, .external_lex_state = 18},
  [1873] = {.lex_state = 260, .external_lex_state = 18},
  [1874] = {.lex_state = 215, .external_lex_state = 22},
  [1875] = {.lex_state = 262, .external_lex_state = 30},
  [1876] = {.lex_state = 262, .external_lex_state = 18},
  [1877] = {.lex_state = 262, .external_lex_state = 30},
  [1878] = {.lex_state = 262, .external_lex_state = 18},
  [1879] = {.lex_state = 262, .external_lex_state = 18},
  [1880] = {.lex_state = 215, .external_lex_state = 22},
  [1881] = {.lex_state = 262, .external_lex_state = 18},
  [1882] = {.lex_state = 262, .external_lex_state = 18},
  [1883] = {.lex_state = 115, .external_lex_state = 10},
  [1884] = {.lex_state = 92, .external_lex_state = 29},
  [1885] = {.lex_state = 92, .external_lex_state = 18},
  [1886] = {.lex_state = 92, .external_lex_state = 18},
  [1887] = {.lex_state = 260, .external_lex_state = 18},
  [1888] = {.lex_state = 115, .external_lex_state = 10},
  [1889] = {.lex_state = 262, .external_lex_state = 30},
  [1890] = {.lex_state = 262, .external_lex_state = 18},
  [1891] = {.lex_state = 262, .external_lex_state = 30},
  [1892] = {.lex_state = 262, .external_lex_state = 18},
  [1893] = {.lex_state = 262, .external_lex_state = 18},
  [1894] = {.lex_state = 115, .external_lex_state = 10},
  [1895] = {.lex_state = 262, .external_lex_state = 18},
  [1896] = {.lex_state = 262, .external_lex_state = 18},
  [1897] = {.lex_state = 239, .external_lex_state = 20},
  [1898] = {.lex_state = 225, .external_lex_state = 29},
  [1899] = {.lex_state = 209, .external_lex_state = 20},
  [1900] = {.lex_state = 209, .external_lex_state = 20},
  [1901] = {.lex_state = 225, .external_lex_state = 29},
  [1902] = {.lex_state = 102},
  [1903] = {.lex_state = 92, .external_lex_state = 29},
  [1904] = {.lex_state = 92, .external_lex_state = 29},
  [1905] = {.lex_state = 217},
  [1906] = {.lex_state = 115},
  [1907] = {.lex_state = 92, .external_lex_state = 29},
  [1908] = {.lex_state = 92, .external_lex_state = 29},
  [1909] = {.lex_state = 92, .external_lex_state = 29},
  [1910] = {.lex_state = 142, .external_lex_state = 6},
  [1911] = {.lex_state = 85},
  [1912] = {.lex_state = 223, .external_lex_state = 7},
  [1913] = {.lex_state = 225, .external_lex_state = 18},
  [1914] = {.lex_state = 225, .external_lex_state = 18},
  [1915] = {.lex_state = 85},
  [1916] = {.lex_state = 215, .external_lex_state = 2},
  [1917] = {.lex_state = 78},
  [1918] = {.lex_state = 85},
  [1919] = {.lex_state = 142, .external_lex_state = 6},
  [1920] = {.lex_state = 92, .external_lex_state = 18},
  [1921] = {.lex_state = 92, .external_lex_state = 18},
  [1922] = {.lex_state = 92, .external_lex_state = 29},
  [1923] = {.lex_state = 92, .external_lex_state = 18},
  [1924] = {.lex_state = 92, .external_lex_state = 18},
  [1925] = {.lex_state = 262, .external_lex_state = 18},
  [1926] = {.lex_state = 142, .external_lex_state = 6},
  [1927] = {.lex_state = 262, .external_lex_state = 18},
  [1928] = {.lex_state = 262, .external_lex_state = 18},
  [1929] = {.lex_state = 262, .external_lex_state = 18},
  [1930] = {.lex_state = 262, .external_lex_state = 29},
  [1931] = {.lex_state = 262, .external_lex_state = 29},
  [1932] = {.lex_state = 262, .external_lex_state = 29},
  [1933] = {.lex_state = 217},
  [1934] = {.lex_state = 260, .external_lex_state = 18},
  [1935] = {.lex_state = 85},
  [1936] = {.lex_state = 225, .external_lex_state = 18},
  [1937] = {.lex_state = 225, .external_lex_state = 18},
  [1938] = {.lex_state = 262, .external_lex_state = 29},
  [1939] = {.lex_state = 262, .external_lex_state = 30},
  [1940] = {.lex_state = 262, .external_lex_state = 18},
  [1941] = {.lex_state = 262, .external_lex_state = 29},
  [1942] = {.lex_state = 262, .external_lex_state = 30},
  [1943] = {.lex_state = 262, .external_lex_state = 18},
  [1944] = {.lex_state = 142, .external_lex_state = 6},
  [1945] = {.lex_state = 262, .external_lex_state = 18},
  [1946] = {.lex_state = 262, .external_lex_state = 29},
  [1947] = {.lex_state = 262, .external_lex_state = 29},
  [1948] = {.lex_state = 215, .external_lex_state = 22},
  [1949] = {.lex_state = 140, .external_lex_state = 21},
  [1950] = {.lex_state = 140, .external_lex_state = 4},
  [1951] = {.lex_state = 108, .external_lex_state = 21},
  [1952] = {.lex_state = 108, .external_lex_state = 4},
  [1953] = {.lex_state = 108, .external_lex_state = 21},
  [1954] = {.lex_state = 108, .external_lex_state = 6},
  [1955] = {.lex_state = 229, .external_lex_state = 6},
  [1956] = {.lex_state = 229, .external_lex_state = 5},
  [1957] = {.lex_state = 229, .external_lex_state = 6},
  [1958] = {.lex_state = 229, .external_lex_state = 5},
  [1959] = {.lex_state = 78, .external_lex_state = 2},
  [1960] = {.lex_state = 260, .external_lex_state = 18},
  [1961] = {.lex_state = 85},
  [1962] = {.lex_state = 225, .external_lex_state = 18},
  [1963] = {.lex_state = 225, .external_lex_state = 18},
  [1964] = {.lex_state = 96, .external_lex_state = 23},
  [1965] = {.lex_state = 262, .external_lex_state = 30},
  [1966] = {.lex_state = 262, .external_lex_state = 18},
  [1967] = {.lex_state = 96, .external_lex_state = 23},
  [1968] = {.lex_state = 262, .external_lex_state = 30},
  [1969] = {.lex_state = 262, .external_lex_state = 18},
  [1970] = {.lex_state = 96, .external_lex_state = 23},
  [1971] = {.lex_state = 136, .external_lex_state = 6},
  [1972] = {.lex_state = 102},
  [1973] = {.lex_state = 136, .external_lex_state = 5},
  [1974] = {.lex_state = 140, .external_lex_state = 4},
  [1975] = {.lex_state = 136, .external_lex_state = 5},
  [1976] = {.lex_state = 140, .external_lex_state = 4},
  [1977] = {.lex_state = 264, .external_lex_state = 6},
  [1978] = {.lex_state = 136, .external_lex_state = 6},
  [1979] = {.lex_state = 264, .external_lex_state = 5},
  [1980] = {.lex_state = 136, .external_lex_state = 6},
  [1981] = {.lex_state = 264, .external_lex_state = 5},
  [1982] = {.lex_state = 78, .external_lex_state = 2},
  [1983] = {.lex_state = 136, .external_lex_state = 5},
  [1984] = {.lex_state = 112, .external_lex_state = 5},
  [1985] = {.lex_state = 85},
  [1986] = {.lex_state = 85},
  [1987] = {.lex_state = 215, .external_lex_state = 10},
  [1988] = {.lex_state = 215, .external_lex_state = 10},
  [1989] = {.lex_state = 215, .external_lex_state = 10},
  [1990] = {.lex_state = 217},
  [1991] = {.lex_state = 260, .external_lex_state = 18},
  [1992] = {.lex_state = 85},
  [1993] = {.lex_state = 225, .external_lex_state = 18},
  [1994] = {.lex_state = 225, .external_lex_state = 18},
  [1995] = {.lex_state = 215, .external_lex_state = 10},
  [1996] = {.lex_state = 262, .external_lex_state = 30},
  [1997] = {.lex_state = 262, .external_lex_state = 18},
  [1998] = {.lex_state = 215, .external_lex_state = 10},
  [1999] = {.lex_state = 262, .external_lex_state = 30},
  [2000] = {.lex_state = 262, .external_lex_state = 18},
  [2001] = {.lex_state = 215, .external_lex_state = 10},
  [2002] = {.lex_state = 215, .external_lex_state = 10},
  [2003] = {.lex_state = 184, .external_lex_state = 21},
  [2004] = {.lex_state = 184, .external_lex_state = 21},
  [2005] = {.lex_state = 92, .external_lex_state = 29},
  [2006] = {.lex_state = 92, .external_lex_state = 18},
  [2007] = {.lex_state = 92, .external_lex_state = 18},
  [2008] = {.lex_state = 260, .external_lex_state = 18},
  [2009] = {.lex_state = 184, .external_lex_state = 21},
  [2010] = {.lex_state = 262, .external_lex_state = 30},
  [2011] = {.lex_state = 262, .external_lex_state = 18},
  [2012] = {.lex_state = 262, .external_lex_state = 30},
  [2013] = {.lex_state = 262, .external_lex_state = 18},
  [2014] = {.lex_state = 262, .external_lex_state = 18},
  [2015] = {.lex_state = 184, .external_lex_state = 21},
  [2016] = {.lex_state = 262, .external_lex_state = 18},
  [2017] = {.lex_state = 262, .external_lex_state = 18},
  [2018] = {.lex_state = 313},
  [2019] = {.lex_state = 186, .external_lex_state = 5},
  [2020] = {.lex_state = 313},
  [2021] = {.lex_state = 153},
  [2022] = {.lex_state = 241, .external_lex_state = 14},
  [2023] = {.lex_state = 241, .external_lex_state = 14},
  [2024] = {.lex_state = 92, .external_lex_state = 29},
  [2025] = {.lex_state = 92, .external_lex_state = 18},
  [2026] = {.lex_state = 92, .external_lex_state = 18},
  [2027] = {.lex_state = 260, .external_lex_state = 18},
  [2028] = {.lex_state = 241, .external_lex_state = 14},
  [2029] = {.lex_state = 262, .external_lex_state = 30},
  [2030] = {.lex_state = 262, .external_lex_state = 18},
  [2031] = {.lex_state = 262, .external_lex_state = 30},
  [2032] = {.lex_state = 262, .external_lex_state = 18},
  [2033] = {.lex_state = 262, .external_lex_state = 18},
  [2034] = {.lex_state = 241, .external_lex_state = 14},
  [2035] = {.lex_state = 262, .external_lex_state = 18},
  [2036] = {.lex_state = 262, .external_lex_state = 18},
  [2037] = {.lex_state = 268},
  [2038] = {.lex_state = 270, .external_lex_state = 14},
  [2039] = {.lex_state = 270, .external_lex_state = 14},
  [2040] = {.lex_state = 270, .external_lex_state = 14},
  [2041] = {.lex_state = 217},
  [2042] = {.lex_state = 260, .external_lex_state = 18},
  [2043] = {.lex_state = 85},
  [2044] = {.lex_state = 225, .external_lex_state = 18},
  [2045] = {.lex_state = 225, .external_lex_state = 18},
  [2046] = {.lex_state = 270, .external_lex_state = 14},
  [2047] = {.lex_state = 262, .external_lex_state = 30},
  [2048] = {.lex_state = 262, .external_lex_state = 18},
  [2049] = {.lex_state = 270, .external_lex_state = 14},
  [2050] = {.lex_state = 262, .external_lex_state = 30},
  [2051] = {.lex_state = 262, .external_lex_state = 18},
  [2052] = {.lex_state = 270, .external_lex_state = 14},
  [2053] = {.lex_state = 270, .external_lex_state = 14},
  [2054] = {.lex_state = 186, .external_lex_state = 5},
  [2055] = {.lex_state = 272, .external_lex_state = 10},
  [2056] = {.lex_state = 272, .external_lex_state = 10},
  [2057] = {.lex_state = 92, .external_lex_state = 29},
  [2058] = {.lex_state = 92, .external_lex_state = 18},
  [2059] = {.lex_state = 92, .external_lex_state = 18},
  [2060] = {.lex_state = 260, .external_lex_state = 18},
  [2061] = {.lex_state = 272, .external_lex_state = 10},
  [2062] = {.lex_state = 262, .external_lex_state = 30},
  [2063] = {.lex_state = 262, .external_lex_state = 18},
  [2064] = {.lex_state = 262, .external_lex_state = 30},
  [2065] = {.lex_state = 262, .external_lex_state = 18},
  [2066] = {.lex_state = 262, .external_lex_state = 18},
  [2067] = {.lex_state = 272, .external_lex_state = 10},
  [2068] = {.lex_state = 262, .external_lex_state = 18},
  [2069] = {.lex_state = 262, .external_lex_state = 18},
  [2070] = {.lex_state = 246, .external_lex_state = 10},
  [2071] = {.lex_state = 246, .external_lex_state = 10},
  [2072] = {.lex_state = 92, .external_lex_state = 29},
  [2073] = {.lex_state = 92, .external_lex_state = 18},
  [2074] = {.lex_state = 92, .external_lex_state = 18},
  [2075] = {.lex_state = 262, .external_lex_state = 18},
  [2076] = {.lex_state = 246, .external_lex_state = 10},
  [2077] = {.lex_state = 262, .external_lex_state = 18},
  [2078] = {.lex_state = 262, .external_lex_state = 18},
  [2079] = {.lex_state = 262, .external_lex_state = 18},
  [2080] = {.lex_state = 246, .external_lex_state = 10},
  [2081] = {.lex_state = 262, .external_lex_state = 18},
  [2082] = {.lex_state = 140, .external_lex_state = 11},
  [2083] = {.lex_state = 140, .external_lex_state = 26},
  [2084] = {.lex_state = 140, .external_lex_state = 26},
  [2085] = {.lex_state = 140, .external_lex_state = 26},
  [2086] = {.lex_state = 217},
  [2087] = {.lex_state = 260, .external_lex_state = 18},
  [2088] = {.lex_state = 85},
  [2089] = {.lex_state = 225, .external_lex_state = 18},
  [2090] = {.lex_state = 225, .external_lex_state = 18},
  [2091] = {.lex_state = 140, .external_lex_state = 26},
  [2092] = {.lex_state = 262, .external_lex_state = 30},
  [2093] = {.lex_state = 262, .external_lex_state = 18},
  [2094] = {.lex_state = 140, .external_lex_state = 26},
  [2095] = {.lex_state = 262, .external_lex_state = 30},
  [2096] = {.lex_state = 262, .external_lex_state = 18},
  [2097] = {.lex_state = 140, .external_lex_state = 26},
  [2098] = {.lex_state = 140, .external_lex_state = 26},
  [2099] = {.lex_state = 313},
  [2100] = {.lex_state = 153},
  [2101] = {.lex_state = 268},
  [2102] = {.lex_state = 241, .external_lex_state = 9},
  [2103] = {.lex_state = 102},
  [2104] = {.lex_state = 136, .external_lex_state = 12},
  [2105] = {.lex_state = 136, .external_lex_state = 12},
  [2106] = {.lex_state = 305},
  [2107] = {.lex_state = 305},
  [2108] = {.lex_state = 136, .external_lex_state = 12},
  [2109] = {.lex_state = 333},
  [2110] = {.lex_state = 102},
  [2111] = {.lex_state = 310},
  [2112] = {.lex_state = 136, .external_lex_state = 12},
  [2113] = {.lex_state = 333},
  [2114] = {.lex_state = 102},
  [2115] = {.lex_state = 310},
  [2116] = {.lex_state = 136, .external_lex_state = 12},
  [2117] = {.lex_state = 108, .external_lex_state = 11},
  [2118] = {.lex_state = 215},
  [2119] = {.lex_state = 108, .external_lex_state = 26},
  [2120] = {.lex_state = 108, .external_lex_state = 26},
  [2121] = {.lex_state = 92, .external_lex_state = 29},
  [2122] = {.lex_state = 92, .external_lex_state = 18},
  [2123] = {.lex_state = 92, .external_lex_state = 18},
  [2124] = {.lex_state = 260, .external_lex_state = 18},
  [2125] = {.lex_state = 108, .external_lex_state = 26},
  [2126] = {.lex_state = 262, .external_lex_state = 30},
  [2127] = {.lex_state = 262, .external_lex_state = 18},
  [2128] = {.lex_state = 262, .external_lex_state = 30},
  [2129] = {.lex_state = 262, .external_lex_state = 18},
  [2130] = {.lex_state = 262, .external_lex_state = 18},
  [2131] = {.lex_state = 108, .external_lex_state = 26},
  [2132] = {.lex_state = 262, .external_lex_state = 18},
  [2133] = {.lex_state = 262, .external_lex_state = 18},
  [2134] = {.lex_state = 108, .external_lex_state = 13},
  [2135] = {.lex_state = 108, .external_lex_state = 13},
  [2136] = {.lex_state = 92, .external_lex_state = 29},
  [2137] = {.lex_state = 92, .external_lex_state = 18},
  [2138] = {.lex_state = 92, .external_lex_state = 18},
  [2139] = {.lex_state = 260, .external_lex_state = 18},
  [2140] = {.lex_state = 108, .external_lex_state = 13},
  [2141] = {.lex_state = 262, .external_lex_state = 30},
  [2142] = {.lex_state = 262, .external_lex_state = 18},
  [2143] = {.lex_state = 262, .external_lex_state = 30},
  [2144] = {.lex_state = 262, .external_lex_state = 18},
  [2145] = {.lex_state = 262, .external_lex_state = 18},
  [2146] = {.lex_state = 108, .external_lex_state = 13},
  [2147] = {.lex_state = 262, .external_lex_state = 18},
  [2148] = {.lex_state = 262, .external_lex_state = 18},
  [2149] = {.lex_state = 112, .external_lex_state = 13},
  [2150] = {.lex_state = 112, .external_lex_state = 13},
  [2151] = {.lex_state = 92, .external_lex_state = 29},
  [2152] = {.lex_state = 92, .external_lex_state = 18},
  [2153] = {.lex_state = 92, .external_lex_state = 18},
  [2154] = {.lex_state = 262, .external_lex_state = 18},
  [2155] = {.lex_state = 112, .external_lex_state = 13},
  [2156] = {.lex_state = 262, .external_lex_state = 18},
  [2157] = {.lex_state = 262, .external_lex_state = 18},
  [2158] = {.lex_state = 262, .external_lex_state = 18},
  [2159] = {.lex_state = 112, .external_lex_state = 13},
  [2160] = {.lex_state = 262, .external_lex_state = 18},
  [2161] = {.lex_state = 287, .external_lex_state = 4},
  [2162] = {.lex_state = 215},
  [2163] = {.lex_state = 287, .external_lex_state = 21},
  [2164] = {.lex_state = 115},
  [2165] = {.lex_state = 122},
  [2166] = {.lex_state = 287, .external_lex_state = 21},
  [2167] = {.lex_state = 122, .external_lex_state = 7},
  [2168] = {.lex_state = 78, .external_lex_state = 2},
  [2169] = {.lex_state = 78, .external_lex_state = 2},
  [2170] = {.lex_state = 78, .external_lex_state = 2},
  [2171] = {.lex_state = 287, .external_lex_state = 4},
  [2172] = {.lex_state = 144, .external_lex_state = 8},
  [2173] = {.lex_state = 102},
  [2174] = {.lex_state = 275, .external_lex_state = 21},
  [2175] = {.lex_state = 275, .external_lex_state = 21},
  [2176] = {.lex_state = 217},
  [2177] = {.lex_state = 115},
  [2178] = {.lex_state = 275, .external_lex_state = 21},
  [2179] = {.lex_state = 275, .external_lex_state = 21},
  [2180] = {.lex_state = 275, .external_lex_state = 21},
  [2181] = {.lex_state = 85},
  [2182] = {.lex_state = 223, .external_lex_state = 7},
  [2183] = {.lex_state = 225, .external_lex_state = 18},
  [2184] = {.lex_state = 225, .external_lex_state = 18},
  [2185] = {.lex_state = 85},
  [2186] = {.lex_state = 215, .external_lex_state = 2},
  [2187] = {.lex_state = 78},
  [2188] = {.lex_state = 85},
  [2189] = {.lex_state = 275, .external_lex_state = 4},
  [2190] = {.lex_state = 275, .external_lex_state = 4},
  [2191] = {.lex_state = 275, .external_lex_state = 4},
  [2192] = {.lex_state = 102},
  [2193] = {.lex_state = 275, .external_lex_state = 6},
  [2194] = {.lex_state = 275, .external_lex_state = 6},
  [2195] = {.lex_state = 217},
  [2196] = {.lex_state = 115},
  [2197] = {.lex_state = 275, .external_lex_state = 6},
  [2198] = {.lex_state = 275, .external_lex_state = 6},
  [2199] = {.lex_state = 275, .external_lex_state = 6},
  [2200] = {.lex_state = 85},
  [2201] = {.lex_state = 223, .external_lex_state = 7},
  [2202] = {.lex_state = 225, .external_lex_state = 18},
  [2203] = {.lex_state = 225, .external_lex_state = 18},
  [2204] = {.lex_state = 85},
  [2205] = {.lex_state = 215, .external_lex_state = 2},
  [2206] = {.lex_state = 78},
  [2207] = {.lex_state = 85},
  [2208] = {.lex_state = 275, .external_lex_state = 5},
  [2209] = {.lex_state = 275, .external_lex_state = 5},
  [2210] = {.lex_state = 275, .external_lex_state = 5},
  [2211] = {.lex_state = 281, .external_lex_state = 6},
  [2212] = {.lex_state = 281, .external_lex_state = 6},
  [2213] = {.lex_state = 281, .external_lex_state = 6},
  [2214] = {.lex_state = 217},
  [2215] = {.lex_state = 260, .external_lex_state = 18},
  [2216] = {.lex_state = 85},
  [2217] = {.lex_state = 225, .external_lex_state = 18},
  [2218] = {.lex_state = 225, .external_lex_state = 18},
  [2219] = {.lex_state = 281, .external_lex_state = 6},
  [2220] = {.lex_state = 262, .external_lex_state = 30},
  [2221] = {.lex_state = 262, .external_lex_state = 18},
  [2222] = {.lex_state = 281, .external_lex_state = 6},
  [2223] = {.lex_state = 262, .external_lex_state = 30},
  [2224] = {.lex_state = 262, .external_lex_state = 18},
  [2225] = {.lex_state = 281, .external_lex_state = 6},
  [2226] = {.lex_state = 281, .external_lex_state = 6},
  [2227] = {.lex_state = 102},
  [2228] = {.lex_state = 285, .external_lex_state = 5},
  [2229] = {.lex_state = 287, .external_lex_state = 4},
  [2230] = {.lex_state = 285, .external_lex_state = 5},
  [2231] = {.lex_state = 287, .external_lex_state = 4},
  [2232] = {.lex_state = 285, .external_lex_state = 6},
  [2233] = {.lex_state = 115},
  [2234] = {.lex_state = 122},
  [2235] = {.lex_state = 285, .external_lex_state = 6},
  [2236] = {.lex_state = 122, .external_lex_state = 7},
  [2237] = {.lex_state = 78, .external_lex_state = 2},
  [2238] = {.lex_state = 78, .external_lex_state = 2},
  [2239] = {.lex_state = 78, .external_lex_state = 2},
  [2240] = {.lex_state = 285, .external_lex_state = 5},
  [2241] = {.lex_state = 285, .external_lex_state = 6},
  [2242] = {.lex_state = 285, .external_lex_state = 5},
  [2243] = {.lex_state = 249, .external_lex_state = 2},
  [2244] = {.lex_state = 285, .external_lex_state = 5},
  [2245] = {.lex_state = 281, .external_lex_state = 5},
  [2246] = {.lex_state = 281, .external_lex_state = 6},
  [2247] = {.lex_state = 281, .external_lex_state = 5},
  [2248] = {.lex_state = 281, .external_lex_state = 5},
  [2249] = {.lex_state = 249, .external_lex_state = 2},
  [2250] = {.lex_state = 316, .external_lex_state = 9},
  [2251] = {.lex_state = 281, .external_lex_state = 5},
  [2252] = {.lex_state = 136, .external_lex_state = 13},
  [2253] = {.lex_state = 308, .external_lex_state = 4},
  [2254] = {.lex_state = 215},
  [2255] = {.lex_state = 308, .external_lex_state = 21},
  [2256] = {.lex_state = 115},
  [2257] = {.lex_state = 122},
  [2258] = {.lex_state = 308, .external_lex_state = 21},
  [2259] = {.lex_state = 122, .external_lex_state = 7},
  [2260] = {.lex_state = 78, .external_lex_state = 2},
  [2261] = {.lex_state = 78, .external_lex_state = 2},
  [2262] = {.lex_state = 78, .external_lex_state = 2},
  [2263] = {.lex_state = 308, .external_lex_state = 4},
  [2264] = {.lex_state = 255, .external_lex_state = 2},
  [2265] = {.lex_state = 144, .external_lex_state = 8},
  [2266] = {.lex_state = 85},
  [2267] = {.lex_state = 318, .external_lex_state = 21},
  [2268] = {.lex_state = 115},
  [2269] = {.lex_state = 122},
  [2270] = {.lex_state = 318, .external_lex_state = 21},
  [2271] = {.lex_state = 122, .external_lex_state = 7},
  [2272] = {.lex_state = 78, .external_lex_state = 2},
  [2273] = {.lex_state = 78, .external_lex_state = 2},
  [2274] = {.lex_state = 78, .external_lex_state = 2},
  [2275] = {.lex_state = 85},
  [2276] = {.lex_state = 318, .external_lex_state = 4},
  [2277] = {.lex_state = 318, .external_lex_state = 4},
  [2278] = {.lex_state = 318, .external_lex_state = 6},
  [2279] = {.lex_state = 115},
  [2280] = {.lex_state = 122},
  [2281] = {.lex_state = 318, .external_lex_state = 6},
  [2282] = {.lex_state = 122, .external_lex_state = 7},
  [2283] = {.lex_state = 78, .external_lex_state = 2},
  [2284] = {.lex_state = 78, .external_lex_state = 2},
  [2285] = {.lex_state = 78, .external_lex_state = 2},
  [2286] = {.lex_state = 318, .external_lex_state = 5},
  [2287] = {.lex_state = 318, .external_lex_state = 5},
  [2288] = {.lex_state = 102},
  [2289] = {.lex_state = 320, .external_lex_state = 6},
  [2290] = {.lex_state = 320, .external_lex_state = 6},
  [2291] = {.lex_state = 217},
  [2292] = {.lex_state = 115},
  [2293] = {.lex_state = 320, .external_lex_state = 6},
  [2294] = {.lex_state = 320, .external_lex_state = 6},
  [2295] = {.lex_state = 320, .external_lex_state = 6},
  [2296] = {.lex_state = 85},
  [2297] = {.lex_state = 223, .external_lex_state = 7},
  [2298] = {.lex_state = 225, .external_lex_state = 18},
  [2299] = {.lex_state = 225, .external_lex_state = 18},
  [2300] = {.lex_state = 85},
  [2301] = {.lex_state = 215, .external_lex_state = 2},
  [2302] = {.lex_state = 78},
  [2303] = {.lex_state = 85},
  [2304] = {.lex_state = 78},
  [2305] = {.lex_state = 289, .external_lex_state = 2},
  [2306] = {.lex_state = 78, .external_lex_state = 2},
  [2307] = {.lex_state = 78, .external_lex_state = 2},
  [2308] = {.lex_state = 102},
  [2309] = {.lex_state = 102},
  [2310] = {.lex_state = 328, .external_lex_state = 9},
  [2311] = {.lex_state = 324, .external_lex_state = 5},
  [2312] = {.lex_state = 237, .external_lex_state = 25},
  [2313] = {.lex_state = 320, .external_lex_state = 6},
  [2314] = {.lex_state = 320, .external_lex_state = 5},
  [2315] = {.lex_state = 320, .external_lex_state = 5},
  [2316] = {.lex_state = 324, .external_lex_state = 5},
  [2317] = {.lex_state = 326, .external_lex_state = 4},
  [2318] = {.lex_state = 320, .external_lex_state = 5},
  [2319] = {.lex_state = 320, .external_lex_state = 5},
  [2320] = {.lex_state = 320, .external_lex_state = 5},
  [2321] = {.lex_state = 144, .external_lex_state = 8},
  [2322] = {.lex_state = 102},
  [2323] = {.lex_state = 291, .external_lex_state = 21},
  [2324] = {.lex_state = 291, .external_lex_state = 21},
  [2325] = {.lex_state = 217},
  [2326] = {.lex_state = 115},
  [2327] = {.lex_state = 291, .external_lex_state = 21},
  [2328] = {.lex_state = 291, .external_lex_state = 21},
  [2329] = {.lex_state = 291, .external_lex_state = 21},
  [2330] = {.lex_state = 85},
  [2331] = {.lex_state = 223, .external_lex_state = 7},
  [2332] = {.lex_state = 225, .external_lex_state = 18},
  [2333] = {.lex_state = 225, .external_lex_state = 18},
  [2334] = {.lex_state = 85},
  [2335] = {.lex_state = 215, .external_lex_state = 2},
  [2336] = {.lex_state = 78},
  [2337] = {.lex_state = 85},
  [2338] = {.lex_state = 291, .external_lex_state = 4},
  [2339] = {.lex_state = 291, .external_lex_state = 4},
  [2340] = {.lex_state = 291, .external_lex_state = 4},
  [2341] = {.lex_state = 102},
  [2342] = {.lex_state = 291, .external_lex_state = 6},
  [2343] = {.lex_state = 291, .external_lex_state = 6},
  [2344] = {.lex_state = 217},
  [2345] = {.lex_state = 115},
  [2346] = {.lex_state = 291, .external_lex_state = 6},
  [2347] = {.lex_state = 291, .external_lex_state = 6},
  [2348] = {.lex_state = 291, .external_lex_state = 6},
  [2349] = {.lex_state = 85},
  [2350] = {.lex_state = 223, .external_lex_state = 7},
  [2351] = {.lex_state = 225, .external_lex_state = 18},
  [2352] = {.lex_state = 225, .external_lex_state = 18},
  [2353] = {.lex_state = 85},
  [2354] = {.lex_state = 215, .external_lex_state = 2},
  [2355] = {.lex_state = 78},
  [2356] = {.lex_state = 85},
  [2357] = {.lex_state = 291, .external_lex_state = 5},
  [2358] = {.lex_state = 291, .external_lex_state = 5},
  [2359] = {.lex_state = 291, .external_lex_state = 5},
  [2360] = {.lex_state = 301, .external_lex_state = 6},
  [2361] = {.lex_state = 301, .external_lex_state = 6},
  [2362] = {.lex_state = 301, .external_lex_state = 6},
  [2363] = {.lex_state = 217},
  [2364] = {.lex_state = 260, .external_lex_state = 18},
  [2365] = {.lex_state = 85},
  [2366] = {.lex_state = 225, .external_lex_state = 18},
  [2367] = {.lex_state = 225, .external_lex_state = 18},
  [2368] = {.lex_state = 301, .external_lex_state = 6},
  [2369] = {.lex_state = 262, .external_lex_state = 30},
  [2370] = {.lex_state = 262, .external_lex_state = 18},
  [2371] = {.lex_state = 301, .external_lex_state = 6},
  [2372] = {.lex_state = 262, .external_lex_state = 30},
  [2373] = {.lex_state = 262, .external_lex_state = 18},
  [2374] = {.lex_state = 301, .external_lex_state = 6},
  [2375] = {.lex_state = 301, .external_lex_state = 6},
  [2376] = {.lex_state = 186, .external_lex_state = 5},
  [2377] = {.lex_state = 305},
  [2378] = {.lex_state = 102},
  [2379] = {.lex_state = 305, .external_lex_state = 5},
  [2380] = {.lex_state = 308, .external_lex_state = 4},
  [2381] = {.lex_state = 305, .external_lex_state = 5},
  [2382] = {.lex_state = 308, .external_lex_state = 4},
  [2383] = {.lex_state = 305, .external_lex_state = 6},
  [2384] = {.lex_state = 305, .external_lex_state = 6},
  [2385] = {.lex_state = 305, .external_lex_state = 5},
  [2386] = {.lex_state = 305, .external_lex_state = 6},
  [2387] = {.lex_state = 305, .external_lex_state = 5},
  [2388] = {.lex_state = 255, .external_lex_state = 2},
  [2389] = {.lex_state = 305, .external_lex_state = 5},
  [2390] = {.lex_state = 301, .external_lex_state = 5},
  [2391] = {.lex_state = 301, .external_lex_state = 6},
  [2392] = {.lex_state = 301, .external_lex_state = 5},
  [2393] = {.lex_state = 301, .external_lex_state = 5},
  [2394] = {.lex_state = 255, .external_lex_state = 2},
  [2395] = {.lex_state = 328, .external_lex_state = 9},
  [2396] = {.lex_state = 301, .external_lex_state = 5},
  [2397] = {.lex_state = 330, .external_lex_state = 10},
  [2398] = {.lex_state = 102},
  [2399] = {.lex_state = 336, .external_lex_state = 2},
  [2400] = {.lex_state = 330},
  [2401] = {.lex_state = 186, .external_lex_state = 5},
  [2402] = {.lex_state = 333},
  [2403] = {.lex_state = 102},
  [2404] = {.lex_state = 336, .external_lex_state = 2},
  [2405] = {.lex_state = 330},
  [2406] = {.lex_state = 330},
  [2407] = {.lex_state = 102},
  [2408] = {.lex_state = 149, .external_lex_state = 14},
  [2409] = {.lex_state = 149, .external_lex_state = 14},
  [2410] = {.lex_state = 92, .external_lex_state = 29},
  [2411] = {.lex_state = 92, .external_lex_state = 18},
  [2412] = {.lex_state = 92, .external_lex_state = 18},
  [2413] = {.lex_state = 262, .external_lex_state = 18},
  [2414] = {.lex_state = 149, .external_lex_state = 14},
  [2415] = {.lex_state = 262, .external_lex_state = 18},
  [2416] = {.lex_state = 262, .external_lex_state = 18},
  [2417] = {.lex_state = 262, .external_lex_state = 18},
  [2418] = {.lex_state = 149, .external_lex_state = 14},
  [2419] = {.lex_state = 262, .external_lex_state = 18},
  [2420] = {.lex_state = 186, .external_lex_state = 5},
  [2421] = {.lex_state = 333},
  [2422] = {.lex_state = 102},
  [2423] = {.lex_state = 184, .external_lex_state = 21},
  [2424] = {.lex_state = 182, .external_lex_state = 6},
  [2425] = {.lex_state = 207, .external_lex_state = 15},
  [2426] = {.lex_state = 207, .external_lex_state = 27},
  [2427] = {.lex_state = 207, .external_lex_state = 27},
  [2428] = {.lex_state = 207, .external_lex_state = 27},
  [2429] = {.lex_state = 217},
  [2430] = {.lex_state = 260, .external_lex_state = 18},
  [2431] = {.lex_state = 85},
  [2432] = {.lex_state = 225, .external_lex_state = 18},
  [2433] = {.lex_state = 225, .external_lex_state = 18},
  [2434] = {.lex_state = 207, .external_lex_state = 27},
  [2435] = {.lex_state = 262, .external_lex_state = 30},
  [2436] = {.lex_state = 262, .external_lex_state = 18},
  [2437] = {.lex_state = 207, .external_lex_state = 27},
  [2438] = {.lex_state = 262, .external_lex_state = 30},
  [2439] = {.lex_state = 262, .external_lex_state = 18},
  [2440] = {.lex_state = 207, .external_lex_state = 27},
  [2441] = {.lex_state = 207, .external_lex_state = 27},
  [2442] = {.lex_state = 313},
  [2443] = {.lex_state = 153},
  [2444] = {.lex_state = 268},
  [2445] = {.lex_state = 241, .external_lex_state = 9},
  [2446] = {.lex_state = 102},
  [2447] = {.lex_state = 205, .external_lex_state = 16},
  [2448] = {.lex_state = 205, .external_lex_state = 16},
  [2449] = {.lex_state = 305},
  [2450] = {.lex_state = 305},
  [2451] = {.lex_state = 205, .external_lex_state = 16},
  [2452] = {.lex_state = 333},
  [2453] = {.lex_state = 102},
  [2454] = {.lex_state = 310},
  [2455] = {.lex_state = 205, .external_lex_state = 16},
  [2456] = {.lex_state = 333},
  [2457] = {.lex_state = 102},
  [2458] = {.lex_state = 310},
  [2459] = {.lex_state = 205, .external_lex_state = 16},
  [2460] = {.lex_state = 199, .external_lex_state = 15},
  [2461] = {.lex_state = 215},
  [2462] = {.lex_state = 199, .external_lex_state = 27},
  [2463] = {.lex_state = 199, .external_lex_state = 27},
  [2464] = {.lex_state = 92, .external_lex_state = 29},
  [2465] = {.lex_state = 92, .external_lex_state = 18},
  [2466] = {.lex_state = 92, .external_lex_state = 18},
  [2467] = {.lex_state = 260, .external_lex_state = 18},
  [2468] = {.lex_state = 199, .external_lex_state = 27},
  [2469] = {.lex_state = 262, .external_lex_state = 30},
  [2470] = {.lex_state = 262, .external_lex_state = 18},
  [2471] = {.lex_state = 262, .external_lex_state = 30},
  [2472] = {.lex_state = 262, .external_lex_state = 18},
  [2473] = {.lex_state = 262, .external_lex_state = 18},
  [2474] = {.lex_state = 199, .external_lex_state = 27},
  [2475] = {.lex_state = 262, .external_lex_state = 18},
  [2476] = {.lex_state = 262, .external_lex_state = 18},
  [2477] = {.lex_state = 199, .external_lex_state = 17},
  [2478] = {.lex_state = 199, .external_lex_state = 17},
  [2479] = {.lex_state = 92, .external_lex_state = 29},
  [2480] = {.lex_state = 92, .external_lex_state = 18},
  [2481] = {.lex_state = 92, .external_lex_state = 18},
  [2482] = {.lex_state = 260, .external_lex_state = 18},
  [2483] = {.lex_state = 199, .external_lex_state = 17},
  [2484] = {.lex_state = 262, .external_lex_state = 30},
  [2485] = {.lex_state = 262, .external_lex_state = 18},
  [2486] = {.lex_state = 262, .external_lex_state = 30},
  [2487] = {.lex_state = 262, .external_lex_state = 18},
  [2488] = {.lex_state = 262, .external_lex_state = 18},
  [2489] = {.lex_state = 199, .external_lex_state = 17},
  [2490] = {.lex_state = 262, .external_lex_state = 18},
  [2491] = {.lex_state = 262, .external_lex_state = 18},
  [2492] = {.lex_state = 201, .external_lex_state = 17},
  [2493] = {.lex_state = 201, .external_lex_state = 17},
  [2494] = {.lex_state = 92, .external_lex_state = 29},
  [2495] = {.lex_state = 92, .external_lex_state = 18},
  [2496] = {.lex_state = 92, .external_lex_state = 18},
  [2497] = {.lex_state = 262, .external_lex_state = 18},
  [2498] = {.lex_state = 201, .external_lex_state = 17},
  [2499] = {.lex_state = 262, .external_lex_state = 18},
  [2500] = {.lex_state = 262, .external_lex_state = 18},
  [2501] = {.lex_state = 262, .external_lex_state = 18},
  [2502] = {.lex_state = 201, .external_lex_state = 17},
  [2503] = {.lex_state = 262, .external_lex_state = 18},
  [2504] = {.lex_state = 205, .external_lex_state = 17},
  [2505] = {.lex_state = 102, .external_lex_state = 2},
  [2506] = {.lex_state = 209, .external_lex_state = 19},
  [2507] = {.lex_state = 209, .external_lex_state = 19},
  [2508] = {.lex_state = 92, .external_lex_state = 29},
  [2509] = {.lex_state = 92, .external_lex_state = 18},
  [2510] = {.lex_state = 92, .external_lex_state = 18},
  [2511] = {.lex_state = 262, .external_lex_state = 18},
  [2512] = {.lex_state = 209, .external_lex_state = 19},
  [2513] = {.lex_state = 262, .external_lex_state = 18},
  [2514] = {.lex_state = 262, .external_lex_state = 18},
  [2515] = {.lex_state = 262, .external_lex_state = 18},
  [2516] = {.lex_state = 209, .external_lex_state = 19},
  [2517] = {.lex_state = 262, .external_lex_state = 18},
  [2518] = {.lex_state = 178, .external_lex_state = 4},
  [2519] = {.lex_state = 178, .external_lex_state = 21},
  [2520] = {.lex_state = 178, .external_lex_state = 21},
  [2521] = {.lex_state = 92, .external_lex_state = 29},
  [2522] = {.lex_state = 92, .external_lex_state = 18},
  [2523] = {.lex_state = 92, .external_lex_state = 18},
  [2524] = {.lex_state = 262, .external_lex_state = 18},
  [2525] = {.lex_state = 178, .external_lex_state = 21},
  [2526] = {.lex_state = 262, .external_lex_state = 18},
  [2527] = {.lex_state = 262, .external_lex_state = 18},
  [2528] = {.lex_state = 262, .external_lex_state = 18},
  [2529] = {.lex_state = 178, .external_lex_state = 21},
  [2530] = {.lex_state = 262, .external_lex_state = 18},
  [2531] = {.lex_state = 178, .external_lex_state = 6},
  [2532] = {.lex_state = 178, .external_lex_state = 6},
  [2533] = {.lex_state = 92, .external_lex_state = 29},
  [2534] = {.lex_state = 92, .external_lex_state = 18},
  [2535] = {.lex_state = 92, .external_lex_state = 18},
  [2536] = {.lex_state = 262, .external_lex_state = 18},
  [2537] = {.lex_state = 178, .external_lex_state = 6},
  [2538] = {.lex_state = 262, .external_lex_state = 18},
  [2539] = {.lex_state = 262, .external_lex_state = 18},
  [2540] = {.lex_state = 262, .external_lex_state = 18},
  [2541] = {.lex_state = 178, .external_lex_state = 6},
  [2542] = {.lex_state = 262, .external_lex_state = 18},
  [2543] = {.lex_state = 215, .external_lex_state = 22},
  [2544] = {.lex_state = 215, .external_lex_state = 22},
  [2545] = {.lex_state = 92, .external_lex_state = 29},
  [2546] = {.lex_state = 92, .external_lex_state = 18},
  [2547] = {.lex_state = 92, .external_lex_state = 18},
  [2548] = {.lex_state = 262, .external_lex_state = 18},
  [2549] = {.lex_state = 215, .external_lex_state = 22},
  [2550] = {.lex_state = 262, .external_lex_state = 18},
  [2551] = {.lex_state = 262, .external_lex_state = 18},
  [2552] = {.lex_state = 262, .external_lex_state = 18},
  [2553] = {.lex_state = 215, .external_lex_state = 22},
  [2554] = {.lex_state = 262, .external_lex_state = 18},
  [2555] = {.lex_state = 115, .external_lex_state = 10},
  [2556] = {.lex_state = 115, .external_lex_state = 10},
  [2557] = {.lex_state = 92, .external_lex_state = 29},
  [2558] = {.lex_state = 92, .external_lex_state = 18},
  [2559] = {.lex_state = 92, .external_lex_state = 18},
  [2560] = {.lex_state = 262, .external_lex_state = 18},
  [2561] = {.lex_state = 115, .external_lex_state = 10},
  [2562] = {.lex_state = 262, .external_lex_state = 18},
  [2563] = {.lex_state = 262, .external_lex_state = 18},
  [2564] = {.lex_state = 262, .external_lex_state = 18},
  [2565] = {.lex_state = 115, .external_lex_state = 10},
  [2566] = {.lex_state = 262, .external_lex_state = 18},
  [2567] = {.lex_state = 225, .external_lex_state = 29},
  [2568] = {.lex_state = 225, .external_lex_state = 18},
  [2569] = {.lex_state = 225, .external_lex_state = 29},
  [2570] = {.lex_state = 225, .external_lex_state = 18},
  [2571] = {.lex_state = 92, .external_lex_state = 29},
  [2572] = {.lex_state = 92, .external_lex_state = 29},
  [2573] = {.lex_state = 92, .external_lex_state = 29},
  [2574] = {.lex_state = 217},
  [2575] = {.lex_state = 260, .external_lex_state = 18},
  [2576] = {.lex_state = 85},
  [2577] = {.lex_state = 225, .external_lex_state = 18},
  [2578] = {.lex_state = 225, .external_lex_state = 18},
  [2579] = {.lex_state = 92, .external_lex_state = 29},
  [2580] = {.lex_state = 262, .external_lex_state = 30},
  [2581] = {.lex_state = 262, .external_lex_state = 18},
  [2582] = {.lex_state = 92, .external_lex_state = 29},
  [2583] = {.lex_state = 262, .external_lex_state = 30},
  [2584] = {.lex_state = 262, .external_lex_state = 18},
  [2585] = {.lex_state = 92, .external_lex_state = 29},
  [2586] = {.lex_state = 92, .external_lex_state = 29},
  [2587] = {.lex_state = 142, .external_lex_state = 6},
  [2588] = {.lex_state = 142, .external_lex_state = 6},
  [2589] = {.lex_state = 142, .external_lex_state = 6},
  [2590] = {.lex_state = 262, .external_lex_state = 18},
  [2591] = {.lex_state = 262, .external_lex_state = 18},
  [2592] = {.lex_state = 262, .external_lex_state = 29},
  [2593] = {.lex_state = 262, .external_lex_state = 29},
  [2594] = {.lex_state = 92, .external_lex_state = 29},
  [2595] = {.lex_state = 92, .external_lex_state = 18},
  [2596] = {.lex_state = 92, .external_lex_state = 18},
  [2597] = {.lex_state = 260, .external_lex_state = 18},
  [2598] = {.lex_state = 262, .external_lex_state = 29},
  [2599] = {.lex_state = 262, .external_lex_state = 30},
  [2600] = {.lex_state = 262, .external_lex_state = 18},
  [2601] = {.lex_state = 262, .external_lex_state = 30},
  [2602] = {.lex_state = 262, .external_lex_state = 18},
  [2603] = {.lex_state = 262, .external_lex_state = 18},
  [2604] = {.lex_state = 262, .external_lex_state = 29},
  [2605] = {.lex_state = 262, .external_lex_state = 18},
  [2606] = {.lex_state = 262, .external_lex_state = 18},
  [2607] = {.lex_state = 142, .external_lex_state = 6},
  [2608] = {.lex_state = 140, .external_lex_state = 21},
  [2609] = {.lex_state = 229, .external_lex_state = 6},
  [2610] = {.lex_state = 96, .external_lex_state = 23},
  [2611] = {.lex_state = 92, .external_lex_state = 29},
  [2612] = {.lex_state = 92, .external_lex_state = 18},
  [2613] = {.lex_state = 92, .external_lex_state = 18},
  [2614] = {.lex_state = 260, .external_lex_state = 18},
  [2615] = {.lex_state = 96, .external_lex_state = 23},
  [2616] = {.lex_state = 262, .external_lex_state = 30},
  [2617] = {.lex_state = 262, .external_lex_state = 18},
  [2618] = {.lex_state = 262, .external_lex_state = 30},
  [2619] = {.lex_state = 262, .external_lex_state = 18},
  [2620] = {.lex_state = 262, .external_lex_state = 18},
  [2621] = {.lex_state = 96, .external_lex_state = 23},
  [2622] = {.lex_state = 262, .external_lex_state = 18},
  [2623] = {.lex_state = 262, .external_lex_state = 18},
  [2624] = {.lex_state = 136, .external_lex_state = 6},
  [2625] = {.lex_state = 264, .external_lex_state = 5},
  [2626] = {.lex_state = 136, .external_lex_state = 6},
  [2627] = {.lex_state = 264, .external_lex_state = 5},
  [2628] = {.lex_state = 215, .external_lex_state = 10},
  [2629] = {.lex_state = 215, .external_lex_state = 10},
  [2630] = {.lex_state = 92, .external_lex_state = 29},
  [2631] = {.lex_state = 92, .external_lex_state = 18},
  [2632] = {.lex_state = 92, .external_lex_state = 18},
  [2633] = {.lex_state = 260, .external_lex_state = 18},
  [2634] = {.lex_state = 215, .external_lex_state = 10},
  [2635] = {.lex_state = 262, .external_lex_state = 30},
  [2636] = {.lex_state = 262, .external_lex_state = 18},
  [2637] = {.lex_state = 262, .external_lex_state = 30},
  [2638] = {.lex_state = 262, .external_lex_state = 18},
  [2639] = {.lex_state = 262, .external_lex_state = 18},
  [2640] = {.lex_state = 215, .external_lex_state = 10},
  [2641] = {.lex_state = 262, .external_lex_state = 18},
  [2642] = {.lex_state = 262, .external_lex_state = 18},
  [2643] = {.lex_state = 184, .external_lex_state = 21},
  [2644] = {.lex_state = 184, .external_lex_state = 21},
  [2645] = {.lex_state = 92, .external_lex_state = 29},
  [2646] = {.lex_state = 92, .external_lex_state = 18},
  [2647] = {.lex_state = 92, .external_lex_state = 18},
  [2648] = {.lex_state = 262, .external_lex_state = 18},
  [2649] = {.lex_state = 184, .external_lex_state = 21},
  [2650] = {.lex_state = 262, .external_lex_state = 18},
  [2651] = {.lex_state = 262, .external_lex_state = 18},
  [2652] = {.lex_state = 262, .external_lex_state = 18},
  [2653] = {.lex_state = 184, .external_lex_state = 21},
  [2654] = {.lex_state = 262, .external_lex_state = 18},
  [2655] = {.lex_state = 186, .external_lex_state = 5},
  [2656] = {.lex_state = 313},
  [2657] = {.lex_state = 313},
  [2658] = {.lex_state = 241, .external_lex_state = 14},
  [2659] = {.lex_state = 241, .external_lex_state = 14},
  [2660] = {.lex_state = 92, .external_lex_state = 29},
  [2661] = {.lex_state = 92, .external_lex_state = 18},
  [2662] = {.lex_state = 92, .external_lex_state = 18},
  [2663] = {.lex_state = 262, .external_lex_state = 18},
  [2664] = {.lex_state = 241, .external_lex_state = 14},
  [2665] = {.lex_state = 262, .external_lex_state = 18},
  [2666] = {.lex_state = 262, .external_lex_state = 18},
  [2667] = {.lex_state = 262, .external_lex_state = 18},
  [2668] = {.lex_state = 241, .external_lex_state = 14},
  [2669] = {.lex_state = 262, .external_lex_state = 18},
  [2670] = {.lex_state = 153},
  [2671] = {.lex_state = 270, .external_lex_state = 14},
  [2672] = {.lex_state = 270, .external_lex_state = 14},
  [2673] = {.lex_state = 92, .external_lex_state = 29},
  [2674] = {.lex_state = 92, .external_lex_state = 18},
  [2675] = {.lex_state = 92, .external_lex_state = 18},
  [2676] = {.lex_state = 260, .external_lex_state = 18},
  [2677] = {.lex_state = 270, .external_lex_state = 14},
  [2678] = {.lex_state = 262, .external_lex_state = 30},
  [2679] = {.lex_state = 262, .external_lex_state = 18},
  [2680] = {.lex_state = 262, .external_lex_state = 30},
  [2681] = {.lex_state = 262, .external_lex_state = 18},
  [2682] = {.lex_state = 262, .external_lex_state = 18},
  [2683] = {.lex_state = 270, .external_lex_state = 14},
  [2684] = {.lex_state = 262, .external_lex_state = 18},
  [2685] = {.lex_state = 262, .external_lex_state = 18},
  [2686] = {.lex_state = 272, .external_lex_state = 10},
  [2687] = {.lex_state = 272, .external_lex_state = 10},
  [2688] = {.lex_state = 92, .external_lex_state = 29},
  [2689] = {.lex_state = 92, .external_lex_state = 18},
  [2690] = {.lex_state = 92, .external_lex_state = 18},
  [2691] = {.lex_state = 262, .external_lex_state = 18},
  [2692] = {.lex_state = 272, .external_lex_state = 10},
  [2693] = {.lex_state = 262, .external_lex_state = 18},
  [2694] = {.lex_state = 262, .external_lex_state = 18},
  [2695] = {.lex_state = 262, .external_lex_state = 18},
  [2696] = {.lex_state = 272, .external_lex_state = 10},
  [2697] = {.lex_state = 262, .external_lex_state = 18},
  [2698] = {.lex_state = 246, .external_lex_state = 10},
  [2699] = {.lex_state = 246, .external_lex_state = 10},
  [2700] = {.lex_state = 246, .external_lex_state = 10},
  [2701] = {.lex_state = 262, .external_lex_state = 18},
  [2702] = {.lex_state = 262, .external_lex_state = 18},
  [2703] = {.lex_state = 246, .external_lex_state = 10},
  [2704] = {.lex_state = 140, .external_lex_state = 26},
  [2705] = {.lex_state = 140, .external_lex_state = 26},
  [2706] = {.lex_state = 92, .external_lex_state = 29},
  [2707] = {.lex_state = 92, .external_lex_state = 18},
  [2708] = {.lex_state = 92, .external_lex_state = 18},
  [2709] = {.lex_state = 260, .external_lex_state = 18},
  [2710] = {.lex_state = 140, .external_lex_state = 26},
  [2711] = {.lex_state = 262, .external_lex_state = 30},
  [2712] = {.lex_state = 262, .external_lex_state = 18},
  [2713] = {.lex_state = 262, .external_lex_state = 30},
  [2714] = {.lex_state = 262, .external_lex_state = 18},
  [2715] = {.lex_state = 262, .external_lex_state = 18},
  [2716] = {.lex_state = 140, .external_lex_state = 26},
  [2717] = {.lex_state = 262, .external_lex_state = 18},
  [2718] = {.lex_state = 262, .external_lex_state = 18},
  [2719] = {.lex_state = 313},
  [2720] = {.lex_state = 136, .external_lex_state = 12},
  [2721] = {.lex_state = 313},
  [2722] = {.lex_state = 153},
  [2723] = {.lex_state = 268},
  [2724] = {.lex_state = 136, .external_lex_state = 12},
  [2725] = {.lex_state = 136, .external_lex_state = 12},
  [2726] = {.lex_state = 305},
  [2727] = {.lex_state = 136, .external_lex_state = 12},
  [2728] = {.lex_state = 333},
  [2729] = {.lex_state = 102},
  [2730] = {.lex_state = 136, .external_lex_state = 12},
  [2731] = {.lex_state = 333},
  [2732] = {.lex_state = 102},
  [2733] = {.lex_state = 108, .external_lex_state = 11},
  [2734] = {.lex_state = 108, .external_lex_state = 26},
  [2735] = {.lex_state = 108, .external_lex_state = 26},
  [2736] = {.lex_state = 92, .external_lex_state = 29},
  [2737] = {.lex_state = 92, .external_lex_state = 18},
  [2738] = {.lex_state = 92, .external_lex_state = 18},
  [2739] = {.lex_state = 262, .external_lex_state = 18},
  [2740] = {.lex_state = 108, .external_lex_state = 26},
  [2741] = {.lex_state = 262, .external_lex_state = 18},
  [2742] = {.lex_state = 262, .external_lex_state = 18},
  [2743] = {.lex_state = 262, .external_lex_state = 18},
  [2744] = {.lex_state = 108, .external_lex_state = 26},
  [2745] = {.lex_state = 262, .external_lex_state = 18},
  [2746] = {.lex_state = 108, .external_lex_state = 13},
  [2747] = {.lex_state = 108, .external_lex_state = 13},
  [2748] = {.lex_state = 92, .external_lex_state = 29},
  [2749] = {.lex_state = 92, .external_lex_state = 18},
  [2750] = {.lex_state = 92, .external_lex_state = 18},
  [2751] = {.lex_state = 262, .external_lex_state = 18},
  [2752] = {.lex_state = 108, .external_lex_state = 13},
  [2753] = {.lex_state = 262, .external_lex_state = 18},
  [2754] = {.lex_state = 262, .external_lex_state = 18},
  [2755] = {.lex_state = 262, .external_lex_state = 18},
  [2756] = {.lex_state = 108, .external_lex_state = 13},
  [2757] = {.lex_state = 262, .external_lex_state = 18},
  [2758] = {.lex_state = 112, .external_lex_state = 13},
  [2759] = {.lex_state = 112, .external_lex_state = 13},
  [2760] = {.lex_state = 112, .external_lex_state = 13},
  [2761] = {.lex_state = 262, .external_lex_state = 18},
  [2762] = {.lex_state = 262, .external_lex_state = 18},
  [2763] = {.lex_state = 112, .external_lex_state = 13},
  [2764] = {.lex_state = 287, .external_lex_state = 4},
  [2765] = {.lex_state = 215},
  [2766] = {.lex_state = 102},
  [2767] = {.lex_state = 287, .external_lex_state = 21},
  [2768] = {.lex_state = 287, .external_lex_state = 21},
  [2769] = {.lex_state = 217},
  [2770] = {.lex_state = 115},
  [2771] = {.lex_state = 287, .external_lex_state = 21},
  [2772] = {.lex_state = 287, .external_lex_state = 21},
  [2773] = {.lex_state = 287, .external_lex_state = 21},
  [2774] = {.lex_state = 85},
  [2775] = {.lex_state = 223, .external_lex_state = 7},
  [2776] = {.lex_state = 225, .external_lex_state = 18},
  [2777] = {.lex_state = 225, .external_lex_state = 18},
  [2778] = {.lex_state = 85},
  [2779] = {.lex_state = 215, .external_lex_state = 2},
  [2780] = {.lex_state = 78},
  [2781] = {.lex_state = 85},
  [2782] = {.lex_state = 287, .external_lex_state = 4},
  [2783] = {.lex_state = 287, .external_lex_state = 4},
  [2784] = {.lex_state = 275, .external_lex_state = 4},
  [2785] = {.lex_state = 215},
  [2786] = {.lex_state = 275, .external_lex_state = 21},
  [2787] = {.lex_state = 275, .external_lex_state = 4},
  [2788] = {.lex_state = 275, .external_lex_state = 21},
  [2789] = {.lex_state = 275, .external_lex_state = 21},
  [2790] = {.lex_state = 275, .external_lex_state = 21},
  [2791] = {.lex_state = 217},
  [2792] = {.lex_state = 260, .external_lex_state = 18},
  [2793] = {.lex_state = 85},
  [2794] = {.lex_state = 225, .external_lex_state = 18},
  [2795] = {.lex_state = 225, .external_lex_state = 18},
  [2796] = {.lex_state = 275, .external_lex_state = 21},
  [2797] = {.lex_state = 262, .external_lex_state = 30},
  [2798] = {.lex_state = 262, .external_lex_state = 18},
  [2799] = {.lex_state = 275, .external_lex_state = 21},
  [2800] = {.lex_state = 262, .external_lex_state = 30},
  [2801] = {.lex_state = 262, .external_lex_state = 18},
  [2802] = {.lex_state = 275, .external_lex_state = 21},
  [2803] = {.lex_state = 275, .external_lex_state = 21},
  [2804] = {.lex_state = 275, .external_lex_state = 6},
  [2805] = {.lex_state = 275, .external_lex_state = 6},
  [2806] = {.lex_state = 275, .external_lex_state = 6},
  [2807] = {.lex_state = 217},
  [2808] = {.lex_state = 260, .external_lex_state = 18},
  [2809] = {.lex_state = 85},
  [2810] = {.lex_state = 225, .external_lex_state = 18},
  [2811] = {.lex_state = 225, .external_lex_state = 18},
  [2812] = {.lex_state = 275, .external_lex_state = 6},
  [2813] = {.lex_state = 262, .external_lex_state = 30},
  [2814] = {.lex_state = 262, .external_lex_state = 18},
  [2815] = {.lex_state = 275, .external_lex_state = 6},
  [2816] = {.lex_state = 262, .external_lex_state = 30},
  [2817] = {.lex_state = 262, .external_lex_state = 18},
  [2818] = {.lex_state = 275, .external_lex_state = 6},
  [2819] = {.lex_state = 275, .external_lex_state = 6},
  [2820] = {.lex_state = 281, .external_lex_state = 6},
  [2821] = {.lex_state = 281, .external_lex_state = 6},
  [2822] = {.lex_state = 92, .external_lex_state = 29},
  [2823] = {.lex_state = 92, .external_lex_state = 18},
  [2824] = {.lex_state = 92, .external_lex_state = 18},
  [2825] = {.lex_state = 260, .external_lex_state = 18},
  [2826] = {.lex_state = 281, .external_lex_state = 6},
  [2827] = {.lex_state = 262, .external_lex_state = 30},
  [2828] = {.lex_state = 262, .external_lex_state = 18},
  [2829] = {.lex_state = 262, .external_lex_state = 30},
  [2830] = {.lex_state = 262, .external_lex_state = 18},
  [2831] = {.lex_state = 262, .external_lex_state = 18},
  [2832] = {.lex_state = 281, .external_lex_state = 6},
  [2833] = {.lex_state = 262, .external_lex_state = 18},
  [2834] = {.lex_state = 262, .external_lex_state = 18},
  [2835] = {.lex_state = 285, .external_lex_state = 6},
  [2836] = {.lex_state = 285, .external_lex_state = 5},
  [2837] = {.lex_state = 102},
  [2838] = {.lex_state = 285, .external_lex_state = 6},
  [2839] = {.lex_state = 338, .external_lex_state = 6},
  [2840] = {.lex_state = 217},
  [2841] = {.lex_state = 115},
  [2842] = {.lex_state = 338, .external_lex_state = 6},
  [2843] = {.lex_state = 338, .external_lex_state = 6},
  [2844] = {.lex_state = 338, .external_lex_state = 6},
  [2845] = {.lex_state = 85},
  [2846] = {.lex_state = 223, .external_lex_state = 7},
  [2847] = {.lex_state = 225, .external_lex_state = 18},
  [2848] = {.lex_state = 225, .external_lex_state = 18},
  [2849] = {.lex_state = 85},
  [2850] = {.lex_state = 215, .external_lex_state = 2},
  [2851] = {.lex_state = 78},
  [2852] = {.lex_state = 85},
  [2853] = {.lex_state = 338, .external_lex_state = 5},
  [2854] = {.lex_state = 285, .external_lex_state = 5},
  [2855] = {.lex_state = 249, .external_lex_state = 2},
  [2856] = {.lex_state = 308, .external_lex_state = 4},
  [2857] = {.lex_state = 215},
  [2858] = {.lex_state = 102},
  [2859] = {.lex_state = 308, .external_lex_state = 21},
  [2860] = {.lex_state = 308, .external_lex_state = 21},
  [2861] = {.lex_state = 217},
  [2862] = {.lex_state = 115},
  [2863] = {.lex_state = 308, .external_lex_state = 21},
  [2864] = {.lex_state = 308, .external_lex_state = 21},
  [2865] = {.lex_state = 308, .external_lex_state = 21},
  [2866] = {.lex_state = 85},
  [2867] = {.lex_state = 223, .external_lex_state = 7},
  [2868] = {.lex_state = 225, .external_lex_state = 18},
  [2869] = {.lex_state = 225, .external_lex_state = 18},
  [2870] = {.lex_state = 85},
  [2871] = {.lex_state = 215, .external_lex_state = 2},
  [2872] = {.lex_state = 78},
  [2873] = {.lex_state = 85},
  [2874] = {.lex_state = 308, .external_lex_state = 4},
  [2875] = {.lex_state = 308, .external_lex_state = 4},
  [2876] = {.lex_state = 305},
  [2877] = {.lex_state = 326, .external_lex_state = 4},
  [2878] = {.lex_state = 215},
  [2879] = {.lex_state = 326, .external_lex_state = 21},
  [2880] = {.lex_state = 115},
  [2881] = {.lex_state = 122},
  [2882] = {.lex_state = 326, .external_lex_state = 21},
  [2883] = {.lex_state = 122, .external_lex_state = 7},
  [2884] = {.lex_state = 78, .external_lex_state = 2},
  [2885] = {.lex_state = 78, .external_lex_state = 2},
  [2886] = {.lex_state = 78, .external_lex_state = 2},
  [2887] = {.lex_state = 326, .external_lex_state = 4},
  [2888] = {.lex_state = 144, .external_lex_state = 8},
  [2889] = {.lex_state = 102},
  [2890] = {.lex_state = 318, .external_lex_state = 21},
  [2891] = {.lex_state = 318, .external_lex_state = 21},
  [2892] = {.lex_state = 217},
  [2893] = {.lex_state = 115},
  [2894] = {.lex_state = 318, .external_lex_state = 21},
  [2895] = {.lex_state = 318, .external_lex_state = 21},
  [2896] = {.lex_state = 318, .external_lex_state = 21},
  [2897] = {.lex_state = 85},
  [2898] = {.lex_state = 223, .external_lex_state = 7},
  [2899] = {.lex_state = 225, .external_lex_state = 18},
  [2900] = {.lex_state = 225, .external_lex_state = 18},
  [2901] = {.lex_state = 85},
  [2902] = {.lex_state = 215, .external_lex_state = 2},
  [2903] = {.lex_state = 78},
  [2904] = {.lex_state = 85},
  [2905] = {.lex_state = 318, .external_lex_state = 4},
  [2906] = {.lex_state = 318, .external_lex_state = 4},
  [2907] = {.lex_state = 318, .external_lex_state = 4},
  [2908] = {.lex_state = 102},
  [2909] = {.lex_state = 318, .external_lex_state = 6},
  [2910] = {.lex_state = 318, .external_lex_state = 6},
  [2911] = {.lex_state = 217},
  [2912] = {.lex_state = 115},
  [2913] = {.lex_state = 318, .external_lex_state = 6},
  [2914] = {.lex_state = 318, .external_lex_state = 6},
  [2915] = {.lex_state = 318, .external_lex_state = 6},
  [2916] = {.lex_state = 85},
  [2917] = {.lex_state = 223, .external_lex_state = 7},
  [2918] = {.lex_state = 225, .external_lex_state = 18},
  [2919] = {.lex_state = 225, .external_lex_state = 18},
  [2920] = {.lex_state = 85},
  [2921] = {.lex_state = 215, .external_lex_state = 2},
  [2922] = {.lex_state = 78},
  [2923] = {.lex_state = 85},
  [2924] = {.lex_state = 318, .external_lex_state = 5},
  [2925] = {.lex_state = 318, .external_lex_state = 5},
  [2926] = {.lex_state = 318, .external_lex_state = 5},
  [2927] = {.lex_state = 320, .external_lex_state = 6},
  [2928] = {.lex_state = 320, .external_lex_state = 6},
  [2929] = {.lex_state = 320, .external_lex_state = 6},
  [2930] = {.lex_state = 217},
  [2931] = {.lex_state = 260, .external_lex_state = 18},
  [2932] = {.lex_state = 85},
  [2933] = {.lex_state = 225, .external_lex_state = 18},
  [2934] = {.lex_state = 225, .external_lex_state = 18},
  [2935] = {.lex_state = 320, .external_lex_state = 6},
  [2936] = {.lex_state = 262, .external_lex_state = 30},
  [2937] = {.lex_state = 262, .external_lex_state = 18},
  [2938] = {.lex_state = 320, .external_lex_state = 6},
  [2939] = {.lex_state = 262, .external_lex_state = 30},
  [2940] = {.lex_state = 262, .external_lex_state = 18},
  [2941] = {.lex_state = 320, .external_lex_state = 6},
  [2942] = {.lex_state = 320, .external_lex_state = 6},
  [2943] = {.lex_state = 102},
  [2944] = {.lex_state = 324, .external_lex_state = 5},
  [2945] = {.lex_state = 326, .external_lex_state = 4},
  [2946] = {.lex_state = 324, .external_lex_state = 5},
  [2947] = {.lex_state = 326, .external_lex_state = 4},
  [2948] = {.lex_state = 324, .external_lex_state = 6},
  [2949] = {.lex_state = 324, .external_lex_state = 6},
  [2950] = {.lex_state = 324, .external_lex_state = 5},
  [2951] = {.lex_state = 324, .external_lex_state = 6},
  [2952] = {.lex_state = 324, .external_lex_state = 5},
  [2953] = {.lex_state = 289, .external_lex_state = 2},
  [2954] = {.lex_state = 324, .external_lex_state = 5},
  [2955] = {.lex_state = 320, .external_lex_state = 5},
  [2956] = {.lex_state = 320, .external_lex_state = 6},
  [2957] = {.lex_state = 320, .external_lex_state = 5},
  [2958] = {.lex_state = 320, .external_lex_state = 5},
  [2959] = {.lex_state = 289, .external_lex_state = 2},
  [2960] = {.lex_state = 328, .external_lex_state = 9},
  [2961] = {.lex_state = 320, .external_lex_state = 5},
  [2962] = {.lex_state = 291, .external_lex_state = 4},
  [2963] = {.lex_state = 215},
  [2964] = {.lex_state = 291, .external_lex_state = 21},
  [2965] = {.lex_state = 291, .external_lex_state = 4},
  [2966] = {.lex_state = 291, .external_lex_state = 21},
  [2967] = {.lex_state = 291, .external_lex_state = 21},
  [2968] = {.lex_state = 291, .external_lex_state = 21},
  [2969] = {.lex_state = 217},
  [2970] = {.lex_state = 260, .external_lex_state = 18},
  [2971] = {.lex_state = 85},
  [2972] = {.lex_state = 225, .external_lex_state = 18},
  [2973] = {.lex_state = 225, .external_lex_state = 18},
  [2974] = {.lex_state = 291, .external_lex_state = 21},
  [2975] = {.lex_state = 262, .external_lex_state = 30},
  [2976] = {.lex_state = 262, .external_lex_state = 18},
  [2977] = {.lex_state = 291, .external_lex_state = 21},
  [2978] = {.lex_state = 262, .external_lex_state = 30},
  [2979] = {.lex_state = 262, .external_lex_state = 18},
  [2980] = {.lex_state = 291, .external_lex_state = 21},
  [2981] = {.lex_state = 291, .external_lex_state = 21},
  [2982] = {.lex_state = 291, .external_lex_state = 6},
  [2983] = {.lex_state = 291, .external_lex_state = 6},
  [2984] = {.lex_state = 291, .external_lex_state = 6},
  [2985] = {.lex_state = 217},
  [2986] = {.lex_state = 260, .external_lex_state = 18},
  [2987] = {.lex_state = 85},
  [2988] = {.lex_state = 225, .external_lex_state = 18},
  [2989] = {.lex_state = 225, .external_lex_state = 18},
  [2990] = {.lex_state = 291, .external_lex_state = 6},
  [2991] = {.lex_state = 262, .external_lex_state = 30},
  [2992] = {.lex_state = 262, .external_lex_state = 18},
  [2993] = {.lex_state = 291, .external_lex_state = 6},
  [2994] = {.lex_state = 262, .external_lex_state = 30},
  [2995] = {.lex_state = 262, .external_lex_state = 18},
  [2996] = {.lex_state = 291, .external_lex_state = 6},
  [2997] = {.lex_state = 291, .external_lex_state = 6},
  [2998] = {.lex_state = 301, .external_lex_state = 6},
  [2999] = {.lex_state = 301, .external_lex_state = 6},
  [3000] = {.lex_state = 92, .external_lex_state = 29},
  [3001] = {.lex_state = 92, .external_lex_state = 18},
  [3002] = {.lex_state = 92, .external_lex_state = 18},
  [3003] = {.lex_state = 260, .external_lex_state = 18},
  [3004] = {.lex_state = 301, .external_lex_state = 6},
  [3005] = {.lex_state = 262, .external_lex_state = 30},
  [3006] = {.lex_state = 262, .external_lex_state = 18},
  [3007] = {.lex_state = 262, .external_lex_state = 30},
  [3008] = {.lex_state = 262, .external_lex_state = 18},
  [3009] = {.lex_state = 262, .external_lex_state = 18},
  [3010] = {.lex_state = 301, .external_lex_state = 6},
  [3011] = {.lex_state = 262, .external_lex_state = 18},
  [3012] = {.lex_state = 262, .external_lex_state = 18},
  [3013] = {.lex_state = 186, .external_lex_state = 5},
  [3014] = {.lex_state = 305, .external_lex_state = 6},
  [3015] = {.lex_state = 305, .external_lex_state = 5},
  [3016] = {.lex_state = 305, .external_lex_state = 6},
  [3017] = {.lex_state = 305, .external_lex_state = 5},
  [3018] = {.lex_state = 255, .external_lex_state = 2},
  [3019] = {.lex_state = 330, .external_lex_state = 10},
  [3020] = {.lex_state = 330, .external_lex_state = 10},
  [3021] = {.lex_state = 330},
  [3022] = {.lex_state = 330},
  [3023] = {.lex_state = 85},
  [3024] = {.lex_state = 310},
  [3025] = {.lex_state = 106, .external_lex_state = 2},
  [3026] = {.lex_state = 340, .external_lex_state = 4},
  [3027] = {.lex_state = 340, .external_lex_state = 5},
  [3028] = {.lex_state = 346, .external_lex_state = 6},
  [3029] = {.lex_state = 115},
  [3030] = {.lex_state = 122},
  [3031] = {.lex_state = 346, .external_lex_state = 6},
  [3032] = {.lex_state = 122, .external_lex_state = 7},
  [3033] = {.lex_state = 78, .external_lex_state = 2},
  [3034] = {.lex_state = 78, .external_lex_state = 2},
  [3035] = {.lex_state = 78, .external_lex_state = 2},
  [3036] = {.lex_state = 348, .external_lex_state = 6},
  [3037] = {.lex_state = 333},
  [3038] = {.lex_state = 333, .external_lex_state = 5},
  [3039] = {.lex_state = 346, .external_lex_state = 5},
  [3040] = {.lex_state = 350, .external_lex_state = 4},
  [3041] = {.lex_state = 85},
  [3042] = {.lex_state = 346, .external_lex_state = 5},
  [3043] = {.lex_state = 78, .external_lex_state = 2},
  [3044] = {.lex_state = 102, .external_lex_state = 2},
  [3045] = {.lex_state = 346, .external_lex_state = 5},
  [3046] = {.lex_state = 336, .external_lex_state = 2},
  [3047] = {.lex_state = 330},
  [3048] = {.lex_state = 186, .external_lex_state = 5},
  [3049] = {.lex_state = 330, .external_lex_state = 10},
  [3050] = {.lex_state = 330},
  [3051] = {.lex_state = 330},
  [3052] = {.lex_state = 310},
  [3053] = {.lex_state = 333},
  [3054] = {.lex_state = 336, .external_lex_state = 2},
  [3055] = {.lex_state = 333},
  [3056] = {.lex_state = 149, .external_lex_state = 14},
  [3057] = {.lex_state = 149, .external_lex_state = 14},
  [3058] = {.lex_state = 149, .external_lex_state = 14},
  [3059] = {.lex_state = 262, .external_lex_state = 18},
  [3060] = {.lex_state = 262, .external_lex_state = 18},
  [3061] = {.lex_state = 149, .external_lex_state = 14},
  [3062] = {.lex_state = 186, .external_lex_state = 5},
  [3063] = {.lex_state = 333},
  [3064] = {.lex_state = 207, .external_lex_state = 27},
  [3065] = {.lex_state = 207, .external_lex_state = 27},
  [3066] = {.lex_state = 92, .external_lex_state = 29},
  [3067] = {.lex_state = 92, .external_lex_state = 18},
  [3068] = {.lex_state = 92, .external_lex_state = 18},
  [3069] = {.lex_state = 260, .external_lex_state = 18},
  [3070] = {.lex_state = 207, .external_lex_state = 27},
  [3071] = {.lex_state = 262, .external_lex_state = 30},
  [3072] = {.lex_state = 262, .external_lex_state = 18},
  [3073] = {.lex_state = 262, .external_lex_state = 30},
  [3074] = {.lex_state = 262, .external_lex_state = 18},
  [3075] = {.lex_state = 262, .external_lex_state = 18},
  [3076] = {.lex_state = 207, .external_lex_state = 27},
  [3077] = {.lex_state = 262, .external_lex_state = 18},
  [3078] = {.lex_state = 262, .external_lex_state = 18},
  [3079] = {.lex_state = 313},
  [3080] = {.lex_state = 205, .external_lex_state = 16},
  [3081] = {.lex_state = 313},
  [3082] = {.lex_state = 153},
  [3083] = {.lex_state = 268},
  [3084] = {.lex_state = 205, .external_lex_state = 16},
  [3085] = {.lex_state = 205, .external_lex_state = 16},
  [3086] = {.lex_state = 305},
  [3087] = {.lex_state = 205, .external_lex_state = 16},
  [3088] = {.lex_state = 333},
  [3089] = {.lex_state = 102},
  [3090] = {.lex_state = 205, .external_lex_state = 16},
  [3091] = {.lex_state = 333},
  [3092] = {.lex_state = 102},
  [3093] = {.lex_state = 199, .external_lex_state = 15},
  [3094] = {.lex_state = 199, .external_lex_state = 27},
  [3095] = {.lex_state = 199, .external_lex_state = 27},
  [3096] = {.lex_state = 92, .external_lex_state = 29},
  [3097] = {.lex_state = 92, .external_lex_state = 18},
  [3098] = {.lex_state = 92, .external_lex_state = 18},
  [3099] = {.lex_state = 262, .external_lex_state = 18},
  [3100] = {.lex_state = 199, .external_lex_state = 27},
  [3101] = {.lex_state = 262, .external_lex_state = 18},
  [3102] = {.lex_state = 262, .external_lex_state = 18},
  [3103] = {.lex_state = 262, .external_lex_state = 18},
  [3104] = {.lex_state = 199, .external_lex_state = 27},
  [3105] = {.lex_state = 262, .external_lex_state = 18},
  [3106] = {.lex_state = 199, .external_lex_state = 17},
  [3107] = {.lex_state = 199, .external_lex_state = 17},
  [3108] = {.lex_state = 92, .external_lex_state = 29},
  [3109] = {.lex_state = 92, .external_lex_state = 18},
  [3110] = {.lex_state = 92, .external_lex_state = 18},
  [3111] = {.lex_state = 262, .external_lex_state = 18},
  [3112] = {.lex_state = 199, .external_lex_state = 17},
  [3113] = {.lex_state = 262, .external_lex_state = 18},
  [3114] = {.lex_state = 262, .external_lex_state = 18},
  [3115] = {.lex_state = 262, .external_lex_state = 18},
  [3116] = {.lex_state = 199, .external_lex_state = 17},
  [3117] = {.lex_state = 262, .external_lex_state = 18},
  [3118] = {.lex_state = 201, .external_lex_state = 17},
  [3119] = {.lex_state = 201, .external_lex_state = 17},
  [3120] = {.lex_state = 201, .external_lex_state = 17},
  [3121] = {.lex_state = 262, .external_lex_state = 18},
  [3122] = {.lex_state = 262, .external_lex_state = 18},
  [3123] = {.lex_state = 201, .external_lex_state = 17},
  [3124] = {.lex_state = 209, .external_lex_state = 19},
  [3125] = {.lex_state = 209, .external_lex_state = 19},
  [3126] = {.lex_state = 209, .external_lex_state = 19},
  [3127] = {.lex_state = 262, .external_lex_state = 18},
  [3128] = {.lex_state = 262, .external_lex_state = 18},
  [3129] = {.lex_state = 209, .external_lex_state = 19},
  [3130] = {.lex_state = 178, .external_lex_state = 21},
  [3131] = {.lex_state = 178, .external_lex_state = 21},
  [3132] = {.lex_state = 178, .external_lex_state = 21},
  [3133] = {.lex_state = 262, .external_lex_state = 18},
  [3134] = {.lex_state = 262, .external_lex_state = 18},
  [3135] = {.lex_state = 178, .external_lex_state = 21},
  [3136] = {.lex_state = 178, .external_lex_state = 6},
  [3137] = {.lex_state = 178, .external_lex_state = 6},
  [3138] = {.lex_state = 178, .external_lex_state = 6},
  [3139] = {.lex_state = 262, .external_lex_state = 18},
  [3140] = {.lex_state = 262, .external_lex_state = 18},
  [3141] = {.lex_state = 178, .external_lex_state = 6},
  [3142] = {.lex_state = 215, .external_lex_state = 22},
  [3143] = {.lex_state = 215, .external_lex_state = 22},
  [3144] = {.lex_state = 215, .external_lex_state = 22},
  [3145] = {.lex_state = 262, .external_lex_state = 18},
  [3146] = {.lex_state = 262, .external_lex_state = 18},
  [3147] = {.lex_state = 215, .external_lex_state = 22},
  [3148] = {.lex_state = 115, .external_lex_state = 10},
  [3149] = {.lex_state = 115, .external_lex_state = 10},
  [3150] = {.lex_state = 115, .external_lex_state = 10},
  [3151] = {.lex_state = 262, .external_lex_state = 18},
  [3152] = {.lex_state = 262, .external_lex_state = 18},
  [3153] = {.lex_state = 115, .external_lex_state = 10},
  [3154] = {.lex_state = 225, .external_lex_state = 18},
  [3155] = {.lex_state = 225, .external_lex_state = 18},
  [3156] = {.lex_state = 92, .external_lex_state = 29},
  [3157] = {.lex_state = 92, .external_lex_state = 29},
  [3158] = {.lex_state = 92, .external_lex_state = 29},
  [3159] = {.lex_state = 92, .external_lex_state = 18},
  [3160] = {.lex_state = 92, .external_lex_state = 18},
  [3161] = {.lex_state = 260, .external_lex_state = 18},
  [3162] = {.lex_state = 92, .external_lex_state = 29},
  [3163] = {.lex_state = 262, .external_lex_state = 30},
  [3164] = {.lex_state = 262, .external_lex_state = 18},
  [3165] = {.lex_state = 262, .external_lex_state = 30},
  [3166] = {.lex_state = 262, .external_lex_state = 18},
  [3167] = {.lex_state = 262, .external_lex_state = 18},
  [3168] = {.lex_state = 92, .external_lex_state = 29},
  [3169] = {.lex_state = 262, .external_lex_state = 18},
  [3170] = {.lex_state = 262, .external_lex_state = 18},
  [3171] = {.lex_state = 142, .external_lex_state = 6},
  [3172] = {.lex_state = 142, .external_lex_state = 6},
  [3173] = {.lex_state = 262, .external_lex_state = 29},
  [3174] = {.lex_state = 262, .external_lex_state = 29},
  [3175] = {.lex_state = 92, .external_lex_state = 29},
  [3176] = {.lex_state = 92, .external_lex_state = 18},
  [3177] = {.lex_state = 92, .external_lex_state = 18},
  [3178] = {.lex_state = 262, .external_lex_state = 18},
  [3179] = {.lex_state = 262, .external_lex_state = 29},
  [3180] = {.lex_state = 262, .external_lex_state = 18},
  [3181] = {.lex_state = 262, .external_lex_state = 18},
  [3182] = {.lex_state = 262, .external_lex_state = 18},
  [3183] = {.lex_state = 262, .external_lex_state = 29},
  [3184] = {.lex_state = 262, .external_lex_state = 18},
  [3185] = {.lex_state = 96, .external_lex_state = 23},
  [3186] = {.lex_state = 96, .external_lex_state = 23},
  [3187] = {.lex_state = 92, .external_lex_state = 29},
  [3188] = {.lex_state = 92, .external_lex_state = 18},
  [3189] = {.lex_state = 92, .external_lex_state = 18},
  [3190] = {.lex_state = 262, .external_lex_state = 18},
  [3191] = {.lex_state = 96, .external_lex_state = 23},
  [3192] = {.lex_state = 262, .external_lex_state = 18},
  [3193] = {.lex_state = 262, .external_lex_state = 18},
  [3194] = {.lex_state = 262, .external_lex_state = 18},
  [3195] = {.lex_state = 96, .external_lex_state = 23},
  [3196] = {.lex_state = 262, .external_lex_state = 18},
  [3197] = {.lex_state = 136, .external_lex_state = 6},
  [3198] = {.lex_state = 215, .external_lex_state = 10},
  [3199] = {.lex_state = 215, .external_lex_state = 10},
  [3200] = {.lex_state = 92, .external_lex_state = 29},
  [3201] = {.lex_state = 92, .external_lex_state = 18},
  [3202] = {.lex_state = 92, .external_lex_state = 18},
  [3203] = {.lex_state = 262, .external_lex_state = 18},
  [3204] = {.lex_state = 215, .external_lex_state = 10},
  [3205] = {.lex_state = 262, .external_lex_state = 18},
  [3206] = {.lex_state = 262, .external_lex_state = 18},
  [3207] = {.lex_state = 262, .external_lex_state = 18},
  [3208] = {.lex_state = 215, .external_lex_state = 10},
  [3209] = {.lex_state = 262, .external_lex_state = 18},
  [3210] = {.lex_state = 184, .external_lex_state = 21},
  [3211] = {.lex_state = 184, .external_lex_state = 21},
  [3212] = {.lex_state = 184, .external_lex_state = 21},
  [3213] = {.lex_state = 262, .external_lex_state = 18},
  [3214] = {.lex_state = 262, .external_lex_state = 18},
  [3215] = {.lex_state = 184, .external_lex_state = 21},
  [3216] = {.lex_state = 186, .external_lex_state = 5},
  [3217] = {.lex_state = 313},
  [3218] = {.lex_state = 241, .external_lex_state = 14},
  [3219] = {.lex_state = 241, .external_lex_state = 14},
  [3220] = {.lex_state = 241, .external_lex_state = 14},
  [3221] = {.lex_state = 262, .external_lex_state = 18},
  [3222] = {.lex_state = 262, .external_lex_state = 18},
  [3223] = {.lex_state = 241, .external_lex_state = 14},
  [3224] = {.lex_state = 313},
  [3225] = {.lex_state = 270, .external_lex_state = 14},
  [3226] = {.lex_state = 270, .external_lex_state = 14},
  [3227] = {.lex_state = 92, .external_lex_state = 29},
  [3228] = {.lex_state = 92, .external_lex_state = 18},
  [3229] = {.lex_state = 92, .external_lex_state = 18},
  [3230] = {.lex_state = 262, .external_lex_state = 18},
  [3231] = {.lex_state = 270, .external_lex_state = 14},
  [3232] = {.lex_state = 262, .external_lex_state = 18},
  [3233] = {.lex_state = 262, .external_lex_state = 18},
  [3234] = {.lex_state = 262, .external_lex_state = 18},
  [3235] = {.lex_state = 270, .external_lex_state = 14},
  [3236] = {.lex_state = 262, .external_lex_state = 18},
  [3237] = {.lex_state = 272, .external_lex_state = 10},
  [3238] = {.lex_state = 272, .external_lex_state = 10},
  [3239] = {.lex_state = 272, .external_lex_state = 10},
  [3240] = {.lex_state = 262, .external_lex_state = 18},
  [3241] = {.lex_state = 262, .external_lex_state = 18},
  [3242] = {.lex_state = 272, .external_lex_state = 10},
  [3243] = {.lex_state = 246, .external_lex_state = 10},
  [3244] = {.lex_state = 246, .external_lex_state = 10},
  [3245] = {.lex_state = 140, .external_lex_state = 26},
  [3246] = {.lex_state = 140, .external_lex_state = 26},
  [3247] = {.lex_state = 92, .external_lex_state = 29},
  [3248] = {.lex_state = 92, .external_lex_state = 18},
  [3249] = {.lex_state = 92, .external_lex_state = 18},
  [3250] = {.lex_state = 262, .external_lex_state = 18},
  [3251] = {.lex_state = 140, .external_lex_state = 26},
  [3252] = {.lex_state = 262, .external_lex_state = 18},
  [3253] = {.lex_state = 262, .external_lex_state = 18},
  [3254] = {.lex_state = 262, .external_lex_state = 18},
  [3255] = {.lex_state = 140, .external_lex_state = 26},
  [3256] = {.lex_state = 262, .external_lex_state = 18},
  [3257] = {.lex_state = 136, .external_lex_state = 12},
  [3258] = {.lex_state = 313},
  [3259] = {.lex_state = 313},
  [3260] = {.lex_state = 153},
  [3261] = {.lex_state = 136, .external_lex_state = 12},
  [3262] = {.lex_state = 136, .external_lex_state = 12},
  [3263] = {.lex_state = 333},
  [3264] = {.lex_state = 136, .external_lex_state = 12},
  [3265] = {.lex_state = 333},
  [3266] = {.lex_state = 108, .external_lex_state = 26},
  [3267] = {.lex_state = 108, .external_lex_state = 26},
  [3268] = {.lex_state = 108, .external_lex_state = 26},
  [3269] = {.lex_state = 262, .external_lex_state = 18},
  [3270] = {.lex_state = 262, .external_lex_state = 18},
  [3271] = {.lex_state = 108, .external_lex_state = 26},
  [3272] = {.lex_state = 108, .external_lex_state = 13},
  [3273] = {.lex_state = 108, .external_lex_state = 13},
  [3274] = {.lex_state = 108, .external_lex_state = 13},
  [3275] = {.lex_state = 262, .external_lex_state = 18},
  [3276] = {.lex_state = 262, .external_lex_state = 18},
  [3277] = {.lex_state = 108, .external_lex_state = 13},
  [3278] = {.lex_state = 112, .external_lex_state = 13},
  [3279] = {.lex_state = 112, .external_lex_state = 13},
  [3280] = {.lex_state = 287, .external_lex_state = 4},
  [3281] = {.lex_state = 287, .external_lex_state = 21},
  [3282] = {.lex_state = 287, .external_lex_state = 21},
  [3283] = {.lex_state = 287, .external_lex_state = 21},
  [3284] = {.lex_state = 217},
  [3285] = {.lex_state = 260, .external_lex_state = 18},
  [3286] = {.lex_state = 85},
  [3287] = {.lex_state = 225, .external_lex_state = 18},
  [3288] = {.lex_state = 225, .external_lex_state = 18},
  [3289] = {.lex_state = 287, .external_lex_state = 21},
  [3290] = {.lex_state = 262, .external_lex_state = 30},
  [3291] = {.lex_state = 262, .external_lex_state = 18},
  [3292] = {.lex_state = 287, .external_lex_state = 21},
  [3293] = {.lex_state = 262, .external_lex_state = 30},
  [3294] = {.lex_state = 262, .external_lex_state = 18},
  [3295] = {.lex_state = 287, .external_lex_state = 21},
  [3296] = {.lex_state = 287, .external_lex_state = 21},
  [3297] = {.lex_state = 275, .external_lex_state = 4},
  [3298] = {.lex_state = 215},
  [3299] = {.lex_state = 275, .external_lex_state = 21},
  [3300] = {.lex_state = 275, .external_lex_state = 21},
  [3301] = {.lex_state = 92, .external_lex_state = 29},
  [3302] = {.lex_state = 92, .external_lex_state = 18},
  [3303] = {.lex_state = 92, .external_lex_state = 18},
  [3304] = {.lex_state = 260, .external_lex_state = 18},
  [3305] = {.lex_state = 275, .external_lex_state = 21},
  [3306] = {.lex_state = 262, .external_lex_state = 30},
  [3307] = {.lex_state = 262, .external_lex_state = 18},
  [3308] = {.lex_state = 262, .external_lex_state = 30},
  [3309] = {.lex_state = 262, .external_lex_state = 18},
  [3310] = {.lex_state = 262, .external_lex_state = 18},
  [3311] = {.lex_state = 275, .external_lex_state = 21},
  [3312] = {.lex_state = 262, .external_lex_state = 18},
  [3313] = {.lex_state = 262, .external_lex_state = 18},
  [3314] = {.lex_state = 275, .external_lex_state = 6},
  [3315] = {.lex_state = 275, .external_lex_state = 6},
  [3316] = {.lex_state = 92, .external_lex_state = 29},
  [3317] = {.lex_state = 92, .external_lex_state = 18},
  [3318] = {.lex_state = 92, .external_lex_state = 18},
  [3319] = {.lex_state = 260, .external_lex_state = 18},
  [3320] = {.lex_state = 275, .external_lex_state = 6},
  [3321] = {.lex_state = 262, .external_lex_state = 30},
  [3322] = {.lex_state = 262, .external_lex_state = 18},
  [3323] = {.lex_state = 262, .external_lex_state = 30},
  [3324] = {.lex_state = 262, .external_lex_state = 18},
  [3325] = {.lex_state = 262, .external_lex_state = 18},
  [3326] = {.lex_state = 275, .external_lex_state = 6},
  [3327] = {.lex_state = 262, .external_lex_state = 18},
  [3328] = {.lex_state = 262, .external_lex_state = 18},
  [3329] = {.lex_state = 281, .external_lex_state = 6},
  [3330] = {.lex_state = 281, .external_lex_state = 6},
  [3331] = {.lex_state = 92, .external_lex_state = 29},
  [3332] = {.lex_state = 92, .external_lex_state = 18},
  [3333] = {.lex_state = 92, .external_lex_state = 18},
  [3334] = {.lex_state = 262, .external_lex_state = 18},
  [3335] = {.lex_state = 281, .external_lex_state = 6},
  [3336] = {.lex_state = 262, .external_lex_state = 18},
  [3337] = {.lex_state = 262, .external_lex_state = 18},
  [3338] = {.lex_state = 262, .external_lex_state = 18},
  [3339] = {.lex_state = 281, .external_lex_state = 6},
  [3340] = {.lex_state = 262, .external_lex_state = 18},
  [3341] = {.lex_state = 338, .external_lex_state = 6},
  [3342] = {.lex_state = 285, .external_lex_state = 6},
  [3343] = {.lex_state = 338, .external_lex_state = 6},
  [3344] = {.lex_state = 217},
  [3345] = {.lex_state = 260, .external_lex_state = 18},
  [3346] = {.lex_state = 85},
  [3347] = {.lex_state = 225, .external_lex_state = 18},
  [3348] = {.lex_state = 225, .external_lex_state = 18},
  [3349] = {.lex_state = 338, .external_lex_state = 6},
  [3350] = {.lex_state = 262, .external_lex_state = 30},
  [3351] = {.lex_state = 262, .external_lex_state = 18},
  [3352] = {.lex_state = 338, .external_lex_state = 6},
  [3353] = {.lex_state = 262, .external_lex_state = 30},
  [3354] = {.lex_state = 262, .external_lex_state = 18},
  [3355] = {.lex_state = 338, .external_lex_state = 6},
  [3356] = {.lex_state = 338, .external_lex_state = 6},
  [3357] = {.lex_state = 308, .external_lex_state = 4},
  [3358] = {.lex_state = 308, .external_lex_state = 21},
  [3359] = {.lex_state = 308, .external_lex_state = 21},
  [3360] = {.lex_state = 308, .external_lex_state = 21},
  [3361] = {.lex_state = 217},
  [3362] = {.lex_state = 260, .external_lex_state = 18},
  [3363] = {.lex_state = 85},
  [3364] = {.lex_state = 225, .external_lex_state = 18},
  [3365] = {.lex_state = 225, .external_lex_state = 18},
  [3366] = {.lex_state = 308, .external_lex_state = 21},
  [3367] = {.lex_state = 262, .external_lex_state = 30},
  [3368] = {.lex_state = 262, .external_lex_state = 18},
  [3369] = {.lex_state = 308, .external_lex_state = 21},
  [3370] = {.lex_state = 262, .external_lex_state = 30},
  [3371] = {.lex_state = 262, .external_lex_state = 18},
  [3372] = {.lex_state = 308, .external_lex_state = 21},
  [3373] = {.lex_state = 308, .external_lex_state = 21},
  [3374] = {.lex_state = 326, .external_lex_state = 4},
  [3375] = {.lex_state = 215},
  [3376] = {.lex_state = 102},
  [3377] = {.lex_state = 326, .external_lex_state = 21},
  [3378] = {.lex_state = 326, .external_lex_state = 21},
  [3379] = {.lex_state = 217},
  [3380] = {.lex_state = 115},
  [3381] = {.lex_state = 326, .external_lex_state = 21},
  [3382] = {.lex_state = 326, .external_lex_state = 21},
  [3383] = {.lex_state = 326, .external_lex_state = 21},
  [3384] = {.lex_state = 85},
  [3385] = {.lex_state = 223, .external_lex_state = 7},
  [3386] = {.lex_state = 225, .external_lex_state = 18},
  [3387] = {.lex_state = 225, .external_lex_state = 18},
  [3388] = {.lex_state = 85},
  [3389] = {.lex_state = 215, .external_lex_state = 2},
  [3390] = {.lex_state = 78},
  [3391] = {.lex_state = 85},
  [3392] = {.lex_state = 326, .external_lex_state = 4},
  [3393] = {.lex_state = 326, .external_lex_state = 4},
  [3394] = {.lex_state = 318, .external_lex_state = 4},
  [3395] = {.lex_state = 215},
  [3396] = {.lex_state = 318, .external_lex_state = 21},
  [3397] = {.lex_state = 318, .external_lex_state = 4},
  [3398] = {.lex_state = 318, .external_lex_state = 21},
  [3399] = {.lex_state = 318, .external_lex_state = 21},
  [3400] = {.lex_state = 318, .external_lex_state = 21},
  [3401] = {.lex_state = 217},
  [3402] = {.lex_state = 260, .external_lex_state = 18},
  [3403] = {.lex_state = 85},
  [3404] = {.lex_state = 225, .external_lex_state = 18},
  [3405] = {.lex_state = 225, .external_lex_state = 18},
  [3406] = {.lex_state = 318, .external_lex_state = 21},
  [3407] = {.lex_state = 262, .external_lex_state = 30},
  [3408] = {.lex_state = 262, .external_lex_state = 18},
  [3409] = {.lex_state = 318, .external_lex_state = 21},
  [3410] = {.lex_state = 262, .external_lex_state = 30},
  [3411] = {.lex_state = 262, .external_lex_state = 18},
  [3412] = {.lex_state = 318, .external_lex_state = 21},
  [3413] = {.lex_state = 318, .external_lex_state = 21},
  [3414] = {.lex_state = 318, .external_lex_state = 6},
  [3415] = {.lex_state = 318, .external_lex_state = 6},
  [3416] = {.lex_state = 318, .external_lex_state = 6},
  [3417] = {.lex_state = 217},
  [3418] = {.lex_state = 260, .external_lex_state = 18},
  [3419] = {.lex_state = 85},
  [3420] = {.lex_state = 225, .external_lex_state = 18},
  [3421] = {.lex_state = 225, .external_lex_state = 18},
  [3422] = {.lex_state = 318, .external_lex_state = 6},
  [3423] = {.lex_state = 262, .external_lex_state = 30},
  [3424] = {.lex_state = 262, .external_lex_state = 18},
  [3425] = {.lex_state = 318, .external_lex_state = 6},
  [3426] = {.lex_state = 262, .external_lex_state = 30},
  [3427] = {.lex_state = 262, .external_lex_state = 18},
  [3428] = {.lex_state = 318, .external_lex_state = 6},
  [3429] = {.lex_state = 318, .external_lex_state = 6},
  [3430] = {.lex_state = 320, .external_lex_state = 6},
  [3431] = {.lex_state = 320, .external_lex_state = 6},
  [3432] = {.lex_state = 92, .external_lex_state = 29},
  [3433] = {.lex_state = 92, .external_lex_state = 18},
  [3434] = {.lex_state = 92, .external_lex_state = 18},
  [3435] = {.lex_state = 260, .external_lex_state = 18},
  [3436] = {.lex_state = 320, .external_lex_state = 6},
  [3437] = {.lex_state = 262, .external_lex_state = 30},
  [3438] = {.lex_state = 262, .external_lex_state = 18},
  [3439] = {.lex_state = 262, .external_lex_state = 30},
  [3440] = {.lex_state = 262, .external_lex_state = 18},
  [3441] = {.lex_state = 262, .external_lex_state = 18},
  [3442] = {.lex_state = 320, .external_lex_state = 6},
  [3443] = {.lex_state = 262, .external_lex_state = 18},
  [3444] = {.lex_state = 262, .external_lex_state = 18},
  [3445] = {.lex_state = 324, .external_lex_state = 6},
  [3446] = {.lex_state = 324, .external_lex_state = 5},
  [3447] = {.lex_state = 324, .external_lex_state = 6},
  [3448] = {.lex_state = 324, .external_lex_state = 5},
  [3449] = {.lex_state = 289, .external_lex_state = 2},
  [3450] = {.lex_state = 291, .external_lex_state = 4},
  [3451] = {.lex_state = 215},
  [3452] = {.lex_state = 291, .external_lex_state = 21},
  [3453] = {.lex_state = 291, .external_lex_state = 21},
  [3454] = {.lex_state = 92, .external_lex_state = 29},
  [3455] = {.lex_state = 92, .external_lex_state = 18},
  [3456] = {.lex_state = 92, .external_lex_state = 18},
  [3457] = {.lex_state = 260, .external_lex_state = 18},
  [3458] = {.lex_state = 291, .external_lex_state = 21},
  [3459] = {.lex_state = 262, .external_lex_state = 30},
  [3460] = {.lex_state = 262, .external_lex_state = 18},
  [3461] = {.lex_state = 262, .external_lex_state = 30},
  [3462] = {.lex_state = 262, .external_lex_state = 18},
  [3463] = {.lex_state = 262, .external_lex_state = 18},
  [3464] = {.lex_state = 291, .external_lex_state = 21},
  [3465] = {.lex_state = 262, .external_lex_state = 18},
  [3466] = {.lex_state = 262, .external_lex_state = 18},
  [3467] = {.lex_state = 291, .external_lex_state = 6},
  [3468] = {.lex_state = 291, .external_lex_state = 6},
  [3469] = {.lex_state = 92, .external_lex_state = 29},
  [3470] = {.lex_state = 92, .external_lex_state = 18},
  [3471] = {.lex_state = 92, .external_lex_state = 18},
  [3472] = {.lex_state = 260, .external_lex_state = 18},
  [3473] = {.lex_state = 291, .external_lex_state = 6},
  [3474] = {.lex_state = 262, .external_lex_state = 30},
  [3475] = {.lex_state = 262, .external_lex_state = 18},
  [3476] = {.lex_state = 262, .external_lex_state = 30},
  [3477] = {.lex_state = 262, .external_lex_state = 18},
  [3478] = {.lex_state = 262, .external_lex_state = 18},
  [3479] = {.lex_state = 291, .external_lex_state = 6},
  [3480] = {.lex_state = 262, .external_lex_state = 18},
  [3481] = {.lex_state = 262, .external_lex_state = 18},
  [3482] = {.lex_state = 301, .external_lex_state = 6},
  [3483] = {.lex_state = 301, .external_lex_state = 6},
  [3484] = {.lex_state = 92, .external_lex_state = 29},
  [3485] = {.lex_state = 92, .external_lex_state = 18},
  [3486] = {.lex_state = 92, .external_lex_state = 18},
  [3487] = {.lex_state = 262, .external_lex_state = 18},
  [3488] = {.lex_state = 301, .external_lex_state = 6},
  [3489] = {.lex_state = 262, .external_lex_state = 18},
  [3490] = {.lex_state = 262, .external_lex_state = 18},
  [3491] = {.lex_state = 262, .external_lex_state = 18},
  [3492] = {.lex_state = 301, .external_lex_state = 6},
  [3493] = {.lex_state = 262, .external_lex_state = 18},
  [3494] = {.lex_state = 305, .external_lex_state = 6},
  [3495] = {.lex_state = 144, .external_lex_state = 8},
  [3496] = {.lex_state = 85},
  [3497] = {.lex_state = 340, .external_lex_state = 21},
  [3498] = {.lex_state = 115},
  [3499] = {.lex_state = 122},
  [3500] = {.lex_state = 340, .external_lex_state = 21},
  [3501] = {.lex_state = 122, .external_lex_state = 7},
  [3502] = {.lex_state = 78, .external_lex_state = 2},
  [3503] = {.lex_state = 78, .external_lex_state = 2},
  [3504] = {.lex_state = 78, .external_lex_state = 2},
  [3505] = {.lex_state = 85},
  [3506] = {.lex_state = 340, .external_lex_state = 4},
  [3507] = {.lex_state = 340, .external_lex_state = 4},
  [3508] = {.lex_state = 340, .external_lex_state = 6},
  [3509] = {.lex_state = 115},
  [3510] = {.lex_state = 122},
  [3511] = {.lex_state = 340, .external_lex_state = 6},
  [3512] = {.lex_state = 122, .external_lex_state = 7},
  [3513] = {.lex_state = 78, .external_lex_state = 2},
  [3514] = {.lex_state = 78, .external_lex_state = 2},
  [3515] = {.lex_state = 78, .external_lex_state = 2},
  [3516] = {.lex_state = 340, .external_lex_state = 5},
  [3517] = {.lex_state = 340, .external_lex_state = 5},
  [3518] = {.lex_state = 102},
  [3519] = {.lex_state = 346, .external_lex_state = 6},
  [3520] = {.lex_state = 346, .external_lex_state = 6},
  [3521] = {.lex_state = 217},
  [3522] = {.lex_state = 115},
  [3523] = {.lex_state = 346, .external_lex_state = 6},
  [3524] = {.lex_state = 346, .external_lex_state = 6},
  [3525] = {.lex_state = 346, .external_lex_state = 6},
  [3526] = {.lex_state = 85},
  [3527] = {.lex_state = 223, .external_lex_state = 7},
  [3528] = {.lex_state = 225, .external_lex_state = 18},
  [3529] = {.lex_state = 225, .external_lex_state = 18},
  [3530] = {.lex_state = 85},
  [3531] = {.lex_state = 215, .external_lex_state = 2},
  [3532] = {.lex_state = 78},
  [3533] = {.lex_state = 85},
  [3534] = {.lex_state = 310},
  [3535] = {.lex_state = 78},
  [3536] = {.lex_state = 336, .external_lex_state = 2},
  [3537] = {.lex_state = 78, .external_lex_state = 2},
  [3538] = {.lex_state = 78, .external_lex_state = 2},
  [3539] = {.lex_state = 102},
  [3540] = {.lex_state = 102},
  [3541] = {.lex_state = 352, .external_lex_state = 9},
  [3542] = {.lex_state = 333, .external_lex_state = 5},
  [3543] = {.lex_state = 237, .external_lex_state = 25},
  [3544] = {.lex_state = 346, .external_lex_state = 6},
  [3545] = {.lex_state = 346, .external_lex_state = 5},
  [3546] = {.lex_state = 346, .external_lex_state = 5},
  [3547] = {.lex_state = 333, .external_lex_state = 5},
  [3548] = {.lex_state = 350, .external_lex_state = 4},
  [3549] = {.lex_state = 346, .external_lex_state = 5},
  [3550] = {.lex_state = 346, .external_lex_state = 5},
  [3551] = {.lex_state = 346, .external_lex_state = 5},
  [3552] = {.lex_state = 333},
  [3553] = {.lex_state = 233, .external_lex_state = 2},
  [3554] = {.lex_state = 330},
  [3555] = {.lex_state = 233, .external_lex_state = 2},
  [3556] = {.lex_state = 330},
  [3557] = {.lex_state = 310},
  [3558] = {.lex_state = 333},
  [3559] = {.lex_state = 186, .external_lex_state = 5},
  [3560] = {.lex_state = 149, .external_lex_state = 14},
  [3561] = {.lex_state = 149, .external_lex_state = 14},
  [3562] = {.lex_state = 186, .external_lex_state = 5},
  [3563] = {.lex_state = 207, .external_lex_state = 27},
  [3564] = {.lex_state = 207, .external_lex_state = 27},
  [3565] = {.lex_state = 92, .external_lex_state = 29},
  [3566] = {.lex_state = 92, .external_lex_state = 18},
  [3567] = {.lex_state = 92, .external_lex_state = 18},
  [3568] = {.lex_state = 262, .external_lex_state = 18},
  [3569] = {.lex_state = 207, .external_lex_state = 27},
  [3570] = {.lex_state = 262, .external_lex_state = 18},
  [3571] = {.lex_state = 262, .external_lex_state = 18},
  [3572] = {.lex_state = 262, .external_lex_state = 18},
  [3573] = {.lex_state = 207, .external_lex_state = 27},
  [3574] = {.lex_state = 262, .external_lex_state = 18},
  [3575] = {.lex_state = 205, .external_lex_state = 16},
  [3576] = {.lex_state = 313},
  [3577] = {.lex_state = 313},
  [3578] = {.lex_state = 153},
  [3579] = {.lex_state = 205, .external_lex_state = 16},
  [3580] = {.lex_state = 205, .external_lex_state = 16},
  [3581] = {.lex_state = 333},
  [3582] = {.lex_state = 205, .external_lex_state = 16},
  [3583] = {.lex_state = 333},
  [3584] = {.lex_state = 199, .external_lex_state = 27},
  [3585] = {.lex_state = 199, .external_lex_state = 27},
  [3586] = {.lex_state = 199, .external_lex_state = 27},
  [3587] = {.lex_state = 262, .external_lex_state = 18},
  [3588] = {.lex_state = 262, .external_lex_state = 18},
  [3589] = {.lex_state = 199, .external_lex_state = 27},
  [3590] = {.lex_state = 199, .external_lex_state = 17},
  [3591] = {.lex_state = 199, .external_lex_state = 17},
  [3592] = {.lex_state = 199, .external_lex_state = 17},
  [3593] = {.lex_state = 262, .external_lex_state = 18},
  [3594] = {.lex_state = 262, .external_lex_state = 18},
  [3595] = {.lex_state = 199, .external_lex_state = 17},
  [3596] = {.lex_state = 201, .external_lex_state = 17},
  [3597] = {.lex_state = 201, .external_lex_state = 17},
  [3598] = {.lex_state = 209, .external_lex_state = 19},
  [3599] = {.lex_state = 209, .external_lex_state = 19},
  [3600] = {.lex_state = 178, .external_lex_state = 21},
  [3601] = {.lex_state = 178, .external_lex_state = 21},
  [3602] = {.lex_state = 178, .external_lex_state = 6},
  [3603] = {.lex_state = 178, .external_lex_state = 6},
  [3604] = {.lex_state = 215, .external_lex_state = 22},
  [3605] = {.lex_state = 215, .external_lex_state = 22},
  [3606] = {.lex_state = 115, .external_lex_state = 10},
  [3607] = {.lex_state = 115, .external_lex_state = 10},
  [3608] = {.lex_state = 92, .external_lex_state = 29},
  [3609] = {.lex_state = 92, .external_lex_state = 29},
  [3610] = {.lex_state = 92, .external_lex_state = 29},
  [3611] = {.lex_state = 92, .external_lex_state = 18},
  [3612] = {.lex_state = 92, .external_lex_state = 18},
  [3613] = {.lex_state = 262, .external_lex_state = 18},
  [3614] = {.lex_state = 92, .external_lex_state = 29},
  [3615] = {.lex_state = 262, .external_lex_state = 18},
  [3616] = {.lex_state = 262, .external_lex_state = 18},
  [3617] = {.lex_state = 262, .external_lex_state = 18},
  [3618] = {.lex_state = 92, .external_lex_state = 29},
  [3619] = {.lex_state = 262, .external_lex_state = 18},
  [3620] = {.lex_state = 262, .external_lex_state = 29},
  [3621] = {.lex_state = 262, .external_lex_state = 29},
  [3622] = {.lex_state = 262, .external_lex_state = 29},
  [3623] = {.lex_state = 262, .external_lex_state = 18},
  [3624] = {.lex_state = 262, .external_lex_state = 18},
  [3625] = {.lex_state = 262, .external_lex_state = 29},
  [3626] = {.lex_state = 96, .external_lex_state = 23},
  [3627] = {.lex_state = 96, .external_lex_state = 23},
  [3628] = {.lex_state = 96, .external_lex_state = 23},
  [3629] = {.lex_state = 262, .external_lex_state = 18},
  [3630] = {.lex_state = 262, .external_lex_state = 18},
  [3631] = {.lex_state = 96, .external_lex_state = 23},
  [3632] = {.lex_state = 215, .external_lex_state = 10},
  [3633] = {.lex_state = 215, .external_lex_state = 10},
  [3634] = {.lex_state = 215, .external_lex_state = 10},
  [3635] = {.lex_state = 262, .external_lex_state = 18},
  [3636] = {.lex_state = 262, .external_lex_state = 18},
  [3637] = {.lex_state = 215, .external_lex_state = 10},
  [3638] = {.lex_state = 184, .external_lex_state = 21},
  [3639] = {.lex_state = 184, .external_lex_state = 21},
  [3640] = {.lex_state = 186, .external_lex_state = 5},
  [3641] = {.lex_state = 241, .external_lex_state = 14},
  [3642] = {.lex_state = 241, .external_lex_state = 14},
  [3643] = {.lex_state = 313},
  [3644] = {.lex_state = 270, .external_lex_state = 14},
  [3645] = {.lex_state = 270, .external_lex_state = 14},
  [3646] = {.lex_state = 270, .external_lex_state = 14},
  [3647] = {.lex_state = 262, .external_lex_state = 18},
  [3648] = {.lex_state = 262, .external_lex_state = 18},
  [3649] = {.lex_state = 270, .external_lex_state = 14},
  [3650] = {.lex_state = 272, .external_lex_state = 10},
  [3651] = {.lex_state = 272, .external_lex_state = 10},
  [3652] = {.lex_state = 140, .external_lex_state = 26},
  [3653] = {.lex_state = 140, .external_lex_state = 26},
  [3654] = {.lex_state = 140, .external_lex_state = 26},
  [3655] = {.lex_state = 262, .external_lex_state = 18},
  [3656] = {.lex_state = 262, .external_lex_state = 18},
  [3657] = {.lex_state = 140, .external_lex_state = 26},
  [3658] = {.lex_state = 136, .external_lex_state = 12},
  [3659] = {.lex_state = 313},
  [3660] = {.lex_state = 313},
  [3661] = {.lex_state = 136, .external_lex_state = 12},
  [3662] = {.lex_state = 136, .external_lex_state = 12},
  [3663] = {.lex_state = 108, .external_lex_state = 26},
  [3664] = {.lex_state = 108, .external_lex_state = 26},
  [3665] = {.lex_state = 108, .external_lex_state = 13},
  [3666] = {.lex_state = 108, .external_lex_state = 13},
  [3667] = {.lex_state = 287, .external_lex_state = 21},
  [3668] = {.lex_state = 287, .external_lex_state = 21},
  [3669] = {.lex_state = 92, .external_lex_state = 29},
  [3670] = {.lex_state = 92, .external_lex_state = 18},
  [3671] = {.lex_state = 92, .external_lex_state = 18},
  [3672] = {.lex_state = 260, .external_lex_state = 18},
  [3673] = {.lex_state = 287, .external_lex_state = 21},
  [3674] = {.lex_state = 262, .external_lex_state = 30},
  [3675] = {.lex_state = 262, .external_lex_state = 18},
  [3676] = {.lex_state = 262, .external_lex_state = 30},
  [3677] = {.lex_state = 262, .external_lex_state = 18},
  [3678] = {.lex_state = 262, .external_lex_state = 18},
  [3679] = {.lex_state = 287, .external_lex_state = 21},
  [3680] = {.lex_state = 262, .external_lex_state = 18},
  [3681] = {.lex_state = 262, .external_lex_state = 18},
  [3682] = {.lex_state = 275, .external_lex_state = 4},
  [3683] = {.lex_state = 275, .external_lex_state = 21},
  [3684] = {.lex_state = 275, .external_lex_state = 21},
  [3685] = {.lex_state = 92, .external_lex_state = 29},
  [3686] = {.lex_state = 92, .external_lex_state = 18},
  [3687] = {.lex_state = 92, .external_lex_state = 18},
  [3688] = {.lex_state = 262, .external_lex_state = 18},
  [3689] = {.lex_state = 275, .external_lex_state = 21},
  [3690] = {.lex_state = 262, .external_lex_state = 18},
  [3691] = {.lex_state = 262, .external_lex_state = 18},
  [3692] = {.lex_state = 262, .external_lex_state = 18},
  [3693] = {.lex_state = 275, .external_lex_state = 21},
  [3694] = {.lex_state = 262, .external_lex_state = 18},
  [3695] = {.lex_state = 275, .external_lex_state = 6},
  [3696] = {.lex_state = 275, .external_lex_state = 6},
  [3697] = {.lex_state = 92, .external_lex_state = 29},
  [3698] = {.lex_state = 92, .external_lex_state = 18},
  [3699] = {.lex_state = 92, .external_lex_state = 18},
  [3700] = {.lex_state = 262, .external_lex_state = 18},
  [3701] = {.lex_state = 275, .external_lex_state = 6},
  [3702] = {.lex_state = 262, .external_lex_state = 18},
  [3703] = {.lex_state = 262, .external_lex_state = 18},
  [3704] = {.lex_state = 262, .external_lex_state = 18},
  [3705] = {.lex_state = 275, .external_lex_state = 6},
  [3706] = {.lex_state = 262, .external_lex_state = 18},
  [3707] = {.lex_state = 281, .external_lex_state = 6},
  [3708] = {.lex_state = 281, .external_lex_state = 6},
  [3709] = {.lex_state = 281, .external_lex_state = 6},
  [3710] = {.lex_state = 262, .external_lex_state = 18},
  [3711] = {.lex_state = 262, .external_lex_state = 18},
  [3712] = {.lex_state = 281, .external_lex_state = 6},
  [3713] = {.lex_state = 338, .external_lex_state = 6},
  [3714] = {.lex_state = 338, .external_lex_state = 6},
  [3715] = {.lex_state = 92, .external_lex_state = 29},
  [3716] = {.lex_state = 92, .external_lex_state = 18},
  [3717] = {.lex_state = 92, .external_lex_state = 18},
  [3718] = {.lex_state = 260, .external_lex_state = 18},
  [3719] = {.lex_state = 338, .external_lex_state = 6},
  [3720] = {.lex_state = 262, .external_lex_state = 30},
  [3721] = {.lex_state = 262, .external_lex_state = 18},
  [3722] = {.lex_state = 262, .external_lex_state = 30},
  [3723] = {.lex_state = 262, .external_lex_state = 18},
  [3724] = {.lex_state = 262, .external_lex_state = 18},
  [3725] = {.lex_state = 338, .external_lex_state = 6},
  [3726] = {.lex_state = 262, .external_lex_state = 18},
  [3727] = {.lex_state = 262, .external_lex_state = 18},
  [3728] = {.lex_state = 308, .external_lex_state = 21},
  [3729] = {.lex_state = 308, .external_lex_state = 21},
  [3730] = {.lex_state = 92, .external_lex_state = 29},
  [3731] = {.lex_state = 92, .external_lex_state = 18},
  [3732] = {.lex_state = 92, .external_lex_state = 18},
  [3733] = {.lex_state = 260, .external_lex_state = 18},
  [3734] = {.lex_state = 308, .external_lex_state = 21},
  [3735] = {.lex_state = 262, .external_lex_state = 30},
  [3736] = {.lex_state = 262, .external_lex_state = 18},
  [3737] = {.lex_state = 262, .external_lex_state = 30},
  [3738] = {.lex_state = 262, .external_lex_state = 18},
  [3739] = {.lex_state = 262, .external_lex_state = 18},
  [3740] = {.lex_state = 308, .external_lex_state = 21},
  [3741] = {.lex_state = 262, .external_lex_state = 18},
  [3742] = {.lex_state = 262, .external_lex_state = 18},
  [3743] = {.lex_state = 326, .external_lex_state = 4},
  [3744] = {.lex_state = 326, .external_lex_state = 21},
  [3745] = {.lex_state = 326, .external_lex_state = 21},
  [3746] = {.lex_state = 326, .external_lex_state = 21},
  [3747] = {.lex_state = 217},
  [3748] = {.lex_state = 260, .external_lex_state = 18},
  [3749] = {.lex_state = 85},
  [3750] = {.lex_state = 225, .external_lex_state = 18},
  [3751] = {.lex_state = 225, .external_lex_state = 18},
  [3752] = {.lex_state = 326, .external_lex_state = 21},
  [3753] = {.lex_state = 262, .external_lex_state = 30},
  [3754] = {.lex_state = 262, .external_lex_state = 18},
  [3755] = {.lex_state = 326, .external_lex_state = 21},
  [3756] = {.lex_state = 262, .external_lex_state = 30},
  [3757] = {.lex_state = 262, .external_lex_state = 18},
  [3758] = {.lex_state = 326, .external_lex_state = 21},
  [3759] = {.lex_state = 326, .external_lex_state = 21},
  [3760] = {.lex_state = 318, .external_lex_state = 4},
  [3761] = {.lex_state = 215},
  [3762] = {.lex_state = 318, .external_lex_state = 21},
  [3763] = {.lex_state = 318, .external_lex_state = 21},
  [3764] = {.lex_state = 92, .external_lex_state = 29},
  [3765] = {.lex_state = 92, .external_lex_state = 18},
  [3766] = {.lex_state = 92, .external_lex_state = 18},
  [3767] = {.lex_state = 260, .external_lex_state = 18},
  [3768] = {.lex_state = 318, .external_lex_state = 21},
  [3769] = {.lex_state = 262, .external_lex_state = 30},
  [3770] = {.lex_state = 262, .external_lex_state = 18},
  [3771] = {.lex_state = 262, .external_lex_state = 30},
  [3772] = {.lex_state = 262, .external_lex_state = 18},
  [3773] = {.lex_state = 262, .external_lex_state = 18},
  [3774] = {.lex_state = 318, .external_lex_state = 21},
  [3775] = {.lex_state = 262, .external_lex_state = 18},
  [3776] = {.lex_state = 262, .external_lex_state = 18},
  [3777] = {.lex_state = 318, .external_lex_state = 6},
  [3778] = {.lex_state = 318, .external_lex_state = 6},
  [3779] = {.lex_state = 92, .external_lex_state = 29},
  [3780] = {.lex_state = 92, .external_lex_state = 18},
  [3781] = {.lex_state = 92, .external_lex_state = 18},
  [3782] = {.lex_state = 260, .external_lex_state = 18},
  [3783] = {.lex_state = 318, .external_lex_state = 6},
  [3784] = {.lex_state = 262, .external_lex_state = 30},
  [3785] = {.lex_state = 262, .external_lex_state = 18},
  [3786] = {.lex_state = 262, .external_lex_state = 30},
  [3787] = {.lex_state = 262, .external_lex_state = 18},
  [3788] = {.lex_state = 262, .external_lex_state = 18},
  [3789] = {.lex_state = 318, .external_lex_state = 6},
  [3790] = {.lex_state = 262, .external_lex_state = 18},
  [3791] = {.lex_state = 262, .external_lex_state = 18},
  [3792] = {.lex_state = 320, .external_lex_state = 6},
  [3793] = {.lex_state = 320, .external_lex_state = 6},
  [3794] = {.lex_state = 92, .external_lex_state = 29},
  [3795] = {.lex_state = 92, .external_lex_state = 18},
  [3796] = {.lex_state = 92, .external_lex_state = 18},
  [3797] = {.lex_state = 262, .external_lex_state = 18},
  [3798] = {.lex_state = 320, .external_lex_state = 6},
  [3799] = {.lex_state = 262, .external_lex_state = 18},
  [3800] = {.lex_state = 262, .external_lex_state = 18},
  [3801] = {.lex_state = 262, .external_lex_state = 18},
  [3802] = {.lex_state = 320, .external_lex_state = 6},
  [3803] = {.lex_state = 262, .external_lex_state = 18},
  [3804] = {.lex_state = 324, .external_lex_state = 6},
  [3805] = {.lex_state = 291, .external_lex_state = 4},
  [3806] = {.lex_state = 291, .external_lex_state = 21},
  [3807] = {.lex_state = 291, .external_lex_state = 21},
  [3808] = {.lex_state = 92, .external_lex_state = 29},
  [3809] = {.lex_state = 92, .external_lex_state = 18},
  [3810] = {.lex_state = 92, .external_lex_state = 18},
  [3811] = {.lex_state = 262, .external_lex_state = 18},
  [3812] = {.lex_state = 291, .external_lex_state = 21},
  [3813] = {.lex_state = 262, .external_lex_state = 18},
  [3814] = {.lex_state = 262, .external_lex_state = 18},
  [3815] = {.lex_state = 262, .external_lex_state = 18},
  [3816] = {.lex_state = 291, .external_lex_state = 21},
  [3817] = {.lex_state = 262, .external_lex_state = 18},
  [3818] = {.lex_state = 291, .external_lex_state = 6},
  [3819] = {.lex_state = 291, .external_lex_state = 6},
  [3820] = {.lex_state = 92, .external_lex_state = 29},
  [3821] = {.lex_state = 92, .external_lex_state = 18},
  [3822] = {.lex_state = 92, .external_lex_state = 18},
  [3823] = {.lex_state = 262, .external_lex_state = 18},
  [3824] = {.lex_state = 291, .external_lex_state = 6},
  [3825] = {.lex_state = 262, .external_lex_state = 18},
  [3826] = {.lex_state = 262, .external_lex_state = 18},
  [3827] = {.lex_state = 262, .external_lex_state = 18},
  [3828] = {.lex_state = 291, .external_lex_state = 6},
  [3829] = {.lex_state = 262, .external_lex_state = 18},
  [3830] = {.lex_state = 301, .external_lex_state = 6},
  [3831] = {.lex_state = 301, .external_lex_state = 6},
  [3832] = {.lex_state = 301, .external_lex_state = 6},
  [3833] = {.lex_state = 262, .external_lex_state = 18},
  [3834] = {.lex_state = 262, .external_lex_state = 18},
  [3835] = {.lex_state = 301, .external_lex_state = 6},
  [3836] = {.lex_state = 350, .external_lex_state = 4},
  [3837] = {.lex_state = 215},
  [3838] = {.lex_state = 350, .external_lex_state = 21},
  [3839] = {.lex_state = 115},
  [3840] = {.lex_state = 122},
  [3841] = {.lex_state = 350, .external_lex_state = 21},
  [3842] = {.lex_state = 122, .external_lex_state = 7},
  [3843] = {.lex_state = 78, .external_lex_state = 2},
  [3844] = {.lex_state = 78, .external_lex_state = 2},
  [3845] = {.lex_state = 78, .external_lex_state = 2},
  [3846] = {.lex_state = 350, .external_lex_state = 4},
  [3847] = {.lex_state = 144, .external_lex_state = 8},
  [3848] = {.lex_state = 102},
  [3849] = {.lex_state = 340, .external_lex_state = 21},
  [3850] = {.lex_state = 340, .external_lex_state = 21},
  [3851] = {.lex_state = 217},
  [3852] = {.lex_state = 115},
  [3853] = {.lex_state = 340, .external_lex_state = 21},
  [3854] = {.lex_state = 340, .external_lex_state = 21},
  [3855] = {.lex_state = 340, .external_lex_state = 21},
  [3856] = {.lex_state = 85},
  [3857] = {.lex_state = 223, .external_lex_state = 7},
  [3858] = {.lex_state = 225, .external_lex_state = 18},
  [3859] = {.lex_state = 225, .external_lex_state = 18},
  [3860] = {.lex_state = 85},
  [3861] = {.lex_state = 215, .external_lex_state = 2},
  [3862] = {.lex_state = 78},
  [3863] = {.lex_state = 85},
  [3864] = {.lex_state = 340, .external_lex_state = 4},
  [3865] = {.lex_state = 340, .external_lex_state = 4},
  [3866] = {.lex_state = 340, .external_lex_state = 4},
  [3867] = {.lex_state = 102},
  [3868] = {.lex_state = 340, .external_lex_state = 6},
  [3869] = {.lex_state = 340, .external_lex_state = 6},
  [3870] = {.lex_state = 217},
  [3871] = {.lex_state = 115},
  [3872] = {.lex_state = 340, .external_lex_state = 6},
  [3873] = {.lex_state = 340, .external_lex_state = 6},
  [3874] = {.lex_state = 340, .external_lex_state = 6},
  [3875] = {.lex_state = 85},
  [3876] = {.lex_state = 223, .external_lex_state = 7},
  [3877] = {.lex_state = 225, .external_lex_state = 18},
  [3878] = {.lex_state = 225, .external_lex_state = 18},
  [3879] = {.lex_state = 85},
  [3880] = {.lex_state = 215, .external_lex_state = 2},
  [3881] = {.lex_state = 78},
  [3882] = {.lex_state = 85},
  [3883] = {.lex_state = 340, .external_lex_state = 5},
  [3884] = {.lex_state = 340, .external_lex_state = 5},
  [3885] = {.lex_state = 340, .external_lex_state = 5},
  [3886] = {.lex_state = 346, .external_lex_state = 6},
  [3887] = {.lex_state = 346, .external_lex_state = 6},
  [3888] = {.lex_state = 346, .external_lex_state = 6},
  [3889] = {.lex_state = 217},
  [3890] = {.lex_state = 260, .external_lex_state = 18},
  [3891] = {.lex_state = 85},
  [3892] = {.lex_state = 225, .external_lex_state = 18},
  [3893] = {.lex_state = 225, .external_lex_state = 18},
  [3894] = {.lex_state = 346, .external_lex_state = 6},
  [3895] = {.lex_state = 262, .external_lex_state = 30},
  [3896] = {.lex_state = 262, .external_lex_state = 18},
  [3897] = {.lex_state = 346, .external_lex_state = 6},
  [3898] = {.lex_state = 262, .external_lex_state = 30},
  [3899] = {.lex_state = 262, .external_lex_state = 18},
  [3900] = {.lex_state = 346, .external_lex_state = 6},
  [3901] = {.lex_state = 346, .external_lex_state = 6},
  [3902] = {.lex_state = 102},
  [3903] = {.lex_state = 333, .external_lex_state = 5},
  [3904] = {.lex_state = 350, .external_lex_state = 4},
  [3905] = {.lex_state = 333, .external_lex_state = 5},
  [3906] = {.lex_state = 350, .external_lex_state = 4},
  [3907] = {.lex_state = 333, .external_lex_state = 6},
  [3908] = {.lex_state = 333, .external_lex_state = 6},
  [3909] = {.lex_state = 333, .external_lex_state = 5},
  [3910] = {.lex_state = 333, .external_lex_state = 6},
  [3911] = {.lex_state = 333, .external_lex_state = 5},
  [3912] = {.lex_state = 336, .external_lex_state = 2},
  [3913] = {.lex_state = 333, .external_lex_state = 5},
  [3914] = {.lex_state = 346, .external_lex_state = 5},
  [3915] = {.lex_state = 346, .external_lex_state = 6},
  [3916] = {.lex_state = 346, .external_lex_state = 5},
  [3917] = {.lex_state = 346, .external_lex_state = 5},
  [3918] = {.lex_state = 336, .external_lex_state = 2},
  [3919] = {.lex_state = 352, .external_lex_state = 9},
  [3920] = {.lex_state = 346, .external_lex_state = 5},
  [3921] = {.lex_state = 310},
  [3922] = {.lex_state = 102},
  [3923] = {.lex_state = 85},
  [3924] = {.lex_state = 136, .external_lex_state = 5},
  [3925] = {.lex_state = 140, .external_lex_state = 4},
  [3926] = {.lex_state = 78, .external_lex_state = 2},
  [3927] = {.lex_state = 233, .external_lex_state = 2},
  [3928] = {.lex_state = 102},
  [3929] = {.lex_state = 85},
  [3930] = {.lex_state = 233, .external_lex_state = 2},
  [3931] = {.lex_state = 310},
  [3932] = {.lex_state = 207, .external_lex_state = 27},
  [3933] = {.lex_state = 207, .external_lex_state = 27},
  [3934] = {.lex_state = 207, .external_lex_state = 27},
  [3935] = {.lex_state = 262, .external_lex_state = 18},
  [3936] = {.lex_state = 262, .external_lex_state = 18},
  [3937] = {.lex_state = 207, .external_lex_state = 27},
  [3938] = {.lex_state = 205, .external_lex_state = 16},
  [3939] = {.lex_state = 313},
  [3940] = {.lex_state = 313},
  [3941] = {.lex_state = 205, .external_lex_state = 16},
  [3942] = {.lex_state = 205, .external_lex_state = 16},
  [3943] = {.lex_state = 199, .external_lex_state = 27},
  [3944] = {.lex_state = 199, .external_lex_state = 27},
  [3945] = {.lex_state = 199, .external_lex_state = 17},
  [3946] = {.lex_state = 199, .external_lex_state = 17},
  [3947] = {.lex_state = 92, .external_lex_state = 29},
  [3948] = {.lex_state = 92, .external_lex_state = 29},
  [3949] = {.lex_state = 92, .external_lex_state = 29},
  [3950] = {.lex_state = 262, .external_lex_state = 18},
  [3951] = {.lex_state = 262, .external_lex_state = 18},
  [3952] = {.lex_state = 92, .external_lex_state = 29},
  [3953] = {.lex_state = 262, .external_lex_state = 29},
  [3954] = {.lex_state = 262, .external_lex_state = 29},
  [3955] = {.lex_state = 96, .external_lex_state = 23},
  [3956] = {.lex_state = 96, .external_lex_state = 23},
  [3957] = {.lex_state = 215, .external_lex_state = 10},
  [3958] = {.lex_state = 215, .external_lex_state = 10},
  [3959] = {.lex_state = 186, .external_lex_state = 5},
  [3960] = {.lex_state = 270, .external_lex_state = 14},
  [3961] = {.lex_state = 270, .external_lex_state = 14},
  [3962] = {.lex_state = 140, .external_lex_state = 26},
  [3963] = {.lex_state = 140, .external_lex_state = 26},
  [3964] = {.lex_state = 136, .external_lex_state = 12},
  [3965] = {.lex_state = 313},
  [3966] = {.lex_state = 287, .external_lex_state = 21},
  [3967] = {.lex_state = 287, .external_lex_state = 21},
  [3968] = {.lex_state = 92, .external_lex_state = 29},
  [3969] = {.lex_state = 92, .external_lex_state = 18},
  [3970] = {.lex_state = 92, .external_lex_state = 18},
  [3971] = {.lex_state = 262, .external_lex_state = 18},
  [3972] = {.lex_state = 287, .external_lex_state = 21},
  [3973] = {.lex_state = 262, .external_lex_state = 18},
  [3974] = {.lex_state = 262, .external_lex_state = 18},
  [3975] = {.lex_state = 262, .external_lex_state = 18},
  [3976] = {.lex_state = 287, .external_lex_state = 21},
  [3977] = {.lex_state = 262, .external_lex_state = 18},
  [3978] = {.lex_state = 275, .external_lex_state = 21},
  [3979] = {.lex_state = 275, .external_lex_state = 21},
  [3980] = {.lex_state = 275, .external_lex_state = 21},
  [3981] = {.lex_state = 262, .external_lex_state = 18},
  [3982] = {.lex_state = 262, .external_lex_state = 18},
  [3983] = {.lex_state = 275, .external_lex_state = 21},
  [3984] = {.lex_state = 275, .external_lex_state = 6},
  [3985] = {.lex_state = 275, .external_lex_state = 6},
  [3986] = {.lex_state = 275, .external_lex_state = 6},
  [3987] = {.lex_state = 262, .external_lex_state = 18},
  [3988] = {.lex_state = 262, .external_lex_state = 18},
  [3989] = {.lex_state = 275, .external_lex_state = 6},
  [3990] = {.lex_state = 281, .external_lex_state = 6},
  [3991] = {.lex_state = 281, .external_lex_state = 6},
  [3992] = {.lex_state = 338, .external_lex_state = 6},
  [3993] = {.lex_state = 338, .external_lex_state = 6},
  [3994] = {.lex_state = 92, .external_lex_state = 29},
  [3995] = {.lex_state = 92, .external_lex_state = 18},
  [3996] = {.lex_state = 92, .external_lex_state = 18},
  [3997] = {.lex_state = 262, .external_lex_state = 18},
  [3998] = {.lex_state = 338, .external_lex_state = 6},
  [3999] = {.lex_state = 262, .external_lex_state = 18},
  [4000] = {.lex_state = 262, .external_lex_state = 18},
  [4001] = {.lex_state = 262, .external_lex_state = 18},
  [4002] = {.lex_state = 338, .external_lex_state = 6},
  [4003] = {.lex_state = 262, .external_lex_state = 18},
  [4004] = {.lex_state = 308, .external_lex_state = 21},
  [4005] = {.lex_state = 308, .external_lex_state = 21},
  [4006] = {.lex_state = 92, .external_lex_state = 29},
  [4007] = {.lex_state = 92, .external_lex_state = 18},
  [4008] = {.lex_state = 92, .external_lex_state = 18},
  [4009] = {.lex_state = 262, .external_lex_state = 18},
  [4010] = {.lex_state = 308, .external_lex_state = 21},
  [4011] = {.lex_state = 262, .external_lex_state = 18},
  [4012] = {.lex_state = 262, .external_lex_state = 18},
  [4013] = {.lex_state = 262, .external_lex_state = 18},
  [4014] = {.lex_state = 308, .external_lex_state = 21},
  [4015] = {.lex_state = 262, .external_lex_state = 18},
  [4016] = {.lex_state = 326, .external_lex_state = 21},
  [4017] = {.lex_state = 326, .external_lex_state = 21},
  [4018] = {.lex_state = 92, .external_lex_state = 29},
  [4019] = {.lex_state = 92, .external_lex_state = 18},
  [4020] = {.lex_state = 92, .external_lex_state = 18},
  [4021] = {.lex_state = 260, .external_lex_state = 18},
  [4022] = {.lex_state = 326, .external_lex_state = 21},
  [4023] = {.lex_state = 262, .external_lex_state = 30},
  [4024] = {.lex_state = 262, .external_lex_state = 18},
  [4025] = {.lex_state = 262, .external_lex_state = 30},
  [4026] = {.lex_state = 262, .external_lex_state = 18},
  [4027] = {.lex_state = 262, .external_lex_state = 18},
  [4028] = {.lex_state = 326, .external_lex_state = 21},
  [4029] = {.lex_state = 262, .external_lex_state = 18},
  [4030] = {.lex_state = 262, .external_lex_state = 18},
  [4031] = {.lex_state = 318, .external_lex_state = 4},
  [4032] = {.lex_state = 318, .external_lex_state = 21},
  [4033] = {.lex_state = 318, .external_lex_state = 21},
  [4034] = {.lex_state = 92, .external_lex_state = 29},
  [4035] = {.lex_state = 92, .external_lex_state = 18},
  [4036] = {.lex_state = 92, .external_lex_state = 18},
  [4037] = {.lex_state = 262, .external_lex_state = 18},
  [4038] = {.lex_state = 318, .external_lex_state = 21},
  [4039] = {.lex_state = 262, .external_lex_state = 18},
  [4040] = {.lex_state = 262, .external_lex_state = 18},
  [4041] = {.lex_state = 262, .external_lex_state = 18},
  [4042] = {.lex_state = 318, .external_lex_state = 21},
  [4043] = {.lex_state = 262, .external_lex_state = 18},
  [4044] = {.lex_state = 318, .external_lex_state = 6},
  [4045] = {.lex_state = 318, .external_lex_state = 6},
  [4046] = {.lex_state = 92, .external_lex_state = 29},
  [4047] = {.lex_state = 92, .external_lex_state = 18},
  [4048] = {.lex_state = 92, .external_lex_state = 18},
  [4049] = {.lex_state = 262, .external_lex_state = 18},
  [4050] = {.lex_state = 318, .external_lex_state = 6},
  [4051] = {.lex_state = 262, .external_lex_state = 18},
  [4052] = {.lex_state = 262, .external_lex_state = 18},
  [4053] = {.lex_state = 262, .external_lex_state = 18},
  [4054] = {.lex_state = 318, .external_lex_state = 6},
  [4055] = {.lex_state = 262, .external_lex_state = 18},
  [4056] = {.lex_state = 320, .external_lex_state = 6},
  [4057] = {.lex_state = 320, .external_lex_state = 6},
  [4058] = {.lex_state = 320, .external_lex_state = 6},
  [4059] = {.lex_state = 262, .external_lex_state = 18},
  [4060] = {.lex_state = 262, .external_lex_state = 18},
  [4061] = {.lex_state = 320, .external_lex_state = 6},
  [4062] = {.lex_state = 291, .external_lex_state = 21},
  [4063] = {.lex_state = 291, .external_lex_state = 21},
  [4064] = {.lex_state = 291, .external_lex_state = 21},
  [4065] = {.lex_state = 262, .external_lex_state = 18},
  [4066] = {.lex_state = 262, .external_lex_state = 18},
  [4067] = {.lex_state = 291, .external_lex_state = 21},
  [4068] = {.lex_state = 291, .external_lex_state = 6},
  [4069] = {.lex_state = 291, .external_lex_state = 6},
  [4070] = {.lex_state = 291, .external_lex_state = 6},
  [4071] = {.lex_state = 262, .external_lex_state = 18},
  [4072] = {.lex_state = 262, .external_lex_state = 18},
  [4073] = {.lex_state = 291, .external_lex_state = 6},
  [4074] = {.lex_state = 301, .external_lex_state = 6},
  [4075] = {.lex_state = 301, .external_lex_state = 6},
  [4076] = {.lex_state = 350, .external_lex_state = 4},
  [4077] = {.lex_state = 215},
  [4078] = {.lex_state = 102},
  [4079] = {.lex_state = 350, .external_lex_state = 21},
  [4080] = {.lex_state = 350, .external_lex_state = 21},
  [4081] = {.lex_state = 217},
  [4082] = {.lex_state = 115},
  [4083] = {.lex_state = 350, .external_lex_state = 21},
  [4084] = {.lex_state = 350, .external_lex_state = 21},
  [4085] = {.lex_state = 350, .external_lex_state = 21},
  [4086] = {.lex_state = 85},
  [4087] = {.lex_state = 223, .external_lex_state = 7},
  [4088] = {.lex_state = 225, .external_lex_state = 18},
  [4089] = {.lex_state = 225, .external_lex_state = 18},
  [4090] = {.lex_state = 85},
  [4091] = {.lex_state = 215, .external_lex_state = 2},
  [4092] = {.lex_state = 78},
  [4093] = {.lex_state = 85},
  [4094] = {.lex_state = 350, .external_lex_state = 4},
  [4095] = {.lex_state = 350, .external_lex_state = 4},
  [4096] = {.lex_state = 340, .external_lex_state = 4},
  [4097] = {.lex_state = 215},
  [4098] = {.lex_state = 340, .external_lex_state = 21},
  [4099] = {.lex_state = 340, .external_lex_state = 4},
  [4100] = {.lex_state = 340, .external_lex_state = 21},
  [4101] = {.lex_state = 340, .external_lex_state = 21},
  [4102] = {.lex_state = 340, .external_lex_state = 21},
  [4103] = {.lex_state = 217},
  [4104] = {.lex_state = 260, .external_lex_state = 18},
  [4105] = {.lex_state = 85},
  [4106] = {.lex_state = 225, .external_lex_state = 18},
  [4107] = {.lex_state = 225, .external_lex_state = 18},
  [4108] = {.lex_state = 340, .external_lex_state = 21},
  [4109] = {.lex_state = 262, .external_lex_state = 30},
  [4110] = {.lex_state = 262, .external_lex_state = 18},
  [4111] = {.lex_state = 340, .external_lex_state = 21},
  [4112] = {.lex_state = 262, .external_lex_state = 30},
  [4113] = {.lex_state = 262, .external_lex_state = 18},
  [4114] = {.lex_state = 340, .external_lex_state = 21},
  [4115] = {.lex_state = 340, .external_lex_state = 21},
  [4116] = {.lex_state = 340, .external_lex_state = 6},
  [4117] = {.lex_state = 340, .external_lex_state = 6},
  [4118] = {.lex_state = 340, .external_lex_state = 6},
  [4119] = {.lex_state = 217},
  [4120] = {.lex_state = 260, .external_lex_state = 18},
  [4121] = {.lex_state = 85},
  [4122] = {.lex_state = 225, .external_lex_state = 18},
  [4123] = {.lex_state = 225, .external_lex_state = 18},
  [4124] = {.lex_state = 340, .external_lex_state = 6},
  [4125] = {.lex_state = 262, .external_lex_state = 30},
  [4126] = {.lex_state = 262, .external_lex_state = 18},
  [4127] = {.lex_state = 340, .external_lex_state = 6},
  [4128] = {.lex_state = 262, .external_lex_state = 30},
  [4129] = {.lex_state = 262, .external_lex_state = 18},
  [4130] = {.lex_state = 340, .external_lex_state = 6},
  [4131] = {.lex_state = 340, .external_lex_state = 6},
  [4132] = {.lex_state = 346, .external_lex_state = 6},
  [4133] = {.lex_state = 346, .external_lex_state = 6},
  [4134] = {.lex_state = 92, .external_lex_state = 29},
  [4135] = {.lex_state = 92, .external_lex_state = 18},
  [4136] = {.lex_state = 92, .external_lex_state = 18},
  [4137] = {.lex_state = 260, .external_lex_state = 18},
  [4138] = {.lex_state = 346, .external_lex_state = 6},
  [4139] = {.lex_state = 262, .external_lex_state = 30},
  [4140] = {.lex_state = 262, .external_lex_state = 18},
  [4141] = {.lex_state = 262, .external_lex_state = 30},
  [4142] = {.lex_state = 262, .external_lex_state = 18},
  [4143] = {.lex_state = 262, .external_lex_state = 18},
  [4144] = {.lex_state = 346, .external_lex_state = 6},
  [4145] = {.lex_state = 262, .external_lex_state = 18},
  [4146] = {.lex_state = 262, .external_lex_state = 18},
  [4147] = {.lex_state = 333, .external_lex_state = 6},
  [4148] = {.lex_state = 333, .external_lex_state = 5},
  [4149] = {.lex_state = 333, .external_lex_state = 6},
  [4150] = {.lex_state = 333, .external_lex_state = 5},
  [4151] = {.lex_state = 336, .external_lex_state = 2},
  [4152] = {.lex_state = 102},
  [4153] = {.lex_state = 146, .external_lex_state = 9},
  [4154] = {.lex_state = 136, .external_lex_state = 5},
  [4155] = {.lex_state = 140, .external_lex_state = 4},
  [4156] = {.lex_state = 85},
  [4157] = {.lex_state = 102},
  [4158] = {.lex_state = 85},
  [4159] = {.lex_state = 207, .external_lex_state = 27},
  [4160] = {.lex_state = 207, .external_lex_state = 27},
  [4161] = {.lex_state = 205, .external_lex_state = 16},
  [4162] = {.lex_state = 313},
  [4163] = {.lex_state = 92, .external_lex_state = 29},
  [4164] = {.lex_state = 92, .external_lex_state = 29},
  [4165] = {.lex_state = 136, .external_lex_state = 12},
  [4166] = {.lex_state = 287, .external_lex_state = 21},
  [4167] = {.lex_state = 287, .external_lex_state = 21},
  [4168] = {.lex_state = 287, .external_lex_state = 21},
  [4169] = {.lex_state = 262, .external_lex_state = 18},
  [4170] = {.lex_state = 262, .external_lex_state = 18},
  [4171] = {.lex_state = 287, .external_lex_state = 21},
  [4172] = {.lex_state = 275, .external_lex_state = 21},
  [4173] = {.lex_state = 275, .external_lex_state = 21},
  [4174] = {.lex_state = 275, .external_lex_state = 6},
  [4175] = {.lex_state = 275, .external_lex_state = 6},
  [4176] = {.lex_state = 338, .external_lex_state = 6},
  [4177] = {.lex_state = 338, .external_lex_state = 6},
  [4178] = {.lex_state = 338, .external_lex_state = 6},
  [4179] = {.lex_state = 262, .external_lex_state = 18},
  [4180] = {.lex_state = 262, .external_lex_state = 18},
  [4181] = {.lex_state = 338, .external_lex_state = 6},
  [4182] = {.lex_state = 308, .external_lex_state = 21},
  [4183] = {.lex_state = 308, .external_lex_state = 21},
  [4184] = {.lex_state = 308, .external_lex_state = 21},
  [4185] = {.lex_state = 262, .external_lex_state = 18},
  [4186] = {.lex_state = 262, .external_lex_state = 18},
  [4187] = {.lex_state = 308, .external_lex_state = 21},
  [4188] = {.lex_state = 326, .external_lex_state = 21},
  [4189] = {.lex_state = 326, .external_lex_state = 21},
  [4190] = {.lex_state = 92, .external_lex_state = 29},
  [4191] = {.lex_state = 92, .external_lex_state = 18},
  [4192] = {.lex_state = 92, .external_lex_state = 18},
  [4193] = {.lex_state = 262, .external_lex_state = 18},
  [4194] = {.lex_state = 326, .external_lex_state = 21},
  [4195] = {.lex_state = 262, .external_lex_state = 18},
  [4196] = {.lex_state = 262, .external_lex_state = 18},
  [4197] = {.lex_state = 262, .external_lex_state = 18},
  [4198] = {.lex_state = 326, .external_lex_state = 21},
  [4199] = {.lex_state = 262, .external_lex_state = 18},
  [4200] = {.lex_state = 318, .external_lex_state = 21},
  [4201] = {.lex_state = 318, .external_lex_state = 21},
  [4202] = {.lex_state = 318, .external_lex_state = 21},
  [4203] = {.lex_state = 262, .external_lex_state = 18},
  [4204] = {.lex_state = 262, .external_lex_state = 18},
  [4205] = {.lex_state = 318, .external_lex_state = 21},
  [4206] = {.lex_state = 318, .external_lex_state = 6},
  [4207] = {.lex_state = 318, .external_lex_state = 6},
  [4208] = {.lex_state = 318, .external_lex_state = 6},
  [4209] = {.lex_state = 262, .external_lex_state = 18},
  [4210] = {.lex_state = 262, .external_lex_state = 18},
  [4211] = {.lex_state = 318, .external_lex_state = 6},
  [4212] = {.lex_state = 320, .external_lex_state = 6},
  [4213] = {.lex_state = 320, .external_lex_state = 6},
  [4214] = {.lex_state = 291, .external_lex_state = 21},
  [4215] = {.lex_state = 291, .external_lex_state = 21},
  [4216] = {.lex_state = 291, .external_lex_state = 6},
  [4217] = {.lex_state = 291, .external_lex_state = 6},
  [4218] = {.lex_state = 350, .external_lex_state = 4},
  [4219] = {.lex_state = 350, .external_lex_state = 21},
  [4220] = {.lex_state = 350, .external_lex_state = 21},
  [4221] = {.lex_state = 350, .external_lex_state = 21},
  [4222] = {.lex_state = 217},
  [4223] = {.lex_state = 260, .external_lex_state = 18},
  [4224] = {.lex_state = 85},
  [4225] = {.lex_state = 225, .external_lex_state = 18},
  [4226] = {.lex_state = 225, .external_lex_state = 18},
  [4227] = {.lex_state = 350, .external_lex_state = 21},
  [4228] = {.lex_state = 262, .external_lex_state = 30},
  [4229] = {.lex_state = 262, .external_lex_state = 18},
  [4230] = {.lex_state = 350, .external_lex_state = 21},
  [4231] = {.lex_state = 262, .external_lex_state = 30},
  [4232] = {.lex_state = 262, .external_lex_state = 18},
  [4233] = {.lex_state = 350, .external_lex_state = 21},
  [4234] = {.lex_state = 350, .external_lex_state = 21},
  [4235] = {.lex_state = 340, .external_lex_state = 4},
  [4236] = {.lex_state = 215},
  [4237] = {.lex_state = 340, .external_lex_state = 21},
  [4238] = {.lex_state = 340, .external_lex_state = 21},
  [4239] = {.lex_state = 92, .external_lex_state = 29},
  [4240] = {.lex_state = 92, .external_lex_state = 18},
  [4241] = {.lex_state = 92, .external_lex_state = 18},
  [4242] = {.lex_state = 260, .external_lex_state = 18},
  [4243] = {.lex_state = 340, .external_lex_state = 21},
  [4244] = {.lex_state = 262, .external_lex_state = 30},
  [4245] = {.lex_state = 262, .external_lex_state = 18},
  [4246] = {.lex_state = 262, .external_lex_state = 30},
  [4247] = {.lex_state = 262, .external_lex_state = 18},
  [4248] = {.lex_state = 262, .external_lex_state = 18},
  [4249] = {.lex_state = 340, .external_lex_state = 21},
  [4250] = {.lex_state = 262, .external_lex_state = 18},
  [4251] = {.lex_state = 262, .external_lex_state = 18},
  [4252] = {.lex_state = 340, .external_lex_state = 6},
  [4253] = {.lex_state = 340, .external_lex_state = 6},
  [4254] = {.lex_state = 92, .external_lex_state = 29},
  [4255] = {.lex_state = 92, .external_lex_state = 18},
  [4256] = {.lex_state = 92, .external_lex_state = 18},
  [4257] = {.lex_state = 260, .external_lex_state = 18},
  [4258] = {.lex_state = 340, .external_lex_state = 6},
  [4259] = {.lex_state = 262, .external_lex_state = 30},
  [4260] = {.lex_state = 262, .external_lex_state = 18},
  [4261] = {.lex_state = 262, .external_lex_state = 30},
  [4262] = {.lex_state = 262, .external_lex_state = 18},
  [4263] = {.lex_state = 262, .external_lex_state = 18},
  [4264] = {.lex_state = 340, .external_lex_state = 6},
  [4265] = {.lex_state = 262, .external_lex_state = 18},
  [4266] = {.lex_state = 262, .external_lex_state = 18},
  [4267] = {.lex_state = 346, .external_lex_state = 6},
  [4268] = {.lex_state = 346, .external_lex_state = 6},
  [4269] = {.lex_state = 92, .external_lex_state = 29},
  [4270] = {.lex_state = 92, .external_lex_state = 18},
  [4271] = {.lex_state = 92, .external_lex_state = 18},
  [4272] = {.lex_state = 262, .external_lex_state = 18},
  [4273] = {.lex_state = 346, .external_lex_state = 6},
  [4274] = {.lex_state = 262, .external_lex_state = 18},
  [4275] = {.lex_state = 262, .external_lex_state = 18},
  [4276] = {.lex_state = 262, .external_lex_state = 18},
  [4277] = {.lex_state = 346, .external_lex_state = 6},
  [4278] = {.lex_state = 262, .external_lex_state = 18},
  [4279] = {.lex_state = 333, .external_lex_state = 6},
  [4280] = {.lex_state = 146, .external_lex_state = 9},
  [4281] = {.lex_state = 102},
  [4282] = {.lex_state = 102},
  [4283] = {.lex_state = 205, .external_lex_state = 16},
  [4284] = {.lex_state = 287, .external_lex_state = 21},
  [4285] = {.lex_state = 287, .external_lex_state = 21},
  [4286] = {.lex_state = 338, .external_lex_state = 6},
  [4287] = {.lex_state = 338, .external_lex_state = 6},
  [4288] = {.lex_state = 308, .external_lex_state = 21},
  [4289] = {.lex_state = 308, .external_lex_state = 21},
  [4290] = {.lex_state = 326, .external_lex_state = 21},
  [4291] = {.lex_state = 326, .external_lex_state = 21},
  [4292] = {.lex_state = 326, .external_lex_state = 21},
  [4293] = {.lex_state = 262, .external_lex_state = 18},
  [4294] = {.lex_state = 262, .external_lex_state = 18},
  [4295] = {.lex_state = 326, .external_lex_state = 21},
  [4296] = {.lex_state = 318, .external_lex_state = 21},
  [4297] = {.lex_state = 318, .external_lex_state = 21},
  [4298] = {.lex_state = 318, .external_lex_state = 6},
  [4299] = {.lex_state = 318, .external_lex_state = 6},
  [4300] = {.lex_state = 350, .external_lex_state = 21},
  [4301] = {.lex_state = 350, .external_lex_state = 21},
  [4302] = {.lex_state = 92, .external_lex_state = 29},
  [4303] = {.lex_state = 92, .external_lex_state = 18},
  [4304] = {.lex_state = 92, .external_lex_state = 18},
  [4305] = {.lex_state = 260, .external_lex_state = 18},
  [4306] = {.lex_state = 350, .external_lex_state = 21},
  [4307] = {.lex_state = 262, .external_lex_state = 30},
  [4308] = {.lex_state = 262, .external_lex_state = 18},
  [4309] = {.lex_state = 262, .external_lex_state = 30},
  [4310] = {.lex_state = 262, .external_lex_state = 18},
  [4311] = {.lex_state = 262, .external_lex_state = 18},
  [4312] = {.lex_state = 350, .external_lex_state = 21},
  [4313] = {.lex_state = 262, .external_lex_state = 18},
  [4314] = {.lex_state = 262, .external_lex_state = 18},
  [4315] = {.lex_state = 340, .external_lex_state = 4},
  [4316] = {.lex_state = 340, .external_lex_state = 21},
  [4317] = {.lex_state = 340, .external_lex_state = 21},
  [4318] = {.lex_state = 92, .external_lex_state = 29},
  [4319] = {.lex_state = 92, .external_lex_state = 18},
  [4320] = {.lex_state = 92, .external_lex_state = 18},
  [4321] = {.lex_state = 262, .external_lex_state = 18},
  [4322] = {.lex_state = 340, .external_lex_state = 21},
  [4323] = {.lex_state = 262, .external_lex_state = 18},
  [4324] = {.lex_state = 262, .external_lex_state = 18},
  [4325] = {.lex_state = 262, .external_lex_state = 18},
  [4326] = {.lex_state = 340, .external_lex_state = 21},
  [4327] = {.lex_state = 262, .external_lex_state = 18},
  [4328] = {.lex_state = 340, .external_lex_state = 6},
  [4329] = {.lex_state = 340, .external_lex_state = 6},
  [4330] = {.lex_state = 92, .external_lex_state = 29},
  [4331] = {.lex_state = 92, .external_lex_state = 18},
  [4332] = {.lex_state = 92, .external_lex_state = 18},
  [4333] = {.lex_state = 262, .external_lex_state = 18},
  [4334] = {.lex_state = 340, .external_lex_state = 6},
  [4335] = {.lex_state = 262, .external_lex_state = 18},
  [4336] = {.lex_state = 262, .external_lex_state = 18},
  [4337] = {.lex_state = 262, .external_lex_state = 18},
  [4338] = {.lex_state = 340, .external_lex_state = 6},
  [4339] = {.lex_state = 262, .external_lex_state = 18},
  [4340] = {.lex_state = 346, .external_lex_state = 6},
  [4341] = {.lex_state = 346, .external_lex_state = 6},
  [4342] = {.lex_state = 346, .external_lex_state = 6},
  [4343] = {.lex_state = 262, .external_lex_state = 18},
  [4344] = {.lex_state = 262, .external_lex_state = 18},
  [4345] = {.lex_state = 346, .external_lex_state = 6},
  [4346] = {.lex_state = 326, .external_lex_state = 21},
  [4347] = {.lex_state = 326, .external_lex_state = 21},
  [4348] = {.lex_state = 350, .external_lex_state = 21},
  [4349] = {.lex_state = 350, .external_lex_state = 21},
  [4350] = {.lex_state = 92, .external_lex_state = 29},
  [4351] = {.lex_state = 92, .external_lex_state = 18},
  [4352] = {.lex_state = 92, .external_lex_state = 18},
  [4353] = {.lex_state = 262, .external_lex_state = 18},
  [4354] = {.lex_state = 350, .external_lex_state = 21},
  [4355] = {.lex_state = 262, .external_lex_state = 18},
  [4356] = {.lex_state = 262, .external_lex_state = 18},
  [4357] = {.lex_state = 262, .external_lex_state = 18},
  [4358] = {.lex_state = 350, .external_lex_state = 21},
  [4359] = {.lex_state = 262, .external_lex_state = 18},
  [4360] = {.lex_state = 340, .external_lex_state = 21},
  [4361] = {.lex_state = 340, .external_lex_state = 21},
  [4362] = {.lex_state = 340, .external_lex_state = 21},
  [4363] = {.lex_state = 262, .external_lex_state = 18},
  [4364] = {.lex_state = 262, .external_lex_state = 18},
  [4365] = {.lex_state = 340, .external_lex_state = 21},
  [4366] = {.lex_state = 340, .external_lex_state = 6},
  [4367] = {.lex_state = 340, .external_lex_state = 6},
  [4368] = {.lex_state = 340, .external_lex_state = 6},
  [4369] = {.lex_state = 262, .external_lex_state = 18},
  [4370] = {.lex_state = 262, .external_lex_state = 18},
  [4371] = {.lex_state = 340, .external_lex_state = 6},
  [4372] = {.lex_state = 346, .external_lex_state = 6},
  [4373] = {.lex_state = 346, .external_lex_state = 6},
  [4374] = {.lex_state = 350, .external_lex_state = 21},
  [4375] = {.lex_state = 350, .external_lex_state = 21},
  [4376] = {.lex_state = 350, .external_lex_state = 21},
  [4377] = {.lex_state = 262, .external_lex_state = 18},
  [4378] = {.lex_state = 262, .external_lex_state = 18},
  [4379] = {.lex_state = 350, .external_lex_state = 21},
  [4380] = {.lex_state = 340, .external_lex_state = 21},
  [4381] = {.lex_state = 340, .external_lex_state = 21},
  [4382] = {.lex_state = 340, .external_lex_state = 6},
  [4383] = {.lex_state = 340, .external_lex_state = 6},
  [4384] = {.lex_state = 350, .external_lex_state = 21},
  [4385] = {.lex_state = 350, .external_lex_state = 21},
};

enum {
  ts_external_token_heredoc_start,
  ts_external_token__simple_heredoc_body,
  ts_external_token__heredoc_body_beginning,
  ts_external_token__heredoc_body_middle,
  ts_external_token__heredoc_body_end,
  ts_external_token_file_descriptor,
  ts_external_token__empty_value,
  ts_external_token__concat,
  ts_external_token_variable_name,
  ts_external_token_regex,
  ts_external_token_RBRACE,
  ts_external_token_RBRACK,
  ts_external_token_LT_LT,
  ts_external_token_LT_LT_DASH,
  ts_external_token_LF,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_heredoc_start] = sym_heredoc_start,
  [ts_external_token__simple_heredoc_body] = sym__simple_heredoc_body,
  [ts_external_token__heredoc_body_beginning] = sym__heredoc_body_beginning,
  [ts_external_token__heredoc_body_middle] = sym__heredoc_body_middle,
  [ts_external_token__heredoc_body_end] = sym__heredoc_body_end,
  [ts_external_token_file_descriptor] = sym_file_descriptor,
  [ts_external_token__empty_value] = sym__empty_value,
  [ts_external_token__concat] = sym__concat,
  [ts_external_token_variable_name] = sym_variable_name,
  [ts_external_token_regex] = sym_regex,
  [ts_external_token_RBRACE] = anon_sym_RBRACE,
  [ts_external_token_RBRACK] = anon_sym_RBRACK,
  [ts_external_token_LT_LT] = anon_sym_LT_LT,
  [ts_external_token_LT_LT_DASH] = anon_sym_LT_LT_DASH,
  [ts_external_token_LF] = anon_sym_LF,
};

static bool ts_external_scanner_states[31][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_heredoc_start] = true,
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token__heredoc_body_middle] = true,
    [ts_external_token__heredoc_body_end] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__empty_value] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_regex] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_RBRACK] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [2] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
  },
  [3] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
  },
  [4] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [5] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [6] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [7] = {
    [ts_external_token_variable_name] = true,
  },
  [8] = {
    [ts_external_token__empty_value] = true,
  },
  [9] = {
    [ts_external_token_LF] = true,
  },
  [10] = {
    [ts_external_token__concat] = true,
  },
  [11] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [12] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [13] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [14] = {
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [15] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [16] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [17] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [18] = {
    [ts_external_token_RBRACE] = true,
  },
  [19] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACK] = true,
  },
  [20] = {
    [ts_external_token_RBRACK] = true,
  },
  [21] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [22] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
  [23] = {
    [ts_external_token__heredoc_body_middle] = true,
    [ts_external_token__heredoc_body_end] = true,
  },
  [24] = {
    [ts_external_token_heredoc_start] = true,
  },
  [25] = {
    [ts_external_token_regex] = true,
  },
  [26] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [27] = {
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_LF] = true,
  },
  [28] = {
    [ts_external_token_RBRACE] = true,
    [ts_external_token_LF] = true,
  },
  [29] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACE] = true,
  },
  [30] = {
    [ts_external_token_regex] = true,
    [ts_external_token_RBRACE] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_heredoc_start] = ACTIONS(1),
    [sym__simple_heredoc_body] = ACTIONS(1),
    [sym__heredoc_body_beginning] = ACTIONS(1),
    [sym__heredoc_body_middle] = ACTIONS(1),
    [sym__heredoc_body_end] = ACTIONS(1),
    [sym_file_descriptor] = ACTIONS(1),
    [sym__empty_value] = ACTIONS(1),
    [sym__concat] = ACTIONS(1),
    [sym_variable_name] = ACTIONS(1),
    [sym_regex] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_fi] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_esac] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_SEMI_SEMI] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_PIPE_AMP] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(3),
    [anon_sym_RBRACK] = ACTIONS(3),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_typeset] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_local] = ACTIONS(1),
    [anon_sym_unset] = ACTIONS(3),
    [anon_sym_unsetenv] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_AMP_GT] = ACTIONS(3),
    [anon_sym_AMP_GT_GT] = ACTIONS(1),
    [anon_sym_LT_AMP] = ACTIONS(1),
    [anon_sym_GT_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_LT_LT_DASH] = ACTIONS(1),
    [anon_sym_LT_LT_LT] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(3),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [sym__special_character] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(3),
    [sym_raw_string] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(3),
    [anon_sym_COLON_QMARK] = ACTIONS(1),
    [anon_sym_COLON_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_LT_LPAREN] = ACTIONS(1),
    [anon_sym_GT_LPAREN] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_0] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [sym_test_operator] = ACTIONS(1),
    [anon_sym_LF] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(3),
  },
  [1] = {
    [sym_program] = STATE(27),
    [sym__statements] = STATE(28),
    [sym_redirected_statement] = STATE(29),
    [sym_for_statement] = STATE(29),
    [sym_c_style_for_statement] = STATE(29),
    [sym_while_statement] = STATE(29),
    [sym_if_statement] = STATE(29),
    [sym_case_statement] = STATE(29),
    [sym_function_definition] = STATE(29),
    [sym_compound_statement] = STATE(29),
    [sym_subshell] = STATE(29),
    [sym_pipeline] = STATE(29),
    [sym_list] = STATE(29),
    [sym_negated_command] = STATE(29),
    [sym_test_command] = STATE(29),
    [sym_declaration_command] = STATE(29),
    [sym_unset_command] = STATE(29),
    [sym_command] = STATE(29),
    [sym_command_name] = STATE(30),
    [sym_variable_assignment] = STATE(31),
    [sym_subscript] = STATE(32),
    [sym_file_redirect] = STATE(35),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym__statements_repeat1] = STATE(34),
    [aux_sym_command_repeat1] = STATE(35),
    [aux_sym__literal_repeat1] = STATE(36),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [ts_builtin_sym_end] = ACTIONS(9),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(33),
    [anon_sym_typeset] = ACTIONS(33),
    [anon_sym_export] = ACTIONS(33),
    [anon_sym_readonly] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym_unset] = ACTIONS(35),
    [anon_sym_unsetenv] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(41),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(59),
  },
  [2] = {
    [anon_sym_LT] = ACTIONS(61),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_GT_GT] = ACTIONS(63),
    [anon_sym_AMP_GT] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(63),
    [anon_sym_LT_AMP] = ACTIONS(63),
    [anon_sym_GT_AMP] = ACTIONS(63),
    [sym_comment] = ACTIONS(57),
  },
  [3] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(67),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [sym_comment] = ACTIONS(57),
  },
  [4] = {
    [anon_sym_LPAREN_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(71),
  },
  [5] = {
    [sym__expression] = STATE(52),
    [sym_binary_expression] = STATE(52),
    [sym_unary_expression] = STATE(52),
    [sym_postfix_expression] = STATE(52),
    [sym_parenthesized_expression] = STATE(52),
    [sym_concatenation] = STATE(52),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_character] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [6] = {
    [sym__terminated_statement] = STATE(77),
    [sym_redirected_statement] = STATE(78),
    [sym_for_statement] = STATE(78),
    [sym_c_style_for_statement] = STATE(78),
    [sym_while_statement] = STATE(78),
    [sym_if_statement] = STATE(78),
    [sym_case_statement] = STATE(78),
    [sym_function_definition] = STATE(78),
    [sym_compound_statement] = STATE(78),
    [sym_subshell] = STATE(78),
    [sym_pipeline] = STATE(78),
    [sym_list] = STATE(78),
    [sym_negated_command] = STATE(78),
    [sym_test_command] = STATE(78),
    [sym_declaration_command] = STATE(78),
    [sym_unset_command] = STATE(78),
    [sym_command] = STATE(78),
    [sym_command_name] = STATE(79),
    [sym_variable_assignment] = STATE(80),
    [sym_subscript] = STATE(81),
    [sym_file_redirect] = STATE(83),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat1] = STATE(83),
    [aux_sym__literal_repeat1] = STATE(84),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [7] = {
    [sym__terminated_statement] = STATE(85),
    [sym_redirected_statement] = STATE(78),
    [sym_for_statement] = STATE(78),
    [sym_c_style_for_statement] = STATE(78),
    [sym_while_statement] = STATE(78),
    [sym_if_statement] = STATE(78),
    [sym_case_statement] = STATE(78),
    [sym_function_definition] = STATE(78),
    [sym_compound_statement] = STATE(78),
    [sym_subshell] = STATE(78),
    [sym_pipeline] = STATE(78),
    [sym_list] = STATE(78),
    [sym_negated_command] = STATE(78),
    [sym_test_command] = STATE(78),
    [sym_declaration_command] = STATE(78),
    [sym_unset_command] = STATE(78),
    [sym_command] = STATE(78),
    [sym_command_name] = STATE(79),
    [sym_variable_assignment] = STATE(80),
    [sym_subscript] = STATE(81),
    [sym_file_redirect] = STATE(83),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat1] = STATE(83),
    [aux_sym__literal_repeat1] = STATE(84),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [8] = {
    [sym_concatenation] = STATE(94),
    [sym_string] = STATE(89),
    [sym_simple_expansion] = STATE(89),
    [sym_string_expansion] = STATE(89),
    [sym_expansion] = STATE(89),
    [sym_command_substitution] = STATE(89),
    [sym_process_substitution] = STATE(89),
    [aux_sym__literal_repeat1] = STATE(95),
    [sym__special_character] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [anon_sym_DOLLAR] = ACTIONS(147),
    [sym_raw_string] = ACTIONS(149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_LT_LPAREN] = ACTIONS(157),
    [anon_sym_GT_LPAREN] = ACTIONS(157),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(149),
  },
  [9] = {
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(159),
  },
  [10] = {
    [sym__statements] = STATE(104),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [11] = {
    [sym__statements] = STATE(136),
    [sym_redirected_statement] = STATE(137),
    [sym_for_statement] = STATE(137),
    [sym_c_style_for_statement] = STATE(137),
    [sym_while_statement] = STATE(137),
    [sym_if_statement] = STATE(137),
    [sym_case_statement] = STATE(137),
    [sym_function_definition] = STATE(137),
    [sym_compound_statement] = STATE(137),
    [sym_subshell] = STATE(137),
    [sym_pipeline] = STATE(137),
    [sym_list] = STATE(137),
    [sym_negated_command] = STATE(137),
    [sym_test_command] = STATE(137),
    [sym_declaration_command] = STATE(137),
    [sym_unset_command] = STATE(137),
    [sym_command] = STATE(137),
    [sym_command_name] = STATE(138),
    [sym_variable_assignment] = STATE(139),
    [sym_subscript] = STATE(140),
    [sym_file_redirect] = STATE(143),
    [sym_concatenation] = STATE(141),
    [sym_string] = STATE(130),
    [sym_simple_expansion] = STATE(130),
    [sym_string_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [sym_process_substitution] = STATE(130),
    [aux_sym__statements_repeat1] = STATE(142),
    [aux_sym_command_repeat1] = STATE(143),
    [aux_sym__literal_repeat1] = STATE(144),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_case] = ACTIONS(185),
    [anon_sym_function] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(193),
    [anon_sym_BANG] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(199),
    [anon_sym_declare] = ACTIONS(201),
    [anon_sym_typeset] = ACTIONS(201),
    [anon_sym_export] = ACTIONS(201),
    [anon_sym_readonly] = ACTIONS(201),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_unset] = ACTIONS(203),
    [anon_sym_unsetenv] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(221),
  },
  [12] = {
    [sym_subshell] = STATE(146),
    [sym_test_command] = STATE(146),
    [sym_command] = STATE(146),
    [sym_command_name] = STATE(30),
    [sym_variable_assignment] = STATE(35),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(35),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym_command_repeat1] = STATE(35),
    [aux_sym__literal_repeat1] = STATE(36),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(41),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(47),
  },
  [13] = {
    [sym__expression] = STATE(158),
    [sym_binary_expression] = STATE(158),
    [sym_unary_expression] = STATE(158),
    [sym_postfix_expression] = STATE(158),
    [sym_parenthesized_expression] = STATE(158),
    [sym_concatenation] = STATE(158),
    [sym_string] = STATE(153),
    [sym_simple_expansion] = STATE(153),
    [sym_string_expansion] = STATE(153),
    [sym_expansion] = STATE(153),
    [sym_command_substitution] = STATE(153),
    [sym_process_substitution] = STATE(153),
    [aux_sym__literal_repeat1] = STATE(159),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_BANG] = ACTIONS(227),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(245),
    [sym_test_operator] = ACTIONS(247),
  },
  [14] = {
    [sym__expression] = STATE(163),
    [sym_binary_expression] = STATE(163),
    [sym_unary_expression] = STATE(163),
    [sym_postfix_expression] = STATE(163),
    [sym_parenthesized_expression] = STATE(163),
    [sym_concatenation] = STATE(163),
    [sym_string] = STATE(162),
    [sym_simple_expansion] = STATE(162),
    [sym_string_expansion] = STATE(162),
    [sym_expansion] = STATE(162),
    [sym_command_substitution] = STATE(162),
    [sym_process_substitution] = STATE(162),
    [aux_sym__literal_repeat1] = STATE(164),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(249),
    [sym__special_character] = ACTIONS(251),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(255),
    [sym_test_operator] = ACTIONS(257),
  },
  [15] = {
    [sym_variable_assignment] = STATE(175),
    [sym_subscript] = STATE(174),
    [sym_concatenation] = STATE(175),
    [sym_string] = STATE(169),
    [sym_simple_expansion] = STATE(169),
    [sym_string_expansion] = STATE(169),
    [sym_expansion] = STATE(169),
    [sym_command_substitution] = STATE(169),
    [sym_process_substitution] = STATE(169),
    [aux_sym_declaration_command_repeat1] = STATE(175),
    [aux_sym__literal_repeat1] = STATE(176),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(261),
    [ts_builtin_sym_end] = ACTIONS(259),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [sym__special_character] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(281),
    [sym_word] = ACTIONS(283),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [16] = {
    [sym_concatenation] = STATE(185),
    [sym_string] = STATE(180),
    [sym_simple_expansion] = STATE(180),
    [sym_string_expansion] = STATE(180),
    [sym_expansion] = STATE(180),
    [sym_command_substitution] = STATE(180),
    [sym_process_substitution] = STATE(180),
    [aux_sym_unset_command_repeat1] = STATE(185),
    [aux_sym__literal_repeat1] = STATE(186),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [ts_builtin_sym_end] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [sym__special_character] = ACTIONS(289),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_DOLLAR] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(305),
    [sym_word] = ACTIONS(307),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [17] = {
    [sym_concatenation] = STATE(195),
    [sym_string] = STATE(190),
    [sym_simple_expansion] = STATE(190),
    [sym_string_expansion] = STATE(190),
    [sym_expansion] = STATE(190),
    [sym_command_substitution] = STATE(190),
    [sym_process_substitution] = STATE(190),
    [aux_sym__literal_repeat1] = STATE(196),
    [sym__special_character] = ACTIONS(309),
    [anon_sym_DQUOTE] = ACTIONS(311),
    [anon_sym_DOLLAR] = ACTIONS(313),
    [sym_raw_string] = ACTIONS(315),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(319),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(315),
  },
  [18] = {
    [aux_sym_concatenation_repeat1] = STATE(198),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [19] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(205),
    [anon_sym_DQUOTE] = ACTIONS(331),
    [anon_sym_DOLLAR] = ACTIONS(333),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [20] = {
    [sym_string] = STATE(207),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(345),
    [sym_raw_string] = ACTIONS(347),
    [anon_sym_POUND] = ACTIONS(345),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(349),
    [anon_sym_STAR] = ACTIONS(351),
    [anon_sym_AT] = ACTIONS(351),
    [anon_sym_QMARK] = ACTIONS(351),
    [anon_sym_0] = ACTIONS(349),
    [anon_sym__] = ACTIONS(349),
  },
  [21] = {
    [aux_sym_concatenation_repeat1] = STATE(198),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [22] = {
    [sym_subscript] = STATE(212),
    [sym_variable_name] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(359),
    [anon_sym_DASH] = ACTIONS(361),
    [anon_sym_DOLLAR] = ACTIONS(361),
    [anon_sym_POUND] = ACTIONS(359),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(365),
    [anon_sym_AT] = ACTIONS(365),
    [anon_sym_QMARK] = ACTIONS(365),
    [anon_sym_0] = ACTIONS(363),
    [anon_sym__] = ACTIONS(363),
  },
  [23] = {
    [sym__statements] = STATE(215),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(216),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [24] = {
    [sym__statements] = STATE(224),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [25] = {
    [sym__statements] = STATE(232),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [26] = {
    [aux_sym_concatenation_repeat1] = STATE(198),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [27] = {
    [ts_builtin_sym_end] = ACTIONS(389),
    [sym_comment] = ACTIONS(57),
  },
  [28] = {
    [ts_builtin_sym_end] = ACTIONS(391),
    [sym_comment] = ACTIONS(57),
  },
  [29] = {
    [sym_file_redirect] = STATE(244),
    [sym_heredoc_redirect] = STATE(244),
    [sym_heredoc_body] = STATE(243),
    [sym_herestring_redirect] = STATE(244),
    [aux_sym_redirected_statement_repeat1] = STATE(244),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(397),
    [ts_builtin_sym_end] = ACTIONS(399),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(403),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(413),
    [anon_sym_AMP_GT] = ACTIONS(411),
    [anon_sym_AMP_GT_GT] = ACTIONS(413),
    [anon_sym_LT_AMP] = ACTIONS(413),
    [anon_sym_GT_AMP] = ACTIONS(413),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(419),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(401),
  },
  [30] = {
    [sym_concatenation] = STATE(247),
    [sym_string] = STATE(246),
    [sym_simple_expansion] = STATE(246),
    [sym_string_expansion] = STATE(246),
    [sym_expansion] = STATE(246),
    [sym_command_substitution] = STATE(246),
    [sym_process_substitution] = STATE(246),
    [aux_sym_command_repeat2] = STATE(247),
    [aux_sym__literal_repeat1] = STATE(248),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [ts_builtin_sym_end] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [sym__special_character] = ACTIONS(427),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(431),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [31] = {
    [sym_file_redirect] = STATE(244),
    [sym_heredoc_redirect] = STATE(244),
    [sym_heredoc_body] = STATE(243),
    [sym_herestring_redirect] = STATE(244),
    [aux_sym_redirected_statement_repeat1] = STATE(244),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [ts_builtin_sym_end] = ACTIONS(399),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(403),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(419),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(401),
  },
  [32] = {
    [anon_sym_EQ] = ACTIONS(67),
    [anon_sym_PLUS_EQ] = ACTIONS(67),
    [sym_comment] = ACTIONS(57),
  },
  [33] = {
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [ts_builtin_sym_end] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_RPAREN] = ACTIONS(353),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [34] = {
    [sym_redirected_statement] = STATE(249),
    [sym_for_statement] = STATE(249),
    [sym_c_style_for_statement] = STATE(249),
    [sym_while_statement] = STATE(249),
    [sym_if_statement] = STATE(249),
    [sym_case_statement] = STATE(249),
    [sym_function_definition] = STATE(249),
    [sym_compound_statement] = STATE(249),
    [sym_subshell] = STATE(249),
    [sym_pipeline] = STATE(249),
    [sym_list] = STATE(249),
    [sym_negated_command] = STATE(249),
    [sym_test_command] = STATE(249),
    [sym_declaration_command] = STATE(249),
    [sym_unset_command] = STATE(249),
    [sym_command] = STATE(249),
    [sym_command_name] = STATE(30),
    [sym_variable_assignment] = STATE(250),
    [sym_subscript] = STATE(32),
    [sym_file_redirect] = STATE(35),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym__statements_repeat1] = STATE(251),
    [aux_sym_command_repeat1] = STATE(35),
    [aux_sym__literal_repeat1] = STATE(36),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(33),
    [anon_sym_typeset] = ACTIONS(33),
    [anon_sym_export] = ACTIONS(33),
    [anon_sym_readonly] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym_unset] = ACTIONS(35),
    [anon_sym_unsetenv] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(41),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(59),
  },
  [35] = {
    [sym_command_name] = STATE(252),
    [sym_variable_assignment] = STATE(253),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(253),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym_command_repeat1] = STATE(253),
    [aux_sym__literal_repeat1] = STATE(36),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(427),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(47),
  },
  [36] = {
    [aux_sym__literal_repeat1] = STATE(255),
    [sym__simple_heredoc_body] = ACTIONS(437),
    [sym__heredoc_body_beginning] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(437),
    [ts_builtin_sym_end] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_EQ_TILDE] = ACTIONS(439),
    [anon_sym_EQ_EQ] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(439),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(439),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [anon_sym_DOLLAR] = ACTIONS(439),
    [sym_raw_string] = ACTIONS(437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(437),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(437),
    [anon_sym_GT_LPAREN] = ACTIONS(437),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(439),
    [anon_sym_LF] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(439),
  },
  [37] = {
    [sym_concatenation] = STATE(257),
    [sym_string] = STATE(256),
    [sym_simple_expansion] = STATE(256),
    [sym_string_expansion] = STATE(256),
    [sym_expansion] = STATE(256),
    [sym_command_substitution] = STATE(256),
    [sym_process_substitution] = STATE(256),
    [aux_sym__literal_repeat1] = STATE(258),
    [sym__special_character] = ACTIONS(309),
    [anon_sym_DQUOTE] = ACTIONS(311),
    [anon_sym_DOLLAR] = ACTIONS(313),
    [sym_raw_string] = ACTIONS(443),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(319),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(443),
  },
  [38] = {
    [sym_concatenation] = STATE(261),
    [sym_string] = STATE(260),
    [sym_simple_expansion] = STATE(260),
    [sym_string_expansion] = STATE(260),
    [sym_expansion] = STATE(260),
    [sym_command_substitution] = STATE(260),
    [sym_process_substitution] = STATE(260),
    [aux_sym__literal_repeat1] = STATE(262),
    [sym__special_character] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(447),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(447),
  },
  [39] = {
    [sym_concatenation] = STATE(263),
    [sym_string] = STATE(268),
    [sym_array] = STATE(263),
    [sym_simple_expansion] = STATE(268),
    [sym_string_expansion] = STATE(268),
    [sym_expansion] = STATE(268),
    [sym_command_substitution] = STATE(268),
    [sym_process_substitution] = STATE(268),
    [aux_sym__literal_repeat1] = STATE(273),
    [sym__empty_value] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [sym__special_character] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(463),
    [anon_sym_BQUOTE] = ACTIONS(465),
    [anon_sym_LT_LPAREN] = ACTIONS(467),
    [anon_sym_GT_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(459),
  },
  [40] = {
    [sym__expression] = STATE(285),
    [sym_binary_expression] = STATE(285),
    [sym_unary_expression] = STATE(285),
    [sym_postfix_expression] = STATE(285),
    [sym_parenthesized_expression] = STATE(285),
    [sym_concatenation] = STATE(285),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(471),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [sym__special_character] = ACTIONS(477),
    [anon_sym_DQUOTE] = ACTIONS(479),
    [anon_sym_DOLLAR] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
    [anon_sym_LF] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(471),
  },
  [41] = {
    [anon_sym_in] = ACTIONS(497),
    [anon_sym_SEMI] = ACTIONS(499),
    [anon_sym_SEMI_SEMI] = ACTIONS(501),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(501),
  },
  [42] = {
    [sym__expression] = STATE(299),
    [sym_binary_expression] = STATE(299),
    [sym_unary_expression] = STATE(299),
    [sym_postfix_expression] = STATE(299),
    [sym_parenthesized_expression] = STATE(299),
    [sym_concatenation] = STATE(299),
    [sym_string] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [sym_expansion] = STATE(294),
    [sym_command_substitution] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(300),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_BANG] = ACTIONS(505),
    [sym__special_character] = ACTIONS(507),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(523),
    [sym_test_operator] = ACTIONS(525),
  },
  [43] = {
    [sym__expression] = STATE(301),
    [sym_binary_expression] = STATE(301),
    [sym_unary_expression] = STATE(301),
    [sym_postfix_expression] = STATE(301),
    [sym_parenthesized_expression] = STATE(301),
    [sym_concatenation] = STATE(301),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_character] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [44] = {
    [aux_sym_concatenation_repeat1] = STATE(303),
    [sym__concat] = ACTIONS(527),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(325),
    [anon_sym_EQ_EQ] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_PLUS_EQ] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_BANG_EQ] = ACTIONS(325),
    [anon_sym_PLUS] = ACTIONS(329),
    [anon_sym_DASH] = ACTIONS(329),
    [anon_sym_DASH_EQ] = ACTIONS(325),
    [anon_sym_LT_EQ] = ACTIONS(325),
    [anon_sym_GT_EQ] = ACTIONS(325),
    [anon_sym_PLUS_PLUS] = ACTIONS(325),
    [anon_sym_DASH_DASH] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(325),
  },
  [45] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(306),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_DOLLAR] = ACTIONS(531),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [46] = {
    [sym_string] = STATE(308),
    [anon_sym_DASH] = ACTIONS(533),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(533),
    [sym_raw_string] = ACTIONS(535),
    [anon_sym_POUND] = ACTIONS(533),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(537),
    [anon_sym_STAR] = ACTIONS(539),
    [anon_sym_AT] = ACTIONS(539),
    [anon_sym_QMARK] = ACTIONS(539),
    [anon_sym_0] = ACTIONS(537),
    [anon_sym__] = ACTIONS(537),
  },
  [47] = {
    [aux_sym_concatenation_repeat1] = STATE(303),
    [sym__concat] = ACTIONS(527),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(541),
    [anon_sym_AMP_AMP] = ACTIONS(541),
    [anon_sym_PIPE_PIPE] = ACTIONS(541),
    [anon_sym_EQ_TILDE] = ACTIONS(541),
    [anon_sym_EQ_EQ] = ACTIONS(541),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_PLUS_EQ] = ACTIONS(541),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_BANG_EQ] = ACTIONS(541),
    [anon_sym_PLUS] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(543),
    [anon_sym_DASH_EQ] = ACTIONS(541),
    [anon_sym_LT_EQ] = ACTIONS(541),
    [anon_sym_GT_EQ] = ACTIONS(541),
    [anon_sym_PLUS_PLUS] = ACTIONS(541),
    [anon_sym_DASH_DASH] = ACTIONS(541),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(541),
  },
  [48] = {
    [sym_subscript] = STATE(313),
    [sym_variable_name] = ACTIONS(545),
    [anon_sym_BANG] = ACTIONS(547),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_DOLLAR] = ACTIONS(549),
    [anon_sym_POUND] = ACTIONS(547),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(551),
    [anon_sym_STAR] = ACTIONS(553),
    [anon_sym_AT] = ACTIONS(553),
    [anon_sym_QMARK] = ACTIONS(553),
    [anon_sym_0] = ACTIONS(551),
    [anon_sym__] = ACTIONS(551),
  },
  [49] = {
    [sym__statements] = STATE(314),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(315),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [50] = {
    [sym__statements] = STATE(316),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [51] = {
    [sym__statements] = STATE(317),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [52] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(555),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [53] = {
    [aux_sym__literal_repeat1] = STATE(323),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(565),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_EQ_EQ] = ACTIONS(565),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(565),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym__special_character] = ACTIONS(569),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(565),
  },
  [54] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [sym_comment] = ACTIONS(57),
  },
  [55] = {
    [anon_sym_LPAREN_LPAREN] = ACTIONS(573),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(575),
  },
  [56] = {
    [sym__expression] = STATE(327),
    [sym_binary_expression] = STATE(327),
    [sym_unary_expression] = STATE(327),
    [sym_postfix_expression] = STATE(327),
    [sym_parenthesized_expression] = STATE(327),
    [sym_concatenation] = STATE(327),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_character] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [57] = {
    [sym__terminated_statement] = STATE(328),
    [sym_redirected_statement] = STATE(78),
    [sym_for_statement] = STATE(78),
    [sym_c_style_for_statement] = STATE(78),
    [sym_while_statement] = STATE(78),
    [sym_if_statement] = STATE(78),
    [sym_case_statement] = STATE(78),
    [sym_function_definition] = STATE(78),
    [sym_compound_statement] = STATE(78),
    [sym_subshell] = STATE(78),
    [sym_pipeline] = STATE(78),
    [sym_list] = STATE(78),
    [sym_negated_command] = STATE(78),
    [sym_test_command] = STATE(78),
    [sym_declaration_command] = STATE(78),
    [sym_unset_command] = STATE(78),
    [sym_command] = STATE(78),
    [sym_command_name] = STATE(79),
    [sym_variable_assignment] = STATE(80),
    [sym_subscript] = STATE(81),
    [sym_file_redirect] = STATE(83),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat1] = STATE(83),
    [aux_sym__literal_repeat1] = STATE(84),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [58] = {
    [sym__terminated_statement] = STATE(329),
    [sym_redirected_statement] = STATE(78),
    [sym_for_statement] = STATE(78),
    [sym_c_style_for_statement] = STATE(78),
    [sym_while_statement] = STATE(78),
    [sym_if_statement] = STATE(78),
    [sym_case_statement] = STATE(78),
    [sym_function_definition] = STATE(78),
    [sym_compound_statement] = STATE(78),
    [sym_subshell] = STATE(78),
    [sym_pipeline] = STATE(78),
    [sym_list] = STATE(78),
    [sym_negated_command] = STATE(78),
    [sym_test_command] = STATE(78),
    [sym_declaration_command] = STATE(78),
    [sym_unset_command] = STATE(78),
    [sym_command] = STATE(78),
    [sym_command_name] = STATE(79),
    [sym_variable_assignment] = STATE(80),
    [sym_subscript] = STATE(81),
    [sym_file_redirect] = STATE(83),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat1] = STATE(83),
    [aux_sym__literal_repeat1] = STATE(84),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [59] = {
    [sym_concatenation] = STATE(331),
    [sym_string] = STATE(330),
    [sym_simple_expansion] = STATE(330),
    [sym_string_expansion] = STATE(330),
    [sym_expansion] = STATE(330),
    [sym_command_substitution] = STATE(330),
    [sym_process_substitution] = STATE(330),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym__special_character] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [anon_sym_DOLLAR] = ACTIONS(147),
    [sym_raw_string] = ACTIONS(577),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_LT_LPAREN] = ACTIONS(157),
    [anon_sym_GT_LPAREN] = ACTIONS(157),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(577),
  },
  [60] = {
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(579),
  },
  [61] = {
    [sym__statements] = STATE(334),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [62] = {
    [sym__statements] = STATE(336),
    [sym_redirected_statement] = STATE(137),
    [sym_for_statement] = STATE(137),
    [sym_c_style_for_statement] = STATE(137),
    [sym_while_statement] = STATE(137),
    [sym_if_statement] = STATE(137),
    [sym_case_statement] = STATE(137),
    [sym_function_definition] = STATE(137),
    [sym_compound_statement] = STATE(137),
    [sym_subshell] = STATE(137),
    [sym_pipeline] = STATE(137),
    [sym_list] = STATE(137),
    [sym_negated_command] = STATE(137),
    [sym_test_command] = STATE(137),
    [sym_declaration_command] = STATE(137),
    [sym_unset_command] = STATE(137),
    [sym_command] = STATE(137),
    [sym_command_name] = STATE(138),
    [sym_variable_assignment] = STATE(139),
    [sym_subscript] = STATE(140),
    [sym_file_redirect] = STATE(143),
    [sym_concatenation] = STATE(141),
    [sym_string] = STATE(130),
    [sym_simple_expansion] = STATE(130),
    [sym_string_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [sym_process_substitution] = STATE(130),
    [aux_sym__statements_repeat1] = STATE(142),
    [aux_sym_command_repeat1] = STATE(143),
    [aux_sym__literal_repeat1] = STATE(144),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_case] = ACTIONS(185),
    [anon_sym_function] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(581),
    [anon_sym_BANG] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(199),
    [anon_sym_declare] = ACTIONS(201),
    [anon_sym_typeset] = ACTIONS(201),
    [anon_sym_export] = ACTIONS(201),
    [anon_sym_readonly] = ACTIONS(201),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_unset] = ACTIONS(203),
    [anon_sym_unsetenv] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(221),
  },
  [63] = {
    [sym_subshell] = STATE(337),
    [sym_test_command] = STATE(337),
    [sym_command] = STATE(337),
    [sym_command_name] = STATE(79),
    [sym_variable_assignment] = STATE(83),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(83),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat1] = STATE(83),
    [aux_sym__literal_repeat1] = STATE(84),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(131),
  },
  [64] = {
    [sym__expression] = STATE(338),
    [sym_binary_expression] = STATE(338),
    [sym_unary_expression] = STATE(338),
    [sym_postfix_expression] = STATE(338),
    [sym_parenthesized_expression] = STATE(338),
    [sym_concatenation] = STATE(338),
    [sym_string] = STATE(153),
    [sym_simple_expansion] = STATE(153),
    [sym_string_expansion] = STATE(153),
    [sym_expansion] = STATE(153),
    [sym_command_substitution] = STATE(153),
    [sym_process_substitution] = STATE(153),
    [aux_sym__literal_repeat1] = STATE(159),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_BANG] = ACTIONS(227),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(245),
    [sym_test_operator] = ACTIONS(247),
  },
  [65] = {
    [sym__expression] = STATE(339),
    [sym_binary_expression] = STATE(339),
    [sym_unary_expression] = STATE(339),
    [sym_postfix_expression] = STATE(339),
    [sym_parenthesized_expression] = STATE(339),
    [sym_concatenation] = STATE(339),
    [sym_string] = STATE(162),
    [sym_simple_expansion] = STATE(162),
    [sym_string_expansion] = STATE(162),
    [sym_expansion] = STATE(162),
    [sym_command_substitution] = STATE(162),
    [sym_process_substitution] = STATE(162),
    [aux_sym__literal_repeat1] = STATE(164),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(249),
    [sym__special_character] = ACTIONS(251),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(255),
    [sym_test_operator] = ACTIONS(257),
  },
  [66] = {
    [sym_variable_assignment] = STATE(350),
    [sym_subscript] = STATE(349),
    [sym_concatenation] = STATE(350),
    [sym_string] = STATE(344),
    [sym_simple_expansion] = STATE(344),
    [sym_string_expansion] = STATE(344),
    [sym_expansion] = STATE(344),
    [sym_command_substitution] = STATE(344),
    [sym_process_substitution] = STATE(344),
    [aux_sym_declaration_command_repeat1] = STATE(350),
    [aux_sym__literal_repeat1] = STATE(351),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [sym__special_character] = ACTIONS(585),
    [anon_sym_DQUOTE] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(589),
    [sym_raw_string] = ACTIONS(591),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(593),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(595),
    [anon_sym_BQUOTE] = ACTIONS(597),
    [anon_sym_LT_LPAREN] = ACTIONS(599),
    [anon_sym_GT_LPAREN] = ACTIONS(599),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(601),
    [sym_word] = ACTIONS(603),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [67] = {
    [sym_concatenation] = STATE(360),
    [sym_string] = STATE(355),
    [sym_simple_expansion] = STATE(355),
    [sym_string_expansion] = STATE(355),
    [sym_expansion] = STATE(355),
    [sym_command_substitution] = STATE(355),
    [sym_process_substitution] = STATE(355),
    [aux_sym_unset_command_repeat1] = STATE(360),
    [aux_sym__literal_repeat1] = STATE(361),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [sym__special_character] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [sym_raw_string] = ACTIONS(611),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(615),
    [anon_sym_BQUOTE] = ACTIONS(617),
    [anon_sym_LT_LPAREN] = ACTIONS(619),
    [anon_sym_GT_LPAREN] = ACTIONS(619),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(621),
    [sym_word] = ACTIONS(623),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [68] = {
    [aux_sym_concatenation_repeat1] = STATE(363),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(625),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [69] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(366),
    [anon_sym_DQUOTE] = ACTIONS(627),
    [anon_sym_DOLLAR] = ACTIONS(629),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [70] = {
    [sym_string] = STATE(368),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(631),
    [sym_raw_string] = ACTIONS(633),
    [anon_sym_POUND] = ACTIONS(631),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(635),
    [anon_sym_STAR] = ACTIONS(637),
    [anon_sym_AT] = ACTIONS(637),
    [anon_sym_QMARK] = ACTIONS(637),
    [anon_sym_0] = ACTIONS(635),
    [anon_sym__] = ACTIONS(635),
  },
  [71] = {
    [aux_sym_concatenation_repeat1] = STATE(363),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(625),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [72] = {
    [sym_subscript] = STATE(373),
    [sym_variable_name] = ACTIONS(639),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_DOLLAR] = ACTIONS(643),
    [anon_sym_POUND] = ACTIONS(641),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(645),
    [anon_sym_STAR] = ACTIONS(647),
    [anon_sym_AT] = ACTIONS(647),
    [anon_sym_QMARK] = ACTIONS(647),
    [anon_sym_0] = ACTIONS(645),
    [anon_sym__] = ACTIONS(645),
  },
  [73] = {
    [sym__statements] = STATE(374),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(375),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [74] = {
    [sym__statements] = STATE(376),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [75] = {
    [sym__statements] = STATE(377),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [76] = {
    [aux_sym_concatenation_repeat1] = STATE(363),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(625),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(649),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [77] = {
    [sym_do_group] = STATE(380),
    [anon_sym_do] = ACTIONS(651),
    [sym_comment] = ACTIONS(57),
  },
  [78] = {
    [sym_file_redirect] = STATE(388),
    [sym_heredoc_redirect] = STATE(388),
    [sym_herestring_redirect] = STATE(388),
    [aux_sym_redirected_statement_repeat1] = STATE(388),
    [sym_file_descriptor] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(655),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_SEMI_SEMI] = ACTIONS(659),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_LT_LT] = ACTIONS(669),
    [anon_sym_LT_LT_DASH] = ACTIONS(671),
    [anon_sym_LT_LT_LT] = ACTIONS(673),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(655),
  },
  [79] = {
    [sym_concatenation] = STATE(391),
    [sym_string] = STATE(390),
    [sym_simple_expansion] = STATE(390),
    [sym_string_expansion] = STATE(390),
    [sym_expansion] = STATE(390),
    [sym_command_substitution] = STATE(390),
    [sym_process_substitution] = STATE(390),
    [aux_sym_command_repeat2] = STATE(391),
    [aux_sym__literal_repeat1] = STATE(392),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(675),
    [anon_sym_EQ_EQ] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [sym__special_character] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(679),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [80] = {
    [sym_file_redirect] = STATE(388),
    [sym_heredoc_redirect] = STATE(388),
    [sym_herestring_redirect] = STATE(388),
    [aux_sym_redirected_statement_repeat1] = STATE(388),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(655),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_SEMI_SEMI] = ACTIONS(659),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(663),
    [anon_sym_PIPE_PIPE] = ACTIONS(663),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(669),
    [anon_sym_LT_LT_DASH] = ACTIONS(671),
    [anon_sym_LT_LT_LT] = ACTIONS(673),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(659),
    [anon_sym_AMP] = ACTIONS(655),
  },
  [81] = {
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_PLUS_EQ] = ACTIONS(571),
    [sym_comment] = ACTIONS(57),
  },
  [82] = {
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [83] = {
    [sym_command_name] = STATE(393),
    [sym_variable_assignment] = STATE(253),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(253),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat1] = STATE(253),
    [aux_sym__literal_repeat1] = STATE(84),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(131),
  },
  [84] = {
    [aux_sym__literal_repeat1] = STATE(395),
    [sym_file_descriptor] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_EQ_TILDE] = ACTIONS(439),
    [anon_sym_EQ_EQ] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(439),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(439),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [sym__special_character] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [anon_sym_DOLLAR] = ACTIONS(439),
    [sym_raw_string] = ACTIONS(437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(437),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(437),
    [anon_sym_GT_LPAREN] = ACTIONS(437),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(439),
    [anon_sym_LF] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(439),
  },
  [85] = {
    [anon_sym_then] = ACTIONS(685),
    [sym_comment] = ACTIONS(57),
  },
  [86] = {
    [aux_sym_concatenation_repeat1] = STATE(398),
    [sym__concat] = ACTIONS(687),
    [anon_sym_in] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(325),
  },
  [87] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(401),
    [anon_sym_DQUOTE] = ACTIONS(689),
    [anon_sym_DOLLAR] = ACTIONS(691),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [88] = {
    [sym_string] = STATE(403),
    [anon_sym_DASH] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [anon_sym_DOLLAR] = ACTIONS(693),
    [sym_raw_string] = ACTIONS(695),
    [anon_sym_POUND] = ACTIONS(693),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(697),
    [anon_sym_STAR] = ACTIONS(699),
    [anon_sym_AT] = ACTIONS(699),
    [anon_sym_QMARK] = ACTIONS(699),
    [anon_sym_0] = ACTIONS(697),
    [anon_sym__] = ACTIONS(697),
  },
  [89] = {
    [aux_sym_concatenation_repeat1] = STATE(398),
    [sym__concat] = ACTIONS(687),
    [anon_sym_in] = ACTIONS(701),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_SEMI_SEMI] = ACTIONS(705),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(705),
  },
  [90] = {
    [sym_subscript] = STATE(410),
    [sym_variable_name] = ACTIONS(707),
    [anon_sym_BANG] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(711),
    [anon_sym_DOLLAR] = ACTIONS(711),
    [anon_sym_POUND] = ACTIONS(709),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(713),
    [anon_sym_STAR] = ACTIONS(715),
    [anon_sym_AT] = ACTIONS(715),
    [anon_sym_QMARK] = ACTIONS(715),
    [anon_sym_0] = ACTIONS(713),
    [anon_sym__] = ACTIONS(713),
  },
  [91] = {
    [sym__statements] = STATE(411),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(412),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [92] = {
    [sym__statements] = STATE(413),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [93] = {
    [sym__statements] = STATE(414),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [94] = {
    [anon_sym_in] = ACTIONS(701),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_SEMI_SEMI] = ACTIONS(705),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(705),
    [anon_sym_AMP] = ACTIONS(705),
  },
  [95] = {
    [aux_sym__literal_repeat1] = STATE(418),
    [anon_sym_in] = ACTIONS(717),
    [anon_sym_SEMI] = ACTIONS(719),
    [anon_sym_SEMI_SEMI] = ACTIONS(721),
    [sym__special_character] = ACTIONS(723),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(721),
    [anon_sym_AMP] = ACTIONS(721),
  },
  [96] = {
    [sym_compound_statement] = STATE(420),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [97] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(727),
    [anon_sym_PLUS_EQ] = ACTIONS(727),
    [sym_comment] = ACTIONS(57),
  },
  [98] = {
    [sym_subshell] = STATE(146),
    [sym_test_command] = STATE(146),
    [sym_command] = STATE(146),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(110),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(171),
  },
  [99] = {
    [sym_variable_assignment] = STATE(426),
    [sym_subscript] = STATE(425),
    [sym_concatenation] = STATE(426),
    [sym_string] = STATE(424),
    [sym_simple_expansion] = STATE(424),
    [sym_string_expansion] = STATE(424),
    [sym_expansion] = STATE(424),
    [sym_command_substitution] = STATE(424),
    [sym_process_substitution] = STATE(424),
    [aux_sym_declaration_command_repeat1] = STATE(426),
    [aux_sym__literal_repeat1] = STATE(427),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(729),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_RPAREN] = ACTIONS(259),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [sym__special_character] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(735),
    [sym_word] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [100] = {
    [sym_concatenation] = STATE(430),
    [sym_string] = STATE(429),
    [sym_simple_expansion] = STATE(429),
    [sym_string_expansion] = STATE(429),
    [sym_expansion] = STATE(429),
    [sym_command_substitution] = STATE(429),
    [sym_process_substitution] = STATE(429),
    [aux_sym_unset_command_repeat1] = STATE(430),
    [aux_sym__literal_repeat1] = STATE(431),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_RPAREN] = ACTIONS(285),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [sym__special_character] = ACTIONS(739),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_DOLLAR] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(741),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(743),
    [sym_word] = ACTIONS(745),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [101] = {
    [aux_sym_concatenation_repeat1] = STATE(432),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_RPAREN] = ACTIONS(325),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [102] = {
    [aux_sym_concatenation_repeat1] = STATE(432),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_RPAREN] = ACTIONS(353),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [103] = {
    [aux_sym_concatenation_repeat1] = STATE(432),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_RPAREN] = ACTIONS(353),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [104] = {
    [anon_sym_RPAREN] = ACTIONS(747),
    [sym_comment] = ACTIONS(57),
  },
  [105] = {
    [sym_file_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [sym_heredoc_body] = STATE(243),
    [sym_herestring_redirect] = STATE(439),
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(749),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(399),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(753),
    [anon_sym_AMP_AMP] = ACTIONS(755),
    [anon_sym_PIPE_PIPE] = ACTIONS(755),
    [anon_sym_LT] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(757),
    [anon_sym_GT_GT] = ACTIONS(759),
    [anon_sym_AMP_GT] = ACTIONS(757),
    [anon_sym_AMP_GT_GT] = ACTIONS(759),
    [anon_sym_LT_AMP] = ACTIONS(759),
    [anon_sym_GT_AMP] = ACTIONS(759),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(761),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(401),
  },
  [106] = {
    [sym_concatenation] = STATE(442),
    [sym_string] = STATE(441),
    [sym_simple_expansion] = STATE(441),
    [sym_string_expansion] = STATE(441),
    [sym_expansion] = STATE(441),
    [sym_command_substitution] = STATE(441),
    [sym_process_substitution] = STATE(441),
    [aux_sym_command_repeat2] = STATE(442),
    [aux_sym__literal_repeat1] = STATE(443),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_RPAREN] = ACTIONS(421),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(763),
    [anon_sym_EQ_EQ] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [sym__special_character] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(769),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [107] = {
    [sym_file_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [sym_heredoc_body] = STATE(243),
    [sym_herestring_redirect] = STATE(439),
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(399),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(753),
    [anon_sym_AMP_AMP] = ACTIONS(755),
    [anon_sym_PIPE_PIPE] = ACTIONS(755),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(761),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(401),
  },
  [108] = {
    [anon_sym_EQ] = ACTIONS(727),
    [anon_sym_PLUS_EQ] = ACTIONS(727),
    [sym_comment] = ACTIONS(57),
  },
  [109] = {
    [sym_redirected_statement] = STATE(444),
    [sym_for_statement] = STATE(444),
    [sym_c_style_for_statement] = STATE(444),
    [sym_while_statement] = STATE(444),
    [sym_if_statement] = STATE(444),
    [sym_case_statement] = STATE(444),
    [sym_function_definition] = STATE(444),
    [sym_compound_statement] = STATE(444),
    [sym_subshell] = STATE(444),
    [sym_pipeline] = STATE(444),
    [sym_list] = STATE(444),
    [sym_negated_command] = STATE(444),
    [sym_test_command] = STATE(444),
    [sym_declaration_command] = STATE(444),
    [sym_unset_command] = STATE(444),
    [sym_command] = STATE(444),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(445),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(251),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [110] = {
    [sym_command_name] = STATE(446),
    [sym_variable_assignment] = STATE(253),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(253),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym_command_repeat1] = STATE(253),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(171),
  },
  [111] = {
    [aux_sym__literal_repeat1] = STATE(447),
    [sym__simple_heredoc_body] = ACTIONS(437),
    [sym__heredoc_body_beginning] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_RPAREN] = ACTIONS(437),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_EQ_TILDE] = ACTIONS(439),
    [anon_sym_EQ_EQ] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(439),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(439),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [anon_sym_DOLLAR] = ACTIONS(439),
    [sym_raw_string] = ACTIONS(437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(437),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(437),
    [anon_sym_GT_LPAREN] = ACTIONS(437),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(439),
    [anon_sym_LF] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(439),
  },
  [112] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_PLUS_EQ] = ACTIONS(771),
    [sym_comment] = ACTIONS(57),
  },
  [113] = {
    [anon_sym_LPAREN_LPAREN] = ACTIONS(773),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(775),
  },
  [114] = {
    [sym__expression] = STATE(451),
    [sym_binary_expression] = STATE(451),
    [sym_unary_expression] = STATE(451),
    [sym_postfix_expression] = STATE(451),
    [sym_parenthesized_expression] = STATE(451),
    [sym_concatenation] = STATE(451),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_character] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [115] = {
    [sym__terminated_statement] = STATE(452),
    [sym_redirected_statement] = STATE(78),
    [sym_for_statement] = STATE(78),
    [sym_c_style_for_statement] = STATE(78),
    [sym_while_statement] = STATE(78),
    [sym_if_statement] = STATE(78),
    [sym_case_statement] = STATE(78),
    [sym_function_definition] = STATE(78),
    [sym_compound_statement] = STATE(78),
    [sym_subshell] = STATE(78),
    [sym_pipeline] = STATE(78),
    [sym_list] = STATE(78),
    [sym_negated_command] = STATE(78),
    [sym_test_command] = STATE(78),
    [sym_declaration_command] = STATE(78),
    [sym_unset_command] = STATE(78),
    [sym_command] = STATE(78),
    [sym_command_name] = STATE(79),
    [sym_variable_assignment] = STATE(80),
    [sym_subscript] = STATE(81),
    [sym_file_redirect] = STATE(83),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat1] = STATE(83),
    [aux_sym__literal_repeat1] = STATE(84),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [116] = {
    [sym__terminated_statement] = STATE(453),
    [sym_redirected_statement] = STATE(78),
    [sym_for_statement] = STATE(78),
    [sym_c_style_for_statement] = STATE(78),
    [sym_while_statement] = STATE(78),
    [sym_if_statement] = STATE(78),
    [sym_case_statement] = STATE(78),
    [sym_function_definition] = STATE(78),
    [sym_compound_statement] = STATE(78),
    [sym_subshell] = STATE(78),
    [sym_pipeline] = STATE(78),
    [sym_list] = STATE(78),
    [sym_negated_command] = STATE(78),
    [sym_test_command] = STATE(78),
    [sym_declaration_command] = STATE(78),
    [sym_unset_command] = STATE(78),
    [sym_command] = STATE(78),
    [sym_command_name] = STATE(79),
    [sym_variable_assignment] = STATE(80),
    [sym_subscript] = STATE(81),
    [sym_file_redirect] = STATE(83),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat1] = STATE(83),
    [aux_sym__literal_repeat1] = STATE(84),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [117] = {
    [sym_concatenation] = STATE(455),
    [sym_string] = STATE(454),
    [sym_simple_expansion] = STATE(454),
    [sym_string_expansion] = STATE(454),
    [sym_expansion] = STATE(454),
    [sym_command_substitution] = STATE(454),
    [sym_process_substitution] = STATE(454),
    [aux_sym__literal_repeat1] = STATE(456),
    [sym__special_character] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [anon_sym_DOLLAR] = ACTIONS(147),
    [sym_raw_string] = ACTIONS(777),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_LT_LPAREN] = ACTIONS(157),
    [anon_sym_GT_LPAREN] = ACTIONS(157),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(777),
  },
  [118] = {
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(779),
  },
  [119] = {
    [sym__statements] = STATE(458),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [120] = {
    [sym__statements] = STATE(460),
    [sym_redirected_statement] = STATE(137),
    [sym_for_statement] = STATE(137),
    [sym_c_style_for_statement] = STATE(137),
    [sym_while_statement] = STATE(137),
    [sym_if_statement] = STATE(137),
    [sym_case_statement] = STATE(137),
    [sym_function_definition] = STATE(137),
    [sym_compound_statement] = STATE(137),
    [sym_subshell] = STATE(137),
    [sym_pipeline] = STATE(137),
    [sym_list] = STATE(137),
    [sym_negated_command] = STATE(137),
    [sym_test_command] = STATE(137),
    [sym_declaration_command] = STATE(137),
    [sym_unset_command] = STATE(137),
    [sym_command] = STATE(137),
    [sym_command_name] = STATE(138),
    [sym_variable_assignment] = STATE(139),
    [sym_subscript] = STATE(140),
    [sym_file_redirect] = STATE(143),
    [sym_concatenation] = STATE(141),
    [sym_string] = STATE(130),
    [sym_simple_expansion] = STATE(130),
    [sym_string_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [sym_process_substitution] = STATE(130),
    [aux_sym__statements_repeat1] = STATE(142),
    [aux_sym_command_repeat1] = STATE(143),
    [aux_sym__literal_repeat1] = STATE(144),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_case] = ACTIONS(185),
    [anon_sym_function] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_RBRACE] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(199),
    [anon_sym_declare] = ACTIONS(201),
    [anon_sym_typeset] = ACTIONS(201),
    [anon_sym_export] = ACTIONS(201),
    [anon_sym_readonly] = ACTIONS(201),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_unset] = ACTIONS(203),
    [anon_sym_unsetenv] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(221),
  },
  [121] = {
    [sym__simple_heredoc_body] = ACTIONS(783),
    [sym__heredoc_body_beginning] = ACTIONS(783),
    [sym_file_descriptor] = ACTIONS(783),
    [ts_builtin_sym_end] = ACTIONS(783),
    [anon_sym_SEMI] = ACTIONS(785),
    [anon_sym_done] = ACTIONS(783),
    [anon_sym_fi] = ACTIONS(783),
    [anon_sym_elif] = ACTIONS(783),
    [anon_sym_else] = ACTIONS(783),
    [anon_sym_esac] = ACTIONS(783),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_RPAREN] = ACTIONS(783),
    [anon_sym_SEMI_SEMI] = ACTIONS(783),
    [anon_sym_PIPE_AMP] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(783),
    [anon_sym_AMP_GT] = ACTIONS(785),
    [anon_sym_AMP_GT_GT] = ACTIONS(783),
    [anon_sym_LT_AMP] = ACTIONS(783),
    [anon_sym_GT_AMP] = ACTIONS(783),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_DASH] = ACTIONS(783),
    [anon_sym_LT_LT_LT] = ACTIONS(783),
    [anon_sym_BQUOTE] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
  },
  [122] = {
    [sym_subshell] = STATE(461),
    [sym_test_command] = STATE(461),
    [sym_command] = STATE(461),
    [sym_command_name] = STATE(138),
    [sym_variable_assignment] = STATE(143),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(143),
    [sym_concatenation] = STATE(141),
    [sym_string] = STATE(130),
    [sym_simple_expansion] = STATE(130),
    [sym_string_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [sym_process_substitution] = STATE(130),
    [aux_sym_command_repeat1] = STATE(143),
    [aux_sym__literal_repeat1] = STATE(144),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(179),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(211),
  },
  [123] = {
    [sym__expression] = STATE(462),
    [sym_binary_expression] = STATE(462),
    [sym_unary_expression] = STATE(462),
    [sym_postfix_expression] = STATE(462),
    [sym_parenthesized_expression] = STATE(462),
    [sym_concatenation] = STATE(462),
    [sym_string] = STATE(153),
    [sym_simple_expansion] = STATE(153),
    [sym_string_expansion] = STATE(153),
    [sym_expansion] = STATE(153),
    [sym_command_substitution] = STATE(153),
    [sym_process_substitution] = STATE(153),
    [aux_sym__literal_repeat1] = STATE(159),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_BANG] = ACTIONS(227),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(245),
    [sym_test_operator] = ACTIONS(247),
  },
  [124] = {
    [sym__expression] = STATE(463),
    [sym_binary_expression] = STATE(463),
    [sym_unary_expression] = STATE(463),
    [sym_postfix_expression] = STATE(463),
    [sym_parenthesized_expression] = STATE(463),
    [sym_concatenation] = STATE(463),
    [sym_string] = STATE(162),
    [sym_simple_expansion] = STATE(162),
    [sym_string_expansion] = STATE(162),
    [sym_expansion] = STATE(162),
    [sym_command_substitution] = STATE(162),
    [sym_process_substitution] = STATE(162),
    [aux_sym__literal_repeat1] = STATE(164),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(249),
    [sym__special_character] = ACTIONS(251),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(255),
    [sym_test_operator] = ACTIONS(257),
  },
  [125] = {
    [sym_variable_assignment] = STATE(474),
    [sym_subscript] = STATE(473),
    [sym_concatenation] = STATE(474),
    [sym_string] = STATE(468),
    [sym_simple_expansion] = STATE(468),
    [sym_string_expansion] = STATE(468),
    [sym_expansion] = STATE(468),
    [sym_command_substitution] = STATE(468),
    [sym_process_substitution] = STATE(468),
    [aux_sym_declaration_command_repeat1] = STATE(474),
    [aux_sym__literal_repeat1] = STATE(475),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(787),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_RBRACE] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [sym__special_character] = ACTIONS(789),
    [anon_sym_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR] = ACTIONS(793),
    [sym_raw_string] = ACTIONS(795),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(797),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(799),
    [anon_sym_BQUOTE] = ACTIONS(801),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(805),
    [sym_word] = ACTIONS(807),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [126] = {
    [sym_concatenation] = STATE(484),
    [sym_string] = STATE(479),
    [sym_simple_expansion] = STATE(479),
    [sym_string_expansion] = STATE(479),
    [sym_expansion] = STATE(479),
    [sym_command_substitution] = STATE(479),
    [sym_process_substitution] = STATE(479),
    [aux_sym_unset_command_repeat1] = STATE(484),
    [aux_sym__literal_repeat1] = STATE(485),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_RBRACE] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [sym__special_character] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(815),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(819),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(823),
    [anon_sym_GT_LPAREN] = ACTIONS(823),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(825),
    [sym_word] = ACTIONS(827),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [127] = {
    [aux_sym_concatenation_repeat1] = STATE(487),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(329),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [128] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(490),
    [anon_sym_DQUOTE] = ACTIONS(831),
    [anon_sym_DOLLAR] = ACTIONS(833),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [129] = {
    [sym_string] = STATE(492),
    [anon_sym_DASH] = ACTIONS(835),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(835),
    [sym_raw_string] = ACTIONS(837),
    [anon_sym_POUND] = ACTIONS(835),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(841),
    [anon_sym_AT] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(841),
    [anon_sym_0] = ACTIONS(839),
    [anon_sym__] = ACTIONS(839),
  },
  [130] = {
    [aux_sym_concatenation_repeat1] = STATE(487),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(355),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [131] = {
    [sym_subscript] = STATE(497),
    [sym_variable_name] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(845),
    [anon_sym_DASH] = ACTIONS(847),
    [anon_sym_DOLLAR] = ACTIONS(847),
    [anon_sym_POUND] = ACTIONS(845),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(851),
    [anon_sym_AT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(851),
    [anon_sym_0] = ACTIONS(849),
    [anon_sym__] = ACTIONS(849),
  },
  [132] = {
    [sym__statements] = STATE(498),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(499),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [133] = {
    [sym__statements] = STATE(500),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [134] = {
    [sym__statements] = STATE(501),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [135] = {
    [aux_sym_concatenation_repeat1] = STATE(487),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_RBRACE] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(355),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [136] = {
    [anon_sym_RBRACE] = ACTIONS(855),
    [sym_comment] = ACTIONS(57),
  },
  [137] = {
    [sym_file_redirect] = STATE(514),
    [sym_heredoc_redirect] = STATE(514),
    [sym_heredoc_body] = STATE(513),
    [sym_herestring_redirect] = STATE(514),
    [aux_sym_redirected_statement_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(857),
    [sym__heredoc_body_beginning] = ACTIONS(859),
    [sym_file_descriptor] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(863),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_SEMI_SEMI] = ACTIONS(867),
    [anon_sym_RBRACE] = ACTIONS(399),
    [anon_sym_PIPE_AMP] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(871),
    [anon_sym_PIPE_PIPE] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_AMP_GT] = ACTIONS(873),
    [anon_sym_AMP_GT_GT] = ACTIONS(875),
    [anon_sym_LT_AMP] = ACTIONS(875),
    [anon_sym_GT_AMP] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(881),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(867),
    [anon_sym_AMP] = ACTIONS(863),
  },
  [138] = {
    [sym_concatenation] = STATE(517),
    [sym_string] = STATE(516),
    [sym_simple_expansion] = STATE(516),
    [sym_string_expansion] = STATE(516),
    [sym_expansion] = STATE(516),
    [sym_command_substitution] = STATE(516),
    [sym_process_substitution] = STATE(516),
    [aux_sym_command_repeat2] = STATE(517),
    [aux_sym__literal_repeat1] = STATE(518),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [sym__special_character] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(887),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [139] = {
    [sym_file_redirect] = STATE(514),
    [sym_heredoc_redirect] = STATE(514),
    [sym_heredoc_body] = STATE(513),
    [sym_herestring_redirect] = STATE(514),
    [aux_sym_redirected_statement_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(857),
    [sym__heredoc_body_beginning] = ACTIONS(859),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(863),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_SEMI_SEMI] = ACTIONS(867),
    [anon_sym_RBRACE] = ACTIONS(399),
    [anon_sym_PIPE_AMP] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(871),
    [anon_sym_PIPE_PIPE] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(881),
    [sym__special_character] = ACTIONS(435),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(867),
    [anon_sym_AMP] = ACTIONS(863),
  },
  [140] = {
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_PLUS_EQ] = ACTIONS(771),
    [sym_comment] = ACTIONS(57),
  },
  [141] = {
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_RBRACE] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(355),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [142] = {
    [sym_redirected_statement] = STATE(519),
    [sym_for_statement] = STATE(519),
    [sym_c_style_for_statement] = STATE(519),
    [sym_while_statement] = STATE(519),
    [sym_if_statement] = STATE(519),
    [sym_case_statement] = STATE(519),
    [sym_function_definition] = STATE(519),
    [sym_compound_statement] = STATE(519),
    [sym_subshell] = STATE(519),
    [sym_pipeline] = STATE(519),
    [sym_list] = STATE(519),
    [sym_negated_command] = STATE(519),
    [sym_test_command] = STATE(519),
    [sym_declaration_command] = STATE(519),
    [sym_unset_command] = STATE(519),
    [sym_command] = STATE(519),
    [sym_command_name] = STATE(138),
    [sym_variable_assignment] = STATE(520),
    [sym_subscript] = STATE(140),
    [sym_file_redirect] = STATE(143),
    [sym_concatenation] = STATE(141),
    [sym_string] = STATE(130),
    [sym_simple_expansion] = STATE(130),
    [sym_string_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [sym_process_substitution] = STATE(130),
    [aux_sym__statements_repeat1] = STATE(251),
    [aux_sym_command_repeat1] = STATE(143),
    [aux_sym__literal_repeat1] = STATE(144),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_case] = ACTIONS(185),
    [anon_sym_function] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(199),
    [anon_sym_declare] = ACTIONS(201),
    [anon_sym_typeset] = ACTIONS(201),
    [anon_sym_export] = ACTIONS(201),
    [anon_sym_readonly] = ACTIONS(201),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_unset] = ACTIONS(203),
    [anon_sym_unsetenv] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(221),
  },
  [143] = {
    [sym_command_name] = STATE(521),
    [sym_variable_assignment] = STATE(253),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(253),
    [sym_concatenation] = STATE(141),
    [sym_string] = STATE(130),
    [sym_simple_expansion] = STATE(130),
    [sym_string_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [sym_process_substitution] = STATE(130),
    [aux_sym_command_repeat1] = STATE(253),
    [aux_sym__literal_repeat1] = STATE(144),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(211),
  },
  [144] = {
    [aux_sym__literal_repeat1] = STATE(523),
    [sym__simple_heredoc_body] = ACTIONS(437),
    [sym__heredoc_body_beginning] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_RBRACE] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_EQ_TILDE] = ACTIONS(439),
    [anon_sym_EQ_EQ] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(439),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(439),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [sym__special_character] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [anon_sym_DOLLAR] = ACTIONS(439),
    [sym_raw_string] = ACTIONS(437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(437),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(437),
    [anon_sym_GT_LPAREN] = ACTIONS(437),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(439),
    [anon_sym_LF] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(439),
  },
  [145] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(893),
    [anon_sym_PLUS_EQ] = ACTIONS(893),
    [sym_comment] = ACTIONS(57),
  },
  [146] = {
    [sym__simple_heredoc_body] = ACTIONS(895),
    [sym__heredoc_body_beginning] = ACTIONS(895),
    [sym_file_descriptor] = ACTIONS(895),
    [ts_builtin_sym_end] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_done] = ACTIONS(895),
    [anon_sym_fi] = ACTIONS(895),
    [anon_sym_elif] = ACTIONS(895),
    [anon_sym_else] = ACTIONS(895),
    [anon_sym_esac] = ACTIONS(895),
    [anon_sym_PIPE] = ACTIONS(897),
    [anon_sym_RPAREN] = ACTIONS(895),
    [anon_sym_SEMI_SEMI] = ACTIONS(895),
    [anon_sym_PIPE_AMP] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(895),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(895),
    [anon_sym_LT_AMP] = ACTIONS(895),
    [anon_sym_GT_AMP] = ACTIONS(895),
    [anon_sym_LT_LT] = ACTIONS(897),
    [anon_sym_LT_LT_DASH] = ACTIONS(895),
    [anon_sym_LT_LT_LT] = ACTIONS(895),
    [anon_sym_BQUOTE] = ACTIONS(895),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(895),
    [anon_sym_AMP] = ACTIONS(897),
  },
  [147] = {
    [anon_sym_EQ] = ACTIONS(893),
    [anon_sym_PLUS_EQ] = ACTIONS(893),
    [sym_comment] = ACTIONS(57),
  },
  [148] = {
    [sym__expression] = STATE(525),
    [sym_binary_expression] = STATE(525),
    [sym_unary_expression] = STATE(525),
    [sym_postfix_expression] = STATE(525),
    [sym_parenthesized_expression] = STATE(525),
    [sym_concatenation] = STATE(525),
    [sym_string] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [sym_expansion] = STATE(294),
    [sym_command_substitution] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(300),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_BANG] = ACTIONS(505),
    [sym__special_character] = ACTIONS(507),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(523),
    [sym_test_operator] = ACTIONS(525),
  },
  [149] = {
    [sym__expression] = STATE(526),
    [sym_binary_expression] = STATE(526),
    [sym_unary_expression] = STATE(526),
    [sym_postfix_expression] = STATE(526),
    [sym_parenthesized_expression] = STATE(526),
    [sym_concatenation] = STATE(526),
    [sym_string] = STATE(153),
    [sym_simple_expansion] = STATE(153),
    [sym_string_expansion] = STATE(153),
    [sym_expansion] = STATE(153),
    [sym_command_substitution] = STATE(153),
    [sym_process_substitution] = STATE(153),
    [aux_sym__literal_repeat1] = STATE(159),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_BANG] = ACTIONS(227),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(245),
    [sym_test_operator] = ACTIONS(247),
  },
  [150] = {
    [aux_sym_concatenation_repeat1] = STATE(528),
    [sym__concat] = ACTIONS(899),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_RBRACK] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(325),
    [anon_sym_EQ_EQ] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_PLUS_EQ] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_BANG_EQ] = ACTIONS(325),
    [anon_sym_PLUS] = ACTIONS(329),
    [anon_sym_DASH] = ACTIONS(329),
    [anon_sym_DASH_EQ] = ACTIONS(325),
    [anon_sym_LT_EQ] = ACTIONS(325),
    [anon_sym_GT_EQ] = ACTIONS(325),
    [anon_sym_PLUS_PLUS] = ACTIONS(325),
    [anon_sym_DASH_DASH] = ACTIONS(325),
    [sym__special_character] = ACTIONS(329),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(325),
  },
  [151] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(531),
    [anon_sym_DQUOTE] = ACTIONS(901),
    [anon_sym_DOLLAR] = ACTIONS(903),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [152] = {
    [sym_string] = STATE(533),
    [anon_sym_DASH] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(907),
    [anon_sym_POUND] = ACTIONS(905),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(909),
    [anon_sym_STAR] = ACTIONS(911),
    [anon_sym_AT] = ACTIONS(911),
    [anon_sym_QMARK] = ACTIONS(911),
    [anon_sym_0] = ACTIONS(909),
    [anon_sym__] = ACTIONS(909),
  },
  [153] = {
    [aux_sym_concatenation_repeat1] = STATE(528),
    [sym__concat] = ACTIONS(899),
    [anon_sym_AMP_AMP] = ACTIONS(541),
    [anon_sym_PIPE_PIPE] = ACTIONS(541),
    [anon_sym_RBRACK] = ACTIONS(541),
    [anon_sym_EQ_TILDE] = ACTIONS(541),
    [anon_sym_EQ_EQ] = ACTIONS(541),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_PLUS_EQ] = ACTIONS(541),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_BANG_EQ] = ACTIONS(541),
    [anon_sym_PLUS] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(543),
    [anon_sym_DASH_EQ] = ACTIONS(541),
    [anon_sym_LT_EQ] = ACTIONS(541),
    [anon_sym_GT_EQ] = ACTIONS(541),
    [anon_sym_PLUS_PLUS] = ACTIONS(541),
    [anon_sym_DASH_DASH] = ACTIONS(541),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(541),
  },
  [154] = {
    [sym_subscript] = STATE(538),
    [sym_variable_name] = ACTIONS(913),
    [anon_sym_BANG] = ACTIONS(915),
    [anon_sym_DASH] = ACTIONS(917),
    [anon_sym_DOLLAR] = ACTIONS(917),
    [anon_sym_POUND] = ACTIONS(915),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(921),
    [anon_sym_QMARK] = ACTIONS(921),
    [anon_sym_0] = ACTIONS(919),
    [anon_sym__] = ACTIONS(919),
  },
  [155] = {
    [sym__statements] = STATE(539),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(540),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [156] = {
    [sym__statements] = STATE(541),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [157] = {
    [sym__statements] = STATE(542),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [158] = {
    [anon_sym_AMP_AMP] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(923),
    [anon_sym_RBRACK] = ACTIONS(555),
    [anon_sym_EQ_TILDE] = ACTIONS(925),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(927),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_GT] = ACTIONS(927),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(923),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_PLUS_PLUS] = ACTIONS(929),
    [anon_sym_DASH_DASH] = ACTIONS(929),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(923),
  },
  [159] = {
    [aux_sym__literal_repeat1] = STATE(547),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(565),
    [anon_sym_RBRACK] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_EQ_EQ] = ACTIONS(565),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(565),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym__special_character] = ACTIONS(931),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(565),
  },
  [160] = {
    [sym__expression] = STATE(548),
    [sym_binary_expression] = STATE(548),
    [sym_unary_expression] = STATE(548),
    [sym_postfix_expression] = STATE(548),
    [sym_parenthesized_expression] = STATE(548),
    [sym_concatenation] = STATE(548),
    [sym_string] = STATE(162),
    [sym_simple_expansion] = STATE(162),
    [sym_string_expansion] = STATE(162),
    [sym_expansion] = STATE(162),
    [sym_command_substitution] = STATE(162),
    [sym_process_substitution] = STATE(162),
    [aux_sym__literal_repeat1] = STATE(164),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(249),
    [sym__special_character] = ACTIONS(251),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(255),
    [sym_test_operator] = ACTIONS(257),
  },
  [161] = {
    [aux_sym_concatenation_repeat1] = STATE(549),
    [sym__concat] = ACTIONS(527),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(325),
    [anon_sym_EQ_EQ] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_PLUS_EQ] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_BANG_EQ] = ACTIONS(325),
    [anon_sym_PLUS] = ACTIONS(329),
    [anon_sym_DASH] = ACTIONS(329),
    [anon_sym_DASH_EQ] = ACTIONS(325),
    [anon_sym_LT_EQ] = ACTIONS(325),
    [anon_sym_GT_EQ] = ACTIONS(325),
    [anon_sym_PLUS_PLUS] = ACTIONS(325),
    [anon_sym_DASH_DASH] = ACTIONS(325),
    [sym__special_character] = ACTIONS(329),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(325),
  },
  [162] = {
    [aux_sym_concatenation_repeat1] = STATE(549),
    [sym__concat] = ACTIONS(527),
    [anon_sym_AMP_AMP] = ACTIONS(541),
    [anon_sym_PIPE_PIPE] = ACTIONS(541),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(541),
    [anon_sym_EQ_TILDE] = ACTIONS(541),
    [anon_sym_EQ_EQ] = ACTIONS(541),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_PLUS_EQ] = ACTIONS(541),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_BANG_EQ] = ACTIONS(541),
    [anon_sym_PLUS] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(543),
    [anon_sym_DASH_EQ] = ACTIONS(541),
    [anon_sym_LT_EQ] = ACTIONS(541),
    [anon_sym_GT_EQ] = ACTIONS(541),
    [anon_sym_PLUS_PLUS] = ACTIONS(541),
    [anon_sym_DASH_DASH] = ACTIONS(541),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(541),
  },
  [163] = {
    [anon_sym_AMP_AMP] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(933),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(555),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(935),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_PLUS_EQ] = ACTIONS(933),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_DASH] = ACTIONS(937),
    [anon_sym_DASH_EQ] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(933),
  },
  [164] = {
    [aux_sym__literal_repeat1] = STATE(553),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(565),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_EQ_EQ] = ACTIONS(565),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(565),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym__special_character] = ACTIONS(939),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(565),
  },
  [165] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_PLUS_EQ] = ACTIONS(941),
    [sym_comment] = ACTIONS(57),
  },
  [166] = {
    [aux_sym_concatenation_repeat1] = STATE(556),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(943),
    [sym_variable_name] = ACTIONS(325),
    [ts_builtin_sym_end] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [167] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(559),
    [anon_sym_DQUOTE] = ACTIONS(945),
    [anon_sym_DOLLAR] = ACTIONS(947),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [168] = {
    [sym_string] = STATE(561),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(949),
    [sym_raw_string] = ACTIONS(951),
    [anon_sym_POUND] = ACTIONS(949),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(953),
    [anon_sym_STAR] = ACTIONS(955),
    [anon_sym_AT] = ACTIONS(955),
    [anon_sym_QMARK] = ACTIONS(955),
    [anon_sym_0] = ACTIONS(953),
    [anon_sym__] = ACTIONS(953),
  },
  [169] = {
    [aux_sym_concatenation_repeat1] = STATE(556),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(943),
    [sym_variable_name] = ACTIONS(957),
    [ts_builtin_sym_end] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [sym__special_character] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [170] = {
    [sym_subscript] = STATE(566),
    [sym_variable_name] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_DASH] = ACTIONS(965),
    [anon_sym_DOLLAR] = ACTIONS(965),
    [anon_sym_POUND] = ACTIONS(963),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(967),
    [anon_sym_STAR] = ACTIONS(969),
    [anon_sym_AT] = ACTIONS(969),
    [anon_sym_QMARK] = ACTIONS(969),
    [anon_sym_0] = ACTIONS(967),
    [anon_sym__] = ACTIONS(967),
  },
  [171] = {
    [sym__statements] = STATE(567),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(568),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [172] = {
    [sym__statements] = STATE(569),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [173] = {
    [sym__statements] = STATE(570),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [174] = {
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_PLUS_EQ] = ACTIONS(941),
    [sym_comment] = ACTIONS(57),
  },
  [175] = {
    [sym_variable_assignment] = STATE(571),
    [sym_subscript] = STATE(174),
    [sym_concatenation] = STATE(571),
    [sym_string] = STATE(169),
    [sym_simple_expansion] = STATE(169),
    [sym_string_expansion] = STATE(169),
    [sym_expansion] = STATE(169),
    [sym_command_substitution] = STATE(169),
    [sym_process_substitution] = STATE(169),
    [aux_sym_declaration_command_repeat1] = STATE(571),
    [aux_sym__literal_repeat1] = STATE(176),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(261),
    [ts_builtin_sym_end] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [sym__special_character] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(975),
    [sym_word] = ACTIONS(283),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [176] = {
    [aux_sym__literal_repeat1] = STATE(573),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym_variable_name] = ACTIONS(977),
    [ts_builtin_sym_end] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(979),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(979),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [sym__special_character] = ACTIONS(981),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(979),
    [sym_word] = ACTIONS(979),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
  },
  [177] = {
    [aux_sym_concatenation_repeat1] = STATE(575),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(983),
    [ts_builtin_sym_end] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [178] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(578),
    [anon_sym_DQUOTE] = ACTIONS(985),
    [anon_sym_DOLLAR] = ACTIONS(987),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [179] = {
    [sym_string] = STATE(580),
    [anon_sym_DASH] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_DOLLAR] = ACTIONS(989),
    [sym_raw_string] = ACTIONS(991),
    [anon_sym_POUND] = ACTIONS(989),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(993),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_QMARK] = ACTIONS(995),
    [anon_sym_0] = ACTIONS(993),
    [anon_sym__] = ACTIONS(993),
  },
  [180] = {
    [aux_sym_concatenation_repeat1] = STATE(575),
    [sym__simple_heredoc_body] = ACTIONS(997),
    [sym__heredoc_body_beginning] = ACTIONS(997),
    [sym_file_descriptor] = ACTIONS(997),
    [sym__concat] = ACTIONS(983),
    [ts_builtin_sym_end] = ACTIONS(997),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI_SEMI] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_AMP_GT] = ACTIONS(999),
    [anon_sym_AMP_GT_GT] = ACTIONS(997),
    [anon_sym_LT_AMP] = ACTIONS(997),
    [anon_sym_GT_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_LT_LT_DASH] = ACTIONS(997),
    [anon_sym_LT_LT_LT] = ACTIONS(997),
    [sym__special_character] = ACTIONS(997),
    [anon_sym_DQUOTE] = ACTIONS(997),
    [anon_sym_DOLLAR] = ACTIONS(999),
    [sym_raw_string] = ACTIONS(997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(997),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(997),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(999),
    [sym_word] = ACTIONS(999),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
  },
  [181] = {
    [sym_subscript] = STATE(585),
    [sym_variable_name] = ACTIONS(1001),
    [anon_sym_BANG] = ACTIONS(1003),
    [anon_sym_DASH] = ACTIONS(1005),
    [anon_sym_DOLLAR] = ACTIONS(1005),
    [anon_sym_POUND] = ACTIONS(1003),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1007),
    [anon_sym_STAR] = ACTIONS(1009),
    [anon_sym_AT] = ACTIONS(1009),
    [anon_sym_QMARK] = ACTIONS(1009),
    [anon_sym_0] = ACTIONS(1007),
    [anon_sym__] = ACTIONS(1007),
  },
  [182] = {
    [sym__statements] = STATE(586),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(587),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [183] = {
    [sym__statements] = STATE(588),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [184] = {
    [sym__statements] = STATE(589),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [185] = {
    [sym_concatenation] = STATE(590),
    [sym_string] = STATE(180),
    [sym_simple_expansion] = STATE(180),
    [sym_string_expansion] = STATE(180),
    [sym_expansion] = STATE(180),
    [sym_command_substitution] = STATE(180),
    [sym_process_substitution] = STATE(180),
    [aux_sym_unset_command_repeat1] = STATE(590),
    [aux_sym__literal_repeat1] = STATE(186),
    [sym__simple_heredoc_body] = ACTIONS(1011),
    [sym__heredoc_body_beginning] = ACTIONS(1011),
    [sym_file_descriptor] = ACTIONS(1011),
    [ts_builtin_sym_end] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1013),
    [anon_sym_GT] = ACTIONS(1013),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT] = ACTIONS(1013),
    [anon_sym_AMP_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_AMP] = ACTIONS(1011),
    [anon_sym_GT_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(1011),
    [anon_sym_LT_LT_LT] = ACTIONS(1011),
    [sym__special_character] = ACTIONS(289),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_DOLLAR] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1015),
    [sym_word] = ACTIONS(307),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
  },
  [186] = {
    [aux_sym__literal_repeat1] = STATE(592),
    [sym__simple_heredoc_body] = ACTIONS(1017),
    [sym__heredoc_body_beginning] = ACTIONS(1017),
    [sym_file_descriptor] = ACTIONS(1017),
    [ts_builtin_sym_end] = ACTIONS(1017),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1017),
    [anon_sym_PIPE_AMP] = ACTIONS(1017),
    [anon_sym_AMP_AMP] = ACTIONS(1017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1017),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1017),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1017),
    [anon_sym_LT_AMP] = ACTIONS(1017),
    [anon_sym_GT_AMP] = ACTIONS(1017),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1017),
    [anon_sym_LT_LT_LT] = ACTIONS(1017),
    [sym__special_character] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1017),
    [anon_sym_DOLLAR] = ACTIONS(1019),
    [sym_raw_string] = ACTIONS(1017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1017),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1017),
    [anon_sym_GT_LPAREN] = ACTIONS(1017),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1019),
    [sym_word] = ACTIONS(1019),
    [anon_sym_LF] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [187] = {
    [aux_sym_concatenation_repeat1] = STATE(594),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(1023),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(325),
  },
  [188] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(597),
    [anon_sym_DQUOTE] = ACTIONS(1025),
    [anon_sym_DOLLAR] = ACTIONS(1027),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [189] = {
    [sym_string] = STATE(599),
    [anon_sym_DASH] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(311),
    [anon_sym_DOLLAR] = ACTIONS(1029),
    [sym_raw_string] = ACTIONS(1031),
    [anon_sym_POUND] = ACTIONS(1029),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1033),
    [anon_sym_STAR] = ACTIONS(1035),
    [anon_sym_AT] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1035),
    [anon_sym_0] = ACTIONS(1033),
    [anon_sym__] = ACTIONS(1033),
  },
  [190] = {
    [aux_sym_concatenation_repeat1] = STATE(594),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(1023),
    [sym_variable_name] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [sym__special_character] = ACTIONS(1037),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [anon_sym_DOLLAR] = ACTIONS(1039),
    [sym_raw_string] = ACTIONS(1037),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1037),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1037),
    [anon_sym_BQUOTE] = ACTIONS(1037),
    [anon_sym_LT_LPAREN] = ACTIONS(1037),
    [anon_sym_GT_LPAREN] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1037),
  },
  [191] = {
    [sym_subscript] = STATE(604),
    [sym_variable_name] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_DOLLAR] = ACTIONS(1045),
    [anon_sym_POUND] = ACTIONS(1043),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1047),
    [anon_sym_STAR] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(1049),
    [anon_sym_QMARK] = ACTIONS(1049),
    [anon_sym_0] = ACTIONS(1047),
    [anon_sym__] = ACTIONS(1047),
  },
  [192] = {
    [sym__statements] = STATE(605),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(606),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [193] = {
    [sym__statements] = STATE(607),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [194] = {
    [sym__statements] = STATE(608),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [195] = {
    [sym_file_descriptor] = ACTIONS(1037),
    [sym_variable_name] = ACTIONS(1037),
    [anon_sym_RPAREN] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [sym__special_character] = ACTIONS(1037),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [anon_sym_DOLLAR] = ACTIONS(1039),
    [sym_raw_string] = ACTIONS(1037),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1037),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1037),
    [anon_sym_BQUOTE] = ACTIONS(1037),
    [anon_sym_LT_LPAREN] = ACTIONS(1037),
    [anon_sym_GT_LPAREN] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1037),
  },
  [196] = {
    [aux_sym__literal_repeat1] = STATE(610),
    [sym_file_descriptor] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1051),
    [anon_sym_BQUOTE] = ACTIONS(1051),
    [anon_sym_LT_LPAREN] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1051),
  },
  [197] = {
    [sym_string] = STATE(611),
    [sym_simple_expansion] = STATE(611),
    [sym_string_expansion] = STATE(611),
    [sym_expansion] = STATE(611),
    [sym_command_substitution] = STATE(611),
    [sym_process_substitution] = STATE(611),
    [sym__special_character] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1057),
  },
  [198] = {
    [aux_sym_concatenation_repeat1] = STATE(612),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_EQ_TILDE] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [199] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [ts_builtin_sym_end] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_EQ_TILDE] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [200] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1069),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [201] = {
    [sym__concat] = ACTIONS(1079),
    [anon_sym_DQUOTE] = ACTIONS(1081),
    [anon_sym_DOLLAR] = ACTIONS(1081),
    [sym__string_content] = ACTIONS(1083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1081),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1081),
    [anon_sym_BQUOTE] = ACTIONS(1081),
    [sym_comment] = ACTIONS(343),
  },
  [202] = {
    [sym_subscript] = STATE(621),
    [sym_variable_name] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(1087),
    [anon_sym_DASH] = ACTIONS(1089),
    [anon_sym_DOLLAR] = ACTIONS(1089),
    [anon_sym_POUND] = ACTIONS(1087),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1093),
    [anon_sym_AT] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1093),
    [anon_sym_0] = ACTIONS(1091),
    [anon_sym__] = ACTIONS(1091),
  },
  [203] = {
    [sym__statements] = STATE(622),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(623),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [204] = {
    [sym__statements] = STATE(624),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [205] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(1069),
    [anon_sym_DOLLAR] = ACTIONS(1095),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [206] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [ts_builtin_sym_end] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_RPAREN] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_EQ_TILDE] = ACTIONS(1099),
    [anon_sym_EQ_EQ] = ACTIONS(1099),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [207] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [ts_builtin_sym_end] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_RPAREN] = ACTIONS(1101),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_EQ_TILDE] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [208] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [ts_builtin_sym_end] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1105),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_EQ_TILDE] = ACTIONS(1107),
    [anon_sym_EQ_EQ] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [209] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(1111),
    [sym_comment] = ACTIONS(57),
  },
  [210] = {
    [sym_subscript] = STATE(631),
    [sym_variable_name] = ACTIONS(1113),
    [anon_sym_DASH] = ACTIONS(1115),
    [anon_sym_DOLLAR] = ACTIONS(1115),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1117),
    [anon_sym_STAR] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(1119),
    [anon_sym_QMARK] = ACTIONS(1119),
    [anon_sym_0] = ACTIONS(1117),
    [anon_sym__] = ACTIONS(1117),
  },
  [211] = {
    [sym_concatenation] = STATE(643),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(643),
    [anon_sym_RBRACE] = ACTIONS(1121),
    [anon_sym_EQ] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(1133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1137),
    [anon_sym_COLON] = ACTIONS(1123),
    [anon_sym_COLON_QMARK] = ACTIONS(1123),
    [anon_sym_COLON_DASH] = ACTIONS(1123),
    [anon_sym_PERCENT] = ACTIONS(1123),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [212] = {
    [sym_concatenation] = STATE(646),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(646),
    [anon_sym_RBRACE] = ACTIONS(1147),
    [anon_sym_EQ] = ACTIONS(1149),
    [anon_sym_DASH] = ACTIONS(1149),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(1151),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1153),
    [anon_sym_COLON] = ACTIONS(1149),
    [anon_sym_COLON_QMARK] = ACTIONS(1149),
    [anon_sym_COLON_DASH] = ACTIONS(1149),
    [anon_sym_PERCENT] = ACTIONS(1149),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [213] = {
    [anon_sym_LT] = ACTIONS(1155),
    [anon_sym_GT] = ACTIONS(1155),
    [anon_sym_GT_GT] = ACTIONS(1157),
    [anon_sym_AMP_GT] = ACTIONS(1155),
    [anon_sym_AMP_GT_GT] = ACTIONS(1157),
    [anon_sym_LT_AMP] = ACTIONS(1157),
    [anon_sym_GT_AMP] = ACTIONS(1157),
    [sym_comment] = ACTIONS(57),
  },
  [214] = {
    [sym_concatenation] = STATE(195),
    [sym_string] = STATE(649),
    [sym_simple_expansion] = STATE(649),
    [sym_string_expansion] = STATE(649),
    [sym_expansion] = STATE(649),
    [sym_command_substitution] = STATE(649),
    [sym_process_substitution] = STATE(649),
    [aux_sym__literal_repeat1] = STATE(650),
    [sym__special_character] = ACTIONS(1159),
    [anon_sym_DQUOTE] = ACTIONS(311),
    [anon_sym_DOLLAR] = ACTIONS(313),
    [sym_raw_string] = ACTIONS(1161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(319),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1161),
  },
  [215] = {
    [anon_sym_RPAREN] = ACTIONS(1163),
    [sym_comment] = ACTIONS(57),
  },
  [216] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [217] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1165),
    [anon_sym_PLUS_EQ] = ACTIONS(1165),
    [sym_comment] = ACTIONS(57),
  },
  [218] = {
    [sym_subshell] = STATE(146),
    [sym_test_command] = STATE(146),
    [sym_command] = STATE(146),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(230),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(383),
  },
  [219] = {
    [sym_variable_assignment] = STATE(657),
    [sym_subscript] = STATE(656),
    [sym_concatenation] = STATE(657),
    [sym_string] = STATE(655),
    [sym_simple_expansion] = STATE(655),
    [sym_string_expansion] = STATE(655),
    [sym_expansion] = STATE(655),
    [sym_command_substitution] = STATE(655),
    [sym_process_substitution] = STATE(655),
    [aux_sym_declaration_command_repeat1] = STATE(657),
    [aux_sym__literal_repeat1] = STATE(658),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(1167),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [sym__special_character] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(1171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(259),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1173),
    [sym_word] = ACTIONS(1175),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [220] = {
    [sym_concatenation] = STATE(661),
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_string_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [aux_sym_unset_command_repeat1] = STATE(661),
    [aux_sym__literal_repeat1] = STATE(662),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [sym__special_character] = ACTIONS(1177),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_DOLLAR] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(1179),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(285),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1181),
    [sym_word] = ACTIONS(1183),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [221] = {
    [aux_sym_concatenation_repeat1] = STATE(663),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [222] = {
    [aux_sym_concatenation_repeat1] = STATE(663),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [223] = {
    [aux_sym_concatenation_repeat1] = STATE(663),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [224] = {
    [anon_sym_BQUOTE] = ACTIONS(1163),
    [sym_comment] = ACTIONS(57),
  },
  [225] = {
    [sym_file_redirect] = STATE(671),
    [sym_heredoc_redirect] = STATE(671),
    [sym_heredoc_body] = STATE(670),
    [sym_herestring_redirect] = STATE(671),
    [aux_sym_redirected_statement_repeat1] = STATE(671),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(1185),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_SEMI_SEMI] = ACTIONS(1191),
    [anon_sym_PIPE_AMP] = ACTIONS(1193),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1197),
    [anon_sym_GT] = ACTIONS(1197),
    [anon_sym_GT_GT] = ACTIONS(1199),
    [anon_sym_AMP_GT] = ACTIONS(1197),
    [anon_sym_AMP_GT_GT] = ACTIONS(1199),
    [anon_sym_LT_AMP] = ACTIONS(1199),
    [anon_sym_GT_AMP] = ACTIONS(1199),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(1201),
    [anon_sym_BQUOTE] = ACTIONS(399),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1191),
    [anon_sym_AMP] = ACTIONS(1187),
  },
  [226] = {
    [sym_concatenation] = STATE(674),
    [sym_string] = STATE(673),
    [sym_simple_expansion] = STATE(673),
    [sym_string_expansion] = STATE(673),
    [sym_expansion] = STATE(673),
    [sym_command_substitution] = STATE(673),
    [sym_process_substitution] = STATE(673),
    [aux_sym_command_repeat2] = STATE(674),
    [aux_sym__literal_repeat1] = STATE(675),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(1203),
    [anon_sym_EQ_EQ] = ACTIONS(1203),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [sym__special_character] = ACTIONS(1205),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(421),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1209),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [227] = {
    [sym_file_redirect] = STATE(671),
    [sym_heredoc_redirect] = STATE(671),
    [sym_heredoc_body] = STATE(670),
    [sym_herestring_redirect] = STATE(671),
    [aux_sym_redirected_statement_repeat1] = STATE(671),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_SEMI_SEMI] = ACTIONS(1191),
    [anon_sym_PIPE_AMP] = ACTIONS(1193),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(1201),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(399),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(1191),
    [anon_sym_AMP] = ACTIONS(1187),
  },
  [228] = {
    [anon_sym_EQ] = ACTIONS(1165),
    [anon_sym_PLUS_EQ] = ACTIONS(1165),
    [sym_comment] = ACTIONS(57),
  },
  [229] = {
    [sym_redirected_statement] = STATE(676),
    [sym_for_statement] = STATE(676),
    [sym_c_style_for_statement] = STATE(676),
    [sym_while_statement] = STATE(676),
    [sym_if_statement] = STATE(676),
    [sym_case_statement] = STATE(676),
    [sym_function_definition] = STATE(676),
    [sym_compound_statement] = STATE(676),
    [sym_subshell] = STATE(676),
    [sym_pipeline] = STATE(676),
    [sym_list] = STATE(676),
    [sym_negated_command] = STATE(676),
    [sym_test_command] = STATE(676),
    [sym_declaration_command] = STATE(676),
    [sym_unset_command] = STATE(676),
    [sym_command] = STATE(676),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(677),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(251),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [230] = {
    [sym_command_name] = STATE(678),
    [sym_variable_assignment] = STATE(253),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(253),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym_command_repeat1] = STATE(253),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(1205),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(383),
  },
  [231] = {
    [aux_sym__literal_repeat1] = STATE(679),
    [sym__simple_heredoc_body] = ACTIONS(437),
    [sym__heredoc_body_beginning] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_EQ_TILDE] = ACTIONS(439),
    [anon_sym_EQ_EQ] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(439),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(439),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [anon_sym_DOLLAR] = ACTIONS(439),
    [sym_raw_string] = ACTIONS(437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(437),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(437),
    [anon_sym_GT_LPAREN] = ACTIONS(437),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(439),
    [anon_sym_LF] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(439),
  },
  [232] = {
    [anon_sym_RPAREN] = ACTIONS(1211),
    [sym_comment] = ACTIONS(57),
  },
  [233] = {
    [anon_sym_RPAREN] = ACTIONS(1213),
    [sym_comment] = ACTIONS(57),
  },
  [234] = {
    [ts_builtin_sym_end] = ACTIONS(1215),
    [anon_sym_SEMI] = ACTIONS(1217),
    [anon_sym_done] = ACTIONS(1215),
    [anon_sym_fi] = ACTIONS(1215),
    [anon_sym_elif] = ACTIONS(1215),
    [anon_sym_else] = ACTIONS(1215),
    [anon_sym_esac] = ACTIONS(1215),
    [anon_sym_RPAREN] = ACTIONS(1215),
    [anon_sym_SEMI_SEMI] = ACTIONS(1215),
    [anon_sym_BQUOTE] = ACTIONS(1215),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
  },
  [235] = {
    [sym_simple_expansion] = STATE(687),
    [sym_expansion] = STATE(687),
    [sym_command_substitution] = STATE(687),
    [aux_sym_heredoc_body_repeat1] = STATE(687),
    [sym__heredoc_body_middle] = ACTIONS(1219),
    [sym__heredoc_body_end] = ACTIONS(1221),
    [anon_sym_DOLLAR] = ACTIONS(1223),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1227),
    [anon_sym_BQUOTE] = ACTIONS(1229),
    [sym_comment] = ACTIONS(57),
  },
  [236] = {
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1233),
    [anon_sym_AMP_GT] = ACTIONS(1231),
    [anon_sym_AMP_GT_GT] = ACTIONS(1233),
    [anon_sym_LT_AMP] = ACTIONS(1233),
    [anon_sym_GT_AMP] = ACTIONS(1233),
    [sym_comment] = ACTIONS(57),
  },
  [237] = {
    [sym_file_descriptor] = ACTIONS(1235),
    [sym_variable_name] = ACTIONS(1235),
    [ts_builtin_sym_end] = ACTIONS(1237),
    [anon_sym_for] = ACTIONS(1239),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1239),
    [anon_sym_if] = ACTIONS(1239),
    [anon_sym_case] = ACTIONS(1239),
    [anon_sym_RPAREN] = ACTIONS(1237),
    [anon_sym_SEMI_SEMI] = ACTIONS(1237),
    [anon_sym_function] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1239),
    [anon_sym_typeset] = ACTIONS(1239),
    [anon_sym_export] = ACTIONS(1239),
    [anon_sym_readonly] = ACTIONS(1239),
    [anon_sym_local] = ACTIONS(1239),
    [anon_sym_unset] = ACTIONS(1239),
    [anon_sym_unsetenv] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_AMP_GT] = ACTIONS(1239),
    [anon_sym_AMP_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_AMP] = ACTIONS(1235),
    [anon_sym_GT_AMP] = ACTIONS(1235),
    [sym__special_character] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_DOLLAR] = ACTIONS(1239),
    [sym_raw_string] = ACTIONS(1235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1235),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1235),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [anon_sym_LT_LPAREN] = ACTIONS(1235),
    [anon_sym_GT_LPAREN] = ACTIONS(1235),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1239),
  },
  [238] = {
    [sym_redirected_statement] = STATE(689),
    [sym_for_statement] = STATE(689),
    [sym_c_style_for_statement] = STATE(689),
    [sym_while_statement] = STATE(689),
    [sym_if_statement] = STATE(689),
    [sym_case_statement] = STATE(689),
    [sym_function_definition] = STATE(689),
    [sym_compound_statement] = STATE(689),
    [sym_subshell] = STATE(689),
    [sym_pipeline] = STATE(689),
    [sym_list] = STATE(689),
    [sym_negated_command] = STATE(689),
    [sym_test_command] = STATE(689),
    [sym_declaration_command] = STATE(689),
    [sym_unset_command] = STATE(689),
    [sym_command] = STATE(689),
    [sym_command_name] = STATE(30),
    [sym_variable_assignment] = STATE(690),
    [sym_subscript] = STATE(32),
    [sym_file_redirect] = STATE(35),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym_command_repeat1] = STATE(35),
    [aux_sym__literal_repeat1] = STATE(36),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(33),
    [anon_sym_typeset] = ACTIONS(33),
    [anon_sym_export] = ACTIONS(33),
    [anon_sym_readonly] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym_unset] = ACTIONS(35),
    [anon_sym_unsetenv] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(41),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(59),
  },
  [239] = {
    [sym_redirected_statement] = STATE(691),
    [sym_for_statement] = STATE(691),
    [sym_c_style_for_statement] = STATE(691),
    [sym_while_statement] = STATE(691),
    [sym_if_statement] = STATE(691),
    [sym_case_statement] = STATE(691),
    [sym_function_definition] = STATE(691),
    [sym_compound_statement] = STATE(691),
    [sym_subshell] = STATE(691),
    [sym_pipeline] = STATE(691),
    [sym_list] = STATE(691),
    [sym_negated_command] = STATE(691),
    [sym_test_command] = STATE(691),
    [sym_declaration_command] = STATE(691),
    [sym_unset_command] = STATE(691),
    [sym_command] = STATE(691),
    [sym_command_name] = STATE(30),
    [sym_variable_assignment] = STATE(692),
    [sym_subscript] = STATE(32),
    [sym_file_redirect] = STATE(35),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(21),
    [sym_simple_expansion] = STATE(21),
    [sym_string_expansion] = STATE(21),
    [sym_expansion] = STATE(21),
    [sym_command_substitution] = STATE(21),
    [sym_process_substitution] = STATE(21),
    [aux_sym_command_repeat1] = STATE(35),
    [aux_sym__literal_repeat1] = STATE(36),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(7),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(27),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(33),
    [anon_sym_typeset] = ACTIONS(33),
    [anon_sym_export] = ACTIONS(33),
    [anon_sym_readonly] = ACTIONS(33),
    [anon_sym_local] = ACTIONS(33),
    [anon_sym_unset] = ACTIONS(35),
    [anon_sym_unsetenv] = ACTIONS(35),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(41),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(47),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(59),
  },
  [240] = {
    [sym_concatenation] = STATE(695),
    [sym_string] = STATE(694),
    [sym_simple_expansion] = STATE(694),
    [sym_string_expansion] = STATE(694),
    [sym_expansion] = STATE(694),
    [sym_command_substitution] = STATE(694),
    [sym_process_substitution] = STATE(694),
    [aux_sym__literal_repeat1] = STATE(696),
    [sym__special_character] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1243),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1243),
  },
  [241] = {
    [sym_heredoc_start] = ACTIONS(1245),
    [sym_comment] = ACTIONS(57),
  },
  [242] = {
    [sym_concatenation] = STATE(699),
    [sym_string] = STATE(698),
    [sym_simple_expansion] = STATE(698),
    [sym_string_expansion] = STATE(698),
    [sym_expansion] = STATE(698),
    [sym_command_substitution] = STATE(698),
    [sym_process_substitution] = STATE(698),
    [aux_sym__literal_repeat1] = STATE(700),
    [sym__special_character] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1247),
  },
  [243] = {
    [ts_builtin_sym_end] = ACTIONS(1237),
    [anon_sym_SEMI] = ACTIONS(1249),
    [anon_sym_RPAREN] = ACTIONS(1237),
    [anon_sym_SEMI_SEMI] = ACTIONS(1251),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
  },
  [244] = {
    [sym_file_redirect] = STATE(702),
    [sym_heredoc_redirect] = STATE(702),
    [sym_herestring_redirect] = STATE(702),
    [aux_sym_redirected_statement_repeat1] = STATE(702),
    [sym__simple_heredoc_body] = ACTIONS(1253),
    [sym__heredoc_body_beginning] = ACTIONS(1253),
    [sym_file_descriptor] = ACTIONS(397),
    [ts_builtin_sym_end] = ACTIONS(1253),
    [anon_sym_SEMI] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_SEMI_SEMI] = ACTIONS(1253),
    [anon_sym_PIPE_AMP] = ACTIONS(1253),
    [anon_sym_AMP_AMP] = ACTIONS(1253),
    [anon_sym_PIPE_PIPE] = ACTIONS(1253),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(413),
    [anon_sym_AMP_GT] = ACTIONS(411),
    [anon_sym_AMP_GT_GT] = ACTIONS(413),
    [anon_sym_LT_AMP] = ACTIONS(413),
    [anon_sym_GT_AMP] = ACTIONS(413),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(419),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1255),
  },
  [245] = {
    [sym_concatenation] = STATE(703),
    [sym_string] = STATE(704),
    [sym_simple_expansion] = STATE(704),
    [sym_string_expansion] = STATE(704),
    [sym_expansion] = STATE(704),
    [sym_command_substitution] = STATE(704),
    [sym_process_substitution] = STATE(704),
    [aux_sym__literal_repeat1] = STATE(705),
    [sym_regex] = ACTIONS(1257),
    [sym__special_character] = ACTIONS(427),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1259),
  },
  [246] = {
    [aux_sym_concatenation_repeat1] = STATE(198),
    [sym__simple_heredoc_body] = ACTIONS(1261),
    [sym__heredoc_body_beginning] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(1261),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [sym__special_character] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [247] = {
    [sym_concatenation] = STATE(706),
    [sym_string] = STATE(246),
    [sym_simple_expansion] = STATE(246),
    [sym_string_expansion] = STATE(246),
    [sym_expansion] = STATE(246),
    [sym_command_substitution] = STATE(246),
    [sym_process_substitution] = STATE(246),
    [aux_sym_command_repeat2] = STATE(706),
    [aux_sym__literal_repeat1] = STATE(248),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [ts_builtin_sym_end] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(427),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(431),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [248] = {
    [aux_sym__literal_repeat1] = STATE(255),
    [sym__simple_heredoc_body] = ACTIONS(1269),
    [sym__heredoc_body_beginning] = ACTIONS(1269),
    [sym_file_descriptor] = ACTIONS(1269),
    [ts_builtin_sym_end] = ACTIONS(1269),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE_AMP] = ACTIONS(1269),
    [anon_sym_AMP_AMP] = ACTIONS(1269),
    [anon_sym_PIPE_PIPE] = ACTIONS(1269),
    [anon_sym_EQ_TILDE] = ACTIONS(1271),
    [anon_sym_EQ_EQ] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT_GT] = ACTIONS(1269),
    [anon_sym_LT_AMP] = ACTIONS(1269),
    [anon_sym_GT_AMP] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_LT_LT_DASH] = ACTIONS(1269),
    [anon_sym_LT_LT_LT] = ACTIONS(1269),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(1269),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1269),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1269),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [anon_sym_LT_LPAREN] = ACTIONS(1269),
    [anon_sym_GT_LPAREN] = ACTIONS(1269),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1271),
  },
  [249] = {
    [sym_file_redirect] = STATE(244),
    [sym_heredoc_redirect] = STATE(244),
    [sym_heredoc_body] = STATE(708),
    [sym_herestring_redirect] = STATE(244),
    [aux_sym_redirected_statement_repeat1] = STATE(244),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(397),
    [ts_builtin_sym_end] = ACTIONS(1237),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(403),
    [anon_sym_SEMI_SEMI] = ACTIONS(1275),
    [anon_sym_PIPE_AMP] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(413),
    [anon_sym_AMP_GT] = ACTIONS(411),
    [anon_sym_AMP_GT_GT] = ACTIONS(413),
    [anon_sym_LT_AMP] = ACTIONS(413),
    [anon_sym_GT_AMP] = ACTIONS(413),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(419),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1273),
  },
  [250] = {
    [sym_file_redirect] = STATE(244),
    [sym_heredoc_redirect] = STATE(244),
    [sym_heredoc_body] = STATE(708),
    [sym_herestring_redirect] = STATE(244),
    [aux_sym_redirected_statement_repeat1] = STATE(244),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [ts_builtin_sym_end] = ACTIONS(1237),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(403),
    [anon_sym_SEMI_SEMI] = ACTIONS(1275),
    [anon_sym_PIPE_AMP] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(419),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1273),
  },
  [251] = {
    [sym_redirected_statement] = STATE(712),
    [sym_for_statement] = STATE(712),
    [sym_c_style_for_statement] = STATE(712),
    [sym_while_statement] = STATE(712),
    [sym_if_statement] = STATE(712),
    [sym_case_statement] = STATE(712),
    [sym_function_definition] = STATE(712),
    [sym_compound_statement] = STATE(712),
    [sym_subshell] = STATE(712),
    [sym_pipeline] = STATE(712),
    [sym_list] = STATE(712),
    [sym_negated_command] = STATE(712),
    [sym_test_command] = STATE(712),
    [sym_declaration_command] = STATE(712),
    [sym_unset_command] = STATE(712),
    [sym_command] = STATE(712),
    [sym_command_name] = STATE(713),
    [sym_variable_assignment] = STATE(714),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(715),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(251),
    [aux_sym_command_repeat1] = STATE(715),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(1277),
    [sym_variable_name] = ACTIONS(1280),
    [anon_sym_for] = ACTIONS(1283),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1286),
    [anon_sym_while] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1292),
    [anon_sym_case] = ACTIONS(1295),
    [anon_sym_function] = ACTIONS(1298),
    [anon_sym_LPAREN] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_LBRACK] = ACTIONS(1310),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1313),
    [anon_sym_declare] = ACTIONS(1316),
    [anon_sym_typeset] = ACTIONS(1316),
    [anon_sym_export] = ACTIONS(1316),
    [anon_sym_readonly] = ACTIONS(1316),
    [anon_sym_local] = ACTIONS(1316),
    [anon_sym_unset] = ACTIONS(1319),
    [anon_sym_unsetenv] = ACTIONS(1319),
    [anon_sym_LT] = ACTIONS(1322),
    [anon_sym_GT] = ACTIONS(1322),
    [anon_sym_GT_GT] = ACTIONS(1325),
    [anon_sym_AMP_GT] = ACTIONS(1322),
    [anon_sym_AMP_GT_GT] = ACTIONS(1325),
    [anon_sym_LT_AMP] = ACTIONS(1325),
    [anon_sym_GT_AMP] = ACTIONS(1325),
    [sym__special_character] = ACTIONS(1328),
    [anon_sym_DQUOTE] = ACTIONS(1331),
    [anon_sym_DOLLAR] = ACTIONS(1334),
    [sym_raw_string] = ACTIONS(1337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1340),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1343),
    [anon_sym_BQUOTE] = ACTIONS(1346),
    [anon_sym_LT_LPAREN] = ACTIONS(1349),
    [anon_sym_GT_LPAREN] = ACTIONS(1349),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1352),
  },
  [252] = {
    [sym_concatenation] = STATE(716),
    [sym_string] = STATE(246),
    [sym_simple_expansion] = STATE(246),
    [sym_string_expansion] = STATE(246),
    [sym_expansion] = STATE(246),
    [sym_command_substitution] = STATE(246),
    [sym_process_substitution] = STATE(246),
    [aux_sym_command_repeat2] = STATE(716),
    [aux_sym__literal_repeat1] = STATE(248),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [ts_builtin_sym_end] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(427),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(431),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [253] = {
    [sym_variable_assignment] = STATE(253),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(253),
    [aux_sym_command_repeat1] = STATE(253),
    [sym_file_descriptor] = ACTIONS(1355),
    [sym_variable_name] = ACTIONS(1358),
    [anon_sym_LT] = ACTIONS(1361),
    [anon_sym_GT] = ACTIONS(1361),
    [anon_sym_GT_GT] = ACTIONS(1364),
    [anon_sym_AMP_GT] = ACTIONS(1361),
    [anon_sym_AMP_GT_GT] = ACTIONS(1364),
    [anon_sym_LT_AMP] = ACTIONS(1364),
    [anon_sym_GT_AMP] = ACTIONS(1364),
    [sym__special_character] = ACTIONS(1367),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [anon_sym_DOLLAR] = ACTIONS(1369),
    [sym_raw_string] = ACTIONS(1367),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1367),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1367),
    [anon_sym_BQUOTE] = ACTIONS(1367),
    [anon_sym_LT_LPAREN] = ACTIONS(1367),
    [anon_sym_GT_LPAREN] = ACTIONS(1367),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1367),
  },
  [254] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [ts_builtin_sym_end] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_RPAREN] = ACTIONS(325),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [255] = {
    [aux_sym__literal_repeat1] = STATE(255),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [ts_builtin_sym_end] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_EQ_TILDE] = ACTIONS(1373),
    [anon_sym_EQ_EQ] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(1375),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [256] = {
    [aux_sym_concatenation_repeat1] = STATE(594),
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(1023),
    [sym_variable_name] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_AMP] = ACTIONS(1378),
    [anon_sym_GT_AMP] = ACTIONS(1378),
    [sym__special_character] = ACTIONS(1378),
    [anon_sym_DQUOTE] = ACTIONS(1378),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [sym_raw_string] = ACTIONS(1378),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1378),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1378),
    [anon_sym_BQUOTE] = ACTIONS(1378),
    [anon_sym_LT_LPAREN] = ACTIONS(1378),
    [anon_sym_GT_LPAREN] = ACTIONS(1378),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1378),
  },
  [257] = {
    [sym_file_descriptor] = ACTIONS(1378),
    [sym_variable_name] = ACTIONS(1378),
    [anon_sym_RPAREN] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_AMP] = ACTIONS(1378),
    [anon_sym_GT_AMP] = ACTIONS(1378),
    [sym__special_character] = ACTIONS(1378),
    [anon_sym_DQUOTE] = ACTIONS(1378),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [sym_raw_string] = ACTIONS(1378),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1378),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1378),
    [anon_sym_BQUOTE] = ACTIONS(1378),
    [anon_sym_LT_LPAREN] = ACTIONS(1378),
    [anon_sym_GT_LPAREN] = ACTIONS(1378),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1378),
  },
  [258] = {
    [aux_sym__literal_repeat1] = STATE(610),
    [sym_file_descriptor] = ACTIONS(1382),
    [sym_variable_name] = ACTIONS(1382),
    [anon_sym_LT] = ACTIONS(1384),
    [anon_sym_GT] = ACTIONS(1384),
    [anon_sym_GT_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT_GT] = ACTIONS(1382),
    [anon_sym_LT_AMP] = ACTIONS(1382),
    [anon_sym_GT_AMP] = ACTIONS(1382),
    [sym__special_character] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1382),
    [anon_sym_DOLLAR] = ACTIONS(1384),
    [sym_raw_string] = ACTIONS(1382),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1382),
    [anon_sym_BQUOTE] = ACTIONS(1382),
    [anon_sym_LT_LPAREN] = ACTIONS(1382),
    [anon_sym_GT_LPAREN] = ACTIONS(1382),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1382),
  },
  [259] = {
    [aux_sym_concatenation_repeat1] = STATE(717),
    [sym__concat] = ACTIONS(325),
    [anon_sym_RBRACK] = ACTIONS(325),
    [sym__special_character] = ACTIONS(329),
    [sym_comment] = ACTIONS(57),
  },
  [260] = {
    [aux_sym_concatenation_repeat1] = STATE(717),
    [sym__concat] = ACTIONS(1386),
    [anon_sym_RBRACK] = ACTIONS(1388),
    [sym_comment] = ACTIONS(57),
  },
  [261] = {
    [sym__concat] = ACTIONS(1390),
    [anon_sym_RBRACK] = ACTIONS(1388),
    [sym_comment] = ACTIONS(57),
  },
  [262] = {
    [aux_sym__literal_repeat1] = STATE(724),
    [sym__concat] = ACTIONS(1392),
    [anon_sym_RBRACK] = ACTIONS(1394),
    [sym__special_character] = ACTIONS(1396),
    [sym_comment] = ACTIONS(57),
  },
  [263] = {
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym_variable_name] = ACTIONS(1398),
    [ts_builtin_sym_end] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_RPAREN] = ACTIONS(1398),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [264] = {
    [sym_concatenation] = STATE(734),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(734),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(1402),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [265] = {
    [aux_sym_concatenation_repeat1] = STATE(737),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(1420),
    [sym_variable_name] = ACTIONS(325),
    [ts_builtin_sym_end] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [266] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(740),
    [anon_sym_DQUOTE] = ACTIONS(1422),
    [anon_sym_DOLLAR] = ACTIONS(1424),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [267] = {
    [sym_string] = STATE(742),
    [anon_sym_DASH] = ACTIONS(1426),
    [anon_sym_DQUOTE] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(1426),
    [sym_raw_string] = ACTIONS(1428),
    [anon_sym_POUND] = ACTIONS(1426),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1430),
    [anon_sym_STAR] = ACTIONS(1432),
    [anon_sym_AT] = ACTIONS(1432),
    [anon_sym_QMARK] = ACTIONS(1432),
    [anon_sym_0] = ACTIONS(1430),
    [anon_sym__] = ACTIONS(1430),
  },
  [268] = {
    [aux_sym_concatenation_repeat1] = STATE(737),
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym__concat] = ACTIONS(1420),
    [sym_variable_name] = ACTIONS(1398),
    [ts_builtin_sym_end] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [269] = {
    [sym_subscript] = STATE(747),
    [sym_variable_name] = ACTIONS(1434),
    [anon_sym_BANG] = ACTIONS(1436),
    [anon_sym_DASH] = ACTIONS(1438),
    [anon_sym_DOLLAR] = ACTIONS(1438),
    [anon_sym_POUND] = ACTIONS(1436),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1440),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(1442),
    [anon_sym_QMARK] = ACTIONS(1442),
    [anon_sym_0] = ACTIONS(1440),
    [anon_sym__] = ACTIONS(1440),
  },
  [270] = {
    [sym__statements] = STATE(748),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(749),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [271] = {
    [sym__statements] = STATE(750),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [272] = {
    [sym__statements] = STATE(751),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [273] = {
    [aux_sym__literal_repeat1] = STATE(753),
    [sym__simple_heredoc_body] = ACTIONS(1444),
    [sym__heredoc_body_beginning] = ACTIONS(1444),
    [sym_file_descriptor] = ACTIONS(1444),
    [sym_variable_name] = ACTIONS(1444),
    [ts_builtin_sym_end] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1446),
    [anon_sym_SEMI_SEMI] = ACTIONS(1444),
    [anon_sym_PIPE_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1446),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_AMP_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT_GT] = ACTIONS(1444),
    [anon_sym_LT_AMP] = ACTIONS(1444),
    [anon_sym_GT_AMP] = ACTIONS(1444),
    [anon_sym_LT_LT] = ACTIONS(1446),
    [anon_sym_LT_LT_DASH] = ACTIONS(1444),
    [anon_sym_LT_LT_LT] = ACTIONS(1444),
    [sym__special_character] = ACTIONS(1448),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [anon_sym_DOLLAR] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1444),
    [anon_sym_BQUOTE] = ACTIONS(1444),
    [anon_sym_LT_LPAREN] = ACTIONS(1444),
    [anon_sym_GT_LPAREN] = ACTIONS(1444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1446),
    [anon_sym_LF] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1446),
  },
  [274] = {
    [sym__expression] = STATE(755),
    [sym_binary_expression] = STATE(755),
    [sym_unary_expression] = STATE(755),
    [sym_postfix_expression] = STATE(755),
    [sym_parenthesized_expression] = STATE(755),
    [sym_concatenation] = STATE(755),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [anon_sym_SEMI] = ACTIONS(1450),
    [anon_sym_SEMI_SEMI] = ACTIONS(1452),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [sym__special_character] = ACTIONS(477),
    [anon_sym_DQUOTE] = ACTIONS(479),
    [anon_sym_DOLLAR] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
    [anon_sym_LF] = ACTIONS(1452),
    [anon_sym_AMP] = ACTIONS(1452),
  },
  [275] = {
    [sym__expression] = STATE(756),
    [sym_binary_expression] = STATE(756),
    [sym_unary_expression] = STATE(756),
    [sym_postfix_expression] = STATE(756),
    [sym_parenthesized_expression] = STATE(756),
    [sym_concatenation] = STATE(756),
    [sym_string] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [sym_expansion] = STATE(294),
    [sym_command_substitution] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(300),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_BANG] = ACTIONS(505),
    [sym__special_character] = ACTIONS(507),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(523),
    [sym_test_operator] = ACTIONS(525),
  },
  [276] = {
    [sym__expression] = STATE(757),
    [sym_binary_expression] = STATE(757),
    [sym_unary_expression] = STATE(757),
    [sym_postfix_expression] = STATE(757),
    [sym_parenthesized_expression] = STATE(757),
    [sym_concatenation] = STATE(757),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [sym__special_character] = ACTIONS(477),
    [anon_sym_DQUOTE] = ACTIONS(479),
    [anon_sym_DOLLAR] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
  },
  [277] = {
    [aux_sym_concatenation_repeat1] = STATE(759),
    [sym__concat] = ACTIONS(1454),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(325),
    [anon_sym_EQ_EQ] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_PLUS_EQ] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_BANG_EQ] = ACTIONS(325),
    [anon_sym_PLUS] = ACTIONS(329),
    [anon_sym_DASH] = ACTIONS(329),
    [anon_sym_DASH_EQ] = ACTIONS(325),
    [anon_sym_LT_EQ] = ACTIONS(325),
    [anon_sym_GT_EQ] = ACTIONS(325),
    [anon_sym_PLUS_PLUS] = ACTIONS(325),
    [anon_sym_DASH_DASH] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(325),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [278] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(762),
    [anon_sym_DQUOTE] = ACTIONS(1456),
    [anon_sym_DOLLAR] = ACTIONS(1458),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [279] = {
    [sym_string] = STATE(764),
    [anon_sym_DASH] = ACTIONS(1460),
    [anon_sym_DQUOTE] = ACTIONS(479),
    [anon_sym_DOLLAR] = ACTIONS(1460),
    [sym_raw_string] = ACTIONS(1462),
    [anon_sym_POUND] = ACTIONS(1460),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1464),
    [anon_sym_STAR] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1466),
    [anon_sym_QMARK] = ACTIONS(1466),
    [anon_sym_0] = ACTIONS(1464),
    [anon_sym__] = ACTIONS(1464),
  },
  [280] = {
    [aux_sym_concatenation_repeat1] = STATE(759),
    [sym__concat] = ACTIONS(1454),
    [anon_sym_SEMI] = ACTIONS(543),
    [anon_sym_SEMI_SEMI] = ACTIONS(541),
    [anon_sym_AMP_AMP] = ACTIONS(541),
    [anon_sym_PIPE_PIPE] = ACTIONS(541),
    [anon_sym_EQ_TILDE] = ACTIONS(541),
    [anon_sym_EQ_EQ] = ACTIONS(541),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_PLUS_EQ] = ACTIONS(541),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_BANG_EQ] = ACTIONS(541),
    [anon_sym_PLUS] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(543),
    [anon_sym_DASH_EQ] = ACTIONS(541),
    [anon_sym_LT_EQ] = ACTIONS(541),
    [anon_sym_GT_EQ] = ACTIONS(541),
    [anon_sym_PLUS_PLUS] = ACTIONS(541),
    [anon_sym_DASH_DASH] = ACTIONS(541),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(541),
    [anon_sym_LF] = ACTIONS(541),
    [anon_sym_AMP] = ACTIONS(543),
  },
  [281] = {
    [sym_subscript] = STATE(769),
    [sym_variable_name] = ACTIONS(1468),
    [anon_sym_BANG] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1472),
    [anon_sym_DOLLAR] = ACTIONS(1472),
    [anon_sym_POUND] = ACTIONS(1470),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1474),
    [anon_sym_STAR] = ACTIONS(1476),
    [anon_sym_AT] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1476),
    [anon_sym_0] = ACTIONS(1474),
    [anon_sym__] = ACTIONS(1474),
  },
  [282] = {
    [sym__statements] = STATE(770),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(771),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [283] = {
    [sym__statements] = STATE(772),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [284] = {
    [sym__statements] = STATE(773),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [285] = {
    [anon_sym_SEMI] = ACTIONS(1478),
    [anon_sym_SEMI_SEMI] = ACTIONS(1480),
    [anon_sym_AMP_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1482),
    [anon_sym_EQ_TILDE] = ACTIONS(1484),
    [anon_sym_EQ_EQ] = ACTIONS(1484),
    [anon_sym_EQ] = ACTIONS(1486),
    [anon_sym_PLUS_EQ] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(1486),
    [anon_sym_GT] = ACTIONS(1486),
    [anon_sym_BANG_EQ] = ACTIONS(1482),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_DASH_EQ] = ACTIONS(1482),
    [anon_sym_LT_EQ] = ACTIONS(1482),
    [anon_sym_GT_EQ] = ACTIONS(1482),
    [anon_sym_PLUS_PLUS] = ACTIONS(1488),
    [anon_sym_DASH_DASH] = ACTIONS(1488),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1482),
    [anon_sym_LF] = ACTIONS(1480),
    [anon_sym_AMP] = ACTIONS(1478),
  },
  [286] = {
    [aux_sym__literal_repeat1] = STATE(779),
    [anon_sym_SEMI] = ACTIONS(567),
    [anon_sym_SEMI_SEMI] = ACTIONS(565),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_EQ_EQ] = ACTIONS(565),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(565),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym__special_character] = ACTIONS(1490),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(565),
    [anon_sym_LF] = ACTIONS(565),
    [anon_sym_AMP] = ACTIONS(567),
  },
  [287] = {
    [sym_concatenation] = STATE(788),
    [sym_string] = STATE(783),
    [sym_simple_expansion] = STATE(783),
    [sym_string_expansion] = STATE(783),
    [sym_expansion] = STATE(783),
    [sym_command_substitution] = STATE(783),
    [sym_process_substitution] = STATE(783),
    [aux_sym_for_statement_repeat1] = STATE(788),
    [aux_sym__literal_repeat1] = STATE(789),
    [sym__special_character] = ACTIONS(1492),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [anon_sym_DOLLAR] = ACTIONS(1496),
    [sym_raw_string] = ACTIONS(1498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1502),
    [anon_sym_BQUOTE] = ACTIONS(1504),
    [anon_sym_LT_LPAREN] = ACTIONS(1506),
    [anon_sym_GT_LPAREN] = ACTIONS(1506),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1498),
  },
  [288] = {
    [sym_do_group] = STATE(790),
    [anon_sym_do] = ACTIONS(651),
    [sym_comment] = ACTIONS(57),
  },
  [289] = {
    [sym__expression] = STATE(791),
    [sym_binary_expression] = STATE(791),
    [sym_unary_expression] = STATE(791),
    [sym_postfix_expression] = STATE(791),
    [sym_parenthesized_expression] = STATE(791),
    [sym_concatenation] = STATE(791),
    [sym_string] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [sym_expansion] = STATE(294),
    [sym_command_substitution] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(300),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_BANG] = ACTIONS(505),
    [sym__special_character] = ACTIONS(507),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(523),
    [sym_test_operator] = ACTIONS(525),
  },
  [290] = {
    [sym__expression] = STATE(792),
    [sym_binary_expression] = STATE(792),
    [sym_unary_expression] = STATE(792),
    [sym_postfix_expression] = STATE(792),
    [sym_parenthesized_expression] = STATE(792),
    [sym_concatenation] = STATE(792),
    [sym_string] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [sym_expansion] = STATE(294),
    [sym_command_substitution] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(300),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_BANG] = ACTIONS(505),
    [sym__special_character] = ACTIONS(507),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(523),
    [sym_test_operator] = ACTIONS(525),
  },
  [291] = {
    [aux_sym_concatenation_repeat1] = STATE(794),
    [sym__concat] = ACTIONS(1508),
    [anon_sym_RPAREN] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(325),
    [anon_sym_EQ_EQ] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_PLUS_EQ] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_BANG_EQ] = ACTIONS(325),
    [anon_sym_PLUS] = ACTIONS(329),
    [anon_sym_DASH] = ACTIONS(329),
    [anon_sym_DASH_EQ] = ACTIONS(325),
    [anon_sym_LT_EQ] = ACTIONS(325),
    [anon_sym_GT_EQ] = ACTIONS(325),
    [anon_sym_PLUS_PLUS] = ACTIONS(325),
    [anon_sym_DASH_DASH] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(325),
  },
  [292] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(797),
    [anon_sym_DQUOTE] = ACTIONS(1510),
    [anon_sym_DOLLAR] = ACTIONS(1512),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [293] = {
    [sym_string] = STATE(799),
    [anon_sym_DASH] = ACTIONS(1514),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(1514),
    [sym_raw_string] = ACTIONS(1516),
    [anon_sym_POUND] = ACTIONS(1514),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1518),
    [anon_sym_STAR] = ACTIONS(1520),
    [anon_sym_AT] = ACTIONS(1520),
    [anon_sym_QMARK] = ACTIONS(1520),
    [anon_sym_0] = ACTIONS(1518),
    [anon_sym__] = ACTIONS(1518),
  },
  [294] = {
    [aux_sym_concatenation_repeat1] = STATE(794),
    [sym__concat] = ACTIONS(1508),
    [anon_sym_RPAREN] = ACTIONS(541),
    [anon_sym_AMP_AMP] = ACTIONS(541),
    [anon_sym_PIPE_PIPE] = ACTIONS(541),
    [anon_sym_EQ_TILDE] = ACTIONS(541),
    [anon_sym_EQ_EQ] = ACTIONS(541),
    [anon_sym_EQ] = ACTIONS(543),
    [anon_sym_PLUS_EQ] = ACTIONS(541),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_BANG_EQ] = ACTIONS(541),
    [anon_sym_PLUS] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(543),
    [anon_sym_DASH_EQ] = ACTIONS(541),
    [anon_sym_LT_EQ] = ACTIONS(541),
    [anon_sym_GT_EQ] = ACTIONS(541),
    [anon_sym_PLUS_PLUS] = ACTIONS(541),
    [anon_sym_DASH_DASH] = ACTIONS(541),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(541),
  },
  [295] = {
    [sym_subscript] = STATE(804),
    [sym_variable_name] = ACTIONS(1522),
    [anon_sym_BANG] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1526),
    [anon_sym_DOLLAR] = ACTIONS(1526),
    [anon_sym_POUND] = ACTIONS(1524),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1528),
    [anon_sym_STAR] = ACTIONS(1530),
    [anon_sym_AT] = ACTIONS(1530),
    [anon_sym_QMARK] = ACTIONS(1530),
    [anon_sym_0] = ACTIONS(1528),
    [anon_sym__] = ACTIONS(1528),
  },
  [296] = {
    [sym__statements] = STATE(805),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(806),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [297] = {
    [sym__statements] = STATE(807),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [298] = {
    [sym__statements] = STATE(808),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [299] = {
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_AMP_AMP] = ACTIONS(1534),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_EQ_TILDE] = ACTIONS(1536),
    [anon_sym_EQ_EQ] = ACTIONS(1536),
    [anon_sym_EQ] = ACTIONS(1538),
    [anon_sym_PLUS_EQ] = ACTIONS(1534),
    [anon_sym_LT] = ACTIONS(1538),
    [anon_sym_GT] = ACTIONS(1538),
    [anon_sym_BANG_EQ] = ACTIONS(1534),
    [anon_sym_PLUS] = ACTIONS(1538),
    [anon_sym_DASH] = ACTIONS(1538),
    [anon_sym_DASH_EQ] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1534),
    [anon_sym_GT_EQ] = ACTIONS(1534),
    [anon_sym_PLUS_PLUS] = ACTIONS(1540),
    [anon_sym_DASH_DASH] = ACTIONS(1540),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1534),
  },
  [300] = {
    [aux_sym__literal_repeat1] = STATE(814),
    [anon_sym_RPAREN] = ACTIONS(565),
    [anon_sym_AMP_AMP] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_EQ_EQ] = ACTIONS(565),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(565),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [sym__special_character] = ACTIONS(1542),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(565),
  },
  [301] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1544),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [302] = {
    [sym_string] = STATE(815),
    [sym_simple_expansion] = STATE(815),
    [sym_string_expansion] = STATE(815),
    [sym_expansion] = STATE(815),
    [sym_command_substitution] = STATE(815),
    [sym_process_substitution] = STATE(815),
    [sym__special_character] = ACTIONS(1546),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(1546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1546),
  },
  [303] = {
    [aux_sym_concatenation_repeat1] = STATE(816),
    [sym__concat] = ACTIONS(527),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_EQ_TILDE] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1059),
    [anon_sym_EQ] = ACTIONS(1061),
    [anon_sym_PLUS_EQ] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_BANG_EQ] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_DASH_EQ] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1059),
  },
  [304] = {
    [sym__concat] = ACTIONS(1063),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1063),
    [anon_sym_EQ_TILDE] = ACTIONS(1063),
    [anon_sym_EQ_EQ] = ACTIONS(1063),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_PLUS_EQ] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG_EQ] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1063),
  },
  [305] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1548),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [306] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(1548),
    [anon_sym_DOLLAR] = ACTIONS(1550),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [307] = {
    [sym__concat] = ACTIONS(1097),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1097),
    [anon_sym_EQ_TILDE] = ACTIONS(1097),
    [anon_sym_EQ_EQ] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_PLUS_EQ] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_BANG_EQ] = ACTIONS(1097),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_DASH_EQ] = ACTIONS(1097),
    [anon_sym_LT_EQ] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1097),
  },
  [308] = {
    [sym__concat] = ACTIONS(1101),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1101),
    [anon_sym_EQ_TILDE] = ACTIONS(1101),
    [anon_sym_EQ_EQ] = ACTIONS(1101),
    [anon_sym_EQ] = ACTIONS(1103),
    [anon_sym_PLUS_EQ] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_DASH_EQ] = ACTIONS(1101),
    [anon_sym_LT_EQ] = ACTIONS(1101),
    [anon_sym_GT_EQ] = ACTIONS(1101),
    [anon_sym_PLUS_PLUS] = ACTIONS(1101),
    [anon_sym_DASH_DASH] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1101),
  },
  [309] = {
    [sym__concat] = ACTIONS(1105),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1105),
    [anon_sym_EQ_TILDE] = ACTIONS(1105),
    [anon_sym_EQ_EQ] = ACTIONS(1105),
    [anon_sym_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_BANG_EQ] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1107),
    [anon_sym_DASH] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1105),
    [anon_sym_LT_EQ] = ACTIONS(1105),
    [anon_sym_GT_EQ] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1105),
    [anon_sym_DASH_DASH] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1105),
  },
  [310] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(1552),
    [sym_comment] = ACTIONS(57),
  },
  [311] = {
    [sym_subscript] = STATE(822),
    [sym_variable_name] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_DOLLAR] = ACTIONS(1556),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1558),
    [anon_sym_STAR] = ACTIONS(1560),
    [anon_sym_AT] = ACTIONS(1560),
    [anon_sym_QMARK] = ACTIONS(1560),
    [anon_sym_0] = ACTIONS(1558),
    [anon_sym__] = ACTIONS(1558),
  },
  [312] = {
    [sym_concatenation] = STATE(825),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(825),
    [anon_sym_RBRACE] = ACTIONS(1562),
    [anon_sym_EQ] = ACTIONS(1564),
    [anon_sym_DASH] = ACTIONS(1564),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(1566),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1568),
    [anon_sym_COLON] = ACTIONS(1564),
    [anon_sym_COLON_QMARK] = ACTIONS(1564),
    [anon_sym_COLON_DASH] = ACTIONS(1564),
    [anon_sym_PERCENT] = ACTIONS(1564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [313] = {
    [sym_concatenation] = STATE(828),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(828),
    [anon_sym_RBRACE] = ACTIONS(1570),
    [anon_sym_EQ] = ACTIONS(1572),
    [anon_sym_DASH] = ACTIONS(1572),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(1574),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1576),
    [anon_sym_COLON] = ACTIONS(1572),
    [anon_sym_COLON_QMARK] = ACTIONS(1572),
    [anon_sym_COLON_DASH] = ACTIONS(1572),
    [anon_sym_PERCENT] = ACTIONS(1572),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [314] = {
    [anon_sym_RPAREN] = ACTIONS(1578),
    [sym_comment] = ACTIONS(57),
  },
  [315] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(1578),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [316] = {
    [anon_sym_BQUOTE] = ACTIONS(1578),
    [sym_comment] = ACTIONS(57),
  },
  [317] = {
    [anon_sym_RPAREN] = ACTIONS(1580),
    [sym_comment] = ACTIONS(57),
  },
  [318] = {
    [sym__simple_heredoc_body] = ACTIONS(1582),
    [sym__heredoc_body_beginning] = ACTIONS(1582),
    [sym_file_descriptor] = ACTIONS(1582),
    [ts_builtin_sym_end] = ACTIONS(1582),
    [anon_sym_SEMI] = ACTIONS(1584),
    [anon_sym_done] = ACTIONS(1582),
    [anon_sym_fi] = ACTIONS(1582),
    [anon_sym_elif] = ACTIONS(1582),
    [anon_sym_else] = ACTIONS(1582),
    [anon_sym_esac] = ACTIONS(1582),
    [anon_sym_PIPE] = ACTIONS(1584),
    [anon_sym_RPAREN] = ACTIONS(1582),
    [anon_sym_SEMI_SEMI] = ACTIONS(1582),
    [anon_sym_PIPE_AMP] = ACTIONS(1582),
    [anon_sym_AMP_AMP] = ACTIONS(1582),
    [anon_sym_PIPE_PIPE] = ACTIONS(1582),
    [anon_sym_LT] = ACTIONS(1584),
    [anon_sym_GT] = ACTIONS(1584),
    [anon_sym_GT_GT] = ACTIONS(1582),
    [anon_sym_AMP_GT] = ACTIONS(1584),
    [anon_sym_AMP_GT_GT] = ACTIONS(1582),
    [anon_sym_LT_AMP] = ACTIONS(1582),
    [anon_sym_GT_AMP] = ACTIONS(1582),
    [anon_sym_LT_LT] = ACTIONS(1584),
    [anon_sym_LT_LT_DASH] = ACTIONS(1582),
    [anon_sym_LT_LT_LT] = ACTIONS(1582),
    [anon_sym_BQUOTE] = ACTIONS(1582),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1584),
  },
  [319] = {
    [sym__expression] = STATE(831),
    [sym_binary_expression] = STATE(831),
    [sym_unary_expression] = STATE(831),
    [sym_postfix_expression] = STATE(831),
    [sym_parenthesized_expression] = STATE(831),
    [sym_concatenation] = STATE(831),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_character] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [320] = {
    [sym__expression] = STATE(831),
    [sym_binary_expression] = STATE(831),
    [sym_unary_expression] = STATE(831),
    [sym_postfix_expression] = STATE(831),
    [sym_parenthesized_expression] = STATE(831),
    [sym_concatenation] = STATE(831),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [sym_regex] = ACTIONS(1586),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_character] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [321] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1588),
    [anon_sym_AMP_AMP] = ACTIONS(1588),
    [anon_sym_PIPE_PIPE] = ACTIONS(1588),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1588),
    [anon_sym_EQ_TILDE] = ACTIONS(1588),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_EQ] = ACTIONS(1590),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_PLUS] = ACTIONS(1590),
    [anon_sym_DASH] = ACTIONS(1590),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_PLUS] = ACTIONS(1588),
    [anon_sym_DASH_DASH] = ACTIONS(1588),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1588),
  },
  [322] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(325),
    [anon_sym_EQ_EQ] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_PLUS_EQ] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_BANG_EQ] = ACTIONS(325),
    [anon_sym_PLUS] = ACTIONS(329),
    [anon_sym_DASH] = ACTIONS(329),
    [anon_sym_DASH_EQ] = ACTIONS(325),
    [anon_sym_LT_EQ] = ACTIONS(325),
    [anon_sym_GT_EQ] = ACTIONS(325),
    [anon_sym_PLUS_PLUS] = ACTIONS(325),
    [anon_sym_DASH_DASH] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(325),
  },
  [323] = {
    [aux_sym__literal_repeat1] = STATE(323),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_EQ_TILDE] = ACTIONS(1371),
    [anon_sym_EQ_EQ] = ACTIONS(1371),
    [anon_sym_EQ] = ACTIONS(1373),
    [anon_sym_PLUS_EQ] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_BANG_EQ] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1373),
    [anon_sym_DASH] = ACTIONS(1373),
    [anon_sym_DASH_EQ] = ACTIONS(1371),
    [anon_sym_LT_EQ] = ACTIONS(1371),
    [anon_sym_GT_EQ] = ACTIONS(1371),
    [anon_sym_PLUS_PLUS] = ACTIONS(1371),
    [anon_sym_DASH_DASH] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(1592),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1371),
  },
  [324] = {
    [sym_concatenation] = STATE(833),
    [sym_string] = STATE(838),
    [sym_array] = STATE(833),
    [sym_simple_expansion] = STATE(838),
    [sym_string_expansion] = STATE(838),
    [sym_expansion] = STATE(838),
    [sym_command_substitution] = STATE(838),
    [sym_process_substitution] = STATE(838),
    [aux_sym__literal_repeat1] = STATE(843),
    [sym__empty_value] = ACTIONS(1595),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [sym__special_character] = ACTIONS(1599),
    [anon_sym_DQUOTE] = ACTIONS(1601),
    [anon_sym_DOLLAR] = ACTIONS(1603),
    [sym_raw_string] = ACTIONS(1605),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1607),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1609),
    [anon_sym_BQUOTE] = ACTIONS(1611),
    [anon_sym_LT_LPAREN] = ACTIONS(1613),
    [anon_sym_GT_LPAREN] = ACTIONS(1613),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1605),
  },
  [325] = {
    [sym__expression] = STATE(845),
    [sym_binary_expression] = STATE(845),
    [sym_unary_expression] = STATE(845),
    [sym_postfix_expression] = STATE(845),
    [sym_parenthesized_expression] = STATE(845),
    [sym_concatenation] = STATE(845),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [anon_sym_SEMI] = ACTIONS(1615),
    [anon_sym_SEMI_SEMI] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [sym__special_character] = ACTIONS(477),
    [anon_sym_DQUOTE] = ACTIONS(479),
    [anon_sym_DOLLAR] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
    [anon_sym_LF] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
  },
  [326] = {
    [anon_sym_in] = ACTIONS(1619),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_SEMI_SEMI] = ACTIONS(1623),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1623),
    [anon_sym_AMP] = ACTIONS(1623),
  },
  [327] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1625),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [328] = {
    [sym_do_group] = STATE(850),
    [anon_sym_do] = ACTIONS(1627),
    [sym_comment] = ACTIONS(57),
  },
  [329] = {
    [anon_sym_then] = ACTIONS(1629),
    [sym_comment] = ACTIONS(57),
  },
  [330] = {
    [aux_sym_concatenation_repeat1] = STATE(398),
    [sym__concat] = ACTIONS(687),
    [anon_sym_in] = ACTIONS(1631),
    [anon_sym_SEMI] = ACTIONS(1633),
    [anon_sym_SEMI_SEMI] = ACTIONS(1635),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
  },
  [331] = {
    [anon_sym_in] = ACTIONS(1631),
    [anon_sym_SEMI] = ACTIONS(1633),
    [anon_sym_SEMI_SEMI] = ACTIONS(1635),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1635),
    [anon_sym_AMP] = ACTIONS(1635),
  },
  [332] = {
    [aux_sym__literal_repeat1] = STATE(418),
    [anon_sym_in] = ACTIONS(1637),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym_SEMI_SEMI] = ACTIONS(1641),
    [sym__special_character] = ACTIONS(723),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1641),
    [anon_sym_AMP] = ACTIONS(1641),
  },
  [333] = {
    [sym_compound_statement] = STATE(857),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [334] = {
    [anon_sym_RPAREN] = ACTIONS(1645),
    [sym_comment] = ACTIONS(57),
  },
  [335] = {
    [sym_file_descriptor] = ACTIONS(783),
    [anon_sym_SEMI] = ACTIONS(785),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_SEMI_SEMI] = ACTIONS(783),
    [anon_sym_PIPE_AMP] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(783),
    [anon_sym_AMP_GT] = ACTIONS(785),
    [anon_sym_AMP_GT_GT] = ACTIONS(783),
    [anon_sym_LT_AMP] = ACTIONS(783),
    [anon_sym_GT_AMP] = ACTIONS(783),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_DASH] = ACTIONS(783),
    [anon_sym_LT_LT_LT] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
  },
  [336] = {
    [anon_sym_RBRACE] = ACTIONS(1647),
    [sym_comment] = ACTIONS(57),
  },
  [337] = {
    [sym_file_descriptor] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_PIPE] = ACTIONS(897),
    [anon_sym_SEMI_SEMI] = ACTIONS(895),
    [anon_sym_PIPE_AMP] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(895),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(895),
    [anon_sym_LT_AMP] = ACTIONS(895),
    [anon_sym_GT_AMP] = ACTIONS(895),
    [anon_sym_LT_LT] = ACTIONS(897),
    [anon_sym_LT_LT_DASH] = ACTIONS(895),
    [anon_sym_LT_LT_LT] = ACTIONS(895),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(895),
    [anon_sym_AMP] = ACTIONS(897),
  },
  [338] = {
    [anon_sym_AMP_AMP] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(923),
    [anon_sym_RBRACK] = ACTIONS(1625),
    [anon_sym_EQ_TILDE] = ACTIONS(925),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(927),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_GT] = ACTIONS(927),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(923),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_PLUS_PLUS] = ACTIONS(929),
    [anon_sym_DASH_DASH] = ACTIONS(929),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(923),
  },
  [339] = {
    [anon_sym_AMP_AMP] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(933),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1625),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(935),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_PLUS_EQ] = ACTIONS(933),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_DASH] = ACTIONS(937),
    [anon_sym_DASH_EQ] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(933),
  },
  [340] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1649),
    [anon_sym_PLUS_EQ] = ACTIONS(1649),
    [sym_comment] = ACTIONS(57),
  },
  [341] = {
    [aux_sym_concatenation_repeat1] = STATE(862),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(1651),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [342] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(865),
    [anon_sym_DQUOTE] = ACTIONS(1653),
    [anon_sym_DOLLAR] = ACTIONS(1655),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [343] = {
    [sym_string] = STATE(867),
    [anon_sym_DASH] = ACTIONS(1657),
    [anon_sym_DQUOTE] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(1657),
    [sym_raw_string] = ACTIONS(1659),
    [anon_sym_POUND] = ACTIONS(1657),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1661),
    [anon_sym_STAR] = ACTIONS(1663),
    [anon_sym_AT] = ACTIONS(1663),
    [anon_sym_QMARK] = ACTIONS(1663),
    [anon_sym_0] = ACTIONS(1661),
    [anon_sym__] = ACTIONS(1661),
  },
  [344] = {
    [aux_sym_concatenation_repeat1] = STATE(862),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(1651),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [sym__special_character] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [345] = {
    [sym_subscript] = STATE(872),
    [sym_variable_name] = ACTIONS(1665),
    [anon_sym_BANG] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1669),
    [anon_sym_DOLLAR] = ACTIONS(1669),
    [anon_sym_POUND] = ACTIONS(1667),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1671),
    [anon_sym_STAR] = ACTIONS(1673),
    [anon_sym_AT] = ACTIONS(1673),
    [anon_sym_QMARK] = ACTIONS(1673),
    [anon_sym_0] = ACTIONS(1671),
    [anon_sym__] = ACTIONS(1671),
  },
  [346] = {
    [sym__statements] = STATE(873),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(874),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [347] = {
    [sym__statements] = STATE(875),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [348] = {
    [sym__statements] = STATE(876),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [349] = {
    [anon_sym_EQ] = ACTIONS(1649),
    [anon_sym_PLUS_EQ] = ACTIONS(1649),
    [sym_comment] = ACTIONS(57),
  },
  [350] = {
    [sym_variable_assignment] = STATE(877),
    [sym_subscript] = STATE(349),
    [sym_concatenation] = STATE(877),
    [sym_string] = STATE(344),
    [sym_simple_expansion] = STATE(344),
    [sym_string_expansion] = STATE(344),
    [sym_expansion] = STATE(344),
    [sym_command_substitution] = STATE(344),
    [sym_process_substitution] = STATE(344),
    [aux_sym_declaration_command_repeat1] = STATE(877),
    [aux_sym__literal_repeat1] = STATE(351),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [sym__special_character] = ACTIONS(585),
    [anon_sym_DQUOTE] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(589),
    [sym_raw_string] = ACTIONS(591),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(593),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(595),
    [anon_sym_BQUOTE] = ACTIONS(597),
    [anon_sym_LT_LPAREN] = ACTIONS(599),
    [anon_sym_GT_LPAREN] = ACTIONS(599),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1675),
    [sym_word] = ACTIONS(603),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [351] = {
    [aux_sym__literal_repeat1] = STATE(879),
    [sym_file_descriptor] = ACTIONS(977),
    [sym_variable_name] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(979),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(979),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [sym__special_character] = ACTIONS(1677),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(979),
    [sym_word] = ACTIONS(979),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
  },
  [352] = {
    [aux_sym_concatenation_repeat1] = STATE(881),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(1679),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [353] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(884),
    [anon_sym_DQUOTE] = ACTIONS(1681),
    [anon_sym_DOLLAR] = ACTIONS(1683),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [354] = {
    [sym_string] = STATE(886),
    [anon_sym_DASH] = ACTIONS(1685),
    [anon_sym_DQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(1685),
    [sym_raw_string] = ACTIONS(1687),
    [anon_sym_POUND] = ACTIONS(1685),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1689),
    [anon_sym_STAR] = ACTIONS(1691),
    [anon_sym_AT] = ACTIONS(1691),
    [anon_sym_QMARK] = ACTIONS(1691),
    [anon_sym_0] = ACTIONS(1689),
    [anon_sym__] = ACTIONS(1689),
  },
  [355] = {
    [aux_sym_concatenation_repeat1] = STATE(881),
    [sym_file_descriptor] = ACTIONS(997),
    [sym__concat] = ACTIONS(1679),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI_SEMI] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_AMP_GT] = ACTIONS(999),
    [anon_sym_AMP_GT_GT] = ACTIONS(997),
    [anon_sym_LT_AMP] = ACTIONS(997),
    [anon_sym_GT_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_LT_LT_DASH] = ACTIONS(997),
    [anon_sym_LT_LT_LT] = ACTIONS(997),
    [sym__special_character] = ACTIONS(997),
    [anon_sym_DQUOTE] = ACTIONS(997),
    [anon_sym_DOLLAR] = ACTIONS(999),
    [sym_raw_string] = ACTIONS(997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(997),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(997),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(999),
    [sym_word] = ACTIONS(999),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
  },
  [356] = {
    [sym_subscript] = STATE(891),
    [sym_variable_name] = ACTIONS(1693),
    [anon_sym_BANG] = ACTIONS(1695),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_DOLLAR] = ACTIONS(1697),
    [anon_sym_POUND] = ACTIONS(1695),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1699),
    [anon_sym_STAR] = ACTIONS(1701),
    [anon_sym_AT] = ACTIONS(1701),
    [anon_sym_QMARK] = ACTIONS(1701),
    [anon_sym_0] = ACTIONS(1699),
    [anon_sym__] = ACTIONS(1699),
  },
  [357] = {
    [sym__statements] = STATE(892),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(893),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [358] = {
    [sym__statements] = STATE(894),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [359] = {
    [sym__statements] = STATE(895),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [360] = {
    [sym_concatenation] = STATE(896),
    [sym_string] = STATE(355),
    [sym_simple_expansion] = STATE(355),
    [sym_string_expansion] = STATE(355),
    [sym_expansion] = STATE(355),
    [sym_command_substitution] = STATE(355),
    [sym_process_substitution] = STATE(355),
    [aux_sym_unset_command_repeat1] = STATE(896),
    [aux_sym__literal_repeat1] = STATE(361),
    [sym_file_descriptor] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1013),
    [anon_sym_GT] = ACTIONS(1013),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT] = ACTIONS(1013),
    [anon_sym_AMP_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_AMP] = ACTIONS(1011),
    [anon_sym_GT_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(1011),
    [anon_sym_LT_LT_LT] = ACTIONS(1011),
    [sym__special_character] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [sym_raw_string] = ACTIONS(611),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(615),
    [anon_sym_BQUOTE] = ACTIONS(617),
    [anon_sym_LT_LPAREN] = ACTIONS(619),
    [anon_sym_GT_LPAREN] = ACTIONS(619),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1703),
    [sym_word] = ACTIONS(623),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
  },
  [361] = {
    [aux_sym__literal_repeat1] = STATE(898),
    [sym_file_descriptor] = ACTIONS(1017),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1017),
    [anon_sym_PIPE_AMP] = ACTIONS(1017),
    [anon_sym_AMP_AMP] = ACTIONS(1017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1017),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1017),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1017),
    [anon_sym_LT_AMP] = ACTIONS(1017),
    [anon_sym_GT_AMP] = ACTIONS(1017),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1017),
    [anon_sym_LT_LT_LT] = ACTIONS(1017),
    [sym__special_character] = ACTIONS(1705),
    [anon_sym_DQUOTE] = ACTIONS(1017),
    [anon_sym_DOLLAR] = ACTIONS(1019),
    [sym_raw_string] = ACTIONS(1017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1017),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1017),
    [anon_sym_GT_LPAREN] = ACTIONS(1017),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1019),
    [sym_word] = ACTIONS(1019),
    [anon_sym_LF] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [362] = {
    [sym_string] = STATE(899),
    [sym_simple_expansion] = STATE(899),
    [sym_string_expansion] = STATE(899),
    [sym_expansion] = STATE(899),
    [sym_command_substitution] = STATE(899),
    [sym_process_substitution] = STATE(899),
    [sym__special_character] = ACTIONS(1707),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(1707),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1707),
  },
  [363] = {
    [aux_sym_concatenation_repeat1] = STATE(900),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(625),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_EQ_TILDE] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [364] = {
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_EQ_TILDE] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [365] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1709),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [366] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(1709),
    [anon_sym_DOLLAR] = ACTIONS(1711),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [367] = {
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_EQ_TILDE] = ACTIONS(1099),
    [anon_sym_EQ_EQ] = ACTIONS(1099),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [368] = {
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_EQ_TILDE] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [369] = {
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_EQ_TILDE] = ACTIONS(1107),
    [anon_sym_EQ_EQ] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [370] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(1713),
    [sym_comment] = ACTIONS(57),
  },
  [371] = {
    [sym_subscript] = STATE(906),
    [sym_variable_name] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1717),
    [anon_sym_DOLLAR] = ACTIONS(1717),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1719),
    [anon_sym_STAR] = ACTIONS(1721),
    [anon_sym_AT] = ACTIONS(1721),
    [anon_sym_QMARK] = ACTIONS(1721),
    [anon_sym_0] = ACTIONS(1719),
    [anon_sym__] = ACTIONS(1719),
  },
  [372] = {
    [sym_concatenation] = STATE(909),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(909),
    [anon_sym_RBRACE] = ACTIONS(1723),
    [anon_sym_EQ] = ACTIONS(1725),
    [anon_sym_DASH] = ACTIONS(1725),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(1727),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(1725),
    [anon_sym_COLON_QMARK] = ACTIONS(1725),
    [anon_sym_COLON_DASH] = ACTIONS(1725),
    [anon_sym_PERCENT] = ACTIONS(1725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [373] = {
    [sym_concatenation] = STATE(912),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(912),
    [anon_sym_RBRACE] = ACTIONS(1731),
    [anon_sym_EQ] = ACTIONS(1733),
    [anon_sym_DASH] = ACTIONS(1733),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(1735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1737),
    [anon_sym_COLON] = ACTIONS(1733),
    [anon_sym_COLON_QMARK] = ACTIONS(1733),
    [anon_sym_COLON_DASH] = ACTIONS(1733),
    [anon_sym_PERCENT] = ACTIONS(1733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [374] = {
    [anon_sym_RPAREN] = ACTIONS(1739),
    [sym_comment] = ACTIONS(57),
  },
  [375] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(1739),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [376] = {
    [anon_sym_BQUOTE] = ACTIONS(1739),
    [sym_comment] = ACTIONS(57),
  },
  [377] = {
    [anon_sym_RPAREN] = ACTIONS(1741),
    [sym_comment] = ACTIONS(57),
  },
  [378] = {
    [anon_sym_RPAREN] = ACTIONS(1743),
    [sym_comment] = ACTIONS(57),
  },
  [379] = {
    [sym__statements] = STATE(930),
    [sym_redirected_statement] = STATE(931),
    [sym_for_statement] = STATE(931),
    [sym_c_style_for_statement] = STATE(931),
    [sym_while_statement] = STATE(931),
    [sym_if_statement] = STATE(931),
    [sym_case_statement] = STATE(931),
    [sym_function_definition] = STATE(931),
    [sym_compound_statement] = STATE(931),
    [sym_subshell] = STATE(931),
    [sym_pipeline] = STATE(931),
    [sym_list] = STATE(931),
    [sym_negated_command] = STATE(931),
    [sym_test_command] = STATE(931),
    [sym_declaration_command] = STATE(931),
    [sym_unset_command] = STATE(931),
    [sym_command] = STATE(931),
    [sym_command_name] = STATE(932),
    [sym_variable_assignment] = STATE(933),
    [sym_subscript] = STATE(934),
    [sym_file_redirect] = STATE(937),
    [sym_concatenation] = STATE(935),
    [sym_string] = STATE(924),
    [sym_simple_expansion] = STATE(924),
    [sym_string_expansion] = STATE(924),
    [sym_expansion] = STATE(924),
    [sym_command_substitution] = STATE(924),
    [sym_process_substitution] = STATE(924),
    [aux_sym__statements_repeat1] = STATE(936),
    [aux_sym_command_repeat1] = STATE(937),
    [aux_sym__literal_repeat1] = STATE(938),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1745),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_done] = ACTIONS(1747),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1751),
    [anon_sym_typeset] = ACTIONS(1751),
    [anon_sym_export] = ACTIONS(1751),
    [anon_sym_readonly] = ACTIONS(1751),
    [anon_sym_local] = ACTIONS(1751),
    [anon_sym_unset] = ACTIONS(1753),
    [anon_sym_unsetenv] = ACTIONS(1753),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(1755),
    [anon_sym_DQUOTE] = ACTIONS(1757),
    [anon_sym_DOLLAR] = ACTIONS(1759),
    [sym_raw_string] = ACTIONS(1761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1765),
    [anon_sym_BQUOTE] = ACTIONS(1767),
    [anon_sym_LT_LPAREN] = ACTIONS(1769),
    [anon_sym_GT_LPAREN] = ACTIONS(1769),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1771),
  },
  [380] = {
    [sym__simple_heredoc_body] = ACTIONS(1773),
    [sym__heredoc_body_beginning] = ACTIONS(1773),
    [sym_file_descriptor] = ACTIONS(1773),
    [ts_builtin_sym_end] = ACTIONS(1773),
    [anon_sym_SEMI] = ACTIONS(1775),
    [anon_sym_done] = ACTIONS(1773),
    [anon_sym_fi] = ACTIONS(1773),
    [anon_sym_elif] = ACTIONS(1773),
    [anon_sym_else] = ACTIONS(1773),
    [anon_sym_esac] = ACTIONS(1773),
    [anon_sym_PIPE] = ACTIONS(1775),
    [anon_sym_RPAREN] = ACTIONS(1773),
    [anon_sym_SEMI_SEMI] = ACTIONS(1773),
    [anon_sym_PIPE_AMP] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_LT] = ACTIONS(1775),
    [anon_sym_GT] = ACTIONS(1775),
    [anon_sym_GT_GT] = ACTIONS(1773),
    [anon_sym_AMP_GT] = ACTIONS(1775),
    [anon_sym_AMP_GT_GT] = ACTIONS(1773),
    [anon_sym_LT_AMP] = ACTIONS(1773),
    [anon_sym_GT_AMP] = ACTIONS(1773),
    [anon_sym_LT_LT] = ACTIONS(1775),
    [anon_sym_LT_LT_DASH] = ACTIONS(1773),
    [anon_sym_LT_LT_LT] = ACTIONS(1773),
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1775),
  },
  [381] = {
    [anon_sym_LT] = ACTIONS(1777),
    [anon_sym_GT] = ACTIONS(1777),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_AMP_GT] = ACTIONS(1777),
    [anon_sym_AMP_GT_GT] = ACTIONS(1779),
    [anon_sym_LT_AMP] = ACTIONS(1779),
    [anon_sym_GT_AMP] = ACTIONS(1779),
    [sym_comment] = ACTIONS(57),
  },
  [382] = {
    [anon_sym_do] = ACTIONS(1781),
    [anon_sym_then] = ACTIONS(1781),
    [sym_comment] = ACTIONS(57),
  },
  [383] = {
    [sym_redirected_statement] = STATE(940),
    [sym_for_statement] = STATE(940),
    [sym_c_style_for_statement] = STATE(940),
    [sym_while_statement] = STATE(940),
    [sym_if_statement] = STATE(940),
    [sym_case_statement] = STATE(940),
    [sym_function_definition] = STATE(940),
    [sym_compound_statement] = STATE(940),
    [sym_subshell] = STATE(940),
    [sym_pipeline] = STATE(940),
    [sym_list] = STATE(940),
    [sym_negated_command] = STATE(940),
    [sym_test_command] = STATE(940),
    [sym_declaration_command] = STATE(940),
    [sym_unset_command] = STATE(940),
    [sym_command] = STATE(940),
    [sym_command_name] = STATE(79),
    [sym_variable_assignment] = STATE(941),
    [sym_subscript] = STATE(81),
    [sym_file_redirect] = STATE(83),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat1] = STATE(83),
    [aux_sym__literal_repeat1] = STATE(84),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [384] = {
    [sym_redirected_statement] = STATE(942),
    [sym_for_statement] = STATE(942),
    [sym_c_style_for_statement] = STATE(942),
    [sym_while_statement] = STATE(942),
    [sym_if_statement] = STATE(942),
    [sym_case_statement] = STATE(942),
    [sym_function_definition] = STATE(942),
    [sym_compound_statement] = STATE(942),
    [sym_subshell] = STATE(942),
    [sym_pipeline] = STATE(942),
    [sym_list] = STATE(942),
    [sym_negated_command] = STATE(942),
    [sym_test_command] = STATE(942),
    [sym_declaration_command] = STATE(942),
    [sym_unset_command] = STATE(942),
    [sym_command] = STATE(942),
    [sym_command_name] = STATE(79),
    [sym_variable_assignment] = STATE(943),
    [sym_subscript] = STATE(81),
    [sym_file_redirect] = STATE(83),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat1] = STATE(83),
    [aux_sym__literal_repeat1] = STATE(84),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [385] = {
    [sym_concatenation] = STATE(946),
    [sym_string] = STATE(945),
    [sym_simple_expansion] = STATE(945),
    [sym_string_expansion] = STATE(945),
    [sym_expansion] = STATE(945),
    [sym_command_substitution] = STATE(945),
    [sym_process_substitution] = STATE(945),
    [aux_sym__literal_repeat1] = STATE(947),
    [sym__special_character] = ACTIONS(1783),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(1785),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1785),
  },
  [386] = {
    [sym_heredoc_start] = ACTIONS(1787),
    [sym_comment] = ACTIONS(57),
  },
  [387] = {
    [sym_concatenation] = STATE(950),
    [sym_string] = STATE(949),
    [sym_simple_expansion] = STATE(949),
    [sym_string_expansion] = STATE(949),
    [sym_expansion] = STATE(949),
    [sym_command_substitution] = STATE(949),
    [sym_process_substitution] = STATE(949),
    [aux_sym__literal_repeat1] = STATE(951),
    [sym__special_character] = ACTIONS(1783),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(1789),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1789),
  },
  [388] = {
    [sym_file_redirect] = STATE(952),
    [sym_heredoc_redirect] = STATE(952),
    [sym_herestring_redirect] = STATE(952),
    [aux_sym_redirected_statement_repeat1] = STATE(952),
    [sym_file_descriptor] = ACTIONS(653),
    [anon_sym_SEMI] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_SEMI_SEMI] = ACTIONS(1253),
    [anon_sym_PIPE_AMP] = ACTIONS(1253),
    [anon_sym_AMP_AMP] = ACTIONS(1253),
    [anon_sym_PIPE_PIPE] = ACTIONS(1253),
    [anon_sym_LT] = ACTIONS(665),
    [anon_sym_GT] = ACTIONS(665),
    [anon_sym_GT_GT] = ACTIONS(667),
    [anon_sym_AMP_GT] = ACTIONS(665),
    [anon_sym_AMP_GT_GT] = ACTIONS(667),
    [anon_sym_LT_AMP] = ACTIONS(667),
    [anon_sym_GT_AMP] = ACTIONS(667),
    [anon_sym_LT_LT] = ACTIONS(669),
    [anon_sym_LT_LT_DASH] = ACTIONS(671),
    [anon_sym_LT_LT_LT] = ACTIONS(673),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1255),
  },
  [389] = {
    [sym_concatenation] = STATE(953),
    [sym_string] = STATE(954),
    [sym_simple_expansion] = STATE(954),
    [sym_string_expansion] = STATE(954),
    [sym_expansion] = STATE(954),
    [sym_command_substitution] = STATE(954),
    [sym_process_substitution] = STATE(954),
    [aux_sym__literal_repeat1] = STATE(955),
    [sym_regex] = ACTIONS(1791),
    [sym__special_character] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1793),
  },
  [390] = {
    [aux_sym_concatenation_repeat1] = STATE(363),
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(625),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [sym__special_character] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [391] = {
    [sym_concatenation] = STATE(956),
    [sym_string] = STATE(390),
    [sym_simple_expansion] = STATE(390),
    [sym_string_expansion] = STATE(390),
    [sym_expansion] = STATE(390),
    [sym_command_substitution] = STATE(390),
    [sym_process_substitution] = STATE(390),
    [aux_sym_command_repeat2] = STATE(956),
    [aux_sym__literal_repeat1] = STATE(392),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(675),
    [anon_sym_EQ_EQ] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(679),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [392] = {
    [aux_sym__literal_repeat1] = STATE(395),
    [sym_file_descriptor] = ACTIONS(1269),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE_AMP] = ACTIONS(1269),
    [anon_sym_AMP_AMP] = ACTIONS(1269),
    [anon_sym_PIPE_PIPE] = ACTIONS(1269),
    [anon_sym_EQ_TILDE] = ACTIONS(1271),
    [anon_sym_EQ_EQ] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT_GT] = ACTIONS(1269),
    [anon_sym_LT_AMP] = ACTIONS(1269),
    [anon_sym_GT_AMP] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_LT_LT_DASH] = ACTIONS(1269),
    [anon_sym_LT_LT_LT] = ACTIONS(1269),
    [sym__special_character] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(1269),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1269),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1269),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [anon_sym_LT_LPAREN] = ACTIONS(1269),
    [anon_sym_GT_LPAREN] = ACTIONS(1269),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1271),
  },
  [393] = {
    [sym_concatenation] = STATE(957),
    [sym_string] = STATE(390),
    [sym_simple_expansion] = STATE(390),
    [sym_string_expansion] = STATE(390),
    [sym_expansion] = STATE(390),
    [sym_command_substitution] = STATE(390),
    [sym_process_substitution] = STATE(390),
    [aux_sym_command_repeat2] = STATE(957),
    [aux_sym__literal_repeat1] = STATE(392),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(675),
    [anon_sym_EQ_EQ] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(679),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [394] = {
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [395] = {
    [aux_sym__literal_repeat1] = STATE(395),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_EQ_TILDE] = ACTIONS(1373),
    [anon_sym_EQ_EQ] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [396] = {
    [sym__statements] = STATE(974),
    [sym_redirected_statement] = STATE(975),
    [sym_for_statement] = STATE(975),
    [sym_c_style_for_statement] = STATE(975),
    [sym_while_statement] = STATE(975),
    [sym_if_statement] = STATE(975),
    [sym_elif_clause] = STATE(982),
    [sym_else_clause] = STATE(976),
    [sym_case_statement] = STATE(975),
    [sym_function_definition] = STATE(975),
    [sym_compound_statement] = STATE(975),
    [sym_subshell] = STATE(975),
    [sym_pipeline] = STATE(975),
    [sym_list] = STATE(975),
    [sym_negated_command] = STATE(975),
    [sym_test_command] = STATE(975),
    [sym_declaration_command] = STATE(975),
    [sym_unset_command] = STATE(975),
    [sym_command] = STATE(975),
    [sym_command_name] = STATE(977),
    [sym_variable_assignment] = STATE(978),
    [sym_subscript] = STATE(979),
    [sym_file_redirect] = STATE(983),
    [sym_concatenation] = STATE(980),
    [sym_string] = STATE(968),
    [sym_simple_expansion] = STATE(968),
    [sym_string_expansion] = STATE(968),
    [sym_expansion] = STATE(968),
    [sym_command_substitution] = STATE(968),
    [sym_process_substitution] = STATE(968),
    [aux_sym__statements_repeat1] = STATE(981),
    [aux_sym_if_statement_repeat1] = STATE(982),
    [aux_sym_command_repeat1] = STATE(983),
    [aux_sym__literal_repeat1] = STATE(984),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1798),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_fi] = ACTIONS(1800),
    [anon_sym_elif] = ACTIONS(1802),
    [anon_sym_else] = ACTIONS(1804),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1808),
    [anon_sym_typeset] = ACTIONS(1808),
    [anon_sym_export] = ACTIONS(1808),
    [anon_sym_readonly] = ACTIONS(1808),
    [anon_sym_local] = ACTIONS(1808),
    [anon_sym_unset] = ACTIONS(1810),
    [anon_sym_unsetenv] = ACTIONS(1810),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(1812),
    [anon_sym_DQUOTE] = ACTIONS(1814),
    [anon_sym_DOLLAR] = ACTIONS(1816),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1822),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1828),
  },
  [397] = {
    [sym_string] = STATE(985),
    [sym_simple_expansion] = STATE(985),
    [sym_string_expansion] = STATE(985),
    [sym_expansion] = STATE(985),
    [sym_command_substitution] = STATE(985),
    [sym_process_substitution] = STATE(985),
    [sym__special_character] = ACTIONS(1830),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [anon_sym_DOLLAR] = ACTIONS(147),
    [sym_raw_string] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [anon_sym_BQUOTE] = ACTIONS(155),
    [anon_sym_LT_LPAREN] = ACTIONS(157),
    [anon_sym_GT_LPAREN] = ACTIONS(157),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1830),
  },
  [398] = {
    [aux_sym_concatenation_repeat1] = STATE(986),
    [sym__concat] = ACTIONS(687),
    [anon_sym_in] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [399] = {
    [sym__concat] = ACTIONS(1063),
    [anon_sym_in] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [400] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [401] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(1832),
    [anon_sym_DOLLAR] = ACTIONS(1834),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [402] = {
    [sym__concat] = ACTIONS(1097),
    [anon_sym_in] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [403] = {
    [sym__concat] = ACTIONS(1101),
    [anon_sym_in] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1101),
  },
  [404] = {
    [sym__concat] = ACTIONS(1105),
    [anon_sym_in] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1105),
  },
  [405] = {
    [anon_sym_SEMI] = ACTIONS(1836),
    [anon_sym_SEMI_SEMI] = ACTIONS(1838),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1838),
    [anon_sym_AMP] = ACTIONS(1838),
  },
  [406] = {
    [anon_sym_in] = ACTIONS(1840),
    [sym_comment] = ACTIONS(57),
  },
  [407] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(1842),
    [sym_comment] = ACTIONS(57),
  },
  [408] = {
    [sym_subscript] = STATE(994),
    [sym_variable_name] = ACTIONS(1844),
    [anon_sym_DASH] = ACTIONS(1846),
    [anon_sym_DOLLAR] = ACTIONS(1846),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1848),
    [anon_sym_STAR] = ACTIONS(1850),
    [anon_sym_AT] = ACTIONS(1850),
    [anon_sym_QMARK] = ACTIONS(1850),
    [anon_sym_0] = ACTIONS(1848),
    [anon_sym__] = ACTIONS(1848),
  },
  [409] = {
    [sym_concatenation] = STATE(997),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(997),
    [anon_sym_RBRACE] = ACTIONS(1852),
    [anon_sym_EQ] = ACTIONS(1854),
    [anon_sym_DASH] = ACTIONS(1854),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(1856),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1858),
    [anon_sym_COLON] = ACTIONS(1854),
    [anon_sym_COLON_QMARK] = ACTIONS(1854),
    [anon_sym_COLON_DASH] = ACTIONS(1854),
    [anon_sym_PERCENT] = ACTIONS(1854),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [410] = {
    [sym_concatenation] = STATE(1000),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1000),
    [anon_sym_RBRACE] = ACTIONS(1860),
    [anon_sym_EQ] = ACTIONS(1862),
    [anon_sym_DASH] = ACTIONS(1862),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(1864),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(1866),
    [anon_sym_COLON] = ACTIONS(1862),
    [anon_sym_COLON_QMARK] = ACTIONS(1862),
    [anon_sym_COLON_DASH] = ACTIONS(1862),
    [anon_sym_PERCENT] = ACTIONS(1862),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [411] = {
    [anon_sym_RPAREN] = ACTIONS(1868),
    [sym_comment] = ACTIONS(57),
  },
  [412] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(1868),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [413] = {
    [anon_sym_BQUOTE] = ACTIONS(1868),
    [sym_comment] = ACTIONS(57),
  },
  [414] = {
    [anon_sym_RPAREN] = ACTIONS(1870),
    [sym_comment] = ACTIONS(57),
  },
  [415] = {
    [anon_sym_SEMI] = ACTIONS(1872),
    [anon_sym_SEMI_SEMI] = ACTIONS(1874),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1874),
  },
  [416] = {
    [anon_sym_in] = ACTIONS(1876),
    [sym_comment] = ACTIONS(57),
  },
  [417] = {
    [anon_sym_in] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(325),
  },
  [418] = {
    [aux_sym__literal_repeat1] = STATE(418),
    [anon_sym_in] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(1878),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1371),
  },
  [419] = {
    [anon_sym_RPAREN] = ACTIONS(1881),
    [sym_comment] = ACTIONS(57),
  },
  [420] = {
    [sym__simple_heredoc_body] = ACTIONS(1883),
    [sym__heredoc_body_beginning] = ACTIONS(1883),
    [sym_file_descriptor] = ACTIONS(1883),
    [ts_builtin_sym_end] = ACTIONS(1883),
    [anon_sym_SEMI] = ACTIONS(1885),
    [anon_sym_done] = ACTIONS(1883),
    [anon_sym_fi] = ACTIONS(1883),
    [anon_sym_elif] = ACTIONS(1883),
    [anon_sym_else] = ACTIONS(1883),
    [anon_sym_esac] = ACTIONS(1883),
    [anon_sym_PIPE] = ACTIONS(1885),
    [anon_sym_RPAREN] = ACTIONS(1883),
    [anon_sym_SEMI_SEMI] = ACTIONS(1883),
    [anon_sym_PIPE_AMP] = ACTIONS(1883),
    [anon_sym_AMP_AMP] = ACTIONS(1883),
    [anon_sym_PIPE_PIPE] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1885),
    [anon_sym_GT_GT] = ACTIONS(1883),
    [anon_sym_AMP_GT] = ACTIONS(1885),
    [anon_sym_AMP_GT_GT] = ACTIONS(1883),
    [anon_sym_LT_AMP] = ACTIONS(1883),
    [anon_sym_GT_AMP] = ACTIONS(1883),
    [anon_sym_LT_LT] = ACTIONS(1885),
    [anon_sym_LT_LT_DASH] = ACTIONS(1883),
    [anon_sym_LT_LT_LT] = ACTIONS(1883),
    [anon_sym_BQUOTE] = ACTIONS(1883),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1885),
  },
  [421] = {
    [sym_concatenation] = STATE(263),
    [sym_string] = STATE(1007),
    [sym_array] = STATE(263),
    [sym_simple_expansion] = STATE(1007),
    [sym_string_expansion] = STATE(1007),
    [sym_expansion] = STATE(1007),
    [sym_command_substitution] = STATE(1007),
    [sym_process_substitution] = STATE(1007),
    [aux_sym__literal_repeat1] = STATE(1008),
    [sym__empty_value] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [sym__special_character] = ACTIONS(1887),
    [anon_sym_DQUOTE] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(1889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(463),
    [anon_sym_BQUOTE] = ACTIONS(465),
    [anon_sym_LT_LPAREN] = ACTIONS(467),
    [anon_sym_GT_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1889),
  },
  [422] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_PLUS_EQ] = ACTIONS(1891),
    [sym_comment] = ACTIONS(57),
  },
  [423] = {
    [aux_sym_concatenation_repeat1] = STATE(1010),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(943),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_RPAREN] = ACTIONS(325),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [424] = {
    [aux_sym_concatenation_repeat1] = STATE(1010),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(943),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_RPAREN] = ACTIONS(957),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [sym__special_character] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [425] = {
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_PLUS_EQ] = ACTIONS(1891),
    [sym_comment] = ACTIONS(57),
  },
  [426] = {
    [sym_variable_assignment] = STATE(1011),
    [sym_subscript] = STATE(425),
    [sym_concatenation] = STATE(1011),
    [sym_string] = STATE(424),
    [sym_simple_expansion] = STATE(424),
    [sym_string_expansion] = STATE(424),
    [sym_expansion] = STATE(424),
    [sym_command_substitution] = STATE(424),
    [sym_process_substitution] = STATE(424),
    [aux_sym_declaration_command_repeat1] = STATE(1011),
    [aux_sym__literal_repeat1] = STATE(427),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(729),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_RPAREN] = ACTIONS(971),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [sym__special_character] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1893),
    [sym_word] = ACTIONS(737),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [427] = {
    [aux_sym__literal_repeat1] = STATE(1012),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym_variable_name] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_RPAREN] = ACTIONS(977),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(979),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(979),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [sym__special_character] = ACTIONS(981),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(979),
    [sym_word] = ACTIONS(979),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
  },
  [428] = {
    [aux_sym_concatenation_repeat1] = STATE(1013),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(983),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_RPAREN] = ACTIONS(325),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [429] = {
    [aux_sym_concatenation_repeat1] = STATE(1013),
    [sym__simple_heredoc_body] = ACTIONS(997),
    [sym__heredoc_body_beginning] = ACTIONS(997),
    [sym_file_descriptor] = ACTIONS(997),
    [sym__concat] = ACTIONS(983),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_SEMI_SEMI] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_AMP_GT] = ACTIONS(999),
    [anon_sym_AMP_GT_GT] = ACTIONS(997),
    [anon_sym_LT_AMP] = ACTIONS(997),
    [anon_sym_GT_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_LT_LT_DASH] = ACTIONS(997),
    [anon_sym_LT_LT_LT] = ACTIONS(997),
    [sym__special_character] = ACTIONS(997),
    [anon_sym_DQUOTE] = ACTIONS(997),
    [anon_sym_DOLLAR] = ACTIONS(999),
    [sym_raw_string] = ACTIONS(997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(997),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(997),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(999),
    [sym_word] = ACTIONS(999),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
  },
  [430] = {
    [sym_concatenation] = STATE(1014),
    [sym_string] = STATE(429),
    [sym_simple_expansion] = STATE(429),
    [sym_string_expansion] = STATE(429),
    [sym_expansion] = STATE(429),
    [sym_command_substitution] = STATE(429),
    [sym_process_substitution] = STATE(429),
    [aux_sym_unset_command_repeat1] = STATE(1014),
    [aux_sym__literal_repeat1] = STATE(431),
    [sym__simple_heredoc_body] = ACTIONS(1011),
    [sym__heredoc_body_beginning] = ACTIONS(1011),
    [sym_file_descriptor] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_RPAREN] = ACTIONS(1011),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1013),
    [anon_sym_GT] = ACTIONS(1013),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT] = ACTIONS(1013),
    [anon_sym_AMP_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_AMP] = ACTIONS(1011),
    [anon_sym_GT_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(1011),
    [anon_sym_LT_LT_LT] = ACTIONS(1011),
    [sym__special_character] = ACTIONS(739),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_DOLLAR] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(741),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1895),
    [sym_word] = ACTIONS(745),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
  },
  [431] = {
    [aux_sym__literal_repeat1] = STATE(1015),
    [sym__simple_heredoc_body] = ACTIONS(1017),
    [sym__heredoc_body_beginning] = ACTIONS(1017),
    [sym_file_descriptor] = ACTIONS(1017),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_RPAREN] = ACTIONS(1017),
    [anon_sym_SEMI_SEMI] = ACTIONS(1017),
    [anon_sym_PIPE_AMP] = ACTIONS(1017),
    [anon_sym_AMP_AMP] = ACTIONS(1017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1017),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1017),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1017),
    [anon_sym_LT_AMP] = ACTIONS(1017),
    [anon_sym_GT_AMP] = ACTIONS(1017),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1017),
    [anon_sym_LT_LT_LT] = ACTIONS(1017),
    [sym__special_character] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1017),
    [anon_sym_DOLLAR] = ACTIONS(1019),
    [sym_raw_string] = ACTIONS(1017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1017),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1017),
    [anon_sym_GT_LPAREN] = ACTIONS(1017),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1019),
    [sym_word] = ACTIONS(1019),
    [anon_sym_LF] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [432] = {
    [aux_sym_concatenation_repeat1] = STATE(1016),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_RPAREN] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_EQ_TILDE] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [433] = {
    [sym__simple_heredoc_body] = ACTIONS(1897),
    [sym__heredoc_body_beginning] = ACTIONS(1897),
    [sym_file_descriptor] = ACTIONS(1897),
    [ts_builtin_sym_end] = ACTIONS(1897),
    [anon_sym_SEMI] = ACTIONS(1899),
    [anon_sym_done] = ACTIONS(1897),
    [anon_sym_fi] = ACTIONS(1897),
    [anon_sym_elif] = ACTIONS(1897),
    [anon_sym_else] = ACTIONS(1897),
    [anon_sym_esac] = ACTIONS(1897),
    [anon_sym_PIPE] = ACTIONS(1899),
    [anon_sym_RPAREN] = ACTIONS(1897),
    [anon_sym_SEMI_SEMI] = ACTIONS(1897),
    [anon_sym_PIPE_AMP] = ACTIONS(1897),
    [anon_sym_AMP_AMP] = ACTIONS(1897),
    [anon_sym_PIPE_PIPE] = ACTIONS(1897),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(1899),
    [anon_sym_GT_GT] = ACTIONS(1897),
    [anon_sym_AMP_GT] = ACTIONS(1899),
    [anon_sym_AMP_GT_GT] = ACTIONS(1897),
    [anon_sym_LT_AMP] = ACTIONS(1897),
    [anon_sym_GT_AMP] = ACTIONS(1897),
    [anon_sym_LT_LT] = ACTIONS(1899),
    [anon_sym_LT_LT_DASH] = ACTIONS(1897),
    [anon_sym_LT_LT_LT] = ACTIONS(1897),
    [anon_sym_BQUOTE] = ACTIONS(1897),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1897),
    [anon_sym_AMP] = ACTIONS(1899),
  },
  [434] = {
    [anon_sym_LT] = ACTIONS(1901),
    [anon_sym_GT] = ACTIONS(1901),
    [anon_sym_GT_GT] = ACTIONS(1903),
    [anon_sym_AMP_GT] = ACTIONS(1901),
    [anon_sym_AMP_GT_GT] = ACTIONS(1903),
    [anon_sym_LT_AMP] = ACTIONS(1903),
    [anon_sym_GT_AMP] = ACTIONS(1903),
    [sym_comment] = ACTIONS(57),
  },
  [435] = {
    [sym_redirected_statement] = STATE(1018),
    [sym_for_statement] = STATE(1018),
    [sym_c_style_for_statement] = STATE(1018),
    [sym_while_statement] = STATE(1018),
    [sym_if_statement] = STATE(1018),
    [sym_case_statement] = STATE(1018),
    [sym_function_definition] = STATE(1018),
    [sym_compound_statement] = STATE(1018),
    [sym_subshell] = STATE(1018),
    [sym_pipeline] = STATE(1018),
    [sym_list] = STATE(1018),
    [sym_negated_command] = STATE(1018),
    [sym_test_command] = STATE(1018),
    [sym_declaration_command] = STATE(1018),
    [sym_unset_command] = STATE(1018),
    [sym_command] = STATE(1018),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(1019),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [436] = {
    [sym_redirected_statement] = STATE(1020),
    [sym_for_statement] = STATE(1020),
    [sym_c_style_for_statement] = STATE(1020),
    [sym_while_statement] = STATE(1020),
    [sym_if_statement] = STATE(1020),
    [sym_case_statement] = STATE(1020),
    [sym_function_definition] = STATE(1020),
    [sym_compound_statement] = STATE(1020),
    [sym_subshell] = STATE(1020),
    [sym_pipeline] = STATE(1020),
    [sym_list] = STATE(1020),
    [sym_negated_command] = STATE(1020),
    [sym_test_command] = STATE(1020),
    [sym_declaration_command] = STATE(1020),
    [sym_unset_command] = STATE(1020),
    [sym_command] = STATE(1020),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(1021),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [437] = {
    [sym_concatenation] = STATE(695),
    [sym_string] = STATE(1023),
    [sym_simple_expansion] = STATE(1023),
    [sym_string_expansion] = STATE(1023),
    [sym_expansion] = STATE(1023),
    [sym_command_substitution] = STATE(1023),
    [sym_process_substitution] = STATE(1023),
    [aux_sym__literal_repeat1] = STATE(1024),
    [sym__special_character] = ACTIONS(1905),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1907),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1907),
  },
  [438] = {
    [sym_concatenation] = STATE(699),
    [sym_string] = STATE(1025),
    [sym_simple_expansion] = STATE(1025),
    [sym_string_expansion] = STATE(1025),
    [sym_expansion] = STATE(1025),
    [sym_command_substitution] = STATE(1025),
    [sym_process_substitution] = STATE(1025),
    [aux_sym__literal_repeat1] = STATE(1026),
    [sym__special_character] = ACTIONS(1905),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1909),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1909),
  },
  [439] = {
    [sym_file_redirect] = STATE(1027),
    [sym_heredoc_redirect] = STATE(1027),
    [sym_herestring_redirect] = STATE(1027),
    [aux_sym_redirected_statement_repeat1] = STATE(1027),
    [sym__simple_heredoc_body] = ACTIONS(1253),
    [sym__heredoc_body_beginning] = ACTIONS(1253),
    [sym_file_descriptor] = ACTIONS(749),
    [anon_sym_SEMI] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_RPAREN] = ACTIONS(1253),
    [anon_sym_SEMI_SEMI] = ACTIONS(1253),
    [anon_sym_PIPE_AMP] = ACTIONS(1253),
    [anon_sym_AMP_AMP] = ACTIONS(1253),
    [anon_sym_PIPE_PIPE] = ACTIONS(1253),
    [anon_sym_LT] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(757),
    [anon_sym_GT_GT] = ACTIONS(759),
    [anon_sym_AMP_GT] = ACTIONS(757),
    [anon_sym_AMP_GT_GT] = ACTIONS(759),
    [anon_sym_LT_AMP] = ACTIONS(759),
    [anon_sym_GT_AMP] = ACTIONS(759),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(761),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1255),
  },
  [440] = {
    [sym_concatenation] = STATE(703),
    [sym_string] = STATE(1028),
    [sym_simple_expansion] = STATE(1028),
    [sym_string_expansion] = STATE(1028),
    [sym_expansion] = STATE(1028),
    [sym_command_substitution] = STATE(1028),
    [sym_process_substitution] = STATE(1028),
    [aux_sym__literal_repeat1] = STATE(1029),
    [sym_regex] = ACTIONS(1257),
    [sym__special_character] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1911),
  },
  [441] = {
    [aux_sym_concatenation_repeat1] = STATE(432),
    [sym__simple_heredoc_body] = ACTIONS(1261),
    [sym__heredoc_body_beginning] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_RPAREN] = ACTIONS(1261),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [sym__special_character] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [442] = {
    [sym_concatenation] = STATE(1030),
    [sym_string] = STATE(441),
    [sym_simple_expansion] = STATE(441),
    [sym_string_expansion] = STATE(441),
    [sym_expansion] = STATE(441),
    [sym_command_substitution] = STATE(441),
    [sym_process_substitution] = STATE(441),
    [aux_sym_command_repeat2] = STATE(1030),
    [aux_sym__literal_repeat1] = STATE(443),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_RPAREN] = ACTIONS(1265),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(763),
    [anon_sym_EQ_EQ] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(769),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [443] = {
    [aux_sym__literal_repeat1] = STATE(447),
    [sym__simple_heredoc_body] = ACTIONS(1269),
    [sym__heredoc_body_beginning] = ACTIONS(1269),
    [sym_file_descriptor] = ACTIONS(1269),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_RPAREN] = ACTIONS(1269),
    [anon_sym_SEMI_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE_AMP] = ACTIONS(1269),
    [anon_sym_AMP_AMP] = ACTIONS(1269),
    [anon_sym_PIPE_PIPE] = ACTIONS(1269),
    [anon_sym_EQ_TILDE] = ACTIONS(1271),
    [anon_sym_EQ_EQ] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT_GT] = ACTIONS(1269),
    [anon_sym_LT_AMP] = ACTIONS(1269),
    [anon_sym_GT_AMP] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_LT_LT_DASH] = ACTIONS(1269),
    [anon_sym_LT_LT_LT] = ACTIONS(1269),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(1269),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1269),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1269),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [anon_sym_LT_LPAREN] = ACTIONS(1269),
    [anon_sym_GT_LPAREN] = ACTIONS(1269),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1271),
  },
  [444] = {
    [sym_file_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [sym_heredoc_body] = STATE(708),
    [sym_herestring_redirect] = STATE(439),
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(749),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(1237),
    [anon_sym_SEMI_SEMI] = ACTIONS(1275),
    [anon_sym_PIPE_AMP] = ACTIONS(753),
    [anon_sym_AMP_AMP] = ACTIONS(755),
    [anon_sym_PIPE_PIPE] = ACTIONS(755),
    [anon_sym_LT] = ACTIONS(757),
    [anon_sym_GT] = ACTIONS(757),
    [anon_sym_GT_GT] = ACTIONS(759),
    [anon_sym_AMP_GT] = ACTIONS(757),
    [anon_sym_AMP_GT_GT] = ACTIONS(759),
    [anon_sym_LT_AMP] = ACTIONS(759),
    [anon_sym_GT_AMP] = ACTIONS(759),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(761),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1273),
  },
  [445] = {
    [sym_file_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [sym_heredoc_body] = STATE(708),
    [sym_herestring_redirect] = STATE(439),
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(1237),
    [anon_sym_SEMI_SEMI] = ACTIONS(1275),
    [anon_sym_PIPE_AMP] = ACTIONS(753),
    [anon_sym_AMP_AMP] = ACTIONS(755),
    [anon_sym_PIPE_PIPE] = ACTIONS(755),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(761),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1273),
  },
  [446] = {
    [sym_concatenation] = STATE(1031),
    [sym_string] = STATE(441),
    [sym_simple_expansion] = STATE(441),
    [sym_string_expansion] = STATE(441),
    [sym_expansion] = STATE(441),
    [sym_command_substitution] = STATE(441),
    [sym_process_substitution] = STATE(441),
    [aux_sym_command_repeat2] = STATE(1031),
    [aux_sym__literal_repeat1] = STATE(443),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_RPAREN] = ACTIONS(1265),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(763),
    [anon_sym_EQ_EQ] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(769),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [447] = {
    [aux_sym__literal_repeat1] = STATE(447),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_RPAREN] = ACTIONS(1371),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_EQ_TILDE] = ACTIONS(1373),
    [anon_sym_EQ_EQ] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(1375),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [448] = {
    [sym_concatenation] = STATE(1032),
    [sym_string] = STATE(1037),
    [sym_array] = STATE(1032),
    [sym_simple_expansion] = STATE(1037),
    [sym_string_expansion] = STATE(1037),
    [sym_expansion] = STATE(1037),
    [sym_command_substitution] = STATE(1037),
    [sym_process_substitution] = STATE(1037),
    [aux_sym__literal_repeat1] = STATE(1042),
    [sym__empty_value] = ACTIONS(1913),
    [anon_sym_LPAREN] = ACTIONS(1915),
    [sym__special_character] = ACTIONS(1917),
    [anon_sym_DQUOTE] = ACTIONS(1919),
    [anon_sym_DOLLAR] = ACTIONS(1921),
    [sym_raw_string] = ACTIONS(1923),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1927),
    [anon_sym_BQUOTE] = ACTIONS(1929),
    [anon_sym_LT_LPAREN] = ACTIONS(1931),
    [anon_sym_GT_LPAREN] = ACTIONS(1931),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1923),
  },
  [449] = {
    [sym__expression] = STATE(1044),
    [sym_binary_expression] = STATE(1044),
    [sym_unary_expression] = STATE(1044),
    [sym_postfix_expression] = STATE(1044),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_concatenation] = STATE(1044),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [anon_sym_SEMI] = ACTIONS(1933),
    [anon_sym_SEMI_SEMI] = ACTIONS(1935),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [sym__special_character] = ACTIONS(477),
    [anon_sym_DQUOTE] = ACTIONS(479),
    [anon_sym_DOLLAR] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
    [anon_sym_LF] = ACTIONS(1935),
    [anon_sym_AMP] = ACTIONS(1935),
  },
  [450] = {
    [anon_sym_in] = ACTIONS(1937),
    [anon_sym_SEMI] = ACTIONS(1939),
    [anon_sym_SEMI_SEMI] = ACTIONS(1941),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1941),
    [anon_sym_AMP] = ACTIONS(1941),
  },
  [451] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1943),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [452] = {
    [sym_do_group] = STATE(1049),
    [anon_sym_do] = ACTIONS(1945),
    [sym_comment] = ACTIONS(57),
  },
  [453] = {
    [anon_sym_then] = ACTIONS(1947),
    [sym_comment] = ACTIONS(57),
  },
  [454] = {
    [aux_sym_concatenation_repeat1] = STATE(398),
    [sym__concat] = ACTIONS(687),
    [anon_sym_in] = ACTIONS(1949),
    [anon_sym_SEMI] = ACTIONS(1951),
    [anon_sym_SEMI_SEMI] = ACTIONS(1953),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1953),
    [anon_sym_AMP] = ACTIONS(1953),
  },
  [455] = {
    [anon_sym_in] = ACTIONS(1949),
    [anon_sym_SEMI] = ACTIONS(1951),
    [anon_sym_SEMI_SEMI] = ACTIONS(1953),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1953),
    [anon_sym_AMP] = ACTIONS(1953),
  },
  [456] = {
    [aux_sym__literal_repeat1] = STATE(418),
    [anon_sym_in] = ACTIONS(1955),
    [anon_sym_SEMI] = ACTIONS(1957),
    [anon_sym_SEMI_SEMI] = ACTIONS(1959),
    [sym__special_character] = ACTIONS(723),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1959),
    [anon_sym_AMP] = ACTIONS(1959),
  },
  [457] = {
    [sym_compound_statement] = STATE(1056),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [458] = {
    [anon_sym_RPAREN] = ACTIONS(1963),
    [sym_comment] = ACTIONS(57),
  },
  [459] = {
    [sym__simple_heredoc_body] = ACTIONS(783),
    [sym__heredoc_body_beginning] = ACTIONS(783),
    [sym_file_descriptor] = ACTIONS(783),
    [anon_sym_SEMI] = ACTIONS(785),
    [anon_sym_PIPE] = ACTIONS(785),
    [anon_sym_SEMI_SEMI] = ACTIONS(783),
    [anon_sym_RBRACE] = ACTIONS(783),
    [anon_sym_PIPE_AMP] = ACTIONS(783),
    [anon_sym_AMP_AMP] = ACTIONS(783),
    [anon_sym_PIPE_PIPE] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(785),
    [anon_sym_GT] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(783),
    [anon_sym_AMP_GT] = ACTIONS(785),
    [anon_sym_AMP_GT_GT] = ACTIONS(783),
    [anon_sym_LT_AMP] = ACTIONS(783),
    [anon_sym_GT_AMP] = ACTIONS(783),
    [anon_sym_LT_LT] = ACTIONS(785),
    [anon_sym_LT_LT_DASH] = ACTIONS(783),
    [anon_sym_LT_LT_LT] = ACTIONS(783),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(783),
    [anon_sym_AMP] = ACTIONS(785),
  },
  [460] = {
    [anon_sym_RBRACE] = ACTIONS(1965),
    [sym_comment] = ACTIONS(57),
  },
  [461] = {
    [sym__simple_heredoc_body] = ACTIONS(895),
    [sym__heredoc_body_beginning] = ACTIONS(895),
    [sym_file_descriptor] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_PIPE] = ACTIONS(897),
    [anon_sym_SEMI_SEMI] = ACTIONS(895),
    [anon_sym_RBRACE] = ACTIONS(895),
    [anon_sym_PIPE_AMP] = ACTIONS(895),
    [anon_sym_AMP_AMP] = ACTIONS(895),
    [anon_sym_PIPE_PIPE] = ACTIONS(895),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(895),
    [anon_sym_AMP_GT] = ACTIONS(897),
    [anon_sym_AMP_GT_GT] = ACTIONS(895),
    [anon_sym_LT_AMP] = ACTIONS(895),
    [anon_sym_GT_AMP] = ACTIONS(895),
    [anon_sym_LT_LT] = ACTIONS(897),
    [anon_sym_LT_LT_DASH] = ACTIONS(895),
    [anon_sym_LT_LT_LT] = ACTIONS(895),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(895),
    [anon_sym_AMP] = ACTIONS(897),
  },
  [462] = {
    [anon_sym_AMP_AMP] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(923),
    [anon_sym_RBRACK] = ACTIONS(1943),
    [anon_sym_EQ_TILDE] = ACTIONS(925),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(927),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_GT] = ACTIONS(927),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(923),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_PLUS_PLUS] = ACTIONS(929),
    [anon_sym_DASH_DASH] = ACTIONS(929),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(923),
  },
  [463] = {
    [anon_sym_AMP_AMP] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(933),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1943),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(935),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_PLUS_EQ] = ACTIONS(933),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_DASH] = ACTIONS(937),
    [anon_sym_DASH_EQ] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(933),
  },
  [464] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(1967),
    [anon_sym_PLUS_EQ] = ACTIONS(1967),
    [sym_comment] = ACTIONS(57),
  },
  [465] = {
    [aux_sym_concatenation_repeat1] = STATE(1061),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(1969),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(329),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [466] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(1064),
    [anon_sym_DQUOTE] = ACTIONS(1971),
    [anon_sym_DOLLAR] = ACTIONS(1973),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [467] = {
    [sym_string] = STATE(1066),
    [anon_sym_DASH] = ACTIONS(1975),
    [anon_sym_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR] = ACTIONS(1975),
    [sym_raw_string] = ACTIONS(1977),
    [anon_sym_POUND] = ACTIONS(1975),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1979),
    [anon_sym_STAR] = ACTIONS(1981),
    [anon_sym_AT] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(1981),
    [anon_sym_0] = ACTIONS(1979),
    [anon_sym__] = ACTIONS(1979),
  },
  [468] = {
    [aux_sym_concatenation_repeat1] = STATE(1061),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(1969),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_RBRACE] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [sym__special_character] = ACTIONS(959),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [469] = {
    [sym_subscript] = STATE(1071),
    [sym_variable_name] = ACTIONS(1983),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_DOLLAR] = ACTIONS(1987),
    [anon_sym_POUND] = ACTIONS(1985),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1989),
    [anon_sym_STAR] = ACTIONS(1991),
    [anon_sym_AT] = ACTIONS(1991),
    [anon_sym_QMARK] = ACTIONS(1991),
    [anon_sym_0] = ACTIONS(1989),
    [anon_sym__] = ACTIONS(1989),
  },
  [470] = {
    [sym__statements] = STATE(1072),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(1073),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [471] = {
    [sym__statements] = STATE(1074),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [472] = {
    [sym__statements] = STATE(1075),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [473] = {
    [anon_sym_EQ] = ACTIONS(1967),
    [anon_sym_PLUS_EQ] = ACTIONS(1967),
    [sym_comment] = ACTIONS(57),
  },
  [474] = {
    [sym_variable_assignment] = STATE(1076),
    [sym_subscript] = STATE(473),
    [sym_concatenation] = STATE(1076),
    [sym_string] = STATE(468),
    [sym_simple_expansion] = STATE(468),
    [sym_string_expansion] = STATE(468),
    [sym_expansion] = STATE(468),
    [sym_command_substitution] = STATE(468),
    [sym_process_substitution] = STATE(468),
    [aux_sym_declaration_command_repeat1] = STATE(1076),
    [aux_sym__literal_repeat1] = STATE(475),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(787),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_RBRACE] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [sym__special_character] = ACTIONS(789),
    [anon_sym_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR] = ACTIONS(793),
    [sym_raw_string] = ACTIONS(795),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(797),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(799),
    [anon_sym_BQUOTE] = ACTIONS(801),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1993),
    [sym_word] = ACTIONS(807),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [475] = {
    [aux_sym__literal_repeat1] = STATE(1078),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym_variable_name] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(979),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(979),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [sym__special_character] = ACTIONS(1995),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(979),
    [sym_word] = ACTIONS(979),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
  },
  [476] = {
    [aux_sym_concatenation_repeat1] = STATE(1080),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(1997),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(329),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [477] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(1083),
    [anon_sym_DQUOTE] = ACTIONS(1999),
    [anon_sym_DOLLAR] = ACTIONS(2001),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [478] = {
    [sym_string] = STATE(1085),
    [anon_sym_DASH] = ACTIONS(2003),
    [anon_sym_DQUOTE] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(2003),
    [sym_raw_string] = ACTIONS(2005),
    [anon_sym_POUND] = ACTIONS(2003),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(2009),
    [anon_sym_AT] = ACTIONS(2009),
    [anon_sym_QMARK] = ACTIONS(2009),
    [anon_sym_0] = ACTIONS(2007),
    [anon_sym__] = ACTIONS(2007),
  },
  [479] = {
    [aux_sym_concatenation_repeat1] = STATE(1080),
    [sym__simple_heredoc_body] = ACTIONS(997),
    [sym__heredoc_body_beginning] = ACTIONS(997),
    [sym_file_descriptor] = ACTIONS(997),
    [sym__concat] = ACTIONS(1997),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI_SEMI] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_AMP_GT] = ACTIONS(999),
    [anon_sym_AMP_GT_GT] = ACTIONS(997),
    [anon_sym_LT_AMP] = ACTIONS(997),
    [anon_sym_GT_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_LT_LT_DASH] = ACTIONS(997),
    [anon_sym_LT_LT_LT] = ACTIONS(997),
    [sym__special_character] = ACTIONS(999),
    [anon_sym_DQUOTE] = ACTIONS(997),
    [anon_sym_DOLLAR] = ACTIONS(999),
    [sym_raw_string] = ACTIONS(997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(997),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(997),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(999),
    [sym_word] = ACTIONS(999),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
  },
  [480] = {
    [sym_subscript] = STATE(1090),
    [sym_variable_name] = ACTIONS(2011),
    [anon_sym_BANG] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_DOLLAR] = ACTIONS(2015),
    [anon_sym_POUND] = ACTIONS(2013),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2017),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_AT] = ACTIONS(2019),
    [anon_sym_QMARK] = ACTIONS(2019),
    [anon_sym_0] = ACTIONS(2017),
    [anon_sym__] = ACTIONS(2017),
  },
  [481] = {
    [sym__statements] = STATE(1091),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(1092),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [482] = {
    [sym__statements] = STATE(1093),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [483] = {
    [sym__statements] = STATE(1094),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [484] = {
    [sym_concatenation] = STATE(1095),
    [sym_string] = STATE(479),
    [sym_simple_expansion] = STATE(479),
    [sym_string_expansion] = STATE(479),
    [sym_expansion] = STATE(479),
    [sym_command_substitution] = STATE(479),
    [sym_process_substitution] = STATE(479),
    [aux_sym_unset_command_repeat1] = STATE(1095),
    [aux_sym__literal_repeat1] = STATE(485),
    [sym__simple_heredoc_body] = ACTIONS(1011),
    [sym__heredoc_body_beginning] = ACTIONS(1011),
    [sym_file_descriptor] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_RBRACE] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1013),
    [anon_sym_GT] = ACTIONS(1013),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT] = ACTIONS(1013),
    [anon_sym_AMP_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_AMP] = ACTIONS(1011),
    [anon_sym_GT_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(1011),
    [anon_sym_LT_LT_LT] = ACTIONS(1011),
    [sym__special_character] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(815),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(819),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(823),
    [anon_sym_GT_LPAREN] = ACTIONS(823),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2021),
    [sym_word] = ACTIONS(827),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
  },
  [485] = {
    [aux_sym__literal_repeat1] = STATE(1097),
    [sym__simple_heredoc_body] = ACTIONS(1017),
    [sym__heredoc_body_beginning] = ACTIONS(1017),
    [sym_file_descriptor] = ACTIONS(1017),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1017),
    [anon_sym_RBRACE] = ACTIONS(1017),
    [anon_sym_PIPE_AMP] = ACTIONS(1017),
    [anon_sym_AMP_AMP] = ACTIONS(1017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1017),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1017),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1017),
    [anon_sym_LT_AMP] = ACTIONS(1017),
    [anon_sym_GT_AMP] = ACTIONS(1017),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1017),
    [anon_sym_LT_LT_LT] = ACTIONS(1017),
    [sym__special_character] = ACTIONS(2023),
    [anon_sym_DQUOTE] = ACTIONS(1017),
    [anon_sym_DOLLAR] = ACTIONS(1019),
    [sym_raw_string] = ACTIONS(1017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1017),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1017),
    [anon_sym_GT_LPAREN] = ACTIONS(1017),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1019),
    [sym_word] = ACTIONS(1019),
    [anon_sym_LF] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [486] = {
    [sym_string] = STATE(1098),
    [sym_simple_expansion] = STATE(1098),
    [sym_string_expansion] = STATE(1098),
    [sym_expansion] = STATE(1098),
    [sym_command_substitution] = STATE(1098),
    [sym_process_substitution] = STATE(1098),
    [sym__special_character] = ACTIONS(2025),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(2025),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2025),
  },
  [487] = {
    [aux_sym_concatenation_repeat1] = STATE(1099),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_EQ_TILDE] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [488] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_RBRACE] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_EQ_TILDE] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [489] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [490] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DOLLAR] = ACTIONS(2029),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [491] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_RBRACE] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_EQ_TILDE] = ACTIONS(1099),
    [anon_sym_EQ_EQ] = ACTIONS(1099),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [492] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_RBRACE] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_EQ_TILDE] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [493] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_RBRACE] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_EQ_TILDE] = ACTIONS(1107),
    [anon_sym_EQ_EQ] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [494] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(2031),
    [sym_comment] = ACTIONS(57),
  },
  [495] = {
    [sym_subscript] = STATE(1105),
    [sym_variable_name] = ACTIONS(2033),
    [anon_sym_DASH] = ACTIONS(2035),
    [anon_sym_DOLLAR] = ACTIONS(2035),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2037),
    [anon_sym_STAR] = ACTIONS(2039),
    [anon_sym_AT] = ACTIONS(2039),
    [anon_sym_QMARK] = ACTIONS(2039),
    [anon_sym_0] = ACTIONS(2037),
    [anon_sym__] = ACTIONS(2037),
  },
  [496] = {
    [sym_concatenation] = STATE(1108),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1108),
    [anon_sym_RBRACE] = ACTIONS(2041),
    [anon_sym_EQ] = ACTIONS(2043),
    [anon_sym_DASH] = ACTIONS(2043),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2045),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(2047),
    [anon_sym_COLON] = ACTIONS(2043),
    [anon_sym_COLON_QMARK] = ACTIONS(2043),
    [anon_sym_COLON_DASH] = ACTIONS(2043),
    [anon_sym_PERCENT] = ACTIONS(2043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [497] = {
    [sym_concatenation] = STATE(1111),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1111),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [anon_sym_EQ] = ACTIONS(2051),
    [anon_sym_DASH] = ACTIONS(2051),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_COLON] = ACTIONS(2051),
    [anon_sym_COLON_QMARK] = ACTIONS(2051),
    [anon_sym_COLON_DASH] = ACTIONS(2051),
    [anon_sym_PERCENT] = ACTIONS(2051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [498] = {
    [anon_sym_RPAREN] = ACTIONS(2057),
    [sym_comment] = ACTIONS(57),
  },
  [499] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2057),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [500] = {
    [anon_sym_BQUOTE] = ACTIONS(2057),
    [sym_comment] = ACTIONS(57),
  },
  [501] = {
    [anon_sym_RPAREN] = ACTIONS(2059),
    [sym_comment] = ACTIONS(57),
  },
  [502] = {
    [anon_sym_RPAREN] = ACTIONS(2061),
    [sym_comment] = ACTIONS(57),
  },
  [503] = {
    [sym__simple_heredoc_body] = ACTIONS(2063),
    [sym__heredoc_body_beginning] = ACTIONS(2063),
    [sym_file_descriptor] = ACTIONS(2063),
    [ts_builtin_sym_end] = ACTIONS(2063),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_done] = ACTIONS(2063),
    [anon_sym_fi] = ACTIONS(2063),
    [anon_sym_elif] = ACTIONS(2063),
    [anon_sym_else] = ACTIONS(2063),
    [anon_sym_esac] = ACTIONS(2063),
    [anon_sym_PIPE] = ACTIONS(2065),
    [anon_sym_RPAREN] = ACTIONS(2063),
    [anon_sym_SEMI_SEMI] = ACTIONS(2063),
    [anon_sym_PIPE_AMP] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2063),
    [anon_sym_PIPE_PIPE] = ACTIONS(2063),
    [anon_sym_LT] = ACTIONS(2065),
    [anon_sym_GT] = ACTIONS(2065),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_AMP_GT] = ACTIONS(2065),
    [anon_sym_AMP_GT_GT] = ACTIONS(2063),
    [anon_sym_LT_AMP] = ACTIONS(2063),
    [anon_sym_GT_AMP] = ACTIONS(2063),
    [anon_sym_LT_LT] = ACTIONS(2065),
    [anon_sym_LT_LT_DASH] = ACTIONS(2063),
    [anon_sym_LT_LT_LT] = ACTIONS(2063),
    [anon_sym_BQUOTE] = ACTIONS(2063),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2063),
    [anon_sym_AMP] = ACTIONS(2065),
  },
  [504] = {
    [anon_sym_SEMI] = ACTIONS(1217),
    [anon_sym_SEMI_SEMI] = ACTIONS(1215),
    [anon_sym_RBRACE] = ACTIONS(1215),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
  },
  [505] = {
    [sym_simple_expansion] = STATE(1116),
    [sym_expansion] = STATE(1116),
    [sym_command_substitution] = STATE(1116),
    [aux_sym_heredoc_body_repeat1] = STATE(1116),
    [sym__heredoc_body_middle] = ACTIONS(2067),
    [sym__heredoc_body_end] = ACTIONS(2069),
    [anon_sym_DOLLAR] = ACTIONS(1223),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1227),
    [anon_sym_BQUOTE] = ACTIONS(1229),
    [sym_comment] = ACTIONS(57),
  },
  [506] = {
    [anon_sym_LT] = ACTIONS(2071),
    [anon_sym_GT] = ACTIONS(2071),
    [anon_sym_GT_GT] = ACTIONS(2073),
    [anon_sym_AMP_GT] = ACTIONS(2071),
    [anon_sym_AMP_GT_GT] = ACTIONS(2073),
    [anon_sym_LT_AMP] = ACTIONS(2073),
    [anon_sym_GT_AMP] = ACTIONS(2073),
    [sym_comment] = ACTIONS(57),
  },
  [507] = {
    [sym_file_descriptor] = ACTIONS(1235),
    [sym_variable_name] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1239),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1239),
    [anon_sym_if] = ACTIONS(1239),
    [anon_sym_case] = ACTIONS(1239),
    [anon_sym_function] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_RBRACE] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1239),
    [anon_sym_typeset] = ACTIONS(1239),
    [anon_sym_export] = ACTIONS(1239),
    [anon_sym_readonly] = ACTIONS(1239),
    [anon_sym_local] = ACTIONS(1239),
    [anon_sym_unset] = ACTIONS(1239),
    [anon_sym_unsetenv] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_AMP_GT] = ACTIONS(1239),
    [anon_sym_AMP_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_AMP] = ACTIONS(1235),
    [anon_sym_GT_AMP] = ACTIONS(1235),
    [sym__special_character] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_DOLLAR] = ACTIONS(1239),
    [sym_raw_string] = ACTIONS(1235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1235),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1235),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [anon_sym_LT_LPAREN] = ACTIONS(1235),
    [anon_sym_GT_LPAREN] = ACTIONS(1235),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1239),
  },
  [508] = {
    [sym_redirected_statement] = STATE(1118),
    [sym_for_statement] = STATE(1118),
    [sym_c_style_for_statement] = STATE(1118),
    [sym_while_statement] = STATE(1118),
    [sym_if_statement] = STATE(1118),
    [sym_case_statement] = STATE(1118),
    [sym_function_definition] = STATE(1118),
    [sym_compound_statement] = STATE(1118),
    [sym_subshell] = STATE(1118),
    [sym_pipeline] = STATE(1118),
    [sym_list] = STATE(1118),
    [sym_negated_command] = STATE(1118),
    [sym_test_command] = STATE(1118),
    [sym_declaration_command] = STATE(1118),
    [sym_unset_command] = STATE(1118),
    [sym_command] = STATE(1118),
    [sym_command_name] = STATE(138),
    [sym_variable_assignment] = STATE(1119),
    [sym_subscript] = STATE(140),
    [sym_file_redirect] = STATE(143),
    [sym_concatenation] = STATE(141),
    [sym_string] = STATE(130),
    [sym_simple_expansion] = STATE(130),
    [sym_string_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [sym_process_substitution] = STATE(130),
    [aux_sym_command_repeat1] = STATE(143),
    [aux_sym__literal_repeat1] = STATE(144),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_case] = ACTIONS(185),
    [anon_sym_function] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(199),
    [anon_sym_declare] = ACTIONS(201),
    [anon_sym_typeset] = ACTIONS(201),
    [anon_sym_export] = ACTIONS(201),
    [anon_sym_readonly] = ACTIONS(201),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_unset] = ACTIONS(203),
    [anon_sym_unsetenv] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(221),
  },
  [509] = {
    [sym_redirected_statement] = STATE(1120),
    [sym_for_statement] = STATE(1120),
    [sym_c_style_for_statement] = STATE(1120),
    [sym_while_statement] = STATE(1120),
    [sym_if_statement] = STATE(1120),
    [sym_case_statement] = STATE(1120),
    [sym_function_definition] = STATE(1120),
    [sym_compound_statement] = STATE(1120),
    [sym_subshell] = STATE(1120),
    [sym_pipeline] = STATE(1120),
    [sym_list] = STATE(1120),
    [sym_negated_command] = STATE(1120),
    [sym_test_command] = STATE(1120),
    [sym_declaration_command] = STATE(1120),
    [sym_unset_command] = STATE(1120),
    [sym_command] = STATE(1120),
    [sym_command_name] = STATE(138),
    [sym_variable_assignment] = STATE(1121),
    [sym_subscript] = STATE(140),
    [sym_file_redirect] = STATE(143),
    [sym_concatenation] = STATE(141),
    [sym_string] = STATE(130),
    [sym_simple_expansion] = STATE(130),
    [sym_string_expansion] = STATE(130),
    [sym_expansion] = STATE(130),
    [sym_command_substitution] = STATE(130),
    [sym_process_substitution] = STATE(130),
    [aux_sym_command_repeat1] = STATE(143),
    [aux_sym__literal_repeat1] = STATE(144),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(175),
    [anon_sym_for] = ACTIONS(177),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(179),
    [anon_sym_while] = ACTIONS(181),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_case] = ACTIONS(185),
    [anon_sym_function] = ACTIONS(187),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(191),
    [anon_sym_BANG] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(199),
    [anon_sym_declare] = ACTIONS(201),
    [anon_sym_typeset] = ACTIONS(201),
    [anon_sym_export] = ACTIONS(201),
    [anon_sym_readonly] = ACTIONS(201),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_unset] = ACTIONS(203),
    [anon_sym_unsetenv] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(211),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(221),
  },
  [510] = {
    [sym_concatenation] = STATE(1124),
    [sym_string] = STATE(1123),
    [sym_simple_expansion] = STATE(1123),
    [sym_string_expansion] = STATE(1123),
    [sym_expansion] = STATE(1123),
    [sym_command_substitution] = STATE(1123),
    [sym_process_substitution] = STATE(1123),
    [aux_sym__literal_repeat1] = STATE(1125),
    [sym__special_character] = ACTIONS(2075),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(2077),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2077),
  },
  [511] = {
    [sym_heredoc_start] = ACTIONS(2079),
    [sym_comment] = ACTIONS(57),
  },
  [512] = {
    [sym_concatenation] = STATE(1128),
    [sym_string] = STATE(1127),
    [sym_simple_expansion] = STATE(1127),
    [sym_string_expansion] = STATE(1127),
    [sym_expansion] = STATE(1127),
    [sym_command_substitution] = STATE(1127),
    [sym_process_substitution] = STATE(1127),
    [aux_sym__literal_repeat1] = STATE(1129),
    [sym__special_character] = ACTIONS(2075),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(2081),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2081),
  },
  [513] = {
    [anon_sym_SEMI] = ACTIONS(2083),
    [anon_sym_SEMI_SEMI] = ACTIONS(2085),
    [anon_sym_RBRACE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2085),
    [anon_sym_AMP] = ACTIONS(2085),
  },
  [514] = {
    [sym_file_redirect] = STATE(1131),
    [sym_heredoc_redirect] = STATE(1131),
    [sym_herestring_redirect] = STATE(1131),
    [aux_sym_redirected_statement_repeat1] = STATE(1131),
    [sym__simple_heredoc_body] = ACTIONS(1253),
    [sym__heredoc_body_beginning] = ACTIONS(1253),
    [sym_file_descriptor] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_SEMI_SEMI] = ACTIONS(1253),
    [anon_sym_RBRACE] = ACTIONS(1253),
    [anon_sym_PIPE_AMP] = ACTIONS(1253),
    [anon_sym_AMP_AMP] = ACTIONS(1253),
    [anon_sym_PIPE_PIPE] = ACTIONS(1253),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_AMP_GT] = ACTIONS(873),
    [anon_sym_AMP_GT_GT] = ACTIONS(875),
    [anon_sym_LT_AMP] = ACTIONS(875),
    [anon_sym_GT_AMP] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(881),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1255),
  },
  [515] = {
    [sym_concatenation] = STATE(1132),
    [sym_string] = STATE(1133),
    [sym_simple_expansion] = STATE(1133),
    [sym_string_expansion] = STATE(1133),
    [sym_expansion] = STATE(1133),
    [sym_command_substitution] = STATE(1133),
    [sym_process_substitution] = STATE(1133),
    [aux_sym__literal_repeat1] = STATE(1134),
    [sym_regex] = ACTIONS(2087),
    [sym__special_character] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(2089),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2089),
  },
  [516] = {
    [aux_sym_concatenation_repeat1] = STATE(487),
    [sym__simple_heredoc_body] = ACTIONS(1261),
    [sym__heredoc_body_beginning] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_RBRACE] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [sym__special_character] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [517] = {
    [sym_concatenation] = STATE(1135),
    [sym_string] = STATE(516),
    [sym_simple_expansion] = STATE(516),
    [sym_string_expansion] = STATE(516),
    [sym_expansion] = STATE(516),
    [sym_command_substitution] = STATE(516),
    [sym_process_substitution] = STATE(516),
    [aux_sym_command_repeat2] = STATE(1135),
    [aux_sym__literal_repeat1] = STATE(518),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_RBRACE] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(887),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [518] = {
    [aux_sym__literal_repeat1] = STATE(523),
    [sym__simple_heredoc_body] = ACTIONS(1269),
    [sym__heredoc_body_beginning] = ACTIONS(1269),
    [sym_file_descriptor] = ACTIONS(1269),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1269),
    [anon_sym_RBRACE] = ACTIONS(1269),
    [anon_sym_PIPE_AMP] = ACTIONS(1269),
    [anon_sym_AMP_AMP] = ACTIONS(1269),
    [anon_sym_PIPE_PIPE] = ACTIONS(1269),
    [anon_sym_EQ_TILDE] = ACTIONS(1271),
    [anon_sym_EQ_EQ] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT_GT] = ACTIONS(1269),
    [anon_sym_LT_AMP] = ACTIONS(1269),
    [anon_sym_GT_AMP] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_LT_LT_DASH] = ACTIONS(1269),
    [anon_sym_LT_LT_LT] = ACTIONS(1269),
    [sym__special_character] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(1269),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1269),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1269),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [anon_sym_LT_LPAREN] = ACTIONS(1269),
    [anon_sym_GT_LPAREN] = ACTIONS(1269),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1271),
  },
  [519] = {
    [sym_file_redirect] = STATE(514),
    [sym_heredoc_redirect] = STATE(514),
    [sym_heredoc_body] = STATE(1137),
    [sym_herestring_redirect] = STATE(514),
    [aux_sym_redirected_statement_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(857),
    [sym__heredoc_body_beginning] = ACTIONS(859),
    [sym_file_descriptor] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(2091),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_SEMI_SEMI] = ACTIONS(2093),
    [anon_sym_RBRACE] = ACTIONS(1237),
    [anon_sym_PIPE_AMP] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(871),
    [anon_sym_PIPE_PIPE] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(873),
    [anon_sym_GT] = ACTIONS(873),
    [anon_sym_GT_GT] = ACTIONS(875),
    [anon_sym_AMP_GT] = ACTIONS(873),
    [anon_sym_AMP_GT_GT] = ACTIONS(875),
    [anon_sym_LT_AMP] = ACTIONS(875),
    [anon_sym_GT_AMP] = ACTIONS(875),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(881),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2093),
    [anon_sym_AMP] = ACTIONS(2091),
  },
  [520] = {
    [sym_file_redirect] = STATE(514),
    [sym_heredoc_redirect] = STATE(514),
    [sym_heredoc_body] = STATE(1137),
    [sym_herestring_redirect] = STATE(514),
    [aux_sym_redirected_statement_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(857),
    [sym__heredoc_body_beginning] = ACTIONS(859),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2091),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_SEMI_SEMI] = ACTIONS(2093),
    [anon_sym_RBRACE] = ACTIONS(1237),
    [anon_sym_PIPE_AMP] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(871),
    [anon_sym_PIPE_PIPE] = ACTIONS(871),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(881),
    [sym__special_character] = ACTIONS(435),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2093),
    [anon_sym_AMP] = ACTIONS(2091),
  },
  [521] = {
    [sym_concatenation] = STATE(1138),
    [sym_string] = STATE(516),
    [sym_simple_expansion] = STATE(516),
    [sym_string_expansion] = STATE(516),
    [sym_expansion] = STATE(516),
    [sym_command_substitution] = STATE(516),
    [sym_process_substitution] = STATE(516),
    [aux_sym_command_repeat2] = STATE(1138),
    [aux_sym__literal_repeat1] = STATE(518),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_RBRACE] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(887),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [522] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(329),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [523] = {
    [aux_sym__literal_repeat1] = STATE(523),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_RBRACE] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_EQ_TILDE] = ACTIONS(1373),
    [anon_sym_EQ_EQ] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(2095),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [524] = {
    [sym_concatenation] = STATE(1139),
    [sym_string] = STATE(1141),
    [sym_array] = STATE(1139),
    [sym_simple_expansion] = STATE(1141),
    [sym_string_expansion] = STATE(1141),
    [sym_expansion] = STATE(1141),
    [sym_command_substitution] = STATE(1141),
    [sym_process_substitution] = STATE(1141),
    [aux_sym__literal_repeat1] = STATE(1142),
    [sym__empty_value] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(2100),
    [sym__special_character] = ACTIONS(309),
    [anon_sym_DQUOTE] = ACTIONS(311),
    [anon_sym_DOLLAR] = ACTIONS(313),
    [sym_raw_string] = ACTIONS(2102),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(319),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2102),
  },
  [525] = {
    [anon_sym_RPAREN] = ACTIONS(2104),
    [anon_sym_AMP_AMP] = ACTIONS(1534),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_EQ_TILDE] = ACTIONS(1536),
    [anon_sym_EQ_EQ] = ACTIONS(1536),
    [anon_sym_EQ] = ACTIONS(1538),
    [anon_sym_PLUS_EQ] = ACTIONS(1534),
    [anon_sym_LT] = ACTIONS(1538),
    [anon_sym_GT] = ACTIONS(1538),
    [anon_sym_BANG_EQ] = ACTIONS(1534),
    [anon_sym_PLUS] = ACTIONS(1538),
    [anon_sym_DASH] = ACTIONS(1538),
    [anon_sym_DASH_EQ] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1534),
    [anon_sym_GT_EQ] = ACTIONS(1534),
    [anon_sym_PLUS_PLUS] = ACTIONS(1540),
    [anon_sym_DASH_DASH] = ACTIONS(1540),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1534),
  },
  [526] = {
    [anon_sym_AMP_AMP] = ACTIONS(923),
    [anon_sym_PIPE_PIPE] = ACTIONS(923),
    [anon_sym_RBRACK] = ACTIONS(1544),
    [anon_sym_EQ_TILDE] = ACTIONS(925),
    [anon_sym_EQ_EQ] = ACTIONS(925),
    [anon_sym_EQ] = ACTIONS(927),
    [anon_sym_PLUS_EQ] = ACTIONS(923),
    [anon_sym_LT] = ACTIONS(927),
    [anon_sym_GT] = ACTIONS(927),
    [anon_sym_BANG_EQ] = ACTIONS(923),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_DASH] = ACTIONS(927),
    [anon_sym_DASH_EQ] = ACTIONS(923),
    [anon_sym_LT_EQ] = ACTIONS(923),
    [anon_sym_GT_EQ] = ACTIONS(923),
    [anon_sym_PLUS_PLUS] = ACTIONS(929),
    [anon_sym_DASH_DASH] = ACTIONS(929),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(923),
  },
  [527] = {
    [sym_string] = STATE(1144),
    [sym_simple_expansion] = STATE(1144),
    [sym_string_expansion] = STATE(1144),
    [sym_expansion] = STATE(1144),
    [sym_command_substitution] = STATE(1144),
    [sym_process_substitution] = STATE(1144),
    [sym__special_character] = ACTIONS(2106),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(2106),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2106),
  },
  [528] = {
    [aux_sym_concatenation_repeat1] = STATE(1145),
    [sym__concat] = ACTIONS(899),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_RBRACK] = ACTIONS(1059),
    [anon_sym_EQ_TILDE] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1059),
    [anon_sym_EQ] = ACTIONS(1061),
    [anon_sym_PLUS_EQ] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_BANG_EQ] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_DASH_EQ] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1059),
  },
  [529] = {
    [sym__concat] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_RBRACK] = ACTIONS(1063),
    [anon_sym_EQ_TILDE] = ACTIONS(1063),
    [anon_sym_EQ_EQ] = ACTIONS(1063),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_PLUS_EQ] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG_EQ] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1063),
  },
  [530] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(2108),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [531] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(2108),
    [anon_sym_DOLLAR] = ACTIONS(2110),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [532] = {
    [sym__concat] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_RBRACK] = ACTIONS(1097),
    [anon_sym_EQ_TILDE] = ACTIONS(1097),
    [anon_sym_EQ_EQ] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_PLUS_EQ] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_BANG_EQ] = ACTIONS(1097),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_DASH_EQ] = ACTIONS(1097),
    [anon_sym_LT_EQ] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1097),
  },
  [533] = {
    [sym__concat] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_RBRACK] = ACTIONS(1101),
    [anon_sym_EQ_TILDE] = ACTIONS(1101),
    [anon_sym_EQ_EQ] = ACTIONS(1101),
    [anon_sym_EQ] = ACTIONS(1103),
    [anon_sym_PLUS_EQ] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_DASH_EQ] = ACTIONS(1101),
    [anon_sym_LT_EQ] = ACTIONS(1101),
    [anon_sym_GT_EQ] = ACTIONS(1101),
    [anon_sym_PLUS_PLUS] = ACTIONS(1101),
    [anon_sym_DASH_DASH] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1101),
  },
  [534] = {
    [sym__concat] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_RBRACK] = ACTIONS(1105),
    [anon_sym_EQ_TILDE] = ACTIONS(1105),
    [anon_sym_EQ_EQ] = ACTIONS(1105),
    [anon_sym_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_BANG_EQ] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1107),
    [anon_sym_DASH] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1105),
    [anon_sym_LT_EQ] = ACTIONS(1105),
    [anon_sym_GT_EQ] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1105),
    [anon_sym_DASH_DASH] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1105),
  },
  [535] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(2112),
    [sym_comment] = ACTIONS(57),
  },
  [536] = {
    [sym_subscript] = STATE(1151),
    [sym_variable_name] = ACTIONS(2114),
    [anon_sym_DASH] = ACTIONS(2116),
    [anon_sym_DOLLAR] = ACTIONS(2116),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2118),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_AT] = ACTIONS(2120),
    [anon_sym_QMARK] = ACTIONS(2120),
    [anon_sym_0] = ACTIONS(2118),
    [anon_sym__] = ACTIONS(2118),
  },
  [537] = {
    [sym_concatenation] = STATE(1154),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1154),
    [anon_sym_RBRACE] = ACTIONS(2122),
    [anon_sym_EQ] = ACTIONS(2124),
    [anon_sym_DASH] = ACTIONS(2124),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2126),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(2128),
    [anon_sym_COLON] = ACTIONS(2124),
    [anon_sym_COLON_QMARK] = ACTIONS(2124),
    [anon_sym_COLON_DASH] = ACTIONS(2124),
    [anon_sym_PERCENT] = ACTIONS(2124),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [538] = {
    [sym_concatenation] = STATE(1157),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1157),
    [anon_sym_RBRACE] = ACTIONS(2130),
    [anon_sym_EQ] = ACTIONS(2132),
    [anon_sym_DASH] = ACTIONS(2132),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2134),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(2136),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_COLON_QMARK] = ACTIONS(2132),
    [anon_sym_COLON_DASH] = ACTIONS(2132),
    [anon_sym_PERCENT] = ACTIONS(2132),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [539] = {
    [anon_sym_RPAREN] = ACTIONS(2138),
    [sym_comment] = ACTIONS(57),
  },
  [540] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2138),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [541] = {
    [anon_sym_BQUOTE] = ACTIONS(2138),
    [sym_comment] = ACTIONS(57),
  },
  [542] = {
    [anon_sym_RPAREN] = ACTIONS(2140),
    [sym_comment] = ACTIONS(57),
  },
  [543] = {
    [sym__expression] = STATE(1160),
    [sym_binary_expression] = STATE(1160),
    [sym_unary_expression] = STATE(1160),
    [sym_postfix_expression] = STATE(1160),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_concatenation] = STATE(1160),
    [sym_string] = STATE(153),
    [sym_simple_expansion] = STATE(153),
    [sym_string_expansion] = STATE(153),
    [sym_expansion] = STATE(153),
    [sym_command_substitution] = STATE(153),
    [sym_process_substitution] = STATE(153),
    [aux_sym__literal_repeat1] = STATE(159),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_BANG] = ACTIONS(227),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(245),
    [sym_test_operator] = ACTIONS(247),
  },
  [544] = {
    [sym__expression] = STATE(1160),
    [sym_binary_expression] = STATE(1160),
    [sym_unary_expression] = STATE(1160),
    [sym_postfix_expression] = STATE(1160),
    [sym_parenthesized_expression] = STATE(1160),
    [sym_concatenation] = STATE(1160),
    [sym_string] = STATE(153),
    [sym_simple_expansion] = STATE(153),
    [sym_string_expansion] = STATE(153),
    [sym_expansion] = STATE(153),
    [sym_command_substitution] = STATE(153),
    [sym_process_substitution] = STATE(153),
    [aux_sym__literal_repeat1] = STATE(159),
    [sym_regex] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(225),
    [anon_sym_BANG] = ACTIONS(227),
    [sym__special_character] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(245),
    [sym_test_operator] = ACTIONS(247),
  },
  [545] = {
    [anon_sym_AMP_AMP] = ACTIONS(1588),
    [anon_sym_PIPE_PIPE] = ACTIONS(1588),
    [anon_sym_RBRACK] = ACTIONS(1588),
    [anon_sym_EQ_TILDE] = ACTIONS(1588),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_EQ] = ACTIONS(1590),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_PLUS] = ACTIONS(1590),
    [anon_sym_DASH] = ACTIONS(1590),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_PLUS] = ACTIONS(1588),
    [anon_sym_DASH_DASH] = ACTIONS(1588),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1588),
  },
  [546] = {
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_RBRACK] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(325),
    [anon_sym_EQ_EQ] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_PLUS_EQ] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_BANG_EQ] = ACTIONS(325),
    [anon_sym_PLUS] = ACTIONS(329),
    [anon_sym_DASH] = ACTIONS(329),
    [anon_sym_DASH_EQ] = ACTIONS(325),
    [anon_sym_LT_EQ] = ACTIONS(325),
    [anon_sym_GT_EQ] = ACTIONS(325),
    [anon_sym_PLUS_PLUS] = ACTIONS(325),
    [anon_sym_DASH_DASH] = ACTIONS(325),
    [sym__special_character] = ACTIONS(329),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(325),
  },
  [547] = {
    [aux_sym__literal_repeat1] = STATE(547),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_RBRACK] = ACTIONS(1371),
    [anon_sym_EQ_TILDE] = ACTIONS(1371),
    [anon_sym_EQ_EQ] = ACTIONS(1371),
    [anon_sym_EQ] = ACTIONS(1373),
    [anon_sym_PLUS_EQ] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_BANG_EQ] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1373),
    [anon_sym_DASH] = ACTIONS(1373),
    [anon_sym_DASH_EQ] = ACTIONS(1371),
    [anon_sym_LT_EQ] = ACTIONS(1371),
    [anon_sym_GT_EQ] = ACTIONS(1371),
    [anon_sym_PLUS_PLUS] = ACTIONS(1371),
    [anon_sym_DASH_DASH] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(2144),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1371),
  },
  [548] = {
    [anon_sym_AMP_AMP] = ACTIONS(933),
    [anon_sym_PIPE_PIPE] = ACTIONS(933),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1544),
    [anon_sym_EQ_TILDE] = ACTIONS(935),
    [anon_sym_EQ_EQ] = ACTIONS(935),
    [anon_sym_EQ] = ACTIONS(937),
    [anon_sym_PLUS_EQ] = ACTIONS(933),
    [anon_sym_LT] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(937),
    [anon_sym_BANG_EQ] = ACTIONS(933),
    [anon_sym_PLUS] = ACTIONS(937),
    [anon_sym_DASH] = ACTIONS(937),
    [anon_sym_DASH_EQ] = ACTIONS(933),
    [anon_sym_LT_EQ] = ACTIONS(933),
    [anon_sym_GT_EQ] = ACTIONS(933),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(933),
  },
  [549] = {
    [aux_sym_concatenation_repeat1] = STATE(1162),
    [sym__concat] = ACTIONS(527),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1059),
    [anon_sym_EQ_TILDE] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1059),
    [anon_sym_EQ] = ACTIONS(1061),
    [anon_sym_PLUS_EQ] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_BANG_EQ] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_DASH_EQ] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1059),
  },
  [550] = {
    [sym__expression] = STATE(831),
    [sym_binary_expression] = STATE(831),
    [sym_unary_expression] = STATE(831),
    [sym_postfix_expression] = STATE(831),
    [sym_parenthesized_expression] = STATE(831),
    [sym_concatenation] = STATE(831),
    [sym_string] = STATE(162),
    [sym_simple_expansion] = STATE(162),
    [sym_string_expansion] = STATE(162),
    [sym_expansion] = STATE(162),
    [sym_command_substitution] = STATE(162),
    [sym_process_substitution] = STATE(162),
    [aux_sym__literal_repeat1] = STATE(164),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(249),
    [sym__special_character] = ACTIONS(251),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(255),
    [sym_test_operator] = ACTIONS(257),
  },
  [551] = {
    [sym__expression] = STATE(831),
    [sym_binary_expression] = STATE(831),
    [sym_unary_expression] = STATE(831),
    [sym_postfix_expression] = STATE(831),
    [sym_parenthesized_expression] = STATE(831),
    [sym_concatenation] = STATE(831),
    [sym_string] = STATE(162),
    [sym_simple_expansion] = STATE(162),
    [sym_string_expansion] = STATE(162),
    [sym_expansion] = STATE(162),
    [sym_command_substitution] = STATE(162),
    [sym_process_substitution] = STATE(162),
    [aux_sym__literal_repeat1] = STATE(164),
    [sym_regex] = ACTIONS(1586),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(249),
    [sym__special_character] = ACTIONS(251),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(255),
    [sym_test_operator] = ACTIONS(257),
  },
  [552] = {
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(325),
    [anon_sym_EQ_EQ] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_PLUS_EQ] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_BANG_EQ] = ACTIONS(325),
    [anon_sym_PLUS] = ACTIONS(329),
    [anon_sym_DASH] = ACTIONS(329),
    [anon_sym_DASH_EQ] = ACTIONS(325),
    [anon_sym_LT_EQ] = ACTIONS(325),
    [anon_sym_GT_EQ] = ACTIONS(325),
    [anon_sym_PLUS_PLUS] = ACTIONS(325),
    [anon_sym_DASH_DASH] = ACTIONS(325),
    [sym__special_character] = ACTIONS(329),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(325),
  },
  [553] = {
    [aux_sym__literal_repeat1] = STATE(553),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1371),
    [anon_sym_EQ_TILDE] = ACTIONS(1371),
    [anon_sym_EQ_EQ] = ACTIONS(1371),
    [anon_sym_EQ] = ACTIONS(1373),
    [anon_sym_PLUS_EQ] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_BANG_EQ] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1373),
    [anon_sym_DASH] = ACTIONS(1373),
    [anon_sym_DASH_EQ] = ACTIONS(1371),
    [anon_sym_LT_EQ] = ACTIONS(1371),
    [anon_sym_GT_EQ] = ACTIONS(1371),
    [anon_sym_PLUS_PLUS] = ACTIONS(1371),
    [anon_sym_DASH_DASH] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(2147),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1371),
  },
  [554] = {
    [sym_concatenation] = STATE(1163),
    [sym_string] = STATE(1165),
    [sym_array] = STATE(1163),
    [sym_simple_expansion] = STATE(1165),
    [sym_string_expansion] = STATE(1165),
    [sym_expansion] = STATE(1165),
    [sym_command_substitution] = STATE(1165),
    [sym_process_substitution] = STATE(1165),
    [aux_sym__literal_repeat1] = STATE(1166),
    [sym__empty_value] = ACTIONS(2150),
    [anon_sym_LPAREN] = ACTIONS(2152),
    [sym__special_character] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(2154),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2154),
  },
  [555] = {
    [sym_string] = STATE(1167),
    [sym_simple_expansion] = STATE(1167),
    [sym_string_expansion] = STATE(1167),
    [sym_expansion] = STATE(1167),
    [sym_command_substitution] = STATE(1167),
    [sym_process_substitution] = STATE(1167),
    [sym__special_character] = ACTIONS(2156),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(2156),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2156),
  },
  [556] = {
    [aux_sym_concatenation_repeat1] = STATE(1168),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(943),
    [sym_variable_name] = ACTIONS(1059),
    [ts_builtin_sym_end] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1061),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [557] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [sym_variable_name] = ACTIONS(1063),
    [ts_builtin_sym_end] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [558] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [559] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(2158),
    [anon_sym_DOLLAR] = ACTIONS(2160),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [560] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [sym_variable_name] = ACTIONS(1097),
    [ts_builtin_sym_end] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_RPAREN] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1099),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [561] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [sym_variable_name] = ACTIONS(1101),
    [ts_builtin_sym_end] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_RPAREN] = ACTIONS(1101),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1103),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [562] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [sym_variable_name] = ACTIONS(1105),
    [ts_builtin_sym_end] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1105),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1107),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [563] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(2162),
    [sym_comment] = ACTIONS(57),
  },
  [564] = {
    [sym_subscript] = STATE(1174),
    [sym_variable_name] = ACTIONS(2164),
    [anon_sym_DASH] = ACTIONS(2166),
    [anon_sym_DOLLAR] = ACTIONS(2166),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2168),
    [anon_sym_STAR] = ACTIONS(2170),
    [anon_sym_AT] = ACTIONS(2170),
    [anon_sym_QMARK] = ACTIONS(2170),
    [anon_sym_0] = ACTIONS(2168),
    [anon_sym__] = ACTIONS(2168),
  },
  [565] = {
    [sym_concatenation] = STATE(1177),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1177),
    [anon_sym_RBRACE] = ACTIONS(2172),
    [anon_sym_EQ] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2174),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2176),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(2178),
    [anon_sym_COLON] = ACTIONS(2174),
    [anon_sym_COLON_QMARK] = ACTIONS(2174),
    [anon_sym_COLON_DASH] = ACTIONS(2174),
    [anon_sym_PERCENT] = ACTIONS(2174),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [566] = {
    [sym_concatenation] = STATE(1180),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1180),
    [anon_sym_RBRACE] = ACTIONS(2180),
    [anon_sym_EQ] = ACTIONS(2182),
    [anon_sym_DASH] = ACTIONS(2182),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(2186),
    [anon_sym_COLON] = ACTIONS(2182),
    [anon_sym_COLON_QMARK] = ACTIONS(2182),
    [anon_sym_COLON_DASH] = ACTIONS(2182),
    [anon_sym_PERCENT] = ACTIONS(2182),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [567] = {
    [anon_sym_RPAREN] = ACTIONS(2188),
    [sym_comment] = ACTIONS(57),
  },
  [568] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [569] = {
    [anon_sym_BQUOTE] = ACTIONS(2188),
    [sym_comment] = ACTIONS(57),
  },
  [570] = {
    [anon_sym_RPAREN] = ACTIONS(2190),
    [sym_comment] = ACTIONS(57),
  },
  [571] = {
    [sym_variable_assignment] = STATE(571),
    [sym_subscript] = STATE(174),
    [sym_concatenation] = STATE(571),
    [sym_string] = STATE(169),
    [sym_simple_expansion] = STATE(169),
    [sym_string_expansion] = STATE(169),
    [sym_expansion] = STATE(169),
    [sym_command_substitution] = STATE(169),
    [sym_process_substitution] = STATE(169),
    [aux_sym_declaration_command_repeat1] = STATE(571),
    [aux_sym__literal_repeat1] = STATE(176),
    [sym__simple_heredoc_body] = ACTIONS(2192),
    [sym__heredoc_body_beginning] = ACTIONS(2192),
    [sym_file_descriptor] = ACTIONS(2192),
    [sym_variable_name] = ACTIONS(2194),
    [ts_builtin_sym_end] = ACTIONS(2192),
    [anon_sym_SEMI] = ACTIONS(2197),
    [anon_sym_PIPE] = ACTIONS(2197),
    [anon_sym_SEMI_SEMI] = ACTIONS(2192),
    [anon_sym_PIPE_AMP] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_GT] = ACTIONS(2197),
    [anon_sym_GT_GT] = ACTIONS(2192),
    [anon_sym_AMP_GT] = ACTIONS(2197),
    [anon_sym_AMP_GT_GT] = ACTIONS(2192),
    [anon_sym_LT_AMP] = ACTIONS(2192),
    [anon_sym_GT_AMP] = ACTIONS(2192),
    [anon_sym_LT_LT] = ACTIONS(2197),
    [anon_sym_LT_LT_DASH] = ACTIONS(2192),
    [anon_sym_LT_LT_LT] = ACTIONS(2192),
    [sym__special_character] = ACTIONS(2199),
    [anon_sym_DQUOTE] = ACTIONS(2202),
    [anon_sym_DOLLAR] = ACTIONS(2205),
    [sym_raw_string] = ACTIONS(2208),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2214),
    [anon_sym_BQUOTE] = ACTIONS(2217),
    [anon_sym_LT_LPAREN] = ACTIONS(2220),
    [anon_sym_GT_LPAREN] = ACTIONS(2220),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2223),
    [sym_word] = ACTIONS(2226),
    [anon_sym_LF] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2197),
  },
  [572] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [ts_builtin_sym_end] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_RPAREN] = ACTIONS(325),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [573] = {
    [aux_sym__literal_repeat1] = STATE(573),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym_variable_name] = ACTIONS(1371),
    [ts_builtin_sym_end] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(2229),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1373),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [574] = {
    [sym_string] = STATE(1183),
    [sym_simple_expansion] = STATE(1183),
    [sym_string_expansion] = STATE(1183),
    [sym_expansion] = STATE(1183),
    [sym_command_substitution] = STATE(1183),
    [sym_process_substitution] = STATE(1183),
    [sym__special_character] = ACTIONS(2232),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_DOLLAR] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(2232),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2232),
  },
  [575] = {
    [aux_sym_concatenation_repeat1] = STATE(1184),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(983),
    [ts_builtin_sym_end] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1061),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [576] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [ts_builtin_sym_end] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [577] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(2234),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [578] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(2234),
    [anon_sym_DOLLAR] = ACTIONS(2236),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [579] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [ts_builtin_sym_end] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_RPAREN] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1099),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [580] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [ts_builtin_sym_end] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_RPAREN] = ACTIONS(1101),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1103),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [581] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [ts_builtin_sym_end] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1105),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1107),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [582] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(2238),
    [sym_comment] = ACTIONS(57),
  },
  [583] = {
    [sym_subscript] = STATE(1190),
    [sym_variable_name] = ACTIONS(2240),
    [anon_sym_DASH] = ACTIONS(2242),
    [anon_sym_DOLLAR] = ACTIONS(2242),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2244),
    [anon_sym_STAR] = ACTIONS(2246),
    [anon_sym_AT] = ACTIONS(2246),
    [anon_sym_QMARK] = ACTIONS(2246),
    [anon_sym_0] = ACTIONS(2244),
    [anon_sym__] = ACTIONS(2244),
  },
  [584] = {
    [sym_concatenation] = STATE(1193),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1193),
    [anon_sym_RBRACE] = ACTIONS(2248),
    [anon_sym_EQ] = ACTIONS(2250),
    [anon_sym_DASH] = ACTIONS(2250),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2252),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(2254),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_COLON_QMARK] = ACTIONS(2250),
    [anon_sym_COLON_DASH] = ACTIONS(2250),
    [anon_sym_PERCENT] = ACTIONS(2250),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [585] = {
    [sym_concatenation] = STATE(1196),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1196),
    [anon_sym_RBRACE] = ACTIONS(2256),
    [anon_sym_EQ] = ACTIONS(2258),
    [anon_sym_DASH] = ACTIONS(2258),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2260),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(2262),
    [anon_sym_COLON] = ACTIONS(2258),
    [anon_sym_COLON_QMARK] = ACTIONS(2258),
    [anon_sym_COLON_DASH] = ACTIONS(2258),
    [anon_sym_PERCENT] = ACTIONS(2258),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [586] = {
    [anon_sym_RPAREN] = ACTIONS(2264),
    [sym_comment] = ACTIONS(57),
  },
  [587] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2264),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [588] = {
    [anon_sym_BQUOTE] = ACTIONS(2264),
    [sym_comment] = ACTIONS(57),
  },
  [589] = {
    [anon_sym_RPAREN] = ACTIONS(2266),
    [sym_comment] = ACTIONS(57),
  },
  [590] = {
    [sym_concatenation] = STATE(590),
    [sym_string] = STATE(180),
    [sym_simple_expansion] = STATE(180),
    [sym_string_expansion] = STATE(180),
    [sym_expansion] = STATE(180),
    [sym_command_substitution] = STATE(180),
    [sym_process_substitution] = STATE(180),
    [aux_sym_unset_command_repeat1] = STATE(590),
    [aux_sym__literal_repeat1] = STATE(186),
    [sym__simple_heredoc_body] = ACTIONS(2268),
    [sym__heredoc_body_beginning] = ACTIONS(2268),
    [sym_file_descriptor] = ACTIONS(2268),
    [ts_builtin_sym_end] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2270),
    [anon_sym_SEMI_SEMI] = ACTIONS(2268),
    [anon_sym_PIPE_AMP] = ACTIONS(2268),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [anon_sym_PIPE_PIPE] = ACTIONS(2268),
    [anon_sym_LT] = ACTIONS(2270),
    [anon_sym_GT] = ACTIONS(2270),
    [anon_sym_GT_GT] = ACTIONS(2268),
    [anon_sym_AMP_GT] = ACTIONS(2270),
    [anon_sym_AMP_GT_GT] = ACTIONS(2268),
    [anon_sym_LT_AMP] = ACTIONS(2268),
    [anon_sym_GT_AMP] = ACTIONS(2268),
    [anon_sym_LT_LT] = ACTIONS(2270),
    [anon_sym_LT_LT_DASH] = ACTIONS(2268),
    [anon_sym_LT_LT_LT] = ACTIONS(2268),
    [sym__special_character] = ACTIONS(2272),
    [anon_sym_DQUOTE] = ACTIONS(2275),
    [anon_sym_DOLLAR] = ACTIONS(2278),
    [sym_raw_string] = ACTIONS(2281),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2287),
    [anon_sym_BQUOTE] = ACTIONS(2290),
    [anon_sym_LT_LPAREN] = ACTIONS(2293),
    [anon_sym_GT_LPAREN] = ACTIONS(2293),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2296),
    [sym_word] = ACTIONS(2299),
    [anon_sym_LF] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2270),
  },
  [591] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [ts_builtin_sym_end] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_RPAREN] = ACTIONS(325),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [592] = {
    [aux_sym__literal_repeat1] = STATE(592),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [ts_builtin_sym_end] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(2302),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1373),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [593] = {
    [sym_string] = STATE(1199),
    [sym_simple_expansion] = STATE(1199),
    [sym_string_expansion] = STATE(1199),
    [sym_expansion] = STATE(1199),
    [sym_command_substitution] = STATE(1199),
    [sym_process_substitution] = STATE(1199),
    [sym__special_character] = ACTIONS(2305),
    [anon_sym_DQUOTE] = ACTIONS(311),
    [anon_sym_DOLLAR] = ACTIONS(313),
    [sym_raw_string] = ACTIONS(2305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(319),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2305),
  },
  [594] = {
    [aux_sym_concatenation_repeat1] = STATE(1200),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(1023),
    [sym_variable_name] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1059),
  },
  [595] = {
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [sym_variable_name] = ACTIONS(1063),
    [anon_sym_RPAREN] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1063),
  },
  [596] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [597] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(2307),
    [anon_sym_DOLLAR] = ACTIONS(2309),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [598] = {
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_RPAREN] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
  },
  [599] = {
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [sym_variable_name] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1101),
  },
  [600] = {
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [sym_variable_name] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1105),
  },
  [601] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(2311),
    [sym_comment] = ACTIONS(57),
  },
  [602] = {
    [sym_subscript] = STATE(1206),
    [sym_variable_name] = ACTIONS(2313),
    [anon_sym_DASH] = ACTIONS(2315),
    [anon_sym_DOLLAR] = ACTIONS(2315),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2317),
    [anon_sym_STAR] = ACTIONS(2319),
    [anon_sym_AT] = ACTIONS(2319),
    [anon_sym_QMARK] = ACTIONS(2319),
    [anon_sym_0] = ACTIONS(2317),
    [anon_sym__] = ACTIONS(2317),
  },
  [603] = {
    [sym_concatenation] = STATE(1209),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1209),
    [anon_sym_RBRACE] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2323),
    [anon_sym_DASH] = ACTIONS(2323),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(2327),
    [anon_sym_COLON] = ACTIONS(2323),
    [anon_sym_COLON_QMARK] = ACTIONS(2323),
    [anon_sym_COLON_DASH] = ACTIONS(2323),
    [anon_sym_PERCENT] = ACTIONS(2323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [604] = {
    [sym_concatenation] = STATE(1212),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1212),
    [anon_sym_RBRACE] = ACTIONS(2329),
    [anon_sym_EQ] = ACTIONS(2331),
    [anon_sym_DASH] = ACTIONS(2331),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(2335),
    [anon_sym_COLON] = ACTIONS(2331),
    [anon_sym_COLON_QMARK] = ACTIONS(2331),
    [anon_sym_COLON_DASH] = ACTIONS(2331),
    [anon_sym_PERCENT] = ACTIONS(2331),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [605] = {
    [anon_sym_RPAREN] = ACTIONS(2337),
    [sym_comment] = ACTIONS(57),
  },
  [606] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2337),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [607] = {
    [anon_sym_BQUOTE] = ACTIONS(2337),
    [sym_comment] = ACTIONS(57),
  },
  [608] = {
    [anon_sym_RPAREN] = ACTIONS(2339),
    [sym_comment] = ACTIONS(57),
  },
  [609] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(325),
  },
  [610] = {
    [aux_sym__literal_repeat1] = STATE(610),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym_variable_name] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(2341),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1371),
  },
  [611] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [ts_builtin_sym_end] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_RPAREN] = ACTIONS(2344),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2346),
    [anon_sym_EQ_EQ] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [612] = {
    [aux_sym_concatenation_repeat1] = STATE(612),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2348),
    [ts_builtin_sym_end] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2346),
    [anon_sym_EQ_EQ] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [613] = {
    [sym__concat] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym__string_content] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1099),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [sym_comment] = ACTIONS(343),
  },
  [614] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [ts_builtin_sym_end] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_RPAREN] = ACTIONS(2351),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_EQ_TILDE] = ACTIONS(2353),
    [anon_sym_EQ_EQ] = ACTIONS(2353),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [615] = {
    [sym__concat] = ACTIONS(2355),
    [anon_sym_DQUOTE] = ACTIONS(2357),
    [anon_sym_DOLLAR] = ACTIONS(2357),
    [sym__string_content] = ACTIONS(2359),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2357),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2357),
    [anon_sym_BQUOTE] = ACTIONS(2357),
    [sym_comment] = ACTIONS(343),
  },
  [616] = {
    [sym__concat] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym__string_content] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1107),
    [anon_sym_BQUOTE] = ACTIONS(1107),
    [sym_comment] = ACTIONS(343),
  },
  [617] = {
    [anon_sym_DQUOTE] = ACTIONS(2357),
    [anon_sym_DOLLAR] = ACTIONS(2357),
    [sym__string_content] = ACTIONS(2359),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2357),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2357),
    [anon_sym_BQUOTE] = ACTIONS(2357),
    [sym_comment] = ACTIONS(343),
  },
  [618] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(2361),
    [sym_comment] = ACTIONS(57),
  },
  [619] = {
    [sym_subscript] = STATE(1219),
    [sym_variable_name] = ACTIONS(2363),
    [anon_sym_DASH] = ACTIONS(2365),
    [anon_sym_DOLLAR] = ACTIONS(2365),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2369),
    [anon_sym_AT] = ACTIONS(2369),
    [anon_sym_QMARK] = ACTIONS(2369),
    [anon_sym_0] = ACTIONS(2367),
    [anon_sym__] = ACTIONS(2367),
  },
  [620] = {
    [sym_concatenation] = STATE(1222),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1222),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_EQ] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2373),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2375),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(2377),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_COLON_QMARK] = ACTIONS(2373),
    [anon_sym_COLON_DASH] = ACTIONS(2373),
    [anon_sym_PERCENT] = ACTIONS(2373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [621] = {
    [sym_concatenation] = STATE(1225),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1225),
    [anon_sym_RBRACE] = ACTIONS(2379),
    [anon_sym_EQ] = ACTIONS(2381),
    [anon_sym_DASH] = ACTIONS(2381),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(2385),
    [anon_sym_COLON] = ACTIONS(2381),
    [anon_sym_COLON_QMARK] = ACTIONS(2381),
    [anon_sym_COLON_DASH] = ACTIONS(2381),
    [anon_sym_PERCENT] = ACTIONS(2381),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [622] = {
    [anon_sym_RPAREN] = ACTIONS(2387),
    [sym_comment] = ACTIONS(57),
  },
  [623] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2387),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [624] = {
    [anon_sym_BQUOTE] = ACTIONS(2387),
    [sym_comment] = ACTIONS(57),
  },
  [625] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(2389),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [626] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(2357),
    [anon_sym_DOLLAR] = ACTIONS(2391),
    [sym__string_content] = ACTIONS(2394),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2397),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2400),
    [anon_sym_BQUOTE] = ACTIONS(2403),
    [sym_comment] = ACTIONS(343),
  },
  [627] = {
    [sym_concatenation] = STATE(1230),
    [sym_string] = STATE(1229),
    [sym_simple_expansion] = STATE(1229),
    [sym_string_expansion] = STATE(1229),
    [sym_expansion] = STATE(1229),
    [sym_command_substitution] = STATE(1229),
    [sym_process_substitution] = STATE(1229),
    [aux_sym__literal_repeat1] = STATE(1231),
    [sym__special_character] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(2406),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2406),
  },
  [628] = {
    [sym_concatenation] = STATE(1241),
    [sym_string] = STATE(1236),
    [sym_simple_expansion] = STATE(1236),
    [sym_string_expansion] = STATE(1236),
    [sym_expansion] = STATE(1236),
    [sym_command_substitution] = STATE(1236),
    [sym_process_substitution] = STATE(1236),
    [aux_sym__literal_repeat1] = STATE(1242),
    [anon_sym_RBRACE] = ACTIONS(2408),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(2416),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2416),
  },
  [629] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(2426),
    [sym_comment] = ACTIONS(57),
  },
  [630] = {
    [sym_concatenation] = STATE(1246),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1246),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_EQ] = ACTIONS(2430),
    [anon_sym_DASH] = ACTIONS(2430),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2432),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(2434),
    [anon_sym_COLON] = ACTIONS(2430),
    [anon_sym_COLON_QMARK] = ACTIONS(2430),
    [anon_sym_COLON_DASH] = ACTIONS(2430),
    [anon_sym_PERCENT] = ACTIONS(2430),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [631] = {
    [sym_concatenation] = STATE(1248),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1248),
    [anon_sym_RBRACE] = ACTIONS(2408),
    [anon_sym_EQ] = ACTIONS(2436),
    [anon_sym_DASH] = ACTIONS(2436),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2438),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(2440),
    [anon_sym_COLON] = ACTIONS(2436),
    [anon_sym_COLON_QMARK] = ACTIONS(2436),
    [anon_sym_COLON_DASH] = ACTIONS(2436),
    [anon_sym_PERCENT] = ACTIONS(2436),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [632] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [ts_builtin_sym_end] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_RPAREN] = ACTIONS(2442),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_EQ_TILDE] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2444),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [633] = {
    [aux_sym_concatenation_repeat1] = STATE(1250),
    [sym__concat] = ACTIONS(2446),
    [anon_sym_RBRACE] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_DASH] = ACTIONS(329),
    [sym__special_character] = ACTIONS(329),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_POUND] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_COLON_QMARK] = ACTIONS(329),
    [anon_sym_COLON_DASH] = ACTIONS(329),
    [anon_sym_PERCENT] = ACTIONS(329),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(329),
  },
  [634] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(1253),
    [anon_sym_DQUOTE] = ACTIONS(2448),
    [anon_sym_DOLLAR] = ACTIONS(2450),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [635] = {
    [sym_string] = STATE(1255),
    [anon_sym_DASH] = ACTIONS(2452),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(2452),
    [sym_raw_string] = ACTIONS(2454),
    [anon_sym_POUND] = ACTIONS(2452),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2456),
    [anon_sym_STAR] = ACTIONS(2458),
    [anon_sym_AT] = ACTIONS(2458),
    [anon_sym_QMARK] = ACTIONS(2458),
    [anon_sym_0] = ACTIONS(2456),
    [anon_sym__] = ACTIONS(2456),
  },
  [636] = {
    [aux_sym_concatenation_repeat1] = STATE(1250),
    [sym__concat] = ACTIONS(2446),
    [anon_sym_RBRACE] = ACTIONS(2460),
    [anon_sym_EQ] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2462),
    [sym__special_character] = ACTIONS(2462),
    [anon_sym_DQUOTE] = ACTIONS(2460),
    [anon_sym_DOLLAR] = ACTIONS(2462),
    [sym_raw_string] = ACTIONS(2460),
    [anon_sym_POUND] = ACTIONS(2460),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2460),
    [anon_sym_COLON] = ACTIONS(2462),
    [anon_sym_COLON_QMARK] = ACTIONS(2462),
    [anon_sym_COLON_DASH] = ACTIONS(2462),
    [anon_sym_PERCENT] = ACTIONS(2462),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2460),
    [anon_sym_BQUOTE] = ACTIONS(2460),
    [anon_sym_LT_LPAREN] = ACTIONS(2460),
    [anon_sym_GT_LPAREN] = ACTIONS(2460),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(2462),
  },
  [637] = {
    [sym_subscript] = STATE(1260),
    [sym_variable_name] = ACTIONS(2464),
    [anon_sym_BANG] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2468),
    [anon_sym_DOLLAR] = ACTIONS(2468),
    [anon_sym_POUND] = ACTIONS(2466),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2470),
    [anon_sym_STAR] = ACTIONS(2472),
    [anon_sym_AT] = ACTIONS(2472),
    [anon_sym_QMARK] = ACTIONS(2472),
    [anon_sym_0] = ACTIONS(2470),
    [anon_sym__] = ACTIONS(2470),
  },
  [638] = {
    [sym_concatenation] = STATE(1263),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1263),
    [sym_regex] = ACTIONS(2474),
    [anon_sym_RBRACE] = ACTIONS(2476),
    [anon_sym_EQ] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2478),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2480),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2478),
    [anon_sym_COLON_QMARK] = ACTIONS(2478),
    [anon_sym_COLON_DASH] = ACTIONS(2478),
    [anon_sym_PERCENT] = ACTIONS(2478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [639] = {
    [sym__statements] = STATE(1264),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(1265),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [640] = {
    [sym__statements] = STATE(1266),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [641] = {
    [sym__statements] = STATE(1267),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [642] = {
    [aux_sym__literal_repeat1] = STATE(1269),
    [anon_sym_RBRACE] = ACTIONS(2482),
    [anon_sym_EQ] = ACTIONS(2484),
    [anon_sym_DASH] = ACTIONS(2484),
    [sym__special_character] = ACTIONS(2486),
    [anon_sym_DQUOTE] = ACTIONS(2482),
    [anon_sym_DOLLAR] = ACTIONS(2484),
    [sym_raw_string] = ACTIONS(2482),
    [anon_sym_POUND] = ACTIONS(2482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2482),
    [anon_sym_COLON] = ACTIONS(2484),
    [anon_sym_COLON_QMARK] = ACTIONS(2484),
    [anon_sym_COLON_DASH] = ACTIONS(2484),
    [anon_sym_PERCENT] = ACTIONS(2484),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2482),
    [anon_sym_BQUOTE] = ACTIONS(2482),
    [anon_sym_LT_LPAREN] = ACTIONS(2482),
    [anon_sym_GT_LPAREN] = ACTIONS(2482),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(2484),
  },
  [643] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(2476),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [644] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [ts_builtin_sym_end] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_RPAREN] = ACTIONS(2492),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_EQ_TILDE] = ACTIONS(2494),
    [anon_sym_EQ_EQ] = ACTIONS(2494),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [645] = {
    [sym_concatenation] = STATE(1248),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1248),
    [sym_regex] = ACTIONS(2496),
    [anon_sym_RBRACE] = ACTIONS(2408),
    [anon_sym_EQ] = ACTIONS(2436),
    [anon_sym_DASH] = ACTIONS(2436),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2438),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2436),
    [anon_sym_COLON_QMARK] = ACTIONS(2436),
    [anon_sym_COLON_DASH] = ACTIONS(2436),
    [anon_sym_PERCENT] = ACTIONS(2436),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [646] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(2408),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [647] = {
    [sym_concatenation] = STATE(257),
    [sym_string] = STATE(1272),
    [sym_simple_expansion] = STATE(1272),
    [sym_string_expansion] = STATE(1272),
    [sym_expansion] = STATE(1272),
    [sym_command_substitution] = STATE(1272),
    [sym_process_substitution] = STATE(1272),
    [aux_sym__literal_repeat1] = STATE(1273),
    [sym__special_character] = ACTIONS(1159),
    [anon_sym_DQUOTE] = ACTIONS(311),
    [anon_sym_DOLLAR] = ACTIONS(313),
    [sym_raw_string] = ACTIONS(2498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(317),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(319),
    [anon_sym_BQUOTE] = ACTIONS(321),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2498),
  },
  [648] = {
    [aux_sym_concatenation_repeat1] = STATE(1274),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(1023),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(325),
  },
  [649] = {
    [aux_sym_concatenation_repeat1] = STATE(1274),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(1023),
    [sym_variable_name] = ACTIONS(1037),
    [anon_sym_RPAREN] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [sym__special_character] = ACTIONS(1037),
    [anon_sym_DQUOTE] = ACTIONS(1037),
    [anon_sym_DOLLAR] = ACTIONS(1039),
    [sym_raw_string] = ACTIONS(1037),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1037),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1037),
    [anon_sym_BQUOTE] = ACTIONS(1037),
    [anon_sym_LT_LPAREN] = ACTIONS(1037),
    [anon_sym_GT_LPAREN] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1037),
  },
  [650] = {
    [aux_sym__literal_repeat1] = STATE(1275),
    [sym_file_descriptor] = ACTIONS(1051),
    [sym_variable_name] = ACTIONS(1051),
    [anon_sym_RPAREN] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1051),
    [anon_sym_DOLLAR] = ACTIONS(1053),
    [sym_raw_string] = ACTIONS(1051),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1051),
    [anon_sym_BQUOTE] = ACTIONS(1051),
    [anon_sym_LT_LPAREN] = ACTIONS(1051),
    [anon_sym_GT_LPAREN] = ACTIONS(1051),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1051),
  },
  [651] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [ts_builtin_sym_end] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_RPAREN] = ACTIONS(2500),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_EQ_TILDE] = ACTIONS(2502),
    [anon_sym_EQ_EQ] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [652] = {
    [sym_concatenation] = STATE(263),
    [sym_string] = STATE(1277),
    [sym_array] = STATE(263),
    [sym_simple_expansion] = STATE(1277),
    [sym_string_expansion] = STATE(1277),
    [sym_expansion] = STATE(1277),
    [sym_command_substitution] = STATE(1277),
    [sym_process_substitution] = STATE(1277),
    [aux_sym__literal_repeat1] = STATE(1278),
    [sym__empty_value] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [sym__special_character] = ACTIONS(2504),
    [anon_sym_DQUOTE] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(2506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(463),
    [anon_sym_BQUOTE] = ACTIONS(465),
    [anon_sym_LT_LPAREN] = ACTIONS(467),
    [anon_sym_GT_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2506),
  },
  [653] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_PLUS_EQ] = ACTIONS(2508),
    [sym_comment] = ACTIONS(57),
  },
  [654] = {
    [aux_sym_concatenation_repeat1] = STATE(1280),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(943),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [655] = {
    [aux_sym_concatenation_repeat1] = STATE(1280),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(943),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [sym__special_character] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [656] = {
    [anon_sym_EQ] = ACTIONS(2508),
    [anon_sym_PLUS_EQ] = ACTIONS(2508),
    [sym_comment] = ACTIONS(57),
  },
  [657] = {
    [sym_variable_assignment] = STATE(1281),
    [sym_subscript] = STATE(656),
    [sym_concatenation] = STATE(1281),
    [sym_string] = STATE(655),
    [sym_simple_expansion] = STATE(655),
    [sym_string_expansion] = STATE(655),
    [sym_expansion] = STATE(655),
    [sym_command_substitution] = STATE(655),
    [sym_process_substitution] = STATE(655),
    [aux_sym_declaration_command_repeat1] = STATE(1281),
    [aux_sym__literal_repeat1] = STATE(658),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(1167),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [sym__special_character] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(1171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(971),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2510),
    [sym_word] = ACTIONS(1175),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [658] = {
    [aux_sym__literal_repeat1] = STATE(1282),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym_variable_name] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(979),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(979),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [sym__special_character] = ACTIONS(981),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(979),
    [sym_word] = ACTIONS(979),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
  },
  [659] = {
    [aux_sym_concatenation_repeat1] = STATE(1283),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(983),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [660] = {
    [aux_sym_concatenation_repeat1] = STATE(1283),
    [sym__simple_heredoc_body] = ACTIONS(997),
    [sym__heredoc_body_beginning] = ACTIONS(997),
    [sym_file_descriptor] = ACTIONS(997),
    [sym__concat] = ACTIONS(983),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI_SEMI] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_AMP_GT] = ACTIONS(999),
    [anon_sym_AMP_GT_GT] = ACTIONS(997),
    [anon_sym_LT_AMP] = ACTIONS(997),
    [anon_sym_GT_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_LT_LT_DASH] = ACTIONS(997),
    [anon_sym_LT_LT_LT] = ACTIONS(997),
    [sym__special_character] = ACTIONS(997),
    [anon_sym_DQUOTE] = ACTIONS(997),
    [anon_sym_DOLLAR] = ACTIONS(999),
    [sym_raw_string] = ACTIONS(997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(997),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(997),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(999),
    [sym_word] = ACTIONS(999),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
  },
  [661] = {
    [sym_concatenation] = STATE(1284),
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_string_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [aux_sym_unset_command_repeat1] = STATE(1284),
    [aux_sym__literal_repeat1] = STATE(662),
    [sym__simple_heredoc_body] = ACTIONS(1011),
    [sym__heredoc_body_beginning] = ACTIONS(1011),
    [sym_file_descriptor] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1013),
    [anon_sym_GT] = ACTIONS(1013),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT] = ACTIONS(1013),
    [anon_sym_AMP_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_AMP] = ACTIONS(1011),
    [anon_sym_GT_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(1011),
    [anon_sym_LT_LT_LT] = ACTIONS(1011),
    [sym__special_character] = ACTIONS(1177),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_DOLLAR] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(1179),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(1011),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2512),
    [sym_word] = ACTIONS(1183),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
  },
  [662] = {
    [aux_sym__literal_repeat1] = STATE(1285),
    [sym__simple_heredoc_body] = ACTIONS(1017),
    [sym__heredoc_body_beginning] = ACTIONS(1017),
    [sym_file_descriptor] = ACTIONS(1017),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1017),
    [anon_sym_PIPE_AMP] = ACTIONS(1017),
    [anon_sym_AMP_AMP] = ACTIONS(1017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1017),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1017),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1017),
    [anon_sym_LT_AMP] = ACTIONS(1017),
    [anon_sym_GT_AMP] = ACTIONS(1017),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1017),
    [anon_sym_LT_LT_LT] = ACTIONS(1017),
    [sym__special_character] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1017),
    [anon_sym_DOLLAR] = ACTIONS(1019),
    [sym_raw_string] = ACTIONS(1017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1017),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1017),
    [anon_sym_GT_LPAREN] = ACTIONS(1017),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1019),
    [sym_word] = ACTIONS(1019),
    [anon_sym_LF] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [663] = {
    [aux_sym_concatenation_repeat1] = STATE(1286),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_EQ_TILDE] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [664] = {
    [anon_sym_LT] = ACTIONS(2514),
    [anon_sym_GT] = ACTIONS(2514),
    [anon_sym_GT_GT] = ACTIONS(2516),
    [anon_sym_AMP_GT] = ACTIONS(2514),
    [anon_sym_AMP_GT_GT] = ACTIONS(2516),
    [anon_sym_LT_AMP] = ACTIONS(2516),
    [anon_sym_GT_AMP] = ACTIONS(2516),
    [sym_comment] = ACTIONS(57),
  },
  [665] = {
    [sym_file_descriptor] = ACTIONS(1235),
    [sym_variable_name] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1239),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1239),
    [anon_sym_if] = ACTIONS(1239),
    [anon_sym_case] = ACTIONS(1239),
    [anon_sym_function] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1239),
    [anon_sym_typeset] = ACTIONS(1239),
    [anon_sym_export] = ACTIONS(1239),
    [anon_sym_readonly] = ACTIONS(1239),
    [anon_sym_local] = ACTIONS(1239),
    [anon_sym_unset] = ACTIONS(1239),
    [anon_sym_unsetenv] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_AMP_GT] = ACTIONS(1239),
    [anon_sym_AMP_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_AMP] = ACTIONS(1235),
    [anon_sym_GT_AMP] = ACTIONS(1235),
    [sym__special_character] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_DOLLAR] = ACTIONS(1239),
    [sym_raw_string] = ACTIONS(1235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1235),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1235),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [anon_sym_LT_LPAREN] = ACTIONS(1235),
    [anon_sym_GT_LPAREN] = ACTIONS(1235),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1239),
  },
  [666] = {
    [sym_redirected_statement] = STATE(1288),
    [sym_for_statement] = STATE(1288),
    [sym_c_style_for_statement] = STATE(1288),
    [sym_while_statement] = STATE(1288),
    [sym_if_statement] = STATE(1288),
    [sym_case_statement] = STATE(1288),
    [sym_function_definition] = STATE(1288),
    [sym_compound_statement] = STATE(1288),
    [sym_subshell] = STATE(1288),
    [sym_pipeline] = STATE(1288),
    [sym_list] = STATE(1288),
    [sym_negated_command] = STATE(1288),
    [sym_test_command] = STATE(1288),
    [sym_declaration_command] = STATE(1288),
    [sym_unset_command] = STATE(1288),
    [sym_command] = STATE(1288),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(1289),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [667] = {
    [sym_redirected_statement] = STATE(1290),
    [sym_for_statement] = STATE(1290),
    [sym_c_style_for_statement] = STATE(1290),
    [sym_while_statement] = STATE(1290),
    [sym_if_statement] = STATE(1290),
    [sym_case_statement] = STATE(1290),
    [sym_function_definition] = STATE(1290),
    [sym_compound_statement] = STATE(1290),
    [sym_subshell] = STATE(1290),
    [sym_pipeline] = STATE(1290),
    [sym_list] = STATE(1290),
    [sym_negated_command] = STATE(1290),
    [sym_test_command] = STATE(1290),
    [sym_declaration_command] = STATE(1290),
    [sym_unset_command] = STATE(1290),
    [sym_command] = STATE(1290),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(1291),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [668] = {
    [sym_concatenation] = STATE(695),
    [sym_string] = STATE(1293),
    [sym_simple_expansion] = STATE(1293),
    [sym_string_expansion] = STATE(1293),
    [sym_expansion] = STATE(1293),
    [sym_command_substitution] = STATE(1293),
    [sym_process_substitution] = STATE(1293),
    [aux_sym__literal_repeat1] = STATE(1294),
    [sym__special_character] = ACTIONS(2518),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(2520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2520),
  },
  [669] = {
    [sym_concatenation] = STATE(699),
    [sym_string] = STATE(1295),
    [sym_simple_expansion] = STATE(1295),
    [sym_string_expansion] = STATE(1295),
    [sym_expansion] = STATE(1295),
    [sym_command_substitution] = STATE(1295),
    [sym_process_substitution] = STATE(1295),
    [aux_sym__literal_repeat1] = STATE(1296),
    [sym__special_character] = ACTIONS(2518),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(2522),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2522),
  },
  [670] = {
    [anon_sym_SEMI] = ACTIONS(2524),
    [anon_sym_SEMI_SEMI] = ACTIONS(2526),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2526),
  },
  [671] = {
    [sym_file_redirect] = STATE(1298),
    [sym_heredoc_redirect] = STATE(1298),
    [sym_herestring_redirect] = STATE(1298),
    [aux_sym_redirected_statement_repeat1] = STATE(1298),
    [sym__simple_heredoc_body] = ACTIONS(1253),
    [sym__heredoc_body_beginning] = ACTIONS(1253),
    [sym_file_descriptor] = ACTIONS(1185),
    [anon_sym_SEMI] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_SEMI_SEMI] = ACTIONS(1253),
    [anon_sym_PIPE_AMP] = ACTIONS(1253),
    [anon_sym_AMP_AMP] = ACTIONS(1253),
    [anon_sym_PIPE_PIPE] = ACTIONS(1253),
    [anon_sym_LT] = ACTIONS(1197),
    [anon_sym_GT] = ACTIONS(1197),
    [anon_sym_GT_GT] = ACTIONS(1199),
    [anon_sym_AMP_GT] = ACTIONS(1197),
    [anon_sym_AMP_GT_GT] = ACTIONS(1199),
    [anon_sym_LT_AMP] = ACTIONS(1199),
    [anon_sym_GT_AMP] = ACTIONS(1199),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(1201),
    [anon_sym_BQUOTE] = ACTIONS(1253),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1255),
  },
  [672] = {
    [sym_concatenation] = STATE(703),
    [sym_string] = STATE(1299),
    [sym_simple_expansion] = STATE(1299),
    [sym_string_expansion] = STATE(1299),
    [sym_expansion] = STATE(1299),
    [sym_command_substitution] = STATE(1299),
    [sym_process_substitution] = STATE(1299),
    [aux_sym__literal_repeat1] = STATE(1300),
    [sym_regex] = ACTIONS(1257),
    [sym__special_character] = ACTIONS(1205),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(2528),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2528),
  },
  [673] = {
    [aux_sym_concatenation_repeat1] = STATE(663),
    [sym__simple_heredoc_body] = ACTIONS(1261),
    [sym__heredoc_body_beginning] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [sym__special_character] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [674] = {
    [sym_concatenation] = STATE(1301),
    [sym_string] = STATE(673),
    [sym_simple_expansion] = STATE(673),
    [sym_string_expansion] = STATE(673),
    [sym_expansion] = STATE(673),
    [sym_command_substitution] = STATE(673),
    [sym_process_substitution] = STATE(673),
    [aux_sym_command_repeat2] = STATE(1301),
    [aux_sym__literal_repeat1] = STATE(675),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(1203),
    [anon_sym_EQ_EQ] = ACTIONS(1203),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(1205),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(1265),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1209),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [675] = {
    [aux_sym__literal_repeat1] = STATE(679),
    [sym__simple_heredoc_body] = ACTIONS(1269),
    [sym__heredoc_body_beginning] = ACTIONS(1269),
    [sym_file_descriptor] = ACTIONS(1269),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE_AMP] = ACTIONS(1269),
    [anon_sym_AMP_AMP] = ACTIONS(1269),
    [anon_sym_PIPE_PIPE] = ACTIONS(1269),
    [anon_sym_EQ_TILDE] = ACTIONS(1271),
    [anon_sym_EQ_EQ] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT_GT] = ACTIONS(1269),
    [anon_sym_LT_AMP] = ACTIONS(1269),
    [anon_sym_GT_AMP] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_LT_LT_DASH] = ACTIONS(1269),
    [anon_sym_LT_LT_LT] = ACTIONS(1269),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(1269),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1269),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1269),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [anon_sym_LT_LPAREN] = ACTIONS(1269),
    [anon_sym_GT_LPAREN] = ACTIONS(1269),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1271),
  },
  [676] = {
    [sym_file_redirect] = STATE(671),
    [sym_heredoc_redirect] = STATE(671),
    [sym_heredoc_body] = STATE(1303),
    [sym_herestring_redirect] = STATE(671),
    [aux_sym_redirected_statement_repeat1] = STATE(671),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(1185),
    [anon_sym_SEMI] = ACTIONS(2530),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_SEMI_SEMI] = ACTIONS(2532),
    [anon_sym_PIPE_AMP] = ACTIONS(1193),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(1197),
    [anon_sym_GT] = ACTIONS(1197),
    [anon_sym_GT_GT] = ACTIONS(1199),
    [anon_sym_AMP_GT] = ACTIONS(1197),
    [anon_sym_AMP_GT_GT] = ACTIONS(1199),
    [anon_sym_LT_AMP] = ACTIONS(1199),
    [anon_sym_GT_AMP] = ACTIONS(1199),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(1201),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2532),
    [anon_sym_AMP] = ACTIONS(2530),
  },
  [677] = {
    [sym_file_redirect] = STATE(671),
    [sym_heredoc_redirect] = STATE(671),
    [sym_heredoc_body] = STATE(1303),
    [sym_herestring_redirect] = STATE(671),
    [aux_sym_redirected_statement_repeat1] = STATE(671),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2530),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_SEMI_SEMI] = ACTIONS(2532),
    [anon_sym_PIPE_AMP] = ACTIONS(1193),
    [anon_sym_AMP_AMP] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1195),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(1201),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(1237),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2532),
    [anon_sym_AMP] = ACTIONS(2530),
  },
  [678] = {
    [sym_concatenation] = STATE(1304),
    [sym_string] = STATE(673),
    [sym_simple_expansion] = STATE(673),
    [sym_string_expansion] = STATE(673),
    [sym_expansion] = STATE(673),
    [sym_command_substitution] = STATE(673),
    [sym_process_substitution] = STATE(673),
    [aux_sym_command_repeat2] = STATE(1304),
    [aux_sym__literal_repeat1] = STATE(675),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(1203),
    [anon_sym_EQ_EQ] = ACTIONS(1203),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(1205),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(1265),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1209),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [679] = {
    [aux_sym__literal_repeat1] = STATE(679),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_EQ_TILDE] = ACTIONS(1373),
    [anon_sym_EQ_EQ] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(1375),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [680] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [ts_builtin_sym_end] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_RPAREN] = ACTIONS(2534),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_EQ_TILDE] = ACTIONS(2536),
    [anon_sym_EQ_EQ] = ACTIONS(2536),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [681] = {
    [sym_compound_statement] = STATE(1305),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [682] = {
    [ts_builtin_sym_end] = ACTIONS(2538),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_done] = ACTIONS(2538),
    [anon_sym_fi] = ACTIONS(2538),
    [anon_sym_elif] = ACTIONS(2538),
    [anon_sym_else] = ACTIONS(2538),
    [anon_sym_esac] = ACTIONS(2538),
    [anon_sym_RPAREN] = ACTIONS(2538),
    [anon_sym_SEMI_SEMI] = ACTIONS(2538),
    [anon_sym_BQUOTE] = ACTIONS(2538),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2538),
  },
  [683] = {
    [anon_sym_DASH] = ACTIONS(2542),
    [anon_sym_DOLLAR] = ACTIONS(2542),
    [anon_sym_POUND] = ACTIONS(2542),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2544),
    [anon_sym_STAR] = ACTIONS(2546),
    [anon_sym_AT] = ACTIONS(2546),
    [anon_sym_QMARK] = ACTIONS(2546),
    [anon_sym_0] = ACTIONS(2544),
    [anon_sym__] = ACTIONS(2544),
  },
  [684] = {
    [sym_subscript] = STATE(1311),
    [sym_variable_name] = ACTIONS(2548),
    [anon_sym_BANG] = ACTIONS(2550),
    [anon_sym_DASH] = ACTIONS(2552),
    [anon_sym_DOLLAR] = ACTIONS(2552),
    [anon_sym_POUND] = ACTIONS(2550),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2554),
    [anon_sym_STAR] = ACTIONS(2556),
    [anon_sym_AT] = ACTIONS(2556),
    [anon_sym_QMARK] = ACTIONS(2556),
    [anon_sym_0] = ACTIONS(2554),
    [anon_sym__] = ACTIONS(2554),
  },
  [685] = {
    [sym__statements] = STATE(1312),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(1313),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [686] = {
    [sym__statements] = STATE(1314),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [687] = {
    [sym_simple_expansion] = STATE(1316),
    [sym_expansion] = STATE(1316),
    [sym_command_substitution] = STATE(1316),
    [aux_sym_heredoc_body_repeat1] = STATE(1316),
    [sym__heredoc_body_middle] = ACTIONS(2558),
    [sym__heredoc_body_end] = ACTIONS(2560),
    [anon_sym_DOLLAR] = ACTIONS(1223),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1227),
    [anon_sym_BQUOTE] = ACTIONS(1229),
    [sym_comment] = ACTIONS(57),
  },
  [688] = {
    [sym_concatenation] = STATE(1318),
    [sym_string] = STATE(1317),
    [sym_simple_expansion] = STATE(1317),
    [sym_string_expansion] = STATE(1317),
    [sym_expansion] = STATE(1317),
    [sym_command_substitution] = STATE(1317),
    [sym_process_substitution] = STATE(1317),
    [aux_sym__literal_repeat1] = STATE(1319),
    [sym__special_character] = ACTIONS(1241),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(2562),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2562),
  },
  [689] = {
    [sym_file_redirect] = STATE(244),
    [sym_heredoc_redirect] = STATE(244),
    [sym_herestring_redirect] = STATE(244),
    [aux_sym_redirected_statement_repeat1] = STATE(244),
    [sym__simple_heredoc_body] = ACTIONS(2564),
    [sym__heredoc_body_beginning] = ACTIONS(2564),
    [sym_file_descriptor] = ACTIONS(2564),
    [ts_builtin_sym_end] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT] = ACTIONS(2566),
    [anon_sym_AMP_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_AMP] = ACTIONS(2564),
    [anon_sym_GT_AMP] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_LT_LT_DASH] = ACTIONS(2564),
    [anon_sym_LT_LT_LT] = ACTIONS(2564),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2566),
  },
  [690] = {
    [sym_file_redirect] = STATE(244),
    [sym_heredoc_redirect] = STATE(244),
    [sym_herestring_redirect] = STATE(244),
    [aux_sym_redirected_statement_repeat1] = STATE(244),
    [sym__simple_heredoc_body] = ACTIONS(2564),
    [sym__heredoc_body_beginning] = ACTIONS(2564),
    [sym_file_descriptor] = ACTIONS(2564),
    [sym_variable_name] = ACTIONS(433),
    [ts_builtin_sym_end] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT] = ACTIONS(2566),
    [anon_sym_AMP_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_AMP] = ACTIONS(2564),
    [anon_sym_GT_AMP] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_LT_LT_DASH] = ACTIONS(2564),
    [anon_sym_LT_LT_LT] = ACTIONS(2564),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2566),
  },
  [691] = {
    [sym_file_redirect] = STATE(244),
    [sym_heredoc_redirect] = STATE(244),
    [sym_herestring_redirect] = STATE(244),
    [aux_sym_redirected_statement_repeat1] = STATE(244),
    [sym__simple_heredoc_body] = ACTIONS(2568),
    [sym__heredoc_body_beginning] = ACTIONS(2568),
    [sym_file_descriptor] = ACTIONS(2568),
    [ts_builtin_sym_end] = ACTIONS(2568),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_PIPE] = ACTIONS(403),
    [anon_sym_SEMI_SEMI] = ACTIONS(2568),
    [anon_sym_PIPE_AMP] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_GT] = ACTIONS(2570),
    [anon_sym_GT_GT] = ACTIONS(2568),
    [anon_sym_AMP_GT] = ACTIONS(2570),
    [anon_sym_AMP_GT_GT] = ACTIONS(2568),
    [anon_sym_LT_AMP] = ACTIONS(2568),
    [anon_sym_GT_AMP] = ACTIONS(2568),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_LT_LT_DASH] = ACTIONS(2568),
    [anon_sym_LT_LT_LT] = ACTIONS(2568),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2570),
  },
  [692] = {
    [sym_file_redirect] = STATE(244),
    [sym_heredoc_redirect] = STATE(244),
    [sym_herestring_redirect] = STATE(244),
    [aux_sym_redirected_statement_repeat1] = STATE(244),
    [sym__simple_heredoc_body] = ACTIONS(2568),
    [sym__heredoc_body_beginning] = ACTIONS(2568),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [ts_builtin_sym_end] = ACTIONS(2568),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_PIPE] = ACTIONS(403),
    [anon_sym_SEMI_SEMI] = ACTIONS(2568),
    [anon_sym_PIPE_AMP] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_LT_LT_DASH] = ACTIONS(2568),
    [anon_sym_LT_LT_LT] = ACTIONS(2568),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2570),
  },
  [693] = {
    [aux_sym_concatenation_repeat1] = STATE(1320),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [694] = {
    [aux_sym_concatenation_repeat1] = STATE(1320),
    [sym__simple_heredoc_body] = ACTIONS(1037),
    [sym__heredoc_body_beginning] = ACTIONS(1037),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [695] = {
    [sym__simple_heredoc_body] = ACTIONS(1037),
    [sym__heredoc_body_beginning] = ACTIONS(1037),
    [sym_file_descriptor] = ACTIONS(1037),
    [ts_builtin_sym_end] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_done] = ACTIONS(1037),
    [anon_sym_fi] = ACTIONS(1037),
    [anon_sym_elif] = ACTIONS(1037),
    [anon_sym_else] = ACTIONS(1037),
    [anon_sym_esac] = ACTIONS(1037),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_RPAREN] = ACTIONS(1037),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [anon_sym_BQUOTE] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [696] = {
    [aux_sym__literal_repeat1] = STATE(1321),
    [sym__simple_heredoc_body] = ACTIONS(1051),
    [sym__heredoc_body_beginning] = ACTIONS(1051),
    [sym_file_descriptor] = ACTIONS(1051),
    [ts_builtin_sym_end] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_LT_LT_DASH] = ACTIONS(1051),
    [anon_sym_LT_LT_LT] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(441),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1051),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [697] = {
    [sym__simple_heredoc_body] = ACTIONS(2572),
    [sym__heredoc_body_beginning] = ACTIONS(2572),
    [sym_file_descriptor] = ACTIONS(2572),
    [ts_builtin_sym_end] = ACTIONS(2572),
    [anon_sym_SEMI] = ACTIONS(2574),
    [anon_sym_done] = ACTIONS(2572),
    [anon_sym_fi] = ACTIONS(2572),
    [anon_sym_elif] = ACTIONS(2572),
    [anon_sym_else] = ACTIONS(2572),
    [anon_sym_esac] = ACTIONS(2572),
    [anon_sym_PIPE] = ACTIONS(2574),
    [anon_sym_RPAREN] = ACTIONS(2572),
    [anon_sym_SEMI_SEMI] = ACTIONS(2572),
    [anon_sym_PIPE_AMP] = ACTIONS(2572),
    [anon_sym_AMP_AMP] = ACTIONS(2572),
    [anon_sym_PIPE_PIPE] = ACTIONS(2572),
    [anon_sym_LT] = ACTIONS(2574),
    [anon_sym_GT] = ACTIONS(2574),
    [anon_sym_GT_GT] = ACTIONS(2572),
    [anon_sym_AMP_GT] = ACTIONS(2574),
    [anon_sym_AMP_GT_GT] = ACTIONS(2572),
    [anon_sym_LT_AMP] = ACTIONS(2572),
    [anon_sym_GT_AMP] = ACTIONS(2572),
    [anon_sym_LT_LT] = ACTIONS(2574),
    [anon_sym_LT_LT_DASH] = ACTIONS(2572),
    [anon_sym_LT_LT_LT] = ACTIONS(2572),
    [anon_sym_BQUOTE] = ACTIONS(2572),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2572),
    [anon_sym_AMP] = ACTIONS(2574),
  },
  [698] = {
    [aux_sym_concatenation_repeat1] = STATE(1320),
    [sym__simple_heredoc_body] = ACTIONS(2576),
    [sym__heredoc_body_beginning] = ACTIONS(2576),
    [sym_file_descriptor] = ACTIONS(2576),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(2576),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI_SEMI] = ACTIONS(2576),
    [anon_sym_PIPE_AMP] = ACTIONS(2576),
    [anon_sym_AMP_AMP] = ACTIONS(2576),
    [anon_sym_PIPE_PIPE] = ACTIONS(2576),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_GT] = ACTIONS(2576),
    [anon_sym_AMP_GT] = ACTIONS(2578),
    [anon_sym_AMP_GT_GT] = ACTIONS(2576),
    [anon_sym_LT_AMP] = ACTIONS(2576),
    [anon_sym_GT_AMP] = ACTIONS(2576),
    [anon_sym_LT_LT] = ACTIONS(2578),
    [anon_sym_LT_LT_DASH] = ACTIONS(2576),
    [anon_sym_LT_LT_LT] = ACTIONS(2576),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2576),
    [anon_sym_AMP] = ACTIONS(2578),
  },
  [699] = {
    [sym__simple_heredoc_body] = ACTIONS(2576),
    [sym__heredoc_body_beginning] = ACTIONS(2576),
    [sym_file_descriptor] = ACTIONS(2576),
    [ts_builtin_sym_end] = ACTIONS(2576),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym_done] = ACTIONS(2576),
    [anon_sym_fi] = ACTIONS(2576),
    [anon_sym_elif] = ACTIONS(2576),
    [anon_sym_else] = ACTIONS(2576),
    [anon_sym_esac] = ACTIONS(2576),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_RPAREN] = ACTIONS(2576),
    [anon_sym_SEMI_SEMI] = ACTIONS(2576),
    [anon_sym_PIPE_AMP] = ACTIONS(2576),
    [anon_sym_AMP_AMP] = ACTIONS(2576),
    [anon_sym_PIPE_PIPE] = ACTIONS(2576),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_GT] = ACTIONS(2576),
    [anon_sym_AMP_GT] = ACTIONS(2578),
    [anon_sym_AMP_GT_GT] = ACTIONS(2576),
    [anon_sym_LT_AMP] = ACTIONS(2576),
    [anon_sym_GT_AMP] = ACTIONS(2576),
    [anon_sym_LT_LT] = ACTIONS(2578),
    [anon_sym_LT_LT_DASH] = ACTIONS(2576),
    [anon_sym_LT_LT_LT] = ACTIONS(2576),
    [anon_sym_BQUOTE] = ACTIONS(2576),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2576),
    [anon_sym_AMP] = ACTIONS(2578),
  },
  [700] = {
    [aux_sym__literal_repeat1] = STATE(1321),
    [sym__simple_heredoc_body] = ACTIONS(2580),
    [sym__heredoc_body_beginning] = ACTIONS(2580),
    [sym_file_descriptor] = ACTIONS(2580),
    [ts_builtin_sym_end] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_SEMI_SEMI] = ACTIONS(2580),
    [anon_sym_PIPE_AMP] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_AMP_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_AMP] = ACTIONS(2580),
    [anon_sym_GT_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2582),
    [anon_sym_LT_LT_DASH] = ACTIONS(2580),
    [anon_sym_LT_LT_LT] = ACTIONS(2580),
    [sym__special_character] = ACTIONS(441),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2580),
    [anon_sym_AMP] = ACTIONS(2582),
  },
  [701] = {
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(2584),
    [ts_builtin_sym_end] = ACTIONS(2586),
    [anon_sym_for] = ACTIONS(2588),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_case] = ACTIONS(2588),
    [anon_sym_RPAREN] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2586),
    [anon_sym_function] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2584),
    [anon_sym_declare] = ACTIONS(2588),
    [anon_sym_typeset] = ACTIONS(2588),
    [anon_sym_export] = ACTIONS(2588),
    [anon_sym_readonly] = ACTIONS(2588),
    [anon_sym_local] = ACTIONS(2588),
    [anon_sym_unset] = ACTIONS(2588),
    [anon_sym_unsetenv] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [sym__special_character] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2584),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2584),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [anon_sym_LT_LPAREN] = ACTIONS(2584),
    [anon_sym_GT_LPAREN] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
  },
  [702] = {
    [sym_file_redirect] = STATE(702),
    [sym_heredoc_redirect] = STATE(702),
    [sym_herestring_redirect] = STATE(702),
    [aux_sym_redirected_statement_repeat1] = STATE(702),
    [sym__simple_heredoc_body] = ACTIONS(2590),
    [sym__heredoc_body_beginning] = ACTIONS(2590),
    [sym_file_descriptor] = ACTIONS(2592),
    [ts_builtin_sym_end] = ACTIONS(2590),
    [anon_sym_SEMI] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(2595),
    [anon_sym_SEMI_SEMI] = ACTIONS(2590),
    [anon_sym_PIPE_AMP] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(2597),
    [anon_sym_GT] = ACTIONS(2597),
    [anon_sym_GT_GT] = ACTIONS(2600),
    [anon_sym_AMP_GT] = ACTIONS(2597),
    [anon_sym_AMP_GT_GT] = ACTIONS(2600),
    [anon_sym_LT_AMP] = ACTIONS(2600),
    [anon_sym_GT_AMP] = ACTIONS(2600),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_LT_LT_DASH] = ACTIONS(2606),
    [anon_sym_LT_LT_LT] = ACTIONS(2609),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2595),
  },
  [703] = {
    [sym__simple_heredoc_body] = ACTIONS(2612),
    [sym__heredoc_body_beginning] = ACTIONS(2612),
    [sym_file_descriptor] = ACTIONS(2612),
    [ts_builtin_sym_end] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_RPAREN] = ACTIONS(2612),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(2614),
    [anon_sym_EQ_EQ] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2612),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2612),
    [anon_sym_BQUOTE] = ACTIONS(2612),
    [anon_sym_LT_LPAREN] = ACTIONS(2612),
    [anon_sym_GT_LPAREN] = ACTIONS(2612),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2614),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [704] = {
    [aux_sym_concatenation_repeat1] = STATE(198),
    [sym__simple_heredoc_body] = ACTIONS(2612),
    [sym__heredoc_body_beginning] = ACTIONS(2612),
    [sym_file_descriptor] = ACTIONS(2612),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(2614),
    [anon_sym_EQ_EQ] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2612),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2612),
    [anon_sym_BQUOTE] = ACTIONS(2612),
    [anon_sym_LT_LPAREN] = ACTIONS(2612),
    [anon_sym_GT_LPAREN] = ACTIONS(2612),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2614),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [705] = {
    [aux_sym__literal_repeat1] = STATE(255),
    [sym__simple_heredoc_body] = ACTIONS(2616),
    [sym__heredoc_body_beginning] = ACTIONS(2616),
    [sym_file_descriptor] = ACTIONS(2616),
    [ts_builtin_sym_end] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_SEMI_SEMI] = ACTIONS(2616),
    [anon_sym_PIPE_AMP] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_EQ_TILDE] = ACTIONS(2618),
    [anon_sym_EQ_EQ] = ACTIONS(2618),
    [anon_sym_LT] = ACTIONS(2618),
    [anon_sym_GT] = ACTIONS(2618),
    [anon_sym_GT_GT] = ACTIONS(2616),
    [anon_sym_AMP_GT] = ACTIONS(2618),
    [anon_sym_AMP_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_AMP] = ACTIONS(2616),
    [anon_sym_GT_AMP] = ACTIONS(2616),
    [anon_sym_LT_LT] = ACTIONS(2618),
    [anon_sym_LT_LT_DASH] = ACTIONS(2616),
    [anon_sym_LT_LT_LT] = ACTIONS(2616),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(2616),
    [anon_sym_DOLLAR] = ACTIONS(2618),
    [sym_raw_string] = ACTIONS(2616),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2616),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2616),
    [anon_sym_BQUOTE] = ACTIONS(2616),
    [anon_sym_LT_LPAREN] = ACTIONS(2616),
    [anon_sym_GT_LPAREN] = ACTIONS(2616),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2618),
    [anon_sym_LF] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2618),
  },
  [706] = {
    [sym_concatenation] = STATE(706),
    [sym_string] = STATE(246),
    [sym_simple_expansion] = STATE(246),
    [sym_string_expansion] = STATE(246),
    [sym_expansion] = STATE(246),
    [sym_command_substitution] = STATE(246),
    [sym_process_substitution] = STATE(246),
    [aux_sym_command_repeat2] = STATE(706),
    [aux_sym__literal_repeat1] = STATE(248),
    [sym__simple_heredoc_body] = ACTIONS(2612),
    [sym__heredoc_body_beginning] = ACTIONS(2612),
    [sym_file_descriptor] = ACTIONS(2612),
    [ts_builtin_sym_end] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(2620),
    [anon_sym_EQ_EQ] = ACTIONS(2620),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(2623),
    [anon_sym_DQUOTE] = ACTIONS(2626),
    [anon_sym_DOLLAR] = ACTIONS(2629),
    [sym_raw_string] = ACTIONS(2632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2638),
    [anon_sym_BQUOTE] = ACTIONS(2641),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2647),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [707] = {
    [sym_file_descriptor] = ACTIONS(1235),
    [sym_variable_name] = ACTIONS(1235),
    [ts_builtin_sym_end] = ACTIONS(2586),
    [anon_sym_for] = ACTIONS(1239),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1239),
    [anon_sym_if] = ACTIONS(1239),
    [anon_sym_case] = ACTIONS(1239),
    [anon_sym_RPAREN] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2586),
    [anon_sym_function] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1239),
    [anon_sym_typeset] = ACTIONS(1239),
    [anon_sym_export] = ACTIONS(1239),
    [anon_sym_readonly] = ACTIONS(1239),
    [anon_sym_local] = ACTIONS(1239),
    [anon_sym_unset] = ACTIONS(1239),
    [anon_sym_unsetenv] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_AMP_GT] = ACTIONS(1239),
    [anon_sym_AMP_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_AMP] = ACTIONS(1235),
    [anon_sym_GT_AMP] = ACTIONS(1235),
    [sym__special_character] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_DOLLAR] = ACTIONS(1239),
    [sym_raw_string] = ACTIONS(1235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1235),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1235),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [anon_sym_LT_LPAREN] = ACTIONS(1235),
    [anon_sym_GT_LPAREN] = ACTIONS(1235),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1239),
  },
  [708] = {
    [ts_builtin_sym_end] = ACTIONS(2586),
    [anon_sym_SEMI] = ACTIONS(2650),
    [anon_sym_RPAREN] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2652),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2652),
    [anon_sym_AMP] = ACTIONS(2652),
  },
  [709] = {
    [sym_subshell] = STATE(146),
    [sym_test_command] = STATE(146),
    [sym_command] = STATE(146),
    [sym_command_name] = STATE(713),
    [sym_variable_assignment] = STATE(715),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(715),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym_command_repeat1] = STATE(715),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(383),
  },
  [710] = {
    [sym_variable_assignment] = STATE(1323),
    [sym_subscript] = STATE(656),
    [sym_concatenation] = STATE(1323),
    [sym_string] = STATE(655),
    [sym_simple_expansion] = STATE(655),
    [sym_string_expansion] = STATE(655),
    [sym_expansion] = STATE(655),
    [sym_command_substitution] = STATE(655),
    [sym_process_substitution] = STATE(655),
    [aux_sym_declaration_command_repeat1] = STATE(1323),
    [aux_sym__literal_repeat1] = STATE(658),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(1167),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [sym__special_character] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(1171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2654),
    [sym_word] = ACTIONS(1175),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [711] = {
    [sym_concatenation] = STATE(1324),
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_string_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [aux_sym_unset_command_repeat1] = STATE(1324),
    [aux_sym__literal_repeat1] = STATE(662),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [sym__special_character] = ACTIONS(1177),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_DOLLAR] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(1179),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2656),
    [sym_word] = ACTIONS(1183),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [712] = {
    [sym_file_redirect] = STATE(1332),
    [sym_heredoc_redirect] = STATE(1332),
    [sym_heredoc_body] = STATE(1331),
    [sym_herestring_redirect] = STATE(1332),
    [aux_sym_redirected_statement_repeat1] = STATE(1332),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(2658),
    [anon_sym_SEMI] = ACTIONS(2660),
    [anon_sym_PIPE] = ACTIONS(2662),
    [anon_sym_SEMI_SEMI] = ACTIONS(2664),
    [anon_sym_PIPE_AMP] = ACTIONS(2666),
    [anon_sym_AMP_AMP] = ACTIONS(2668),
    [anon_sym_PIPE_PIPE] = ACTIONS(2668),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_GT] = ACTIONS(2670),
    [anon_sym_GT_GT] = ACTIONS(2672),
    [anon_sym_AMP_GT] = ACTIONS(2670),
    [anon_sym_AMP_GT_GT] = ACTIONS(2672),
    [anon_sym_LT_AMP] = ACTIONS(2672),
    [anon_sym_GT_AMP] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(2674),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2664),
    [anon_sym_AMP] = ACTIONS(2660),
  },
  [713] = {
    [sym_concatenation] = STATE(1333),
    [sym_string] = STATE(673),
    [sym_simple_expansion] = STATE(673),
    [sym_string_expansion] = STATE(673),
    [sym_expansion] = STATE(673),
    [sym_command_substitution] = STATE(673),
    [sym_process_substitution] = STATE(673),
    [aux_sym_command_repeat2] = STATE(1333),
    [aux_sym__literal_repeat1] = STATE(675),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(1203),
    [anon_sym_EQ_EQ] = ACTIONS(1203),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [sym__special_character] = ACTIONS(1205),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1209),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [714] = {
    [sym_file_redirect] = STATE(1332),
    [sym_heredoc_redirect] = STATE(1332),
    [sym_heredoc_body] = STATE(1331),
    [sym_herestring_redirect] = STATE(1332),
    [aux_sym_redirected_statement_repeat1] = STATE(1332),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2660),
    [anon_sym_PIPE] = ACTIONS(2662),
    [anon_sym_SEMI_SEMI] = ACTIONS(2664),
    [anon_sym_PIPE_AMP] = ACTIONS(2666),
    [anon_sym_AMP_AMP] = ACTIONS(2668),
    [anon_sym_PIPE_PIPE] = ACTIONS(2668),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(2674),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2664),
    [anon_sym_AMP] = ACTIONS(2660),
  },
  [715] = {
    [sym_command_name] = STATE(1334),
    [sym_variable_assignment] = STATE(253),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(253),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym_command_repeat1] = STATE(253),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(1205),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(383),
  },
  [716] = {
    [sym_concatenation] = STATE(706),
    [sym_string] = STATE(246),
    [sym_simple_expansion] = STATE(246),
    [sym_string_expansion] = STATE(246),
    [sym_expansion] = STATE(246),
    [sym_command_substitution] = STATE(246),
    [sym_process_substitution] = STATE(246),
    [aux_sym_command_repeat2] = STATE(706),
    [aux_sym__literal_repeat1] = STATE(248),
    [sym__simple_heredoc_body] = ACTIONS(2676),
    [sym__heredoc_body_beginning] = ACTIONS(2676),
    [sym_file_descriptor] = ACTIONS(2676),
    [ts_builtin_sym_end] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym_PIPE] = ACTIONS(2678),
    [anon_sym_SEMI_SEMI] = ACTIONS(2676),
    [anon_sym_PIPE_AMP] = ACTIONS(2676),
    [anon_sym_AMP_AMP] = ACTIONS(2676),
    [anon_sym_PIPE_PIPE] = ACTIONS(2676),
    [anon_sym_EQ_TILDE] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_GT] = ACTIONS(2678),
    [anon_sym_GT_GT] = ACTIONS(2676),
    [anon_sym_AMP_GT] = ACTIONS(2678),
    [anon_sym_AMP_GT_GT] = ACTIONS(2676),
    [anon_sym_LT_AMP] = ACTIONS(2676),
    [anon_sym_GT_AMP] = ACTIONS(2676),
    [anon_sym_LT_LT] = ACTIONS(2678),
    [anon_sym_LT_LT_DASH] = ACTIONS(2676),
    [anon_sym_LT_LT_LT] = ACTIONS(2676),
    [sym__special_character] = ACTIONS(427),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(431),
    [anon_sym_LF] = ACTIONS(2676),
    [anon_sym_AMP] = ACTIONS(2678),
  },
  [717] = {
    [aux_sym_concatenation_repeat1] = STATE(1335),
    [sym__concat] = ACTIONS(899),
    [anon_sym_RBRACK] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
  },
  [718] = {
    [sym_string] = STATE(1144),
    [sym_simple_expansion] = STATE(1144),
    [sym_string_expansion] = STATE(1144),
    [sym_expansion] = STATE(1144),
    [sym_command_substitution] = STATE(1144),
    [sym_process_substitution] = STATE(1144),
    [anon_sym_RBRACK] = ACTIONS(2680),
    [sym__special_character] = ACTIONS(2682),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(2106),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2106),
  },
  [719] = {
    [sym__concat] = ACTIONS(2684),
    [anon_sym_EQ] = ACTIONS(2686),
    [anon_sym_PLUS_EQ] = ACTIONS(2686),
    [sym_comment] = ACTIONS(57),
  },
  [720] = {
    [anon_sym_RBRACK] = ACTIONS(2680),
    [sym_comment] = ACTIONS(57),
  },
  [721] = {
    [anon_sym_RBRACK] = ACTIONS(2688),
    [sym_comment] = ACTIONS(57),
  },
  [722] = {
    [sym__concat] = ACTIONS(2690),
    [anon_sym_EQ] = ACTIONS(2692),
    [anon_sym_PLUS_EQ] = ACTIONS(2692),
    [sym_comment] = ACTIONS(57),
  },
  [723] = {
    [sym__concat] = ACTIONS(325),
    [anon_sym_RBRACK] = ACTIONS(325),
    [sym__special_character] = ACTIONS(329),
    [sym_comment] = ACTIONS(57),
  },
  [724] = {
    [aux_sym__literal_repeat1] = STATE(724),
    [sym__concat] = ACTIONS(1371),
    [anon_sym_RBRACK] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(2694),
    [sym_comment] = ACTIONS(57),
  },
  [725] = {
    [sym__simple_heredoc_body] = ACTIONS(2697),
    [sym__heredoc_body_beginning] = ACTIONS(2697),
    [sym_file_descriptor] = ACTIONS(2697),
    [sym_variable_name] = ACTIONS(2697),
    [ts_builtin_sym_end] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_RPAREN] = ACTIONS(2697),
    [anon_sym_SEMI_SEMI] = ACTIONS(2697),
    [anon_sym_PIPE_AMP] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_PIPE_PIPE] = ACTIONS(2697),
    [anon_sym_LT] = ACTIONS(2699),
    [anon_sym_GT] = ACTIONS(2699),
    [anon_sym_GT_GT] = ACTIONS(2697),
    [anon_sym_AMP_GT] = ACTIONS(2699),
    [anon_sym_AMP_GT_GT] = ACTIONS(2697),
    [anon_sym_LT_AMP] = ACTIONS(2697),
    [anon_sym_GT_AMP] = ACTIONS(2697),
    [anon_sym_LT_LT] = ACTIONS(2699),
    [anon_sym_LT_LT_DASH] = ACTIONS(2697),
    [anon_sym_LT_LT_LT] = ACTIONS(2697),
    [sym__special_character] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [anon_sym_DOLLAR] = ACTIONS(2699),
    [sym_raw_string] = ACTIONS(2697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2697),
    [anon_sym_BQUOTE] = ACTIONS(2697),
    [anon_sym_LT_LPAREN] = ACTIONS(2697),
    [anon_sym_GT_LPAREN] = ACTIONS(2697),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2699),
    [anon_sym_LF] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
  },
  [726] = {
    [aux_sym_concatenation_repeat1] = STATE(1341),
    [sym__concat] = ACTIONS(2701),
    [anon_sym_RPAREN] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(325),
  },
  [727] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(1344),
    [anon_sym_DQUOTE] = ACTIONS(2703),
    [anon_sym_DOLLAR] = ACTIONS(2705),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [728] = {
    [sym_string] = STATE(1346),
    [anon_sym_DASH] = ACTIONS(2707),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(2707),
    [sym_raw_string] = ACTIONS(2709),
    [anon_sym_POUND] = ACTIONS(2707),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2711),
    [anon_sym_STAR] = ACTIONS(2713),
    [anon_sym_AT] = ACTIONS(2713),
    [anon_sym_QMARK] = ACTIONS(2713),
    [anon_sym_0] = ACTIONS(2711),
    [anon_sym__] = ACTIONS(2711),
  },
  [729] = {
    [aux_sym_concatenation_repeat1] = STATE(1341),
    [sym__concat] = ACTIONS(2701),
    [anon_sym_RPAREN] = ACTIONS(2715),
    [sym__special_character] = ACTIONS(2715),
    [anon_sym_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2717),
    [sym_raw_string] = ACTIONS(2715),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2715),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2715),
    [anon_sym_BQUOTE] = ACTIONS(2715),
    [anon_sym_LT_LPAREN] = ACTIONS(2715),
    [anon_sym_GT_LPAREN] = ACTIONS(2715),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2715),
  },
  [730] = {
    [sym_subscript] = STATE(1351),
    [sym_variable_name] = ACTIONS(2719),
    [anon_sym_BANG] = ACTIONS(2721),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_DOLLAR] = ACTIONS(2723),
    [anon_sym_POUND] = ACTIONS(2721),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2725),
    [anon_sym_STAR] = ACTIONS(2727),
    [anon_sym_AT] = ACTIONS(2727),
    [anon_sym_QMARK] = ACTIONS(2727),
    [anon_sym_0] = ACTIONS(2725),
    [anon_sym__] = ACTIONS(2725),
  },
  [731] = {
    [sym__statements] = STATE(1352),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(1353),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [732] = {
    [sym__statements] = STATE(1354),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [733] = {
    [sym__statements] = STATE(1355),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [734] = {
    [sym_concatenation] = STATE(1357),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(1357),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(2729),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [735] = {
    [aux_sym__literal_repeat1] = STATE(1359),
    [anon_sym_RPAREN] = ACTIONS(2731),
    [sym__special_character] = ACTIONS(2733),
    [anon_sym_DQUOTE] = ACTIONS(2731),
    [anon_sym_DOLLAR] = ACTIONS(2735),
    [sym_raw_string] = ACTIONS(2731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2731),
    [anon_sym_BQUOTE] = ACTIONS(2731),
    [anon_sym_LT_LPAREN] = ACTIONS(2731),
    [anon_sym_GT_LPAREN] = ACTIONS(2731),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2731),
  },
  [736] = {
    [sym_string] = STATE(1360),
    [sym_simple_expansion] = STATE(1360),
    [sym_string_expansion] = STATE(1360),
    [sym_expansion] = STATE(1360),
    [sym_command_substitution] = STATE(1360),
    [sym_process_substitution] = STATE(1360),
    [sym__special_character] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(455),
    [anon_sym_DOLLAR] = ACTIONS(457),
    [sym_raw_string] = ACTIONS(2737),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(463),
    [anon_sym_BQUOTE] = ACTIONS(465),
    [anon_sym_LT_LPAREN] = ACTIONS(467),
    [anon_sym_GT_LPAREN] = ACTIONS(467),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2737),
  },
  [737] = {
    [aux_sym_concatenation_repeat1] = STATE(1361),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(1420),
    [sym_variable_name] = ACTIONS(1059),
    [ts_builtin_sym_end] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [738] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [sym_variable_name] = ACTIONS(1063),
    [ts_builtin_sym_end] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1063),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [739] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(2739),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [740] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(2739),
    [anon_sym_DOLLAR] = ACTIONS(2741),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [741] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [sym_variable_name] = ACTIONS(1097),
    [ts_builtin_sym_end] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_RPAREN] = ACTIONS(1097),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [742] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [sym_variable_name] = ACTIONS(1101),
    [ts_builtin_sym_end] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_RPAREN] = ACTIONS(1101),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [743] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [sym_variable_name] = ACTIONS(1105),
    [ts_builtin_sym_end] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1105),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [744] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(2743),
    [sym_comment] = ACTIONS(57),
  },
  [745] = {
    [sym_subscript] = STATE(1367),
    [sym_variable_name] = ACTIONS(2745),
    [anon_sym_DASH] = ACTIONS(2747),
    [anon_sym_DOLLAR] = ACTIONS(2747),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(2751),
    [anon_sym_AT] = ACTIONS(2751),
    [anon_sym_QMARK] = ACTIONS(2751),
    [anon_sym_0] = ACTIONS(2749),
    [anon_sym__] = ACTIONS(2749),
  },
  [746] = {
    [sym_concatenation] = STATE(1370),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1370),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_EQ] = ACTIONS(2755),
    [anon_sym_DASH] = ACTIONS(2755),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2757),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(2759),
    [anon_sym_COLON] = ACTIONS(2755),
    [anon_sym_COLON_QMARK] = ACTIONS(2755),
    [anon_sym_COLON_DASH] = ACTIONS(2755),
    [anon_sym_PERCENT] = ACTIONS(2755),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [747] = {
    [sym_concatenation] = STATE(1373),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1373),
    [anon_sym_RBRACE] = ACTIONS(2761),
    [anon_sym_EQ] = ACTIONS(2763),
    [anon_sym_DASH] = ACTIONS(2763),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(2767),
    [anon_sym_COLON] = ACTIONS(2763),
    [anon_sym_COLON_QMARK] = ACTIONS(2763),
    [anon_sym_COLON_DASH] = ACTIONS(2763),
    [anon_sym_PERCENT] = ACTIONS(2763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [748] = {
    [anon_sym_RPAREN] = ACTIONS(2769),
    [sym_comment] = ACTIONS(57),
  },
  [749] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2769),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [750] = {
    [anon_sym_BQUOTE] = ACTIONS(2769),
    [sym_comment] = ACTIONS(57),
  },
  [751] = {
    [anon_sym_RPAREN] = ACTIONS(2771),
    [sym_comment] = ACTIONS(57),
  },
  [752] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [ts_builtin_sym_end] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_RPAREN] = ACTIONS(325),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [753] = {
    [aux_sym__literal_repeat1] = STATE(753),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym_variable_name] = ACTIONS(1371),
    [ts_builtin_sym_end] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(2773),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [754] = {
    [sym__expression] = STATE(1377),
    [sym_binary_expression] = STATE(1377),
    [sym_unary_expression] = STATE(1377),
    [sym_postfix_expression] = STATE(1377),
    [sym_parenthesized_expression] = STATE(1377),
    [sym_concatenation] = STATE(1377),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2776),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_character] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [755] = {
    [anon_sym_SEMI] = ACTIONS(2778),
    [anon_sym_SEMI_SEMI] = ACTIONS(2780),
    [anon_sym_AMP_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1482),
    [anon_sym_EQ_TILDE] = ACTIONS(1484),
    [anon_sym_EQ_EQ] = ACTIONS(1484),
    [anon_sym_EQ] = ACTIONS(1486),
    [anon_sym_PLUS_EQ] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(1486),
    [anon_sym_GT] = ACTIONS(1486),
    [anon_sym_BANG_EQ] = ACTIONS(1482),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_DASH_EQ] = ACTIONS(1482),
    [anon_sym_LT_EQ] = ACTIONS(1482),
    [anon_sym_GT_EQ] = ACTIONS(1482),
    [anon_sym_PLUS_PLUS] = ACTIONS(1488),
    [anon_sym_DASH_DASH] = ACTIONS(1488),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1482),
    [anon_sym_LF] = ACTIONS(2780),
    [anon_sym_AMP] = ACTIONS(2778),
  },
  [756] = {
    [anon_sym_RPAREN] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(1534),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_EQ_TILDE] = ACTIONS(1536),
    [anon_sym_EQ_EQ] = ACTIONS(1536),
    [anon_sym_EQ] = ACTIONS(1538),
    [anon_sym_PLUS_EQ] = ACTIONS(1534),
    [anon_sym_LT] = ACTIONS(1538),
    [anon_sym_GT] = ACTIONS(1538),
    [anon_sym_BANG_EQ] = ACTIONS(1534),
    [anon_sym_PLUS] = ACTIONS(1538),
    [anon_sym_DASH] = ACTIONS(1538),
    [anon_sym_DASH_EQ] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1534),
    [anon_sym_GT_EQ] = ACTIONS(1534),
    [anon_sym_PLUS_PLUS] = ACTIONS(1540),
    [anon_sym_DASH_DASH] = ACTIONS(1540),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1534),
  },
  [757] = {
    [anon_sym_SEMI] = ACTIONS(2784),
    [anon_sym_SEMI_SEMI] = ACTIONS(1544),
    [anon_sym_AMP_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1482),
    [anon_sym_EQ_TILDE] = ACTIONS(1484),
    [anon_sym_EQ_EQ] = ACTIONS(1484),
    [anon_sym_EQ] = ACTIONS(1486),
    [anon_sym_PLUS_EQ] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(1486),
    [anon_sym_GT] = ACTIONS(1486),
    [anon_sym_BANG_EQ] = ACTIONS(1482),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_DASH_EQ] = ACTIONS(1482),
    [anon_sym_LT_EQ] = ACTIONS(1482),
    [anon_sym_GT_EQ] = ACTIONS(1482),
    [anon_sym_PLUS_PLUS] = ACTIONS(1488),
    [anon_sym_DASH_DASH] = ACTIONS(1488),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1482),
    [anon_sym_LF] = ACTIONS(1544),
    [anon_sym_AMP] = ACTIONS(2784),
  },
  [758] = {
    [sym_string] = STATE(1380),
    [sym_simple_expansion] = STATE(1380),
    [sym_string_expansion] = STATE(1380),
    [sym_expansion] = STATE(1380),
    [sym_command_substitution] = STATE(1380),
    [sym_process_substitution] = STATE(1380),
    [sym__special_character] = ACTIONS(2786),
    [anon_sym_DQUOTE] = ACTIONS(479),
    [anon_sym_DOLLAR] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(2786),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2786),
  },
  [759] = {
    [aux_sym_concatenation_repeat1] = STATE(1381),
    [sym__concat] = ACTIONS(1454),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_EQ_TILDE] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1059),
    [anon_sym_EQ] = ACTIONS(1061),
    [anon_sym_PLUS_EQ] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_BANG_EQ] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_DASH_EQ] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1059),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [760] = {
    [sym__concat] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_EQ_TILDE] = ACTIONS(1063),
    [anon_sym_EQ_EQ] = ACTIONS(1063),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_PLUS_EQ] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG_EQ] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1063),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [761] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(2788),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [762] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(2788),
    [anon_sym_DOLLAR] = ACTIONS(2790),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [763] = {
    [sym__concat] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_EQ_TILDE] = ACTIONS(1097),
    [anon_sym_EQ_EQ] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_PLUS_EQ] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_BANG_EQ] = ACTIONS(1097),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_DASH_EQ] = ACTIONS(1097),
    [anon_sym_LT_EQ] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1097),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [764] = {
    [sym__concat] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_EQ_TILDE] = ACTIONS(1101),
    [anon_sym_EQ_EQ] = ACTIONS(1101),
    [anon_sym_EQ] = ACTIONS(1103),
    [anon_sym_PLUS_EQ] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_DASH_EQ] = ACTIONS(1101),
    [anon_sym_LT_EQ] = ACTIONS(1101),
    [anon_sym_GT_EQ] = ACTIONS(1101),
    [anon_sym_PLUS_PLUS] = ACTIONS(1101),
    [anon_sym_DASH_DASH] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1101),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [765] = {
    [sym__concat] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_EQ_TILDE] = ACTIONS(1105),
    [anon_sym_EQ_EQ] = ACTIONS(1105),
    [anon_sym_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_BANG_EQ] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1107),
    [anon_sym_DASH] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1105),
    [anon_sym_LT_EQ] = ACTIONS(1105),
    [anon_sym_GT_EQ] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1105),
    [anon_sym_DASH_DASH] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1105),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [766] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(2792),
    [sym_comment] = ACTIONS(57),
  },
  [767] = {
    [sym_subscript] = STATE(1387),
    [sym_variable_name] = ACTIONS(2794),
    [anon_sym_DASH] = ACTIONS(2796),
    [anon_sym_DOLLAR] = ACTIONS(2796),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2798),
    [anon_sym_STAR] = ACTIONS(2800),
    [anon_sym_AT] = ACTIONS(2800),
    [anon_sym_QMARK] = ACTIONS(2800),
    [anon_sym_0] = ACTIONS(2798),
    [anon_sym__] = ACTIONS(2798),
  },
  [768] = {
    [sym_concatenation] = STATE(1390),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1390),
    [anon_sym_RBRACE] = ACTIONS(2802),
    [anon_sym_EQ] = ACTIONS(2804),
    [anon_sym_DASH] = ACTIONS(2804),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2806),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(2808),
    [anon_sym_COLON] = ACTIONS(2804),
    [anon_sym_COLON_QMARK] = ACTIONS(2804),
    [anon_sym_COLON_DASH] = ACTIONS(2804),
    [anon_sym_PERCENT] = ACTIONS(2804),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [769] = {
    [sym_concatenation] = STATE(1393),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1393),
    [anon_sym_RBRACE] = ACTIONS(2810),
    [anon_sym_EQ] = ACTIONS(2812),
    [anon_sym_DASH] = ACTIONS(2812),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2814),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(2816),
    [anon_sym_COLON] = ACTIONS(2812),
    [anon_sym_COLON_QMARK] = ACTIONS(2812),
    [anon_sym_COLON_DASH] = ACTIONS(2812),
    [anon_sym_PERCENT] = ACTIONS(2812),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [770] = {
    [anon_sym_RPAREN] = ACTIONS(2818),
    [sym_comment] = ACTIONS(57),
  },
  [771] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2818),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [772] = {
    [anon_sym_BQUOTE] = ACTIONS(2818),
    [sym_comment] = ACTIONS(57),
  },
  [773] = {
    [anon_sym_RPAREN] = ACTIONS(2820),
    [sym_comment] = ACTIONS(57),
  },
  [774] = {
    [sym__expression] = STATE(1396),
    [sym_binary_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1396),
    [sym_postfix_expression] = STATE(1396),
    [sym_parenthesized_expression] = STATE(1396),
    [sym_concatenation] = STATE(1396),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [anon_sym_SEMI] = ACTIONS(2778),
    [anon_sym_SEMI_SEMI] = ACTIONS(2780),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [sym__special_character] = ACTIONS(477),
    [anon_sym_DQUOTE] = ACTIONS(479),
    [anon_sym_DOLLAR] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
    [anon_sym_LF] = ACTIONS(2780),
    [anon_sym_AMP] = ACTIONS(2780),
  },
  [775] = {
    [sym__expression] = STATE(1397),
    [sym_binary_expression] = STATE(1397),
    [sym_unary_expression] = STATE(1397),
    [sym_postfix_expression] = STATE(1397),
    [sym_parenthesized_expression] = STATE(1397),
    [sym_concatenation] = STATE(1397),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [sym__special_character] = ACTIONS(477),
    [anon_sym_DQUOTE] = ACTIONS(479),
    [anon_sym_DOLLAR] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
  },
  [776] = {
    [sym__expression] = STATE(1397),
    [sym_binary_expression] = STATE(1397),
    [sym_unary_expression] = STATE(1397),
    [sym_postfix_expression] = STATE(1397),
    [sym_parenthesized_expression] = STATE(1397),
    [sym_concatenation] = STATE(1397),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [sym_regex] = ACTIONS(2822),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [sym__special_character] = ACTIONS(477),
    [anon_sym_DQUOTE] = ACTIONS(479),
    [anon_sym_DOLLAR] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
  },
  [777] = {
    [anon_sym_SEMI] = ACTIONS(1590),
    [anon_sym_SEMI_SEMI] = ACTIONS(1588),
    [anon_sym_AMP_AMP] = ACTIONS(1588),
    [anon_sym_PIPE_PIPE] = ACTIONS(1588),
    [anon_sym_EQ_TILDE] = ACTIONS(1588),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_EQ] = ACTIONS(1590),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_PLUS] = ACTIONS(1590),
    [anon_sym_DASH] = ACTIONS(1590),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_PLUS] = ACTIONS(1588),
    [anon_sym_DASH_DASH] = ACTIONS(1588),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1588),
    [anon_sym_LF] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1590),
  },
  [778] = {
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(325),
    [anon_sym_EQ_EQ] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_PLUS_EQ] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_BANG_EQ] = ACTIONS(325),
    [anon_sym_PLUS] = ACTIONS(329),
    [anon_sym_DASH] = ACTIONS(329),
    [anon_sym_DASH_EQ] = ACTIONS(325),
    [anon_sym_LT_EQ] = ACTIONS(325),
    [anon_sym_GT_EQ] = ACTIONS(325),
    [anon_sym_PLUS_PLUS] = ACTIONS(325),
    [anon_sym_DASH_DASH] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(325),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [779] = {
    [aux_sym__literal_repeat1] = STATE(779),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_EQ_TILDE] = ACTIONS(1371),
    [anon_sym_EQ_EQ] = ACTIONS(1371),
    [anon_sym_EQ] = ACTIONS(1373),
    [anon_sym_PLUS_EQ] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_BANG_EQ] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1373),
    [anon_sym_DASH] = ACTIONS(1373),
    [anon_sym_DASH_EQ] = ACTIONS(1371),
    [anon_sym_LT_EQ] = ACTIONS(1371),
    [anon_sym_GT_EQ] = ACTIONS(1371),
    [anon_sym_PLUS_PLUS] = ACTIONS(1371),
    [anon_sym_DASH_DASH] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(2824),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1371),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [780] = {
    [aux_sym_concatenation_repeat1] = STATE(1400),
    [sym__concat] = ACTIONS(2827),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(325),
  },
  [781] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(1403),
    [anon_sym_DQUOTE] = ACTIONS(2829),
    [anon_sym_DOLLAR] = ACTIONS(2831),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [782] = {
    [sym_string] = STATE(1405),
    [anon_sym_DASH] = ACTIONS(2833),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [anon_sym_DOLLAR] = ACTIONS(2833),
    [sym_raw_string] = ACTIONS(2835),
    [anon_sym_POUND] = ACTIONS(2833),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2837),
    [anon_sym_STAR] = ACTIONS(2839),
    [anon_sym_AT] = ACTIONS(2839),
    [anon_sym_QMARK] = ACTIONS(2839),
    [anon_sym_0] = ACTIONS(2837),
    [anon_sym__] = ACTIONS(2837),
  },
  [783] = {
    [aux_sym_concatenation_repeat1] = STATE(1400),
    [sym__concat] = ACTIONS(2827),
    [anon_sym_SEMI] = ACTIONS(2717),
    [anon_sym_SEMI_SEMI] = ACTIONS(2715),
    [sym__special_character] = ACTIONS(2715),
    [anon_sym_DQUOTE] = ACTIONS(2715),
    [anon_sym_DOLLAR] = ACTIONS(2717),
    [sym_raw_string] = ACTIONS(2715),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2715),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2715),
    [anon_sym_BQUOTE] = ACTIONS(2715),
    [anon_sym_LT_LPAREN] = ACTIONS(2715),
    [anon_sym_GT_LPAREN] = ACTIONS(2715),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2717),
    [anon_sym_LF] = ACTIONS(2715),
    [anon_sym_AMP] = ACTIONS(2715),
  },
  [784] = {
    [sym_subscript] = STATE(1410),
    [sym_variable_name] = ACTIONS(2841),
    [anon_sym_BANG] = ACTIONS(2843),
    [anon_sym_DASH] = ACTIONS(2845),
    [anon_sym_DOLLAR] = ACTIONS(2845),
    [anon_sym_POUND] = ACTIONS(2843),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2847),
    [anon_sym_STAR] = ACTIONS(2849),
    [anon_sym_AT] = ACTIONS(2849),
    [anon_sym_QMARK] = ACTIONS(2849),
    [anon_sym_0] = ACTIONS(2847),
    [anon_sym__] = ACTIONS(2847),
  },
  [785] = {
    [sym__statements] = STATE(1411),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(1412),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [786] = {
    [sym__statements] = STATE(1413),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [787] = {
    [sym__statements] = STATE(1414),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [788] = {
    [sym_concatenation] = STATE(1416),
    [sym_string] = STATE(783),
    [sym_simple_expansion] = STATE(783),
    [sym_string_expansion] = STATE(783),
    [sym_expansion] = STATE(783),
    [sym_command_substitution] = STATE(783),
    [sym_process_substitution] = STATE(783),
    [aux_sym_for_statement_repeat1] = STATE(1416),
    [aux_sym__literal_repeat1] = STATE(789),
    [anon_sym_SEMI] = ACTIONS(2851),
    [anon_sym_SEMI_SEMI] = ACTIONS(2853),
    [sym__special_character] = ACTIONS(1492),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [anon_sym_DOLLAR] = ACTIONS(1496),
    [sym_raw_string] = ACTIONS(1498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1502),
    [anon_sym_BQUOTE] = ACTIONS(1504),
    [anon_sym_LT_LPAREN] = ACTIONS(1506),
    [anon_sym_GT_LPAREN] = ACTIONS(1506),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2855),
    [anon_sym_LF] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2853),
  },
  [789] = {
    [aux_sym__literal_repeat1] = STATE(1418),
    [anon_sym_SEMI] = ACTIONS(2735),
    [anon_sym_SEMI_SEMI] = ACTIONS(2731),
    [sym__special_character] = ACTIONS(2857),
    [anon_sym_DQUOTE] = ACTIONS(2731),
    [anon_sym_DOLLAR] = ACTIONS(2735),
    [sym_raw_string] = ACTIONS(2731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2731),
    [anon_sym_BQUOTE] = ACTIONS(2731),
    [anon_sym_LT_LPAREN] = ACTIONS(2731),
    [anon_sym_GT_LPAREN] = ACTIONS(2731),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2735),
    [anon_sym_LF] = ACTIONS(2731),
    [anon_sym_AMP] = ACTIONS(2731),
  },
  [790] = {
    [sym__simple_heredoc_body] = ACTIONS(2859),
    [sym__heredoc_body_beginning] = ACTIONS(2859),
    [sym_file_descriptor] = ACTIONS(2859),
    [ts_builtin_sym_end] = ACTIONS(2859),
    [anon_sym_SEMI] = ACTIONS(2861),
    [anon_sym_done] = ACTIONS(2859),
    [anon_sym_fi] = ACTIONS(2859),
    [anon_sym_elif] = ACTIONS(2859),
    [anon_sym_else] = ACTIONS(2859),
    [anon_sym_esac] = ACTIONS(2859),
    [anon_sym_PIPE] = ACTIONS(2861),
    [anon_sym_RPAREN] = ACTIONS(2859),
    [anon_sym_SEMI_SEMI] = ACTIONS(2859),
    [anon_sym_PIPE_AMP] = ACTIONS(2859),
    [anon_sym_AMP_AMP] = ACTIONS(2859),
    [anon_sym_PIPE_PIPE] = ACTIONS(2859),
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_GT] = ACTIONS(2861),
    [anon_sym_GT_GT] = ACTIONS(2859),
    [anon_sym_AMP_GT] = ACTIONS(2861),
    [anon_sym_AMP_GT_GT] = ACTIONS(2859),
    [anon_sym_LT_AMP] = ACTIONS(2859),
    [anon_sym_GT_AMP] = ACTIONS(2859),
    [anon_sym_LT_LT] = ACTIONS(2861),
    [anon_sym_LT_LT_DASH] = ACTIONS(2859),
    [anon_sym_LT_LT_LT] = ACTIONS(2859),
    [anon_sym_BQUOTE] = ACTIONS(2859),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2859),
    [anon_sym_AMP] = ACTIONS(2861),
  },
  [791] = {
    [anon_sym_RPAREN] = ACTIONS(2863),
    [anon_sym_AMP_AMP] = ACTIONS(1534),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_EQ_TILDE] = ACTIONS(1536),
    [anon_sym_EQ_EQ] = ACTIONS(1536),
    [anon_sym_EQ] = ACTIONS(1538),
    [anon_sym_PLUS_EQ] = ACTIONS(1534),
    [anon_sym_LT] = ACTIONS(1538),
    [anon_sym_GT] = ACTIONS(1538),
    [anon_sym_BANG_EQ] = ACTIONS(1534),
    [anon_sym_PLUS] = ACTIONS(1538),
    [anon_sym_DASH] = ACTIONS(1538),
    [anon_sym_DASH_EQ] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1534),
    [anon_sym_GT_EQ] = ACTIONS(1534),
    [anon_sym_PLUS_PLUS] = ACTIONS(1540),
    [anon_sym_DASH_DASH] = ACTIONS(1540),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1534),
  },
  [792] = {
    [anon_sym_RPAREN] = ACTIONS(1544),
    [anon_sym_AMP_AMP] = ACTIONS(1534),
    [anon_sym_PIPE_PIPE] = ACTIONS(1534),
    [anon_sym_EQ_TILDE] = ACTIONS(1536),
    [anon_sym_EQ_EQ] = ACTIONS(1536),
    [anon_sym_EQ] = ACTIONS(1538),
    [anon_sym_PLUS_EQ] = ACTIONS(1534),
    [anon_sym_LT] = ACTIONS(1538),
    [anon_sym_GT] = ACTIONS(1538),
    [anon_sym_BANG_EQ] = ACTIONS(1534),
    [anon_sym_PLUS] = ACTIONS(1538),
    [anon_sym_DASH] = ACTIONS(1538),
    [anon_sym_DASH_EQ] = ACTIONS(1534),
    [anon_sym_LT_EQ] = ACTIONS(1534),
    [anon_sym_GT_EQ] = ACTIONS(1534),
    [anon_sym_PLUS_PLUS] = ACTIONS(1540),
    [anon_sym_DASH_DASH] = ACTIONS(1540),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1534),
  },
  [793] = {
    [sym_string] = STATE(1420),
    [sym_simple_expansion] = STATE(1420),
    [sym_string_expansion] = STATE(1420),
    [sym_expansion] = STATE(1420),
    [sym_command_substitution] = STATE(1420),
    [sym_process_substitution] = STATE(1420),
    [sym__special_character] = ACTIONS(2865),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(2865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2865),
  },
  [794] = {
    [aux_sym_concatenation_repeat1] = STATE(1421),
    [sym__concat] = ACTIONS(1508),
    [anon_sym_RPAREN] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_EQ_TILDE] = ACTIONS(1059),
    [anon_sym_EQ_EQ] = ACTIONS(1059),
    [anon_sym_EQ] = ACTIONS(1061),
    [anon_sym_PLUS_EQ] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_BANG_EQ] = ACTIONS(1059),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_DASH_EQ] = ACTIONS(1059),
    [anon_sym_LT_EQ] = ACTIONS(1059),
    [anon_sym_GT_EQ] = ACTIONS(1059),
    [anon_sym_PLUS_PLUS] = ACTIONS(1059),
    [anon_sym_DASH_DASH] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1059),
  },
  [795] = {
    [sym__concat] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_EQ_TILDE] = ACTIONS(1063),
    [anon_sym_EQ_EQ] = ACTIONS(1063),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_PLUS_EQ] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG_EQ] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DASH_EQ] = ACTIONS(1063),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_DASH_DASH] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1063),
  },
  [796] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [797] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(2867),
    [anon_sym_DOLLAR] = ACTIONS(2869),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [798] = {
    [sym__concat] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_RPAREN] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_EQ_TILDE] = ACTIONS(1097),
    [anon_sym_EQ_EQ] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_PLUS_EQ] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_BANG_EQ] = ACTIONS(1097),
    [anon_sym_PLUS] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [anon_sym_DASH_EQ] = ACTIONS(1097),
    [anon_sym_LT_EQ] = ACTIONS(1097),
    [anon_sym_GT_EQ] = ACTIONS(1097),
    [anon_sym_PLUS_PLUS] = ACTIONS(1097),
    [anon_sym_DASH_DASH] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1097),
  },
  [799] = {
    [sym__concat] = ACTIONS(1101),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_RPAREN] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_EQ_TILDE] = ACTIONS(1101),
    [anon_sym_EQ_EQ] = ACTIONS(1101),
    [anon_sym_EQ] = ACTIONS(1103),
    [anon_sym_PLUS_EQ] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_BANG_EQ] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(1103),
    [anon_sym_DASH] = ACTIONS(1103),
    [anon_sym_DASH_EQ] = ACTIONS(1101),
    [anon_sym_LT_EQ] = ACTIONS(1101),
    [anon_sym_GT_EQ] = ACTIONS(1101),
    [anon_sym_PLUS_PLUS] = ACTIONS(1101),
    [anon_sym_DASH_DASH] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1101),
  },
  [800] = {
    [sym__concat] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_EQ_TILDE] = ACTIONS(1105),
    [anon_sym_EQ_EQ] = ACTIONS(1105),
    [anon_sym_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_BANG_EQ] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1107),
    [anon_sym_DASH] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1105),
    [anon_sym_LT_EQ] = ACTIONS(1105),
    [anon_sym_GT_EQ] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1105),
    [anon_sym_DASH_DASH] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1105),
  },
  [801] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(2871),
    [sym_comment] = ACTIONS(57),
  },
  [802] = {
    [sym_subscript] = STATE(1427),
    [sym_variable_name] = ACTIONS(2873),
    [anon_sym_DASH] = ACTIONS(2875),
    [anon_sym_DOLLAR] = ACTIONS(2875),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2877),
    [anon_sym_STAR] = ACTIONS(2879),
    [anon_sym_AT] = ACTIONS(2879),
    [anon_sym_QMARK] = ACTIONS(2879),
    [anon_sym_0] = ACTIONS(2877),
    [anon_sym__] = ACTIONS(2877),
  },
  [803] = {
    [sym_concatenation] = STATE(1430),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1430),
    [anon_sym_RBRACE] = ACTIONS(2881),
    [anon_sym_EQ] = ACTIONS(2883),
    [anon_sym_DASH] = ACTIONS(2883),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(2887),
    [anon_sym_COLON] = ACTIONS(2883),
    [anon_sym_COLON_QMARK] = ACTIONS(2883),
    [anon_sym_COLON_DASH] = ACTIONS(2883),
    [anon_sym_PERCENT] = ACTIONS(2883),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [804] = {
    [sym_concatenation] = STATE(1433),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1433),
    [anon_sym_RBRACE] = ACTIONS(2889),
    [anon_sym_EQ] = ACTIONS(2891),
    [anon_sym_DASH] = ACTIONS(2891),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(2895),
    [anon_sym_COLON] = ACTIONS(2891),
    [anon_sym_COLON_QMARK] = ACTIONS(2891),
    [anon_sym_COLON_DASH] = ACTIONS(2891),
    [anon_sym_PERCENT] = ACTIONS(2891),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [805] = {
    [anon_sym_RPAREN] = ACTIONS(2897),
    [sym_comment] = ACTIONS(57),
  },
  [806] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(2897),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [807] = {
    [anon_sym_BQUOTE] = ACTIONS(2897),
    [sym_comment] = ACTIONS(57),
  },
  [808] = {
    [anon_sym_RPAREN] = ACTIONS(2899),
    [sym_comment] = ACTIONS(57),
  },
  [809] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE] = ACTIONS(2901),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2901),
    [anon_sym_EQ_TILDE] = ACTIONS(2901),
    [anon_sym_EQ_EQ] = ACTIONS(2901),
    [anon_sym_EQ] = ACTIONS(2903),
    [anon_sym_PLUS_EQ] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2903),
    [anon_sym_GT] = ACTIONS(2903),
    [anon_sym_BANG_EQ] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_DASH_EQ] = ACTIONS(2901),
    [anon_sym_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_EQ] = ACTIONS(2901),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2901),
  },
  [810] = {
    [sym__expression] = STATE(1436),
    [sym_binary_expression] = STATE(1436),
    [sym_unary_expression] = STATE(1436),
    [sym_postfix_expression] = STATE(1436),
    [sym_parenthesized_expression] = STATE(1436),
    [sym_concatenation] = STATE(1436),
    [sym_string] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [sym_expansion] = STATE(294),
    [sym_command_substitution] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(300),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_BANG] = ACTIONS(505),
    [sym__special_character] = ACTIONS(507),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(523),
    [sym_test_operator] = ACTIONS(525),
  },
  [811] = {
    [sym__expression] = STATE(1436),
    [sym_binary_expression] = STATE(1436),
    [sym_unary_expression] = STATE(1436),
    [sym_postfix_expression] = STATE(1436),
    [sym_parenthesized_expression] = STATE(1436),
    [sym_concatenation] = STATE(1436),
    [sym_string] = STATE(294),
    [sym_simple_expansion] = STATE(294),
    [sym_string_expansion] = STATE(294),
    [sym_expansion] = STATE(294),
    [sym_command_substitution] = STATE(294),
    [sym_process_substitution] = STATE(294),
    [aux_sym__literal_repeat1] = STATE(300),
    [sym_regex] = ACTIONS(2905),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_BANG] = ACTIONS(505),
    [sym__special_character] = ACTIONS(507),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(523),
    [sym_test_operator] = ACTIONS(525),
  },
  [812] = {
    [anon_sym_RPAREN] = ACTIONS(1588),
    [anon_sym_AMP_AMP] = ACTIONS(1588),
    [anon_sym_PIPE_PIPE] = ACTIONS(1588),
    [anon_sym_EQ_TILDE] = ACTIONS(1588),
    [anon_sym_EQ_EQ] = ACTIONS(1588),
    [anon_sym_EQ] = ACTIONS(1590),
    [anon_sym_PLUS_EQ] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1590),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_BANG_EQ] = ACTIONS(1588),
    [anon_sym_PLUS] = ACTIONS(1590),
    [anon_sym_DASH] = ACTIONS(1590),
    [anon_sym_DASH_EQ] = ACTIONS(1588),
    [anon_sym_LT_EQ] = ACTIONS(1588),
    [anon_sym_GT_EQ] = ACTIONS(1588),
    [anon_sym_PLUS_PLUS] = ACTIONS(1588),
    [anon_sym_DASH_DASH] = ACTIONS(1588),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1588),
  },
  [813] = {
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_RPAREN] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(325),
    [anon_sym_EQ_EQ] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_PLUS_EQ] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_BANG_EQ] = ACTIONS(325),
    [anon_sym_PLUS] = ACTIONS(329),
    [anon_sym_DASH] = ACTIONS(329),
    [anon_sym_DASH_EQ] = ACTIONS(325),
    [anon_sym_LT_EQ] = ACTIONS(325),
    [anon_sym_GT_EQ] = ACTIONS(325),
    [anon_sym_PLUS_PLUS] = ACTIONS(325),
    [anon_sym_DASH_DASH] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(325),
  },
  [814] = {
    [aux_sym__literal_repeat1] = STATE(814),
    [anon_sym_RPAREN] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_EQ_TILDE] = ACTIONS(1371),
    [anon_sym_EQ_EQ] = ACTIONS(1371),
    [anon_sym_EQ] = ACTIONS(1373),
    [anon_sym_PLUS_EQ] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_BANG_EQ] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1373),
    [anon_sym_DASH] = ACTIONS(1373),
    [anon_sym_DASH_EQ] = ACTIONS(1371),
    [anon_sym_LT_EQ] = ACTIONS(1371),
    [anon_sym_GT_EQ] = ACTIONS(1371),
    [anon_sym_PLUS_PLUS] = ACTIONS(1371),
    [anon_sym_DASH_DASH] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(2907),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1371),
  },
  [815] = {
    [sym__concat] = ACTIONS(2344),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2344),
    [anon_sym_EQ_EQ] = ACTIONS(2344),
    [anon_sym_EQ] = ACTIONS(2346),
    [anon_sym_PLUS_EQ] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_BANG_EQ] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(2346),
    [anon_sym_DASH] = ACTIONS(2346),
    [anon_sym_DASH_EQ] = ACTIONS(2344),
    [anon_sym_LT_EQ] = ACTIONS(2344),
    [anon_sym_GT_EQ] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2344),
  },
  [816] = {
    [aux_sym_concatenation_repeat1] = STATE(816),
    [sym__concat] = ACTIONS(2910),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2344),
    [anon_sym_EQ_EQ] = ACTIONS(2344),
    [anon_sym_EQ] = ACTIONS(2346),
    [anon_sym_PLUS_EQ] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_BANG_EQ] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(2346),
    [anon_sym_DASH] = ACTIONS(2346),
    [anon_sym_DASH_EQ] = ACTIONS(2344),
    [anon_sym_LT_EQ] = ACTIONS(2344),
    [anon_sym_GT_EQ] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2344),
  },
  [817] = {
    [sym__concat] = ACTIONS(2351),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2351),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_EQ_EQ] = ACTIONS(2351),
    [anon_sym_EQ] = ACTIONS(2353),
    [anon_sym_PLUS_EQ] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2353),
    [anon_sym_DASH] = ACTIONS(2353),
    [anon_sym_DASH_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2351),
    [anon_sym_GT_EQ] = ACTIONS(2351),
    [anon_sym_PLUS_PLUS] = ACTIONS(2351),
    [anon_sym_DASH_DASH] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2351),
  },
  [818] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(2913),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [819] = {
    [sym_concatenation] = STATE(1441),
    [sym_string] = STATE(1440),
    [sym_simple_expansion] = STATE(1440),
    [sym_string_expansion] = STATE(1440),
    [sym_expansion] = STATE(1440),
    [sym_command_substitution] = STATE(1440),
    [sym_process_substitution] = STATE(1440),
    [aux_sym__literal_repeat1] = STATE(1442),
    [anon_sym_RBRACE] = ACTIONS(2915),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(2917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2917),
  },
  [820] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(2919),
    [sym_comment] = ACTIONS(57),
  },
  [821] = {
    [sym_concatenation] = STATE(1446),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1446),
    [anon_sym_RBRACE] = ACTIONS(2921),
    [anon_sym_EQ] = ACTIONS(2923),
    [anon_sym_DASH] = ACTIONS(2923),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(2927),
    [anon_sym_COLON] = ACTIONS(2923),
    [anon_sym_COLON_QMARK] = ACTIONS(2923),
    [anon_sym_COLON_DASH] = ACTIONS(2923),
    [anon_sym_PERCENT] = ACTIONS(2923),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [822] = {
    [sym_concatenation] = STATE(1448),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1448),
    [anon_sym_RBRACE] = ACTIONS(2915),
    [anon_sym_EQ] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2931),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(2933),
    [anon_sym_COLON] = ACTIONS(2929),
    [anon_sym_COLON_QMARK] = ACTIONS(2929),
    [anon_sym_COLON_DASH] = ACTIONS(2929),
    [anon_sym_PERCENT] = ACTIONS(2929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [823] = {
    [sym__concat] = ACTIONS(2442),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2442),
    [anon_sym_EQ_TILDE] = ACTIONS(2442),
    [anon_sym_EQ_EQ] = ACTIONS(2442),
    [anon_sym_EQ] = ACTIONS(2444),
    [anon_sym_PLUS_EQ] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_BANG_EQ] = ACTIONS(2442),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_DASH_EQ] = ACTIONS(2442),
    [anon_sym_LT_EQ] = ACTIONS(2442),
    [anon_sym_GT_EQ] = ACTIONS(2442),
    [anon_sym_PLUS_PLUS] = ACTIONS(2442),
    [anon_sym_DASH_DASH] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2442),
  },
  [824] = {
    [sym_concatenation] = STATE(1451),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1451),
    [sym_regex] = ACTIONS(2935),
    [anon_sym_RBRACE] = ACTIONS(2937),
    [anon_sym_EQ] = ACTIONS(2939),
    [anon_sym_DASH] = ACTIONS(2939),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2941),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2939),
    [anon_sym_COLON_QMARK] = ACTIONS(2939),
    [anon_sym_COLON_DASH] = ACTIONS(2939),
    [anon_sym_PERCENT] = ACTIONS(2939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [825] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(2937),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [826] = {
    [sym__concat] = ACTIONS(2492),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2492),
    [anon_sym_EQ_TILDE] = ACTIONS(2492),
    [anon_sym_EQ_EQ] = ACTIONS(2492),
    [anon_sym_EQ] = ACTIONS(2494),
    [anon_sym_PLUS_EQ] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_BANG_EQ] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(2494),
    [anon_sym_DASH] = ACTIONS(2494),
    [anon_sym_DASH_EQ] = ACTIONS(2492),
    [anon_sym_LT_EQ] = ACTIONS(2492),
    [anon_sym_GT_EQ] = ACTIONS(2492),
    [anon_sym_PLUS_PLUS] = ACTIONS(2492),
    [anon_sym_DASH_DASH] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2492),
  },
  [827] = {
    [sym_concatenation] = STATE(1448),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1448),
    [sym_regex] = ACTIONS(2943),
    [anon_sym_RBRACE] = ACTIONS(2915),
    [anon_sym_EQ] = ACTIONS(2929),
    [anon_sym_DASH] = ACTIONS(2929),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2931),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2929),
    [anon_sym_COLON_QMARK] = ACTIONS(2929),
    [anon_sym_COLON_DASH] = ACTIONS(2929),
    [anon_sym_PERCENT] = ACTIONS(2929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [828] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(2915),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [829] = {
    [sym__concat] = ACTIONS(2500),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2500),
    [anon_sym_EQ_TILDE] = ACTIONS(2500),
    [anon_sym_EQ_EQ] = ACTIONS(2500),
    [anon_sym_EQ] = ACTIONS(2502),
    [anon_sym_PLUS_EQ] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_BANG_EQ] = ACTIONS(2500),
    [anon_sym_PLUS] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2502),
    [anon_sym_DASH_EQ] = ACTIONS(2500),
    [anon_sym_LT_EQ] = ACTIONS(2500),
    [anon_sym_GT_EQ] = ACTIONS(2500),
    [anon_sym_PLUS_PLUS] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2500),
  },
  [830] = {
    [sym__concat] = ACTIONS(2534),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2534),
    [anon_sym_EQ_TILDE] = ACTIONS(2534),
    [anon_sym_EQ_EQ] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2536),
    [anon_sym_PLUS_EQ] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_BANG_EQ] = ACTIONS(2534),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_DASH_EQ] = ACTIONS(2534),
    [anon_sym_LT_EQ] = ACTIONS(2534),
    [anon_sym_GT_EQ] = ACTIONS(2534),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2534),
  },
  [831] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2945),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE] = ACTIONS(2945),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2945),
    [anon_sym_EQ_TILDE] = ACTIONS(2945),
    [anon_sym_EQ_EQ] = ACTIONS(2945),
    [anon_sym_EQ] = ACTIONS(2947),
    [anon_sym_PLUS_EQ] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2947),
    [anon_sym_BANG_EQ] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2947),
    [anon_sym_DASH_EQ] = ACTIONS(2945),
    [anon_sym_LT_EQ] = ACTIONS(2945),
    [anon_sym_GT_EQ] = ACTIONS(2945),
    [anon_sym_PLUS_PLUS] = ACTIONS(2945),
    [anon_sym_DASH_DASH] = ACTIONS(2945),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2945),
  },
  [832] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2945),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE] = ACTIONS(2945),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2945),
    [anon_sym_EQ_TILDE] = ACTIONS(2945),
    [anon_sym_EQ_EQ] = ACTIONS(2945),
    [anon_sym_EQ] = ACTIONS(2947),
    [anon_sym_PLUS_EQ] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2947),
    [anon_sym_BANG_EQ] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2947),
    [anon_sym_DASH_EQ] = ACTIONS(2945),
    [anon_sym_LT_EQ] = ACTIONS(2945),
    [anon_sym_GT_EQ] = ACTIONS(2945),
    [anon_sym_PLUS_PLUS] = ACTIONS(2945),
    [anon_sym_DASH_DASH] = ACTIONS(2945),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2945),
  },
  [833] = {
    [sym_file_descriptor] = ACTIONS(1398),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [834] = {
    [sym_concatenation] = STATE(1454),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(1454),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(2949),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [835] = {
    [aux_sym_concatenation_repeat1] = STATE(1456),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(2951),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [836] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(1459),
    [anon_sym_DQUOTE] = ACTIONS(2953),
    [anon_sym_DOLLAR] = ACTIONS(2955),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [837] = {
    [sym_string] = STATE(1461),
    [anon_sym_DASH] = ACTIONS(2957),
    [anon_sym_DQUOTE] = ACTIONS(1601),
    [anon_sym_DOLLAR] = ACTIONS(2957),
    [sym_raw_string] = ACTIONS(2959),
    [anon_sym_POUND] = ACTIONS(2957),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2961),
    [anon_sym_STAR] = ACTIONS(2963),
    [anon_sym_AT] = ACTIONS(2963),
    [anon_sym_QMARK] = ACTIONS(2963),
    [anon_sym_0] = ACTIONS(2961),
    [anon_sym__] = ACTIONS(2961),
  },
  [838] = {
    [aux_sym_concatenation_repeat1] = STATE(1456),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym__concat] = ACTIONS(2951),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [839] = {
    [sym_subscript] = STATE(1466),
    [sym_variable_name] = ACTIONS(2965),
    [anon_sym_BANG] = ACTIONS(2967),
    [anon_sym_DASH] = ACTIONS(2969),
    [anon_sym_DOLLAR] = ACTIONS(2969),
    [anon_sym_POUND] = ACTIONS(2967),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2971),
    [anon_sym_STAR] = ACTIONS(2973),
    [anon_sym_AT] = ACTIONS(2973),
    [anon_sym_QMARK] = ACTIONS(2973),
    [anon_sym_0] = ACTIONS(2971),
    [anon_sym__] = ACTIONS(2971),
  },
  [840] = {
    [sym__statements] = STATE(1467),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(1468),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [841] = {
    [sym__statements] = STATE(1469),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [842] = {
    [sym__statements] = STATE(1470),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [843] = {
    [aux_sym__literal_repeat1] = STATE(1472),
    [sym_file_descriptor] = ACTIONS(1444),
    [sym_variable_name] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1446),
    [anon_sym_SEMI_SEMI] = ACTIONS(1444),
    [anon_sym_PIPE_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1446),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_AMP_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT_GT] = ACTIONS(1444),
    [anon_sym_LT_AMP] = ACTIONS(1444),
    [anon_sym_GT_AMP] = ACTIONS(1444),
    [anon_sym_LT_LT] = ACTIONS(1446),
    [anon_sym_LT_LT_DASH] = ACTIONS(1444),
    [anon_sym_LT_LT_LT] = ACTIONS(1444),
    [sym__special_character] = ACTIONS(2975),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [anon_sym_DOLLAR] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1444),
    [anon_sym_BQUOTE] = ACTIONS(1444),
    [anon_sym_LT_LPAREN] = ACTIONS(1444),
    [anon_sym_GT_LPAREN] = ACTIONS(1444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1446),
    [anon_sym_LF] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1446),
  },
  [844] = {
    [sym__expression] = STATE(1474),
    [sym_binary_expression] = STATE(1474),
    [sym_unary_expression] = STATE(1474),
    [sym_postfix_expression] = STATE(1474),
    [sym_parenthesized_expression] = STATE(1474),
    [sym_concatenation] = STATE(1474),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [anon_sym_SEMI] = ACTIONS(2977),
    [anon_sym_SEMI_SEMI] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [sym__special_character] = ACTIONS(477),
    [anon_sym_DQUOTE] = ACTIONS(479),
    [anon_sym_DOLLAR] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
    [anon_sym_LF] = ACTIONS(2979),
    [anon_sym_AMP] = ACTIONS(2979),
  },
  [845] = {
    [anon_sym_SEMI] = ACTIONS(2981),
    [anon_sym_SEMI_SEMI] = ACTIONS(2983),
    [anon_sym_AMP_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1482),
    [anon_sym_EQ_TILDE] = ACTIONS(1484),
    [anon_sym_EQ_EQ] = ACTIONS(1484),
    [anon_sym_EQ] = ACTIONS(1486),
    [anon_sym_PLUS_EQ] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(1486),
    [anon_sym_GT] = ACTIONS(1486),
    [anon_sym_BANG_EQ] = ACTIONS(1482),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_DASH_EQ] = ACTIONS(1482),
    [anon_sym_LT_EQ] = ACTIONS(1482),
    [anon_sym_GT_EQ] = ACTIONS(1482),
    [anon_sym_PLUS_PLUS] = ACTIONS(1488),
    [anon_sym_DASH_DASH] = ACTIONS(1488),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1482),
    [anon_sym_LF] = ACTIONS(2983),
    [anon_sym_AMP] = ACTIONS(2981),
  },
  [846] = {
    [sym_concatenation] = STATE(1476),
    [sym_string] = STATE(783),
    [sym_simple_expansion] = STATE(783),
    [sym_string_expansion] = STATE(783),
    [sym_expansion] = STATE(783),
    [sym_command_substitution] = STATE(783),
    [sym_process_substitution] = STATE(783),
    [aux_sym_for_statement_repeat1] = STATE(1476),
    [aux_sym__literal_repeat1] = STATE(789),
    [sym__special_character] = ACTIONS(1492),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [anon_sym_DOLLAR] = ACTIONS(1496),
    [sym_raw_string] = ACTIONS(1498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1502),
    [anon_sym_BQUOTE] = ACTIONS(1504),
    [anon_sym_LT_LPAREN] = ACTIONS(1506),
    [anon_sym_GT_LPAREN] = ACTIONS(1506),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1498),
  },
  [847] = {
    [sym_do_group] = STATE(1477),
    [anon_sym_do] = ACTIONS(1627),
    [sym_comment] = ACTIONS(57),
  },
  [848] = {
    [sym_file_descriptor] = ACTIONS(1582),
    [anon_sym_SEMI] = ACTIONS(1584),
    [anon_sym_PIPE] = ACTIONS(1584),
    [anon_sym_SEMI_SEMI] = ACTIONS(1582),
    [anon_sym_PIPE_AMP] = ACTIONS(1582),
    [anon_sym_AMP_AMP] = ACTIONS(1582),
    [anon_sym_PIPE_PIPE] = ACTIONS(1582),
    [anon_sym_LT] = ACTIONS(1584),
    [anon_sym_GT] = ACTIONS(1584),
    [anon_sym_GT_GT] = ACTIONS(1582),
    [anon_sym_AMP_GT] = ACTIONS(1584),
    [anon_sym_AMP_GT_GT] = ACTIONS(1582),
    [anon_sym_LT_AMP] = ACTIONS(1582),
    [anon_sym_GT_AMP] = ACTIONS(1582),
    [anon_sym_LT_LT] = ACTIONS(1584),
    [anon_sym_LT_LT_DASH] = ACTIONS(1582),
    [anon_sym_LT_LT_LT] = ACTIONS(1582),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1584),
  },
  [849] = {
    [sym__statements] = STATE(1479),
    [sym_redirected_statement] = STATE(931),
    [sym_for_statement] = STATE(931),
    [sym_c_style_for_statement] = STATE(931),
    [sym_while_statement] = STATE(931),
    [sym_if_statement] = STATE(931),
    [sym_case_statement] = STATE(931),
    [sym_function_definition] = STATE(931),
    [sym_compound_statement] = STATE(931),
    [sym_subshell] = STATE(931),
    [sym_pipeline] = STATE(931),
    [sym_list] = STATE(931),
    [sym_negated_command] = STATE(931),
    [sym_test_command] = STATE(931),
    [sym_declaration_command] = STATE(931),
    [sym_unset_command] = STATE(931),
    [sym_command] = STATE(931),
    [sym_command_name] = STATE(932),
    [sym_variable_assignment] = STATE(933),
    [sym_subscript] = STATE(934),
    [sym_file_redirect] = STATE(937),
    [sym_concatenation] = STATE(935),
    [sym_string] = STATE(924),
    [sym_simple_expansion] = STATE(924),
    [sym_string_expansion] = STATE(924),
    [sym_expansion] = STATE(924),
    [sym_command_substitution] = STATE(924),
    [sym_process_substitution] = STATE(924),
    [aux_sym__statements_repeat1] = STATE(936),
    [aux_sym_command_repeat1] = STATE(937),
    [aux_sym__literal_repeat1] = STATE(938),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1745),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_done] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1751),
    [anon_sym_typeset] = ACTIONS(1751),
    [anon_sym_export] = ACTIONS(1751),
    [anon_sym_readonly] = ACTIONS(1751),
    [anon_sym_local] = ACTIONS(1751),
    [anon_sym_unset] = ACTIONS(1753),
    [anon_sym_unsetenv] = ACTIONS(1753),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(1755),
    [anon_sym_DQUOTE] = ACTIONS(1757),
    [anon_sym_DOLLAR] = ACTIONS(1759),
    [sym_raw_string] = ACTIONS(1761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1765),
    [anon_sym_BQUOTE] = ACTIONS(1767),
    [anon_sym_LT_LPAREN] = ACTIONS(1769),
    [anon_sym_GT_LPAREN] = ACTIONS(1769),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1771),
  },
  [850] = {
    [sym_file_descriptor] = ACTIONS(1773),
    [anon_sym_SEMI] = ACTIONS(1775),
    [anon_sym_PIPE] = ACTIONS(1775),
    [anon_sym_SEMI_SEMI] = ACTIONS(1773),
    [anon_sym_PIPE_AMP] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_LT] = ACTIONS(1775),
    [anon_sym_GT] = ACTIONS(1775),
    [anon_sym_GT_GT] = ACTIONS(1773),
    [anon_sym_AMP_GT] = ACTIONS(1775),
    [anon_sym_AMP_GT_GT] = ACTIONS(1773),
    [anon_sym_LT_AMP] = ACTIONS(1773),
    [anon_sym_GT_AMP] = ACTIONS(1773),
    [anon_sym_LT_LT] = ACTIONS(1775),
    [anon_sym_LT_LT_DASH] = ACTIONS(1773),
    [anon_sym_LT_LT_LT] = ACTIONS(1773),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1775),
  },
  [851] = {
    [sym__statements] = STATE(1481),
    [sym_redirected_statement] = STATE(975),
    [sym_for_statement] = STATE(975),
    [sym_c_style_for_statement] = STATE(975),
    [sym_while_statement] = STATE(975),
    [sym_if_statement] = STATE(975),
    [sym_elif_clause] = STATE(1483),
    [sym_else_clause] = STATE(1482),
    [sym_case_statement] = STATE(975),
    [sym_function_definition] = STATE(975),
    [sym_compound_statement] = STATE(975),
    [sym_subshell] = STATE(975),
    [sym_pipeline] = STATE(975),
    [sym_list] = STATE(975),
    [sym_negated_command] = STATE(975),
    [sym_test_command] = STATE(975),
    [sym_declaration_command] = STATE(975),
    [sym_unset_command] = STATE(975),
    [sym_command] = STATE(975),
    [sym_command_name] = STATE(977),
    [sym_variable_assignment] = STATE(978),
    [sym_subscript] = STATE(979),
    [sym_file_redirect] = STATE(983),
    [sym_concatenation] = STATE(980),
    [sym_string] = STATE(968),
    [sym_simple_expansion] = STATE(968),
    [sym_string_expansion] = STATE(968),
    [sym_expansion] = STATE(968),
    [sym_command_substitution] = STATE(968),
    [sym_process_substitution] = STATE(968),
    [aux_sym__statements_repeat1] = STATE(981),
    [aux_sym_if_statement_repeat1] = STATE(1483),
    [aux_sym_command_repeat1] = STATE(983),
    [aux_sym__literal_repeat1] = STATE(984),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1798),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_fi] = ACTIONS(2987),
    [anon_sym_elif] = ACTIONS(1802),
    [anon_sym_else] = ACTIONS(1804),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1808),
    [anon_sym_typeset] = ACTIONS(1808),
    [anon_sym_export] = ACTIONS(1808),
    [anon_sym_readonly] = ACTIONS(1808),
    [anon_sym_local] = ACTIONS(1808),
    [anon_sym_unset] = ACTIONS(1810),
    [anon_sym_unsetenv] = ACTIONS(1810),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(1812),
    [anon_sym_DQUOTE] = ACTIONS(1814),
    [anon_sym_DOLLAR] = ACTIONS(1816),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1822),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1828),
  },
  [852] = {
    [anon_sym_SEMI] = ACTIONS(2989),
    [anon_sym_SEMI_SEMI] = ACTIONS(2991),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2991),
    [anon_sym_AMP] = ACTIONS(2991),
  },
  [853] = {
    [anon_sym_in] = ACTIONS(2993),
    [sym_comment] = ACTIONS(57),
  },
  [854] = {
    [anon_sym_SEMI] = ACTIONS(2995),
    [anon_sym_SEMI_SEMI] = ACTIONS(2997),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2997),
    [anon_sym_AMP] = ACTIONS(2997),
  },
  [855] = {
    [anon_sym_in] = ACTIONS(2999),
    [sym_comment] = ACTIONS(57),
  },
  [856] = {
    [anon_sym_RPAREN] = ACTIONS(3001),
    [sym_comment] = ACTIONS(57),
  },
  [857] = {
    [sym_file_descriptor] = ACTIONS(1883),
    [anon_sym_SEMI] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1885),
    [anon_sym_SEMI_SEMI] = ACTIONS(1883),
    [anon_sym_PIPE_AMP] = ACTIONS(1883),
    [anon_sym_AMP_AMP] = ACTIONS(1883),
    [anon_sym_PIPE_PIPE] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1885),
    [anon_sym_GT_GT] = ACTIONS(1883),
    [anon_sym_AMP_GT] = ACTIONS(1885),
    [anon_sym_AMP_GT_GT] = ACTIONS(1883),
    [anon_sym_LT_AMP] = ACTIONS(1883),
    [anon_sym_GT_AMP] = ACTIONS(1883),
    [anon_sym_LT_LT] = ACTIONS(1885),
    [anon_sym_LT_LT_DASH] = ACTIONS(1883),
    [anon_sym_LT_LT_LT] = ACTIONS(1883),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1885),
  },
  [858] = {
    [sym_file_descriptor] = ACTIONS(1897),
    [anon_sym_SEMI] = ACTIONS(1899),
    [anon_sym_PIPE] = ACTIONS(1899),
    [anon_sym_SEMI_SEMI] = ACTIONS(1897),
    [anon_sym_PIPE_AMP] = ACTIONS(1897),
    [anon_sym_AMP_AMP] = ACTIONS(1897),
    [anon_sym_PIPE_PIPE] = ACTIONS(1897),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(1899),
    [anon_sym_GT_GT] = ACTIONS(1897),
    [anon_sym_AMP_GT] = ACTIONS(1899),
    [anon_sym_AMP_GT_GT] = ACTIONS(1897),
    [anon_sym_LT_AMP] = ACTIONS(1897),
    [anon_sym_GT_AMP] = ACTIONS(1897),
    [anon_sym_LT_LT] = ACTIONS(1899),
    [anon_sym_LT_LT_DASH] = ACTIONS(1897),
    [anon_sym_LT_LT_LT] = ACTIONS(1897),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1897),
    [anon_sym_AMP] = ACTIONS(1899),
  },
  [859] = {
    [sym_file_descriptor] = ACTIONS(2063),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_PIPE] = ACTIONS(2065),
    [anon_sym_SEMI_SEMI] = ACTIONS(2063),
    [anon_sym_PIPE_AMP] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2063),
    [anon_sym_PIPE_PIPE] = ACTIONS(2063),
    [anon_sym_LT] = ACTIONS(2065),
    [anon_sym_GT] = ACTIONS(2065),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_AMP_GT] = ACTIONS(2065),
    [anon_sym_AMP_GT_GT] = ACTIONS(2063),
    [anon_sym_LT_AMP] = ACTIONS(2063),
    [anon_sym_GT_AMP] = ACTIONS(2063),
    [anon_sym_LT_LT] = ACTIONS(2065),
    [anon_sym_LT_LT_DASH] = ACTIONS(2063),
    [anon_sym_LT_LT_LT] = ACTIONS(2063),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2063),
    [anon_sym_AMP] = ACTIONS(2065),
  },
  [860] = {
    [sym_concatenation] = STATE(1489),
    [sym_string] = STATE(1491),
    [sym_array] = STATE(1489),
    [sym_simple_expansion] = STATE(1491),
    [sym_string_expansion] = STATE(1491),
    [sym_expansion] = STATE(1491),
    [sym_command_substitution] = STATE(1491),
    [sym_process_substitution] = STATE(1491),
    [aux_sym__literal_repeat1] = STATE(1492),
    [sym__empty_value] = ACTIONS(3003),
    [anon_sym_LPAREN] = ACTIONS(3005),
    [sym__special_character] = ACTIONS(585),
    [anon_sym_DQUOTE] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(589),
    [sym_raw_string] = ACTIONS(3007),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(593),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(595),
    [anon_sym_BQUOTE] = ACTIONS(597),
    [anon_sym_LT_LPAREN] = ACTIONS(599),
    [anon_sym_GT_LPAREN] = ACTIONS(599),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3007),
  },
  [861] = {
    [sym_string] = STATE(1493),
    [sym_simple_expansion] = STATE(1493),
    [sym_string_expansion] = STATE(1493),
    [sym_expansion] = STATE(1493),
    [sym_command_substitution] = STATE(1493),
    [sym_process_substitution] = STATE(1493),
    [sym__special_character] = ACTIONS(3009),
    [anon_sym_DQUOTE] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(589),
    [sym_raw_string] = ACTIONS(3009),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(593),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(595),
    [anon_sym_BQUOTE] = ACTIONS(597),
    [anon_sym_LT_LPAREN] = ACTIONS(599),
    [anon_sym_GT_LPAREN] = ACTIONS(599),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3009),
  },
  [862] = {
    [aux_sym_concatenation_repeat1] = STATE(1494),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(1651),
    [sym_variable_name] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1061),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [863] = {
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [sym_variable_name] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [864] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [865] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [anon_sym_DOLLAR] = ACTIONS(3013),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [866] = {
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1099),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [867] = {
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [sym_variable_name] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1103),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [868] = {
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [sym_variable_name] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1107),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [869] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(3015),
    [sym_comment] = ACTIONS(57),
  },
  [870] = {
    [sym_subscript] = STATE(1500),
    [sym_variable_name] = ACTIONS(3017),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_DOLLAR] = ACTIONS(3019),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3021),
    [anon_sym_STAR] = ACTIONS(3023),
    [anon_sym_AT] = ACTIONS(3023),
    [anon_sym_QMARK] = ACTIONS(3023),
    [anon_sym_0] = ACTIONS(3021),
    [anon_sym__] = ACTIONS(3021),
  },
  [871] = {
    [sym_concatenation] = STATE(1503),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1503),
    [anon_sym_RBRACE] = ACTIONS(3025),
    [anon_sym_EQ] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3029),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(3031),
    [anon_sym_COLON] = ACTIONS(3027),
    [anon_sym_COLON_QMARK] = ACTIONS(3027),
    [anon_sym_COLON_DASH] = ACTIONS(3027),
    [anon_sym_PERCENT] = ACTIONS(3027),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [872] = {
    [sym_concatenation] = STATE(1506),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1506),
    [anon_sym_RBRACE] = ACTIONS(3033),
    [anon_sym_EQ] = ACTIONS(3035),
    [anon_sym_DASH] = ACTIONS(3035),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3037),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(3039),
    [anon_sym_COLON] = ACTIONS(3035),
    [anon_sym_COLON_QMARK] = ACTIONS(3035),
    [anon_sym_COLON_DASH] = ACTIONS(3035),
    [anon_sym_PERCENT] = ACTIONS(3035),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [873] = {
    [anon_sym_RPAREN] = ACTIONS(3041),
    [sym_comment] = ACTIONS(57),
  },
  [874] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(3041),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [875] = {
    [anon_sym_BQUOTE] = ACTIONS(3041),
    [sym_comment] = ACTIONS(57),
  },
  [876] = {
    [anon_sym_RPAREN] = ACTIONS(3043),
    [sym_comment] = ACTIONS(57),
  },
  [877] = {
    [sym_variable_assignment] = STATE(877),
    [sym_subscript] = STATE(349),
    [sym_concatenation] = STATE(877),
    [sym_string] = STATE(344),
    [sym_simple_expansion] = STATE(344),
    [sym_string_expansion] = STATE(344),
    [sym_expansion] = STATE(344),
    [sym_command_substitution] = STATE(344),
    [sym_process_substitution] = STATE(344),
    [aux_sym_declaration_command_repeat1] = STATE(877),
    [aux_sym__literal_repeat1] = STATE(351),
    [sym_file_descriptor] = ACTIONS(2192),
    [sym_variable_name] = ACTIONS(3045),
    [anon_sym_SEMI] = ACTIONS(2197),
    [anon_sym_PIPE] = ACTIONS(2197),
    [anon_sym_SEMI_SEMI] = ACTIONS(2192),
    [anon_sym_PIPE_AMP] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_GT] = ACTIONS(2197),
    [anon_sym_GT_GT] = ACTIONS(2192),
    [anon_sym_AMP_GT] = ACTIONS(2197),
    [anon_sym_AMP_GT_GT] = ACTIONS(2192),
    [anon_sym_LT_AMP] = ACTIONS(2192),
    [anon_sym_GT_AMP] = ACTIONS(2192),
    [anon_sym_LT_LT] = ACTIONS(2197),
    [anon_sym_LT_LT_DASH] = ACTIONS(2192),
    [anon_sym_LT_LT_LT] = ACTIONS(2192),
    [sym__special_character] = ACTIONS(3048),
    [anon_sym_DQUOTE] = ACTIONS(3051),
    [anon_sym_DOLLAR] = ACTIONS(3054),
    [sym_raw_string] = ACTIONS(3057),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3060),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3063),
    [anon_sym_BQUOTE] = ACTIONS(3066),
    [anon_sym_LT_LPAREN] = ACTIONS(3069),
    [anon_sym_GT_LPAREN] = ACTIONS(3069),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3072),
    [sym_word] = ACTIONS(3075),
    [anon_sym_LF] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2197),
  },
  [878] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [879] = {
    [aux_sym__literal_repeat1] = STATE(879),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym_variable_name] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1373),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [880] = {
    [sym_string] = STATE(1509),
    [sym_simple_expansion] = STATE(1509),
    [sym_string_expansion] = STATE(1509),
    [sym_expansion] = STATE(1509),
    [sym_command_substitution] = STATE(1509),
    [sym_process_substitution] = STATE(1509),
    [sym__special_character] = ACTIONS(3081),
    [anon_sym_DQUOTE] = ACTIONS(607),
    [anon_sym_DOLLAR] = ACTIONS(609),
    [sym_raw_string] = ACTIONS(3081),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(615),
    [anon_sym_BQUOTE] = ACTIONS(617),
    [anon_sym_LT_LPAREN] = ACTIONS(619),
    [anon_sym_GT_LPAREN] = ACTIONS(619),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3081),
  },
  [881] = {
    [aux_sym_concatenation_repeat1] = STATE(1510),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(1679),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1061),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [882] = {
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [883] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(3083),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [884] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(3083),
    [anon_sym_DOLLAR] = ACTIONS(3085),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [885] = {
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1099),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [886] = {
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1103),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [887] = {
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1107),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [888] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(3087),
    [sym_comment] = ACTIONS(57),
  },
  [889] = {
    [sym_subscript] = STATE(1516),
    [sym_variable_name] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3091),
    [anon_sym_DOLLAR] = ACTIONS(3091),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3093),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_AT] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_0] = ACTIONS(3093),
    [anon_sym__] = ACTIONS(3093),
  },
  [890] = {
    [sym_concatenation] = STATE(1519),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1519),
    [anon_sym_RBRACE] = ACTIONS(3097),
    [anon_sym_EQ] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3099),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(3103),
    [anon_sym_COLON] = ACTIONS(3099),
    [anon_sym_COLON_QMARK] = ACTIONS(3099),
    [anon_sym_COLON_DASH] = ACTIONS(3099),
    [anon_sym_PERCENT] = ACTIONS(3099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [891] = {
    [sym_concatenation] = STATE(1522),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1522),
    [anon_sym_RBRACE] = ACTIONS(3105),
    [anon_sym_EQ] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3107),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(3111),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_COLON_QMARK] = ACTIONS(3107),
    [anon_sym_COLON_DASH] = ACTIONS(3107),
    [anon_sym_PERCENT] = ACTIONS(3107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [892] = {
    [anon_sym_RPAREN] = ACTIONS(3113),
    [sym_comment] = ACTIONS(57),
  },
  [893] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(3113),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [894] = {
    [anon_sym_BQUOTE] = ACTIONS(3113),
    [sym_comment] = ACTIONS(57),
  },
  [895] = {
    [anon_sym_RPAREN] = ACTIONS(3115),
    [sym_comment] = ACTIONS(57),
  },
  [896] = {
    [sym_concatenation] = STATE(896),
    [sym_string] = STATE(355),
    [sym_simple_expansion] = STATE(355),
    [sym_string_expansion] = STATE(355),
    [sym_expansion] = STATE(355),
    [sym_command_substitution] = STATE(355),
    [sym_process_substitution] = STATE(355),
    [aux_sym_unset_command_repeat1] = STATE(896),
    [aux_sym__literal_repeat1] = STATE(361),
    [sym_file_descriptor] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2270),
    [anon_sym_SEMI_SEMI] = ACTIONS(2268),
    [anon_sym_PIPE_AMP] = ACTIONS(2268),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [anon_sym_PIPE_PIPE] = ACTIONS(2268),
    [anon_sym_LT] = ACTIONS(2270),
    [anon_sym_GT] = ACTIONS(2270),
    [anon_sym_GT_GT] = ACTIONS(2268),
    [anon_sym_AMP_GT] = ACTIONS(2270),
    [anon_sym_AMP_GT_GT] = ACTIONS(2268),
    [anon_sym_LT_AMP] = ACTIONS(2268),
    [anon_sym_GT_AMP] = ACTIONS(2268),
    [anon_sym_LT_LT] = ACTIONS(2270),
    [anon_sym_LT_LT_DASH] = ACTIONS(2268),
    [anon_sym_LT_LT_LT] = ACTIONS(2268),
    [sym__special_character] = ACTIONS(3117),
    [anon_sym_DQUOTE] = ACTIONS(3120),
    [anon_sym_DOLLAR] = ACTIONS(3123),
    [sym_raw_string] = ACTIONS(3126),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3129),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3132),
    [anon_sym_BQUOTE] = ACTIONS(3135),
    [anon_sym_LT_LPAREN] = ACTIONS(3138),
    [anon_sym_GT_LPAREN] = ACTIONS(3138),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3141),
    [sym_word] = ACTIONS(3144),
    [anon_sym_LF] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2270),
  },
  [897] = {
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [898] = {
    [aux_sym__literal_repeat1] = STATE(898),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(3147),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1373),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [899] = {
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2346),
    [anon_sym_EQ_EQ] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [900] = {
    [aux_sym_concatenation_repeat1] = STATE(900),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2346),
    [anon_sym_EQ_EQ] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [901] = {
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_EQ_TILDE] = ACTIONS(2353),
    [anon_sym_EQ_EQ] = ACTIONS(2353),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [902] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(3153),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [903] = {
    [sym_concatenation] = STATE(1528),
    [sym_string] = STATE(1527),
    [sym_simple_expansion] = STATE(1527),
    [sym_string_expansion] = STATE(1527),
    [sym_expansion] = STATE(1527),
    [sym_command_substitution] = STATE(1527),
    [sym_process_substitution] = STATE(1527),
    [aux_sym__literal_repeat1] = STATE(1529),
    [anon_sym_RBRACE] = ACTIONS(3155),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(3157),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3157),
  },
  [904] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(3159),
    [sym_comment] = ACTIONS(57),
  },
  [905] = {
    [sym_concatenation] = STATE(1533),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1533),
    [anon_sym_RBRACE] = ACTIONS(3161),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_DASH] = ACTIONS(3163),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(3167),
    [anon_sym_COLON] = ACTIONS(3163),
    [anon_sym_COLON_QMARK] = ACTIONS(3163),
    [anon_sym_COLON_DASH] = ACTIONS(3163),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [906] = {
    [sym_concatenation] = STATE(1535),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1535),
    [anon_sym_RBRACE] = ACTIONS(3155),
    [anon_sym_EQ] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(3173),
    [anon_sym_COLON] = ACTIONS(3169),
    [anon_sym_COLON_QMARK] = ACTIONS(3169),
    [anon_sym_COLON_DASH] = ACTIONS(3169),
    [anon_sym_PERCENT] = ACTIONS(3169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [907] = {
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_EQ_TILDE] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2444),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [908] = {
    [sym_concatenation] = STATE(1538),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1538),
    [sym_regex] = ACTIONS(3175),
    [anon_sym_RBRACE] = ACTIONS(3177),
    [anon_sym_EQ] = ACTIONS(3179),
    [anon_sym_DASH] = ACTIONS(3179),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3181),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(3179),
    [anon_sym_COLON_QMARK] = ACTIONS(3179),
    [anon_sym_COLON_DASH] = ACTIONS(3179),
    [anon_sym_PERCENT] = ACTIONS(3179),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [909] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(3177),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [910] = {
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_EQ_TILDE] = ACTIONS(2494),
    [anon_sym_EQ_EQ] = ACTIONS(2494),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [911] = {
    [sym_concatenation] = STATE(1535),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1535),
    [sym_regex] = ACTIONS(3183),
    [anon_sym_RBRACE] = ACTIONS(3155),
    [anon_sym_EQ] = ACTIONS(3169),
    [anon_sym_DASH] = ACTIONS(3169),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(3169),
    [anon_sym_COLON_QMARK] = ACTIONS(3169),
    [anon_sym_COLON_DASH] = ACTIONS(3169),
    [anon_sym_PERCENT] = ACTIONS(3169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [912] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(3155),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [913] = {
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_EQ_TILDE] = ACTIONS(2502),
    [anon_sym_EQ_EQ] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [914] = {
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_EQ_TILDE] = ACTIONS(2536),
    [anon_sym_EQ_EQ] = ACTIONS(2536),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [915] = {
    [sym_compound_statement] = STATE(1540),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [916] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(3185),
    [anon_sym_PLUS_EQ] = ACTIONS(3185),
    [sym_comment] = ACTIONS(57),
  },
  [917] = {
    [sym__simple_heredoc_body] = ACTIONS(3187),
    [sym__heredoc_body_beginning] = ACTIONS(3187),
    [sym_file_descriptor] = ACTIONS(3187),
    [ts_builtin_sym_end] = ACTIONS(3187),
    [anon_sym_SEMI] = ACTIONS(3189),
    [anon_sym_done] = ACTIONS(3187),
    [anon_sym_fi] = ACTIONS(3187),
    [anon_sym_elif] = ACTIONS(3187),
    [anon_sym_else] = ACTIONS(3187),
    [anon_sym_esac] = ACTIONS(3187),
    [anon_sym_PIPE] = ACTIONS(3189),
    [anon_sym_RPAREN] = ACTIONS(3187),
    [anon_sym_SEMI_SEMI] = ACTIONS(3187),
    [anon_sym_PIPE_AMP] = ACTIONS(3187),
    [anon_sym_AMP_AMP] = ACTIONS(3187),
    [anon_sym_PIPE_PIPE] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_GT] = ACTIONS(3189),
    [anon_sym_GT_GT] = ACTIONS(3187),
    [anon_sym_AMP_GT] = ACTIONS(3189),
    [anon_sym_AMP_GT_GT] = ACTIONS(3187),
    [anon_sym_LT_AMP] = ACTIONS(3187),
    [anon_sym_GT_AMP] = ACTIONS(3187),
    [anon_sym_LT_LT] = ACTIONS(3189),
    [anon_sym_LT_LT_DASH] = ACTIONS(3187),
    [anon_sym_LT_LT_LT] = ACTIONS(3187),
    [anon_sym_BQUOTE] = ACTIONS(3187),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3187),
    [anon_sym_AMP] = ACTIONS(3189),
  },
  [918] = {
    [sym_subshell] = STATE(146),
    [sym_test_command] = STATE(146),
    [sym_command] = STATE(146),
    [sym_command_name] = STATE(932),
    [sym_variable_assignment] = STATE(937),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(937),
    [sym_concatenation] = STATE(935),
    [sym_string] = STATE(924),
    [sym_simple_expansion] = STATE(924),
    [sym_string_expansion] = STATE(924),
    [sym_expansion] = STATE(924),
    [sym_command_substitution] = STATE(924),
    [sym_process_substitution] = STATE(924),
    [aux_sym_command_repeat1] = STATE(937),
    [aux_sym__literal_repeat1] = STATE(938),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(1755),
    [anon_sym_DQUOTE] = ACTIONS(1757),
    [anon_sym_DOLLAR] = ACTIONS(1759),
    [sym_raw_string] = ACTIONS(1761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1765),
    [anon_sym_BQUOTE] = ACTIONS(1767),
    [anon_sym_LT_LPAREN] = ACTIONS(1769),
    [anon_sym_GT_LPAREN] = ACTIONS(1769),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1761),
  },
  [919] = {
    [sym_variable_assignment] = STATE(1552),
    [sym_subscript] = STATE(1551),
    [sym_concatenation] = STATE(1552),
    [sym_string] = STATE(1546),
    [sym_simple_expansion] = STATE(1546),
    [sym_string_expansion] = STATE(1546),
    [sym_expansion] = STATE(1546),
    [sym_command_substitution] = STATE(1546),
    [sym_process_substitution] = STATE(1546),
    [aux_sym_declaration_command_repeat1] = STATE(1552),
    [aux_sym__literal_repeat1] = STATE(1553),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(3191),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_done] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [sym__special_character] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3195),
    [anon_sym_DOLLAR] = ACTIONS(3197),
    [sym_raw_string] = ACTIONS(3199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3203),
    [anon_sym_BQUOTE] = ACTIONS(3205),
    [anon_sym_LT_LPAREN] = ACTIONS(3207),
    [anon_sym_GT_LPAREN] = ACTIONS(3207),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3209),
    [sym_word] = ACTIONS(3211),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [920] = {
    [sym_concatenation] = STATE(1562),
    [sym_string] = STATE(1557),
    [sym_simple_expansion] = STATE(1557),
    [sym_string_expansion] = STATE(1557),
    [sym_expansion] = STATE(1557),
    [sym_command_substitution] = STATE(1557),
    [sym_process_substitution] = STATE(1557),
    [aux_sym_unset_command_repeat1] = STATE(1562),
    [aux_sym__literal_repeat1] = STATE(1563),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_done] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [sym__special_character] = ACTIONS(3213),
    [anon_sym_DQUOTE] = ACTIONS(3215),
    [anon_sym_DOLLAR] = ACTIONS(3217),
    [sym_raw_string] = ACTIONS(3219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3223),
    [anon_sym_BQUOTE] = ACTIONS(3225),
    [anon_sym_LT_LPAREN] = ACTIONS(3227),
    [anon_sym_GT_LPAREN] = ACTIONS(3227),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3229),
    [sym_word] = ACTIONS(3231),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [921] = {
    [aux_sym_concatenation_repeat1] = STATE(1565),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(3233),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_done] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [922] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(1568),
    [anon_sym_DQUOTE] = ACTIONS(3235),
    [anon_sym_DOLLAR] = ACTIONS(3237),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [923] = {
    [sym_string] = STATE(1570),
    [anon_sym_DASH] = ACTIONS(3239),
    [anon_sym_DQUOTE] = ACTIONS(1757),
    [anon_sym_DOLLAR] = ACTIONS(3239),
    [sym_raw_string] = ACTIONS(3241),
    [anon_sym_POUND] = ACTIONS(3239),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3243),
    [anon_sym_STAR] = ACTIONS(3245),
    [anon_sym_AT] = ACTIONS(3245),
    [anon_sym_QMARK] = ACTIONS(3245),
    [anon_sym_0] = ACTIONS(3243),
    [anon_sym__] = ACTIONS(3243),
  },
  [924] = {
    [aux_sym_concatenation_repeat1] = STATE(1565),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(3233),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_done] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [925] = {
    [sym_subscript] = STATE(1575),
    [sym_variable_name] = ACTIONS(3247),
    [anon_sym_BANG] = ACTIONS(3249),
    [anon_sym_DASH] = ACTIONS(3251),
    [anon_sym_DOLLAR] = ACTIONS(3251),
    [anon_sym_POUND] = ACTIONS(3249),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3253),
    [anon_sym_STAR] = ACTIONS(3255),
    [anon_sym_AT] = ACTIONS(3255),
    [anon_sym_QMARK] = ACTIONS(3255),
    [anon_sym_0] = ACTIONS(3253),
    [anon_sym__] = ACTIONS(3253),
  },
  [926] = {
    [sym__statements] = STATE(1576),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(1577),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [927] = {
    [sym__statements] = STATE(1578),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [928] = {
    [sym__statements] = STATE(1579),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [929] = {
    [aux_sym_concatenation_repeat1] = STATE(1565),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(3233),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_done] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [930] = {
    [anon_sym_done] = ACTIONS(3257),
    [sym_comment] = ACTIONS(57),
  },
  [931] = {
    [sym_file_redirect] = STATE(1588),
    [sym_heredoc_redirect] = STATE(1588),
    [sym_heredoc_body] = STATE(1587),
    [sym_herestring_redirect] = STATE(1588),
    [aux_sym_redirected_statement_repeat1] = STATE(1588),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(3259),
    [anon_sym_SEMI] = ACTIONS(3261),
    [anon_sym_done] = ACTIONS(399),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_SEMI_SEMI] = ACTIONS(3265),
    [anon_sym_PIPE_AMP] = ACTIONS(3267),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3271),
    [anon_sym_GT] = ACTIONS(3271),
    [anon_sym_GT_GT] = ACTIONS(3273),
    [anon_sym_AMP_GT] = ACTIONS(3271),
    [anon_sym_AMP_GT_GT] = ACTIONS(3273),
    [anon_sym_LT_AMP] = ACTIONS(3273),
    [anon_sym_GT_AMP] = ACTIONS(3273),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3275),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3265),
    [anon_sym_AMP] = ACTIONS(3261),
  },
  [932] = {
    [sym_concatenation] = STATE(1591),
    [sym_string] = STATE(1590),
    [sym_simple_expansion] = STATE(1590),
    [sym_string_expansion] = STATE(1590),
    [sym_expansion] = STATE(1590),
    [sym_command_substitution] = STATE(1590),
    [sym_process_substitution] = STATE(1590),
    [aux_sym_command_repeat2] = STATE(1591),
    [aux_sym__literal_repeat1] = STATE(1592),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_done] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(3277),
    [anon_sym_EQ_EQ] = ACTIONS(3277),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [sym__special_character] = ACTIONS(3279),
    [anon_sym_DQUOTE] = ACTIONS(1757),
    [anon_sym_DOLLAR] = ACTIONS(1759),
    [sym_raw_string] = ACTIONS(3281),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1765),
    [anon_sym_BQUOTE] = ACTIONS(1767),
    [anon_sym_LT_LPAREN] = ACTIONS(1769),
    [anon_sym_GT_LPAREN] = ACTIONS(1769),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3283),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [933] = {
    [sym_file_redirect] = STATE(1588),
    [sym_heredoc_redirect] = STATE(1588),
    [sym_heredoc_body] = STATE(1587),
    [sym_herestring_redirect] = STATE(1588),
    [aux_sym_redirected_statement_repeat1] = STATE(1588),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(3261),
    [anon_sym_done] = ACTIONS(3285),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_SEMI_SEMI] = ACTIONS(3265),
    [anon_sym_PIPE_AMP] = ACTIONS(3267),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3275),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(3265),
    [anon_sym_AMP] = ACTIONS(3261),
  },
  [934] = {
    [anon_sym_EQ] = ACTIONS(3185),
    [anon_sym_PLUS_EQ] = ACTIONS(3185),
    [sym_comment] = ACTIONS(57),
  },
  [935] = {
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_done] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [936] = {
    [sym_redirected_statement] = STATE(1593),
    [sym_for_statement] = STATE(1593),
    [sym_c_style_for_statement] = STATE(1593),
    [sym_while_statement] = STATE(1593),
    [sym_if_statement] = STATE(1593),
    [sym_case_statement] = STATE(1593),
    [sym_function_definition] = STATE(1593),
    [sym_compound_statement] = STATE(1593),
    [sym_subshell] = STATE(1593),
    [sym_pipeline] = STATE(1593),
    [sym_list] = STATE(1593),
    [sym_negated_command] = STATE(1593),
    [sym_test_command] = STATE(1593),
    [sym_declaration_command] = STATE(1593),
    [sym_unset_command] = STATE(1593),
    [sym_command] = STATE(1593),
    [sym_command_name] = STATE(932),
    [sym_variable_assignment] = STATE(1594),
    [sym_subscript] = STATE(934),
    [sym_file_redirect] = STATE(937),
    [sym_concatenation] = STATE(935),
    [sym_string] = STATE(924),
    [sym_simple_expansion] = STATE(924),
    [sym_string_expansion] = STATE(924),
    [sym_expansion] = STATE(924),
    [sym_command_substitution] = STATE(924),
    [sym_process_substitution] = STATE(924),
    [aux_sym__statements_repeat1] = STATE(251),
    [aux_sym_command_repeat1] = STATE(937),
    [aux_sym__literal_repeat1] = STATE(938),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1745),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1751),
    [anon_sym_typeset] = ACTIONS(1751),
    [anon_sym_export] = ACTIONS(1751),
    [anon_sym_readonly] = ACTIONS(1751),
    [anon_sym_local] = ACTIONS(1751),
    [anon_sym_unset] = ACTIONS(1753),
    [anon_sym_unsetenv] = ACTIONS(1753),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(1755),
    [anon_sym_DQUOTE] = ACTIONS(1757),
    [anon_sym_DOLLAR] = ACTIONS(1759),
    [sym_raw_string] = ACTIONS(1761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1765),
    [anon_sym_BQUOTE] = ACTIONS(1767),
    [anon_sym_LT_LPAREN] = ACTIONS(1769),
    [anon_sym_GT_LPAREN] = ACTIONS(1769),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1771),
  },
  [937] = {
    [sym_command_name] = STATE(1595),
    [sym_variable_assignment] = STATE(253),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(253),
    [sym_concatenation] = STATE(935),
    [sym_string] = STATE(924),
    [sym_simple_expansion] = STATE(924),
    [sym_string_expansion] = STATE(924),
    [sym_expansion] = STATE(924),
    [sym_command_substitution] = STATE(924),
    [sym_process_substitution] = STATE(924),
    [aux_sym_command_repeat1] = STATE(253),
    [aux_sym__literal_repeat1] = STATE(938),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(3279),
    [anon_sym_DQUOTE] = ACTIONS(1757),
    [anon_sym_DOLLAR] = ACTIONS(1759),
    [sym_raw_string] = ACTIONS(1761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1765),
    [anon_sym_BQUOTE] = ACTIONS(1767),
    [anon_sym_LT_LPAREN] = ACTIONS(1769),
    [anon_sym_GT_LPAREN] = ACTIONS(1769),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1761),
  },
  [938] = {
    [aux_sym__literal_repeat1] = STATE(1597),
    [sym__simple_heredoc_body] = ACTIONS(437),
    [sym__heredoc_body_beginning] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_done] = ACTIONS(439),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_EQ_TILDE] = ACTIONS(439),
    [anon_sym_EQ_EQ] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(439),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(439),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [sym__special_character] = ACTIONS(3287),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [anon_sym_DOLLAR] = ACTIONS(439),
    [sym_raw_string] = ACTIONS(437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(437),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(437),
    [anon_sym_GT_LPAREN] = ACTIONS(437),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(439),
    [anon_sym_LF] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(439),
  },
  [939] = {
    [sym_concatenation] = STATE(1599),
    [sym_string] = STATE(1598),
    [sym_simple_expansion] = STATE(1598),
    [sym_string_expansion] = STATE(1598),
    [sym_expansion] = STATE(1598),
    [sym_command_substitution] = STATE(1598),
    [sym_process_substitution] = STATE(1598),
    [aux_sym__literal_repeat1] = STATE(1600),
    [sym__special_character] = ACTIONS(1783),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(3289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3289),
  },
  [940] = {
    [sym_file_redirect] = STATE(388),
    [sym_heredoc_redirect] = STATE(388),
    [sym_herestring_redirect] = STATE(388),
    [aux_sym_redirected_statement_repeat1] = STATE(388),
    [sym_file_descriptor] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT] = ACTIONS(2566),
    [anon_sym_AMP_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_AMP] = ACTIONS(2564),
    [anon_sym_GT_AMP] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_LT_LT_DASH] = ACTIONS(2564),
    [anon_sym_LT_LT_LT] = ACTIONS(2564),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2566),
  },
  [941] = {
    [sym_file_redirect] = STATE(388),
    [sym_heredoc_redirect] = STATE(388),
    [sym_herestring_redirect] = STATE(388),
    [aux_sym_redirected_statement_repeat1] = STATE(388),
    [sym_file_descriptor] = ACTIONS(2564),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT] = ACTIONS(2566),
    [anon_sym_AMP_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_AMP] = ACTIONS(2564),
    [anon_sym_GT_AMP] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_LT_LT_DASH] = ACTIONS(2564),
    [anon_sym_LT_LT_LT] = ACTIONS(2564),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2566),
  },
  [942] = {
    [sym_file_redirect] = STATE(388),
    [sym_heredoc_redirect] = STATE(388),
    [sym_herestring_redirect] = STATE(388),
    [aux_sym_redirected_statement_repeat1] = STATE(388),
    [sym_file_descriptor] = ACTIONS(2568),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_SEMI_SEMI] = ACTIONS(2568),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_GT] = ACTIONS(2570),
    [anon_sym_GT_GT] = ACTIONS(2568),
    [anon_sym_AMP_GT] = ACTIONS(2570),
    [anon_sym_AMP_GT_GT] = ACTIONS(2568),
    [anon_sym_LT_AMP] = ACTIONS(2568),
    [anon_sym_GT_AMP] = ACTIONS(2568),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_LT_LT_DASH] = ACTIONS(2568),
    [anon_sym_LT_LT_LT] = ACTIONS(2568),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2570),
  },
  [943] = {
    [sym_file_redirect] = STATE(388),
    [sym_heredoc_redirect] = STATE(388),
    [sym_herestring_redirect] = STATE(388),
    [aux_sym_redirected_statement_repeat1] = STATE(388),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_PIPE] = ACTIONS(657),
    [anon_sym_SEMI_SEMI] = ACTIONS(2568),
    [anon_sym_PIPE_AMP] = ACTIONS(661),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_LT_LT_DASH] = ACTIONS(2568),
    [anon_sym_LT_LT_LT] = ACTIONS(2568),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2570),
  },
  [944] = {
    [aux_sym_concatenation_repeat1] = STATE(1601),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(625),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [945] = {
    [aux_sym_concatenation_repeat1] = STATE(1601),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(625),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [946] = {
    [sym_file_descriptor] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [947] = {
    [aux_sym__literal_repeat1] = STATE(1602),
    [sym_file_descriptor] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_LT_LT_DASH] = ACTIONS(1051),
    [anon_sym_LT_LT_LT] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(683),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1051),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [948] = {
    [sym_file_descriptor] = ACTIONS(2572),
    [anon_sym_SEMI] = ACTIONS(2574),
    [anon_sym_PIPE] = ACTIONS(2574),
    [anon_sym_SEMI_SEMI] = ACTIONS(2572),
    [anon_sym_PIPE_AMP] = ACTIONS(2572),
    [anon_sym_AMP_AMP] = ACTIONS(2572),
    [anon_sym_PIPE_PIPE] = ACTIONS(2572),
    [anon_sym_LT] = ACTIONS(2574),
    [anon_sym_GT] = ACTIONS(2574),
    [anon_sym_GT_GT] = ACTIONS(2572),
    [anon_sym_AMP_GT] = ACTIONS(2574),
    [anon_sym_AMP_GT_GT] = ACTIONS(2572),
    [anon_sym_LT_AMP] = ACTIONS(2572),
    [anon_sym_GT_AMP] = ACTIONS(2572),
    [anon_sym_LT_LT] = ACTIONS(2574),
    [anon_sym_LT_LT_DASH] = ACTIONS(2572),
    [anon_sym_LT_LT_LT] = ACTIONS(2572),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2572),
    [anon_sym_AMP] = ACTIONS(2574),
  },
  [949] = {
    [aux_sym_concatenation_repeat1] = STATE(1601),
    [sym_file_descriptor] = ACTIONS(2576),
    [sym__concat] = ACTIONS(625),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI_SEMI] = ACTIONS(2576),
    [anon_sym_PIPE_AMP] = ACTIONS(2576),
    [anon_sym_AMP_AMP] = ACTIONS(2576),
    [anon_sym_PIPE_PIPE] = ACTIONS(2576),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_GT] = ACTIONS(2576),
    [anon_sym_AMP_GT] = ACTIONS(2578),
    [anon_sym_AMP_GT_GT] = ACTIONS(2576),
    [anon_sym_LT_AMP] = ACTIONS(2576),
    [anon_sym_GT_AMP] = ACTIONS(2576),
    [anon_sym_LT_LT] = ACTIONS(2578),
    [anon_sym_LT_LT_DASH] = ACTIONS(2576),
    [anon_sym_LT_LT_LT] = ACTIONS(2576),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2576),
    [anon_sym_AMP] = ACTIONS(2578),
  },
  [950] = {
    [sym_file_descriptor] = ACTIONS(2576),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI_SEMI] = ACTIONS(2576),
    [anon_sym_PIPE_AMP] = ACTIONS(2576),
    [anon_sym_AMP_AMP] = ACTIONS(2576),
    [anon_sym_PIPE_PIPE] = ACTIONS(2576),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_GT] = ACTIONS(2576),
    [anon_sym_AMP_GT] = ACTIONS(2578),
    [anon_sym_AMP_GT_GT] = ACTIONS(2576),
    [anon_sym_LT_AMP] = ACTIONS(2576),
    [anon_sym_GT_AMP] = ACTIONS(2576),
    [anon_sym_LT_LT] = ACTIONS(2578),
    [anon_sym_LT_LT_DASH] = ACTIONS(2576),
    [anon_sym_LT_LT_LT] = ACTIONS(2576),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2576),
    [anon_sym_AMP] = ACTIONS(2578),
  },
  [951] = {
    [aux_sym__literal_repeat1] = STATE(1602),
    [sym_file_descriptor] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_SEMI_SEMI] = ACTIONS(2580),
    [anon_sym_PIPE_AMP] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_AMP_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_AMP] = ACTIONS(2580),
    [anon_sym_GT_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2582),
    [anon_sym_LT_LT_DASH] = ACTIONS(2580),
    [anon_sym_LT_LT_LT] = ACTIONS(2580),
    [sym__special_character] = ACTIONS(683),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2580),
    [anon_sym_AMP] = ACTIONS(2582),
  },
  [952] = {
    [sym_file_redirect] = STATE(952),
    [sym_heredoc_redirect] = STATE(952),
    [sym_herestring_redirect] = STATE(952),
    [aux_sym_redirected_statement_repeat1] = STATE(952),
    [sym_file_descriptor] = ACTIONS(3291),
    [anon_sym_SEMI] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(2595),
    [anon_sym_SEMI_SEMI] = ACTIONS(2590),
    [anon_sym_PIPE_AMP] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_GT_GT] = ACTIONS(3297),
    [anon_sym_AMP_GT] = ACTIONS(3294),
    [anon_sym_AMP_GT_GT] = ACTIONS(3297),
    [anon_sym_LT_AMP] = ACTIONS(3297),
    [anon_sym_GT_AMP] = ACTIONS(3297),
    [anon_sym_LT_LT] = ACTIONS(3300),
    [anon_sym_LT_LT_DASH] = ACTIONS(3303),
    [anon_sym_LT_LT_LT] = ACTIONS(3306),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2595),
  },
  [953] = {
    [sym_file_descriptor] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(2614),
    [anon_sym_EQ_EQ] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2612),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2612),
    [anon_sym_BQUOTE] = ACTIONS(2612),
    [anon_sym_LT_LPAREN] = ACTIONS(2612),
    [anon_sym_GT_LPAREN] = ACTIONS(2612),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2614),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [954] = {
    [aux_sym_concatenation_repeat1] = STATE(363),
    [sym_file_descriptor] = ACTIONS(2612),
    [sym__concat] = ACTIONS(625),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(2614),
    [anon_sym_EQ_EQ] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2612),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2612),
    [anon_sym_BQUOTE] = ACTIONS(2612),
    [anon_sym_LT_LPAREN] = ACTIONS(2612),
    [anon_sym_GT_LPAREN] = ACTIONS(2612),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2614),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [955] = {
    [aux_sym__literal_repeat1] = STATE(395),
    [sym_file_descriptor] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_SEMI_SEMI] = ACTIONS(2616),
    [anon_sym_PIPE_AMP] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_EQ_TILDE] = ACTIONS(2618),
    [anon_sym_EQ_EQ] = ACTIONS(2618),
    [anon_sym_LT] = ACTIONS(2618),
    [anon_sym_GT] = ACTIONS(2618),
    [anon_sym_GT_GT] = ACTIONS(2616),
    [anon_sym_AMP_GT] = ACTIONS(2618),
    [anon_sym_AMP_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_AMP] = ACTIONS(2616),
    [anon_sym_GT_AMP] = ACTIONS(2616),
    [anon_sym_LT_LT] = ACTIONS(2618),
    [anon_sym_LT_LT_DASH] = ACTIONS(2616),
    [anon_sym_LT_LT_LT] = ACTIONS(2616),
    [sym__special_character] = ACTIONS(683),
    [anon_sym_DQUOTE] = ACTIONS(2616),
    [anon_sym_DOLLAR] = ACTIONS(2618),
    [sym_raw_string] = ACTIONS(2616),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2616),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2616),
    [anon_sym_BQUOTE] = ACTIONS(2616),
    [anon_sym_LT_LPAREN] = ACTIONS(2616),
    [anon_sym_GT_LPAREN] = ACTIONS(2616),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2618),
    [anon_sym_LF] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2618),
  },
  [956] = {
    [sym_concatenation] = STATE(956),
    [sym_string] = STATE(390),
    [sym_simple_expansion] = STATE(390),
    [sym_string_expansion] = STATE(390),
    [sym_expansion] = STATE(390),
    [sym_command_substitution] = STATE(390),
    [sym_process_substitution] = STATE(390),
    [aux_sym_command_repeat2] = STATE(956),
    [aux_sym__literal_repeat1] = STATE(392),
    [sym_file_descriptor] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(3309),
    [anon_sym_EQ_EQ] = ACTIONS(3309),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(3312),
    [anon_sym_DQUOTE] = ACTIONS(3315),
    [anon_sym_DOLLAR] = ACTIONS(3318),
    [sym_raw_string] = ACTIONS(3321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3324),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3327),
    [anon_sym_BQUOTE] = ACTIONS(3330),
    [anon_sym_LT_LPAREN] = ACTIONS(3333),
    [anon_sym_GT_LPAREN] = ACTIONS(3333),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3336),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [957] = {
    [sym_concatenation] = STATE(956),
    [sym_string] = STATE(390),
    [sym_simple_expansion] = STATE(390),
    [sym_string_expansion] = STATE(390),
    [sym_expansion] = STATE(390),
    [sym_command_substitution] = STATE(390),
    [sym_process_substitution] = STATE(390),
    [aux_sym_command_repeat2] = STATE(956),
    [aux_sym__literal_repeat1] = STATE(392),
    [sym_file_descriptor] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym_PIPE] = ACTIONS(2678),
    [anon_sym_SEMI_SEMI] = ACTIONS(2676),
    [anon_sym_PIPE_AMP] = ACTIONS(2676),
    [anon_sym_AMP_AMP] = ACTIONS(2676),
    [anon_sym_PIPE_PIPE] = ACTIONS(2676),
    [anon_sym_EQ_TILDE] = ACTIONS(675),
    [anon_sym_EQ_EQ] = ACTIONS(675),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_GT] = ACTIONS(2678),
    [anon_sym_GT_GT] = ACTIONS(2676),
    [anon_sym_AMP_GT] = ACTIONS(2678),
    [anon_sym_AMP_GT_GT] = ACTIONS(2676),
    [anon_sym_LT_AMP] = ACTIONS(2676),
    [anon_sym_GT_AMP] = ACTIONS(2676),
    [anon_sym_LT_LT] = ACTIONS(2678),
    [anon_sym_LT_LT_DASH] = ACTIONS(2676),
    [anon_sym_LT_LT_LT] = ACTIONS(2676),
    [sym__special_character] = ACTIONS(677),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(679),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(681),
    [anon_sym_LF] = ACTIONS(2676),
    [anon_sym_AMP] = ACTIONS(2678),
  },
  [958] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(3339),
    [anon_sym_PLUS_EQ] = ACTIONS(3339),
    [sym_comment] = ACTIONS(57),
  },
  [959] = {
    [sym__simple_heredoc_body] = ACTIONS(3341),
    [sym__heredoc_body_beginning] = ACTIONS(3341),
    [sym_file_descriptor] = ACTIONS(3341),
    [ts_builtin_sym_end] = ACTIONS(3341),
    [anon_sym_SEMI] = ACTIONS(3343),
    [anon_sym_done] = ACTIONS(3341),
    [anon_sym_fi] = ACTIONS(3341),
    [anon_sym_elif] = ACTIONS(3341),
    [anon_sym_else] = ACTIONS(3341),
    [anon_sym_esac] = ACTIONS(3341),
    [anon_sym_PIPE] = ACTIONS(3343),
    [anon_sym_RPAREN] = ACTIONS(3341),
    [anon_sym_SEMI_SEMI] = ACTIONS(3341),
    [anon_sym_PIPE_AMP] = ACTIONS(3341),
    [anon_sym_AMP_AMP] = ACTIONS(3341),
    [anon_sym_PIPE_PIPE] = ACTIONS(3341),
    [anon_sym_LT] = ACTIONS(3343),
    [anon_sym_GT] = ACTIONS(3343),
    [anon_sym_GT_GT] = ACTIONS(3341),
    [anon_sym_AMP_GT] = ACTIONS(3343),
    [anon_sym_AMP_GT_GT] = ACTIONS(3341),
    [anon_sym_LT_AMP] = ACTIONS(3341),
    [anon_sym_GT_AMP] = ACTIONS(3341),
    [anon_sym_LT_LT] = ACTIONS(3343),
    [anon_sym_LT_LT_DASH] = ACTIONS(3341),
    [anon_sym_LT_LT_LT] = ACTIONS(3341),
    [anon_sym_BQUOTE] = ACTIONS(3341),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3341),
    [anon_sym_AMP] = ACTIONS(3343),
  },
  [960] = {
    [sym__terminated_statement] = STATE(1604),
    [sym_redirected_statement] = STATE(78),
    [sym_for_statement] = STATE(78),
    [sym_c_style_for_statement] = STATE(78),
    [sym_while_statement] = STATE(78),
    [sym_if_statement] = STATE(78),
    [sym_case_statement] = STATE(78),
    [sym_function_definition] = STATE(78),
    [sym_compound_statement] = STATE(78),
    [sym_subshell] = STATE(78),
    [sym_pipeline] = STATE(78),
    [sym_list] = STATE(78),
    [sym_negated_command] = STATE(78),
    [sym_test_command] = STATE(78),
    [sym_declaration_command] = STATE(78),
    [sym_unset_command] = STATE(78),
    [sym_command] = STATE(78),
    [sym_command_name] = STATE(79),
    [sym_variable_assignment] = STATE(80),
    [sym_subscript] = STATE(81),
    [sym_file_redirect] = STATE(83),
    [sym_concatenation] = STATE(82),
    [sym_string] = STATE(71),
    [sym_simple_expansion] = STATE(71),
    [sym_string_expansion] = STATE(71),
    [sym_expansion] = STATE(71),
    [sym_command_substitution] = STATE(71),
    [sym_process_substitution] = STATE(71),
    [aux_sym_command_repeat1] = STATE(83),
    [aux_sym__literal_repeat1] = STATE(84),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(97),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(105),
    [anon_sym_case] = ACTIONS(107),
    [anon_sym_function] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(119),
    [anon_sym_declare] = ACTIONS(121),
    [anon_sym_typeset] = ACTIONS(121),
    [anon_sym_export] = ACTIONS(121),
    [anon_sym_readonly] = ACTIONS(121),
    [anon_sym_local] = ACTIONS(121),
    [anon_sym_unset] = ACTIONS(123),
    [anon_sym_unsetenv] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(125),
    [anon_sym_DQUOTE] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(129),
    [sym_raw_string] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(137),
    [anon_sym_LT_LPAREN] = ACTIONS(139),
    [anon_sym_GT_LPAREN] = ACTIONS(139),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(141),
  },
  [961] = {
    [sym__statements] = STATE(1618),
    [sym_redirected_statement] = STATE(1619),
    [sym_for_statement] = STATE(1619),
    [sym_c_style_for_statement] = STATE(1619),
    [sym_while_statement] = STATE(1619),
    [sym_if_statement] = STATE(1619),
    [sym_case_statement] = STATE(1619),
    [sym_function_definition] = STATE(1619),
    [sym_compound_statement] = STATE(1619),
    [sym_subshell] = STATE(1619),
    [sym_pipeline] = STATE(1619),
    [sym_list] = STATE(1619),
    [sym_negated_command] = STATE(1619),
    [sym_test_command] = STATE(1619),
    [sym_declaration_command] = STATE(1619),
    [sym_unset_command] = STATE(1619),
    [sym_command] = STATE(1619),
    [sym_command_name] = STATE(1620),
    [sym_variable_assignment] = STATE(1621),
    [sym_subscript] = STATE(1622),
    [sym_file_redirect] = STATE(1625),
    [sym_concatenation] = STATE(1623),
    [sym_string] = STATE(1612),
    [sym_simple_expansion] = STATE(1612),
    [sym_string_expansion] = STATE(1612),
    [sym_expansion] = STATE(1612),
    [sym_command_substitution] = STATE(1612),
    [sym_process_substitution] = STATE(1612),
    [aux_sym__statements_repeat1] = STATE(1624),
    [aux_sym_command_repeat1] = STATE(1625),
    [aux_sym__literal_repeat1] = STATE(1626),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(3345),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_fi] = ACTIONS(3347),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(3349),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(3351),
    [anon_sym_typeset] = ACTIONS(3351),
    [anon_sym_export] = ACTIONS(3351),
    [anon_sym_readonly] = ACTIONS(3351),
    [anon_sym_local] = ACTIONS(3351),
    [anon_sym_unset] = ACTIONS(3353),
    [anon_sym_unsetenv] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3359),
    [sym_raw_string] = ACTIONS(3361),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3363),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3365),
    [anon_sym_BQUOTE] = ACTIONS(3367),
    [anon_sym_LT_LPAREN] = ACTIONS(3369),
    [anon_sym_GT_LPAREN] = ACTIONS(3369),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3371),
  },
  [962] = {
    [sym_subshell] = STATE(146),
    [sym_test_command] = STATE(146),
    [sym_command] = STATE(146),
    [sym_command_name] = STATE(977),
    [sym_variable_assignment] = STATE(983),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(983),
    [sym_concatenation] = STATE(980),
    [sym_string] = STATE(968),
    [sym_simple_expansion] = STATE(968),
    [sym_string_expansion] = STATE(968),
    [sym_expansion] = STATE(968),
    [sym_command_substitution] = STATE(968),
    [sym_process_substitution] = STATE(968),
    [aux_sym_command_repeat1] = STATE(983),
    [aux_sym__literal_repeat1] = STATE(984),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(1812),
    [anon_sym_DQUOTE] = ACTIONS(1814),
    [anon_sym_DOLLAR] = ACTIONS(1816),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1822),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1818),
  },
  [963] = {
    [sym_variable_assignment] = STATE(1637),
    [sym_subscript] = STATE(1636),
    [sym_concatenation] = STATE(1637),
    [sym_string] = STATE(1631),
    [sym_simple_expansion] = STATE(1631),
    [sym_string_expansion] = STATE(1631),
    [sym_expansion] = STATE(1631),
    [sym_command_substitution] = STATE(1631),
    [sym_process_substitution] = STATE(1631),
    [aux_sym_declaration_command_repeat1] = STATE(1637),
    [aux_sym__literal_repeat1] = STATE(1638),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(3373),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_fi] = ACTIONS(263),
    [anon_sym_elif] = ACTIONS(263),
    [anon_sym_else] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [sym__special_character] = ACTIONS(3375),
    [anon_sym_DQUOTE] = ACTIONS(3377),
    [anon_sym_DOLLAR] = ACTIONS(3379),
    [sym_raw_string] = ACTIONS(3381),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3383),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3385),
    [anon_sym_BQUOTE] = ACTIONS(3387),
    [anon_sym_LT_LPAREN] = ACTIONS(3389),
    [anon_sym_GT_LPAREN] = ACTIONS(3389),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3391),
    [sym_word] = ACTIONS(3393),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [964] = {
    [sym_concatenation] = STATE(1647),
    [sym_string] = STATE(1642),
    [sym_simple_expansion] = STATE(1642),
    [sym_string_expansion] = STATE(1642),
    [sym_expansion] = STATE(1642),
    [sym_command_substitution] = STATE(1642),
    [sym_process_substitution] = STATE(1642),
    [aux_sym_unset_command_repeat1] = STATE(1647),
    [aux_sym__literal_repeat1] = STATE(1648),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_fi] = ACTIONS(287),
    [anon_sym_elif] = ACTIONS(287),
    [anon_sym_else] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [sym__special_character] = ACTIONS(3395),
    [anon_sym_DQUOTE] = ACTIONS(3397),
    [anon_sym_DOLLAR] = ACTIONS(3399),
    [sym_raw_string] = ACTIONS(3401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3403),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3405),
    [anon_sym_BQUOTE] = ACTIONS(3407),
    [anon_sym_LT_LPAREN] = ACTIONS(3409),
    [anon_sym_GT_LPAREN] = ACTIONS(3409),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3411),
    [sym_word] = ACTIONS(3413),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [965] = {
    [aux_sym_concatenation_repeat1] = STATE(1650),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_fi] = ACTIONS(329),
    [anon_sym_elif] = ACTIONS(329),
    [anon_sym_else] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [966] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(1653),
    [anon_sym_DQUOTE] = ACTIONS(3417),
    [anon_sym_DOLLAR] = ACTIONS(3419),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [967] = {
    [sym_string] = STATE(1655),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(1814),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3423),
    [anon_sym_POUND] = ACTIONS(3421),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3425),
    [anon_sym_STAR] = ACTIONS(3427),
    [anon_sym_AT] = ACTIONS(3427),
    [anon_sym_QMARK] = ACTIONS(3427),
    [anon_sym_0] = ACTIONS(3425),
    [anon_sym__] = ACTIONS(3425),
  },
  [968] = {
    [aux_sym_concatenation_repeat1] = STATE(1650),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_fi] = ACTIONS(355),
    [anon_sym_elif] = ACTIONS(355),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [969] = {
    [sym_subscript] = STATE(1660),
    [sym_variable_name] = ACTIONS(3429),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3433),
    [anon_sym_DOLLAR] = ACTIONS(3433),
    [anon_sym_POUND] = ACTIONS(3431),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3435),
    [anon_sym_STAR] = ACTIONS(3437),
    [anon_sym_AT] = ACTIONS(3437),
    [anon_sym_QMARK] = ACTIONS(3437),
    [anon_sym_0] = ACTIONS(3435),
    [anon_sym__] = ACTIONS(3435),
  },
  [970] = {
    [sym__statements] = STATE(1661),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(1662),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [971] = {
    [sym__statements] = STATE(1663),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [972] = {
    [sym__statements] = STATE(1664),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [973] = {
    [aux_sym_concatenation_repeat1] = STATE(1650),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_fi] = ACTIONS(355),
    [anon_sym_elif] = ACTIONS(355),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [974] = {
    [sym_elif_clause] = STATE(1667),
    [sym_else_clause] = STATE(1666),
    [aux_sym_if_statement_repeat1] = STATE(1667),
    [anon_sym_fi] = ACTIONS(3439),
    [anon_sym_elif] = ACTIONS(3441),
    [anon_sym_else] = ACTIONS(3443),
    [sym_comment] = ACTIONS(57),
  },
  [975] = {
    [sym_file_redirect] = STATE(1675),
    [sym_heredoc_redirect] = STATE(1675),
    [sym_heredoc_body] = STATE(1674),
    [sym_herestring_redirect] = STATE(1675),
    [aux_sym_redirected_statement_repeat1] = STATE(1675),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(3445),
    [anon_sym_SEMI] = ACTIONS(3447),
    [anon_sym_fi] = ACTIONS(399),
    [anon_sym_elif] = ACTIONS(399),
    [anon_sym_else] = ACTIONS(399),
    [anon_sym_PIPE] = ACTIONS(3449),
    [anon_sym_SEMI_SEMI] = ACTIONS(3451),
    [anon_sym_PIPE_AMP] = ACTIONS(3453),
    [anon_sym_AMP_AMP] = ACTIONS(3455),
    [anon_sym_PIPE_PIPE] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(3457),
    [anon_sym_GT] = ACTIONS(3457),
    [anon_sym_GT_GT] = ACTIONS(3459),
    [anon_sym_AMP_GT] = ACTIONS(3457),
    [anon_sym_AMP_GT_GT] = ACTIONS(3459),
    [anon_sym_LT_AMP] = ACTIONS(3459),
    [anon_sym_GT_AMP] = ACTIONS(3459),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3461),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3451),
    [anon_sym_AMP] = ACTIONS(3447),
  },
  [976] = {
    [anon_sym_fi] = ACTIONS(3439),
    [sym_comment] = ACTIONS(57),
  },
  [977] = {
    [sym_concatenation] = STATE(1678),
    [sym_string] = STATE(1677),
    [sym_simple_expansion] = STATE(1677),
    [sym_string_expansion] = STATE(1677),
    [sym_expansion] = STATE(1677),
    [sym_command_substitution] = STATE(1677),
    [sym_process_substitution] = STATE(1677),
    [aux_sym_command_repeat2] = STATE(1678),
    [aux_sym__literal_repeat1] = STATE(1679),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_fi] = ACTIONS(423),
    [anon_sym_elif] = ACTIONS(423),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(3463),
    [anon_sym_EQ_EQ] = ACTIONS(3463),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [sym__special_character] = ACTIONS(3465),
    [anon_sym_DQUOTE] = ACTIONS(1814),
    [anon_sym_DOLLAR] = ACTIONS(1816),
    [sym_raw_string] = ACTIONS(3467),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1822),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3469),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [978] = {
    [sym_file_redirect] = STATE(1675),
    [sym_heredoc_redirect] = STATE(1675),
    [sym_heredoc_body] = STATE(1674),
    [sym_herestring_redirect] = STATE(1675),
    [aux_sym_redirected_statement_repeat1] = STATE(1675),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(3447),
    [anon_sym_fi] = ACTIONS(3285),
    [anon_sym_elif] = ACTIONS(3285),
    [anon_sym_else] = ACTIONS(3285),
    [anon_sym_PIPE] = ACTIONS(3449),
    [anon_sym_SEMI_SEMI] = ACTIONS(3451),
    [anon_sym_PIPE_AMP] = ACTIONS(3453),
    [anon_sym_AMP_AMP] = ACTIONS(3455),
    [anon_sym_PIPE_PIPE] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3461),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(3451),
    [anon_sym_AMP] = ACTIONS(3447),
  },
  [979] = {
    [anon_sym_EQ] = ACTIONS(3339),
    [anon_sym_PLUS_EQ] = ACTIONS(3339),
    [sym_comment] = ACTIONS(57),
  },
  [980] = {
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_fi] = ACTIONS(355),
    [anon_sym_elif] = ACTIONS(355),
    [anon_sym_else] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [981] = {
    [sym_redirected_statement] = STATE(1680),
    [sym_for_statement] = STATE(1680),
    [sym_c_style_for_statement] = STATE(1680),
    [sym_while_statement] = STATE(1680),
    [sym_if_statement] = STATE(1680),
    [sym_case_statement] = STATE(1680),
    [sym_function_definition] = STATE(1680),
    [sym_compound_statement] = STATE(1680),
    [sym_subshell] = STATE(1680),
    [sym_pipeline] = STATE(1680),
    [sym_list] = STATE(1680),
    [sym_negated_command] = STATE(1680),
    [sym_test_command] = STATE(1680),
    [sym_declaration_command] = STATE(1680),
    [sym_unset_command] = STATE(1680),
    [sym_command] = STATE(1680),
    [sym_command_name] = STATE(977),
    [sym_variable_assignment] = STATE(1681),
    [sym_subscript] = STATE(979),
    [sym_file_redirect] = STATE(983),
    [sym_concatenation] = STATE(980),
    [sym_string] = STATE(968),
    [sym_simple_expansion] = STATE(968),
    [sym_string_expansion] = STATE(968),
    [sym_expansion] = STATE(968),
    [sym_command_substitution] = STATE(968),
    [sym_process_substitution] = STATE(968),
    [aux_sym__statements_repeat1] = STATE(251),
    [aux_sym_command_repeat1] = STATE(983),
    [aux_sym__literal_repeat1] = STATE(984),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1798),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1808),
    [anon_sym_typeset] = ACTIONS(1808),
    [anon_sym_export] = ACTIONS(1808),
    [anon_sym_readonly] = ACTIONS(1808),
    [anon_sym_local] = ACTIONS(1808),
    [anon_sym_unset] = ACTIONS(1810),
    [anon_sym_unsetenv] = ACTIONS(1810),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(1812),
    [anon_sym_DQUOTE] = ACTIONS(1814),
    [anon_sym_DOLLAR] = ACTIONS(1816),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1822),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1828),
  },
  [982] = {
    [sym_elif_clause] = STATE(1682),
    [sym_else_clause] = STATE(1666),
    [aux_sym_if_statement_repeat1] = STATE(1682),
    [anon_sym_fi] = ACTIONS(3439),
    [anon_sym_elif] = ACTIONS(3441),
    [anon_sym_else] = ACTIONS(3443),
    [sym_comment] = ACTIONS(57),
  },
  [983] = {
    [sym_command_name] = STATE(1683),
    [sym_variable_assignment] = STATE(253),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(253),
    [sym_concatenation] = STATE(980),
    [sym_string] = STATE(968),
    [sym_simple_expansion] = STATE(968),
    [sym_string_expansion] = STATE(968),
    [sym_expansion] = STATE(968),
    [sym_command_substitution] = STATE(968),
    [sym_process_substitution] = STATE(968),
    [aux_sym_command_repeat1] = STATE(253),
    [aux_sym__literal_repeat1] = STATE(984),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(3465),
    [anon_sym_DQUOTE] = ACTIONS(1814),
    [anon_sym_DOLLAR] = ACTIONS(1816),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1822),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1818),
  },
  [984] = {
    [aux_sym__literal_repeat1] = STATE(1685),
    [sym__simple_heredoc_body] = ACTIONS(437),
    [sym__heredoc_body_beginning] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_fi] = ACTIONS(439),
    [anon_sym_elif] = ACTIONS(439),
    [anon_sym_else] = ACTIONS(439),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_EQ_TILDE] = ACTIONS(439),
    [anon_sym_EQ_EQ] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(439),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(439),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [sym__special_character] = ACTIONS(3471),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [anon_sym_DOLLAR] = ACTIONS(439),
    [sym_raw_string] = ACTIONS(437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(437),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(437),
    [anon_sym_GT_LPAREN] = ACTIONS(437),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(439),
    [anon_sym_LF] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(439),
  },
  [985] = {
    [sym__concat] = ACTIONS(2344),
    [anon_sym_in] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
  },
  [986] = {
    [aux_sym_concatenation_repeat1] = STATE(986),
    [sym__concat] = ACTIONS(3473),
    [anon_sym_in] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
  },
  [987] = {
    [sym__concat] = ACTIONS(2351),
    [anon_sym_in] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2351),
  },
  [988] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [989] = {
    [sym_case_item] = STATE(1692),
    [sym_last_case_item] = STATE(1690),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(1692),
    [aux_sym__literal_repeat1] = STATE(1693),
    [anon_sym_esac] = ACTIONS(3478),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3484),
  },
  [990] = {
    [anon_sym_SEMI] = ACTIONS(3486),
    [anon_sym_SEMI_SEMI] = ACTIONS(3488),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3488),
    [anon_sym_AMP] = ACTIONS(3488),
  },
  [991] = {
    [sym_concatenation] = STATE(1697),
    [sym_string] = STATE(1696),
    [sym_simple_expansion] = STATE(1696),
    [sym_string_expansion] = STATE(1696),
    [sym_expansion] = STATE(1696),
    [sym_command_substitution] = STATE(1696),
    [sym_process_substitution] = STATE(1696),
    [aux_sym__literal_repeat1] = STATE(1698),
    [anon_sym_RBRACE] = ACTIONS(3490),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(3492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3492),
  },
  [992] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(3494),
    [sym_comment] = ACTIONS(57),
  },
  [993] = {
    [sym_concatenation] = STATE(1702),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1702),
    [anon_sym_RBRACE] = ACTIONS(3496),
    [anon_sym_EQ] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3498),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(3502),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_COLON_QMARK] = ACTIONS(3498),
    [anon_sym_COLON_DASH] = ACTIONS(3498),
    [anon_sym_PERCENT] = ACTIONS(3498),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [994] = {
    [sym_concatenation] = STATE(1704),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1704),
    [anon_sym_RBRACE] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(3504),
    [anon_sym_DASH] = ACTIONS(3504),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(3508),
    [anon_sym_COLON] = ACTIONS(3504),
    [anon_sym_COLON_QMARK] = ACTIONS(3504),
    [anon_sym_COLON_DASH] = ACTIONS(3504),
    [anon_sym_PERCENT] = ACTIONS(3504),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [995] = {
    [sym__concat] = ACTIONS(2442),
    [anon_sym_in] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2442),
  },
  [996] = {
    [sym_concatenation] = STATE(1707),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1707),
    [sym_regex] = ACTIONS(3510),
    [anon_sym_RBRACE] = ACTIONS(3512),
    [anon_sym_EQ] = ACTIONS(3514),
    [anon_sym_DASH] = ACTIONS(3514),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3516),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(3514),
    [anon_sym_COLON_QMARK] = ACTIONS(3514),
    [anon_sym_COLON_DASH] = ACTIONS(3514),
    [anon_sym_PERCENT] = ACTIONS(3514),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [997] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(3512),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [998] = {
    [sym__concat] = ACTIONS(2492),
    [anon_sym_in] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2492),
  },
  [999] = {
    [sym_concatenation] = STATE(1704),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1704),
    [sym_regex] = ACTIONS(3518),
    [anon_sym_RBRACE] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(3504),
    [anon_sym_DASH] = ACTIONS(3504),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(3504),
    [anon_sym_COLON_QMARK] = ACTIONS(3504),
    [anon_sym_COLON_DASH] = ACTIONS(3504),
    [anon_sym_PERCENT] = ACTIONS(3504),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1000] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1001] = {
    [sym__concat] = ACTIONS(2500),
    [anon_sym_in] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2500),
  },
  [1002] = {
    [sym__concat] = ACTIONS(2534),
    [anon_sym_in] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2534),
  },
  [1003] = {
    [sym_case_item] = STATE(1711),
    [sym_last_case_item] = STATE(1710),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(1711),
    [aux_sym__literal_repeat1] = STATE(1693),
    [anon_sym_esac] = ACTIONS(3520),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3484),
  },
  [1004] = {
    [anon_sym_SEMI] = ACTIONS(3522),
    [anon_sym_SEMI_SEMI] = ACTIONS(3524),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3524),
    [anon_sym_AMP] = ACTIONS(3524),
  },
  [1005] = {
    [sym_compound_statement] = STATE(1713),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [1006] = {
    [aux_sym_concatenation_repeat1] = STATE(1714),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(1420),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_RPAREN] = ACTIONS(325),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [1007] = {
    [aux_sym_concatenation_repeat1] = STATE(1714),
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym__concat] = ACTIONS(1420),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_RPAREN] = ACTIONS(1398),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [1008] = {
    [aux_sym__literal_repeat1] = STATE(1715),
    [sym__simple_heredoc_body] = ACTIONS(1444),
    [sym__heredoc_body_beginning] = ACTIONS(1444),
    [sym_file_descriptor] = ACTIONS(1444),
    [sym_variable_name] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1446),
    [anon_sym_RPAREN] = ACTIONS(1444),
    [anon_sym_SEMI_SEMI] = ACTIONS(1444),
    [anon_sym_PIPE_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1446),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_AMP_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT_GT] = ACTIONS(1444),
    [anon_sym_LT_AMP] = ACTIONS(1444),
    [anon_sym_GT_AMP] = ACTIONS(1444),
    [anon_sym_LT_LT] = ACTIONS(1446),
    [anon_sym_LT_LT_DASH] = ACTIONS(1444),
    [anon_sym_LT_LT_LT] = ACTIONS(1444),
    [sym__special_character] = ACTIONS(1448),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [anon_sym_DOLLAR] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1444),
    [anon_sym_BQUOTE] = ACTIONS(1444),
    [anon_sym_LT_LPAREN] = ACTIONS(1444),
    [anon_sym_GT_LPAREN] = ACTIONS(1444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1446),
    [anon_sym_LF] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1446),
  },
  [1009] = {
    [sym_concatenation] = STATE(1163),
    [sym_string] = STATE(1716),
    [sym_array] = STATE(1163),
    [sym_simple_expansion] = STATE(1716),
    [sym_string_expansion] = STATE(1716),
    [sym_expansion] = STATE(1716),
    [sym_command_substitution] = STATE(1716),
    [sym_process_substitution] = STATE(1716),
    [aux_sym__literal_repeat1] = STATE(1717),
    [sym__empty_value] = ACTIONS(2150),
    [anon_sym_LPAREN] = ACTIONS(2152),
    [sym__special_character] = ACTIONS(731),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(3526),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3526),
  },
  [1010] = {
    [aux_sym_concatenation_repeat1] = STATE(1718),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(943),
    [sym_variable_name] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_RPAREN] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1061),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [1011] = {
    [sym_variable_assignment] = STATE(1011),
    [sym_subscript] = STATE(425),
    [sym_concatenation] = STATE(1011),
    [sym_string] = STATE(424),
    [sym_simple_expansion] = STATE(424),
    [sym_string_expansion] = STATE(424),
    [sym_expansion] = STATE(424),
    [sym_command_substitution] = STATE(424),
    [sym_process_substitution] = STATE(424),
    [aux_sym_declaration_command_repeat1] = STATE(1011),
    [aux_sym__literal_repeat1] = STATE(427),
    [sym__simple_heredoc_body] = ACTIONS(2192),
    [sym__heredoc_body_beginning] = ACTIONS(2192),
    [sym_file_descriptor] = ACTIONS(2192),
    [sym_variable_name] = ACTIONS(3528),
    [anon_sym_SEMI] = ACTIONS(2197),
    [anon_sym_PIPE] = ACTIONS(2197),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [anon_sym_SEMI_SEMI] = ACTIONS(2192),
    [anon_sym_PIPE_AMP] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_GT] = ACTIONS(2197),
    [anon_sym_GT_GT] = ACTIONS(2192),
    [anon_sym_AMP_GT] = ACTIONS(2197),
    [anon_sym_AMP_GT_GT] = ACTIONS(2192),
    [anon_sym_LT_AMP] = ACTIONS(2192),
    [anon_sym_GT_AMP] = ACTIONS(2192),
    [anon_sym_LT_LT] = ACTIONS(2197),
    [anon_sym_LT_LT_DASH] = ACTIONS(2192),
    [anon_sym_LT_LT_LT] = ACTIONS(2192),
    [sym__special_character] = ACTIONS(3531),
    [anon_sym_DQUOTE] = ACTIONS(2202),
    [anon_sym_DOLLAR] = ACTIONS(2205),
    [sym_raw_string] = ACTIONS(3534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2214),
    [anon_sym_BQUOTE] = ACTIONS(2217),
    [anon_sym_LT_LPAREN] = ACTIONS(2220),
    [anon_sym_GT_LPAREN] = ACTIONS(2220),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3537),
    [sym_word] = ACTIONS(3540),
    [anon_sym_LF] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2197),
  },
  [1012] = {
    [aux_sym__literal_repeat1] = STATE(1012),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym_variable_name] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_RPAREN] = ACTIONS(1371),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(2229),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1373),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1013] = {
    [aux_sym_concatenation_repeat1] = STATE(1719),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(983),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_RPAREN] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1061),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [1014] = {
    [sym_concatenation] = STATE(1014),
    [sym_string] = STATE(429),
    [sym_simple_expansion] = STATE(429),
    [sym_string_expansion] = STATE(429),
    [sym_expansion] = STATE(429),
    [sym_command_substitution] = STATE(429),
    [sym_process_substitution] = STATE(429),
    [aux_sym_unset_command_repeat1] = STATE(1014),
    [aux_sym__literal_repeat1] = STATE(431),
    [sym__simple_heredoc_body] = ACTIONS(2268),
    [sym__heredoc_body_beginning] = ACTIONS(2268),
    [sym_file_descriptor] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2270),
    [anon_sym_RPAREN] = ACTIONS(2268),
    [anon_sym_SEMI_SEMI] = ACTIONS(2268),
    [anon_sym_PIPE_AMP] = ACTIONS(2268),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [anon_sym_PIPE_PIPE] = ACTIONS(2268),
    [anon_sym_LT] = ACTIONS(2270),
    [anon_sym_GT] = ACTIONS(2270),
    [anon_sym_GT_GT] = ACTIONS(2268),
    [anon_sym_AMP_GT] = ACTIONS(2270),
    [anon_sym_AMP_GT_GT] = ACTIONS(2268),
    [anon_sym_LT_AMP] = ACTIONS(2268),
    [anon_sym_GT_AMP] = ACTIONS(2268),
    [anon_sym_LT_LT] = ACTIONS(2270),
    [anon_sym_LT_LT_DASH] = ACTIONS(2268),
    [anon_sym_LT_LT_LT] = ACTIONS(2268),
    [sym__special_character] = ACTIONS(3543),
    [anon_sym_DQUOTE] = ACTIONS(2275),
    [anon_sym_DOLLAR] = ACTIONS(2278),
    [sym_raw_string] = ACTIONS(3546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2287),
    [anon_sym_BQUOTE] = ACTIONS(2290),
    [anon_sym_LT_LPAREN] = ACTIONS(2293),
    [anon_sym_GT_LPAREN] = ACTIONS(2293),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3549),
    [sym_word] = ACTIONS(3552),
    [anon_sym_LF] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2270),
  },
  [1015] = {
    [aux_sym__literal_repeat1] = STATE(1015),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_RPAREN] = ACTIONS(1371),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(2302),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1373),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1016] = {
    [aux_sym_concatenation_repeat1] = STATE(1016),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2348),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_RPAREN] = ACTIONS(2344),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2346),
    [anon_sym_EQ_EQ] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1017] = {
    [sym_concatenation] = STATE(1318),
    [sym_string] = STATE(1720),
    [sym_simple_expansion] = STATE(1720),
    [sym_string_expansion] = STATE(1720),
    [sym_expansion] = STATE(1720),
    [sym_command_substitution] = STATE(1720),
    [sym_process_substitution] = STATE(1720),
    [aux_sym__literal_repeat1] = STATE(1721),
    [sym__special_character] = ACTIONS(1905),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(3555),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3555),
  },
  [1018] = {
    [sym_file_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [sym_herestring_redirect] = STATE(439),
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym__simple_heredoc_body] = ACTIONS(2564),
    [sym__heredoc_body_beginning] = ACTIONS(2564),
    [sym_file_descriptor] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_RPAREN] = ACTIONS(2564),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT] = ACTIONS(2566),
    [anon_sym_AMP_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_AMP] = ACTIONS(2564),
    [anon_sym_GT_AMP] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_LT_LT_DASH] = ACTIONS(2564),
    [anon_sym_LT_LT_LT] = ACTIONS(2564),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2566),
  },
  [1019] = {
    [sym_file_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [sym_herestring_redirect] = STATE(439),
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym__simple_heredoc_body] = ACTIONS(2564),
    [sym__heredoc_body_beginning] = ACTIONS(2564),
    [sym_file_descriptor] = ACTIONS(2564),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_RPAREN] = ACTIONS(2564),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT] = ACTIONS(2566),
    [anon_sym_AMP_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_AMP] = ACTIONS(2564),
    [anon_sym_GT_AMP] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_LT_LT_DASH] = ACTIONS(2564),
    [anon_sym_LT_LT_LT] = ACTIONS(2564),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2566),
  },
  [1020] = {
    [sym_file_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [sym_herestring_redirect] = STATE(439),
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym__simple_heredoc_body] = ACTIONS(2568),
    [sym__heredoc_body_beginning] = ACTIONS(2568),
    [sym_file_descriptor] = ACTIONS(2568),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(2568),
    [anon_sym_SEMI_SEMI] = ACTIONS(2568),
    [anon_sym_PIPE_AMP] = ACTIONS(753),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_GT] = ACTIONS(2570),
    [anon_sym_GT_GT] = ACTIONS(2568),
    [anon_sym_AMP_GT] = ACTIONS(2570),
    [anon_sym_AMP_GT_GT] = ACTIONS(2568),
    [anon_sym_LT_AMP] = ACTIONS(2568),
    [anon_sym_GT_AMP] = ACTIONS(2568),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_LT_LT_DASH] = ACTIONS(2568),
    [anon_sym_LT_LT_LT] = ACTIONS(2568),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2570),
  },
  [1021] = {
    [sym_file_redirect] = STATE(439),
    [sym_heredoc_redirect] = STATE(439),
    [sym_herestring_redirect] = STATE(439),
    [aux_sym_redirected_statement_repeat1] = STATE(439),
    [sym__simple_heredoc_body] = ACTIONS(2568),
    [sym__heredoc_body_beginning] = ACTIONS(2568),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_PIPE] = ACTIONS(751),
    [anon_sym_RPAREN] = ACTIONS(2568),
    [anon_sym_SEMI_SEMI] = ACTIONS(2568),
    [anon_sym_PIPE_AMP] = ACTIONS(753),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_LT_LT_DASH] = ACTIONS(2568),
    [anon_sym_LT_LT_LT] = ACTIONS(2568),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2570),
  },
  [1022] = {
    [aux_sym_concatenation_repeat1] = STATE(1722),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_RPAREN] = ACTIONS(325),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [1023] = {
    [aux_sym_concatenation_repeat1] = STATE(1722),
    [sym__simple_heredoc_body] = ACTIONS(1037),
    [sym__heredoc_body_beginning] = ACTIONS(1037),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_RPAREN] = ACTIONS(1037),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [1024] = {
    [aux_sym__literal_repeat1] = STATE(1723),
    [sym__simple_heredoc_body] = ACTIONS(1051),
    [sym__heredoc_body_beginning] = ACTIONS(1051),
    [sym_file_descriptor] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_RPAREN] = ACTIONS(1051),
    [anon_sym_SEMI_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_LT_LT_DASH] = ACTIONS(1051),
    [anon_sym_LT_LT_LT] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(441),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1051),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [1025] = {
    [aux_sym_concatenation_repeat1] = STATE(1722),
    [sym__simple_heredoc_body] = ACTIONS(2576),
    [sym__heredoc_body_beginning] = ACTIONS(2576),
    [sym_file_descriptor] = ACTIONS(2576),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_RPAREN] = ACTIONS(2576),
    [anon_sym_SEMI_SEMI] = ACTIONS(2576),
    [anon_sym_PIPE_AMP] = ACTIONS(2576),
    [anon_sym_AMP_AMP] = ACTIONS(2576),
    [anon_sym_PIPE_PIPE] = ACTIONS(2576),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_GT] = ACTIONS(2576),
    [anon_sym_AMP_GT] = ACTIONS(2578),
    [anon_sym_AMP_GT_GT] = ACTIONS(2576),
    [anon_sym_LT_AMP] = ACTIONS(2576),
    [anon_sym_GT_AMP] = ACTIONS(2576),
    [anon_sym_LT_LT] = ACTIONS(2578),
    [anon_sym_LT_LT_DASH] = ACTIONS(2576),
    [anon_sym_LT_LT_LT] = ACTIONS(2576),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2576),
    [anon_sym_AMP] = ACTIONS(2578),
  },
  [1026] = {
    [aux_sym__literal_repeat1] = STATE(1723),
    [sym__simple_heredoc_body] = ACTIONS(2580),
    [sym__heredoc_body_beginning] = ACTIONS(2580),
    [sym_file_descriptor] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_RPAREN] = ACTIONS(2580),
    [anon_sym_SEMI_SEMI] = ACTIONS(2580),
    [anon_sym_PIPE_AMP] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_AMP_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_AMP] = ACTIONS(2580),
    [anon_sym_GT_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2582),
    [anon_sym_LT_LT_DASH] = ACTIONS(2580),
    [anon_sym_LT_LT_LT] = ACTIONS(2580),
    [sym__special_character] = ACTIONS(441),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2580),
    [anon_sym_AMP] = ACTIONS(2582),
  },
  [1027] = {
    [sym_file_redirect] = STATE(1027),
    [sym_heredoc_redirect] = STATE(1027),
    [sym_herestring_redirect] = STATE(1027),
    [aux_sym_redirected_statement_repeat1] = STATE(1027),
    [sym__simple_heredoc_body] = ACTIONS(2590),
    [sym__heredoc_body_beginning] = ACTIONS(2590),
    [sym_file_descriptor] = ACTIONS(3557),
    [anon_sym_SEMI] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(2595),
    [anon_sym_RPAREN] = ACTIONS(2590),
    [anon_sym_SEMI_SEMI] = ACTIONS(2590),
    [anon_sym_PIPE_AMP] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(3560),
    [anon_sym_GT] = ACTIONS(3560),
    [anon_sym_GT_GT] = ACTIONS(3563),
    [anon_sym_AMP_GT] = ACTIONS(3560),
    [anon_sym_AMP_GT_GT] = ACTIONS(3563),
    [anon_sym_LT_AMP] = ACTIONS(3563),
    [anon_sym_GT_AMP] = ACTIONS(3563),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_LT_LT_DASH] = ACTIONS(2606),
    [anon_sym_LT_LT_LT] = ACTIONS(3566),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2595),
  },
  [1028] = {
    [aux_sym_concatenation_repeat1] = STATE(432),
    [sym__simple_heredoc_body] = ACTIONS(2612),
    [sym__heredoc_body_beginning] = ACTIONS(2612),
    [sym_file_descriptor] = ACTIONS(2612),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_RPAREN] = ACTIONS(2612),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(2614),
    [anon_sym_EQ_EQ] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2612),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2612),
    [anon_sym_BQUOTE] = ACTIONS(2612),
    [anon_sym_LT_LPAREN] = ACTIONS(2612),
    [anon_sym_GT_LPAREN] = ACTIONS(2612),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2614),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [1029] = {
    [aux_sym__literal_repeat1] = STATE(447),
    [sym__simple_heredoc_body] = ACTIONS(2616),
    [sym__heredoc_body_beginning] = ACTIONS(2616),
    [sym_file_descriptor] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_RPAREN] = ACTIONS(2616),
    [anon_sym_SEMI_SEMI] = ACTIONS(2616),
    [anon_sym_PIPE_AMP] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_EQ_TILDE] = ACTIONS(2618),
    [anon_sym_EQ_EQ] = ACTIONS(2618),
    [anon_sym_LT] = ACTIONS(2618),
    [anon_sym_GT] = ACTIONS(2618),
    [anon_sym_GT_GT] = ACTIONS(2616),
    [anon_sym_AMP_GT] = ACTIONS(2618),
    [anon_sym_AMP_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_AMP] = ACTIONS(2616),
    [anon_sym_GT_AMP] = ACTIONS(2616),
    [anon_sym_LT_LT] = ACTIONS(2618),
    [anon_sym_LT_LT_DASH] = ACTIONS(2616),
    [anon_sym_LT_LT_LT] = ACTIONS(2616),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(2616),
    [anon_sym_DOLLAR] = ACTIONS(2618),
    [sym_raw_string] = ACTIONS(2616),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2616),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2616),
    [anon_sym_BQUOTE] = ACTIONS(2616),
    [anon_sym_LT_LPAREN] = ACTIONS(2616),
    [anon_sym_GT_LPAREN] = ACTIONS(2616),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2618),
    [anon_sym_LF] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2618),
  },
  [1030] = {
    [sym_concatenation] = STATE(1030),
    [sym_string] = STATE(441),
    [sym_simple_expansion] = STATE(441),
    [sym_string_expansion] = STATE(441),
    [sym_expansion] = STATE(441),
    [sym_command_substitution] = STATE(441),
    [sym_process_substitution] = STATE(441),
    [aux_sym_command_repeat2] = STATE(1030),
    [aux_sym__literal_repeat1] = STATE(443),
    [sym__simple_heredoc_body] = ACTIONS(2612),
    [sym__heredoc_body_beginning] = ACTIONS(2612),
    [sym_file_descriptor] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_RPAREN] = ACTIONS(2612),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(3569),
    [anon_sym_EQ_EQ] = ACTIONS(3569),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(3572),
    [anon_sym_DQUOTE] = ACTIONS(2626),
    [anon_sym_DOLLAR] = ACTIONS(2629),
    [sym_raw_string] = ACTIONS(3575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2638),
    [anon_sym_BQUOTE] = ACTIONS(2641),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3578),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [1031] = {
    [sym_concatenation] = STATE(1030),
    [sym_string] = STATE(441),
    [sym_simple_expansion] = STATE(441),
    [sym_string_expansion] = STATE(441),
    [sym_expansion] = STATE(441),
    [sym_command_substitution] = STATE(441),
    [sym_process_substitution] = STATE(441),
    [aux_sym_command_repeat2] = STATE(1030),
    [aux_sym__literal_repeat1] = STATE(443),
    [sym__simple_heredoc_body] = ACTIONS(2676),
    [sym__heredoc_body_beginning] = ACTIONS(2676),
    [sym_file_descriptor] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym_PIPE] = ACTIONS(2678),
    [anon_sym_RPAREN] = ACTIONS(2676),
    [anon_sym_SEMI_SEMI] = ACTIONS(2676),
    [anon_sym_PIPE_AMP] = ACTIONS(2676),
    [anon_sym_AMP_AMP] = ACTIONS(2676),
    [anon_sym_PIPE_PIPE] = ACTIONS(2676),
    [anon_sym_EQ_TILDE] = ACTIONS(763),
    [anon_sym_EQ_EQ] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_GT] = ACTIONS(2678),
    [anon_sym_GT_GT] = ACTIONS(2676),
    [anon_sym_AMP_GT] = ACTIONS(2678),
    [anon_sym_AMP_GT_GT] = ACTIONS(2676),
    [anon_sym_LT_AMP] = ACTIONS(2676),
    [anon_sym_GT_AMP] = ACTIONS(2676),
    [anon_sym_LT_LT] = ACTIONS(2678),
    [anon_sym_LT_LT_DASH] = ACTIONS(2676),
    [anon_sym_LT_LT_LT] = ACTIONS(2676),
    [sym__special_character] = ACTIONS(765),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(769),
    [anon_sym_LF] = ACTIONS(2676),
    [anon_sym_AMP] = ACTIONS(2678),
  },
  [1032] = {
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_RBRACE] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [1033] = {
    [sym_concatenation] = STATE(1725),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(1725),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(3581),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [1034] = {
    [aux_sym_concatenation_repeat1] = STATE(1727),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(3583),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(329),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [1035] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(1730),
    [anon_sym_DQUOTE] = ACTIONS(3585),
    [anon_sym_DOLLAR] = ACTIONS(3587),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1036] = {
    [sym_string] = STATE(1732),
    [anon_sym_DASH] = ACTIONS(3589),
    [anon_sym_DQUOTE] = ACTIONS(1919),
    [anon_sym_DOLLAR] = ACTIONS(3589),
    [sym_raw_string] = ACTIONS(3591),
    [anon_sym_POUND] = ACTIONS(3589),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3593),
    [anon_sym_STAR] = ACTIONS(3595),
    [anon_sym_AT] = ACTIONS(3595),
    [anon_sym_QMARK] = ACTIONS(3595),
    [anon_sym_0] = ACTIONS(3593),
    [anon_sym__] = ACTIONS(3593),
  },
  [1037] = {
    [aux_sym_concatenation_repeat1] = STATE(1727),
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym__concat] = ACTIONS(3583),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_RBRACE] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [1038] = {
    [sym_subscript] = STATE(1737),
    [sym_variable_name] = ACTIONS(3597),
    [anon_sym_BANG] = ACTIONS(3599),
    [anon_sym_DASH] = ACTIONS(3601),
    [anon_sym_DOLLAR] = ACTIONS(3601),
    [anon_sym_POUND] = ACTIONS(3599),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3603),
    [anon_sym_STAR] = ACTIONS(3605),
    [anon_sym_AT] = ACTIONS(3605),
    [anon_sym_QMARK] = ACTIONS(3605),
    [anon_sym_0] = ACTIONS(3603),
    [anon_sym__] = ACTIONS(3603),
  },
  [1039] = {
    [sym__statements] = STATE(1738),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(1739),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1040] = {
    [sym__statements] = STATE(1740),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1041] = {
    [sym__statements] = STATE(1741),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1042] = {
    [aux_sym__literal_repeat1] = STATE(1743),
    [sym__simple_heredoc_body] = ACTIONS(1444),
    [sym__heredoc_body_beginning] = ACTIONS(1444),
    [sym_file_descriptor] = ACTIONS(1444),
    [sym_variable_name] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1446),
    [anon_sym_SEMI_SEMI] = ACTIONS(1444),
    [anon_sym_RBRACE] = ACTIONS(1444),
    [anon_sym_PIPE_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1446),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_AMP_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT_GT] = ACTIONS(1444),
    [anon_sym_LT_AMP] = ACTIONS(1444),
    [anon_sym_GT_AMP] = ACTIONS(1444),
    [anon_sym_LT_LT] = ACTIONS(1446),
    [anon_sym_LT_LT_DASH] = ACTIONS(1444),
    [anon_sym_LT_LT_LT] = ACTIONS(1444),
    [sym__special_character] = ACTIONS(3607),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [anon_sym_DOLLAR] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1444),
    [anon_sym_BQUOTE] = ACTIONS(1444),
    [anon_sym_LT_LPAREN] = ACTIONS(1444),
    [anon_sym_GT_LPAREN] = ACTIONS(1444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1446),
    [anon_sym_LF] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1446),
  },
  [1043] = {
    [sym__expression] = STATE(1745),
    [sym_binary_expression] = STATE(1745),
    [sym_unary_expression] = STATE(1745),
    [sym_postfix_expression] = STATE(1745),
    [sym_parenthesized_expression] = STATE(1745),
    [sym_concatenation] = STATE(1745),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [anon_sym_SEMI] = ACTIONS(3609),
    [anon_sym_SEMI_SEMI] = ACTIONS(3611),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [sym__special_character] = ACTIONS(477),
    [anon_sym_DQUOTE] = ACTIONS(479),
    [anon_sym_DOLLAR] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
    [anon_sym_LF] = ACTIONS(3611),
    [anon_sym_AMP] = ACTIONS(3611),
  },
  [1044] = {
    [anon_sym_SEMI] = ACTIONS(3613),
    [anon_sym_SEMI_SEMI] = ACTIONS(3615),
    [anon_sym_AMP_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1482),
    [anon_sym_EQ_TILDE] = ACTIONS(1484),
    [anon_sym_EQ_EQ] = ACTIONS(1484),
    [anon_sym_EQ] = ACTIONS(1486),
    [anon_sym_PLUS_EQ] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(1486),
    [anon_sym_GT] = ACTIONS(1486),
    [anon_sym_BANG_EQ] = ACTIONS(1482),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_DASH_EQ] = ACTIONS(1482),
    [anon_sym_LT_EQ] = ACTIONS(1482),
    [anon_sym_GT_EQ] = ACTIONS(1482),
    [anon_sym_PLUS_PLUS] = ACTIONS(1488),
    [anon_sym_DASH_DASH] = ACTIONS(1488),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1482),
    [anon_sym_LF] = ACTIONS(3615),
    [anon_sym_AMP] = ACTIONS(3613),
  },
  [1045] = {
    [sym_concatenation] = STATE(1747),
    [sym_string] = STATE(783),
    [sym_simple_expansion] = STATE(783),
    [sym_string_expansion] = STATE(783),
    [sym_expansion] = STATE(783),
    [sym_command_substitution] = STATE(783),
    [sym_process_substitution] = STATE(783),
    [aux_sym_for_statement_repeat1] = STATE(1747),
    [aux_sym__literal_repeat1] = STATE(789),
    [sym__special_character] = ACTIONS(1492),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [anon_sym_DOLLAR] = ACTIONS(1496),
    [sym_raw_string] = ACTIONS(1498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1502),
    [anon_sym_BQUOTE] = ACTIONS(1504),
    [anon_sym_LT_LPAREN] = ACTIONS(1506),
    [anon_sym_GT_LPAREN] = ACTIONS(1506),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1498),
  },
  [1046] = {
    [sym_do_group] = STATE(1748),
    [anon_sym_do] = ACTIONS(1945),
    [sym_comment] = ACTIONS(57),
  },
  [1047] = {
    [sym__simple_heredoc_body] = ACTIONS(1582),
    [sym__heredoc_body_beginning] = ACTIONS(1582),
    [sym_file_descriptor] = ACTIONS(1582),
    [anon_sym_SEMI] = ACTIONS(1584),
    [anon_sym_PIPE] = ACTIONS(1584),
    [anon_sym_SEMI_SEMI] = ACTIONS(1582),
    [anon_sym_RBRACE] = ACTIONS(1582),
    [anon_sym_PIPE_AMP] = ACTIONS(1582),
    [anon_sym_AMP_AMP] = ACTIONS(1582),
    [anon_sym_PIPE_PIPE] = ACTIONS(1582),
    [anon_sym_LT] = ACTIONS(1584),
    [anon_sym_GT] = ACTIONS(1584),
    [anon_sym_GT_GT] = ACTIONS(1582),
    [anon_sym_AMP_GT] = ACTIONS(1584),
    [anon_sym_AMP_GT_GT] = ACTIONS(1582),
    [anon_sym_LT_AMP] = ACTIONS(1582),
    [anon_sym_GT_AMP] = ACTIONS(1582),
    [anon_sym_LT_LT] = ACTIONS(1584),
    [anon_sym_LT_LT_DASH] = ACTIONS(1582),
    [anon_sym_LT_LT_LT] = ACTIONS(1582),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1582),
    [anon_sym_AMP] = ACTIONS(1584),
  },
  [1048] = {
    [sym__statements] = STATE(1750),
    [sym_redirected_statement] = STATE(931),
    [sym_for_statement] = STATE(931),
    [sym_c_style_for_statement] = STATE(931),
    [sym_while_statement] = STATE(931),
    [sym_if_statement] = STATE(931),
    [sym_case_statement] = STATE(931),
    [sym_function_definition] = STATE(931),
    [sym_compound_statement] = STATE(931),
    [sym_subshell] = STATE(931),
    [sym_pipeline] = STATE(931),
    [sym_list] = STATE(931),
    [sym_negated_command] = STATE(931),
    [sym_test_command] = STATE(931),
    [sym_declaration_command] = STATE(931),
    [sym_unset_command] = STATE(931),
    [sym_command] = STATE(931),
    [sym_command_name] = STATE(932),
    [sym_variable_assignment] = STATE(933),
    [sym_subscript] = STATE(934),
    [sym_file_redirect] = STATE(937),
    [sym_concatenation] = STATE(935),
    [sym_string] = STATE(924),
    [sym_simple_expansion] = STATE(924),
    [sym_string_expansion] = STATE(924),
    [sym_expansion] = STATE(924),
    [sym_command_substitution] = STATE(924),
    [sym_process_substitution] = STATE(924),
    [aux_sym__statements_repeat1] = STATE(936),
    [aux_sym_command_repeat1] = STATE(937),
    [aux_sym__literal_repeat1] = STATE(938),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1745),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_done] = ACTIONS(3617),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1751),
    [anon_sym_typeset] = ACTIONS(1751),
    [anon_sym_export] = ACTIONS(1751),
    [anon_sym_readonly] = ACTIONS(1751),
    [anon_sym_local] = ACTIONS(1751),
    [anon_sym_unset] = ACTIONS(1753),
    [anon_sym_unsetenv] = ACTIONS(1753),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(1755),
    [anon_sym_DQUOTE] = ACTIONS(1757),
    [anon_sym_DOLLAR] = ACTIONS(1759),
    [sym_raw_string] = ACTIONS(1761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1765),
    [anon_sym_BQUOTE] = ACTIONS(1767),
    [anon_sym_LT_LPAREN] = ACTIONS(1769),
    [anon_sym_GT_LPAREN] = ACTIONS(1769),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1771),
  },
  [1049] = {
    [sym__simple_heredoc_body] = ACTIONS(1773),
    [sym__heredoc_body_beginning] = ACTIONS(1773),
    [sym_file_descriptor] = ACTIONS(1773),
    [anon_sym_SEMI] = ACTIONS(1775),
    [anon_sym_PIPE] = ACTIONS(1775),
    [anon_sym_SEMI_SEMI] = ACTIONS(1773),
    [anon_sym_RBRACE] = ACTIONS(1773),
    [anon_sym_PIPE_AMP] = ACTIONS(1773),
    [anon_sym_AMP_AMP] = ACTIONS(1773),
    [anon_sym_PIPE_PIPE] = ACTIONS(1773),
    [anon_sym_LT] = ACTIONS(1775),
    [anon_sym_GT] = ACTIONS(1775),
    [anon_sym_GT_GT] = ACTIONS(1773),
    [anon_sym_AMP_GT] = ACTIONS(1775),
    [anon_sym_AMP_GT_GT] = ACTIONS(1773),
    [anon_sym_LT_AMP] = ACTIONS(1773),
    [anon_sym_GT_AMP] = ACTIONS(1773),
    [anon_sym_LT_LT] = ACTIONS(1775),
    [anon_sym_LT_LT_DASH] = ACTIONS(1773),
    [anon_sym_LT_LT_LT] = ACTIONS(1773),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1773),
    [anon_sym_AMP] = ACTIONS(1775),
  },
  [1050] = {
    [sym__statements] = STATE(1752),
    [sym_redirected_statement] = STATE(975),
    [sym_for_statement] = STATE(975),
    [sym_c_style_for_statement] = STATE(975),
    [sym_while_statement] = STATE(975),
    [sym_if_statement] = STATE(975),
    [sym_elif_clause] = STATE(1754),
    [sym_else_clause] = STATE(1753),
    [sym_case_statement] = STATE(975),
    [sym_function_definition] = STATE(975),
    [sym_compound_statement] = STATE(975),
    [sym_subshell] = STATE(975),
    [sym_pipeline] = STATE(975),
    [sym_list] = STATE(975),
    [sym_negated_command] = STATE(975),
    [sym_test_command] = STATE(975),
    [sym_declaration_command] = STATE(975),
    [sym_unset_command] = STATE(975),
    [sym_command] = STATE(975),
    [sym_command_name] = STATE(977),
    [sym_variable_assignment] = STATE(978),
    [sym_subscript] = STATE(979),
    [sym_file_redirect] = STATE(983),
    [sym_concatenation] = STATE(980),
    [sym_string] = STATE(968),
    [sym_simple_expansion] = STATE(968),
    [sym_string_expansion] = STATE(968),
    [sym_expansion] = STATE(968),
    [sym_command_substitution] = STATE(968),
    [sym_process_substitution] = STATE(968),
    [aux_sym__statements_repeat1] = STATE(981),
    [aux_sym_if_statement_repeat1] = STATE(1754),
    [aux_sym_command_repeat1] = STATE(983),
    [aux_sym__literal_repeat1] = STATE(984),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1798),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_fi] = ACTIONS(3619),
    [anon_sym_elif] = ACTIONS(1802),
    [anon_sym_else] = ACTIONS(1804),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1808),
    [anon_sym_typeset] = ACTIONS(1808),
    [anon_sym_export] = ACTIONS(1808),
    [anon_sym_readonly] = ACTIONS(1808),
    [anon_sym_local] = ACTIONS(1808),
    [anon_sym_unset] = ACTIONS(1810),
    [anon_sym_unsetenv] = ACTIONS(1810),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(1812),
    [anon_sym_DQUOTE] = ACTIONS(1814),
    [anon_sym_DOLLAR] = ACTIONS(1816),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1822),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1828),
  },
  [1051] = {
    [anon_sym_SEMI] = ACTIONS(3621),
    [anon_sym_SEMI_SEMI] = ACTIONS(3623),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3623),
    [anon_sym_AMP] = ACTIONS(3623),
  },
  [1052] = {
    [anon_sym_in] = ACTIONS(3625),
    [sym_comment] = ACTIONS(57),
  },
  [1053] = {
    [anon_sym_SEMI] = ACTIONS(3627),
    [anon_sym_SEMI_SEMI] = ACTIONS(3629),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3629),
    [anon_sym_AMP] = ACTIONS(3629),
  },
  [1054] = {
    [anon_sym_in] = ACTIONS(3631),
    [sym_comment] = ACTIONS(57),
  },
  [1055] = {
    [anon_sym_RPAREN] = ACTIONS(3633),
    [sym_comment] = ACTIONS(57),
  },
  [1056] = {
    [sym__simple_heredoc_body] = ACTIONS(1883),
    [sym__heredoc_body_beginning] = ACTIONS(1883),
    [sym_file_descriptor] = ACTIONS(1883),
    [anon_sym_SEMI] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1885),
    [anon_sym_SEMI_SEMI] = ACTIONS(1883),
    [anon_sym_RBRACE] = ACTIONS(1883),
    [anon_sym_PIPE_AMP] = ACTIONS(1883),
    [anon_sym_AMP_AMP] = ACTIONS(1883),
    [anon_sym_PIPE_PIPE] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1885),
    [anon_sym_GT_GT] = ACTIONS(1883),
    [anon_sym_AMP_GT] = ACTIONS(1885),
    [anon_sym_AMP_GT_GT] = ACTIONS(1883),
    [anon_sym_LT_AMP] = ACTIONS(1883),
    [anon_sym_GT_AMP] = ACTIONS(1883),
    [anon_sym_LT_LT] = ACTIONS(1885),
    [anon_sym_LT_LT_DASH] = ACTIONS(1883),
    [anon_sym_LT_LT_LT] = ACTIONS(1883),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1883),
    [anon_sym_AMP] = ACTIONS(1885),
  },
  [1057] = {
    [sym__simple_heredoc_body] = ACTIONS(1897),
    [sym__heredoc_body_beginning] = ACTIONS(1897),
    [sym_file_descriptor] = ACTIONS(1897),
    [anon_sym_SEMI] = ACTIONS(1899),
    [anon_sym_PIPE] = ACTIONS(1899),
    [anon_sym_SEMI_SEMI] = ACTIONS(1897),
    [anon_sym_RBRACE] = ACTIONS(1897),
    [anon_sym_PIPE_AMP] = ACTIONS(1897),
    [anon_sym_AMP_AMP] = ACTIONS(1897),
    [anon_sym_PIPE_PIPE] = ACTIONS(1897),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(1899),
    [anon_sym_GT_GT] = ACTIONS(1897),
    [anon_sym_AMP_GT] = ACTIONS(1899),
    [anon_sym_AMP_GT_GT] = ACTIONS(1897),
    [anon_sym_LT_AMP] = ACTIONS(1897),
    [anon_sym_GT_AMP] = ACTIONS(1897),
    [anon_sym_LT_LT] = ACTIONS(1899),
    [anon_sym_LT_LT_DASH] = ACTIONS(1897),
    [anon_sym_LT_LT_LT] = ACTIONS(1897),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1897),
    [anon_sym_AMP] = ACTIONS(1899),
  },
  [1058] = {
    [sym__simple_heredoc_body] = ACTIONS(2063),
    [sym__heredoc_body_beginning] = ACTIONS(2063),
    [sym_file_descriptor] = ACTIONS(2063),
    [anon_sym_SEMI] = ACTIONS(2065),
    [anon_sym_PIPE] = ACTIONS(2065),
    [anon_sym_SEMI_SEMI] = ACTIONS(2063),
    [anon_sym_RBRACE] = ACTIONS(2063),
    [anon_sym_PIPE_AMP] = ACTIONS(2063),
    [anon_sym_AMP_AMP] = ACTIONS(2063),
    [anon_sym_PIPE_PIPE] = ACTIONS(2063),
    [anon_sym_LT] = ACTIONS(2065),
    [anon_sym_GT] = ACTIONS(2065),
    [anon_sym_GT_GT] = ACTIONS(2063),
    [anon_sym_AMP_GT] = ACTIONS(2065),
    [anon_sym_AMP_GT_GT] = ACTIONS(2063),
    [anon_sym_LT_AMP] = ACTIONS(2063),
    [anon_sym_GT_AMP] = ACTIONS(2063),
    [anon_sym_LT_LT] = ACTIONS(2065),
    [anon_sym_LT_LT_DASH] = ACTIONS(2063),
    [anon_sym_LT_LT_LT] = ACTIONS(2063),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2063),
    [anon_sym_AMP] = ACTIONS(2065),
  },
  [1059] = {
    [sym_concatenation] = STATE(1760),
    [sym_string] = STATE(1762),
    [sym_array] = STATE(1760),
    [sym_simple_expansion] = STATE(1762),
    [sym_string_expansion] = STATE(1762),
    [sym_expansion] = STATE(1762),
    [sym_command_substitution] = STATE(1762),
    [sym_process_substitution] = STATE(1762),
    [aux_sym__literal_repeat1] = STATE(1763),
    [sym__empty_value] = ACTIONS(3635),
    [anon_sym_LPAREN] = ACTIONS(3637),
    [sym__special_character] = ACTIONS(3639),
    [anon_sym_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR] = ACTIONS(793),
    [sym_raw_string] = ACTIONS(3641),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(797),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(799),
    [anon_sym_BQUOTE] = ACTIONS(801),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3641),
  },
  [1060] = {
    [sym_string] = STATE(1764),
    [sym_simple_expansion] = STATE(1764),
    [sym_string_expansion] = STATE(1764),
    [sym_expansion] = STATE(1764),
    [sym_command_substitution] = STATE(1764),
    [sym_process_substitution] = STATE(1764),
    [sym__special_character] = ACTIONS(3643),
    [anon_sym_DQUOTE] = ACTIONS(791),
    [anon_sym_DOLLAR] = ACTIONS(793),
    [sym_raw_string] = ACTIONS(3643),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(797),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(799),
    [anon_sym_BQUOTE] = ACTIONS(801),
    [anon_sym_LT_LPAREN] = ACTIONS(803),
    [anon_sym_GT_LPAREN] = ACTIONS(803),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3643),
  },
  [1061] = {
    [aux_sym_concatenation_repeat1] = STATE(1765),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(1969),
    [sym_variable_name] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1061),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [1062] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [sym_variable_name] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_RBRACE] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [1063] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(3645),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1064] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(3645),
    [anon_sym_DOLLAR] = ACTIONS(3647),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1065] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_RBRACE] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1099),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [1066] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [sym_variable_name] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_RBRACE] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1103),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [1067] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [sym_variable_name] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_RBRACE] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1107),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [1068] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(3649),
    [sym_comment] = ACTIONS(57),
  },
  [1069] = {
    [sym_subscript] = STATE(1771),
    [sym_variable_name] = ACTIONS(3651),
    [anon_sym_DASH] = ACTIONS(3653),
    [anon_sym_DOLLAR] = ACTIONS(3653),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3655),
    [anon_sym_STAR] = ACTIONS(3657),
    [anon_sym_AT] = ACTIONS(3657),
    [anon_sym_QMARK] = ACTIONS(3657),
    [anon_sym_0] = ACTIONS(3655),
    [anon_sym__] = ACTIONS(3655),
  },
  [1070] = {
    [sym_concatenation] = STATE(1774),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1774),
    [anon_sym_RBRACE] = ACTIONS(3659),
    [anon_sym_EQ] = ACTIONS(3661),
    [anon_sym_DASH] = ACTIONS(3661),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3663),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(3665),
    [anon_sym_COLON] = ACTIONS(3661),
    [anon_sym_COLON_QMARK] = ACTIONS(3661),
    [anon_sym_COLON_DASH] = ACTIONS(3661),
    [anon_sym_PERCENT] = ACTIONS(3661),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1071] = {
    [sym_concatenation] = STATE(1777),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1777),
    [anon_sym_RBRACE] = ACTIONS(3667),
    [anon_sym_EQ] = ACTIONS(3669),
    [anon_sym_DASH] = ACTIONS(3669),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(3673),
    [anon_sym_COLON] = ACTIONS(3669),
    [anon_sym_COLON_QMARK] = ACTIONS(3669),
    [anon_sym_COLON_DASH] = ACTIONS(3669),
    [anon_sym_PERCENT] = ACTIONS(3669),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1072] = {
    [anon_sym_RPAREN] = ACTIONS(3675),
    [sym_comment] = ACTIONS(57),
  },
  [1073] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(3675),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1074] = {
    [anon_sym_BQUOTE] = ACTIONS(3675),
    [sym_comment] = ACTIONS(57),
  },
  [1075] = {
    [anon_sym_RPAREN] = ACTIONS(3677),
    [sym_comment] = ACTIONS(57),
  },
  [1076] = {
    [sym_variable_assignment] = STATE(1076),
    [sym_subscript] = STATE(473),
    [sym_concatenation] = STATE(1076),
    [sym_string] = STATE(468),
    [sym_simple_expansion] = STATE(468),
    [sym_string_expansion] = STATE(468),
    [sym_expansion] = STATE(468),
    [sym_command_substitution] = STATE(468),
    [sym_process_substitution] = STATE(468),
    [aux_sym_declaration_command_repeat1] = STATE(1076),
    [aux_sym__literal_repeat1] = STATE(475),
    [sym__simple_heredoc_body] = ACTIONS(2192),
    [sym__heredoc_body_beginning] = ACTIONS(2192),
    [sym_file_descriptor] = ACTIONS(2192),
    [sym_variable_name] = ACTIONS(3679),
    [anon_sym_SEMI] = ACTIONS(2197),
    [anon_sym_PIPE] = ACTIONS(2197),
    [anon_sym_SEMI_SEMI] = ACTIONS(2192),
    [anon_sym_RBRACE] = ACTIONS(2192),
    [anon_sym_PIPE_AMP] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_GT] = ACTIONS(2197),
    [anon_sym_GT_GT] = ACTIONS(2192),
    [anon_sym_AMP_GT] = ACTIONS(2197),
    [anon_sym_AMP_GT_GT] = ACTIONS(2192),
    [anon_sym_LT_AMP] = ACTIONS(2192),
    [anon_sym_GT_AMP] = ACTIONS(2192),
    [anon_sym_LT_LT] = ACTIONS(2197),
    [anon_sym_LT_LT_DASH] = ACTIONS(2192),
    [anon_sym_LT_LT_LT] = ACTIONS(2192),
    [sym__special_character] = ACTIONS(3682),
    [anon_sym_DQUOTE] = ACTIONS(3685),
    [anon_sym_DOLLAR] = ACTIONS(3688),
    [sym_raw_string] = ACTIONS(3691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3694),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3697),
    [anon_sym_BQUOTE] = ACTIONS(3700),
    [anon_sym_LT_LPAREN] = ACTIONS(3703),
    [anon_sym_GT_LPAREN] = ACTIONS(3703),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3706),
    [sym_word] = ACTIONS(3709),
    [anon_sym_LF] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2197),
  },
  [1077] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(329),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [1078] = {
    [aux_sym__literal_repeat1] = STATE(1078),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym_variable_name] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_RBRACE] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(3712),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1373),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1079] = {
    [sym_string] = STATE(1780),
    [sym_simple_expansion] = STATE(1780),
    [sym_string_expansion] = STATE(1780),
    [sym_expansion] = STATE(1780),
    [sym_command_substitution] = STATE(1780),
    [sym_process_substitution] = STATE(1780),
    [sym__special_character] = ACTIONS(3715),
    [anon_sym_DQUOTE] = ACTIONS(811),
    [anon_sym_DOLLAR] = ACTIONS(813),
    [sym_raw_string] = ACTIONS(3715),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(819),
    [anon_sym_BQUOTE] = ACTIONS(821),
    [anon_sym_LT_LPAREN] = ACTIONS(823),
    [anon_sym_GT_LPAREN] = ACTIONS(823),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3715),
  },
  [1080] = {
    [aux_sym_concatenation_repeat1] = STATE(1781),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(1997),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1061),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [1081] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_RBRACE] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [1082] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(3717),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1083] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(3717),
    [anon_sym_DOLLAR] = ACTIONS(3719),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1084] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_RBRACE] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1099),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [1085] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_RBRACE] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1103),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [1086] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_RBRACE] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1107),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [1087] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(3721),
    [sym_comment] = ACTIONS(57),
  },
  [1088] = {
    [sym_subscript] = STATE(1787),
    [sym_variable_name] = ACTIONS(3723),
    [anon_sym_DASH] = ACTIONS(3725),
    [anon_sym_DOLLAR] = ACTIONS(3725),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3727),
    [anon_sym_STAR] = ACTIONS(3729),
    [anon_sym_AT] = ACTIONS(3729),
    [anon_sym_QMARK] = ACTIONS(3729),
    [anon_sym_0] = ACTIONS(3727),
    [anon_sym__] = ACTIONS(3727),
  },
  [1089] = {
    [sym_concatenation] = STATE(1790),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1790),
    [anon_sym_RBRACE] = ACTIONS(3731),
    [anon_sym_EQ] = ACTIONS(3733),
    [anon_sym_DASH] = ACTIONS(3733),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(3737),
    [anon_sym_COLON] = ACTIONS(3733),
    [anon_sym_COLON_QMARK] = ACTIONS(3733),
    [anon_sym_COLON_DASH] = ACTIONS(3733),
    [anon_sym_PERCENT] = ACTIONS(3733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1090] = {
    [sym_concatenation] = STATE(1793),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1793),
    [anon_sym_RBRACE] = ACTIONS(3739),
    [anon_sym_EQ] = ACTIONS(3741),
    [anon_sym_DASH] = ACTIONS(3741),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3743),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(3745),
    [anon_sym_COLON] = ACTIONS(3741),
    [anon_sym_COLON_QMARK] = ACTIONS(3741),
    [anon_sym_COLON_DASH] = ACTIONS(3741),
    [anon_sym_PERCENT] = ACTIONS(3741),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1091] = {
    [anon_sym_RPAREN] = ACTIONS(3747),
    [sym_comment] = ACTIONS(57),
  },
  [1092] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(3747),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1093] = {
    [anon_sym_BQUOTE] = ACTIONS(3747),
    [sym_comment] = ACTIONS(57),
  },
  [1094] = {
    [anon_sym_RPAREN] = ACTIONS(3749),
    [sym_comment] = ACTIONS(57),
  },
  [1095] = {
    [sym_concatenation] = STATE(1095),
    [sym_string] = STATE(479),
    [sym_simple_expansion] = STATE(479),
    [sym_string_expansion] = STATE(479),
    [sym_expansion] = STATE(479),
    [sym_command_substitution] = STATE(479),
    [sym_process_substitution] = STATE(479),
    [aux_sym_unset_command_repeat1] = STATE(1095),
    [aux_sym__literal_repeat1] = STATE(485),
    [sym__simple_heredoc_body] = ACTIONS(2268),
    [sym__heredoc_body_beginning] = ACTIONS(2268),
    [sym_file_descriptor] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2270),
    [anon_sym_SEMI_SEMI] = ACTIONS(2268),
    [anon_sym_RBRACE] = ACTIONS(2268),
    [anon_sym_PIPE_AMP] = ACTIONS(2268),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [anon_sym_PIPE_PIPE] = ACTIONS(2268),
    [anon_sym_LT] = ACTIONS(2270),
    [anon_sym_GT] = ACTIONS(2270),
    [anon_sym_GT_GT] = ACTIONS(2268),
    [anon_sym_AMP_GT] = ACTIONS(2270),
    [anon_sym_AMP_GT_GT] = ACTIONS(2268),
    [anon_sym_LT_AMP] = ACTIONS(2268),
    [anon_sym_GT_AMP] = ACTIONS(2268),
    [anon_sym_LT_LT] = ACTIONS(2270),
    [anon_sym_LT_LT_DASH] = ACTIONS(2268),
    [anon_sym_LT_LT_LT] = ACTIONS(2268),
    [sym__special_character] = ACTIONS(3751),
    [anon_sym_DQUOTE] = ACTIONS(3754),
    [anon_sym_DOLLAR] = ACTIONS(3757),
    [sym_raw_string] = ACTIONS(3760),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3766),
    [anon_sym_BQUOTE] = ACTIONS(3769),
    [anon_sym_LT_LPAREN] = ACTIONS(3772),
    [anon_sym_GT_LPAREN] = ACTIONS(3772),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3775),
    [sym_word] = ACTIONS(3778),
    [anon_sym_LF] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2270),
  },
  [1096] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(329),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [1097] = {
    [aux_sym__literal_repeat1] = STATE(1097),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_RBRACE] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(3781),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1373),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1098] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2346),
    [anon_sym_EQ_EQ] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2346),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1099] = {
    [aux_sym_concatenation_repeat1] = STATE(1099),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(3784),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2346),
    [anon_sym_EQ_EQ] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2346),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1100] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_RBRACE] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_EQ_TILDE] = ACTIONS(2353),
    [anon_sym_EQ_EQ] = ACTIONS(2353),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2353),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [1101] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(3787),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1102] = {
    [sym_concatenation] = STATE(1799),
    [sym_string] = STATE(1798),
    [sym_simple_expansion] = STATE(1798),
    [sym_string_expansion] = STATE(1798),
    [sym_expansion] = STATE(1798),
    [sym_command_substitution] = STATE(1798),
    [sym_process_substitution] = STATE(1798),
    [aux_sym__literal_repeat1] = STATE(1800),
    [anon_sym_RBRACE] = ACTIONS(3789),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(3791),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3791),
  },
  [1103] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(3793),
    [sym_comment] = ACTIONS(57),
  },
  [1104] = {
    [sym_concatenation] = STATE(1804),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1804),
    [anon_sym_RBRACE] = ACTIONS(3795),
    [anon_sym_EQ] = ACTIONS(3797),
    [anon_sym_DASH] = ACTIONS(3797),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3799),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(3801),
    [anon_sym_COLON] = ACTIONS(3797),
    [anon_sym_COLON_QMARK] = ACTIONS(3797),
    [anon_sym_COLON_DASH] = ACTIONS(3797),
    [anon_sym_PERCENT] = ACTIONS(3797),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1105] = {
    [sym_concatenation] = STATE(1806),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1806),
    [anon_sym_RBRACE] = ACTIONS(3789),
    [anon_sym_EQ] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3803),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3805),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(3807),
    [anon_sym_COLON] = ACTIONS(3803),
    [anon_sym_COLON_QMARK] = ACTIONS(3803),
    [anon_sym_COLON_DASH] = ACTIONS(3803),
    [anon_sym_PERCENT] = ACTIONS(3803),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1106] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_RBRACE] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_EQ_TILDE] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2444),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2444),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [1107] = {
    [sym_concatenation] = STATE(1809),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1809),
    [sym_regex] = ACTIONS(3809),
    [anon_sym_RBRACE] = ACTIONS(3811),
    [anon_sym_EQ] = ACTIONS(3813),
    [anon_sym_DASH] = ACTIONS(3813),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3815),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(3813),
    [anon_sym_COLON_QMARK] = ACTIONS(3813),
    [anon_sym_COLON_DASH] = ACTIONS(3813),
    [anon_sym_PERCENT] = ACTIONS(3813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1108] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(3811),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1109] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_RBRACE] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_EQ_TILDE] = ACTIONS(2494),
    [anon_sym_EQ_EQ] = ACTIONS(2494),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2494),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [1110] = {
    [sym_concatenation] = STATE(1806),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1806),
    [sym_regex] = ACTIONS(3817),
    [anon_sym_RBRACE] = ACTIONS(3789),
    [anon_sym_EQ] = ACTIONS(3803),
    [anon_sym_DASH] = ACTIONS(3803),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3805),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(3803),
    [anon_sym_COLON_QMARK] = ACTIONS(3803),
    [anon_sym_COLON_DASH] = ACTIONS(3803),
    [anon_sym_PERCENT] = ACTIONS(3803),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1111] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(3789),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1112] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_RBRACE] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_EQ_TILDE] = ACTIONS(2502),
    [anon_sym_EQ_EQ] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [1113] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_RBRACE] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_EQ_TILDE] = ACTIONS(2536),
    [anon_sym_EQ_EQ] = ACTIONS(2536),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [1114] = {
    [sym_compound_statement] = STATE(1811),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [1115] = {
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_SEMI_SEMI] = ACTIONS(2538),
    [anon_sym_RBRACE] = ACTIONS(2538),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2538),
    [anon_sym_AMP] = ACTIONS(2538),
  },
  [1116] = {
    [sym_simple_expansion] = STATE(1316),
    [sym_expansion] = STATE(1316),
    [sym_command_substitution] = STATE(1316),
    [aux_sym_heredoc_body_repeat1] = STATE(1316),
    [sym__heredoc_body_middle] = ACTIONS(2558),
    [sym__heredoc_body_end] = ACTIONS(3819),
    [anon_sym_DOLLAR] = ACTIONS(1223),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1227),
    [anon_sym_BQUOTE] = ACTIONS(1229),
    [sym_comment] = ACTIONS(57),
  },
  [1117] = {
    [sym_concatenation] = STATE(1814),
    [sym_string] = STATE(1813),
    [sym_simple_expansion] = STATE(1813),
    [sym_string_expansion] = STATE(1813),
    [sym_expansion] = STATE(1813),
    [sym_command_substitution] = STATE(1813),
    [sym_process_substitution] = STATE(1813),
    [aux_sym__literal_repeat1] = STATE(1815),
    [sym__special_character] = ACTIONS(2075),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(3821),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3821),
  },
  [1118] = {
    [sym_file_redirect] = STATE(514),
    [sym_heredoc_redirect] = STATE(514),
    [sym_herestring_redirect] = STATE(514),
    [aux_sym_redirected_statement_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(2564),
    [sym__heredoc_body_beginning] = ACTIONS(2564),
    [sym_file_descriptor] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT] = ACTIONS(2566),
    [anon_sym_AMP_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_AMP] = ACTIONS(2564),
    [anon_sym_GT_AMP] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_LT_LT_DASH] = ACTIONS(2564),
    [anon_sym_LT_LT_LT] = ACTIONS(2564),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2566),
  },
  [1119] = {
    [sym_file_redirect] = STATE(514),
    [sym_heredoc_redirect] = STATE(514),
    [sym_herestring_redirect] = STATE(514),
    [aux_sym_redirected_statement_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(2564),
    [sym__heredoc_body_beginning] = ACTIONS(2564),
    [sym_file_descriptor] = ACTIONS(2564),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_RBRACE] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT] = ACTIONS(2566),
    [anon_sym_AMP_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_AMP] = ACTIONS(2564),
    [anon_sym_GT_AMP] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_LT_LT_DASH] = ACTIONS(2564),
    [anon_sym_LT_LT_LT] = ACTIONS(2564),
    [sym__special_character] = ACTIONS(435),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2566),
  },
  [1120] = {
    [sym_file_redirect] = STATE(514),
    [sym_heredoc_redirect] = STATE(514),
    [sym_herestring_redirect] = STATE(514),
    [aux_sym_redirected_statement_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(2568),
    [sym__heredoc_body_beginning] = ACTIONS(2568),
    [sym_file_descriptor] = ACTIONS(2568),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_SEMI_SEMI] = ACTIONS(2568),
    [anon_sym_RBRACE] = ACTIONS(2568),
    [anon_sym_PIPE_AMP] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_GT] = ACTIONS(2570),
    [anon_sym_GT_GT] = ACTIONS(2568),
    [anon_sym_AMP_GT] = ACTIONS(2570),
    [anon_sym_AMP_GT_GT] = ACTIONS(2568),
    [anon_sym_LT_AMP] = ACTIONS(2568),
    [anon_sym_GT_AMP] = ACTIONS(2568),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_LT_LT_DASH] = ACTIONS(2568),
    [anon_sym_LT_LT_LT] = ACTIONS(2568),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2570),
  },
  [1121] = {
    [sym_file_redirect] = STATE(514),
    [sym_heredoc_redirect] = STATE(514),
    [sym_herestring_redirect] = STATE(514),
    [aux_sym_redirected_statement_repeat1] = STATE(514),
    [sym__simple_heredoc_body] = ACTIONS(2568),
    [sym__heredoc_body_beginning] = ACTIONS(2568),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_PIPE] = ACTIONS(865),
    [anon_sym_SEMI_SEMI] = ACTIONS(2568),
    [anon_sym_RBRACE] = ACTIONS(2568),
    [anon_sym_PIPE_AMP] = ACTIONS(869),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_LT_LT_DASH] = ACTIONS(2568),
    [anon_sym_LT_LT_LT] = ACTIONS(2568),
    [sym__special_character] = ACTIONS(435),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2570),
  },
  [1122] = {
    [aux_sym_concatenation_repeat1] = STATE(1816),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(329),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [1123] = {
    [aux_sym_concatenation_repeat1] = STATE(1816),
    [sym__simple_heredoc_body] = ACTIONS(1037),
    [sym__heredoc_body_beginning] = ACTIONS(1037),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_RBRACE] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [1124] = {
    [sym__simple_heredoc_body] = ACTIONS(1037),
    [sym__heredoc_body_beginning] = ACTIONS(1037),
    [sym_file_descriptor] = ACTIONS(1037),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_RBRACE] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [1125] = {
    [aux_sym__literal_repeat1] = STATE(1817),
    [sym__simple_heredoc_body] = ACTIONS(1051),
    [sym__heredoc_body_beginning] = ACTIONS(1051),
    [sym_file_descriptor] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1051),
    [anon_sym_RBRACE] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_LT_LT_DASH] = ACTIONS(1051),
    [anon_sym_LT_LT_LT] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(891),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1051),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [1126] = {
    [sym__simple_heredoc_body] = ACTIONS(2572),
    [sym__heredoc_body_beginning] = ACTIONS(2572),
    [sym_file_descriptor] = ACTIONS(2572),
    [anon_sym_SEMI] = ACTIONS(2574),
    [anon_sym_PIPE] = ACTIONS(2574),
    [anon_sym_SEMI_SEMI] = ACTIONS(2572),
    [anon_sym_RBRACE] = ACTIONS(2572),
    [anon_sym_PIPE_AMP] = ACTIONS(2572),
    [anon_sym_AMP_AMP] = ACTIONS(2572),
    [anon_sym_PIPE_PIPE] = ACTIONS(2572),
    [anon_sym_LT] = ACTIONS(2574),
    [anon_sym_GT] = ACTIONS(2574),
    [anon_sym_GT_GT] = ACTIONS(2572),
    [anon_sym_AMP_GT] = ACTIONS(2574),
    [anon_sym_AMP_GT_GT] = ACTIONS(2572),
    [anon_sym_LT_AMP] = ACTIONS(2572),
    [anon_sym_GT_AMP] = ACTIONS(2572),
    [anon_sym_LT_LT] = ACTIONS(2574),
    [anon_sym_LT_LT_DASH] = ACTIONS(2572),
    [anon_sym_LT_LT_LT] = ACTIONS(2572),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2572),
    [anon_sym_AMP] = ACTIONS(2574),
  },
  [1127] = {
    [aux_sym_concatenation_repeat1] = STATE(1816),
    [sym__simple_heredoc_body] = ACTIONS(2576),
    [sym__heredoc_body_beginning] = ACTIONS(2576),
    [sym_file_descriptor] = ACTIONS(2576),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI_SEMI] = ACTIONS(2576),
    [anon_sym_RBRACE] = ACTIONS(2576),
    [anon_sym_PIPE_AMP] = ACTIONS(2576),
    [anon_sym_AMP_AMP] = ACTIONS(2576),
    [anon_sym_PIPE_PIPE] = ACTIONS(2576),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_GT] = ACTIONS(2576),
    [anon_sym_AMP_GT] = ACTIONS(2578),
    [anon_sym_AMP_GT_GT] = ACTIONS(2576),
    [anon_sym_LT_AMP] = ACTIONS(2576),
    [anon_sym_GT_AMP] = ACTIONS(2576),
    [anon_sym_LT_LT] = ACTIONS(2578),
    [anon_sym_LT_LT_DASH] = ACTIONS(2576),
    [anon_sym_LT_LT_LT] = ACTIONS(2576),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2576),
    [anon_sym_AMP] = ACTIONS(2578),
  },
  [1128] = {
    [sym__simple_heredoc_body] = ACTIONS(2576),
    [sym__heredoc_body_beginning] = ACTIONS(2576),
    [sym_file_descriptor] = ACTIONS(2576),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI_SEMI] = ACTIONS(2576),
    [anon_sym_RBRACE] = ACTIONS(2576),
    [anon_sym_PIPE_AMP] = ACTIONS(2576),
    [anon_sym_AMP_AMP] = ACTIONS(2576),
    [anon_sym_PIPE_PIPE] = ACTIONS(2576),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_GT] = ACTIONS(2576),
    [anon_sym_AMP_GT] = ACTIONS(2578),
    [anon_sym_AMP_GT_GT] = ACTIONS(2576),
    [anon_sym_LT_AMP] = ACTIONS(2576),
    [anon_sym_GT_AMP] = ACTIONS(2576),
    [anon_sym_LT_LT] = ACTIONS(2578),
    [anon_sym_LT_LT_DASH] = ACTIONS(2576),
    [anon_sym_LT_LT_LT] = ACTIONS(2576),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2576),
    [anon_sym_AMP] = ACTIONS(2578),
  },
  [1129] = {
    [aux_sym__literal_repeat1] = STATE(1817),
    [sym__simple_heredoc_body] = ACTIONS(2580),
    [sym__heredoc_body_beginning] = ACTIONS(2580),
    [sym_file_descriptor] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_SEMI_SEMI] = ACTIONS(2580),
    [anon_sym_RBRACE] = ACTIONS(2580),
    [anon_sym_PIPE_AMP] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_AMP_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_AMP] = ACTIONS(2580),
    [anon_sym_GT_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2582),
    [anon_sym_LT_LT_DASH] = ACTIONS(2580),
    [anon_sym_LT_LT_LT] = ACTIONS(2580),
    [sym__special_character] = ACTIONS(891),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2580),
    [anon_sym_AMP] = ACTIONS(2582),
  },
  [1130] = {
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(2584),
    [anon_sym_for] = ACTIONS(2588),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_case] = ACTIONS(2588),
    [anon_sym_function] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_RBRACE] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2584),
    [anon_sym_declare] = ACTIONS(2588),
    [anon_sym_typeset] = ACTIONS(2588),
    [anon_sym_export] = ACTIONS(2588),
    [anon_sym_readonly] = ACTIONS(2588),
    [anon_sym_local] = ACTIONS(2588),
    [anon_sym_unset] = ACTIONS(2588),
    [anon_sym_unsetenv] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [sym__special_character] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2584),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2584),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [anon_sym_LT_LPAREN] = ACTIONS(2584),
    [anon_sym_GT_LPAREN] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
  },
  [1131] = {
    [sym_file_redirect] = STATE(1131),
    [sym_heredoc_redirect] = STATE(1131),
    [sym_herestring_redirect] = STATE(1131),
    [aux_sym_redirected_statement_repeat1] = STATE(1131),
    [sym__simple_heredoc_body] = ACTIONS(2590),
    [sym__heredoc_body_beginning] = ACTIONS(2590),
    [sym_file_descriptor] = ACTIONS(3823),
    [anon_sym_SEMI] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(2595),
    [anon_sym_SEMI_SEMI] = ACTIONS(2590),
    [anon_sym_RBRACE] = ACTIONS(2590),
    [anon_sym_PIPE_AMP] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(3826),
    [anon_sym_GT] = ACTIONS(3826),
    [anon_sym_GT_GT] = ACTIONS(3829),
    [anon_sym_AMP_GT] = ACTIONS(3826),
    [anon_sym_AMP_GT_GT] = ACTIONS(3829),
    [anon_sym_LT_AMP] = ACTIONS(3829),
    [anon_sym_GT_AMP] = ACTIONS(3829),
    [anon_sym_LT_LT] = ACTIONS(3832),
    [anon_sym_LT_LT_DASH] = ACTIONS(3835),
    [anon_sym_LT_LT_LT] = ACTIONS(3838),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2595),
  },
  [1132] = {
    [sym__simple_heredoc_body] = ACTIONS(2612),
    [sym__heredoc_body_beginning] = ACTIONS(2612),
    [sym_file_descriptor] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_RBRACE] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(2614),
    [anon_sym_EQ_EQ] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(2614),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2612),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2612),
    [anon_sym_BQUOTE] = ACTIONS(2612),
    [anon_sym_LT_LPAREN] = ACTIONS(2612),
    [anon_sym_GT_LPAREN] = ACTIONS(2612),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2614),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [1133] = {
    [aux_sym_concatenation_repeat1] = STATE(487),
    [sym__simple_heredoc_body] = ACTIONS(2612),
    [sym__heredoc_body_beginning] = ACTIONS(2612),
    [sym_file_descriptor] = ACTIONS(2612),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_RBRACE] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(2614),
    [anon_sym_EQ_EQ] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(2614),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2612),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2612),
    [anon_sym_BQUOTE] = ACTIONS(2612),
    [anon_sym_LT_LPAREN] = ACTIONS(2612),
    [anon_sym_GT_LPAREN] = ACTIONS(2612),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2614),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [1134] = {
    [aux_sym__literal_repeat1] = STATE(523),
    [sym__simple_heredoc_body] = ACTIONS(2616),
    [sym__heredoc_body_beginning] = ACTIONS(2616),
    [sym_file_descriptor] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_SEMI_SEMI] = ACTIONS(2616),
    [anon_sym_RBRACE] = ACTIONS(2616),
    [anon_sym_PIPE_AMP] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_EQ_TILDE] = ACTIONS(2618),
    [anon_sym_EQ_EQ] = ACTIONS(2618),
    [anon_sym_LT] = ACTIONS(2618),
    [anon_sym_GT] = ACTIONS(2618),
    [anon_sym_GT_GT] = ACTIONS(2616),
    [anon_sym_AMP_GT] = ACTIONS(2618),
    [anon_sym_AMP_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_AMP] = ACTIONS(2616),
    [anon_sym_GT_AMP] = ACTIONS(2616),
    [anon_sym_LT_LT] = ACTIONS(2618),
    [anon_sym_LT_LT_DASH] = ACTIONS(2616),
    [anon_sym_LT_LT_LT] = ACTIONS(2616),
    [sym__special_character] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(2616),
    [anon_sym_DOLLAR] = ACTIONS(2618),
    [sym_raw_string] = ACTIONS(2616),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2616),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2616),
    [anon_sym_BQUOTE] = ACTIONS(2616),
    [anon_sym_LT_LPAREN] = ACTIONS(2616),
    [anon_sym_GT_LPAREN] = ACTIONS(2616),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2618),
    [anon_sym_LF] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2618),
  },
  [1135] = {
    [sym_concatenation] = STATE(1135),
    [sym_string] = STATE(516),
    [sym_simple_expansion] = STATE(516),
    [sym_string_expansion] = STATE(516),
    [sym_expansion] = STATE(516),
    [sym_command_substitution] = STATE(516),
    [sym_process_substitution] = STATE(516),
    [aux_sym_command_repeat2] = STATE(1135),
    [aux_sym__literal_repeat1] = STATE(518),
    [sym__simple_heredoc_body] = ACTIONS(2612),
    [sym__heredoc_body_beginning] = ACTIONS(2612),
    [sym_file_descriptor] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_RBRACE] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(3841),
    [anon_sym_EQ_EQ] = ACTIONS(3841),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(3844),
    [anon_sym_DQUOTE] = ACTIONS(3847),
    [anon_sym_DOLLAR] = ACTIONS(3850),
    [sym_raw_string] = ACTIONS(3853),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3856),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3859),
    [anon_sym_BQUOTE] = ACTIONS(3862),
    [anon_sym_LT_LPAREN] = ACTIONS(3865),
    [anon_sym_GT_LPAREN] = ACTIONS(3865),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3868),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [1136] = {
    [sym_file_descriptor] = ACTIONS(1235),
    [sym_variable_name] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1239),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1239),
    [anon_sym_if] = ACTIONS(1239),
    [anon_sym_case] = ACTIONS(1239),
    [anon_sym_function] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_RBRACE] = ACTIONS(2586),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1239),
    [anon_sym_typeset] = ACTIONS(1239),
    [anon_sym_export] = ACTIONS(1239),
    [anon_sym_readonly] = ACTIONS(1239),
    [anon_sym_local] = ACTIONS(1239),
    [anon_sym_unset] = ACTIONS(1239),
    [anon_sym_unsetenv] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_AMP_GT] = ACTIONS(1239),
    [anon_sym_AMP_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_AMP] = ACTIONS(1235),
    [anon_sym_GT_AMP] = ACTIONS(1235),
    [sym__special_character] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_DOLLAR] = ACTIONS(1239),
    [sym_raw_string] = ACTIONS(1235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1235),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1235),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [anon_sym_LT_LPAREN] = ACTIONS(1235),
    [anon_sym_GT_LPAREN] = ACTIONS(1235),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1239),
  },
  [1137] = {
    [anon_sym_SEMI] = ACTIONS(3871),
    [anon_sym_SEMI_SEMI] = ACTIONS(3873),
    [anon_sym_RBRACE] = ACTIONS(2586),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3873),
    [anon_sym_AMP] = ACTIONS(3873),
  },
  [1138] = {
    [sym_concatenation] = STATE(1135),
    [sym_string] = STATE(516),
    [sym_simple_expansion] = STATE(516),
    [sym_string_expansion] = STATE(516),
    [sym_expansion] = STATE(516),
    [sym_command_substitution] = STATE(516),
    [sym_process_substitution] = STATE(516),
    [aux_sym_command_repeat2] = STATE(1135),
    [aux_sym__literal_repeat1] = STATE(518),
    [sym__simple_heredoc_body] = ACTIONS(2676),
    [sym__heredoc_body_beginning] = ACTIONS(2676),
    [sym_file_descriptor] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym_PIPE] = ACTIONS(2678),
    [anon_sym_SEMI_SEMI] = ACTIONS(2676),
    [anon_sym_RBRACE] = ACTIONS(2676),
    [anon_sym_PIPE_AMP] = ACTIONS(2676),
    [anon_sym_AMP_AMP] = ACTIONS(2676),
    [anon_sym_PIPE_PIPE] = ACTIONS(2676),
    [anon_sym_EQ_TILDE] = ACTIONS(883),
    [anon_sym_EQ_EQ] = ACTIONS(883),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_GT] = ACTIONS(2678),
    [anon_sym_GT_GT] = ACTIONS(2676),
    [anon_sym_AMP_GT] = ACTIONS(2678),
    [anon_sym_AMP_GT_GT] = ACTIONS(2676),
    [anon_sym_LT_AMP] = ACTIONS(2676),
    [anon_sym_GT_AMP] = ACTIONS(2676),
    [anon_sym_LT_LT] = ACTIONS(2678),
    [anon_sym_LT_LT_DASH] = ACTIONS(2676),
    [anon_sym_LT_LT_LT] = ACTIONS(2676),
    [sym__special_character] = ACTIONS(205),
    [anon_sym_DQUOTE] = ACTIONS(207),
    [anon_sym_DOLLAR] = ACTIONS(209),
    [sym_raw_string] = ACTIONS(885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(213),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(217),
    [anon_sym_LT_LPAREN] = ACTIONS(219),
    [anon_sym_GT_LPAREN] = ACTIONS(219),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(887),
    [anon_sym_LF] = ACTIONS(2676),
    [anon_sym_AMP] = ACTIONS(2678),
  },
  [1139] = {
    [sym_file_descriptor] = ACTIONS(1398),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1398),
  },
  [1140] = {
    [sym_concatenation] = STATE(1820),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(1820),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(3875),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [1141] = {
    [aux_sym_concatenation_repeat1] = STATE(594),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym__concat] = ACTIONS(1023),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1398),
  },
  [1142] = {
    [aux_sym__literal_repeat1] = STATE(610),
    [sym_file_descriptor] = ACTIONS(1444),
    [sym_variable_name] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1446),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_AMP_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT_GT] = ACTIONS(1444),
    [anon_sym_LT_AMP] = ACTIONS(1444),
    [anon_sym_GT_AMP] = ACTIONS(1444),
    [sym__special_character] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [anon_sym_DOLLAR] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1444),
    [anon_sym_BQUOTE] = ACTIONS(1444),
    [anon_sym_LT_LPAREN] = ACTIONS(1444),
    [anon_sym_GT_LPAREN] = ACTIONS(1444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1444),
  },
  [1143] = {
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE] = ACTIONS(2901),
    [anon_sym_RBRACK] = ACTIONS(2901),
    [anon_sym_EQ_TILDE] = ACTIONS(2901),
    [anon_sym_EQ_EQ] = ACTIONS(2901),
    [anon_sym_EQ] = ACTIONS(2903),
    [anon_sym_PLUS_EQ] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2903),
    [anon_sym_GT] = ACTIONS(2903),
    [anon_sym_BANG_EQ] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_DASH_EQ] = ACTIONS(2901),
    [anon_sym_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_EQ] = ACTIONS(2901),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2901),
  },
  [1144] = {
    [sym__concat] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_RBRACK] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2344),
    [anon_sym_EQ_EQ] = ACTIONS(2344),
    [anon_sym_EQ] = ACTIONS(2346),
    [anon_sym_PLUS_EQ] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_BANG_EQ] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(2346),
    [anon_sym_DASH] = ACTIONS(2346),
    [anon_sym_DASH_EQ] = ACTIONS(2344),
    [anon_sym_LT_EQ] = ACTIONS(2344),
    [anon_sym_GT_EQ] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2344),
  },
  [1145] = {
    [aux_sym_concatenation_repeat1] = STATE(1145),
    [sym__concat] = ACTIONS(3877),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_RBRACK] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2344),
    [anon_sym_EQ_EQ] = ACTIONS(2344),
    [anon_sym_EQ] = ACTIONS(2346),
    [anon_sym_PLUS_EQ] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_BANG_EQ] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(2346),
    [anon_sym_DASH] = ACTIONS(2346),
    [anon_sym_DASH_EQ] = ACTIONS(2344),
    [anon_sym_LT_EQ] = ACTIONS(2344),
    [anon_sym_GT_EQ] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2344),
  },
  [1146] = {
    [sym__concat] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_RBRACK] = ACTIONS(2351),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_EQ_EQ] = ACTIONS(2351),
    [anon_sym_EQ] = ACTIONS(2353),
    [anon_sym_PLUS_EQ] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2353),
    [anon_sym_DASH] = ACTIONS(2353),
    [anon_sym_DASH_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2351),
    [anon_sym_GT_EQ] = ACTIONS(2351),
    [anon_sym_PLUS_PLUS] = ACTIONS(2351),
    [anon_sym_DASH_DASH] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2351),
  },
  [1147] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(3880),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1148] = {
    [sym_concatenation] = STATE(1824),
    [sym_string] = STATE(1823),
    [sym_simple_expansion] = STATE(1823),
    [sym_string_expansion] = STATE(1823),
    [sym_expansion] = STATE(1823),
    [sym_command_substitution] = STATE(1823),
    [sym_process_substitution] = STATE(1823),
    [aux_sym__literal_repeat1] = STATE(1825),
    [anon_sym_RBRACE] = ACTIONS(3882),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(3884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3884),
  },
  [1149] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(3886),
    [sym_comment] = ACTIONS(57),
  },
  [1150] = {
    [sym_concatenation] = STATE(1829),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1829),
    [anon_sym_RBRACE] = ACTIONS(3888),
    [anon_sym_EQ] = ACTIONS(3890),
    [anon_sym_DASH] = ACTIONS(3890),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3892),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(3894),
    [anon_sym_COLON] = ACTIONS(3890),
    [anon_sym_COLON_QMARK] = ACTIONS(3890),
    [anon_sym_COLON_DASH] = ACTIONS(3890),
    [anon_sym_PERCENT] = ACTIONS(3890),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1151] = {
    [sym_concatenation] = STATE(1831),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1831),
    [anon_sym_RBRACE] = ACTIONS(3882),
    [anon_sym_EQ] = ACTIONS(3896),
    [anon_sym_DASH] = ACTIONS(3896),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3898),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(3900),
    [anon_sym_COLON] = ACTIONS(3896),
    [anon_sym_COLON_QMARK] = ACTIONS(3896),
    [anon_sym_COLON_DASH] = ACTIONS(3896),
    [anon_sym_PERCENT] = ACTIONS(3896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1152] = {
    [sym__concat] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_RBRACK] = ACTIONS(2442),
    [anon_sym_EQ_TILDE] = ACTIONS(2442),
    [anon_sym_EQ_EQ] = ACTIONS(2442),
    [anon_sym_EQ] = ACTIONS(2444),
    [anon_sym_PLUS_EQ] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_BANG_EQ] = ACTIONS(2442),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_DASH_EQ] = ACTIONS(2442),
    [anon_sym_LT_EQ] = ACTIONS(2442),
    [anon_sym_GT_EQ] = ACTIONS(2442),
    [anon_sym_PLUS_PLUS] = ACTIONS(2442),
    [anon_sym_DASH_DASH] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2442),
  },
  [1153] = {
    [sym_concatenation] = STATE(1834),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1834),
    [sym_regex] = ACTIONS(3902),
    [anon_sym_RBRACE] = ACTIONS(3904),
    [anon_sym_EQ] = ACTIONS(3906),
    [anon_sym_DASH] = ACTIONS(3906),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3908),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(3906),
    [anon_sym_COLON_QMARK] = ACTIONS(3906),
    [anon_sym_COLON_DASH] = ACTIONS(3906),
    [anon_sym_PERCENT] = ACTIONS(3906),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1154] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(3904),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1155] = {
    [sym__concat] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_RBRACK] = ACTIONS(2492),
    [anon_sym_EQ_TILDE] = ACTIONS(2492),
    [anon_sym_EQ_EQ] = ACTIONS(2492),
    [anon_sym_EQ] = ACTIONS(2494),
    [anon_sym_PLUS_EQ] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_BANG_EQ] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(2494),
    [anon_sym_DASH] = ACTIONS(2494),
    [anon_sym_DASH_EQ] = ACTIONS(2492),
    [anon_sym_LT_EQ] = ACTIONS(2492),
    [anon_sym_GT_EQ] = ACTIONS(2492),
    [anon_sym_PLUS_PLUS] = ACTIONS(2492),
    [anon_sym_DASH_DASH] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2492),
  },
  [1156] = {
    [sym_concatenation] = STATE(1831),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1831),
    [sym_regex] = ACTIONS(3910),
    [anon_sym_RBRACE] = ACTIONS(3882),
    [anon_sym_EQ] = ACTIONS(3896),
    [anon_sym_DASH] = ACTIONS(3896),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3898),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(3896),
    [anon_sym_COLON_QMARK] = ACTIONS(3896),
    [anon_sym_COLON_DASH] = ACTIONS(3896),
    [anon_sym_PERCENT] = ACTIONS(3896),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1157] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(3882),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1158] = {
    [sym__concat] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_RBRACK] = ACTIONS(2500),
    [anon_sym_EQ_TILDE] = ACTIONS(2500),
    [anon_sym_EQ_EQ] = ACTIONS(2500),
    [anon_sym_EQ] = ACTIONS(2502),
    [anon_sym_PLUS_EQ] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_BANG_EQ] = ACTIONS(2500),
    [anon_sym_PLUS] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2502),
    [anon_sym_DASH_EQ] = ACTIONS(2500),
    [anon_sym_LT_EQ] = ACTIONS(2500),
    [anon_sym_GT_EQ] = ACTIONS(2500),
    [anon_sym_PLUS_PLUS] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2500),
  },
  [1159] = {
    [sym__concat] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_RBRACK] = ACTIONS(2534),
    [anon_sym_EQ_TILDE] = ACTIONS(2534),
    [anon_sym_EQ_EQ] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2536),
    [anon_sym_PLUS_EQ] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_BANG_EQ] = ACTIONS(2534),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_DASH_EQ] = ACTIONS(2534),
    [anon_sym_LT_EQ] = ACTIONS(2534),
    [anon_sym_GT_EQ] = ACTIONS(2534),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2534),
  },
  [1160] = {
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE] = ACTIONS(2945),
    [anon_sym_RBRACK] = ACTIONS(2945),
    [anon_sym_EQ_TILDE] = ACTIONS(2945),
    [anon_sym_EQ_EQ] = ACTIONS(2945),
    [anon_sym_EQ] = ACTIONS(2947),
    [anon_sym_PLUS_EQ] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2947),
    [anon_sym_BANG_EQ] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2947),
    [anon_sym_DASH_EQ] = ACTIONS(2945),
    [anon_sym_LT_EQ] = ACTIONS(2945),
    [anon_sym_GT_EQ] = ACTIONS(2945),
    [anon_sym_PLUS_PLUS] = ACTIONS(2945),
    [anon_sym_DASH_DASH] = ACTIONS(2945),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2945),
  },
  [1161] = {
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE] = ACTIONS(2945),
    [anon_sym_RBRACK] = ACTIONS(2945),
    [anon_sym_EQ_TILDE] = ACTIONS(2945),
    [anon_sym_EQ_EQ] = ACTIONS(2945),
    [anon_sym_EQ] = ACTIONS(2947),
    [anon_sym_PLUS_EQ] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2947),
    [anon_sym_BANG_EQ] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2947),
    [anon_sym_DASH_EQ] = ACTIONS(2945),
    [anon_sym_LT_EQ] = ACTIONS(2945),
    [anon_sym_GT_EQ] = ACTIONS(2945),
    [anon_sym_PLUS_PLUS] = ACTIONS(2945),
    [anon_sym_DASH_DASH] = ACTIONS(2945),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2945),
  },
  [1162] = {
    [aux_sym_concatenation_repeat1] = STATE(1162),
    [sym__concat] = ACTIONS(2910),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2344),
    [anon_sym_EQ_EQ] = ACTIONS(2344),
    [anon_sym_EQ] = ACTIONS(2346),
    [anon_sym_PLUS_EQ] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_BANG_EQ] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(2346),
    [anon_sym_DASH] = ACTIONS(2346),
    [anon_sym_DASH_EQ] = ACTIONS(2344),
    [anon_sym_LT_EQ] = ACTIONS(2344),
    [anon_sym_GT_EQ] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2344),
  },
  [1163] = {
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym_variable_name] = ACTIONS(1398),
    [ts_builtin_sym_end] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_RPAREN] = ACTIONS(1398),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1400),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [1164] = {
    [sym_concatenation] = STATE(1837),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(1837),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(3912),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [1165] = {
    [aux_sym_concatenation_repeat1] = STATE(556),
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym__concat] = ACTIONS(943),
    [sym_variable_name] = ACTIONS(1398),
    [ts_builtin_sym_end] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1400),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [1166] = {
    [aux_sym__literal_repeat1] = STATE(573),
    [sym__simple_heredoc_body] = ACTIONS(1444),
    [sym__heredoc_body_beginning] = ACTIONS(1444),
    [sym_file_descriptor] = ACTIONS(1444),
    [sym_variable_name] = ACTIONS(1444),
    [ts_builtin_sym_end] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1446),
    [anon_sym_SEMI_SEMI] = ACTIONS(1444),
    [anon_sym_PIPE_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1446),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_AMP_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT_GT] = ACTIONS(1444),
    [anon_sym_LT_AMP] = ACTIONS(1444),
    [anon_sym_GT_AMP] = ACTIONS(1444),
    [anon_sym_LT_LT] = ACTIONS(1446),
    [anon_sym_LT_LT_DASH] = ACTIONS(1444),
    [anon_sym_LT_LT_LT] = ACTIONS(1444),
    [sym__special_character] = ACTIONS(981),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [anon_sym_DOLLAR] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1444),
    [anon_sym_BQUOTE] = ACTIONS(1444),
    [anon_sym_LT_LPAREN] = ACTIONS(1444),
    [anon_sym_GT_LPAREN] = ACTIONS(1444),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1446),
    [sym_word] = ACTIONS(1446),
    [anon_sym_LF] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1446),
  },
  [1167] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [sym_variable_name] = ACTIONS(2344),
    [ts_builtin_sym_end] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_RPAREN] = ACTIONS(2344),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1168] = {
    [aux_sym_concatenation_repeat1] = STATE(1168),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(3914),
    [sym_variable_name] = ACTIONS(2344),
    [ts_builtin_sym_end] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1169] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [sym_variable_name] = ACTIONS(2351),
    [ts_builtin_sym_end] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_RPAREN] = ACTIONS(2351),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2353),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [1170] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(3917),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1171] = {
    [sym_concatenation] = STATE(1841),
    [sym_string] = STATE(1840),
    [sym_simple_expansion] = STATE(1840),
    [sym_string_expansion] = STATE(1840),
    [sym_expansion] = STATE(1840),
    [sym_command_substitution] = STATE(1840),
    [sym_process_substitution] = STATE(1840),
    [aux_sym__literal_repeat1] = STATE(1842),
    [anon_sym_RBRACE] = ACTIONS(3919),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(3921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3921),
  },
  [1172] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(3923),
    [sym_comment] = ACTIONS(57),
  },
  [1173] = {
    [sym_concatenation] = STATE(1846),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1846),
    [anon_sym_RBRACE] = ACTIONS(3925),
    [anon_sym_EQ] = ACTIONS(3927),
    [anon_sym_DASH] = ACTIONS(3927),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(3931),
    [anon_sym_COLON] = ACTIONS(3927),
    [anon_sym_COLON_QMARK] = ACTIONS(3927),
    [anon_sym_COLON_DASH] = ACTIONS(3927),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1174] = {
    [sym_concatenation] = STATE(1848),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1848),
    [anon_sym_RBRACE] = ACTIONS(3919),
    [anon_sym_EQ] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3935),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(3937),
    [anon_sym_COLON] = ACTIONS(3933),
    [anon_sym_COLON_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_DASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3933),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1175] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [sym_variable_name] = ACTIONS(2442),
    [ts_builtin_sym_end] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_RPAREN] = ACTIONS(2442),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2444),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [1176] = {
    [sym_concatenation] = STATE(1851),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1851),
    [sym_regex] = ACTIONS(3939),
    [anon_sym_RBRACE] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3943),
    [anon_sym_DASH] = ACTIONS(3943),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(3943),
    [anon_sym_COLON_QMARK] = ACTIONS(3943),
    [anon_sym_COLON_DASH] = ACTIONS(3943),
    [anon_sym_PERCENT] = ACTIONS(3943),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1177] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1178] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [sym_variable_name] = ACTIONS(2492),
    [ts_builtin_sym_end] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_RPAREN] = ACTIONS(2492),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2494),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [1179] = {
    [sym_concatenation] = STATE(1848),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1848),
    [sym_regex] = ACTIONS(3947),
    [anon_sym_RBRACE] = ACTIONS(3919),
    [anon_sym_EQ] = ACTIONS(3933),
    [anon_sym_DASH] = ACTIONS(3933),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3935),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(3933),
    [anon_sym_COLON_QMARK] = ACTIONS(3933),
    [anon_sym_COLON_DASH] = ACTIONS(3933),
    [anon_sym_PERCENT] = ACTIONS(3933),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1180] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(3919),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1181] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [sym_variable_name] = ACTIONS(2500),
    [ts_builtin_sym_end] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_RPAREN] = ACTIONS(2500),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2502),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [1182] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(2534),
    [ts_builtin_sym_end] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_RPAREN] = ACTIONS(2534),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2536),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [1183] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [ts_builtin_sym_end] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_RPAREN] = ACTIONS(2344),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1184] = {
    [aux_sym_concatenation_repeat1] = STATE(1184),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(3949),
    [ts_builtin_sym_end] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1185] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [ts_builtin_sym_end] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_RPAREN] = ACTIONS(2351),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2353),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [1186] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(3952),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1187] = {
    [sym_concatenation] = STATE(1856),
    [sym_string] = STATE(1855),
    [sym_simple_expansion] = STATE(1855),
    [sym_string_expansion] = STATE(1855),
    [sym_expansion] = STATE(1855),
    [sym_command_substitution] = STATE(1855),
    [sym_process_substitution] = STATE(1855),
    [aux_sym__literal_repeat1] = STATE(1857),
    [anon_sym_RBRACE] = ACTIONS(3954),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(3956),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3956),
  },
  [1188] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(3958),
    [sym_comment] = ACTIONS(57),
  },
  [1189] = {
    [sym_concatenation] = STATE(1861),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1861),
    [anon_sym_RBRACE] = ACTIONS(3960),
    [anon_sym_EQ] = ACTIONS(3962),
    [anon_sym_DASH] = ACTIONS(3962),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3964),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(3966),
    [anon_sym_COLON] = ACTIONS(3962),
    [anon_sym_COLON_QMARK] = ACTIONS(3962),
    [anon_sym_COLON_DASH] = ACTIONS(3962),
    [anon_sym_PERCENT] = ACTIONS(3962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1190] = {
    [sym_concatenation] = STATE(1863),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1863),
    [anon_sym_RBRACE] = ACTIONS(3954),
    [anon_sym_EQ] = ACTIONS(3968),
    [anon_sym_DASH] = ACTIONS(3968),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3970),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(3972),
    [anon_sym_COLON] = ACTIONS(3968),
    [anon_sym_COLON_QMARK] = ACTIONS(3968),
    [anon_sym_COLON_DASH] = ACTIONS(3968),
    [anon_sym_PERCENT] = ACTIONS(3968),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1191] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [ts_builtin_sym_end] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_RPAREN] = ACTIONS(2442),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2444),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [1192] = {
    [sym_concatenation] = STATE(1866),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1866),
    [sym_regex] = ACTIONS(3974),
    [anon_sym_RBRACE] = ACTIONS(3976),
    [anon_sym_EQ] = ACTIONS(3978),
    [anon_sym_DASH] = ACTIONS(3978),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3980),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(3978),
    [anon_sym_COLON_QMARK] = ACTIONS(3978),
    [anon_sym_COLON_DASH] = ACTIONS(3978),
    [anon_sym_PERCENT] = ACTIONS(3978),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1193] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(3976),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1194] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [ts_builtin_sym_end] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_RPAREN] = ACTIONS(2492),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2494),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [1195] = {
    [sym_concatenation] = STATE(1863),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1863),
    [sym_regex] = ACTIONS(3982),
    [anon_sym_RBRACE] = ACTIONS(3954),
    [anon_sym_EQ] = ACTIONS(3968),
    [anon_sym_DASH] = ACTIONS(3968),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3970),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(3968),
    [anon_sym_COLON_QMARK] = ACTIONS(3968),
    [anon_sym_COLON_DASH] = ACTIONS(3968),
    [anon_sym_PERCENT] = ACTIONS(3968),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1196] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(3954),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1197] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [ts_builtin_sym_end] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_RPAREN] = ACTIONS(2500),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2502),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [1198] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [ts_builtin_sym_end] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_RPAREN] = ACTIONS(2534),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2536),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [1199] = {
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2344),
  },
  [1200] = {
    [aux_sym_concatenation_repeat1] = STATE(1200),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(3984),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2344),
  },
  [1201] = {
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [sym_variable_name] = ACTIONS(2351),
    [anon_sym_RPAREN] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2351),
  },
  [1202] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(3987),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1203] = {
    [sym_concatenation] = STATE(1871),
    [sym_string] = STATE(1870),
    [sym_simple_expansion] = STATE(1870),
    [sym_string_expansion] = STATE(1870),
    [sym_expansion] = STATE(1870),
    [sym_command_substitution] = STATE(1870),
    [sym_process_substitution] = STATE(1870),
    [aux_sym__literal_repeat1] = STATE(1872),
    [anon_sym_RBRACE] = ACTIONS(3989),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(3991),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3991),
  },
  [1204] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(3993),
    [sym_comment] = ACTIONS(57),
  },
  [1205] = {
    [sym_concatenation] = STATE(1876),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1876),
    [anon_sym_RBRACE] = ACTIONS(3995),
    [anon_sym_EQ] = ACTIONS(3997),
    [anon_sym_DASH] = ACTIONS(3997),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(3999),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4001),
    [anon_sym_COLON] = ACTIONS(3997),
    [anon_sym_COLON_QMARK] = ACTIONS(3997),
    [anon_sym_COLON_DASH] = ACTIONS(3997),
    [anon_sym_PERCENT] = ACTIONS(3997),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1206] = {
    [sym_concatenation] = STATE(1878),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1878),
    [anon_sym_RBRACE] = ACTIONS(3989),
    [anon_sym_EQ] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4005),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4007),
    [anon_sym_COLON] = ACTIONS(4003),
    [anon_sym_COLON_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_DASH] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4003),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1207] = {
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [sym_variable_name] = ACTIONS(2442),
    [anon_sym_RPAREN] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2442),
  },
  [1208] = {
    [sym_concatenation] = STATE(1881),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1881),
    [sym_regex] = ACTIONS(4009),
    [anon_sym_RBRACE] = ACTIONS(4011),
    [anon_sym_EQ] = ACTIONS(4013),
    [anon_sym_DASH] = ACTIONS(4013),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4015),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4013),
    [anon_sym_COLON_QMARK] = ACTIONS(4013),
    [anon_sym_COLON_DASH] = ACTIONS(4013),
    [anon_sym_PERCENT] = ACTIONS(4013),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1209] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(4011),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1210] = {
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [sym_variable_name] = ACTIONS(2492),
    [anon_sym_RPAREN] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2492),
  },
  [1211] = {
    [sym_concatenation] = STATE(1878),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1878),
    [sym_regex] = ACTIONS(4017),
    [anon_sym_RBRACE] = ACTIONS(3989),
    [anon_sym_EQ] = ACTIONS(4003),
    [anon_sym_DASH] = ACTIONS(4003),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4005),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4003),
    [anon_sym_COLON_QMARK] = ACTIONS(4003),
    [anon_sym_COLON_DASH] = ACTIONS(4003),
    [anon_sym_PERCENT] = ACTIONS(4003),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1212] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(3989),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1213] = {
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [sym_variable_name] = ACTIONS(2500),
    [anon_sym_RPAREN] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2500),
  },
  [1214] = {
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(2534),
    [anon_sym_RPAREN] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2534),
  },
  [1215] = {
    [anon_sym_DQUOTE] = ACTIONS(4019),
    [anon_sym_DOLLAR] = ACTIONS(4019),
    [sym__string_content] = ACTIONS(4021),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4019),
    [anon_sym_BQUOTE] = ACTIONS(4019),
    [sym_comment] = ACTIONS(343),
  },
  [1216] = {
    [sym_concatenation] = STATE(1885),
    [sym_string] = STATE(1884),
    [sym_simple_expansion] = STATE(1884),
    [sym_string_expansion] = STATE(1884),
    [sym_expansion] = STATE(1884),
    [sym_command_substitution] = STATE(1884),
    [sym_process_substitution] = STATE(1884),
    [aux_sym__literal_repeat1] = STATE(1886),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(4025),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4025),
  },
  [1217] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(4027),
    [sym_comment] = ACTIONS(57),
  },
  [1218] = {
    [sym_concatenation] = STATE(1890),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1890),
    [anon_sym_RBRACE] = ACTIONS(4029),
    [anon_sym_EQ] = ACTIONS(4031),
    [anon_sym_DASH] = ACTIONS(4031),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4035),
    [anon_sym_COLON] = ACTIONS(4031),
    [anon_sym_COLON_QMARK] = ACTIONS(4031),
    [anon_sym_COLON_DASH] = ACTIONS(4031),
    [anon_sym_PERCENT] = ACTIONS(4031),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1219] = {
    [sym_concatenation] = STATE(1892),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1892),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_EQ] = ACTIONS(4037),
    [anon_sym_DASH] = ACTIONS(4037),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4039),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4041),
    [anon_sym_COLON] = ACTIONS(4037),
    [anon_sym_COLON_QMARK] = ACTIONS(4037),
    [anon_sym_COLON_DASH] = ACTIONS(4037),
    [anon_sym_PERCENT] = ACTIONS(4037),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1220] = {
    [sym__concat] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2444),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym__string_content] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2444),
    [anon_sym_BQUOTE] = ACTIONS(2444),
    [sym_comment] = ACTIONS(343),
  },
  [1221] = {
    [sym_concatenation] = STATE(1895),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1895),
    [sym_regex] = ACTIONS(4043),
    [anon_sym_RBRACE] = ACTIONS(4045),
    [anon_sym_EQ] = ACTIONS(4047),
    [anon_sym_DASH] = ACTIONS(4047),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4049),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4047),
    [anon_sym_COLON_QMARK] = ACTIONS(4047),
    [anon_sym_COLON_DASH] = ACTIONS(4047),
    [anon_sym_PERCENT] = ACTIONS(4047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1222] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(4045),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1223] = {
    [sym__concat] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2494),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym__string_content] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2494),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2494),
    [anon_sym_BQUOTE] = ACTIONS(2494),
    [sym_comment] = ACTIONS(343),
  },
  [1224] = {
    [sym_concatenation] = STATE(1892),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1892),
    [sym_regex] = ACTIONS(4051),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_EQ] = ACTIONS(4037),
    [anon_sym_DASH] = ACTIONS(4037),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4039),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4037),
    [anon_sym_COLON_QMARK] = ACTIONS(4037),
    [anon_sym_COLON_DASH] = ACTIONS(4037),
    [anon_sym_PERCENT] = ACTIONS(4037),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1225] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(4023),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1226] = {
    [sym__concat] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2502),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym__string_content] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [sym_comment] = ACTIONS(343),
  },
  [1227] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [ts_builtin_sym_end] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_RPAREN] = ACTIONS(4053),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_EQ_TILDE] = ACTIONS(4055),
    [anon_sym_EQ_EQ] = ACTIONS(4055),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [1228] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1229] = {
    [aux_sym_concatenation_repeat1] = STATE(717),
    [sym__concat] = ACTIONS(4057),
    [anon_sym_RBRACK] = ACTIONS(4059),
    [sym_comment] = ACTIONS(57),
  },
  [1230] = {
    [sym__concat] = ACTIONS(4061),
    [anon_sym_RBRACK] = ACTIONS(4059),
    [sym_comment] = ACTIONS(57),
  },
  [1231] = {
    [aux_sym__literal_repeat1] = STATE(724),
    [sym__concat] = ACTIONS(4063),
    [anon_sym_RBRACK] = ACTIONS(4065),
    [sym__special_character] = ACTIONS(1396),
    [sym_comment] = ACTIONS(57),
  },
  [1232] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [ts_builtin_sym_end] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_RPAREN] = ACTIONS(4067),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_EQ_TILDE] = ACTIONS(4069),
    [anon_sym_EQ_EQ] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [1233] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(325),
    [sym__special_character] = ACTIONS(329),
    [sym_comment] = ACTIONS(57),
  },
  [1234] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(1906),
    [anon_sym_DQUOTE] = ACTIONS(4073),
    [anon_sym_DOLLAR] = ACTIONS(4075),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1235] = {
    [sym_string] = STATE(1908),
    [anon_sym_DASH] = ACTIONS(4077),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(4077),
    [sym_raw_string] = ACTIONS(4079),
    [anon_sym_POUND] = ACTIONS(4077),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4081),
    [anon_sym_STAR] = ACTIONS(4083),
    [anon_sym_AT] = ACTIONS(4083),
    [anon_sym_QMARK] = ACTIONS(4083),
    [anon_sym_0] = ACTIONS(4081),
    [anon_sym__] = ACTIONS(4081),
  },
  [1236] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(4085),
    [sym_comment] = ACTIONS(57),
  },
  [1237] = {
    [sym_subscript] = STATE(1914),
    [sym_variable_name] = ACTIONS(4087),
    [anon_sym_BANG] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4091),
    [anon_sym_DOLLAR] = ACTIONS(4091),
    [anon_sym_POUND] = ACTIONS(4089),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4093),
    [anon_sym_STAR] = ACTIONS(4095),
    [anon_sym_AT] = ACTIONS(4095),
    [anon_sym_QMARK] = ACTIONS(4095),
    [anon_sym_0] = ACTIONS(4093),
    [anon_sym__] = ACTIONS(4093),
  },
  [1238] = {
    [sym__statements] = STATE(1915),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(1916),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1239] = {
    [sym__statements] = STATE(1917),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1240] = {
    [sym__statements] = STATE(1918),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1241] = {
    [anon_sym_RBRACE] = ACTIONS(4085),
    [sym_comment] = ACTIONS(57),
  },
  [1242] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(4097),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [1243] = {
    [sym_concatenation] = STATE(1923),
    [sym_string] = STATE(1922),
    [sym_simple_expansion] = STATE(1922),
    [sym_string_expansion] = STATE(1922),
    [sym_expansion] = STATE(1922),
    [sym_command_substitution] = STATE(1922),
    [sym_process_substitution] = STATE(1922),
    [aux_sym__literal_repeat1] = STATE(1924),
    [anon_sym_RBRACE] = ACTIONS(4085),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(4101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4101),
  },
  [1244] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [ts_builtin_sym_end] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_RPAREN] = ACTIONS(4103),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_EQ_TILDE] = ACTIONS(4105),
    [anon_sym_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [1245] = {
    [sym_concatenation] = STATE(1927),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1927),
    [sym_regex] = ACTIONS(4107),
    [anon_sym_RBRACE] = ACTIONS(4109),
    [anon_sym_EQ] = ACTIONS(4111),
    [anon_sym_DASH] = ACTIONS(4111),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4113),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4111),
    [anon_sym_COLON_QMARK] = ACTIONS(4111),
    [anon_sym_COLON_DASH] = ACTIONS(4111),
    [anon_sym_PERCENT] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1246] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(4109),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1247] = {
    [sym_concatenation] = STATE(1929),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1929),
    [sym_regex] = ACTIONS(4115),
    [anon_sym_RBRACE] = ACTIONS(4085),
    [anon_sym_EQ] = ACTIONS(4117),
    [anon_sym_DASH] = ACTIONS(4117),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4117),
    [anon_sym_COLON_QMARK] = ACTIONS(4117),
    [anon_sym_COLON_DASH] = ACTIONS(4117),
    [anon_sym_PERCENT] = ACTIONS(4117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1248] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(4085),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1249] = {
    [sym_string] = STATE(1930),
    [sym_simple_expansion] = STATE(1930),
    [sym_string_expansion] = STATE(1930),
    [sym_expansion] = STATE(1930),
    [sym_command_substitution] = STATE(1930),
    [sym_process_substitution] = STATE(1930),
    [sym__special_character] = ACTIONS(4121),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(4121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4121),
  },
  [1250] = {
    [aux_sym_concatenation_repeat1] = STATE(1931),
    [sym__concat] = ACTIONS(2446),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_EQ] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_POUND] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_COLON] = ACTIONS(1061),
    [anon_sym_COLON_QMARK] = ACTIONS(1061),
    [anon_sym_COLON_DASH] = ACTIONS(1061),
    [anon_sym_PERCENT] = ACTIONS(1061),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1061),
  },
  [1251] = {
    [sym__concat] = ACTIONS(1063),
    [anon_sym_RBRACE] = ACTIONS(1063),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_POUND] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_COLON_QMARK] = ACTIONS(1065),
    [anon_sym_COLON_DASH] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1065),
  },
  [1252] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(4123),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1253] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(4123),
    [anon_sym_DOLLAR] = ACTIONS(4125),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1254] = {
    [sym__concat] = ACTIONS(1097),
    [anon_sym_RBRACE] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1099),
    [anon_sym_DASH] = ACTIONS(1099),
    [sym__special_character] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_POUND] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_COLON] = ACTIONS(1099),
    [anon_sym_COLON_QMARK] = ACTIONS(1099),
    [anon_sym_COLON_DASH] = ACTIONS(1099),
    [anon_sym_PERCENT] = ACTIONS(1099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1099),
  },
  [1255] = {
    [sym__concat] = ACTIONS(1101),
    [anon_sym_RBRACE] = ACTIONS(1101),
    [anon_sym_EQ] = ACTIONS(1103),
    [anon_sym_DASH] = ACTIONS(1103),
    [sym__special_character] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_POUND] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_COLON] = ACTIONS(1103),
    [anon_sym_COLON_QMARK] = ACTIONS(1103),
    [anon_sym_COLON_DASH] = ACTIONS(1103),
    [anon_sym_PERCENT] = ACTIONS(1103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1103),
  },
  [1256] = {
    [sym__concat] = ACTIONS(1105),
    [anon_sym_RBRACE] = ACTIONS(1105),
    [anon_sym_EQ] = ACTIONS(1107),
    [anon_sym_DASH] = ACTIONS(1107),
    [sym__special_character] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_POUND] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_COLON] = ACTIONS(1107),
    [anon_sym_COLON_QMARK] = ACTIONS(1107),
    [anon_sym_COLON_DASH] = ACTIONS(1107),
    [anon_sym_PERCENT] = ACTIONS(1107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1107),
  },
  [1257] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(4127),
    [sym_comment] = ACTIONS(57),
  },
  [1258] = {
    [sym_subscript] = STATE(1937),
    [sym_variable_name] = ACTIONS(4129),
    [anon_sym_DASH] = ACTIONS(4131),
    [anon_sym_DOLLAR] = ACTIONS(4131),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4133),
    [anon_sym_STAR] = ACTIONS(4135),
    [anon_sym_AT] = ACTIONS(4135),
    [anon_sym_QMARK] = ACTIONS(4135),
    [anon_sym_0] = ACTIONS(4133),
    [anon_sym__] = ACTIONS(4133),
  },
  [1259] = {
    [sym_concatenation] = STATE(1940),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1940),
    [anon_sym_RBRACE] = ACTIONS(4137),
    [anon_sym_EQ] = ACTIONS(4139),
    [anon_sym_DASH] = ACTIONS(4139),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4141),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4143),
    [anon_sym_COLON] = ACTIONS(4139),
    [anon_sym_COLON_QMARK] = ACTIONS(4139),
    [anon_sym_COLON_DASH] = ACTIONS(4139),
    [anon_sym_PERCENT] = ACTIONS(4139),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1260] = {
    [sym_concatenation] = STATE(1943),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1943),
    [anon_sym_RBRACE] = ACTIONS(4145),
    [anon_sym_EQ] = ACTIONS(4147),
    [anon_sym_DASH] = ACTIONS(4147),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4149),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4151),
    [anon_sym_COLON] = ACTIONS(4147),
    [anon_sym_COLON_QMARK] = ACTIONS(4147),
    [anon_sym_COLON_DASH] = ACTIONS(4147),
    [anon_sym_PERCENT] = ACTIONS(4147),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1261] = {
    [sym_concatenation] = STATE(1945),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1945),
    [anon_sym_RBRACE] = ACTIONS(4153),
    [anon_sym_EQ] = ACTIONS(4155),
    [anon_sym_DASH] = ACTIONS(4155),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4157),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4155),
    [anon_sym_COLON_QMARK] = ACTIONS(4155),
    [anon_sym_COLON_DASH] = ACTIONS(4155),
    [anon_sym_PERCENT] = ACTIONS(4155),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1262] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [ts_builtin_sym_end] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_RPAREN] = ACTIONS(4159),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_EQ_TILDE] = ACTIONS(4161),
    [anon_sym_EQ_EQ] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [1263] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(4153),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1264] = {
    [anon_sym_RPAREN] = ACTIONS(4163),
    [sym_comment] = ACTIONS(57),
  },
  [1265] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(4163),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1266] = {
    [anon_sym_BQUOTE] = ACTIONS(4163),
    [sym_comment] = ACTIONS(57),
  },
  [1267] = {
    [anon_sym_RPAREN] = ACTIONS(4165),
    [sym_comment] = ACTIONS(57),
  },
  [1268] = {
    [anon_sym_RBRACE] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_DASH] = ACTIONS(329),
    [sym__special_character] = ACTIONS(329),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_POUND] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_COLON_QMARK] = ACTIONS(329),
    [anon_sym_COLON_DASH] = ACTIONS(329),
    [anon_sym_PERCENT] = ACTIONS(329),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(329),
  },
  [1269] = {
    [aux_sym__literal_repeat1] = STATE(1269),
    [anon_sym_RBRACE] = ACTIONS(1371),
    [anon_sym_EQ] = ACTIONS(1373),
    [anon_sym_DASH] = ACTIONS(1373),
    [sym__special_character] = ACTIONS(4167),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_POUND] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_COLON] = ACTIONS(1373),
    [anon_sym_COLON_QMARK] = ACTIONS(1373),
    [anon_sym_COLON_DASH] = ACTIONS(1373),
    [anon_sym_PERCENT] = ACTIONS(1373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1373),
  },
  [1270] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(4170),
    [anon_sym_EQ] = ACTIONS(4172),
    [anon_sym_DASH] = ACTIONS(4172),
    [sym__special_character] = ACTIONS(4175),
    [anon_sym_DQUOTE] = ACTIONS(4178),
    [anon_sym_DOLLAR] = ACTIONS(4181),
    [sym_raw_string] = ACTIONS(4184),
    [anon_sym_POUND] = ACTIONS(4187),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4190),
    [anon_sym_COLON] = ACTIONS(4172),
    [anon_sym_COLON_QMARK] = ACTIONS(4172),
    [anon_sym_COLON_DASH] = ACTIONS(4172),
    [anon_sym_PERCENT] = ACTIONS(4172),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4193),
    [anon_sym_BQUOTE] = ACTIONS(4196),
    [anon_sym_LT_LPAREN] = ACTIONS(4199),
    [anon_sym_GT_LPAREN] = ACTIONS(4199),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(4202),
  },
  [1271] = {
    [sym_concatenation] = STATE(1929),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1929),
    [anon_sym_RBRACE] = ACTIONS(4085),
    [anon_sym_EQ] = ACTIONS(4117),
    [anon_sym_DASH] = ACTIONS(4117),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4119),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4117),
    [anon_sym_COLON_QMARK] = ACTIONS(4117),
    [anon_sym_COLON_DASH] = ACTIONS(4117),
    [anon_sym_PERCENT] = ACTIONS(4117),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1272] = {
    [aux_sym_concatenation_repeat1] = STATE(1274),
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(1023),
    [sym_variable_name] = ACTIONS(1378),
    [anon_sym_RPAREN] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_AMP] = ACTIONS(1378),
    [anon_sym_GT_AMP] = ACTIONS(1378),
    [sym__special_character] = ACTIONS(1378),
    [anon_sym_DQUOTE] = ACTIONS(1378),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [sym_raw_string] = ACTIONS(1378),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1378),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1378),
    [anon_sym_BQUOTE] = ACTIONS(1378),
    [anon_sym_LT_LPAREN] = ACTIONS(1378),
    [anon_sym_GT_LPAREN] = ACTIONS(1378),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1378),
  },
  [1273] = {
    [aux_sym__literal_repeat1] = STATE(1275),
    [sym_file_descriptor] = ACTIONS(1382),
    [sym_variable_name] = ACTIONS(1382),
    [anon_sym_RPAREN] = ACTIONS(1382),
    [anon_sym_LT] = ACTIONS(1384),
    [anon_sym_GT] = ACTIONS(1384),
    [anon_sym_GT_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT_GT] = ACTIONS(1382),
    [anon_sym_LT_AMP] = ACTIONS(1382),
    [anon_sym_GT_AMP] = ACTIONS(1382),
    [sym__special_character] = ACTIONS(1055),
    [anon_sym_DQUOTE] = ACTIONS(1382),
    [anon_sym_DOLLAR] = ACTIONS(1384),
    [sym_raw_string] = ACTIONS(1382),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1382),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1382),
    [anon_sym_BQUOTE] = ACTIONS(1382),
    [anon_sym_LT_LPAREN] = ACTIONS(1382),
    [anon_sym_GT_LPAREN] = ACTIONS(1382),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1382),
  },
  [1274] = {
    [aux_sym_concatenation_repeat1] = STATE(1948),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(1023),
    [sym_variable_name] = ACTIONS(1059),
    [anon_sym_RPAREN] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1059),
  },
  [1275] = {
    [aux_sym__literal_repeat1] = STATE(1275),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym_variable_name] = ACTIONS(1371),
    [anon_sym_RPAREN] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(2341),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1371),
  },
  [1276] = {
    [aux_sym_concatenation_repeat1] = STATE(1949),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(1420),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [1277] = {
    [aux_sym_concatenation_repeat1] = STATE(1949),
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym__concat] = ACTIONS(1420),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [1278] = {
    [aux_sym__literal_repeat1] = STATE(1950),
    [sym__simple_heredoc_body] = ACTIONS(1444),
    [sym__heredoc_body_beginning] = ACTIONS(1444),
    [sym_file_descriptor] = ACTIONS(1444),
    [sym_variable_name] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1446),
    [anon_sym_SEMI_SEMI] = ACTIONS(1444),
    [anon_sym_PIPE_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1446),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_AMP_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT_GT] = ACTIONS(1444),
    [anon_sym_LT_AMP] = ACTIONS(1444),
    [anon_sym_GT_AMP] = ACTIONS(1444),
    [anon_sym_LT_LT] = ACTIONS(1446),
    [anon_sym_LT_LT_DASH] = ACTIONS(1444),
    [anon_sym_LT_LT_LT] = ACTIONS(1444),
    [sym__special_character] = ACTIONS(1448),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [anon_sym_DOLLAR] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1444),
    [anon_sym_BQUOTE] = ACTIONS(1444),
    [anon_sym_LT_LPAREN] = ACTIONS(1444),
    [anon_sym_GT_LPAREN] = ACTIONS(1444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1446),
    [anon_sym_LF] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1446),
  },
  [1279] = {
    [sym_concatenation] = STATE(1163),
    [sym_string] = STATE(1951),
    [sym_array] = STATE(1163),
    [sym_simple_expansion] = STATE(1951),
    [sym_string_expansion] = STATE(1951),
    [sym_expansion] = STATE(1951),
    [sym_command_substitution] = STATE(1951),
    [sym_process_substitution] = STATE(1951),
    [aux_sym__literal_repeat1] = STATE(1952),
    [sym__empty_value] = ACTIONS(2150),
    [anon_sym_LPAREN] = ACTIONS(2152),
    [sym__special_character] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(4205),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4205),
  },
  [1280] = {
    [aux_sym_concatenation_repeat1] = STATE(1953),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(943),
    [sym_variable_name] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1061),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [1281] = {
    [sym_variable_assignment] = STATE(1281),
    [sym_subscript] = STATE(656),
    [sym_concatenation] = STATE(1281),
    [sym_string] = STATE(655),
    [sym_simple_expansion] = STATE(655),
    [sym_string_expansion] = STATE(655),
    [sym_expansion] = STATE(655),
    [sym_command_substitution] = STATE(655),
    [sym_process_substitution] = STATE(655),
    [aux_sym_declaration_command_repeat1] = STATE(1281),
    [aux_sym__literal_repeat1] = STATE(658),
    [sym__simple_heredoc_body] = ACTIONS(2192),
    [sym__heredoc_body_beginning] = ACTIONS(2192),
    [sym_file_descriptor] = ACTIONS(2192),
    [sym_variable_name] = ACTIONS(4207),
    [anon_sym_SEMI] = ACTIONS(2197),
    [anon_sym_PIPE] = ACTIONS(2197),
    [anon_sym_SEMI_SEMI] = ACTIONS(2192),
    [anon_sym_PIPE_AMP] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_GT] = ACTIONS(2197),
    [anon_sym_GT_GT] = ACTIONS(2192),
    [anon_sym_AMP_GT] = ACTIONS(2197),
    [anon_sym_AMP_GT_GT] = ACTIONS(2192),
    [anon_sym_LT_AMP] = ACTIONS(2192),
    [anon_sym_GT_AMP] = ACTIONS(2192),
    [anon_sym_LT_LT] = ACTIONS(2197),
    [anon_sym_LT_LT_DASH] = ACTIONS(2192),
    [anon_sym_LT_LT_LT] = ACTIONS(2192),
    [sym__special_character] = ACTIONS(4210),
    [anon_sym_DQUOTE] = ACTIONS(2202),
    [anon_sym_DOLLAR] = ACTIONS(2205),
    [sym_raw_string] = ACTIONS(4213),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2211),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2214),
    [anon_sym_BQUOTE] = ACTIONS(2217),
    [anon_sym_LT_LPAREN] = ACTIONS(2220),
    [anon_sym_GT_LPAREN] = ACTIONS(2220),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4216),
    [sym_word] = ACTIONS(4219),
    [anon_sym_LF] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2197),
  },
  [1282] = {
    [aux_sym__literal_repeat1] = STATE(1282),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym_variable_name] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(2229),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1373),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1283] = {
    [aux_sym_concatenation_repeat1] = STATE(1954),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(983),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1061),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [1284] = {
    [sym_concatenation] = STATE(1284),
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_string_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [aux_sym_unset_command_repeat1] = STATE(1284),
    [aux_sym__literal_repeat1] = STATE(662),
    [sym__simple_heredoc_body] = ACTIONS(2268),
    [sym__heredoc_body_beginning] = ACTIONS(2268),
    [sym_file_descriptor] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2270),
    [anon_sym_SEMI_SEMI] = ACTIONS(2268),
    [anon_sym_PIPE_AMP] = ACTIONS(2268),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [anon_sym_PIPE_PIPE] = ACTIONS(2268),
    [anon_sym_LT] = ACTIONS(2270),
    [anon_sym_GT] = ACTIONS(2270),
    [anon_sym_GT_GT] = ACTIONS(2268),
    [anon_sym_AMP_GT] = ACTIONS(2270),
    [anon_sym_AMP_GT_GT] = ACTIONS(2268),
    [anon_sym_LT_AMP] = ACTIONS(2268),
    [anon_sym_GT_AMP] = ACTIONS(2268),
    [anon_sym_LT_LT] = ACTIONS(2270),
    [anon_sym_LT_LT_DASH] = ACTIONS(2268),
    [anon_sym_LT_LT_LT] = ACTIONS(2268),
    [sym__special_character] = ACTIONS(4222),
    [anon_sym_DQUOTE] = ACTIONS(2275),
    [anon_sym_DOLLAR] = ACTIONS(2278),
    [sym_raw_string] = ACTIONS(4225),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2287),
    [anon_sym_BQUOTE] = ACTIONS(2290),
    [anon_sym_LT_LPAREN] = ACTIONS(2293),
    [anon_sym_GT_LPAREN] = ACTIONS(2293),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4228),
    [sym_word] = ACTIONS(4231),
    [anon_sym_LF] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2270),
  },
  [1285] = {
    [aux_sym__literal_repeat1] = STATE(1285),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(2302),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1373),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1286] = {
    [aux_sym_concatenation_repeat1] = STATE(1286),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2348),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2346),
    [anon_sym_EQ_EQ] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1287] = {
    [sym_concatenation] = STATE(1318),
    [sym_string] = STATE(1955),
    [sym_simple_expansion] = STATE(1955),
    [sym_string_expansion] = STATE(1955),
    [sym_expansion] = STATE(1955),
    [sym_command_substitution] = STATE(1955),
    [sym_process_substitution] = STATE(1955),
    [aux_sym__literal_repeat1] = STATE(1956),
    [sym__special_character] = ACTIONS(2518),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(4234),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4234),
  },
  [1288] = {
    [sym_file_redirect] = STATE(671),
    [sym_heredoc_redirect] = STATE(671),
    [sym_herestring_redirect] = STATE(671),
    [aux_sym_redirected_statement_repeat1] = STATE(671),
    [sym__simple_heredoc_body] = ACTIONS(2564),
    [sym__heredoc_body_beginning] = ACTIONS(2564),
    [sym_file_descriptor] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT] = ACTIONS(2566),
    [anon_sym_AMP_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_AMP] = ACTIONS(2564),
    [anon_sym_GT_AMP] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_LT_LT_DASH] = ACTIONS(2564),
    [anon_sym_LT_LT_LT] = ACTIONS(2564),
    [anon_sym_BQUOTE] = ACTIONS(2564),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2566),
  },
  [1289] = {
    [sym_file_redirect] = STATE(671),
    [sym_heredoc_redirect] = STATE(671),
    [sym_herestring_redirect] = STATE(671),
    [aux_sym_redirected_statement_repeat1] = STATE(671),
    [sym__simple_heredoc_body] = ACTIONS(2564),
    [sym__heredoc_body_beginning] = ACTIONS(2564),
    [sym_file_descriptor] = ACTIONS(2564),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT] = ACTIONS(2566),
    [anon_sym_AMP_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_AMP] = ACTIONS(2564),
    [anon_sym_GT_AMP] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_LT_LT_DASH] = ACTIONS(2564),
    [anon_sym_LT_LT_LT] = ACTIONS(2564),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(2564),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2566),
  },
  [1290] = {
    [sym_file_redirect] = STATE(671),
    [sym_heredoc_redirect] = STATE(671),
    [sym_herestring_redirect] = STATE(671),
    [aux_sym_redirected_statement_repeat1] = STATE(671),
    [sym__simple_heredoc_body] = ACTIONS(2568),
    [sym__heredoc_body_beginning] = ACTIONS(2568),
    [sym_file_descriptor] = ACTIONS(2568),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_SEMI_SEMI] = ACTIONS(2568),
    [anon_sym_PIPE_AMP] = ACTIONS(1193),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_GT] = ACTIONS(2570),
    [anon_sym_GT_GT] = ACTIONS(2568),
    [anon_sym_AMP_GT] = ACTIONS(2570),
    [anon_sym_AMP_GT_GT] = ACTIONS(2568),
    [anon_sym_LT_AMP] = ACTIONS(2568),
    [anon_sym_GT_AMP] = ACTIONS(2568),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_LT_LT_DASH] = ACTIONS(2568),
    [anon_sym_LT_LT_LT] = ACTIONS(2568),
    [anon_sym_BQUOTE] = ACTIONS(2568),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2570),
  },
  [1291] = {
    [sym_file_redirect] = STATE(671),
    [sym_heredoc_redirect] = STATE(671),
    [sym_herestring_redirect] = STATE(671),
    [aux_sym_redirected_statement_repeat1] = STATE(671),
    [sym__simple_heredoc_body] = ACTIONS(2568),
    [sym__heredoc_body_beginning] = ACTIONS(2568),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym_SEMI_SEMI] = ACTIONS(2568),
    [anon_sym_PIPE_AMP] = ACTIONS(1193),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_LT_LT_DASH] = ACTIONS(2568),
    [anon_sym_LT_LT_LT] = ACTIONS(2568),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2570),
  },
  [1292] = {
    [aux_sym_concatenation_repeat1] = STATE(1957),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [1293] = {
    [aux_sym_concatenation_repeat1] = STATE(1957),
    [sym__simple_heredoc_body] = ACTIONS(1037),
    [sym__heredoc_body_beginning] = ACTIONS(1037),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [anon_sym_BQUOTE] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [1294] = {
    [aux_sym__literal_repeat1] = STATE(1958),
    [sym__simple_heredoc_body] = ACTIONS(1051),
    [sym__heredoc_body_beginning] = ACTIONS(1051),
    [sym_file_descriptor] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_LT_LT_DASH] = ACTIONS(1051),
    [anon_sym_LT_LT_LT] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(1051),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1051),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [1295] = {
    [aux_sym_concatenation_repeat1] = STATE(1957),
    [sym__simple_heredoc_body] = ACTIONS(2576),
    [sym__heredoc_body_beginning] = ACTIONS(2576),
    [sym_file_descriptor] = ACTIONS(2576),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI_SEMI] = ACTIONS(2576),
    [anon_sym_PIPE_AMP] = ACTIONS(2576),
    [anon_sym_AMP_AMP] = ACTIONS(2576),
    [anon_sym_PIPE_PIPE] = ACTIONS(2576),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_GT] = ACTIONS(2576),
    [anon_sym_AMP_GT] = ACTIONS(2578),
    [anon_sym_AMP_GT_GT] = ACTIONS(2576),
    [anon_sym_LT_AMP] = ACTIONS(2576),
    [anon_sym_GT_AMP] = ACTIONS(2576),
    [anon_sym_LT_LT] = ACTIONS(2578),
    [anon_sym_LT_LT_DASH] = ACTIONS(2576),
    [anon_sym_LT_LT_LT] = ACTIONS(2576),
    [anon_sym_BQUOTE] = ACTIONS(2576),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2576),
    [anon_sym_AMP] = ACTIONS(2578),
  },
  [1296] = {
    [aux_sym__literal_repeat1] = STATE(1958),
    [sym__simple_heredoc_body] = ACTIONS(2580),
    [sym__heredoc_body_beginning] = ACTIONS(2580),
    [sym_file_descriptor] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_SEMI_SEMI] = ACTIONS(2580),
    [anon_sym_PIPE_AMP] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_AMP_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_AMP] = ACTIONS(2580),
    [anon_sym_GT_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2582),
    [anon_sym_LT_LT_DASH] = ACTIONS(2580),
    [anon_sym_LT_LT_LT] = ACTIONS(2580),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(2580),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2580),
    [anon_sym_AMP] = ACTIONS(2582),
  },
  [1297] = {
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(2584),
    [anon_sym_for] = ACTIONS(2588),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_case] = ACTIONS(2588),
    [anon_sym_function] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2584),
    [anon_sym_declare] = ACTIONS(2588),
    [anon_sym_typeset] = ACTIONS(2588),
    [anon_sym_export] = ACTIONS(2588),
    [anon_sym_readonly] = ACTIONS(2588),
    [anon_sym_local] = ACTIONS(2588),
    [anon_sym_unset] = ACTIONS(2588),
    [anon_sym_unsetenv] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [sym__special_character] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2584),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2584),
    [anon_sym_BQUOTE] = ACTIONS(2586),
    [anon_sym_LT_LPAREN] = ACTIONS(2584),
    [anon_sym_GT_LPAREN] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
  },
  [1298] = {
    [sym_file_redirect] = STATE(1298),
    [sym_heredoc_redirect] = STATE(1298),
    [sym_herestring_redirect] = STATE(1298),
    [aux_sym_redirected_statement_repeat1] = STATE(1298),
    [sym__simple_heredoc_body] = ACTIONS(2590),
    [sym__heredoc_body_beginning] = ACTIONS(2590),
    [sym_file_descriptor] = ACTIONS(4236),
    [anon_sym_SEMI] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(2595),
    [anon_sym_SEMI_SEMI] = ACTIONS(2590),
    [anon_sym_PIPE_AMP] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(4239),
    [anon_sym_GT] = ACTIONS(4239),
    [anon_sym_GT_GT] = ACTIONS(4242),
    [anon_sym_AMP_GT] = ACTIONS(4239),
    [anon_sym_AMP_GT_GT] = ACTIONS(4242),
    [anon_sym_LT_AMP] = ACTIONS(4242),
    [anon_sym_GT_AMP] = ACTIONS(4242),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_LT_LT_DASH] = ACTIONS(2606),
    [anon_sym_LT_LT_LT] = ACTIONS(4245),
    [anon_sym_BQUOTE] = ACTIONS(2590),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2595),
  },
  [1299] = {
    [aux_sym_concatenation_repeat1] = STATE(663),
    [sym__simple_heredoc_body] = ACTIONS(2612),
    [sym__heredoc_body_beginning] = ACTIONS(2612),
    [sym_file_descriptor] = ACTIONS(2612),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(2614),
    [anon_sym_EQ_EQ] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2612),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2612),
    [anon_sym_BQUOTE] = ACTIONS(2612),
    [anon_sym_LT_LPAREN] = ACTIONS(2612),
    [anon_sym_GT_LPAREN] = ACTIONS(2612),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2614),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [1300] = {
    [aux_sym__literal_repeat1] = STATE(679),
    [sym__simple_heredoc_body] = ACTIONS(2616),
    [sym__heredoc_body_beginning] = ACTIONS(2616),
    [sym_file_descriptor] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_SEMI_SEMI] = ACTIONS(2616),
    [anon_sym_PIPE_AMP] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_EQ_TILDE] = ACTIONS(2618),
    [anon_sym_EQ_EQ] = ACTIONS(2618),
    [anon_sym_LT] = ACTIONS(2618),
    [anon_sym_GT] = ACTIONS(2618),
    [anon_sym_GT_GT] = ACTIONS(2616),
    [anon_sym_AMP_GT] = ACTIONS(2618),
    [anon_sym_AMP_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_AMP] = ACTIONS(2616),
    [anon_sym_GT_AMP] = ACTIONS(2616),
    [anon_sym_LT_LT] = ACTIONS(2618),
    [anon_sym_LT_LT_DASH] = ACTIONS(2616),
    [anon_sym_LT_LT_LT] = ACTIONS(2616),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(2616),
    [anon_sym_DOLLAR] = ACTIONS(2618),
    [sym_raw_string] = ACTIONS(2616),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2616),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2616),
    [anon_sym_BQUOTE] = ACTIONS(2616),
    [anon_sym_LT_LPAREN] = ACTIONS(2616),
    [anon_sym_GT_LPAREN] = ACTIONS(2616),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2618),
    [anon_sym_LF] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2618),
  },
  [1301] = {
    [sym_concatenation] = STATE(1301),
    [sym_string] = STATE(673),
    [sym_simple_expansion] = STATE(673),
    [sym_string_expansion] = STATE(673),
    [sym_expansion] = STATE(673),
    [sym_command_substitution] = STATE(673),
    [sym_process_substitution] = STATE(673),
    [aux_sym_command_repeat2] = STATE(1301),
    [aux_sym__literal_repeat1] = STATE(675),
    [sym__simple_heredoc_body] = ACTIONS(2612),
    [sym__heredoc_body_beginning] = ACTIONS(2612),
    [sym_file_descriptor] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(4248),
    [anon_sym_EQ_EQ] = ACTIONS(4248),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(4251),
    [anon_sym_DQUOTE] = ACTIONS(2626),
    [anon_sym_DOLLAR] = ACTIONS(2629),
    [sym_raw_string] = ACTIONS(4254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2638),
    [anon_sym_BQUOTE] = ACTIONS(2641),
    [anon_sym_LT_LPAREN] = ACTIONS(2644),
    [anon_sym_GT_LPAREN] = ACTIONS(2644),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4257),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [1302] = {
    [sym_file_descriptor] = ACTIONS(1235),
    [sym_variable_name] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1239),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1239),
    [anon_sym_if] = ACTIONS(1239),
    [anon_sym_case] = ACTIONS(1239),
    [anon_sym_function] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1239),
    [anon_sym_typeset] = ACTIONS(1239),
    [anon_sym_export] = ACTIONS(1239),
    [anon_sym_readonly] = ACTIONS(1239),
    [anon_sym_local] = ACTIONS(1239),
    [anon_sym_unset] = ACTIONS(1239),
    [anon_sym_unsetenv] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_AMP_GT] = ACTIONS(1239),
    [anon_sym_AMP_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_AMP] = ACTIONS(1235),
    [anon_sym_GT_AMP] = ACTIONS(1235),
    [sym__special_character] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_DOLLAR] = ACTIONS(1239),
    [sym_raw_string] = ACTIONS(1235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1235),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1235),
    [anon_sym_BQUOTE] = ACTIONS(2586),
    [anon_sym_LT_LPAREN] = ACTIONS(1235),
    [anon_sym_GT_LPAREN] = ACTIONS(1235),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1239),
  },
  [1303] = {
    [anon_sym_SEMI] = ACTIONS(4260),
    [anon_sym_SEMI_SEMI] = ACTIONS(4262),
    [anon_sym_BQUOTE] = ACTIONS(2586),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4262),
  },
  [1304] = {
    [sym_concatenation] = STATE(1301),
    [sym_string] = STATE(673),
    [sym_simple_expansion] = STATE(673),
    [sym_string_expansion] = STATE(673),
    [sym_expansion] = STATE(673),
    [sym_command_substitution] = STATE(673),
    [sym_process_substitution] = STATE(673),
    [aux_sym_command_repeat2] = STATE(1301),
    [aux_sym__literal_repeat1] = STATE(675),
    [sym__simple_heredoc_body] = ACTIONS(2676),
    [sym__heredoc_body_beginning] = ACTIONS(2676),
    [sym_file_descriptor] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym_PIPE] = ACTIONS(2678),
    [anon_sym_SEMI_SEMI] = ACTIONS(2676),
    [anon_sym_PIPE_AMP] = ACTIONS(2676),
    [anon_sym_AMP_AMP] = ACTIONS(2676),
    [anon_sym_PIPE_PIPE] = ACTIONS(2676),
    [anon_sym_EQ_TILDE] = ACTIONS(1203),
    [anon_sym_EQ_EQ] = ACTIONS(1203),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_GT] = ACTIONS(2678),
    [anon_sym_GT_GT] = ACTIONS(2676),
    [anon_sym_AMP_GT] = ACTIONS(2678),
    [anon_sym_AMP_GT_GT] = ACTIONS(2676),
    [anon_sym_LT_AMP] = ACTIONS(2676),
    [anon_sym_GT_AMP] = ACTIONS(2676),
    [anon_sym_LT_LT] = ACTIONS(2678),
    [anon_sym_LT_LT_DASH] = ACTIONS(2676),
    [anon_sym_LT_LT_LT] = ACTIONS(2676),
    [sym__special_character] = ACTIONS(1205),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(2676),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1209),
    [anon_sym_LF] = ACTIONS(2676),
    [anon_sym_AMP] = ACTIONS(2678),
  },
  [1305] = {
    [sym__simple_heredoc_body] = ACTIONS(4264),
    [sym__heredoc_body_beginning] = ACTIONS(4264),
    [sym_file_descriptor] = ACTIONS(4264),
    [ts_builtin_sym_end] = ACTIONS(4264),
    [anon_sym_SEMI] = ACTIONS(4266),
    [anon_sym_done] = ACTIONS(4264),
    [anon_sym_fi] = ACTIONS(4264),
    [anon_sym_elif] = ACTIONS(4264),
    [anon_sym_else] = ACTIONS(4264),
    [anon_sym_esac] = ACTIONS(4264),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_RPAREN] = ACTIONS(4264),
    [anon_sym_SEMI_SEMI] = ACTIONS(4264),
    [anon_sym_PIPE_AMP] = ACTIONS(4264),
    [anon_sym_AMP_AMP] = ACTIONS(4264),
    [anon_sym_PIPE_PIPE] = ACTIONS(4264),
    [anon_sym_LT] = ACTIONS(4266),
    [anon_sym_GT] = ACTIONS(4266),
    [anon_sym_GT_GT] = ACTIONS(4264),
    [anon_sym_AMP_GT] = ACTIONS(4266),
    [anon_sym_AMP_GT_GT] = ACTIONS(4264),
    [anon_sym_LT_AMP] = ACTIONS(4264),
    [anon_sym_GT_AMP] = ACTIONS(4264),
    [anon_sym_LT_LT] = ACTIONS(4266),
    [anon_sym_LT_LT_DASH] = ACTIONS(4264),
    [anon_sym_LT_LT_LT] = ACTIONS(4264),
    [anon_sym_BQUOTE] = ACTIONS(4264),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4264),
    [anon_sym_AMP] = ACTIONS(4266),
  },
  [1306] = {
    [sym__heredoc_body_middle] = ACTIONS(1097),
    [sym__heredoc_body_end] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
  },
  [1307] = {
    [sym__heredoc_body_middle] = ACTIONS(1105),
    [sym__heredoc_body_end] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
  },
  [1308] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(4268),
    [sym_comment] = ACTIONS(57),
  },
  [1309] = {
    [sym_subscript] = STATE(1963),
    [sym_variable_name] = ACTIONS(4270),
    [anon_sym_DASH] = ACTIONS(4272),
    [anon_sym_DOLLAR] = ACTIONS(4272),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4274),
    [anon_sym_STAR] = ACTIONS(4276),
    [anon_sym_AT] = ACTIONS(4276),
    [anon_sym_QMARK] = ACTIONS(4276),
    [anon_sym_0] = ACTIONS(4274),
    [anon_sym__] = ACTIONS(4274),
  },
  [1310] = {
    [sym_concatenation] = STATE(1966),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1966),
    [anon_sym_RBRACE] = ACTIONS(4278),
    [anon_sym_EQ] = ACTIONS(4280),
    [anon_sym_DASH] = ACTIONS(4280),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4282),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4284),
    [anon_sym_COLON] = ACTIONS(4280),
    [anon_sym_COLON_QMARK] = ACTIONS(4280),
    [anon_sym_COLON_DASH] = ACTIONS(4280),
    [anon_sym_PERCENT] = ACTIONS(4280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1311] = {
    [sym_concatenation] = STATE(1969),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1969),
    [anon_sym_RBRACE] = ACTIONS(4286),
    [anon_sym_EQ] = ACTIONS(4288),
    [anon_sym_DASH] = ACTIONS(4288),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4290),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4292),
    [anon_sym_COLON] = ACTIONS(4288),
    [anon_sym_COLON_QMARK] = ACTIONS(4288),
    [anon_sym_COLON_DASH] = ACTIONS(4288),
    [anon_sym_PERCENT] = ACTIONS(4288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1312] = {
    [anon_sym_RPAREN] = ACTIONS(4294),
    [sym_comment] = ACTIONS(57),
  },
  [1313] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(4294),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1314] = {
    [anon_sym_BQUOTE] = ACTIONS(4294),
    [sym_comment] = ACTIONS(57),
  },
  [1315] = {
    [ts_builtin_sym_end] = ACTIONS(4296),
    [anon_sym_SEMI] = ACTIONS(4298),
    [anon_sym_done] = ACTIONS(4296),
    [anon_sym_fi] = ACTIONS(4296),
    [anon_sym_elif] = ACTIONS(4296),
    [anon_sym_else] = ACTIONS(4296),
    [anon_sym_esac] = ACTIONS(4296),
    [anon_sym_RPAREN] = ACTIONS(4296),
    [anon_sym_SEMI_SEMI] = ACTIONS(4296),
    [anon_sym_BQUOTE] = ACTIONS(4296),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4296),
    [anon_sym_AMP] = ACTIONS(4296),
  },
  [1316] = {
    [sym_simple_expansion] = STATE(1316),
    [sym_expansion] = STATE(1316),
    [sym_command_substitution] = STATE(1316),
    [aux_sym_heredoc_body_repeat1] = STATE(1316),
    [sym__heredoc_body_middle] = ACTIONS(4300),
    [sym__heredoc_body_end] = ACTIONS(4303),
    [anon_sym_DOLLAR] = ACTIONS(4305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4308),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4311),
    [anon_sym_BQUOTE] = ACTIONS(4314),
    [sym_comment] = ACTIONS(57),
  },
  [1317] = {
    [aux_sym_concatenation_repeat1] = STATE(1320),
    [sym__simple_heredoc_body] = ACTIONS(1378),
    [sym__heredoc_body_beginning] = ACTIONS(1378),
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(1378),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1378),
    [anon_sym_PIPE_AMP] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_AMP] = ACTIONS(1378),
    [anon_sym_GT_AMP] = ACTIONS(1378),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1378),
    [anon_sym_LT_LT_LT] = ACTIONS(1378),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1378),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [1318] = {
    [sym__simple_heredoc_body] = ACTIONS(1378),
    [sym__heredoc_body_beginning] = ACTIONS(1378),
    [sym_file_descriptor] = ACTIONS(1378),
    [ts_builtin_sym_end] = ACTIONS(1378),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_done] = ACTIONS(1378),
    [anon_sym_fi] = ACTIONS(1378),
    [anon_sym_elif] = ACTIONS(1378),
    [anon_sym_else] = ACTIONS(1378),
    [anon_sym_esac] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_RPAREN] = ACTIONS(1378),
    [anon_sym_SEMI_SEMI] = ACTIONS(1378),
    [anon_sym_PIPE_AMP] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_AMP] = ACTIONS(1378),
    [anon_sym_GT_AMP] = ACTIONS(1378),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1378),
    [anon_sym_LT_LT_LT] = ACTIONS(1378),
    [anon_sym_BQUOTE] = ACTIONS(1378),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1378),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [1319] = {
    [aux_sym__literal_repeat1] = STATE(1321),
    [sym__simple_heredoc_body] = ACTIONS(1382),
    [sym__heredoc_body_beginning] = ACTIONS(1382),
    [sym_file_descriptor] = ACTIONS(1382),
    [ts_builtin_sym_end] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym_PIPE] = ACTIONS(1384),
    [anon_sym_SEMI_SEMI] = ACTIONS(1382),
    [anon_sym_PIPE_AMP] = ACTIONS(1382),
    [anon_sym_AMP_AMP] = ACTIONS(1382),
    [anon_sym_PIPE_PIPE] = ACTIONS(1382),
    [anon_sym_LT] = ACTIONS(1384),
    [anon_sym_GT] = ACTIONS(1384),
    [anon_sym_GT_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT_GT] = ACTIONS(1382),
    [anon_sym_LT_AMP] = ACTIONS(1382),
    [anon_sym_GT_AMP] = ACTIONS(1382),
    [anon_sym_LT_LT] = ACTIONS(1384),
    [anon_sym_LT_LT_DASH] = ACTIONS(1382),
    [anon_sym_LT_LT_LT] = ACTIONS(1382),
    [sym__special_character] = ACTIONS(441),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
  },
  [1320] = {
    [aux_sym_concatenation_repeat1] = STATE(1971),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(327),
    [ts_builtin_sym_end] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [1321] = {
    [aux_sym__literal_repeat1] = STATE(1321),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [ts_builtin_sym_end] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(1375),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1322] = {
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(2584),
    [ts_builtin_sym_end] = ACTIONS(4317),
    [anon_sym_for] = ACTIONS(2588),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_case] = ACTIONS(2588),
    [anon_sym_RPAREN] = ACTIONS(4317),
    [anon_sym_SEMI_SEMI] = ACTIONS(4317),
    [anon_sym_function] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2584),
    [anon_sym_declare] = ACTIONS(2588),
    [anon_sym_typeset] = ACTIONS(2588),
    [anon_sym_export] = ACTIONS(2588),
    [anon_sym_readonly] = ACTIONS(2588),
    [anon_sym_local] = ACTIONS(2588),
    [anon_sym_unset] = ACTIONS(2588),
    [anon_sym_unsetenv] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [sym__special_character] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2584),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2584),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [anon_sym_LT_LPAREN] = ACTIONS(2584),
    [anon_sym_GT_LPAREN] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
  },
  [1323] = {
    [sym_variable_assignment] = STATE(1281),
    [sym_subscript] = STATE(656),
    [sym_concatenation] = STATE(1281),
    [sym_string] = STATE(655),
    [sym_simple_expansion] = STATE(655),
    [sym_string_expansion] = STATE(655),
    [sym_expansion] = STATE(655),
    [sym_command_substitution] = STATE(655),
    [sym_process_substitution] = STATE(655),
    [aux_sym_declaration_command_repeat1] = STATE(1281),
    [aux_sym__literal_repeat1] = STATE(658),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(1167),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [sym__special_character] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_DOLLAR] = ACTIONS(269),
    [sym_raw_string] = ACTIONS(1171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(275),
    [anon_sym_BQUOTE] = ACTIONS(277),
    [anon_sym_LT_LPAREN] = ACTIONS(279),
    [anon_sym_GT_LPAREN] = ACTIONS(279),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2510),
    [sym_word] = ACTIONS(1175),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [1324] = {
    [sym_concatenation] = STATE(1284),
    [sym_string] = STATE(660),
    [sym_simple_expansion] = STATE(660),
    [sym_string_expansion] = STATE(660),
    [sym_expansion] = STATE(660),
    [sym_command_substitution] = STATE(660),
    [sym_process_substitution] = STATE(660),
    [aux_sym_unset_command_repeat1] = STATE(1284),
    [aux_sym__literal_repeat1] = STATE(662),
    [sym__simple_heredoc_body] = ACTIONS(1011),
    [sym__heredoc_body_beginning] = ACTIONS(1011),
    [sym_file_descriptor] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1013),
    [anon_sym_GT] = ACTIONS(1013),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT] = ACTIONS(1013),
    [anon_sym_AMP_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_AMP] = ACTIONS(1011),
    [anon_sym_GT_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(1011),
    [anon_sym_LT_LT_LT] = ACTIONS(1011),
    [sym__special_character] = ACTIONS(1177),
    [anon_sym_DQUOTE] = ACTIONS(291),
    [anon_sym_DOLLAR] = ACTIONS(293),
    [sym_raw_string] = ACTIONS(1179),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(301),
    [anon_sym_LT_LPAREN] = ACTIONS(303),
    [anon_sym_GT_LPAREN] = ACTIONS(303),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2512),
    [sym_word] = ACTIONS(1183),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
  },
  [1325] = {
    [anon_sym_LT] = ACTIONS(4319),
    [anon_sym_GT] = ACTIONS(4319),
    [anon_sym_GT_GT] = ACTIONS(4321),
    [anon_sym_AMP_GT] = ACTIONS(4319),
    [anon_sym_AMP_GT_GT] = ACTIONS(4321),
    [anon_sym_LT_AMP] = ACTIONS(4321),
    [anon_sym_GT_AMP] = ACTIONS(4321),
    [sym_comment] = ACTIONS(57),
  },
  [1326] = {
    [sym_file_descriptor] = ACTIONS(1235),
    [sym_variable_name] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1239),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1239),
    [anon_sym_if] = ACTIONS(1239),
    [anon_sym_case] = ACTIONS(1239),
    [anon_sym_function] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1239),
    [anon_sym_typeset] = ACTIONS(1239),
    [anon_sym_export] = ACTIONS(1239),
    [anon_sym_readonly] = ACTIONS(1239),
    [anon_sym_local] = ACTIONS(1239),
    [anon_sym_unset] = ACTIONS(1239),
    [anon_sym_unsetenv] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_AMP_GT] = ACTIONS(1239),
    [anon_sym_AMP_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_AMP] = ACTIONS(1235),
    [anon_sym_GT_AMP] = ACTIONS(1235),
    [sym__special_character] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_DOLLAR] = ACTIONS(1239),
    [sym_raw_string] = ACTIONS(1235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1235),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1235),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [anon_sym_LT_LPAREN] = ACTIONS(1235),
    [anon_sym_GT_LPAREN] = ACTIONS(1235),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1239),
  },
  [1327] = {
    [sym_redirected_statement] = STATE(1973),
    [sym_for_statement] = STATE(1973),
    [sym_c_style_for_statement] = STATE(1973),
    [sym_while_statement] = STATE(1973),
    [sym_if_statement] = STATE(1973),
    [sym_case_statement] = STATE(1973),
    [sym_function_definition] = STATE(1973),
    [sym_compound_statement] = STATE(1973),
    [sym_subshell] = STATE(1973),
    [sym_pipeline] = STATE(1973),
    [sym_list] = STATE(1973),
    [sym_negated_command] = STATE(1973),
    [sym_test_command] = STATE(1973),
    [sym_declaration_command] = STATE(1973),
    [sym_unset_command] = STATE(1973),
    [sym_command] = STATE(1973),
    [sym_command_name] = STATE(713),
    [sym_variable_assignment] = STATE(1974),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(715),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym_command_repeat1] = STATE(715),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4323),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4325),
    [anon_sym_typeset] = ACTIONS(4325),
    [anon_sym_export] = ACTIONS(4325),
    [anon_sym_readonly] = ACTIONS(4325),
    [anon_sym_local] = ACTIONS(4325),
    [anon_sym_unset] = ACTIONS(4327),
    [anon_sym_unsetenv] = ACTIONS(4327),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1328] = {
    [sym_redirected_statement] = STATE(1975),
    [sym_for_statement] = STATE(1975),
    [sym_c_style_for_statement] = STATE(1975),
    [sym_while_statement] = STATE(1975),
    [sym_if_statement] = STATE(1975),
    [sym_case_statement] = STATE(1975),
    [sym_function_definition] = STATE(1975),
    [sym_compound_statement] = STATE(1975),
    [sym_subshell] = STATE(1975),
    [sym_pipeline] = STATE(1975),
    [sym_list] = STATE(1975),
    [sym_negated_command] = STATE(1975),
    [sym_test_command] = STATE(1975),
    [sym_declaration_command] = STATE(1975),
    [sym_unset_command] = STATE(1975),
    [sym_command] = STATE(1975),
    [sym_command_name] = STATE(713),
    [sym_variable_assignment] = STATE(1976),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(715),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym_command_repeat1] = STATE(715),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4323),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4325),
    [anon_sym_typeset] = ACTIONS(4325),
    [anon_sym_export] = ACTIONS(4325),
    [anon_sym_readonly] = ACTIONS(4325),
    [anon_sym_local] = ACTIONS(4325),
    [anon_sym_unset] = ACTIONS(4327),
    [anon_sym_unsetenv] = ACTIONS(4327),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1329] = {
    [sym_concatenation] = STATE(695),
    [sym_string] = STATE(1978),
    [sym_simple_expansion] = STATE(1978),
    [sym_string_expansion] = STATE(1978),
    [sym_expansion] = STATE(1978),
    [sym_command_substitution] = STATE(1978),
    [sym_process_substitution] = STATE(1978),
    [aux_sym__literal_repeat1] = STATE(1979),
    [sym__special_character] = ACTIONS(4329),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(4331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4331),
  },
  [1330] = {
    [sym_concatenation] = STATE(699),
    [sym_string] = STATE(1980),
    [sym_simple_expansion] = STATE(1980),
    [sym_string_expansion] = STATE(1980),
    [sym_expansion] = STATE(1980),
    [sym_command_substitution] = STATE(1980),
    [sym_process_substitution] = STATE(1980),
    [aux_sym__literal_repeat1] = STATE(1981),
    [sym__special_character] = ACTIONS(4329),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(4333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4333),
  },
  [1331] = {
    [anon_sym_SEMI] = ACTIONS(4335),
    [anon_sym_SEMI_SEMI] = ACTIONS(4337),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4337),
    [anon_sym_AMP] = ACTIONS(4337),
  },
  [1332] = {
    [sym_file_redirect] = STATE(1983),
    [sym_heredoc_redirect] = STATE(1983),
    [sym_herestring_redirect] = STATE(1983),
    [aux_sym_redirected_statement_repeat1] = STATE(1983),
    [sym__simple_heredoc_body] = ACTIONS(1253),
    [sym__heredoc_body_beginning] = ACTIONS(1253),
    [sym_file_descriptor] = ACTIONS(2658),
    [anon_sym_SEMI] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_SEMI_SEMI] = ACTIONS(1253),
    [anon_sym_PIPE_AMP] = ACTIONS(1253),
    [anon_sym_AMP_AMP] = ACTIONS(1253),
    [anon_sym_PIPE_PIPE] = ACTIONS(1253),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_GT] = ACTIONS(2670),
    [anon_sym_GT_GT] = ACTIONS(2672),
    [anon_sym_AMP_GT] = ACTIONS(2670),
    [anon_sym_AMP_GT_GT] = ACTIONS(2672),
    [anon_sym_LT_AMP] = ACTIONS(2672),
    [anon_sym_GT_AMP] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(2674),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1255),
  },
  [1333] = {
    [sym_concatenation] = STATE(1301),
    [sym_string] = STATE(673),
    [sym_simple_expansion] = STATE(673),
    [sym_string_expansion] = STATE(673),
    [sym_expansion] = STATE(673),
    [sym_command_substitution] = STATE(673),
    [sym_process_substitution] = STATE(673),
    [aux_sym_command_repeat2] = STATE(1301),
    [aux_sym__literal_repeat1] = STATE(675),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(1203),
    [anon_sym_EQ_EQ] = ACTIONS(1203),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(1205),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1209),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [1334] = {
    [sym_concatenation] = STATE(1984),
    [sym_string] = STATE(673),
    [sym_simple_expansion] = STATE(673),
    [sym_string_expansion] = STATE(673),
    [sym_expansion] = STATE(673),
    [sym_command_substitution] = STATE(673),
    [sym_process_substitution] = STATE(673),
    [aux_sym_command_repeat2] = STATE(1984),
    [aux_sym__literal_repeat1] = STATE(675),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(1203),
    [anon_sym_EQ_EQ] = ACTIONS(1203),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(1205),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1209),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [1335] = {
    [aux_sym_concatenation_repeat1] = STATE(1335),
    [sym__concat] = ACTIONS(3877),
    [anon_sym_RBRACK] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
  },
  [1336] = {
    [sym__concat] = ACTIONS(4339),
    [anon_sym_EQ] = ACTIONS(4341),
    [anon_sym_PLUS_EQ] = ACTIONS(4341),
    [sym_comment] = ACTIONS(57),
  },
  [1337] = {
    [anon_sym_EQ] = ACTIONS(4341),
    [anon_sym_PLUS_EQ] = ACTIONS(4341),
    [sym_comment] = ACTIONS(57),
  },
  [1338] = {
    [sym__concat] = ACTIONS(4343),
    [anon_sym_EQ] = ACTIONS(4345),
    [anon_sym_PLUS_EQ] = ACTIONS(4345),
    [sym_comment] = ACTIONS(57),
  },
  [1339] = {
    [anon_sym_EQ] = ACTIONS(4345),
    [anon_sym_PLUS_EQ] = ACTIONS(4345),
    [sym_comment] = ACTIONS(57),
  },
  [1340] = {
    [sym_string] = STATE(1987),
    [sym_simple_expansion] = STATE(1987),
    [sym_string_expansion] = STATE(1987),
    [sym_expansion] = STATE(1987),
    [sym_command_substitution] = STATE(1987),
    [sym_process_substitution] = STATE(1987),
    [sym__special_character] = ACTIONS(4347),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(4347),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4347),
  },
  [1341] = {
    [aux_sym_concatenation_repeat1] = STATE(1988),
    [sym__concat] = ACTIONS(2701),
    [anon_sym_RPAREN] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1059),
  },
  [1342] = {
    [sym__concat] = ACTIONS(1063),
    [anon_sym_RPAREN] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1063),
  },
  [1343] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(4349),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1344] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(4349),
    [anon_sym_DOLLAR] = ACTIONS(4351),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1345] = {
    [sym__concat] = ACTIONS(1097),
    [anon_sym_RPAREN] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1097),
  },
  [1346] = {
    [sym__concat] = ACTIONS(1101),
    [anon_sym_RPAREN] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1101),
  },
  [1347] = {
    [sym__concat] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1105),
  },
  [1348] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(4353),
    [sym_comment] = ACTIONS(57),
  },
  [1349] = {
    [sym_subscript] = STATE(1994),
    [sym_variable_name] = ACTIONS(4355),
    [anon_sym_DASH] = ACTIONS(4357),
    [anon_sym_DOLLAR] = ACTIONS(4357),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4359),
    [anon_sym_STAR] = ACTIONS(4361),
    [anon_sym_AT] = ACTIONS(4361),
    [anon_sym_QMARK] = ACTIONS(4361),
    [anon_sym_0] = ACTIONS(4359),
    [anon_sym__] = ACTIONS(4359),
  },
  [1350] = {
    [sym_concatenation] = STATE(1997),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1997),
    [anon_sym_RBRACE] = ACTIONS(4363),
    [anon_sym_EQ] = ACTIONS(4365),
    [anon_sym_DASH] = ACTIONS(4365),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4367),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4369),
    [anon_sym_COLON] = ACTIONS(4365),
    [anon_sym_COLON_QMARK] = ACTIONS(4365),
    [anon_sym_COLON_DASH] = ACTIONS(4365),
    [anon_sym_PERCENT] = ACTIONS(4365),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1351] = {
    [sym_concatenation] = STATE(2000),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2000),
    [anon_sym_RBRACE] = ACTIONS(4371),
    [anon_sym_EQ] = ACTIONS(4373),
    [anon_sym_DASH] = ACTIONS(4373),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4375),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4377),
    [anon_sym_COLON] = ACTIONS(4373),
    [anon_sym_COLON_QMARK] = ACTIONS(4373),
    [anon_sym_COLON_DASH] = ACTIONS(4373),
    [anon_sym_PERCENT] = ACTIONS(4373),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1352] = {
    [anon_sym_RPAREN] = ACTIONS(4379),
    [sym_comment] = ACTIONS(57),
  },
  [1353] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(4379),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1354] = {
    [anon_sym_BQUOTE] = ACTIONS(4379),
    [sym_comment] = ACTIONS(57),
  },
  [1355] = {
    [anon_sym_RPAREN] = ACTIONS(4381),
    [sym_comment] = ACTIONS(57),
  },
  [1356] = {
    [sym__simple_heredoc_body] = ACTIONS(4383),
    [sym__heredoc_body_beginning] = ACTIONS(4383),
    [sym_file_descriptor] = ACTIONS(4383),
    [sym_variable_name] = ACTIONS(4383),
    [ts_builtin_sym_end] = ACTIONS(4383),
    [anon_sym_SEMI] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_SEMI_SEMI] = ACTIONS(4383),
    [anon_sym_PIPE_AMP] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_AMP_GT] = ACTIONS(4385),
    [anon_sym_AMP_GT_GT] = ACTIONS(4383),
    [anon_sym_LT_AMP] = ACTIONS(4383),
    [anon_sym_GT_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_LT_LT_DASH] = ACTIONS(4383),
    [anon_sym_LT_LT_LT] = ACTIONS(4383),
    [sym__special_character] = ACTIONS(4383),
    [anon_sym_DQUOTE] = ACTIONS(4383),
    [anon_sym_DOLLAR] = ACTIONS(4385),
    [sym_raw_string] = ACTIONS(4383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4383),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4383),
    [anon_sym_BQUOTE] = ACTIONS(4383),
    [anon_sym_LT_LPAREN] = ACTIONS(4383),
    [anon_sym_GT_LPAREN] = ACTIONS(4383),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4385),
    [anon_sym_LF] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
  },
  [1357] = {
    [sym_concatenation] = STATE(1357),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(1357),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(4387),
    [sym__special_character] = ACTIONS(4389),
    [anon_sym_DQUOTE] = ACTIONS(4392),
    [anon_sym_DOLLAR] = ACTIONS(4395),
    [sym_raw_string] = ACTIONS(4398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4404),
    [anon_sym_BQUOTE] = ACTIONS(4407),
    [anon_sym_LT_LPAREN] = ACTIONS(4410),
    [anon_sym_GT_LPAREN] = ACTIONS(4410),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4398),
  },
  [1358] = {
    [anon_sym_RPAREN] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(325),
  },
  [1359] = {
    [aux_sym__literal_repeat1] = STATE(1359),
    [anon_sym_RPAREN] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(4413),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1371),
  },
  [1360] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [sym_variable_name] = ACTIONS(2344),
    [ts_builtin_sym_end] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_RPAREN] = ACTIONS(2344),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1361] = {
    [aux_sym_concatenation_repeat1] = STATE(1361),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(4416),
    [sym_variable_name] = ACTIONS(2344),
    [ts_builtin_sym_end] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1362] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [sym_variable_name] = ACTIONS(2351),
    [ts_builtin_sym_end] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_RPAREN] = ACTIONS(2351),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [1363] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(4419),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1364] = {
    [sym_concatenation] = STATE(2006),
    [sym_string] = STATE(2005),
    [sym_simple_expansion] = STATE(2005),
    [sym_string_expansion] = STATE(2005),
    [sym_expansion] = STATE(2005),
    [sym_command_substitution] = STATE(2005),
    [sym_process_substitution] = STATE(2005),
    [aux_sym__literal_repeat1] = STATE(2007),
    [anon_sym_RBRACE] = ACTIONS(4421),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(4423),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4423),
  },
  [1365] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(4425),
    [sym_comment] = ACTIONS(57),
  },
  [1366] = {
    [sym_concatenation] = STATE(2011),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2011),
    [anon_sym_RBRACE] = ACTIONS(4427),
    [anon_sym_EQ] = ACTIONS(4429),
    [anon_sym_DASH] = ACTIONS(4429),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4433),
    [anon_sym_COLON] = ACTIONS(4429),
    [anon_sym_COLON_QMARK] = ACTIONS(4429),
    [anon_sym_COLON_DASH] = ACTIONS(4429),
    [anon_sym_PERCENT] = ACTIONS(4429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1367] = {
    [sym_concatenation] = STATE(2013),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2013),
    [anon_sym_RBRACE] = ACTIONS(4421),
    [anon_sym_EQ] = ACTIONS(4435),
    [anon_sym_DASH] = ACTIONS(4435),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4439),
    [anon_sym_COLON] = ACTIONS(4435),
    [anon_sym_COLON_QMARK] = ACTIONS(4435),
    [anon_sym_COLON_DASH] = ACTIONS(4435),
    [anon_sym_PERCENT] = ACTIONS(4435),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1368] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [sym_variable_name] = ACTIONS(2442),
    [ts_builtin_sym_end] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_RPAREN] = ACTIONS(2442),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [1369] = {
    [sym_concatenation] = STATE(2016),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2016),
    [sym_regex] = ACTIONS(4441),
    [anon_sym_RBRACE] = ACTIONS(4443),
    [anon_sym_EQ] = ACTIONS(4445),
    [anon_sym_DASH] = ACTIONS(4445),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4447),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4445),
    [anon_sym_COLON_QMARK] = ACTIONS(4445),
    [anon_sym_COLON_DASH] = ACTIONS(4445),
    [anon_sym_PERCENT] = ACTIONS(4445),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1370] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(4443),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1371] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [sym_variable_name] = ACTIONS(2492),
    [ts_builtin_sym_end] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_RPAREN] = ACTIONS(2492),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [1372] = {
    [sym_concatenation] = STATE(2013),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2013),
    [sym_regex] = ACTIONS(4449),
    [anon_sym_RBRACE] = ACTIONS(4421),
    [anon_sym_EQ] = ACTIONS(4435),
    [anon_sym_DASH] = ACTIONS(4435),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4435),
    [anon_sym_COLON_QMARK] = ACTIONS(4435),
    [anon_sym_COLON_DASH] = ACTIONS(4435),
    [anon_sym_PERCENT] = ACTIONS(4435),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1373] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(4421),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1374] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [sym_variable_name] = ACTIONS(2500),
    [ts_builtin_sym_end] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_RPAREN] = ACTIONS(2500),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [1375] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(2534),
    [ts_builtin_sym_end] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_RPAREN] = ACTIONS(2534),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [1376] = {
    [sym_do_group] = STATE(2019),
    [sym_compound_statement] = STATE(2019),
    [anon_sym_SEMI] = ACTIONS(4451),
    [anon_sym_do] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [1377] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4453),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [1378] = {
    [sym__expression] = STATE(2021),
    [sym_binary_expression] = STATE(2021),
    [sym_unary_expression] = STATE(2021),
    [sym_postfix_expression] = STATE(2021),
    [sym_parenthesized_expression] = STATE(2021),
    [sym_concatenation] = STATE(2021),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4453),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_character] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [1379] = {
    [anon_sym_SEMI] = ACTIONS(2903),
    [anon_sym_SEMI_SEMI] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE] = ACTIONS(2901),
    [anon_sym_EQ_TILDE] = ACTIONS(2901),
    [anon_sym_EQ_EQ] = ACTIONS(2901),
    [anon_sym_EQ] = ACTIONS(2903),
    [anon_sym_PLUS_EQ] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2903),
    [anon_sym_GT] = ACTIONS(2903),
    [anon_sym_BANG_EQ] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_DASH_EQ] = ACTIONS(2901),
    [anon_sym_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_EQ] = ACTIONS(2901),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2901),
    [anon_sym_LF] = ACTIONS(2901),
    [anon_sym_AMP] = ACTIONS(2903),
  },
  [1380] = {
    [sym__concat] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2344),
    [anon_sym_EQ_EQ] = ACTIONS(2344),
    [anon_sym_EQ] = ACTIONS(2346),
    [anon_sym_PLUS_EQ] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_BANG_EQ] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(2346),
    [anon_sym_DASH] = ACTIONS(2346),
    [anon_sym_DASH_EQ] = ACTIONS(2344),
    [anon_sym_LT_EQ] = ACTIONS(2344),
    [anon_sym_GT_EQ] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2344),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1381] = {
    [aux_sym_concatenation_repeat1] = STATE(1381),
    [sym__concat] = ACTIONS(4455),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2344),
    [anon_sym_EQ_EQ] = ACTIONS(2344),
    [anon_sym_EQ] = ACTIONS(2346),
    [anon_sym_PLUS_EQ] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_BANG_EQ] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(2346),
    [anon_sym_DASH] = ACTIONS(2346),
    [anon_sym_DASH_EQ] = ACTIONS(2344),
    [anon_sym_LT_EQ] = ACTIONS(2344),
    [anon_sym_GT_EQ] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2344),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1382] = {
    [sym__concat] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_EQ_EQ] = ACTIONS(2351),
    [anon_sym_EQ] = ACTIONS(2353),
    [anon_sym_PLUS_EQ] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2353),
    [anon_sym_DASH] = ACTIONS(2353),
    [anon_sym_DASH_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2351),
    [anon_sym_GT_EQ] = ACTIONS(2351),
    [anon_sym_PLUS_PLUS] = ACTIONS(2351),
    [anon_sym_DASH_DASH] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2351),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [1383] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(4458),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1384] = {
    [sym_concatenation] = STATE(2025),
    [sym_string] = STATE(2024),
    [sym_simple_expansion] = STATE(2024),
    [sym_string_expansion] = STATE(2024),
    [sym_expansion] = STATE(2024),
    [sym_command_substitution] = STATE(2024),
    [sym_process_substitution] = STATE(2024),
    [aux_sym__literal_repeat1] = STATE(2026),
    [anon_sym_RBRACE] = ACTIONS(4460),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(4462),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4462),
  },
  [1385] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(4464),
    [sym_comment] = ACTIONS(57),
  },
  [1386] = {
    [sym_concatenation] = STATE(2030),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2030),
    [anon_sym_RBRACE] = ACTIONS(4466),
    [anon_sym_EQ] = ACTIONS(4468),
    [anon_sym_DASH] = ACTIONS(4468),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4470),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4472),
    [anon_sym_COLON] = ACTIONS(4468),
    [anon_sym_COLON_QMARK] = ACTIONS(4468),
    [anon_sym_COLON_DASH] = ACTIONS(4468),
    [anon_sym_PERCENT] = ACTIONS(4468),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1387] = {
    [sym_concatenation] = STATE(2032),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2032),
    [anon_sym_RBRACE] = ACTIONS(4460),
    [anon_sym_EQ] = ACTIONS(4474),
    [anon_sym_DASH] = ACTIONS(4474),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4478),
    [anon_sym_COLON] = ACTIONS(4474),
    [anon_sym_COLON_QMARK] = ACTIONS(4474),
    [anon_sym_COLON_DASH] = ACTIONS(4474),
    [anon_sym_PERCENT] = ACTIONS(4474),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1388] = {
    [sym__concat] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_EQ_TILDE] = ACTIONS(2442),
    [anon_sym_EQ_EQ] = ACTIONS(2442),
    [anon_sym_EQ] = ACTIONS(2444),
    [anon_sym_PLUS_EQ] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_BANG_EQ] = ACTIONS(2442),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_DASH_EQ] = ACTIONS(2442),
    [anon_sym_LT_EQ] = ACTIONS(2442),
    [anon_sym_GT_EQ] = ACTIONS(2442),
    [anon_sym_PLUS_PLUS] = ACTIONS(2442),
    [anon_sym_DASH_DASH] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2442),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [1389] = {
    [sym_concatenation] = STATE(2035),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2035),
    [sym_regex] = ACTIONS(4480),
    [anon_sym_RBRACE] = ACTIONS(4482),
    [anon_sym_EQ] = ACTIONS(4484),
    [anon_sym_DASH] = ACTIONS(4484),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4486),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4484),
    [anon_sym_COLON_QMARK] = ACTIONS(4484),
    [anon_sym_COLON_DASH] = ACTIONS(4484),
    [anon_sym_PERCENT] = ACTIONS(4484),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1390] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(4482),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1391] = {
    [sym__concat] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_EQ_TILDE] = ACTIONS(2492),
    [anon_sym_EQ_EQ] = ACTIONS(2492),
    [anon_sym_EQ] = ACTIONS(2494),
    [anon_sym_PLUS_EQ] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_BANG_EQ] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(2494),
    [anon_sym_DASH] = ACTIONS(2494),
    [anon_sym_DASH_EQ] = ACTIONS(2492),
    [anon_sym_LT_EQ] = ACTIONS(2492),
    [anon_sym_GT_EQ] = ACTIONS(2492),
    [anon_sym_PLUS_PLUS] = ACTIONS(2492),
    [anon_sym_DASH_DASH] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2492),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [1392] = {
    [sym_concatenation] = STATE(2032),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2032),
    [sym_regex] = ACTIONS(4488),
    [anon_sym_RBRACE] = ACTIONS(4460),
    [anon_sym_EQ] = ACTIONS(4474),
    [anon_sym_DASH] = ACTIONS(4474),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4476),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4474),
    [anon_sym_COLON_QMARK] = ACTIONS(4474),
    [anon_sym_COLON_DASH] = ACTIONS(4474),
    [anon_sym_PERCENT] = ACTIONS(4474),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1393] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(4460),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1394] = {
    [sym__concat] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_EQ_TILDE] = ACTIONS(2500),
    [anon_sym_EQ_EQ] = ACTIONS(2500),
    [anon_sym_EQ] = ACTIONS(2502),
    [anon_sym_PLUS_EQ] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_BANG_EQ] = ACTIONS(2500),
    [anon_sym_PLUS] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2502),
    [anon_sym_DASH_EQ] = ACTIONS(2500),
    [anon_sym_LT_EQ] = ACTIONS(2500),
    [anon_sym_GT_EQ] = ACTIONS(2500),
    [anon_sym_PLUS_PLUS] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2500),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [1395] = {
    [sym__concat] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_EQ_TILDE] = ACTIONS(2534),
    [anon_sym_EQ_EQ] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2536),
    [anon_sym_PLUS_EQ] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_BANG_EQ] = ACTIONS(2534),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_DASH_EQ] = ACTIONS(2534),
    [anon_sym_LT_EQ] = ACTIONS(2534),
    [anon_sym_GT_EQ] = ACTIONS(2534),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2534),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [1396] = {
    [anon_sym_SEMI] = ACTIONS(4490),
    [anon_sym_SEMI_SEMI] = ACTIONS(4492),
    [anon_sym_AMP_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1482),
    [anon_sym_EQ_TILDE] = ACTIONS(1484),
    [anon_sym_EQ_EQ] = ACTIONS(1484),
    [anon_sym_EQ] = ACTIONS(1486),
    [anon_sym_PLUS_EQ] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(1486),
    [anon_sym_GT] = ACTIONS(1486),
    [anon_sym_BANG_EQ] = ACTIONS(1482),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_DASH_EQ] = ACTIONS(1482),
    [anon_sym_LT_EQ] = ACTIONS(1482),
    [anon_sym_GT_EQ] = ACTIONS(1482),
    [anon_sym_PLUS_PLUS] = ACTIONS(1488),
    [anon_sym_DASH_DASH] = ACTIONS(1488),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1482),
    [anon_sym_LF] = ACTIONS(4492),
    [anon_sym_AMP] = ACTIONS(4490),
  },
  [1397] = {
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_SEMI_SEMI] = ACTIONS(2945),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE] = ACTIONS(2945),
    [anon_sym_EQ_TILDE] = ACTIONS(2945),
    [anon_sym_EQ_EQ] = ACTIONS(2945),
    [anon_sym_EQ] = ACTIONS(2947),
    [anon_sym_PLUS_EQ] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2947),
    [anon_sym_BANG_EQ] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2947),
    [anon_sym_DASH_EQ] = ACTIONS(2945),
    [anon_sym_LT_EQ] = ACTIONS(2945),
    [anon_sym_GT_EQ] = ACTIONS(2945),
    [anon_sym_PLUS_PLUS] = ACTIONS(2945),
    [anon_sym_DASH_DASH] = ACTIONS(2945),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2945),
    [anon_sym_LF] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2947),
  },
  [1398] = {
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_SEMI_SEMI] = ACTIONS(2945),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE] = ACTIONS(2945),
    [anon_sym_EQ_TILDE] = ACTIONS(2945),
    [anon_sym_EQ_EQ] = ACTIONS(2945),
    [anon_sym_EQ] = ACTIONS(2947),
    [anon_sym_PLUS_EQ] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2947),
    [anon_sym_BANG_EQ] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2947),
    [anon_sym_DASH_EQ] = ACTIONS(2945),
    [anon_sym_LT_EQ] = ACTIONS(2945),
    [anon_sym_GT_EQ] = ACTIONS(2945),
    [anon_sym_PLUS_PLUS] = ACTIONS(2945),
    [anon_sym_DASH_DASH] = ACTIONS(2945),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2945),
    [anon_sym_LF] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2947),
  },
  [1399] = {
    [sym_string] = STATE(2038),
    [sym_simple_expansion] = STATE(2038),
    [sym_string_expansion] = STATE(2038),
    [sym_expansion] = STATE(2038),
    [sym_command_substitution] = STATE(2038),
    [sym_process_substitution] = STATE(2038),
    [sym__special_character] = ACTIONS(4494),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [anon_sym_DOLLAR] = ACTIONS(1496),
    [sym_raw_string] = ACTIONS(4494),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1502),
    [anon_sym_BQUOTE] = ACTIONS(1504),
    [anon_sym_LT_LPAREN] = ACTIONS(1506),
    [anon_sym_GT_LPAREN] = ACTIONS(1506),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4494),
  },
  [1400] = {
    [aux_sym_concatenation_repeat1] = STATE(2039),
    [sym__concat] = ACTIONS(2827),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1059),
  },
  [1401] = {
    [sym__concat] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1063),
  },
  [1402] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(4496),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1403] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(4496),
    [anon_sym_DOLLAR] = ACTIONS(4498),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1404] = {
    [sym__concat] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1097),
  },
  [1405] = {
    [sym__concat] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1101),
  },
  [1406] = {
    [sym__concat] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1105),
  },
  [1407] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(4500),
    [sym_comment] = ACTIONS(57),
  },
  [1408] = {
    [sym_subscript] = STATE(2045),
    [sym_variable_name] = ACTIONS(4502),
    [anon_sym_DASH] = ACTIONS(4504),
    [anon_sym_DOLLAR] = ACTIONS(4504),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4506),
    [anon_sym_STAR] = ACTIONS(4508),
    [anon_sym_AT] = ACTIONS(4508),
    [anon_sym_QMARK] = ACTIONS(4508),
    [anon_sym_0] = ACTIONS(4506),
    [anon_sym__] = ACTIONS(4506),
  },
  [1409] = {
    [sym_concatenation] = STATE(2048),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2048),
    [anon_sym_RBRACE] = ACTIONS(4510),
    [anon_sym_EQ] = ACTIONS(4512),
    [anon_sym_DASH] = ACTIONS(4512),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4514),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4516),
    [anon_sym_COLON] = ACTIONS(4512),
    [anon_sym_COLON_QMARK] = ACTIONS(4512),
    [anon_sym_COLON_DASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1410] = {
    [sym_concatenation] = STATE(2051),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2051),
    [anon_sym_RBRACE] = ACTIONS(4518),
    [anon_sym_EQ] = ACTIONS(4520),
    [anon_sym_DASH] = ACTIONS(4520),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4522),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4524),
    [anon_sym_COLON] = ACTIONS(4520),
    [anon_sym_COLON_QMARK] = ACTIONS(4520),
    [anon_sym_COLON_DASH] = ACTIONS(4520),
    [anon_sym_PERCENT] = ACTIONS(4520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1411] = {
    [anon_sym_RPAREN] = ACTIONS(4526),
    [sym_comment] = ACTIONS(57),
  },
  [1412] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(4526),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1413] = {
    [anon_sym_BQUOTE] = ACTIONS(4526),
    [sym_comment] = ACTIONS(57),
  },
  [1414] = {
    [anon_sym_RPAREN] = ACTIONS(4528),
    [sym_comment] = ACTIONS(57),
  },
  [1415] = {
    [sym_do_group] = STATE(2054),
    [anon_sym_do] = ACTIONS(651),
    [sym_comment] = ACTIONS(57),
  },
  [1416] = {
    [sym_concatenation] = STATE(1416),
    [sym_string] = STATE(783),
    [sym_simple_expansion] = STATE(783),
    [sym_string_expansion] = STATE(783),
    [sym_expansion] = STATE(783),
    [sym_command_substitution] = STATE(783),
    [sym_process_substitution] = STATE(783),
    [aux_sym_for_statement_repeat1] = STATE(1416),
    [aux_sym__literal_repeat1] = STATE(789),
    [anon_sym_SEMI] = ACTIONS(4530),
    [anon_sym_SEMI_SEMI] = ACTIONS(4387),
    [sym__special_character] = ACTIONS(4532),
    [anon_sym_DQUOTE] = ACTIONS(4535),
    [anon_sym_DOLLAR] = ACTIONS(4538),
    [sym_raw_string] = ACTIONS(4541),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4547),
    [anon_sym_BQUOTE] = ACTIONS(4550),
    [anon_sym_LT_LPAREN] = ACTIONS(4553),
    [anon_sym_GT_LPAREN] = ACTIONS(4553),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4556),
    [anon_sym_LF] = ACTIONS(4387),
    [anon_sym_AMP] = ACTIONS(4387),
  },
  [1417] = {
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(325),
  },
  [1418] = {
    [aux_sym__literal_repeat1] = STATE(1418),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(4559),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1371),
  },
  [1419] = {
    [anon_sym_RPAREN] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE] = ACTIONS(2901),
    [anon_sym_EQ_TILDE] = ACTIONS(2901),
    [anon_sym_EQ_EQ] = ACTIONS(2901),
    [anon_sym_EQ] = ACTIONS(2903),
    [anon_sym_PLUS_EQ] = ACTIONS(2901),
    [anon_sym_LT] = ACTIONS(2903),
    [anon_sym_GT] = ACTIONS(2903),
    [anon_sym_BANG_EQ] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_DASH_EQ] = ACTIONS(2901),
    [anon_sym_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_EQ] = ACTIONS(2901),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2901),
  },
  [1420] = {
    [sym__concat] = ACTIONS(2344),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_RPAREN] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2344),
    [anon_sym_EQ_EQ] = ACTIONS(2344),
    [anon_sym_EQ] = ACTIONS(2346),
    [anon_sym_PLUS_EQ] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_BANG_EQ] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(2346),
    [anon_sym_DASH] = ACTIONS(2346),
    [anon_sym_DASH_EQ] = ACTIONS(2344),
    [anon_sym_LT_EQ] = ACTIONS(2344),
    [anon_sym_GT_EQ] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2344),
  },
  [1421] = {
    [aux_sym_concatenation_repeat1] = STATE(1421),
    [sym__concat] = ACTIONS(4562),
    [anon_sym_RPAREN] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2344),
    [anon_sym_EQ_EQ] = ACTIONS(2344),
    [anon_sym_EQ] = ACTIONS(2346),
    [anon_sym_PLUS_EQ] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_BANG_EQ] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(2346),
    [anon_sym_DASH] = ACTIONS(2346),
    [anon_sym_DASH_EQ] = ACTIONS(2344),
    [anon_sym_LT_EQ] = ACTIONS(2344),
    [anon_sym_GT_EQ] = ACTIONS(2344),
    [anon_sym_PLUS_PLUS] = ACTIONS(2344),
    [anon_sym_DASH_DASH] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2344),
  },
  [1422] = {
    [sym__concat] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_RPAREN] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_EQ_TILDE] = ACTIONS(2351),
    [anon_sym_EQ_EQ] = ACTIONS(2351),
    [anon_sym_EQ] = ACTIONS(2353),
    [anon_sym_PLUS_EQ] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_BANG_EQ] = ACTIONS(2351),
    [anon_sym_PLUS] = ACTIONS(2353),
    [anon_sym_DASH] = ACTIONS(2353),
    [anon_sym_DASH_EQ] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2351),
    [anon_sym_GT_EQ] = ACTIONS(2351),
    [anon_sym_PLUS_PLUS] = ACTIONS(2351),
    [anon_sym_DASH_DASH] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2351),
  },
  [1423] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(4565),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1424] = {
    [sym_concatenation] = STATE(2058),
    [sym_string] = STATE(2057),
    [sym_simple_expansion] = STATE(2057),
    [sym_string_expansion] = STATE(2057),
    [sym_expansion] = STATE(2057),
    [sym_command_substitution] = STATE(2057),
    [sym_process_substitution] = STATE(2057),
    [aux_sym__literal_repeat1] = STATE(2059),
    [anon_sym_RBRACE] = ACTIONS(4567),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(4569),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4569),
  },
  [1425] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(4571),
    [sym_comment] = ACTIONS(57),
  },
  [1426] = {
    [sym_concatenation] = STATE(2063),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2063),
    [anon_sym_RBRACE] = ACTIONS(4573),
    [anon_sym_EQ] = ACTIONS(4575),
    [anon_sym_DASH] = ACTIONS(4575),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4577),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4579),
    [anon_sym_COLON] = ACTIONS(4575),
    [anon_sym_COLON_QMARK] = ACTIONS(4575),
    [anon_sym_COLON_DASH] = ACTIONS(4575),
    [anon_sym_PERCENT] = ACTIONS(4575),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1427] = {
    [sym_concatenation] = STATE(2065),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2065),
    [anon_sym_RBRACE] = ACTIONS(4567),
    [anon_sym_EQ] = ACTIONS(4581),
    [anon_sym_DASH] = ACTIONS(4581),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4585),
    [anon_sym_COLON] = ACTIONS(4581),
    [anon_sym_COLON_QMARK] = ACTIONS(4581),
    [anon_sym_COLON_DASH] = ACTIONS(4581),
    [anon_sym_PERCENT] = ACTIONS(4581),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1428] = {
    [sym__concat] = ACTIONS(2442),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_RPAREN] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_EQ_TILDE] = ACTIONS(2442),
    [anon_sym_EQ_EQ] = ACTIONS(2442),
    [anon_sym_EQ] = ACTIONS(2444),
    [anon_sym_PLUS_EQ] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_BANG_EQ] = ACTIONS(2442),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_DASH_EQ] = ACTIONS(2442),
    [anon_sym_LT_EQ] = ACTIONS(2442),
    [anon_sym_GT_EQ] = ACTIONS(2442),
    [anon_sym_PLUS_PLUS] = ACTIONS(2442),
    [anon_sym_DASH_DASH] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2442),
  },
  [1429] = {
    [sym_concatenation] = STATE(2068),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2068),
    [sym_regex] = ACTIONS(4587),
    [anon_sym_RBRACE] = ACTIONS(4589),
    [anon_sym_EQ] = ACTIONS(4591),
    [anon_sym_DASH] = ACTIONS(4591),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4593),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4591),
    [anon_sym_COLON_QMARK] = ACTIONS(4591),
    [anon_sym_COLON_DASH] = ACTIONS(4591),
    [anon_sym_PERCENT] = ACTIONS(4591),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1430] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(4589),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1431] = {
    [sym__concat] = ACTIONS(2492),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_RPAREN] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_EQ_TILDE] = ACTIONS(2492),
    [anon_sym_EQ_EQ] = ACTIONS(2492),
    [anon_sym_EQ] = ACTIONS(2494),
    [anon_sym_PLUS_EQ] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_BANG_EQ] = ACTIONS(2492),
    [anon_sym_PLUS] = ACTIONS(2494),
    [anon_sym_DASH] = ACTIONS(2494),
    [anon_sym_DASH_EQ] = ACTIONS(2492),
    [anon_sym_LT_EQ] = ACTIONS(2492),
    [anon_sym_GT_EQ] = ACTIONS(2492),
    [anon_sym_PLUS_PLUS] = ACTIONS(2492),
    [anon_sym_DASH_DASH] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2492),
  },
  [1432] = {
    [sym_concatenation] = STATE(2065),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2065),
    [sym_regex] = ACTIONS(4595),
    [anon_sym_RBRACE] = ACTIONS(4567),
    [anon_sym_EQ] = ACTIONS(4581),
    [anon_sym_DASH] = ACTIONS(4581),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4581),
    [anon_sym_COLON_QMARK] = ACTIONS(4581),
    [anon_sym_COLON_DASH] = ACTIONS(4581),
    [anon_sym_PERCENT] = ACTIONS(4581),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1433] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(4567),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1434] = {
    [sym__concat] = ACTIONS(2500),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_RPAREN] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_EQ_TILDE] = ACTIONS(2500),
    [anon_sym_EQ_EQ] = ACTIONS(2500),
    [anon_sym_EQ] = ACTIONS(2502),
    [anon_sym_PLUS_EQ] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_BANG_EQ] = ACTIONS(2500),
    [anon_sym_PLUS] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2502),
    [anon_sym_DASH_EQ] = ACTIONS(2500),
    [anon_sym_LT_EQ] = ACTIONS(2500),
    [anon_sym_GT_EQ] = ACTIONS(2500),
    [anon_sym_PLUS_PLUS] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2500),
  },
  [1435] = {
    [sym__concat] = ACTIONS(2534),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_RPAREN] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_EQ_TILDE] = ACTIONS(2534),
    [anon_sym_EQ_EQ] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2536),
    [anon_sym_PLUS_EQ] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_BANG_EQ] = ACTIONS(2534),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_DASH_EQ] = ACTIONS(2534),
    [anon_sym_LT_EQ] = ACTIONS(2534),
    [anon_sym_GT_EQ] = ACTIONS(2534),
    [anon_sym_PLUS_PLUS] = ACTIONS(2534),
    [anon_sym_DASH_DASH] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2534),
  },
  [1436] = {
    [anon_sym_RPAREN] = ACTIONS(2945),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE] = ACTIONS(2945),
    [anon_sym_EQ_TILDE] = ACTIONS(2945),
    [anon_sym_EQ_EQ] = ACTIONS(2945),
    [anon_sym_EQ] = ACTIONS(2947),
    [anon_sym_PLUS_EQ] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2947),
    [anon_sym_BANG_EQ] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2947),
    [anon_sym_DASH_EQ] = ACTIONS(2945),
    [anon_sym_LT_EQ] = ACTIONS(2945),
    [anon_sym_GT_EQ] = ACTIONS(2945),
    [anon_sym_PLUS_PLUS] = ACTIONS(2945),
    [anon_sym_DASH_DASH] = ACTIONS(2945),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2945),
  },
  [1437] = {
    [anon_sym_RPAREN] = ACTIONS(2945),
    [anon_sym_AMP_AMP] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE] = ACTIONS(2945),
    [anon_sym_EQ_TILDE] = ACTIONS(2945),
    [anon_sym_EQ_EQ] = ACTIONS(2945),
    [anon_sym_EQ] = ACTIONS(2947),
    [anon_sym_PLUS_EQ] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2947),
    [anon_sym_BANG_EQ] = ACTIONS(2945),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_DASH] = ACTIONS(2947),
    [anon_sym_DASH_EQ] = ACTIONS(2945),
    [anon_sym_LT_EQ] = ACTIONS(2945),
    [anon_sym_GT_EQ] = ACTIONS(2945),
    [anon_sym_PLUS_PLUS] = ACTIONS(2945),
    [anon_sym_DASH_DASH] = ACTIONS(2945),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(2945),
  },
  [1438] = {
    [sym__concat] = ACTIONS(4053),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4053),
    [anon_sym_EQ_TILDE] = ACTIONS(4053),
    [anon_sym_EQ_EQ] = ACTIONS(4053),
    [anon_sym_EQ] = ACTIONS(4055),
    [anon_sym_PLUS_EQ] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_BANG_EQ] = ACTIONS(4053),
    [anon_sym_PLUS] = ACTIONS(4055),
    [anon_sym_DASH] = ACTIONS(4055),
    [anon_sym_DASH_EQ] = ACTIONS(4053),
    [anon_sym_LT_EQ] = ACTIONS(4053),
    [anon_sym_GT_EQ] = ACTIONS(4053),
    [anon_sym_PLUS_PLUS] = ACTIONS(4053),
    [anon_sym_DASH_DASH] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4053),
  },
  [1439] = {
    [sym__concat] = ACTIONS(4067),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4067),
    [anon_sym_EQ_TILDE] = ACTIONS(4067),
    [anon_sym_EQ_EQ] = ACTIONS(4067),
    [anon_sym_EQ] = ACTIONS(4069),
    [anon_sym_PLUS_EQ] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_BANG_EQ] = ACTIONS(4067),
    [anon_sym_PLUS] = ACTIONS(4069),
    [anon_sym_DASH] = ACTIONS(4069),
    [anon_sym_DASH_EQ] = ACTIONS(4067),
    [anon_sym_LT_EQ] = ACTIONS(4067),
    [anon_sym_GT_EQ] = ACTIONS(4067),
    [anon_sym_PLUS_PLUS] = ACTIONS(4067),
    [anon_sym_DASH_DASH] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4067),
  },
  [1440] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(4597),
    [sym_comment] = ACTIONS(57),
  },
  [1441] = {
    [anon_sym_RBRACE] = ACTIONS(4597),
    [sym_comment] = ACTIONS(57),
  },
  [1442] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(4599),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [1443] = {
    [sym_concatenation] = STATE(2073),
    [sym_string] = STATE(2072),
    [sym_simple_expansion] = STATE(2072),
    [sym_string_expansion] = STATE(2072),
    [sym_expansion] = STATE(2072),
    [sym_command_substitution] = STATE(2072),
    [sym_process_substitution] = STATE(2072),
    [aux_sym__literal_repeat1] = STATE(2074),
    [anon_sym_RBRACE] = ACTIONS(4597),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(4601),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4601),
  },
  [1444] = {
    [sym__concat] = ACTIONS(4103),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4103),
    [anon_sym_EQ_TILDE] = ACTIONS(4103),
    [anon_sym_EQ_EQ] = ACTIONS(4103),
    [anon_sym_EQ] = ACTIONS(4105),
    [anon_sym_PLUS_EQ] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_BANG_EQ] = ACTIONS(4103),
    [anon_sym_PLUS] = ACTIONS(4105),
    [anon_sym_DASH] = ACTIONS(4105),
    [anon_sym_DASH_EQ] = ACTIONS(4103),
    [anon_sym_LT_EQ] = ACTIONS(4103),
    [anon_sym_GT_EQ] = ACTIONS(4103),
    [anon_sym_PLUS_PLUS] = ACTIONS(4103),
    [anon_sym_DASH_DASH] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4103),
  },
  [1445] = {
    [sym_concatenation] = STATE(2077),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2077),
    [sym_regex] = ACTIONS(4603),
    [anon_sym_RBRACE] = ACTIONS(4605),
    [anon_sym_EQ] = ACTIONS(4607),
    [anon_sym_DASH] = ACTIONS(4607),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4609),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4607),
    [anon_sym_COLON_QMARK] = ACTIONS(4607),
    [anon_sym_COLON_DASH] = ACTIONS(4607),
    [anon_sym_PERCENT] = ACTIONS(4607),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1446] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(4605),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1447] = {
    [sym_concatenation] = STATE(2079),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2079),
    [sym_regex] = ACTIONS(4611),
    [anon_sym_RBRACE] = ACTIONS(4597),
    [anon_sym_EQ] = ACTIONS(4613),
    [anon_sym_DASH] = ACTIONS(4613),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4613),
    [anon_sym_COLON_QMARK] = ACTIONS(4613),
    [anon_sym_COLON_DASH] = ACTIONS(4613),
    [anon_sym_PERCENT] = ACTIONS(4613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1448] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(4597),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1449] = {
    [sym_concatenation] = STATE(2081),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2081),
    [anon_sym_RBRACE] = ACTIONS(4617),
    [anon_sym_EQ] = ACTIONS(4619),
    [anon_sym_DASH] = ACTIONS(4619),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4621),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4619),
    [anon_sym_COLON_QMARK] = ACTIONS(4619),
    [anon_sym_COLON_DASH] = ACTIONS(4619),
    [anon_sym_PERCENT] = ACTIONS(4619),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1450] = {
    [sym__concat] = ACTIONS(4159),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(4159),
    [anon_sym_EQ_TILDE] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4159),
    [anon_sym_EQ] = ACTIONS(4161),
    [anon_sym_PLUS_EQ] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_BANG_EQ] = ACTIONS(4159),
    [anon_sym_PLUS] = ACTIONS(4161),
    [anon_sym_DASH] = ACTIONS(4161),
    [anon_sym_DASH_EQ] = ACTIONS(4159),
    [anon_sym_LT_EQ] = ACTIONS(4159),
    [anon_sym_GT_EQ] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4159),
    [anon_sym_DASH_DASH] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4159),
  },
  [1451] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(4617),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1452] = {
    [sym_concatenation] = STATE(2079),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2079),
    [anon_sym_RBRACE] = ACTIONS(4597),
    [anon_sym_EQ] = ACTIONS(4613),
    [anon_sym_DASH] = ACTIONS(4613),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4613),
    [anon_sym_COLON_QMARK] = ACTIONS(4613),
    [anon_sym_COLON_DASH] = ACTIONS(4613),
    [anon_sym_PERCENT] = ACTIONS(4613),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1453] = {
    [sym_file_descriptor] = ACTIONS(2697),
    [sym_variable_name] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI_SEMI] = ACTIONS(2697),
    [anon_sym_PIPE_AMP] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_PIPE_PIPE] = ACTIONS(2697),
    [anon_sym_LT] = ACTIONS(2699),
    [anon_sym_GT] = ACTIONS(2699),
    [anon_sym_GT_GT] = ACTIONS(2697),
    [anon_sym_AMP_GT] = ACTIONS(2699),
    [anon_sym_AMP_GT_GT] = ACTIONS(2697),
    [anon_sym_LT_AMP] = ACTIONS(2697),
    [anon_sym_GT_AMP] = ACTIONS(2697),
    [anon_sym_LT_LT] = ACTIONS(2699),
    [anon_sym_LT_LT_DASH] = ACTIONS(2697),
    [anon_sym_LT_LT_LT] = ACTIONS(2697),
    [sym__special_character] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [anon_sym_DOLLAR] = ACTIONS(2699),
    [sym_raw_string] = ACTIONS(2697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2697),
    [anon_sym_BQUOTE] = ACTIONS(2697),
    [anon_sym_LT_LPAREN] = ACTIONS(2697),
    [anon_sym_GT_LPAREN] = ACTIONS(2697),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2699),
    [anon_sym_LF] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
  },
  [1454] = {
    [sym_concatenation] = STATE(1357),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(1357),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(4623),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [1455] = {
    [sym_string] = STATE(2083),
    [sym_simple_expansion] = STATE(2083),
    [sym_string_expansion] = STATE(2083),
    [sym_expansion] = STATE(2083),
    [sym_command_substitution] = STATE(2083),
    [sym_process_substitution] = STATE(2083),
    [sym__special_character] = ACTIONS(4625),
    [anon_sym_DQUOTE] = ACTIONS(1601),
    [anon_sym_DOLLAR] = ACTIONS(1603),
    [sym_raw_string] = ACTIONS(4625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1607),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1609),
    [anon_sym_BQUOTE] = ACTIONS(1611),
    [anon_sym_LT_LPAREN] = ACTIONS(1613),
    [anon_sym_GT_LPAREN] = ACTIONS(1613),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4625),
  },
  [1456] = {
    [aux_sym_concatenation_repeat1] = STATE(2084),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(2951),
    [sym_variable_name] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [1457] = {
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [sym_variable_name] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [1458] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(4627),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1459] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(4627),
    [anon_sym_DOLLAR] = ACTIONS(4629),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1460] = {
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [1461] = {
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [sym_variable_name] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [1462] = {
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [sym_variable_name] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [1463] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(4631),
    [sym_comment] = ACTIONS(57),
  },
  [1464] = {
    [sym_subscript] = STATE(2090),
    [sym_variable_name] = ACTIONS(4633),
    [anon_sym_DASH] = ACTIONS(4635),
    [anon_sym_DOLLAR] = ACTIONS(4635),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4637),
    [anon_sym_STAR] = ACTIONS(4639),
    [anon_sym_AT] = ACTIONS(4639),
    [anon_sym_QMARK] = ACTIONS(4639),
    [anon_sym_0] = ACTIONS(4637),
    [anon_sym__] = ACTIONS(4637),
  },
  [1465] = {
    [sym_concatenation] = STATE(2093),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2093),
    [anon_sym_RBRACE] = ACTIONS(4641),
    [anon_sym_EQ] = ACTIONS(4643),
    [anon_sym_DASH] = ACTIONS(4643),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4645),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4647),
    [anon_sym_COLON] = ACTIONS(4643),
    [anon_sym_COLON_QMARK] = ACTIONS(4643),
    [anon_sym_COLON_DASH] = ACTIONS(4643),
    [anon_sym_PERCENT] = ACTIONS(4643),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1466] = {
    [sym_concatenation] = STATE(2096),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2096),
    [anon_sym_RBRACE] = ACTIONS(4649),
    [anon_sym_EQ] = ACTIONS(4651),
    [anon_sym_DASH] = ACTIONS(4651),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4653),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4655),
    [anon_sym_COLON] = ACTIONS(4651),
    [anon_sym_COLON_QMARK] = ACTIONS(4651),
    [anon_sym_COLON_DASH] = ACTIONS(4651),
    [anon_sym_PERCENT] = ACTIONS(4651),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1467] = {
    [anon_sym_RPAREN] = ACTIONS(4657),
    [sym_comment] = ACTIONS(57),
  },
  [1468] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(4657),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1469] = {
    [anon_sym_BQUOTE] = ACTIONS(4657),
    [sym_comment] = ACTIONS(57),
  },
  [1470] = {
    [anon_sym_RPAREN] = ACTIONS(4659),
    [sym_comment] = ACTIONS(57),
  },
  [1471] = {
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [1472] = {
    [aux_sym__literal_repeat1] = STATE(1472),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym_variable_name] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(4661),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1473] = {
    [sym__expression] = STATE(2100),
    [sym_binary_expression] = STATE(2100),
    [sym_unary_expression] = STATE(2100),
    [sym_postfix_expression] = STATE(2100),
    [sym_parenthesized_expression] = STATE(2100),
    [sym_concatenation] = STATE(2100),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(4664),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_character] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [1474] = {
    [anon_sym_SEMI] = ACTIONS(4666),
    [anon_sym_SEMI_SEMI] = ACTIONS(4668),
    [anon_sym_AMP_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1482),
    [anon_sym_EQ_TILDE] = ACTIONS(1484),
    [anon_sym_EQ_EQ] = ACTIONS(1484),
    [anon_sym_EQ] = ACTIONS(1486),
    [anon_sym_PLUS_EQ] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(1486),
    [anon_sym_GT] = ACTIONS(1486),
    [anon_sym_BANG_EQ] = ACTIONS(1482),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_DASH_EQ] = ACTIONS(1482),
    [anon_sym_LT_EQ] = ACTIONS(1482),
    [anon_sym_GT_EQ] = ACTIONS(1482),
    [anon_sym_PLUS_PLUS] = ACTIONS(1488),
    [anon_sym_DASH_DASH] = ACTIONS(1488),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1482),
    [anon_sym_LF] = ACTIONS(4668),
    [anon_sym_AMP] = ACTIONS(4666),
  },
  [1475] = {
    [sym__expression] = STATE(2102),
    [sym_binary_expression] = STATE(2102),
    [sym_unary_expression] = STATE(2102),
    [sym_postfix_expression] = STATE(2102),
    [sym_parenthesized_expression] = STATE(2102),
    [sym_concatenation] = STATE(2102),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [anon_sym_SEMI] = ACTIONS(4666),
    [anon_sym_SEMI_SEMI] = ACTIONS(4668),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [sym__special_character] = ACTIONS(477),
    [anon_sym_DQUOTE] = ACTIONS(479),
    [anon_sym_DOLLAR] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
    [anon_sym_LF] = ACTIONS(4668),
    [anon_sym_AMP] = ACTIONS(4668),
  },
  [1476] = {
    [sym_concatenation] = STATE(1416),
    [sym_string] = STATE(783),
    [sym_simple_expansion] = STATE(783),
    [sym_string_expansion] = STATE(783),
    [sym_expansion] = STATE(783),
    [sym_command_substitution] = STATE(783),
    [sym_process_substitution] = STATE(783),
    [aux_sym_for_statement_repeat1] = STATE(1416),
    [aux_sym__literal_repeat1] = STATE(789),
    [anon_sym_SEMI] = ACTIONS(4670),
    [anon_sym_SEMI_SEMI] = ACTIONS(4672),
    [sym__special_character] = ACTIONS(1492),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [anon_sym_DOLLAR] = ACTIONS(1496),
    [sym_raw_string] = ACTIONS(1498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1502),
    [anon_sym_BQUOTE] = ACTIONS(1504),
    [anon_sym_LT_LPAREN] = ACTIONS(1506),
    [anon_sym_GT_LPAREN] = ACTIONS(1506),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2855),
    [anon_sym_LF] = ACTIONS(4672),
    [anon_sym_AMP] = ACTIONS(4672),
  },
  [1477] = {
    [sym_file_descriptor] = ACTIONS(2859),
    [anon_sym_SEMI] = ACTIONS(2861),
    [anon_sym_PIPE] = ACTIONS(2861),
    [anon_sym_SEMI_SEMI] = ACTIONS(2859),
    [anon_sym_PIPE_AMP] = ACTIONS(2859),
    [anon_sym_AMP_AMP] = ACTIONS(2859),
    [anon_sym_PIPE_PIPE] = ACTIONS(2859),
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_GT] = ACTIONS(2861),
    [anon_sym_GT_GT] = ACTIONS(2859),
    [anon_sym_AMP_GT] = ACTIONS(2861),
    [anon_sym_AMP_GT_GT] = ACTIONS(2859),
    [anon_sym_LT_AMP] = ACTIONS(2859),
    [anon_sym_GT_AMP] = ACTIONS(2859),
    [anon_sym_LT_LT] = ACTIONS(2861),
    [anon_sym_LT_LT_DASH] = ACTIONS(2859),
    [anon_sym_LT_LT_LT] = ACTIONS(2859),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2859),
    [anon_sym_AMP] = ACTIONS(2861),
  },
  [1478] = {
    [sym_file_descriptor] = ACTIONS(3187),
    [anon_sym_SEMI] = ACTIONS(3189),
    [anon_sym_PIPE] = ACTIONS(3189),
    [anon_sym_SEMI_SEMI] = ACTIONS(3187),
    [anon_sym_PIPE_AMP] = ACTIONS(3187),
    [anon_sym_AMP_AMP] = ACTIONS(3187),
    [anon_sym_PIPE_PIPE] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_GT] = ACTIONS(3189),
    [anon_sym_GT_GT] = ACTIONS(3187),
    [anon_sym_AMP_GT] = ACTIONS(3189),
    [anon_sym_AMP_GT_GT] = ACTIONS(3187),
    [anon_sym_LT_AMP] = ACTIONS(3187),
    [anon_sym_GT_AMP] = ACTIONS(3187),
    [anon_sym_LT_LT] = ACTIONS(3189),
    [anon_sym_LT_LT_DASH] = ACTIONS(3187),
    [anon_sym_LT_LT_LT] = ACTIONS(3187),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3187),
    [anon_sym_AMP] = ACTIONS(3189),
  },
  [1479] = {
    [anon_sym_done] = ACTIONS(4674),
    [sym_comment] = ACTIONS(57),
  },
  [1480] = {
    [sym_file_descriptor] = ACTIONS(3341),
    [anon_sym_SEMI] = ACTIONS(3343),
    [anon_sym_PIPE] = ACTIONS(3343),
    [anon_sym_SEMI_SEMI] = ACTIONS(3341),
    [anon_sym_PIPE_AMP] = ACTIONS(3341),
    [anon_sym_AMP_AMP] = ACTIONS(3341),
    [anon_sym_PIPE_PIPE] = ACTIONS(3341),
    [anon_sym_LT] = ACTIONS(3343),
    [anon_sym_GT] = ACTIONS(3343),
    [anon_sym_GT_GT] = ACTIONS(3341),
    [anon_sym_AMP_GT] = ACTIONS(3343),
    [anon_sym_AMP_GT_GT] = ACTIONS(3341),
    [anon_sym_LT_AMP] = ACTIONS(3341),
    [anon_sym_GT_AMP] = ACTIONS(3341),
    [anon_sym_LT_LT] = ACTIONS(3343),
    [anon_sym_LT_LT_DASH] = ACTIONS(3341),
    [anon_sym_LT_LT_LT] = ACTIONS(3341),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3341),
    [anon_sym_AMP] = ACTIONS(3343),
  },
  [1481] = {
    [sym_elif_clause] = STATE(2107),
    [sym_else_clause] = STATE(2106),
    [aux_sym_if_statement_repeat1] = STATE(2107),
    [anon_sym_fi] = ACTIONS(4676),
    [anon_sym_elif] = ACTIONS(3441),
    [anon_sym_else] = ACTIONS(3443),
    [sym_comment] = ACTIONS(57),
  },
  [1482] = {
    [anon_sym_fi] = ACTIONS(4676),
    [sym_comment] = ACTIONS(57),
  },
  [1483] = {
    [sym_elif_clause] = STATE(1682),
    [sym_else_clause] = STATE(2106),
    [aux_sym_if_statement_repeat1] = STATE(1682),
    [anon_sym_fi] = ACTIONS(4676),
    [anon_sym_elif] = ACTIONS(3441),
    [anon_sym_else] = ACTIONS(3443),
    [sym_comment] = ACTIONS(57),
  },
  [1484] = {
    [sym_case_item] = STATE(2110),
    [sym_last_case_item] = STATE(2109),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(2110),
    [aux_sym__literal_repeat1] = STATE(1693),
    [anon_sym_esac] = ACTIONS(4678),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3484),
  },
  [1485] = {
    [anon_sym_SEMI] = ACTIONS(4680),
    [anon_sym_SEMI_SEMI] = ACTIONS(4682),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4682),
    [anon_sym_AMP] = ACTIONS(4682),
  },
  [1486] = {
    [sym_case_item] = STATE(2114),
    [sym_last_case_item] = STATE(2113),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(2114),
    [aux_sym__literal_repeat1] = STATE(1693),
    [anon_sym_esac] = ACTIONS(4684),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3484),
  },
  [1487] = {
    [anon_sym_SEMI] = ACTIONS(4686),
    [anon_sym_SEMI_SEMI] = ACTIONS(4688),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4688),
    [anon_sym_AMP] = ACTIONS(4688),
  },
  [1488] = {
    [sym_compound_statement] = STATE(2116),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [1489] = {
    [sym_file_descriptor] = ACTIONS(1398),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1400),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [1490] = {
    [sym_concatenation] = STATE(2118),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(2118),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(4690),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [1491] = {
    [aux_sym_concatenation_repeat1] = STATE(862),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym__concat] = ACTIONS(1651),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1400),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [1492] = {
    [aux_sym__literal_repeat1] = STATE(879),
    [sym_file_descriptor] = ACTIONS(1444),
    [sym_variable_name] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1446),
    [anon_sym_SEMI_SEMI] = ACTIONS(1444),
    [anon_sym_PIPE_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1446),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_AMP_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT_GT] = ACTIONS(1444),
    [anon_sym_LT_AMP] = ACTIONS(1444),
    [anon_sym_GT_AMP] = ACTIONS(1444),
    [anon_sym_LT_LT] = ACTIONS(1446),
    [anon_sym_LT_LT_DASH] = ACTIONS(1444),
    [anon_sym_LT_LT_LT] = ACTIONS(1444),
    [sym__special_character] = ACTIONS(1677),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [anon_sym_DOLLAR] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1444),
    [anon_sym_BQUOTE] = ACTIONS(1444),
    [anon_sym_LT_LPAREN] = ACTIONS(1444),
    [anon_sym_GT_LPAREN] = ACTIONS(1444),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1446),
    [sym_word] = ACTIONS(1446),
    [anon_sym_LF] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1446),
  },
  [1493] = {
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1494] = {
    [aux_sym_concatenation_repeat1] = STATE(1494),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(4692),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1495] = {
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [sym_variable_name] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2353),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [1496] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(4695),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1497] = {
    [sym_concatenation] = STATE(2122),
    [sym_string] = STATE(2121),
    [sym_simple_expansion] = STATE(2121),
    [sym_string_expansion] = STATE(2121),
    [sym_expansion] = STATE(2121),
    [sym_command_substitution] = STATE(2121),
    [sym_process_substitution] = STATE(2121),
    [aux_sym__literal_repeat1] = STATE(2123),
    [anon_sym_RBRACE] = ACTIONS(4697),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(4699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4699),
  },
  [1498] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(4701),
    [sym_comment] = ACTIONS(57),
  },
  [1499] = {
    [sym_concatenation] = STATE(2127),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2127),
    [anon_sym_RBRACE] = ACTIONS(4703),
    [anon_sym_EQ] = ACTIONS(4705),
    [anon_sym_DASH] = ACTIONS(4705),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4707),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4709),
    [anon_sym_COLON] = ACTIONS(4705),
    [anon_sym_COLON_QMARK] = ACTIONS(4705),
    [anon_sym_COLON_DASH] = ACTIONS(4705),
    [anon_sym_PERCENT] = ACTIONS(4705),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1500] = {
    [sym_concatenation] = STATE(2129),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2129),
    [anon_sym_RBRACE] = ACTIONS(4697),
    [anon_sym_EQ] = ACTIONS(4711),
    [anon_sym_DASH] = ACTIONS(4711),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4713),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4715),
    [anon_sym_COLON] = ACTIONS(4711),
    [anon_sym_COLON_QMARK] = ACTIONS(4711),
    [anon_sym_COLON_DASH] = ACTIONS(4711),
    [anon_sym_PERCENT] = ACTIONS(4711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1501] = {
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [sym_variable_name] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2444),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [1502] = {
    [sym_concatenation] = STATE(2132),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2132),
    [sym_regex] = ACTIONS(4717),
    [anon_sym_RBRACE] = ACTIONS(4719),
    [anon_sym_EQ] = ACTIONS(4721),
    [anon_sym_DASH] = ACTIONS(4721),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4723),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4721),
    [anon_sym_COLON_QMARK] = ACTIONS(4721),
    [anon_sym_COLON_DASH] = ACTIONS(4721),
    [anon_sym_PERCENT] = ACTIONS(4721),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1503] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(4719),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1504] = {
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [sym_variable_name] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2494),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [1505] = {
    [sym_concatenation] = STATE(2129),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2129),
    [sym_regex] = ACTIONS(4725),
    [anon_sym_RBRACE] = ACTIONS(4697),
    [anon_sym_EQ] = ACTIONS(4711),
    [anon_sym_DASH] = ACTIONS(4711),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4713),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4711),
    [anon_sym_COLON_QMARK] = ACTIONS(4711),
    [anon_sym_COLON_DASH] = ACTIONS(4711),
    [anon_sym_PERCENT] = ACTIONS(4711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1506] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(4697),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1507] = {
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [sym_variable_name] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2502),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [1508] = {
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2536),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [1509] = {
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1510] = {
    [aux_sym_concatenation_repeat1] = STATE(1510),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(4727),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1511] = {
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2353),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [1512] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(4730),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1513] = {
    [sym_concatenation] = STATE(2137),
    [sym_string] = STATE(2136),
    [sym_simple_expansion] = STATE(2136),
    [sym_string_expansion] = STATE(2136),
    [sym_expansion] = STATE(2136),
    [sym_command_substitution] = STATE(2136),
    [sym_process_substitution] = STATE(2136),
    [aux_sym__literal_repeat1] = STATE(2138),
    [anon_sym_RBRACE] = ACTIONS(4732),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(4734),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4734),
  },
  [1514] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(4736),
    [sym_comment] = ACTIONS(57),
  },
  [1515] = {
    [sym_concatenation] = STATE(2142),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2142),
    [anon_sym_RBRACE] = ACTIONS(4738),
    [anon_sym_EQ] = ACTIONS(4740),
    [anon_sym_DASH] = ACTIONS(4740),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4742),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4744),
    [anon_sym_COLON] = ACTIONS(4740),
    [anon_sym_COLON_QMARK] = ACTIONS(4740),
    [anon_sym_COLON_DASH] = ACTIONS(4740),
    [anon_sym_PERCENT] = ACTIONS(4740),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1516] = {
    [sym_concatenation] = STATE(2144),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2144),
    [anon_sym_RBRACE] = ACTIONS(4732),
    [anon_sym_EQ] = ACTIONS(4746),
    [anon_sym_DASH] = ACTIONS(4746),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4748),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4750),
    [anon_sym_COLON] = ACTIONS(4746),
    [anon_sym_COLON_QMARK] = ACTIONS(4746),
    [anon_sym_COLON_DASH] = ACTIONS(4746),
    [anon_sym_PERCENT] = ACTIONS(4746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1517] = {
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2444),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [1518] = {
    [sym_concatenation] = STATE(2147),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2147),
    [sym_regex] = ACTIONS(4752),
    [anon_sym_RBRACE] = ACTIONS(4754),
    [anon_sym_EQ] = ACTIONS(4756),
    [anon_sym_DASH] = ACTIONS(4756),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4758),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4756),
    [anon_sym_COLON_QMARK] = ACTIONS(4756),
    [anon_sym_COLON_DASH] = ACTIONS(4756),
    [anon_sym_PERCENT] = ACTIONS(4756),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1519] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(4754),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1520] = {
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2494),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [1521] = {
    [sym_concatenation] = STATE(2144),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2144),
    [sym_regex] = ACTIONS(4760),
    [anon_sym_RBRACE] = ACTIONS(4732),
    [anon_sym_EQ] = ACTIONS(4746),
    [anon_sym_DASH] = ACTIONS(4746),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4748),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4746),
    [anon_sym_COLON_QMARK] = ACTIONS(4746),
    [anon_sym_COLON_DASH] = ACTIONS(4746),
    [anon_sym_PERCENT] = ACTIONS(4746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1522] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(4732),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1523] = {
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2502),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [1524] = {
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2536),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [1525] = {
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_EQ_TILDE] = ACTIONS(4055),
    [anon_sym_EQ_EQ] = ACTIONS(4055),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [1526] = {
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_EQ_TILDE] = ACTIONS(4069),
    [anon_sym_EQ_EQ] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [1527] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(4762),
    [sym_comment] = ACTIONS(57),
  },
  [1528] = {
    [anon_sym_RBRACE] = ACTIONS(4762),
    [sym_comment] = ACTIONS(57),
  },
  [1529] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(4764),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [1530] = {
    [sym_concatenation] = STATE(2152),
    [sym_string] = STATE(2151),
    [sym_simple_expansion] = STATE(2151),
    [sym_string_expansion] = STATE(2151),
    [sym_expansion] = STATE(2151),
    [sym_command_substitution] = STATE(2151),
    [sym_process_substitution] = STATE(2151),
    [aux_sym__literal_repeat1] = STATE(2153),
    [anon_sym_RBRACE] = ACTIONS(4762),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(4766),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4766),
  },
  [1531] = {
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_EQ_TILDE] = ACTIONS(4105),
    [anon_sym_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [1532] = {
    [sym_concatenation] = STATE(2156),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2156),
    [sym_regex] = ACTIONS(4768),
    [anon_sym_RBRACE] = ACTIONS(4770),
    [anon_sym_EQ] = ACTIONS(4772),
    [anon_sym_DASH] = ACTIONS(4772),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4774),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4772),
    [anon_sym_COLON_QMARK] = ACTIONS(4772),
    [anon_sym_COLON_DASH] = ACTIONS(4772),
    [anon_sym_PERCENT] = ACTIONS(4772),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1533] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(4770),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1534] = {
    [sym_concatenation] = STATE(2158),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2158),
    [sym_regex] = ACTIONS(4776),
    [anon_sym_RBRACE] = ACTIONS(4762),
    [anon_sym_EQ] = ACTIONS(4778),
    [anon_sym_DASH] = ACTIONS(4778),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4780),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4778),
    [anon_sym_COLON_QMARK] = ACTIONS(4778),
    [anon_sym_COLON_DASH] = ACTIONS(4778),
    [anon_sym_PERCENT] = ACTIONS(4778),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1535] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(4762),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1536] = {
    [sym_concatenation] = STATE(2160),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2160),
    [anon_sym_RBRACE] = ACTIONS(4782),
    [anon_sym_EQ] = ACTIONS(4784),
    [anon_sym_DASH] = ACTIONS(4784),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4786),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4784),
    [anon_sym_COLON_QMARK] = ACTIONS(4784),
    [anon_sym_COLON_DASH] = ACTIONS(4784),
    [anon_sym_PERCENT] = ACTIONS(4784),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1537] = {
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_EQ_TILDE] = ACTIONS(4161),
    [anon_sym_EQ_EQ] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [1538] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(4782),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1539] = {
    [sym_concatenation] = STATE(2158),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2158),
    [anon_sym_RBRACE] = ACTIONS(4762),
    [anon_sym_EQ] = ACTIONS(4778),
    [anon_sym_DASH] = ACTIONS(4778),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4780),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(4778),
    [anon_sym_COLON_QMARK] = ACTIONS(4778),
    [anon_sym_COLON_DASH] = ACTIONS(4778),
    [anon_sym_PERCENT] = ACTIONS(4778),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1540] = {
    [sym_file_descriptor] = ACTIONS(4264),
    [anon_sym_SEMI] = ACTIONS(4266),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_SEMI_SEMI] = ACTIONS(4264),
    [anon_sym_PIPE_AMP] = ACTIONS(4264),
    [anon_sym_AMP_AMP] = ACTIONS(4264),
    [anon_sym_PIPE_PIPE] = ACTIONS(4264),
    [anon_sym_LT] = ACTIONS(4266),
    [anon_sym_GT] = ACTIONS(4266),
    [anon_sym_GT_GT] = ACTIONS(4264),
    [anon_sym_AMP_GT] = ACTIONS(4266),
    [anon_sym_AMP_GT_GT] = ACTIONS(4264),
    [anon_sym_LT_AMP] = ACTIONS(4264),
    [anon_sym_GT_AMP] = ACTIONS(4264),
    [anon_sym_LT_LT] = ACTIONS(4266),
    [anon_sym_LT_LT_DASH] = ACTIONS(4264),
    [anon_sym_LT_LT_LT] = ACTIONS(4264),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4264),
    [anon_sym_AMP] = ACTIONS(4266),
  },
  [1541] = {
    [sym_concatenation] = STATE(2161),
    [sym_string] = STATE(2166),
    [sym_array] = STATE(2161),
    [sym_simple_expansion] = STATE(2166),
    [sym_string_expansion] = STATE(2166),
    [sym_expansion] = STATE(2166),
    [sym_command_substitution] = STATE(2166),
    [sym_process_substitution] = STATE(2166),
    [aux_sym__literal_repeat1] = STATE(2171),
    [sym__empty_value] = ACTIONS(4788),
    [anon_sym_LPAREN] = ACTIONS(4790),
    [sym__special_character] = ACTIONS(4792),
    [anon_sym_DQUOTE] = ACTIONS(4794),
    [anon_sym_DOLLAR] = ACTIONS(4796),
    [sym_raw_string] = ACTIONS(4798),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4800),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4802),
    [anon_sym_BQUOTE] = ACTIONS(4804),
    [anon_sym_LT_LPAREN] = ACTIONS(4806),
    [anon_sym_GT_LPAREN] = ACTIONS(4806),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4798),
  },
  [1542] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(4808),
    [anon_sym_PLUS_EQ] = ACTIONS(4808),
    [sym_comment] = ACTIONS(57),
  },
  [1543] = {
    [aux_sym_concatenation_repeat1] = STATE(2174),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(4810),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_done] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [1544] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(2177),
    [anon_sym_DQUOTE] = ACTIONS(4812),
    [anon_sym_DOLLAR] = ACTIONS(4814),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1545] = {
    [sym_string] = STATE(2179),
    [anon_sym_DASH] = ACTIONS(4816),
    [anon_sym_DQUOTE] = ACTIONS(3195),
    [anon_sym_DOLLAR] = ACTIONS(4816),
    [sym_raw_string] = ACTIONS(4818),
    [anon_sym_POUND] = ACTIONS(4816),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4820),
    [anon_sym_STAR] = ACTIONS(4822),
    [anon_sym_AT] = ACTIONS(4822),
    [anon_sym_QMARK] = ACTIONS(4822),
    [anon_sym_0] = ACTIONS(4820),
    [anon_sym__] = ACTIONS(4820),
  },
  [1546] = {
    [aux_sym_concatenation_repeat1] = STATE(2174),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(4810),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_done] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [sym__special_character] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [1547] = {
    [sym_subscript] = STATE(2184),
    [sym_variable_name] = ACTIONS(4824),
    [anon_sym_BANG] = ACTIONS(4826),
    [anon_sym_DASH] = ACTIONS(4828),
    [anon_sym_DOLLAR] = ACTIONS(4828),
    [anon_sym_POUND] = ACTIONS(4826),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4830),
    [anon_sym_STAR] = ACTIONS(4832),
    [anon_sym_AT] = ACTIONS(4832),
    [anon_sym_QMARK] = ACTIONS(4832),
    [anon_sym_0] = ACTIONS(4830),
    [anon_sym__] = ACTIONS(4830),
  },
  [1548] = {
    [sym__statements] = STATE(2185),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(2186),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1549] = {
    [sym__statements] = STATE(2187),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1550] = {
    [sym__statements] = STATE(2188),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1551] = {
    [anon_sym_EQ] = ACTIONS(4808),
    [anon_sym_PLUS_EQ] = ACTIONS(4808),
    [sym_comment] = ACTIONS(57),
  },
  [1552] = {
    [sym_variable_assignment] = STATE(2189),
    [sym_subscript] = STATE(1551),
    [sym_concatenation] = STATE(2189),
    [sym_string] = STATE(1546),
    [sym_simple_expansion] = STATE(1546),
    [sym_string_expansion] = STATE(1546),
    [sym_expansion] = STATE(1546),
    [sym_command_substitution] = STATE(1546),
    [sym_process_substitution] = STATE(1546),
    [aux_sym_declaration_command_repeat1] = STATE(2189),
    [aux_sym__literal_repeat1] = STATE(1553),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(3191),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_done] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [sym__special_character] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3195),
    [anon_sym_DOLLAR] = ACTIONS(3197),
    [sym_raw_string] = ACTIONS(3199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3203),
    [anon_sym_BQUOTE] = ACTIONS(3205),
    [anon_sym_LT_LPAREN] = ACTIONS(3207),
    [anon_sym_GT_LPAREN] = ACTIONS(3207),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4834),
    [sym_word] = ACTIONS(3211),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [1553] = {
    [aux_sym__literal_repeat1] = STATE(2191),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym_variable_name] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_done] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(979),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(979),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [sym__special_character] = ACTIONS(4836),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(979),
    [sym_word] = ACTIONS(979),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
  },
  [1554] = {
    [aux_sym_concatenation_repeat1] = STATE(2193),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(4838),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_done] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [1555] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(2196),
    [anon_sym_DQUOTE] = ACTIONS(4840),
    [anon_sym_DOLLAR] = ACTIONS(4842),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1556] = {
    [sym_string] = STATE(2198),
    [anon_sym_DASH] = ACTIONS(4844),
    [anon_sym_DQUOTE] = ACTIONS(3215),
    [anon_sym_DOLLAR] = ACTIONS(4844),
    [sym_raw_string] = ACTIONS(4846),
    [anon_sym_POUND] = ACTIONS(4844),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4848),
    [anon_sym_STAR] = ACTIONS(4850),
    [anon_sym_AT] = ACTIONS(4850),
    [anon_sym_QMARK] = ACTIONS(4850),
    [anon_sym_0] = ACTIONS(4848),
    [anon_sym__] = ACTIONS(4848),
  },
  [1557] = {
    [aux_sym_concatenation_repeat1] = STATE(2193),
    [sym__simple_heredoc_body] = ACTIONS(997),
    [sym__heredoc_body_beginning] = ACTIONS(997),
    [sym_file_descriptor] = ACTIONS(997),
    [sym__concat] = ACTIONS(4838),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_done] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI_SEMI] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_AMP_GT] = ACTIONS(999),
    [anon_sym_AMP_GT_GT] = ACTIONS(997),
    [anon_sym_LT_AMP] = ACTIONS(997),
    [anon_sym_GT_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_LT_LT_DASH] = ACTIONS(997),
    [anon_sym_LT_LT_LT] = ACTIONS(997),
    [sym__special_character] = ACTIONS(997),
    [anon_sym_DQUOTE] = ACTIONS(997),
    [anon_sym_DOLLAR] = ACTIONS(999),
    [sym_raw_string] = ACTIONS(997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(997),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(997),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(999),
    [sym_word] = ACTIONS(999),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
  },
  [1558] = {
    [sym_subscript] = STATE(2203),
    [sym_variable_name] = ACTIONS(4852),
    [anon_sym_BANG] = ACTIONS(4854),
    [anon_sym_DASH] = ACTIONS(4856),
    [anon_sym_DOLLAR] = ACTIONS(4856),
    [anon_sym_POUND] = ACTIONS(4854),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4858),
    [anon_sym_STAR] = ACTIONS(4860),
    [anon_sym_AT] = ACTIONS(4860),
    [anon_sym_QMARK] = ACTIONS(4860),
    [anon_sym_0] = ACTIONS(4858),
    [anon_sym__] = ACTIONS(4858),
  },
  [1559] = {
    [sym__statements] = STATE(2204),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(2205),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1560] = {
    [sym__statements] = STATE(2206),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1561] = {
    [sym__statements] = STATE(2207),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1562] = {
    [sym_concatenation] = STATE(2208),
    [sym_string] = STATE(1557),
    [sym_simple_expansion] = STATE(1557),
    [sym_string_expansion] = STATE(1557),
    [sym_expansion] = STATE(1557),
    [sym_command_substitution] = STATE(1557),
    [sym_process_substitution] = STATE(1557),
    [aux_sym_unset_command_repeat1] = STATE(2208),
    [aux_sym__literal_repeat1] = STATE(1563),
    [sym__simple_heredoc_body] = ACTIONS(1011),
    [sym__heredoc_body_beginning] = ACTIONS(1011),
    [sym_file_descriptor] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_done] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1013),
    [anon_sym_GT] = ACTIONS(1013),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT] = ACTIONS(1013),
    [anon_sym_AMP_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_AMP] = ACTIONS(1011),
    [anon_sym_GT_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(1011),
    [anon_sym_LT_LT_LT] = ACTIONS(1011),
    [sym__special_character] = ACTIONS(3213),
    [anon_sym_DQUOTE] = ACTIONS(3215),
    [anon_sym_DOLLAR] = ACTIONS(3217),
    [sym_raw_string] = ACTIONS(3219),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3223),
    [anon_sym_BQUOTE] = ACTIONS(3225),
    [anon_sym_LT_LPAREN] = ACTIONS(3227),
    [anon_sym_GT_LPAREN] = ACTIONS(3227),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4862),
    [sym_word] = ACTIONS(3231),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
  },
  [1563] = {
    [aux_sym__literal_repeat1] = STATE(2210),
    [sym__simple_heredoc_body] = ACTIONS(1017),
    [sym__heredoc_body_beginning] = ACTIONS(1017),
    [sym_file_descriptor] = ACTIONS(1017),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_done] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1017),
    [anon_sym_PIPE_AMP] = ACTIONS(1017),
    [anon_sym_AMP_AMP] = ACTIONS(1017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1017),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1017),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1017),
    [anon_sym_LT_AMP] = ACTIONS(1017),
    [anon_sym_GT_AMP] = ACTIONS(1017),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1017),
    [anon_sym_LT_LT_LT] = ACTIONS(1017),
    [sym__special_character] = ACTIONS(4864),
    [anon_sym_DQUOTE] = ACTIONS(1017),
    [anon_sym_DOLLAR] = ACTIONS(1019),
    [sym_raw_string] = ACTIONS(1017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1017),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1017),
    [anon_sym_GT_LPAREN] = ACTIONS(1017),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1019),
    [sym_word] = ACTIONS(1019),
    [anon_sym_LF] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [1564] = {
    [sym_string] = STATE(2211),
    [sym_simple_expansion] = STATE(2211),
    [sym_string_expansion] = STATE(2211),
    [sym_expansion] = STATE(2211),
    [sym_command_substitution] = STATE(2211),
    [sym_process_substitution] = STATE(2211),
    [sym__special_character] = ACTIONS(4866),
    [anon_sym_DQUOTE] = ACTIONS(1757),
    [anon_sym_DOLLAR] = ACTIONS(1759),
    [sym_raw_string] = ACTIONS(4866),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1765),
    [anon_sym_BQUOTE] = ACTIONS(1767),
    [anon_sym_LT_LPAREN] = ACTIONS(1769),
    [anon_sym_GT_LPAREN] = ACTIONS(1769),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4866),
  },
  [1565] = {
    [aux_sym_concatenation_repeat1] = STATE(2212),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(3233),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_done] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_EQ_TILDE] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [1566] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_done] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_EQ_TILDE] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [1567] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(4868),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1568] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(4868),
    [anon_sym_DOLLAR] = ACTIONS(4870),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1569] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_done] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_EQ_TILDE] = ACTIONS(1099),
    [anon_sym_EQ_EQ] = ACTIONS(1099),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [1570] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_done] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_EQ_TILDE] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [1571] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_done] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_EQ_TILDE] = ACTIONS(1107),
    [anon_sym_EQ_EQ] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [1572] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(4872),
    [sym_comment] = ACTIONS(57),
  },
  [1573] = {
    [sym_subscript] = STATE(2218),
    [sym_variable_name] = ACTIONS(4874),
    [anon_sym_DASH] = ACTIONS(4876),
    [anon_sym_DOLLAR] = ACTIONS(4876),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4878),
    [anon_sym_STAR] = ACTIONS(4880),
    [anon_sym_AT] = ACTIONS(4880),
    [anon_sym_QMARK] = ACTIONS(4880),
    [anon_sym_0] = ACTIONS(4878),
    [anon_sym__] = ACTIONS(4878),
  },
  [1574] = {
    [sym_concatenation] = STATE(2221),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2221),
    [anon_sym_RBRACE] = ACTIONS(4882),
    [anon_sym_EQ] = ACTIONS(4884),
    [anon_sym_DASH] = ACTIONS(4884),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4888),
    [anon_sym_COLON] = ACTIONS(4884),
    [anon_sym_COLON_QMARK] = ACTIONS(4884),
    [anon_sym_COLON_DASH] = ACTIONS(4884),
    [anon_sym_PERCENT] = ACTIONS(4884),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1575] = {
    [sym_concatenation] = STATE(2224),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2224),
    [anon_sym_RBRACE] = ACTIONS(4890),
    [anon_sym_EQ] = ACTIONS(4892),
    [anon_sym_DASH] = ACTIONS(4892),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(4894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(4896),
    [anon_sym_COLON] = ACTIONS(4892),
    [anon_sym_COLON_QMARK] = ACTIONS(4892),
    [anon_sym_COLON_DASH] = ACTIONS(4892),
    [anon_sym_PERCENT] = ACTIONS(4892),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1576] = {
    [anon_sym_RPAREN] = ACTIONS(4898),
    [sym_comment] = ACTIONS(57),
  },
  [1577] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(4898),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1578] = {
    [anon_sym_BQUOTE] = ACTIONS(4898),
    [sym_comment] = ACTIONS(57),
  },
  [1579] = {
    [anon_sym_RPAREN] = ACTIONS(4900),
    [sym_comment] = ACTIONS(57),
  },
  [1580] = {
    [sym__simple_heredoc_body] = ACTIONS(4902),
    [sym__heredoc_body_beginning] = ACTIONS(4902),
    [sym_file_descriptor] = ACTIONS(4902),
    [ts_builtin_sym_end] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(4904),
    [anon_sym_done] = ACTIONS(4902),
    [anon_sym_fi] = ACTIONS(4902),
    [anon_sym_elif] = ACTIONS(4902),
    [anon_sym_else] = ACTIONS(4902),
    [anon_sym_esac] = ACTIONS(4902),
    [anon_sym_PIPE] = ACTIONS(4904),
    [anon_sym_RPAREN] = ACTIONS(4902),
    [anon_sym_SEMI_SEMI] = ACTIONS(4902),
    [anon_sym_PIPE_AMP] = ACTIONS(4902),
    [anon_sym_AMP_AMP] = ACTIONS(4902),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_GT] = ACTIONS(4904),
    [anon_sym_GT_GT] = ACTIONS(4902),
    [anon_sym_AMP_GT] = ACTIONS(4904),
    [anon_sym_AMP_GT_GT] = ACTIONS(4902),
    [anon_sym_LT_AMP] = ACTIONS(4902),
    [anon_sym_GT_AMP] = ACTIONS(4902),
    [anon_sym_LT_LT] = ACTIONS(4904),
    [anon_sym_LT_LT_DASH] = ACTIONS(4902),
    [anon_sym_LT_LT_LT] = ACTIONS(4902),
    [anon_sym_BQUOTE] = ACTIONS(4902),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4902),
    [anon_sym_AMP] = ACTIONS(4904),
  },
  [1581] = {
    [anon_sym_LT] = ACTIONS(4906),
    [anon_sym_GT] = ACTIONS(4906),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_AMP_GT] = ACTIONS(4906),
    [anon_sym_AMP_GT_GT] = ACTIONS(4908),
    [anon_sym_LT_AMP] = ACTIONS(4908),
    [anon_sym_GT_AMP] = ACTIONS(4908),
    [sym_comment] = ACTIONS(57),
  },
  [1582] = {
    [sym_file_descriptor] = ACTIONS(1235),
    [sym_variable_name] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1239),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1239),
    [anon_sym_done] = ACTIONS(4910),
    [anon_sym_if] = ACTIONS(1239),
    [anon_sym_case] = ACTIONS(1239),
    [anon_sym_function] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1239),
    [anon_sym_typeset] = ACTIONS(1239),
    [anon_sym_export] = ACTIONS(1239),
    [anon_sym_readonly] = ACTIONS(1239),
    [anon_sym_local] = ACTIONS(1239),
    [anon_sym_unset] = ACTIONS(1239),
    [anon_sym_unsetenv] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_AMP_GT] = ACTIONS(1239),
    [anon_sym_AMP_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_AMP] = ACTIONS(1235),
    [anon_sym_GT_AMP] = ACTIONS(1235),
    [sym__special_character] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_DOLLAR] = ACTIONS(1239),
    [sym_raw_string] = ACTIONS(1235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1235),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1235),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [anon_sym_LT_LPAREN] = ACTIONS(1235),
    [anon_sym_GT_LPAREN] = ACTIONS(1235),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1239),
  },
  [1583] = {
    [sym_redirected_statement] = STATE(2228),
    [sym_for_statement] = STATE(2228),
    [sym_c_style_for_statement] = STATE(2228),
    [sym_while_statement] = STATE(2228),
    [sym_if_statement] = STATE(2228),
    [sym_case_statement] = STATE(2228),
    [sym_function_definition] = STATE(2228),
    [sym_compound_statement] = STATE(2228),
    [sym_subshell] = STATE(2228),
    [sym_pipeline] = STATE(2228),
    [sym_list] = STATE(2228),
    [sym_negated_command] = STATE(2228),
    [sym_test_command] = STATE(2228),
    [sym_declaration_command] = STATE(2228),
    [sym_unset_command] = STATE(2228),
    [sym_command] = STATE(2228),
    [sym_command_name] = STATE(932),
    [sym_variable_assignment] = STATE(2229),
    [sym_subscript] = STATE(934),
    [sym_file_redirect] = STATE(937),
    [sym_concatenation] = STATE(935),
    [sym_string] = STATE(924),
    [sym_simple_expansion] = STATE(924),
    [sym_string_expansion] = STATE(924),
    [sym_expansion] = STATE(924),
    [sym_command_substitution] = STATE(924),
    [sym_process_substitution] = STATE(924),
    [aux_sym_command_repeat1] = STATE(937),
    [aux_sym__literal_repeat1] = STATE(938),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1745),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1751),
    [anon_sym_typeset] = ACTIONS(1751),
    [anon_sym_export] = ACTIONS(1751),
    [anon_sym_readonly] = ACTIONS(1751),
    [anon_sym_local] = ACTIONS(1751),
    [anon_sym_unset] = ACTIONS(1753),
    [anon_sym_unsetenv] = ACTIONS(1753),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(1755),
    [anon_sym_DQUOTE] = ACTIONS(1757),
    [anon_sym_DOLLAR] = ACTIONS(1759),
    [sym_raw_string] = ACTIONS(1761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1765),
    [anon_sym_BQUOTE] = ACTIONS(1767),
    [anon_sym_LT_LPAREN] = ACTIONS(1769),
    [anon_sym_GT_LPAREN] = ACTIONS(1769),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1771),
  },
  [1584] = {
    [sym_redirected_statement] = STATE(2230),
    [sym_for_statement] = STATE(2230),
    [sym_c_style_for_statement] = STATE(2230),
    [sym_while_statement] = STATE(2230),
    [sym_if_statement] = STATE(2230),
    [sym_case_statement] = STATE(2230),
    [sym_function_definition] = STATE(2230),
    [sym_compound_statement] = STATE(2230),
    [sym_subshell] = STATE(2230),
    [sym_pipeline] = STATE(2230),
    [sym_list] = STATE(2230),
    [sym_negated_command] = STATE(2230),
    [sym_test_command] = STATE(2230),
    [sym_declaration_command] = STATE(2230),
    [sym_unset_command] = STATE(2230),
    [sym_command] = STATE(2230),
    [sym_command_name] = STATE(932),
    [sym_variable_assignment] = STATE(2231),
    [sym_subscript] = STATE(934),
    [sym_file_redirect] = STATE(937),
    [sym_concatenation] = STATE(935),
    [sym_string] = STATE(924),
    [sym_simple_expansion] = STATE(924),
    [sym_string_expansion] = STATE(924),
    [sym_expansion] = STATE(924),
    [sym_command_substitution] = STATE(924),
    [sym_process_substitution] = STATE(924),
    [aux_sym_command_repeat1] = STATE(937),
    [aux_sym__literal_repeat1] = STATE(938),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1745),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1749),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1751),
    [anon_sym_typeset] = ACTIONS(1751),
    [anon_sym_export] = ACTIONS(1751),
    [anon_sym_readonly] = ACTIONS(1751),
    [anon_sym_local] = ACTIONS(1751),
    [anon_sym_unset] = ACTIONS(1753),
    [anon_sym_unsetenv] = ACTIONS(1753),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(1755),
    [anon_sym_DQUOTE] = ACTIONS(1757),
    [anon_sym_DOLLAR] = ACTIONS(1759),
    [sym_raw_string] = ACTIONS(1761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1765),
    [anon_sym_BQUOTE] = ACTIONS(1767),
    [anon_sym_LT_LPAREN] = ACTIONS(1769),
    [anon_sym_GT_LPAREN] = ACTIONS(1769),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1771),
  },
  [1585] = {
    [sym_concatenation] = STATE(695),
    [sym_string] = STATE(2235),
    [sym_simple_expansion] = STATE(2235),
    [sym_string_expansion] = STATE(2235),
    [sym_expansion] = STATE(2235),
    [sym_command_substitution] = STATE(2235),
    [sym_process_substitution] = STATE(2235),
    [aux_sym__literal_repeat1] = STATE(2240),
    [sym__special_character] = ACTIONS(4912),
    [anon_sym_DQUOTE] = ACTIONS(4914),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(4918),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4922),
    [anon_sym_BQUOTE] = ACTIONS(4924),
    [anon_sym_LT_LPAREN] = ACTIONS(4926),
    [anon_sym_GT_LPAREN] = ACTIONS(4926),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4918),
  },
  [1586] = {
    [sym_concatenation] = STATE(699),
    [sym_string] = STATE(2241),
    [sym_simple_expansion] = STATE(2241),
    [sym_string_expansion] = STATE(2241),
    [sym_expansion] = STATE(2241),
    [sym_command_substitution] = STATE(2241),
    [sym_process_substitution] = STATE(2241),
    [aux_sym__literal_repeat1] = STATE(2242),
    [sym__special_character] = ACTIONS(4912),
    [anon_sym_DQUOTE] = ACTIONS(4914),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(4928),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4922),
    [anon_sym_BQUOTE] = ACTIONS(4924),
    [anon_sym_LT_LPAREN] = ACTIONS(4926),
    [anon_sym_GT_LPAREN] = ACTIONS(4926),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4928),
  },
  [1587] = {
    [anon_sym_SEMI] = ACTIONS(4930),
    [anon_sym_done] = ACTIONS(1237),
    [anon_sym_SEMI_SEMI] = ACTIONS(4932),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4932),
    [anon_sym_AMP] = ACTIONS(4932),
  },
  [1588] = {
    [sym_file_redirect] = STATE(2244),
    [sym_heredoc_redirect] = STATE(2244),
    [sym_herestring_redirect] = STATE(2244),
    [aux_sym_redirected_statement_repeat1] = STATE(2244),
    [sym__simple_heredoc_body] = ACTIONS(1253),
    [sym__heredoc_body_beginning] = ACTIONS(1253),
    [sym_file_descriptor] = ACTIONS(3259),
    [anon_sym_SEMI] = ACTIONS(1255),
    [anon_sym_done] = ACTIONS(1253),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_SEMI_SEMI] = ACTIONS(1253),
    [anon_sym_PIPE_AMP] = ACTIONS(1253),
    [anon_sym_AMP_AMP] = ACTIONS(1253),
    [anon_sym_PIPE_PIPE] = ACTIONS(1253),
    [anon_sym_LT] = ACTIONS(3271),
    [anon_sym_GT] = ACTIONS(3271),
    [anon_sym_GT_GT] = ACTIONS(3273),
    [anon_sym_AMP_GT] = ACTIONS(3271),
    [anon_sym_AMP_GT_GT] = ACTIONS(3273),
    [anon_sym_LT_AMP] = ACTIONS(3273),
    [anon_sym_GT_AMP] = ACTIONS(3273),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3275),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1255),
  },
  [1589] = {
    [sym_concatenation] = STATE(2245),
    [sym_string] = STATE(2246),
    [sym_simple_expansion] = STATE(2246),
    [sym_string_expansion] = STATE(2246),
    [sym_expansion] = STATE(2246),
    [sym_command_substitution] = STATE(2246),
    [sym_process_substitution] = STATE(2246),
    [aux_sym__literal_repeat1] = STATE(2247),
    [sym_regex] = ACTIONS(4934),
    [sym__special_character] = ACTIONS(3279),
    [anon_sym_DQUOTE] = ACTIONS(1757),
    [anon_sym_DOLLAR] = ACTIONS(1759),
    [sym_raw_string] = ACTIONS(4936),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1765),
    [anon_sym_BQUOTE] = ACTIONS(1767),
    [anon_sym_LT_LPAREN] = ACTIONS(1769),
    [anon_sym_GT_LPAREN] = ACTIONS(1769),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4936),
  },
  [1590] = {
    [aux_sym_concatenation_repeat1] = STATE(1565),
    [sym__simple_heredoc_body] = ACTIONS(1261),
    [sym__heredoc_body_beginning] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(3233),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_done] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [sym__special_character] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [1591] = {
    [sym_concatenation] = STATE(2248),
    [sym_string] = STATE(1590),
    [sym_simple_expansion] = STATE(1590),
    [sym_string_expansion] = STATE(1590),
    [sym_expansion] = STATE(1590),
    [sym_command_substitution] = STATE(1590),
    [sym_process_substitution] = STATE(1590),
    [aux_sym_command_repeat2] = STATE(2248),
    [aux_sym__literal_repeat1] = STATE(1592),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_done] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(3277),
    [anon_sym_EQ_EQ] = ACTIONS(3277),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(3279),
    [anon_sym_DQUOTE] = ACTIONS(1757),
    [anon_sym_DOLLAR] = ACTIONS(1759),
    [sym_raw_string] = ACTIONS(3281),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1765),
    [anon_sym_BQUOTE] = ACTIONS(1767),
    [anon_sym_LT_LPAREN] = ACTIONS(1769),
    [anon_sym_GT_LPAREN] = ACTIONS(1769),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3283),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [1592] = {
    [aux_sym__literal_repeat1] = STATE(1597),
    [sym__simple_heredoc_body] = ACTIONS(1269),
    [sym__heredoc_body_beginning] = ACTIONS(1269),
    [sym_file_descriptor] = ACTIONS(1269),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_done] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE_AMP] = ACTIONS(1269),
    [anon_sym_AMP_AMP] = ACTIONS(1269),
    [anon_sym_PIPE_PIPE] = ACTIONS(1269),
    [anon_sym_EQ_TILDE] = ACTIONS(1271),
    [anon_sym_EQ_EQ] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT_GT] = ACTIONS(1269),
    [anon_sym_LT_AMP] = ACTIONS(1269),
    [anon_sym_GT_AMP] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_LT_LT_DASH] = ACTIONS(1269),
    [anon_sym_LT_LT_LT] = ACTIONS(1269),
    [sym__special_character] = ACTIONS(3287),
    [anon_sym_DQUOTE] = ACTIONS(1269),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1269),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1269),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [anon_sym_LT_LPAREN] = ACTIONS(1269),
    [anon_sym_GT_LPAREN] = ACTIONS(1269),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1271),
  },
  [1593] = {
    [sym_file_redirect] = STATE(1588),
    [sym_heredoc_redirect] = STATE(1588),
    [sym_heredoc_body] = STATE(2250),
    [sym_herestring_redirect] = STATE(1588),
    [aux_sym_redirected_statement_repeat1] = STATE(1588),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(3259),
    [anon_sym_SEMI] = ACTIONS(4938),
    [anon_sym_done] = ACTIONS(1237),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_SEMI_SEMI] = ACTIONS(4940),
    [anon_sym_PIPE_AMP] = ACTIONS(3267),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(3271),
    [anon_sym_GT] = ACTIONS(3271),
    [anon_sym_GT_GT] = ACTIONS(3273),
    [anon_sym_AMP_GT] = ACTIONS(3271),
    [anon_sym_AMP_GT_GT] = ACTIONS(3273),
    [anon_sym_LT_AMP] = ACTIONS(3273),
    [anon_sym_GT_AMP] = ACTIONS(3273),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3275),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4940),
    [anon_sym_AMP] = ACTIONS(4938),
  },
  [1594] = {
    [sym_file_redirect] = STATE(1588),
    [sym_heredoc_redirect] = STATE(1588),
    [sym_heredoc_body] = STATE(2250),
    [sym_herestring_redirect] = STATE(1588),
    [aux_sym_redirected_statement_repeat1] = STATE(1588),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(4938),
    [anon_sym_done] = ACTIONS(4910),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_SEMI_SEMI] = ACTIONS(4940),
    [anon_sym_PIPE_AMP] = ACTIONS(3267),
    [anon_sym_AMP_AMP] = ACTIONS(3269),
    [anon_sym_PIPE_PIPE] = ACTIONS(3269),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3275),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(4940),
    [anon_sym_AMP] = ACTIONS(4938),
  },
  [1595] = {
    [sym_concatenation] = STATE(2251),
    [sym_string] = STATE(1590),
    [sym_simple_expansion] = STATE(1590),
    [sym_string_expansion] = STATE(1590),
    [sym_expansion] = STATE(1590),
    [sym_command_substitution] = STATE(1590),
    [sym_process_substitution] = STATE(1590),
    [aux_sym_command_repeat2] = STATE(2251),
    [aux_sym__literal_repeat1] = STATE(1592),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_done] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(3277),
    [anon_sym_EQ_EQ] = ACTIONS(3277),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(3279),
    [anon_sym_DQUOTE] = ACTIONS(1757),
    [anon_sym_DOLLAR] = ACTIONS(1759),
    [sym_raw_string] = ACTIONS(3281),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1765),
    [anon_sym_BQUOTE] = ACTIONS(1767),
    [anon_sym_LT_LPAREN] = ACTIONS(1769),
    [anon_sym_GT_LPAREN] = ACTIONS(1769),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3283),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [1596] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_done] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [1597] = {
    [aux_sym__literal_repeat1] = STATE(1597),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_done] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_EQ_TILDE] = ACTIONS(1373),
    [anon_sym_EQ_EQ] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(4942),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1598] = {
    [aux_sym_concatenation_repeat1] = STATE(1601),
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(625),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1378),
    [anon_sym_PIPE_AMP] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_AMP] = ACTIONS(1378),
    [anon_sym_GT_AMP] = ACTIONS(1378),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1378),
    [anon_sym_LT_LT_LT] = ACTIONS(1378),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1378),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [1599] = {
    [sym_file_descriptor] = ACTIONS(1378),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1378),
    [anon_sym_PIPE_AMP] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_AMP] = ACTIONS(1378),
    [anon_sym_GT_AMP] = ACTIONS(1378),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1378),
    [anon_sym_LT_LT_LT] = ACTIONS(1378),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1378),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [1600] = {
    [aux_sym__literal_repeat1] = STATE(1602),
    [sym_file_descriptor] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym_PIPE] = ACTIONS(1384),
    [anon_sym_SEMI_SEMI] = ACTIONS(1382),
    [anon_sym_PIPE_AMP] = ACTIONS(1382),
    [anon_sym_AMP_AMP] = ACTIONS(1382),
    [anon_sym_PIPE_PIPE] = ACTIONS(1382),
    [anon_sym_LT] = ACTIONS(1384),
    [anon_sym_GT] = ACTIONS(1384),
    [anon_sym_GT_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT_GT] = ACTIONS(1382),
    [anon_sym_LT_AMP] = ACTIONS(1382),
    [anon_sym_GT_AMP] = ACTIONS(1382),
    [anon_sym_LT_LT] = ACTIONS(1384),
    [anon_sym_LT_LT_DASH] = ACTIONS(1382),
    [anon_sym_LT_LT_LT] = ACTIONS(1382),
    [sym__special_character] = ACTIONS(683),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
  },
  [1601] = {
    [aux_sym_concatenation_repeat1] = STATE(2252),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(625),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [1602] = {
    [aux_sym__literal_repeat1] = STATE(1602),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(1795),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1603] = {
    [sym_concatenation] = STATE(2253),
    [sym_string] = STATE(2258),
    [sym_array] = STATE(2253),
    [sym_simple_expansion] = STATE(2258),
    [sym_string_expansion] = STATE(2258),
    [sym_expansion] = STATE(2258),
    [sym_command_substitution] = STATE(2258),
    [sym_process_substitution] = STATE(2258),
    [aux_sym__literal_repeat1] = STATE(2263),
    [sym__empty_value] = ACTIONS(4945),
    [anon_sym_LPAREN] = ACTIONS(4947),
    [sym__special_character] = ACTIONS(4949),
    [anon_sym_DQUOTE] = ACTIONS(4951),
    [anon_sym_DOLLAR] = ACTIONS(4953),
    [sym_raw_string] = ACTIONS(4955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4959),
    [anon_sym_BQUOTE] = ACTIONS(4961),
    [anon_sym_LT_LPAREN] = ACTIONS(4963),
    [anon_sym_GT_LPAREN] = ACTIONS(4963),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4955),
  },
  [1604] = {
    [anon_sym_then] = ACTIONS(4965),
    [sym_comment] = ACTIONS(57),
  },
  [1605] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(4967),
    [anon_sym_PLUS_EQ] = ACTIONS(4967),
    [sym_comment] = ACTIONS(57),
  },
  [1606] = {
    [sym_subshell] = STATE(146),
    [sym_test_command] = STATE(146),
    [sym_command] = STATE(146),
    [sym_command_name] = STATE(1620),
    [sym_variable_assignment] = STATE(1625),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(1625),
    [sym_concatenation] = STATE(1623),
    [sym_string] = STATE(1612),
    [sym_simple_expansion] = STATE(1612),
    [sym_string_expansion] = STATE(1612),
    [sym_expansion] = STATE(1612),
    [sym_command_substitution] = STATE(1612),
    [sym_process_substitution] = STATE(1612),
    [aux_sym_command_repeat1] = STATE(1625),
    [aux_sym__literal_repeat1] = STATE(1626),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3359),
    [sym_raw_string] = ACTIONS(3361),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3363),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3365),
    [anon_sym_BQUOTE] = ACTIONS(3367),
    [anon_sym_LT_LPAREN] = ACTIONS(3369),
    [anon_sym_GT_LPAREN] = ACTIONS(3369),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3361),
  },
  [1607] = {
    [sym_variable_assignment] = STATE(2276),
    [sym_subscript] = STATE(2275),
    [sym_concatenation] = STATE(2276),
    [sym_string] = STATE(2270),
    [sym_simple_expansion] = STATE(2270),
    [sym_string_expansion] = STATE(2270),
    [sym_expansion] = STATE(2270),
    [sym_command_substitution] = STATE(2270),
    [sym_process_substitution] = STATE(2270),
    [aux_sym_declaration_command_repeat1] = STATE(2276),
    [aux_sym__literal_repeat1] = STATE(2277),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(4969),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_fi] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [sym__special_character] = ACTIONS(4971),
    [anon_sym_DQUOTE] = ACTIONS(4973),
    [anon_sym_DOLLAR] = ACTIONS(4975),
    [sym_raw_string] = ACTIONS(4977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4979),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4981),
    [anon_sym_BQUOTE] = ACTIONS(4983),
    [anon_sym_LT_LPAREN] = ACTIONS(4985),
    [anon_sym_GT_LPAREN] = ACTIONS(4985),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4987),
    [sym_word] = ACTIONS(4989),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [1608] = {
    [sym_concatenation] = STATE(2286),
    [sym_string] = STATE(2281),
    [sym_simple_expansion] = STATE(2281),
    [sym_string_expansion] = STATE(2281),
    [sym_expansion] = STATE(2281),
    [sym_command_substitution] = STATE(2281),
    [sym_process_substitution] = STATE(2281),
    [aux_sym_unset_command_repeat1] = STATE(2286),
    [aux_sym__literal_repeat1] = STATE(2287),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_fi] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [sym__special_character] = ACTIONS(4991),
    [anon_sym_DQUOTE] = ACTIONS(4993),
    [anon_sym_DOLLAR] = ACTIONS(4995),
    [sym_raw_string] = ACTIONS(4997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5001),
    [anon_sym_BQUOTE] = ACTIONS(5003),
    [anon_sym_LT_LPAREN] = ACTIONS(5005),
    [anon_sym_GT_LPAREN] = ACTIONS(5005),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5007),
    [sym_word] = ACTIONS(5009),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [1609] = {
    [aux_sym_concatenation_repeat1] = STATE(2289),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(5011),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_fi] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [1610] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(2292),
    [anon_sym_DQUOTE] = ACTIONS(5013),
    [anon_sym_DOLLAR] = ACTIONS(5015),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1611] = {
    [sym_string] = STATE(2294),
    [anon_sym_DASH] = ACTIONS(5017),
    [anon_sym_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(5017),
    [sym_raw_string] = ACTIONS(5019),
    [anon_sym_POUND] = ACTIONS(5017),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5021),
    [anon_sym_STAR] = ACTIONS(5023),
    [anon_sym_AT] = ACTIONS(5023),
    [anon_sym_QMARK] = ACTIONS(5023),
    [anon_sym_0] = ACTIONS(5021),
    [anon_sym__] = ACTIONS(5021),
  },
  [1612] = {
    [aux_sym_concatenation_repeat1] = STATE(2289),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(5011),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_fi] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [1613] = {
    [sym_subscript] = STATE(2299),
    [sym_variable_name] = ACTIONS(5025),
    [anon_sym_BANG] = ACTIONS(5027),
    [anon_sym_DASH] = ACTIONS(5029),
    [anon_sym_DOLLAR] = ACTIONS(5029),
    [anon_sym_POUND] = ACTIONS(5027),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5031),
    [anon_sym_STAR] = ACTIONS(5033),
    [anon_sym_AT] = ACTIONS(5033),
    [anon_sym_QMARK] = ACTIONS(5033),
    [anon_sym_0] = ACTIONS(5031),
    [anon_sym__] = ACTIONS(5031),
  },
  [1614] = {
    [sym__statements] = STATE(2300),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(2301),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1615] = {
    [sym__statements] = STATE(2302),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1616] = {
    [sym__statements] = STATE(2303),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1617] = {
    [aux_sym_concatenation_repeat1] = STATE(2289),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(5011),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_fi] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [1618] = {
    [anon_sym_fi] = ACTIONS(5035),
    [sym_comment] = ACTIONS(57),
  },
  [1619] = {
    [sym_file_redirect] = STATE(2311),
    [sym_heredoc_redirect] = STATE(2311),
    [sym_heredoc_body] = STATE(2310),
    [sym_herestring_redirect] = STATE(2311),
    [aux_sym_redirected_statement_repeat1] = STATE(2311),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(5037),
    [anon_sym_SEMI] = ACTIONS(5039),
    [anon_sym_fi] = ACTIONS(399),
    [anon_sym_PIPE] = ACTIONS(5041),
    [anon_sym_SEMI_SEMI] = ACTIONS(5043),
    [anon_sym_PIPE_AMP] = ACTIONS(5045),
    [anon_sym_AMP_AMP] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(5047),
    [anon_sym_LT] = ACTIONS(5049),
    [anon_sym_GT] = ACTIONS(5049),
    [anon_sym_GT_GT] = ACTIONS(5051),
    [anon_sym_AMP_GT] = ACTIONS(5049),
    [anon_sym_AMP_GT_GT] = ACTIONS(5051),
    [anon_sym_LT_AMP] = ACTIONS(5051),
    [anon_sym_GT_AMP] = ACTIONS(5051),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(5053),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5043),
    [anon_sym_AMP] = ACTIONS(5039),
  },
  [1620] = {
    [sym_concatenation] = STATE(2314),
    [sym_string] = STATE(2313),
    [sym_simple_expansion] = STATE(2313),
    [sym_string_expansion] = STATE(2313),
    [sym_expansion] = STATE(2313),
    [sym_command_substitution] = STATE(2313),
    [sym_process_substitution] = STATE(2313),
    [aux_sym_command_repeat2] = STATE(2314),
    [aux_sym__literal_repeat1] = STATE(2315),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_fi] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(5055),
    [anon_sym_EQ_EQ] = ACTIONS(5055),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [sym__special_character] = ACTIONS(5057),
    [anon_sym_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3359),
    [sym_raw_string] = ACTIONS(5059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3363),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3365),
    [anon_sym_BQUOTE] = ACTIONS(3367),
    [anon_sym_LT_LPAREN] = ACTIONS(3369),
    [anon_sym_GT_LPAREN] = ACTIONS(3369),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5061),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [1621] = {
    [sym_file_redirect] = STATE(2311),
    [sym_heredoc_redirect] = STATE(2311),
    [sym_heredoc_body] = STATE(2310),
    [sym_herestring_redirect] = STATE(2311),
    [aux_sym_redirected_statement_repeat1] = STATE(2311),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(5039),
    [anon_sym_fi] = ACTIONS(3285),
    [anon_sym_PIPE] = ACTIONS(5041),
    [anon_sym_SEMI_SEMI] = ACTIONS(5043),
    [anon_sym_PIPE_AMP] = ACTIONS(5045),
    [anon_sym_AMP_AMP] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(5047),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(5053),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(5043),
    [anon_sym_AMP] = ACTIONS(5039),
  },
  [1622] = {
    [anon_sym_EQ] = ACTIONS(4967),
    [anon_sym_PLUS_EQ] = ACTIONS(4967),
    [sym_comment] = ACTIONS(57),
  },
  [1623] = {
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_fi] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [1624] = {
    [sym_redirected_statement] = STATE(2316),
    [sym_for_statement] = STATE(2316),
    [sym_c_style_for_statement] = STATE(2316),
    [sym_while_statement] = STATE(2316),
    [sym_if_statement] = STATE(2316),
    [sym_case_statement] = STATE(2316),
    [sym_function_definition] = STATE(2316),
    [sym_compound_statement] = STATE(2316),
    [sym_subshell] = STATE(2316),
    [sym_pipeline] = STATE(2316),
    [sym_list] = STATE(2316),
    [sym_negated_command] = STATE(2316),
    [sym_test_command] = STATE(2316),
    [sym_declaration_command] = STATE(2316),
    [sym_unset_command] = STATE(2316),
    [sym_command] = STATE(2316),
    [sym_command_name] = STATE(1620),
    [sym_variable_assignment] = STATE(2317),
    [sym_subscript] = STATE(1622),
    [sym_file_redirect] = STATE(1625),
    [sym_concatenation] = STATE(1623),
    [sym_string] = STATE(1612),
    [sym_simple_expansion] = STATE(1612),
    [sym_string_expansion] = STATE(1612),
    [sym_expansion] = STATE(1612),
    [sym_command_substitution] = STATE(1612),
    [sym_process_substitution] = STATE(1612),
    [aux_sym__statements_repeat1] = STATE(251),
    [aux_sym_command_repeat1] = STATE(1625),
    [aux_sym__literal_repeat1] = STATE(1626),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(3345),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(3349),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(3351),
    [anon_sym_typeset] = ACTIONS(3351),
    [anon_sym_export] = ACTIONS(3351),
    [anon_sym_readonly] = ACTIONS(3351),
    [anon_sym_local] = ACTIONS(3351),
    [anon_sym_unset] = ACTIONS(3353),
    [anon_sym_unsetenv] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3359),
    [sym_raw_string] = ACTIONS(3361),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3363),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3365),
    [anon_sym_BQUOTE] = ACTIONS(3367),
    [anon_sym_LT_LPAREN] = ACTIONS(3369),
    [anon_sym_GT_LPAREN] = ACTIONS(3369),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3371),
  },
  [1625] = {
    [sym_command_name] = STATE(2318),
    [sym_variable_assignment] = STATE(253),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(253),
    [sym_concatenation] = STATE(1623),
    [sym_string] = STATE(1612),
    [sym_simple_expansion] = STATE(1612),
    [sym_string_expansion] = STATE(1612),
    [sym_expansion] = STATE(1612),
    [sym_command_substitution] = STATE(1612),
    [sym_process_substitution] = STATE(1612),
    [aux_sym_command_repeat1] = STATE(253),
    [aux_sym__literal_repeat1] = STATE(1626),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(5057),
    [anon_sym_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3359),
    [sym_raw_string] = ACTIONS(3361),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3363),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3365),
    [anon_sym_BQUOTE] = ACTIONS(3367),
    [anon_sym_LT_LPAREN] = ACTIONS(3369),
    [anon_sym_GT_LPAREN] = ACTIONS(3369),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3361),
  },
  [1626] = {
    [aux_sym__literal_repeat1] = STATE(2320),
    [sym__simple_heredoc_body] = ACTIONS(437),
    [sym__heredoc_body_beginning] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_fi] = ACTIONS(439),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_EQ_TILDE] = ACTIONS(439),
    [anon_sym_EQ_EQ] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(439),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(439),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [sym__special_character] = ACTIONS(5063),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [anon_sym_DOLLAR] = ACTIONS(439),
    [sym_raw_string] = ACTIONS(437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(437),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(437),
    [anon_sym_GT_LPAREN] = ACTIONS(437),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(439),
    [anon_sym_LF] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(439),
  },
  [1627] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(5065),
    [anon_sym_PLUS_EQ] = ACTIONS(5065),
    [sym_comment] = ACTIONS(57),
  },
  [1628] = {
    [aux_sym_concatenation_repeat1] = STATE(2323),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(5067),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_fi] = ACTIONS(329),
    [anon_sym_elif] = ACTIONS(329),
    [anon_sym_else] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [1629] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(2326),
    [anon_sym_DQUOTE] = ACTIONS(5069),
    [anon_sym_DOLLAR] = ACTIONS(5071),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1630] = {
    [sym_string] = STATE(2328),
    [anon_sym_DASH] = ACTIONS(5073),
    [anon_sym_DQUOTE] = ACTIONS(3377),
    [anon_sym_DOLLAR] = ACTIONS(5073),
    [sym_raw_string] = ACTIONS(5075),
    [anon_sym_POUND] = ACTIONS(5073),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5079),
    [anon_sym_AT] = ACTIONS(5079),
    [anon_sym_QMARK] = ACTIONS(5079),
    [anon_sym_0] = ACTIONS(5077),
    [anon_sym__] = ACTIONS(5077),
  },
  [1631] = {
    [aux_sym_concatenation_repeat1] = STATE(2323),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(5067),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_fi] = ACTIONS(959),
    [anon_sym_elif] = ACTIONS(959),
    [anon_sym_else] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [sym__special_character] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [1632] = {
    [sym_subscript] = STATE(2333),
    [sym_variable_name] = ACTIONS(5081),
    [anon_sym_BANG] = ACTIONS(5083),
    [anon_sym_DASH] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5085),
    [anon_sym_POUND] = ACTIONS(5083),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5087),
    [anon_sym_STAR] = ACTIONS(5089),
    [anon_sym_AT] = ACTIONS(5089),
    [anon_sym_QMARK] = ACTIONS(5089),
    [anon_sym_0] = ACTIONS(5087),
    [anon_sym__] = ACTIONS(5087),
  },
  [1633] = {
    [sym__statements] = STATE(2334),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(2335),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1634] = {
    [sym__statements] = STATE(2336),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1635] = {
    [sym__statements] = STATE(2337),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1636] = {
    [anon_sym_EQ] = ACTIONS(5065),
    [anon_sym_PLUS_EQ] = ACTIONS(5065),
    [sym_comment] = ACTIONS(57),
  },
  [1637] = {
    [sym_variable_assignment] = STATE(2338),
    [sym_subscript] = STATE(1636),
    [sym_concatenation] = STATE(2338),
    [sym_string] = STATE(1631),
    [sym_simple_expansion] = STATE(1631),
    [sym_string_expansion] = STATE(1631),
    [sym_expansion] = STATE(1631),
    [sym_command_substitution] = STATE(1631),
    [sym_process_substitution] = STATE(1631),
    [aux_sym_declaration_command_repeat1] = STATE(2338),
    [aux_sym__literal_repeat1] = STATE(1638),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(3373),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_fi] = ACTIONS(973),
    [anon_sym_elif] = ACTIONS(973),
    [anon_sym_else] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [sym__special_character] = ACTIONS(3375),
    [anon_sym_DQUOTE] = ACTIONS(3377),
    [anon_sym_DOLLAR] = ACTIONS(3379),
    [sym_raw_string] = ACTIONS(3381),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3383),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3385),
    [anon_sym_BQUOTE] = ACTIONS(3387),
    [anon_sym_LT_LPAREN] = ACTIONS(3389),
    [anon_sym_GT_LPAREN] = ACTIONS(3389),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5091),
    [sym_word] = ACTIONS(3393),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [1638] = {
    [aux_sym__literal_repeat1] = STATE(2340),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym_variable_name] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_fi] = ACTIONS(979),
    [anon_sym_elif] = ACTIONS(979),
    [anon_sym_else] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(979),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(979),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [sym__special_character] = ACTIONS(5093),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(979),
    [sym_word] = ACTIONS(979),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
  },
  [1639] = {
    [aux_sym_concatenation_repeat1] = STATE(2342),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(5095),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_fi] = ACTIONS(329),
    [anon_sym_elif] = ACTIONS(329),
    [anon_sym_else] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [1640] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(2345),
    [anon_sym_DQUOTE] = ACTIONS(5097),
    [anon_sym_DOLLAR] = ACTIONS(5099),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1641] = {
    [sym_string] = STATE(2347),
    [anon_sym_DASH] = ACTIONS(5101),
    [anon_sym_DQUOTE] = ACTIONS(3397),
    [anon_sym_DOLLAR] = ACTIONS(5101),
    [sym_raw_string] = ACTIONS(5103),
    [anon_sym_POUND] = ACTIONS(5101),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5105),
    [anon_sym_STAR] = ACTIONS(5107),
    [anon_sym_AT] = ACTIONS(5107),
    [anon_sym_QMARK] = ACTIONS(5107),
    [anon_sym_0] = ACTIONS(5105),
    [anon_sym__] = ACTIONS(5105),
  },
  [1642] = {
    [aux_sym_concatenation_repeat1] = STATE(2342),
    [sym__simple_heredoc_body] = ACTIONS(997),
    [sym__heredoc_body_beginning] = ACTIONS(997),
    [sym_file_descriptor] = ACTIONS(997),
    [sym__concat] = ACTIONS(5095),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_fi] = ACTIONS(999),
    [anon_sym_elif] = ACTIONS(999),
    [anon_sym_else] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI_SEMI] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_AMP_GT] = ACTIONS(999),
    [anon_sym_AMP_GT_GT] = ACTIONS(997),
    [anon_sym_LT_AMP] = ACTIONS(997),
    [anon_sym_GT_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_LT_LT_DASH] = ACTIONS(997),
    [anon_sym_LT_LT_LT] = ACTIONS(997),
    [sym__special_character] = ACTIONS(997),
    [anon_sym_DQUOTE] = ACTIONS(997),
    [anon_sym_DOLLAR] = ACTIONS(999),
    [sym_raw_string] = ACTIONS(997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(997),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(997),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(999),
    [sym_word] = ACTIONS(999),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
  },
  [1643] = {
    [sym_subscript] = STATE(2352),
    [sym_variable_name] = ACTIONS(5109),
    [anon_sym_BANG] = ACTIONS(5111),
    [anon_sym_DASH] = ACTIONS(5113),
    [anon_sym_DOLLAR] = ACTIONS(5113),
    [anon_sym_POUND] = ACTIONS(5111),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5115),
    [anon_sym_STAR] = ACTIONS(5117),
    [anon_sym_AT] = ACTIONS(5117),
    [anon_sym_QMARK] = ACTIONS(5117),
    [anon_sym_0] = ACTIONS(5115),
    [anon_sym__] = ACTIONS(5115),
  },
  [1644] = {
    [sym__statements] = STATE(2353),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(2354),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1645] = {
    [sym__statements] = STATE(2355),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [1646] = {
    [sym__statements] = STATE(2356),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [1647] = {
    [sym_concatenation] = STATE(2357),
    [sym_string] = STATE(1642),
    [sym_simple_expansion] = STATE(1642),
    [sym_string_expansion] = STATE(1642),
    [sym_expansion] = STATE(1642),
    [sym_command_substitution] = STATE(1642),
    [sym_process_substitution] = STATE(1642),
    [aux_sym_unset_command_repeat1] = STATE(2357),
    [aux_sym__literal_repeat1] = STATE(1648),
    [sym__simple_heredoc_body] = ACTIONS(1011),
    [sym__heredoc_body_beginning] = ACTIONS(1011),
    [sym_file_descriptor] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_fi] = ACTIONS(1013),
    [anon_sym_elif] = ACTIONS(1013),
    [anon_sym_else] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1013),
    [anon_sym_GT] = ACTIONS(1013),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT] = ACTIONS(1013),
    [anon_sym_AMP_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_AMP] = ACTIONS(1011),
    [anon_sym_GT_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(1011),
    [anon_sym_LT_LT_LT] = ACTIONS(1011),
    [sym__special_character] = ACTIONS(3395),
    [anon_sym_DQUOTE] = ACTIONS(3397),
    [anon_sym_DOLLAR] = ACTIONS(3399),
    [sym_raw_string] = ACTIONS(3401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3403),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3405),
    [anon_sym_BQUOTE] = ACTIONS(3407),
    [anon_sym_LT_LPAREN] = ACTIONS(3409),
    [anon_sym_GT_LPAREN] = ACTIONS(3409),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5119),
    [sym_word] = ACTIONS(3413),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
  },
  [1648] = {
    [aux_sym__literal_repeat1] = STATE(2359),
    [sym__simple_heredoc_body] = ACTIONS(1017),
    [sym__heredoc_body_beginning] = ACTIONS(1017),
    [sym_file_descriptor] = ACTIONS(1017),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_fi] = ACTIONS(1019),
    [anon_sym_elif] = ACTIONS(1019),
    [anon_sym_else] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1017),
    [anon_sym_PIPE_AMP] = ACTIONS(1017),
    [anon_sym_AMP_AMP] = ACTIONS(1017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1017),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1017),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1017),
    [anon_sym_LT_AMP] = ACTIONS(1017),
    [anon_sym_GT_AMP] = ACTIONS(1017),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1017),
    [anon_sym_LT_LT_LT] = ACTIONS(1017),
    [sym__special_character] = ACTIONS(5121),
    [anon_sym_DQUOTE] = ACTIONS(1017),
    [anon_sym_DOLLAR] = ACTIONS(1019),
    [sym_raw_string] = ACTIONS(1017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1017),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1017),
    [anon_sym_GT_LPAREN] = ACTIONS(1017),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1019),
    [sym_word] = ACTIONS(1019),
    [anon_sym_LF] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [1649] = {
    [sym_string] = STATE(2360),
    [sym_simple_expansion] = STATE(2360),
    [sym_string_expansion] = STATE(2360),
    [sym_expansion] = STATE(2360),
    [sym_command_substitution] = STATE(2360),
    [sym_process_substitution] = STATE(2360),
    [sym__special_character] = ACTIONS(5123),
    [anon_sym_DQUOTE] = ACTIONS(1814),
    [anon_sym_DOLLAR] = ACTIONS(1816),
    [sym_raw_string] = ACTIONS(5123),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1822),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5123),
  },
  [1650] = {
    [aux_sym_concatenation_repeat1] = STATE(2361),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_fi] = ACTIONS(1061),
    [anon_sym_elif] = ACTIONS(1061),
    [anon_sym_else] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_EQ_TILDE] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [1651] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_fi] = ACTIONS(1065),
    [anon_sym_elif] = ACTIONS(1065),
    [anon_sym_else] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_EQ_TILDE] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [1652] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(5125),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1653] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(5125),
    [anon_sym_DOLLAR] = ACTIONS(5127),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1654] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_fi] = ACTIONS(1099),
    [anon_sym_elif] = ACTIONS(1099),
    [anon_sym_else] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_EQ_TILDE] = ACTIONS(1099),
    [anon_sym_EQ_EQ] = ACTIONS(1099),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [1655] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_fi] = ACTIONS(1103),
    [anon_sym_elif] = ACTIONS(1103),
    [anon_sym_else] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_EQ_TILDE] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [1656] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_fi] = ACTIONS(1107),
    [anon_sym_elif] = ACTIONS(1107),
    [anon_sym_else] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_EQ_TILDE] = ACTIONS(1107),
    [anon_sym_EQ_EQ] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [1657] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(5129),
    [sym_comment] = ACTIONS(57),
  },
  [1658] = {
    [sym_subscript] = STATE(2367),
    [sym_variable_name] = ACTIONS(5131),
    [anon_sym_DASH] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(5133),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5135),
    [anon_sym_STAR] = ACTIONS(5137),
    [anon_sym_AT] = ACTIONS(5137),
    [anon_sym_QMARK] = ACTIONS(5137),
    [anon_sym_0] = ACTIONS(5135),
    [anon_sym__] = ACTIONS(5135),
  },
  [1659] = {
    [sym_concatenation] = STATE(2370),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2370),
    [anon_sym_RBRACE] = ACTIONS(5139),
    [anon_sym_EQ] = ACTIONS(5141),
    [anon_sym_DASH] = ACTIONS(5141),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5143),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(5145),
    [anon_sym_COLON] = ACTIONS(5141),
    [anon_sym_COLON_QMARK] = ACTIONS(5141),
    [anon_sym_COLON_DASH] = ACTIONS(5141),
    [anon_sym_PERCENT] = ACTIONS(5141),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1660] = {
    [sym_concatenation] = STATE(2373),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2373),
    [anon_sym_RBRACE] = ACTIONS(5147),
    [anon_sym_EQ] = ACTIONS(5149),
    [anon_sym_DASH] = ACTIONS(5149),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5151),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(5153),
    [anon_sym_COLON] = ACTIONS(5149),
    [anon_sym_COLON_QMARK] = ACTIONS(5149),
    [anon_sym_COLON_DASH] = ACTIONS(5149),
    [anon_sym_PERCENT] = ACTIONS(5149),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1661] = {
    [anon_sym_RPAREN] = ACTIONS(5155),
    [sym_comment] = ACTIONS(57),
  },
  [1662] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(5155),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1663] = {
    [anon_sym_BQUOTE] = ACTIONS(5155),
    [sym_comment] = ACTIONS(57),
  },
  [1664] = {
    [anon_sym_RPAREN] = ACTIONS(5157),
    [sym_comment] = ACTIONS(57),
  },
  [1665] = {
    [sym__simple_heredoc_body] = ACTIONS(5159),
    [sym__heredoc_body_beginning] = ACTIONS(5159),
    [sym_file_descriptor] = ACTIONS(5159),
    [ts_builtin_sym_end] = ACTIONS(5159),
    [anon_sym_SEMI] = ACTIONS(5161),
    [anon_sym_done] = ACTIONS(5159),
    [anon_sym_fi] = ACTIONS(5159),
    [anon_sym_elif] = ACTIONS(5159),
    [anon_sym_else] = ACTIONS(5159),
    [anon_sym_esac] = ACTIONS(5159),
    [anon_sym_PIPE] = ACTIONS(5161),
    [anon_sym_RPAREN] = ACTIONS(5159),
    [anon_sym_SEMI_SEMI] = ACTIONS(5159),
    [anon_sym_PIPE_AMP] = ACTIONS(5159),
    [anon_sym_AMP_AMP] = ACTIONS(5159),
    [anon_sym_PIPE_PIPE] = ACTIONS(5159),
    [anon_sym_LT] = ACTIONS(5161),
    [anon_sym_GT] = ACTIONS(5161),
    [anon_sym_GT_GT] = ACTIONS(5159),
    [anon_sym_AMP_GT] = ACTIONS(5161),
    [anon_sym_AMP_GT_GT] = ACTIONS(5159),
    [anon_sym_LT_AMP] = ACTIONS(5159),
    [anon_sym_GT_AMP] = ACTIONS(5159),
    [anon_sym_LT_LT] = ACTIONS(5161),
    [anon_sym_LT_LT_DASH] = ACTIONS(5159),
    [anon_sym_LT_LT_LT] = ACTIONS(5159),
    [anon_sym_BQUOTE] = ACTIONS(5159),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5159),
    [anon_sym_AMP] = ACTIONS(5161),
  },
  [1666] = {
    [anon_sym_fi] = ACTIONS(5163),
    [sym_comment] = ACTIONS(57),
  },
  [1667] = {
    [sym_elif_clause] = STATE(1682),
    [sym_else_clause] = STATE(2377),
    [aux_sym_if_statement_repeat1] = STATE(1682),
    [anon_sym_fi] = ACTIONS(5163),
    [anon_sym_elif] = ACTIONS(3441),
    [anon_sym_else] = ACTIONS(3443),
    [sym_comment] = ACTIONS(57),
  },
  [1668] = {
    [anon_sym_LT] = ACTIONS(5165),
    [anon_sym_GT] = ACTIONS(5165),
    [anon_sym_GT_GT] = ACTIONS(5167),
    [anon_sym_AMP_GT] = ACTIONS(5165),
    [anon_sym_AMP_GT_GT] = ACTIONS(5167),
    [anon_sym_LT_AMP] = ACTIONS(5167),
    [anon_sym_GT_AMP] = ACTIONS(5167),
    [sym_comment] = ACTIONS(57),
  },
  [1669] = {
    [sym_file_descriptor] = ACTIONS(1235),
    [sym_variable_name] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1239),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1239),
    [anon_sym_if] = ACTIONS(1239),
    [anon_sym_fi] = ACTIONS(4910),
    [anon_sym_elif] = ACTIONS(4910),
    [anon_sym_else] = ACTIONS(4910),
    [anon_sym_case] = ACTIONS(1239),
    [anon_sym_function] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1239),
    [anon_sym_typeset] = ACTIONS(1239),
    [anon_sym_export] = ACTIONS(1239),
    [anon_sym_readonly] = ACTIONS(1239),
    [anon_sym_local] = ACTIONS(1239),
    [anon_sym_unset] = ACTIONS(1239),
    [anon_sym_unsetenv] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_AMP_GT] = ACTIONS(1239),
    [anon_sym_AMP_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_AMP] = ACTIONS(1235),
    [anon_sym_GT_AMP] = ACTIONS(1235),
    [sym__special_character] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_DOLLAR] = ACTIONS(1239),
    [sym_raw_string] = ACTIONS(1235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1235),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1235),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [anon_sym_LT_LPAREN] = ACTIONS(1235),
    [anon_sym_GT_LPAREN] = ACTIONS(1235),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1239),
  },
  [1670] = {
    [sym_redirected_statement] = STATE(2379),
    [sym_for_statement] = STATE(2379),
    [sym_c_style_for_statement] = STATE(2379),
    [sym_while_statement] = STATE(2379),
    [sym_if_statement] = STATE(2379),
    [sym_case_statement] = STATE(2379),
    [sym_function_definition] = STATE(2379),
    [sym_compound_statement] = STATE(2379),
    [sym_subshell] = STATE(2379),
    [sym_pipeline] = STATE(2379),
    [sym_list] = STATE(2379),
    [sym_negated_command] = STATE(2379),
    [sym_test_command] = STATE(2379),
    [sym_declaration_command] = STATE(2379),
    [sym_unset_command] = STATE(2379),
    [sym_command] = STATE(2379),
    [sym_command_name] = STATE(977),
    [sym_variable_assignment] = STATE(2380),
    [sym_subscript] = STATE(979),
    [sym_file_redirect] = STATE(983),
    [sym_concatenation] = STATE(980),
    [sym_string] = STATE(968),
    [sym_simple_expansion] = STATE(968),
    [sym_string_expansion] = STATE(968),
    [sym_expansion] = STATE(968),
    [sym_command_substitution] = STATE(968),
    [sym_process_substitution] = STATE(968),
    [aux_sym_command_repeat1] = STATE(983),
    [aux_sym__literal_repeat1] = STATE(984),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1798),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1808),
    [anon_sym_typeset] = ACTIONS(1808),
    [anon_sym_export] = ACTIONS(1808),
    [anon_sym_readonly] = ACTIONS(1808),
    [anon_sym_local] = ACTIONS(1808),
    [anon_sym_unset] = ACTIONS(1810),
    [anon_sym_unsetenv] = ACTIONS(1810),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(1812),
    [anon_sym_DQUOTE] = ACTIONS(1814),
    [anon_sym_DOLLAR] = ACTIONS(1816),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1822),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1828),
  },
  [1671] = {
    [sym_redirected_statement] = STATE(2381),
    [sym_for_statement] = STATE(2381),
    [sym_c_style_for_statement] = STATE(2381),
    [sym_while_statement] = STATE(2381),
    [sym_if_statement] = STATE(2381),
    [sym_case_statement] = STATE(2381),
    [sym_function_definition] = STATE(2381),
    [sym_compound_statement] = STATE(2381),
    [sym_subshell] = STATE(2381),
    [sym_pipeline] = STATE(2381),
    [sym_list] = STATE(2381),
    [sym_negated_command] = STATE(2381),
    [sym_test_command] = STATE(2381),
    [sym_declaration_command] = STATE(2381),
    [sym_unset_command] = STATE(2381),
    [sym_command] = STATE(2381),
    [sym_command_name] = STATE(977),
    [sym_variable_assignment] = STATE(2382),
    [sym_subscript] = STATE(979),
    [sym_file_redirect] = STATE(983),
    [sym_concatenation] = STATE(980),
    [sym_string] = STATE(968),
    [sym_simple_expansion] = STATE(968),
    [sym_string_expansion] = STATE(968),
    [sym_expansion] = STATE(968),
    [sym_command_substitution] = STATE(968),
    [sym_process_substitution] = STATE(968),
    [aux_sym_command_repeat1] = STATE(983),
    [aux_sym__literal_repeat1] = STATE(984),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1798),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1808),
    [anon_sym_typeset] = ACTIONS(1808),
    [anon_sym_export] = ACTIONS(1808),
    [anon_sym_readonly] = ACTIONS(1808),
    [anon_sym_local] = ACTIONS(1808),
    [anon_sym_unset] = ACTIONS(1810),
    [anon_sym_unsetenv] = ACTIONS(1810),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(1812),
    [anon_sym_DQUOTE] = ACTIONS(1814),
    [anon_sym_DOLLAR] = ACTIONS(1816),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1822),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1828),
  },
  [1672] = {
    [sym_concatenation] = STATE(695),
    [sym_string] = STATE(2384),
    [sym_simple_expansion] = STATE(2384),
    [sym_string_expansion] = STATE(2384),
    [sym_expansion] = STATE(2384),
    [sym_command_substitution] = STATE(2384),
    [sym_process_substitution] = STATE(2384),
    [aux_sym__literal_repeat1] = STATE(2385),
    [sym__special_character] = ACTIONS(5169),
    [anon_sym_DQUOTE] = ACTIONS(4914),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(5171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4922),
    [anon_sym_BQUOTE] = ACTIONS(4924),
    [anon_sym_LT_LPAREN] = ACTIONS(4926),
    [anon_sym_GT_LPAREN] = ACTIONS(4926),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5171),
  },
  [1673] = {
    [sym_concatenation] = STATE(699),
    [sym_string] = STATE(2386),
    [sym_simple_expansion] = STATE(2386),
    [sym_string_expansion] = STATE(2386),
    [sym_expansion] = STATE(2386),
    [sym_command_substitution] = STATE(2386),
    [sym_process_substitution] = STATE(2386),
    [aux_sym__literal_repeat1] = STATE(2387),
    [sym__special_character] = ACTIONS(5169),
    [anon_sym_DQUOTE] = ACTIONS(4914),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(5173),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4922),
    [anon_sym_BQUOTE] = ACTIONS(4924),
    [anon_sym_LT_LPAREN] = ACTIONS(4926),
    [anon_sym_GT_LPAREN] = ACTIONS(4926),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5173),
  },
  [1674] = {
    [anon_sym_SEMI] = ACTIONS(5175),
    [anon_sym_fi] = ACTIONS(1237),
    [anon_sym_elif] = ACTIONS(1237),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_SEMI_SEMI] = ACTIONS(5177),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5177),
    [anon_sym_AMP] = ACTIONS(5177),
  },
  [1675] = {
    [sym_file_redirect] = STATE(2389),
    [sym_heredoc_redirect] = STATE(2389),
    [sym_herestring_redirect] = STATE(2389),
    [aux_sym_redirected_statement_repeat1] = STATE(2389),
    [sym__simple_heredoc_body] = ACTIONS(1253),
    [sym__heredoc_body_beginning] = ACTIONS(1253),
    [sym_file_descriptor] = ACTIONS(3445),
    [anon_sym_SEMI] = ACTIONS(1255),
    [anon_sym_fi] = ACTIONS(1253),
    [anon_sym_elif] = ACTIONS(1253),
    [anon_sym_else] = ACTIONS(1253),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_SEMI_SEMI] = ACTIONS(1253),
    [anon_sym_PIPE_AMP] = ACTIONS(1253),
    [anon_sym_AMP_AMP] = ACTIONS(1253),
    [anon_sym_PIPE_PIPE] = ACTIONS(1253),
    [anon_sym_LT] = ACTIONS(3457),
    [anon_sym_GT] = ACTIONS(3457),
    [anon_sym_GT_GT] = ACTIONS(3459),
    [anon_sym_AMP_GT] = ACTIONS(3457),
    [anon_sym_AMP_GT_GT] = ACTIONS(3459),
    [anon_sym_LT_AMP] = ACTIONS(3459),
    [anon_sym_GT_AMP] = ACTIONS(3459),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3461),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1255),
  },
  [1676] = {
    [sym_concatenation] = STATE(2390),
    [sym_string] = STATE(2391),
    [sym_simple_expansion] = STATE(2391),
    [sym_string_expansion] = STATE(2391),
    [sym_expansion] = STATE(2391),
    [sym_command_substitution] = STATE(2391),
    [sym_process_substitution] = STATE(2391),
    [aux_sym__literal_repeat1] = STATE(2392),
    [sym_regex] = ACTIONS(5179),
    [sym__special_character] = ACTIONS(3465),
    [anon_sym_DQUOTE] = ACTIONS(1814),
    [anon_sym_DOLLAR] = ACTIONS(1816),
    [sym_raw_string] = ACTIONS(5181),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1822),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5181),
  },
  [1677] = {
    [aux_sym_concatenation_repeat1] = STATE(1650),
    [sym__simple_heredoc_body] = ACTIONS(1261),
    [sym__heredoc_body_beginning] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_fi] = ACTIONS(1263),
    [anon_sym_elif] = ACTIONS(1263),
    [anon_sym_else] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [sym__special_character] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [1678] = {
    [sym_concatenation] = STATE(2393),
    [sym_string] = STATE(1677),
    [sym_simple_expansion] = STATE(1677),
    [sym_string_expansion] = STATE(1677),
    [sym_expansion] = STATE(1677),
    [sym_command_substitution] = STATE(1677),
    [sym_process_substitution] = STATE(1677),
    [aux_sym_command_repeat2] = STATE(2393),
    [aux_sym__literal_repeat1] = STATE(1679),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_fi] = ACTIONS(1267),
    [anon_sym_elif] = ACTIONS(1267),
    [anon_sym_else] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(3463),
    [anon_sym_EQ_EQ] = ACTIONS(3463),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(3465),
    [anon_sym_DQUOTE] = ACTIONS(1814),
    [anon_sym_DOLLAR] = ACTIONS(1816),
    [sym_raw_string] = ACTIONS(3467),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1822),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3469),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [1679] = {
    [aux_sym__literal_repeat1] = STATE(1685),
    [sym__simple_heredoc_body] = ACTIONS(1269),
    [sym__heredoc_body_beginning] = ACTIONS(1269),
    [sym_file_descriptor] = ACTIONS(1269),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_fi] = ACTIONS(1271),
    [anon_sym_elif] = ACTIONS(1271),
    [anon_sym_else] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE_AMP] = ACTIONS(1269),
    [anon_sym_AMP_AMP] = ACTIONS(1269),
    [anon_sym_PIPE_PIPE] = ACTIONS(1269),
    [anon_sym_EQ_TILDE] = ACTIONS(1271),
    [anon_sym_EQ_EQ] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT_GT] = ACTIONS(1269),
    [anon_sym_LT_AMP] = ACTIONS(1269),
    [anon_sym_GT_AMP] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_LT_LT_DASH] = ACTIONS(1269),
    [anon_sym_LT_LT_LT] = ACTIONS(1269),
    [sym__special_character] = ACTIONS(3471),
    [anon_sym_DQUOTE] = ACTIONS(1269),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1269),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1269),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [anon_sym_LT_LPAREN] = ACTIONS(1269),
    [anon_sym_GT_LPAREN] = ACTIONS(1269),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1271),
  },
  [1680] = {
    [sym_file_redirect] = STATE(1675),
    [sym_heredoc_redirect] = STATE(1675),
    [sym_heredoc_body] = STATE(2395),
    [sym_herestring_redirect] = STATE(1675),
    [aux_sym_redirected_statement_repeat1] = STATE(1675),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(3445),
    [anon_sym_SEMI] = ACTIONS(5183),
    [anon_sym_fi] = ACTIONS(1237),
    [anon_sym_elif] = ACTIONS(1237),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_PIPE] = ACTIONS(3449),
    [anon_sym_SEMI_SEMI] = ACTIONS(5185),
    [anon_sym_PIPE_AMP] = ACTIONS(3453),
    [anon_sym_AMP_AMP] = ACTIONS(3455),
    [anon_sym_PIPE_PIPE] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(3457),
    [anon_sym_GT] = ACTIONS(3457),
    [anon_sym_GT_GT] = ACTIONS(3459),
    [anon_sym_AMP_GT] = ACTIONS(3457),
    [anon_sym_AMP_GT_GT] = ACTIONS(3459),
    [anon_sym_LT_AMP] = ACTIONS(3459),
    [anon_sym_GT_AMP] = ACTIONS(3459),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3461),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5183),
  },
  [1681] = {
    [sym_file_redirect] = STATE(1675),
    [sym_heredoc_redirect] = STATE(1675),
    [sym_heredoc_body] = STATE(2395),
    [sym_herestring_redirect] = STATE(1675),
    [aux_sym_redirected_statement_repeat1] = STATE(1675),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(5183),
    [anon_sym_fi] = ACTIONS(4910),
    [anon_sym_elif] = ACTIONS(4910),
    [anon_sym_else] = ACTIONS(4910),
    [anon_sym_PIPE] = ACTIONS(3449),
    [anon_sym_SEMI_SEMI] = ACTIONS(5185),
    [anon_sym_PIPE_AMP] = ACTIONS(3453),
    [anon_sym_AMP_AMP] = ACTIONS(3455),
    [anon_sym_PIPE_PIPE] = ACTIONS(3455),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(3461),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(5185),
    [anon_sym_AMP] = ACTIONS(5183),
  },
  [1682] = {
    [sym_elif_clause] = STATE(1682),
    [aux_sym_if_statement_repeat1] = STATE(1682),
    [anon_sym_fi] = ACTIONS(5187),
    [anon_sym_elif] = ACTIONS(5189),
    [anon_sym_else] = ACTIONS(5187),
    [sym_comment] = ACTIONS(57),
  },
  [1683] = {
    [sym_concatenation] = STATE(2396),
    [sym_string] = STATE(1677),
    [sym_simple_expansion] = STATE(1677),
    [sym_string_expansion] = STATE(1677),
    [sym_expansion] = STATE(1677),
    [sym_command_substitution] = STATE(1677),
    [sym_process_substitution] = STATE(1677),
    [aux_sym_command_repeat2] = STATE(2396),
    [aux_sym__literal_repeat1] = STATE(1679),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_fi] = ACTIONS(1267),
    [anon_sym_elif] = ACTIONS(1267),
    [anon_sym_else] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(3463),
    [anon_sym_EQ_EQ] = ACTIONS(3463),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(3465),
    [anon_sym_DQUOTE] = ACTIONS(1814),
    [anon_sym_DOLLAR] = ACTIONS(1816),
    [sym_raw_string] = ACTIONS(3467),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1822),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3469),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [1684] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_fi] = ACTIONS(329),
    [anon_sym_elif] = ACTIONS(329),
    [anon_sym_else] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [1685] = {
    [aux_sym__literal_repeat1] = STATE(1685),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_fi] = ACTIONS(1373),
    [anon_sym_elif] = ACTIONS(1373),
    [anon_sym_else] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_EQ_TILDE] = ACTIONS(1373),
    [anon_sym_EQ_EQ] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(5192),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1686] = {
    [sym__concat] = ACTIONS(4053),
    [anon_sym_in] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4053),
  },
  [1687] = {
    [sym__simple_heredoc_body] = ACTIONS(5195),
    [sym__heredoc_body_beginning] = ACTIONS(5195),
    [sym_file_descriptor] = ACTIONS(5195),
    [ts_builtin_sym_end] = ACTIONS(5195),
    [anon_sym_SEMI] = ACTIONS(5197),
    [anon_sym_done] = ACTIONS(5195),
    [anon_sym_fi] = ACTIONS(5195),
    [anon_sym_elif] = ACTIONS(5195),
    [anon_sym_else] = ACTIONS(5195),
    [anon_sym_esac] = ACTIONS(5195),
    [anon_sym_PIPE] = ACTIONS(5197),
    [anon_sym_RPAREN] = ACTIONS(5195),
    [anon_sym_SEMI_SEMI] = ACTIONS(5195),
    [anon_sym_PIPE_AMP] = ACTIONS(5195),
    [anon_sym_AMP_AMP] = ACTIONS(5195),
    [anon_sym_PIPE_PIPE] = ACTIONS(5195),
    [anon_sym_LT] = ACTIONS(5197),
    [anon_sym_GT] = ACTIONS(5197),
    [anon_sym_GT_GT] = ACTIONS(5195),
    [anon_sym_AMP_GT] = ACTIONS(5197),
    [anon_sym_AMP_GT_GT] = ACTIONS(5195),
    [anon_sym_LT_AMP] = ACTIONS(5195),
    [anon_sym_GT_AMP] = ACTIONS(5195),
    [anon_sym_LT_LT] = ACTIONS(5197),
    [anon_sym_LT_LT_DASH] = ACTIONS(5195),
    [anon_sym_LT_LT_LT] = ACTIONS(5195),
    [anon_sym_BQUOTE] = ACTIONS(5195),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5195),
    [anon_sym_AMP] = ACTIONS(5197),
  },
  [1688] = {
    [aux_sym_concatenation_repeat1] = STATE(2397),
    [sym__concat] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
  },
  [1689] = {
    [aux_sym_case_item_repeat1] = STATE(2400),
    [aux_sym_concatenation_repeat1] = STATE(2397),
    [sym__concat] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(5199),
    [anon_sym_RPAREN] = ACTIONS(5201),
    [sym_comment] = ACTIONS(57),
  },
  [1690] = {
    [anon_sym_esac] = ACTIONS(5203),
    [sym_comment] = ACTIONS(57),
  },
  [1691] = {
    [aux_sym_case_item_repeat1] = STATE(2400),
    [anon_sym_PIPE] = ACTIONS(5199),
    [anon_sym_RPAREN] = ACTIONS(5201),
    [sym_comment] = ACTIONS(57),
  },
  [1692] = {
    [sym_case_item] = STATE(2403),
    [sym_last_case_item] = STATE(2402),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(2403),
    [aux_sym__literal_repeat1] = STATE(1693),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3482),
  },
  [1693] = {
    [aux_sym_case_item_repeat1] = STATE(2405),
    [aux_sym__literal_repeat1] = STATE(2406),
    [anon_sym_PIPE] = ACTIONS(5199),
    [anon_sym_RPAREN] = ACTIONS(5205),
    [sym__special_character] = ACTIONS(1542),
    [sym_comment] = ACTIONS(57),
  },
  [1694] = {
    [sym_case_item] = STATE(2407),
    [sym_last_case_item] = STATE(2402),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(2407),
    [aux_sym__literal_repeat1] = STATE(1693),
    [anon_sym_esac] = ACTIONS(5207),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3484),
  },
  [1695] = {
    [sym__concat] = ACTIONS(4067),
    [anon_sym_in] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4067),
  },
  [1696] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(5209),
    [sym_comment] = ACTIONS(57),
  },
  [1697] = {
    [anon_sym_RBRACE] = ACTIONS(5209),
    [sym_comment] = ACTIONS(57),
  },
  [1698] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(5211),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [1699] = {
    [sym_concatenation] = STATE(2411),
    [sym_string] = STATE(2410),
    [sym_simple_expansion] = STATE(2410),
    [sym_string_expansion] = STATE(2410),
    [sym_expansion] = STATE(2410),
    [sym_command_substitution] = STATE(2410),
    [sym_process_substitution] = STATE(2410),
    [aux_sym__literal_repeat1] = STATE(2412),
    [anon_sym_RBRACE] = ACTIONS(5209),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(5213),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5213),
  },
  [1700] = {
    [sym__concat] = ACTIONS(4103),
    [anon_sym_in] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4103),
  },
  [1701] = {
    [sym_concatenation] = STATE(2415),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2415),
    [sym_regex] = ACTIONS(5215),
    [anon_sym_RBRACE] = ACTIONS(5217),
    [anon_sym_EQ] = ACTIONS(5219),
    [anon_sym_DASH] = ACTIONS(5219),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5221),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5219),
    [anon_sym_COLON_QMARK] = ACTIONS(5219),
    [anon_sym_COLON_DASH] = ACTIONS(5219),
    [anon_sym_PERCENT] = ACTIONS(5219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1702] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5217),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1703] = {
    [sym_concatenation] = STATE(2417),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2417),
    [sym_regex] = ACTIONS(5223),
    [anon_sym_RBRACE] = ACTIONS(5209),
    [anon_sym_EQ] = ACTIONS(5225),
    [anon_sym_DASH] = ACTIONS(5225),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5225),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_COLON_DASH] = ACTIONS(5225),
    [anon_sym_PERCENT] = ACTIONS(5225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1704] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5209),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1705] = {
    [sym_concatenation] = STATE(2419),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2419),
    [anon_sym_RBRACE] = ACTIONS(5229),
    [anon_sym_EQ] = ACTIONS(5231),
    [anon_sym_DASH] = ACTIONS(5231),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5231),
    [anon_sym_COLON_QMARK] = ACTIONS(5231),
    [anon_sym_COLON_DASH] = ACTIONS(5231),
    [anon_sym_PERCENT] = ACTIONS(5231),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1706] = {
    [sym__concat] = ACTIONS(4159),
    [anon_sym_in] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
  },
  [1707] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5229),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1708] = {
    [sym_concatenation] = STATE(2417),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2417),
    [anon_sym_RBRACE] = ACTIONS(5209),
    [anon_sym_EQ] = ACTIONS(5225),
    [anon_sym_DASH] = ACTIONS(5225),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5227),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5225),
    [anon_sym_COLON_QMARK] = ACTIONS(5225),
    [anon_sym_COLON_DASH] = ACTIONS(5225),
    [anon_sym_PERCENT] = ACTIONS(5225),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1709] = {
    [sym__simple_heredoc_body] = ACTIONS(5235),
    [sym__heredoc_body_beginning] = ACTIONS(5235),
    [sym_file_descriptor] = ACTIONS(5235),
    [ts_builtin_sym_end] = ACTIONS(5235),
    [anon_sym_SEMI] = ACTIONS(5237),
    [anon_sym_done] = ACTIONS(5235),
    [anon_sym_fi] = ACTIONS(5235),
    [anon_sym_elif] = ACTIONS(5235),
    [anon_sym_else] = ACTIONS(5235),
    [anon_sym_esac] = ACTIONS(5235),
    [anon_sym_PIPE] = ACTIONS(5237),
    [anon_sym_RPAREN] = ACTIONS(5235),
    [anon_sym_SEMI_SEMI] = ACTIONS(5235),
    [anon_sym_PIPE_AMP] = ACTIONS(5235),
    [anon_sym_AMP_AMP] = ACTIONS(5235),
    [anon_sym_PIPE_PIPE] = ACTIONS(5235),
    [anon_sym_LT] = ACTIONS(5237),
    [anon_sym_GT] = ACTIONS(5237),
    [anon_sym_GT_GT] = ACTIONS(5235),
    [anon_sym_AMP_GT] = ACTIONS(5237),
    [anon_sym_AMP_GT_GT] = ACTIONS(5235),
    [anon_sym_LT_AMP] = ACTIONS(5235),
    [anon_sym_GT_AMP] = ACTIONS(5235),
    [anon_sym_LT_LT] = ACTIONS(5237),
    [anon_sym_LT_LT_DASH] = ACTIONS(5235),
    [anon_sym_LT_LT_LT] = ACTIONS(5235),
    [anon_sym_BQUOTE] = ACTIONS(5235),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5235),
    [anon_sym_AMP] = ACTIONS(5237),
  },
  [1710] = {
    [anon_sym_esac] = ACTIONS(5239),
    [sym_comment] = ACTIONS(57),
  },
  [1711] = {
    [sym_case_item] = STATE(2403),
    [sym_last_case_item] = STATE(2421),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(2403),
    [aux_sym__literal_repeat1] = STATE(1693),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3482),
  },
  [1712] = {
    [sym_case_item] = STATE(2422),
    [sym_last_case_item] = STATE(2421),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(2422),
    [aux_sym__literal_repeat1] = STATE(1693),
    [anon_sym_esac] = ACTIONS(5241),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3484),
  },
  [1713] = {
    [sym__simple_heredoc_body] = ACTIONS(5243),
    [sym__heredoc_body_beginning] = ACTIONS(5243),
    [sym_file_descriptor] = ACTIONS(5243),
    [ts_builtin_sym_end] = ACTIONS(5243),
    [anon_sym_SEMI] = ACTIONS(5245),
    [anon_sym_done] = ACTIONS(5243),
    [anon_sym_fi] = ACTIONS(5243),
    [anon_sym_elif] = ACTIONS(5243),
    [anon_sym_else] = ACTIONS(5243),
    [anon_sym_esac] = ACTIONS(5243),
    [anon_sym_PIPE] = ACTIONS(5245),
    [anon_sym_RPAREN] = ACTIONS(5243),
    [anon_sym_SEMI_SEMI] = ACTIONS(5243),
    [anon_sym_PIPE_AMP] = ACTIONS(5243),
    [anon_sym_AMP_AMP] = ACTIONS(5243),
    [anon_sym_PIPE_PIPE] = ACTIONS(5243),
    [anon_sym_LT] = ACTIONS(5245),
    [anon_sym_GT] = ACTIONS(5245),
    [anon_sym_GT_GT] = ACTIONS(5243),
    [anon_sym_AMP_GT] = ACTIONS(5245),
    [anon_sym_AMP_GT_GT] = ACTIONS(5243),
    [anon_sym_LT_AMP] = ACTIONS(5243),
    [anon_sym_GT_AMP] = ACTIONS(5243),
    [anon_sym_LT_LT] = ACTIONS(5245),
    [anon_sym_LT_LT_DASH] = ACTIONS(5243),
    [anon_sym_LT_LT_LT] = ACTIONS(5243),
    [anon_sym_BQUOTE] = ACTIONS(5243),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5243),
    [anon_sym_AMP] = ACTIONS(5245),
  },
  [1714] = {
    [aux_sym_concatenation_repeat1] = STATE(2423),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(1420),
    [sym_variable_name] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_RPAREN] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [1715] = {
    [aux_sym__literal_repeat1] = STATE(1715),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym_variable_name] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_RPAREN] = ACTIONS(1371),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(2773),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1716] = {
    [aux_sym_concatenation_repeat1] = STATE(1010),
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym__concat] = ACTIONS(943),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_RPAREN] = ACTIONS(1398),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1400),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [1717] = {
    [aux_sym__literal_repeat1] = STATE(1012),
    [sym__simple_heredoc_body] = ACTIONS(1444),
    [sym__heredoc_body_beginning] = ACTIONS(1444),
    [sym_file_descriptor] = ACTIONS(1444),
    [sym_variable_name] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1446),
    [anon_sym_RPAREN] = ACTIONS(1444),
    [anon_sym_SEMI_SEMI] = ACTIONS(1444),
    [anon_sym_PIPE_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1446),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_AMP_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT_GT] = ACTIONS(1444),
    [anon_sym_LT_AMP] = ACTIONS(1444),
    [anon_sym_GT_AMP] = ACTIONS(1444),
    [anon_sym_LT_LT] = ACTIONS(1446),
    [anon_sym_LT_LT_DASH] = ACTIONS(1444),
    [anon_sym_LT_LT_LT] = ACTIONS(1444),
    [sym__special_character] = ACTIONS(981),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [anon_sym_DOLLAR] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1444),
    [anon_sym_BQUOTE] = ACTIONS(1444),
    [anon_sym_LT_LPAREN] = ACTIONS(1444),
    [anon_sym_GT_LPAREN] = ACTIONS(1444),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1446),
    [sym_word] = ACTIONS(1446),
    [anon_sym_LF] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1446),
  },
  [1718] = {
    [aux_sym_concatenation_repeat1] = STATE(1718),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(3914),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_RPAREN] = ACTIONS(2344),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1719] = {
    [aux_sym_concatenation_repeat1] = STATE(1719),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(3949),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_RPAREN] = ACTIONS(2344),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1720] = {
    [aux_sym_concatenation_repeat1] = STATE(1722),
    [sym__simple_heredoc_body] = ACTIONS(1378),
    [sym__heredoc_body_beginning] = ACTIONS(1378),
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_RPAREN] = ACTIONS(1378),
    [anon_sym_SEMI_SEMI] = ACTIONS(1378),
    [anon_sym_PIPE_AMP] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_AMP] = ACTIONS(1378),
    [anon_sym_GT_AMP] = ACTIONS(1378),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1378),
    [anon_sym_LT_LT_LT] = ACTIONS(1378),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1378),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [1721] = {
    [aux_sym__literal_repeat1] = STATE(1723),
    [sym__simple_heredoc_body] = ACTIONS(1382),
    [sym__heredoc_body_beginning] = ACTIONS(1382),
    [sym_file_descriptor] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym_PIPE] = ACTIONS(1384),
    [anon_sym_RPAREN] = ACTIONS(1382),
    [anon_sym_SEMI_SEMI] = ACTIONS(1382),
    [anon_sym_PIPE_AMP] = ACTIONS(1382),
    [anon_sym_AMP_AMP] = ACTIONS(1382),
    [anon_sym_PIPE_PIPE] = ACTIONS(1382),
    [anon_sym_LT] = ACTIONS(1384),
    [anon_sym_GT] = ACTIONS(1384),
    [anon_sym_GT_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT_GT] = ACTIONS(1382),
    [anon_sym_LT_AMP] = ACTIONS(1382),
    [anon_sym_GT_AMP] = ACTIONS(1382),
    [anon_sym_LT_LT] = ACTIONS(1384),
    [anon_sym_LT_LT_DASH] = ACTIONS(1382),
    [anon_sym_LT_LT_LT] = ACTIONS(1382),
    [sym__special_character] = ACTIONS(441),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
  },
  [1722] = {
    [aux_sym_concatenation_repeat1] = STATE(2424),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_RPAREN] = ACTIONS(1059),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [1723] = {
    [aux_sym__literal_repeat1] = STATE(1723),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_RPAREN] = ACTIONS(1371),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(1375),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1724] = {
    [sym__simple_heredoc_body] = ACTIONS(2697),
    [sym__heredoc_body_beginning] = ACTIONS(2697),
    [sym_file_descriptor] = ACTIONS(2697),
    [sym_variable_name] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI_SEMI] = ACTIONS(2697),
    [anon_sym_RBRACE] = ACTIONS(2697),
    [anon_sym_PIPE_AMP] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_PIPE_PIPE] = ACTIONS(2697),
    [anon_sym_LT] = ACTIONS(2699),
    [anon_sym_GT] = ACTIONS(2699),
    [anon_sym_GT_GT] = ACTIONS(2697),
    [anon_sym_AMP_GT] = ACTIONS(2699),
    [anon_sym_AMP_GT_GT] = ACTIONS(2697),
    [anon_sym_LT_AMP] = ACTIONS(2697),
    [anon_sym_GT_AMP] = ACTIONS(2697),
    [anon_sym_LT_LT] = ACTIONS(2699),
    [anon_sym_LT_LT_DASH] = ACTIONS(2697),
    [anon_sym_LT_LT_LT] = ACTIONS(2697),
    [sym__special_character] = ACTIONS(2699),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [anon_sym_DOLLAR] = ACTIONS(2699),
    [sym_raw_string] = ACTIONS(2697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2697),
    [anon_sym_BQUOTE] = ACTIONS(2697),
    [anon_sym_LT_LPAREN] = ACTIONS(2697),
    [anon_sym_GT_LPAREN] = ACTIONS(2697),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2699),
    [anon_sym_LF] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
  },
  [1725] = {
    [sym_concatenation] = STATE(1357),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(1357),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(5247),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [1726] = {
    [sym_string] = STATE(2426),
    [sym_simple_expansion] = STATE(2426),
    [sym_string_expansion] = STATE(2426),
    [sym_expansion] = STATE(2426),
    [sym_command_substitution] = STATE(2426),
    [sym_process_substitution] = STATE(2426),
    [sym__special_character] = ACTIONS(5249),
    [anon_sym_DQUOTE] = ACTIONS(1919),
    [anon_sym_DOLLAR] = ACTIONS(1921),
    [sym_raw_string] = ACTIONS(5249),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1925),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1927),
    [anon_sym_BQUOTE] = ACTIONS(1929),
    [anon_sym_LT_LPAREN] = ACTIONS(1931),
    [anon_sym_GT_LPAREN] = ACTIONS(1931),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5249),
  },
  [1727] = {
    [aux_sym_concatenation_repeat1] = STATE(2427),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(3583),
    [sym_variable_name] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [1728] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [sym_variable_name] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_RBRACE] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1065),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [1729] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(5251),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1730] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(5251),
    [anon_sym_DOLLAR] = ACTIONS(5253),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1731] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_RBRACE] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [1732] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [sym_variable_name] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_RBRACE] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [1733] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [sym_variable_name] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_RBRACE] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [1734] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(5255),
    [sym_comment] = ACTIONS(57),
  },
  [1735] = {
    [sym_subscript] = STATE(2433),
    [sym_variable_name] = ACTIONS(5257),
    [anon_sym_DASH] = ACTIONS(5259),
    [anon_sym_DOLLAR] = ACTIONS(5259),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5261),
    [anon_sym_STAR] = ACTIONS(5263),
    [anon_sym_AT] = ACTIONS(5263),
    [anon_sym_QMARK] = ACTIONS(5263),
    [anon_sym_0] = ACTIONS(5261),
    [anon_sym__] = ACTIONS(5261),
  },
  [1736] = {
    [sym_concatenation] = STATE(2436),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2436),
    [anon_sym_RBRACE] = ACTIONS(5265),
    [anon_sym_EQ] = ACTIONS(5267),
    [anon_sym_DASH] = ACTIONS(5267),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(5271),
    [anon_sym_COLON] = ACTIONS(5267),
    [anon_sym_COLON_QMARK] = ACTIONS(5267),
    [anon_sym_COLON_DASH] = ACTIONS(5267),
    [anon_sym_PERCENT] = ACTIONS(5267),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1737] = {
    [sym_concatenation] = STATE(2439),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2439),
    [anon_sym_RBRACE] = ACTIONS(5273),
    [anon_sym_EQ] = ACTIONS(5275),
    [anon_sym_DASH] = ACTIONS(5275),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5277),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(5279),
    [anon_sym_COLON] = ACTIONS(5275),
    [anon_sym_COLON_QMARK] = ACTIONS(5275),
    [anon_sym_COLON_DASH] = ACTIONS(5275),
    [anon_sym_PERCENT] = ACTIONS(5275),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1738] = {
    [anon_sym_RPAREN] = ACTIONS(5281),
    [sym_comment] = ACTIONS(57),
  },
  [1739] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(5281),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1740] = {
    [anon_sym_BQUOTE] = ACTIONS(5281),
    [sym_comment] = ACTIONS(57),
  },
  [1741] = {
    [anon_sym_RPAREN] = ACTIONS(5283),
    [sym_comment] = ACTIONS(57),
  },
  [1742] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_RBRACE] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(329),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [1743] = {
    [aux_sym__literal_repeat1] = STATE(1743),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym_variable_name] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_RBRACE] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(5285),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1744] = {
    [sym__expression] = STATE(2443),
    [sym_binary_expression] = STATE(2443),
    [sym_unary_expression] = STATE(2443),
    [sym_postfix_expression] = STATE(2443),
    [sym_parenthesized_expression] = STATE(2443),
    [sym_concatenation] = STATE(2443),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5288),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_character] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [1745] = {
    [anon_sym_SEMI] = ACTIONS(5290),
    [anon_sym_SEMI_SEMI] = ACTIONS(5292),
    [anon_sym_AMP_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1482),
    [anon_sym_EQ_TILDE] = ACTIONS(1484),
    [anon_sym_EQ_EQ] = ACTIONS(1484),
    [anon_sym_EQ] = ACTIONS(1486),
    [anon_sym_PLUS_EQ] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(1486),
    [anon_sym_GT] = ACTIONS(1486),
    [anon_sym_BANG_EQ] = ACTIONS(1482),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_DASH_EQ] = ACTIONS(1482),
    [anon_sym_LT_EQ] = ACTIONS(1482),
    [anon_sym_GT_EQ] = ACTIONS(1482),
    [anon_sym_PLUS_PLUS] = ACTIONS(1488),
    [anon_sym_DASH_DASH] = ACTIONS(1488),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1482),
    [anon_sym_LF] = ACTIONS(5292),
    [anon_sym_AMP] = ACTIONS(5290),
  },
  [1746] = {
    [sym__expression] = STATE(2445),
    [sym_binary_expression] = STATE(2445),
    [sym_unary_expression] = STATE(2445),
    [sym_postfix_expression] = STATE(2445),
    [sym_parenthesized_expression] = STATE(2445),
    [sym_concatenation] = STATE(2445),
    [sym_string] = STATE(280),
    [sym_simple_expansion] = STATE(280),
    [sym_string_expansion] = STATE(280),
    [sym_expansion] = STATE(280),
    [sym_command_substitution] = STATE(280),
    [sym_process_substitution] = STATE(280),
    [aux_sym__literal_repeat1] = STATE(286),
    [anon_sym_SEMI] = ACTIONS(5290),
    [anon_sym_SEMI_SEMI] = ACTIONS(5292),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_BANG] = ACTIONS(475),
    [sym__special_character] = ACTIONS(477),
    [anon_sym_DQUOTE] = ACTIONS(479),
    [anon_sym_DOLLAR] = ACTIONS(481),
    [sym_raw_string] = ACTIONS(483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(485),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(489),
    [anon_sym_LT_LPAREN] = ACTIONS(491),
    [anon_sym_GT_LPAREN] = ACTIONS(491),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(493),
    [sym_test_operator] = ACTIONS(495),
    [anon_sym_LF] = ACTIONS(5292),
    [anon_sym_AMP] = ACTIONS(5292),
  },
  [1747] = {
    [sym_concatenation] = STATE(1416),
    [sym_string] = STATE(783),
    [sym_simple_expansion] = STATE(783),
    [sym_string_expansion] = STATE(783),
    [sym_expansion] = STATE(783),
    [sym_command_substitution] = STATE(783),
    [sym_process_substitution] = STATE(783),
    [aux_sym_for_statement_repeat1] = STATE(1416),
    [aux_sym__literal_repeat1] = STATE(789),
    [anon_sym_SEMI] = ACTIONS(5294),
    [anon_sym_SEMI_SEMI] = ACTIONS(5296),
    [sym__special_character] = ACTIONS(1492),
    [anon_sym_DQUOTE] = ACTIONS(1494),
    [anon_sym_DOLLAR] = ACTIONS(1496),
    [sym_raw_string] = ACTIONS(1498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1502),
    [anon_sym_BQUOTE] = ACTIONS(1504),
    [anon_sym_LT_LPAREN] = ACTIONS(1506),
    [anon_sym_GT_LPAREN] = ACTIONS(1506),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2855),
    [anon_sym_LF] = ACTIONS(5296),
    [anon_sym_AMP] = ACTIONS(5296),
  },
  [1748] = {
    [sym__simple_heredoc_body] = ACTIONS(2859),
    [sym__heredoc_body_beginning] = ACTIONS(2859),
    [sym_file_descriptor] = ACTIONS(2859),
    [anon_sym_SEMI] = ACTIONS(2861),
    [anon_sym_PIPE] = ACTIONS(2861),
    [anon_sym_SEMI_SEMI] = ACTIONS(2859),
    [anon_sym_RBRACE] = ACTIONS(2859),
    [anon_sym_PIPE_AMP] = ACTIONS(2859),
    [anon_sym_AMP_AMP] = ACTIONS(2859),
    [anon_sym_PIPE_PIPE] = ACTIONS(2859),
    [anon_sym_LT] = ACTIONS(2861),
    [anon_sym_GT] = ACTIONS(2861),
    [anon_sym_GT_GT] = ACTIONS(2859),
    [anon_sym_AMP_GT] = ACTIONS(2861),
    [anon_sym_AMP_GT_GT] = ACTIONS(2859),
    [anon_sym_LT_AMP] = ACTIONS(2859),
    [anon_sym_GT_AMP] = ACTIONS(2859),
    [anon_sym_LT_LT] = ACTIONS(2861),
    [anon_sym_LT_LT_DASH] = ACTIONS(2859),
    [anon_sym_LT_LT_LT] = ACTIONS(2859),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2859),
    [anon_sym_AMP] = ACTIONS(2861),
  },
  [1749] = {
    [sym__simple_heredoc_body] = ACTIONS(3187),
    [sym__heredoc_body_beginning] = ACTIONS(3187),
    [sym_file_descriptor] = ACTIONS(3187),
    [anon_sym_SEMI] = ACTIONS(3189),
    [anon_sym_PIPE] = ACTIONS(3189),
    [anon_sym_SEMI_SEMI] = ACTIONS(3187),
    [anon_sym_RBRACE] = ACTIONS(3187),
    [anon_sym_PIPE_AMP] = ACTIONS(3187),
    [anon_sym_AMP_AMP] = ACTIONS(3187),
    [anon_sym_PIPE_PIPE] = ACTIONS(3187),
    [anon_sym_LT] = ACTIONS(3189),
    [anon_sym_GT] = ACTIONS(3189),
    [anon_sym_GT_GT] = ACTIONS(3187),
    [anon_sym_AMP_GT] = ACTIONS(3189),
    [anon_sym_AMP_GT_GT] = ACTIONS(3187),
    [anon_sym_LT_AMP] = ACTIONS(3187),
    [anon_sym_GT_AMP] = ACTIONS(3187),
    [anon_sym_LT_LT] = ACTIONS(3189),
    [anon_sym_LT_LT_DASH] = ACTIONS(3187),
    [anon_sym_LT_LT_LT] = ACTIONS(3187),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3187),
    [anon_sym_AMP] = ACTIONS(3189),
  },
  [1750] = {
    [anon_sym_done] = ACTIONS(5298),
    [sym_comment] = ACTIONS(57),
  },
  [1751] = {
    [sym__simple_heredoc_body] = ACTIONS(3341),
    [sym__heredoc_body_beginning] = ACTIONS(3341),
    [sym_file_descriptor] = ACTIONS(3341),
    [anon_sym_SEMI] = ACTIONS(3343),
    [anon_sym_PIPE] = ACTIONS(3343),
    [anon_sym_SEMI_SEMI] = ACTIONS(3341),
    [anon_sym_RBRACE] = ACTIONS(3341),
    [anon_sym_PIPE_AMP] = ACTIONS(3341),
    [anon_sym_AMP_AMP] = ACTIONS(3341),
    [anon_sym_PIPE_PIPE] = ACTIONS(3341),
    [anon_sym_LT] = ACTIONS(3343),
    [anon_sym_GT] = ACTIONS(3343),
    [anon_sym_GT_GT] = ACTIONS(3341),
    [anon_sym_AMP_GT] = ACTIONS(3343),
    [anon_sym_AMP_GT_GT] = ACTIONS(3341),
    [anon_sym_LT_AMP] = ACTIONS(3341),
    [anon_sym_GT_AMP] = ACTIONS(3341),
    [anon_sym_LT_LT] = ACTIONS(3343),
    [anon_sym_LT_LT_DASH] = ACTIONS(3341),
    [anon_sym_LT_LT_LT] = ACTIONS(3341),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(3341),
    [anon_sym_AMP] = ACTIONS(3343),
  },
  [1752] = {
    [sym_elif_clause] = STATE(2450),
    [sym_else_clause] = STATE(2449),
    [aux_sym_if_statement_repeat1] = STATE(2450),
    [anon_sym_fi] = ACTIONS(5300),
    [anon_sym_elif] = ACTIONS(3441),
    [anon_sym_else] = ACTIONS(3443),
    [sym_comment] = ACTIONS(57),
  },
  [1753] = {
    [anon_sym_fi] = ACTIONS(5300),
    [sym_comment] = ACTIONS(57),
  },
  [1754] = {
    [sym_elif_clause] = STATE(1682),
    [sym_else_clause] = STATE(2449),
    [aux_sym_if_statement_repeat1] = STATE(1682),
    [anon_sym_fi] = ACTIONS(5300),
    [anon_sym_elif] = ACTIONS(3441),
    [anon_sym_else] = ACTIONS(3443),
    [sym_comment] = ACTIONS(57),
  },
  [1755] = {
    [sym_case_item] = STATE(2453),
    [sym_last_case_item] = STATE(2452),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(2453),
    [aux_sym__literal_repeat1] = STATE(1693),
    [anon_sym_esac] = ACTIONS(5302),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3484),
  },
  [1756] = {
    [anon_sym_SEMI] = ACTIONS(5304),
    [anon_sym_SEMI_SEMI] = ACTIONS(5306),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5306),
    [anon_sym_AMP] = ACTIONS(5306),
  },
  [1757] = {
    [sym_case_item] = STATE(2457),
    [sym_last_case_item] = STATE(2456),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(2457),
    [aux_sym__literal_repeat1] = STATE(1693),
    [anon_sym_esac] = ACTIONS(5308),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3484),
  },
  [1758] = {
    [anon_sym_SEMI] = ACTIONS(5310),
    [anon_sym_SEMI_SEMI] = ACTIONS(5312),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5312),
    [anon_sym_AMP] = ACTIONS(5312),
  },
  [1759] = {
    [sym_compound_statement] = STATE(2459),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [1760] = {
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_RBRACE] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1400),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [1761] = {
    [sym_concatenation] = STATE(2461),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(2461),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(5314),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [1762] = {
    [aux_sym_concatenation_repeat1] = STATE(1061),
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym__concat] = ACTIONS(1969),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_RBRACE] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1400),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1400),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [1763] = {
    [aux_sym__literal_repeat1] = STATE(1078),
    [sym__simple_heredoc_body] = ACTIONS(1444),
    [sym__heredoc_body_beginning] = ACTIONS(1444),
    [sym_file_descriptor] = ACTIONS(1444),
    [sym_variable_name] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1446),
    [anon_sym_SEMI_SEMI] = ACTIONS(1444),
    [anon_sym_RBRACE] = ACTIONS(1444),
    [anon_sym_PIPE_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1446),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_AMP_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT_GT] = ACTIONS(1444),
    [anon_sym_LT_AMP] = ACTIONS(1444),
    [anon_sym_GT_AMP] = ACTIONS(1444),
    [anon_sym_LT_LT] = ACTIONS(1446),
    [anon_sym_LT_LT_DASH] = ACTIONS(1444),
    [anon_sym_LT_LT_LT] = ACTIONS(1444),
    [sym__special_character] = ACTIONS(1995),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [anon_sym_DOLLAR] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1444),
    [anon_sym_BQUOTE] = ACTIONS(1444),
    [anon_sym_LT_LPAREN] = ACTIONS(1444),
    [anon_sym_GT_LPAREN] = ACTIONS(1444),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1446),
    [sym_word] = ACTIONS(1446),
    [anon_sym_LF] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1446),
  },
  [1764] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2346),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1765] = {
    [aux_sym_concatenation_repeat1] = STATE(1765),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(5316),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2346),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1766] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [sym_variable_name] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_RBRACE] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2353),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2353),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [1767] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(5319),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1768] = {
    [sym_concatenation] = STATE(2465),
    [sym_string] = STATE(2464),
    [sym_simple_expansion] = STATE(2464),
    [sym_string_expansion] = STATE(2464),
    [sym_expansion] = STATE(2464),
    [sym_command_substitution] = STATE(2464),
    [sym_process_substitution] = STATE(2464),
    [aux_sym__literal_repeat1] = STATE(2466),
    [anon_sym_RBRACE] = ACTIONS(5321),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(5323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5323),
  },
  [1769] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(5325),
    [sym_comment] = ACTIONS(57),
  },
  [1770] = {
    [sym_concatenation] = STATE(2470),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2470),
    [anon_sym_RBRACE] = ACTIONS(5327),
    [anon_sym_EQ] = ACTIONS(5329),
    [anon_sym_DASH] = ACTIONS(5329),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5331),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(5333),
    [anon_sym_COLON] = ACTIONS(5329),
    [anon_sym_COLON_QMARK] = ACTIONS(5329),
    [anon_sym_COLON_DASH] = ACTIONS(5329),
    [anon_sym_PERCENT] = ACTIONS(5329),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1771] = {
    [sym_concatenation] = STATE(2472),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2472),
    [anon_sym_RBRACE] = ACTIONS(5321),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_DASH] = ACTIONS(5335),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(5339),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_COLON_QMARK] = ACTIONS(5335),
    [anon_sym_COLON_DASH] = ACTIONS(5335),
    [anon_sym_PERCENT] = ACTIONS(5335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1772] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [sym_variable_name] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_RBRACE] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2444),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2444),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [1773] = {
    [sym_concatenation] = STATE(2475),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2475),
    [sym_regex] = ACTIONS(5341),
    [anon_sym_RBRACE] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(5345),
    [anon_sym_DASH] = ACTIONS(5345),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5347),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5345),
    [anon_sym_COLON_QMARK] = ACTIONS(5345),
    [anon_sym_COLON_DASH] = ACTIONS(5345),
    [anon_sym_PERCENT] = ACTIONS(5345),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1774] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5343),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1775] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [sym_variable_name] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_RBRACE] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2494),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2494),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [1776] = {
    [sym_concatenation] = STATE(2472),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2472),
    [sym_regex] = ACTIONS(5349),
    [anon_sym_RBRACE] = ACTIONS(5321),
    [anon_sym_EQ] = ACTIONS(5335),
    [anon_sym_DASH] = ACTIONS(5335),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5335),
    [anon_sym_COLON_QMARK] = ACTIONS(5335),
    [anon_sym_COLON_DASH] = ACTIONS(5335),
    [anon_sym_PERCENT] = ACTIONS(5335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1777] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5321),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1778] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [sym_variable_name] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_RBRACE] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2502),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [1779] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_RBRACE] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2536),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [1780] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2346),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1781] = {
    [aux_sym_concatenation_repeat1] = STATE(1781),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(5351),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2346),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1782] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_RBRACE] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2353),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2353),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [1783] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(5354),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1784] = {
    [sym_concatenation] = STATE(2480),
    [sym_string] = STATE(2479),
    [sym_simple_expansion] = STATE(2479),
    [sym_string_expansion] = STATE(2479),
    [sym_expansion] = STATE(2479),
    [sym_command_substitution] = STATE(2479),
    [sym_process_substitution] = STATE(2479),
    [aux_sym__literal_repeat1] = STATE(2481),
    [anon_sym_RBRACE] = ACTIONS(5356),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(5358),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5358),
  },
  [1785] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(5360),
    [sym_comment] = ACTIONS(57),
  },
  [1786] = {
    [sym_concatenation] = STATE(2485),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2485),
    [anon_sym_RBRACE] = ACTIONS(5362),
    [anon_sym_EQ] = ACTIONS(5364),
    [anon_sym_DASH] = ACTIONS(5364),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5366),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(5368),
    [anon_sym_COLON] = ACTIONS(5364),
    [anon_sym_COLON_QMARK] = ACTIONS(5364),
    [anon_sym_COLON_DASH] = ACTIONS(5364),
    [anon_sym_PERCENT] = ACTIONS(5364),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1787] = {
    [sym_concatenation] = STATE(2487),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2487),
    [anon_sym_RBRACE] = ACTIONS(5356),
    [anon_sym_EQ] = ACTIONS(5370),
    [anon_sym_DASH] = ACTIONS(5370),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5372),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(5374),
    [anon_sym_COLON] = ACTIONS(5370),
    [anon_sym_COLON_QMARK] = ACTIONS(5370),
    [anon_sym_COLON_DASH] = ACTIONS(5370),
    [anon_sym_PERCENT] = ACTIONS(5370),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1788] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_RBRACE] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2444),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2444),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [1789] = {
    [sym_concatenation] = STATE(2490),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2490),
    [sym_regex] = ACTIONS(5376),
    [anon_sym_RBRACE] = ACTIONS(5378),
    [anon_sym_EQ] = ACTIONS(5380),
    [anon_sym_DASH] = ACTIONS(5380),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5382),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5380),
    [anon_sym_COLON_QMARK] = ACTIONS(5380),
    [anon_sym_COLON_DASH] = ACTIONS(5380),
    [anon_sym_PERCENT] = ACTIONS(5380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1790] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5378),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1791] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_RBRACE] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2494),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2494),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [1792] = {
    [sym_concatenation] = STATE(2487),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2487),
    [sym_regex] = ACTIONS(5384),
    [anon_sym_RBRACE] = ACTIONS(5356),
    [anon_sym_EQ] = ACTIONS(5370),
    [anon_sym_DASH] = ACTIONS(5370),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5372),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5370),
    [anon_sym_COLON_QMARK] = ACTIONS(5370),
    [anon_sym_COLON_DASH] = ACTIONS(5370),
    [anon_sym_PERCENT] = ACTIONS(5370),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1793] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5356),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1794] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_RBRACE] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2502),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [1795] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_RBRACE] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2536),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [1796] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_RBRACE] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_EQ_TILDE] = ACTIONS(4055),
    [anon_sym_EQ_EQ] = ACTIONS(4055),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4055),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [1797] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_RBRACE] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_EQ_TILDE] = ACTIONS(4069),
    [anon_sym_EQ_EQ] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [1798] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(5386),
    [sym_comment] = ACTIONS(57),
  },
  [1799] = {
    [anon_sym_RBRACE] = ACTIONS(5386),
    [sym_comment] = ACTIONS(57),
  },
  [1800] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(5388),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [1801] = {
    [sym_concatenation] = STATE(2495),
    [sym_string] = STATE(2494),
    [sym_simple_expansion] = STATE(2494),
    [sym_string_expansion] = STATE(2494),
    [sym_expansion] = STATE(2494),
    [sym_command_substitution] = STATE(2494),
    [sym_process_substitution] = STATE(2494),
    [aux_sym__literal_repeat1] = STATE(2496),
    [anon_sym_RBRACE] = ACTIONS(5386),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(5390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5390),
  },
  [1802] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_RBRACE] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_EQ_TILDE] = ACTIONS(4105),
    [anon_sym_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4105),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [1803] = {
    [sym_concatenation] = STATE(2499),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2499),
    [sym_regex] = ACTIONS(5392),
    [anon_sym_RBRACE] = ACTIONS(5394),
    [anon_sym_EQ] = ACTIONS(5396),
    [anon_sym_DASH] = ACTIONS(5396),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5396),
    [anon_sym_COLON_QMARK] = ACTIONS(5396),
    [anon_sym_COLON_DASH] = ACTIONS(5396),
    [anon_sym_PERCENT] = ACTIONS(5396),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1804] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5394),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1805] = {
    [sym_concatenation] = STATE(2501),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2501),
    [sym_regex] = ACTIONS(5400),
    [anon_sym_RBRACE] = ACTIONS(5386),
    [anon_sym_EQ] = ACTIONS(5402),
    [anon_sym_DASH] = ACTIONS(5402),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5404),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5402),
    [anon_sym_COLON_QMARK] = ACTIONS(5402),
    [anon_sym_COLON_DASH] = ACTIONS(5402),
    [anon_sym_PERCENT] = ACTIONS(5402),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1806] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5386),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1807] = {
    [sym_concatenation] = STATE(2503),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2503),
    [anon_sym_RBRACE] = ACTIONS(5406),
    [anon_sym_EQ] = ACTIONS(5408),
    [anon_sym_DASH] = ACTIONS(5408),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5408),
    [anon_sym_COLON_QMARK] = ACTIONS(5408),
    [anon_sym_COLON_DASH] = ACTIONS(5408),
    [anon_sym_PERCENT] = ACTIONS(5408),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1808] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_RBRACE] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_EQ_TILDE] = ACTIONS(4161),
    [anon_sym_EQ_EQ] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [1809] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5406),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1810] = {
    [sym_concatenation] = STATE(2501),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2501),
    [anon_sym_RBRACE] = ACTIONS(5386),
    [anon_sym_EQ] = ACTIONS(5402),
    [anon_sym_DASH] = ACTIONS(5402),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5404),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5402),
    [anon_sym_COLON_QMARK] = ACTIONS(5402),
    [anon_sym_COLON_DASH] = ACTIONS(5402),
    [anon_sym_PERCENT] = ACTIONS(5402),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1811] = {
    [sym__simple_heredoc_body] = ACTIONS(4264),
    [sym__heredoc_body_beginning] = ACTIONS(4264),
    [sym_file_descriptor] = ACTIONS(4264),
    [anon_sym_SEMI] = ACTIONS(4266),
    [anon_sym_PIPE] = ACTIONS(4266),
    [anon_sym_SEMI_SEMI] = ACTIONS(4264),
    [anon_sym_RBRACE] = ACTIONS(4264),
    [anon_sym_PIPE_AMP] = ACTIONS(4264),
    [anon_sym_AMP_AMP] = ACTIONS(4264),
    [anon_sym_PIPE_PIPE] = ACTIONS(4264),
    [anon_sym_LT] = ACTIONS(4266),
    [anon_sym_GT] = ACTIONS(4266),
    [anon_sym_GT_GT] = ACTIONS(4264),
    [anon_sym_AMP_GT] = ACTIONS(4266),
    [anon_sym_AMP_GT_GT] = ACTIONS(4264),
    [anon_sym_LT_AMP] = ACTIONS(4264),
    [anon_sym_GT_AMP] = ACTIONS(4264),
    [anon_sym_LT_LT] = ACTIONS(4266),
    [anon_sym_LT_LT_DASH] = ACTIONS(4264),
    [anon_sym_LT_LT_LT] = ACTIONS(4264),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4264),
    [anon_sym_AMP] = ACTIONS(4266),
  },
  [1812] = {
    [anon_sym_SEMI] = ACTIONS(4298),
    [anon_sym_SEMI_SEMI] = ACTIONS(4296),
    [anon_sym_RBRACE] = ACTIONS(4296),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4296),
    [anon_sym_AMP] = ACTIONS(4296),
  },
  [1813] = {
    [aux_sym_concatenation_repeat1] = STATE(1816),
    [sym__simple_heredoc_body] = ACTIONS(1378),
    [sym__heredoc_body_beginning] = ACTIONS(1378),
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1378),
    [anon_sym_RBRACE] = ACTIONS(1378),
    [anon_sym_PIPE_AMP] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_AMP] = ACTIONS(1378),
    [anon_sym_GT_AMP] = ACTIONS(1378),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1378),
    [anon_sym_LT_LT_LT] = ACTIONS(1378),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1378),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [1814] = {
    [sym__simple_heredoc_body] = ACTIONS(1378),
    [sym__heredoc_body_beginning] = ACTIONS(1378),
    [sym_file_descriptor] = ACTIONS(1378),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1378),
    [anon_sym_RBRACE] = ACTIONS(1378),
    [anon_sym_PIPE_AMP] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_AMP] = ACTIONS(1378),
    [anon_sym_GT_AMP] = ACTIONS(1378),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1378),
    [anon_sym_LT_LT_LT] = ACTIONS(1378),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1378),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [1815] = {
    [aux_sym__literal_repeat1] = STATE(1817),
    [sym__simple_heredoc_body] = ACTIONS(1382),
    [sym__heredoc_body_beginning] = ACTIONS(1382),
    [sym_file_descriptor] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym_PIPE] = ACTIONS(1384),
    [anon_sym_SEMI_SEMI] = ACTIONS(1382),
    [anon_sym_RBRACE] = ACTIONS(1382),
    [anon_sym_PIPE_AMP] = ACTIONS(1382),
    [anon_sym_AMP_AMP] = ACTIONS(1382),
    [anon_sym_PIPE_PIPE] = ACTIONS(1382),
    [anon_sym_LT] = ACTIONS(1384),
    [anon_sym_GT] = ACTIONS(1384),
    [anon_sym_GT_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT_GT] = ACTIONS(1382),
    [anon_sym_LT_AMP] = ACTIONS(1382),
    [anon_sym_GT_AMP] = ACTIONS(1382),
    [anon_sym_LT_LT] = ACTIONS(1384),
    [anon_sym_LT_LT_DASH] = ACTIONS(1382),
    [anon_sym_LT_LT_LT] = ACTIONS(1382),
    [sym__special_character] = ACTIONS(891),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
  },
  [1816] = {
    [aux_sym_concatenation_repeat1] = STATE(2504),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(829),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [1817] = {
    [aux_sym__literal_repeat1] = STATE(1817),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_RBRACE] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(2095),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1818] = {
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(2584),
    [anon_sym_for] = ACTIONS(2588),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_case] = ACTIONS(2588),
    [anon_sym_function] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_RBRACE] = ACTIONS(4317),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2584),
    [anon_sym_declare] = ACTIONS(2588),
    [anon_sym_typeset] = ACTIONS(2588),
    [anon_sym_export] = ACTIONS(2588),
    [anon_sym_readonly] = ACTIONS(2588),
    [anon_sym_local] = ACTIONS(2588),
    [anon_sym_unset] = ACTIONS(2588),
    [anon_sym_unsetenv] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [sym__special_character] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2584),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2584),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [anon_sym_LT_LPAREN] = ACTIONS(2584),
    [anon_sym_GT_LPAREN] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
  },
  [1819] = {
    [sym_file_descriptor] = ACTIONS(2697),
    [sym_variable_name] = ACTIONS(2697),
    [anon_sym_LT] = ACTIONS(2699),
    [anon_sym_GT] = ACTIONS(2699),
    [anon_sym_GT_GT] = ACTIONS(2697),
    [anon_sym_AMP_GT] = ACTIONS(2699),
    [anon_sym_AMP_GT_GT] = ACTIONS(2697),
    [anon_sym_LT_AMP] = ACTIONS(2697),
    [anon_sym_GT_AMP] = ACTIONS(2697),
    [sym__special_character] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [anon_sym_DOLLAR] = ACTIONS(2699),
    [sym_raw_string] = ACTIONS(2697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2697),
    [anon_sym_BQUOTE] = ACTIONS(2697),
    [anon_sym_LT_LPAREN] = ACTIONS(2697),
    [anon_sym_GT_LPAREN] = ACTIONS(2697),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2697),
  },
  [1820] = {
    [sym_concatenation] = STATE(1357),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(1357),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(5412),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [1821] = {
    [sym__concat] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_RBRACK] = ACTIONS(4053),
    [anon_sym_EQ_TILDE] = ACTIONS(4053),
    [anon_sym_EQ_EQ] = ACTIONS(4053),
    [anon_sym_EQ] = ACTIONS(4055),
    [anon_sym_PLUS_EQ] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_BANG_EQ] = ACTIONS(4053),
    [anon_sym_PLUS] = ACTIONS(4055),
    [anon_sym_DASH] = ACTIONS(4055),
    [anon_sym_DASH_EQ] = ACTIONS(4053),
    [anon_sym_LT_EQ] = ACTIONS(4053),
    [anon_sym_GT_EQ] = ACTIONS(4053),
    [anon_sym_PLUS_PLUS] = ACTIONS(4053),
    [anon_sym_DASH_DASH] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4053),
  },
  [1822] = {
    [sym__concat] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_RBRACK] = ACTIONS(4067),
    [anon_sym_EQ_TILDE] = ACTIONS(4067),
    [anon_sym_EQ_EQ] = ACTIONS(4067),
    [anon_sym_EQ] = ACTIONS(4069),
    [anon_sym_PLUS_EQ] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_BANG_EQ] = ACTIONS(4067),
    [anon_sym_PLUS] = ACTIONS(4069),
    [anon_sym_DASH] = ACTIONS(4069),
    [anon_sym_DASH_EQ] = ACTIONS(4067),
    [anon_sym_LT_EQ] = ACTIONS(4067),
    [anon_sym_GT_EQ] = ACTIONS(4067),
    [anon_sym_PLUS_PLUS] = ACTIONS(4067),
    [anon_sym_DASH_DASH] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4067),
  },
  [1823] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(5414),
    [sym_comment] = ACTIONS(57),
  },
  [1824] = {
    [anon_sym_RBRACE] = ACTIONS(5414),
    [sym_comment] = ACTIONS(57),
  },
  [1825] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(5416),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [1826] = {
    [sym_concatenation] = STATE(2509),
    [sym_string] = STATE(2508),
    [sym_simple_expansion] = STATE(2508),
    [sym_string_expansion] = STATE(2508),
    [sym_expansion] = STATE(2508),
    [sym_command_substitution] = STATE(2508),
    [sym_process_substitution] = STATE(2508),
    [aux_sym__literal_repeat1] = STATE(2510),
    [anon_sym_RBRACE] = ACTIONS(5414),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(5418),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5418),
  },
  [1827] = {
    [sym__concat] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_RBRACK] = ACTIONS(4103),
    [anon_sym_EQ_TILDE] = ACTIONS(4103),
    [anon_sym_EQ_EQ] = ACTIONS(4103),
    [anon_sym_EQ] = ACTIONS(4105),
    [anon_sym_PLUS_EQ] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_BANG_EQ] = ACTIONS(4103),
    [anon_sym_PLUS] = ACTIONS(4105),
    [anon_sym_DASH] = ACTIONS(4105),
    [anon_sym_DASH_EQ] = ACTIONS(4103),
    [anon_sym_LT_EQ] = ACTIONS(4103),
    [anon_sym_GT_EQ] = ACTIONS(4103),
    [anon_sym_PLUS_PLUS] = ACTIONS(4103),
    [anon_sym_DASH_DASH] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4103),
  },
  [1828] = {
    [sym_concatenation] = STATE(2513),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2513),
    [sym_regex] = ACTIONS(5420),
    [anon_sym_RBRACE] = ACTIONS(5422),
    [anon_sym_EQ] = ACTIONS(5424),
    [anon_sym_DASH] = ACTIONS(5424),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5426),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5424),
    [anon_sym_COLON_QMARK] = ACTIONS(5424),
    [anon_sym_COLON_DASH] = ACTIONS(5424),
    [anon_sym_PERCENT] = ACTIONS(5424),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1829] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5422),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1830] = {
    [sym_concatenation] = STATE(2515),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2515),
    [sym_regex] = ACTIONS(5428),
    [anon_sym_RBRACE] = ACTIONS(5414),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_DASH] = ACTIONS(5430),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5432),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5430),
    [anon_sym_COLON_QMARK] = ACTIONS(5430),
    [anon_sym_COLON_DASH] = ACTIONS(5430),
    [anon_sym_PERCENT] = ACTIONS(5430),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1831] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5414),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1832] = {
    [sym_concatenation] = STATE(2517),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2517),
    [anon_sym_RBRACE] = ACTIONS(5434),
    [anon_sym_EQ] = ACTIONS(5436),
    [anon_sym_DASH] = ACTIONS(5436),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5438),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5436),
    [anon_sym_COLON_QMARK] = ACTIONS(5436),
    [anon_sym_COLON_DASH] = ACTIONS(5436),
    [anon_sym_PERCENT] = ACTIONS(5436),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1833] = {
    [sym__concat] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_RBRACK] = ACTIONS(4159),
    [anon_sym_EQ_TILDE] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4159),
    [anon_sym_EQ] = ACTIONS(4161),
    [anon_sym_PLUS_EQ] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_BANG_EQ] = ACTIONS(4159),
    [anon_sym_PLUS] = ACTIONS(4161),
    [anon_sym_DASH] = ACTIONS(4161),
    [anon_sym_DASH_EQ] = ACTIONS(4159),
    [anon_sym_LT_EQ] = ACTIONS(4159),
    [anon_sym_GT_EQ] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4159),
    [anon_sym_DASH_DASH] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4159),
  },
  [1834] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5434),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1835] = {
    [sym_concatenation] = STATE(2515),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2515),
    [anon_sym_RBRACE] = ACTIONS(5414),
    [anon_sym_EQ] = ACTIONS(5430),
    [anon_sym_DASH] = ACTIONS(5430),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5432),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5430),
    [anon_sym_COLON_QMARK] = ACTIONS(5430),
    [anon_sym_COLON_DASH] = ACTIONS(5430),
    [anon_sym_PERCENT] = ACTIONS(5430),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1836] = {
    [sym__simple_heredoc_body] = ACTIONS(2697),
    [sym__heredoc_body_beginning] = ACTIONS(2697),
    [sym_file_descriptor] = ACTIONS(2697),
    [sym_variable_name] = ACTIONS(2697),
    [ts_builtin_sym_end] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_RPAREN] = ACTIONS(2697),
    [anon_sym_SEMI_SEMI] = ACTIONS(2697),
    [anon_sym_PIPE_AMP] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_PIPE_PIPE] = ACTIONS(2697),
    [anon_sym_LT] = ACTIONS(2699),
    [anon_sym_GT] = ACTIONS(2699),
    [anon_sym_GT_GT] = ACTIONS(2697),
    [anon_sym_AMP_GT] = ACTIONS(2699),
    [anon_sym_AMP_GT_GT] = ACTIONS(2697),
    [anon_sym_LT_AMP] = ACTIONS(2697),
    [anon_sym_GT_AMP] = ACTIONS(2697),
    [anon_sym_LT_LT] = ACTIONS(2699),
    [anon_sym_LT_LT_DASH] = ACTIONS(2697),
    [anon_sym_LT_LT_LT] = ACTIONS(2697),
    [sym__special_character] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [anon_sym_DOLLAR] = ACTIONS(2699),
    [sym_raw_string] = ACTIONS(2697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2697),
    [anon_sym_BQUOTE] = ACTIONS(2697),
    [anon_sym_LT_LPAREN] = ACTIONS(2697),
    [anon_sym_GT_LPAREN] = ACTIONS(2697),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2699),
    [sym_word] = ACTIONS(2699),
    [anon_sym_LF] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
  },
  [1837] = {
    [sym_concatenation] = STATE(1357),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(1357),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(5440),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [1838] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [sym_variable_name] = ACTIONS(4053),
    [ts_builtin_sym_end] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_RPAREN] = ACTIONS(4053),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4055),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [1839] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [sym_variable_name] = ACTIONS(4067),
    [ts_builtin_sym_end] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_RPAREN] = ACTIONS(4067),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4069),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [1840] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(5442),
    [sym_comment] = ACTIONS(57),
  },
  [1841] = {
    [anon_sym_RBRACE] = ACTIONS(5442),
    [sym_comment] = ACTIONS(57),
  },
  [1842] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(5444),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [1843] = {
    [sym_concatenation] = STATE(2522),
    [sym_string] = STATE(2521),
    [sym_simple_expansion] = STATE(2521),
    [sym_string_expansion] = STATE(2521),
    [sym_expansion] = STATE(2521),
    [sym_command_substitution] = STATE(2521),
    [sym_process_substitution] = STATE(2521),
    [aux_sym__literal_repeat1] = STATE(2523),
    [anon_sym_RBRACE] = ACTIONS(5442),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(5446),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5446),
  },
  [1844] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [sym_variable_name] = ACTIONS(4103),
    [ts_builtin_sym_end] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_RPAREN] = ACTIONS(4103),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4105),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [1845] = {
    [sym_concatenation] = STATE(2526),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2526),
    [sym_regex] = ACTIONS(5448),
    [anon_sym_RBRACE] = ACTIONS(5450),
    [anon_sym_EQ] = ACTIONS(5452),
    [anon_sym_DASH] = ACTIONS(5452),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5452),
    [anon_sym_COLON_QMARK] = ACTIONS(5452),
    [anon_sym_COLON_DASH] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1846] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5450),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1847] = {
    [sym_concatenation] = STATE(2528),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2528),
    [sym_regex] = ACTIONS(5456),
    [anon_sym_RBRACE] = ACTIONS(5442),
    [anon_sym_EQ] = ACTIONS(5458),
    [anon_sym_DASH] = ACTIONS(5458),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5460),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5458),
    [anon_sym_COLON_QMARK] = ACTIONS(5458),
    [anon_sym_COLON_DASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1848] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5442),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1849] = {
    [sym_concatenation] = STATE(2530),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2530),
    [anon_sym_RBRACE] = ACTIONS(5462),
    [anon_sym_EQ] = ACTIONS(5464),
    [anon_sym_DASH] = ACTIONS(5464),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5466),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5464),
    [anon_sym_COLON_QMARK] = ACTIONS(5464),
    [anon_sym_COLON_DASH] = ACTIONS(5464),
    [anon_sym_PERCENT] = ACTIONS(5464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1850] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [sym_variable_name] = ACTIONS(4159),
    [ts_builtin_sym_end] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_RPAREN] = ACTIONS(4159),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4161),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [1851] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5462),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1852] = {
    [sym_concatenation] = STATE(2528),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2528),
    [anon_sym_RBRACE] = ACTIONS(5442),
    [anon_sym_EQ] = ACTIONS(5458),
    [anon_sym_DASH] = ACTIONS(5458),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5460),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5458),
    [anon_sym_COLON_QMARK] = ACTIONS(5458),
    [anon_sym_COLON_DASH] = ACTIONS(5458),
    [anon_sym_PERCENT] = ACTIONS(5458),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1853] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [ts_builtin_sym_end] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_RPAREN] = ACTIONS(4053),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4055),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [1854] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [ts_builtin_sym_end] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_RPAREN] = ACTIONS(4067),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4069),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [1855] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(5468),
    [sym_comment] = ACTIONS(57),
  },
  [1856] = {
    [anon_sym_RBRACE] = ACTIONS(5468),
    [sym_comment] = ACTIONS(57),
  },
  [1857] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(5470),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [1858] = {
    [sym_concatenation] = STATE(2534),
    [sym_string] = STATE(2533),
    [sym_simple_expansion] = STATE(2533),
    [sym_string_expansion] = STATE(2533),
    [sym_expansion] = STATE(2533),
    [sym_command_substitution] = STATE(2533),
    [sym_process_substitution] = STATE(2533),
    [aux_sym__literal_repeat1] = STATE(2535),
    [anon_sym_RBRACE] = ACTIONS(5468),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(5472),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5472),
  },
  [1859] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [ts_builtin_sym_end] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_RPAREN] = ACTIONS(4103),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4105),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [1860] = {
    [sym_concatenation] = STATE(2538),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2538),
    [sym_regex] = ACTIONS(5474),
    [anon_sym_RBRACE] = ACTIONS(5476),
    [anon_sym_EQ] = ACTIONS(5478),
    [anon_sym_DASH] = ACTIONS(5478),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5480),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5478),
    [anon_sym_COLON_QMARK] = ACTIONS(5478),
    [anon_sym_COLON_DASH] = ACTIONS(5478),
    [anon_sym_PERCENT] = ACTIONS(5478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1861] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5476),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1862] = {
    [sym_concatenation] = STATE(2540),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2540),
    [sym_regex] = ACTIONS(5482),
    [anon_sym_RBRACE] = ACTIONS(5468),
    [anon_sym_EQ] = ACTIONS(5484),
    [anon_sym_DASH] = ACTIONS(5484),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5486),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5484),
    [anon_sym_COLON_QMARK] = ACTIONS(5484),
    [anon_sym_COLON_DASH] = ACTIONS(5484),
    [anon_sym_PERCENT] = ACTIONS(5484),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1863] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5468),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1864] = {
    [sym_concatenation] = STATE(2542),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2542),
    [anon_sym_RBRACE] = ACTIONS(5488),
    [anon_sym_EQ] = ACTIONS(5490),
    [anon_sym_DASH] = ACTIONS(5490),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5490),
    [anon_sym_COLON_QMARK] = ACTIONS(5490),
    [anon_sym_COLON_DASH] = ACTIONS(5490),
    [anon_sym_PERCENT] = ACTIONS(5490),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1865] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [ts_builtin_sym_end] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_RPAREN] = ACTIONS(4159),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4161),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [1866] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5488),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1867] = {
    [sym_concatenation] = STATE(2540),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2540),
    [anon_sym_RBRACE] = ACTIONS(5468),
    [anon_sym_EQ] = ACTIONS(5484),
    [anon_sym_DASH] = ACTIONS(5484),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5486),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5484),
    [anon_sym_COLON_QMARK] = ACTIONS(5484),
    [anon_sym_COLON_DASH] = ACTIONS(5484),
    [anon_sym_PERCENT] = ACTIONS(5484),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1868] = {
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [sym_variable_name] = ACTIONS(4053),
    [anon_sym_RPAREN] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4053),
  },
  [1869] = {
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [sym_variable_name] = ACTIONS(4067),
    [anon_sym_RPAREN] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4067),
  },
  [1870] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(5494),
    [sym_comment] = ACTIONS(57),
  },
  [1871] = {
    [anon_sym_RBRACE] = ACTIONS(5494),
    [sym_comment] = ACTIONS(57),
  },
  [1872] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(5496),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [1873] = {
    [sym_concatenation] = STATE(2546),
    [sym_string] = STATE(2545),
    [sym_simple_expansion] = STATE(2545),
    [sym_string_expansion] = STATE(2545),
    [sym_expansion] = STATE(2545),
    [sym_command_substitution] = STATE(2545),
    [sym_process_substitution] = STATE(2545),
    [aux_sym__literal_repeat1] = STATE(2547),
    [anon_sym_RBRACE] = ACTIONS(5494),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(5498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5498),
  },
  [1874] = {
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [sym_variable_name] = ACTIONS(4103),
    [anon_sym_RPAREN] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4103),
  },
  [1875] = {
    [sym_concatenation] = STATE(2550),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2550),
    [sym_regex] = ACTIONS(5500),
    [anon_sym_RBRACE] = ACTIONS(5502),
    [anon_sym_EQ] = ACTIONS(5504),
    [anon_sym_DASH] = ACTIONS(5504),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5504),
    [anon_sym_COLON_QMARK] = ACTIONS(5504),
    [anon_sym_COLON_DASH] = ACTIONS(5504),
    [anon_sym_PERCENT] = ACTIONS(5504),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1876] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5502),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1877] = {
    [sym_concatenation] = STATE(2552),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2552),
    [sym_regex] = ACTIONS(5508),
    [anon_sym_RBRACE] = ACTIONS(5494),
    [anon_sym_EQ] = ACTIONS(5510),
    [anon_sym_DASH] = ACTIONS(5510),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5510),
    [anon_sym_COLON_QMARK] = ACTIONS(5510),
    [anon_sym_COLON_DASH] = ACTIONS(5510),
    [anon_sym_PERCENT] = ACTIONS(5510),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1878] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5494),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1879] = {
    [sym_concatenation] = STATE(2554),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2554),
    [anon_sym_RBRACE] = ACTIONS(5514),
    [anon_sym_EQ] = ACTIONS(5516),
    [anon_sym_DASH] = ACTIONS(5516),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5518),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5516),
    [anon_sym_COLON_QMARK] = ACTIONS(5516),
    [anon_sym_COLON_DASH] = ACTIONS(5516),
    [anon_sym_PERCENT] = ACTIONS(5516),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1880] = {
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [sym_variable_name] = ACTIONS(4159),
    [anon_sym_RPAREN] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4159),
  },
  [1881] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5514),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1882] = {
    [sym_concatenation] = STATE(2552),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2552),
    [anon_sym_RBRACE] = ACTIONS(5494),
    [anon_sym_EQ] = ACTIONS(5510),
    [anon_sym_DASH] = ACTIONS(5510),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5512),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5510),
    [anon_sym_COLON_QMARK] = ACTIONS(5510),
    [anon_sym_COLON_DASH] = ACTIONS(5510),
    [anon_sym_PERCENT] = ACTIONS(5510),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1883] = {
    [sym__concat] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4069),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym__string_content] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4069),
    [anon_sym_BQUOTE] = ACTIONS(4069),
    [sym_comment] = ACTIONS(343),
  },
  [1884] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(5520),
    [sym_comment] = ACTIONS(57),
  },
  [1885] = {
    [anon_sym_RBRACE] = ACTIONS(5520),
    [sym_comment] = ACTIONS(57),
  },
  [1886] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(5522),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [1887] = {
    [sym_concatenation] = STATE(2558),
    [sym_string] = STATE(2557),
    [sym_simple_expansion] = STATE(2557),
    [sym_string_expansion] = STATE(2557),
    [sym_expansion] = STATE(2557),
    [sym_command_substitution] = STATE(2557),
    [sym_process_substitution] = STATE(2557),
    [aux_sym__literal_repeat1] = STATE(2559),
    [anon_sym_RBRACE] = ACTIONS(5520),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(5524),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5524),
  },
  [1888] = {
    [sym__concat] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4105),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym__string_content] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4105),
    [anon_sym_BQUOTE] = ACTIONS(4105),
    [sym_comment] = ACTIONS(343),
  },
  [1889] = {
    [sym_concatenation] = STATE(2562),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2562),
    [sym_regex] = ACTIONS(5526),
    [anon_sym_RBRACE] = ACTIONS(5528),
    [anon_sym_EQ] = ACTIONS(5530),
    [anon_sym_DASH] = ACTIONS(5530),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5530),
    [anon_sym_COLON_QMARK] = ACTIONS(5530),
    [anon_sym_COLON_DASH] = ACTIONS(5530),
    [anon_sym_PERCENT] = ACTIONS(5530),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1890] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5528),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1891] = {
    [sym_concatenation] = STATE(2564),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2564),
    [sym_regex] = ACTIONS(5534),
    [anon_sym_RBRACE] = ACTIONS(5520),
    [anon_sym_EQ] = ACTIONS(5536),
    [anon_sym_DASH] = ACTIONS(5536),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5538),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5536),
    [anon_sym_COLON_QMARK] = ACTIONS(5536),
    [anon_sym_COLON_DASH] = ACTIONS(5536),
    [anon_sym_PERCENT] = ACTIONS(5536),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1892] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5520),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1893] = {
    [sym_concatenation] = STATE(2566),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2566),
    [anon_sym_RBRACE] = ACTIONS(5540),
    [anon_sym_EQ] = ACTIONS(5542),
    [anon_sym_DASH] = ACTIONS(5542),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5542),
    [anon_sym_COLON_QMARK] = ACTIONS(5542),
    [anon_sym_COLON_DASH] = ACTIONS(5542),
    [anon_sym_PERCENT] = ACTIONS(5542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1894] = {
    [sym__concat] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4161),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym__string_content] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4161),
    [anon_sym_BQUOTE] = ACTIONS(4161),
    [sym_comment] = ACTIONS(343),
  },
  [1895] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5540),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1896] = {
    [sym_concatenation] = STATE(2564),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2564),
    [anon_sym_RBRACE] = ACTIONS(5520),
    [anon_sym_EQ] = ACTIONS(5536),
    [anon_sym_DASH] = ACTIONS(5536),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5538),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5536),
    [anon_sym_COLON_QMARK] = ACTIONS(5536),
    [anon_sym_COLON_DASH] = ACTIONS(5536),
    [anon_sym_PERCENT] = ACTIONS(5536),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1897] = {
    [sym_string] = STATE(1144),
    [sym_simple_expansion] = STATE(1144),
    [sym_string_expansion] = STATE(1144),
    [sym_expansion] = STATE(1144),
    [sym_command_substitution] = STATE(1144),
    [sym_process_substitution] = STATE(1144),
    [anon_sym_RBRACK] = ACTIONS(5546),
    [sym__special_character] = ACTIONS(2682),
    [anon_sym_DQUOTE] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(233),
    [sym_raw_string] = ACTIONS(2106),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(237),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(239),
    [anon_sym_BQUOTE] = ACTIONS(241),
    [anon_sym_LT_LPAREN] = ACTIONS(243),
    [anon_sym_GT_LPAREN] = ACTIONS(243),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2106),
  },
  [1898] = {
    [sym__concat] = ACTIONS(5548),
    [anon_sym_RBRACE] = ACTIONS(2686),
    [anon_sym_EQ] = ACTIONS(5550),
    [anon_sym_DASH] = ACTIONS(5550),
    [sym__special_character] = ACTIONS(5550),
    [anon_sym_DQUOTE] = ACTIONS(2686),
    [anon_sym_DOLLAR] = ACTIONS(5550),
    [sym_raw_string] = ACTIONS(2686),
    [anon_sym_POUND] = ACTIONS(2686),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2686),
    [anon_sym_SLASH] = ACTIONS(2686),
    [anon_sym_COLON] = ACTIONS(5550),
    [anon_sym_COLON_QMARK] = ACTIONS(5550),
    [anon_sym_COLON_DASH] = ACTIONS(5550),
    [anon_sym_PERCENT] = ACTIONS(5550),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2686),
    [anon_sym_BQUOTE] = ACTIONS(2686),
    [anon_sym_LT_LPAREN] = ACTIONS(2686),
    [anon_sym_GT_LPAREN] = ACTIONS(2686),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(5550),
  },
  [1899] = {
    [anon_sym_RBRACK] = ACTIONS(5546),
    [sym_comment] = ACTIONS(57),
  },
  [1900] = {
    [anon_sym_RBRACK] = ACTIONS(5552),
    [sym_comment] = ACTIONS(57),
  },
  [1901] = {
    [sym__concat] = ACTIONS(5554),
    [anon_sym_RBRACE] = ACTIONS(2692),
    [anon_sym_EQ] = ACTIONS(5556),
    [anon_sym_DASH] = ACTIONS(5556),
    [sym__special_character] = ACTIONS(5556),
    [anon_sym_DQUOTE] = ACTIONS(2692),
    [anon_sym_DOLLAR] = ACTIONS(5556),
    [sym_raw_string] = ACTIONS(2692),
    [anon_sym_POUND] = ACTIONS(2692),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2692),
    [anon_sym_SLASH] = ACTIONS(2692),
    [anon_sym_COLON] = ACTIONS(5556),
    [anon_sym_COLON_QMARK] = ACTIONS(5556),
    [anon_sym_COLON_DASH] = ACTIONS(5556),
    [anon_sym_PERCENT] = ACTIONS(5556),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2692),
    [anon_sym_BQUOTE] = ACTIONS(2692),
    [anon_sym_LT_LPAREN] = ACTIONS(2692),
    [anon_sym_GT_LPAREN] = ACTIONS(2692),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(5556),
  },
  [1902] = {
    [sym_string] = STATE(2571),
    [sym_simple_expansion] = STATE(2571),
    [sym_string_expansion] = STATE(2571),
    [sym_expansion] = STATE(2571),
    [sym_command_substitution] = STATE(2571),
    [sym_process_substitution] = STATE(2571),
    [sym__special_character] = ACTIONS(5558),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(5558),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5558),
  },
  [1903] = {
    [aux_sym_concatenation_repeat1] = STATE(2572),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
  },
  [1904] = {
    [sym__concat] = ACTIONS(1063),
    [anon_sym_RBRACE] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
  },
  [1905] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(5560),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1906] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(5560),
    [anon_sym_DOLLAR] = ACTIONS(5562),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [1907] = {
    [sym__concat] = ACTIONS(1097),
    [anon_sym_RBRACE] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
  },
  [1908] = {
    [sym__concat] = ACTIONS(1101),
    [anon_sym_RBRACE] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
  },
  [1909] = {
    [sym__concat] = ACTIONS(1105),
    [anon_sym_RBRACE] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
  },
  [1910] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [ts_builtin_sym_end] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_RPAREN] = ACTIONS(5564),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5566),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [1911] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(5568),
    [sym_comment] = ACTIONS(57),
  },
  [1912] = {
    [sym_subscript] = STATE(2578),
    [sym_variable_name] = ACTIONS(5570),
    [anon_sym_DASH] = ACTIONS(5572),
    [anon_sym_DOLLAR] = ACTIONS(5572),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5574),
    [anon_sym_STAR] = ACTIONS(5576),
    [anon_sym_AT] = ACTIONS(5576),
    [anon_sym_QMARK] = ACTIONS(5576),
    [anon_sym_0] = ACTIONS(5574),
    [anon_sym__] = ACTIONS(5574),
  },
  [1913] = {
    [sym_concatenation] = STATE(2581),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2581),
    [anon_sym_RBRACE] = ACTIONS(5578),
    [anon_sym_EQ] = ACTIONS(5580),
    [anon_sym_DASH] = ACTIONS(5580),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(5584),
    [anon_sym_COLON] = ACTIONS(5580),
    [anon_sym_COLON_QMARK] = ACTIONS(5580),
    [anon_sym_COLON_DASH] = ACTIONS(5580),
    [anon_sym_PERCENT] = ACTIONS(5580),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1914] = {
    [sym_concatenation] = STATE(2584),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2584),
    [anon_sym_RBRACE] = ACTIONS(5586),
    [anon_sym_EQ] = ACTIONS(5588),
    [anon_sym_DASH] = ACTIONS(5588),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5590),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_COLON] = ACTIONS(5588),
    [anon_sym_COLON_QMARK] = ACTIONS(5588),
    [anon_sym_COLON_DASH] = ACTIONS(5588),
    [anon_sym_PERCENT] = ACTIONS(5588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1915] = {
    [anon_sym_RPAREN] = ACTIONS(5594),
    [sym_comment] = ACTIONS(57),
  },
  [1916] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [1917] = {
    [anon_sym_BQUOTE] = ACTIONS(5594),
    [sym_comment] = ACTIONS(57),
  },
  [1918] = {
    [anon_sym_RPAREN] = ACTIONS(5596),
    [sym_comment] = ACTIONS(57),
  },
  [1919] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [ts_builtin_sym_end] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_RPAREN] = ACTIONS(5598),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_EQ_TILDE] = ACTIONS(5600),
    [anon_sym_EQ_EQ] = ACTIONS(5600),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [1920] = {
    [anon_sym_RBRACE] = ACTIONS(325),
    [sym__special_character] = ACTIONS(329),
    [sym_comment] = ACTIONS(57),
  },
  [1921] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(5602),
    [sym_comment] = ACTIONS(57),
  },
  [1922] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(5605),
    [sym_comment] = ACTIONS(57),
  },
  [1923] = {
    [anon_sym_RBRACE] = ACTIONS(5605),
    [sym_comment] = ACTIONS(57),
  },
  [1924] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(5607),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [1925] = {
    [sym_concatenation] = STATE(2590),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2590),
    [anon_sym_RBRACE] = ACTIONS(5609),
    [anon_sym_EQ] = ACTIONS(5611),
    [anon_sym_DASH] = ACTIONS(5611),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5613),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5611),
    [anon_sym_COLON_QMARK] = ACTIONS(5611),
    [anon_sym_COLON_DASH] = ACTIONS(5611),
    [anon_sym_PERCENT] = ACTIONS(5611),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1926] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [ts_builtin_sym_end] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_RPAREN] = ACTIONS(5615),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_EQ_TILDE] = ACTIONS(5617),
    [anon_sym_EQ_EQ] = ACTIONS(5617),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [1927] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5609),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1928] = {
    [sym_concatenation] = STATE(2591),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2591),
    [anon_sym_RBRACE] = ACTIONS(5605),
    [anon_sym_EQ] = ACTIONS(5619),
    [anon_sym_DASH] = ACTIONS(5619),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5621),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5619),
    [anon_sym_COLON_QMARK] = ACTIONS(5619),
    [anon_sym_COLON_DASH] = ACTIONS(5619),
    [anon_sym_PERCENT] = ACTIONS(5619),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1929] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5605),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1930] = {
    [sym__concat] = ACTIONS(2344),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [anon_sym_EQ] = ACTIONS(2346),
    [anon_sym_DASH] = ACTIONS(2346),
    [sym__special_character] = ACTIONS(2346),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_POUND] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_COLON] = ACTIONS(2346),
    [anon_sym_COLON_QMARK] = ACTIONS(2346),
    [anon_sym_COLON_DASH] = ACTIONS(2346),
    [anon_sym_PERCENT] = ACTIONS(2346),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(2346),
  },
  [1931] = {
    [aux_sym_concatenation_repeat1] = STATE(1931),
    [sym__concat] = ACTIONS(5623),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [anon_sym_EQ] = ACTIONS(2346),
    [anon_sym_DASH] = ACTIONS(2346),
    [sym__special_character] = ACTIONS(2346),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_POUND] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_COLON] = ACTIONS(2346),
    [anon_sym_COLON_QMARK] = ACTIONS(2346),
    [anon_sym_COLON_DASH] = ACTIONS(2346),
    [anon_sym_PERCENT] = ACTIONS(2346),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(2346),
  },
  [1932] = {
    [sym__concat] = ACTIONS(2351),
    [anon_sym_RBRACE] = ACTIONS(2351),
    [anon_sym_EQ] = ACTIONS(2353),
    [anon_sym_DASH] = ACTIONS(2353),
    [sym__special_character] = ACTIONS(2353),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_POUND] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_COLON] = ACTIONS(2353),
    [anon_sym_COLON_QMARK] = ACTIONS(2353),
    [anon_sym_COLON_DASH] = ACTIONS(2353),
    [anon_sym_PERCENT] = ACTIONS(2353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(2353),
  },
  [1933] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(5626),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1934] = {
    [sym_concatenation] = STATE(2595),
    [sym_string] = STATE(2594),
    [sym_simple_expansion] = STATE(2594),
    [sym_string_expansion] = STATE(2594),
    [sym_expansion] = STATE(2594),
    [sym_command_substitution] = STATE(2594),
    [sym_process_substitution] = STATE(2594),
    [aux_sym__literal_repeat1] = STATE(2596),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(5630),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5630),
  },
  [1935] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(5632),
    [sym_comment] = ACTIONS(57),
  },
  [1936] = {
    [sym_concatenation] = STATE(2600),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2600),
    [anon_sym_RBRACE] = ACTIONS(5634),
    [anon_sym_EQ] = ACTIONS(5636),
    [anon_sym_DASH] = ACTIONS(5636),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5638),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(5640),
    [anon_sym_COLON] = ACTIONS(5636),
    [anon_sym_COLON_QMARK] = ACTIONS(5636),
    [anon_sym_COLON_DASH] = ACTIONS(5636),
    [anon_sym_PERCENT] = ACTIONS(5636),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1937] = {
    [sym_concatenation] = STATE(2602),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2602),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_EQ] = ACTIONS(5642),
    [anon_sym_DASH] = ACTIONS(5642),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(5646),
    [anon_sym_COLON] = ACTIONS(5642),
    [anon_sym_COLON_QMARK] = ACTIONS(5642),
    [anon_sym_COLON_DASH] = ACTIONS(5642),
    [anon_sym_PERCENT] = ACTIONS(5642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1938] = {
    [sym__concat] = ACTIONS(2442),
    [anon_sym_RBRACE] = ACTIONS(2442),
    [anon_sym_EQ] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [sym__special_character] = ACTIONS(2444),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_POUND] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_COLON] = ACTIONS(2444),
    [anon_sym_COLON_QMARK] = ACTIONS(2444),
    [anon_sym_COLON_DASH] = ACTIONS(2444),
    [anon_sym_PERCENT] = ACTIONS(2444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(2444),
  },
  [1939] = {
    [sym_concatenation] = STATE(2605),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2605),
    [sym_regex] = ACTIONS(5648),
    [anon_sym_RBRACE] = ACTIONS(5650),
    [anon_sym_EQ] = ACTIONS(5652),
    [anon_sym_DASH] = ACTIONS(5652),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5652),
    [anon_sym_COLON_QMARK] = ACTIONS(5652),
    [anon_sym_COLON_DASH] = ACTIONS(5652),
    [anon_sym_PERCENT] = ACTIONS(5652),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1940] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5650),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1941] = {
    [sym__concat] = ACTIONS(2492),
    [anon_sym_RBRACE] = ACTIONS(2492),
    [anon_sym_EQ] = ACTIONS(2494),
    [anon_sym_DASH] = ACTIONS(2494),
    [sym__special_character] = ACTIONS(2494),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_POUND] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_COLON] = ACTIONS(2494),
    [anon_sym_COLON_QMARK] = ACTIONS(2494),
    [anon_sym_COLON_DASH] = ACTIONS(2494),
    [anon_sym_PERCENT] = ACTIONS(2494),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(2494),
  },
  [1942] = {
    [sym_concatenation] = STATE(2602),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2602),
    [sym_regex] = ACTIONS(5656),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_EQ] = ACTIONS(5642),
    [anon_sym_DASH] = ACTIONS(5642),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5642),
    [anon_sym_COLON_QMARK] = ACTIONS(5642),
    [anon_sym_COLON_DASH] = ACTIONS(5642),
    [anon_sym_PERCENT] = ACTIONS(5642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1943] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1944] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [ts_builtin_sym_end] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_RPAREN] = ACTIONS(5658),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_EQ_TILDE] = ACTIONS(5660),
    [anon_sym_EQ_EQ] = ACTIONS(5660),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [1945] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5662),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1946] = {
    [sym__concat] = ACTIONS(2500),
    [anon_sym_RBRACE] = ACTIONS(2500),
    [anon_sym_EQ] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2502),
    [sym__special_character] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_POUND] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_COLON] = ACTIONS(2502),
    [anon_sym_COLON_QMARK] = ACTIONS(2502),
    [anon_sym_COLON_DASH] = ACTIONS(2502),
    [anon_sym_PERCENT] = ACTIONS(2502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(2502),
  },
  [1947] = {
    [sym__concat] = ACTIONS(2534),
    [anon_sym_RBRACE] = ACTIONS(2534),
    [anon_sym_EQ] = ACTIONS(2536),
    [anon_sym_DASH] = ACTIONS(2536),
    [sym__special_character] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_POUND] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_COLON] = ACTIONS(2536),
    [anon_sym_COLON_QMARK] = ACTIONS(2536),
    [anon_sym_COLON_DASH] = ACTIONS(2536),
    [anon_sym_PERCENT] = ACTIONS(2536),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(2536),
  },
  [1948] = {
    [aux_sym_concatenation_repeat1] = STATE(1948),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(3984),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2344),
  },
  [1949] = {
    [aux_sym_concatenation_repeat1] = STATE(2608),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(1420),
    [sym_variable_name] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [1950] = {
    [aux_sym__literal_repeat1] = STATE(1950),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym_variable_name] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(2773),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1951] = {
    [aux_sym_concatenation_repeat1] = STATE(1280),
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym__concat] = ACTIONS(943),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1400),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [1952] = {
    [aux_sym__literal_repeat1] = STATE(1282),
    [sym__simple_heredoc_body] = ACTIONS(1444),
    [sym__heredoc_body_beginning] = ACTIONS(1444),
    [sym_file_descriptor] = ACTIONS(1444),
    [sym_variable_name] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1446),
    [anon_sym_SEMI_SEMI] = ACTIONS(1444),
    [anon_sym_PIPE_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1446),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_AMP_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT_GT] = ACTIONS(1444),
    [anon_sym_LT_AMP] = ACTIONS(1444),
    [anon_sym_GT_AMP] = ACTIONS(1444),
    [anon_sym_LT_LT] = ACTIONS(1446),
    [anon_sym_LT_LT_DASH] = ACTIONS(1444),
    [anon_sym_LT_LT_LT] = ACTIONS(1444),
    [sym__special_character] = ACTIONS(981),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [anon_sym_DOLLAR] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1444),
    [anon_sym_BQUOTE] = ACTIONS(1444),
    [anon_sym_LT_LPAREN] = ACTIONS(1444),
    [anon_sym_GT_LPAREN] = ACTIONS(1444),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1446),
    [sym_word] = ACTIONS(1446),
    [anon_sym_LF] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1446),
  },
  [1953] = {
    [aux_sym_concatenation_repeat1] = STATE(1953),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(3914),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1954] = {
    [aux_sym_concatenation_repeat1] = STATE(1954),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(3949),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1955] = {
    [aux_sym_concatenation_repeat1] = STATE(1957),
    [sym__simple_heredoc_body] = ACTIONS(1378),
    [sym__heredoc_body_beginning] = ACTIONS(1378),
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1378),
    [anon_sym_PIPE_AMP] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_AMP] = ACTIONS(1378),
    [anon_sym_GT_AMP] = ACTIONS(1378),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1378),
    [anon_sym_LT_LT_LT] = ACTIONS(1378),
    [anon_sym_BQUOTE] = ACTIONS(1378),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1378),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [1956] = {
    [aux_sym__literal_repeat1] = STATE(1958),
    [sym__simple_heredoc_body] = ACTIONS(1382),
    [sym__heredoc_body_beginning] = ACTIONS(1382),
    [sym_file_descriptor] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym_PIPE] = ACTIONS(1384),
    [anon_sym_SEMI_SEMI] = ACTIONS(1382),
    [anon_sym_PIPE_AMP] = ACTIONS(1382),
    [anon_sym_AMP_AMP] = ACTIONS(1382),
    [anon_sym_PIPE_PIPE] = ACTIONS(1382),
    [anon_sym_LT] = ACTIONS(1384),
    [anon_sym_GT] = ACTIONS(1384),
    [anon_sym_GT_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT_GT] = ACTIONS(1382),
    [anon_sym_LT_AMP] = ACTIONS(1382),
    [anon_sym_GT_AMP] = ACTIONS(1382),
    [anon_sym_LT_LT] = ACTIONS(1384),
    [anon_sym_LT_LT_DASH] = ACTIONS(1382),
    [anon_sym_LT_LT_LT] = ACTIONS(1382),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(1382),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
  },
  [1957] = {
    [aux_sym_concatenation_repeat1] = STATE(2609),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [1958] = {
    [aux_sym__literal_repeat1] = STATE(1958),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(1375),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [1959] = {
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(2584),
    [anon_sym_for] = ACTIONS(2588),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_case] = ACTIONS(2588),
    [anon_sym_function] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2584),
    [anon_sym_declare] = ACTIONS(2588),
    [anon_sym_typeset] = ACTIONS(2588),
    [anon_sym_export] = ACTIONS(2588),
    [anon_sym_readonly] = ACTIONS(2588),
    [anon_sym_local] = ACTIONS(2588),
    [anon_sym_unset] = ACTIONS(2588),
    [anon_sym_unsetenv] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [sym__special_character] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2584),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2584),
    [anon_sym_BQUOTE] = ACTIONS(4317),
    [anon_sym_LT_LPAREN] = ACTIONS(2584),
    [anon_sym_GT_LPAREN] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
  },
  [1960] = {
    [sym_concatenation] = STATE(2612),
    [sym_string] = STATE(2611),
    [sym_simple_expansion] = STATE(2611),
    [sym_string_expansion] = STATE(2611),
    [sym_expansion] = STATE(2611),
    [sym_command_substitution] = STATE(2611),
    [sym_process_substitution] = STATE(2611),
    [aux_sym__literal_repeat1] = STATE(2613),
    [anon_sym_RBRACE] = ACTIONS(5664),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(5666),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5666),
  },
  [1961] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(5668),
    [sym_comment] = ACTIONS(57),
  },
  [1962] = {
    [sym_concatenation] = STATE(2617),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2617),
    [anon_sym_RBRACE] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5672),
    [anon_sym_DASH] = ACTIONS(5672),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5674),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(5676),
    [anon_sym_COLON] = ACTIONS(5672),
    [anon_sym_COLON_QMARK] = ACTIONS(5672),
    [anon_sym_COLON_DASH] = ACTIONS(5672),
    [anon_sym_PERCENT] = ACTIONS(5672),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1963] = {
    [sym_concatenation] = STATE(2619),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2619),
    [anon_sym_RBRACE] = ACTIONS(5664),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5678),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5680),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(5682),
    [anon_sym_COLON] = ACTIONS(5678),
    [anon_sym_COLON_QMARK] = ACTIONS(5678),
    [anon_sym_COLON_DASH] = ACTIONS(5678),
    [anon_sym_PERCENT] = ACTIONS(5678),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1964] = {
    [sym__heredoc_body_middle] = ACTIONS(2442),
    [sym__heredoc_body_end] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
  },
  [1965] = {
    [sym_concatenation] = STATE(2622),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2622),
    [sym_regex] = ACTIONS(5684),
    [anon_sym_RBRACE] = ACTIONS(5686),
    [anon_sym_EQ] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5688),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5690),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5688),
    [anon_sym_COLON_QMARK] = ACTIONS(5688),
    [anon_sym_COLON_DASH] = ACTIONS(5688),
    [anon_sym_PERCENT] = ACTIONS(5688),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1966] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5686),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1967] = {
    [sym__heredoc_body_middle] = ACTIONS(2492),
    [sym__heredoc_body_end] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
  },
  [1968] = {
    [sym_concatenation] = STATE(2619),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2619),
    [sym_regex] = ACTIONS(5692),
    [anon_sym_RBRACE] = ACTIONS(5664),
    [anon_sym_EQ] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5678),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5680),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5678),
    [anon_sym_COLON_QMARK] = ACTIONS(5678),
    [anon_sym_COLON_DASH] = ACTIONS(5678),
    [anon_sym_PERCENT] = ACTIONS(5678),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1969] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5664),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1970] = {
    [sym__heredoc_body_middle] = ACTIONS(2500),
    [sym__heredoc_body_end] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
  },
  [1971] = {
    [aux_sym_concatenation_repeat1] = STATE(1971),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2348),
    [ts_builtin_sym_end] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [1972] = {
    [sym_concatenation] = STATE(1318),
    [sym_string] = STATE(2624),
    [sym_simple_expansion] = STATE(2624),
    [sym_string_expansion] = STATE(2624),
    [sym_expansion] = STATE(2624),
    [sym_command_substitution] = STATE(2624),
    [sym_process_substitution] = STATE(2624),
    [aux_sym__literal_repeat1] = STATE(2625),
    [sym__special_character] = ACTIONS(4329),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(5694),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5694),
  },
  [1973] = {
    [sym_file_redirect] = STATE(1332),
    [sym_heredoc_redirect] = STATE(1332),
    [sym_herestring_redirect] = STATE(1332),
    [aux_sym_redirected_statement_repeat1] = STATE(1332),
    [sym__simple_heredoc_body] = ACTIONS(2564),
    [sym__heredoc_body_beginning] = ACTIONS(2564),
    [sym_file_descriptor] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT] = ACTIONS(2566),
    [anon_sym_AMP_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_AMP] = ACTIONS(2564),
    [anon_sym_GT_AMP] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_LT_LT_DASH] = ACTIONS(2564),
    [anon_sym_LT_LT_LT] = ACTIONS(2564),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2566),
  },
  [1974] = {
    [sym_file_redirect] = STATE(1332),
    [sym_heredoc_redirect] = STATE(1332),
    [sym_herestring_redirect] = STATE(1332),
    [aux_sym_redirected_statement_repeat1] = STATE(1332),
    [sym__simple_heredoc_body] = ACTIONS(2564),
    [sym__heredoc_body_beginning] = ACTIONS(2564),
    [sym_file_descriptor] = ACTIONS(2564),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT] = ACTIONS(2566),
    [anon_sym_AMP_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_AMP] = ACTIONS(2564),
    [anon_sym_GT_AMP] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_LT_LT_DASH] = ACTIONS(2564),
    [anon_sym_LT_LT_LT] = ACTIONS(2564),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2566),
  },
  [1975] = {
    [sym_file_redirect] = STATE(1332),
    [sym_heredoc_redirect] = STATE(1332),
    [sym_herestring_redirect] = STATE(1332),
    [aux_sym_redirected_statement_repeat1] = STATE(1332),
    [sym__simple_heredoc_body] = ACTIONS(2568),
    [sym__heredoc_body_beginning] = ACTIONS(2568),
    [sym_file_descriptor] = ACTIONS(2568),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_PIPE] = ACTIONS(2662),
    [anon_sym_SEMI_SEMI] = ACTIONS(2568),
    [anon_sym_PIPE_AMP] = ACTIONS(2666),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_GT] = ACTIONS(2570),
    [anon_sym_GT_GT] = ACTIONS(2568),
    [anon_sym_AMP_GT] = ACTIONS(2570),
    [anon_sym_AMP_GT_GT] = ACTIONS(2568),
    [anon_sym_LT_AMP] = ACTIONS(2568),
    [anon_sym_GT_AMP] = ACTIONS(2568),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_LT_LT_DASH] = ACTIONS(2568),
    [anon_sym_LT_LT_LT] = ACTIONS(2568),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2570),
  },
  [1976] = {
    [sym_file_redirect] = STATE(1332),
    [sym_heredoc_redirect] = STATE(1332),
    [sym_herestring_redirect] = STATE(1332),
    [aux_sym_redirected_statement_repeat1] = STATE(1332),
    [sym__simple_heredoc_body] = ACTIONS(2568),
    [sym__heredoc_body_beginning] = ACTIONS(2568),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_PIPE] = ACTIONS(2662),
    [anon_sym_SEMI_SEMI] = ACTIONS(2568),
    [anon_sym_PIPE_AMP] = ACTIONS(2666),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_LT_LT_DASH] = ACTIONS(2568),
    [anon_sym_LT_LT_LT] = ACTIONS(2568),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2570),
  },
  [1977] = {
    [aux_sym_concatenation_repeat1] = STATE(2626),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [1978] = {
    [aux_sym_concatenation_repeat1] = STATE(2626),
    [sym__simple_heredoc_body] = ACTIONS(1037),
    [sym__heredoc_body_beginning] = ACTIONS(1037),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [1979] = {
    [aux_sym__literal_repeat1] = STATE(2627),
    [sym__simple_heredoc_body] = ACTIONS(1051),
    [sym__heredoc_body_beginning] = ACTIONS(1051),
    [sym_file_descriptor] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_LT_LT_DASH] = ACTIONS(1051),
    [anon_sym_LT_LT_LT] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(441),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1051),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [1980] = {
    [aux_sym_concatenation_repeat1] = STATE(2626),
    [sym__simple_heredoc_body] = ACTIONS(2576),
    [sym__heredoc_body_beginning] = ACTIONS(2576),
    [sym_file_descriptor] = ACTIONS(2576),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI_SEMI] = ACTIONS(2576),
    [anon_sym_PIPE_AMP] = ACTIONS(2576),
    [anon_sym_AMP_AMP] = ACTIONS(2576),
    [anon_sym_PIPE_PIPE] = ACTIONS(2576),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_GT] = ACTIONS(2576),
    [anon_sym_AMP_GT] = ACTIONS(2578),
    [anon_sym_AMP_GT_GT] = ACTIONS(2576),
    [anon_sym_LT_AMP] = ACTIONS(2576),
    [anon_sym_GT_AMP] = ACTIONS(2576),
    [anon_sym_LT_LT] = ACTIONS(2578),
    [anon_sym_LT_LT_DASH] = ACTIONS(2576),
    [anon_sym_LT_LT_LT] = ACTIONS(2576),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2576),
    [anon_sym_AMP] = ACTIONS(2578),
  },
  [1981] = {
    [aux_sym__literal_repeat1] = STATE(2627),
    [sym__simple_heredoc_body] = ACTIONS(2580),
    [sym__heredoc_body_beginning] = ACTIONS(2580),
    [sym_file_descriptor] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_SEMI_SEMI] = ACTIONS(2580),
    [anon_sym_PIPE_AMP] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_AMP_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_AMP] = ACTIONS(2580),
    [anon_sym_GT_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2582),
    [anon_sym_LT_LT_DASH] = ACTIONS(2580),
    [anon_sym_LT_LT_LT] = ACTIONS(2580),
    [sym__special_character] = ACTIONS(441),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2580),
    [anon_sym_AMP] = ACTIONS(2582),
  },
  [1982] = {
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(2584),
    [anon_sym_for] = ACTIONS(2588),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_case] = ACTIONS(2588),
    [anon_sym_function] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2584),
    [anon_sym_declare] = ACTIONS(2588),
    [anon_sym_typeset] = ACTIONS(2588),
    [anon_sym_export] = ACTIONS(2588),
    [anon_sym_readonly] = ACTIONS(2588),
    [anon_sym_local] = ACTIONS(2588),
    [anon_sym_unset] = ACTIONS(2588),
    [anon_sym_unsetenv] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [sym__special_character] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2584),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2584),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [anon_sym_LT_LPAREN] = ACTIONS(2584),
    [anon_sym_GT_LPAREN] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
  },
  [1983] = {
    [sym_file_redirect] = STATE(1983),
    [sym_heredoc_redirect] = STATE(1983),
    [sym_herestring_redirect] = STATE(1983),
    [aux_sym_redirected_statement_repeat1] = STATE(1983),
    [sym__simple_heredoc_body] = ACTIONS(2590),
    [sym__heredoc_body_beginning] = ACTIONS(2590),
    [sym_file_descriptor] = ACTIONS(5696),
    [anon_sym_SEMI] = ACTIONS(2595),
    [anon_sym_PIPE] = ACTIONS(2595),
    [anon_sym_SEMI_SEMI] = ACTIONS(2590),
    [anon_sym_PIPE_AMP] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(5699),
    [anon_sym_GT] = ACTIONS(5699),
    [anon_sym_GT_GT] = ACTIONS(5702),
    [anon_sym_AMP_GT] = ACTIONS(5699),
    [anon_sym_AMP_GT_GT] = ACTIONS(5702),
    [anon_sym_LT_AMP] = ACTIONS(5702),
    [anon_sym_GT_AMP] = ACTIONS(5702),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_LT_LT_DASH] = ACTIONS(2606),
    [anon_sym_LT_LT_LT] = ACTIONS(5705),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2595),
  },
  [1984] = {
    [sym_concatenation] = STATE(1301),
    [sym_string] = STATE(673),
    [sym_simple_expansion] = STATE(673),
    [sym_string_expansion] = STATE(673),
    [sym_expansion] = STATE(673),
    [sym_command_substitution] = STATE(673),
    [sym_process_substitution] = STATE(673),
    [aux_sym_command_repeat2] = STATE(1301),
    [aux_sym__literal_repeat1] = STATE(675),
    [sym__simple_heredoc_body] = ACTIONS(2676),
    [sym__heredoc_body_beginning] = ACTIONS(2676),
    [sym_file_descriptor] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym_PIPE] = ACTIONS(2678),
    [anon_sym_SEMI_SEMI] = ACTIONS(2676),
    [anon_sym_PIPE_AMP] = ACTIONS(2676),
    [anon_sym_AMP_AMP] = ACTIONS(2676),
    [anon_sym_PIPE_PIPE] = ACTIONS(2676),
    [anon_sym_EQ_TILDE] = ACTIONS(1203),
    [anon_sym_EQ_EQ] = ACTIONS(1203),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_GT] = ACTIONS(2678),
    [anon_sym_GT_GT] = ACTIONS(2676),
    [anon_sym_AMP_GT] = ACTIONS(2678),
    [anon_sym_AMP_GT_GT] = ACTIONS(2676),
    [anon_sym_LT_AMP] = ACTIONS(2676),
    [anon_sym_GT_AMP] = ACTIONS(2676),
    [anon_sym_LT_LT] = ACTIONS(2678),
    [anon_sym_LT_LT_DASH] = ACTIONS(2676),
    [anon_sym_LT_LT_LT] = ACTIONS(2676),
    [sym__special_character] = ACTIONS(1205),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(1207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1209),
    [anon_sym_LF] = ACTIONS(2676),
    [anon_sym_AMP] = ACTIONS(2678),
  },
  [1985] = {
    [anon_sym_EQ] = ACTIONS(5708),
    [anon_sym_PLUS_EQ] = ACTIONS(5708),
    [sym_comment] = ACTIONS(57),
  },
  [1986] = {
    [anon_sym_EQ] = ACTIONS(5710),
    [anon_sym_PLUS_EQ] = ACTIONS(5710),
    [sym_comment] = ACTIONS(57),
  },
  [1987] = {
    [sym__concat] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2344),
  },
  [1988] = {
    [aux_sym_concatenation_repeat1] = STATE(1988),
    [sym__concat] = ACTIONS(5712),
    [anon_sym_RPAREN] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2344),
  },
  [1989] = {
    [sym__concat] = ACTIONS(2351),
    [anon_sym_RPAREN] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2351),
  },
  [1990] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(5715),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [1991] = {
    [sym_concatenation] = STATE(2631),
    [sym_string] = STATE(2630),
    [sym_simple_expansion] = STATE(2630),
    [sym_string_expansion] = STATE(2630),
    [sym_expansion] = STATE(2630),
    [sym_command_substitution] = STATE(2630),
    [sym_process_substitution] = STATE(2630),
    [aux_sym__literal_repeat1] = STATE(2632),
    [anon_sym_RBRACE] = ACTIONS(5717),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(5719),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5719),
  },
  [1992] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(5721),
    [sym_comment] = ACTIONS(57),
  },
  [1993] = {
    [sym_concatenation] = STATE(2636),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2636),
    [anon_sym_RBRACE] = ACTIONS(5723),
    [anon_sym_EQ] = ACTIONS(5725),
    [anon_sym_DASH] = ACTIONS(5725),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5727),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(5729),
    [anon_sym_COLON] = ACTIONS(5725),
    [anon_sym_COLON_QMARK] = ACTIONS(5725),
    [anon_sym_COLON_DASH] = ACTIONS(5725),
    [anon_sym_PERCENT] = ACTIONS(5725),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1994] = {
    [sym_concatenation] = STATE(2638),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2638),
    [anon_sym_RBRACE] = ACTIONS(5717),
    [anon_sym_EQ] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5731),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(5735),
    [anon_sym_COLON] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_DASH] = ACTIONS(5731),
    [anon_sym_PERCENT] = ACTIONS(5731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1995] = {
    [sym__concat] = ACTIONS(2442),
    [anon_sym_RPAREN] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2442),
  },
  [1996] = {
    [sym_concatenation] = STATE(2641),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2641),
    [sym_regex] = ACTIONS(5737),
    [anon_sym_RBRACE] = ACTIONS(5739),
    [anon_sym_EQ] = ACTIONS(5741),
    [anon_sym_DASH] = ACTIONS(5741),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5743),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5741),
    [anon_sym_COLON_QMARK] = ACTIONS(5741),
    [anon_sym_COLON_DASH] = ACTIONS(5741),
    [anon_sym_PERCENT] = ACTIONS(5741),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1997] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5739),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [1998] = {
    [sym__concat] = ACTIONS(2492),
    [anon_sym_RPAREN] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2492),
  },
  [1999] = {
    [sym_concatenation] = STATE(2638),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2638),
    [sym_regex] = ACTIONS(5745),
    [anon_sym_RBRACE] = ACTIONS(5717),
    [anon_sym_EQ] = ACTIONS(5731),
    [anon_sym_DASH] = ACTIONS(5731),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5731),
    [anon_sym_COLON_QMARK] = ACTIONS(5731),
    [anon_sym_COLON_DASH] = ACTIONS(5731),
    [anon_sym_PERCENT] = ACTIONS(5731),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2000] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5717),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2001] = {
    [sym__concat] = ACTIONS(2500),
    [anon_sym_RPAREN] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2500),
  },
  [2002] = {
    [sym__concat] = ACTIONS(2534),
    [anon_sym_RPAREN] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2534),
  },
  [2003] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [sym_variable_name] = ACTIONS(4053),
    [ts_builtin_sym_end] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_RPAREN] = ACTIONS(4053),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [2004] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [sym_variable_name] = ACTIONS(4067),
    [ts_builtin_sym_end] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_RPAREN] = ACTIONS(4067),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [2005] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(5747),
    [sym_comment] = ACTIONS(57),
  },
  [2006] = {
    [anon_sym_RBRACE] = ACTIONS(5747),
    [sym_comment] = ACTIONS(57),
  },
  [2007] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(5749),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2008] = {
    [sym_concatenation] = STATE(2646),
    [sym_string] = STATE(2645),
    [sym_simple_expansion] = STATE(2645),
    [sym_string_expansion] = STATE(2645),
    [sym_expansion] = STATE(2645),
    [sym_command_substitution] = STATE(2645),
    [sym_process_substitution] = STATE(2645),
    [aux_sym__literal_repeat1] = STATE(2647),
    [anon_sym_RBRACE] = ACTIONS(5747),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(5751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5751),
  },
  [2009] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [sym_variable_name] = ACTIONS(4103),
    [ts_builtin_sym_end] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_RPAREN] = ACTIONS(4103),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [2010] = {
    [sym_concatenation] = STATE(2650),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2650),
    [sym_regex] = ACTIONS(5753),
    [anon_sym_RBRACE] = ACTIONS(5755),
    [anon_sym_EQ] = ACTIONS(5757),
    [anon_sym_DASH] = ACTIONS(5757),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5759),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5757),
    [anon_sym_COLON_QMARK] = ACTIONS(5757),
    [anon_sym_COLON_DASH] = ACTIONS(5757),
    [anon_sym_PERCENT] = ACTIONS(5757),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2011] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5755),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2012] = {
    [sym_concatenation] = STATE(2652),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2652),
    [sym_regex] = ACTIONS(5761),
    [anon_sym_RBRACE] = ACTIONS(5747),
    [anon_sym_EQ] = ACTIONS(5763),
    [anon_sym_DASH] = ACTIONS(5763),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5763),
    [anon_sym_COLON_QMARK] = ACTIONS(5763),
    [anon_sym_COLON_DASH] = ACTIONS(5763),
    [anon_sym_PERCENT] = ACTIONS(5763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2013] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5747),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2014] = {
    [sym_concatenation] = STATE(2654),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2654),
    [anon_sym_RBRACE] = ACTIONS(5767),
    [anon_sym_EQ] = ACTIONS(5769),
    [anon_sym_DASH] = ACTIONS(5769),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5771),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5769),
    [anon_sym_COLON_QMARK] = ACTIONS(5769),
    [anon_sym_COLON_DASH] = ACTIONS(5769),
    [anon_sym_PERCENT] = ACTIONS(5769),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2015] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [sym_variable_name] = ACTIONS(4159),
    [ts_builtin_sym_end] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_RPAREN] = ACTIONS(4159),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [2016] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5767),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2017] = {
    [sym_concatenation] = STATE(2652),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2652),
    [anon_sym_RBRACE] = ACTIONS(5747),
    [anon_sym_EQ] = ACTIONS(5763),
    [anon_sym_DASH] = ACTIONS(5763),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5765),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5763),
    [anon_sym_COLON_QMARK] = ACTIONS(5763),
    [anon_sym_COLON_DASH] = ACTIONS(5763),
    [anon_sym_PERCENT] = ACTIONS(5763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2018] = {
    [sym_do_group] = STATE(2655),
    [sym_compound_statement] = STATE(2655),
    [anon_sym_do] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [2019] = {
    [sym__simple_heredoc_body] = ACTIONS(5773),
    [sym__heredoc_body_beginning] = ACTIONS(5773),
    [sym_file_descriptor] = ACTIONS(5773),
    [ts_builtin_sym_end] = ACTIONS(5773),
    [anon_sym_SEMI] = ACTIONS(5775),
    [anon_sym_done] = ACTIONS(5773),
    [anon_sym_fi] = ACTIONS(5773),
    [anon_sym_elif] = ACTIONS(5773),
    [anon_sym_else] = ACTIONS(5773),
    [anon_sym_esac] = ACTIONS(5773),
    [anon_sym_PIPE] = ACTIONS(5775),
    [anon_sym_RPAREN] = ACTIONS(5773),
    [anon_sym_SEMI_SEMI] = ACTIONS(5773),
    [anon_sym_PIPE_AMP] = ACTIONS(5773),
    [anon_sym_AMP_AMP] = ACTIONS(5773),
    [anon_sym_PIPE_PIPE] = ACTIONS(5773),
    [anon_sym_LT] = ACTIONS(5775),
    [anon_sym_GT] = ACTIONS(5775),
    [anon_sym_GT_GT] = ACTIONS(5773),
    [anon_sym_AMP_GT] = ACTIONS(5775),
    [anon_sym_AMP_GT_GT] = ACTIONS(5773),
    [anon_sym_LT_AMP] = ACTIONS(5773),
    [anon_sym_GT_AMP] = ACTIONS(5773),
    [anon_sym_LT_LT] = ACTIONS(5775),
    [anon_sym_LT_LT_DASH] = ACTIONS(5773),
    [anon_sym_LT_LT_LT] = ACTIONS(5773),
    [anon_sym_BQUOTE] = ACTIONS(5773),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5773),
    [anon_sym_AMP] = ACTIONS(5775),
  },
  [2020] = {
    [sym_do_group] = STATE(2655),
    [sym_compound_statement] = STATE(2655),
    [anon_sym_SEMI] = ACTIONS(5777),
    [anon_sym_do] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [2021] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5779),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [2022] = {
    [sym__concat] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_EQ_TILDE] = ACTIONS(4053),
    [anon_sym_EQ_EQ] = ACTIONS(4053),
    [anon_sym_EQ] = ACTIONS(4055),
    [anon_sym_PLUS_EQ] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_BANG_EQ] = ACTIONS(4053),
    [anon_sym_PLUS] = ACTIONS(4055),
    [anon_sym_DASH] = ACTIONS(4055),
    [anon_sym_DASH_EQ] = ACTIONS(4053),
    [anon_sym_LT_EQ] = ACTIONS(4053),
    [anon_sym_GT_EQ] = ACTIONS(4053),
    [anon_sym_PLUS_PLUS] = ACTIONS(4053),
    [anon_sym_DASH_DASH] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4053),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [2023] = {
    [sym__concat] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_EQ_TILDE] = ACTIONS(4067),
    [anon_sym_EQ_EQ] = ACTIONS(4067),
    [anon_sym_EQ] = ACTIONS(4069),
    [anon_sym_PLUS_EQ] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_BANG_EQ] = ACTIONS(4067),
    [anon_sym_PLUS] = ACTIONS(4069),
    [anon_sym_DASH] = ACTIONS(4069),
    [anon_sym_DASH_EQ] = ACTIONS(4067),
    [anon_sym_LT_EQ] = ACTIONS(4067),
    [anon_sym_GT_EQ] = ACTIONS(4067),
    [anon_sym_PLUS_PLUS] = ACTIONS(4067),
    [anon_sym_DASH_DASH] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4067),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [2024] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(5781),
    [sym_comment] = ACTIONS(57),
  },
  [2025] = {
    [anon_sym_RBRACE] = ACTIONS(5781),
    [sym_comment] = ACTIONS(57),
  },
  [2026] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(5783),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2027] = {
    [sym_concatenation] = STATE(2661),
    [sym_string] = STATE(2660),
    [sym_simple_expansion] = STATE(2660),
    [sym_string_expansion] = STATE(2660),
    [sym_expansion] = STATE(2660),
    [sym_command_substitution] = STATE(2660),
    [sym_process_substitution] = STATE(2660),
    [aux_sym__literal_repeat1] = STATE(2662),
    [anon_sym_RBRACE] = ACTIONS(5781),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(5785),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5785),
  },
  [2028] = {
    [sym__concat] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_EQ_TILDE] = ACTIONS(4103),
    [anon_sym_EQ_EQ] = ACTIONS(4103),
    [anon_sym_EQ] = ACTIONS(4105),
    [anon_sym_PLUS_EQ] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_BANG_EQ] = ACTIONS(4103),
    [anon_sym_PLUS] = ACTIONS(4105),
    [anon_sym_DASH] = ACTIONS(4105),
    [anon_sym_DASH_EQ] = ACTIONS(4103),
    [anon_sym_LT_EQ] = ACTIONS(4103),
    [anon_sym_GT_EQ] = ACTIONS(4103),
    [anon_sym_PLUS_PLUS] = ACTIONS(4103),
    [anon_sym_DASH_DASH] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4103),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [2029] = {
    [sym_concatenation] = STATE(2665),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2665),
    [sym_regex] = ACTIONS(5787),
    [anon_sym_RBRACE] = ACTIONS(5789),
    [anon_sym_EQ] = ACTIONS(5791),
    [anon_sym_DASH] = ACTIONS(5791),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5791),
    [anon_sym_COLON_QMARK] = ACTIONS(5791),
    [anon_sym_COLON_DASH] = ACTIONS(5791),
    [anon_sym_PERCENT] = ACTIONS(5791),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2030] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5789),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2031] = {
    [sym_concatenation] = STATE(2667),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2667),
    [sym_regex] = ACTIONS(5795),
    [anon_sym_RBRACE] = ACTIONS(5781),
    [anon_sym_EQ] = ACTIONS(5797),
    [anon_sym_DASH] = ACTIONS(5797),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5799),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5797),
    [anon_sym_COLON_QMARK] = ACTIONS(5797),
    [anon_sym_COLON_DASH] = ACTIONS(5797),
    [anon_sym_PERCENT] = ACTIONS(5797),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2032] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5781),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2033] = {
    [sym_concatenation] = STATE(2669),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2669),
    [anon_sym_RBRACE] = ACTIONS(5801),
    [anon_sym_EQ] = ACTIONS(5803),
    [anon_sym_DASH] = ACTIONS(5803),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5805),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5803),
    [anon_sym_COLON_QMARK] = ACTIONS(5803),
    [anon_sym_COLON_DASH] = ACTIONS(5803),
    [anon_sym_PERCENT] = ACTIONS(5803),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2034] = {
    [sym__concat] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_EQ_TILDE] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4159),
    [anon_sym_EQ] = ACTIONS(4161),
    [anon_sym_PLUS_EQ] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_BANG_EQ] = ACTIONS(4159),
    [anon_sym_PLUS] = ACTIONS(4161),
    [anon_sym_DASH] = ACTIONS(4161),
    [anon_sym_DASH_EQ] = ACTIONS(4159),
    [anon_sym_LT_EQ] = ACTIONS(4159),
    [anon_sym_GT_EQ] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4159),
    [anon_sym_DASH_DASH] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4159),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [2035] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5801),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2036] = {
    [sym_concatenation] = STATE(2667),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2667),
    [anon_sym_RBRACE] = ACTIONS(5781),
    [anon_sym_EQ] = ACTIONS(5797),
    [anon_sym_DASH] = ACTIONS(5797),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5799),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5797),
    [anon_sym_COLON_QMARK] = ACTIONS(5797),
    [anon_sym_COLON_DASH] = ACTIONS(5797),
    [anon_sym_PERCENT] = ACTIONS(5797),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2037] = {
    [sym__expression] = STATE(2670),
    [sym_binary_expression] = STATE(2670),
    [sym_unary_expression] = STATE(2670),
    [sym_postfix_expression] = STATE(2670),
    [sym_parenthesized_expression] = STATE(2670),
    [sym_concatenation] = STATE(2670),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5779),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_character] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [2038] = {
    [sym__concat] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
  },
  [2039] = {
    [aux_sym_concatenation_repeat1] = STATE(2039),
    [sym__concat] = ACTIONS(5807),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2344),
  },
  [2040] = {
    [sym__concat] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2351),
  },
  [2041] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [2042] = {
    [sym_concatenation] = STATE(2674),
    [sym_string] = STATE(2673),
    [sym_simple_expansion] = STATE(2673),
    [sym_string_expansion] = STATE(2673),
    [sym_expansion] = STATE(2673),
    [sym_command_substitution] = STATE(2673),
    [sym_process_substitution] = STATE(2673),
    [aux_sym__literal_repeat1] = STATE(2675),
    [anon_sym_RBRACE] = ACTIONS(5812),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(5814),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5814),
  },
  [2043] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(5816),
    [sym_comment] = ACTIONS(57),
  },
  [2044] = {
    [sym_concatenation] = STATE(2679),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2679),
    [anon_sym_RBRACE] = ACTIONS(5818),
    [anon_sym_EQ] = ACTIONS(5820),
    [anon_sym_DASH] = ACTIONS(5820),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5822),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(5824),
    [anon_sym_COLON] = ACTIONS(5820),
    [anon_sym_COLON_QMARK] = ACTIONS(5820),
    [anon_sym_COLON_DASH] = ACTIONS(5820),
    [anon_sym_PERCENT] = ACTIONS(5820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2045] = {
    [sym_concatenation] = STATE(2681),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2681),
    [anon_sym_RBRACE] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5826),
    [anon_sym_DASH] = ACTIONS(5826),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5828),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(5830),
    [anon_sym_COLON] = ACTIONS(5826),
    [anon_sym_COLON_QMARK] = ACTIONS(5826),
    [anon_sym_COLON_DASH] = ACTIONS(5826),
    [anon_sym_PERCENT] = ACTIONS(5826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2046] = {
    [sym__concat] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2442),
  },
  [2047] = {
    [sym_concatenation] = STATE(2684),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2684),
    [sym_regex] = ACTIONS(5832),
    [anon_sym_RBRACE] = ACTIONS(5834),
    [anon_sym_EQ] = ACTIONS(5836),
    [anon_sym_DASH] = ACTIONS(5836),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5838),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5836),
    [anon_sym_COLON_QMARK] = ACTIONS(5836),
    [anon_sym_COLON_DASH] = ACTIONS(5836),
    [anon_sym_PERCENT] = ACTIONS(5836),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2048] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5834),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2049] = {
    [sym__concat] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2492),
  },
  [2050] = {
    [sym_concatenation] = STATE(2681),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2681),
    [sym_regex] = ACTIONS(5840),
    [anon_sym_RBRACE] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(5826),
    [anon_sym_DASH] = ACTIONS(5826),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5828),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5826),
    [anon_sym_COLON_QMARK] = ACTIONS(5826),
    [anon_sym_COLON_DASH] = ACTIONS(5826),
    [anon_sym_PERCENT] = ACTIONS(5826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2051] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5812),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2052] = {
    [sym__concat] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2500),
  },
  [2053] = {
    [sym__concat] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2534),
  },
  [2054] = {
    [sym__simple_heredoc_body] = ACTIONS(5842),
    [sym__heredoc_body_beginning] = ACTIONS(5842),
    [sym_file_descriptor] = ACTIONS(5842),
    [ts_builtin_sym_end] = ACTIONS(5842),
    [anon_sym_SEMI] = ACTIONS(5844),
    [anon_sym_done] = ACTIONS(5842),
    [anon_sym_fi] = ACTIONS(5842),
    [anon_sym_elif] = ACTIONS(5842),
    [anon_sym_else] = ACTIONS(5842),
    [anon_sym_esac] = ACTIONS(5842),
    [anon_sym_PIPE] = ACTIONS(5844),
    [anon_sym_RPAREN] = ACTIONS(5842),
    [anon_sym_SEMI_SEMI] = ACTIONS(5842),
    [anon_sym_PIPE_AMP] = ACTIONS(5842),
    [anon_sym_AMP_AMP] = ACTIONS(5842),
    [anon_sym_PIPE_PIPE] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5844),
    [anon_sym_GT] = ACTIONS(5844),
    [anon_sym_GT_GT] = ACTIONS(5842),
    [anon_sym_AMP_GT] = ACTIONS(5844),
    [anon_sym_AMP_GT_GT] = ACTIONS(5842),
    [anon_sym_LT_AMP] = ACTIONS(5842),
    [anon_sym_GT_AMP] = ACTIONS(5842),
    [anon_sym_LT_LT] = ACTIONS(5844),
    [anon_sym_LT_LT_DASH] = ACTIONS(5842),
    [anon_sym_LT_LT_LT] = ACTIONS(5842),
    [anon_sym_BQUOTE] = ACTIONS(5842),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5842),
    [anon_sym_AMP] = ACTIONS(5844),
  },
  [2055] = {
    [sym__concat] = ACTIONS(4053),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_RPAREN] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_EQ_TILDE] = ACTIONS(4053),
    [anon_sym_EQ_EQ] = ACTIONS(4053),
    [anon_sym_EQ] = ACTIONS(4055),
    [anon_sym_PLUS_EQ] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_BANG_EQ] = ACTIONS(4053),
    [anon_sym_PLUS] = ACTIONS(4055),
    [anon_sym_DASH] = ACTIONS(4055),
    [anon_sym_DASH_EQ] = ACTIONS(4053),
    [anon_sym_LT_EQ] = ACTIONS(4053),
    [anon_sym_GT_EQ] = ACTIONS(4053),
    [anon_sym_PLUS_PLUS] = ACTIONS(4053),
    [anon_sym_DASH_DASH] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4053),
  },
  [2056] = {
    [sym__concat] = ACTIONS(4067),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_RPAREN] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_EQ_TILDE] = ACTIONS(4067),
    [anon_sym_EQ_EQ] = ACTIONS(4067),
    [anon_sym_EQ] = ACTIONS(4069),
    [anon_sym_PLUS_EQ] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_BANG_EQ] = ACTIONS(4067),
    [anon_sym_PLUS] = ACTIONS(4069),
    [anon_sym_DASH] = ACTIONS(4069),
    [anon_sym_DASH_EQ] = ACTIONS(4067),
    [anon_sym_LT_EQ] = ACTIONS(4067),
    [anon_sym_GT_EQ] = ACTIONS(4067),
    [anon_sym_PLUS_PLUS] = ACTIONS(4067),
    [anon_sym_DASH_DASH] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4067),
  },
  [2057] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(5846),
    [sym_comment] = ACTIONS(57),
  },
  [2058] = {
    [anon_sym_RBRACE] = ACTIONS(5846),
    [sym_comment] = ACTIONS(57),
  },
  [2059] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(5848),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2060] = {
    [sym_concatenation] = STATE(2689),
    [sym_string] = STATE(2688),
    [sym_simple_expansion] = STATE(2688),
    [sym_string_expansion] = STATE(2688),
    [sym_expansion] = STATE(2688),
    [sym_command_substitution] = STATE(2688),
    [sym_process_substitution] = STATE(2688),
    [aux_sym__literal_repeat1] = STATE(2690),
    [anon_sym_RBRACE] = ACTIONS(5846),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(5850),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5850),
  },
  [2061] = {
    [sym__concat] = ACTIONS(4103),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_RPAREN] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_EQ_TILDE] = ACTIONS(4103),
    [anon_sym_EQ_EQ] = ACTIONS(4103),
    [anon_sym_EQ] = ACTIONS(4105),
    [anon_sym_PLUS_EQ] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_BANG_EQ] = ACTIONS(4103),
    [anon_sym_PLUS] = ACTIONS(4105),
    [anon_sym_DASH] = ACTIONS(4105),
    [anon_sym_DASH_EQ] = ACTIONS(4103),
    [anon_sym_LT_EQ] = ACTIONS(4103),
    [anon_sym_GT_EQ] = ACTIONS(4103),
    [anon_sym_PLUS_PLUS] = ACTIONS(4103),
    [anon_sym_DASH_DASH] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4103),
  },
  [2062] = {
    [sym_concatenation] = STATE(2693),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2693),
    [sym_regex] = ACTIONS(5852),
    [anon_sym_RBRACE] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5856),
    [anon_sym_DASH] = ACTIONS(5856),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5858),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5856),
    [anon_sym_COLON_QMARK] = ACTIONS(5856),
    [anon_sym_COLON_DASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2063] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2064] = {
    [sym_concatenation] = STATE(2695),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2695),
    [sym_regex] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5846),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_DASH] = ACTIONS(5862),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5864),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5862),
    [anon_sym_COLON_QMARK] = ACTIONS(5862),
    [anon_sym_COLON_DASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2065] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5846),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2066] = {
    [sym_concatenation] = STATE(2697),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2697),
    [anon_sym_RBRACE] = ACTIONS(5866),
    [anon_sym_EQ] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(5868),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5870),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5868),
    [anon_sym_COLON_QMARK] = ACTIONS(5868),
    [anon_sym_COLON_DASH] = ACTIONS(5868),
    [anon_sym_PERCENT] = ACTIONS(5868),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2067] = {
    [sym__concat] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_RPAREN] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_EQ_TILDE] = ACTIONS(4159),
    [anon_sym_EQ_EQ] = ACTIONS(4159),
    [anon_sym_EQ] = ACTIONS(4161),
    [anon_sym_PLUS_EQ] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_BANG_EQ] = ACTIONS(4159),
    [anon_sym_PLUS] = ACTIONS(4161),
    [anon_sym_DASH] = ACTIONS(4161),
    [anon_sym_DASH_EQ] = ACTIONS(4159),
    [anon_sym_LT_EQ] = ACTIONS(4159),
    [anon_sym_GT_EQ] = ACTIONS(4159),
    [anon_sym_PLUS_PLUS] = ACTIONS(4159),
    [anon_sym_DASH_DASH] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(4159),
  },
  [2068] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5866),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2069] = {
    [sym_concatenation] = STATE(2695),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2695),
    [anon_sym_RBRACE] = ACTIONS(5846),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_DASH] = ACTIONS(5862),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5864),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5862),
    [anon_sym_COLON_QMARK] = ACTIONS(5862),
    [anon_sym_COLON_DASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2070] = {
    [sym__concat] = ACTIONS(5564),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5564),
    [anon_sym_EQ_EQ] = ACTIONS(5564),
    [anon_sym_EQ] = ACTIONS(5566),
    [anon_sym_PLUS_EQ] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5564),
    [anon_sym_PLUS] = ACTIONS(5566),
    [anon_sym_DASH] = ACTIONS(5566),
    [anon_sym_DASH_EQ] = ACTIONS(5564),
    [anon_sym_LT_EQ] = ACTIONS(5564),
    [anon_sym_GT_EQ] = ACTIONS(5564),
    [anon_sym_PLUS_PLUS] = ACTIONS(5564),
    [anon_sym_DASH_DASH] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5564),
  },
  [2071] = {
    [sym__concat] = ACTIONS(5598),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5598),
    [anon_sym_EQ_TILDE] = ACTIONS(5598),
    [anon_sym_EQ_EQ] = ACTIONS(5598),
    [anon_sym_EQ] = ACTIONS(5600),
    [anon_sym_PLUS_EQ] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_BANG_EQ] = ACTIONS(5598),
    [anon_sym_PLUS] = ACTIONS(5600),
    [anon_sym_DASH] = ACTIONS(5600),
    [anon_sym_DASH_EQ] = ACTIONS(5598),
    [anon_sym_LT_EQ] = ACTIONS(5598),
    [anon_sym_GT_EQ] = ACTIONS(5598),
    [anon_sym_PLUS_PLUS] = ACTIONS(5598),
    [anon_sym_DASH_DASH] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5598),
  },
  [2072] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(5872),
    [sym_comment] = ACTIONS(57),
  },
  [2073] = {
    [anon_sym_RBRACE] = ACTIONS(5872),
    [sym_comment] = ACTIONS(57),
  },
  [2074] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(5874),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2075] = {
    [sym_concatenation] = STATE(2701),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2701),
    [anon_sym_RBRACE] = ACTIONS(5876),
    [anon_sym_EQ] = ACTIONS(5878),
    [anon_sym_DASH] = ACTIONS(5878),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5878),
    [anon_sym_COLON_QMARK] = ACTIONS(5878),
    [anon_sym_COLON_DASH] = ACTIONS(5878),
    [anon_sym_PERCENT] = ACTIONS(5878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2076] = {
    [sym__concat] = ACTIONS(5615),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5615),
    [anon_sym_EQ_TILDE] = ACTIONS(5615),
    [anon_sym_EQ_EQ] = ACTIONS(5615),
    [anon_sym_EQ] = ACTIONS(5617),
    [anon_sym_PLUS_EQ] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_BANG_EQ] = ACTIONS(5615),
    [anon_sym_PLUS] = ACTIONS(5617),
    [anon_sym_DASH] = ACTIONS(5617),
    [anon_sym_DASH_EQ] = ACTIONS(5615),
    [anon_sym_LT_EQ] = ACTIONS(5615),
    [anon_sym_GT_EQ] = ACTIONS(5615),
    [anon_sym_PLUS_PLUS] = ACTIONS(5615),
    [anon_sym_DASH_DASH] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5615),
  },
  [2077] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5876),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2078] = {
    [sym_concatenation] = STATE(2702),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2702),
    [anon_sym_RBRACE] = ACTIONS(5872),
    [anon_sym_EQ] = ACTIONS(5882),
    [anon_sym_DASH] = ACTIONS(5882),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5884),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5882),
    [anon_sym_COLON_QMARK] = ACTIONS(5882),
    [anon_sym_COLON_DASH] = ACTIONS(5882),
    [anon_sym_PERCENT] = ACTIONS(5882),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2079] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5872),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2080] = {
    [sym__concat] = ACTIONS(5658),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(5658),
    [anon_sym_EQ_TILDE] = ACTIONS(5658),
    [anon_sym_EQ_EQ] = ACTIONS(5658),
    [anon_sym_EQ] = ACTIONS(5660),
    [anon_sym_PLUS_EQ] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_BANG_EQ] = ACTIONS(5658),
    [anon_sym_PLUS] = ACTIONS(5660),
    [anon_sym_DASH] = ACTIONS(5660),
    [anon_sym_DASH_EQ] = ACTIONS(5658),
    [anon_sym_LT_EQ] = ACTIONS(5658),
    [anon_sym_GT_EQ] = ACTIONS(5658),
    [anon_sym_PLUS_PLUS] = ACTIONS(5658),
    [anon_sym_DASH_DASH] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5658),
  },
  [2081] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5886),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2082] = {
    [sym_file_descriptor] = ACTIONS(4383),
    [sym_variable_name] = ACTIONS(4383),
    [anon_sym_SEMI] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI_SEMI] = ACTIONS(4383),
    [anon_sym_PIPE_AMP] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_AMP_GT] = ACTIONS(4385),
    [anon_sym_AMP_GT_GT] = ACTIONS(4383),
    [anon_sym_LT_AMP] = ACTIONS(4383),
    [anon_sym_GT_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_LT_LT_DASH] = ACTIONS(4383),
    [anon_sym_LT_LT_LT] = ACTIONS(4383),
    [sym__special_character] = ACTIONS(4383),
    [anon_sym_DQUOTE] = ACTIONS(4383),
    [anon_sym_DOLLAR] = ACTIONS(4385),
    [sym_raw_string] = ACTIONS(4383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4383),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4383),
    [anon_sym_BQUOTE] = ACTIONS(4383),
    [anon_sym_LT_LPAREN] = ACTIONS(4383),
    [anon_sym_GT_LPAREN] = ACTIONS(4383),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4385),
    [anon_sym_LF] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
  },
  [2083] = {
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2084] = {
    [aux_sym_concatenation_repeat1] = STATE(2084),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(5888),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2085] = {
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [sym_variable_name] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [2086] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(5891),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [2087] = {
    [sym_concatenation] = STATE(2707),
    [sym_string] = STATE(2706),
    [sym_simple_expansion] = STATE(2706),
    [sym_string_expansion] = STATE(2706),
    [sym_expansion] = STATE(2706),
    [sym_command_substitution] = STATE(2706),
    [sym_process_substitution] = STATE(2706),
    [aux_sym__literal_repeat1] = STATE(2708),
    [anon_sym_RBRACE] = ACTIONS(5893),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(5895),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5895),
  },
  [2088] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(5897),
    [sym_comment] = ACTIONS(57),
  },
  [2089] = {
    [sym_concatenation] = STATE(2712),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2712),
    [anon_sym_RBRACE] = ACTIONS(5899),
    [anon_sym_EQ] = ACTIONS(5901),
    [anon_sym_DASH] = ACTIONS(5901),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5903),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(5905),
    [anon_sym_COLON] = ACTIONS(5901),
    [anon_sym_COLON_QMARK] = ACTIONS(5901),
    [anon_sym_COLON_DASH] = ACTIONS(5901),
    [anon_sym_PERCENT] = ACTIONS(5901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2090] = {
    [sym_concatenation] = STATE(2714),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2714),
    [anon_sym_RBRACE] = ACTIONS(5893),
    [anon_sym_EQ] = ACTIONS(5907),
    [anon_sym_DASH] = ACTIONS(5907),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5909),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(5911),
    [anon_sym_COLON] = ACTIONS(5907),
    [anon_sym_COLON_QMARK] = ACTIONS(5907),
    [anon_sym_COLON_DASH] = ACTIONS(5907),
    [anon_sym_PERCENT] = ACTIONS(5907),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2091] = {
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [sym_variable_name] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [2092] = {
    [sym_concatenation] = STATE(2717),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2717),
    [sym_regex] = ACTIONS(5913),
    [anon_sym_RBRACE] = ACTIONS(5915),
    [anon_sym_EQ] = ACTIONS(5917),
    [anon_sym_DASH] = ACTIONS(5917),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5917),
    [anon_sym_COLON_QMARK] = ACTIONS(5917),
    [anon_sym_COLON_DASH] = ACTIONS(5917),
    [anon_sym_PERCENT] = ACTIONS(5917),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2093] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5915),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2094] = {
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [sym_variable_name] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [2095] = {
    [sym_concatenation] = STATE(2714),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2714),
    [sym_regex] = ACTIONS(5921),
    [anon_sym_RBRACE] = ACTIONS(5893),
    [anon_sym_EQ] = ACTIONS(5907),
    [anon_sym_DASH] = ACTIONS(5907),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5909),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5907),
    [anon_sym_COLON_QMARK] = ACTIONS(5907),
    [anon_sym_COLON_DASH] = ACTIONS(5907),
    [anon_sym_PERCENT] = ACTIONS(5907),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2096] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5893),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2097] = {
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [sym_variable_name] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [2098] = {
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [2099] = {
    [sym_do_group] = STATE(2720),
    [sym_compound_statement] = STATE(2720),
    [anon_sym_SEMI] = ACTIONS(5923),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [2100] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5925),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [2101] = {
    [sym__expression] = STATE(2722),
    [sym_binary_expression] = STATE(2722),
    [sym_unary_expression] = STATE(2722),
    [sym_postfix_expression] = STATE(2722),
    [sym_parenthesized_expression] = STATE(2722),
    [sym_concatenation] = STATE(2722),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5925),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_character] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [2102] = {
    [anon_sym_SEMI] = ACTIONS(5927),
    [anon_sym_SEMI_SEMI] = ACTIONS(5929),
    [anon_sym_AMP_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1482),
    [anon_sym_EQ_TILDE] = ACTIONS(1484),
    [anon_sym_EQ_EQ] = ACTIONS(1484),
    [anon_sym_EQ] = ACTIONS(1486),
    [anon_sym_PLUS_EQ] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(1486),
    [anon_sym_GT] = ACTIONS(1486),
    [anon_sym_BANG_EQ] = ACTIONS(1482),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_DASH_EQ] = ACTIONS(1482),
    [anon_sym_LT_EQ] = ACTIONS(1482),
    [anon_sym_GT_EQ] = ACTIONS(1482),
    [anon_sym_PLUS_PLUS] = ACTIONS(1488),
    [anon_sym_DASH_DASH] = ACTIONS(1488),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1482),
    [anon_sym_LF] = ACTIONS(5929),
    [anon_sym_AMP] = ACTIONS(5927),
  },
  [2103] = {
    [sym_do_group] = STATE(2724),
    [anon_sym_do] = ACTIONS(1627),
    [sym_comment] = ACTIONS(57),
  },
  [2104] = {
    [sym_file_descriptor] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(4904),
    [anon_sym_PIPE] = ACTIONS(4904),
    [anon_sym_SEMI_SEMI] = ACTIONS(4902),
    [anon_sym_PIPE_AMP] = ACTIONS(4902),
    [anon_sym_AMP_AMP] = ACTIONS(4902),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_GT] = ACTIONS(4904),
    [anon_sym_GT_GT] = ACTIONS(4902),
    [anon_sym_AMP_GT] = ACTIONS(4904),
    [anon_sym_AMP_GT_GT] = ACTIONS(4902),
    [anon_sym_LT_AMP] = ACTIONS(4902),
    [anon_sym_GT_AMP] = ACTIONS(4902),
    [anon_sym_LT_LT] = ACTIONS(4904),
    [anon_sym_LT_LT_DASH] = ACTIONS(4902),
    [anon_sym_LT_LT_LT] = ACTIONS(4902),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4902),
    [anon_sym_AMP] = ACTIONS(4904),
  },
  [2105] = {
    [sym_file_descriptor] = ACTIONS(5159),
    [anon_sym_SEMI] = ACTIONS(5161),
    [anon_sym_PIPE] = ACTIONS(5161),
    [anon_sym_SEMI_SEMI] = ACTIONS(5159),
    [anon_sym_PIPE_AMP] = ACTIONS(5159),
    [anon_sym_AMP_AMP] = ACTIONS(5159),
    [anon_sym_PIPE_PIPE] = ACTIONS(5159),
    [anon_sym_LT] = ACTIONS(5161),
    [anon_sym_GT] = ACTIONS(5161),
    [anon_sym_GT_GT] = ACTIONS(5159),
    [anon_sym_AMP_GT] = ACTIONS(5161),
    [anon_sym_AMP_GT_GT] = ACTIONS(5159),
    [anon_sym_LT_AMP] = ACTIONS(5159),
    [anon_sym_GT_AMP] = ACTIONS(5159),
    [anon_sym_LT_LT] = ACTIONS(5161),
    [anon_sym_LT_LT_DASH] = ACTIONS(5159),
    [anon_sym_LT_LT_LT] = ACTIONS(5159),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5159),
    [anon_sym_AMP] = ACTIONS(5161),
  },
  [2106] = {
    [anon_sym_fi] = ACTIONS(5931),
    [sym_comment] = ACTIONS(57),
  },
  [2107] = {
    [sym_elif_clause] = STATE(1682),
    [sym_else_clause] = STATE(2726),
    [aux_sym_if_statement_repeat1] = STATE(1682),
    [anon_sym_fi] = ACTIONS(5931),
    [anon_sym_elif] = ACTIONS(3441),
    [anon_sym_else] = ACTIONS(3443),
    [sym_comment] = ACTIONS(57),
  },
  [2108] = {
    [sym_file_descriptor] = ACTIONS(5195),
    [anon_sym_SEMI] = ACTIONS(5197),
    [anon_sym_PIPE] = ACTIONS(5197),
    [anon_sym_SEMI_SEMI] = ACTIONS(5195),
    [anon_sym_PIPE_AMP] = ACTIONS(5195),
    [anon_sym_AMP_AMP] = ACTIONS(5195),
    [anon_sym_PIPE_PIPE] = ACTIONS(5195),
    [anon_sym_LT] = ACTIONS(5197),
    [anon_sym_GT] = ACTIONS(5197),
    [anon_sym_GT_GT] = ACTIONS(5195),
    [anon_sym_AMP_GT] = ACTIONS(5197),
    [anon_sym_AMP_GT_GT] = ACTIONS(5195),
    [anon_sym_LT_AMP] = ACTIONS(5195),
    [anon_sym_GT_AMP] = ACTIONS(5195),
    [anon_sym_LT_LT] = ACTIONS(5197),
    [anon_sym_LT_LT_DASH] = ACTIONS(5195),
    [anon_sym_LT_LT_LT] = ACTIONS(5195),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5195),
    [anon_sym_AMP] = ACTIONS(5197),
  },
  [2109] = {
    [anon_sym_esac] = ACTIONS(5933),
    [sym_comment] = ACTIONS(57),
  },
  [2110] = {
    [sym_case_item] = STATE(2403),
    [sym_last_case_item] = STATE(2728),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(2403),
    [aux_sym__literal_repeat1] = STATE(1693),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3482),
  },
  [2111] = {
    [sym_case_item] = STATE(2729),
    [sym_last_case_item] = STATE(2728),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(2729),
    [aux_sym__literal_repeat1] = STATE(1693),
    [anon_sym_esac] = ACTIONS(5935),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3484),
  },
  [2112] = {
    [sym_file_descriptor] = ACTIONS(5235),
    [anon_sym_SEMI] = ACTIONS(5237),
    [anon_sym_PIPE] = ACTIONS(5237),
    [anon_sym_SEMI_SEMI] = ACTIONS(5235),
    [anon_sym_PIPE_AMP] = ACTIONS(5235),
    [anon_sym_AMP_AMP] = ACTIONS(5235),
    [anon_sym_PIPE_PIPE] = ACTIONS(5235),
    [anon_sym_LT] = ACTIONS(5237),
    [anon_sym_GT] = ACTIONS(5237),
    [anon_sym_GT_GT] = ACTIONS(5235),
    [anon_sym_AMP_GT] = ACTIONS(5237),
    [anon_sym_AMP_GT_GT] = ACTIONS(5235),
    [anon_sym_LT_AMP] = ACTIONS(5235),
    [anon_sym_GT_AMP] = ACTIONS(5235),
    [anon_sym_LT_LT] = ACTIONS(5237),
    [anon_sym_LT_LT_DASH] = ACTIONS(5235),
    [anon_sym_LT_LT_LT] = ACTIONS(5235),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5235),
    [anon_sym_AMP] = ACTIONS(5237),
  },
  [2113] = {
    [anon_sym_esac] = ACTIONS(5937),
    [sym_comment] = ACTIONS(57),
  },
  [2114] = {
    [sym_case_item] = STATE(2403),
    [sym_last_case_item] = STATE(2731),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(2403),
    [aux_sym__literal_repeat1] = STATE(1693),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3482),
  },
  [2115] = {
    [sym_case_item] = STATE(2732),
    [sym_last_case_item] = STATE(2731),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(2732),
    [aux_sym__literal_repeat1] = STATE(1693),
    [anon_sym_esac] = ACTIONS(5939),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3484),
  },
  [2116] = {
    [sym_file_descriptor] = ACTIONS(5243),
    [anon_sym_SEMI] = ACTIONS(5245),
    [anon_sym_PIPE] = ACTIONS(5245),
    [anon_sym_SEMI_SEMI] = ACTIONS(5243),
    [anon_sym_PIPE_AMP] = ACTIONS(5243),
    [anon_sym_AMP_AMP] = ACTIONS(5243),
    [anon_sym_PIPE_PIPE] = ACTIONS(5243),
    [anon_sym_LT] = ACTIONS(5245),
    [anon_sym_GT] = ACTIONS(5245),
    [anon_sym_GT_GT] = ACTIONS(5243),
    [anon_sym_AMP_GT] = ACTIONS(5245),
    [anon_sym_AMP_GT_GT] = ACTIONS(5243),
    [anon_sym_LT_AMP] = ACTIONS(5243),
    [anon_sym_GT_AMP] = ACTIONS(5243),
    [anon_sym_LT_LT] = ACTIONS(5245),
    [anon_sym_LT_LT_DASH] = ACTIONS(5243),
    [anon_sym_LT_LT_LT] = ACTIONS(5243),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5243),
    [anon_sym_AMP] = ACTIONS(5245),
  },
  [2117] = {
    [sym_file_descriptor] = ACTIONS(2697),
    [sym_variable_name] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI_SEMI] = ACTIONS(2697),
    [anon_sym_PIPE_AMP] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_PIPE_PIPE] = ACTIONS(2697),
    [anon_sym_LT] = ACTIONS(2699),
    [anon_sym_GT] = ACTIONS(2699),
    [anon_sym_GT_GT] = ACTIONS(2697),
    [anon_sym_AMP_GT] = ACTIONS(2699),
    [anon_sym_AMP_GT_GT] = ACTIONS(2697),
    [anon_sym_LT_AMP] = ACTIONS(2697),
    [anon_sym_GT_AMP] = ACTIONS(2697),
    [anon_sym_LT_LT] = ACTIONS(2699),
    [anon_sym_LT_LT_DASH] = ACTIONS(2697),
    [anon_sym_LT_LT_LT] = ACTIONS(2697),
    [sym__special_character] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [anon_sym_DOLLAR] = ACTIONS(2699),
    [sym_raw_string] = ACTIONS(2697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2697),
    [anon_sym_BQUOTE] = ACTIONS(2697),
    [anon_sym_LT_LPAREN] = ACTIONS(2697),
    [anon_sym_GT_LPAREN] = ACTIONS(2697),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2699),
    [sym_word] = ACTIONS(2699),
    [anon_sym_LF] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
  },
  [2118] = {
    [sym_concatenation] = STATE(1357),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(1357),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(5941),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [2119] = {
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [sym_variable_name] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4055),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [2120] = {
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [sym_variable_name] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4069),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [2121] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(5943),
    [sym_comment] = ACTIONS(57),
  },
  [2122] = {
    [anon_sym_RBRACE] = ACTIONS(5943),
    [sym_comment] = ACTIONS(57),
  },
  [2123] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(5945),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2124] = {
    [sym_concatenation] = STATE(2737),
    [sym_string] = STATE(2736),
    [sym_simple_expansion] = STATE(2736),
    [sym_string_expansion] = STATE(2736),
    [sym_expansion] = STATE(2736),
    [sym_command_substitution] = STATE(2736),
    [sym_process_substitution] = STATE(2736),
    [aux_sym__literal_repeat1] = STATE(2738),
    [anon_sym_RBRACE] = ACTIONS(5943),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(5947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5947),
  },
  [2125] = {
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [sym_variable_name] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4105),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [2126] = {
    [sym_concatenation] = STATE(2741),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2741),
    [sym_regex] = ACTIONS(5949),
    [anon_sym_RBRACE] = ACTIONS(5951),
    [anon_sym_EQ] = ACTIONS(5953),
    [anon_sym_DASH] = ACTIONS(5953),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5955),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_COLON_QMARK] = ACTIONS(5953),
    [anon_sym_COLON_DASH] = ACTIONS(5953),
    [anon_sym_PERCENT] = ACTIONS(5953),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2127] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5951),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2128] = {
    [sym_concatenation] = STATE(2743),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2743),
    [sym_regex] = ACTIONS(5957),
    [anon_sym_RBRACE] = ACTIONS(5943),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5961),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5959),
    [anon_sym_COLON_QMARK] = ACTIONS(5959),
    [anon_sym_COLON_DASH] = ACTIONS(5959),
    [anon_sym_PERCENT] = ACTIONS(5959),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2129] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5943),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2130] = {
    [sym_concatenation] = STATE(2745),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2745),
    [anon_sym_RBRACE] = ACTIONS(5963),
    [anon_sym_EQ] = ACTIONS(5965),
    [anon_sym_DASH] = ACTIONS(5965),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5967),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5965),
    [anon_sym_COLON_QMARK] = ACTIONS(5965),
    [anon_sym_COLON_DASH] = ACTIONS(5965),
    [anon_sym_PERCENT] = ACTIONS(5965),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2131] = {
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [sym_variable_name] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4161),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [2132] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5963),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2133] = {
    [sym_concatenation] = STATE(2743),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2743),
    [anon_sym_RBRACE] = ACTIONS(5943),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5961),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5959),
    [anon_sym_COLON_QMARK] = ACTIONS(5959),
    [anon_sym_COLON_DASH] = ACTIONS(5959),
    [anon_sym_PERCENT] = ACTIONS(5959),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2134] = {
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4055),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [2135] = {
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4069),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [2136] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(5969),
    [sym_comment] = ACTIONS(57),
  },
  [2137] = {
    [anon_sym_RBRACE] = ACTIONS(5969),
    [sym_comment] = ACTIONS(57),
  },
  [2138] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(5971),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2139] = {
    [sym_concatenation] = STATE(2749),
    [sym_string] = STATE(2748),
    [sym_simple_expansion] = STATE(2748),
    [sym_string_expansion] = STATE(2748),
    [sym_expansion] = STATE(2748),
    [sym_command_substitution] = STATE(2748),
    [sym_process_substitution] = STATE(2748),
    [aux_sym__literal_repeat1] = STATE(2750),
    [anon_sym_RBRACE] = ACTIONS(5969),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(5973),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5973),
  },
  [2140] = {
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4105),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [2141] = {
    [sym_concatenation] = STATE(2753),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2753),
    [sym_regex] = ACTIONS(5975),
    [anon_sym_RBRACE] = ACTIONS(5977),
    [anon_sym_EQ] = ACTIONS(5979),
    [anon_sym_DASH] = ACTIONS(5979),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5981),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5979),
    [anon_sym_COLON_QMARK] = ACTIONS(5979),
    [anon_sym_COLON_DASH] = ACTIONS(5979),
    [anon_sym_PERCENT] = ACTIONS(5979),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2142] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5977),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2143] = {
    [sym_concatenation] = STATE(2755),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2755),
    [sym_regex] = ACTIONS(5983),
    [anon_sym_RBRACE] = ACTIONS(5969),
    [anon_sym_EQ] = ACTIONS(5985),
    [anon_sym_DASH] = ACTIONS(5985),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5987),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5985),
    [anon_sym_COLON_QMARK] = ACTIONS(5985),
    [anon_sym_COLON_DASH] = ACTIONS(5985),
    [anon_sym_PERCENT] = ACTIONS(5985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2144] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5969),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2145] = {
    [sym_concatenation] = STATE(2757),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2757),
    [anon_sym_RBRACE] = ACTIONS(5989),
    [anon_sym_EQ] = ACTIONS(5991),
    [anon_sym_DASH] = ACTIONS(5991),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5991),
    [anon_sym_COLON_QMARK] = ACTIONS(5991),
    [anon_sym_COLON_DASH] = ACTIONS(5991),
    [anon_sym_PERCENT] = ACTIONS(5991),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2146] = {
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4161),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [2147] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5989),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2148] = {
    [sym_concatenation] = STATE(2755),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2755),
    [anon_sym_RBRACE] = ACTIONS(5969),
    [anon_sym_EQ] = ACTIONS(5985),
    [anon_sym_DASH] = ACTIONS(5985),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(5987),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(5985),
    [anon_sym_COLON_QMARK] = ACTIONS(5985),
    [anon_sym_COLON_DASH] = ACTIONS(5985),
    [anon_sym_PERCENT] = ACTIONS(5985),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2149] = {
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5566),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [2150] = {
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_EQ_TILDE] = ACTIONS(5600),
    [anon_sym_EQ_EQ] = ACTIONS(5600),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [2151] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(5995),
    [sym_comment] = ACTIONS(57),
  },
  [2152] = {
    [anon_sym_RBRACE] = ACTIONS(5995),
    [sym_comment] = ACTIONS(57),
  },
  [2153] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(5997),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2154] = {
    [sym_concatenation] = STATE(2761),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2761),
    [anon_sym_RBRACE] = ACTIONS(5999),
    [anon_sym_EQ] = ACTIONS(6001),
    [anon_sym_DASH] = ACTIONS(6001),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6003),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6001),
    [anon_sym_COLON_QMARK] = ACTIONS(6001),
    [anon_sym_COLON_DASH] = ACTIONS(6001),
    [anon_sym_PERCENT] = ACTIONS(6001),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2155] = {
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_EQ_TILDE] = ACTIONS(5617),
    [anon_sym_EQ_EQ] = ACTIONS(5617),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [2156] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5999),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2157] = {
    [sym_concatenation] = STATE(2762),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2762),
    [anon_sym_RBRACE] = ACTIONS(5995),
    [anon_sym_EQ] = ACTIONS(6005),
    [anon_sym_DASH] = ACTIONS(6005),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6007),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6005),
    [anon_sym_COLON_QMARK] = ACTIONS(6005),
    [anon_sym_COLON_DASH] = ACTIONS(6005),
    [anon_sym_PERCENT] = ACTIONS(6005),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2158] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(5995),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2159] = {
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_EQ_TILDE] = ACTIONS(5660),
    [anon_sym_EQ_EQ] = ACTIONS(5660),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [2160] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6009),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2161] = {
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_done] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [2162] = {
    [sym_concatenation] = STATE(2765),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(2765),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(6011),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [2163] = {
    [aux_sym_concatenation_repeat1] = STATE(2767),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(6013),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_done] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [2164] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(2770),
    [anon_sym_DQUOTE] = ACTIONS(6015),
    [anon_sym_DOLLAR] = ACTIONS(6017),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2165] = {
    [sym_string] = STATE(2772),
    [anon_sym_DASH] = ACTIONS(6019),
    [anon_sym_DQUOTE] = ACTIONS(4794),
    [anon_sym_DOLLAR] = ACTIONS(6019),
    [sym_raw_string] = ACTIONS(6021),
    [anon_sym_POUND] = ACTIONS(6019),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6023),
    [anon_sym_STAR] = ACTIONS(6025),
    [anon_sym_AT] = ACTIONS(6025),
    [anon_sym_QMARK] = ACTIONS(6025),
    [anon_sym_0] = ACTIONS(6023),
    [anon_sym__] = ACTIONS(6023),
  },
  [2166] = {
    [aux_sym_concatenation_repeat1] = STATE(2767),
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym__concat] = ACTIONS(6013),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_done] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [2167] = {
    [sym_subscript] = STATE(2777),
    [sym_variable_name] = ACTIONS(6027),
    [anon_sym_BANG] = ACTIONS(6029),
    [anon_sym_DASH] = ACTIONS(6031),
    [anon_sym_DOLLAR] = ACTIONS(6031),
    [anon_sym_POUND] = ACTIONS(6029),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6033),
    [anon_sym_STAR] = ACTIONS(6035),
    [anon_sym_AT] = ACTIONS(6035),
    [anon_sym_QMARK] = ACTIONS(6035),
    [anon_sym_0] = ACTIONS(6033),
    [anon_sym__] = ACTIONS(6033),
  },
  [2168] = {
    [sym__statements] = STATE(2778),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(2779),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2169] = {
    [sym__statements] = STATE(2780),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [2170] = {
    [sym__statements] = STATE(2781),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2171] = {
    [aux_sym__literal_repeat1] = STATE(2783),
    [sym__simple_heredoc_body] = ACTIONS(1444),
    [sym__heredoc_body_beginning] = ACTIONS(1444),
    [sym_file_descriptor] = ACTIONS(1444),
    [sym_variable_name] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_done] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1446),
    [anon_sym_SEMI_SEMI] = ACTIONS(1444),
    [anon_sym_PIPE_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1446),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_AMP_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT_GT] = ACTIONS(1444),
    [anon_sym_LT_AMP] = ACTIONS(1444),
    [anon_sym_GT_AMP] = ACTIONS(1444),
    [anon_sym_LT_LT] = ACTIONS(1446),
    [anon_sym_LT_LT_DASH] = ACTIONS(1444),
    [anon_sym_LT_LT_LT] = ACTIONS(1444),
    [sym__special_character] = ACTIONS(6037),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [anon_sym_DOLLAR] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1444),
    [anon_sym_BQUOTE] = ACTIONS(1444),
    [anon_sym_LT_LPAREN] = ACTIONS(1444),
    [anon_sym_GT_LPAREN] = ACTIONS(1444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1446),
    [anon_sym_LF] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1446),
  },
  [2172] = {
    [sym_concatenation] = STATE(2784),
    [sym_string] = STATE(2786),
    [sym_array] = STATE(2784),
    [sym_simple_expansion] = STATE(2786),
    [sym_string_expansion] = STATE(2786),
    [sym_expansion] = STATE(2786),
    [sym_command_substitution] = STATE(2786),
    [sym_process_substitution] = STATE(2786),
    [aux_sym__literal_repeat1] = STATE(2787),
    [sym__empty_value] = ACTIONS(6039),
    [anon_sym_LPAREN] = ACTIONS(6041),
    [sym__special_character] = ACTIONS(3193),
    [anon_sym_DQUOTE] = ACTIONS(3195),
    [anon_sym_DOLLAR] = ACTIONS(3197),
    [sym_raw_string] = ACTIONS(6043),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3203),
    [anon_sym_BQUOTE] = ACTIONS(3205),
    [anon_sym_LT_LPAREN] = ACTIONS(3207),
    [anon_sym_GT_LPAREN] = ACTIONS(3207),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6043),
  },
  [2173] = {
    [sym_string] = STATE(2788),
    [sym_simple_expansion] = STATE(2788),
    [sym_string_expansion] = STATE(2788),
    [sym_expansion] = STATE(2788),
    [sym_command_substitution] = STATE(2788),
    [sym_process_substitution] = STATE(2788),
    [sym__special_character] = ACTIONS(6045),
    [anon_sym_DQUOTE] = ACTIONS(3195),
    [anon_sym_DOLLAR] = ACTIONS(3197),
    [sym_raw_string] = ACTIONS(6045),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3203),
    [anon_sym_BQUOTE] = ACTIONS(3205),
    [anon_sym_LT_LPAREN] = ACTIONS(3207),
    [anon_sym_GT_LPAREN] = ACTIONS(3207),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6045),
  },
  [2174] = {
    [aux_sym_concatenation_repeat1] = STATE(2789),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(4810),
    [sym_variable_name] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_done] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1061),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [2175] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [sym_variable_name] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_done] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [2176] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(6047),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [2177] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(6047),
    [anon_sym_DOLLAR] = ACTIONS(6049),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2178] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_done] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1099),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [2179] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [sym_variable_name] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_done] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1103),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [2180] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [sym_variable_name] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_done] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1107),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [2181] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(6051),
    [sym_comment] = ACTIONS(57),
  },
  [2182] = {
    [sym_subscript] = STATE(2795),
    [sym_variable_name] = ACTIONS(6053),
    [anon_sym_DASH] = ACTIONS(6055),
    [anon_sym_DOLLAR] = ACTIONS(6055),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6057),
    [anon_sym_STAR] = ACTIONS(6059),
    [anon_sym_AT] = ACTIONS(6059),
    [anon_sym_QMARK] = ACTIONS(6059),
    [anon_sym_0] = ACTIONS(6057),
    [anon_sym__] = ACTIONS(6057),
  },
  [2183] = {
    [sym_concatenation] = STATE(2798),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2798),
    [anon_sym_RBRACE] = ACTIONS(6061),
    [anon_sym_EQ] = ACTIONS(6063),
    [anon_sym_DASH] = ACTIONS(6063),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6065),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(6067),
    [anon_sym_COLON] = ACTIONS(6063),
    [anon_sym_COLON_QMARK] = ACTIONS(6063),
    [anon_sym_COLON_DASH] = ACTIONS(6063),
    [anon_sym_PERCENT] = ACTIONS(6063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2184] = {
    [sym_concatenation] = STATE(2801),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2801),
    [anon_sym_RBRACE] = ACTIONS(6069),
    [anon_sym_EQ] = ACTIONS(6071),
    [anon_sym_DASH] = ACTIONS(6071),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6073),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(6075),
    [anon_sym_COLON] = ACTIONS(6071),
    [anon_sym_COLON_QMARK] = ACTIONS(6071),
    [anon_sym_COLON_DASH] = ACTIONS(6071),
    [anon_sym_PERCENT] = ACTIONS(6071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2185] = {
    [anon_sym_RPAREN] = ACTIONS(6077),
    [sym_comment] = ACTIONS(57),
  },
  [2186] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(6077),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2187] = {
    [anon_sym_BQUOTE] = ACTIONS(6077),
    [sym_comment] = ACTIONS(57),
  },
  [2188] = {
    [anon_sym_RPAREN] = ACTIONS(6079),
    [sym_comment] = ACTIONS(57),
  },
  [2189] = {
    [sym_variable_assignment] = STATE(2189),
    [sym_subscript] = STATE(1551),
    [sym_concatenation] = STATE(2189),
    [sym_string] = STATE(1546),
    [sym_simple_expansion] = STATE(1546),
    [sym_string_expansion] = STATE(1546),
    [sym_expansion] = STATE(1546),
    [sym_command_substitution] = STATE(1546),
    [sym_process_substitution] = STATE(1546),
    [aux_sym_declaration_command_repeat1] = STATE(2189),
    [aux_sym__literal_repeat1] = STATE(1553),
    [sym__simple_heredoc_body] = ACTIONS(2192),
    [sym__heredoc_body_beginning] = ACTIONS(2192),
    [sym_file_descriptor] = ACTIONS(2192),
    [sym_variable_name] = ACTIONS(6081),
    [anon_sym_SEMI] = ACTIONS(2197),
    [anon_sym_done] = ACTIONS(2197),
    [anon_sym_PIPE] = ACTIONS(2197),
    [anon_sym_SEMI_SEMI] = ACTIONS(2192),
    [anon_sym_PIPE_AMP] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_GT] = ACTIONS(2197),
    [anon_sym_GT_GT] = ACTIONS(2192),
    [anon_sym_AMP_GT] = ACTIONS(2197),
    [anon_sym_AMP_GT_GT] = ACTIONS(2192),
    [anon_sym_LT_AMP] = ACTIONS(2192),
    [anon_sym_GT_AMP] = ACTIONS(2192),
    [anon_sym_LT_LT] = ACTIONS(2197),
    [anon_sym_LT_LT_DASH] = ACTIONS(2192),
    [anon_sym_LT_LT_LT] = ACTIONS(2192),
    [sym__special_character] = ACTIONS(6084),
    [anon_sym_DQUOTE] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(6090),
    [sym_raw_string] = ACTIONS(6093),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6096),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6099),
    [anon_sym_BQUOTE] = ACTIONS(6102),
    [anon_sym_LT_LPAREN] = ACTIONS(6105),
    [anon_sym_GT_LPAREN] = ACTIONS(6105),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6108),
    [sym_word] = ACTIONS(6111),
    [anon_sym_LF] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2197),
  },
  [2190] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_done] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [2191] = {
    [aux_sym__literal_repeat1] = STATE(2191),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym_variable_name] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_done] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(6114),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1373),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [2192] = {
    [sym_string] = STATE(2804),
    [sym_simple_expansion] = STATE(2804),
    [sym_string_expansion] = STATE(2804),
    [sym_expansion] = STATE(2804),
    [sym_command_substitution] = STATE(2804),
    [sym_process_substitution] = STATE(2804),
    [sym__special_character] = ACTIONS(6117),
    [anon_sym_DQUOTE] = ACTIONS(3215),
    [anon_sym_DOLLAR] = ACTIONS(3217),
    [sym_raw_string] = ACTIONS(6117),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3221),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3223),
    [anon_sym_BQUOTE] = ACTIONS(3225),
    [anon_sym_LT_LPAREN] = ACTIONS(3227),
    [anon_sym_GT_LPAREN] = ACTIONS(3227),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6117),
  },
  [2193] = {
    [aux_sym_concatenation_repeat1] = STATE(2805),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(4838),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_done] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1061),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [2194] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_done] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [2195] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(6119),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [2196] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(6119),
    [anon_sym_DOLLAR] = ACTIONS(6121),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2197] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_done] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1099),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [2198] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_done] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1103),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [2199] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_done] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1107),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [2200] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(6123),
    [sym_comment] = ACTIONS(57),
  },
  [2201] = {
    [sym_subscript] = STATE(2811),
    [sym_variable_name] = ACTIONS(6125),
    [anon_sym_DASH] = ACTIONS(6127),
    [anon_sym_DOLLAR] = ACTIONS(6127),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_AT] = ACTIONS(6131),
    [anon_sym_QMARK] = ACTIONS(6131),
    [anon_sym_0] = ACTIONS(6129),
    [anon_sym__] = ACTIONS(6129),
  },
  [2202] = {
    [sym_concatenation] = STATE(2814),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2814),
    [anon_sym_RBRACE] = ACTIONS(6133),
    [anon_sym_EQ] = ACTIONS(6135),
    [anon_sym_DASH] = ACTIONS(6135),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6137),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(6139),
    [anon_sym_COLON] = ACTIONS(6135),
    [anon_sym_COLON_QMARK] = ACTIONS(6135),
    [anon_sym_COLON_DASH] = ACTIONS(6135),
    [anon_sym_PERCENT] = ACTIONS(6135),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2203] = {
    [sym_concatenation] = STATE(2817),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2817),
    [anon_sym_RBRACE] = ACTIONS(6141),
    [anon_sym_EQ] = ACTIONS(6143),
    [anon_sym_DASH] = ACTIONS(6143),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(6147),
    [anon_sym_COLON] = ACTIONS(6143),
    [anon_sym_COLON_QMARK] = ACTIONS(6143),
    [anon_sym_COLON_DASH] = ACTIONS(6143),
    [anon_sym_PERCENT] = ACTIONS(6143),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2204] = {
    [anon_sym_RPAREN] = ACTIONS(6149),
    [sym_comment] = ACTIONS(57),
  },
  [2205] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(6149),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2206] = {
    [anon_sym_BQUOTE] = ACTIONS(6149),
    [sym_comment] = ACTIONS(57),
  },
  [2207] = {
    [anon_sym_RPAREN] = ACTIONS(6151),
    [sym_comment] = ACTIONS(57),
  },
  [2208] = {
    [sym_concatenation] = STATE(2208),
    [sym_string] = STATE(1557),
    [sym_simple_expansion] = STATE(1557),
    [sym_string_expansion] = STATE(1557),
    [sym_expansion] = STATE(1557),
    [sym_command_substitution] = STATE(1557),
    [sym_process_substitution] = STATE(1557),
    [aux_sym_unset_command_repeat1] = STATE(2208),
    [aux_sym__literal_repeat1] = STATE(1563),
    [sym__simple_heredoc_body] = ACTIONS(2268),
    [sym__heredoc_body_beginning] = ACTIONS(2268),
    [sym_file_descriptor] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_done] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2270),
    [anon_sym_SEMI_SEMI] = ACTIONS(2268),
    [anon_sym_PIPE_AMP] = ACTIONS(2268),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [anon_sym_PIPE_PIPE] = ACTIONS(2268),
    [anon_sym_LT] = ACTIONS(2270),
    [anon_sym_GT] = ACTIONS(2270),
    [anon_sym_GT_GT] = ACTIONS(2268),
    [anon_sym_AMP_GT] = ACTIONS(2270),
    [anon_sym_AMP_GT_GT] = ACTIONS(2268),
    [anon_sym_LT_AMP] = ACTIONS(2268),
    [anon_sym_GT_AMP] = ACTIONS(2268),
    [anon_sym_LT_LT] = ACTIONS(2270),
    [anon_sym_LT_LT_DASH] = ACTIONS(2268),
    [anon_sym_LT_LT_LT] = ACTIONS(2268),
    [sym__special_character] = ACTIONS(6153),
    [anon_sym_DQUOTE] = ACTIONS(6156),
    [anon_sym_DOLLAR] = ACTIONS(6159),
    [sym_raw_string] = ACTIONS(6162),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6165),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6168),
    [anon_sym_BQUOTE] = ACTIONS(6171),
    [anon_sym_LT_LPAREN] = ACTIONS(6174),
    [anon_sym_GT_LPAREN] = ACTIONS(6174),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6177),
    [sym_word] = ACTIONS(6180),
    [anon_sym_LF] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2270),
  },
  [2209] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_done] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [2210] = {
    [aux_sym__literal_repeat1] = STATE(2210),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_done] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(6183),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1373),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [2211] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_done] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2346),
    [anon_sym_EQ_EQ] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2212] = {
    [aux_sym_concatenation_repeat1] = STATE(2212),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(6186),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_done] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2346),
    [anon_sym_EQ_EQ] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2213] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_done] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_EQ_TILDE] = ACTIONS(2353),
    [anon_sym_EQ_EQ] = ACTIONS(2353),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [2214] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(6189),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [2215] = {
    [sym_concatenation] = STATE(2823),
    [sym_string] = STATE(2822),
    [sym_simple_expansion] = STATE(2822),
    [sym_string_expansion] = STATE(2822),
    [sym_expansion] = STATE(2822),
    [sym_command_substitution] = STATE(2822),
    [sym_process_substitution] = STATE(2822),
    [aux_sym__literal_repeat1] = STATE(2824),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(6193),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6193),
  },
  [2216] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(6195),
    [sym_comment] = ACTIONS(57),
  },
  [2217] = {
    [sym_concatenation] = STATE(2828),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2828),
    [anon_sym_RBRACE] = ACTIONS(6197),
    [anon_sym_EQ] = ACTIONS(6199),
    [anon_sym_DASH] = ACTIONS(6199),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(6203),
    [anon_sym_COLON] = ACTIONS(6199),
    [anon_sym_COLON_QMARK] = ACTIONS(6199),
    [anon_sym_COLON_DASH] = ACTIONS(6199),
    [anon_sym_PERCENT] = ACTIONS(6199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2218] = {
    [sym_concatenation] = STATE(2830),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2830),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_EQ] = ACTIONS(6205),
    [anon_sym_DASH] = ACTIONS(6205),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(6209),
    [anon_sym_COLON] = ACTIONS(6205),
    [anon_sym_COLON_QMARK] = ACTIONS(6205),
    [anon_sym_COLON_DASH] = ACTIONS(6205),
    [anon_sym_PERCENT] = ACTIONS(6205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2219] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_done] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_EQ_TILDE] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2444),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [2220] = {
    [sym_concatenation] = STATE(2833),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2833),
    [sym_regex] = ACTIONS(6211),
    [anon_sym_RBRACE] = ACTIONS(6213),
    [anon_sym_EQ] = ACTIONS(6215),
    [anon_sym_DASH] = ACTIONS(6215),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6217),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6215),
    [anon_sym_COLON_QMARK] = ACTIONS(6215),
    [anon_sym_COLON_DASH] = ACTIONS(6215),
    [anon_sym_PERCENT] = ACTIONS(6215),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2221] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6213),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2222] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_done] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_EQ_TILDE] = ACTIONS(2494),
    [anon_sym_EQ_EQ] = ACTIONS(2494),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [2223] = {
    [sym_concatenation] = STATE(2830),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2830),
    [sym_regex] = ACTIONS(6219),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_EQ] = ACTIONS(6205),
    [anon_sym_DASH] = ACTIONS(6205),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6207),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6205),
    [anon_sym_COLON_QMARK] = ACTIONS(6205),
    [anon_sym_COLON_DASH] = ACTIONS(6205),
    [anon_sym_PERCENT] = ACTIONS(6205),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2224] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6191),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2225] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_done] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_EQ_TILDE] = ACTIONS(2502),
    [anon_sym_EQ_EQ] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [2226] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_done] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_EQ_TILDE] = ACTIONS(2536),
    [anon_sym_EQ_EQ] = ACTIONS(2536),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [2227] = {
    [sym_concatenation] = STATE(1318),
    [sym_string] = STATE(2835),
    [sym_simple_expansion] = STATE(2835),
    [sym_string_expansion] = STATE(2835),
    [sym_expansion] = STATE(2835),
    [sym_command_substitution] = STATE(2835),
    [sym_process_substitution] = STATE(2835),
    [aux_sym__literal_repeat1] = STATE(2836),
    [sym__special_character] = ACTIONS(4912),
    [anon_sym_DQUOTE] = ACTIONS(4914),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(6221),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4922),
    [anon_sym_BQUOTE] = ACTIONS(4924),
    [anon_sym_LT_LPAREN] = ACTIONS(4926),
    [anon_sym_GT_LPAREN] = ACTIONS(4926),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6221),
  },
  [2228] = {
    [sym_file_redirect] = STATE(1588),
    [sym_heredoc_redirect] = STATE(1588),
    [sym_herestring_redirect] = STATE(1588),
    [aux_sym_redirected_statement_repeat1] = STATE(1588),
    [sym__simple_heredoc_body] = ACTIONS(2564),
    [sym__heredoc_body_beginning] = ACTIONS(2564),
    [sym_file_descriptor] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_done] = ACTIONS(2564),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT] = ACTIONS(2566),
    [anon_sym_AMP_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_AMP] = ACTIONS(2564),
    [anon_sym_GT_AMP] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_LT_LT_DASH] = ACTIONS(2564),
    [anon_sym_LT_LT_LT] = ACTIONS(2564),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2566),
  },
  [2229] = {
    [sym_file_redirect] = STATE(1588),
    [sym_heredoc_redirect] = STATE(1588),
    [sym_herestring_redirect] = STATE(1588),
    [aux_sym_redirected_statement_repeat1] = STATE(1588),
    [sym__simple_heredoc_body] = ACTIONS(2564),
    [sym__heredoc_body_beginning] = ACTIONS(2564),
    [sym_file_descriptor] = ACTIONS(2564),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_done] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT] = ACTIONS(2566),
    [anon_sym_AMP_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_AMP] = ACTIONS(2564),
    [anon_sym_GT_AMP] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_LT_LT_DASH] = ACTIONS(2564),
    [anon_sym_LT_LT_LT] = ACTIONS(2564),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2566),
  },
  [2230] = {
    [sym_file_redirect] = STATE(1588),
    [sym_heredoc_redirect] = STATE(1588),
    [sym_herestring_redirect] = STATE(1588),
    [aux_sym_redirected_statement_repeat1] = STATE(1588),
    [sym__simple_heredoc_body] = ACTIONS(2568),
    [sym__heredoc_body_beginning] = ACTIONS(2568),
    [sym_file_descriptor] = ACTIONS(2568),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_done] = ACTIONS(2568),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_SEMI_SEMI] = ACTIONS(2568),
    [anon_sym_PIPE_AMP] = ACTIONS(3267),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_GT] = ACTIONS(2570),
    [anon_sym_GT_GT] = ACTIONS(2568),
    [anon_sym_AMP_GT] = ACTIONS(2570),
    [anon_sym_AMP_GT_GT] = ACTIONS(2568),
    [anon_sym_LT_AMP] = ACTIONS(2568),
    [anon_sym_GT_AMP] = ACTIONS(2568),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_LT_LT_DASH] = ACTIONS(2568),
    [anon_sym_LT_LT_LT] = ACTIONS(2568),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2570),
  },
  [2231] = {
    [sym_file_redirect] = STATE(1588),
    [sym_heredoc_redirect] = STATE(1588),
    [sym_herestring_redirect] = STATE(1588),
    [aux_sym_redirected_statement_repeat1] = STATE(1588),
    [sym__simple_heredoc_body] = ACTIONS(2568),
    [sym__heredoc_body_beginning] = ACTIONS(2568),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_done] = ACTIONS(2570),
    [anon_sym_PIPE] = ACTIONS(3263),
    [anon_sym_SEMI_SEMI] = ACTIONS(2568),
    [anon_sym_PIPE_AMP] = ACTIONS(3267),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_LT_LT_DASH] = ACTIONS(2568),
    [anon_sym_LT_LT_LT] = ACTIONS(2568),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2570),
  },
  [2232] = {
    [aux_sym_concatenation_repeat1] = STATE(2838),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_done] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [2233] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(2841),
    [anon_sym_DQUOTE] = ACTIONS(6225),
    [anon_sym_DOLLAR] = ACTIONS(6227),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2234] = {
    [sym_string] = STATE(2843),
    [anon_sym_DASH] = ACTIONS(6229),
    [anon_sym_DQUOTE] = ACTIONS(4914),
    [anon_sym_DOLLAR] = ACTIONS(6229),
    [sym_raw_string] = ACTIONS(6231),
    [anon_sym_POUND] = ACTIONS(6229),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6233),
    [anon_sym_STAR] = ACTIONS(6235),
    [anon_sym_AT] = ACTIONS(6235),
    [anon_sym_QMARK] = ACTIONS(6235),
    [anon_sym_0] = ACTIONS(6233),
    [anon_sym__] = ACTIONS(6233),
  },
  [2235] = {
    [aux_sym_concatenation_repeat1] = STATE(2838),
    [sym__simple_heredoc_body] = ACTIONS(1037),
    [sym__heredoc_body_beginning] = ACTIONS(1037),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_done] = ACTIONS(1037),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [2236] = {
    [sym_subscript] = STATE(2848),
    [sym_variable_name] = ACTIONS(6237),
    [anon_sym_BANG] = ACTIONS(6239),
    [anon_sym_DASH] = ACTIONS(6241),
    [anon_sym_DOLLAR] = ACTIONS(6241),
    [anon_sym_POUND] = ACTIONS(6239),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6243),
    [anon_sym_STAR] = ACTIONS(6245),
    [anon_sym_AT] = ACTIONS(6245),
    [anon_sym_QMARK] = ACTIONS(6245),
    [anon_sym_0] = ACTIONS(6243),
    [anon_sym__] = ACTIONS(6243),
  },
  [2237] = {
    [sym__statements] = STATE(2849),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(2850),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2238] = {
    [sym__statements] = STATE(2851),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [2239] = {
    [sym__statements] = STATE(2852),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2240] = {
    [aux_sym__literal_repeat1] = STATE(2854),
    [sym__simple_heredoc_body] = ACTIONS(1051),
    [sym__heredoc_body_beginning] = ACTIONS(1051),
    [sym_file_descriptor] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_done] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_LT_LT_DASH] = ACTIONS(1051),
    [anon_sym_LT_LT_LT] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(6247),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1051),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [2241] = {
    [aux_sym_concatenation_repeat1] = STATE(2838),
    [sym__simple_heredoc_body] = ACTIONS(2576),
    [sym__heredoc_body_beginning] = ACTIONS(2576),
    [sym_file_descriptor] = ACTIONS(2576),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym_done] = ACTIONS(2576),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI_SEMI] = ACTIONS(2576),
    [anon_sym_PIPE_AMP] = ACTIONS(2576),
    [anon_sym_AMP_AMP] = ACTIONS(2576),
    [anon_sym_PIPE_PIPE] = ACTIONS(2576),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_GT] = ACTIONS(2576),
    [anon_sym_AMP_GT] = ACTIONS(2578),
    [anon_sym_AMP_GT_GT] = ACTIONS(2576),
    [anon_sym_LT_AMP] = ACTIONS(2576),
    [anon_sym_GT_AMP] = ACTIONS(2576),
    [anon_sym_LT_LT] = ACTIONS(2578),
    [anon_sym_LT_LT_DASH] = ACTIONS(2576),
    [anon_sym_LT_LT_LT] = ACTIONS(2576),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2576),
    [anon_sym_AMP] = ACTIONS(2578),
  },
  [2242] = {
    [aux_sym__literal_repeat1] = STATE(2854),
    [sym__simple_heredoc_body] = ACTIONS(2580),
    [sym__heredoc_body_beginning] = ACTIONS(2580),
    [sym_file_descriptor] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym_done] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_SEMI_SEMI] = ACTIONS(2580),
    [anon_sym_PIPE_AMP] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_AMP_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_AMP] = ACTIONS(2580),
    [anon_sym_GT_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2582),
    [anon_sym_LT_LT_DASH] = ACTIONS(2580),
    [anon_sym_LT_LT_LT] = ACTIONS(2580),
    [sym__special_character] = ACTIONS(6247),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2580),
    [anon_sym_AMP] = ACTIONS(2582),
  },
  [2243] = {
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(2584),
    [anon_sym_for] = ACTIONS(2588),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_done] = ACTIONS(6249),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_case] = ACTIONS(2588),
    [anon_sym_function] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2584),
    [anon_sym_declare] = ACTIONS(2588),
    [anon_sym_typeset] = ACTIONS(2588),
    [anon_sym_export] = ACTIONS(2588),
    [anon_sym_readonly] = ACTIONS(2588),
    [anon_sym_local] = ACTIONS(2588),
    [anon_sym_unset] = ACTIONS(2588),
    [anon_sym_unsetenv] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [sym__special_character] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2584),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2584),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [anon_sym_LT_LPAREN] = ACTIONS(2584),
    [anon_sym_GT_LPAREN] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
  },
  [2244] = {
    [sym_file_redirect] = STATE(2244),
    [sym_heredoc_redirect] = STATE(2244),
    [sym_herestring_redirect] = STATE(2244),
    [aux_sym_redirected_statement_repeat1] = STATE(2244),
    [sym__simple_heredoc_body] = ACTIONS(2590),
    [sym__heredoc_body_beginning] = ACTIONS(2590),
    [sym_file_descriptor] = ACTIONS(6251),
    [anon_sym_SEMI] = ACTIONS(2595),
    [anon_sym_done] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(2595),
    [anon_sym_SEMI_SEMI] = ACTIONS(2590),
    [anon_sym_PIPE_AMP] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(6254),
    [anon_sym_GT] = ACTIONS(6254),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_AMP_GT] = ACTIONS(6254),
    [anon_sym_AMP_GT_GT] = ACTIONS(6257),
    [anon_sym_LT_AMP] = ACTIONS(6257),
    [anon_sym_GT_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_LT_LT_DASH] = ACTIONS(2606),
    [anon_sym_LT_LT_LT] = ACTIONS(6260),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2595),
  },
  [2245] = {
    [sym__simple_heredoc_body] = ACTIONS(2612),
    [sym__heredoc_body_beginning] = ACTIONS(2612),
    [sym_file_descriptor] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_done] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(2614),
    [anon_sym_EQ_EQ] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2612),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2612),
    [anon_sym_BQUOTE] = ACTIONS(2612),
    [anon_sym_LT_LPAREN] = ACTIONS(2612),
    [anon_sym_GT_LPAREN] = ACTIONS(2612),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2614),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [2246] = {
    [aux_sym_concatenation_repeat1] = STATE(1565),
    [sym__simple_heredoc_body] = ACTIONS(2612),
    [sym__heredoc_body_beginning] = ACTIONS(2612),
    [sym_file_descriptor] = ACTIONS(2612),
    [sym__concat] = ACTIONS(3233),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_done] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(2614),
    [anon_sym_EQ_EQ] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2612),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2612),
    [anon_sym_BQUOTE] = ACTIONS(2612),
    [anon_sym_LT_LPAREN] = ACTIONS(2612),
    [anon_sym_GT_LPAREN] = ACTIONS(2612),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2614),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [2247] = {
    [aux_sym__literal_repeat1] = STATE(1597),
    [sym__simple_heredoc_body] = ACTIONS(2616),
    [sym__heredoc_body_beginning] = ACTIONS(2616),
    [sym_file_descriptor] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_done] = ACTIONS(2618),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_SEMI_SEMI] = ACTIONS(2616),
    [anon_sym_PIPE_AMP] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_EQ_TILDE] = ACTIONS(2618),
    [anon_sym_EQ_EQ] = ACTIONS(2618),
    [anon_sym_LT] = ACTIONS(2618),
    [anon_sym_GT] = ACTIONS(2618),
    [anon_sym_GT_GT] = ACTIONS(2616),
    [anon_sym_AMP_GT] = ACTIONS(2618),
    [anon_sym_AMP_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_AMP] = ACTIONS(2616),
    [anon_sym_GT_AMP] = ACTIONS(2616),
    [anon_sym_LT_LT] = ACTIONS(2618),
    [anon_sym_LT_LT_DASH] = ACTIONS(2616),
    [anon_sym_LT_LT_LT] = ACTIONS(2616),
    [sym__special_character] = ACTIONS(3287),
    [anon_sym_DQUOTE] = ACTIONS(2616),
    [anon_sym_DOLLAR] = ACTIONS(2618),
    [sym_raw_string] = ACTIONS(2616),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2616),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2616),
    [anon_sym_BQUOTE] = ACTIONS(2616),
    [anon_sym_LT_LPAREN] = ACTIONS(2616),
    [anon_sym_GT_LPAREN] = ACTIONS(2616),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2618),
    [anon_sym_LF] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2618),
  },
  [2248] = {
    [sym_concatenation] = STATE(2248),
    [sym_string] = STATE(1590),
    [sym_simple_expansion] = STATE(1590),
    [sym_string_expansion] = STATE(1590),
    [sym_expansion] = STATE(1590),
    [sym_command_substitution] = STATE(1590),
    [sym_process_substitution] = STATE(1590),
    [aux_sym_command_repeat2] = STATE(2248),
    [aux_sym__literal_repeat1] = STATE(1592),
    [sym__simple_heredoc_body] = ACTIONS(2612),
    [sym__heredoc_body_beginning] = ACTIONS(2612),
    [sym_file_descriptor] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_done] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(6263),
    [anon_sym_EQ_EQ] = ACTIONS(6263),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(6266),
    [anon_sym_DQUOTE] = ACTIONS(6269),
    [anon_sym_DOLLAR] = ACTIONS(6272),
    [sym_raw_string] = ACTIONS(6275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6278),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6281),
    [anon_sym_BQUOTE] = ACTIONS(6284),
    [anon_sym_LT_LPAREN] = ACTIONS(6287),
    [anon_sym_GT_LPAREN] = ACTIONS(6287),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6290),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [2249] = {
    [sym_file_descriptor] = ACTIONS(1235),
    [sym_variable_name] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1239),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1239),
    [anon_sym_done] = ACTIONS(6249),
    [anon_sym_if] = ACTIONS(1239),
    [anon_sym_case] = ACTIONS(1239),
    [anon_sym_function] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1239),
    [anon_sym_typeset] = ACTIONS(1239),
    [anon_sym_export] = ACTIONS(1239),
    [anon_sym_readonly] = ACTIONS(1239),
    [anon_sym_local] = ACTIONS(1239),
    [anon_sym_unset] = ACTIONS(1239),
    [anon_sym_unsetenv] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_AMP_GT] = ACTIONS(1239),
    [anon_sym_AMP_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_AMP] = ACTIONS(1235),
    [anon_sym_GT_AMP] = ACTIONS(1235),
    [sym__special_character] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_DOLLAR] = ACTIONS(1239),
    [sym_raw_string] = ACTIONS(1235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1235),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1235),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [anon_sym_LT_LPAREN] = ACTIONS(1235),
    [anon_sym_GT_LPAREN] = ACTIONS(1235),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1239),
  },
  [2250] = {
    [anon_sym_SEMI] = ACTIONS(6293),
    [anon_sym_done] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(6295),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6295),
    [anon_sym_AMP] = ACTIONS(6295),
  },
  [2251] = {
    [sym_concatenation] = STATE(2248),
    [sym_string] = STATE(1590),
    [sym_simple_expansion] = STATE(1590),
    [sym_string_expansion] = STATE(1590),
    [sym_expansion] = STATE(1590),
    [sym_command_substitution] = STATE(1590),
    [sym_process_substitution] = STATE(1590),
    [aux_sym_command_repeat2] = STATE(2248),
    [aux_sym__literal_repeat1] = STATE(1592),
    [sym__simple_heredoc_body] = ACTIONS(2676),
    [sym__heredoc_body_beginning] = ACTIONS(2676),
    [sym_file_descriptor] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym_done] = ACTIONS(2678),
    [anon_sym_PIPE] = ACTIONS(2678),
    [anon_sym_SEMI_SEMI] = ACTIONS(2676),
    [anon_sym_PIPE_AMP] = ACTIONS(2676),
    [anon_sym_AMP_AMP] = ACTIONS(2676),
    [anon_sym_PIPE_PIPE] = ACTIONS(2676),
    [anon_sym_EQ_TILDE] = ACTIONS(3277),
    [anon_sym_EQ_EQ] = ACTIONS(3277),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_GT] = ACTIONS(2678),
    [anon_sym_GT_GT] = ACTIONS(2676),
    [anon_sym_AMP_GT] = ACTIONS(2678),
    [anon_sym_AMP_GT_GT] = ACTIONS(2676),
    [anon_sym_LT_AMP] = ACTIONS(2676),
    [anon_sym_GT_AMP] = ACTIONS(2676),
    [anon_sym_LT_LT] = ACTIONS(2678),
    [anon_sym_LT_LT_DASH] = ACTIONS(2676),
    [anon_sym_LT_LT_LT] = ACTIONS(2676),
    [sym__special_character] = ACTIONS(3279),
    [anon_sym_DQUOTE] = ACTIONS(1757),
    [anon_sym_DOLLAR] = ACTIONS(1759),
    [sym_raw_string] = ACTIONS(3281),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1763),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1765),
    [anon_sym_BQUOTE] = ACTIONS(1767),
    [anon_sym_LT_LPAREN] = ACTIONS(1769),
    [anon_sym_GT_LPAREN] = ACTIONS(1769),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3283),
    [anon_sym_LF] = ACTIONS(2676),
    [anon_sym_AMP] = ACTIONS(2678),
  },
  [2252] = {
    [aux_sym_concatenation_repeat1] = STATE(2252),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2253] = {
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_fi] = ACTIONS(1400),
    [anon_sym_elif] = ACTIONS(1400),
    [anon_sym_else] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [2254] = {
    [sym_concatenation] = STATE(2857),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(2857),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(6297),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [2255] = {
    [aux_sym_concatenation_repeat1] = STATE(2859),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(6299),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_fi] = ACTIONS(329),
    [anon_sym_elif] = ACTIONS(329),
    [anon_sym_else] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [2256] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(2862),
    [anon_sym_DQUOTE] = ACTIONS(6301),
    [anon_sym_DOLLAR] = ACTIONS(6303),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2257] = {
    [sym_string] = STATE(2864),
    [anon_sym_DASH] = ACTIONS(6305),
    [anon_sym_DQUOTE] = ACTIONS(4951),
    [anon_sym_DOLLAR] = ACTIONS(6305),
    [sym_raw_string] = ACTIONS(6307),
    [anon_sym_POUND] = ACTIONS(6305),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6309),
    [anon_sym_STAR] = ACTIONS(6311),
    [anon_sym_AT] = ACTIONS(6311),
    [anon_sym_QMARK] = ACTIONS(6311),
    [anon_sym_0] = ACTIONS(6309),
    [anon_sym__] = ACTIONS(6309),
  },
  [2258] = {
    [aux_sym_concatenation_repeat1] = STATE(2859),
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym__concat] = ACTIONS(6299),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_fi] = ACTIONS(1400),
    [anon_sym_elif] = ACTIONS(1400),
    [anon_sym_else] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [2259] = {
    [sym_subscript] = STATE(2869),
    [sym_variable_name] = ACTIONS(6313),
    [anon_sym_BANG] = ACTIONS(6315),
    [anon_sym_DASH] = ACTIONS(6317),
    [anon_sym_DOLLAR] = ACTIONS(6317),
    [anon_sym_POUND] = ACTIONS(6315),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6319),
    [anon_sym_STAR] = ACTIONS(6321),
    [anon_sym_AT] = ACTIONS(6321),
    [anon_sym_QMARK] = ACTIONS(6321),
    [anon_sym_0] = ACTIONS(6319),
    [anon_sym__] = ACTIONS(6319),
  },
  [2260] = {
    [sym__statements] = STATE(2870),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(2871),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2261] = {
    [sym__statements] = STATE(2872),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [2262] = {
    [sym__statements] = STATE(2873),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2263] = {
    [aux_sym__literal_repeat1] = STATE(2875),
    [sym__simple_heredoc_body] = ACTIONS(1444),
    [sym__heredoc_body_beginning] = ACTIONS(1444),
    [sym_file_descriptor] = ACTIONS(1444),
    [sym_variable_name] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_fi] = ACTIONS(1446),
    [anon_sym_elif] = ACTIONS(1446),
    [anon_sym_else] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1446),
    [anon_sym_SEMI_SEMI] = ACTIONS(1444),
    [anon_sym_PIPE_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1446),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_AMP_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT_GT] = ACTIONS(1444),
    [anon_sym_LT_AMP] = ACTIONS(1444),
    [anon_sym_GT_AMP] = ACTIONS(1444),
    [anon_sym_LT_LT] = ACTIONS(1446),
    [anon_sym_LT_LT_DASH] = ACTIONS(1444),
    [anon_sym_LT_LT_LT] = ACTIONS(1444),
    [sym__special_character] = ACTIONS(6323),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [anon_sym_DOLLAR] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1444),
    [anon_sym_BQUOTE] = ACTIONS(1444),
    [anon_sym_LT_LPAREN] = ACTIONS(1444),
    [anon_sym_GT_LPAREN] = ACTIONS(1444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1446),
    [anon_sym_LF] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1446),
  },
  [2264] = {
    [sym__statements] = STATE(2876),
    [sym_redirected_statement] = STATE(975),
    [sym_for_statement] = STATE(975),
    [sym_c_style_for_statement] = STATE(975),
    [sym_while_statement] = STATE(975),
    [sym_if_statement] = STATE(975),
    [sym_case_statement] = STATE(975),
    [sym_function_definition] = STATE(975),
    [sym_compound_statement] = STATE(975),
    [sym_subshell] = STATE(975),
    [sym_pipeline] = STATE(975),
    [sym_list] = STATE(975),
    [sym_negated_command] = STATE(975),
    [sym_test_command] = STATE(975),
    [sym_declaration_command] = STATE(975),
    [sym_unset_command] = STATE(975),
    [sym_command] = STATE(975),
    [sym_command_name] = STATE(977),
    [sym_variable_assignment] = STATE(978),
    [sym_subscript] = STATE(979),
    [sym_file_redirect] = STATE(983),
    [sym_concatenation] = STATE(980),
    [sym_string] = STATE(968),
    [sym_simple_expansion] = STATE(968),
    [sym_string_expansion] = STATE(968),
    [sym_expansion] = STATE(968),
    [sym_command_substitution] = STATE(968),
    [sym_process_substitution] = STATE(968),
    [aux_sym__statements_repeat1] = STATE(981),
    [aux_sym_command_repeat1] = STATE(983),
    [aux_sym__literal_repeat1] = STATE(984),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(1798),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_fi] = ACTIONS(6325),
    [anon_sym_elif] = ACTIONS(6325),
    [anon_sym_else] = ACTIONS(6325),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1806),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(1808),
    [anon_sym_typeset] = ACTIONS(1808),
    [anon_sym_export] = ACTIONS(1808),
    [anon_sym_readonly] = ACTIONS(1808),
    [anon_sym_local] = ACTIONS(1808),
    [anon_sym_unset] = ACTIONS(1810),
    [anon_sym_unsetenv] = ACTIONS(1810),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(1812),
    [anon_sym_DQUOTE] = ACTIONS(1814),
    [anon_sym_DOLLAR] = ACTIONS(1816),
    [sym_raw_string] = ACTIONS(1818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1822),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1828),
  },
  [2265] = {
    [sym_concatenation] = STATE(2877),
    [sym_string] = STATE(2882),
    [sym_array] = STATE(2877),
    [sym_simple_expansion] = STATE(2882),
    [sym_string_expansion] = STATE(2882),
    [sym_expansion] = STATE(2882),
    [sym_command_substitution] = STATE(2882),
    [sym_process_substitution] = STATE(2882),
    [aux_sym__literal_repeat1] = STATE(2887),
    [sym__empty_value] = ACTIONS(6327),
    [anon_sym_LPAREN] = ACTIONS(6329),
    [sym__special_character] = ACTIONS(6331),
    [anon_sym_DQUOTE] = ACTIONS(6333),
    [anon_sym_DOLLAR] = ACTIONS(6335),
    [sym_raw_string] = ACTIONS(6337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6341),
    [anon_sym_BQUOTE] = ACTIONS(6343),
    [anon_sym_LT_LPAREN] = ACTIONS(6345),
    [anon_sym_GT_LPAREN] = ACTIONS(6345),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6337),
  },
  [2266] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(6347),
    [anon_sym_PLUS_EQ] = ACTIONS(6347),
    [sym_comment] = ACTIONS(57),
  },
  [2267] = {
    [aux_sym_concatenation_repeat1] = STATE(2890),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(6349),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_fi] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [2268] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(2893),
    [anon_sym_DQUOTE] = ACTIONS(6351),
    [anon_sym_DOLLAR] = ACTIONS(6353),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2269] = {
    [sym_string] = STATE(2895),
    [anon_sym_DASH] = ACTIONS(6355),
    [anon_sym_DQUOTE] = ACTIONS(4973),
    [anon_sym_DOLLAR] = ACTIONS(6355),
    [sym_raw_string] = ACTIONS(6357),
    [anon_sym_POUND] = ACTIONS(6355),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6359),
    [anon_sym_STAR] = ACTIONS(6361),
    [anon_sym_AT] = ACTIONS(6361),
    [anon_sym_QMARK] = ACTIONS(6361),
    [anon_sym_0] = ACTIONS(6359),
    [anon_sym__] = ACTIONS(6359),
  },
  [2270] = {
    [aux_sym_concatenation_repeat1] = STATE(2890),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(6349),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_fi] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [sym__special_character] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [2271] = {
    [sym_subscript] = STATE(2900),
    [sym_variable_name] = ACTIONS(6363),
    [anon_sym_BANG] = ACTIONS(6365),
    [anon_sym_DASH] = ACTIONS(6367),
    [anon_sym_DOLLAR] = ACTIONS(6367),
    [anon_sym_POUND] = ACTIONS(6365),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6369),
    [anon_sym_STAR] = ACTIONS(6371),
    [anon_sym_AT] = ACTIONS(6371),
    [anon_sym_QMARK] = ACTIONS(6371),
    [anon_sym_0] = ACTIONS(6369),
    [anon_sym__] = ACTIONS(6369),
  },
  [2272] = {
    [sym__statements] = STATE(2901),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(2902),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2273] = {
    [sym__statements] = STATE(2903),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [2274] = {
    [sym__statements] = STATE(2904),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2275] = {
    [anon_sym_EQ] = ACTIONS(6347),
    [anon_sym_PLUS_EQ] = ACTIONS(6347),
    [sym_comment] = ACTIONS(57),
  },
  [2276] = {
    [sym_variable_assignment] = STATE(2905),
    [sym_subscript] = STATE(2275),
    [sym_concatenation] = STATE(2905),
    [sym_string] = STATE(2270),
    [sym_simple_expansion] = STATE(2270),
    [sym_string_expansion] = STATE(2270),
    [sym_expansion] = STATE(2270),
    [sym_command_substitution] = STATE(2270),
    [sym_process_substitution] = STATE(2270),
    [aux_sym_declaration_command_repeat1] = STATE(2905),
    [aux_sym__literal_repeat1] = STATE(2277),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(4969),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_fi] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [sym__special_character] = ACTIONS(4971),
    [anon_sym_DQUOTE] = ACTIONS(4973),
    [anon_sym_DOLLAR] = ACTIONS(4975),
    [sym_raw_string] = ACTIONS(4977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4979),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4981),
    [anon_sym_BQUOTE] = ACTIONS(4983),
    [anon_sym_LT_LPAREN] = ACTIONS(4985),
    [anon_sym_GT_LPAREN] = ACTIONS(4985),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6373),
    [sym_word] = ACTIONS(4989),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [2277] = {
    [aux_sym__literal_repeat1] = STATE(2907),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym_variable_name] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_fi] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(979),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(979),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [sym__special_character] = ACTIONS(6375),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(979),
    [sym_word] = ACTIONS(979),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
  },
  [2278] = {
    [aux_sym_concatenation_repeat1] = STATE(2909),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(6377),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_fi] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [2279] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(2912),
    [anon_sym_DQUOTE] = ACTIONS(6379),
    [anon_sym_DOLLAR] = ACTIONS(6381),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2280] = {
    [sym_string] = STATE(2914),
    [anon_sym_DASH] = ACTIONS(6383),
    [anon_sym_DQUOTE] = ACTIONS(4993),
    [anon_sym_DOLLAR] = ACTIONS(6383),
    [sym_raw_string] = ACTIONS(6385),
    [anon_sym_POUND] = ACTIONS(6383),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6387),
    [anon_sym_STAR] = ACTIONS(6389),
    [anon_sym_AT] = ACTIONS(6389),
    [anon_sym_QMARK] = ACTIONS(6389),
    [anon_sym_0] = ACTIONS(6387),
    [anon_sym__] = ACTIONS(6387),
  },
  [2281] = {
    [aux_sym_concatenation_repeat1] = STATE(2909),
    [sym__simple_heredoc_body] = ACTIONS(997),
    [sym__heredoc_body_beginning] = ACTIONS(997),
    [sym_file_descriptor] = ACTIONS(997),
    [sym__concat] = ACTIONS(6377),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_fi] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI_SEMI] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_AMP_GT] = ACTIONS(999),
    [anon_sym_AMP_GT_GT] = ACTIONS(997),
    [anon_sym_LT_AMP] = ACTIONS(997),
    [anon_sym_GT_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_LT_LT_DASH] = ACTIONS(997),
    [anon_sym_LT_LT_LT] = ACTIONS(997),
    [sym__special_character] = ACTIONS(997),
    [anon_sym_DQUOTE] = ACTIONS(997),
    [anon_sym_DOLLAR] = ACTIONS(999),
    [sym_raw_string] = ACTIONS(997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(997),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(997),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(999),
    [sym_word] = ACTIONS(999),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
  },
  [2282] = {
    [sym_subscript] = STATE(2919),
    [sym_variable_name] = ACTIONS(6391),
    [anon_sym_BANG] = ACTIONS(6393),
    [anon_sym_DASH] = ACTIONS(6395),
    [anon_sym_DOLLAR] = ACTIONS(6395),
    [anon_sym_POUND] = ACTIONS(6393),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6397),
    [anon_sym_STAR] = ACTIONS(6399),
    [anon_sym_AT] = ACTIONS(6399),
    [anon_sym_QMARK] = ACTIONS(6399),
    [anon_sym_0] = ACTIONS(6397),
    [anon_sym__] = ACTIONS(6397),
  },
  [2283] = {
    [sym__statements] = STATE(2920),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(2921),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2284] = {
    [sym__statements] = STATE(2922),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [2285] = {
    [sym__statements] = STATE(2923),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2286] = {
    [sym_concatenation] = STATE(2924),
    [sym_string] = STATE(2281),
    [sym_simple_expansion] = STATE(2281),
    [sym_string_expansion] = STATE(2281),
    [sym_expansion] = STATE(2281),
    [sym_command_substitution] = STATE(2281),
    [sym_process_substitution] = STATE(2281),
    [aux_sym_unset_command_repeat1] = STATE(2924),
    [aux_sym__literal_repeat1] = STATE(2287),
    [sym__simple_heredoc_body] = ACTIONS(1011),
    [sym__heredoc_body_beginning] = ACTIONS(1011),
    [sym_file_descriptor] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_fi] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1013),
    [anon_sym_GT] = ACTIONS(1013),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT] = ACTIONS(1013),
    [anon_sym_AMP_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_AMP] = ACTIONS(1011),
    [anon_sym_GT_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(1011),
    [anon_sym_LT_LT_LT] = ACTIONS(1011),
    [sym__special_character] = ACTIONS(4991),
    [anon_sym_DQUOTE] = ACTIONS(4993),
    [anon_sym_DOLLAR] = ACTIONS(4995),
    [sym_raw_string] = ACTIONS(4997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5001),
    [anon_sym_BQUOTE] = ACTIONS(5003),
    [anon_sym_LT_LPAREN] = ACTIONS(5005),
    [anon_sym_GT_LPAREN] = ACTIONS(5005),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6401),
    [sym_word] = ACTIONS(5009),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
  },
  [2287] = {
    [aux_sym__literal_repeat1] = STATE(2926),
    [sym__simple_heredoc_body] = ACTIONS(1017),
    [sym__heredoc_body_beginning] = ACTIONS(1017),
    [sym_file_descriptor] = ACTIONS(1017),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_fi] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1017),
    [anon_sym_PIPE_AMP] = ACTIONS(1017),
    [anon_sym_AMP_AMP] = ACTIONS(1017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1017),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1017),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1017),
    [anon_sym_LT_AMP] = ACTIONS(1017),
    [anon_sym_GT_AMP] = ACTIONS(1017),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1017),
    [anon_sym_LT_LT_LT] = ACTIONS(1017),
    [sym__special_character] = ACTIONS(6403),
    [anon_sym_DQUOTE] = ACTIONS(1017),
    [anon_sym_DOLLAR] = ACTIONS(1019),
    [sym_raw_string] = ACTIONS(1017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1017),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1017),
    [anon_sym_GT_LPAREN] = ACTIONS(1017),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1019),
    [sym_word] = ACTIONS(1019),
    [anon_sym_LF] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [2288] = {
    [sym_string] = STATE(2927),
    [sym_simple_expansion] = STATE(2927),
    [sym_string_expansion] = STATE(2927),
    [sym_expansion] = STATE(2927),
    [sym_command_substitution] = STATE(2927),
    [sym_process_substitution] = STATE(2927),
    [sym__special_character] = ACTIONS(6405),
    [anon_sym_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3359),
    [sym_raw_string] = ACTIONS(6405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3363),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3365),
    [anon_sym_BQUOTE] = ACTIONS(3367),
    [anon_sym_LT_LPAREN] = ACTIONS(3369),
    [anon_sym_GT_LPAREN] = ACTIONS(3369),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6405),
  },
  [2289] = {
    [aux_sym_concatenation_repeat1] = STATE(2928),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(5011),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_fi] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_EQ_TILDE] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [2290] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_fi] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_EQ_TILDE] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [2291] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(6407),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [2292] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(6407),
    [anon_sym_DOLLAR] = ACTIONS(6409),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2293] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_fi] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_EQ_TILDE] = ACTIONS(1099),
    [anon_sym_EQ_EQ] = ACTIONS(1099),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [2294] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_fi] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_EQ_TILDE] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [2295] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_fi] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_EQ_TILDE] = ACTIONS(1107),
    [anon_sym_EQ_EQ] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [2296] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(6411),
    [sym_comment] = ACTIONS(57),
  },
  [2297] = {
    [sym_subscript] = STATE(2934),
    [sym_variable_name] = ACTIONS(6413),
    [anon_sym_DASH] = ACTIONS(6415),
    [anon_sym_DOLLAR] = ACTIONS(6415),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6417),
    [anon_sym_STAR] = ACTIONS(6419),
    [anon_sym_AT] = ACTIONS(6419),
    [anon_sym_QMARK] = ACTIONS(6419),
    [anon_sym_0] = ACTIONS(6417),
    [anon_sym__] = ACTIONS(6417),
  },
  [2298] = {
    [sym_concatenation] = STATE(2937),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2937),
    [anon_sym_RBRACE] = ACTIONS(6421),
    [anon_sym_EQ] = ACTIONS(6423),
    [anon_sym_DASH] = ACTIONS(6423),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6425),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(6427),
    [anon_sym_COLON] = ACTIONS(6423),
    [anon_sym_COLON_QMARK] = ACTIONS(6423),
    [anon_sym_COLON_DASH] = ACTIONS(6423),
    [anon_sym_PERCENT] = ACTIONS(6423),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2299] = {
    [sym_concatenation] = STATE(2940),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2940),
    [anon_sym_RBRACE] = ACTIONS(6429),
    [anon_sym_EQ] = ACTIONS(6431),
    [anon_sym_DASH] = ACTIONS(6431),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(6435),
    [anon_sym_COLON] = ACTIONS(6431),
    [anon_sym_COLON_QMARK] = ACTIONS(6431),
    [anon_sym_COLON_DASH] = ACTIONS(6431),
    [anon_sym_PERCENT] = ACTIONS(6431),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2300] = {
    [anon_sym_RPAREN] = ACTIONS(6437),
    [sym_comment] = ACTIONS(57),
  },
  [2301] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(6437),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2302] = {
    [anon_sym_BQUOTE] = ACTIONS(6437),
    [sym_comment] = ACTIONS(57),
  },
  [2303] = {
    [anon_sym_RPAREN] = ACTIONS(6439),
    [sym_comment] = ACTIONS(57),
  },
  [2304] = {
    [anon_sym_LT] = ACTIONS(6441),
    [anon_sym_GT] = ACTIONS(6441),
    [anon_sym_GT_GT] = ACTIONS(6443),
    [anon_sym_AMP_GT] = ACTIONS(6441),
    [anon_sym_AMP_GT_GT] = ACTIONS(6443),
    [anon_sym_LT_AMP] = ACTIONS(6443),
    [anon_sym_GT_AMP] = ACTIONS(6443),
    [sym_comment] = ACTIONS(57),
  },
  [2305] = {
    [sym_file_descriptor] = ACTIONS(1235),
    [sym_variable_name] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1239),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1239),
    [anon_sym_if] = ACTIONS(1239),
    [anon_sym_fi] = ACTIONS(4910),
    [anon_sym_case] = ACTIONS(1239),
    [anon_sym_function] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1239),
    [anon_sym_typeset] = ACTIONS(1239),
    [anon_sym_export] = ACTIONS(1239),
    [anon_sym_readonly] = ACTIONS(1239),
    [anon_sym_local] = ACTIONS(1239),
    [anon_sym_unset] = ACTIONS(1239),
    [anon_sym_unsetenv] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_AMP_GT] = ACTIONS(1239),
    [anon_sym_AMP_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_AMP] = ACTIONS(1235),
    [anon_sym_GT_AMP] = ACTIONS(1235),
    [sym__special_character] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_DOLLAR] = ACTIONS(1239),
    [sym_raw_string] = ACTIONS(1235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1235),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1235),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [anon_sym_LT_LPAREN] = ACTIONS(1235),
    [anon_sym_GT_LPAREN] = ACTIONS(1235),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1239),
  },
  [2306] = {
    [sym_redirected_statement] = STATE(2944),
    [sym_for_statement] = STATE(2944),
    [sym_c_style_for_statement] = STATE(2944),
    [sym_while_statement] = STATE(2944),
    [sym_if_statement] = STATE(2944),
    [sym_case_statement] = STATE(2944),
    [sym_function_definition] = STATE(2944),
    [sym_compound_statement] = STATE(2944),
    [sym_subshell] = STATE(2944),
    [sym_pipeline] = STATE(2944),
    [sym_list] = STATE(2944),
    [sym_negated_command] = STATE(2944),
    [sym_test_command] = STATE(2944),
    [sym_declaration_command] = STATE(2944),
    [sym_unset_command] = STATE(2944),
    [sym_command] = STATE(2944),
    [sym_command_name] = STATE(1620),
    [sym_variable_assignment] = STATE(2945),
    [sym_subscript] = STATE(1622),
    [sym_file_redirect] = STATE(1625),
    [sym_concatenation] = STATE(1623),
    [sym_string] = STATE(1612),
    [sym_simple_expansion] = STATE(1612),
    [sym_string_expansion] = STATE(1612),
    [sym_expansion] = STATE(1612),
    [sym_command_substitution] = STATE(1612),
    [sym_process_substitution] = STATE(1612),
    [aux_sym_command_repeat1] = STATE(1625),
    [aux_sym__literal_repeat1] = STATE(1626),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(3345),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(3349),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(3351),
    [anon_sym_typeset] = ACTIONS(3351),
    [anon_sym_export] = ACTIONS(3351),
    [anon_sym_readonly] = ACTIONS(3351),
    [anon_sym_local] = ACTIONS(3351),
    [anon_sym_unset] = ACTIONS(3353),
    [anon_sym_unsetenv] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3359),
    [sym_raw_string] = ACTIONS(3361),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3363),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3365),
    [anon_sym_BQUOTE] = ACTIONS(3367),
    [anon_sym_LT_LPAREN] = ACTIONS(3369),
    [anon_sym_GT_LPAREN] = ACTIONS(3369),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3371),
  },
  [2307] = {
    [sym_redirected_statement] = STATE(2946),
    [sym_for_statement] = STATE(2946),
    [sym_c_style_for_statement] = STATE(2946),
    [sym_while_statement] = STATE(2946),
    [sym_if_statement] = STATE(2946),
    [sym_case_statement] = STATE(2946),
    [sym_function_definition] = STATE(2946),
    [sym_compound_statement] = STATE(2946),
    [sym_subshell] = STATE(2946),
    [sym_pipeline] = STATE(2946),
    [sym_list] = STATE(2946),
    [sym_negated_command] = STATE(2946),
    [sym_test_command] = STATE(2946),
    [sym_declaration_command] = STATE(2946),
    [sym_unset_command] = STATE(2946),
    [sym_command] = STATE(2946),
    [sym_command_name] = STATE(1620),
    [sym_variable_assignment] = STATE(2947),
    [sym_subscript] = STATE(1622),
    [sym_file_redirect] = STATE(1625),
    [sym_concatenation] = STATE(1623),
    [sym_string] = STATE(1612),
    [sym_simple_expansion] = STATE(1612),
    [sym_string_expansion] = STATE(1612),
    [sym_expansion] = STATE(1612),
    [sym_command_substitution] = STATE(1612),
    [sym_process_substitution] = STATE(1612),
    [aux_sym_command_repeat1] = STATE(1625),
    [aux_sym__literal_repeat1] = STATE(1626),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(3345),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(3349),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(3351),
    [anon_sym_typeset] = ACTIONS(3351),
    [anon_sym_export] = ACTIONS(3351),
    [anon_sym_readonly] = ACTIONS(3351),
    [anon_sym_local] = ACTIONS(3351),
    [anon_sym_unset] = ACTIONS(3353),
    [anon_sym_unsetenv] = ACTIONS(3353),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(3355),
    [anon_sym_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3359),
    [sym_raw_string] = ACTIONS(3361),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3363),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3365),
    [anon_sym_BQUOTE] = ACTIONS(3367),
    [anon_sym_LT_LPAREN] = ACTIONS(3369),
    [anon_sym_GT_LPAREN] = ACTIONS(3369),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3371),
  },
  [2308] = {
    [sym_concatenation] = STATE(695),
    [sym_string] = STATE(2949),
    [sym_simple_expansion] = STATE(2949),
    [sym_string_expansion] = STATE(2949),
    [sym_expansion] = STATE(2949),
    [sym_command_substitution] = STATE(2949),
    [sym_process_substitution] = STATE(2949),
    [aux_sym__literal_repeat1] = STATE(2950),
    [sym__special_character] = ACTIONS(6445),
    [anon_sym_DQUOTE] = ACTIONS(4914),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(6447),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4922),
    [anon_sym_BQUOTE] = ACTIONS(4924),
    [anon_sym_LT_LPAREN] = ACTIONS(4926),
    [anon_sym_GT_LPAREN] = ACTIONS(4926),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6447),
  },
  [2309] = {
    [sym_concatenation] = STATE(699),
    [sym_string] = STATE(2951),
    [sym_simple_expansion] = STATE(2951),
    [sym_string_expansion] = STATE(2951),
    [sym_expansion] = STATE(2951),
    [sym_command_substitution] = STATE(2951),
    [sym_process_substitution] = STATE(2951),
    [aux_sym__literal_repeat1] = STATE(2952),
    [sym__special_character] = ACTIONS(6445),
    [anon_sym_DQUOTE] = ACTIONS(4914),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(6449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4922),
    [anon_sym_BQUOTE] = ACTIONS(4924),
    [anon_sym_LT_LPAREN] = ACTIONS(4926),
    [anon_sym_GT_LPAREN] = ACTIONS(4926),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6449),
  },
  [2310] = {
    [anon_sym_SEMI] = ACTIONS(6451),
    [anon_sym_fi] = ACTIONS(1237),
    [anon_sym_SEMI_SEMI] = ACTIONS(6453),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6453),
    [anon_sym_AMP] = ACTIONS(6453),
  },
  [2311] = {
    [sym_file_redirect] = STATE(2954),
    [sym_heredoc_redirect] = STATE(2954),
    [sym_herestring_redirect] = STATE(2954),
    [aux_sym_redirected_statement_repeat1] = STATE(2954),
    [sym__simple_heredoc_body] = ACTIONS(1253),
    [sym__heredoc_body_beginning] = ACTIONS(1253),
    [sym_file_descriptor] = ACTIONS(5037),
    [anon_sym_SEMI] = ACTIONS(1255),
    [anon_sym_fi] = ACTIONS(1253),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_SEMI_SEMI] = ACTIONS(1253),
    [anon_sym_PIPE_AMP] = ACTIONS(1253),
    [anon_sym_AMP_AMP] = ACTIONS(1253),
    [anon_sym_PIPE_PIPE] = ACTIONS(1253),
    [anon_sym_LT] = ACTIONS(5049),
    [anon_sym_GT] = ACTIONS(5049),
    [anon_sym_GT_GT] = ACTIONS(5051),
    [anon_sym_AMP_GT] = ACTIONS(5049),
    [anon_sym_AMP_GT_GT] = ACTIONS(5051),
    [anon_sym_LT_AMP] = ACTIONS(5051),
    [anon_sym_GT_AMP] = ACTIONS(5051),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(5053),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1255),
  },
  [2312] = {
    [sym_concatenation] = STATE(2955),
    [sym_string] = STATE(2956),
    [sym_simple_expansion] = STATE(2956),
    [sym_string_expansion] = STATE(2956),
    [sym_expansion] = STATE(2956),
    [sym_command_substitution] = STATE(2956),
    [sym_process_substitution] = STATE(2956),
    [aux_sym__literal_repeat1] = STATE(2957),
    [sym_regex] = ACTIONS(6455),
    [sym__special_character] = ACTIONS(5057),
    [anon_sym_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3359),
    [sym_raw_string] = ACTIONS(6457),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3363),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3365),
    [anon_sym_BQUOTE] = ACTIONS(3367),
    [anon_sym_LT_LPAREN] = ACTIONS(3369),
    [anon_sym_GT_LPAREN] = ACTIONS(3369),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6457),
  },
  [2313] = {
    [aux_sym_concatenation_repeat1] = STATE(2289),
    [sym__simple_heredoc_body] = ACTIONS(1261),
    [sym__heredoc_body_beginning] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(5011),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_fi] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [sym__special_character] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [2314] = {
    [sym_concatenation] = STATE(2958),
    [sym_string] = STATE(2313),
    [sym_simple_expansion] = STATE(2313),
    [sym_string_expansion] = STATE(2313),
    [sym_expansion] = STATE(2313),
    [sym_command_substitution] = STATE(2313),
    [sym_process_substitution] = STATE(2313),
    [aux_sym_command_repeat2] = STATE(2958),
    [aux_sym__literal_repeat1] = STATE(2315),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_fi] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(5055),
    [anon_sym_EQ_EQ] = ACTIONS(5055),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(5057),
    [anon_sym_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3359),
    [sym_raw_string] = ACTIONS(5059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3363),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3365),
    [anon_sym_BQUOTE] = ACTIONS(3367),
    [anon_sym_LT_LPAREN] = ACTIONS(3369),
    [anon_sym_GT_LPAREN] = ACTIONS(3369),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5061),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [2315] = {
    [aux_sym__literal_repeat1] = STATE(2320),
    [sym__simple_heredoc_body] = ACTIONS(1269),
    [sym__heredoc_body_beginning] = ACTIONS(1269),
    [sym_file_descriptor] = ACTIONS(1269),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_fi] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE_AMP] = ACTIONS(1269),
    [anon_sym_AMP_AMP] = ACTIONS(1269),
    [anon_sym_PIPE_PIPE] = ACTIONS(1269),
    [anon_sym_EQ_TILDE] = ACTIONS(1271),
    [anon_sym_EQ_EQ] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT_GT] = ACTIONS(1269),
    [anon_sym_LT_AMP] = ACTIONS(1269),
    [anon_sym_GT_AMP] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_LT_LT_DASH] = ACTIONS(1269),
    [anon_sym_LT_LT_LT] = ACTIONS(1269),
    [sym__special_character] = ACTIONS(5063),
    [anon_sym_DQUOTE] = ACTIONS(1269),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1269),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1269),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [anon_sym_LT_LPAREN] = ACTIONS(1269),
    [anon_sym_GT_LPAREN] = ACTIONS(1269),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1271),
  },
  [2316] = {
    [sym_file_redirect] = STATE(2311),
    [sym_heredoc_redirect] = STATE(2311),
    [sym_heredoc_body] = STATE(2960),
    [sym_herestring_redirect] = STATE(2311),
    [aux_sym_redirected_statement_repeat1] = STATE(2311),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(5037),
    [anon_sym_SEMI] = ACTIONS(6459),
    [anon_sym_fi] = ACTIONS(1237),
    [anon_sym_PIPE] = ACTIONS(5041),
    [anon_sym_SEMI_SEMI] = ACTIONS(6461),
    [anon_sym_PIPE_AMP] = ACTIONS(5045),
    [anon_sym_AMP_AMP] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(5047),
    [anon_sym_LT] = ACTIONS(5049),
    [anon_sym_GT] = ACTIONS(5049),
    [anon_sym_GT_GT] = ACTIONS(5051),
    [anon_sym_AMP_GT] = ACTIONS(5049),
    [anon_sym_AMP_GT_GT] = ACTIONS(5051),
    [anon_sym_LT_AMP] = ACTIONS(5051),
    [anon_sym_GT_AMP] = ACTIONS(5051),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(5053),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6461),
    [anon_sym_AMP] = ACTIONS(6459),
  },
  [2317] = {
    [sym_file_redirect] = STATE(2311),
    [sym_heredoc_redirect] = STATE(2311),
    [sym_heredoc_body] = STATE(2960),
    [sym_herestring_redirect] = STATE(2311),
    [aux_sym_redirected_statement_repeat1] = STATE(2311),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(6459),
    [anon_sym_fi] = ACTIONS(4910),
    [anon_sym_PIPE] = ACTIONS(5041),
    [anon_sym_SEMI_SEMI] = ACTIONS(6461),
    [anon_sym_PIPE_AMP] = ACTIONS(5045),
    [anon_sym_AMP_AMP] = ACTIONS(5047),
    [anon_sym_PIPE_PIPE] = ACTIONS(5047),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(5053),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(6461),
    [anon_sym_AMP] = ACTIONS(6459),
  },
  [2318] = {
    [sym_concatenation] = STATE(2961),
    [sym_string] = STATE(2313),
    [sym_simple_expansion] = STATE(2313),
    [sym_string_expansion] = STATE(2313),
    [sym_expansion] = STATE(2313),
    [sym_command_substitution] = STATE(2313),
    [sym_process_substitution] = STATE(2313),
    [aux_sym_command_repeat2] = STATE(2961),
    [aux_sym__literal_repeat1] = STATE(2315),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_fi] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(5055),
    [anon_sym_EQ_EQ] = ACTIONS(5055),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(5057),
    [anon_sym_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3359),
    [sym_raw_string] = ACTIONS(5059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3363),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3365),
    [anon_sym_BQUOTE] = ACTIONS(3367),
    [anon_sym_LT_LPAREN] = ACTIONS(3369),
    [anon_sym_GT_LPAREN] = ACTIONS(3369),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5061),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [2319] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_fi] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [2320] = {
    [aux_sym__literal_repeat1] = STATE(2320),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_fi] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_EQ_TILDE] = ACTIONS(1373),
    [anon_sym_EQ_EQ] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(6463),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [2321] = {
    [sym_concatenation] = STATE(2962),
    [sym_string] = STATE(2964),
    [sym_array] = STATE(2962),
    [sym_simple_expansion] = STATE(2964),
    [sym_string_expansion] = STATE(2964),
    [sym_expansion] = STATE(2964),
    [sym_command_substitution] = STATE(2964),
    [sym_process_substitution] = STATE(2964),
    [aux_sym__literal_repeat1] = STATE(2965),
    [sym__empty_value] = ACTIONS(6466),
    [anon_sym_LPAREN] = ACTIONS(6468),
    [sym__special_character] = ACTIONS(3375),
    [anon_sym_DQUOTE] = ACTIONS(3377),
    [anon_sym_DOLLAR] = ACTIONS(3379),
    [sym_raw_string] = ACTIONS(6470),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3383),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3385),
    [anon_sym_BQUOTE] = ACTIONS(3387),
    [anon_sym_LT_LPAREN] = ACTIONS(3389),
    [anon_sym_GT_LPAREN] = ACTIONS(3389),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6470),
  },
  [2322] = {
    [sym_string] = STATE(2966),
    [sym_simple_expansion] = STATE(2966),
    [sym_string_expansion] = STATE(2966),
    [sym_expansion] = STATE(2966),
    [sym_command_substitution] = STATE(2966),
    [sym_process_substitution] = STATE(2966),
    [sym__special_character] = ACTIONS(6472),
    [anon_sym_DQUOTE] = ACTIONS(3377),
    [anon_sym_DOLLAR] = ACTIONS(3379),
    [sym_raw_string] = ACTIONS(6472),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3383),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3385),
    [anon_sym_BQUOTE] = ACTIONS(3387),
    [anon_sym_LT_LPAREN] = ACTIONS(3389),
    [anon_sym_GT_LPAREN] = ACTIONS(3389),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6472),
  },
  [2323] = {
    [aux_sym_concatenation_repeat1] = STATE(2967),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(5067),
    [sym_variable_name] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_fi] = ACTIONS(1061),
    [anon_sym_elif] = ACTIONS(1061),
    [anon_sym_else] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1061),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [2324] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [sym_variable_name] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_fi] = ACTIONS(1065),
    [anon_sym_elif] = ACTIONS(1065),
    [anon_sym_else] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [2325] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(6474),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [2326] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(6474),
    [anon_sym_DOLLAR] = ACTIONS(6476),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2327] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_fi] = ACTIONS(1099),
    [anon_sym_elif] = ACTIONS(1099),
    [anon_sym_else] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1099),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [2328] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [sym_variable_name] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_fi] = ACTIONS(1103),
    [anon_sym_elif] = ACTIONS(1103),
    [anon_sym_else] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1103),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [2329] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [sym_variable_name] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_fi] = ACTIONS(1107),
    [anon_sym_elif] = ACTIONS(1107),
    [anon_sym_else] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1107),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [2330] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(6478),
    [sym_comment] = ACTIONS(57),
  },
  [2331] = {
    [sym_subscript] = STATE(2973),
    [sym_variable_name] = ACTIONS(6480),
    [anon_sym_DASH] = ACTIONS(6482),
    [anon_sym_DOLLAR] = ACTIONS(6482),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6484),
    [anon_sym_STAR] = ACTIONS(6486),
    [anon_sym_AT] = ACTIONS(6486),
    [anon_sym_QMARK] = ACTIONS(6486),
    [anon_sym_0] = ACTIONS(6484),
    [anon_sym__] = ACTIONS(6484),
  },
  [2332] = {
    [sym_concatenation] = STATE(2976),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2976),
    [anon_sym_RBRACE] = ACTIONS(6488),
    [anon_sym_EQ] = ACTIONS(6490),
    [anon_sym_DASH] = ACTIONS(6490),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(6494),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_COLON_QMARK] = ACTIONS(6490),
    [anon_sym_COLON_DASH] = ACTIONS(6490),
    [anon_sym_PERCENT] = ACTIONS(6490),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2333] = {
    [sym_concatenation] = STATE(2979),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2979),
    [anon_sym_RBRACE] = ACTIONS(6496),
    [anon_sym_EQ] = ACTIONS(6498),
    [anon_sym_DASH] = ACTIONS(6498),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(6502),
    [anon_sym_COLON] = ACTIONS(6498),
    [anon_sym_COLON_QMARK] = ACTIONS(6498),
    [anon_sym_COLON_DASH] = ACTIONS(6498),
    [anon_sym_PERCENT] = ACTIONS(6498),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2334] = {
    [anon_sym_RPAREN] = ACTIONS(6504),
    [sym_comment] = ACTIONS(57),
  },
  [2335] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(6504),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2336] = {
    [anon_sym_BQUOTE] = ACTIONS(6504),
    [sym_comment] = ACTIONS(57),
  },
  [2337] = {
    [anon_sym_RPAREN] = ACTIONS(6506),
    [sym_comment] = ACTIONS(57),
  },
  [2338] = {
    [sym_variable_assignment] = STATE(2338),
    [sym_subscript] = STATE(1636),
    [sym_concatenation] = STATE(2338),
    [sym_string] = STATE(1631),
    [sym_simple_expansion] = STATE(1631),
    [sym_string_expansion] = STATE(1631),
    [sym_expansion] = STATE(1631),
    [sym_command_substitution] = STATE(1631),
    [sym_process_substitution] = STATE(1631),
    [aux_sym_declaration_command_repeat1] = STATE(2338),
    [aux_sym__literal_repeat1] = STATE(1638),
    [sym__simple_heredoc_body] = ACTIONS(2192),
    [sym__heredoc_body_beginning] = ACTIONS(2192),
    [sym_file_descriptor] = ACTIONS(2192),
    [sym_variable_name] = ACTIONS(6508),
    [anon_sym_SEMI] = ACTIONS(2197),
    [anon_sym_fi] = ACTIONS(2197),
    [anon_sym_elif] = ACTIONS(2197),
    [anon_sym_else] = ACTIONS(2197),
    [anon_sym_PIPE] = ACTIONS(2197),
    [anon_sym_SEMI_SEMI] = ACTIONS(2192),
    [anon_sym_PIPE_AMP] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_GT] = ACTIONS(2197),
    [anon_sym_GT_GT] = ACTIONS(2192),
    [anon_sym_AMP_GT] = ACTIONS(2197),
    [anon_sym_AMP_GT_GT] = ACTIONS(2192),
    [anon_sym_LT_AMP] = ACTIONS(2192),
    [anon_sym_GT_AMP] = ACTIONS(2192),
    [anon_sym_LT_LT] = ACTIONS(2197),
    [anon_sym_LT_LT_DASH] = ACTIONS(2192),
    [anon_sym_LT_LT_LT] = ACTIONS(2192),
    [sym__special_character] = ACTIONS(6511),
    [anon_sym_DQUOTE] = ACTIONS(6514),
    [anon_sym_DOLLAR] = ACTIONS(6517),
    [sym_raw_string] = ACTIONS(6520),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6523),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6526),
    [anon_sym_BQUOTE] = ACTIONS(6529),
    [anon_sym_LT_LPAREN] = ACTIONS(6532),
    [anon_sym_GT_LPAREN] = ACTIONS(6532),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6535),
    [sym_word] = ACTIONS(6538),
    [anon_sym_LF] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2197),
  },
  [2339] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_fi] = ACTIONS(329),
    [anon_sym_elif] = ACTIONS(329),
    [anon_sym_else] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [2340] = {
    [aux_sym__literal_repeat1] = STATE(2340),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym_variable_name] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_fi] = ACTIONS(1373),
    [anon_sym_elif] = ACTIONS(1373),
    [anon_sym_else] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(6541),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1373),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [2341] = {
    [sym_string] = STATE(2982),
    [sym_simple_expansion] = STATE(2982),
    [sym_string_expansion] = STATE(2982),
    [sym_expansion] = STATE(2982),
    [sym_command_substitution] = STATE(2982),
    [sym_process_substitution] = STATE(2982),
    [sym__special_character] = ACTIONS(6544),
    [anon_sym_DQUOTE] = ACTIONS(3397),
    [anon_sym_DOLLAR] = ACTIONS(3399),
    [sym_raw_string] = ACTIONS(6544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3403),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3405),
    [anon_sym_BQUOTE] = ACTIONS(3407),
    [anon_sym_LT_LPAREN] = ACTIONS(3409),
    [anon_sym_GT_LPAREN] = ACTIONS(3409),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6544),
  },
  [2342] = {
    [aux_sym_concatenation_repeat1] = STATE(2983),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(5095),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_fi] = ACTIONS(1061),
    [anon_sym_elif] = ACTIONS(1061),
    [anon_sym_else] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1061),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [2343] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_fi] = ACTIONS(1065),
    [anon_sym_elif] = ACTIONS(1065),
    [anon_sym_else] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [2344] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(6546),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [2345] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(6546),
    [anon_sym_DOLLAR] = ACTIONS(6548),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2346] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_fi] = ACTIONS(1099),
    [anon_sym_elif] = ACTIONS(1099),
    [anon_sym_else] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1099),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [2347] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_fi] = ACTIONS(1103),
    [anon_sym_elif] = ACTIONS(1103),
    [anon_sym_else] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1103),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [2348] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_fi] = ACTIONS(1107),
    [anon_sym_elif] = ACTIONS(1107),
    [anon_sym_else] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1107),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [2349] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(6550),
    [sym_comment] = ACTIONS(57),
  },
  [2350] = {
    [sym_subscript] = STATE(2989),
    [sym_variable_name] = ACTIONS(6552),
    [anon_sym_DASH] = ACTIONS(6554),
    [anon_sym_DOLLAR] = ACTIONS(6554),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6556),
    [anon_sym_STAR] = ACTIONS(6558),
    [anon_sym_AT] = ACTIONS(6558),
    [anon_sym_QMARK] = ACTIONS(6558),
    [anon_sym_0] = ACTIONS(6556),
    [anon_sym__] = ACTIONS(6556),
  },
  [2351] = {
    [sym_concatenation] = STATE(2992),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2992),
    [anon_sym_RBRACE] = ACTIONS(6560),
    [anon_sym_EQ] = ACTIONS(6562),
    [anon_sym_DASH] = ACTIONS(6562),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(6566),
    [anon_sym_COLON] = ACTIONS(6562),
    [anon_sym_COLON_QMARK] = ACTIONS(6562),
    [anon_sym_COLON_DASH] = ACTIONS(6562),
    [anon_sym_PERCENT] = ACTIONS(6562),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2352] = {
    [sym_concatenation] = STATE(2995),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(2995),
    [anon_sym_RBRACE] = ACTIONS(6568),
    [anon_sym_EQ] = ACTIONS(6570),
    [anon_sym_DASH] = ACTIONS(6570),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(6574),
    [anon_sym_COLON] = ACTIONS(6570),
    [anon_sym_COLON_QMARK] = ACTIONS(6570),
    [anon_sym_COLON_DASH] = ACTIONS(6570),
    [anon_sym_PERCENT] = ACTIONS(6570),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2353] = {
    [anon_sym_RPAREN] = ACTIONS(6576),
    [sym_comment] = ACTIONS(57),
  },
  [2354] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(6576),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2355] = {
    [anon_sym_BQUOTE] = ACTIONS(6576),
    [sym_comment] = ACTIONS(57),
  },
  [2356] = {
    [anon_sym_RPAREN] = ACTIONS(6578),
    [sym_comment] = ACTIONS(57),
  },
  [2357] = {
    [sym_concatenation] = STATE(2357),
    [sym_string] = STATE(1642),
    [sym_simple_expansion] = STATE(1642),
    [sym_string_expansion] = STATE(1642),
    [sym_expansion] = STATE(1642),
    [sym_command_substitution] = STATE(1642),
    [sym_process_substitution] = STATE(1642),
    [aux_sym_unset_command_repeat1] = STATE(2357),
    [aux_sym__literal_repeat1] = STATE(1648),
    [sym__simple_heredoc_body] = ACTIONS(2268),
    [sym__heredoc_body_beginning] = ACTIONS(2268),
    [sym_file_descriptor] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_fi] = ACTIONS(2270),
    [anon_sym_elif] = ACTIONS(2270),
    [anon_sym_else] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2270),
    [anon_sym_SEMI_SEMI] = ACTIONS(2268),
    [anon_sym_PIPE_AMP] = ACTIONS(2268),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [anon_sym_PIPE_PIPE] = ACTIONS(2268),
    [anon_sym_LT] = ACTIONS(2270),
    [anon_sym_GT] = ACTIONS(2270),
    [anon_sym_GT_GT] = ACTIONS(2268),
    [anon_sym_AMP_GT] = ACTIONS(2270),
    [anon_sym_AMP_GT_GT] = ACTIONS(2268),
    [anon_sym_LT_AMP] = ACTIONS(2268),
    [anon_sym_GT_AMP] = ACTIONS(2268),
    [anon_sym_LT_LT] = ACTIONS(2270),
    [anon_sym_LT_LT_DASH] = ACTIONS(2268),
    [anon_sym_LT_LT_LT] = ACTIONS(2268),
    [sym__special_character] = ACTIONS(6580),
    [anon_sym_DQUOTE] = ACTIONS(6583),
    [anon_sym_DOLLAR] = ACTIONS(6586),
    [sym_raw_string] = ACTIONS(6589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6592),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6595),
    [anon_sym_BQUOTE] = ACTIONS(6598),
    [anon_sym_LT_LPAREN] = ACTIONS(6601),
    [anon_sym_GT_LPAREN] = ACTIONS(6601),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(6604),
    [sym_word] = ACTIONS(6607),
    [anon_sym_LF] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2270),
  },
  [2358] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_fi] = ACTIONS(329),
    [anon_sym_elif] = ACTIONS(329),
    [anon_sym_else] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [2359] = {
    [aux_sym__literal_repeat1] = STATE(2359),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_fi] = ACTIONS(1373),
    [anon_sym_elif] = ACTIONS(1373),
    [anon_sym_else] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(6610),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1373),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [2360] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_fi] = ACTIONS(2346),
    [anon_sym_elif] = ACTIONS(2346),
    [anon_sym_else] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2346),
    [anon_sym_EQ_EQ] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2361] = {
    [aux_sym_concatenation_repeat1] = STATE(2361),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(6613),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_fi] = ACTIONS(2346),
    [anon_sym_elif] = ACTIONS(2346),
    [anon_sym_else] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2346),
    [anon_sym_EQ_EQ] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2362] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_fi] = ACTIONS(2353),
    [anon_sym_elif] = ACTIONS(2353),
    [anon_sym_else] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_EQ_TILDE] = ACTIONS(2353),
    [anon_sym_EQ_EQ] = ACTIONS(2353),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [2363] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(6616),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [2364] = {
    [sym_concatenation] = STATE(3001),
    [sym_string] = STATE(3000),
    [sym_simple_expansion] = STATE(3000),
    [sym_string_expansion] = STATE(3000),
    [sym_expansion] = STATE(3000),
    [sym_command_substitution] = STATE(3000),
    [sym_process_substitution] = STATE(3000),
    [aux_sym__literal_repeat1] = STATE(3002),
    [anon_sym_RBRACE] = ACTIONS(6618),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(6620),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6620),
  },
  [2365] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(6622),
    [sym_comment] = ACTIONS(57),
  },
  [2366] = {
    [sym_concatenation] = STATE(3006),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3006),
    [anon_sym_RBRACE] = ACTIONS(6624),
    [anon_sym_EQ] = ACTIONS(6626),
    [anon_sym_DASH] = ACTIONS(6626),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6628),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(6630),
    [anon_sym_COLON] = ACTIONS(6626),
    [anon_sym_COLON_QMARK] = ACTIONS(6626),
    [anon_sym_COLON_DASH] = ACTIONS(6626),
    [anon_sym_PERCENT] = ACTIONS(6626),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2367] = {
    [sym_concatenation] = STATE(3008),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3008),
    [anon_sym_RBRACE] = ACTIONS(6618),
    [anon_sym_EQ] = ACTIONS(6632),
    [anon_sym_DASH] = ACTIONS(6632),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6634),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(6636),
    [anon_sym_COLON] = ACTIONS(6632),
    [anon_sym_COLON_QMARK] = ACTIONS(6632),
    [anon_sym_COLON_DASH] = ACTIONS(6632),
    [anon_sym_PERCENT] = ACTIONS(6632),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2368] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_fi] = ACTIONS(2444),
    [anon_sym_elif] = ACTIONS(2444),
    [anon_sym_else] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_EQ_TILDE] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2444),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [2369] = {
    [sym_concatenation] = STATE(3011),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3011),
    [sym_regex] = ACTIONS(6638),
    [anon_sym_RBRACE] = ACTIONS(6640),
    [anon_sym_EQ] = ACTIONS(6642),
    [anon_sym_DASH] = ACTIONS(6642),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6642),
    [anon_sym_COLON_QMARK] = ACTIONS(6642),
    [anon_sym_COLON_DASH] = ACTIONS(6642),
    [anon_sym_PERCENT] = ACTIONS(6642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2370] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6640),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2371] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_fi] = ACTIONS(2494),
    [anon_sym_elif] = ACTIONS(2494),
    [anon_sym_else] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_EQ_TILDE] = ACTIONS(2494),
    [anon_sym_EQ_EQ] = ACTIONS(2494),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [2372] = {
    [sym_concatenation] = STATE(3008),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3008),
    [sym_regex] = ACTIONS(6646),
    [anon_sym_RBRACE] = ACTIONS(6618),
    [anon_sym_EQ] = ACTIONS(6632),
    [anon_sym_DASH] = ACTIONS(6632),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6634),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6632),
    [anon_sym_COLON_QMARK] = ACTIONS(6632),
    [anon_sym_COLON_DASH] = ACTIONS(6632),
    [anon_sym_PERCENT] = ACTIONS(6632),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2373] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6618),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2374] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_fi] = ACTIONS(2502),
    [anon_sym_elif] = ACTIONS(2502),
    [anon_sym_else] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_EQ_TILDE] = ACTIONS(2502),
    [anon_sym_EQ_EQ] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [2375] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_fi] = ACTIONS(2536),
    [anon_sym_elif] = ACTIONS(2536),
    [anon_sym_else] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_EQ_TILDE] = ACTIONS(2536),
    [anon_sym_EQ_EQ] = ACTIONS(2536),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [2376] = {
    [sym__simple_heredoc_body] = ACTIONS(6648),
    [sym__heredoc_body_beginning] = ACTIONS(6648),
    [sym_file_descriptor] = ACTIONS(6648),
    [ts_builtin_sym_end] = ACTIONS(6648),
    [anon_sym_SEMI] = ACTIONS(6650),
    [anon_sym_done] = ACTIONS(6648),
    [anon_sym_fi] = ACTIONS(6648),
    [anon_sym_elif] = ACTIONS(6648),
    [anon_sym_else] = ACTIONS(6648),
    [anon_sym_esac] = ACTIONS(6648),
    [anon_sym_PIPE] = ACTIONS(6650),
    [anon_sym_RPAREN] = ACTIONS(6648),
    [anon_sym_SEMI_SEMI] = ACTIONS(6648),
    [anon_sym_PIPE_AMP] = ACTIONS(6648),
    [anon_sym_AMP_AMP] = ACTIONS(6648),
    [anon_sym_PIPE_PIPE] = ACTIONS(6648),
    [anon_sym_LT] = ACTIONS(6650),
    [anon_sym_GT] = ACTIONS(6650),
    [anon_sym_GT_GT] = ACTIONS(6648),
    [anon_sym_AMP_GT] = ACTIONS(6650),
    [anon_sym_AMP_GT_GT] = ACTIONS(6648),
    [anon_sym_LT_AMP] = ACTIONS(6648),
    [anon_sym_GT_AMP] = ACTIONS(6648),
    [anon_sym_LT_LT] = ACTIONS(6650),
    [anon_sym_LT_LT_DASH] = ACTIONS(6648),
    [anon_sym_LT_LT_LT] = ACTIONS(6648),
    [anon_sym_BQUOTE] = ACTIONS(6648),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6648),
    [anon_sym_AMP] = ACTIONS(6650),
  },
  [2377] = {
    [anon_sym_fi] = ACTIONS(6652),
    [sym_comment] = ACTIONS(57),
  },
  [2378] = {
    [sym_concatenation] = STATE(1318),
    [sym_string] = STATE(3014),
    [sym_simple_expansion] = STATE(3014),
    [sym_string_expansion] = STATE(3014),
    [sym_expansion] = STATE(3014),
    [sym_command_substitution] = STATE(3014),
    [sym_process_substitution] = STATE(3014),
    [aux_sym__literal_repeat1] = STATE(3015),
    [sym__special_character] = ACTIONS(5169),
    [anon_sym_DQUOTE] = ACTIONS(4914),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(6654),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4922),
    [anon_sym_BQUOTE] = ACTIONS(4924),
    [anon_sym_LT_LPAREN] = ACTIONS(4926),
    [anon_sym_GT_LPAREN] = ACTIONS(4926),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6654),
  },
  [2379] = {
    [sym_file_redirect] = STATE(1675),
    [sym_heredoc_redirect] = STATE(1675),
    [sym_herestring_redirect] = STATE(1675),
    [aux_sym_redirected_statement_repeat1] = STATE(1675),
    [sym__simple_heredoc_body] = ACTIONS(2564),
    [sym__heredoc_body_beginning] = ACTIONS(2564),
    [sym_file_descriptor] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_fi] = ACTIONS(2564),
    [anon_sym_elif] = ACTIONS(2564),
    [anon_sym_else] = ACTIONS(2564),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT] = ACTIONS(2566),
    [anon_sym_AMP_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_AMP] = ACTIONS(2564),
    [anon_sym_GT_AMP] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_LT_LT_DASH] = ACTIONS(2564),
    [anon_sym_LT_LT_LT] = ACTIONS(2564),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2566),
  },
  [2380] = {
    [sym_file_redirect] = STATE(1675),
    [sym_heredoc_redirect] = STATE(1675),
    [sym_herestring_redirect] = STATE(1675),
    [aux_sym_redirected_statement_repeat1] = STATE(1675),
    [sym__simple_heredoc_body] = ACTIONS(2564),
    [sym__heredoc_body_beginning] = ACTIONS(2564),
    [sym_file_descriptor] = ACTIONS(2564),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_fi] = ACTIONS(2566),
    [anon_sym_elif] = ACTIONS(2566),
    [anon_sym_else] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT] = ACTIONS(2566),
    [anon_sym_AMP_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_AMP] = ACTIONS(2564),
    [anon_sym_GT_AMP] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_LT_LT_DASH] = ACTIONS(2564),
    [anon_sym_LT_LT_LT] = ACTIONS(2564),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2566),
  },
  [2381] = {
    [sym_file_redirect] = STATE(1675),
    [sym_heredoc_redirect] = STATE(1675),
    [sym_herestring_redirect] = STATE(1675),
    [aux_sym_redirected_statement_repeat1] = STATE(1675),
    [sym__simple_heredoc_body] = ACTIONS(2568),
    [sym__heredoc_body_beginning] = ACTIONS(2568),
    [sym_file_descriptor] = ACTIONS(2568),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_fi] = ACTIONS(2568),
    [anon_sym_elif] = ACTIONS(2568),
    [anon_sym_else] = ACTIONS(2568),
    [anon_sym_PIPE] = ACTIONS(3449),
    [anon_sym_SEMI_SEMI] = ACTIONS(2568),
    [anon_sym_PIPE_AMP] = ACTIONS(3453),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_GT] = ACTIONS(2570),
    [anon_sym_GT_GT] = ACTIONS(2568),
    [anon_sym_AMP_GT] = ACTIONS(2570),
    [anon_sym_AMP_GT_GT] = ACTIONS(2568),
    [anon_sym_LT_AMP] = ACTIONS(2568),
    [anon_sym_GT_AMP] = ACTIONS(2568),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_LT_LT_DASH] = ACTIONS(2568),
    [anon_sym_LT_LT_LT] = ACTIONS(2568),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2570),
  },
  [2382] = {
    [sym_file_redirect] = STATE(1675),
    [sym_heredoc_redirect] = STATE(1675),
    [sym_herestring_redirect] = STATE(1675),
    [aux_sym_redirected_statement_repeat1] = STATE(1675),
    [sym__simple_heredoc_body] = ACTIONS(2568),
    [sym__heredoc_body_beginning] = ACTIONS(2568),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_fi] = ACTIONS(2570),
    [anon_sym_elif] = ACTIONS(2570),
    [anon_sym_else] = ACTIONS(2570),
    [anon_sym_PIPE] = ACTIONS(3449),
    [anon_sym_SEMI_SEMI] = ACTIONS(2568),
    [anon_sym_PIPE_AMP] = ACTIONS(3453),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_LT_LT_DASH] = ACTIONS(2568),
    [anon_sym_LT_LT_LT] = ACTIONS(2568),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2570),
  },
  [2383] = {
    [aux_sym_concatenation_repeat1] = STATE(3016),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_fi] = ACTIONS(325),
    [anon_sym_elif] = ACTIONS(325),
    [anon_sym_else] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [2384] = {
    [aux_sym_concatenation_repeat1] = STATE(3016),
    [sym__simple_heredoc_body] = ACTIONS(1037),
    [sym__heredoc_body_beginning] = ACTIONS(1037),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_fi] = ACTIONS(1037),
    [anon_sym_elif] = ACTIONS(1037),
    [anon_sym_else] = ACTIONS(1037),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [2385] = {
    [aux_sym__literal_repeat1] = STATE(3017),
    [sym__simple_heredoc_body] = ACTIONS(1051),
    [sym__heredoc_body_beginning] = ACTIONS(1051),
    [sym_file_descriptor] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_fi] = ACTIONS(1051),
    [anon_sym_elif] = ACTIONS(1051),
    [anon_sym_else] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_LT_LT_DASH] = ACTIONS(1051),
    [anon_sym_LT_LT_LT] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(6247),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1051),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [2386] = {
    [aux_sym_concatenation_repeat1] = STATE(3016),
    [sym__simple_heredoc_body] = ACTIONS(2576),
    [sym__heredoc_body_beginning] = ACTIONS(2576),
    [sym_file_descriptor] = ACTIONS(2576),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym_fi] = ACTIONS(2576),
    [anon_sym_elif] = ACTIONS(2576),
    [anon_sym_else] = ACTIONS(2576),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI_SEMI] = ACTIONS(2576),
    [anon_sym_PIPE_AMP] = ACTIONS(2576),
    [anon_sym_AMP_AMP] = ACTIONS(2576),
    [anon_sym_PIPE_PIPE] = ACTIONS(2576),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_GT] = ACTIONS(2576),
    [anon_sym_AMP_GT] = ACTIONS(2578),
    [anon_sym_AMP_GT_GT] = ACTIONS(2576),
    [anon_sym_LT_AMP] = ACTIONS(2576),
    [anon_sym_GT_AMP] = ACTIONS(2576),
    [anon_sym_LT_LT] = ACTIONS(2578),
    [anon_sym_LT_LT_DASH] = ACTIONS(2576),
    [anon_sym_LT_LT_LT] = ACTIONS(2576),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2576),
    [anon_sym_AMP] = ACTIONS(2578),
  },
  [2387] = {
    [aux_sym__literal_repeat1] = STATE(3017),
    [sym__simple_heredoc_body] = ACTIONS(2580),
    [sym__heredoc_body_beginning] = ACTIONS(2580),
    [sym_file_descriptor] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym_fi] = ACTIONS(2580),
    [anon_sym_elif] = ACTIONS(2580),
    [anon_sym_else] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_SEMI_SEMI] = ACTIONS(2580),
    [anon_sym_PIPE_AMP] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_AMP_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_AMP] = ACTIONS(2580),
    [anon_sym_GT_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2582),
    [anon_sym_LT_LT_DASH] = ACTIONS(2580),
    [anon_sym_LT_LT_LT] = ACTIONS(2580),
    [sym__special_character] = ACTIONS(6247),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2580),
    [anon_sym_AMP] = ACTIONS(2582),
  },
  [2388] = {
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(2584),
    [anon_sym_for] = ACTIONS(2588),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_fi] = ACTIONS(6249),
    [anon_sym_elif] = ACTIONS(6249),
    [anon_sym_else] = ACTIONS(6249),
    [anon_sym_case] = ACTIONS(2588),
    [anon_sym_function] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2584),
    [anon_sym_declare] = ACTIONS(2588),
    [anon_sym_typeset] = ACTIONS(2588),
    [anon_sym_export] = ACTIONS(2588),
    [anon_sym_readonly] = ACTIONS(2588),
    [anon_sym_local] = ACTIONS(2588),
    [anon_sym_unset] = ACTIONS(2588),
    [anon_sym_unsetenv] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [sym__special_character] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2584),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2584),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [anon_sym_LT_LPAREN] = ACTIONS(2584),
    [anon_sym_GT_LPAREN] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
  },
  [2389] = {
    [sym_file_redirect] = STATE(2389),
    [sym_heredoc_redirect] = STATE(2389),
    [sym_herestring_redirect] = STATE(2389),
    [aux_sym_redirected_statement_repeat1] = STATE(2389),
    [sym__simple_heredoc_body] = ACTIONS(2590),
    [sym__heredoc_body_beginning] = ACTIONS(2590),
    [sym_file_descriptor] = ACTIONS(6656),
    [anon_sym_SEMI] = ACTIONS(2595),
    [anon_sym_fi] = ACTIONS(2590),
    [anon_sym_elif] = ACTIONS(2590),
    [anon_sym_else] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(2595),
    [anon_sym_SEMI_SEMI] = ACTIONS(2590),
    [anon_sym_PIPE_AMP] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(6659),
    [anon_sym_GT] = ACTIONS(6659),
    [anon_sym_GT_GT] = ACTIONS(6662),
    [anon_sym_AMP_GT] = ACTIONS(6659),
    [anon_sym_AMP_GT_GT] = ACTIONS(6662),
    [anon_sym_LT_AMP] = ACTIONS(6662),
    [anon_sym_GT_AMP] = ACTIONS(6662),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_LT_LT_DASH] = ACTIONS(2606),
    [anon_sym_LT_LT_LT] = ACTIONS(6665),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2595),
  },
  [2390] = {
    [sym__simple_heredoc_body] = ACTIONS(2612),
    [sym__heredoc_body_beginning] = ACTIONS(2612),
    [sym_file_descriptor] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_fi] = ACTIONS(2614),
    [anon_sym_elif] = ACTIONS(2614),
    [anon_sym_else] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(2614),
    [anon_sym_EQ_EQ] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2612),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2612),
    [anon_sym_BQUOTE] = ACTIONS(2612),
    [anon_sym_LT_LPAREN] = ACTIONS(2612),
    [anon_sym_GT_LPAREN] = ACTIONS(2612),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2614),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [2391] = {
    [aux_sym_concatenation_repeat1] = STATE(1650),
    [sym__simple_heredoc_body] = ACTIONS(2612),
    [sym__heredoc_body_beginning] = ACTIONS(2612),
    [sym_file_descriptor] = ACTIONS(2612),
    [sym__concat] = ACTIONS(3415),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_fi] = ACTIONS(2614),
    [anon_sym_elif] = ACTIONS(2614),
    [anon_sym_else] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(2614),
    [anon_sym_EQ_EQ] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2612),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2612),
    [anon_sym_BQUOTE] = ACTIONS(2612),
    [anon_sym_LT_LPAREN] = ACTIONS(2612),
    [anon_sym_GT_LPAREN] = ACTIONS(2612),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2614),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [2392] = {
    [aux_sym__literal_repeat1] = STATE(1685),
    [sym__simple_heredoc_body] = ACTIONS(2616),
    [sym__heredoc_body_beginning] = ACTIONS(2616),
    [sym_file_descriptor] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_fi] = ACTIONS(2618),
    [anon_sym_elif] = ACTIONS(2618),
    [anon_sym_else] = ACTIONS(2618),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_SEMI_SEMI] = ACTIONS(2616),
    [anon_sym_PIPE_AMP] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_EQ_TILDE] = ACTIONS(2618),
    [anon_sym_EQ_EQ] = ACTIONS(2618),
    [anon_sym_LT] = ACTIONS(2618),
    [anon_sym_GT] = ACTIONS(2618),
    [anon_sym_GT_GT] = ACTIONS(2616),
    [anon_sym_AMP_GT] = ACTIONS(2618),
    [anon_sym_AMP_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_AMP] = ACTIONS(2616),
    [anon_sym_GT_AMP] = ACTIONS(2616),
    [anon_sym_LT_LT] = ACTIONS(2618),
    [anon_sym_LT_LT_DASH] = ACTIONS(2616),
    [anon_sym_LT_LT_LT] = ACTIONS(2616),
    [sym__special_character] = ACTIONS(3471),
    [anon_sym_DQUOTE] = ACTIONS(2616),
    [anon_sym_DOLLAR] = ACTIONS(2618),
    [sym_raw_string] = ACTIONS(2616),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2616),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2616),
    [anon_sym_BQUOTE] = ACTIONS(2616),
    [anon_sym_LT_LPAREN] = ACTIONS(2616),
    [anon_sym_GT_LPAREN] = ACTIONS(2616),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2618),
    [anon_sym_LF] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2618),
  },
  [2393] = {
    [sym_concatenation] = STATE(2393),
    [sym_string] = STATE(1677),
    [sym_simple_expansion] = STATE(1677),
    [sym_string_expansion] = STATE(1677),
    [sym_expansion] = STATE(1677),
    [sym_command_substitution] = STATE(1677),
    [sym_process_substitution] = STATE(1677),
    [aux_sym_command_repeat2] = STATE(2393),
    [aux_sym__literal_repeat1] = STATE(1679),
    [sym__simple_heredoc_body] = ACTIONS(2612),
    [sym__heredoc_body_beginning] = ACTIONS(2612),
    [sym_file_descriptor] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_fi] = ACTIONS(2614),
    [anon_sym_elif] = ACTIONS(2614),
    [anon_sym_else] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(6668),
    [anon_sym_EQ_EQ] = ACTIONS(6668),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(6671),
    [anon_sym_DQUOTE] = ACTIONS(6674),
    [anon_sym_DOLLAR] = ACTIONS(6677),
    [sym_raw_string] = ACTIONS(6680),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6683),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6686),
    [anon_sym_BQUOTE] = ACTIONS(6689),
    [anon_sym_LT_LPAREN] = ACTIONS(6692),
    [anon_sym_GT_LPAREN] = ACTIONS(6692),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6695),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [2394] = {
    [sym_file_descriptor] = ACTIONS(1235),
    [sym_variable_name] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1239),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1239),
    [anon_sym_if] = ACTIONS(1239),
    [anon_sym_fi] = ACTIONS(6249),
    [anon_sym_elif] = ACTIONS(6249),
    [anon_sym_else] = ACTIONS(6249),
    [anon_sym_case] = ACTIONS(1239),
    [anon_sym_function] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1239),
    [anon_sym_typeset] = ACTIONS(1239),
    [anon_sym_export] = ACTIONS(1239),
    [anon_sym_readonly] = ACTIONS(1239),
    [anon_sym_local] = ACTIONS(1239),
    [anon_sym_unset] = ACTIONS(1239),
    [anon_sym_unsetenv] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_AMP_GT] = ACTIONS(1239),
    [anon_sym_AMP_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_AMP] = ACTIONS(1235),
    [anon_sym_GT_AMP] = ACTIONS(1235),
    [sym__special_character] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_DOLLAR] = ACTIONS(1239),
    [sym_raw_string] = ACTIONS(1235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1235),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1235),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [anon_sym_LT_LPAREN] = ACTIONS(1235),
    [anon_sym_GT_LPAREN] = ACTIONS(1235),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1239),
  },
  [2395] = {
    [anon_sym_SEMI] = ACTIONS(6698),
    [anon_sym_fi] = ACTIONS(2586),
    [anon_sym_elif] = ACTIONS(2586),
    [anon_sym_else] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(6700),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6700),
    [anon_sym_AMP] = ACTIONS(6700),
  },
  [2396] = {
    [sym_concatenation] = STATE(2393),
    [sym_string] = STATE(1677),
    [sym_simple_expansion] = STATE(1677),
    [sym_string_expansion] = STATE(1677),
    [sym_expansion] = STATE(1677),
    [sym_command_substitution] = STATE(1677),
    [sym_process_substitution] = STATE(1677),
    [aux_sym_command_repeat2] = STATE(2393),
    [aux_sym__literal_repeat1] = STATE(1679),
    [sym__simple_heredoc_body] = ACTIONS(2676),
    [sym__heredoc_body_beginning] = ACTIONS(2676),
    [sym_file_descriptor] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym_fi] = ACTIONS(2678),
    [anon_sym_elif] = ACTIONS(2678),
    [anon_sym_else] = ACTIONS(2678),
    [anon_sym_PIPE] = ACTIONS(2678),
    [anon_sym_SEMI_SEMI] = ACTIONS(2676),
    [anon_sym_PIPE_AMP] = ACTIONS(2676),
    [anon_sym_AMP_AMP] = ACTIONS(2676),
    [anon_sym_PIPE_PIPE] = ACTIONS(2676),
    [anon_sym_EQ_TILDE] = ACTIONS(3463),
    [anon_sym_EQ_EQ] = ACTIONS(3463),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_GT] = ACTIONS(2678),
    [anon_sym_GT_GT] = ACTIONS(2676),
    [anon_sym_AMP_GT] = ACTIONS(2678),
    [anon_sym_AMP_GT_GT] = ACTIONS(2676),
    [anon_sym_LT_AMP] = ACTIONS(2676),
    [anon_sym_GT_AMP] = ACTIONS(2676),
    [anon_sym_LT_LT] = ACTIONS(2678),
    [anon_sym_LT_LT_DASH] = ACTIONS(2676),
    [anon_sym_LT_LT_LT] = ACTIONS(2676),
    [sym__special_character] = ACTIONS(3465),
    [anon_sym_DQUOTE] = ACTIONS(1814),
    [anon_sym_DOLLAR] = ACTIONS(1816),
    [sym_raw_string] = ACTIONS(3467),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1822),
    [anon_sym_BQUOTE] = ACTIONS(1824),
    [anon_sym_LT_LPAREN] = ACTIONS(1826),
    [anon_sym_GT_LPAREN] = ACTIONS(1826),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3469),
    [anon_sym_LF] = ACTIONS(2676),
    [anon_sym_AMP] = ACTIONS(2678),
  },
  [2397] = {
    [aux_sym_concatenation_repeat1] = STATE(3019),
    [sym__concat] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(1059),
    [anon_sym_RPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
  },
  [2398] = {
    [sym_concatenation] = STATE(3021),
    [sym_string] = STATE(3020),
    [sym_simple_expansion] = STATE(3020),
    [sym_string_expansion] = STATE(3020),
    [sym_expansion] = STATE(3020),
    [sym_command_substitution] = STATE(3020),
    [sym_process_substitution] = STATE(3020),
    [aux_sym__literal_repeat1] = STATE(3022),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(6702),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6702),
  },
  [2399] = {
    [sym__statements] = STATE(3037),
    [sym_redirected_statement] = STATE(3038),
    [sym_for_statement] = STATE(3038),
    [sym_c_style_for_statement] = STATE(3038),
    [sym_while_statement] = STATE(3038),
    [sym_if_statement] = STATE(3038),
    [sym_case_statement] = STATE(3038),
    [sym_function_definition] = STATE(3038),
    [sym_compound_statement] = STATE(3038),
    [sym_subshell] = STATE(3038),
    [sym_pipeline] = STATE(3038),
    [sym_list] = STATE(3038),
    [sym_negated_command] = STATE(3038),
    [sym_test_command] = STATE(3038),
    [sym_declaration_command] = STATE(3038),
    [sym_unset_command] = STATE(3038),
    [sym_command] = STATE(3038),
    [sym_command_name] = STATE(3039),
    [sym_variable_assignment] = STATE(3040),
    [sym_subscript] = STATE(3041),
    [sym_file_redirect] = STATE(3044),
    [sym_concatenation] = STATE(3042),
    [sym_string] = STATE(3031),
    [sym_simple_expansion] = STATE(3031),
    [sym_string_expansion] = STATE(3031),
    [sym_expansion] = STATE(3031),
    [sym_command_substitution] = STATE(3031),
    [sym_process_substitution] = STATE(3031),
    [aux_sym__statements_repeat1] = STATE(3043),
    [aux_sym_command_repeat1] = STATE(3044),
    [aux_sym__literal_repeat1] = STATE(3045),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(6704),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_esac] = ACTIONS(6706),
    [anon_sym_SEMI_SEMI] = ACTIONS(6708),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(6710),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(6712),
    [anon_sym_typeset] = ACTIONS(6712),
    [anon_sym_export] = ACTIONS(6712),
    [anon_sym_readonly] = ACTIONS(6712),
    [anon_sym_local] = ACTIONS(6712),
    [anon_sym_unset] = ACTIONS(6714),
    [anon_sym_unsetenv] = ACTIONS(6714),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(6716),
    [anon_sym_DQUOTE] = ACTIONS(6718),
    [anon_sym_DOLLAR] = ACTIONS(6720),
    [sym_raw_string] = ACTIONS(6722),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6726),
    [anon_sym_BQUOTE] = ACTIONS(6728),
    [anon_sym_LT_LPAREN] = ACTIONS(6730),
    [anon_sym_GT_LPAREN] = ACTIONS(6730),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6732),
  },
  [2400] = {
    [aux_sym_case_item_repeat1] = STATE(3047),
    [anon_sym_PIPE] = ACTIONS(5199),
    [anon_sym_RPAREN] = ACTIONS(6734),
    [sym_comment] = ACTIONS(57),
  },
  [2401] = {
    [sym__simple_heredoc_body] = ACTIONS(6736),
    [sym__heredoc_body_beginning] = ACTIONS(6736),
    [sym_file_descriptor] = ACTIONS(6736),
    [ts_builtin_sym_end] = ACTIONS(6736),
    [anon_sym_SEMI] = ACTIONS(6738),
    [anon_sym_done] = ACTIONS(6736),
    [anon_sym_fi] = ACTIONS(6736),
    [anon_sym_elif] = ACTIONS(6736),
    [anon_sym_else] = ACTIONS(6736),
    [anon_sym_esac] = ACTIONS(6736),
    [anon_sym_PIPE] = ACTIONS(6738),
    [anon_sym_RPAREN] = ACTIONS(6736),
    [anon_sym_SEMI_SEMI] = ACTIONS(6736),
    [anon_sym_PIPE_AMP] = ACTIONS(6736),
    [anon_sym_AMP_AMP] = ACTIONS(6736),
    [anon_sym_PIPE_PIPE] = ACTIONS(6736),
    [anon_sym_LT] = ACTIONS(6738),
    [anon_sym_GT] = ACTIONS(6738),
    [anon_sym_GT_GT] = ACTIONS(6736),
    [anon_sym_AMP_GT] = ACTIONS(6738),
    [anon_sym_AMP_GT_GT] = ACTIONS(6736),
    [anon_sym_LT_AMP] = ACTIONS(6736),
    [anon_sym_GT_AMP] = ACTIONS(6736),
    [anon_sym_LT_LT] = ACTIONS(6738),
    [anon_sym_LT_LT_DASH] = ACTIONS(6736),
    [anon_sym_LT_LT_LT] = ACTIONS(6736),
    [anon_sym_BQUOTE] = ACTIONS(6736),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6736),
    [anon_sym_AMP] = ACTIONS(6738),
  },
  [2402] = {
    [anon_sym_esac] = ACTIONS(6740),
    [sym_comment] = ACTIONS(57),
  },
  [2403] = {
    [sym_case_item] = STATE(2403),
    [sym_concatenation] = STATE(3050),
    [sym_string] = STATE(3049),
    [sym_simple_expansion] = STATE(3049),
    [sym_string_expansion] = STATE(3049),
    [sym_expansion] = STATE(3049),
    [sym_command_substitution] = STATE(3049),
    [sym_process_substitution] = STATE(3049),
    [aux_sym_case_statement_repeat1] = STATE(2403),
    [aux_sym__literal_repeat1] = STATE(3051),
    [sym__special_character] = ACTIONS(6742),
    [anon_sym_DQUOTE] = ACTIONS(6745),
    [anon_sym_DOLLAR] = ACTIONS(6748),
    [sym_raw_string] = ACTIONS(6751),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6754),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6757),
    [anon_sym_BQUOTE] = ACTIONS(6760),
    [anon_sym_LT_LPAREN] = ACTIONS(6763),
    [anon_sym_GT_LPAREN] = ACTIONS(6763),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6751),
  },
  [2404] = {
    [sym__statements] = STATE(3053),
    [sym_redirected_statement] = STATE(3038),
    [sym_for_statement] = STATE(3038),
    [sym_c_style_for_statement] = STATE(3038),
    [sym_while_statement] = STATE(3038),
    [sym_if_statement] = STATE(3038),
    [sym_case_statement] = STATE(3038),
    [sym_function_definition] = STATE(3038),
    [sym_compound_statement] = STATE(3038),
    [sym_subshell] = STATE(3038),
    [sym_pipeline] = STATE(3038),
    [sym_list] = STATE(3038),
    [sym_negated_command] = STATE(3038),
    [sym_test_command] = STATE(3038),
    [sym_declaration_command] = STATE(3038),
    [sym_unset_command] = STATE(3038),
    [sym_command] = STATE(3038),
    [sym_command_name] = STATE(3039),
    [sym_variable_assignment] = STATE(3040),
    [sym_subscript] = STATE(3041),
    [sym_file_redirect] = STATE(3044),
    [sym_concatenation] = STATE(3042),
    [sym_string] = STATE(3031),
    [sym_simple_expansion] = STATE(3031),
    [sym_string_expansion] = STATE(3031),
    [sym_expansion] = STATE(3031),
    [sym_command_substitution] = STATE(3031),
    [sym_process_substitution] = STATE(3031),
    [aux_sym__statements_repeat1] = STATE(3043),
    [aux_sym_command_repeat1] = STATE(3044),
    [aux_sym__literal_repeat1] = STATE(3045),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(6704),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_esac] = ACTIONS(6766),
    [anon_sym_SEMI_SEMI] = ACTIONS(6768),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(6710),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(6712),
    [anon_sym_typeset] = ACTIONS(6712),
    [anon_sym_export] = ACTIONS(6712),
    [anon_sym_readonly] = ACTIONS(6712),
    [anon_sym_local] = ACTIONS(6712),
    [anon_sym_unset] = ACTIONS(6714),
    [anon_sym_unsetenv] = ACTIONS(6714),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(6716),
    [anon_sym_DQUOTE] = ACTIONS(6718),
    [anon_sym_DOLLAR] = ACTIONS(6720),
    [sym_raw_string] = ACTIONS(6722),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6726),
    [anon_sym_BQUOTE] = ACTIONS(6728),
    [anon_sym_LT_LPAREN] = ACTIONS(6730),
    [anon_sym_GT_LPAREN] = ACTIONS(6730),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6732),
  },
  [2405] = {
    [aux_sym_case_item_repeat1] = STATE(3047),
    [anon_sym_PIPE] = ACTIONS(5199),
    [anon_sym_RPAREN] = ACTIONS(6770),
    [sym_comment] = ACTIONS(57),
  },
  [2406] = {
    [aux_sym__literal_repeat1] = STATE(2406),
    [anon_sym_PIPE] = ACTIONS(1371),
    [anon_sym_RPAREN] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(2907),
    [sym_comment] = ACTIONS(57),
  },
  [2407] = {
    [sym_case_item] = STATE(2403),
    [sym_last_case_item] = STATE(3055),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(2403),
    [aux_sym__literal_repeat1] = STATE(1693),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3482),
  },
  [2408] = {
    [sym__concat] = ACTIONS(5564),
    [anon_sym_in] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5564),
  },
  [2409] = {
    [sym__concat] = ACTIONS(5598),
    [anon_sym_in] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5598),
  },
  [2410] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(6772),
    [sym_comment] = ACTIONS(57),
  },
  [2411] = {
    [anon_sym_RBRACE] = ACTIONS(6772),
    [sym_comment] = ACTIONS(57),
  },
  [2412] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(6774),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2413] = {
    [sym_concatenation] = STATE(3059),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3059),
    [anon_sym_RBRACE] = ACTIONS(6776),
    [anon_sym_EQ] = ACTIONS(6778),
    [anon_sym_DASH] = ACTIONS(6778),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6780),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6778),
    [anon_sym_COLON_QMARK] = ACTIONS(6778),
    [anon_sym_COLON_DASH] = ACTIONS(6778),
    [anon_sym_PERCENT] = ACTIONS(6778),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2414] = {
    [sym__concat] = ACTIONS(5615),
    [anon_sym_in] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5615),
  },
  [2415] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6776),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2416] = {
    [sym_concatenation] = STATE(3060),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3060),
    [anon_sym_RBRACE] = ACTIONS(6772),
    [anon_sym_EQ] = ACTIONS(6782),
    [anon_sym_DASH] = ACTIONS(6782),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6782),
    [anon_sym_COLON_QMARK] = ACTIONS(6782),
    [anon_sym_COLON_DASH] = ACTIONS(6782),
    [anon_sym_PERCENT] = ACTIONS(6782),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2417] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6772),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2418] = {
    [sym__concat] = ACTIONS(5658),
    [anon_sym_in] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5658),
  },
  [2419] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6786),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2420] = {
    [sym__simple_heredoc_body] = ACTIONS(6788),
    [sym__heredoc_body_beginning] = ACTIONS(6788),
    [sym_file_descriptor] = ACTIONS(6788),
    [ts_builtin_sym_end] = ACTIONS(6788),
    [anon_sym_SEMI] = ACTIONS(6790),
    [anon_sym_done] = ACTIONS(6788),
    [anon_sym_fi] = ACTIONS(6788),
    [anon_sym_elif] = ACTIONS(6788),
    [anon_sym_else] = ACTIONS(6788),
    [anon_sym_esac] = ACTIONS(6788),
    [anon_sym_PIPE] = ACTIONS(6790),
    [anon_sym_RPAREN] = ACTIONS(6788),
    [anon_sym_SEMI_SEMI] = ACTIONS(6788),
    [anon_sym_PIPE_AMP] = ACTIONS(6788),
    [anon_sym_AMP_AMP] = ACTIONS(6788),
    [anon_sym_PIPE_PIPE] = ACTIONS(6788),
    [anon_sym_LT] = ACTIONS(6790),
    [anon_sym_GT] = ACTIONS(6790),
    [anon_sym_GT_GT] = ACTIONS(6788),
    [anon_sym_AMP_GT] = ACTIONS(6790),
    [anon_sym_AMP_GT_GT] = ACTIONS(6788),
    [anon_sym_LT_AMP] = ACTIONS(6788),
    [anon_sym_GT_AMP] = ACTIONS(6788),
    [anon_sym_LT_LT] = ACTIONS(6790),
    [anon_sym_LT_LT_DASH] = ACTIONS(6788),
    [anon_sym_LT_LT_LT] = ACTIONS(6788),
    [anon_sym_BQUOTE] = ACTIONS(6788),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6788),
    [anon_sym_AMP] = ACTIONS(6790),
  },
  [2421] = {
    [anon_sym_esac] = ACTIONS(6792),
    [sym_comment] = ACTIONS(57),
  },
  [2422] = {
    [sym_case_item] = STATE(2403),
    [sym_last_case_item] = STATE(3063),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(2403),
    [aux_sym__literal_repeat1] = STATE(1693),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3482),
  },
  [2423] = {
    [aux_sym_concatenation_repeat1] = STATE(2423),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(4416),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_RPAREN] = ACTIONS(2344),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2424] = {
    [aux_sym_concatenation_repeat1] = STATE(2424),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2348),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_RPAREN] = ACTIONS(2344),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2425] = {
    [sym__simple_heredoc_body] = ACTIONS(4383),
    [sym__heredoc_body_beginning] = ACTIONS(4383),
    [sym_file_descriptor] = ACTIONS(4383),
    [sym_variable_name] = ACTIONS(4383),
    [anon_sym_SEMI] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI_SEMI] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_PIPE_AMP] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_AMP_GT] = ACTIONS(4385),
    [anon_sym_AMP_GT_GT] = ACTIONS(4383),
    [anon_sym_LT_AMP] = ACTIONS(4383),
    [anon_sym_GT_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_LT_LT_DASH] = ACTIONS(4383),
    [anon_sym_LT_LT_LT] = ACTIONS(4383),
    [sym__special_character] = ACTIONS(4385),
    [anon_sym_DQUOTE] = ACTIONS(4383),
    [anon_sym_DOLLAR] = ACTIONS(4385),
    [sym_raw_string] = ACTIONS(4383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4383),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4383),
    [anon_sym_BQUOTE] = ACTIONS(4383),
    [anon_sym_LT_LPAREN] = ACTIONS(4383),
    [anon_sym_GT_LPAREN] = ACTIONS(4383),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4385),
    [anon_sym_LF] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
  },
  [2426] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2346),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2427] = {
    [aux_sym_concatenation_repeat1] = STATE(2427),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(6794),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2346),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2428] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [sym_variable_name] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_RBRACE] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2353),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [2429] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(6797),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [2430] = {
    [sym_concatenation] = STATE(3067),
    [sym_string] = STATE(3066),
    [sym_simple_expansion] = STATE(3066),
    [sym_string_expansion] = STATE(3066),
    [sym_expansion] = STATE(3066),
    [sym_command_substitution] = STATE(3066),
    [sym_process_substitution] = STATE(3066),
    [aux_sym__literal_repeat1] = STATE(3068),
    [anon_sym_RBRACE] = ACTIONS(6799),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(6801),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6801),
  },
  [2431] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(6803),
    [sym_comment] = ACTIONS(57),
  },
  [2432] = {
    [sym_concatenation] = STATE(3072),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3072),
    [anon_sym_RBRACE] = ACTIONS(6805),
    [anon_sym_EQ] = ACTIONS(6807),
    [anon_sym_DASH] = ACTIONS(6807),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6809),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(6811),
    [anon_sym_COLON] = ACTIONS(6807),
    [anon_sym_COLON_QMARK] = ACTIONS(6807),
    [anon_sym_COLON_DASH] = ACTIONS(6807),
    [anon_sym_PERCENT] = ACTIONS(6807),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2433] = {
    [sym_concatenation] = STATE(3074),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3074),
    [anon_sym_RBRACE] = ACTIONS(6799),
    [anon_sym_EQ] = ACTIONS(6813),
    [anon_sym_DASH] = ACTIONS(6813),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6815),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(6817),
    [anon_sym_COLON] = ACTIONS(6813),
    [anon_sym_COLON_QMARK] = ACTIONS(6813),
    [anon_sym_COLON_DASH] = ACTIONS(6813),
    [anon_sym_PERCENT] = ACTIONS(6813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2434] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [sym_variable_name] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_RBRACE] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2444),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [2435] = {
    [sym_concatenation] = STATE(3077),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3077),
    [sym_regex] = ACTIONS(6819),
    [anon_sym_RBRACE] = ACTIONS(6821),
    [anon_sym_EQ] = ACTIONS(6823),
    [anon_sym_DASH] = ACTIONS(6823),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6825),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6823),
    [anon_sym_COLON_QMARK] = ACTIONS(6823),
    [anon_sym_COLON_DASH] = ACTIONS(6823),
    [anon_sym_PERCENT] = ACTIONS(6823),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2436] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6821),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2437] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [sym_variable_name] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_RBRACE] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2494),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [2438] = {
    [sym_concatenation] = STATE(3074),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3074),
    [sym_regex] = ACTIONS(6827),
    [anon_sym_RBRACE] = ACTIONS(6799),
    [anon_sym_EQ] = ACTIONS(6813),
    [anon_sym_DASH] = ACTIONS(6813),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6815),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6813),
    [anon_sym_COLON_QMARK] = ACTIONS(6813),
    [anon_sym_COLON_DASH] = ACTIONS(6813),
    [anon_sym_PERCENT] = ACTIONS(6813),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2439] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6799),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2440] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [sym_variable_name] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_RBRACE] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2502),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [2441] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_RBRACE] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [2442] = {
    [sym_do_group] = STATE(3080),
    [sym_compound_statement] = STATE(3080),
    [anon_sym_SEMI] = ACTIONS(6829),
    [anon_sym_do] = ACTIONS(1945),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [2443] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(6831),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [2444] = {
    [sym__expression] = STATE(3082),
    [sym_binary_expression] = STATE(3082),
    [sym_unary_expression] = STATE(3082),
    [sym_postfix_expression] = STATE(3082),
    [sym_parenthesized_expression] = STATE(3082),
    [sym_concatenation] = STATE(3082),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(6831),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_character] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [2445] = {
    [anon_sym_SEMI] = ACTIONS(6833),
    [anon_sym_SEMI_SEMI] = ACTIONS(6835),
    [anon_sym_AMP_AMP] = ACTIONS(1482),
    [anon_sym_PIPE_PIPE] = ACTIONS(1482),
    [anon_sym_EQ_TILDE] = ACTIONS(1484),
    [anon_sym_EQ_EQ] = ACTIONS(1484),
    [anon_sym_EQ] = ACTIONS(1486),
    [anon_sym_PLUS_EQ] = ACTIONS(1482),
    [anon_sym_LT] = ACTIONS(1486),
    [anon_sym_GT] = ACTIONS(1486),
    [anon_sym_BANG_EQ] = ACTIONS(1482),
    [anon_sym_PLUS] = ACTIONS(1486),
    [anon_sym_DASH] = ACTIONS(1486),
    [anon_sym_DASH_EQ] = ACTIONS(1482),
    [anon_sym_LT_EQ] = ACTIONS(1482),
    [anon_sym_GT_EQ] = ACTIONS(1482),
    [anon_sym_PLUS_PLUS] = ACTIONS(1488),
    [anon_sym_DASH_DASH] = ACTIONS(1488),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(1482),
    [anon_sym_LF] = ACTIONS(6835),
    [anon_sym_AMP] = ACTIONS(6833),
  },
  [2446] = {
    [sym_do_group] = STATE(3084),
    [anon_sym_do] = ACTIONS(1945),
    [sym_comment] = ACTIONS(57),
  },
  [2447] = {
    [sym__simple_heredoc_body] = ACTIONS(4902),
    [sym__heredoc_body_beginning] = ACTIONS(4902),
    [sym_file_descriptor] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(4904),
    [anon_sym_PIPE] = ACTIONS(4904),
    [anon_sym_SEMI_SEMI] = ACTIONS(4902),
    [anon_sym_RBRACE] = ACTIONS(4902),
    [anon_sym_PIPE_AMP] = ACTIONS(4902),
    [anon_sym_AMP_AMP] = ACTIONS(4902),
    [anon_sym_PIPE_PIPE] = ACTIONS(4902),
    [anon_sym_LT] = ACTIONS(4904),
    [anon_sym_GT] = ACTIONS(4904),
    [anon_sym_GT_GT] = ACTIONS(4902),
    [anon_sym_AMP_GT] = ACTIONS(4904),
    [anon_sym_AMP_GT_GT] = ACTIONS(4902),
    [anon_sym_LT_AMP] = ACTIONS(4902),
    [anon_sym_GT_AMP] = ACTIONS(4902),
    [anon_sym_LT_LT] = ACTIONS(4904),
    [anon_sym_LT_LT_DASH] = ACTIONS(4902),
    [anon_sym_LT_LT_LT] = ACTIONS(4902),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4902),
    [anon_sym_AMP] = ACTIONS(4904),
  },
  [2448] = {
    [sym__simple_heredoc_body] = ACTIONS(5159),
    [sym__heredoc_body_beginning] = ACTIONS(5159),
    [sym_file_descriptor] = ACTIONS(5159),
    [anon_sym_SEMI] = ACTIONS(5161),
    [anon_sym_PIPE] = ACTIONS(5161),
    [anon_sym_SEMI_SEMI] = ACTIONS(5159),
    [anon_sym_RBRACE] = ACTIONS(5159),
    [anon_sym_PIPE_AMP] = ACTIONS(5159),
    [anon_sym_AMP_AMP] = ACTIONS(5159),
    [anon_sym_PIPE_PIPE] = ACTIONS(5159),
    [anon_sym_LT] = ACTIONS(5161),
    [anon_sym_GT] = ACTIONS(5161),
    [anon_sym_GT_GT] = ACTIONS(5159),
    [anon_sym_AMP_GT] = ACTIONS(5161),
    [anon_sym_AMP_GT_GT] = ACTIONS(5159),
    [anon_sym_LT_AMP] = ACTIONS(5159),
    [anon_sym_GT_AMP] = ACTIONS(5159),
    [anon_sym_LT_LT] = ACTIONS(5161),
    [anon_sym_LT_LT_DASH] = ACTIONS(5159),
    [anon_sym_LT_LT_LT] = ACTIONS(5159),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5159),
    [anon_sym_AMP] = ACTIONS(5161),
  },
  [2449] = {
    [anon_sym_fi] = ACTIONS(6837),
    [sym_comment] = ACTIONS(57),
  },
  [2450] = {
    [sym_elif_clause] = STATE(1682),
    [sym_else_clause] = STATE(3086),
    [aux_sym_if_statement_repeat1] = STATE(1682),
    [anon_sym_fi] = ACTIONS(6837),
    [anon_sym_elif] = ACTIONS(3441),
    [anon_sym_else] = ACTIONS(3443),
    [sym_comment] = ACTIONS(57),
  },
  [2451] = {
    [sym__simple_heredoc_body] = ACTIONS(5195),
    [sym__heredoc_body_beginning] = ACTIONS(5195),
    [sym_file_descriptor] = ACTIONS(5195),
    [anon_sym_SEMI] = ACTIONS(5197),
    [anon_sym_PIPE] = ACTIONS(5197),
    [anon_sym_SEMI_SEMI] = ACTIONS(5195),
    [anon_sym_RBRACE] = ACTIONS(5195),
    [anon_sym_PIPE_AMP] = ACTIONS(5195),
    [anon_sym_AMP_AMP] = ACTIONS(5195),
    [anon_sym_PIPE_PIPE] = ACTIONS(5195),
    [anon_sym_LT] = ACTIONS(5197),
    [anon_sym_GT] = ACTIONS(5197),
    [anon_sym_GT_GT] = ACTIONS(5195),
    [anon_sym_AMP_GT] = ACTIONS(5197),
    [anon_sym_AMP_GT_GT] = ACTIONS(5195),
    [anon_sym_LT_AMP] = ACTIONS(5195),
    [anon_sym_GT_AMP] = ACTIONS(5195),
    [anon_sym_LT_LT] = ACTIONS(5197),
    [anon_sym_LT_LT_DASH] = ACTIONS(5195),
    [anon_sym_LT_LT_LT] = ACTIONS(5195),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5195),
    [anon_sym_AMP] = ACTIONS(5197),
  },
  [2452] = {
    [anon_sym_esac] = ACTIONS(6839),
    [sym_comment] = ACTIONS(57),
  },
  [2453] = {
    [sym_case_item] = STATE(2403),
    [sym_last_case_item] = STATE(3088),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(2403),
    [aux_sym__literal_repeat1] = STATE(1693),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3482),
  },
  [2454] = {
    [sym_case_item] = STATE(3089),
    [sym_last_case_item] = STATE(3088),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(3089),
    [aux_sym__literal_repeat1] = STATE(1693),
    [anon_sym_esac] = ACTIONS(6841),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3484),
  },
  [2455] = {
    [sym__simple_heredoc_body] = ACTIONS(5235),
    [sym__heredoc_body_beginning] = ACTIONS(5235),
    [sym_file_descriptor] = ACTIONS(5235),
    [anon_sym_SEMI] = ACTIONS(5237),
    [anon_sym_PIPE] = ACTIONS(5237),
    [anon_sym_SEMI_SEMI] = ACTIONS(5235),
    [anon_sym_RBRACE] = ACTIONS(5235),
    [anon_sym_PIPE_AMP] = ACTIONS(5235),
    [anon_sym_AMP_AMP] = ACTIONS(5235),
    [anon_sym_PIPE_PIPE] = ACTIONS(5235),
    [anon_sym_LT] = ACTIONS(5237),
    [anon_sym_GT] = ACTIONS(5237),
    [anon_sym_GT_GT] = ACTIONS(5235),
    [anon_sym_AMP_GT] = ACTIONS(5237),
    [anon_sym_AMP_GT_GT] = ACTIONS(5235),
    [anon_sym_LT_AMP] = ACTIONS(5235),
    [anon_sym_GT_AMP] = ACTIONS(5235),
    [anon_sym_LT_LT] = ACTIONS(5237),
    [anon_sym_LT_LT_DASH] = ACTIONS(5235),
    [anon_sym_LT_LT_LT] = ACTIONS(5235),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5235),
    [anon_sym_AMP] = ACTIONS(5237),
  },
  [2456] = {
    [anon_sym_esac] = ACTIONS(6843),
    [sym_comment] = ACTIONS(57),
  },
  [2457] = {
    [sym_case_item] = STATE(2403),
    [sym_last_case_item] = STATE(3091),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(2403),
    [aux_sym__literal_repeat1] = STATE(1693),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3482),
  },
  [2458] = {
    [sym_case_item] = STATE(3092),
    [sym_last_case_item] = STATE(3091),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(3092),
    [aux_sym__literal_repeat1] = STATE(1693),
    [anon_sym_esac] = ACTIONS(6845),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3484),
  },
  [2459] = {
    [sym__simple_heredoc_body] = ACTIONS(5243),
    [sym__heredoc_body_beginning] = ACTIONS(5243),
    [sym_file_descriptor] = ACTIONS(5243),
    [anon_sym_SEMI] = ACTIONS(5245),
    [anon_sym_PIPE] = ACTIONS(5245),
    [anon_sym_SEMI_SEMI] = ACTIONS(5243),
    [anon_sym_RBRACE] = ACTIONS(5243),
    [anon_sym_PIPE_AMP] = ACTIONS(5243),
    [anon_sym_AMP_AMP] = ACTIONS(5243),
    [anon_sym_PIPE_PIPE] = ACTIONS(5243),
    [anon_sym_LT] = ACTIONS(5245),
    [anon_sym_GT] = ACTIONS(5245),
    [anon_sym_GT_GT] = ACTIONS(5243),
    [anon_sym_AMP_GT] = ACTIONS(5245),
    [anon_sym_AMP_GT_GT] = ACTIONS(5243),
    [anon_sym_LT_AMP] = ACTIONS(5243),
    [anon_sym_GT_AMP] = ACTIONS(5243),
    [anon_sym_LT_LT] = ACTIONS(5245),
    [anon_sym_LT_LT_DASH] = ACTIONS(5243),
    [anon_sym_LT_LT_LT] = ACTIONS(5243),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5243),
    [anon_sym_AMP] = ACTIONS(5245),
  },
  [2460] = {
    [sym__simple_heredoc_body] = ACTIONS(2697),
    [sym__heredoc_body_beginning] = ACTIONS(2697),
    [sym_file_descriptor] = ACTIONS(2697),
    [sym_variable_name] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI_SEMI] = ACTIONS(2697),
    [anon_sym_RBRACE] = ACTIONS(2697),
    [anon_sym_PIPE_AMP] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_PIPE_PIPE] = ACTIONS(2697),
    [anon_sym_LT] = ACTIONS(2699),
    [anon_sym_GT] = ACTIONS(2699),
    [anon_sym_GT_GT] = ACTIONS(2697),
    [anon_sym_AMP_GT] = ACTIONS(2699),
    [anon_sym_AMP_GT_GT] = ACTIONS(2697),
    [anon_sym_LT_AMP] = ACTIONS(2697),
    [anon_sym_GT_AMP] = ACTIONS(2697),
    [anon_sym_LT_LT] = ACTIONS(2699),
    [anon_sym_LT_LT_DASH] = ACTIONS(2697),
    [anon_sym_LT_LT_LT] = ACTIONS(2697),
    [sym__special_character] = ACTIONS(2699),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [anon_sym_DOLLAR] = ACTIONS(2699),
    [sym_raw_string] = ACTIONS(2697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2697),
    [anon_sym_BQUOTE] = ACTIONS(2697),
    [anon_sym_LT_LPAREN] = ACTIONS(2697),
    [anon_sym_GT_LPAREN] = ACTIONS(2697),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2699),
    [sym_word] = ACTIONS(2699),
    [anon_sym_LF] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
  },
  [2461] = {
    [sym_concatenation] = STATE(1357),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(1357),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(6847),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [2462] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [sym_variable_name] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_RBRACE] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4055),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4055),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [2463] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [sym_variable_name] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_RBRACE] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4069),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [2464] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(6849),
    [sym_comment] = ACTIONS(57),
  },
  [2465] = {
    [anon_sym_RBRACE] = ACTIONS(6849),
    [sym_comment] = ACTIONS(57),
  },
  [2466] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(6851),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2467] = {
    [sym_concatenation] = STATE(3097),
    [sym_string] = STATE(3096),
    [sym_simple_expansion] = STATE(3096),
    [sym_string_expansion] = STATE(3096),
    [sym_expansion] = STATE(3096),
    [sym_command_substitution] = STATE(3096),
    [sym_process_substitution] = STATE(3096),
    [aux_sym__literal_repeat1] = STATE(3098),
    [anon_sym_RBRACE] = ACTIONS(6849),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(6853),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6853),
  },
  [2468] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [sym_variable_name] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_RBRACE] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4105),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4105),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [2469] = {
    [sym_concatenation] = STATE(3101),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3101),
    [sym_regex] = ACTIONS(6855),
    [anon_sym_RBRACE] = ACTIONS(6857),
    [anon_sym_EQ] = ACTIONS(6859),
    [anon_sym_DASH] = ACTIONS(6859),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6859),
    [anon_sym_COLON_QMARK] = ACTIONS(6859),
    [anon_sym_COLON_DASH] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6859),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2470] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6857),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2471] = {
    [sym_concatenation] = STATE(3103),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3103),
    [sym_regex] = ACTIONS(6863),
    [anon_sym_RBRACE] = ACTIONS(6849),
    [anon_sym_EQ] = ACTIONS(6865),
    [anon_sym_DASH] = ACTIONS(6865),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6867),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6865),
    [anon_sym_COLON_QMARK] = ACTIONS(6865),
    [anon_sym_COLON_DASH] = ACTIONS(6865),
    [anon_sym_PERCENT] = ACTIONS(6865),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2472] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6849),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2473] = {
    [sym_concatenation] = STATE(3105),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3105),
    [anon_sym_RBRACE] = ACTIONS(6869),
    [anon_sym_EQ] = ACTIONS(6871),
    [anon_sym_DASH] = ACTIONS(6871),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6871),
    [anon_sym_COLON_QMARK] = ACTIONS(6871),
    [anon_sym_COLON_DASH] = ACTIONS(6871),
    [anon_sym_PERCENT] = ACTIONS(6871),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2474] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [sym_variable_name] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_RBRACE] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4161),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [2475] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6869),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2476] = {
    [sym_concatenation] = STATE(3103),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3103),
    [anon_sym_RBRACE] = ACTIONS(6849),
    [anon_sym_EQ] = ACTIONS(6865),
    [anon_sym_DASH] = ACTIONS(6865),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6867),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6865),
    [anon_sym_COLON_QMARK] = ACTIONS(6865),
    [anon_sym_COLON_DASH] = ACTIONS(6865),
    [anon_sym_PERCENT] = ACTIONS(6865),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2477] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_RBRACE] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4055),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4055),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [2478] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_RBRACE] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4069),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [2479] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(6875),
    [sym_comment] = ACTIONS(57),
  },
  [2480] = {
    [anon_sym_RBRACE] = ACTIONS(6875),
    [sym_comment] = ACTIONS(57),
  },
  [2481] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(6877),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2482] = {
    [sym_concatenation] = STATE(3109),
    [sym_string] = STATE(3108),
    [sym_simple_expansion] = STATE(3108),
    [sym_string_expansion] = STATE(3108),
    [sym_expansion] = STATE(3108),
    [sym_command_substitution] = STATE(3108),
    [sym_process_substitution] = STATE(3108),
    [aux_sym__literal_repeat1] = STATE(3110),
    [anon_sym_RBRACE] = ACTIONS(6875),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(6879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6879),
  },
  [2483] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_RBRACE] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4105),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4105),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [2484] = {
    [sym_concatenation] = STATE(3113),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3113),
    [sym_regex] = ACTIONS(6881),
    [anon_sym_RBRACE] = ACTIONS(6883),
    [anon_sym_EQ] = ACTIONS(6885),
    [anon_sym_DASH] = ACTIONS(6885),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6887),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6885),
    [anon_sym_COLON_QMARK] = ACTIONS(6885),
    [anon_sym_COLON_DASH] = ACTIONS(6885),
    [anon_sym_PERCENT] = ACTIONS(6885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2485] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6883),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2486] = {
    [sym_concatenation] = STATE(3115),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3115),
    [sym_regex] = ACTIONS(6889),
    [anon_sym_RBRACE] = ACTIONS(6875),
    [anon_sym_EQ] = ACTIONS(6891),
    [anon_sym_DASH] = ACTIONS(6891),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6891),
    [anon_sym_COLON_QMARK] = ACTIONS(6891),
    [anon_sym_COLON_DASH] = ACTIONS(6891),
    [anon_sym_PERCENT] = ACTIONS(6891),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2487] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6875),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2488] = {
    [sym_concatenation] = STATE(3117),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3117),
    [anon_sym_RBRACE] = ACTIONS(6895),
    [anon_sym_EQ] = ACTIONS(6897),
    [anon_sym_DASH] = ACTIONS(6897),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6897),
    [anon_sym_COLON_QMARK] = ACTIONS(6897),
    [anon_sym_COLON_DASH] = ACTIONS(6897),
    [anon_sym_PERCENT] = ACTIONS(6897),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2489] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_RBRACE] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4161),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [2490] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6895),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2491] = {
    [sym_concatenation] = STATE(3115),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3115),
    [anon_sym_RBRACE] = ACTIONS(6875),
    [anon_sym_EQ] = ACTIONS(6891),
    [anon_sym_DASH] = ACTIONS(6891),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6893),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6891),
    [anon_sym_COLON_QMARK] = ACTIONS(6891),
    [anon_sym_COLON_DASH] = ACTIONS(6891),
    [anon_sym_PERCENT] = ACTIONS(6891),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2492] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_RBRACE] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5566),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5566),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [2493] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_RBRACE] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_EQ_TILDE] = ACTIONS(5600),
    [anon_sym_EQ_EQ] = ACTIONS(5600),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5600),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [2494] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(6901),
    [sym_comment] = ACTIONS(57),
  },
  [2495] = {
    [anon_sym_RBRACE] = ACTIONS(6901),
    [sym_comment] = ACTIONS(57),
  },
  [2496] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(6903),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2497] = {
    [sym_concatenation] = STATE(3121),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3121),
    [anon_sym_RBRACE] = ACTIONS(6905),
    [anon_sym_EQ] = ACTIONS(6907),
    [anon_sym_DASH] = ACTIONS(6907),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6909),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6907),
    [anon_sym_COLON_QMARK] = ACTIONS(6907),
    [anon_sym_COLON_DASH] = ACTIONS(6907),
    [anon_sym_PERCENT] = ACTIONS(6907),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2498] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_RBRACE] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_EQ_TILDE] = ACTIONS(5617),
    [anon_sym_EQ_EQ] = ACTIONS(5617),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5617),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [2499] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6905),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2500] = {
    [sym_concatenation] = STATE(3122),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3122),
    [anon_sym_RBRACE] = ACTIONS(6901),
    [anon_sym_EQ] = ACTIONS(6911),
    [anon_sym_DASH] = ACTIONS(6911),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6913),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6911),
    [anon_sym_COLON_QMARK] = ACTIONS(6911),
    [anon_sym_COLON_DASH] = ACTIONS(6911),
    [anon_sym_PERCENT] = ACTIONS(6911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2501] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6901),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2502] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_RBRACE] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_EQ_TILDE] = ACTIONS(5660),
    [anon_sym_EQ_EQ] = ACTIONS(5660),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5660),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [2503] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6915),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2504] = {
    [aux_sym_concatenation_repeat1] = STATE(2504),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(3784),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2505] = {
    [sym_file_descriptor] = ACTIONS(4383),
    [sym_variable_name] = ACTIONS(4383),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_AMP_GT] = ACTIONS(4385),
    [anon_sym_AMP_GT_GT] = ACTIONS(4383),
    [anon_sym_LT_AMP] = ACTIONS(4383),
    [anon_sym_GT_AMP] = ACTIONS(4383),
    [sym__special_character] = ACTIONS(4383),
    [anon_sym_DQUOTE] = ACTIONS(4383),
    [anon_sym_DOLLAR] = ACTIONS(4385),
    [sym_raw_string] = ACTIONS(4383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4383),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4383),
    [anon_sym_BQUOTE] = ACTIONS(4383),
    [anon_sym_LT_LPAREN] = ACTIONS(4383),
    [anon_sym_GT_LPAREN] = ACTIONS(4383),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4383),
  },
  [2506] = {
    [sym__concat] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_RBRACK] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5564),
    [anon_sym_EQ_EQ] = ACTIONS(5564),
    [anon_sym_EQ] = ACTIONS(5566),
    [anon_sym_PLUS_EQ] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5564),
    [anon_sym_PLUS] = ACTIONS(5566),
    [anon_sym_DASH] = ACTIONS(5566),
    [anon_sym_DASH_EQ] = ACTIONS(5564),
    [anon_sym_LT_EQ] = ACTIONS(5564),
    [anon_sym_GT_EQ] = ACTIONS(5564),
    [anon_sym_PLUS_PLUS] = ACTIONS(5564),
    [anon_sym_DASH_DASH] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5564),
  },
  [2507] = {
    [sym__concat] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_RBRACK] = ACTIONS(5598),
    [anon_sym_EQ_TILDE] = ACTIONS(5598),
    [anon_sym_EQ_EQ] = ACTIONS(5598),
    [anon_sym_EQ] = ACTIONS(5600),
    [anon_sym_PLUS_EQ] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_BANG_EQ] = ACTIONS(5598),
    [anon_sym_PLUS] = ACTIONS(5600),
    [anon_sym_DASH] = ACTIONS(5600),
    [anon_sym_DASH_EQ] = ACTIONS(5598),
    [anon_sym_LT_EQ] = ACTIONS(5598),
    [anon_sym_GT_EQ] = ACTIONS(5598),
    [anon_sym_PLUS_PLUS] = ACTIONS(5598),
    [anon_sym_DASH_DASH] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5598),
  },
  [2508] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(6917),
    [sym_comment] = ACTIONS(57),
  },
  [2509] = {
    [anon_sym_RBRACE] = ACTIONS(6917),
    [sym_comment] = ACTIONS(57),
  },
  [2510] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(6919),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2511] = {
    [sym_concatenation] = STATE(3127),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3127),
    [anon_sym_RBRACE] = ACTIONS(6921),
    [anon_sym_EQ] = ACTIONS(6923),
    [anon_sym_DASH] = ACTIONS(6923),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6925),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6923),
    [anon_sym_COLON_QMARK] = ACTIONS(6923),
    [anon_sym_COLON_DASH] = ACTIONS(6923),
    [anon_sym_PERCENT] = ACTIONS(6923),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2512] = {
    [sym__concat] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_RBRACK] = ACTIONS(5615),
    [anon_sym_EQ_TILDE] = ACTIONS(5615),
    [anon_sym_EQ_EQ] = ACTIONS(5615),
    [anon_sym_EQ] = ACTIONS(5617),
    [anon_sym_PLUS_EQ] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_BANG_EQ] = ACTIONS(5615),
    [anon_sym_PLUS] = ACTIONS(5617),
    [anon_sym_DASH] = ACTIONS(5617),
    [anon_sym_DASH_EQ] = ACTIONS(5615),
    [anon_sym_LT_EQ] = ACTIONS(5615),
    [anon_sym_GT_EQ] = ACTIONS(5615),
    [anon_sym_PLUS_PLUS] = ACTIONS(5615),
    [anon_sym_DASH_DASH] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5615),
  },
  [2513] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6921),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2514] = {
    [sym_concatenation] = STATE(3128),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3128),
    [anon_sym_RBRACE] = ACTIONS(6917),
    [anon_sym_EQ] = ACTIONS(6927),
    [anon_sym_DASH] = ACTIONS(6927),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6927),
    [anon_sym_COLON_QMARK] = ACTIONS(6927),
    [anon_sym_COLON_DASH] = ACTIONS(6927),
    [anon_sym_PERCENT] = ACTIONS(6927),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2515] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6917),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2516] = {
    [sym__concat] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_RBRACK] = ACTIONS(5658),
    [anon_sym_EQ_TILDE] = ACTIONS(5658),
    [anon_sym_EQ_EQ] = ACTIONS(5658),
    [anon_sym_EQ] = ACTIONS(5660),
    [anon_sym_PLUS_EQ] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_BANG_EQ] = ACTIONS(5658),
    [anon_sym_PLUS] = ACTIONS(5660),
    [anon_sym_DASH] = ACTIONS(5660),
    [anon_sym_DASH_EQ] = ACTIONS(5658),
    [anon_sym_LT_EQ] = ACTIONS(5658),
    [anon_sym_GT_EQ] = ACTIONS(5658),
    [anon_sym_PLUS_PLUS] = ACTIONS(5658),
    [anon_sym_DASH_DASH] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5658),
  },
  [2517] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6931),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2518] = {
    [sym__simple_heredoc_body] = ACTIONS(4383),
    [sym__heredoc_body_beginning] = ACTIONS(4383),
    [sym_file_descriptor] = ACTIONS(4383),
    [sym_variable_name] = ACTIONS(4383),
    [ts_builtin_sym_end] = ACTIONS(4383),
    [anon_sym_SEMI] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_RPAREN] = ACTIONS(4383),
    [anon_sym_SEMI_SEMI] = ACTIONS(4383),
    [anon_sym_PIPE_AMP] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_AMP_GT] = ACTIONS(4385),
    [anon_sym_AMP_GT_GT] = ACTIONS(4383),
    [anon_sym_LT_AMP] = ACTIONS(4383),
    [anon_sym_GT_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_LT_LT_DASH] = ACTIONS(4383),
    [anon_sym_LT_LT_LT] = ACTIONS(4383),
    [sym__special_character] = ACTIONS(4383),
    [anon_sym_DQUOTE] = ACTIONS(4383),
    [anon_sym_DOLLAR] = ACTIONS(4385),
    [sym_raw_string] = ACTIONS(4383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4383),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4383),
    [anon_sym_BQUOTE] = ACTIONS(4383),
    [anon_sym_LT_LPAREN] = ACTIONS(4383),
    [anon_sym_GT_LPAREN] = ACTIONS(4383),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4385),
    [sym_word] = ACTIONS(4385),
    [anon_sym_LF] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
  },
  [2519] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [sym_variable_name] = ACTIONS(5564),
    [ts_builtin_sym_end] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_RPAREN] = ACTIONS(5564),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5566),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [2520] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [sym_variable_name] = ACTIONS(5598),
    [ts_builtin_sym_end] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_RPAREN] = ACTIONS(5598),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5600),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [2521] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(6933),
    [sym_comment] = ACTIONS(57),
  },
  [2522] = {
    [anon_sym_RBRACE] = ACTIONS(6933),
    [sym_comment] = ACTIONS(57),
  },
  [2523] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(6935),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2524] = {
    [sym_concatenation] = STATE(3133),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3133),
    [anon_sym_RBRACE] = ACTIONS(6937),
    [anon_sym_EQ] = ACTIONS(6939),
    [anon_sym_DASH] = ACTIONS(6939),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6941),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6939),
    [anon_sym_COLON_QMARK] = ACTIONS(6939),
    [anon_sym_COLON_DASH] = ACTIONS(6939),
    [anon_sym_PERCENT] = ACTIONS(6939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2525] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [sym_variable_name] = ACTIONS(5615),
    [ts_builtin_sym_end] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_RPAREN] = ACTIONS(5615),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5617),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [2526] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6937),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2527] = {
    [sym_concatenation] = STATE(3134),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3134),
    [anon_sym_RBRACE] = ACTIONS(6933),
    [anon_sym_EQ] = ACTIONS(6943),
    [anon_sym_DASH] = ACTIONS(6943),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6945),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6943),
    [anon_sym_COLON_QMARK] = ACTIONS(6943),
    [anon_sym_COLON_DASH] = ACTIONS(6943),
    [anon_sym_PERCENT] = ACTIONS(6943),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2528] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6933),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2529] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [sym_variable_name] = ACTIONS(5658),
    [ts_builtin_sym_end] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_RPAREN] = ACTIONS(5658),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5660),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [2530] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6947),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2531] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [ts_builtin_sym_end] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_RPAREN] = ACTIONS(5564),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5566),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [2532] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [ts_builtin_sym_end] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_RPAREN] = ACTIONS(5598),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5600),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [2533] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(6949),
    [sym_comment] = ACTIONS(57),
  },
  [2534] = {
    [anon_sym_RBRACE] = ACTIONS(6949),
    [sym_comment] = ACTIONS(57),
  },
  [2535] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(6951),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2536] = {
    [sym_concatenation] = STATE(3139),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3139),
    [anon_sym_RBRACE] = ACTIONS(6953),
    [anon_sym_EQ] = ACTIONS(6955),
    [anon_sym_DASH] = ACTIONS(6955),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6955),
    [anon_sym_COLON_QMARK] = ACTIONS(6955),
    [anon_sym_COLON_DASH] = ACTIONS(6955),
    [anon_sym_PERCENT] = ACTIONS(6955),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2537] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [ts_builtin_sym_end] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_RPAREN] = ACTIONS(5615),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5617),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [2538] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6953),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2539] = {
    [sym_concatenation] = STATE(3140),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3140),
    [anon_sym_RBRACE] = ACTIONS(6949),
    [anon_sym_EQ] = ACTIONS(6959),
    [anon_sym_DASH] = ACTIONS(6959),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6961),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6959),
    [anon_sym_COLON_QMARK] = ACTIONS(6959),
    [anon_sym_COLON_DASH] = ACTIONS(6959),
    [anon_sym_PERCENT] = ACTIONS(6959),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2540] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6949),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2541] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [ts_builtin_sym_end] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_RPAREN] = ACTIONS(5658),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5660),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [2542] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6963),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2543] = {
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [sym_variable_name] = ACTIONS(5564),
    [anon_sym_RPAREN] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5564),
  },
  [2544] = {
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [sym_variable_name] = ACTIONS(5598),
    [anon_sym_RPAREN] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5598),
  },
  [2545] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(6965),
    [sym_comment] = ACTIONS(57),
  },
  [2546] = {
    [anon_sym_RBRACE] = ACTIONS(6965),
    [sym_comment] = ACTIONS(57),
  },
  [2547] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(6967),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2548] = {
    [sym_concatenation] = STATE(3145),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3145),
    [anon_sym_RBRACE] = ACTIONS(6969),
    [anon_sym_EQ] = ACTIONS(6971),
    [anon_sym_DASH] = ACTIONS(6971),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6973),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6971),
    [anon_sym_COLON_QMARK] = ACTIONS(6971),
    [anon_sym_COLON_DASH] = ACTIONS(6971),
    [anon_sym_PERCENT] = ACTIONS(6971),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2549] = {
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [sym_variable_name] = ACTIONS(5615),
    [anon_sym_RPAREN] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5615),
  },
  [2550] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6969),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2551] = {
    [sym_concatenation] = STATE(3146),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3146),
    [anon_sym_RBRACE] = ACTIONS(6965),
    [anon_sym_EQ] = ACTIONS(6975),
    [anon_sym_DASH] = ACTIONS(6975),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6975),
    [anon_sym_COLON_QMARK] = ACTIONS(6975),
    [anon_sym_COLON_DASH] = ACTIONS(6975),
    [anon_sym_PERCENT] = ACTIONS(6975),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2552] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6965),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2553] = {
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [sym_variable_name] = ACTIONS(5658),
    [anon_sym_RPAREN] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5658),
  },
  [2554] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6979),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2555] = {
    [sym__concat] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5566),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym__string_content] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5566),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5566),
    [anon_sym_BQUOTE] = ACTIONS(5566),
    [sym_comment] = ACTIONS(343),
  },
  [2556] = {
    [sym__concat] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5600),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym__string_content] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5600),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5600),
    [anon_sym_BQUOTE] = ACTIONS(5600),
    [sym_comment] = ACTIONS(343),
  },
  [2557] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(6981),
    [sym_comment] = ACTIONS(57),
  },
  [2558] = {
    [anon_sym_RBRACE] = ACTIONS(6981),
    [sym_comment] = ACTIONS(57),
  },
  [2559] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(6983),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2560] = {
    [sym_concatenation] = STATE(3151),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3151),
    [anon_sym_RBRACE] = ACTIONS(6985),
    [anon_sym_EQ] = ACTIONS(6987),
    [anon_sym_DASH] = ACTIONS(6987),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6989),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6987),
    [anon_sym_COLON_QMARK] = ACTIONS(6987),
    [anon_sym_COLON_DASH] = ACTIONS(6987),
    [anon_sym_PERCENT] = ACTIONS(6987),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2561] = {
    [sym__concat] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5617),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym__string_content] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5617),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5617),
    [anon_sym_BQUOTE] = ACTIONS(5617),
    [sym_comment] = ACTIONS(343),
  },
  [2562] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6985),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2563] = {
    [sym_concatenation] = STATE(3152),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3152),
    [anon_sym_RBRACE] = ACTIONS(6981),
    [anon_sym_EQ] = ACTIONS(6991),
    [anon_sym_DASH] = ACTIONS(6991),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(6993),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(6991),
    [anon_sym_COLON_QMARK] = ACTIONS(6991),
    [anon_sym_COLON_DASH] = ACTIONS(6991),
    [anon_sym_PERCENT] = ACTIONS(6991),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2564] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6981),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2565] = {
    [sym__concat] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5660),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym__string_content] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5660),
    [anon_sym_BQUOTE] = ACTIONS(5660),
    [sym_comment] = ACTIONS(343),
  },
  [2566] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(6995),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2567] = {
    [sym__concat] = ACTIONS(6997),
    [anon_sym_RBRACE] = ACTIONS(4341),
    [anon_sym_EQ] = ACTIONS(6999),
    [anon_sym_DASH] = ACTIONS(6999),
    [sym__special_character] = ACTIONS(6999),
    [anon_sym_DQUOTE] = ACTIONS(4341),
    [anon_sym_DOLLAR] = ACTIONS(6999),
    [sym_raw_string] = ACTIONS(4341),
    [anon_sym_POUND] = ACTIONS(4341),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4341),
    [anon_sym_SLASH] = ACTIONS(4341),
    [anon_sym_COLON] = ACTIONS(6999),
    [anon_sym_COLON_QMARK] = ACTIONS(6999),
    [anon_sym_COLON_DASH] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(6999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4341),
    [anon_sym_BQUOTE] = ACTIONS(4341),
    [anon_sym_LT_LPAREN] = ACTIONS(4341),
    [anon_sym_GT_LPAREN] = ACTIONS(4341),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(6999),
  },
  [2568] = {
    [anon_sym_RBRACE] = ACTIONS(4341),
    [anon_sym_EQ] = ACTIONS(6999),
    [anon_sym_DASH] = ACTIONS(6999),
    [sym__special_character] = ACTIONS(6999),
    [anon_sym_DQUOTE] = ACTIONS(4341),
    [anon_sym_DOLLAR] = ACTIONS(6999),
    [sym_raw_string] = ACTIONS(4341),
    [anon_sym_POUND] = ACTIONS(4341),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4341),
    [anon_sym_SLASH] = ACTIONS(4341),
    [anon_sym_COLON] = ACTIONS(6999),
    [anon_sym_COLON_QMARK] = ACTIONS(6999),
    [anon_sym_COLON_DASH] = ACTIONS(6999),
    [anon_sym_PERCENT] = ACTIONS(6999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4341),
    [anon_sym_BQUOTE] = ACTIONS(4341),
    [anon_sym_LT_LPAREN] = ACTIONS(4341),
    [anon_sym_GT_LPAREN] = ACTIONS(4341),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(6999),
  },
  [2569] = {
    [sym__concat] = ACTIONS(7001),
    [anon_sym_RBRACE] = ACTIONS(4345),
    [anon_sym_EQ] = ACTIONS(7003),
    [anon_sym_DASH] = ACTIONS(7003),
    [sym__special_character] = ACTIONS(7003),
    [anon_sym_DQUOTE] = ACTIONS(4345),
    [anon_sym_DOLLAR] = ACTIONS(7003),
    [sym_raw_string] = ACTIONS(4345),
    [anon_sym_POUND] = ACTIONS(4345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4345),
    [anon_sym_SLASH] = ACTIONS(4345),
    [anon_sym_COLON] = ACTIONS(7003),
    [anon_sym_COLON_QMARK] = ACTIONS(7003),
    [anon_sym_COLON_DASH] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4345),
    [anon_sym_BQUOTE] = ACTIONS(4345),
    [anon_sym_LT_LPAREN] = ACTIONS(4345),
    [anon_sym_GT_LPAREN] = ACTIONS(4345),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(7003),
  },
  [2570] = {
    [anon_sym_RBRACE] = ACTIONS(4345),
    [anon_sym_EQ] = ACTIONS(7003),
    [anon_sym_DASH] = ACTIONS(7003),
    [sym__special_character] = ACTIONS(7003),
    [anon_sym_DQUOTE] = ACTIONS(4345),
    [anon_sym_DOLLAR] = ACTIONS(7003),
    [sym_raw_string] = ACTIONS(4345),
    [anon_sym_POUND] = ACTIONS(4345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4345),
    [anon_sym_SLASH] = ACTIONS(4345),
    [anon_sym_COLON] = ACTIONS(7003),
    [anon_sym_COLON_QMARK] = ACTIONS(7003),
    [anon_sym_COLON_DASH] = ACTIONS(7003),
    [anon_sym_PERCENT] = ACTIONS(7003),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4345),
    [anon_sym_BQUOTE] = ACTIONS(4345),
    [anon_sym_LT_LPAREN] = ACTIONS(4345),
    [anon_sym_GT_LPAREN] = ACTIONS(4345),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(7003),
  },
  [2571] = {
    [sym__concat] = ACTIONS(2344),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
  },
  [2572] = {
    [aux_sym_concatenation_repeat1] = STATE(2572),
    [sym__concat] = ACTIONS(7005),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
  },
  [2573] = {
    [sym__concat] = ACTIONS(2351),
    [anon_sym_RBRACE] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
  },
  [2574] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(7008),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [2575] = {
    [sym_concatenation] = STATE(3159),
    [sym_string] = STATE(3158),
    [sym_simple_expansion] = STATE(3158),
    [sym_string_expansion] = STATE(3158),
    [sym_expansion] = STATE(3158),
    [sym_command_substitution] = STATE(3158),
    [sym_process_substitution] = STATE(3158),
    [aux_sym__literal_repeat1] = STATE(3160),
    [anon_sym_RBRACE] = ACTIONS(7010),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(7012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7012),
  },
  [2576] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(7014),
    [sym_comment] = ACTIONS(57),
  },
  [2577] = {
    [sym_concatenation] = STATE(3164),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3164),
    [anon_sym_RBRACE] = ACTIONS(7016),
    [anon_sym_EQ] = ACTIONS(7018),
    [anon_sym_DASH] = ACTIONS(7018),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7020),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(7022),
    [anon_sym_COLON] = ACTIONS(7018),
    [anon_sym_COLON_QMARK] = ACTIONS(7018),
    [anon_sym_COLON_DASH] = ACTIONS(7018),
    [anon_sym_PERCENT] = ACTIONS(7018),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2578] = {
    [sym_concatenation] = STATE(3166),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3166),
    [anon_sym_RBRACE] = ACTIONS(7010),
    [anon_sym_EQ] = ACTIONS(7024),
    [anon_sym_DASH] = ACTIONS(7024),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(7028),
    [anon_sym_COLON] = ACTIONS(7024),
    [anon_sym_COLON_QMARK] = ACTIONS(7024),
    [anon_sym_COLON_DASH] = ACTIONS(7024),
    [anon_sym_PERCENT] = ACTIONS(7024),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2579] = {
    [sym__concat] = ACTIONS(2442),
    [anon_sym_RBRACE] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
  },
  [2580] = {
    [sym_concatenation] = STATE(3169),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3169),
    [sym_regex] = ACTIONS(7030),
    [anon_sym_RBRACE] = ACTIONS(7032),
    [anon_sym_EQ] = ACTIONS(7034),
    [anon_sym_DASH] = ACTIONS(7034),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7036),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7034),
    [anon_sym_COLON_QMARK] = ACTIONS(7034),
    [anon_sym_COLON_DASH] = ACTIONS(7034),
    [anon_sym_PERCENT] = ACTIONS(7034),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2581] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7032),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2582] = {
    [sym__concat] = ACTIONS(2492),
    [anon_sym_RBRACE] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
  },
  [2583] = {
    [sym_concatenation] = STATE(3166),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3166),
    [sym_regex] = ACTIONS(7038),
    [anon_sym_RBRACE] = ACTIONS(7010),
    [anon_sym_EQ] = ACTIONS(7024),
    [anon_sym_DASH] = ACTIONS(7024),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7024),
    [anon_sym_COLON_QMARK] = ACTIONS(7024),
    [anon_sym_COLON_DASH] = ACTIONS(7024),
    [anon_sym_PERCENT] = ACTIONS(7024),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2584] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7010),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2585] = {
    [sym__concat] = ACTIONS(2500),
    [anon_sym_RBRACE] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
  },
  [2586] = {
    [sym__concat] = ACTIONS(2534),
    [anon_sym_RBRACE] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
  },
  [2587] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [ts_builtin_sym_end] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_RPAREN] = ACTIONS(7040),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_EQ_TILDE] = ACTIONS(7042),
    [anon_sym_EQ_EQ] = ACTIONS(7042),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [2588] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [ts_builtin_sym_end] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_RPAREN] = ACTIONS(7044),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_EQ_TILDE] = ACTIONS(7046),
    [anon_sym_EQ_EQ] = ACTIONS(7046),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [2589] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [ts_builtin_sym_end] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_RPAREN] = ACTIONS(7048),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_EQ_TILDE] = ACTIONS(7050),
    [anon_sym_EQ_EQ] = ACTIONS(7050),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [2590] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7052),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2591] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7054),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2592] = {
    [sym__concat] = ACTIONS(4053),
    [anon_sym_RBRACE] = ACTIONS(4053),
    [anon_sym_EQ] = ACTIONS(4055),
    [anon_sym_DASH] = ACTIONS(4055),
    [sym__special_character] = ACTIONS(4055),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_POUND] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_COLON] = ACTIONS(4055),
    [anon_sym_COLON_QMARK] = ACTIONS(4055),
    [anon_sym_COLON_DASH] = ACTIONS(4055),
    [anon_sym_PERCENT] = ACTIONS(4055),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(4055),
  },
  [2593] = {
    [sym__concat] = ACTIONS(4067),
    [anon_sym_RBRACE] = ACTIONS(4067),
    [anon_sym_EQ] = ACTIONS(4069),
    [anon_sym_DASH] = ACTIONS(4069),
    [sym__special_character] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_POUND] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_COLON] = ACTIONS(4069),
    [anon_sym_COLON_QMARK] = ACTIONS(4069),
    [anon_sym_COLON_DASH] = ACTIONS(4069),
    [anon_sym_PERCENT] = ACTIONS(4069),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(4069),
  },
  [2594] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(7056),
    [sym_comment] = ACTIONS(57),
  },
  [2595] = {
    [anon_sym_RBRACE] = ACTIONS(7056),
    [sym_comment] = ACTIONS(57),
  },
  [2596] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(7058),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2597] = {
    [sym_concatenation] = STATE(3176),
    [sym_string] = STATE(3175),
    [sym_simple_expansion] = STATE(3175),
    [sym_string_expansion] = STATE(3175),
    [sym_expansion] = STATE(3175),
    [sym_command_substitution] = STATE(3175),
    [sym_process_substitution] = STATE(3175),
    [aux_sym__literal_repeat1] = STATE(3177),
    [anon_sym_RBRACE] = ACTIONS(7056),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(7060),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7060),
  },
  [2598] = {
    [sym__concat] = ACTIONS(4103),
    [anon_sym_RBRACE] = ACTIONS(4103),
    [anon_sym_EQ] = ACTIONS(4105),
    [anon_sym_DASH] = ACTIONS(4105),
    [sym__special_character] = ACTIONS(4105),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_POUND] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_COLON] = ACTIONS(4105),
    [anon_sym_COLON_QMARK] = ACTIONS(4105),
    [anon_sym_COLON_DASH] = ACTIONS(4105),
    [anon_sym_PERCENT] = ACTIONS(4105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(4105),
  },
  [2599] = {
    [sym_concatenation] = STATE(3180),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3180),
    [sym_regex] = ACTIONS(7062),
    [anon_sym_RBRACE] = ACTIONS(7064),
    [anon_sym_EQ] = ACTIONS(7066),
    [anon_sym_DASH] = ACTIONS(7066),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7068),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7066),
    [anon_sym_COLON_QMARK] = ACTIONS(7066),
    [anon_sym_COLON_DASH] = ACTIONS(7066),
    [anon_sym_PERCENT] = ACTIONS(7066),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2600] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7064),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2601] = {
    [sym_concatenation] = STATE(3182),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3182),
    [sym_regex] = ACTIONS(7070),
    [anon_sym_RBRACE] = ACTIONS(7056),
    [anon_sym_EQ] = ACTIONS(7072),
    [anon_sym_DASH] = ACTIONS(7072),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7072),
    [anon_sym_COLON_QMARK] = ACTIONS(7072),
    [anon_sym_COLON_DASH] = ACTIONS(7072),
    [anon_sym_PERCENT] = ACTIONS(7072),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2602] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7056),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2603] = {
    [sym_concatenation] = STATE(3184),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3184),
    [anon_sym_RBRACE] = ACTIONS(7076),
    [anon_sym_EQ] = ACTIONS(7078),
    [anon_sym_DASH] = ACTIONS(7078),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7080),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7078),
    [anon_sym_COLON_QMARK] = ACTIONS(7078),
    [anon_sym_COLON_DASH] = ACTIONS(7078),
    [anon_sym_PERCENT] = ACTIONS(7078),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2604] = {
    [sym__concat] = ACTIONS(4159),
    [anon_sym_RBRACE] = ACTIONS(4159),
    [anon_sym_EQ] = ACTIONS(4161),
    [anon_sym_DASH] = ACTIONS(4161),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_POUND] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_COLON] = ACTIONS(4161),
    [anon_sym_COLON_QMARK] = ACTIONS(4161),
    [anon_sym_COLON_DASH] = ACTIONS(4161),
    [anon_sym_PERCENT] = ACTIONS(4161),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(4161),
  },
  [2605] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7076),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2606] = {
    [sym_concatenation] = STATE(3182),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3182),
    [anon_sym_RBRACE] = ACTIONS(7056),
    [anon_sym_EQ] = ACTIONS(7072),
    [anon_sym_DASH] = ACTIONS(7072),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7072),
    [anon_sym_COLON_QMARK] = ACTIONS(7072),
    [anon_sym_COLON_DASH] = ACTIONS(7072),
    [anon_sym_PERCENT] = ACTIONS(7072),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2607] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [ts_builtin_sym_end] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_RPAREN] = ACTIONS(7082),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_EQ_TILDE] = ACTIONS(7084),
    [anon_sym_EQ_EQ] = ACTIONS(7084),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [2608] = {
    [aux_sym_concatenation_repeat1] = STATE(2608),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(4416),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2609] = {
    [aux_sym_concatenation_repeat1] = STATE(2609),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2348),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2610] = {
    [sym__heredoc_body_middle] = ACTIONS(4067),
    [sym__heredoc_body_end] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
  },
  [2611] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(7086),
    [sym_comment] = ACTIONS(57),
  },
  [2612] = {
    [anon_sym_RBRACE] = ACTIONS(7086),
    [sym_comment] = ACTIONS(57),
  },
  [2613] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(7088),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2614] = {
    [sym_concatenation] = STATE(3188),
    [sym_string] = STATE(3187),
    [sym_simple_expansion] = STATE(3187),
    [sym_string_expansion] = STATE(3187),
    [sym_expansion] = STATE(3187),
    [sym_command_substitution] = STATE(3187),
    [sym_process_substitution] = STATE(3187),
    [aux_sym__literal_repeat1] = STATE(3189),
    [anon_sym_RBRACE] = ACTIONS(7086),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(7090),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7090),
  },
  [2615] = {
    [sym__heredoc_body_middle] = ACTIONS(4103),
    [sym__heredoc_body_end] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
  },
  [2616] = {
    [sym_concatenation] = STATE(3192),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3192),
    [sym_regex] = ACTIONS(7092),
    [anon_sym_RBRACE] = ACTIONS(7094),
    [anon_sym_EQ] = ACTIONS(7096),
    [anon_sym_DASH] = ACTIONS(7096),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7098),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7096),
    [anon_sym_COLON_QMARK] = ACTIONS(7096),
    [anon_sym_COLON_DASH] = ACTIONS(7096),
    [anon_sym_PERCENT] = ACTIONS(7096),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2617] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7094),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2618] = {
    [sym_concatenation] = STATE(3194),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3194),
    [sym_regex] = ACTIONS(7100),
    [anon_sym_RBRACE] = ACTIONS(7086),
    [anon_sym_EQ] = ACTIONS(7102),
    [anon_sym_DASH] = ACTIONS(7102),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7104),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7102),
    [anon_sym_COLON_QMARK] = ACTIONS(7102),
    [anon_sym_COLON_DASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2619] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7086),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2620] = {
    [sym_concatenation] = STATE(3196),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3196),
    [anon_sym_RBRACE] = ACTIONS(7106),
    [anon_sym_EQ] = ACTIONS(7108),
    [anon_sym_DASH] = ACTIONS(7108),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7110),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7108),
    [anon_sym_COLON_QMARK] = ACTIONS(7108),
    [anon_sym_COLON_DASH] = ACTIONS(7108),
    [anon_sym_PERCENT] = ACTIONS(7108),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2621] = {
    [sym__heredoc_body_middle] = ACTIONS(4159),
    [sym__heredoc_body_end] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
  },
  [2622] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7106),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2623] = {
    [sym_concatenation] = STATE(3194),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3194),
    [anon_sym_RBRACE] = ACTIONS(7086),
    [anon_sym_EQ] = ACTIONS(7102),
    [anon_sym_DASH] = ACTIONS(7102),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7104),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7102),
    [anon_sym_COLON_QMARK] = ACTIONS(7102),
    [anon_sym_COLON_DASH] = ACTIONS(7102),
    [anon_sym_PERCENT] = ACTIONS(7102),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2624] = {
    [aux_sym_concatenation_repeat1] = STATE(2626),
    [sym__simple_heredoc_body] = ACTIONS(1378),
    [sym__heredoc_body_beginning] = ACTIONS(1378),
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1378),
    [anon_sym_PIPE_AMP] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_AMP] = ACTIONS(1378),
    [anon_sym_GT_AMP] = ACTIONS(1378),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1378),
    [anon_sym_LT_LT_LT] = ACTIONS(1378),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1378),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [2625] = {
    [aux_sym__literal_repeat1] = STATE(2627),
    [sym__simple_heredoc_body] = ACTIONS(1382),
    [sym__heredoc_body_beginning] = ACTIONS(1382),
    [sym_file_descriptor] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym_PIPE] = ACTIONS(1384),
    [anon_sym_SEMI_SEMI] = ACTIONS(1382),
    [anon_sym_PIPE_AMP] = ACTIONS(1382),
    [anon_sym_AMP_AMP] = ACTIONS(1382),
    [anon_sym_PIPE_PIPE] = ACTIONS(1382),
    [anon_sym_LT] = ACTIONS(1384),
    [anon_sym_GT] = ACTIONS(1384),
    [anon_sym_GT_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT_GT] = ACTIONS(1382),
    [anon_sym_LT_AMP] = ACTIONS(1382),
    [anon_sym_GT_AMP] = ACTIONS(1382),
    [anon_sym_LT_LT] = ACTIONS(1384),
    [anon_sym_LT_LT_DASH] = ACTIONS(1382),
    [anon_sym_LT_LT_LT] = ACTIONS(1382),
    [sym__special_character] = ACTIONS(441),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
  },
  [2626] = {
    [aux_sym_concatenation_repeat1] = STATE(3197),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(327),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [2627] = {
    [aux_sym__literal_repeat1] = STATE(2627),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(1375),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [2628] = {
    [sym__concat] = ACTIONS(4053),
    [anon_sym_RPAREN] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4053),
  },
  [2629] = {
    [sym__concat] = ACTIONS(4067),
    [anon_sym_RPAREN] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4067),
  },
  [2630] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(7112),
    [sym_comment] = ACTIONS(57),
  },
  [2631] = {
    [anon_sym_RBRACE] = ACTIONS(7112),
    [sym_comment] = ACTIONS(57),
  },
  [2632] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(7114),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2633] = {
    [sym_concatenation] = STATE(3201),
    [sym_string] = STATE(3200),
    [sym_simple_expansion] = STATE(3200),
    [sym_string_expansion] = STATE(3200),
    [sym_expansion] = STATE(3200),
    [sym_command_substitution] = STATE(3200),
    [sym_process_substitution] = STATE(3200),
    [aux_sym__literal_repeat1] = STATE(3202),
    [anon_sym_RBRACE] = ACTIONS(7112),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(7116),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7116),
  },
  [2634] = {
    [sym__concat] = ACTIONS(4103),
    [anon_sym_RPAREN] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4103),
  },
  [2635] = {
    [sym_concatenation] = STATE(3205),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3205),
    [sym_regex] = ACTIONS(7118),
    [anon_sym_RBRACE] = ACTIONS(7120),
    [anon_sym_EQ] = ACTIONS(7122),
    [anon_sym_DASH] = ACTIONS(7122),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7124),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7122),
    [anon_sym_COLON_QMARK] = ACTIONS(7122),
    [anon_sym_COLON_DASH] = ACTIONS(7122),
    [anon_sym_PERCENT] = ACTIONS(7122),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2636] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7120),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2637] = {
    [sym_concatenation] = STATE(3207),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3207),
    [sym_regex] = ACTIONS(7126),
    [anon_sym_RBRACE] = ACTIONS(7112),
    [anon_sym_EQ] = ACTIONS(7128),
    [anon_sym_DASH] = ACTIONS(7128),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7130),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7128),
    [anon_sym_COLON_QMARK] = ACTIONS(7128),
    [anon_sym_COLON_DASH] = ACTIONS(7128),
    [anon_sym_PERCENT] = ACTIONS(7128),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2638] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7112),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2639] = {
    [sym_concatenation] = STATE(3209),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3209),
    [anon_sym_RBRACE] = ACTIONS(7132),
    [anon_sym_EQ] = ACTIONS(7134),
    [anon_sym_DASH] = ACTIONS(7134),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7136),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7134),
    [anon_sym_COLON_QMARK] = ACTIONS(7134),
    [anon_sym_COLON_DASH] = ACTIONS(7134),
    [anon_sym_PERCENT] = ACTIONS(7134),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2640] = {
    [sym__concat] = ACTIONS(4159),
    [anon_sym_RPAREN] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4159),
  },
  [2641] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7132),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2642] = {
    [sym_concatenation] = STATE(3207),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3207),
    [anon_sym_RBRACE] = ACTIONS(7112),
    [anon_sym_EQ] = ACTIONS(7128),
    [anon_sym_DASH] = ACTIONS(7128),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7130),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7128),
    [anon_sym_COLON_QMARK] = ACTIONS(7128),
    [anon_sym_COLON_DASH] = ACTIONS(7128),
    [anon_sym_PERCENT] = ACTIONS(7128),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2643] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [sym_variable_name] = ACTIONS(5564),
    [ts_builtin_sym_end] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_RPAREN] = ACTIONS(5564),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [2644] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [sym_variable_name] = ACTIONS(5598),
    [ts_builtin_sym_end] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_RPAREN] = ACTIONS(5598),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [2645] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(7138),
    [sym_comment] = ACTIONS(57),
  },
  [2646] = {
    [anon_sym_RBRACE] = ACTIONS(7138),
    [sym_comment] = ACTIONS(57),
  },
  [2647] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(7140),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2648] = {
    [sym_concatenation] = STATE(3213),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3213),
    [anon_sym_RBRACE] = ACTIONS(7142),
    [anon_sym_EQ] = ACTIONS(7144),
    [anon_sym_DASH] = ACTIONS(7144),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7146),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7144),
    [anon_sym_COLON_QMARK] = ACTIONS(7144),
    [anon_sym_COLON_DASH] = ACTIONS(7144),
    [anon_sym_PERCENT] = ACTIONS(7144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2649] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [sym_variable_name] = ACTIONS(5615),
    [ts_builtin_sym_end] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_RPAREN] = ACTIONS(5615),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [2650] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7142),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2651] = {
    [sym_concatenation] = STATE(3214),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3214),
    [anon_sym_RBRACE] = ACTIONS(7138),
    [anon_sym_EQ] = ACTIONS(7148),
    [anon_sym_DASH] = ACTIONS(7148),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7150),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7148),
    [anon_sym_COLON_QMARK] = ACTIONS(7148),
    [anon_sym_COLON_DASH] = ACTIONS(7148),
    [anon_sym_PERCENT] = ACTIONS(7148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2652] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7138),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2653] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [sym_variable_name] = ACTIONS(5658),
    [ts_builtin_sym_end] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_RPAREN] = ACTIONS(5658),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [2654] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7152),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2655] = {
    [sym__simple_heredoc_body] = ACTIONS(7154),
    [sym__heredoc_body_beginning] = ACTIONS(7154),
    [sym_file_descriptor] = ACTIONS(7154),
    [ts_builtin_sym_end] = ACTIONS(7154),
    [anon_sym_SEMI] = ACTIONS(7156),
    [anon_sym_done] = ACTIONS(7154),
    [anon_sym_fi] = ACTIONS(7154),
    [anon_sym_elif] = ACTIONS(7154),
    [anon_sym_else] = ACTIONS(7154),
    [anon_sym_esac] = ACTIONS(7154),
    [anon_sym_PIPE] = ACTIONS(7156),
    [anon_sym_RPAREN] = ACTIONS(7154),
    [anon_sym_SEMI_SEMI] = ACTIONS(7154),
    [anon_sym_PIPE_AMP] = ACTIONS(7154),
    [anon_sym_AMP_AMP] = ACTIONS(7154),
    [anon_sym_PIPE_PIPE] = ACTIONS(7154),
    [anon_sym_LT] = ACTIONS(7156),
    [anon_sym_GT] = ACTIONS(7156),
    [anon_sym_GT_GT] = ACTIONS(7154),
    [anon_sym_AMP_GT] = ACTIONS(7156),
    [anon_sym_AMP_GT_GT] = ACTIONS(7154),
    [anon_sym_LT_AMP] = ACTIONS(7154),
    [anon_sym_GT_AMP] = ACTIONS(7154),
    [anon_sym_LT_LT] = ACTIONS(7156),
    [anon_sym_LT_LT_DASH] = ACTIONS(7154),
    [anon_sym_LT_LT_LT] = ACTIONS(7154),
    [anon_sym_BQUOTE] = ACTIONS(7154),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7154),
    [anon_sym_AMP] = ACTIONS(7156),
  },
  [2656] = {
    [sym_do_group] = STATE(3216),
    [sym_compound_statement] = STATE(3216),
    [anon_sym_do] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [2657] = {
    [sym_do_group] = STATE(3216),
    [sym_compound_statement] = STATE(3216),
    [anon_sym_SEMI] = ACTIONS(7158),
    [anon_sym_do] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [2658] = {
    [sym__concat] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5564),
    [anon_sym_EQ_EQ] = ACTIONS(5564),
    [anon_sym_EQ] = ACTIONS(5566),
    [anon_sym_PLUS_EQ] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5564),
    [anon_sym_PLUS] = ACTIONS(5566),
    [anon_sym_DASH] = ACTIONS(5566),
    [anon_sym_DASH_EQ] = ACTIONS(5564),
    [anon_sym_LT_EQ] = ACTIONS(5564),
    [anon_sym_GT_EQ] = ACTIONS(5564),
    [anon_sym_PLUS_PLUS] = ACTIONS(5564),
    [anon_sym_DASH_DASH] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5564),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [2659] = {
    [sym__concat] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_EQ_TILDE] = ACTIONS(5598),
    [anon_sym_EQ_EQ] = ACTIONS(5598),
    [anon_sym_EQ] = ACTIONS(5600),
    [anon_sym_PLUS_EQ] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_BANG_EQ] = ACTIONS(5598),
    [anon_sym_PLUS] = ACTIONS(5600),
    [anon_sym_DASH] = ACTIONS(5600),
    [anon_sym_DASH_EQ] = ACTIONS(5598),
    [anon_sym_LT_EQ] = ACTIONS(5598),
    [anon_sym_GT_EQ] = ACTIONS(5598),
    [anon_sym_PLUS_PLUS] = ACTIONS(5598),
    [anon_sym_DASH_DASH] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5598),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [2660] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(7160),
    [sym_comment] = ACTIONS(57),
  },
  [2661] = {
    [anon_sym_RBRACE] = ACTIONS(7160),
    [sym_comment] = ACTIONS(57),
  },
  [2662] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(7162),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2663] = {
    [sym_concatenation] = STATE(3221),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3221),
    [anon_sym_RBRACE] = ACTIONS(7164),
    [anon_sym_EQ] = ACTIONS(7166),
    [anon_sym_DASH] = ACTIONS(7166),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7168),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7166),
    [anon_sym_COLON_QMARK] = ACTIONS(7166),
    [anon_sym_COLON_DASH] = ACTIONS(7166),
    [anon_sym_PERCENT] = ACTIONS(7166),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2664] = {
    [sym__concat] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_EQ_TILDE] = ACTIONS(5615),
    [anon_sym_EQ_EQ] = ACTIONS(5615),
    [anon_sym_EQ] = ACTIONS(5617),
    [anon_sym_PLUS_EQ] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_BANG_EQ] = ACTIONS(5615),
    [anon_sym_PLUS] = ACTIONS(5617),
    [anon_sym_DASH] = ACTIONS(5617),
    [anon_sym_DASH_EQ] = ACTIONS(5615),
    [anon_sym_LT_EQ] = ACTIONS(5615),
    [anon_sym_GT_EQ] = ACTIONS(5615),
    [anon_sym_PLUS_PLUS] = ACTIONS(5615),
    [anon_sym_DASH_DASH] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5615),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [2665] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7164),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2666] = {
    [sym_concatenation] = STATE(3222),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3222),
    [anon_sym_RBRACE] = ACTIONS(7160),
    [anon_sym_EQ] = ACTIONS(7170),
    [anon_sym_DASH] = ACTIONS(7170),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7172),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7170),
    [anon_sym_COLON_QMARK] = ACTIONS(7170),
    [anon_sym_COLON_DASH] = ACTIONS(7170),
    [anon_sym_PERCENT] = ACTIONS(7170),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2667] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7160),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2668] = {
    [sym__concat] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_EQ_TILDE] = ACTIONS(5658),
    [anon_sym_EQ_EQ] = ACTIONS(5658),
    [anon_sym_EQ] = ACTIONS(5660),
    [anon_sym_PLUS_EQ] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_BANG_EQ] = ACTIONS(5658),
    [anon_sym_PLUS] = ACTIONS(5660),
    [anon_sym_DASH] = ACTIONS(5660),
    [anon_sym_DASH_EQ] = ACTIONS(5658),
    [anon_sym_LT_EQ] = ACTIONS(5658),
    [anon_sym_GT_EQ] = ACTIONS(5658),
    [anon_sym_PLUS_PLUS] = ACTIONS(5658),
    [anon_sym_DASH_DASH] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5658),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [2669] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7174),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2670] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(7176),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [2671] = {
    [sym__concat] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4053),
  },
  [2672] = {
    [sym__concat] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4067),
  },
  [2673] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(7178),
    [sym_comment] = ACTIONS(57),
  },
  [2674] = {
    [anon_sym_RBRACE] = ACTIONS(7178),
    [sym_comment] = ACTIONS(57),
  },
  [2675] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(7180),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2676] = {
    [sym_concatenation] = STATE(3228),
    [sym_string] = STATE(3227),
    [sym_simple_expansion] = STATE(3227),
    [sym_string_expansion] = STATE(3227),
    [sym_expansion] = STATE(3227),
    [sym_command_substitution] = STATE(3227),
    [sym_process_substitution] = STATE(3227),
    [aux_sym__literal_repeat1] = STATE(3229),
    [anon_sym_RBRACE] = ACTIONS(7178),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(7182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7182),
  },
  [2677] = {
    [sym__concat] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4103),
  },
  [2678] = {
    [sym_concatenation] = STATE(3232),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3232),
    [sym_regex] = ACTIONS(7184),
    [anon_sym_RBRACE] = ACTIONS(7186),
    [anon_sym_EQ] = ACTIONS(7188),
    [anon_sym_DASH] = ACTIONS(7188),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7190),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7188),
    [anon_sym_COLON_QMARK] = ACTIONS(7188),
    [anon_sym_COLON_DASH] = ACTIONS(7188),
    [anon_sym_PERCENT] = ACTIONS(7188),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2679] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7186),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2680] = {
    [sym_concatenation] = STATE(3234),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3234),
    [sym_regex] = ACTIONS(7192),
    [anon_sym_RBRACE] = ACTIONS(7178),
    [anon_sym_EQ] = ACTIONS(7194),
    [anon_sym_DASH] = ACTIONS(7194),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7196),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7194),
    [anon_sym_COLON_QMARK] = ACTIONS(7194),
    [anon_sym_COLON_DASH] = ACTIONS(7194),
    [anon_sym_PERCENT] = ACTIONS(7194),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2681] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7178),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2682] = {
    [sym_concatenation] = STATE(3236),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3236),
    [anon_sym_RBRACE] = ACTIONS(7198),
    [anon_sym_EQ] = ACTIONS(7200),
    [anon_sym_DASH] = ACTIONS(7200),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7202),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7200),
    [anon_sym_COLON_QMARK] = ACTIONS(7200),
    [anon_sym_COLON_DASH] = ACTIONS(7200),
    [anon_sym_PERCENT] = ACTIONS(7200),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2683] = {
    [sym__concat] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4159),
  },
  [2684] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7198),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2685] = {
    [sym_concatenation] = STATE(3234),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3234),
    [anon_sym_RBRACE] = ACTIONS(7178),
    [anon_sym_EQ] = ACTIONS(7194),
    [anon_sym_DASH] = ACTIONS(7194),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7196),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7194),
    [anon_sym_COLON_QMARK] = ACTIONS(7194),
    [anon_sym_COLON_DASH] = ACTIONS(7194),
    [anon_sym_PERCENT] = ACTIONS(7194),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2686] = {
    [sym__concat] = ACTIONS(5564),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_RPAREN] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5564),
    [anon_sym_EQ_EQ] = ACTIONS(5564),
    [anon_sym_EQ] = ACTIONS(5566),
    [anon_sym_PLUS_EQ] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5564),
    [anon_sym_PLUS] = ACTIONS(5566),
    [anon_sym_DASH] = ACTIONS(5566),
    [anon_sym_DASH_EQ] = ACTIONS(5564),
    [anon_sym_LT_EQ] = ACTIONS(5564),
    [anon_sym_GT_EQ] = ACTIONS(5564),
    [anon_sym_PLUS_PLUS] = ACTIONS(5564),
    [anon_sym_DASH_DASH] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5564),
  },
  [2687] = {
    [sym__concat] = ACTIONS(5598),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_RPAREN] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_EQ_TILDE] = ACTIONS(5598),
    [anon_sym_EQ_EQ] = ACTIONS(5598),
    [anon_sym_EQ] = ACTIONS(5600),
    [anon_sym_PLUS_EQ] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_BANG_EQ] = ACTIONS(5598),
    [anon_sym_PLUS] = ACTIONS(5600),
    [anon_sym_DASH] = ACTIONS(5600),
    [anon_sym_DASH_EQ] = ACTIONS(5598),
    [anon_sym_LT_EQ] = ACTIONS(5598),
    [anon_sym_GT_EQ] = ACTIONS(5598),
    [anon_sym_PLUS_PLUS] = ACTIONS(5598),
    [anon_sym_DASH_DASH] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5598),
  },
  [2688] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(7204),
    [sym_comment] = ACTIONS(57),
  },
  [2689] = {
    [anon_sym_RBRACE] = ACTIONS(7204),
    [sym_comment] = ACTIONS(57),
  },
  [2690] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(7206),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2691] = {
    [sym_concatenation] = STATE(3240),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3240),
    [anon_sym_RBRACE] = ACTIONS(7208),
    [anon_sym_EQ] = ACTIONS(7210),
    [anon_sym_DASH] = ACTIONS(7210),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7212),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7210),
    [anon_sym_COLON_QMARK] = ACTIONS(7210),
    [anon_sym_COLON_DASH] = ACTIONS(7210),
    [anon_sym_PERCENT] = ACTIONS(7210),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2692] = {
    [sym__concat] = ACTIONS(5615),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_RPAREN] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_EQ_TILDE] = ACTIONS(5615),
    [anon_sym_EQ_EQ] = ACTIONS(5615),
    [anon_sym_EQ] = ACTIONS(5617),
    [anon_sym_PLUS_EQ] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_BANG_EQ] = ACTIONS(5615),
    [anon_sym_PLUS] = ACTIONS(5617),
    [anon_sym_DASH] = ACTIONS(5617),
    [anon_sym_DASH_EQ] = ACTIONS(5615),
    [anon_sym_LT_EQ] = ACTIONS(5615),
    [anon_sym_GT_EQ] = ACTIONS(5615),
    [anon_sym_PLUS_PLUS] = ACTIONS(5615),
    [anon_sym_DASH_DASH] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5615),
  },
  [2693] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7208),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2694] = {
    [sym_concatenation] = STATE(3241),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3241),
    [anon_sym_RBRACE] = ACTIONS(7204),
    [anon_sym_EQ] = ACTIONS(7214),
    [anon_sym_DASH] = ACTIONS(7214),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7216),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7214),
    [anon_sym_COLON_QMARK] = ACTIONS(7214),
    [anon_sym_COLON_DASH] = ACTIONS(7214),
    [anon_sym_PERCENT] = ACTIONS(7214),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2695] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7204),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2696] = {
    [sym__concat] = ACTIONS(5658),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_RPAREN] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_EQ_TILDE] = ACTIONS(5658),
    [anon_sym_EQ_EQ] = ACTIONS(5658),
    [anon_sym_EQ] = ACTIONS(5660),
    [anon_sym_PLUS_EQ] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_BANG_EQ] = ACTIONS(5658),
    [anon_sym_PLUS] = ACTIONS(5660),
    [anon_sym_DASH] = ACTIONS(5660),
    [anon_sym_DASH_EQ] = ACTIONS(5658),
    [anon_sym_LT_EQ] = ACTIONS(5658),
    [anon_sym_GT_EQ] = ACTIONS(5658),
    [anon_sym_PLUS_PLUS] = ACTIONS(5658),
    [anon_sym_DASH_DASH] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(5658),
  },
  [2697] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7218),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2698] = {
    [sym__concat] = ACTIONS(7040),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(7040),
    [anon_sym_EQ_TILDE] = ACTIONS(7040),
    [anon_sym_EQ_EQ] = ACTIONS(7040),
    [anon_sym_EQ] = ACTIONS(7042),
    [anon_sym_PLUS_EQ] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_BANG_EQ] = ACTIONS(7040),
    [anon_sym_PLUS] = ACTIONS(7042),
    [anon_sym_DASH] = ACTIONS(7042),
    [anon_sym_DASH_EQ] = ACTIONS(7040),
    [anon_sym_LT_EQ] = ACTIONS(7040),
    [anon_sym_GT_EQ] = ACTIONS(7040),
    [anon_sym_PLUS_PLUS] = ACTIONS(7040),
    [anon_sym_DASH_DASH] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7040),
  },
  [2699] = {
    [sym__concat] = ACTIONS(7044),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(7044),
    [anon_sym_EQ_TILDE] = ACTIONS(7044),
    [anon_sym_EQ_EQ] = ACTIONS(7044),
    [anon_sym_EQ] = ACTIONS(7046),
    [anon_sym_PLUS_EQ] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_BANG_EQ] = ACTIONS(7044),
    [anon_sym_PLUS] = ACTIONS(7046),
    [anon_sym_DASH] = ACTIONS(7046),
    [anon_sym_DASH_EQ] = ACTIONS(7044),
    [anon_sym_LT_EQ] = ACTIONS(7044),
    [anon_sym_GT_EQ] = ACTIONS(7044),
    [anon_sym_PLUS_PLUS] = ACTIONS(7044),
    [anon_sym_DASH_DASH] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7044),
  },
  [2700] = {
    [sym__concat] = ACTIONS(7048),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(7048),
    [anon_sym_EQ_TILDE] = ACTIONS(7048),
    [anon_sym_EQ_EQ] = ACTIONS(7048),
    [anon_sym_EQ] = ACTIONS(7050),
    [anon_sym_PLUS_EQ] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_BANG_EQ] = ACTIONS(7048),
    [anon_sym_PLUS] = ACTIONS(7050),
    [anon_sym_DASH] = ACTIONS(7050),
    [anon_sym_DASH_EQ] = ACTIONS(7048),
    [anon_sym_LT_EQ] = ACTIONS(7048),
    [anon_sym_GT_EQ] = ACTIONS(7048),
    [anon_sym_PLUS_PLUS] = ACTIONS(7048),
    [anon_sym_DASH_DASH] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7048),
  },
  [2701] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7220),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2702] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7222),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2703] = {
    [sym__concat] = ACTIONS(7082),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(7082),
    [anon_sym_EQ_TILDE] = ACTIONS(7082),
    [anon_sym_EQ_EQ] = ACTIONS(7082),
    [anon_sym_EQ] = ACTIONS(7084),
    [anon_sym_PLUS_EQ] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_BANG_EQ] = ACTIONS(7082),
    [anon_sym_PLUS] = ACTIONS(7084),
    [anon_sym_DASH] = ACTIONS(7084),
    [anon_sym_DASH_EQ] = ACTIONS(7082),
    [anon_sym_LT_EQ] = ACTIONS(7082),
    [anon_sym_GT_EQ] = ACTIONS(7082),
    [anon_sym_PLUS_PLUS] = ACTIONS(7082),
    [anon_sym_DASH_DASH] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7082),
  },
  [2704] = {
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [sym_variable_name] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [2705] = {
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [sym_variable_name] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [2706] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(7224),
    [sym_comment] = ACTIONS(57),
  },
  [2707] = {
    [anon_sym_RBRACE] = ACTIONS(7224),
    [sym_comment] = ACTIONS(57),
  },
  [2708] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(7226),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2709] = {
    [sym_concatenation] = STATE(3248),
    [sym_string] = STATE(3247),
    [sym_simple_expansion] = STATE(3247),
    [sym_string_expansion] = STATE(3247),
    [sym_expansion] = STATE(3247),
    [sym_command_substitution] = STATE(3247),
    [sym_process_substitution] = STATE(3247),
    [aux_sym__literal_repeat1] = STATE(3249),
    [anon_sym_RBRACE] = ACTIONS(7224),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(7228),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7228),
  },
  [2710] = {
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [sym_variable_name] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [2711] = {
    [sym_concatenation] = STATE(3252),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3252),
    [sym_regex] = ACTIONS(7230),
    [anon_sym_RBRACE] = ACTIONS(7232),
    [anon_sym_EQ] = ACTIONS(7234),
    [anon_sym_DASH] = ACTIONS(7234),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7234),
    [anon_sym_COLON_QMARK] = ACTIONS(7234),
    [anon_sym_COLON_DASH] = ACTIONS(7234),
    [anon_sym_PERCENT] = ACTIONS(7234),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2712] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7232),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2713] = {
    [sym_concatenation] = STATE(3254),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3254),
    [sym_regex] = ACTIONS(7238),
    [anon_sym_RBRACE] = ACTIONS(7224),
    [anon_sym_EQ] = ACTIONS(7240),
    [anon_sym_DASH] = ACTIONS(7240),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7240),
    [anon_sym_COLON_QMARK] = ACTIONS(7240),
    [anon_sym_COLON_DASH] = ACTIONS(7240),
    [anon_sym_PERCENT] = ACTIONS(7240),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2714] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7224),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2715] = {
    [sym_concatenation] = STATE(3256),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3256),
    [anon_sym_RBRACE] = ACTIONS(7244),
    [anon_sym_EQ] = ACTIONS(7246),
    [anon_sym_DASH] = ACTIONS(7246),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7248),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7246),
    [anon_sym_COLON_QMARK] = ACTIONS(7246),
    [anon_sym_COLON_DASH] = ACTIONS(7246),
    [anon_sym_PERCENT] = ACTIONS(7246),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2716] = {
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [sym_variable_name] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [2717] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7244),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2718] = {
    [sym_concatenation] = STATE(3254),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3254),
    [anon_sym_RBRACE] = ACTIONS(7224),
    [anon_sym_EQ] = ACTIONS(7240),
    [anon_sym_DASH] = ACTIONS(7240),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7240),
    [anon_sym_COLON_QMARK] = ACTIONS(7240),
    [anon_sym_COLON_DASH] = ACTIONS(7240),
    [anon_sym_PERCENT] = ACTIONS(7240),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2719] = {
    [sym_do_group] = STATE(3257),
    [sym_compound_statement] = STATE(3257),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [2720] = {
    [sym_file_descriptor] = ACTIONS(5773),
    [anon_sym_SEMI] = ACTIONS(5775),
    [anon_sym_PIPE] = ACTIONS(5775),
    [anon_sym_SEMI_SEMI] = ACTIONS(5773),
    [anon_sym_PIPE_AMP] = ACTIONS(5773),
    [anon_sym_AMP_AMP] = ACTIONS(5773),
    [anon_sym_PIPE_PIPE] = ACTIONS(5773),
    [anon_sym_LT] = ACTIONS(5775),
    [anon_sym_GT] = ACTIONS(5775),
    [anon_sym_GT_GT] = ACTIONS(5773),
    [anon_sym_AMP_GT] = ACTIONS(5775),
    [anon_sym_AMP_GT_GT] = ACTIONS(5773),
    [anon_sym_LT_AMP] = ACTIONS(5773),
    [anon_sym_GT_AMP] = ACTIONS(5773),
    [anon_sym_LT_LT] = ACTIONS(5775),
    [anon_sym_LT_LT_DASH] = ACTIONS(5773),
    [anon_sym_LT_LT_LT] = ACTIONS(5773),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5773),
    [anon_sym_AMP] = ACTIONS(5775),
  },
  [2721] = {
    [sym_do_group] = STATE(3257),
    [sym_compound_statement] = STATE(3257),
    [anon_sym_SEMI] = ACTIONS(7250),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [2722] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(7252),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [2723] = {
    [sym__expression] = STATE(3260),
    [sym_binary_expression] = STATE(3260),
    [sym_unary_expression] = STATE(3260),
    [sym_postfix_expression] = STATE(3260),
    [sym_parenthesized_expression] = STATE(3260),
    [sym_concatenation] = STATE(3260),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(7252),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_character] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [2724] = {
    [sym_file_descriptor] = ACTIONS(5842),
    [anon_sym_SEMI] = ACTIONS(5844),
    [anon_sym_PIPE] = ACTIONS(5844),
    [anon_sym_SEMI_SEMI] = ACTIONS(5842),
    [anon_sym_PIPE_AMP] = ACTIONS(5842),
    [anon_sym_AMP_AMP] = ACTIONS(5842),
    [anon_sym_PIPE_PIPE] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5844),
    [anon_sym_GT] = ACTIONS(5844),
    [anon_sym_GT_GT] = ACTIONS(5842),
    [anon_sym_AMP_GT] = ACTIONS(5844),
    [anon_sym_AMP_GT_GT] = ACTIONS(5842),
    [anon_sym_LT_AMP] = ACTIONS(5842),
    [anon_sym_GT_AMP] = ACTIONS(5842),
    [anon_sym_LT_LT] = ACTIONS(5844),
    [anon_sym_LT_LT_DASH] = ACTIONS(5842),
    [anon_sym_LT_LT_LT] = ACTIONS(5842),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5842),
    [anon_sym_AMP] = ACTIONS(5844),
  },
  [2725] = {
    [sym_file_descriptor] = ACTIONS(6648),
    [anon_sym_SEMI] = ACTIONS(6650),
    [anon_sym_PIPE] = ACTIONS(6650),
    [anon_sym_SEMI_SEMI] = ACTIONS(6648),
    [anon_sym_PIPE_AMP] = ACTIONS(6648),
    [anon_sym_AMP_AMP] = ACTIONS(6648),
    [anon_sym_PIPE_PIPE] = ACTIONS(6648),
    [anon_sym_LT] = ACTIONS(6650),
    [anon_sym_GT] = ACTIONS(6650),
    [anon_sym_GT_GT] = ACTIONS(6648),
    [anon_sym_AMP_GT] = ACTIONS(6650),
    [anon_sym_AMP_GT_GT] = ACTIONS(6648),
    [anon_sym_LT_AMP] = ACTIONS(6648),
    [anon_sym_GT_AMP] = ACTIONS(6648),
    [anon_sym_LT_LT] = ACTIONS(6650),
    [anon_sym_LT_LT_DASH] = ACTIONS(6648),
    [anon_sym_LT_LT_LT] = ACTIONS(6648),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6648),
    [anon_sym_AMP] = ACTIONS(6650),
  },
  [2726] = {
    [anon_sym_fi] = ACTIONS(7254),
    [sym_comment] = ACTIONS(57),
  },
  [2727] = {
    [sym_file_descriptor] = ACTIONS(6736),
    [anon_sym_SEMI] = ACTIONS(6738),
    [anon_sym_PIPE] = ACTIONS(6738),
    [anon_sym_SEMI_SEMI] = ACTIONS(6736),
    [anon_sym_PIPE_AMP] = ACTIONS(6736),
    [anon_sym_AMP_AMP] = ACTIONS(6736),
    [anon_sym_PIPE_PIPE] = ACTIONS(6736),
    [anon_sym_LT] = ACTIONS(6738),
    [anon_sym_GT] = ACTIONS(6738),
    [anon_sym_GT_GT] = ACTIONS(6736),
    [anon_sym_AMP_GT] = ACTIONS(6738),
    [anon_sym_AMP_GT_GT] = ACTIONS(6736),
    [anon_sym_LT_AMP] = ACTIONS(6736),
    [anon_sym_GT_AMP] = ACTIONS(6736),
    [anon_sym_LT_LT] = ACTIONS(6738),
    [anon_sym_LT_LT_DASH] = ACTIONS(6736),
    [anon_sym_LT_LT_LT] = ACTIONS(6736),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6736),
    [anon_sym_AMP] = ACTIONS(6738),
  },
  [2728] = {
    [anon_sym_esac] = ACTIONS(7256),
    [sym_comment] = ACTIONS(57),
  },
  [2729] = {
    [sym_case_item] = STATE(2403),
    [sym_last_case_item] = STATE(3263),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(2403),
    [aux_sym__literal_repeat1] = STATE(1693),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3482),
  },
  [2730] = {
    [sym_file_descriptor] = ACTIONS(6788),
    [anon_sym_SEMI] = ACTIONS(6790),
    [anon_sym_PIPE] = ACTIONS(6790),
    [anon_sym_SEMI_SEMI] = ACTIONS(6788),
    [anon_sym_PIPE_AMP] = ACTIONS(6788),
    [anon_sym_AMP_AMP] = ACTIONS(6788),
    [anon_sym_PIPE_PIPE] = ACTIONS(6788),
    [anon_sym_LT] = ACTIONS(6790),
    [anon_sym_GT] = ACTIONS(6790),
    [anon_sym_GT_GT] = ACTIONS(6788),
    [anon_sym_AMP_GT] = ACTIONS(6790),
    [anon_sym_AMP_GT_GT] = ACTIONS(6788),
    [anon_sym_LT_AMP] = ACTIONS(6788),
    [anon_sym_GT_AMP] = ACTIONS(6788),
    [anon_sym_LT_LT] = ACTIONS(6790),
    [anon_sym_LT_LT_DASH] = ACTIONS(6788),
    [anon_sym_LT_LT_LT] = ACTIONS(6788),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6788),
    [anon_sym_AMP] = ACTIONS(6790),
  },
  [2731] = {
    [anon_sym_esac] = ACTIONS(7258),
    [sym_comment] = ACTIONS(57),
  },
  [2732] = {
    [sym_case_item] = STATE(2403),
    [sym_last_case_item] = STATE(3265),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(2403),
    [aux_sym__literal_repeat1] = STATE(1693),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3482),
  },
  [2733] = {
    [sym_file_descriptor] = ACTIONS(4383),
    [sym_variable_name] = ACTIONS(4383),
    [anon_sym_SEMI] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI_SEMI] = ACTIONS(4383),
    [anon_sym_PIPE_AMP] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_AMP_GT] = ACTIONS(4385),
    [anon_sym_AMP_GT_GT] = ACTIONS(4383),
    [anon_sym_LT_AMP] = ACTIONS(4383),
    [anon_sym_GT_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_LT_LT_DASH] = ACTIONS(4383),
    [anon_sym_LT_LT_LT] = ACTIONS(4383),
    [sym__special_character] = ACTIONS(4383),
    [anon_sym_DQUOTE] = ACTIONS(4383),
    [anon_sym_DOLLAR] = ACTIONS(4385),
    [sym_raw_string] = ACTIONS(4383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4383),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4383),
    [anon_sym_BQUOTE] = ACTIONS(4383),
    [anon_sym_LT_LPAREN] = ACTIONS(4383),
    [anon_sym_GT_LPAREN] = ACTIONS(4383),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4385),
    [sym_word] = ACTIONS(4385),
    [anon_sym_LF] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
  },
  [2734] = {
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [sym_variable_name] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5566),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [2735] = {
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [sym_variable_name] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5600),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [2736] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(7260),
    [sym_comment] = ACTIONS(57),
  },
  [2737] = {
    [anon_sym_RBRACE] = ACTIONS(7260),
    [sym_comment] = ACTIONS(57),
  },
  [2738] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(7262),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2739] = {
    [sym_concatenation] = STATE(3269),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3269),
    [anon_sym_RBRACE] = ACTIONS(7264),
    [anon_sym_EQ] = ACTIONS(7266),
    [anon_sym_DASH] = ACTIONS(7266),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7268),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7266),
    [anon_sym_COLON_QMARK] = ACTIONS(7266),
    [anon_sym_COLON_DASH] = ACTIONS(7266),
    [anon_sym_PERCENT] = ACTIONS(7266),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2740] = {
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [sym_variable_name] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5617),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [2741] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7264),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2742] = {
    [sym_concatenation] = STATE(3270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3270),
    [anon_sym_RBRACE] = ACTIONS(7260),
    [anon_sym_EQ] = ACTIONS(7270),
    [anon_sym_DASH] = ACTIONS(7270),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7272),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7270),
    [anon_sym_COLON_QMARK] = ACTIONS(7270),
    [anon_sym_COLON_DASH] = ACTIONS(7270),
    [anon_sym_PERCENT] = ACTIONS(7270),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2743] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7260),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2744] = {
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [sym_variable_name] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5660),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [2745] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7274),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2746] = {
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5566),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [2747] = {
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5600),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [2748] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(7276),
    [sym_comment] = ACTIONS(57),
  },
  [2749] = {
    [anon_sym_RBRACE] = ACTIONS(7276),
    [sym_comment] = ACTIONS(57),
  },
  [2750] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(7278),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2751] = {
    [sym_concatenation] = STATE(3275),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3275),
    [anon_sym_RBRACE] = ACTIONS(7280),
    [anon_sym_EQ] = ACTIONS(7282),
    [anon_sym_DASH] = ACTIONS(7282),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7284),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7282),
    [anon_sym_COLON_QMARK] = ACTIONS(7282),
    [anon_sym_COLON_DASH] = ACTIONS(7282),
    [anon_sym_PERCENT] = ACTIONS(7282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2752] = {
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5617),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [2753] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7280),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2754] = {
    [sym_concatenation] = STATE(3276),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3276),
    [anon_sym_RBRACE] = ACTIONS(7276),
    [anon_sym_EQ] = ACTIONS(7286),
    [anon_sym_DASH] = ACTIONS(7286),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7288),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7286),
    [anon_sym_COLON_QMARK] = ACTIONS(7286),
    [anon_sym_COLON_DASH] = ACTIONS(7286),
    [anon_sym_PERCENT] = ACTIONS(7286),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2755] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7276),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2756] = {
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5660),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [2757] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7290),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2758] = {
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_EQ_TILDE] = ACTIONS(7042),
    [anon_sym_EQ_EQ] = ACTIONS(7042),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [2759] = {
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_EQ_TILDE] = ACTIONS(7046),
    [anon_sym_EQ_EQ] = ACTIONS(7046),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [2760] = {
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_EQ_TILDE] = ACTIONS(7050),
    [anon_sym_EQ_EQ] = ACTIONS(7050),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [2761] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7292),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2762] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7294),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2763] = {
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_EQ_TILDE] = ACTIONS(7084),
    [anon_sym_EQ_EQ] = ACTIONS(7084),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [2764] = {
    [sym__simple_heredoc_body] = ACTIONS(2697),
    [sym__heredoc_body_beginning] = ACTIONS(2697),
    [sym_file_descriptor] = ACTIONS(2697),
    [sym_variable_name] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym_done] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI_SEMI] = ACTIONS(2697),
    [anon_sym_PIPE_AMP] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_PIPE_PIPE] = ACTIONS(2697),
    [anon_sym_LT] = ACTIONS(2699),
    [anon_sym_GT] = ACTIONS(2699),
    [anon_sym_GT_GT] = ACTIONS(2697),
    [anon_sym_AMP_GT] = ACTIONS(2699),
    [anon_sym_AMP_GT_GT] = ACTIONS(2697),
    [anon_sym_LT_AMP] = ACTIONS(2697),
    [anon_sym_GT_AMP] = ACTIONS(2697),
    [anon_sym_LT_LT] = ACTIONS(2699),
    [anon_sym_LT_LT_DASH] = ACTIONS(2697),
    [anon_sym_LT_LT_LT] = ACTIONS(2697),
    [sym__special_character] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [anon_sym_DOLLAR] = ACTIONS(2699),
    [sym_raw_string] = ACTIONS(2697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2697),
    [anon_sym_BQUOTE] = ACTIONS(2697),
    [anon_sym_LT_LPAREN] = ACTIONS(2697),
    [anon_sym_GT_LPAREN] = ACTIONS(2697),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2699),
    [anon_sym_LF] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
  },
  [2765] = {
    [sym_concatenation] = STATE(1357),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(1357),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(7296),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [2766] = {
    [sym_string] = STATE(3281),
    [sym_simple_expansion] = STATE(3281),
    [sym_string_expansion] = STATE(3281),
    [sym_expansion] = STATE(3281),
    [sym_command_substitution] = STATE(3281),
    [sym_process_substitution] = STATE(3281),
    [sym__special_character] = ACTIONS(7298),
    [anon_sym_DQUOTE] = ACTIONS(4794),
    [anon_sym_DOLLAR] = ACTIONS(4796),
    [sym_raw_string] = ACTIONS(7298),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4800),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4802),
    [anon_sym_BQUOTE] = ACTIONS(4804),
    [anon_sym_LT_LPAREN] = ACTIONS(4806),
    [anon_sym_GT_LPAREN] = ACTIONS(4806),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7298),
  },
  [2767] = {
    [aux_sym_concatenation_repeat1] = STATE(3282),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(6013),
    [sym_variable_name] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_done] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [2768] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [sym_variable_name] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_done] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [2769] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(7300),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [2770] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(7300),
    [anon_sym_DOLLAR] = ACTIONS(7302),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2771] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_done] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [2772] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [sym_variable_name] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_done] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [2773] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [sym_variable_name] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_done] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [2774] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(7304),
    [sym_comment] = ACTIONS(57),
  },
  [2775] = {
    [sym_subscript] = STATE(3288),
    [sym_variable_name] = ACTIONS(7306),
    [anon_sym_DASH] = ACTIONS(7308),
    [anon_sym_DOLLAR] = ACTIONS(7308),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7310),
    [anon_sym_STAR] = ACTIONS(7312),
    [anon_sym_AT] = ACTIONS(7312),
    [anon_sym_QMARK] = ACTIONS(7312),
    [anon_sym_0] = ACTIONS(7310),
    [anon_sym__] = ACTIONS(7310),
  },
  [2776] = {
    [sym_concatenation] = STATE(3291),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3291),
    [anon_sym_RBRACE] = ACTIONS(7314),
    [anon_sym_EQ] = ACTIONS(7316),
    [anon_sym_DASH] = ACTIONS(7316),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7318),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(7320),
    [anon_sym_COLON] = ACTIONS(7316),
    [anon_sym_COLON_QMARK] = ACTIONS(7316),
    [anon_sym_COLON_DASH] = ACTIONS(7316),
    [anon_sym_PERCENT] = ACTIONS(7316),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2777] = {
    [sym_concatenation] = STATE(3294),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3294),
    [anon_sym_RBRACE] = ACTIONS(7322),
    [anon_sym_EQ] = ACTIONS(7324),
    [anon_sym_DASH] = ACTIONS(7324),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7326),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(7328),
    [anon_sym_COLON] = ACTIONS(7324),
    [anon_sym_COLON_QMARK] = ACTIONS(7324),
    [anon_sym_COLON_DASH] = ACTIONS(7324),
    [anon_sym_PERCENT] = ACTIONS(7324),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2778] = {
    [anon_sym_RPAREN] = ACTIONS(7330),
    [sym_comment] = ACTIONS(57),
  },
  [2779] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(7330),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2780] = {
    [anon_sym_BQUOTE] = ACTIONS(7330),
    [sym_comment] = ACTIONS(57),
  },
  [2781] = {
    [anon_sym_RPAREN] = ACTIONS(7332),
    [sym_comment] = ACTIONS(57),
  },
  [2782] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_done] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [2783] = {
    [aux_sym__literal_repeat1] = STATE(2783),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym_variable_name] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_done] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(7334),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [2784] = {
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_done] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1400),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [2785] = {
    [sym_concatenation] = STATE(3298),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(3298),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(7337),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [2786] = {
    [aux_sym_concatenation_repeat1] = STATE(2174),
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym__concat] = ACTIONS(4810),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_done] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1400),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [2787] = {
    [aux_sym__literal_repeat1] = STATE(2191),
    [sym__simple_heredoc_body] = ACTIONS(1444),
    [sym__heredoc_body_beginning] = ACTIONS(1444),
    [sym_file_descriptor] = ACTIONS(1444),
    [sym_variable_name] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_done] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1446),
    [anon_sym_SEMI_SEMI] = ACTIONS(1444),
    [anon_sym_PIPE_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1446),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_AMP_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT_GT] = ACTIONS(1444),
    [anon_sym_LT_AMP] = ACTIONS(1444),
    [anon_sym_GT_AMP] = ACTIONS(1444),
    [anon_sym_LT_LT] = ACTIONS(1446),
    [anon_sym_LT_LT_DASH] = ACTIONS(1444),
    [anon_sym_LT_LT_LT] = ACTIONS(1444),
    [sym__special_character] = ACTIONS(4836),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [anon_sym_DOLLAR] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1444),
    [anon_sym_BQUOTE] = ACTIONS(1444),
    [anon_sym_LT_LPAREN] = ACTIONS(1444),
    [anon_sym_GT_LPAREN] = ACTIONS(1444),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1446),
    [sym_word] = ACTIONS(1446),
    [anon_sym_LF] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1446),
  },
  [2788] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_done] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2789] = {
    [aux_sym_concatenation_repeat1] = STATE(2789),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(7339),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_done] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2790] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [sym_variable_name] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_done] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2353),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [2791] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(7342),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [2792] = {
    [sym_concatenation] = STATE(3302),
    [sym_string] = STATE(3301),
    [sym_simple_expansion] = STATE(3301),
    [sym_string_expansion] = STATE(3301),
    [sym_expansion] = STATE(3301),
    [sym_command_substitution] = STATE(3301),
    [sym_process_substitution] = STATE(3301),
    [aux_sym__literal_repeat1] = STATE(3303),
    [anon_sym_RBRACE] = ACTIONS(7344),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(7346),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7346),
  },
  [2793] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(7348),
    [sym_comment] = ACTIONS(57),
  },
  [2794] = {
    [sym_concatenation] = STATE(3307),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3307),
    [anon_sym_RBRACE] = ACTIONS(7350),
    [anon_sym_EQ] = ACTIONS(7352),
    [anon_sym_DASH] = ACTIONS(7352),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(7356),
    [anon_sym_COLON] = ACTIONS(7352),
    [anon_sym_COLON_QMARK] = ACTIONS(7352),
    [anon_sym_COLON_DASH] = ACTIONS(7352),
    [anon_sym_PERCENT] = ACTIONS(7352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2795] = {
    [sym_concatenation] = STATE(3309),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3309),
    [anon_sym_RBRACE] = ACTIONS(7344),
    [anon_sym_EQ] = ACTIONS(7358),
    [anon_sym_DASH] = ACTIONS(7358),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(7362),
    [anon_sym_COLON] = ACTIONS(7358),
    [anon_sym_COLON_QMARK] = ACTIONS(7358),
    [anon_sym_COLON_DASH] = ACTIONS(7358),
    [anon_sym_PERCENT] = ACTIONS(7358),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2796] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [sym_variable_name] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_done] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2444),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [2797] = {
    [sym_concatenation] = STATE(3312),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3312),
    [sym_regex] = ACTIONS(7364),
    [anon_sym_RBRACE] = ACTIONS(7366),
    [anon_sym_EQ] = ACTIONS(7368),
    [anon_sym_DASH] = ACTIONS(7368),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7370),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7368),
    [anon_sym_COLON_QMARK] = ACTIONS(7368),
    [anon_sym_COLON_DASH] = ACTIONS(7368),
    [anon_sym_PERCENT] = ACTIONS(7368),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2798] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7366),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2799] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [sym_variable_name] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_done] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2494),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [2800] = {
    [sym_concatenation] = STATE(3309),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3309),
    [sym_regex] = ACTIONS(7372),
    [anon_sym_RBRACE] = ACTIONS(7344),
    [anon_sym_EQ] = ACTIONS(7358),
    [anon_sym_DASH] = ACTIONS(7358),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7358),
    [anon_sym_COLON_QMARK] = ACTIONS(7358),
    [anon_sym_COLON_DASH] = ACTIONS(7358),
    [anon_sym_PERCENT] = ACTIONS(7358),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2801] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7344),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2802] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [sym_variable_name] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_done] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2502),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [2803] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_done] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2536),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [2804] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_done] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2805] = {
    [aux_sym_concatenation_repeat1] = STATE(2805),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(7374),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_done] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2806] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_done] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2353),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [2807] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(7377),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [2808] = {
    [sym_concatenation] = STATE(3317),
    [sym_string] = STATE(3316),
    [sym_simple_expansion] = STATE(3316),
    [sym_string_expansion] = STATE(3316),
    [sym_expansion] = STATE(3316),
    [sym_command_substitution] = STATE(3316),
    [sym_process_substitution] = STATE(3316),
    [aux_sym__literal_repeat1] = STATE(3318),
    [anon_sym_RBRACE] = ACTIONS(7379),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(7381),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7381),
  },
  [2809] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(7383),
    [sym_comment] = ACTIONS(57),
  },
  [2810] = {
    [sym_concatenation] = STATE(3322),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3322),
    [anon_sym_RBRACE] = ACTIONS(7385),
    [anon_sym_EQ] = ACTIONS(7387),
    [anon_sym_DASH] = ACTIONS(7387),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7389),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(7391),
    [anon_sym_COLON] = ACTIONS(7387),
    [anon_sym_COLON_QMARK] = ACTIONS(7387),
    [anon_sym_COLON_DASH] = ACTIONS(7387),
    [anon_sym_PERCENT] = ACTIONS(7387),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2811] = {
    [sym_concatenation] = STATE(3324),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3324),
    [anon_sym_RBRACE] = ACTIONS(7379),
    [anon_sym_EQ] = ACTIONS(7393),
    [anon_sym_DASH] = ACTIONS(7393),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7395),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(7397),
    [anon_sym_COLON] = ACTIONS(7393),
    [anon_sym_COLON_QMARK] = ACTIONS(7393),
    [anon_sym_COLON_DASH] = ACTIONS(7393),
    [anon_sym_PERCENT] = ACTIONS(7393),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2812] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_done] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2444),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [2813] = {
    [sym_concatenation] = STATE(3327),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3327),
    [sym_regex] = ACTIONS(7399),
    [anon_sym_RBRACE] = ACTIONS(7401),
    [anon_sym_EQ] = ACTIONS(7403),
    [anon_sym_DASH] = ACTIONS(7403),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7403),
    [anon_sym_COLON_QMARK] = ACTIONS(7403),
    [anon_sym_COLON_DASH] = ACTIONS(7403),
    [anon_sym_PERCENT] = ACTIONS(7403),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2814] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7401),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2815] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_done] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2494),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [2816] = {
    [sym_concatenation] = STATE(3324),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3324),
    [sym_regex] = ACTIONS(7407),
    [anon_sym_RBRACE] = ACTIONS(7379),
    [anon_sym_EQ] = ACTIONS(7393),
    [anon_sym_DASH] = ACTIONS(7393),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7395),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7393),
    [anon_sym_COLON_QMARK] = ACTIONS(7393),
    [anon_sym_COLON_DASH] = ACTIONS(7393),
    [anon_sym_PERCENT] = ACTIONS(7393),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2817] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7379),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2818] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_done] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2502),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [2819] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_done] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2536),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [2820] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_done] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_EQ_TILDE] = ACTIONS(4055),
    [anon_sym_EQ_EQ] = ACTIONS(4055),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [2821] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_done] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_EQ_TILDE] = ACTIONS(4069),
    [anon_sym_EQ_EQ] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [2822] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(7409),
    [sym_comment] = ACTIONS(57),
  },
  [2823] = {
    [anon_sym_RBRACE] = ACTIONS(7409),
    [sym_comment] = ACTIONS(57),
  },
  [2824] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(7411),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [2825] = {
    [sym_concatenation] = STATE(3332),
    [sym_string] = STATE(3331),
    [sym_simple_expansion] = STATE(3331),
    [sym_string_expansion] = STATE(3331),
    [sym_expansion] = STATE(3331),
    [sym_command_substitution] = STATE(3331),
    [sym_process_substitution] = STATE(3331),
    [aux_sym__literal_repeat1] = STATE(3333),
    [anon_sym_RBRACE] = ACTIONS(7409),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(7413),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7413),
  },
  [2826] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_done] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_EQ_TILDE] = ACTIONS(4105),
    [anon_sym_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [2827] = {
    [sym_concatenation] = STATE(3336),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3336),
    [sym_regex] = ACTIONS(7415),
    [anon_sym_RBRACE] = ACTIONS(7417),
    [anon_sym_EQ] = ACTIONS(7419),
    [anon_sym_DASH] = ACTIONS(7419),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7419),
    [anon_sym_COLON_QMARK] = ACTIONS(7419),
    [anon_sym_COLON_DASH] = ACTIONS(7419),
    [anon_sym_PERCENT] = ACTIONS(7419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2828] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7417),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2829] = {
    [sym_concatenation] = STATE(3338),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3338),
    [sym_regex] = ACTIONS(7423),
    [anon_sym_RBRACE] = ACTIONS(7409),
    [anon_sym_EQ] = ACTIONS(7425),
    [anon_sym_DASH] = ACTIONS(7425),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7427),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7425),
    [anon_sym_COLON_QMARK] = ACTIONS(7425),
    [anon_sym_COLON_DASH] = ACTIONS(7425),
    [anon_sym_PERCENT] = ACTIONS(7425),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2830] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7409),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2831] = {
    [sym_concatenation] = STATE(3340),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3340),
    [anon_sym_RBRACE] = ACTIONS(7429),
    [anon_sym_EQ] = ACTIONS(7431),
    [anon_sym_DASH] = ACTIONS(7431),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7431),
    [anon_sym_COLON_QMARK] = ACTIONS(7431),
    [anon_sym_COLON_DASH] = ACTIONS(7431),
    [anon_sym_PERCENT] = ACTIONS(7431),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2832] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_done] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_EQ_TILDE] = ACTIONS(4161),
    [anon_sym_EQ_EQ] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [2833] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7429),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2834] = {
    [sym_concatenation] = STATE(3338),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3338),
    [anon_sym_RBRACE] = ACTIONS(7409),
    [anon_sym_EQ] = ACTIONS(7425),
    [anon_sym_DASH] = ACTIONS(7425),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7427),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7425),
    [anon_sym_COLON_QMARK] = ACTIONS(7425),
    [anon_sym_COLON_DASH] = ACTIONS(7425),
    [anon_sym_PERCENT] = ACTIONS(7425),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2835] = {
    [aux_sym_concatenation_repeat1] = STATE(2838),
    [sym__simple_heredoc_body] = ACTIONS(1378),
    [sym__heredoc_body_beginning] = ACTIONS(1378),
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_done] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1378),
    [anon_sym_PIPE_AMP] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_AMP] = ACTIONS(1378),
    [anon_sym_GT_AMP] = ACTIONS(1378),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1378),
    [anon_sym_LT_LT_LT] = ACTIONS(1378),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1378),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [2836] = {
    [aux_sym__literal_repeat1] = STATE(2854),
    [sym__simple_heredoc_body] = ACTIONS(1382),
    [sym__heredoc_body_beginning] = ACTIONS(1382),
    [sym_file_descriptor] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym_done] = ACTIONS(1382),
    [anon_sym_PIPE] = ACTIONS(1384),
    [anon_sym_SEMI_SEMI] = ACTIONS(1382),
    [anon_sym_PIPE_AMP] = ACTIONS(1382),
    [anon_sym_AMP_AMP] = ACTIONS(1382),
    [anon_sym_PIPE_PIPE] = ACTIONS(1382),
    [anon_sym_LT] = ACTIONS(1384),
    [anon_sym_GT] = ACTIONS(1384),
    [anon_sym_GT_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT_GT] = ACTIONS(1382),
    [anon_sym_LT_AMP] = ACTIONS(1382),
    [anon_sym_GT_AMP] = ACTIONS(1382),
    [anon_sym_LT_LT] = ACTIONS(1384),
    [anon_sym_LT_LT_DASH] = ACTIONS(1382),
    [anon_sym_LT_LT_LT] = ACTIONS(1382),
    [sym__special_character] = ACTIONS(6247),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
  },
  [2837] = {
    [sym_string] = STATE(3341),
    [sym_simple_expansion] = STATE(3341),
    [sym_string_expansion] = STATE(3341),
    [sym_expansion] = STATE(3341),
    [sym_command_substitution] = STATE(3341),
    [sym_process_substitution] = STATE(3341),
    [sym__special_character] = ACTIONS(7435),
    [anon_sym_DQUOTE] = ACTIONS(4914),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(7435),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4922),
    [anon_sym_BQUOTE] = ACTIONS(4924),
    [anon_sym_LT_LPAREN] = ACTIONS(4926),
    [anon_sym_GT_LPAREN] = ACTIONS(4926),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7435),
  },
  [2838] = {
    [aux_sym_concatenation_repeat1] = STATE(3342),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_done] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [2839] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_done] = ACTIONS(1063),
    [anon_sym_fi] = ACTIONS(1063),
    [anon_sym_elif] = ACTIONS(1063),
    [anon_sym_else] = ACTIONS(1063),
    [anon_sym_esac] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [2840] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(7437),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [2841] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(7437),
    [anon_sym_DOLLAR] = ACTIONS(7439),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2842] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_done] = ACTIONS(1097),
    [anon_sym_fi] = ACTIONS(1097),
    [anon_sym_elif] = ACTIONS(1097),
    [anon_sym_else] = ACTIONS(1097),
    [anon_sym_esac] = ACTIONS(1097),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [2843] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_done] = ACTIONS(1101),
    [anon_sym_fi] = ACTIONS(1101),
    [anon_sym_elif] = ACTIONS(1101),
    [anon_sym_else] = ACTIONS(1101),
    [anon_sym_esac] = ACTIONS(1101),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [2844] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_done] = ACTIONS(1105),
    [anon_sym_fi] = ACTIONS(1105),
    [anon_sym_elif] = ACTIONS(1105),
    [anon_sym_else] = ACTIONS(1105),
    [anon_sym_esac] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [2845] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(7441),
    [sym_comment] = ACTIONS(57),
  },
  [2846] = {
    [sym_subscript] = STATE(3348),
    [sym_variable_name] = ACTIONS(7443),
    [anon_sym_DASH] = ACTIONS(7445),
    [anon_sym_DOLLAR] = ACTIONS(7445),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7447),
    [anon_sym_STAR] = ACTIONS(7449),
    [anon_sym_AT] = ACTIONS(7449),
    [anon_sym_QMARK] = ACTIONS(7449),
    [anon_sym_0] = ACTIONS(7447),
    [anon_sym__] = ACTIONS(7447),
  },
  [2847] = {
    [sym_concatenation] = STATE(3351),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3351),
    [anon_sym_RBRACE] = ACTIONS(7451),
    [anon_sym_EQ] = ACTIONS(7453),
    [anon_sym_DASH] = ACTIONS(7453),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7455),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(7457),
    [anon_sym_COLON] = ACTIONS(7453),
    [anon_sym_COLON_QMARK] = ACTIONS(7453),
    [anon_sym_COLON_DASH] = ACTIONS(7453),
    [anon_sym_PERCENT] = ACTIONS(7453),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2848] = {
    [sym_concatenation] = STATE(3354),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3354),
    [anon_sym_RBRACE] = ACTIONS(7459),
    [anon_sym_EQ] = ACTIONS(7461),
    [anon_sym_DASH] = ACTIONS(7461),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(7465),
    [anon_sym_COLON] = ACTIONS(7461),
    [anon_sym_COLON_QMARK] = ACTIONS(7461),
    [anon_sym_COLON_DASH] = ACTIONS(7461),
    [anon_sym_PERCENT] = ACTIONS(7461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2849] = {
    [anon_sym_RPAREN] = ACTIONS(7467),
    [sym_comment] = ACTIONS(57),
  },
  [2850] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(7467),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2851] = {
    [anon_sym_BQUOTE] = ACTIONS(7467),
    [sym_comment] = ACTIONS(57),
  },
  [2852] = {
    [anon_sym_RPAREN] = ACTIONS(7469),
    [sym_comment] = ACTIONS(57),
  },
  [2853] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_done] = ACTIONS(325),
    [anon_sym_fi] = ACTIONS(325),
    [anon_sym_elif] = ACTIONS(325),
    [anon_sym_else] = ACTIONS(325),
    [anon_sym_esac] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [2854] = {
    [aux_sym__literal_repeat1] = STATE(2854),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_done] = ACTIONS(1371),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(7471),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [2855] = {
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(2584),
    [anon_sym_for] = ACTIONS(2588),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_done] = ACTIONS(7474),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_case] = ACTIONS(2588),
    [anon_sym_function] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2584),
    [anon_sym_declare] = ACTIONS(2588),
    [anon_sym_typeset] = ACTIONS(2588),
    [anon_sym_export] = ACTIONS(2588),
    [anon_sym_readonly] = ACTIONS(2588),
    [anon_sym_local] = ACTIONS(2588),
    [anon_sym_unset] = ACTIONS(2588),
    [anon_sym_unsetenv] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [sym__special_character] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2584),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2584),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [anon_sym_LT_LPAREN] = ACTIONS(2584),
    [anon_sym_GT_LPAREN] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
  },
  [2856] = {
    [sym__simple_heredoc_body] = ACTIONS(2697),
    [sym__heredoc_body_beginning] = ACTIONS(2697),
    [sym_file_descriptor] = ACTIONS(2697),
    [sym_variable_name] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym_fi] = ACTIONS(2699),
    [anon_sym_elif] = ACTIONS(2699),
    [anon_sym_else] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI_SEMI] = ACTIONS(2697),
    [anon_sym_PIPE_AMP] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_PIPE_PIPE] = ACTIONS(2697),
    [anon_sym_LT] = ACTIONS(2699),
    [anon_sym_GT] = ACTIONS(2699),
    [anon_sym_GT_GT] = ACTIONS(2697),
    [anon_sym_AMP_GT] = ACTIONS(2699),
    [anon_sym_AMP_GT_GT] = ACTIONS(2697),
    [anon_sym_LT_AMP] = ACTIONS(2697),
    [anon_sym_GT_AMP] = ACTIONS(2697),
    [anon_sym_LT_LT] = ACTIONS(2699),
    [anon_sym_LT_LT_DASH] = ACTIONS(2697),
    [anon_sym_LT_LT_LT] = ACTIONS(2697),
    [sym__special_character] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [anon_sym_DOLLAR] = ACTIONS(2699),
    [sym_raw_string] = ACTIONS(2697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2697),
    [anon_sym_BQUOTE] = ACTIONS(2697),
    [anon_sym_LT_LPAREN] = ACTIONS(2697),
    [anon_sym_GT_LPAREN] = ACTIONS(2697),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2699),
    [anon_sym_LF] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
  },
  [2857] = {
    [sym_concatenation] = STATE(1357),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(1357),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(7476),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [2858] = {
    [sym_string] = STATE(3358),
    [sym_simple_expansion] = STATE(3358),
    [sym_string_expansion] = STATE(3358),
    [sym_expansion] = STATE(3358),
    [sym_command_substitution] = STATE(3358),
    [sym_process_substitution] = STATE(3358),
    [sym__special_character] = ACTIONS(7478),
    [anon_sym_DQUOTE] = ACTIONS(4951),
    [anon_sym_DOLLAR] = ACTIONS(4953),
    [sym_raw_string] = ACTIONS(7478),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4959),
    [anon_sym_BQUOTE] = ACTIONS(4961),
    [anon_sym_LT_LPAREN] = ACTIONS(4963),
    [anon_sym_GT_LPAREN] = ACTIONS(4963),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7478),
  },
  [2859] = {
    [aux_sym_concatenation_repeat1] = STATE(3359),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(6299),
    [sym_variable_name] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_fi] = ACTIONS(1061),
    [anon_sym_elif] = ACTIONS(1061),
    [anon_sym_else] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [2860] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [sym_variable_name] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_fi] = ACTIONS(1065),
    [anon_sym_elif] = ACTIONS(1065),
    [anon_sym_else] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [2861] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [2862] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(7480),
    [anon_sym_DOLLAR] = ACTIONS(7482),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2863] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_fi] = ACTIONS(1099),
    [anon_sym_elif] = ACTIONS(1099),
    [anon_sym_else] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [2864] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [sym_variable_name] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_fi] = ACTIONS(1103),
    [anon_sym_elif] = ACTIONS(1103),
    [anon_sym_else] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [2865] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [sym_variable_name] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_fi] = ACTIONS(1107),
    [anon_sym_elif] = ACTIONS(1107),
    [anon_sym_else] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [2866] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(7484),
    [sym_comment] = ACTIONS(57),
  },
  [2867] = {
    [sym_subscript] = STATE(3365),
    [sym_variable_name] = ACTIONS(7486),
    [anon_sym_DASH] = ACTIONS(7488),
    [anon_sym_DOLLAR] = ACTIONS(7488),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7490),
    [anon_sym_STAR] = ACTIONS(7492),
    [anon_sym_AT] = ACTIONS(7492),
    [anon_sym_QMARK] = ACTIONS(7492),
    [anon_sym_0] = ACTIONS(7490),
    [anon_sym__] = ACTIONS(7490),
  },
  [2868] = {
    [sym_concatenation] = STATE(3368),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3368),
    [anon_sym_RBRACE] = ACTIONS(7494),
    [anon_sym_EQ] = ACTIONS(7496),
    [anon_sym_DASH] = ACTIONS(7496),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7498),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(7500),
    [anon_sym_COLON] = ACTIONS(7496),
    [anon_sym_COLON_QMARK] = ACTIONS(7496),
    [anon_sym_COLON_DASH] = ACTIONS(7496),
    [anon_sym_PERCENT] = ACTIONS(7496),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2869] = {
    [sym_concatenation] = STATE(3371),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3371),
    [anon_sym_RBRACE] = ACTIONS(7502),
    [anon_sym_EQ] = ACTIONS(7504),
    [anon_sym_DASH] = ACTIONS(7504),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7506),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(7508),
    [anon_sym_COLON] = ACTIONS(7504),
    [anon_sym_COLON_QMARK] = ACTIONS(7504),
    [anon_sym_COLON_DASH] = ACTIONS(7504),
    [anon_sym_PERCENT] = ACTIONS(7504),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2870] = {
    [anon_sym_RPAREN] = ACTIONS(7510),
    [sym_comment] = ACTIONS(57),
  },
  [2871] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(7510),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2872] = {
    [anon_sym_BQUOTE] = ACTIONS(7510),
    [sym_comment] = ACTIONS(57),
  },
  [2873] = {
    [anon_sym_RPAREN] = ACTIONS(7512),
    [sym_comment] = ACTIONS(57),
  },
  [2874] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_fi] = ACTIONS(329),
    [anon_sym_elif] = ACTIONS(329),
    [anon_sym_else] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [2875] = {
    [aux_sym__literal_repeat1] = STATE(2875),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym_variable_name] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_fi] = ACTIONS(1373),
    [anon_sym_elif] = ACTIONS(1373),
    [anon_sym_else] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(7514),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [2876] = {
    [anon_sym_fi] = ACTIONS(7517),
    [anon_sym_elif] = ACTIONS(7517),
    [anon_sym_else] = ACTIONS(7517),
    [sym_comment] = ACTIONS(57),
  },
  [2877] = {
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_fi] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [2878] = {
    [sym_concatenation] = STATE(3375),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(3375),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(7519),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [2879] = {
    [aux_sym_concatenation_repeat1] = STATE(3377),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(7521),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_fi] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [2880] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(3380),
    [anon_sym_DQUOTE] = ACTIONS(7523),
    [anon_sym_DOLLAR] = ACTIONS(7525),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2881] = {
    [sym_string] = STATE(3382),
    [anon_sym_DASH] = ACTIONS(7527),
    [anon_sym_DQUOTE] = ACTIONS(6333),
    [anon_sym_DOLLAR] = ACTIONS(7527),
    [sym_raw_string] = ACTIONS(7529),
    [anon_sym_POUND] = ACTIONS(7527),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7531),
    [anon_sym_STAR] = ACTIONS(7533),
    [anon_sym_AT] = ACTIONS(7533),
    [anon_sym_QMARK] = ACTIONS(7533),
    [anon_sym_0] = ACTIONS(7531),
    [anon_sym__] = ACTIONS(7531),
  },
  [2882] = {
    [aux_sym_concatenation_repeat1] = STATE(3377),
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym__concat] = ACTIONS(7521),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_fi] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [2883] = {
    [sym_subscript] = STATE(3387),
    [sym_variable_name] = ACTIONS(7535),
    [anon_sym_BANG] = ACTIONS(7537),
    [anon_sym_DASH] = ACTIONS(7539),
    [anon_sym_DOLLAR] = ACTIONS(7539),
    [anon_sym_POUND] = ACTIONS(7537),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7541),
    [anon_sym_STAR] = ACTIONS(7543),
    [anon_sym_AT] = ACTIONS(7543),
    [anon_sym_QMARK] = ACTIONS(7543),
    [anon_sym_0] = ACTIONS(7541),
    [anon_sym__] = ACTIONS(7541),
  },
  [2884] = {
    [sym__statements] = STATE(3388),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(3389),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2885] = {
    [sym__statements] = STATE(3390),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [2886] = {
    [sym__statements] = STATE(3391),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [2887] = {
    [aux_sym__literal_repeat1] = STATE(3393),
    [sym__simple_heredoc_body] = ACTIONS(1444),
    [sym__heredoc_body_beginning] = ACTIONS(1444),
    [sym_file_descriptor] = ACTIONS(1444),
    [sym_variable_name] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_fi] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1446),
    [anon_sym_SEMI_SEMI] = ACTIONS(1444),
    [anon_sym_PIPE_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1446),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_AMP_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT_GT] = ACTIONS(1444),
    [anon_sym_LT_AMP] = ACTIONS(1444),
    [anon_sym_GT_AMP] = ACTIONS(1444),
    [anon_sym_LT_LT] = ACTIONS(1446),
    [anon_sym_LT_LT_DASH] = ACTIONS(1444),
    [anon_sym_LT_LT_LT] = ACTIONS(1444),
    [sym__special_character] = ACTIONS(7545),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [anon_sym_DOLLAR] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1444),
    [anon_sym_BQUOTE] = ACTIONS(1444),
    [anon_sym_LT_LPAREN] = ACTIONS(1444),
    [anon_sym_GT_LPAREN] = ACTIONS(1444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1446),
    [anon_sym_LF] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1446),
  },
  [2888] = {
    [sym_concatenation] = STATE(3394),
    [sym_string] = STATE(3396),
    [sym_array] = STATE(3394),
    [sym_simple_expansion] = STATE(3396),
    [sym_string_expansion] = STATE(3396),
    [sym_expansion] = STATE(3396),
    [sym_command_substitution] = STATE(3396),
    [sym_process_substitution] = STATE(3396),
    [aux_sym__literal_repeat1] = STATE(3397),
    [sym__empty_value] = ACTIONS(7547),
    [anon_sym_LPAREN] = ACTIONS(7549),
    [sym__special_character] = ACTIONS(4971),
    [anon_sym_DQUOTE] = ACTIONS(4973),
    [anon_sym_DOLLAR] = ACTIONS(4975),
    [sym_raw_string] = ACTIONS(7551),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4979),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4981),
    [anon_sym_BQUOTE] = ACTIONS(4983),
    [anon_sym_LT_LPAREN] = ACTIONS(4985),
    [anon_sym_GT_LPAREN] = ACTIONS(4985),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7551),
  },
  [2889] = {
    [sym_string] = STATE(3398),
    [sym_simple_expansion] = STATE(3398),
    [sym_string_expansion] = STATE(3398),
    [sym_expansion] = STATE(3398),
    [sym_command_substitution] = STATE(3398),
    [sym_process_substitution] = STATE(3398),
    [sym__special_character] = ACTIONS(7553),
    [anon_sym_DQUOTE] = ACTIONS(4973),
    [anon_sym_DOLLAR] = ACTIONS(4975),
    [sym_raw_string] = ACTIONS(7553),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4979),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4981),
    [anon_sym_BQUOTE] = ACTIONS(4983),
    [anon_sym_LT_LPAREN] = ACTIONS(4985),
    [anon_sym_GT_LPAREN] = ACTIONS(4985),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7553),
  },
  [2890] = {
    [aux_sym_concatenation_repeat1] = STATE(3399),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(6349),
    [sym_variable_name] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_fi] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1061),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [2891] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [sym_variable_name] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_fi] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [2892] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(7555),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [2893] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(7555),
    [anon_sym_DOLLAR] = ACTIONS(7557),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2894] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_fi] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1099),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [2895] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [sym_variable_name] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_fi] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1103),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [2896] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [sym_variable_name] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_fi] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1107),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [2897] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(7559),
    [sym_comment] = ACTIONS(57),
  },
  [2898] = {
    [sym_subscript] = STATE(3405),
    [sym_variable_name] = ACTIONS(7561),
    [anon_sym_DASH] = ACTIONS(7563),
    [anon_sym_DOLLAR] = ACTIONS(7563),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(7567),
    [anon_sym_AT] = ACTIONS(7567),
    [anon_sym_QMARK] = ACTIONS(7567),
    [anon_sym_0] = ACTIONS(7565),
    [anon_sym__] = ACTIONS(7565),
  },
  [2899] = {
    [sym_concatenation] = STATE(3408),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3408),
    [anon_sym_RBRACE] = ACTIONS(7569),
    [anon_sym_EQ] = ACTIONS(7571),
    [anon_sym_DASH] = ACTIONS(7571),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7573),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(7575),
    [anon_sym_COLON] = ACTIONS(7571),
    [anon_sym_COLON_QMARK] = ACTIONS(7571),
    [anon_sym_COLON_DASH] = ACTIONS(7571),
    [anon_sym_PERCENT] = ACTIONS(7571),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2900] = {
    [sym_concatenation] = STATE(3411),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3411),
    [anon_sym_RBRACE] = ACTIONS(7577),
    [anon_sym_EQ] = ACTIONS(7579),
    [anon_sym_DASH] = ACTIONS(7579),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7581),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(7583),
    [anon_sym_COLON] = ACTIONS(7579),
    [anon_sym_COLON_QMARK] = ACTIONS(7579),
    [anon_sym_COLON_DASH] = ACTIONS(7579),
    [anon_sym_PERCENT] = ACTIONS(7579),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2901] = {
    [anon_sym_RPAREN] = ACTIONS(7585),
    [sym_comment] = ACTIONS(57),
  },
  [2902] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(7585),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2903] = {
    [anon_sym_BQUOTE] = ACTIONS(7585),
    [sym_comment] = ACTIONS(57),
  },
  [2904] = {
    [anon_sym_RPAREN] = ACTIONS(7587),
    [sym_comment] = ACTIONS(57),
  },
  [2905] = {
    [sym_variable_assignment] = STATE(2905),
    [sym_subscript] = STATE(2275),
    [sym_concatenation] = STATE(2905),
    [sym_string] = STATE(2270),
    [sym_simple_expansion] = STATE(2270),
    [sym_string_expansion] = STATE(2270),
    [sym_expansion] = STATE(2270),
    [sym_command_substitution] = STATE(2270),
    [sym_process_substitution] = STATE(2270),
    [aux_sym_declaration_command_repeat1] = STATE(2905),
    [aux_sym__literal_repeat1] = STATE(2277),
    [sym__simple_heredoc_body] = ACTIONS(2192),
    [sym__heredoc_body_beginning] = ACTIONS(2192),
    [sym_file_descriptor] = ACTIONS(2192),
    [sym_variable_name] = ACTIONS(7589),
    [anon_sym_SEMI] = ACTIONS(2197),
    [anon_sym_fi] = ACTIONS(2197),
    [anon_sym_PIPE] = ACTIONS(2197),
    [anon_sym_SEMI_SEMI] = ACTIONS(2192),
    [anon_sym_PIPE_AMP] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_GT] = ACTIONS(2197),
    [anon_sym_GT_GT] = ACTIONS(2192),
    [anon_sym_AMP_GT] = ACTIONS(2197),
    [anon_sym_AMP_GT_GT] = ACTIONS(2192),
    [anon_sym_LT_AMP] = ACTIONS(2192),
    [anon_sym_GT_AMP] = ACTIONS(2192),
    [anon_sym_LT_LT] = ACTIONS(2197),
    [anon_sym_LT_LT_DASH] = ACTIONS(2192),
    [anon_sym_LT_LT_LT] = ACTIONS(2192),
    [sym__special_character] = ACTIONS(7592),
    [anon_sym_DQUOTE] = ACTIONS(7595),
    [anon_sym_DOLLAR] = ACTIONS(7598),
    [sym_raw_string] = ACTIONS(7601),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7607),
    [anon_sym_BQUOTE] = ACTIONS(7610),
    [anon_sym_LT_LPAREN] = ACTIONS(7613),
    [anon_sym_GT_LPAREN] = ACTIONS(7613),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7616),
    [sym_word] = ACTIONS(7619),
    [anon_sym_LF] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2197),
  },
  [2906] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_fi] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [2907] = {
    [aux_sym__literal_repeat1] = STATE(2907),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym_variable_name] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_fi] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(7622),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1373),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [2908] = {
    [sym_string] = STATE(3414),
    [sym_simple_expansion] = STATE(3414),
    [sym_string_expansion] = STATE(3414),
    [sym_expansion] = STATE(3414),
    [sym_command_substitution] = STATE(3414),
    [sym_process_substitution] = STATE(3414),
    [sym__special_character] = ACTIONS(7625),
    [anon_sym_DQUOTE] = ACTIONS(4993),
    [anon_sym_DOLLAR] = ACTIONS(4995),
    [sym_raw_string] = ACTIONS(7625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4999),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5001),
    [anon_sym_BQUOTE] = ACTIONS(5003),
    [anon_sym_LT_LPAREN] = ACTIONS(5005),
    [anon_sym_GT_LPAREN] = ACTIONS(5005),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7625),
  },
  [2909] = {
    [aux_sym_concatenation_repeat1] = STATE(3415),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(6377),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_fi] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1061),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [2910] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_fi] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [2911] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(7627),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [2912] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(7627),
    [anon_sym_DOLLAR] = ACTIONS(7629),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [2913] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_fi] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1099),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [2914] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_fi] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1103),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [2915] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_fi] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1107),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [2916] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(7631),
    [sym_comment] = ACTIONS(57),
  },
  [2917] = {
    [sym_subscript] = STATE(3421),
    [sym_variable_name] = ACTIONS(7633),
    [anon_sym_DASH] = ACTIONS(7635),
    [anon_sym_DOLLAR] = ACTIONS(7635),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7637),
    [anon_sym_STAR] = ACTIONS(7639),
    [anon_sym_AT] = ACTIONS(7639),
    [anon_sym_QMARK] = ACTIONS(7639),
    [anon_sym_0] = ACTIONS(7637),
    [anon_sym__] = ACTIONS(7637),
  },
  [2918] = {
    [sym_concatenation] = STATE(3424),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3424),
    [anon_sym_RBRACE] = ACTIONS(7641),
    [anon_sym_EQ] = ACTIONS(7643),
    [anon_sym_DASH] = ACTIONS(7643),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7645),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(7647),
    [anon_sym_COLON] = ACTIONS(7643),
    [anon_sym_COLON_QMARK] = ACTIONS(7643),
    [anon_sym_COLON_DASH] = ACTIONS(7643),
    [anon_sym_PERCENT] = ACTIONS(7643),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2919] = {
    [sym_concatenation] = STATE(3427),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3427),
    [anon_sym_RBRACE] = ACTIONS(7649),
    [anon_sym_EQ] = ACTIONS(7651),
    [anon_sym_DASH] = ACTIONS(7651),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7653),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(7655),
    [anon_sym_COLON] = ACTIONS(7651),
    [anon_sym_COLON_QMARK] = ACTIONS(7651),
    [anon_sym_COLON_DASH] = ACTIONS(7651),
    [anon_sym_PERCENT] = ACTIONS(7651),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2920] = {
    [anon_sym_RPAREN] = ACTIONS(7657),
    [sym_comment] = ACTIONS(57),
  },
  [2921] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(7657),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [2922] = {
    [anon_sym_BQUOTE] = ACTIONS(7657),
    [sym_comment] = ACTIONS(57),
  },
  [2923] = {
    [anon_sym_RPAREN] = ACTIONS(7659),
    [sym_comment] = ACTIONS(57),
  },
  [2924] = {
    [sym_concatenation] = STATE(2924),
    [sym_string] = STATE(2281),
    [sym_simple_expansion] = STATE(2281),
    [sym_string_expansion] = STATE(2281),
    [sym_expansion] = STATE(2281),
    [sym_command_substitution] = STATE(2281),
    [sym_process_substitution] = STATE(2281),
    [aux_sym_unset_command_repeat1] = STATE(2924),
    [aux_sym__literal_repeat1] = STATE(2287),
    [sym__simple_heredoc_body] = ACTIONS(2268),
    [sym__heredoc_body_beginning] = ACTIONS(2268),
    [sym_file_descriptor] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_fi] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2270),
    [anon_sym_SEMI_SEMI] = ACTIONS(2268),
    [anon_sym_PIPE_AMP] = ACTIONS(2268),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [anon_sym_PIPE_PIPE] = ACTIONS(2268),
    [anon_sym_LT] = ACTIONS(2270),
    [anon_sym_GT] = ACTIONS(2270),
    [anon_sym_GT_GT] = ACTIONS(2268),
    [anon_sym_AMP_GT] = ACTIONS(2270),
    [anon_sym_AMP_GT_GT] = ACTIONS(2268),
    [anon_sym_LT_AMP] = ACTIONS(2268),
    [anon_sym_GT_AMP] = ACTIONS(2268),
    [anon_sym_LT_LT] = ACTIONS(2270),
    [anon_sym_LT_LT_DASH] = ACTIONS(2268),
    [anon_sym_LT_LT_LT] = ACTIONS(2268),
    [sym__special_character] = ACTIONS(7661),
    [anon_sym_DQUOTE] = ACTIONS(7664),
    [anon_sym_DOLLAR] = ACTIONS(7667),
    [sym_raw_string] = ACTIONS(7670),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7673),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7676),
    [anon_sym_BQUOTE] = ACTIONS(7679),
    [anon_sym_LT_LPAREN] = ACTIONS(7682),
    [anon_sym_GT_LPAREN] = ACTIONS(7682),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7685),
    [sym_word] = ACTIONS(7688),
    [anon_sym_LF] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2270),
  },
  [2925] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_fi] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [2926] = {
    [aux_sym__literal_repeat1] = STATE(2926),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_fi] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(7691),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1373),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [2927] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_fi] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2346),
    [anon_sym_EQ_EQ] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2928] = {
    [aux_sym_concatenation_repeat1] = STATE(2928),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(7694),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_fi] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2346),
    [anon_sym_EQ_EQ] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2929] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_fi] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_EQ_TILDE] = ACTIONS(2353),
    [anon_sym_EQ_EQ] = ACTIONS(2353),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [2930] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(7697),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [2931] = {
    [sym_concatenation] = STATE(3433),
    [sym_string] = STATE(3432),
    [sym_simple_expansion] = STATE(3432),
    [sym_string_expansion] = STATE(3432),
    [sym_expansion] = STATE(3432),
    [sym_command_substitution] = STATE(3432),
    [sym_process_substitution] = STATE(3432),
    [aux_sym__literal_repeat1] = STATE(3434),
    [anon_sym_RBRACE] = ACTIONS(7699),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(7701),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7701),
  },
  [2932] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(7703),
    [sym_comment] = ACTIONS(57),
  },
  [2933] = {
    [sym_concatenation] = STATE(3438),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3438),
    [anon_sym_RBRACE] = ACTIONS(7705),
    [anon_sym_EQ] = ACTIONS(7707),
    [anon_sym_DASH] = ACTIONS(7707),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7709),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(7711),
    [anon_sym_COLON] = ACTIONS(7707),
    [anon_sym_COLON_QMARK] = ACTIONS(7707),
    [anon_sym_COLON_DASH] = ACTIONS(7707),
    [anon_sym_PERCENT] = ACTIONS(7707),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2934] = {
    [sym_concatenation] = STATE(3440),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3440),
    [anon_sym_RBRACE] = ACTIONS(7699),
    [anon_sym_EQ] = ACTIONS(7713),
    [anon_sym_DASH] = ACTIONS(7713),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7715),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(7717),
    [anon_sym_COLON] = ACTIONS(7713),
    [anon_sym_COLON_QMARK] = ACTIONS(7713),
    [anon_sym_COLON_DASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2935] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_fi] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_EQ_TILDE] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2444),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [2936] = {
    [sym_concatenation] = STATE(3443),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3443),
    [sym_regex] = ACTIONS(7719),
    [anon_sym_RBRACE] = ACTIONS(7721),
    [anon_sym_EQ] = ACTIONS(7723),
    [anon_sym_DASH] = ACTIONS(7723),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7725),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7723),
    [anon_sym_COLON_QMARK] = ACTIONS(7723),
    [anon_sym_COLON_DASH] = ACTIONS(7723),
    [anon_sym_PERCENT] = ACTIONS(7723),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2937] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7721),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2938] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_fi] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_EQ_TILDE] = ACTIONS(2494),
    [anon_sym_EQ_EQ] = ACTIONS(2494),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [2939] = {
    [sym_concatenation] = STATE(3440),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3440),
    [sym_regex] = ACTIONS(7727),
    [anon_sym_RBRACE] = ACTIONS(7699),
    [anon_sym_EQ] = ACTIONS(7713),
    [anon_sym_DASH] = ACTIONS(7713),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7715),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7713),
    [anon_sym_COLON_QMARK] = ACTIONS(7713),
    [anon_sym_COLON_DASH] = ACTIONS(7713),
    [anon_sym_PERCENT] = ACTIONS(7713),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2940] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7699),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2941] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_fi] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_EQ_TILDE] = ACTIONS(2502),
    [anon_sym_EQ_EQ] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [2942] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_fi] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_EQ_TILDE] = ACTIONS(2536),
    [anon_sym_EQ_EQ] = ACTIONS(2536),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [2943] = {
    [sym_concatenation] = STATE(1318),
    [sym_string] = STATE(3445),
    [sym_simple_expansion] = STATE(3445),
    [sym_string_expansion] = STATE(3445),
    [sym_expansion] = STATE(3445),
    [sym_command_substitution] = STATE(3445),
    [sym_process_substitution] = STATE(3445),
    [aux_sym__literal_repeat1] = STATE(3446),
    [sym__special_character] = ACTIONS(6445),
    [anon_sym_DQUOTE] = ACTIONS(4914),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(7729),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4922),
    [anon_sym_BQUOTE] = ACTIONS(4924),
    [anon_sym_LT_LPAREN] = ACTIONS(4926),
    [anon_sym_GT_LPAREN] = ACTIONS(4926),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7729),
  },
  [2944] = {
    [sym_file_redirect] = STATE(2311),
    [sym_heredoc_redirect] = STATE(2311),
    [sym_herestring_redirect] = STATE(2311),
    [aux_sym_redirected_statement_repeat1] = STATE(2311),
    [sym__simple_heredoc_body] = ACTIONS(2564),
    [sym__heredoc_body_beginning] = ACTIONS(2564),
    [sym_file_descriptor] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_fi] = ACTIONS(2564),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT] = ACTIONS(2566),
    [anon_sym_AMP_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_AMP] = ACTIONS(2564),
    [anon_sym_GT_AMP] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_LT_LT_DASH] = ACTIONS(2564),
    [anon_sym_LT_LT_LT] = ACTIONS(2564),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2566),
  },
  [2945] = {
    [sym_file_redirect] = STATE(2311),
    [sym_heredoc_redirect] = STATE(2311),
    [sym_herestring_redirect] = STATE(2311),
    [aux_sym_redirected_statement_repeat1] = STATE(2311),
    [sym__simple_heredoc_body] = ACTIONS(2564),
    [sym__heredoc_body_beginning] = ACTIONS(2564),
    [sym_file_descriptor] = ACTIONS(2564),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_fi] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT] = ACTIONS(2566),
    [anon_sym_AMP_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_AMP] = ACTIONS(2564),
    [anon_sym_GT_AMP] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_LT_LT_DASH] = ACTIONS(2564),
    [anon_sym_LT_LT_LT] = ACTIONS(2564),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2566),
  },
  [2946] = {
    [sym_file_redirect] = STATE(2311),
    [sym_heredoc_redirect] = STATE(2311),
    [sym_herestring_redirect] = STATE(2311),
    [aux_sym_redirected_statement_repeat1] = STATE(2311),
    [sym__simple_heredoc_body] = ACTIONS(2568),
    [sym__heredoc_body_beginning] = ACTIONS(2568),
    [sym_file_descriptor] = ACTIONS(2568),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_fi] = ACTIONS(2568),
    [anon_sym_PIPE] = ACTIONS(5041),
    [anon_sym_SEMI_SEMI] = ACTIONS(2568),
    [anon_sym_PIPE_AMP] = ACTIONS(5045),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_GT] = ACTIONS(2570),
    [anon_sym_GT_GT] = ACTIONS(2568),
    [anon_sym_AMP_GT] = ACTIONS(2570),
    [anon_sym_AMP_GT_GT] = ACTIONS(2568),
    [anon_sym_LT_AMP] = ACTIONS(2568),
    [anon_sym_GT_AMP] = ACTIONS(2568),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_LT_LT_DASH] = ACTIONS(2568),
    [anon_sym_LT_LT_LT] = ACTIONS(2568),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2570),
  },
  [2947] = {
    [sym_file_redirect] = STATE(2311),
    [sym_heredoc_redirect] = STATE(2311),
    [sym_herestring_redirect] = STATE(2311),
    [aux_sym_redirected_statement_repeat1] = STATE(2311),
    [sym__simple_heredoc_body] = ACTIONS(2568),
    [sym__heredoc_body_beginning] = ACTIONS(2568),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_fi] = ACTIONS(2570),
    [anon_sym_PIPE] = ACTIONS(5041),
    [anon_sym_SEMI_SEMI] = ACTIONS(2568),
    [anon_sym_PIPE_AMP] = ACTIONS(5045),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_LT_LT_DASH] = ACTIONS(2568),
    [anon_sym_LT_LT_LT] = ACTIONS(2568),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2570),
  },
  [2948] = {
    [aux_sym_concatenation_repeat1] = STATE(3447),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_fi] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [2949] = {
    [aux_sym_concatenation_repeat1] = STATE(3447),
    [sym__simple_heredoc_body] = ACTIONS(1037),
    [sym__heredoc_body_beginning] = ACTIONS(1037),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_fi] = ACTIONS(1037),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [2950] = {
    [aux_sym__literal_repeat1] = STATE(3448),
    [sym__simple_heredoc_body] = ACTIONS(1051),
    [sym__heredoc_body_beginning] = ACTIONS(1051),
    [sym_file_descriptor] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_fi] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_LT_LT_DASH] = ACTIONS(1051),
    [anon_sym_LT_LT_LT] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(6247),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1051),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [2951] = {
    [aux_sym_concatenation_repeat1] = STATE(3447),
    [sym__simple_heredoc_body] = ACTIONS(2576),
    [sym__heredoc_body_beginning] = ACTIONS(2576),
    [sym_file_descriptor] = ACTIONS(2576),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym_fi] = ACTIONS(2576),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI_SEMI] = ACTIONS(2576),
    [anon_sym_PIPE_AMP] = ACTIONS(2576),
    [anon_sym_AMP_AMP] = ACTIONS(2576),
    [anon_sym_PIPE_PIPE] = ACTIONS(2576),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_GT] = ACTIONS(2576),
    [anon_sym_AMP_GT] = ACTIONS(2578),
    [anon_sym_AMP_GT_GT] = ACTIONS(2576),
    [anon_sym_LT_AMP] = ACTIONS(2576),
    [anon_sym_GT_AMP] = ACTIONS(2576),
    [anon_sym_LT_LT] = ACTIONS(2578),
    [anon_sym_LT_LT_DASH] = ACTIONS(2576),
    [anon_sym_LT_LT_LT] = ACTIONS(2576),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2576),
    [anon_sym_AMP] = ACTIONS(2578),
  },
  [2952] = {
    [aux_sym__literal_repeat1] = STATE(3448),
    [sym__simple_heredoc_body] = ACTIONS(2580),
    [sym__heredoc_body_beginning] = ACTIONS(2580),
    [sym_file_descriptor] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym_fi] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_SEMI_SEMI] = ACTIONS(2580),
    [anon_sym_PIPE_AMP] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_AMP_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_AMP] = ACTIONS(2580),
    [anon_sym_GT_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2582),
    [anon_sym_LT_LT_DASH] = ACTIONS(2580),
    [anon_sym_LT_LT_LT] = ACTIONS(2580),
    [sym__special_character] = ACTIONS(6247),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2580),
    [anon_sym_AMP] = ACTIONS(2582),
  },
  [2953] = {
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(2584),
    [anon_sym_for] = ACTIONS(2588),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_fi] = ACTIONS(6249),
    [anon_sym_case] = ACTIONS(2588),
    [anon_sym_function] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2584),
    [anon_sym_declare] = ACTIONS(2588),
    [anon_sym_typeset] = ACTIONS(2588),
    [anon_sym_export] = ACTIONS(2588),
    [anon_sym_readonly] = ACTIONS(2588),
    [anon_sym_local] = ACTIONS(2588),
    [anon_sym_unset] = ACTIONS(2588),
    [anon_sym_unsetenv] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [sym__special_character] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2584),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2584),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [anon_sym_LT_LPAREN] = ACTIONS(2584),
    [anon_sym_GT_LPAREN] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
  },
  [2954] = {
    [sym_file_redirect] = STATE(2954),
    [sym_heredoc_redirect] = STATE(2954),
    [sym_herestring_redirect] = STATE(2954),
    [aux_sym_redirected_statement_repeat1] = STATE(2954),
    [sym__simple_heredoc_body] = ACTIONS(2590),
    [sym__heredoc_body_beginning] = ACTIONS(2590),
    [sym_file_descriptor] = ACTIONS(7731),
    [anon_sym_SEMI] = ACTIONS(2595),
    [anon_sym_fi] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(2595),
    [anon_sym_SEMI_SEMI] = ACTIONS(2590),
    [anon_sym_PIPE_AMP] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(7734),
    [anon_sym_GT] = ACTIONS(7734),
    [anon_sym_GT_GT] = ACTIONS(7737),
    [anon_sym_AMP_GT] = ACTIONS(7734),
    [anon_sym_AMP_GT_GT] = ACTIONS(7737),
    [anon_sym_LT_AMP] = ACTIONS(7737),
    [anon_sym_GT_AMP] = ACTIONS(7737),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_LT_LT_DASH] = ACTIONS(2606),
    [anon_sym_LT_LT_LT] = ACTIONS(7740),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2595),
  },
  [2955] = {
    [sym__simple_heredoc_body] = ACTIONS(2612),
    [sym__heredoc_body_beginning] = ACTIONS(2612),
    [sym_file_descriptor] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_fi] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(2614),
    [anon_sym_EQ_EQ] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2612),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2612),
    [anon_sym_BQUOTE] = ACTIONS(2612),
    [anon_sym_LT_LPAREN] = ACTIONS(2612),
    [anon_sym_GT_LPAREN] = ACTIONS(2612),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2614),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [2956] = {
    [aux_sym_concatenation_repeat1] = STATE(2289),
    [sym__simple_heredoc_body] = ACTIONS(2612),
    [sym__heredoc_body_beginning] = ACTIONS(2612),
    [sym_file_descriptor] = ACTIONS(2612),
    [sym__concat] = ACTIONS(5011),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_fi] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(2614),
    [anon_sym_EQ_EQ] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2612),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2612),
    [anon_sym_BQUOTE] = ACTIONS(2612),
    [anon_sym_LT_LPAREN] = ACTIONS(2612),
    [anon_sym_GT_LPAREN] = ACTIONS(2612),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2614),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [2957] = {
    [aux_sym__literal_repeat1] = STATE(2320),
    [sym__simple_heredoc_body] = ACTIONS(2616),
    [sym__heredoc_body_beginning] = ACTIONS(2616),
    [sym_file_descriptor] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_fi] = ACTIONS(2618),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_SEMI_SEMI] = ACTIONS(2616),
    [anon_sym_PIPE_AMP] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_EQ_TILDE] = ACTIONS(2618),
    [anon_sym_EQ_EQ] = ACTIONS(2618),
    [anon_sym_LT] = ACTIONS(2618),
    [anon_sym_GT] = ACTIONS(2618),
    [anon_sym_GT_GT] = ACTIONS(2616),
    [anon_sym_AMP_GT] = ACTIONS(2618),
    [anon_sym_AMP_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_AMP] = ACTIONS(2616),
    [anon_sym_GT_AMP] = ACTIONS(2616),
    [anon_sym_LT_LT] = ACTIONS(2618),
    [anon_sym_LT_LT_DASH] = ACTIONS(2616),
    [anon_sym_LT_LT_LT] = ACTIONS(2616),
    [sym__special_character] = ACTIONS(5063),
    [anon_sym_DQUOTE] = ACTIONS(2616),
    [anon_sym_DOLLAR] = ACTIONS(2618),
    [sym_raw_string] = ACTIONS(2616),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2616),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2616),
    [anon_sym_BQUOTE] = ACTIONS(2616),
    [anon_sym_LT_LPAREN] = ACTIONS(2616),
    [anon_sym_GT_LPAREN] = ACTIONS(2616),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2618),
    [anon_sym_LF] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2618),
  },
  [2958] = {
    [sym_concatenation] = STATE(2958),
    [sym_string] = STATE(2313),
    [sym_simple_expansion] = STATE(2313),
    [sym_string_expansion] = STATE(2313),
    [sym_expansion] = STATE(2313),
    [sym_command_substitution] = STATE(2313),
    [sym_process_substitution] = STATE(2313),
    [aux_sym_command_repeat2] = STATE(2958),
    [aux_sym__literal_repeat1] = STATE(2315),
    [sym__simple_heredoc_body] = ACTIONS(2612),
    [sym__heredoc_body_beginning] = ACTIONS(2612),
    [sym_file_descriptor] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_fi] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(7743),
    [anon_sym_EQ_EQ] = ACTIONS(7743),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(7746),
    [anon_sym_DQUOTE] = ACTIONS(7749),
    [anon_sym_DOLLAR] = ACTIONS(7752),
    [sym_raw_string] = ACTIONS(7755),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7758),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7761),
    [anon_sym_BQUOTE] = ACTIONS(7764),
    [anon_sym_LT_LPAREN] = ACTIONS(7767),
    [anon_sym_GT_LPAREN] = ACTIONS(7767),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7770),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [2959] = {
    [sym_file_descriptor] = ACTIONS(1235),
    [sym_variable_name] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1239),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1239),
    [anon_sym_if] = ACTIONS(1239),
    [anon_sym_fi] = ACTIONS(6249),
    [anon_sym_case] = ACTIONS(1239),
    [anon_sym_function] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1239),
    [anon_sym_typeset] = ACTIONS(1239),
    [anon_sym_export] = ACTIONS(1239),
    [anon_sym_readonly] = ACTIONS(1239),
    [anon_sym_local] = ACTIONS(1239),
    [anon_sym_unset] = ACTIONS(1239),
    [anon_sym_unsetenv] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_AMP_GT] = ACTIONS(1239),
    [anon_sym_AMP_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_AMP] = ACTIONS(1235),
    [anon_sym_GT_AMP] = ACTIONS(1235),
    [sym__special_character] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_DOLLAR] = ACTIONS(1239),
    [sym_raw_string] = ACTIONS(1235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1235),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1235),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [anon_sym_LT_LPAREN] = ACTIONS(1235),
    [anon_sym_GT_LPAREN] = ACTIONS(1235),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1239),
  },
  [2960] = {
    [anon_sym_SEMI] = ACTIONS(7773),
    [anon_sym_fi] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(7775),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7775),
    [anon_sym_AMP] = ACTIONS(7775),
  },
  [2961] = {
    [sym_concatenation] = STATE(2958),
    [sym_string] = STATE(2313),
    [sym_simple_expansion] = STATE(2313),
    [sym_string_expansion] = STATE(2313),
    [sym_expansion] = STATE(2313),
    [sym_command_substitution] = STATE(2313),
    [sym_process_substitution] = STATE(2313),
    [aux_sym_command_repeat2] = STATE(2958),
    [aux_sym__literal_repeat1] = STATE(2315),
    [sym__simple_heredoc_body] = ACTIONS(2676),
    [sym__heredoc_body_beginning] = ACTIONS(2676),
    [sym_file_descriptor] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym_fi] = ACTIONS(2678),
    [anon_sym_PIPE] = ACTIONS(2678),
    [anon_sym_SEMI_SEMI] = ACTIONS(2676),
    [anon_sym_PIPE_AMP] = ACTIONS(2676),
    [anon_sym_AMP_AMP] = ACTIONS(2676),
    [anon_sym_PIPE_PIPE] = ACTIONS(2676),
    [anon_sym_EQ_TILDE] = ACTIONS(5055),
    [anon_sym_EQ_EQ] = ACTIONS(5055),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_GT] = ACTIONS(2678),
    [anon_sym_GT_GT] = ACTIONS(2676),
    [anon_sym_AMP_GT] = ACTIONS(2678),
    [anon_sym_AMP_GT_GT] = ACTIONS(2676),
    [anon_sym_LT_AMP] = ACTIONS(2676),
    [anon_sym_GT_AMP] = ACTIONS(2676),
    [anon_sym_LT_LT] = ACTIONS(2678),
    [anon_sym_LT_LT_DASH] = ACTIONS(2676),
    [anon_sym_LT_LT_LT] = ACTIONS(2676),
    [sym__special_character] = ACTIONS(5057),
    [anon_sym_DQUOTE] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(3359),
    [sym_raw_string] = ACTIONS(5059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3363),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3365),
    [anon_sym_BQUOTE] = ACTIONS(3367),
    [anon_sym_LT_LPAREN] = ACTIONS(3369),
    [anon_sym_GT_LPAREN] = ACTIONS(3369),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5061),
    [anon_sym_LF] = ACTIONS(2676),
    [anon_sym_AMP] = ACTIONS(2678),
  },
  [2962] = {
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_fi] = ACTIONS(1400),
    [anon_sym_elif] = ACTIONS(1400),
    [anon_sym_else] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1400),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [2963] = {
    [sym_concatenation] = STATE(3451),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(3451),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(7777),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [2964] = {
    [aux_sym_concatenation_repeat1] = STATE(2323),
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym__concat] = ACTIONS(5067),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_fi] = ACTIONS(1400),
    [anon_sym_elif] = ACTIONS(1400),
    [anon_sym_else] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1400),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [2965] = {
    [aux_sym__literal_repeat1] = STATE(2340),
    [sym__simple_heredoc_body] = ACTIONS(1444),
    [sym__heredoc_body_beginning] = ACTIONS(1444),
    [sym_file_descriptor] = ACTIONS(1444),
    [sym_variable_name] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_fi] = ACTIONS(1446),
    [anon_sym_elif] = ACTIONS(1446),
    [anon_sym_else] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1446),
    [anon_sym_SEMI_SEMI] = ACTIONS(1444),
    [anon_sym_PIPE_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1446),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_AMP_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT_GT] = ACTIONS(1444),
    [anon_sym_LT_AMP] = ACTIONS(1444),
    [anon_sym_GT_AMP] = ACTIONS(1444),
    [anon_sym_LT_LT] = ACTIONS(1446),
    [anon_sym_LT_LT_DASH] = ACTIONS(1444),
    [anon_sym_LT_LT_LT] = ACTIONS(1444),
    [sym__special_character] = ACTIONS(5093),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [anon_sym_DOLLAR] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1444),
    [anon_sym_BQUOTE] = ACTIONS(1444),
    [anon_sym_LT_LPAREN] = ACTIONS(1444),
    [anon_sym_GT_LPAREN] = ACTIONS(1444),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1446),
    [sym_word] = ACTIONS(1446),
    [anon_sym_LF] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1446),
  },
  [2966] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_fi] = ACTIONS(2346),
    [anon_sym_elif] = ACTIONS(2346),
    [anon_sym_else] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2967] = {
    [aux_sym_concatenation_repeat1] = STATE(2967),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(7779),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_fi] = ACTIONS(2346),
    [anon_sym_elif] = ACTIONS(2346),
    [anon_sym_else] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2968] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [sym_variable_name] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_fi] = ACTIONS(2353),
    [anon_sym_elif] = ACTIONS(2353),
    [anon_sym_else] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2353),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [2969] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(7782),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [2970] = {
    [sym_concatenation] = STATE(3455),
    [sym_string] = STATE(3454),
    [sym_simple_expansion] = STATE(3454),
    [sym_string_expansion] = STATE(3454),
    [sym_expansion] = STATE(3454),
    [sym_command_substitution] = STATE(3454),
    [sym_process_substitution] = STATE(3454),
    [aux_sym__literal_repeat1] = STATE(3456),
    [anon_sym_RBRACE] = ACTIONS(7784),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(7786),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7786),
  },
  [2971] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(7788),
    [sym_comment] = ACTIONS(57),
  },
  [2972] = {
    [sym_concatenation] = STATE(3460),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3460),
    [anon_sym_RBRACE] = ACTIONS(7790),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_DASH] = ACTIONS(7792),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7794),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(7796),
    [anon_sym_COLON] = ACTIONS(7792),
    [anon_sym_COLON_QMARK] = ACTIONS(7792),
    [anon_sym_COLON_DASH] = ACTIONS(7792),
    [anon_sym_PERCENT] = ACTIONS(7792),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2973] = {
    [sym_concatenation] = STATE(3462),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3462),
    [anon_sym_RBRACE] = ACTIONS(7784),
    [anon_sym_EQ] = ACTIONS(7798),
    [anon_sym_DASH] = ACTIONS(7798),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7800),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(7802),
    [anon_sym_COLON] = ACTIONS(7798),
    [anon_sym_COLON_QMARK] = ACTIONS(7798),
    [anon_sym_COLON_DASH] = ACTIONS(7798),
    [anon_sym_PERCENT] = ACTIONS(7798),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2974] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [sym_variable_name] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_fi] = ACTIONS(2444),
    [anon_sym_elif] = ACTIONS(2444),
    [anon_sym_else] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2444),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [2975] = {
    [sym_concatenation] = STATE(3465),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3465),
    [sym_regex] = ACTIONS(7804),
    [anon_sym_RBRACE] = ACTIONS(7806),
    [anon_sym_EQ] = ACTIONS(7808),
    [anon_sym_DASH] = ACTIONS(7808),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7810),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7808),
    [anon_sym_COLON_QMARK] = ACTIONS(7808),
    [anon_sym_COLON_DASH] = ACTIONS(7808),
    [anon_sym_PERCENT] = ACTIONS(7808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2976] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7806),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2977] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [sym_variable_name] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_fi] = ACTIONS(2494),
    [anon_sym_elif] = ACTIONS(2494),
    [anon_sym_else] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2494),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [2978] = {
    [sym_concatenation] = STATE(3462),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3462),
    [sym_regex] = ACTIONS(7812),
    [anon_sym_RBRACE] = ACTIONS(7784),
    [anon_sym_EQ] = ACTIONS(7798),
    [anon_sym_DASH] = ACTIONS(7798),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7800),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7798),
    [anon_sym_COLON_QMARK] = ACTIONS(7798),
    [anon_sym_COLON_DASH] = ACTIONS(7798),
    [anon_sym_PERCENT] = ACTIONS(7798),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2979] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7784),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2980] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [sym_variable_name] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_fi] = ACTIONS(2502),
    [anon_sym_elif] = ACTIONS(2502),
    [anon_sym_else] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2502),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [2981] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_fi] = ACTIONS(2536),
    [anon_sym_elif] = ACTIONS(2536),
    [anon_sym_else] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2536),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [2982] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_fi] = ACTIONS(2346),
    [anon_sym_elif] = ACTIONS(2346),
    [anon_sym_else] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2983] = {
    [aux_sym_concatenation_repeat1] = STATE(2983),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(7814),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_fi] = ACTIONS(2346),
    [anon_sym_elif] = ACTIONS(2346),
    [anon_sym_else] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [2984] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_fi] = ACTIONS(2353),
    [anon_sym_elif] = ACTIONS(2353),
    [anon_sym_else] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2353),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [2985] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(7817),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [2986] = {
    [sym_concatenation] = STATE(3470),
    [sym_string] = STATE(3469),
    [sym_simple_expansion] = STATE(3469),
    [sym_string_expansion] = STATE(3469),
    [sym_expansion] = STATE(3469),
    [sym_command_substitution] = STATE(3469),
    [sym_process_substitution] = STATE(3469),
    [aux_sym__literal_repeat1] = STATE(3471),
    [anon_sym_RBRACE] = ACTIONS(7819),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(7821),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7821),
  },
  [2987] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(7823),
    [sym_comment] = ACTIONS(57),
  },
  [2988] = {
    [sym_concatenation] = STATE(3475),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3475),
    [anon_sym_RBRACE] = ACTIONS(7825),
    [anon_sym_EQ] = ACTIONS(7827),
    [anon_sym_DASH] = ACTIONS(7827),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7829),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(7831),
    [anon_sym_COLON] = ACTIONS(7827),
    [anon_sym_COLON_QMARK] = ACTIONS(7827),
    [anon_sym_COLON_DASH] = ACTIONS(7827),
    [anon_sym_PERCENT] = ACTIONS(7827),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2989] = {
    [sym_concatenation] = STATE(3477),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3477),
    [anon_sym_RBRACE] = ACTIONS(7819),
    [anon_sym_EQ] = ACTIONS(7833),
    [anon_sym_DASH] = ACTIONS(7833),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7835),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(7837),
    [anon_sym_COLON] = ACTIONS(7833),
    [anon_sym_COLON_QMARK] = ACTIONS(7833),
    [anon_sym_COLON_DASH] = ACTIONS(7833),
    [anon_sym_PERCENT] = ACTIONS(7833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2990] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_fi] = ACTIONS(2444),
    [anon_sym_elif] = ACTIONS(2444),
    [anon_sym_else] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2444),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [2991] = {
    [sym_concatenation] = STATE(3480),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3480),
    [sym_regex] = ACTIONS(7839),
    [anon_sym_RBRACE] = ACTIONS(7841),
    [anon_sym_EQ] = ACTIONS(7843),
    [anon_sym_DASH] = ACTIONS(7843),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7845),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7843),
    [anon_sym_COLON_QMARK] = ACTIONS(7843),
    [anon_sym_COLON_DASH] = ACTIONS(7843),
    [anon_sym_PERCENT] = ACTIONS(7843),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2992] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7841),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2993] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_fi] = ACTIONS(2494),
    [anon_sym_elif] = ACTIONS(2494),
    [anon_sym_else] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2494),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [2994] = {
    [sym_concatenation] = STATE(3477),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3477),
    [sym_regex] = ACTIONS(7847),
    [anon_sym_RBRACE] = ACTIONS(7819),
    [anon_sym_EQ] = ACTIONS(7833),
    [anon_sym_DASH] = ACTIONS(7833),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7835),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7833),
    [anon_sym_COLON_QMARK] = ACTIONS(7833),
    [anon_sym_COLON_DASH] = ACTIONS(7833),
    [anon_sym_PERCENT] = ACTIONS(7833),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2995] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7819),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [2996] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_fi] = ACTIONS(2502),
    [anon_sym_elif] = ACTIONS(2502),
    [anon_sym_else] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2502),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [2997] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_fi] = ACTIONS(2536),
    [anon_sym_elif] = ACTIONS(2536),
    [anon_sym_else] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2536),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [2998] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_fi] = ACTIONS(4055),
    [anon_sym_elif] = ACTIONS(4055),
    [anon_sym_else] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_EQ_TILDE] = ACTIONS(4055),
    [anon_sym_EQ_EQ] = ACTIONS(4055),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [2999] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_fi] = ACTIONS(4069),
    [anon_sym_elif] = ACTIONS(4069),
    [anon_sym_else] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_EQ_TILDE] = ACTIONS(4069),
    [anon_sym_EQ_EQ] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [3000] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(7849),
    [sym_comment] = ACTIONS(57),
  },
  [3001] = {
    [anon_sym_RBRACE] = ACTIONS(7849),
    [sym_comment] = ACTIONS(57),
  },
  [3002] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(7851),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3003] = {
    [sym_concatenation] = STATE(3485),
    [sym_string] = STATE(3484),
    [sym_simple_expansion] = STATE(3484),
    [sym_string_expansion] = STATE(3484),
    [sym_expansion] = STATE(3484),
    [sym_command_substitution] = STATE(3484),
    [sym_process_substitution] = STATE(3484),
    [aux_sym__literal_repeat1] = STATE(3486),
    [anon_sym_RBRACE] = ACTIONS(7849),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(7853),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7853),
  },
  [3004] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_fi] = ACTIONS(4105),
    [anon_sym_elif] = ACTIONS(4105),
    [anon_sym_else] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_EQ_TILDE] = ACTIONS(4105),
    [anon_sym_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [3005] = {
    [sym_concatenation] = STATE(3489),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3489),
    [sym_regex] = ACTIONS(7855),
    [anon_sym_RBRACE] = ACTIONS(7857),
    [anon_sym_EQ] = ACTIONS(7859),
    [anon_sym_DASH] = ACTIONS(7859),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7859),
    [anon_sym_COLON_QMARK] = ACTIONS(7859),
    [anon_sym_COLON_DASH] = ACTIONS(7859),
    [anon_sym_PERCENT] = ACTIONS(7859),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3006] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7857),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3007] = {
    [sym_concatenation] = STATE(3491),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3491),
    [sym_regex] = ACTIONS(7863),
    [anon_sym_RBRACE] = ACTIONS(7849),
    [anon_sym_EQ] = ACTIONS(7865),
    [anon_sym_DASH] = ACTIONS(7865),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7867),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7865),
    [anon_sym_COLON_QMARK] = ACTIONS(7865),
    [anon_sym_COLON_DASH] = ACTIONS(7865),
    [anon_sym_PERCENT] = ACTIONS(7865),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3008] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7849),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3009] = {
    [sym_concatenation] = STATE(3493),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3493),
    [anon_sym_RBRACE] = ACTIONS(7869),
    [anon_sym_EQ] = ACTIONS(7871),
    [anon_sym_DASH] = ACTIONS(7871),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7871),
    [anon_sym_COLON_QMARK] = ACTIONS(7871),
    [anon_sym_COLON_DASH] = ACTIONS(7871),
    [anon_sym_PERCENT] = ACTIONS(7871),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3010] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_fi] = ACTIONS(4161),
    [anon_sym_elif] = ACTIONS(4161),
    [anon_sym_else] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_EQ_TILDE] = ACTIONS(4161),
    [anon_sym_EQ_EQ] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [3011] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(7869),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3012] = {
    [sym_concatenation] = STATE(3491),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3491),
    [anon_sym_RBRACE] = ACTIONS(7849),
    [anon_sym_EQ] = ACTIONS(7865),
    [anon_sym_DASH] = ACTIONS(7865),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(7867),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(7865),
    [anon_sym_COLON_QMARK] = ACTIONS(7865),
    [anon_sym_COLON_DASH] = ACTIONS(7865),
    [anon_sym_PERCENT] = ACTIONS(7865),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3013] = {
    [sym__simple_heredoc_body] = ACTIONS(7875),
    [sym__heredoc_body_beginning] = ACTIONS(7875),
    [sym_file_descriptor] = ACTIONS(7875),
    [ts_builtin_sym_end] = ACTIONS(7875),
    [anon_sym_SEMI] = ACTIONS(7877),
    [anon_sym_done] = ACTIONS(7875),
    [anon_sym_fi] = ACTIONS(7875),
    [anon_sym_elif] = ACTIONS(7875),
    [anon_sym_else] = ACTIONS(7875),
    [anon_sym_esac] = ACTIONS(7875),
    [anon_sym_PIPE] = ACTIONS(7877),
    [anon_sym_RPAREN] = ACTIONS(7875),
    [anon_sym_SEMI_SEMI] = ACTIONS(7875),
    [anon_sym_PIPE_AMP] = ACTIONS(7875),
    [anon_sym_AMP_AMP] = ACTIONS(7875),
    [anon_sym_PIPE_PIPE] = ACTIONS(7875),
    [anon_sym_LT] = ACTIONS(7877),
    [anon_sym_GT] = ACTIONS(7877),
    [anon_sym_GT_GT] = ACTIONS(7875),
    [anon_sym_AMP_GT] = ACTIONS(7877),
    [anon_sym_AMP_GT_GT] = ACTIONS(7875),
    [anon_sym_LT_AMP] = ACTIONS(7875),
    [anon_sym_GT_AMP] = ACTIONS(7875),
    [anon_sym_LT_LT] = ACTIONS(7877),
    [anon_sym_LT_LT_DASH] = ACTIONS(7875),
    [anon_sym_LT_LT_LT] = ACTIONS(7875),
    [anon_sym_BQUOTE] = ACTIONS(7875),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7875),
    [anon_sym_AMP] = ACTIONS(7877),
  },
  [3014] = {
    [aux_sym_concatenation_repeat1] = STATE(3016),
    [sym__simple_heredoc_body] = ACTIONS(1378),
    [sym__heredoc_body_beginning] = ACTIONS(1378),
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_fi] = ACTIONS(1378),
    [anon_sym_elif] = ACTIONS(1378),
    [anon_sym_else] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1378),
    [anon_sym_PIPE_AMP] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_AMP] = ACTIONS(1378),
    [anon_sym_GT_AMP] = ACTIONS(1378),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1378),
    [anon_sym_LT_LT_LT] = ACTIONS(1378),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1378),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [3015] = {
    [aux_sym__literal_repeat1] = STATE(3017),
    [sym__simple_heredoc_body] = ACTIONS(1382),
    [sym__heredoc_body_beginning] = ACTIONS(1382),
    [sym_file_descriptor] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym_fi] = ACTIONS(1382),
    [anon_sym_elif] = ACTIONS(1382),
    [anon_sym_else] = ACTIONS(1382),
    [anon_sym_PIPE] = ACTIONS(1384),
    [anon_sym_SEMI_SEMI] = ACTIONS(1382),
    [anon_sym_PIPE_AMP] = ACTIONS(1382),
    [anon_sym_AMP_AMP] = ACTIONS(1382),
    [anon_sym_PIPE_PIPE] = ACTIONS(1382),
    [anon_sym_LT] = ACTIONS(1384),
    [anon_sym_GT] = ACTIONS(1384),
    [anon_sym_GT_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT_GT] = ACTIONS(1382),
    [anon_sym_LT_AMP] = ACTIONS(1382),
    [anon_sym_GT_AMP] = ACTIONS(1382),
    [anon_sym_LT_LT] = ACTIONS(1384),
    [anon_sym_LT_LT_DASH] = ACTIONS(1382),
    [anon_sym_LT_LT_LT] = ACTIONS(1382),
    [sym__special_character] = ACTIONS(6247),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
  },
  [3016] = {
    [aux_sym_concatenation_repeat1] = STATE(3494),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_fi] = ACTIONS(1059),
    [anon_sym_elif] = ACTIONS(1059),
    [anon_sym_else] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [3017] = {
    [aux_sym__literal_repeat1] = STATE(3017),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_fi] = ACTIONS(1371),
    [anon_sym_elif] = ACTIONS(1371),
    [anon_sym_else] = ACTIONS(1371),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(7471),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [3018] = {
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(2584),
    [anon_sym_for] = ACTIONS(2588),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_fi] = ACTIONS(7474),
    [anon_sym_elif] = ACTIONS(7474),
    [anon_sym_else] = ACTIONS(7474),
    [anon_sym_case] = ACTIONS(2588),
    [anon_sym_function] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2584),
    [anon_sym_declare] = ACTIONS(2588),
    [anon_sym_typeset] = ACTIONS(2588),
    [anon_sym_export] = ACTIONS(2588),
    [anon_sym_readonly] = ACTIONS(2588),
    [anon_sym_local] = ACTIONS(2588),
    [anon_sym_unset] = ACTIONS(2588),
    [anon_sym_unsetenv] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [sym__special_character] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2584),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2584),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [anon_sym_LT_LPAREN] = ACTIONS(2584),
    [anon_sym_GT_LPAREN] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
  },
  [3019] = {
    [aux_sym_concatenation_repeat1] = STATE(3019),
    [sym__concat] = ACTIONS(4562),
    [anon_sym_PIPE] = ACTIONS(2344),
    [anon_sym_RPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
  },
  [3020] = {
    [aux_sym_concatenation_repeat1] = STATE(2397),
    [sym__concat] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(7879),
    [anon_sym_RPAREN] = ACTIONS(7879),
    [sym_comment] = ACTIONS(57),
  },
  [3021] = {
    [anon_sym_PIPE] = ACTIONS(7879),
    [anon_sym_RPAREN] = ACTIONS(7879),
    [sym_comment] = ACTIONS(57),
  },
  [3022] = {
    [aux_sym__literal_repeat1] = STATE(2406),
    [anon_sym_PIPE] = ACTIONS(7881),
    [anon_sym_RPAREN] = ACTIONS(7881),
    [sym__special_character] = ACTIONS(1542),
    [sym_comment] = ACTIONS(57),
  },
  [3023] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(7883),
    [anon_sym_PLUS_EQ] = ACTIONS(7883),
    [sym_comment] = ACTIONS(57),
  },
  [3024] = {
    [anon_sym_esac] = ACTIONS(7885),
    [sym__special_character] = ACTIONS(7887),
    [anon_sym_DQUOTE] = ACTIONS(7887),
    [anon_sym_DOLLAR] = ACTIONS(7889),
    [sym_raw_string] = ACTIONS(7887),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7887),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7887),
    [anon_sym_BQUOTE] = ACTIONS(7887),
    [anon_sym_LT_LPAREN] = ACTIONS(7887),
    [anon_sym_GT_LPAREN] = ACTIONS(7887),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7889),
  },
  [3025] = {
    [sym_subshell] = STATE(146),
    [sym_test_command] = STATE(146),
    [sym_command] = STATE(146),
    [sym_command_name] = STATE(3039),
    [sym_variable_assignment] = STATE(3044),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(3044),
    [sym_concatenation] = STATE(3042),
    [sym_string] = STATE(3031),
    [sym_simple_expansion] = STATE(3031),
    [sym_string_expansion] = STATE(3031),
    [sym_expansion] = STATE(3031),
    [sym_command_substitution] = STATE(3031),
    [sym_process_substitution] = STATE(3031),
    [aux_sym_command_repeat1] = STATE(3044),
    [aux_sym__literal_repeat1] = STATE(3045),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(6716),
    [anon_sym_DQUOTE] = ACTIONS(6718),
    [anon_sym_DOLLAR] = ACTIONS(6720),
    [sym_raw_string] = ACTIONS(6722),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6726),
    [anon_sym_BQUOTE] = ACTIONS(6728),
    [anon_sym_LT_LPAREN] = ACTIONS(6730),
    [anon_sym_GT_LPAREN] = ACTIONS(6730),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6722),
  },
  [3026] = {
    [sym_variable_assignment] = STATE(3506),
    [sym_subscript] = STATE(3505),
    [sym_concatenation] = STATE(3506),
    [sym_string] = STATE(3500),
    [sym_simple_expansion] = STATE(3500),
    [sym_string_expansion] = STATE(3500),
    [sym_expansion] = STATE(3500),
    [sym_command_substitution] = STATE(3500),
    [sym_process_substitution] = STATE(3500),
    [aux_sym_declaration_command_repeat1] = STATE(3506),
    [aux_sym__literal_repeat1] = STATE(3507),
    [sym__simple_heredoc_body] = ACTIONS(259),
    [sym__heredoc_body_beginning] = ACTIONS(259),
    [sym_file_descriptor] = ACTIONS(259),
    [sym_variable_name] = ACTIONS(7891),
    [anon_sym_SEMI] = ACTIONS(263),
    [anon_sym_esac] = ACTIONS(263),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_SEMI_SEMI] = ACTIONS(259),
    [anon_sym_PIPE_AMP] = ACTIONS(259),
    [anon_sym_AMP_AMP] = ACTIONS(259),
    [anon_sym_PIPE_PIPE] = ACTIONS(259),
    [anon_sym_LT] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(259),
    [anon_sym_AMP_GT] = ACTIONS(263),
    [anon_sym_AMP_GT_GT] = ACTIONS(259),
    [anon_sym_LT_AMP] = ACTIONS(259),
    [anon_sym_GT_AMP] = ACTIONS(259),
    [anon_sym_LT_LT] = ACTIONS(263),
    [anon_sym_LT_LT_DASH] = ACTIONS(259),
    [anon_sym_LT_LT_LT] = ACTIONS(259),
    [sym__special_character] = ACTIONS(7893),
    [anon_sym_DQUOTE] = ACTIONS(7895),
    [anon_sym_DOLLAR] = ACTIONS(7897),
    [sym_raw_string] = ACTIONS(7899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7903),
    [anon_sym_BQUOTE] = ACTIONS(7905),
    [anon_sym_LT_LPAREN] = ACTIONS(7907),
    [anon_sym_GT_LPAREN] = ACTIONS(7907),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7909),
    [sym_word] = ACTIONS(7911),
    [anon_sym_LF] = ACTIONS(259),
    [anon_sym_AMP] = ACTIONS(263),
  },
  [3027] = {
    [sym_concatenation] = STATE(3516),
    [sym_string] = STATE(3511),
    [sym_simple_expansion] = STATE(3511),
    [sym_string_expansion] = STATE(3511),
    [sym_expansion] = STATE(3511),
    [sym_command_substitution] = STATE(3511),
    [sym_process_substitution] = STATE(3511),
    [aux_sym_unset_command_repeat1] = STATE(3516),
    [aux_sym__literal_repeat1] = STATE(3517),
    [sym__simple_heredoc_body] = ACTIONS(285),
    [sym__heredoc_body_beginning] = ACTIONS(285),
    [sym_file_descriptor] = ACTIONS(285),
    [anon_sym_SEMI] = ACTIONS(287),
    [anon_sym_esac] = ACTIONS(287),
    [anon_sym_PIPE] = ACTIONS(287),
    [anon_sym_SEMI_SEMI] = ACTIONS(285),
    [anon_sym_PIPE_AMP] = ACTIONS(285),
    [anon_sym_AMP_AMP] = ACTIONS(285),
    [anon_sym_PIPE_PIPE] = ACTIONS(285),
    [anon_sym_LT] = ACTIONS(287),
    [anon_sym_GT] = ACTIONS(287),
    [anon_sym_GT_GT] = ACTIONS(285),
    [anon_sym_AMP_GT] = ACTIONS(287),
    [anon_sym_AMP_GT_GT] = ACTIONS(285),
    [anon_sym_LT_AMP] = ACTIONS(285),
    [anon_sym_GT_AMP] = ACTIONS(285),
    [anon_sym_LT_LT] = ACTIONS(287),
    [anon_sym_LT_LT_DASH] = ACTIONS(285),
    [anon_sym_LT_LT_LT] = ACTIONS(285),
    [sym__special_character] = ACTIONS(7913),
    [anon_sym_DQUOTE] = ACTIONS(7915),
    [anon_sym_DOLLAR] = ACTIONS(7917),
    [sym_raw_string] = ACTIONS(7919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7921),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7923),
    [anon_sym_BQUOTE] = ACTIONS(7925),
    [anon_sym_LT_LPAREN] = ACTIONS(7927),
    [anon_sym_GT_LPAREN] = ACTIONS(7927),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7929),
    [sym_word] = ACTIONS(7931),
    [anon_sym_LF] = ACTIONS(285),
    [anon_sym_AMP] = ACTIONS(287),
  },
  [3028] = {
    [aux_sym_concatenation_repeat1] = STATE(3519),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(7933),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_esac] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [3029] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(3522),
    [anon_sym_DQUOTE] = ACTIONS(7935),
    [anon_sym_DOLLAR] = ACTIONS(7937),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [3030] = {
    [sym_string] = STATE(3524),
    [anon_sym_DASH] = ACTIONS(7939),
    [anon_sym_DQUOTE] = ACTIONS(6718),
    [anon_sym_DOLLAR] = ACTIONS(7939),
    [sym_raw_string] = ACTIONS(7941),
    [anon_sym_POUND] = ACTIONS(7939),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7943),
    [anon_sym_STAR] = ACTIONS(7945),
    [anon_sym_AT] = ACTIONS(7945),
    [anon_sym_QMARK] = ACTIONS(7945),
    [anon_sym_0] = ACTIONS(7943),
    [anon_sym__] = ACTIONS(7943),
  },
  [3031] = {
    [aux_sym_concatenation_repeat1] = STATE(3519),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(7933),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_esac] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [3032] = {
    [sym_subscript] = STATE(3529),
    [sym_variable_name] = ACTIONS(7947),
    [anon_sym_BANG] = ACTIONS(7949),
    [anon_sym_DASH] = ACTIONS(7951),
    [anon_sym_DOLLAR] = ACTIONS(7951),
    [anon_sym_POUND] = ACTIONS(7949),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7953),
    [anon_sym_STAR] = ACTIONS(7955),
    [anon_sym_AT] = ACTIONS(7955),
    [anon_sym_QMARK] = ACTIONS(7955),
    [anon_sym_0] = ACTIONS(7953),
    [anon_sym__] = ACTIONS(7953),
  },
  [3033] = {
    [sym__statements] = STATE(3530),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(3531),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [3034] = {
    [sym__statements] = STATE(3532),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [3035] = {
    [sym__statements] = STATE(3533),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [3036] = {
    [aux_sym_concatenation_repeat1] = STATE(3519),
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [sym__concat] = ACTIONS(7933),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_esac] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(387),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [3037] = {
    [anon_sym_esac] = ACTIONS(7957),
    [anon_sym_SEMI_SEMI] = ACTIONS(7959),
    [sym_comment] = ACTIONS(57),
  },
  [3038] = {
    [sym_file_redirect] = STATE(3542),
    [sym_heredoc_redirect] = STATE(3542),
    [sym_heredoc_body] = STATE(3541),
    [sym_herestring_redirect] = STATE(3542),
    [aux_sym_redirected_statement_repeat1] = STATE(3542),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(7961),
    [anon_sym_SEMI] = ACTIONS(7963),
    [anon_sym_esac] = ACTIONS(399),
    [anon_sym_PIPE] = ACTIONS(7965),
    [anon_sym_SEMI_SEMI] = ACTIONS(399),
    [anon_sym_PIPE_AMP] = ACTIONS(7967),
    [anon_sym_AMP_AMP] = ACTIONS(7969),
    [anon_sym_PIPE_PIPE] = ACTIONS(7969),
    [anon_sym_LT] = ACTIONS(7971),
    [anon_sym_GT] = ACTIONS(7971),
    [anon_sym_GT_GT] = ACTIONS(7973),
    [anon_sym_AMP_GT] = ACTIONS(7971),
    [anon_sym_AMP_GT_GT] = ACTIONS(7973),
    [anon_sym_LT_AMP] = ACTIONS(7973),
    [anon_sym_GT_AMP] = ACTIONS(7973),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(7975),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7977),
    [anon_sym_AMP] = ACTIONS(7963),
  },
  [3039] = {
    [sym_concatenation] = STATE(3545),
    [sym_string] = STATE(3544),
    [sym_simple_expansion] = STATE(3544),
    [sym_string_expansion] = STATE(3544),
    [sym_expansion] = STATE(3544),
    [sym_command_substitution] = STATE(3544),
    [sym_process_substitution] = STATE(3544),
    [aux_sym_command_repeat2] = STATE(3545),
    [aux_sym__literal_repeat1] = STATE(3546),
    [sym__simple_heredoc_body] = ACTIONS(421),
    [sym__heredoc_body_beginning] = ACTIONS(421),
    [sym_file_descriptor] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_esac] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(423),
    [anon_sym_SEMI_SEMI] = ACTIONS(421),
    [anon_sym_PIPE_AMP] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_EQ_TILDE] = ACTIONS(7979),
    [anon_sym_EQ_EQ] = ACTIONS(7979),
    [anon_sym_LT] = ACTIONS(423),
    [anon_sym_GT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_AMP_GT] = ACTIONS(423),
    [anon_sym_AMP_GT_GT] = ACTIONS(421),
    [anon_sym_LT_AMP] = ACTIONS(421),
    [anon_sym_GT_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_LT_LT_DASH] = ACTIONS(421),
    [anon_sym_LT_LT_LT] = ACTIONS(421),
    [sym__special_character] = ACTIONS(7981),
    [anon_sym_DQUOTE] = ACTIONS(6718),
    [anon_sym_DOLLAR] = ACTIONS(6720),
    [sym_raw_string] = ACTIONS(7983),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6726),
    [anon_sym_BQUOTE] = ACTIONS(6728),
    [anon_sym_LT_LPAREN] = ACTIONS(6730),
    [anon_sym_GT_LPAREN] = ACTIONS(6730),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7985),
    [anon_sym_LF] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(423),
  },
  [3040] = {
    [sym_file_redirect] = STATE(3542),
    [sym_heredoc_redirect] = STATE(3542),
    [sym_heredoc_body] = STATE(3541),
    [sym_herestring_redirect] = STATE(3542),
    [aux_sym_redirected_statement_repeat1] = STATE(3542),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(7963),
    [anon_sym_esac] = ACTIONS(3285),
    [anon_sym_PIPE] = ACTIONS(7965),
    [anon_sym_SEMI_SEMI] = ACTIONS(399),
    [anon_sym_PIPE_AMP] = ACTIONS(7967),
    [anon_sym_AMP_AMP] = ACTIONS(7969),
    [anon_sym_PIPE_PIPE] = ACTIONS(7969),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(7975),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(7977),
    [anon_sym_AMP] = ACTIONS(7963),
  },
  [3041] = {
    [anon_sym_EQ] = ACTIONS(7883),
    [anon_sym_PLUS_EQ] = ACTIONS(7883),
    [sym_comment] = ACTIONS(57),
  },
  [3042] = {
    [sym__simple_heredoc_body] = ACTIONS(353),
    [sym__heredoc_body_beginning] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_esac] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(353),
    [anon_sym_PIPE_AMP] = ACTIONS(353),
    [anon_sym_AMP_AMP] = ACTIONS(353),
    [anon_sym_PIPE_PIPE] = ACTIONS(353),
    [anon_sym_EQ_TILDE] = ACTIONS(355),
    [anon_sym_EQ_EQ] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(353),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [sym_raw_string] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_AMP] = ACTIONS(355),
  },
  [3043] = {
    [sym_redirected_statement] = STATE(3547),
    [sym_for_statement] = STATE(3547),
    [sym_c_style_for_statement] = STATE(3547),
    [sym_while_statement] = STATE(3547),
    [sym_if_statement] = STATE(3547),
    [sym_case_statement] = STATE(3547),
    [sym_function_definition] = STATE(3547),
    [sym_compound_statement] = STATE(3547),
    [sym_subshell] = STATE(3547),
    [sym_pipeline] = STATE(3547),
    [sym_list] = STATE(3547),
    [sym_negated_command] = STATE(3547),
    [sym_test_command] = STATE(3547),
    [sym_declaration_command] = STATE(3547),
    [sym_unset_command] = STATE(3547),
    [sym_command] = STATE(3547),
    [sym_command_name] = STATE(3039),
    [sym_variable_assignment] = STATE(3548),
    [sym_subscript] = STATE(3041),
    [sym_file_redirect] = STATE(3044),
    [sym_concatenation] = STATE(3042),
    [sym_string] = STATE(3031),
    [sym_simple_expansion] = STATE(3031),
    [sym_string_expansion] = STATE(3031),
    [sym_expansion] = STATE(3031),
    [sym_command_substitution] = STATE(3031),
    [sym_process_substitution] = STATE(3031),
    [aux_sym__statements_repeat1] = STATE(251),
    [aux_sym_command_repeat1] = STATE(3044),
    [aux_sym__literal_repeat1] = STATE(3045),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(6704),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(6710),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(6712),
    [anon_sym_typeset] = ACTIONS(6712),
    [anon_sym_export] = ACTIONS(6712),
    [anon_sym_readonly] = ACTIONS(6712),
    [anon_sym_local] = ACTIONS(6712),
    [anon_sym_unset] = ACTIONS(6714),
    [anon_sym_unsetenv] = ACTIONS(6714),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(6716),
    [anon_sym_DQUOTE] = ACTIONS(6718),
    [anon_sym_DOLLAR] = ACTIONS(6720),
    [sym_raw_string] = ACTIONS(6722),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6726),
    [anon_sym_BQUOTE] = ACTIONS(6728),
    [anon_sym_LT_LPAREN] = ACTIONS(6730),
    [anon_sym_GT_LPAREN] = ACTIONS(6730),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6732),
  },
  [3044] = {
    [sym_command_name] = STATE(3549),
    [sym_variable_assignment] = STATE(253),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(253),
    [sym_concatenation] = STATE(3042),
    [sym_string] = STATE(3031),
    [sym_simple_expansion] = STATE(3031),
    [sym_string_expansion] = STATE(3031),
    [sym_expansion] = STATE(3031),
    [sym_command_substitution] = STATE(3031),
    [sym_process_substitution] = STATE(3031),
    [aux_sym_command_repeat1] = STATE(253),
    [aux_sym__literal_repeat1] = STATE(3045),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(223),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(7981),
    [anon_sym_DQUOTE] = ACTIONS(6718),
    [anon_sym_DOLLAR] = ACTIONS(6720),
    [sym_raw_string] = ACTIONS(6722),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6726),
    [anon_sym_BQUOTE] = ACTIONS(6728),
    [anon_sym_LT_LPAREN] = ACTIONS(6730),
    [anon_sym_GT_LPAREN] = ACTIONS(6730),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6722),
  },
  [3045] = {
    [aux_sym__literal_repeat1] = STATE(3551),
    [sym__simple_heredoc_body] = ACTIONS(437),
    [sym__heredoc_body_beginning] = ACTIONS(437),
    [sym_file_descriptor] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(439),
    [anon_sym_esac] = ACTIONS(439),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_SEMI_SEMI] = ACTIONS(437),
    [anon_sym_PIPE_AMP] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_EQ_TILDE] = ACTIONS(439),
    [anon_sym_EQ_EQ] = ACTIONS(439),
    [anon_sym_LT] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(439),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_AMP_GT] = ACTIONS(439),
    [anon_sym_AMP_GT_GT] = ACTIONS(437),
    [anon_sym_LT_AMP] = ACTIONS(437),
    [anon_sym_GT_AMP] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(439),
    [anon_sym_LT_LT_DASH] = ACTIONS(437),
    [anon_sym_LT_LT_LT] = ACTIONS(437),
    [sym__special_character] = ACTIONS(7987),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [anon_sym_DOLLAR] = ACTIONS(439),
    [sym_raw_string] = ACTIONS(437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(437),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(437),
    [anon_sym_GT_LPAREN] = ACTIONS(437),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(439),
    [anon_sym_LF] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(439),
  },
  [3046] = {
    [sym__statements] = STATE(3552),
    [sym_redirected_statement] = STATE(3038),
    [sym_for_statement] = STATE(3038),
    [sym_c_style_for_statement] = STATE(3038),
    [sym_while_statement] = STATE(3038),
    [sym_if_statement] = STATE(3038),
    [sym_case_statement] = STATE(3038),
    [sym_function_definition] = STATE(3038),
    [sym_compound_statement] = STATE(3038),
    [sym_subshell] = STATE(3038),
    [sym_pipeline] = STATE(3038),
    [sym_list] = STATE(3038),
    [sym_negated_command] = STATE(3038),
    [sym_test_command] = STATE(3038),
    [sym_declaration_command] = STATE(3038),
    [sym_unset_command] = STATE(3038),
    [sym_command] = STATE(3038),
    [sym_command_name] = STATE(3039),
    [sym_variable_assignment] = STATE(3040),
    [sym_subscript] = STATE(3041),
    [sym_file_redirect] = STATE(3044),
    [sym_concatenation] = STATE(3042),
    [sym_string] = STATE(3031),
    [sym_simple_expansion] = STATE(3031),
    [sym_string_expansion] = STATE(3031),
    [sym_expansion] = STATE(3031),
    [sym_command_substitution] = STATE(3031),
    [sym_process_substitution] = STATE(3031),
    [aux_sym__statements_repeat1] = STATE(3043),
    [aux_sym_command_repeat1] = STATE(3044),
    [aux_sym__literal_repeat1] = STATE(3045),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(6704),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_esac] = ACTIONS(7885),
    [anon_sym_SEMI_SEMI] = ACTIONS(7959),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(6710),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(6712),
    [anon_sym_typeset] = ACTIONS(6712),
    [anon_sym_export] = ACTIONS(6712),
    [anon_sym_readonly] = ACTIONS(6712),
    [anon_sym_local] = ACTIONS(6712),
    [anon_sym_unset] = ACTIONS(6714),
    [anon_sym_unsetenv] = ACTIONS(6714),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(6716),
    [anon_sym_DQUOTE] = ACTIONS(6718),
    [anon_sym_DOLLAR] = ACTIONS(6720),
    [sym_raw_string] = ACTIONS(6722),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6726),
    [anon_sym_BQUOTE] = ACTIONS(6728),
    [anon_sym_LT_LPAREN] = ACTIONS(6730),
    [anon_sym_GT_LPAREN] = ACTIONS(6730),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6732),
  },
  [3047] = {
    [aux_sym_case_item_repeat1] = STATE(3047),
    [anon_sym_PIPE] = ACTIONS(7989),
    [anon_sym_RPAREN] = ACTIONS(7879),
    [sym_comment] = ACTIONS(57),
  },
  [3048] = {
    [sym__simple_heredoc_body] = ACTIONS(7992),
    [sym__heredoc_body_beginning] = ACTIONS(7992),
    [sym_file_descriptor] = ACTIONS(7992),
    [ts_builtin_sym_end] = ACTIONS(7992),
    [anon_sym_SEMI] = ACTIONS(7994),
    [anon_sym_done] = ACTIONS(7992),
    [anon_sym_fi] = ACTIONS(7992),
    [anon_sym_elif] = ACTIONS(7992),
    [anon_sym_else] = ACTIONS(7992),
    [anon_sym_esac] = ACTIONS(7992),
    [anon_sym_PIPE] = ACTIONS(7994),
    [anon_sym_RPAREN] = ACTIONS(7992),
    [anon_sym_SEMI_SEMI] = ACTIONS(7992),
    [anon_sym_PIPE_AMP] = ACTIONS(7992),
    [anon_sym_AMP_AMP] = ACTIONS(7992),
    [anon_sym_PIPE_PIPE] = ACTIONS(7992),
    [anon_sym_LT] = ACTIONS(7994),
    [anon_sym_GT] = ACTIONS(7994),
    [anon_sym_GT_GT] = ACTIONS(7992),
    [anon_sym_AMP_GT] = ACTIONS(7994),
    [anon_sym_AMP_GT_GT] = ACTIONS(7992),
    [anon_sym_LT_AMP] = ACTIONS(7992),
    [anon_sym_GT_AMP] = ACTIONS(7992),
    [anon_sym_LT_LT] = ACTIONS(7994),
    [anon_sym_LT_LT_DASH] = ACTIONS(7992),
    [anon_sym_LT_LT_LT] = ACTIONS(7992),
    [anon_sym_BQUOTE] = ACTIONS(7992),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7992),
    [anon_sym_AMP] = ACTIONS(7994),
  },
  [3049] = {
    [aux_sym_case_item_repeat1] = STATE(3554),
    [aux_sym_concatenation_repeat1] = STATE(2397),
    [sym__concat] = ACTIONS(1508),
    [anon_sym_PIPE] = ACTIONS(5199),
    [anon_sym_RPAREN] = ACTIONS(7996),
    [sym_comment] = ACTIONS(57),
  },
  [3050] = {
    [aux_sym_case_item_repeat1] = STATE(3554),
    [anon_sym_PIPE] = ACTIONS(5199),
    [anon_sym_RPAREN] = ACTIONS(7996),
    [sym_comment] = ACTIONS(57),
  },
  [3051] = {
    [aux_sym_case_item_repeat1] = STATE(3556),
    [aux_sym__literal_repeat1] = STATE(2406),
    [anon_sym_PIPE] = ACTIONS(5199),
    [anon_sym_RPAREN] = ACTIONS(7998),
    [sym__special_character] = ACTIONS(1542),
    [sym_comment] = ACTIONS(57),
  },
  [3052] = {
    [anon_sym_esac] = ACTIONS(8000),
    [sym__special_character] = ACTIONS(8002),
    [anon_sym_DQUOTE] = ACTIONS(8002),
    [anon_sym_DOLLAR] = ACTIONS(8004),
    [sym_raw_string] = ACTIONS(8002),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8002),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8002),
    [anon_sym_BQUOTE] = ACTIONS(8002),
    [anon_sym_LT_LPAREN] = ACTIONS(8002),
    [anon_sym_GT_LPAREN] = ACTIONS(8002),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8004),
  },
  [3053] = {
    [anon_sym_esac] = ACTIONS(8006),
    [anon_sym_SEMI_SEMI] = ACTIONS(8008),
    [sym_comment] = ACTIONS(57),
  },
  [3054] = {
    [sym__statements] = STATE(3558),
    [sym_redirected_statement] = STATE(3038),
    [sym_for_statement] = STATE(3038),
    [sym_c_style_for_statement] = STATE(3038),
    [sym_while_statement] = STATE(3038),
    [sym_if_statement] = STATE(3038),
    [sym_case_statement] = STATE(3038),
    [sym_function_definition] = STATE(3038),
    [sym_compound_statement] = STATE(3038),
    [sym_subshell] = STATE(3038),
    [sym_pipeline] = STATE(3038),
    [sym_list] = STATE(3038),
    [sym_negated_command] = STATE(3038),
    [sym_test_command] = STATE(3038),
    [sym_declaration_command] = STATE(3038),
    [sym_unset_command] = STATE(3038),
    [sym_command] = STATE(3038),
    [sym_command_name] = STATE(3039),
    [sym_variable_assignment] = STATE(3040),
    [sym_subscript] = STATE(3041),
    [sym_file_redirect] = STATE(3044),
    [sym_concatenation] = STATE(3042),
    [sym_string] = STATE(3031),
    [sym_simple_expansion] = STATE(3031),
    [sym_string_expansion] = STATE(3031),
    [sym_expansion] = STATE(3031),
    [sym_command_substitution] = STATE(3031),
    [sym_process_substitution] = STATE(3031),
    [aux_sym__statements_repeat1] = STATE(3043),
    [aux_sym_command_repeat1] = STATE(3044),
    [aux_sym__literal_repeat1] = STATE(3045),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(6704),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_esac] = ACTIONS(8000),
    [anon_sym_SEMI_SEMI] = ACTIONS(8008),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(6710),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(6712),
    [anon_sym_typeset] = ACTIONS(6712),
    [anon_sym_export] = ACTIONS(6712),
    [anon_sym_readonly] = ACTIONS(6712),
    [anon_sym_local] = ACTIONS(6712),
    [anon_sym_unset] = ACTIONS(6714),
    [anon_sym_unsetenv] = ACTIONS(6714),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(6716),
    [anon_sym_DQUOTE] = ACTIONS(6718),
    [anon_sym_DOLLAR] = ACTIONS(6720),
    [sym_raw_string] = ACTIONS(6722),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6726),
    [anon_sym_BQUOTE] = ACTIONS(6728),
    [anon_sym_LT_LPAREN] = ACTIONS(6730),
    [anon_sym_GT_LPAREN] = ACTIONS(6730),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6732),
  },
  [3055] = {
    [anon_sym_esac] = ACTIONS(8010),
    [sym_comment] = ACTIONS(57),
  },
  [3056] = {
    [sym__concat] = ACTIONS(7040),
    [anon_sym_in] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7040),
  },
  [3057] = {
    [sym__concat] = ACTIONS(7044),
    [anon_sym_in] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7044),
  },
  [3058] = {
    [sym__concat] = ACTIONS(7048),
    [anon_sym_in] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7048),
  },
  [3059] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8012),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3060] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8014),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3061] = {
    [sym__concat] = ACTIONS(7082),
    [anon_sym_in] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7082),
  },
  [3062] = {
    [sym__simple_heredoc_body] = ACTIONS(8016),
    [sym__heredoc_body_beginning] = ACTIONS(8016),
    [sym_file_descriptor] = ACTIONS(8016),
    [ts_builtin_sym_end] = ACTIONS(8016),
    [anon_sym_SEMI] = ACTIONS(8018),
    [anon_sym_done] = ACTIONS(8016),
    [anon_sym_fi] = ACTIONS(8016),
    [anon_sym_elif] = ACTIONS(8016),
    [anon_sym_else] = ACTIONS(8016),
    [anon_sym_esac] = ACTIONS(8016),
    [anon_sym_PIPE] = ACTIONS(8018),
    [anon_sym_RPAREN] = ACTIONS(8016),
    [anon_sym_SEMI_SEMI] = ACTIONS(8016),
    [anon_sym_PIPE_AMP] = ACTIONS(8016),
    [anon_sym_AMP_AMP] = ACTIONS(8016),
    [anon_sym_PIPE_PIPE] = ACTIONS(8016),
    [anon_sym_LT] = ACTIONS(8018),
    [anon_sym_GT] = ACTIONS(8018),
    [anon_sym_GT_GT] = ACTIONS(8016),
    [anon_sym_AMP_GT] = ACTIONS(8018),
    [anon_sym_AMP_GT_GT] = ACTIONS(8016),
    [anon_sym_LT_AMP] = ACTIONS(8016),
    [anon_sym_GT_AMP] = ACTIONS(8016),
    [anon_sym_LT_LT] = ACTIONS(8018),
    [anon_sym_LT_LT_DASH] = ACTIONS(8016),
    [anon_sym_LT_LT_LT] = ACTIONS(8016),
    [anon_sym_BQUOTE] = ACTIONS(8016),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8016),
    [anon_sym_AMP] = ACTIONS(8018),
  },
  [3063] = {
    [anon_sym_esac] = ACTIONS(8020),
    [sym_comment] = ACTIONS(57),
  },
  [3064] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [sym_variable_name] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_RBRACE] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4055),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [3065] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [sym_variable_name] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_RBRACE] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [3066] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(8022),
    [sym_comment] = ACTIONS(57),
  },
  [3067] = {
    [anon_sym_RBRACE] = ACTIONS(8022),
    [sym_comment] = ACTIONS(57),
  },
  [3068] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(8024),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3069] = {
    [sym_concatenation] = STATE(3566),
    [sym_string] = STATE(3565),
    [sym_simple_expansion] = STATE(3565),
    [sym_string_expansion] = STATE(3565),
    [sym_expansion] = STATE(3565),
    [sym_command_substitution] = STATE(3565),
    [sym_process_substitution] = STATE(3565),
    [aux_sym__literal_repeat1] = STATE(3567),
    [anon_sym_RBRACE] = ACTIONS(8022),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(8026),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8026),
  },
  [3070] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [sym_variable_name] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_RBRACE] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4105),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [3071] = {
    [sym_concatenation] = STATE(3570),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3570),
    [sym_regex] = ACTIONS(8028),
    [anon_sym_RBRACE] = ACTIONS(8030),
    [anon_sym_EQ] = ACTIONS(8032),
    [anon_sym_DASH] = ACTIONS(8032),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8032),
    [anon_sym_COLON_QMARK] = ACTIONS(8032),
    [anon_sym_COLON_DASH] = ACTIONS(8032),
    [anon_sym_PERCENT] = ACTIONS(8032),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3072] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8030),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3073] = {
    [sym_concatenation] = STATE(3572),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3572),
    [sym_regex] = ACTIONS(8036),
    [anon_sym_RBRACE] = ACTIONS(8022),
    [anon_sym_EQ] = ACTIONS(8038),
    [anon_sym_DASH] = ACTIONS(8038),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8038),
    [anon_sym_COLON_QMARK] = ACTIONS(8038),
    [anon_sym_COLON_DASH] = ACTIONS(8038),
    [anon_sym_PERCENT] = ACTIONS(8038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3074] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8022),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3075] = {
    [sym_concatenation] = STATE(3574),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3574),
    [anon_sym_RBRACE] = ACTIONS(8042),
    [anon_sym_EQ] = ACTIONS(8044),
    [anon_sym_DASH] = ACTIONS(8044),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8044),
    [anon_sym_COLON_QMARK] = ACTIONS(8044),
    [anon_sym_COLON_DASH] = ACTIONS(8044),
    [anon_sym_PERCENT] = ACTIONS(8044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3076] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [sym_variable_name] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_RBRACE] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4161),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [3077] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8042),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3078] = {
    [sym_concatenation] = STATE(3572),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3572),
    [anon_sym_RBRACE] = ACTIONS(8022),
    [anon_sym_EQ] = ACTIONS(8038),
    [anon_sym_DASH] = ACTIONS(8038),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8038),
    [anon_sym_COLON_QMARK] = ACTIONS(8038),
    [anon_sym_COLON_DASH] = ACTIONS(8038),
    [anon_sym_PERCENT] = ACTIONS(8038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3079] = {
    [sym_do_group] = STATE(3575),
    [sym_compound_statement] = STATE(3575),
    [anon_sym_do] = ACTIONS(1945),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [3080] = {
    [sym__simple_heredoc_body] = ACTIONS(5773),
    [sym__heredoc_body_beginning] = ACTIONS(5773),
    [sym_file_descriptor] = ACTIONS(5773),
    [anon_sym_SEMI] = ACTIONS(5775),
    [anon_sym_PIPE] = ACTIONS(5775),
    [anon_sym_SEMI_SEMI] = ACTIONS(5773),
    [anon_sym_RBRACE] = ACTIONS(5773),
    [anon_sym_PIPE_AMP] = ACTIONS(5773),
    [anon_sym_AMP_AMP] = ACTIONS(5773),
    [anon_sym_PIPE_PIPE] = ACTIONS(5773),
    [anon_sym_LT] = ACTIONS(5775),
    [anon_sym_GT] = ACTIONS(5775),
    [anon_sym_GT_GT] = ACTIONS(5773),
    [anon_sym_AMP_GT] = ACTIONS(5775),
    [anon_sym_AMP_GT_GT] = ACTIONS(5773),
    [anon_sym_LT_AMP] = ACTIONS(5773),
    [anon_sym_GT_AMP] = ACTIONS(5773),
    [anon_sym_LT_LT] = ACTIONS(5775),
    [anon_sym_LT_LT_DASH] = ACTIONS(5773),
    [anon_sym_LT_LT_LT] = ACTIONS(5773),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5773),
    [anon_sym_AMP] = ACTIONS(5775),
  },
  [3081] = {
    [sym_do_group] = STATE(3575),
    [sym_compound_statement] = STATE(3575),
    [anon_sym_SEMI] = ACTIONS(8048),
    [anon_sym_do] = ACTIONS(1945),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [3082] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(8050),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [3083] = {
    [sym__expression] = STATE(3578),
    [sym_binary_expression] = STATE(3578),
    [sym_unary_expression] = STATE(3578),
    [sym_postfix_expression] = STATE(3578),
    [sym_parenthesized_expression] = STATE(3578),
    [sym_concatenation] = STATE(3578),
    [sym_string] = STATE(47),
    [sym_simple_expansion] = STATE(47),
    [sym_string_expansion] = STATE(47),
    [sym_expansion] = STATE(47),
    [sym_command_substitution] = STATE(47),
    [sym_process_substitution] = STATE(47),
    [aux_sym__literal_repeat1] = STATE(53),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(8050),
    [anon_sym_LPAREN] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(75),
    [sym__special_character] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_DOLLAR] = ACTIONS(81),
    [sym_raw_string] = ACTIONS(83),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(85),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(87),
    [anon_sym_BQUOTE] = ACTIONS(89),
    [anon_sym_LT_LPAREN] = ACTIONS(91),
    [anon_sym_GT_LPAREN] = ACTIONS(91),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(93),
    [sym_test_operator] = ACTIONS(95),
  },
  [3084] = {
    [sym__simple_heredoc_body] = ACTIONS(5842),
    [sym__heredoc_body_beginning] = ACTIONS(5842),
    [sym_file_descriptor] = ACTIONS(5842),
    [anon_sym_SEMI] = ACTIONS(5844),
    [anon_sym_PIPE] = ACTIONS(5844),
    [anon_sym_SEMI_SEMI] = ACTIONS(5842),
    [anon_sym_RBRACE] = ACTIONS(5842),
    [anon_sym_PIPE_AMP] = ACTIONS(5842),
    [anon_sym_AMP_AMP] = ACTIONS(5842),
    [anon_sym_PIPE_PIPE] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5844),
    [anon_sym_GT] = ACTIONS(5844),
    [anon_sym_GT_GT] = ACTIONS(5842),
    [anon_sym_AMP_GT] = ACTIONS(5844),
    [anon_sym_AMP_GT_GT] = ACTIONS(5842),
    [anon_sym_LT_AMP] = ACTIONS(5842),
    [anon_sym_GT_AMP] = ACTIONS(5842),
    [anon_sym_LT_LT] = ACTIONS(5844),
    [anon_sym_LT_LT_DASH] = ACTIONS(5842),
    [anon_sym_LT_LT_LT] = ACTIONS(5842),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5842),
    [anon_sym_AMP] = ACTIONS(5844),
  },
  [3085] = {
    [sym__simple_heredoc_body] = ACTIONS(6648),
    [sym__heredoc_body_beginning] = ACTIONS(6648),
    [sym_file_descriptor] = ACTIONS(6648),
    [anon_sym_SEMI] = ACTIONS(6650),
    [anon_sym_PIPE] = ACTIONS(6650),
    [anon_sym_SEMI_SEMI] = ACTIONS(6648),
    [anon_sym_RBRACE] = ACTIONS(6648),
    [anon_sym_PIPE_AMP] = ACTIONS(6648),
    [anon_sym_AMP_AMP] = ACTIONS(6648),
    [anon_sym_PIPE_PIPE] = ACTIONS(6648),
    [anon_sym_LT] = ACTIONS(6650),
    [anon_sym_GT] = ACTIONS(6650),
    [anon_sym_GT_GT] = ACTIONS(6648),
    [anon_sym_AMP_GT] = ACTIONS(6650),
    [anon_sym_AMP_GT_GT] = ACTIONS(6648),
    [anon_sym_LT_AMP] = ACTIONS(6648),
    [anon_sym_GT_AMP] = ACTIONS(6648),
    [anon_sym_LT_LT] = ACTIONS(6650),
    [anon_sym_LT_LT_DASH] = ACTIONS(6648),
    [anon_sym_LT_LT_LT] = ACTIONS(6648),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6648),
    [anon_sym_AMP] = ACTIONS(6650),
  },
  [3086] = {
    [anon_sym_fi] = ACTIONS(8052),
    [sym_comment] = ACTIONS(57),
  },
  [3087] = {
    [sym__simple_heredoc_body] = ACTIONS(6736),
    [sym__heredoc_body_beginning] = ACTIONS(6736),
    [sym_file_descriptor] = ACTIONS(6736),
    [anon_sym_SEMI] = ACTIONS(6738),
    [anon_sym_PIPE] = ACTIONS(6738),
    [anon_sym_SEMI_SEMI] = ACTIONS(6736),
    [anon_sym_RBRACE] = ACTIONS(6736),
    [anon_sym_PIPE_AMP] = ACTIONS(6736),
    [anon_sym_AMP_AMP] = ACTIONS(6736),
    [anon_sym_PIPE_PIPE] = ACTIONS(6736),
    [anon_sym_LT] = ACTIONS(6738),
    [anon_sym_GT] = ACTIONS(6738),
    [anon_sym_GT_GT] = ACTIONS(6736),
    [anon_sym_AMP_GT] = ACTIONS(6738),
    [anon_sym_AMP_GT_GT] = ACTIONS(6736),
    [anon_sym_LT_AMP] = ACTIONS(6736),
    [anon_sym_GT_AMP] = ACTIONS(6736),
    [anon_sym_LT_LT] = ACTIONS(6738),
    [anon_sym_LT_LT_DASH] = ACTIONS(6736),
    [anon_sym_LT_LT_LT] = ACTIONS(6736),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6736),
    [anon_sym_AMP] = ACTIONS(6738),
  },
  [3088] = {
    [anon_sym_esac] = ACTIONS(8054),
    [sym_comment] = ACTIONS(57),
  },
  [3089] = {
    [sym_case_item] = STATE(2403),
    [sym_last_case_item] = STATE(3581),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(2403),
    [aux_sym__literal_repeat1] = STATE(1693),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3482),
  },
  [3090] = {
    [sym__simple_heredoc_body] = ACTIONS(6788),
    [sym__heredoc_body_beginning] = ACTIONS(6788),
    [sym_file_descriptor] = ACTIONS(6788),
    [anon_sym_SEMI] = ACTIONS(6790),
    [anon_sym_PIPE] = ACTIONS(6790),
    [anon_sym_SEMI_SEMI] = ACTIONS(6788),
    [anon_sym_RBRACE] = ACTIONS(6788),
    [anon_sym_PIPE_AMP] = ACTIONS(6788),
    [anon_sym_AMP_AMP] = ACTIONS(6788),
    [anon_sym_PIPE_PIPE] = ACTIONS(6788),
    [anon_sym_LT] = ACTIONS(6790),
    [anon_sym_GT] = ACTIONS(6790),
    [anon_sym_GT_GT] = ACTIONS(6788),
    [anon_sym_AMP_GT] = ACTIONS(6790),
    [anon_sym_AMP_GT_GT] = ACTIONS(6788),
    [anon_sym_LT_AMP] = ACTIONS(6788),
    [anon_sym_GT_AMP] = ACTIONS(6788),
    [anon_sym_LT_LT] = ACTIONS(6790),
    [anon_sym_LT_LT_DASH] = ACTIONS(6788),
    [anon_sym_LT_LT_LT] = ACTIONS(6788),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(6788),
    [anon_sym_AMP] = ACTIONS(6790),
  },
  [3091] = {
    [anon_sym_esac] = ACTIONS(8056),
    [sym_comment] = ACTIONS(57),
  },
  [3092] = {
    [sym_case_item] = STATE(2403),
    [sym_last_case_item] = STATE(3583),
    [sym_concatenation] = STATE(1691),
    [sym_string] = STATE(1689),
    [sym_simple_expansion] = STATE(1689),
    [sym_string_expansion] = STATE(1689),
    [sym_expansion] = STATE(1689),
    [sym_command_substitution] = STATE(1689),
    [sym_process_substitution] = STATE(1689),
    [aux_sym_case_statement_repeat1] = STATE(2403),
    [aux_sym__literal_repeat1] = STATE(1693),
    [sym__special_character] = ACTIONS(3480),
    [anon_sym_DQUOTE] = ACTIONS(509),
    [anon_sym_DOLLAR] = ACTIONS(511),
    [sym_raw_string] = ACTIONS(3482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(515),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(517),
    [anon_sym_BQUOTE] = ACTIONS(519),
    [anon_sym_LT_LPAREN] = ACTIONS(521),
    [anon_sym_GT_LPAREN] = ACTIONS(521),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(3482),
  },
  [3093] = {
    [sym__simple_heredoc_body] = ACTIONS(4383),
    [sym__heredoc_body_beginning] = ACTIONS(4383),
    [sym_file_descriptor] = ACTIONS(4383),
    [sym_variable_name] = ACTIONS(4383),
    [anon_sym_SEMI] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI_SEMI] = ACTIONS(4383),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [anon_sym_PIPE_AMP] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_AMP_GT] = ACTIONS(4385),
    [anon_sym_AMP_GT_GT] = ACTIONS(4383),
    [anon_sym_LT_AMP] = ACTIONS(4383),
    [anon_sym_GT_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_LT_LT_DASH] = ACTIONS(4383),
    [anon_sym_LT_LT_LT] = ACTIONS(4383),
    [sym__special_character] = ACTIONS(4385),
    [anon_sym_DQUOTE] = ACTIONS(4383),
    [anon_sym_DOLLAR] = ACTIONS(4385),
    [sym_raw_string] = ACTIONS(4383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4383),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4383),
    [anon_sym_BQUOTE] = ACTIONS(4383),
    [anon_sym_LT_LPAREN] = ACTIONS(4383),
    [anon_sym_GT_LPAREN] = ACTIONS(4383),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4385),
    [sym_word] = ACTIONS(4385),
    [anon_sym_LF] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
  },
  [3094] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [sym_variable_name] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_RBRACE] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5566),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5566),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [3095] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [sym_variable_name] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_RBRACE] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5600),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5600),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [3096] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(8058),
    [sym_comment] = ACTIONS(57),
  },
  [3097] = {
    [anon_sym_RBRACE] = ACTIONS(8058),
    [sym_comment] = ACTIONS(57),
  },
  [3098] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(8060),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3099] = {
    [sym_concatenation] = STATE(3587),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3587),
    [anon_sym_RBRACE] = ACTIONS(8062),
    [anon_sym_EQ] = ACTIONS(8064),
    [anon_sym_DASH] = ACTIONS(8064),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8066),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8064),
    [anon_sym_COLON_QMARK] = ACTIONS(8064),
    [anon_sym_COLON_DASH] = ACTIONS(8064),
    [anon_sym_PERCENT] = ACTIONS(8064),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3100] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [sym_variable_name] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_RBRACE] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5617),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5617),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [3101] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8062),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3102] = {
    [sym_concatenation] = STATE(3588),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3588),
    [anon_sym_RBRACE] = ACTIONS(8058),
    [anon_sym_EQ] = ACTIONS(8068),
    [anon_sym_DASH] = ACTIONS(8068),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8070),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8068),
    [anon_sym_COLON_QMARK] = ACTIONS(8068),
    [anon_sym_COLON_DASH] = ACTIONS(8068),
    [anon_sym_PERCENT] = ACTIONS(8068),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3103] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8058),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3104] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [sym_variable_name] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_RBRACE] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5660),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5660),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [3105] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8072),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3106] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_RBRACE] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5566),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5566),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [3107] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_RBRACE] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5600),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5600),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [3108] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(8074),
    [sym_comment] = ACTIONS(57),
  },
  [3109] = {
    [anon_sym_RBRACE] = ACTIONS(8074),
    [sym_comment] = ACTIONS(57),
  },
  [3110] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(8076),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3111] = {
    [sym_concatenation] = STATE(3593),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3593),
    [anon_sym_RBRACE] = ACTIONS(8078),
    [anon_sym_EQ] = ACTIONS(8080),
    [anon_sym_DASH] = ACTIONS(8080),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8080),
    [anon_sym_COLON_QMARK] = ACTIONS(8080),
    [anon_sym_COLON_DASH] = ACTIONS(8080),
    [anon_sym_PERCENT] = ACTIONS(8080),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3112] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_RBRACE] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5617),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5617),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [3113] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8078),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3114] = {
    [sym_concatenation] = STATE(3594),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3594),
    [anon_sym_RBRACE] = ACTIONS(8074),
    [anon_sym_EQ] = ACTIONS(8084),
    [anon_sym_DASH] = ACTIONS(8084),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8086),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8084),
    [anon_sym_COLON_QMARK] = ACTIONS(8084),
    [anon_sym_COLON_DASH] = ACTIONS(8084),
    [anon_sym_PERCENT] = ACTIONS(8084),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3115] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8074),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3116] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_RBRACE] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5660),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5660),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [3117] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8088),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3118] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_RBRACE] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_EQ_TILDE] = ACTIONS(7042),
    [anon_sym_EQ_EQ] = ACTIONS(7042),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7042),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [3119] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_RBRACE] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_EQ_TILDE] = ACTIONS(7046),
    [anon_sym_EQ_EQ] = ACTIONS(7046),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7046),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [3120] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_RBRACE] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_EQ_TILDE] = ACTIONS(7050),
    [anon_sym_EQ_EQ] = ACTIONS(7050),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7050),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [3121] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8090),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3122] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8092),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3123] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_RBRACE] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_EQ_TILDE] = ACTIONS(7084),
    [anon_sym_EQ_EQ] = ACTIONS(7084),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7084),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [3124] = {
    [sym__concat] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_RBRACK] = ACTIONS(7040),
    [anon_sym_EQ_TILDE] = ACTIONS(7040),
    [anon_sym_EQ_EQ] = ACTIONS(7040),
    [anon_sym_EQ] = ACTIONS(7042),
    [anon_sym_PLUS_EQ] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_BANG_EQ] = ACTIONS(7040),
    [anon_sym_PLUS] = ACTIONS(7042),
    [anon_sym_DASH] = ACTIONS(7042),
    [anon_sym_DASH_EQ] = ACTIONS(7040),
    [anon_sym_LT_EQ] = ACTIONS(7040),
    [anon_sym_GT_EQ] = ACTIONS(7040),
    [anon_sym_PLUS_PLUS] = ACTIONS(7040),
    [anon_sym_DASH_DASH] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7040),
  },
  [3125] = {
    [sym__concat] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_RBRACK] = ACTIONS(7044),
    [anon_sym_EQ_TILDE] = ACTIONS(7044),
    [anon_sym_EQ_EQ] = ACTIONS(7044),
    [anon_sym_EQ] = ACTIONS(7046),
    [anon_sym_PLUS_EQ] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_BANG_EQ] = ACTIONS(7044),
    [anon_sym_PLUS] = ACTIONS(7046),
    [anon_sym_DASH] = ACTIONS(7046),
    [anon_sym_DASH_EQ] = ACTIONS(7044),
    [anon_sym_LT_EQ] = ACTIONS(7044),
    [anon_sym_GT_EQ] = ACTIONS(7044),
    [anon_sym_PLUS_PLUS] = ACTIONS(7044),
    [anon_sym_DASH_DASH] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7044),
  },
  [3126] = {
    [sym__concat] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_RBRACK] = ACTIONS(7048),
    [anon_sym_EQ_TILDE] = ACTIONS(7048),
    [anon_sym_EQ_EQ] = ACTIONS(7048),
    [anon_sym_EQ] = ACTIONS(7050),
    [anon_sym_PLUS_EQ] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_BANG_EQ] = ACTIONS(7048),
    [anon_sym_PLUS] = ACTIONS(7050),
    [anon_sym_DASH] = ACTIONS(7050),
    [anon_sym_DASH_EQ] = ACTIONS(7048),
    [anon_sym_LT_EQ] = ACTIONS(7048),
    [anon_sym_GT_EQ] = ACTIONS(7048),
    [anon_sym_PLUS_PLUS] = ACTIONS(7048),
    [anon_sym_DASH_DASH] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7048),
  },
  [3127] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8094),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3128] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8096),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3129] = {
    [sym__concat] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_RBRACK] = ACTIONS(7082),
    [anon_sym_EQ_TILDE] = ACTIONS(7082),
    [anon_sym_EQ_EQ] = ACTIONS(7082),
    [anon_sym_EQ] = ACTIONS(7084),
    [anon_sym_PLUS_EQ] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_BANG_EQ] = ACTIONS(7082),
    [anon_sym_PLUS] = ACTIONS(7084),
    [anon_sym_DASH] = ACTIONS(7084),
    [anon_sym_DASH_EQ] = ACTIONS(7082),
    [anon_sym_LT_EQ] = ACTIONS(7082),
    [anon_sym_GT_EQ] = ACTIONS(7082),
    [anon_sym_PLUS_PLUS] = ACTIONS(7082),
    [anon_sym_DASH_DASH] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7082),
  },
  [3130] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [sym_variable_name] = ACTIONS(7040),
    [ts_builtin_sym_end] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_RPAREN] = ACTIONS(7040),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7042),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [3131] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [sym_variable_name] = ACTIONS(7044),
    [ts_builtin_sym_end] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_RPAREN] = ACTIONS(7044),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7046),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [3132] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [sym_variable_name] = ACTIONS(7048),
    [ts_builtin_sym_end] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_RPAREN] = ACTIONS(7048),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7050),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [3133] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8098),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3134] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8100),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3135] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [sym_variable_name] = ACTIONS(7082),
    [ts_builtin_sym_end] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_RPAREN] = ACTIONS(7082),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7084),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [3136] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [ts_builtin_sym_end] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_RPAREN] = ACTIONS(7040),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7042),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [3137] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [ts_builtin_sym_end] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_RPAREN] = ACTIONS(7044),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7046),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [3138] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [ts_builtin_sym_end] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_RPAREN] = ACTIONS(7048),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7050),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [3139] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8102),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3140] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8104),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3141] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [ts_builtin_sym_end] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_RPAREN] = ACTIONS(7082),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7084),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [3142] = {
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [sym_variable_name] = ACTIONS(7040),
    [anon_sym_RPAREN] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7040),
  },
  [3143] = {
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [sym_variable_name] = ACTIONS(7044),
    [anon_sym_RPAREN] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7044),
  },
  [3144] = {
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [sym_variable_name] = ACTIONS(7048),
    [anon_sym_RPAREN] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7048),
  },
  [3145] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8106),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3146] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8108),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3147] = {
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [sym_variable_name] = ACTIONS(7082),
    [anon_sym_RPAREN] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7082),
  },
  [3148] = {
    [sym__concat] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7042),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym__string_content] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7042),
    [anon_sym_BQUOTE] = ACTIONS(7042),
    [sym_comment] = ACTIONS(343),
  },
  [3149] = {
    [sym__concat] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7046),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym__string_content] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7046),
    [anon_sym_BQUOTE] = ACTIONS(7046),
    [sym_comment] = ACTIONS(343),
  },
  [3150] = {
    [sym__concat] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7050),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym__string_content] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7050),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7050),
    [anon_sym_BQUOTE] = ACTIONS(7050),
    [sym_comment] = ACTIONS(343),
  },
  [3151] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8110),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3152] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8112),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3153] = {
    [sym__concat] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7084),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym__string_content] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7084),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7084),
    [anon_sym_BQUOTE] = ACTIONS(7084),
    [sym_comment] = ACTIONS(343),
  },
  [3154] = {
    [anon_sym_RBRACE] = ACTIONS(5708),
    [anon_sym_EQ] = ACTIONS(8114),
    [anon_sym_DASH] = ACTIONS(8114),
    [sym__special_character] = ACTIONS(8114),
    [anon_sym_DQUOTE] = ACTIONS(5708),
    [anon_sym_DOLLAR] = ACTIONS(8114),
    [sym_raw_string] = ACTIONS(5708),
    [anon_sym_POUND] = ACTIONS(5708),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5708),
    [anon_sym_SLASH] = ACTIONS(5708),
    [anon_sym_COLON] = ACTIONS(8114),
    [anon_sym_COLON_QMARK] = ACTIONS(8114),
    [anon_sym_COLON_DASH] = ACTIONS(8114),
    [anon_sym_PERCENT] = ACTIONS(8114),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5708),
    [anon_sym_BQUOTE] = ACTIONS(5708),
    [anon_sym_LT_LPAREN] = ACTIONS(5708),
    [anon_sym_GT_LPAREN] = ACTIONS(5708),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(8114),
  },
  [3155] = {
    [anon_sym_RBRACE] = ACTIONS(5710),
    [anon_sym_EQ] = ACTIONS(8116),
    [anon_sym_DASH] = ACTIONS(8116),
    [sym__special_character] = ACTIONS(8116),
    [anon_sym_DQUOTE] = ACTIONS(5710),
    [anon_sym_DOLLAR] = ACTIONS(8116),
    [sym_raw_string] = ACTIONS(5710),
    [anon_sym_POUND] = ACTIONS(5710),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5710),
    [anon_sym_SLASH] = ACTIONS(5710),
    [anon_sym_COLON] = ACTIONS(8116),
    [anon_sym_COLON_QMARK] = ACTIONS(8116),
    [anon_sym_COLON_DASH] = ACTIONS(8116),
    [anon_sym_PERCENT] = ACTIONS(8116),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5710),
    [anon_sym_BQUOTE] = ACTIONS(5710),
    [anon_sym_LT_LPAREN] = ACTIONS(5710),
    [anon_sym_GT_LPAREN] = ACTIONS(5710),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(8116),
  },
  [3156] = {
    [sym__concat] = ACTIONS(4053),
    [anon_sym_RBRACE] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
  },
  [3157] = {
    [sym__concat] = ACTIONS(4067),
    [anon_sym_RBRACE] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
  },
  [3158] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(8118),
    [sym_comment] = ACTIONS(57),
  },
  [3159] = {
    [anon_sym_RBRACE] = ACTIONS(8118),
    [sym_comment] = ACTIONS(57),
  },
  [3160] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(8120),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3161] = {
    [sym_concatenation] = STATE(3611),
    [sym_string] = STATE(3610),
    [sym_simple_expansion] = STATE(3610),
    [sym_string_expansion] = STATE(3610),
    [sym_expansion] = STATE(3610),
    [sym_command_substitution] = STATE(3610),
    [sym_process_substitution] = STATE(3610),
    [aux_sym__literal_repeat1] = STATE(3612),
    [anon_sym_RBRACE] = ACTIONS(8118),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(8122),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8122),
  },
  [3162] = {
    [sym__concat] = ACTIONS(4103),
    [anon_sym_RBRACE] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
  },
  [3163] = {
    [sym_concatenation] = STATE(3615),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3615),
    [sym_regex] = ACTIONS(8124),
    [anon_sym_RBRACE] = ACTIONS(8126),
    [anon_sym_EQ] = ACTIONS(8128),
    [anon_sym_DASH] = ACTIONS(8128),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8130),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8128),
    [anon_sym_COLON_QMARK] = ACTIONS(8128),
    [anon_sym_COLON_DASH] = ACTIONS(8128),
    [anon_sym_PERCENT] = ACTIONS(8128),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3164] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8126),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3165] = {
    [sym_concatenation] = STATE(3617),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3617),
    [sym_regex] = ACTIONS(8132),
    [anon_sym_RBRACE] = ACTIONS(8118),
    [anon_sym_EQ] = ACTIONS(8134),
    [anon_sym_DASH] = ACTIONS(8134),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8136),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8134),
    [anon_sym_COLON_QMARK] = ACTIONS(8134),
    [anon_sym_COLON_DASH] = ACTIONS(8134),
    [anon_sym_PERCENT] = ACTIONS(8134),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3166] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8118),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3167] = {
    [sym_concatenation] = STATE(3619),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3619),
    [anon_sym_RBRACE] = ACTIONS(8138),
    [anon_sym_EQ] = ACTIONS(8140),
    [anon_sym_DASH] = ACTIONS(8140),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8140),
    [anon_sym_COLON_QMARK] = ACTIONS(8140),
    [anon_sym_COLON_DASH] = ACTIONS(8140),
    [anon_sym_PERCENT] = ACTIONS(8140),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3168] = {
    [sym__concat] = ACTIONS(4159),
    [anon_sym_RBRACE] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
  },
  [3169] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8138),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3170] = {
    [sym_concatenation] = STATE(3617),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3617),
    [anon_sym_RBRACE] = ACTIONS(8118),
    [anon_sym_EQ] = ACTIONS(8134),
    [anon_sym_DASH] = ACTIONS(8134),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8136),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8134),
    [anon_sym_COLON_QMARK] = ACTIONS(8134),
    [anon_sym_COLON_DASH] = ACTIONS(8134),
    [anon_sym_PERCENT] = ACTIONS(8134),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3171] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [ts_builtin_sym_end] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_RPAREN] = ACTIONS(8144),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_EQ_TILDE] = ACTIONS(8146),
    [anon_sym_EQ_EQ] = ACTIONS(8146),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [3172] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [ts_builtin_sym_end] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_RPAREN] = ACTIONS(8148),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_EQ_TILDE] = ACTIONS(8150),
    [anon_sym_EQ_EQ] = ACTIONS(8150),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [3173] = {
    [sym__concat] = ACTIONS(5564),
    [anon_sym_RBRACE] = ACTIONS(5564),
    [anon_sym_EQ] = ACTIONS(5566),
    [anon_sym_DASH] = ACTIONS(5566),
    [sym__special_character] = ACTIONS(5566),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_POUND] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_COLON] = ACTIONS(5566),
    [anon_sym_COLON_QMARK] = ACTIONS(5566),
    [anon_sym_COLON_DASH] = ACTIONS(5566),
    [anon_sym_PERCENT] = ACTIONS(5566),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(5566),
  },
  [3174] = {
    [sym__concat] = ACTIONS(5598),
    [anon_sym_RBRACE] = ACTIONS(5598),
    [anon_sym_EQ] = ACTIONS(5600),
    [anon_sym_DASH] = ACTIONS(5600),
    [sym__special_character] = ACTIONS(5600),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_POUND] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_COLON] = ACTIONS(5600),
    [anon_sym_COLON_QMARK] = ACTIONS(5600),
    [anon_sym_COLON_DASH] = ACTIONS(5600),
    [anon_sym_PERCENT] = ACTIONS(5600),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(5600),
  },
  [3175] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(8152),
    [sym_comment] = ACTIONS(57),
  },
  [3176] = {
    [anon_sym_RBRACE] = ACTIONS(8152),
    [sym_comment] = ACTIONS(57),
  },
  [3177] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(8154),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3178] = {
    [sym_concatenation] = STATE(3623),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3623),
    [anon_sym_RBRACE] = ACTIONS(8156),
    [anon_sym_EQ] = ACTIONS(8158),
    [anon_sym_DASH] = ACTIONS(8158),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8158),
    [anon_sym_COLON_QMARK] = ACTIONS(8158),
    [anon_sym_COLON_DASH] = ACTIONS(8158),
    [anon_sym_PERCENT] = ACTIONS(8158),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3179] = {
    [sym__concat] = ACTIONS(5615),
    [anon_sym_RBRACE] = ACTIONS(5615),
    [anon_sym_EQ] = ACTIONS(5617),
    [anon_sym_DASH] = ACTIONS(5617),
    [sym__special_character] = ACTIONS(5617),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_POUND] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_COLON] = ACTIONS(5617),
    [anon_sym_COLON_QMARK] = ACTIONS(5617),
    [anon_sym_COLON_DASH] = ACTIONS(5617),
    [anon_sym_PERCENT] = ACTIONS(5617),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(5617),
  },
  [3180] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8156),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3181] = {
    [sym_concatenation] = STATE(3624),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3624),
    [anon_sym_RBRACE] = ACTIONS(8152),
    [anon_sym_EQ] = ACTIONS(8162),
    [anon_sym_DASH] = ACTIONS(8162),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8164),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8162),
    [anon_sym_COLON_QMARK] = ACTIONS(8162),
    [anon_sym_COLON_DASH] = ACTIONS(8162),
    [anon_sym_PERCENT] = ACTIONS(8162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3182] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8152),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3183] = {
    [sym__concat] = ACTIONS(5658),
    [anon_sym_RBRACE] = ACTIONS(5658),
    [anon_sym_EQ] = ACTIONS(5660),
    [anon_sym_DASH] = ACTIONS(5660),
    [sym__special_character] = ACTIONS(5660),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_POUND] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_COLON] = ACTIONS(5660),
    [anon_sym_COLON_QMARK] = ACTIONS(5660),
    [anon_sym_COLON_DASH] = ACTIONS(5660),
    [anon_sym_PERCENT] = ACTIONS(5660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(5660),
  },
  [3184] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8166),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3185] = {
    [sym__heredoc_body_middle] = ACTIONS(5564),
    [sym__heredoc_body_end] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
  },
  [3186] = {
    [sym__heredoc_body_middle] = ACTIONS(5598),
    [sym__heredoc_body_end] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
  },
  [3187] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(8168),
    [sym_comment] = ACTIONS(57),
  },
  [3188] = {
    [anon_sym_RBRACE] = ACTIONS(8168),
    [sym_comment] = ACTIONS(57),
  },
  [3189] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(8170),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3190] = {
    [sym_concatenation] = STATE(3629),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3629),
    [anon_sym_RBRACE] = ACTIONS(8172),
    [anon_sym_EQ] = ACTIONS(8174),
    [anon_sym_DASH] = ACTIONS(8174),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8176),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8174),
    [anon_sym_COLON_QMARK] = ACTIONS(8174),
    [anon_sym_COLON_DASH] = ACTIONS(8174),
    [anon_sym_PERCENT] = ACTIONS(8174),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3191] = {
    [sym__heredoc_body_middle] = ACTIONS(5615),
    [sym__heredoc_body_end] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
  },
  [3192] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8172),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3193] = {
    [sym_concatenation] = STATE(3630),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3630),
    [anon_sym_RBRACE] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_DASH] = ACTIONS(8178),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8180),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8178),
    [anon_sym_COLON_QMARK] = ACTIONS(8178),
    [anon_sym_COLON_DASH] = ACTIONS(8178),
    [anon_sym_PERCENT] = ACTIONS(8178),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3194] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8168),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3195] = {
    [sym__heredoc_body_middle] = ACTIONS(5658),
    [sym__heredoc_body_end] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
  },
  [3196] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8182),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3197] = {
    [aux_sym_concatenation_repeat1] = STATE(3197),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2348),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [3198] = {
    [sym__concat] = ACTIONS(5564),
    [anon_sym_RPAREN] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5564),
  },
  [3199] = {
    [sym__concat] = ACTIONS(5598),
    [anon_sym_RPAREN] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5598),
  },
  [3200] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(8184),
    [sym_comment] = ACTIONS(57),
  },
  [3201] = {
    [anon_sym_RBRACE] = ACTIONS(8184),
    [sym_comment] = ACTIONS(57),
  },
  [3202] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(8186),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3203] = {
    [sym_concatenation] = STATE(3635),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3635),
    [anon_sym_RBRACE] = ACTIONS(8188),
    [anon_sym_EQ] = ACTIONS(8190),
    [anon_sym_DASH] = ACTIONS(8190),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8192),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8190),
    [anon_sym_COLON_QMARK] = ACTIONS(8190),
    [anon_sym_COLON_DASH] = ACTIONS(8190),
    [anon_sym_PERCENT] = ACTIONS(8190),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3204] = {
    [sym__concat] = ACTIONS(5615),
    [anon_sym_RPAREN] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5615),
  },
  [3205] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8188),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3206] = {
    [sym_concatenation] = STATE(3636),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3636),
    [anon_sym_RBRACE] = ACTIONS(8184),
    [anon_sym_EQ] = ACTIONS(8194),
    [anon_sym_DASH] = ACTIONS(8194),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8196),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8194),
    [anon_sym_COLON_QMARK] = ACTIONS(8194),
    [anon_sym_COLON_DASH] = ACTIONS(8194),
    [anon_sym_PERCENT] = ACTIONS(8194),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3207] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8184),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3208] = {
    [sym__concat] = ACTIONS(5658),
    [anon_sym_RPAREN] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5658),
  },
  [3209] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8198),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3210] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [sym_variable_name] = ACTIONS(7040),
    [ts_builtin_sym_end] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_RPAREN] = ACTIONS(7040),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [3211] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [sym_variable_name] = ACTIONS(7044),
    [ts_builtin_sym_end] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_RPAREN] = ACTIONS(7044),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [3212] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [sym_variable_name] = ACTIONS(7048),
    [ts_builtin_sym_end] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_RPAREN] = ACTIONS(7048),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [3213] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8200),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3214] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8202),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3215] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [sym_variable_name] = ACTIONS(7082),
    [ts_builtin_sym_end] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_RPAREN] = ACTIONS(7082),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [3216] = {
    [sym__simple_heredoc_body] = ACTIONS(8204),
    [sym__heredoc_body_beginning] = ACTIONS(8204),
    [sym_file_descriptor] = ACTIONS(8204),
    [ts_builtin_sym_end] = ACTIONS(8204),
    [anon_sym_SEMI] = ACTIONS(8206),
    [anon_sym_done] = ACTIONS(8204),
    [anon_sym_fi] = ACTIONS(8204),
    [anon_sym_elif] = ACTIONS(8204),
    [anon_sym_else] = ACTIONS(8204),
    [anon_sym_esac] = ACTIONS(8204),
    [anon_sym_PIPE] = ACTIONS(8206),
    [anon_sym_RPAREN] = ACTIONS(8204),
    [anon_sym_SEMI_SEMI] = ACTIONS(8204),
    [anon_sym_PIPE_AMP] = ACTIONS(8204),
    [anon_sym_AMP_AMP] = ACTIONS(8204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8204),
    [anon_sym_LT] = ACTIONS(8206),
    [anon_sym_GT] = ACTIONS(8206),
    [anon_sym_GT_GT] = ACTIONS(8204),
    [anon_sym_AMP_GT] = ACTIONS(8206),
    [anon_sym_AMP_GT_GT] = ACTIONS(8204),
    [anon_sym_LT_AMP] = ACTIONS(8204),
    [anon_sym_GT_AMP] = ACTIONS(8204),
    [anon_sym_LT_LT] = ACTIONS(8206),
    [anon_sym_LT_LT_DASH] = ACTIONS(8204),
    [anon_sym_LT_LT_LT] = ACTIONS(8204),
    [anon_sym_BQUOTE] = ACTIONS(8204),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8204),
    [anon_sym_AMP] = ACTIONS(8206),
  },
  [3217] = {
    [sym_do_group] = STATE(3640),
    [sym_compound_statement] = STATE(3640),
    [anon_sym_do] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [3218] = {
    [sym__concat] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_EQ_TILDE] = ACTIONS(7040),
    [anon_sym_EQ_EQ] = ACTIONS(7040),
    [anon_sym_EQ] = ACTIONS(7042),
    [anon_sym_PLUS_EQ] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_BANG_EQ] = ACTIONS(7040),
    [anon_sym_PLUS] = ACTIONS(7042),
    [anon_sym_DASH] = ACTIONS(7042),
    [anon_sym_DASH_EQ] = ACTIONS(7040),
    [anon_sym_LT_EQ] = ACTIONS(7040),
    [anon_sym_GT_EQ] = ACTIONS(7040),
    [anon_sym_PLUS_PLUS] = ACTIONS(7040),
    [anon_sym_DASH_DASH] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7040),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [3219] = {
    [sym__concat] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_EQ_TILDE] = ACTIONS(7044),
    [anon_sym_EQ_EQ] = ACTIONS(7044),
    [anon_sym_EQ] = ACTIONS(7046),
    [anon_sym_PLUS_EQ] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_BANG_EQ] = ACTIONS(7044),
    [anon_sym_PLUS] = ACTIONS(7046),
    [anon_sym_DASH] = ACTIONS(7046),
    [anon_sym_DASH_EQ] = ACTIONS(7044),
    [anon_sym_LT_EQ] = ACTIONS(7044),
    [anon_sym_GT_EQ] = ACTIONS(7044),
    [anon_sym_PLUS_PLUS] = ACTIONS(7044),
    [anon_sym_DASH_DASH] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7044),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [3220] = {
    [sym__concat] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_EQ_TILDE] = ACTIONS(7048),
    [anon_sym_EQ_EQ] = ACTIONS(7048),
    [anon_sym_EQ] = ACTIONS(7050),
    [anon_sym_PLUS_EQ] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_BANG_EQ] = ACTIONS(7048),
    [anon_sym_PLUS] = ACTIONS(7050),
    [anon_sym_DASH] = ACTIONS(7050),
    [anon_sym_DASH_EQ] = ACTIONS(7048),
    [anon_sym_LT_EQ] = ACTIONS(7048),
    [anon_sym_GT_EQ] = ACTIONS(7048),
    [anon_sym_PLUS_PLUS] = ACTIONS(7048),
    [anon_sym_DASH_DASH] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7048),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [3221] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8208),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3222] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8210),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3223] = {
    [sym__concat] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_EQ_TILDE] = ACTIONS(7082),
    [anon_sym_EQ_EQ] = ACTIONS(7082),
    [anon_sym_EQ] = ACTIONS(7084),
    [anon_sym_PLUS_EQ] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_BANG_EQ] = ACTIONS(7082),
    [anon_sym_PLUS] = ACTIONS(7084),
    [anon_sym_DASH] = ACTIONS(7084),
    [anon_sym_DASH_EQ] = ACTIONS(7082),
    [anon_sym_LT_EQ] = ACTIONS(7082),
    [anon_sym_GT_EQ] = ACTIONS(7082),
    [anon_sym_PLUS_PLUS] = ACTIONS(7082),
    [anon_sym_DASH_DASH] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7082),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [3224] = {
    [sym_do_group] = STATE(3640),
    [sym_compound_statement] = STATE(3640),
    [anon_sym_SEMI] = ACTIONS(8212),
    [anon_sym_do] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [3225] = {
    [sym__concat] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5564),
  },
  [3226] = {
    [sym__concat] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5598),
  },
  [3227] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(8214),
    [sym_comment] = ACTIONS(57),
  },
  [3228] = {
    [anon_sym_RBRACE] = ACTIONS(8214),
    [sym_comment] = ACTIONS(57),
  },
  [3229] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(8216),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3230] = {
    [sym_concatenation] = STATE(3647),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3647),
    [anon_sym_RBRACE] = ACTIONS(8218),
    [anon_sym_EQ] = ACTIONS(8220),
    [anon_sym_DASH] = ACTIONS(8220),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8222),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8220),
    [anon_sym_COLON_QMARK] = ACTIONS(8220),
    [anon_sym_COLON_DASH] = ACTIONS(8220),
    [anon_sym_PERCENT] = ACTIONS(8220),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3231] = {
    [sym__concat] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5615),
  },
  [3232] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8218),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3233] = {
    [sym_concatenation] = STATE(3648),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3648),
    [anon_sym_RBRACE] = ACTIONS(8214),
    [anon_sym_EQ] = ACTIONS(8224),
    [anon_sym_DASH] = ACTIONS(8224),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8226),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8224),
    [anon_sym_COLON_QMARK] = ACTIONS(8224),
    [anon_sym_COLON_DASH] = ACTIONS(8224),
    [anon_sym_PERCENT] = ACTIONS(8224),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3234] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8214),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3235] = {
    [sym__concat] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5658),
  },
  [3236] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8228),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3237] = {
    [sym__concat] = ACTIONS(7040),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_RPAREN] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_EQ_TILDE] = ACTIONS(7040),
    [anon_sym_EQ_EQ] = ACTIONS(7040),
    [anon_sym_EQ] = ACTIONS(7042),
    [anon_sym_PLUS_EQ] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_BANG_EQ] = ACTIONS(7040),
    [anon_sym_PLUS] = ACTIONS(7042),
    [anon_sym_DASH] = ACTIONS(7042),
    [anon_sym_DASH_EQ] = ACTIONS(7040),
    [anon_sym_LT_EQ] = ACTIONS(7040),
    [anon_sym_GT_EQ] = ACTIONS(7040),
    [anon_sym_PLUS_PLUS] = ACTIONS(7040),
    [anon_sym_DASH_DASH] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7040),
  },
  [3238] = {
    [sym__concat] = ACTIONS(7044),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_RPAREN] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_EQ_TILDE] = ACTIONS(7044),
    [anon_sym_EQ_EQ] = ACTIONS(7044),
    [anon_sym_EQ] = ACTIONS(7046),
    [anon_sym_PLUS_EQ] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_BANG_EQ] = ACTIONS(7044),
    [anon_sym_PLUS] = ACTIONS(7046),
    [anon_sym_DASH] = ACTIONS(7046),
    [anon_sym_DASH_EQ] = ACTIONS(7044),
    [anon_sym_LT_EQ] = ACTIONS(7044),
    [anon_sym_GT_EQ] = ACTIONS(7044),
    [anon_sym_PLUS_PLUS] = ACTIONS(7044),
    [anon_sym_DASH_DASH] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7044),
  },
  [3239] = {
    [sym__concat] = ACTIONS(7048),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_RPAREN] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_EQ_TILDE] = ACTIONS(7048),
    [anon_sym_EQ_EQ] = ACTIONS(7048),
    [anon_sym_EQ] = ACTIONS(7050),
    [anon_sym_PLUS_EQ] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_BANG_EQ] = ACTIONS(7048),
    [anon_sym_PLUS] = ACTIONS(7050),
    [anon_sym_DASH] = ACTIONS(7050),
    [anon_sym_DASH_EQ] = ACTIONS(7048),
    [anon_sym_LT_EQ] = ACTIONS(7048),
    [anon_sym_GT_EQ] = ACTIONS(7048),
    [anon_sym_PLUS_PLUS] = ACTIONS(7048),
    [anon_sym_DASH_DASH] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7048),
  },
  [3240] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8230),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3241] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8232),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3242] = {
    [sym__concat] = ACTIONS(7082),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_RPAREN] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_EQ_TILDE] = ACTIONS(7082),
    [anon_sym_EQ_EQ] = ACTIONS(7082),
    [anon_sym_EQ] = ACTIONS(7084),
    [anon_sym_PLUS_EQ] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_BANG_EQ] = ACTIONS(7082),
    [anon_sym_PLUS] = ACTIONS(7084),
    [anon_sym_DASH] = ACTIONS(7084),
    [anon_sym_DASH_EQ] = ACTIONS(7082),
    [anon_sym_LT_EQ] = ACTIONS(7082),
    [anon_sym_GT_EQ] = ACTIONS(7082),
    [anon_sym_PLUS_PLUS] = ACTIONS(7082),
    [anon_sym_DASH_DASH] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(7082),
  },
  [3243] = {
    [sym__concat] = ACTIONS(8144),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(8144),
    [anon_sym_EQ_TILDE] = ACTIONS(8144),
    [anon_sym_EQ_EQ] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_PLUS_EQ] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_BANG_EQ] = ACTIONS(8144),
    [anon_sym_PLUS] = ACTIONS(8146),
    [anon_sym_DASH] = ACTIONS(8146),
    [anon_sym_DASH_EQ] = ACTIONS(8144),
    [anon_sym_LT_EQ] = ACTIONS(8144),
    [anon_sym_GT_EQ] = ACTIONS(8144),
    [anon_sym_PLUS_PLUS] = ACTIONS(8144),
    [anon_sym_DASH_DASH] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8144),
  },
  [3244] = {
    [sym__concat] = ACTIONS(8148),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(8148),
    [anon_sym_EQ_TILDE] = ACTIONS(8148),
    [anon_sym_EQ_EQ] = ACTIONS(8148),
    [anon_sym_EQ] = ACTIONS(8150),
    [anon_sym_PLUS_EQ] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_BANG_EQ] = ACTIONS(8148),
    [anon_sym_PLUS] = ACTIONS(8150),
    [anon_sym_DASH] = ACTIONS(8150),
    [anon_sym_DASH_EQ] = ACTIONS(8148),
    [anon_sym_LT_EQ] = ACTIONS(8148),
    [anon_sym_GT_EQ] = ACTIONS(8148),
    [anon_sym_PLUS_PLUS] = ACTIONS(8148),
    [anon_sym_DASH_DASH] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8148),
  },
  [3245] = {
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [sym_variable_name] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [3246] = {
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [sym_variable_name] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [3247] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(8234),
    [sym_comment] = ACTIONS(57),
  },
  [3248] = {
    [anon_sym_RBRACE] = ACTIONS(8234),
    [sym_comment] = ACTIONS(57),
  },
  [3249] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(8236),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3250] = {
    [sym_concatenation] = STATE(3655),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3655),
    [anon_sym_RBRACE] = ACTIONS(8238),
    [anon_sym_EQ] = ACTIONS(8240),
    [anon_sym_DASH] = ACTIONS(8240),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8242),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8240),
    [anon_sym_COLON_QMARK] = ACTIONS(8240),
    [anon_sym_COLON_DASH] = ACTIONS(8240),
    [anon_sym_PERCENT] = ACTIONS(8240),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3251] = {
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [sym_variable_name] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [3252] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8238),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3253] = {
    [sym_concatenation] = STATE(3656),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3656),
    [anon_sym_RBRACE] = ACTIONS(8234),
    [anon_sym_EQ] = ACTIONS(8244),
    [anon_sym_DASH] = ACTIONS(8244),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8246),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8244),
    [anon_sym_COLON_QMARK] = ACTIONS(8244),
    [anon_sym_COLON_DASH] = ACTIONS(8244),
    [anon_sym_PERCENT] = ACTIONS(8244),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3254] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8234),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3255] = {
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [sym_variable_name] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [3256] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8248),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3257] = {
    [sym_file_descriptor] = ACTIONS(7154),
    [anon_sym_SEMI] = ACTIONS(7156),
    [anon_sym_PIPE] = ACTIONS(7156),
    [anon_sym_SEMI_SEMI] = ACTIONS(7154),
    [anon_sym_PIPE_AMP] = ACTIONS(7154),
    [anon_sym_AMP_AMP] = ACTIONS(7154),
    [anon_sym_PIPE_PIPE] = ACTIONS(7154),
    [anon_sym_LT] = ACTIONS(7156),
    [anon_sym_GT] = ACTIONS(7156),
    [anon_sym_GT_GT] = ACTIONS(7154),
    [anon_sym_AMP_GT] = ACTIONS(7156),
    [anon_sym_AMP_GT_GT] = ACTIONS(7154),
    [anon_sym_LT_AMP] = ACTIONS(7154),
    [anon_sym_GT_AMP] = ACTIONS(7154),
    [anon_sym_LT_LT] = ACTIONS(7156),
    [anon_sym_LT_LT_DASH] = ACTIONS(7154),
    [anon_sym_LT_LT_LT] = ACTIONS(7154),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7154),
    [anon_sym_AMP] = ACTIONS(7156),
  },
  [3258] = {
    [sym_do_group] = STATE(3658),
    [sym_compound_statement] = STATE(3658),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [3259] = {
    [sym_do_group] = STATE(3658),
    [sym_compound_statement] = STATE(3658),
    [anon_sym_SEMI] = ACTIONS(8250),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [3260] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(8252),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [3261] = {
    [sym_file_descriptor] = ACTIONS(7875),
    [anon_sym_SEMI] = ACTIONS(7877),
    [anon_sym_PIPE] = ACTIONS(7877),
    [anon_sym_SEMI_SEMI] = ACTIONS(7875),
    [anon_sym_PIPE_AMP] = ACTIONS(7875),
    [anon_sym_AMP_AMP] = ACTIONS(7875),
    [anon_sym_PIPE_PIPE] = ACTIONS(7875),
    [anon_sym_LT] = ACTIONS(7877),
    [anon_sym_GT] = ACTIONS(7877),
    [anon_sym_GT_GT] = ACTIONS(7875),
    [anon_sym_AMP_GT] = ACTIONS(7877),
    [anon_sym_AMP_GT_GT] = ACTIONS(7875),
    [anon_sym_LT_AMP] = ACTIONS(7875),
    [anon_sym_GT_AMP] = ACTIONS(7875),
    [anon_sym_LT_LT] = ACTIONS(7877),
    [anon_sym_LT_LT_DASH] = ACTIONS(7875),
    [anon_sym_LT_LT_LT] = ACTIONS(7875),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7875),
    [anon_sym_AMP] = ACTIONS(7877),
  },
  [3262] = {
    [sym_file_descriptor] = ACTIONS(7992),
    [anon_sym_SEMI] = ACTIONS(7994),
    [anon_sym_PIPE] = ACTIONS(7994),
    [anon_sym_SEMI_SEMI] = ACTIONS(7992),
    [anon_sym_PIPE_AMP] = ACTIONS(7992),
    [anon_sym_AMP_AMP] = ACTIONS(7992),
    [anon_sym_PIPE_PIPE] = ACTIONS(7992),
    [anon_sym_LT] = ACTIONS(7994),
    [anon_sym_GT] = ACTIONS(7994),
    [anon_sym_GT_GT] = ACTIONS(7992),
    [anon_sym_AMP_GT] = ACTIONS(7994),
    [anon_sym_AMP_GT_GT] = ACTIONS(7992),
    [anon_sym_LT_AMP] = ACTIONS(7992),
    [anon_sym_GT_AMP] = ACTIONS(7992),
    [anon_sym_LT_LT] = ACTIONS(7994),
    [anon_sym_LT_LT_DASH] = ACTIONS(7992),
    [anon_sym_LT_LT_LT] = ACTIONS(7992),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7992),
    [anon_sym_AMP] = ACTIONS(7994),
  },
  [3263] = {
    [anon_sym_esac] = ACTIONS(8254),
    [sym_comment] = ACTIONS(57),
  },
  [3264] = {
    [sym_file_descriptor] = ACTIONS(8016),
    [anon_sym_SEMI] = ACTIONS(8018),
    [anon_sym_PIPE] = ACTIONS(8018),
    [anon_sym_SEMI_SEMI] = ACTIONS(8016),
    [anon_sym_PIPE_AMP] = ACTIONS(8016),
    [anon_sym_AMP_AMP] = ACTIONS(8016),
    [anon_sym_PIPE_PIPE] = ACTIONS(8016),
    [anon_sym_LT] = ACTIONS(8018),
    [anon_sym_GT] = ACTIONS(8018),
    [anon_sym_GT_GT] = ACTIONS(8016),
    [anon_sym_AMP_GT] = ACTIONS(8018),
    [anon_sym_AMP_GT_GT] = ACTIONS(8016),
    [anon_sym_LT_AMP] = ACTIONS(8016),
    [anon_sym_GT_AMP] = ACTIONS(8016),
    [anon_sym_LT_LT] = ACTIONS(8018),
    [anon_sym_LT_LT_DASH] = ACTIONS(8016),
    [anon_sym_LT_LT_LT] = ACTIONS(8016),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8016),
    [anon_sym_AMP] = ACTIONS(8018),
  },
  [3265] = {
    [anon_sym_esac] = ACTIONS(8256),
    [sym_comment] = ACTIONS(57),
  },
  [3266] = {
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [sym_variable_name] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7042),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [3267] = {
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [sym_variable_name] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7046),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [3268] = {
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [sym_variable_name] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7050),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [3269] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8258),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3270] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8260),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3271] = {
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [sym_variable_name] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7084),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [3272] = {
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7042),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [3273] = {
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7046),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [3274] = {
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7050),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [3275] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8262),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3276] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8264),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3277] = {
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7084),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [3278] = {
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_EQ_TILDE] = ACTIONS(8146),
    [anon_sym_EQ_EQ] = ACTIONS(8146),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [3279] = {
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_EQ_TILDE] = ACTIONS(8150),
    [anon_sym_EQ_EQ] = ACTIONS(8150),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [3280] = {
    [sym__simple_heredoc_body] = ACTIONS(4383),
    [sym__heredoc_body_beginning] = ACTIONS(4383),
    [sym_file_descriptor] = ACTIONS(4383),
    [sym_variable_name] = ACTIONS(4383),
    [anon_sym_SEMI] = ACTIONS(4385),
    [anon_sym_done] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI_SEMI] = ACTIONS(4383),
    [anon_sym_PIPE_AMP] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_AMP_GT] = ACTIONS(4385),
    [anon_sym_AMP_GT_GT] = ACTIONS(4383),
    [anon_sym_LT_AMP] = ACTIONS(4383),
    [anon_sym_GT_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_LT_LT_DASH] = ACTIONS(4383),
    [anon_sym_LT_LT_LT] = ACTIONS(4383),
    [sym__special_character] = ACTIONS(4383),
    [anon_sym_DQUOTE] = ACTIONS(4383),
    [anon_sym_DOLLAR] = ACTIONS(4385),
    [sym_raw_string] = ACTIONS(4383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4383),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4383),
    [anon_sym_BQUOTE] = ACTIONS(4383),
    [anon_sym_LT_LPAREN] = ACTIONS(4383),
    [anon_sym_GT_LPAREN] = ACTIONS(4383),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4385),
    [anon_sym_LF] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
  },
  [3281] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_done] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [3282] = {
    [aux_sym_concatenation_repeat1] = STATE(3282),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(8266),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_done] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [3283] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [sym_variable_name] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_done] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [3284] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(8269),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [3285] = {
    [sym_concatenation] = STATE(3670),
    [sym_string] = STATE(3669),
    [sym_simple_expansion] = STATE(3669),
    [sym_string_expansion] = STATE(3669),
    [sym_expansion] = STATE(3669),
    [sym_command_substitution] = STATE(3669),
    [sym_process_substitution] = STATE(3669),
    [aux_sym__literal_repeat1] = STATE(3671),
    [anon_sym_RBRACE] = ACTIONS(8271),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(8273),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8273),
  },
  [3286] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(8275),
    [sym_comment] = ACTIONS(57),
  },
  [3287] = {
    [sym_concatenation] = STATE(3675),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3675),
    [anon_sym_RBRACE] = ACTIONS(8277),
    [anon_sym_EQ] = ACTIONS(8279),
    [anon_sym_DASH] = ACTIONS(8279),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8281),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(8283),
    [anon_sym_COLON] = ACTIONS(8279),
    [anon_sym_COLON_QMARK] = ACTIONS(8279),
    [anon_sym_COLON_DASH] = ACTIONS(8279),
    [anon_sym_PERCENT] = ACTIONS(8279),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3288] = {
    [sym_concatenation] = STATE(3677),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3677),
    [anon_sym_RBRACE] = ACTIONS(8271),
    [anon_sym_EQ] = ACTIONS(8285),
    [anon_sym_DASH] = ACTIONS(8285),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8287),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(8289),
    [anon_sym_COLON] = ACTIONS(8285),
    [anon_sym_COLON_QMARK] = ACTIONS(8285),
    [anon_sym_COLON_DASH] = ACTIONS(8285),
    [anon_sym_PERCENT] = ACTIONS(8285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3289] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [sym_variable_name] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_done] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [3290] = {
    [sym_concatenation] = STATE(3680),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3680),
    [sym_regex] = ACTIONS(8291),
    [anon_sym_RBRACE] = ACTIONS(8293),
    [anon_sym_EQ] = ACTIONS(8295),
    [anon_sym_DASH] = ACTIONS(8295),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8297),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8295),
    [anon_sym_COLON_QMARK] = ACTIONS(8295),
    [anon_sym_COLON_DASH] = ACTIONS(8295),
    [anon_sym_PERCENT] = ACTIONS(8295),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3291] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8293),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3292] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [sym_variable_name] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_done] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [3293] = {
    [sym_concatenation] = STATE(3677),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3677),
    [sym_regex] = ACTIONS(8299),
    [anon_sym_RBRACE] = ACTIONS(8271),
    [anon_sym_EQ] = ACTIONS(8285),
    [anon_sym_DASH] = ACTIONS(8285),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8287),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8285),
    [anon_sym_COLON_QMARK] = ACTIONS(8285),
    [anon_sym_COLON_DASH] = ACTIONS(8285),
    [anon_sym_PERCENT] = ACTIONS(8285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3294] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8271),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3295] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [sym_variable_name] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_done] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [3296] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_done] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [3297] = {
    [sym__simple_heredoc_body] = ACTIONS(2697),
    [sym__heredoc_body_beginning] = ACTIONS(2697),
    [sym_file_descriptor] = ACTIONS(2697),
    [sym_variable_name] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym_done] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI_SEMI] = ACTIONS(2697),
    [anon_sym_PIPE_AMP] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_PIPE_PIPE] = ACTIONS(2697),
    [anon_sym_LT] = ACTIONS(2699),
    [anon_sym_GT] = ACTIONS(2699),
    [anon_sym_GT_GT] = ACTIONS(2697),
    [anon_sym_AMP_GT] = ACTIONS(2699),
    [anon_sym_AMP_GT_GT] = ACTIONS(2697),
    [anon_sym_LT_AMP] = ACTIONS(2697),
    [anon_sym_GT_AMP] = ACTIONS(2697),
    [anon_sym_LT_LT] = ACTIONS(2699),
    [anon_sym_LT_LT_DASH] = ACTIONS(2697),
    [anon_sym_LT_LT_LT] = ACTIONS(2697),
    [sym__special_character] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [anon_sym_DOLLAR] = ACTIONS(2699),
    [sym_raw_string] = ACTIONS(2697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2697),
    [anon_sym_BQUOTE] = ACTIONS(2697),
    [anon_sym_LT_LPAREN] = ACTIONS(2697),
    [anon_sym_GT_LPAREN] = ACTIONS(2697),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2699),
    [sym_word] = ACTIONS(2699),
    [anon_sym_LF] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
  },
  [3298] = {
    [sym_concatenation] = STATE(1357),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(1357),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(8301),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [3299] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [sym_variable_name] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_done] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4055),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [3300] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [sym_variable_name] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_done] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4069),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [3301] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(8303),
    [sym_comment] = ACTIONS(57),
  },
  [3302] = {
    [anon_sym_RBRACE] = ACTIONS(8303),
    [sym_comment] = ACTIONS(57),
  },
  [3303] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(8305),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3304] = {
    [sym_concatenation] = STATE(3686),
    [sym_string] = STATE(3685),
    [sym_simple_expansion] = STATE(3685),
    [sym_string_expansion] = STATE(3685),
    [sym_expansion] = STATE(3685),
    [sym_command_substitution] = STATE(3685),
    [sym_process_substitution] = STATE(3685),
    [aux_sym__literal_repeat1] = STATE(3687),
    [anon_sym_RBRACE] = ACTIONS(8303),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(8307),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8307),
  },
  [3305] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [sym_variable_name] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_done] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4105),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [3306] = {
    [sym_concatenation] = STATE(3690),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3690),
    [sym_regex] = ACTIONS(8309),
    [anon_sym_RBRACE] = ACTIONS(8311),
    [anon_sym_EQ] = ACTIONS(8313),
    [anon_sym_DASH] = ACTIONS(8313),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8315),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8313),
    [anon_sym_COLON_QMARK] = ACTIONS(8313),
    [anon_sym_COLON_DASH] = ACTIONS(8313),
    [anon_sym_PERCENT] = ACTIONS(8313),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3307] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8311),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3308] = {
    [sym_concatenation] = STATE(3692),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3692),
    [sym_regex] = ACTIONS(8317),
    [anon_sym_RBRACE] = ACTIONS(8303),
    [anon_sym_EQ] = ACTIONS(8319),
    [anon_sym_DASH] = ACTIONS(8319),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8319),
    [anon_sym_COLON_QMARK] = ACTIONS(8319),
    [anon_sym_COLON_DASH] = ACTIONS(8319),
    [anon_sym_PERCENT] = ACTIONS(8319),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3309] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8303),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3310] = {
    [sym_concatenation] = STATE(3694),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3694),
    [anon_sym_RBRACE] = ACTIONS(8323),
    [anon_sym_EQ] = ACTIONS(8325),
    [anon_sym_DASH] = ACTIONS(8325),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8327),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8325),
    [anon_sym_COLON_QMARK] = ACTIONS(8325),
    [anon_sym_COLON_DASH] = ACTIONS(8325),
    [anon_sym_PERCENT] = ACTIONS(8325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3311] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [sym_variable_name] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_done] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4161),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [3312] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8323),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3313] = {
    [sym_concatenation] = STATE(3692),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3692),
    [anon_sym_RBRACE] = ACTIONS(8303),
    [anon_sym_EQ] = ACTIONS(8319),
    [anon_sym_DASH] = ACTIONS(8319),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8319),
    [anon_sym_COLON_QMARK] = ACTIONS(8319),
    [anon_sym_COLON_DASH] = ACTIONS(8319),
    [anon_sym_PERCENT] = ACTIONS(8319),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3314] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_done] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4055),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [3315] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_done] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4069),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [3316] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(8329),
    [sym_comment] = ACTIONS(57),
  },
  [3317] = {
    [anon_sym_RBRACE] = ACTIONS(8329),
    [sym_comment] = ACTIONS(57),
  },
  [3318] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(8331),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3319] = {
    [sym_concatenation] = STATE(3698),
    [sym_string] = STATE(3697),
    [sym_simple_expansion] = STATE(3697),
    [sym_string_expansion] = STATE(3697),
    [sym_expansion] = STATE(3697),
    [sym_command_substitution] = STATE(3697),
    [sym_process_substitution] = STATE(3697),
    [aux_sym__literal_repeat1] = STATE(3699),
    [anon_sym_RBRACE] = ACTIONS(8329),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(8333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8333),
  },
  [3320] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_done] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4105),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [3321] = {
    [sym_concatenation] = STATE(3702),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3702),
    [sym_regex] = ACTIONS(8335),
    [anon_sym_RBRACE] = ACTIONS(8337),
    [anon_sym_EQ] = ACTIONS(8339),
    [anon_sym_DASH] = ACTIONS(8339),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8341),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8339),
    [anon_sym_COLON_QMARK] = ACTIONS(8339),
    [anon_sym_COLON_DASH] = ACTIONS(8339),
    [anon_sym_PERCENT] = ACTIONS(8339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3322] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8337),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3323] = {
    [sym_concatenation] = STATE(3704),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3704),
    [sym_regex] = ACTIONS(8343),
    [anon_sym_RBRACE] = ACTIONS(8329),
    [anon_sym_EQ] = ACTIONS(8345),
    [anon_sym_DASH] = ACTIONS(8345),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8347),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8345),
    [anon_sym_COLON_QMARK] = ACTIONS(8345),
    [anon_sym_COLON_DASH] = ACTIONS(8345),
    [anon_sym_PERCENT] = ACTIONS(8345),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3324] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8329),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3325] = {
    [sym_concatenation] = STATE(3706),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3706),
    [anon_sym_RBRACE] = ACTIONS(8349),
    [anon_sym_EQ] = ACTIONS(8351),
    [anon_sym_DASH] = ACTIONS(8351),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8351),
    [anon_sym_COLON_QMARK] = ACTIONS(8351),
    [anon_sym_COLON_DASH] = ACTIONS(8351),
    [anon_sym_PERCENT] = ACTIONS(8351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3326] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_done] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4161),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [3327] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8349),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3328] = {
    [sym_concatenation] = STATE(3704),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3704),
    [anon_sym_RBRACE] = ACTIONS(8329),
    [anon_sym_EQ] = ACTIONS(8345),
    [anon_sym_DASH] = ACTIONS(8345),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8347),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8345),
    [anon_sym_COLON_QMARK] = ACTIONS(8345),
    [anon_sym_COLON_DASH] = ACTIONS(8345),
    [anon_sym_PERCENT] = ACTIONS(8345),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3329] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_done] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5566),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [3330] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_done] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_EQ_TILDE] = ACTIONS(5600),
    [anon_sym_EQ_EQ] = ACTIONS(5600),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [3331] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(8355),
    [sym_comment] = ACTIONS(57),
  },
  [3332] = {
    [anon_sym_RBRACE] = ACTIONS(8355),
    [sym_comment] = ACTIONS(57),
  },
  [3333] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(8357),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3334] = {
    [sym_concatenation] = STATE(3710),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3710),
    [anon_sym_RBRACE] = ACTIONS(8359),
    [anon_sym_EQ] = ACTIONS(8361),
    [anon_sym_DASH] = ACTIONS(8361),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8363),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8361),
    [anon_sym_COLON_QMARK] = ACTIONS(8361),
    [anon_sym_COLON_DASH] = ACTIONS(8361),
    [anon_sym_PERCENT] = ACTIONS(8361),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3335] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_done] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_EQ_TILDE] = ACTIONS(5617),
    [anon_sym_EQ_EQ] = ACTIONS(5617),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [3336] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8359),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3337] = {
    [sym_concatenation] = STATE(3711),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3711),
    [anon_sym_RBRACE] = ACTIONS(8355),
    [anon_sym_EQ] = ACTIONS(8365),
    [anon_sym_DASH] = ACTIONS(8365),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8367),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8365),
    [anon_sym_COLON_QMARK] = ACTIONS(8365),
    [anon_sym_COLON_DASH] = ACTIONS(8365),
    [anon_sym_PERCENT] = ACTIONS(8365),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3338] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8355),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3339] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_done] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_EQ_TILDE] = ACTIONS(5660),
    [anon_sym_EQ_EQ] = ACTIONS(5660),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [3340] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8369),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3341] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_done] = ACTIONS(2344),
    [anon_sym_fi] = ACTIONS(2344),
    [anon_sym_elif] = ACTIONS(2344),
    [anon_sym_else] = ACTIONS(2344),
    [anon_sym_esac] = ACTIONS(2344),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [3342] = {
    [aux_sym_concatenation_repeat1] = STATE(3342),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(8371),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_done] = ACTIONS(2344),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [3343] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_done] = ACTIONS(2351),
    [anon_sym_fi] = ACTIONS(2351),
    [anon_sym_elif] = ACTIONS(2351),
    [anon_sym_else] = ACTIONS(2351),
    [anon_sym_esac] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [3344] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(8374),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [3345] = {
    [sym_concatenation] = STATE(3716),
    [sym_string] = STATE(3715),
    [sym_simple_expansion] = STATE(3715),
    [sym_string_expansion] = STATE(3715),
    [sym_expansion] = STATE(3715),
    [sym_command_substitution] = STATE(3715),
    [sym_process_substitution] = STATE(3715),
    [aux_sym__literal_repeat1] = STATE(3717),
    [anon_sym_RBRACE] = ACTIONS(8376),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(8378),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8378),
  },
  [3346] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(8380),
    [sym_comment] = ACTIONS(57),
  },
  [3347] = {
    [sym_concatenation] = STATE(3721),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3721),
    [anon_sym_RBRACE] = ACTIONS(8382),
    [anon_sym_EQ] = ACTIONS(8384),
    [anon_sym_DASH] = ACTIONS(8384),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8386),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(8388),
    [anon_sym_COLON] = ACTIONS(8384),
    [anon_sym_COLON_QMARK] = ACTIONS(8384),
    [anon_sym_COLON_DASH] = ACTIONS(8384),
    [anon_sym_PERCENT] = ACTIONS(8384),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3348] = {
    [sym_concatenation] = STATE(3723),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3723),
    [anon_sym_RBRACE] = ACTIONS(8376),
    [anon_sym_EQ] = ACTIONS(8390),
    [anon_sym_DASH] = ACTIONS(8390),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8392),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(8394),
    [anon_sym_COLON] = ACTIONS(8390),
    [anon_sym_COLON_QMARK] = ACTIONS(8390),
    [anon_sym_COLON_DASH] = ACTIONS(8390),
    [anon_sym_PERCENT] = ACTIONS(8390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3349] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_done] = ACTIONS(2442),
    [anon_sym_fi] = ACTIONS(2442),
    [anon_sym_elif] = ACTIONS(2442),
    [anon_sym_else] = ACTIONS(2442),
    [anon_sym_esac] = ACTIONS(2442),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [3350] = {
    [sym_concatenation] = STATE(3726),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3726),
    [sym_regex] = ACTIONS(8396),
    [anon_sym_RBRACE] = ACTIONS(8398),
    [anon_sym_EQ] = ACTIONS(8400),
    [anon_sym_DASH] = ACTIONS(8400),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8402),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8400),
    [anon_sym_COLON_QMARK] = ACTIONS(8400),
    [anon_sym_COLON_DASH] = ACTIONS(8400),
    [anon_sym_PERCENT] = ACTIONS(8400),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3351] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8398),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3352] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_done] = ACTIONS(2492),
    [anon_sym_fi] = ACTIONS(2492),
    [anon_sym_elif] = ACTIONS(2492),
    [anon_sym_else] = ACTIONS(2492),
    [anon_sym_esac] = ACTIONS(2492),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [3353] = {
    [sym_concatenation] = STATE(3723),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3723),
    [sym_regex] = ACTIONS(8404),
    [anon_sym_RBRACE] = ACTIONS(8376),
    [anon_sym_EQ] = ACTIONS(8390),
    [anon_sym_DASH] = ACTIONS(8390),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8392),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8390),
    [anon_sym_COLON_QMARK] = ACTIONS(8390),
    [anon_sym_COLON_DASH] = ACTIONS(8390),
    [anon_sym_PERCENT] = ACTIONS(8390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3354] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8376),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3355] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_done] = ACTIONS(2500),
    [anon_sym_fi] = ACTIONS(2500),
    [anon_sym_elif] = ACTIONS(2500),
    [anon_sym_else] = ACTIONS(2500),
    [anon_sym_esac] = ACTIONS(2500),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [3356] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_done] = ACTIONS(2534),
    [anon_sym_fi] = ACTIONS(2534),
    [anon_sym_elif] = ACTIONS(2534),
    [anon_sym_else] = ACTIONS(2534),
    [anon_sym_esac] = ACTIONS(2534),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [3357] = {
    [sym__simple_heredoc_body] = ACTIONS(4383),
    [sym__heredoc_body_beginning] = ACTIONS(4383),
    [sym_file_descriptor] = ACTIONS(4383),
    [sym_variable_name] = ACTIONS(4383),
    [anon_sym_SEMI] = ACTIONS(4385),
    [anon_sym_fi] = ACTIONS(4385),
    [anon_sym_elif] = ACTIONS(4385),
    [anon_sym_else] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI_SEMI] = ACTIONS(4383),
    [anon_sym_PIPE_AMP] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_AMP_GT] = ACTIONS(4385),
    [anon_sym_AMP_GT_GT] = ACTIONS(4383),
    [anon_sym_LT_AMP] = ACTIONS(4383),
    [anon_sym_GT_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_LT_LT_DASH] = ACTIONS(4383),
    [anon_sym_LT_LT_LT] = ACTIONS(4383),
    [sym__special_character] = ACTIONS(4383),
    [anon_sym_DQUOTE] = ACTIONS(4383),
    [anon_sym_DOLLAR] = ACTIONS(4385),
    [sym_raw_string] = ACTIONS(4383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4383),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4383),
    [anon_sym_BQUOTE] = ACTIONS(4383),
    [anon_sym_LT_LPAREN] = ACTIONS(4383),
    [anon_sym_GT_LPAREN] = ACTIONS(4383),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4385),
    [anon_sym_LF] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
  },
  [3358] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_fi] = ACTIONS(2346),
    [anon_sym_elif] = ACTIONS(2346),
    [anon_sym_else] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [3359] = {
    [aux_sym_concatenation_repeat1] = STATE(3359),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(8406),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_fi] = ACTIONS(2346),
    [anon_sym_elif] = ACTIONS(2346),
    [anon_sym_else] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [3360] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [sym_variable_name] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_fi] = ACTIONS(2353),
    [anon_sym_elif] = ACTIONS(2353),
    [anon_sym_else] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [3361] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(8409),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [3362] = {
    [sym_concatenation] = STATE(3731),
    [sym_string] = STATE(3730),
    [sym_simple_expansion] = STATE(3730),
    [sym_string_expansion] = STATE(3730),
    [sym_expansion] = STATE(3730),
    [sym_command_substitution] = STATE(3730),
    [sym_process_substitution] = STATE(3730),
    [aux_sym__literal_repeat1] = STATE(3732),
    [anon_sym_RBRACE] = ACTIONS(8411),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(8413),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8413),
  },
  [3363] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(8415),
    [sym_comment] = ACTIONS(57),
  },
  [3364] = {
    [sym_concatenation] = STATE(3736),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3736),
    [anon_sym_RBRACE] = ACTIONS(8417),
    [anon_sym_EQ] = ACTIONS(8419),
    [anon_sym_DASH] = ACTIONS(8419),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(8423),
    [anon_sym_COLON] = ACTIONS(8419),
    [anon_sym_COLON_QMARK] = ACTIONS(8419),
    [anon_sym_COLON_DASH] = ACTIONS(8419),
    [anon_sym_PERCENT] = ACTIONS(8419),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3365] = {
    [sym_concatenation] = STATE(3738),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3738),
    [anon_sym_RBRACE] = ACTIONS(8411),
    [anon_sym_EQ] = ACTIONS(8425),
    [anon_sym_DASH] = ACTIONS(8425),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8427),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(8429),
    [anon_sym_COLON] = ACTIONS(8425),
    [anon_sym_COLON_QMARK] = ACTIONS(8425),
    [anon_sym_COLON_DASH] = ACTIONS(8425),
    [anon_sym_PERCENT] = ACTIONS(8425),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3366] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [sym_variable_name] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_fi] = ACTIONS(2444),
    [anon_sym_elif] = ACTIONS(2444),
    [anon_sym_else] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [3367] = {
    [sym_concatenation] = STATE(3741),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3741),
    [sym_regex] = ACTIONS(8431),
    [anon_sym_RBRACE] = ACTIONS(8433),
    [anon_sym_EQ] = ACTIONS(8435),
    [anon_sym_DASH] = ACTIONS(8435),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8435),
    [anon_sym_COLON_QMARK] = ACTIONS(8435),
    [anon_sym_COLON_DASH] = ACTIONS(8435),
    [anon_sym_PERCENT] = ACTIONS(8435),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3368] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8433),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3369] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [sym_variable_name] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_fi] = ACTIONS(2494),
    [anon_sym_elif] = ACTIONS(2494),
    [anon_sym_else] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [3370] = {
    [sym_concatenation] = STATE(3738),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3738),
    [sym_regex] = ACTIONS(8439),
    [anon_sym_RBRACE] = ACTIONS(8411),
    [anon_sym_EQ] = ACTIONS(8425),
    [anon_sym_DASH] = ACTIONS(8425),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8427),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8425),
    [anon_sym_COLON_QMARK] = ACTIONS(8425),
    [anon_sym_COLON_DASH] = ACTIONS(8425),
    [anon_sym_PERCENT] = ACTIONS(8425),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3371] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8411),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3372] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [sym_variable_name] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_fi] = ACTIONS(2502),
    [anon_sym_elif] = ACTIONS(2502),
    [anon_sym_else] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [3373] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_fi] = ACTIONS(2536),
    [anon_sym_elif] = ACTIONS(2536),
    [anon_sym_else] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [3374] = {
    [sym__simple_heredoc_body] = ACTIONS(2697),
    [sym__heredoc_body_beginning] = ACTIONS(2697),
    [sym_file_descriptor] = ACTIONS(2697),
    [sym_variable_name] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym_fi] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI_SEMI] = ACTIONS(2697),
    [anon_sym_PIPE_AMP] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_PIPE_PIPE] = ACTIONS(2697),
    [anon_sym_LT] = ACTIONS(2699),
    [anon_sym_GT] = ACTIONS(2699),
    [anon_sym_GT_GT] = ACTIONS(2697),
    [anon_sym_AMP_GT] = ACTIONS(2699),
    [anon_sym_AMP_GT_GT] = ACTIONS(2697),
    [anon_sym_LT_AMP] = ACTIONS(2697),
    [anon_sym_GT_AMP] = ACTIONS(2697),
    [anon_sym_LT_LT] = ACTIONS(2699),
    [anon_sym_LT_LT_DASH] = ACTIONS(2697),
    [anon_sym_LT_LT_LT] = ACTIONS(2697),
    [sym__special_character] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [anon_sym_DOLLAR] = ACTIONS(2699),
    [sym_raw_string] = ACTIONS(2697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2697),
    [anon_sym_BQUOTE] = ACTIONS(2697),
    [anon_sym_LT_LPAREN] = ACTIONS(2697),
    [anon_sym_GT_LPAREN] = ACTIONS(2697),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2699),
    [anon_sym_LF] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
  },
  [3375] = {
    [sym_concatenation] = STATE(1357),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(1357),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(8441),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [3376] = {
    [sym_string] = STATE(3744),
    [sym_simple_expansion] = STATE(3744),
    [sym_string_expansion] = STATE(3744),
    [sym_expansion] = STATE(3744),
    [sym_command_substitution] = STATE(3744),
    [sym_process_substitution] = STATE(3744),
    [sym__special_character] = ACTIONS(8443),
    [anon_sym_DQUOTE] = ACTIONS(6333),
    [anon_sym_DOLLAR] = ACTIONS(6335),
    [sym_raw_string] = ACTIONS(8443),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6341),
    [anon_sym_BQUOTE] = ACTIONS(6343),
    [anon_sym_LT_LPAREN] = ACTIONS(6345),
    [anon_sym_GT_LPAREN] = ACTIONS(6345),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8443),
  },
  [3377] = {
    [aux_sym_concatenation_repeat1] = STATE(3745),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(7521),
    [sym_variable_name] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_fi] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [3378] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [sym_variable_name] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_fi] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [3379] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(8445),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [3380] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(8445),
    [anon_sym_DOLLAR] = ACTIONS(8447),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [3381] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_fi] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [3382] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [sym_variable_name] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_fi] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [3383] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [sym_variable_name] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_fi] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [3384] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(8449),
    [sym_comment] = ACTIONS(57),
  },
  [3385] = {
    [sym_subscript] = STATE(3751),
    [sym_variable_name] = ACTIONS(8451),
    [anon_sym_DASH] = ACTIONS(8453),
    [anon_sym_DOLLAR] = ACTIONS(8453),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8455),
    [anon_sym_STAR] = ACTIONS(8457),
    [anon_sym_AT] = ACTIONS(8457),
    [anon_sym_QMARK] = ACTIONS(8457),
    [anon_sym_0] = ACTIONS(8455),
    [anon_sym__] = ACTIONS(8455),
  },
  [3386] = {
    [sym_concatenation] = STATE(3754),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3754),
    [anon_sym_RBRACE] = ACTIONS(8459),
    [anon_sym_EQ] = ACTIONS(8461),
    [anon_sym_DASH] = ACTIONS(8461),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(8465),
    [anon_sym_COLON] = ACTIONS(8461),
    [anon_sym_COLON_QMARK] = ACTIONS(8461),
    [anon_sym_COLON_DASH] = ACTIONS(8461),
    [anon_sym_PERCENT] = ACTIONS(8461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3387] = {
    [sym_concatenation] = STATE(3757),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3757),
    [anon_sym_RBRACE] = ACTIONS(8467),
    [anon_sym_EQ] = ACTIONS(8469),
    [anon_sym_DASH] = ACTIONS(8469),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(8473),
    [anon_sym_COLON] = ACTIONS(8469),
    [anon_sym_COLON_QMARK] = ACTIONS(8469),
    [anon_sym_COLON_DASH] = ACTIONS(8469),
    [anon_sym_PERCENT] = ACTIONS(8469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3388] = {
    [anon_sym_RPAREN] = ACTIONS(8475),
    [sym_comment] = ACTIONS(57),
  },
  [3389] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(8475),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [3390] = {
    [anon_sym_BQUOTE] = ACTIONS(8475),
    [sym_comment] = ACTIONS(57),
  },
  [3391] = {
    [anon_sym_RPAREN] = ACTIONS(8477),
    [sym_comment] = ACTIONS(57),
  },
  [3392] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_fi] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [3393] = {
    [aux_sym__literal_repeat1] = STATE(3393),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym_variable_name] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_fi] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(8479),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [3394] = {
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_fi] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1400),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [3395] = {
    [sym_concatenation] = STATE(3761),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(3761),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(8482),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [3396] = {
    [aux_sym_concatenation_repeat1] = STATE(2890),
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym__concat] = ACTIONS(6349),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_fi] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1400),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [3397] = {
    [aux_sym__literal_repeat1] = STATE(2907),
    [sym__simple_heredoc_body] = ACTIONS(1444),
    [sym__heredoc_body_beginning] = ACTIONS(1444),
    [sym_file_descriptor] = ACTIONS(1444),
    [sym_variable_name] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_fi] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1446),
    [anon_sym_SEMI_SEMI] = ACTIONS(1444),
    [anon_sym_PIPE_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1446),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_AMP_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT_GT] = ACTIONS(1444),
    [anon_sym_LT_AMP] = ACTIONS(1444),
    [anon_sym_GT_AMP] = ACTIONS(1444),
    [anon_sym_LT_LT] = ACTIONS(1446),
    [anon_sym_LT_LT_DASH] = ACTIONS(1444),
    [anon_sym_LT_LT_LT] = ACTIONS(1444),
    [sym__special_character] = ACTIONS(6375),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [anon_sym_DOLLAR] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1444),
    [anon_sym_BQUOTE] = ACTIONS(1444),
    [anon_sym_LT_LPAREN] = ACTIONS(1444),
    [anon_sym_GT_LPAREN] = ACTIONS(1444),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1446),
    [sym_word] = ACTIONS(1446),
    [anon_sym_LF] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1446),
  },
  [3398] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_fi] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [3399] = {
    [aux_sym_concatenation_repeat1] = STATE(3399),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(8484),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_fi] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [3400] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [sym_variable_name] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_fi] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2353),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [3401] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(8487),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [3402] = {
    [sym_concatenation] = STATE(3765),
    [sym_string] = STATE(3764),
    [sym_simple_expansion] = STATE(3764),
    [sym_string_expansion] = STATE(3764),
    [sym_expansion] = STATE(3764),
    [sym_command_substitution] = STATE(3764),
    [sym_process_substitution] = STATE(3764),
    [aux_sym__literal_repeat1] = STATE(3766),
    [anon_sym_RBRACE] = ACTIONS(8489),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(8491),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8491),
  },
  [3403] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(8493),
    [sym_comment] = ACTIONS(57),
  },
  [3404] = {
    [sym_concatenation] = STATE(3770),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3770),
    [anon_sym_RBRACE] = ACTIONS(8495),
    [anon_sym_EQ] = ACTIONS(8497),
    [anon_sym_DASH] = ACTIONS(8497),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8499),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(8501),
    [anon_sym_COLON] = ACTIONS(8497),
    [anon_sym_COLON_QMARK] = ACTIONS(8497),
    [anon_sym_COLON_DASH] = ACTIONS(8497),
    [anon_sym_PERCENT] = ACTIONS(8497),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3405] = {
    [sym_concatenation] = STATE(3772),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3772),
    [anon_sym_RBRACE] = ACTIONS(8489),
    [anon_sym_EQ] = ACTIONS(8503),
    [anon_sym_DASH] = ACTIONS(8503),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8505),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(8507),
    [anon_sym_COLON] = ACTIONS(8503),
    [anon_sym_COLON_QMARK] = ACTIONS(8503),
    [anon_sym_COLON_DASH] = ACTIONS(8503),
    [anon_sym_PERCENT] = ACTIONS(8503),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3406] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [sym_variable_name] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_fi] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2444),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [3407] = {
    [sym_concatenation] = STATE(3775),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3775),
    [sym_regex] = ACTIONS(8509),
    [anon_sym_RBRACE] = ACTIONS(8511),
    [anon_sym_EQ] = ACTIONS(8513),
    [anon_sym_DASH] = ACTIONS(8513),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8515),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8513),
    [anon_sym_COLON_QMARK] = ACTIONS(8513),
    [anon_sym_COLON_DASH] = ACTIONS(8513),
    [anon_sym_PERCENT] = ACTIONS(8513),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3408] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8511),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3409] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [sym_variable_name] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_fi] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2494),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [3410] = {
    [sym_concatenation] = STATE(3772),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3772),
    [sym_regex] = ACTIONS(8517),
    [anon_sym_RBRACE] = ACTIONS(8489),
    [anon_sym_EQ] = ACTIONS(8503),
    [anon_sym_DASH] = ACTIONS(8503),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8505),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8503),
    [anon_sym_COLON_QMARK] = ACTIONS(8503),
    [anon_sym_COLON_DASH] = ACTIONS(8503),
    [anon_sym_PERCENT] = ACTIONS(8503),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3411] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8489),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3412] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [sym_variable_name] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_fi] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2502),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [3413] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_fi] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2536),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [3414] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_fi] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [3415] = {
    [aux_sym_concatenation_repeat1] = STATE(3415),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(8519),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_fi] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [3416] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_fi] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2353),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [3417] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(8522),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [3418] = {
    [sym_concatenation] = STATE(3780),
    [sym_string] = STATE(3779),
    [sym_simple_expansion] = STATE(3779),
    [sym_string_expansion] = STATE(3779),
    [sym_expansion] = STATE(3779),
    [sym_command_substitution] = STATE(3779),
    [sym_process_substitution] = STATE(3779),
    [aux_sym__literal_repeat1] = STATE(3781),
    [anon_sym_RBRACE] = ACTIONS(8524),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(8526),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8526),
  },
  [3419] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(8528),
    [sym_comment] = ACTIONS(57),
  },
  [3420] = {
    [sym_concatenation] = STATE(3785),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3785),
    [anon_sym_RBRACE] = ACTIONS(8530),
    [anon_sym_EQ] = ACTIONS(8532),
    [anon_sym_DASH] = ACTIONS(8532),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(8536),
    [anon_sym_COLON] = ACTIONS(8532),
    [anon_sym_COLON_QMARK] = ACTIONS(8532),
    [anon_sym_COLON_DASH] = ACTIONS(8532),
    [anon_sym_PERCENT] = ACTIONS(8532),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3421] = {
    [sym_concatenation] = STATE(3787),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3787),
    [anon_sym_RBRACE] = ACTIONS(8524),
    [anon_sym_EQ] = ACTIONS(8538),
    [anon_sym_DASH] = ACTIONS(8538),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(8542),
    [anon_sym_COLON] = ACTIONS(8538),
    [anon_sym_COLON_QMARK] = ACTIONS(8538),
    [anon_sym_COLON_DASH] = ACTIONS(8538),
    [anon_sym_PERCENT] = ACTIONS(8538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3422] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_fi] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2444),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [3423] = {
    [sym_concatenation] = STATE(3790),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3790),
    [sym_regex] = ACTIONS(8544),
    [anon_sym_RBRACE] = ACTIONS(8546),
    [anon_sym_EQ] = ACTIONS(8548),
    [anon_sym_DASH] = ACTIONS(8548),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8550),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8548),
    [anon_sym_COLON_QMARK] = ACTIONS(8548),
    [anon_sym_COLON_DASH] = ACTIONS(8548),
    [anon_sym_PERCENT] = ACTIONS(8548),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3424] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8546),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3425] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_fi] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2494),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [3426] = {
    [sym_concatenation] = STATE(3787),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3787),
    [sym_regex] = ACTIONS(8552),
    [anon_sym_RBRACE] = ACTIONS(8524),
    [anon_sym_EQ] = ACTIONS(8538),
    [anon_sym_DASH] = ACTIONS(8538),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8538),
    [anon_sym_COLON_QMARK] = ACTIONS(8538),
    [anon_sym_COLON_DASH] = ACTIONS(8538),
    [anon_sym_PERCENT] = ACTIONS(8538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3427] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8524),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3428] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_fi] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2502),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [3429] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_fi] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2536),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [3430] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_fi] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_EQ_TILDE] = ACTIONS(4055),
    [anon_sym_EQ_EQ] = ACTIONS(4055),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [3431] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_fi] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_EQ_TILDE] = ACTIONS(4069),
    [anon_sym_EQ_EQ] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [3432] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(8554),
    [sym_comment] = ACTIONS(57),
  },
  [3433] = {
    [anon_sym_RBRACE] = ACTIONS(8554),
    [sym_comment] = ACTIONS(57),
  },
  [3434] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(8556),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3435] = {
    [sym_concatenation] = STATE(3795),
    [sym_string] = STATE(3794),
    [sym_simple_expansion] = STATE(3794),
    [sym_string_expansion] = STATE(3794),
    [sym_expansion] = STATE(3794),
    [sym_command_substitution] = STATE(3794),
    [sym_process_substitution] = STATE(3794),
    [aux_sym__literal_repeat1] = STATE(3796),
    [anon_sym_RBRACE] = ACTIONS(8554),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(8558),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8558),
  },
  [3436] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_fi] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_EQ_TILDE] = ACTIONS(4105),
    [anon_sym_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [3437] = {
    [sym_concatenation] = STATE(3799),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3799),
    [sym_regex] = ACTIONS(8560),
    [anon_sym_RBRACE] = ACTIONS(8562),
    [anon_sym_EQ] = ACTIONS(8564),
    [anon_sym_DASH] = ACTIONS(8564),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8566),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8564),
    [anon_sym_COLON_QMARK] = ACTIONS(8564),
    [anon_sym_COLON_DASH] = ACTIONS(8564),
    [anon_sym_PERCENT] = ACTIONS(8564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3438] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8562),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3439] = {
    [sym_concatenation] = STATE(3801),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3801),
    [sym_regex] = ACTIONS(8568),
    [anon_sym_RBRACE] = ACTIONS(8554),
    [anon_sym_EQ] = ACTIONS(8570),
    [anon_sym_DASH] = ACTIONS(8570),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8570),
    [anon_sym_COLON_QMARK] = ACTIONS(8570),
    [anon_sym_COLON_DASH] = ACTIONS(8570),
    [anon_sym_PERCENT] = ACTIONS(8570),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3440] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8554),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3441] = {
    [sym_concatenation] = STATE(3803),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3803),
    [anon_sym_RBRACE] = ACTIONS(8574),
    [anon_sym_EQ] = ACTIONS(8576),
    [anon_sym_DASH] = ACTIONS(8576),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8578),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8576),
    [anon_sym_COLON_QMARK] = ACTIONS(8576),
    [anon_sym_COLON_DASH] = ACTIONS(8576),
    [anon_sym_PERCENT] = ACTIONS(8576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3442] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_fi] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_EQ_TILDE] = ACTIONS(4161),
    [anon_sym_EQ_EQ] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [3443] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8574),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3444] = {
    [sym_concatenation] = STATE(3801),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3801),
    [anon_sym_RBRACE] = ACTIONS(8554),
    [anon_sym_EQ] = ACTIONS(8570),
    [anon_sym_DASH] = ACTIONS(8570),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8570),
    [anon_sym_COLON_QMARK] = ACTIONS(8570),
    [anon_sym_COLON_DASH] = ACTIONS(8570),
    [anon_sym_PERCENT] = ACTIONS(8570),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3445] = {
    [aux_sym_concatenation_repeat1] = STATE(3447),
    [sym__simple_heredoc_body] = ACTIONS(1378),
    [sym__heredoc_body_beginning] = ACTIONS(1378),
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_fi] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1378),
    [anon_sym_PIPE_AMP] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_AMP] = ACTIONS(1378),
    [anon_sym_GT_AMP] = ACTIONS(1378),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1378),
    [anon_sym_LT_LT_LT] = ACTIONS(1378),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1378),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [3446] = {
    [aux_sym__literal_repeat1] = STATE(3448),
    [sym__simple_heredoc_body] = ACTIONS(1382),
    [sym__heredoc_body_beginning] = ACTIONS(1382),
    [sym_file_descriptor] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym_fi] = ACTIONS(1382),
    [anon_sym_PIPE] = ACTIONS(1384),
    [anon_sym_SEMI_SEMI] = ACTIONS(1382),
    [anon_sym_PIPE_AMP] = ACTIONS(1382),
    [anon_sym_AMP_AMP] = ACTIONS(1382),
    [anon_sym_PIPE_PIPE] = ACTIONS(1382),
    [anon_sym_LT] = ACTIONS(1384),
    [anon_sym_GT] = ACTIONS(1384),
    [anon_sym_GT_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT_GT] = ACTIONS(1382),
    [anon_sym_LT_AMP] = ACTIONS(1382),
    [anon_sym_GT_AMP] = ACTIONS(1382),
    [anon_sym_LT_LT] = ACTIONS(1384),
    [anon_sym_LT_LT_DASH] = ACTIONS(1382),
    [anon_sym_LT_LT_LT] = ACTIONS(1382),
    [sym__special_character] = ACTIONS(6247),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
  },
  [3447] = {
    [aux_sym_concatenation_repeat1] = STATE(3804),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_fi] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [3448] = {
    [aux_sym__literal_repeat1] = STATE(3448),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_fi] = ACTIONS(1371),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(7471),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [3449] = {
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(2584),
    [anon_sym_for] = ACTIONS(2588),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_fi] = ACTIONS(7474),
    [anon_sym_case] = ACTIONS(2588),
    [anon_sym_function] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2584),
    [anon_sym_declare] = ACTIONS(2588),
    [anon_sym_typeset] = ACTIONS(2588),
    [anon_sym_export] = ACTIONS(2588),
    [anon_sym_readonly] = ACTIONS(2588),
    [anon_sym_local] = ACTIONS(2588),
    [anon_sym_unset] = ACTIONS(2588),
    [anon_sym_unsetenv] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [sym__special_character] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2584),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2584),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [anon_sym_LT_LPAREN] = ACTIONS(2584),
    [anon_sym_GT_LPAREN] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
  },
  [3450] = {
    [sym__simple_heredoc_body] = ACTIONS(2697),
    [sym__heredoc_body_beginning] = ACTIONS(2697),
    [sym_file_descriptor] = ACTIONS(2697),
    [sym_variable_name] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym_fi] = ACTIONS(2699),
    [anon_sym_elif] = ACTIONS(2699),
    [anon_sym_else] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI_SEMI] = ACTIONS(2697),
    [anon_sym_PIPE_AMP] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_PIPE_PIPE] = ACTIONS(2697),
    [anon_sym_LT] = ACTIONS(2699),
    [anon_sym_GT] = ACTIONS(2699),
    [anon_sym_GT_GT] = ACTIONS(2697),
    [anon_sym_AMP_GT] = ACTIONS(2699),
    [anon_sym_AMP_GT_GT] = ACTIONS(2697),
    [anon_sym_LT_AMP] = ACTIONS(2697),
    [anon_sym_GT_AMP] = ACTIONS(2697),
    [anon_sym_LT_LT] = ACTIONS(2699),
    [anon_sym_LT_LT_DASH] = ACTIONS(2697),
    [anon_sym_LT_LT_LT] = ACTIONS(2697),
    [sym__special_character] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [anon_sym_DOLLAR] = ACTIONS(2699),
    [sym_raw_string] = ACTIONS(2697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2697),
    [anon_sym_BQUOTE] = ACTIONS(2697),
    [anon_sym_LT_LPAREN] = ACTIONS(2697),
    [anon_sym_GT_LPAREN] = ACTIONS(2697),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2699),
    [sym_word] = ACTIONS(2699),
    [anon_sym_LF] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
  },
  [3451] = {
    [sym_concatenation] = STATE(1357),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(1357),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(8580),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [3452] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [sym_variable_name] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_fi] = ACTIONS(4055),
    [anon_sym_elif] = ACTIONS(4055),
    [anon_sym_else] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4055),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [3453] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [sym_variable_name] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_fi] = ACTIONS(4069),
    [anon_sym_elif] = ACTIONS(4069),
    [anon_sym_else] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4069),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [3454] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(8582),
    [sym_comment] = ACTIONS(57),
  },
  [3455] = {
    [anon_sym_RBRACE] = ACTIONS(8582),
    [sym_comment] = ACTIONS(57),
  },
  [3456] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(8584),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3457] = {
    [sym_concatenation] = STATE(3809),
    [sym_string] = STATE(3808),
    [sym_simple_expansion] = STATE(3808),
    [sym_string_expansion] = STATE(3808),
    [sym_expansion] = STATE(3808),
    [sym_command_substitution] = STATE(3808),
    [sym_process_substitution] = STATE(3808),
    [aux_sym__literal_repeat1] = STATE(3810),
    [anon_sym_RBRACE] = ACTIONS(8582),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(8586),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8586),
  },
  [3458] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [sym_variable_name] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_fi] = ACTIONS(4105),
    [anon_sym_elif] = ACTIONS(4105),
    [anon_sym_else] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4105),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [3459] = {
    [sym_concatenation] = STATE(3813),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3813),
    [sym_regex] = ACTIONS(8588),
    [anon_sym_RBRACE] = ACTIONS(8590),
    [anon_sym_EQ] = ACTIONS(8592),
    [anon_sym_DASH] = ACTIONS(8592),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8594),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8592),
    [anon_sym_COLON_QMARK] = ACTIONS(8592),
    [anon_sym_COLON_DASH] = ACTIONS(8592),
    [anon_sym_PERCENT] = ACTIONS(8592),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3460] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8590),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3461] = {
    [sym_concatenation] = STATE(3815),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3815),
    [sym_regex] = ACTIONS(8596),
    [anon_sym_RBRACE] = ACTIONS(8582),
    [anon_sym_EQ] = ACTIONS(8598),
    [anon_sym_DASH] = ACTIONS(8598),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8598),
    [anon_sym_COLON_QMARK] = ACTIONS(8598),
    [anon_sym_COLON_DASH] = ACTIONS(8598),
    [anon_sym_PERCENT] = ACTIONS(8598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3462] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8582),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3463] = {
    [sym_concatenation] = STATE(3817),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3817),
    [anon_sym_RBRACE] = ACTIONS(8602),
    [anon_sym_EQ] = ACTIONS(8604),
    [anon_sym_DASH] = ACTIONS(8604),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8606),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8604),
    [anon_sym_COLON_QMARK] = ACTIONS(8604),
    [anon_sym_COLON_DASH] = ACTIONS(8604),
    [anon_sym_PERCENT] = ACTIONS(8604),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3464] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [sym_variable_name] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_fi] = ACTIONS(4161),
    [anon_sym_elif] = ACTIONS(4161),
    [anon_sym_else] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4161),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [3465] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8602),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3466] = {
    [sym_concatenation] = STATE(3815),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3815),
    [anon_sym_RBRACE] = ACTIONS(8582),
    [anon_sym_EQ] = ACTIONS(8598),
    [anon_sym_DASH] = ACTIONS(8598),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8598),
    [anon_sym_COLON_QMARK] = ACTIONS(8598),
    [anon_sym_COLON_DASH] = ACTIONS(8598),
    [anon_sym_PERCENT] = ACTIONS(8598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3467] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_fi] = ACTIONS(4055),
    [anon_sym_elif] = ACTIONS(4055),
    [anon_sym_else] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4055),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [3468] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_fi] = ACTIONS(4069),
    [anon_sym_elif] = ACTIONS(4069),
    [anon_sym_else] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4069),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [3469] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(8608),
    [sym_comment] = ACTIONS(57),
  },
  [3470] = {
    [anon_sym_RBRACE] = ACTIONS(8608),
    [sym_comment] = ACTIONS(57),
  },
  [3471] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(8610),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3472] = {
    [sym_concatenation] = STATE(3821),
    [sym_string] = STATE(3820),
    [sym_simple_expansion] = STATE(3820),
    [sym_string_expansion] = STATE(3820),
    [sym_expansion] = STATE(3820),
    [sym_command_substitution] = STATE(3820),
    [sym_process_substitution] = STATE(3820),
    [aux_sym__literal_repeat1] = STATE(3822),
    [anon_sym_RBRACE] = ACTIONS(8608),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(8612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8612),
  },
  [3473] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_fi] = ACTIONS(4105),
    [anon_sym_elif] = ACTIONS(4105),
    [anon_sym_else] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4105),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [3474] = {
    [sym_concatenation] = STATE(3825),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3825),
    [sym_regex] = ACTIONS(8614),
    [anon_sym_RBRACE] = ACTIONS(8616),
    [anon_sym_EQ] = ACTIONS(8618),
    [anon_sym_DASH] = ACTIONS(8618),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8620),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8618),
    [anon_sym_COLON_QMARK] = ACTIONS(8618),
    [anon_sym_COLON_DASH] = ACTIONS(8618),
    [anon_sym_PERCENT] = ACTIONS(8618),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3475] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8616),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3476] = {
    [sym_concatenation] = STATE(3827),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3827),
    [sym_regex] = ACTIONS(8622),
    [anon_sym_RBRACE] = ACTIONS(8608),
    [anon_sym_EQ] = ACTIONS(8624),
    [anon_sym_DASH] = ACTIONS(8624),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8626),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8624),
    [anon_sym_COLON_QMARK] = ACTIONS(8624),
    [anon_sym_COLON_DASH] = ACTIONS(8624),
    [anon_sym_PERCENT] = ACTIONS(8624),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3477] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8608),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3478] = {
    [sym_concatenation] = STATE(3829),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3829),
    [anon_sym_RBRACE] = ACTIONS(8628),
    [anon_sym_EQ] = ACTIONS(8630),
    [anon_sym_DASH] = ACTIONS(8630),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8630),
    [anon_sym_COLON_QMARK] = ACTIONS(8630),
    [anon_sym_COLON_DASH] = ACTIONS(8630),
    [anon_sym_PERCENT] = ACTIONS(8630),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3479] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_fi] = ACTIONS(4161),
    [anon_sym_elif] = ACTIONS(4161),
    [anon_sym_else] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4161),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [3480] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8628),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3481] = {
    [sym_concatenation] = STATE(3827),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3827),
    [anon_sym_RBRACE] = ACTIONS(8608),
    [anon_sym_EQ] = ACTIONS(8624),
    [anon_sym_DASH] = ACTIONS(8624),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8626),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8624),
    [anon_sym_COLON_QMARK] = ACTIONS(8624),
    [anon_sym_COLON_DASH] = ACTIONS(8624),
    [anon_sym_PERCENT] = ACTIONS(8624),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3482] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_fi] = ACTIONS(5566),
    [anon_sym_elif] = ACTIONS(5566),
    [anon_sym_else] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5566),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [3483] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_fi] = ACTIONS(5600),
    [anon_sym_elif] = ACTIONS(5600),
    [anon_sym_else] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_EQ_TILDE] = ACTIONS(5600),
    [anon_sym_EQ_EQ] = ACTIONS(5600),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [3484] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(8634),
    [sym_comment] = ACTIONS(57),
  },
  [3485] = {
    [anon_sym_RBRACE] = ACTIONS(8634),
    [sym_comment] = ACTIONS(57),
  },
  [3486] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(8636),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3487] = {
    [sym_concatenation] = STATE(3833),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3833),
    [anon_sym_RBRACE] = ACTIONS(8638),
    [anon_sym_EQ] = ACTIONS(8640),
    [anon_sym_DASH] = ACTIONS(8640),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8640),
    [anon_sym_COLON_QMARK] = ACTIONS(8640),
    [anon_sym_COLON_DASH] = ACTIONS(8640),
    [anon_sym_PERCENT] = ACTIONS(8640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3488] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_fi] = ACTIONS(5617),
    [anon_sym_elif] = ACTIONS(5617),
    [anon_sym_else] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_EQ_TILDE] = ACTIONS(5617),
    [anon_sym_EQ_EQ] = ACTIONS(5617),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [3489] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8638),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3490] = {
    [sym_concatenation] = STATE(3834),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3834),
    [anon_sym_RBRACE] = ACTIONS(8634),
    [anon_sym_EQ] = ACTIONS(8644),
    [anon_sym_DASH] = ACTIONS(8644),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8646),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8644),
    [anon_sym_COLON_QMARK] = ACTIONS(8644),
    [anon_sym_COLON_DASH] = ACTIONS(8644),
    [anon_sym_PERCENT] = ACTIONS(8644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3491] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8634),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3492] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_fi] = ACTIONS(5660),
    [anon_sym_elif] = ACTIONS(5660),
    [anon_sym_else] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_EQ_TILDE] = ACTIONS(5660),
    [anon_sym_EQ_EQ] = ACTIONS(5660),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [3493] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8648),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3494] = {
    [aux_sym_concatenation_repeat1] = STATE(3494),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(8371),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_fi] = ACTIONS(2344),
    [anon_sym_elif] = ACTIONS(2344),
    [anon_sym_else] = ACTIONS(2344),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [3495] = {
    [sym_concatenation] = STATE(3836),
    [sym_string] = STATE(3841),
    [sym_array] = STATE(3836),
    [sym_simple_expansion] = STATE(3841),
    [sym_string_expansion] = STATE(3841),
    [sym_expansion] = STATE(3841),
    [sym_command_substitution] = STATE(3841),
    [sym_process_substitution] = STATE(3841),
    [aux_sym__literal_repeat1] = STATE(3846),
    [sym__empty_value] = ACTIONS(8650),
    [anon_sym_LPAREN] = ACTIONS(8652),
    [sym__special_character] = ACTIONS(8654),
    [anon_sym_DQUOTE] = ACTIONS(8656),
    [anon_sym_DOLLAR] = ACTIONS(8658),
    [sym_raw_string] = ACTIONS(8660),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8664),
    [anon_sym_BQUOTE] = ACTIONS(8666),
    [anon_sym_LT_LPAREN] = ACTIONS(8668),
    [anon_sym_GT_LPAREN] = ACTIONS(8668),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8660),
  },
  [3496] = {
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_EQ] = ACTIONS(8670),
    [anon_sym_PLUS_EQ] = ACTIONS(8670),
    [sym_comment] = ACTIONS(57),
  },
  [3497] = {
    [aux_sym_concatenation_repeat1] = STATE(3849),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(8672),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_esac] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [3498] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(3852),
    [anon_sym_DQUOTE] = ACTIONS(8674),
    [anon_sym_DOLLAR] = ACTIONS(8676),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [3499] = {
    [sym_string] = STATE(3854),
    [anon_sym_DASH] = ACTIONS(8678),
    [anon_sym_DQUOTE] = ACTIONS(7895),
    [anon_sym_DOLLAR] = ACTIONS(8678),
    [sym_raw_string] = ACTIONS(8680),
    [anon_sym_POUND] = ACTIONS(8678),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8682),
    [anon_sym_STAR] = ACTIONS(8684),
    [anon_sym_AT] = ACTIONS(8684),
    [anon_sym_QMARK] = ACTIONS(8684),
    [anon_sym_0] = ACTIONS(8682),
    [anon_sym__] = ACTIONS(8682),
  },
  [3500] = {
    [aux_sym_concatenation_repeat1] = STATE(3849),
    [sym__simple_heredoc_body] = ACTIONS(957),
    [sym__heredoc_body_beginning] = ACTIONS(957),
    [sym_file_descriptor] = ACTIONS(957),
    [sym__concat] = ACTIONS(8672),
    [sym_variable_name] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_esac] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_SEMI_SEMI] = ACTIONS(957),
    [anon_sym_PIPE_AMP] = ACTIONS(957),
    [anon_sym_AMP_AMP] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_AMP_GT] = ACTIONS(959),
    [anon_sym_AMP_GT_GT] = ACTIONS(957),
    [anon_sym_LT_AMP] = ACTIONS(957),
    [anon_sym_GT_AMP] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_LT_LT_DASH] = ACTIONS(957),
    [anon_sym_LT_LT_LT] = ACTIONS(957),
    [sym__special_character] = ACTIONS(957),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_DOLLAR] = ACTIONS(959),
    [sym_raw_string] = ACTIONS(957),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(957),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(957),
    [anon_sym_BQUOTE] = ACTIONS(957),
    [anon_sym_LT_LPAREN] = ACTIONS(957),
    [anon_sym_GT_LPAREN] = ACTIONS(957),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(959),
    [sym_word] = ACTIONS(959),
    [anon_sym_LF] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
  },
  [3501] = {
    [sym_subscript] = STATE(3859),
    [sym_variable_name] = ACTIONS(8686),
    [anon_sym_BANG] = ACTIONS(8688),
    [anon_sym_DASH] = ACTIONS(8690),
    [anon_sym_DOLLAR] = ACTIONS(8690),
    [anon_sym_POUND] = ACTIONS(8688),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8692),
    [anon_sym_STAR] = ACTIONS(8694),
    [anon_sym_AT] = ACTIONS(8694),
    [anon_sym_QMARK] = ACTIONS(8694),
    [anon_sym_0] = ACTIONS(8692),
    [anon_sym__] = ACTIONS(8692),
  },
  [3502] = {
    [sym__statements] = STATE(3860),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(3861),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [3503] = {
    [sym__statements] = STATE(3862),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [3504] = {
    [sym__statements] = STATE(3863),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [3505] = {
    [anon_sym_EQ] = ACTIONS(8670),
    [anon_sym_PLUS_EQ] = ACTIONS(8670),
    [sym_comment] = ACTIONS(57),
  },
  [3506] = {
    [sym_variable_assignment] = STATE(3864),
    [sym_subscript] = STATE(3505),
    [sym_concatenation] = STATE(3864),
    [sym_string] = STATE(3500),
    [sym_simple_expansion] = STATE(3500),
    [sym_string_expansion] = STATE(3500),
    [sym_expansion] = STATE(3500),
    [sym_command_substitution] = STATE(3500),
    [sym_process_substitution] = STATE(3500),
    [aux_sym_declaration_command_repeat1] = STATE(3864),
    [aux_sym__literal_repeat1] = STATE(3507),
    [sym__simple_heredoc_body] = ACTIONS(971),
    [sym__heredoc_body_beginning] = ACTIONS(971),
    [sym_file_descriptor] = ACTIONS(971),
    [sym_variable_name] = ACTIONS(7891),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_esac] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(973),
    [anon_sym_SEMI_SEMI] = ACTIONS(971),
    [anon_sym_PIPE_AMP] = ACTIONS(971),
    [anon_sym_AMP_AMP] = ACTIONS(971),
    [anon_sym_PIPE_PIPE] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [anon_sym_GT] = ACTIONS(973),
    [anon_sym_GT_GT] = ACTIONS(971),
    [anon_sym_AMP_GT] = ACTIONS(973),
    [anon_sym_AMP_GT_GT] = ACTIONS(971),
    [anon_sym_LT_AMP] = ACTIONS(971),
    [anon_sym_GT_AMP] = ACTIONS(971),
    [anon_sym_LT_LT] = ACTIONS(973),
    [anon_sym_LT_LT_DASH] = ACTIONS(971),
    [anon_sym_LT_LT_LT] = ACTIONS(971),
    [sym__special_character] = ACTIONS(7893),
    [anon_sym_DQUOTE] = ACTIONS(7895),
    [anon_sym_DOLLAR] = ACTIONS(7897),
    [sym_raw_string] = ACTIONS(7899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7903),
    [anon_sym_BQUOTE] = ACTIONS(7905),
    [anon_sym_LT_LPAREN] = ACTIONS(7907),
    [anon_sym_GT_LPAREN] = ACTIONS(7907),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8696),
    [sym_word] = ACTIONS(7911),
    [anon_sym_LF] = ACTIONS(971),
    [anon_sym_AMP] = ACTIONS(973),
  },
  [3507] = {
    [aux_sym__literal_repeat1] = STATE(3866),
    [sym__simple_heredoc_body] = ACTIONS(977),
    [sym__heredoc_body_beginning] = ACTIONS(977),
    [sym_file_descriptor] = ACTIONS(977),
    [sym_variable_name] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(979),
    [anon_sym_esac] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_SEMI_SEMI] = ACTIONS(977),
    [anon_sym_PIPE_AMP] = ACTIONS(977),
    [anon_sym_AMP_AMP] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_AMP_GT] = ACTIONS(979),
    [anon_sym_AMP_GT_GT] = ACTIONS(977),
    [anon_sym_LT_AMP] = ACTIONS(977),
    [anon_sym_GT_AMP] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(979),
    [anon_sym_LT_LT_DASH] = ACTIONS(977),
    [anon_sym_LT_LT_LT] = ACTIONS(977),
    [sym__special_character] = ACTIONS(8698),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_DOLLAR] = ACTIONS(979),
    [sym_raw_string] = ACTIONS(977),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(977),
    [anon_sym_BQUOTE] = ACTIONS(977),
    [anon_sym_LT_LPAREN] = ACTIONS(977),
    [anon_sym_GT_LPAREN] = ACTIONS(977),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(979),
    [sym_word] = ACTIONS(979),
    [anon_sym_LF] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
  },
  [3508] = {
    [aux_sym_concatenation_repeat1] = STATE(3868),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(8700),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_esac] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [3509] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(3871),
    [anon_sym_DQUOTE] = ACTIONS(8702),
    [anon_sym_DOLLAR] = ACTIONS(8704),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [3510] = {
    [sym_string] = STATE(3873),
    [anon_sym_DASH] = ACTIONS(8706),
    [anon_sym_DQUOTE] = ACTIONS(7915),
    [anon_sym_DOLLAR] = ACTIONS(8706),
    [sym_raw_string] = ACTIONS(8708),
    [anon_sym_POUND] = ACTIONS(8706),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8710),
    [anon_sym_STAR] = ACTIONS(8712),
    [anon_sym_AT] = ACTIONS(8712),
    [anon_sym_QMARK] = ACTIONS(8712),
    [anon_sym_0] = ACTIONS(8710),
    [anon_sym__] = ACTIONS(8710),
  },
  [3511] = {
    [aux_sym_concatenation_repeat1] = STATE(3868),
    [sym__simple_heredoc_body] = ACTIONS(997),
    [sym__heredoc_body_beginning] = ACTIONS(997),
    [sym_file_descriptor] = ACTIONS(997),
    [sym__concat] = ACTIONS(8700),
    [anon_sym_SEMI] = ACTIONS(999),
    [anon_sym_esac] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI_SEMI] = ACTIONS(997),
    [anon_sym_PIPE_AMP] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_AMP_GT] = ACTIONS(999),
    [anon_sym_AMP_GT_GT] = ACTIONS(997),
    [anon_sym_LT_AMP] = ACTIONS(997),
    [anon_sym_GT_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_LT_LT_DASH] = ACTIONS(997),
    [anon_sym_LT_LT_LT] = ACTIONS(997),
    [sym__special_character] = ACTIONS(997),
    [anon_sym_DQUOTE] = ACTIONS(997),
    [anon_sym_DOLLAR] = ACTIONS(999),
    [sym_raw_string] = ACTIONS(997),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(997),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(997),
    [anon_sym_BQUOTE] = ACTIONS(997),
    [anon_sym_LT_LPAREN] = ACTIONS(997),
    [anon_sym_GT_LPAREN] = ACTIONS(997),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(999),
    [sym_word] = ACTIONS(999),
    [anon_sym_LF] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
  },
  [3512] = {
    [sym_subscript] = STATE(3878),
    [sym_variable_name] = ACTIONS(8714),
    [anon_sym_BANG] = ACTIONS(8716),
    [anon_sym_DASH] = ACTIONS(8718),
    [anon_sym_DOLLAR] = ACTIONS(8718),
    [anon_sym_POUND] = ACTIONS(8716),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8720),
    [anon_sym_STAR] = ACTIONS(8722),
    [anon_sym_AT] = ACTIONS(8722),
    [anon_sym_QMARK] = ACTIONS(8722),
    [anon_sym_0] = ACTIONS(8720),
    [anon_sym__] = ACTIONS(8720),
  },
  [3513] = {
    [sym__statements] = STATE(3879),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(3880),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [3514] = {
    [sym__statements] = STATE(3881),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [3515] = {
    [sym__statements] = STATE(3882),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [3516] = {
    [sym_concatenation] = STATE(3883),
    [sym_string] = STATE(3511),
    [sym_simple_expansion] = STATE(3511),
    [sym_string_expansion] = STATE(3511),
    [sym_expansion] = STATE(3511),
    [sym_command_substitution] = STATE(3511),
    [sym_process_substitution] = STATE(3511),
    [aux_sym_unset_command_repeat1] = STATE(3883),
    [aux_sym__literal_repeat1] = STATE(3517),
    [sym__simple_heredoc_body] = ACTIONS(1011),
    [sym__heredoc_body_beginning] = ACTIONS(1011),
    [sym_file_descriptor] = ACTIONS(1011),
    [anon_sym_SEMI] = ACTIONS(1013),
    [anon_sym_esac] = ACTIONS(1013),
    [anon_sym_PIPE] = ACTIONS(1013),
    [anon_sym_SEMI_SEMI] = ACTIONS(1011),
    [anon_sym_PIPE_AMP] = ACTIONS(1011),
    [anon_sym_AMP_AMP] = ACTIONS(1011),
    [anon_sym_PIPE_PIPE] = ACTIONS(1011),
    [anon_sym_LT] = ACTIONS(1013),
    [anon_sym_GT] = ACTIONS(1013),
    [anon_sym_GT_GT] = ACTIONS(1011),
    [anon_sym_AMP_GT] = ACTIONS(1013),
    [anon_sym_AMP_GT_GT] = ACTIONS(1011),
    [anon_sym_LT_AMP] = ACTIONS(1011),
    [anon_sym_GT_AMP] = ACTIONS(1011),
    [anon_sym_LT_LT] = ACTIONS(1013),
    [anon_sym_LT_LT_DASH] = ACTIONS(1011),
    [anon_sym_LT_LT_LT] = ACTIONS(1011),
    [sym__special_character] = ACTIONS(7913),
    [anon_sym_DQUOTE] = ACTIONS(7915),
    [anon_sym_DOLLAR] = ACTIONS(7917),
    [sym_raw_string] = ACTIONS(7919),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7921),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7923),
    [anon_sym_BQUOTE] = ACTIONS(7925),
    [anon_sym_LT_LPAREN] = ACTIONS(7927),
    [anon_sym_GT_LPAREN] = ACTIONS(7927),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8724),
    [sym_word] = ACTIONS(7931),
    [anon_sym_LF] = ACTIONS(1011),
    [anon_sym_AMP] = ACTIONS(1013),
  },
  [3517] = {
    [aux_sym__literal_repeat1] = STATE(3885),
    [sym__simple_heredoc_body] = ACTIONS(1017),
    [sym__heredoc_body_beginning] = ACTIONS(1017),
    [sym_file_descriptor] = ACTIONS(1017),
    [anon_sym_SEMI] = ACTIONS(1019),
    [anon_sym_esac] = ACTIONS(1019),
    [anon_sym_PIPE] = ACTIONS(1019),
    [anon_sym_SEMI_SEMI] = ACTIONS(1017),
    [anon_sym_PIPE_AMP] = ACTIONS(1017),
    [anon_sym_AMP_AMP] = ACTIONS(1017),
    [anon_sym_PIPE_PIPE] = ACTIONS(1017),
    [anon_sym_LT] = ACTIONS(1019),
    [anon_sym_GT] = ACTIONS(1019),
    [anon_sym_GT_GT] = ACTIONS(1017),
    [anon_sym_AMP_GT] = ACTIONS(1019),
    [anon_sym_AMP_GT_GT] = ACTIONS(1017),
    [anon_sym_LT_AMP] = ACTIONS(1017),
    [anon_sym_GT_AMP] = ACTIONS(1017),
    [anon_sym_LT_LT] = ACTIONS(1019),
    [anon_sym_LT_LT_DASH] = ACTIONS(1017),
    [anon_sym_LT_LT_LT] = ACTIONS(1017),
    [sym__special_character] = ACTIONS(8726),
    [anon_sym_DQUOTE] = ACTIONS(1017),
    [anon_sym_DOLLAR] = ACTIONS(1019),
    [sym_raw_string] = ACTIONS(1017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1017),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1017),
    [anon_sym_BQUOTE] = ACTIONS(1017),
    [anon_sym_LT_LPAREN] = ACTIONS(1017),
    [anon_sym_GT_LPAREN] = ACTIONS(1017),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1019),
    [sym_word] = ACTIONS(1019),
    [anon_sym_LF] = ACTIONS(1017),
    [anon_sym_AMP] = ACTIONS(1019),
  },
  [3518] = {
    [sym_string] = STATE(3886),
    [sym_simple_expansion] = STATE(3886),
    [sym_string_expansion] = STATE(3886),
    [sym_expansion] = STATE(3886),
    [sym_command_substitution] = STATE(3886),
    [sym_process_substitution] = STATE(3886),
    [sym__special_character] = ACTIONS(8728),
    [anon_sym_DQUOTE] = ACTIONS(6718),
    [anon_sym_DOLLAR] = ACTIONS(6720),
    [sym_raw_string] = ACTIONS(8728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6726),
    [anon_sym_BQUOTE] = ACTIONS(6728),
    [anon_sym_LT_LPAREN] = ACTIONS(6730),
    [anon_sym_GT_LPAREN] = ACTIONS(6730),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8728),
  },
  [3519] = {
    [aux_sym_concatenation_repeat1] = STATE(3887),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(7933),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_esac] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_EQ_TILDE] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [3520] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_esac] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_EQ_TILDE] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [3521] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(8730),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [3522] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(8730),
    [anon_sym_DOLLAR] = ACTIONS(8732),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [3523] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_esac] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_EQ_TILDE] = ACTIONS(1099),
    [anon_sym_EQ_EQ] = ACTIONS(1099),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [3524] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_esac] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_EQ_TILDE] = ACTIONS(1103),
    [anon_sym_EQ_EQ] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [3525] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_esac] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_EQ_TILDE] = ACTIONS(1107),
    [anon_sym_EQ_EQ] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [3526] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(8734),
    [sym_comment] = ACTIONS(57),
  },
  [3527] = {
    [sym_subscript] = STATE(3893),
    [sym_variable_name] = ACTIONS(8736),
    [anon_sym_DASH] = ACTIONS(8738),
    [anon_sym_DOLLAR] = ACTIONS(8738),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8740),
    [anon_sym_STAR] = ACTIONS(8742),
    [anon_sym_AT] = ACTIONS(8742),
    [anon_sym_QMARK] = ACTIONS(8742),
    [anon_sym_0] = ACTIONS(8740),
    [anon_sym__] = ACTIONS(8740),
  },
  [3528] = {
    [sym_concatenation] = STATE(3896),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3896),
    [anon_sym_RBRACE] = ACTIONS(8744),
    [anon_sym_EQ] = ACTIONS(8746),
    [anon_sym_DASH] = ACTIONS(8746),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8748),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(8750),
    [anon_sym_COLON] = ACTIONS(8746),
    [anon_sym_COLON_QMARK] = ACTIONS(8746),
    [anon_sym_COLON_DASH] = ACTIONS(8746),
    [anon_sym_PERCENT] = ACTIONS(8746),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3529] = {
    [sym_concatenation] = STATE(3899),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3899),
    [anon_sym_RBRACE] = ACTIONS(8752),
    [anon_sym_EQ] = ACTIONS(8754),
    [anon_sym_DASH] = ACTIONS(8754),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8756),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(8758),
    [anon_sym_COLON] = ACTIONS(8754),
    [anon_sym_COLON_QMARK] = ACTIONS(8754),
    [anon_sym_COLON_DASH] = ACTIONS(8754),
    [anon_sym_PERCENT] = ACTIONS(8754),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3530] = {
    [anon_sym_RPAREN] = ACTIONS(8760),
    [sym_comment] = ACTIONS(57),
  },
  [3531] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(8760),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [3532] = {
    [anon_sym_BQUOTE] = ACTIONS(8760),
    [sym_comment] = ACTIONS(57),
  },
  [3533] = {
    [anon_sym_RPAREN] = ACTIONS(8762),
    [sym_comment] = ACTIONS(57),
  },
  [3534] = {
    [anon_sym_esac] = ACTIONS(8764),
    [sym__special_character] = ACTIONS(8766),
    [anon_sym_DQUOTE] = ACTIONS(8766),
    [anon_sym_DOLLAR] = ACTIONS(8768),
    [sym_raw_string] = ACTIONS(8766),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8766),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8766),
    [anon_sym_BQUOTE] = ACTIONS(8766),
    [anon_sym_LT_LPAREN] = ACTIONS(8766),
    [anon_sym_GT_LPAREN] = ACTIONS(8766),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8768),
  },
  [3535] = {
    [anon_sym_LT] = ACTIONS(8770),
    [anon_sym_GT] = ACTIONS(8770),
    [anon_sym_GT_GT] = ACTIONS(8772),
    [anon_sym_AMP_GT] = ACTIONS(8770),
    [anon_sym_AMP_GT_GT] = ACTIONS(8772),
    [anon_sym_LT_AMP] = ACTIONS(8772),
    [anon_sym_GT_AMP] = ACTIONS(8772),
    [sym_comment] = ACTIONS(57),
  },
  [3536] = {
    [sym_file_descriptor] = ACTIONS(1235),
    [sym_variable_name] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1239),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1239),
    [anon_sym_if] = ACTIONS(1239),
    [anon_sym_case] = ACTIONS(1239),
    [anon_sym_esac] = ACTIONS(4910),
    [anon_sym_SEMI_SEMI] = ACTIONS(1237),
    [anon_sym_function] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1239),
    [anon_sym_typeset] = ACTIONS(1239),
    [anon_sym_export] = ACTIONS(1239),
    [anon_sym_readonly] = ACTIONS(1239),
    [anon_sym_local] = ACTIONS(1239),
    [anon_sym_unset] = ACTIONS(1239),
    [anon_sym_unsetenv] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_AMP_GT] = ACTIONS(1239),
    [anon_sym_AMP_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_AMP] = ACTIONS(1235),
    [anon_sym_GT_AMP] = ACTIONS(1235),
    [sym__special_character] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_DOLLAR] = ACTIONS(1239),
    [sym_raw_string] = ACTIONS(1235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1235),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1235),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [anon_sym_LT_LPAREN] = ACTIONS(1235),
    [anon_sym_GT_LPAREN] = ACTIONS(1235),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1239),
  },
  [3537] = {
    [sym_redirected_statement] = STATE(3903),
    [sym_for_statement] = STATE(3903),
    [sym_c_style_for_statement] = STATE(3903),
    [sym_while_statement] = STATE(3903),
    [sym_if_statement] = STATE(3903),
    [sym_case_statement] = STATE(3903),
    [sym_function_definition] = STATE(3903),
    [sym_compound_statement] = STATE(3903),
    [sym_subshell] = STATE(3903),
    [sym_pipeline] = STATE(3903),
    [sym_list] = STATE(3903),
    [sym_negated_command] = STATE(3903),
    [sym_test_command] = STATE(3903),
    [sym_declaration_command] = STATE(3903),
    [sym_unset_command] = STATE(3903),
    [sym_command] = STATE(3903),
    [sym_command_name] = STATE(3039),
    [sym_variable_assignment] = STATE(3904),
    [sym_subscript] = STATE(3041),
    [sym_file_redirect] = STATE(3044),
    [sym_concatenation] = STATE(3042),
    [sym_string] = STATE(3031),
    [sym_simple_expansion] = STATE(3031),
    [sym_string_expansion] = STATE(3031),
    [sym_expansion] = STATE(3031),
    [sym_command_substitution] = STATE(3031),
    [sym_process_substitution] = STATE(3031),
    [aux_sym_command_repeat1] = STATE(3044),
    [aux_sym__literal_repeat1] = STATE(3045),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(6704),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(6710),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(6712),
    [anon_sym_typeset] = ACTIONS(6712),
    [anon_sym_export] = ACTIONS(6712),
    [anon_sym_readonly] = ACTIONS(6712),
    [anon_sym_local] = ACTIONS(6712),
    [anon_sym_unset] = ACTIONS(6714),
    [anon_sym_unsetenv] = ACTIONS(6714),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(6716),
    [anon_sym_DQUOTE] = ACTIONS(6718),
    [anon_sym_DOLLAR] = ACTIONS(6720),
    [sym_raw_string] = ACTIONS(6722),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6726),
    [anon_sym_BQUOTE] = ACTIONS(6728),
    [anon_sym_LT_LPAREN] = ACTIONS(6730),
    [anon_sym_GT_LPAREN] = ACTIONS(6730),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6732),
  },
  [3538] = {
    [sym_redirected_statement] = STATE(3905),
    [sym_for_statement] = STATE(3905),
    [sym_c_style_for_statement] = STATE(3905),
    [sym_while_statement] = STATE(3905),
    [sym_if_statement] = STATE(3905),
    [sym_case_statement] = STATE(3905),
    [sym_function_definition] = STATE(3905),
    [sym_compound_statement] = STATE(3905),
    [sym_subshell] = STATE(3905),
    [sym_pipeline] = STATE(3905),
    [sym_list] = STATE(3905),
    [sym_negated_command] = STATE(3905),
    [sym_test_command] = STATE(3905),
    [sym_declaration_command] = STATE(3905),
    [sym_unset_command] = STATE(3905),
    [sym_command] = STATE(3905),
    [sym_command_name] = STATE(3039),
    [sym_variable_assignment] = STATE(3906),
    [sym_subscript] = STATE(3041),
    [sym_file_redirect] = STATE(3044),
    [sym_concatenation] = STATE(3042),
    [sym_string] = STATE(3031),
    [sym_simple_expansion] = STATE(3031),
    [sym_string_expansion] = STATE(3031),
    [sym_expansion] = STATE(3031),
    [sym_command_substitution] = STATE(3031),
    [sym_process_substitution] = STATE(3031),
    [aux_sym_command_repeat1] = STATE(3044),
    [aux_sym__literal_repeat1] = STATE(3045),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(6704),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(6710),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(6712),
    [anon_sym_typeset] = ACTIONS(6712),
    [anon_sym_export] = ACTIONS(6712),
    [anon_sym_readonly] = ACTIONS(6712),
    [anon_sym_local] = ACTIONS(6712),
    [anon_sym_unset] = ACTIONS(6714),
    [anon_sym_unsetenv] = ACTIONS(6714),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(6716),
    [anon_sym_DQUOTE] = ACTIONS(6718),
    [anon_sym_DOLLAR] = ACTIONS(6720),
    [sym_raw_string] = ACTIONS(6722),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6726),
    [anon_sym_BQUOTE] = ACTIONS(6728),
    [anon_sym_LT_LPAREN] = ACTIONS(6730),
    [anon_sym_GT_LPAREN] = ACTIONS(6730),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(6732),
  },
  [3539] = {
    [sym_concatenation] = STATE(695),
    [sym_string] = STATE(3908),
    [sym_simple_expansion] = STATE(3908),
    [sym_string_expansion] = STATE(3908),
    [sym_expansion] = STATE(3908),
    [sym_command_substitution] = STATE(3908),
    [sym_process_substitution] = STATE(3908),
    [aux_sym__literal_repeat1] = STATE(3909),
    [sym__special_character] = ACTIONS(8774),
    [anon_sym_DQUOTE] = ACTIONS(4914),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(8776),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4922),
    [anon_sym_BQUOTE] = ACTIONS(4924),
    [anon_sym_LT_LPAREN] = ACTIONS(4926),
    [anon_sym_GT_LPAREN] = ACTIONS(4926),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8776),
  },
  [3540] = {
    [sym_concatenation] = STATE(699),
    [sym_string] = STATE(3910),
    [sym_simple_expansion] = STATE(3910),
    [sym_string_expansion] = STATE(3910),
    [sym_expansion] = STATE(3910),
    [sym_command_substitution] = STATE(3910),
    [sym_process_substitution] = STATE(3910),
    [aux_sym__literal_repeat1] = STATE(3911),
    [sym__special_character] = ACTIONS(8774),
    [anon_sym_DQUOTE] = ACTIONS(4914),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(8778),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4922),
    [anon_sym_BQUOTE] = ACTIONS(4924),
    [anon_sym_LT_LPAREN] = ACTIONS(4926),
    [anon_sym_GT_LPAREN] = ACTIONS(4926),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8778),
  },
  [3541] = {
    [anon_sym_SEMI] = ACTIONS(8780),
    [anon_sym_esac] = ACTIONS(1237),
    [anon_sym_SEMI_SEMI] = ACTIONS(1237),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8782),
    [anon_sym_AMP] = ACTIONS(8782),
  },
  [3542] = {
    [sym_file_redirect] = STATE(3913),
    [sym_heredoc_redirect] = STATE(3913),
    [sym_herestring_redirect] = STATE(3913),
    [aux_sym_redirected_statement_repeat1] = STATE(3913),
    [sym__simple_heredoc_body] = ACTIONS(1253),
    [sym__heredoc_body_beginning] = ACTIONS(1253),
    [sym_file_descriptor] = ACTIONS(7961),
    [anon_sym_SEMI] = ACTIONS(1255),
    [anon_sym_esac] = ACTIONS(1253),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_SEMI_SEMI] = ACTIONS(1253),
    [anon_sym_PIPE_AMP] = ACTIONS(1253),
    [anon_sym_AMP_AMP] = ACTIONS(1253),
    [anon_sym_PIPE_PIPE] = ACTIONS(1253),
    [anon_sym_LT] = ACTIONS(7971),
    [anon_sym_GT] = ACTIONS(7971),
    [anon_sym_GT_GT] = ACTIONS(7973),
    [anon_sym_AMP_GT] = ACTIONS(7971),
    [anon_sym_AMP_GT_GT] = ACTIONS(7973),
    [anon_sym_LT_AMP] = ACTIONS(7973),
    [anon_sym_GT_AMP] = ACTIONS(7973),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(7975),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1255),
  },
  [3543] = {
    [sym_concatenation] = STATE(3914),
    [sym_string] = STATE(3915),
    [sym_simple_expansion] = STATE(3915),
    [sym_string_expansion] = STATE(3915),
    [sym_expansion] = STATE(3915),
    [sym_command_substitution] = STATE(3915),
    [sym_process_substitution] = STATE(3915),
    [aux_sym__literal_repeat1] = STATE(3916),
    [sym_regex] = ACTIONS(8784),
    [sym__special_character] = ACTIONS(7981),
    [anon_sym_DQUOTE] = ACTIONS(6718),
    [anon_sym_DOLLAR] = ACTIONS(6720),
    [sym_raw_string] = ACTIONS(8786),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6726),
    [anon_sym_BQUOTE] = ACTIONS(6728),
    [anon_sym_LT_LPAREN] = ACTIONS(6730),
    [anon_sym_GT_LPAREN] = ACTIONS(6730),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8786),
  },
  [3544] = {
    [aux_sym_concatenation_repeat1] = STATE(3519),
    [sym__simple_heredoc_body] = ACTIONS(1261),
    [sym__heredoc_body_beginning] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1261),
    [sym__concat] = ACTIONS(7933),
    [anon_sym_SEMI] = ACTIONS(1263),
    [anon_sym_esac] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_EQ_EQ] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1263),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [sym__special_character] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1263),
  },
  [3545] = {
    [sym_concatenation] = STATE(3917),
    [sym_string] = STATE(3544),
    [sym_simple_expansion] = STATE(3544),
    [sym_string_expansion] = STATE(3544),
    [sym_expansion] = STATE(3544),
    [sym_command_substitution] = STATE(3544),
    [sym_process_substitution] = STATE(3544),
    [aux_sym_command_repeat2] = STATE(3917),
    [aux_sym__literal_repeat1] = STATE(3546),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_esac] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(7979),
    [anon_sym_EQ_EQ] = ACTIONS(7979),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(7981),
    [anon_sym_DQUOTE] = ACTIONS(6718),
    [anon_sym_DOLLAR] = ACTIONS(6720),
    [sym_raw_string] = ACTIONS(7983),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6726),
    [anon_sym_BQUOTE] = ACTIONS(6728),
    [anon_sym_LT_LPAREN] = ACTIONS(6730),
    [anon_sym_GT_LPAREN] = ACTIONS(6730),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7985),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [3546] = {
    [aux_sym__literal_repeat1] = STATE(3551),
    [sym__simple_heredoc_body] = ACTIONS(1269),
    [sym__heredoc_body_beginning] = ACTIONS(1269),
    [sym_file_descriptor] = ACTIONS(1269),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_esac] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1269),
    [anon_sym_PIPE_AMP] = ACTIONS(1269),
    [anon_sym_AMP_AMP] = ACTIONS(1269),
    [anon_sym_PIPE_PIPE] = ACTIONS(1269),
    [anon_sym_EQ_TILDE] = ACTIONS(1271),
    [anon_sym_EQ_EQ] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1269),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT_GT] = ACTIONS(1269),
    [anon_sym_LT_AMP] = ACTIONS(1269),
    [anon_sym_GT_AMP] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_LT_LT_DASH] = ACTIONS(1269),
    [anon_sym_LT_LT_LT] = ACTIONS(1269),
    [sym__special_character] = ACTIONS(7987),
    [anon_sym_DQUOTE] = ACTIONS(1269),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1269),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1269),
    [anon_sym_BQUOTE] = ACTIONS(1269),
    [anon_sym_LT_LPAREN] = ACTIONS(1269),
    [anon_sym_GT_LPAREN] = ACTIONS(1269),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1271),
  },
  [3547] = {
    [sym_file_redirect] = STATE(3542),
    [sym_heredoc_redirect] = STATE(3542),
    [sym_heredoc_body] = STATE(3919),
    [sym_herestring_redirect] = STATE(3542),
    [aux_sym_redirected_statement_repeat1] = STATE(3542),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(7961),
    [anon_sym_SEMI] = ACTIONS(8788),
    [anon_sym_esac] = ACTIONS(1237),
    [anon_sym_PIPE] = ACTIONS(7965),
    [anon_sym_SEMI_SEMI] = ACTIONS(1237),
    [anon_sym_PIPE_AMP] = ACTIONS(7967),
    [anon_sym_AMP_AMP] = ACTIONS(7969),
    [anon_sym_PIPE_PIPE] = ACTIONS(7969),
    [anon_sym_LT] = ACTIONS(7971),
    [anon_sym_GT] = ACTIONS(7971),
    [anon_sym_GT_GT] = ACTIONS(7973),
    [anon_sym_AMP_GT] = ACTIONS(7971),
    [anon_sym_AMP_GT_GT] = ACTIONS(7973),
    [anon_sym_LT_AMP] = ACTIONS(7973),
    [anon_sym_GT_AMP] = ACTIONS(7973),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(7975),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8790),
    [anon_sym_AMP] = ACTIONS(8788),
  },
  [3548] = {
    [sym_file_redirect] = STATE(3542),
    [sym_heredoc_redirect] = STATE(3542),
    [sym_heredoc_body] = STATE(3919),
    [sym_herestring_redirect] = STATE(3542),
    [aux_sym_redirected_statement_repeat1] = STATE(3542),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(8788),
    [anon_sym_esac] = ACTIONS(4910),
    [anon_sym_PIPE] = ACTIONS(7965),
    [anon_sym_SEMI_SEMI] = ACTIONS(1237),
    [anon_sym_PIPE_AMP] = ACTIONS(7967),
    [anon_sym_AMP_AMP] = ACTIONS(7969),
    [anon_sym_PIPE_PIPE] = ACTIONS(7969),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(7975),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(8790),
    [anon_sym_AMP] = ACTIONS(8788),
  },
  [3549] = {
    [sym_concatenation] = STATE(3920),
    [sym_string] = STATE(3544),
    [sym_simple_expansion] = STATE(3544),
    [sym_string_expansion] = STATE(3544),
    [sym_expansion] = STATE(3544),
    [sym_command_substitution] = STATE(3544),
    [sym_process_substitution] = STATE(3544),
    [aux_sym_command_repeat2] = STATE(3920),
    [aux_sym__literal_repeat1] = STATE(3546),
    [sym__simple_heredoc_body] = ACTIONS(1265),
    [sym__heredoc_body_beginning] = ACTIONS(1265),
    [sym_file_descriptor] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1267),
    [anon_sym_esac] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_SEMI_SEMI] = ACTIONS(1265),
    [anon_sym_PIPE_AMP] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_EQ_TILDE] = ACTIONS(7979),
    [anon_sym_EQ_EQ] = ACTIONS(7979),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_AMP_GT] = ACTIONS(1267),
    [anon_sym_AMP_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_AMP] = ACTIONS(1265),
    [anon_sym_GT_AMP] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_LT_LT_DASH] = ACTIONS(1265),
    [anon_sym_LT_LT_LT] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(7981),
    [anon_sym_DQUOTE] = ACTIONS(6718),
    [anon_sym_DOLLAR] = ACTIONS(6720),
    [sym_raw_string] = ACTIONS(7983),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6726),
    [anon_sym_BQUOTE] = ACTIONS(6728),
    [anon_sym_LT_LPAREN] = ACTIONS(6730),
    [anon_sym_GT_LPAREN] = ACTIONS(6730),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7985),
    [anon_sym_LF] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
  },
  [3550] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_esac] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_EQ_TILDE] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [3551] = {
    [aux_sym__literal_repeat1] = STATE(3551),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_esac] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_EQ_TILDE] = ACTIONS(1373),
    [anon_sym_EQ_EQ] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(8792),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [3552] = {
    [anon_sym_esac] = ACTIONS(8795),
    [anon_sym_SEMI_SEMI] = ACTIONS(8797),
    [sym_comment] = ACTIONS(57),
  },
  [3553] = {
    [sym__statements] = STATE(3923),
    [sym_redirected_statement] = STATE(3924),
    [sym_for_statement] = STATE(3924),
    [sym_c_style_for_statement] = STATE(3924),
    [sym_while_statement] = STATE(3924),
    [sym_if_statement] = STATE(3924),
    [sym_case_statement] = STATE(3924),
    [sym_function_definition] = STATE(3924),
    [sym_compound_statement] = STATE(3924),
    [sym_subshell] = STATE(3924),
    [sym_pipeline] = STATE(3924),
    [sym_list] = STATE(3924),
    [sym_negated_command] = STATE(3924),
    [sym_test_command] = STATE(3924),
    [sym_declaration_command] = STATE(3924),
    [sym_unset_command] = STATE(3924),
    [sym_command] = STATE(3924),
    [sym_command_name] = STATE(713),
    [sym_variable_assignment] = STATE(3925),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(715),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(3926),
    [aux_sym_command_repeat1] = STATE(715),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_SEMI_SEMI] = ACTIONS(8799),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4323),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4325),
    [anon_sym_typeset] = ACTIONS(4325),
    [anon_sym_export] = ACTIONS(4325),
    [anon_sym_readonly] = ACTIONS(4325),
    [anon_sym_local] = ACTIONS(4325),
    [anon_sym_unset] = ACTIONS(4327),
    [anon_sym_unsetenv] = ACTIONS(4327),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [3554] = {
    [aux_sym_case_item_repeat1] = STATE(3047),
    [anon_sym_PIPE] = ACTIONS(5199),
    [anon_sym_RPAREN] = ACTIONS(8801),
    [sym_comment] = ACTIONS(57),
  },
  [3555] = {
    [sym__statements] = STATE(3929),
    [sym_redirected_statement] = STATE(3924),
    [sym_for_statement] = STATE(3924),
    [sym_c_style_for_statement] = STATE(3924),
    [sym_while_statement] = STATE(3924),
    [sym_if_statement] = STATE(3924),
    [sym_case_statement] = STATE(3924),
    [sym_function_definition] = STATE(3924),
    [sym_compound_statement] = STATE(3924),
    [sym_subshell] = STATE(3924),
    [sym_pipeline] = STATE(3924),
    [sym_list] = STATE(3924),
    [sym_negated_command] = STATE(3924),
    [sym_test_command] = STATE(3924),
    [sym_declaration_command] = STATE(3924),
    [sym_unset_command] = STATE(3924),
    [sym_command] = STATE(3924),
    [sym_command_name] = STATE(713),
    [sym_variable_assignment] = STATE(3925),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(715),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(3926),
    [aux_sym_command_repeat1] = STATE(715),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_SEMI_SEMI] = ACTIONS(8803),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4323),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4325),
    [anon_sym_typeset] = ACTIONS(4325),
    [anon_sym_export] = ACTIONS(4325),
    [anon_sym_readonly] = ACTIONS(4325),
    [anon_sym_local] = ACTIONS(4325),
    [anon_sym_unset] = ACTIONS(4327),
    [anon_sym_unsetenv] = ACTIONS(4327),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [3556] = {
    [aux_sym_case_item_repeat1] = STATE(3047),
    [anon_sym_PIPE] = ACTIONS(5199),
    [anon_sym_RPAREN] = ACTIONS(8805),
    [sym_comment] = ACTIONS(57),
  },
  [3557] = {
    [anon_sym_esac] = ACTIONS(8807),
    [sym__special_character] = ACTIONS(8809),
    [anon_sym_DQUOTE] = ACTIONS(8809),
    [anon_sym_DOLLAR] = ACTIONS(8811),
    [sym_raw_string] = ACTIONS(8809),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8809),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8809),
    [anon_sym_BQUOTE] = ACTIONS(8809),
    [anon_sym_LT_LPAREN] = ACTIONS(8809),
    [anon_sym_GT_LPAREN] = ACTIONS(8809),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8811),
  },
  [3558] = {
    [anon_sym_esac] = ACTIONS(8813),
    [anon_sym_SEMI_SEMI] = ACTIONS(8815),
    [sym_comment] = ACTIONS(57),
  },
  [3559] = {
    [sym__simple_heredoc_body] = ACTIONS(8817),
    [sym__heredoc_body_beginning] = ACTIONS(8817),
    [sym_file_descriptor] = ACTIONS(8817),
    [ts_builtin_sym_end] = ACTIONS(8817),
    [anon_sym_SEMI] = ACTIONS(8819),
    [anon_sym_done] = ACTIONS(8817),
    [anon_sym_fi] = ACTIONS(8817),
    [anon_sym_elif] = ACTIONS(8817),
    [anon_sym_else] = ACTIONS(8817),
    [anon_sym_esac] = ACTIONS(8817),
    [anon_sym_PIPE] = ACTIONS(8819),
    [anon_sym_RPAREN] = ACTIONS(8817),
    [anon_sym_SEMI_SEMI] = ACTIONS(8817),
    [anon_sym_PIPE_AMP] = ACTIONS(8817),
    [anon_sym_AMP_AMP] = ACTIONS(8817),
    [anon_sym_PIPE_PIPE] = ACTIONS(8817),
    [anon_sym_LT] = ACTIONS(8819),
    [anon_sym_GT] = ACTIONS(8819),
    [anon_sym_GT_GT] = ACTIONS(8817),
    [anon_sym_AMP_GT] = ACTIONS(8819),
    [anon_sym_AMP_GT_GT] = ACTIONS(8817),
    [anon_sym_LT_AMP] = ACTIONS(8817),
    [anon_sym_GT_AMP] = ACTIONS(8817),
    [anon_sym_LT_LT] = ACTIONS(8819),
    [anon_sym_LT_LT_DASH] = ACTIONS(8817),
    [anon_sym_LT_LT_LT] = ACTIONS(8817),
    [anon_sym_BQUOTE] = ACTIONS(8817),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8817),
    [anon_sym_AMP] = ACTIONS(8819),
  },
  [3560] = {
    [sym__concat] = ACTIONS(8144),
    [anon_sym_in] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8144),
  },
  [3561] = {
    [sym__concat] = ACTIONS(8148),
    [anon_sym_in] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8148),
  },
  [3562] = {
    [sym__simple_heredoc_body] = ACTIONS(8821),
    [sym__heredoc_body_beginning] = ACTIONS(8821),
    [sym_file_descriptor] = ACTIONS(8821),
    [ts_builtin_sym_end] = ACTIONS(8821),
    [anon_sym_SEMI] = ACTIONS(8823),
    [anon_sym_done] = ACTIONS(8821),
    [anon_sym_fi] = ACTIONS(8821),
    [anon_sym_elif] = ACTIONS(8821),
    [anon_sym_else] = ACTIONS(8821),
    [anon_sym_esac] = ACTIONS(8821),
    [anon_sym_PIPE] = ACTIONS(8823),
    [anon_sym_RPAREN] = ACTIONS(8821),
    [anon_sym_SEMI_SEMI] = ACTIONS(8821),
    [anon_sym_PIPE_AMP] = ACTIONS(8821),
    [anon_sym_AMP_AMP] = ACTIONS(8821),
    [anon_sym_PIPE_PIPE] = ACTIONS(8821),
    [anon_sym_LT] = ACTIONS(8823),
    [anon_sym_GT] = ACTIONS(8823),
    [anon_sym_GT_GT] = ACTIONS(8821),
    [anon_sym_AMP_GT] = ACTIONS(8823),
    [anon_sym_AMP_GT_GT] = ACTIONS(8821),
    [anon_sym_LT_AMP] = ACTIONS(8821),
    [anon_sym_GT_AMP] = ACTIONS(8821),
    [anon_sym_LT_LT] = ACTIONS(8823),
    [anon_sym_LT_LT_DASH] = ACTIONS(8821),
    [anon_sym_LT_LT_LT] = ACTIONS(8821),
    [anon_sym_BQUOTE] = ACTIONS(8821),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8821),
    [anon_sym_AMP] = ACTIONS(8823),
  },
  [3563] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [sym_variable_name] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_RBRACE] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5566),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [3564] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [sym_variable_name] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_RBRACE] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5600),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [3565] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(8825),
    [sym_comment] = ACTIONS(57),
  },
  [3566] = {
    [anon_sym_RBRACE] = ACTIONS(8825),
    [sym_comment] = ACTIONS(57),
  },
  [3567] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(8827),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3568] = {
    [sym_concatenation] = STATE(3935),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3935),
    [anon_sym_RBRACE] = ACTIONS(8829),
    [anon_sym_EQ] = ACTIONS(8831),
    [anon_sym_DASH] = ACTIONS(8831),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8833),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8831),
    [anon_sym_COLON_QMARK] = ACTIONS(8831),
    [anon_sym_COLON_DASH] = ACTIONS(8831),
    [anon_sym_PERCENT] = ACTIONS(8831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3569] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [sym_variable_name] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_RBRACE] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5617),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [3570] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8829),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3571] = {
    [sym_concatenation] = STATE(3936),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3936),
    [anon_sym_RBRACE] = ACTIONS(8825),
    [anon_sym_EQ] = ACTIONS(8835),
    [anon_sym_DASH] = ACTIONS(8835),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8837),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8835),
    [anon_sym_COLON_QMARK] = ACTIONS(8835),
    [anon_sym_COLON_DASH] = ACTIONS(8835),
    [anon_sym_PERCENT] = ACTIONS(8835),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3572] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8825),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3573] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [sym_variable_name] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_RBRACE] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5660),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [3574] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8839),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3575] = {
    [sym__simple_heredoc_body] = ACTIONS(7154),
    [sym__heredoc_body_beginning] = ACTIONS(7154),
    [sym_file_descriptor] = ACTIONS(7154),
    [anon_sym_SEMI] = ACTIONS(7156),
    [anon_sym_PIPE] = ACTIONS(7156),
    [anon_sym_SEMI_SEMI] = ACTIONS(7154),
    [anon_sym_RBRACE] = ACTIONS(7154),
    [anon_sym_PIPE_AMP] = ACTIONS(7154),
    [anon_sym_AMP_AMP] = ACTIONS(7154),
    [anon_sym_PIPE_PIPE] = ACTIONS(7154),
    [anon_sym_LT] = ACTIONS(7156),
    [anon_sym_GT] = ACTIONS(7156),
    [anon_sym_GT_GT] = ACTIONS(7154),
    [anon_sym_AMP_GT] = ACTIONS(7156),
    [anon_sym_AMP_GT_GT] = ACTIONS(7154),
    [anon_sym_LT_AMP] = ACTIONS(7154),
    [anon_sym_GT_AMP] = ACTIONS(7154),
    [anon_sym_LT_LT] = ACTIONS(7156),
    [anon_sym_LT_LT_DASH] = ACTIONS(7154),
    [anon_sym_LT_LT_LT] = ACTIONS(7154),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7154),
    [anon_sym_AMP] = ACTIONS(7156),
  },
  [3576] = {
    [sym_do_group] = STATE(3938),
    [sym_compound_statement] = STATE(3938),
    [anon_sym_do] = ACTIONS(1945),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [3577] = {
    [sym_do_group] = STATE(3938),
    [sym_compound_statement] = STATE(3938),
    [anon_sym_SEMI] = ACTIONS(8841),
    [anon_sym_do] = ACTIONS(1945),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [3578] = {
    [anon_sym_RPAREN_RPAREN] = ACTIONS(8843),
    [anon_sym_AMP_AMP] = ACTIONS(557),
    [anon_sym_PIPE_PIPE] = ACTIONS(557),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(559),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_PLUS_EQ] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_DASH_EQ] = ACTIONS(557),
    [anon_sym_LT_EQ] = ACTIONS(557),
    [anon_sym_GT_EQ] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(563),
    [anon_sym_DASH_DASH] = ACTIONS(563),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(557),
  },
  [3579] = {
    [sym__simple_heredoc_body] = ACTIONS(7875),
    [sym__heredoc_body_beginning] = ACTIONS(7875),
    [sym_file_descriptor] = ACTIONS(7875),
    [anon_sym_SEMI] = ACTIONS(7877),
    [anon_sym_PIPE] = ACTIONS(7877),
    [anon_sym_SEMI_SEMI] = ACTIONS(7875),
    [anon_sym_RBRACE] = ACTIONS(7875),
    [anon_sym_PIPE_AMP] = ACTIONS(7875),
    [anon_sym_AMP_AMP] = ACTIONS(7875),
    [anon_sym_PIPE_PIPE] = ACTIONS(7875),
    [anon_sym_LT] = ACTIONS(7877),
    [anon_sym_GT] = ACTIONS(7877),
    [anon_sym_GT_GT] = ACTIONS(7875),
    [anon_sym_AMP_GT] = ACTIONS(7877),
    [anon_sym_AMP_GT_GT] = ACTIONS(7875),
    [anon_sym_LT_AMP] = ACTIONS(7875),
    [anon_sym_GT_AMP] = ACTIONS(7875),
    [anon_sym_LT_LT] = ACTIONS(7877),
    [anon_sym_LT_LT_DASH] = ACTIONS(7875),
    [anon_sym_LT_LT_LT] = ACTIONS(7875),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7875),
    [anon_sym_AMP] = ACTIONS(7877),
  },
  [3580] = {
    [sym__simple_heredoc_body] = ACTIONS(7992),
    [sym__heredoc_body_beginning] = ACTIONS(7992),
    [sym_file_descriptor] = ACTIONS(7992),
    [anon_sym_SEMI] = ACTIONS(7994),
    [anon_sym_PIPE] = ACTIONS(7994),
    [anon_sym_SEMI_SEMI] = ACTIONS(7992),
    [anon_sym_RBRACE] = ACTIONS(7992),
    [anon_sym_PIPE_AMP] = ACTIONS(7992),
    [anon_sym_AMP_AMP] = ACTIONS(7992),
    [anon_sym_PIPE_PIPE] = ACTIONS(7992),
    [anon_sym_LT] = ACTIONS(7994),
    [anon_sym_GT] = ACTIONS(7994),
    [anon_sym_GT_GT] = ACTIONS(7992),
    [anon_sym_AMP_GT] = ACTIONS(7994),
    [anon_sym_AMP_GT_GT] = ACTIONS(7992),
    [anon_sym_LT_AMP] = ACTIONS(7992),
    [anon_sym_GT_AMP] = ACTIONS(7992),
    [anon_sym_LT_LT] = ACTIONS(7994),
    [anon_sym_LT_LT_DASH] = ACTIONS(7992),
    [anon_sym_LT_LT_LT] = ACTIONS(7992),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7992),
    [anon_sym_AMP] = ACTIONS(7994),
  },
  [3581] = {
    [anon_sym_esac] = ACTIONS(8845),
    [sym_comment] = ACTIONS(57),
  },
  [3582] = {
    [sym__simple_heredoc_body] = ACTIONS(8016),
    [sym__heredoc_body_beginning] = ACTIONS(8016),
    [sym_file_descriptor] = ACTIONS(8016),
    [anon_sym_SEMI] = ACTIONS(8018),
    [anon_sym_PIPE] = ACTIONS(8018),
    [anon_sym_SEMI_SEMI] = ACTIONS(8016),
    [anon_sym_RBRACE] = ACTIONS(8016),
    [anon_sym_PIPE_AMP] = ACTIONS(8016),
    [anon_sym_AMP_AMP] = ACTIONS(8016),
    [anon_sym_PIPE_PIPE] = ACTIONS(8016),
    [anon_sym_LT] = ACTIONS(8018),
    [anon_sym_GT] = ACTIONS(8018),
    [anon_sym_GT_GT] = ACTIONS(8016),
    [anon_sym_AMP_GT] = ACTIONS(8018),
    [anon_sym_AMP_GT_GT] = ACTIONS(8016),
    [anon_sym_LT_AMP] = ACTIONS(8016),
    [anon_sym_GT_AMP] = ACTIONS(8016),
    [anon_sym_LT_LT] = ACTIONS(8018),
    [anon_sym_LT_LT_DASH] = ACTIONS(8016),
    [anon_sym_LT_LT_LT] = ACTIONS(8016),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8016),
    [anon_sym_AMP] = ACTIONS(8018),
  },
  [3583] = {
    [anon_sym_esac] = ACTIONS(8847),
    [sym_comment] = ACTIONS(57),
  },
  [3584] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [sym_variable_name] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_RBRACE] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7042),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7042),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [3585] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [sym_variable_name] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_RBRACE] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7046),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7046),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [3586] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [sym_variable_name] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_RBRACE] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7050),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7050),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [3587] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8849),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3588] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8851),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3589] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [sym_variable_name] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_RBRACE] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7084),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7084),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [3590] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_RBRACE] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7042),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7042),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [3591] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_RBRACE] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7046),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7046),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [3592] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_RBRACE] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7050),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7050),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [3593] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8853),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3594] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8855),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3595] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_RBRACE] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7084),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7084),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [3596] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_RBRACE] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_EQ_TILDE] = ACTIONS(8146),
    [anon_sym_EQ_EQ] = ACTIONS(8146),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8146),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [3597] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_RBRACE] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_EQ_TILDE] = ACTIONS(8150),
    [anon_sym_EQ_EQ] = ACTIONS(8150),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8150),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [3598] = {
    [sym__concat] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_RBRACK] = ACTIONS(8144),
    [anon_sym_EQ_TILDE] = ACTIONS(8144),
    [anon_sym_EQ_EQ] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_PLUS_EQ] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_BANG_EQ] = ACTIONS(8144),
    [anon_sym_PLUS] = ACTIONS(8146),
    [anon_sym_DASH] = ACTIONS(8146),
    [anon_sym_DASH_EQ] = ACTIONS(8144),
    [anon_sym_LT_EQ] = ACTIONS(8144),
    [anon_sym_GT_EQ] = ACTIONS(8144),
    [anon_sym_PLUS_PLUS] = ACTIONS(8144),
    [anon_sym_DASH_DASH] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8144),
  },
  [3599] = {
    [sym__concat] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_RBRACK] = ACTIONS(8148),
    [anon_sym_EQ_TILDE] = ACTIONS(8148),
    [anon_sym_EQ_EQ] = ACTIONS(8148),
    [anon_sym_EQ] = ACTIONS(8150),
    [anon_sym_PLUS_EQ] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_BANG_EQ] = ACTIONS(8148),
    [anon_sym_PLUS] = ACTIONS(8150),
    [anon_sym_DASH] = ACTIONS(8150),
    [anon_sym_DASH_EQ] = ACTIONS(8148),
    [anon_sym_LT_EQ] = ACTIONS(8148),
    [anon_sym_GT_EQ] = ACTIONS(8148),
    [anon_sym_PLUS_PLUS] = ACTIONS(8148),
    [anon_sym_DASH_DASH] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8148),
  },
  [3600] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [sym_variable_name] = ACTIONS(8144),
    [ts_builtin_sym_end] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_RPAREN] = ACTIONS(8144),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8146),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [3601] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [sym_variable_name] = ACTIONS(8148),
    [ts_builtin_sym_end] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_RPAREN] = ACTIONS(8148),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8150),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [3602] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [ts_builtin_sym_end] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_RPAREN] = ACTIONS(8144),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8146),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [3603] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [ts_builtin_sym_end] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_RPAREN] = ACTIONS(8148),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8150),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [3604] = {
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [sym_variable_name] = ACTIONS(8144),
    [anon_sym_RPAREN] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8144),
  },
  [3605] = {
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [sym_variable_name] = ACTIONS(8148),
    [anon_sym_RPAREN] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8148),
  },
  [3606] = {
    [sym__concat] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8146),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym__string_content] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8146),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8146),
    [anon_sym_BQUOTE] = ACTIONS(8146),
    [sym_comment] = ACTIONS(343),
  },
  [3607] = {
    [sym__concat] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8150),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym__string_content] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8150),
    [anon_sym_BQUOTE] = ACTIONS(8150),
    [sym_comment] = ACTIONS(343),
  },
  [3608] = {
    [sym__concat] = ACTIONS(5564),
    [anon_sym_RBRACE] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
  },
  [3609] = {
    [sym__concat] = ACTIONS(5598),
    [anon_sym_RBRACE] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
  },
  [3610] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(8857),
    [sym_comment] = ACTIONS(57),
  },
  [3611] = {
    [anon_sym_RBRACE] = ACTIONS(8857),
    [sym_comment] = ACTIONS(57),
  },
  [3612] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(8859),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3613] = {
    [sym_concatenation] = STATE(3950),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3950),
    [anon_sym_RBRACE] = ACTIONS(8861),
    [anon_sym_EQ] = ACTIONS(8863),
    [anon_sym_DASH] = ACTIONS(8863),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8863),
    [anon_sym_COLON_QMARK] = ACTIONS(8863),
    [anon_sym_COLON_DASH] = ACTIONS(8863),
    [anon_sym_PERCENT] = ACTIONS(8863),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3614] = {
    [sym__concat] = ACTIONS(5615),
    [anon_sym_RBRACE] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
  },
  [3615] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8861),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3616] = {
    [sym_concatenation] = STATE(3951),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3951),
    [anon_sym_RBRACE] = ACTIONS(8857),
    [anon_sym_EQ] = ACTIONS(8867),
    [anon_sym_DASH] = ACTIONS(8867),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8869),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8867),
    [anon_sym_COLON_QMARK] = ACTIONS(8867),
    [anon_sym_COLON_DASH] = ACTIONS(8867),
    [anon_sym_PERCENT] = ACTIONS(8867),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3617] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8857),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3618] = {
    [sym__concat] = ACTIONS(5658),
    [anon_sym_RBRACE] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
  },
  [3619] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8871),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3620] = {
    [sym__concat] = ACTIONS(7040),
    [anon_sym_RBRACE] = ACTIONS(7040),
    [anon_sym_EQ] = ACTIONS(7042),
    [anon_sym_DASH] = ACTIONS(7042),
    [sym__special_character] = ACTIONS(7042),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_POUND] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_COLON] = ACTIONS(7042),
    [anon_sym_COLON_QMARK] = ACTIONS(7042),
    [anon_sym_COLON_DASH] = ACTIONS(7042),
    [anon_sym_PERCENT] = ACTIONS(7042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(7042),
  },
  [3621] = {
    [sym__concat] = ACTIONS(7044),
    [anon_sym_RBRACE] = ACTIONS(7044),
    [anon_sym_EQ] = ACTIONS(7046),
    [anon_sym_DASH] = ACTIONS(7046),
    [sym__special_character] = ACTIONS(7046),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_POUND] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_COLON] = ACTIONS(7046),
    [anon_sym_COLON_QMARK] = ACTIONS(7046),
    [anon_sym_COLON_DASH] = ACTIONS(7046),
    [anon_sym_PERCENT] = ACTIONS(7046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(7046),
  },
  [3622] = {
    [sym__concat] = ACTIONS(7048),
    [anon_sym_RBRACE] = ACTIONS(7048),
    [anon_sym_EQ] = ACTIONS(7050),
    [anon_sym_DASH] = ACTIONS(7050),
    [sym__special_character] = ACTIONS(7050),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_POUND] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_COLON] = ACTIONS(7050),
    [anon_sym_COLON_QMARK] = ACTIONS(7050),
    [anon_sym_COLON_DASH] = ACTIONS(7050),
    [anon_sym_PERCENT] = ACTIONS(7050),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(7050),
  },
  [3623] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8873),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3624] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8875),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3625] = {
    [sym__concat] = ACTIONS(7082),
    [anon_sym_RBRACE] = ACTIONS(7082),
    [anon_sym_EQ] = ACTIONS(7084),
    [anon_sym_DASH] = ACTIONS(7084),
    [sym__special_character] = ACTIONS(7084),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_POUND] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_COLON] = ACTIONS(7084),
    [anon_sym_COLON_QMARK] = ACTIONS(7084),
    [anon_sym_COLON_DASH] = ACTIONS(7084),
    [anon_sym_PERCENT] = ACTIONS(7084),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(7084),
  },
  [3626] = {
    [sym__heredoc_body_middle] = ACTIONS(7040),
    [sym__heredoc_body_end] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
  },
  [3627] = {
    [sym__heredoc_body_middle] = ACTIONS(7044),
    [sym__heredoc_body_end] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
  },
  [3628] = {
    [sym__heredoc_body_middle] = ACTIONS(7048),
    [sym__heredoc_body_end] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
  },
  [3629] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8877),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3630] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8879),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3631] = {
    [sym__heredoc_body_middle] = ACTIONS(7082),
    [sym__heredoc_body_end] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
  },
  [3632] = {
    [sym__concat] = ACTIONS(7040),
    [anon_sym_RPAREN] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7040),
  },
  [3633] = {
    [sym__concat] = ACTIONS(7044),
    [anon_sym_RPAREN] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7044),
  },
  [3634] = {
    [sym__concat] = ACTIONS(7048),
    [anon_sym_RPAREN] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7048),
  },
  [3635] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8881),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3636] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8883),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3637] = {
    [sym__concat] = ACTIONS(7082),
    [anon_sym_RPAREN] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7082),
  },
  [3638] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [sym_variable_name] = ACTIONS(8144),
    [ts_builtin_sym_end] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_RPAREN] = ACTIONS(8144),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [3639] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [sym_variable_name] = ACTIONS(8148),
    [ts_builtin_sym_end] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_RPAREN] = ACTIONS(8148),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [3640] = {
    [sym__simple_heredoc_body] = ACTIONS(8885),
    [sym__heredoc_body_beginning] = ACTIONS(8885),
    [sym_file_descriptor] = ACTIONS(8885),
    [ts_builtin_sym_end] = ACTIONS(8885),
    [anon_sym_SEMI] = ACTIONS(8887),
    [anon_sym_done] = ACTIONS(8885),
    [anon_sym_fi] = ACTIONS(8885),
    [anon_sym_elif] = ACTIONS(8885),
    [anon_sym_else] = ACTIONS(8885),
    [anon_sym_esac] = ACTIONS(8885),
    [anon_sym_PIPE] = ACTIONS(8887),
    [anon_sym_RPAREN] = ACTIONS(8885),
    [anon_sym_SEMI_SEMI] = ACTIONS(8885),
    [anon_sym_PIPE_AMP] = ACTIONS(8885),
    [anon_sym_AMP_AMP] = ACTIONS(8885),
    [anon_sym_PIPE_PIPE] = ACTIONS(8885),
    [anon_sym_LT] = ACTIONS(8887),
    [anon_sym_GT] = ACTIONS(8887),
    [anon_sym_GT_GT] = ACTIONS(8885),
    [anon_sym_AMP_GT] = ACTIONS(8887),
    [anon_sym_AMP_GT_GT] = ACTIONS(8885),
    [anon_sym_LT_AMP] = ACTIONS(8885),
    [anon_sym_GT_AMP] = ACTIONS(8885),
    [anon_sym_LT_LT] = ACTIONS(8887),
    [anon_sym_LT_LT_DASH] = ACTIONS(8885),
    [anon_sym_LT_LT_LT] = ACTIONS(8885),
    [anon_sym_BQUOTE] = ACTIONS(8885),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8885),
    [anon_sym_AMP] = ACTIONS(8887),
  },
  [3641] = {
    [sym__concat] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_EQ_TILDE] = ACTIONS(8144),
    [anon_sym_EQ_EQ] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_PLUS_EQ] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_BANG_EQ] = ACTIONS(8144),
    [anon_sym_PLUS] = ACTIONS(8146),
    [anon_sym_DASH] = ACTIONS(8146),
    [anon_sym_DASH_EQ] = ACTIONS(8144),
    [anon_sym_LT_EQ] = ACTIONS(8144),
    [anon_sym_GT_EQ] = ACTIONS(8144),
    [anon_sym_PLUS_PLUS] = ACTIONS(8144),
    [anon_sym_DASH_DASH] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8144),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [3642] = {
    [sym__concat] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_EQ_TILDE] = ACTIONS(8148),
    [anon_sym_EQ_EQ] = ACTIONS(8148),
    [anon_sym_EQ] = ACTIONS(8150),
    [anon_sym_PLUS_EQ] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_BANG_EQ] = ACTIONS(8148),
    [anon_sym_PLUS] = ACTIONS(8150),
    [anon_sym_DASH] = ACTIONS(8150),
    [anon_sym_DASH_EQ] = ACTIONS(8148),
    [anon_sym_LT_EQ] = ACTIONS(8148),
    [anon_sym_GT_EQ] = ACTIONS(8148),
    [anon_sym_PLUS_PLUS] = ACTIONS(8148),
    [anon_sym_DASH_DASH] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8148),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [3643] = {
    [sym_do_group] = STATE(3959),
    [sym_compound_statement] = STATE(3959),
    [anon_sym_do] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(57),
  },
  [3644] = {
    [sym__concat] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7040),
  },
  [3645] = {
    [sym__concat] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7044),
  },
  [3646] = {
    [sym__concat] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7048),
  },
  [3647] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8889),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3648] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8891),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3649] = {
    [sym__concat] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7082),
  },
  [3650] = {
    [sym__concat] = ACTIONS(8144),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_RPAREN] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_EQ_TILDE] = ACTIONS(8144),
    [anon_sym_EQ_EQ] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_PLUS_EQ] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_BANG_EQ] = ACTIONS(8144),
    [anon_sym_PLUS] = ACTIONS(8146),
    [anon_sym_DASH] = ACTIONS(8146),
    [anon_sym_DASH_EQ] = ACTIONS(8144),
    [anon_sym_LT_EQ] = ACTIONS(8144),
    [anon_sym_GT_EQ] = ACTIONS(8144),
    [anon_sym_PLUS_PLUS] = ACTIONS(8144),
    [anon_sym_DASH_DASH] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8144),
  },
  [3651] = {
    [sym__concat] = ACTIONS(8148),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_RPAREN] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_EQ_TILDE] = ACTIONS(8148),
    [anon_sym_EQ_EQ] = ACTIONS(8148),
    [anon_sym_EQ] = ACTIONS(8150),
    [anon_sym_PLUS_EQ] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_BANG_EQ] = ACTIONS(8148),
    [anon_sym_PLUS] = ACTIONS(8150),
    [anon_sym_DASH] = ACTIONS(8150),
    [anon_sym_DASH_EQ] = ACTIONS(8148),
    [anon_sym_LT_EQ] = ACTIONS(8148),
    [anon_sym_GT_EQ] = ACTIONS(8148),
    [anon_sym_PLUS_PLUS] = ACTIONS(8148),
    [anon_sym_DASH_DASH] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [sym_test_operator] = ACTIONS(8148),
  },
  [3652] = {
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [sym_variable_name] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [3653] = {
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [sym_variable_name] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [3654] = {
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [sym_variable_name] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [3655] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8893),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3656] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8895),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3657] = {
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [sym_variable_name] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [3658] = {
    [sym_file_descriptor] = ACTIONS(8204),
    [anon_sym_SEMI] = ACTIONS(8206),
    [anon_sym_PIPE] = ACTIONS(8206),
    [anon_sym_SEMI_SEMI] = ACTIONS(8204),
    [anon_sym_PIPE_AMP] = ACTIONS(8204),
    [anon_sym_AMP_AMP] = ACTIONS(8204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8204),
    [anon_sym_LT] = ACTIONS(8206),
    [anon_sym_GT] = ACTIONS(8206),
    [anon_sym_GT_GT] = ACTIONS(8204),
    [anon_sym_AMP_GT] = ACTIONS(8206),
    [anon_sym_AMP_GT_GT] = ACTIONS(8204),
    [anon_sym_LT_AMP] = ACTIONS(8204),
    [anon_sym_GT_AMP] = ACTIONS(8204),
    [anon_sym_LT_LT] = ACTIONS(8206),
    [anon_sym_LT_LT_DASH] = ACTIONS(8204),
    [anon_sym_LT_LT_LT] = ACTIONS(8204),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8204),
    [anon_sym_AMP] = ACTIONS(8206),
  },
  [3659] = {
    [sym_do_group] = STATE(3964),
    [sym_compound_statement] = STATE(3964),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [3660] = {
    [sym_do_group] = STATE(3964),
    [sym_compound_statement] = STATE(3964),
    [anon_sym_SEMI] = ACTIONS(8897),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [3661] = {
    [sym_file_descriptor] = ACTIONS(8817),
    [anon_sym_SEMI] = ACTIONS(8819),
    [anon_sym_PIPE] = ACTIONS(8819),
    [anon_sym_SEMI_SEMI] = ACTIONS(8817),
    [anon_sym_PIPE_AMP] = ACTIONS(8817),
    [anon_sym_AMP_AMP] = ACTIONS(8817),
    [anon_sym_PIPE_PIPE] = ACTIONS(8817),
    [anon_sym_LT] = ACTIONS(8819),
    [anon_sym_GT] = ACTIONS(8819),
    [anon_sym_GT_GT] = ACTIONS(8817),
    [anon_sym_AMP_GT] = ACTIONS(8819),
    [anon_sym_AMP_GT_GT] = ACTIONS(8817),
    [anon_sym_LT_AMP] = ACTIONS(8817),
    [anon_sym_GT_AMP] = ACTIONS(8817),
    [anon_sym_LT_LT] = ACTIONS(8819),
    [anon_sym_LT_LT_DASH] = ACTIONS(8817),
    [anon_sym_LT_LT_LT] = ACTIONS(8817),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8817),
    [anon_sym_AMP] = ACTIONS(8819),
  },
  [3662] = {
    [sym_file_descriptor] = ACTIONS(8821),
    [anon_sym_SEMI] = ACTIONS(8823),
    [anon_sym_PIPE] = ACTIONS(8823),
    [anon_sym_SEMI_SEMI] = ACTIONS(8821),
    [anon_sym_PIPE_AMP] = ACTIONS(8821),
    [anon_sym_AMP_AMP] = ACTIONS(8821),
    [anon_sym_PIPE_PIPE] = ACTIONS(8821),
    [anon_sym_LT] = ACTIONS(8823),
    [anon_sym_GT] = ACTIONS(8823),
    [anon_sym_GT_GT] = ACTIONS(8821),
    [anon_sym_AMP_GT] = ACTIONS(8823),
    [anon_sym_AMP_GT_GT] = ACTIONS(8821),
    [anon_sym_LT_AMP] = ACTIONS(8821),
    [anon_sym_GT_AMP] = ACTIONS(8821),
    [anon_sym_LT_LT] = ACTIONS(8823),
    [anon_sym_LT_LT_DASH] = ACTIONS(8821),
    [anon_sym_LT_LT_LT] = ACTIONS(8821),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8821),
    [anon_sym_AMP] = ACTIONS(8823),
  },
  [3663] = {
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [sym_variable_name] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8146),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [3664] = {
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [sym_variable_name] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8150),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [3665] = {
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8146),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [3666] = {
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8150),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [3667] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [sym_variable_name] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_done] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [3668] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [sym_variable_name] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_done] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [3669] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(8899),
    [sym_comment] = ACTIONS(57),
  },
  [3670] = {
    [anon_sym_RBRACE] = ACTIONS(8899),
    [sym_comment] = ACTIONS(57),
  },
  [3671] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(8901),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3672] = {
    [sym_concatenation] = STATE(3969),
    [sym_string] = STATE(3968),
    [sym_simple_expansion] = STATE(3968),
    [sym_string_expansion] = STATE(3968),
    [sym_expansion] = STATE(3968),
    [sym_command_substitution] = STATE(3968),
    [sym_process_substitution] = STATE(3968),
    [aux_sym__literal_repeat1] = STATE(3970),
    [anon_sym_RBRACE] = ACTIONS(8899),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(8903),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8903),
  },
  [3673] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [sym_variable_name] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_done] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [3674] = {
    [sym_concatenation] = STATE(3973),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3973),
    [sym_regex] = ACTIONS(8905),
    [anon_sym_RBRACE] = ACTIONS(8907),
    [anon_sym_EQ] = ACTIONS(8909),
    [anon_sym_DASH] = ACTIONS(8909),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8911),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8909),
    [anon_sym_COLON_QMARK] = ACTIONS(8909),
    [anon_sym_COLON_DASH] = ACTIONS(8909),
    [anon_sym_PERCENT] = ACTIONS(8909),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3675] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8907),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3676] = {
    [sym_concatenation] = STATE(3975),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3975),
    [sym_regex] = ACTIONS(8913),
    [anon_sym_RBRACE] = ACTIONS(8899),
    [anon_sym_EQ] = ACTIONS(8915),
    [anon_sym_DASH] = ACTIONS(8915),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8915),
    [anon_sym_COLON_QMARK] = ACTIONS(8915),
    [anon_sym_COLON_DASH] = ACTIONS(8915),
    [anon_sym_PERCENT] = ACTIONS(8915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3677] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8899),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3678] = {
    [sym_concatenation] = STATE(3977),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3977),
    [anon_sym_RBRACE] = ACTIONS(8919),
    [anon_sym_EQ] = ACTIONS(8921),
    [anon_sym_DASH] = ACTIONS(8921),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8923),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8921),
    [anon_sym_COLON_QMARK] = ACTIONS(8921),
    [anon_sym_COLON_DASH] = ACTIONS(8921),
    [anon_sym_PERCENT] = ACTIONS(8921),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3679] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [sym_variable_name] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_done] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [3680] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8919),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3681] = {
    [sym_concatenation] = STATE(3975),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3975),
    [anon_sym_RBRACE] = ACTIONS(8899),
    [anon_sym_EQ] = ACTIONS(8915),
    [anon_sym_DASH] = ACTIONS(8915),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8915),
    [anon_sym_COLON_QMARK] = ACTIONS(8915),
    [anon_sym_COLON_DASH] = ACTIONS(8915),
    [anon_sym_PERCENT] = ACTIONS(8915),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3682] = {
    [sym__simple_heredoc_body] = ACTIONS(4383),
    [sym__heredoc_body_beginning] = ACTIONS(4383),
    [sym_file_descriptor] = ACTIONS(4383),
    [sym_variable_name] = ACTIONS(4383),
    [anon_sym_SEMI] = ACTIONS(4385),
    [anon_sym_done] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI_SEMI] = ACTIONS(4383),
    [anon_sym_PIPE_AMP] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_AMP_GT] = ACTIONS(4385),
    [anon_sym_AMP_GT_GT] = ACTIONS(4383),
    [anon_sym_LT_AMP] = ACTIONS(4383),
    [anon_sym_GT_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_LT_LT_DASH] = ACTIONS(4383),
    [anon_sym_LT_LT_LT] = ACTIONS(4383),
    [sym__special_character] = ACTIONS(4383),
    [anon_sym_DQUOTE] = ACTIONS(4383),
    [anon_sym_DOLLAR] = ACTIONS(4385),
    [sym_raw_string] = ACTIONS(4383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4383),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4383),
    [anon_sym_BQUOTE] = ACTIONS(4383),
    [anon_sym_LT_LPAREN] = ACTIONS(4383),
    [anon_sym_GT_LPAREN] = ACTIONS(4383),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4385),
    [sym_word] = ACTIONS(4385),
    [anon_sym_LF] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
  },
  [3683] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [sym_variable_name] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_done] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5566),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [3684] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [sym_variable_name] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_done] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5600),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [3685] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(8925),
    [sym_comment] = ACTIONS(57),
  },
  [3686] = {
    [anon_sym_RBRACE] = ACTIONS(8925),
    [sym_comment] = ACTIONS(57),
  },
  [3687] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(8927),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3688] = {
    [sym_concatenation] = STATE(3981),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3981),
    [anon_sym_RBRACE] = ACTIONS(8929),
    [anon_sym_EQ] = ACTIONS(8931),
    [anon_sym_DASH] = ACTIONS(8931),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8933),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8931),
    [anon_sym_COLON_QMARK] = ACTIONS(8931),
    [anon_sym_COLON_DASH] = ACTIONS(8931),
    [anon_sym_PERCENT] = ACTIONS(8931),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3689] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [sym_variable_name] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_done] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5617),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [3690] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8929),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3691] = {
    [sym_concatenation] = STATE(3982),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3982),
    [anon_sym_RBRACE] = ACTIONS(8925),
    [anon_sym_EQ] = ACTIONS(8935),
    [anon_sym_DASH] = ACTIONS(8935),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8937),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8935),
    [anon_sym_COLON_QMARK] = ACTIONS(8935),
    [anon_sym_COLON_DASH] = ACTIONS(8935),
    [anon_sym_PERCENT] = ACTIONS(8935),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3692] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8925),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3693] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [sym_variable_name] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_done] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5660),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [3694] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8939),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3695] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_done] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5566),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [3696] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_done] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5600),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [3697] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(8941),
    [sym_comment] = ACTIONS(57),
  },
  [3698] = {
    [anon_sym_RBRACE] = ACTIONS(8941),
    [sym_comment] = ACTIONS(57),
  },
  [3699] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(8943),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3700] = {
    [sym_concatenation] = STATE(3987),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3987),
    [anon_sym_RBRACE] = ACTIONS(8945),
    [anon_sym_EQ] = ACTIONS(8947),
    [anon_sym_DASH] = ACTIONS(8947),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8949),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8947),
    [anon_sym_COLON_QMARK] = ACTIONS(8947),
    [anon_sym_COLON_DASH] = ACTIONS(8947),
    [anon_sym_PERCENT] = ACTIONS(8947),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3701] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_done] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5617),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [3702] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8945),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3703] = {
    [sym_concatenation] = STATE(3988),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3988),
    [anon_sym_RBRACE] = ACTIONS(8941),
    [anon_sym_EQ] = ACTIONS(8951),
    [anon_sym_DASH] = ACTIONS(8951),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8953),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8951),
    [anon_sym_COLON_QMARK] = ACTIONS(8951),
    [anon_sym_COLON_DASH] = ACTIONS(8951),
    [anon_sym_PERCENT] = ACTIONS(8951),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3704] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8941),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3705] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_done] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5660),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [3706] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8955),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3707] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_done] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_EQ_TILDE] = ACTIONS(7042),
    [anon_sym_EQ_EQ] = ACTIONS(7042),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [3708] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_done] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_EQ_TILDE] = ACTIONS(7046),
    [anon_sym_EQ_EQ] = ACTIONS(7046),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [3709] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_done] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_EQ_TILDE] = ACTIONS(7050),
    [anon_sym_EQ_EQ] = ACTIONS(7050),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [3710] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8957),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3711] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8959),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3712] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_done] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_EQ_TILDE] = ACTIONS(7084),
    [anon_sym_EQ_EQ] = ACTIONS(7084),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [3713] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_done] = ACTIONS(4053),
    [anon_sym_fi] = ACTIONS(4053),
    [anon_sym_elif] = ACTIONS(4053),
    [anon_sym_else] = ACTIONS(4053),
    [anon_sym_esac] = ACTIONS(4053),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [3714] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_done] = ACTIONS(4067),
    [anon_sym_fi] = ACTIONS(4067),
    [anon_sym_elif] = ACTIONS(4067),
    [anon_sym_else] = ACTIONS(4067),
    [anon_sym_esac] = ACTIONS(4067),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [3715] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(8961),
    [sym_comment] = ACTIONS(57),
  },
  [3716] = {
    [anon_sym_RBRACE] = ACTIONS(8961),
    [sym_comment] = ACTIONS(57),
  },
  [3717] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(8963),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3718] = {
    [sym_concatenation] = STATE(3995),
    [sym_string] = STATE(3994),
    [sym_simple_expansion] = STATE(3994),
    [sym_string_expansion] = STATE(3994),
    [sym_expansion] = STATE(3994),
    [sym_command_substitution] = STATE(3994),
    [sym_process_substitution] = STATE(3994),
    [aux_sym__literal_repeat1] = STATE(3996),
    [anon_sym_RBRACE] = ACTIONS(8961),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(8965),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8965),
  },
  [3719] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_done] = ACTIONS(4103),
    [anon_sym_fi] = ACTIONS(4103),
    [anon_sym_elif] = ACTIONS(4103),
    [anon_sym_else] = ACTIONS(4103),
    [anon_sym_esac] = ACTIONS(4103),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [3720] = {
    [sym_concatenation] = STATE(3999),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(3999),
    [sym_regex] = ACTIONS(8967),
    [anon_sym_RBRACE] = ACTIONS(8969),
    [anon_sym_EQ] = ACTIONS(8971),
    [anon_sym_DASH] = ACTIONS(8971),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8973),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8971),
    [anon_sym_COLON_QMARK] = ACTIONS(8971),
    [anon_sym_COLON_DASH] = ACTIONS(8971),
    [anon_sym_PERCENT] = ACTIONS(8971),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3721] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8969),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3722] = {
    [sym_concatenation] = STATE(4001),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4001),
    [sym_regex] = ACTIONS(8975),
    [anon_sym_RBRACE] = ACTIONS(8961),
    [anon_sym_EQ] = ACTIONS(8977),
    [anon_sym_DASH] = ACTIONS(8977),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8979),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8977),
    [anon_sym_COLON_QMARK] = ACTIONS(8977),
    [anon_sym_COLON_DASH] = ACTIONS(8977),
    [anon_sym_PERCENT] = ACTIONS(8977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3723] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8961),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3724] = {
    [sym_concatenation] = STATE(4003),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4003),
    [anon_sym_RBRACE] = ACTIONS(8981),
    [anon_sym_EQ] = ACTIONS(8983),
    [anon_sym_DASH] = ACTIONS(8983),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8983),
    [anon_sym_COLON_QMARK] = ACTIONS(8983),
    [anon_sym_COLON_DASH] = ACTIONS(8983),
    [anon_sym_PERCENT] = ACTIONS(8983),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3725] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_done] = ACTIONS(4159),
    [anon_sym_fi] = ACTIONS(4159),
    [anon_sym_elif] = ACTIONS(4159),
    [anon_sym_else] = ACTIONS(4159),
    [anon_sym_esac] = ACTIONS(4159),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [3726] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8981),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3727] = {
    [sym_concatenation] = STATE(4001),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4001),
    [anon_sym_RBRACE] = ACTIONS(8961),
    [anon_sym_EQ] = ACTIONS(8977),
    [anon_sym_DASH] = ACTIONS(8977),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8979),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8977),
    [anon_sym_COLON_QMARK] = ACTIONS(8977),
    [anon_sym_COLON_DASH] = ACTIONS(8977),
    [anon_sym_PERCENT] = ACTIONS(8977),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3728] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [sym_variable_name] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_fi] = ACTIONS(4055),
    [anon_sym_elif] = ACTIONS(4055),
    [anon_sym_else] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [3729] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [sym_variable_name] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_fi] = ACTIONS(4069),
    [anon_sym_elif] = ACTIONS(4069),
    [anon_sym_else] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [3730] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(8987),
    [sym_comment] = ACTIONS(57),
  },
  [3731] = {
    [anon_sym_RBRACE] = ACTIONS(8987),
    [sym_comment] = ACTIONS(57),
  },
  [3732] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(8989),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3733] = {
    [sym_concatenation] = STATE(4007),
    [sym_string] = STATE(4006),
    [sym_simple_expansion] = STATE(4006),
    [sym_string_expansion] = STATE(4006),
    [sym_expansion] = STATE(4006),
    [sym_command_substitution] = STATE(4006),
    [sym_process_substitution] = STATE(4006),
    [aux_sym__literal_repeat1] = STATE(4008),
    [anon_sym_RBRACE] = ACTIONS(8987),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(8991),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8991),
  },
  [3734] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [sym_variable_name] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_fi] = ACTIONS(4105),
    [anon_sym_elif] = ACTIONS(4105),
    [anon_sym_else] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [3735] = {
    [sym_concatenation] = STATE(4011),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4011),
    [sym_regex] = ACTIONS(8993),
    [anon_sym_RBRACE] = ACTIONS(8995),
    [anon_sym_EQ] = ACTIONS(8997),
    [anon_sym_DASH] = ACTIONS(8997),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(8999),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(8997),
    [anon_sym_COLON_QMARK] = ACTIONS(8997),
    [anon_sym_COLON_DASH] = ACTIONS(8997),
    [anon_sym_PERCENT] = ACTIONS(8997),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3736] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8995),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3737] = {
    [sym_concatenation] = STATE(4013),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4013),
    [sym_regex] = ACTIONS(9001),
    [anon_sym_RBRACE] = ACTIONS(8987),
    [anon_sym_EQ] = ACTIONS(9003),
    [anon_sym_DASH] = ACTIONS(9003),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9005),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9003),
    [anon_sym_COLON_QMARK] = ACTIONS(9003),
    [anon_sym_COLON_DASH] = ACTIONS(9003),
    [anon_sym_PERCENT] = ACTIONS(9003),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3738] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(8987),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3739] = {
    [sym_concatenation] = STATE(4015),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4015),
    [anon_sym_RBRACE] = ACTIONS(9007),
    [anon_sym_EQ] = ACTIONS(9009),
    [anon_sym_DASH] = ACTIONS(9009),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9011),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9009),
    [anon_sym_COLON_QMARK] = ACTIONS(9009),
    [anon_sym_COLON_DASH] = ACTIONS(9009),
    [anon_sym_PERCENT] = ACTIONS(9009),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3740] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [sym_variable_name] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_fi] = ACTIONS(4161),
    [anon_sym_elif] = ACTIONS(4161),
    [anon_sym_else] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [3741] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9007),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3742] = {
    [sym_concatenation] = STATE(4013),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4013),
    [anon_sym_RBRACE] = ACTIONS(8987),
    [anon_sym_EQ] = ACTIONS(9003),
    [anon_sym_DASH] = ACTIONS(9003),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9005),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9003),
    [anon_sym_COLON_QMARK] = ACTIONS(9003),
    [anon_sym_COLON_DASH] = ACTIONS(9003),
    [anon_sym_PERCENT] = ACTIONS(9003),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3743] = {
    [sym__simple_heredoc_body] = ACTIONS(4383),
    [sym__heredoc_body_beginning] = ACTIONS(4383),
    [sym_file_descriptor] = ACTIONS(4383),
    [sym_variable_name] = ACTIONS(4383),
    [anon_sym_SEMI] = ACTIONS(4385),
    [anon_sym_fi] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI_SEMI] = ACTIONS(4383),
    [anon_sym_PIPE_AMP] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_AMP_GT] = ACTIONS(4385),
    [anon_sym_AMP_GT_GT] = ACTIONS(4383),
    [anon_sym_LT_AMP] = ACTIONS(4383),
    [anon_sym_GT_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_LT_LT_DASH] = ACTIONS(4383),
    [anon_sym_LT_LT_LT] = ACTIONS(4383),
    [sym__special_character] = ACTIONS(4383),
    [anon_sym_DQUOTE] = ACTIONS(4383),
    [anon_sym_DOLLAR] = ACTIONS(4385),
    [sym_raw_string] = ACTIONS(4383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4383),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4383),
    [anon_sym_BQUOTE] = ACTIONS(4383),
    [anon_sym_LT_LPAREN] = ACTIONS(4383),
    [anon_sym_GT_LPAREN] = ACTIONS(4383),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4385),
    [anon_sym_LF] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
  },
  [3744] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_fi] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [3745] = {
    [aux_sym_concatenation_repeat1] = STATE(3745),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(9013),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_fi] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [3746] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [sym_variable_name] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_fi] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [3747] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(9016),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [3748] = {
    [sym_concatenation] = STATE(4019),
    [sym_string] = STATE(4018),
    [sym_simple_expansion] = STATE(4018),
    [sym_string_expansion] = STATE(4018),
    [sym_expansion] = STATE(4018),
    [sym_command_substitution] = STATE(4018),
    [sym_process_substitution] = STATE(4018),
    [aux_sym__literal_repeat1] = STATE(4020),
    [anon_sym_RBRACE] = ACTIONS(9018),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(9020),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9020),
  },
  [3749] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(9022),
    [sym_comment] = ACTIONS(57),
  },
  [3750] = {
    [sym_concatenation] = STATE(4024),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4024),
    [anon_sym_RBRACE] = ACTIONS(9024),
    [anon_sym_EQ] = ACTIONS(9026),
    [anon_sym_DASH] = ACTIONS(9026),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9028),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(9030),
    [anon_sym_COLON] = ACTIONS(9026),
    [anon_sym_COLON_QMARK] = ACTIONS(9026),
    [anon_sym_COLON_DASH] = ACTIONS(9026),
    [anon_sym_PERCENT] = ACTIONS(9026),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3751] = {
    [sym_concatenation] = STATE(4026),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4026),
    [anon_sym_RBRACE] = ACTIONS(9018),
    [anon_sym_EQ] = ACTIONS(9032),
    [anon_sym_DASH] = ACTIONS(9032),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(9036),
    [anon_sym_COLON] = ACTIONS(9032),
    [anon_sym_COLON_QMARK] = ACTIONS(9032),
    [anon_sym_COLON_DASH] = ACTIONS(9032),
    [anon_sym_PERCENT] = ACTIONS(9032),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3752] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [sym_variable_name] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_fi] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [3753] = {
    [sym_concatenation] = STATE(4029),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4029),
    [sym_regex] = ACTIONS(9038),
    [anon_sym_RBRACE] = ACTIONS(9040),
    [anon_sym_EQ] = ACTIONS(9042),
    [anon_sym_DASH] = ACTIONS(9042),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9042),
    [anon_sym_COLON_QMARK] = ACTIONS(9042),
    [anon_sym_COLON_DASH] = ACTIONS(9042),
    [anon_sym_PERCENT] = ACTIONS(9042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3754] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9040),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3755] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [sym_variable_name] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_fi] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [3756] = {
    [sym_concatenation] = STATE(4026),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4026),
    [sym_regex] = ACTIONS(9046),
    [anon_sym_RBRACE] = ACTIONS(9018),
    [anon_sym_EQ] = ACTIONS(9032),
    [anon_sym_DASH] = ACTIONS(9032),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9032),
    [anon_sym_COLON_QMARK] = ACTIONS(9032),
    [anon_sym_COLON_DASH] = ACTIONS(9032),
    [anon_sym_PERCENT] = ACTIONS(9032),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3757] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9018),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3758] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [sym_variable_name] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_fi] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [3759] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_fi] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [3760] = {
    [sym__simple_heredoc_body] = ACTIONS(2697),
    [sym__heredoc_body_beginning] = ACTIONS(2697),
    [sym_file_descriptor] = ACTIONS(2697),
    [sym_variable_name] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym_fi] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI_SEMI] = ACTIONS(2697),
    [anon_sym_PIPE_AMP] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_PIPE_PIPE] = ACTIONS(2697),
    [anon_sym_LT] = ACTIONS(2699),
    [anon_sym_GT] = ACTIONS(2699),
    [anon_sym_GT_GT] = ACTIONS(2697),
    [anon_sym_AMP_GT] = ACTIONS(2699),
    [anon_sym_AMP_GT_GT] = ACTIONS(2697),
    [anon_sym_LT_AMP] = ACTIONS(2697),
    [anon_sym_GT_AMP] = ACTIONS(2697),
    [anon_sym_LT_LT] = ACTIONS(2699),
    [anon_sym_LT_LT_DASH] = ACTIONS(2697),
    [anon_sym_LT_LT_LT] = ACTIONS(2697),
    [sym__special_character] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [anon_sym_DOLLAR] = ACTIONS(2699),
    [sym_raw_string] = ACTIONS(2697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2697),
    [anon_sym_BQUOTE] = ACTIONS(2697),
    [anon_sym_LT_LPAREN] = ACTIONS(2697),
    [anon_sym_GT_LPAREN] = ACTIONS(2697),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2699),
    [sym_word] = ACTIONS(2699),
    [anon_sym_LF] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
  },
  [3761] = {
    [sym_concatenation] = STATE(1357),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(1357),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(9048),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [3762] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [sym_variable_name] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_fi] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4055),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [3763] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [sym_variable_name] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_fi] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4069),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [3764] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(9050),
    [sym_comment] = ACTIONS(57),
  },
  [3765] = {
    [anon_sym_RBRACE] = ACTIONS(9050),
    [sym_comment] = ACTIONS(57),
  },
  [3766] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(9052),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3767] = {
    [sym_concatenation] = STATE(4035),
    [sym_string] = STATE(4034),
    [sym_simple_expansion] = STATE(4034),
    [sym_string_expansion] = STATE(4034),
    [sym_expansion] = STATE(4034),
    [sym_command_substitution] = STATE(4034),
    [sym_process_substitution] = STATE(4034),
    [aux_sym__literal_repeat1] = STATE(4036),
    [anon_sym_RBRACE] = ACTIONS(9050),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(9054),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9054),
  },
  [3768] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [sym_variable_name] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_fi] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4105),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [3769] = {
    [sym_concatenation] = STATE(4039),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4039),
    [sym_regex] = ACTIONS(9056),
    [anon_sym_RBRACE] = ACTIONS(9058),
    [anon_sym_EQ] = ACTIONS(9060),
    [anon_sym_DASH] = ACTIONS(9060),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9062),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9060),
    [anon_sym_COLON_QMARK] = ACTIONS(9060),
    [anon_sym_COLON_DASH] = ACTIONS(9060),
    [anon_sym_PERCENT] = ACTIONS(9060),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3770] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9058),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3771] = {
    [sym_concatenation] = STATE(4041),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4041),
    [sym_regex] = ACTIONS(9064),
    [anon_sym_RBRACE] = ACTIONS(9050),
    [anon_sym_EQ] = ACTIONS(9066),
    [anon_sym_DASH] = ACTIONS(9066),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9068),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9066),
    [anon_sym_COLON_QMARK] = ACTIONS(9066),
    [anon_sym_COLON_DASH] = ACTIONS(9066),
    [anon_sym_PERCENT] = ACTIONS(9066),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3772] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9050),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3773] = {
    [sym_concatenation] = STATE(4043),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4043),
    [anon_sym_RBRACE] = ACTIONS(9070),
    [anon_sym_EQ] = ACTIONS(9072),
    [anon_sym_DASH] = ACTIONS(9072),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9074),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9072),
    [anon_sym_COLON_QMARK] = ACTIONS(9072),
    [anon_sym_COLON_DASH] = ACTIONS(9072),
    [anon_sym_PERCENT] = ACTIONS(9072),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3774] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [sym_variable_name] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_fi] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4161),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [3775] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9070),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3776] = {
    [sym_concatenation] = STATE(4041),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4041),
    [anon_sym_RBRACE] = ACTIONS(9050),
    [anon_sym_EQ] = ACTIONS(9066),
    [anon_sym_DASH] = ACTIONS(9066),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9068),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9066),
    [anon_sym_COLON_QMARK] = ACTIONS(9066),
    [anon_sym_COLON_DASH] = ACTIONS(9066),
    [anon_sym_PERCENT] = ACTIONS(9066),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3777] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_fi] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4055),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [3778] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_fi] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4069),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [3779] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(9076),
    [sym_comment] = ACTIONS(57),
  },
  [3780] = {
    [anon_sym_RBRACE] = ACTIONS(9076),
    [sym_comment] = ACTIONS(57),
  },
  [3781] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(9078),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3782] = {
    [sym_concatenation] = STATE(4047),
    [sym_string] = STATE(4046),
    [sym_simple_expansion] = STATE(4046),
    [sym_string_expansion] = STATE(4046),
    [sym_expansion] = STATE(4046),
    [sym_command_substitution] = STATE(4046),
    [sym_process_substitution] = STATE(4046),
    [aux_sym__literal_repeat1] = STATE(4048),
    [anon_sym_RBRACE] = ACTIONS(9076),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(9080),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9080),
  },
  [3783] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_fi] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4105),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [3784] = {
    [sym_concatenation] = STATE(4051),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4051),
    [sym_regex] = ACTIONS(9082),
    [anon_sym_RBRACE] = ACTIONS(9084),
    [anon_sym_EQ] = ACTIONS(9086),
    [anon_sym_DASH] = ACTIONS(9086),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9088),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9086),
    [anon_sym_COLON_QMARK] = ACTIONS(9086),
    [anon_sym_COLON_DASH] = ACTIONS(9086),
    [anon_sym_PERCENT] = ACTIONS(9086),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3785] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9084),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3786] = {
    [sym_concatenation] = STATE(4053),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4053),
    [sym_regex] = ACTIONS(9090),
    [anon_sym_RBRACE] = ACTIONS(9076),
    [anon_sym_EQ] = ACTIONS(9092),
    [anon_sym_DASH] = ACTIONS(9092),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9094),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9092),
    [anon_sym_COLON_QMARK] = ACTIONS(9092),
    [anon_sym_COLON_DASH] = ACTIONS(9092),
    [anon_sym_PERCENT] = ACTIONS(9092),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3787] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9076),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3788] = {
    [sym_concatenation] = STATE(4055),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4055),
    [anon_sym_RBRACE] = ACTIONS(9096),
    [anon_sym_EQ] = ACTIONS(9098),
    [anon_sym_DASH] = ACTIONS(9098),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9100),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9098),
    [anon_sym_COLON_QMARK] = ACTIONS(9098),
    [anon_sym_COLON_DASH] = ACTIONS(9098),
    [anon_sym_PERCENT] = ACTIONS(9098),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3789] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_fi] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4161),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [3790] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9096),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3791] = {
    [sym_concatenation] = STATE(4053),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4053),
    [anon_sym_RBRACE] = ACTIONS(9076),
    [anon_sym_EQ] = ACTIONS(9092),
    [anon_sym_DASH] = ACTIONS(9092),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9094),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9092),
    [anon_sym_COLON_QMARK] = ACTIONS(9092),
    [anon_sym_COLON_DASH] = ACTIONS(9092),
    [anon_sym_PERCENT] = ACTIONS(9092),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3792] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_fi] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5566),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [3793] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_fi] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_EQ_TILDE] = ACTIONS(5600),
    [anon_sym_EQ_EQ] = ACTIONS(5600),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [3794] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(9102),
    [sym_comment] = ACTIONS(57),
  },
  [3795] = {
    [anon_sym_RBRACE] = ACTIONS(9102),
    [sym_comment] = ACTIONS(57),
  },
  [3796] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(9104),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3797] = {
    [sym_concatenation] = STATE(4059),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4059),
    [anon_sym_RBRACE] = ACTIONS(9106),
    [anon_sym_EQ] = ACTIONS(9108),
    [anon_sym_DASH] = ACTIONS(9108),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9110),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9108),
    [anon_sym_COLON_QMARK] = ACTIONS(9108),
    [anon_sym_COLON_DASH] = ACTIONS(9108),
    [anon_sym_PERCENT] = ACTIONS(9108),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3798] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_fi] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_EQ_TILDE] = ACTIONS(5617),
    [anon_sym_EQ_EQ] = ACTIONS(5617),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [3799] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9106),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3800] = {
    [sym_concatenation] = STATE(4060),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4060),
    [anon_sym_RBRACE] = ACTIONS(9102),
    [anon_sym_EQ] = ACTIONS(9112),
    [anon_sym_DASH] = ACTIONS(9112),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9114),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9112),
    [anon_sym_COLON_QMARK] = ACTIONS(9112),
    [anon_sym_COLON_DASH] = ACTIONS(9112),
    [anon_sym_PERCENT] = ACTIONS(9112),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3801] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9102),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3802] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_fi] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_EQ_TILDE] = ACTIONS(5660),
    [anon_sym_EQ_EQ] = ACTIONS(5660),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [3803] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9116),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3804] = {
    [aux_sym_concatenation_repeat1] = STATE(3804),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(8371),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_fi] = ACTIONS(2344),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [3805] = {
    [sym__simple_heredoc_body] = ACTIONS(4383),
    [sym__heredoc_body_beginning] = ACTIONS(4383),
    [sym_file_descriptor] = ACTIONS(4383),
    [sym_variable_name] = ACTIONS(4383),
    [anon_sym_SEMI] = ACTIONS(4385),
    [anon_sym_fi] = ACTIONS(4385),
    [anon_sym_elif] = ACTIONS(4385),
    [anon_sym_else] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI_SEMI] = ACTIONS(4383),
    [anon_sym_PIPE_AMP] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_AMP_GT] = ACTIONS(4385),
    [anon_sym_AMP_GT_GT] = ACTIONS(4383),
    [anon_sym_LT_AMP] = ACTIONS(4383),
    [anon_sym_GT_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_LT_LT_DASH] = ACTIONS(4383),
    [anon_sym_LT_LT_LT] = ACTIONS(4383),
    [sym__special_character] = ACTIONS(4383),
    [anon_sym_DQUOTE] = ACTIONS(4383),
    [anon_sym_DOLLAR] = ACTIONS(4385),
    [sym_raw_string] = ACTIONS(4383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4383),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4383),
    [anon_sym_BQUOTE] = ACTIONS(4383),
    [anon_sym_LT_LPAREN] = ACTIONS(4383),
    [anon_sym_GT_LPAREN] = ACTIONS(4383),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4385),
    [sym_word] = ACTIONS(4385),
    [anon_sym_LF] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
  },
  [3806] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [sym_variable_name] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_fi] = ACTIONS(5566),
    [anon_sym_elif] = ACTIONS(5566),
    [anon_sym_else] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5566),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [3807] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [sym_variable_name] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_fi] = ACTIONS(5600),
    [anon_sym_elif] = ACTIONS(5600),
    [anon_sym_else] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5600),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [3808] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(9118),
    [sym_comment] = ACTIONS(57),
  },
  [3809] = {
    [anon_sym_RBRACE] = ACTIONS(9118),
    [sym_comment] = ACTIONS(57),
  },
  [3810] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(9120),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3811] = {
    [sym_concatenation] = STATE(4065),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4065),
    [anon_sym_RBRACE] = ACTIONS(9122),
    [anon_sym_EQ] = ACTIONS(9124),
    [anon_sym_DASH] = ACTIONS(9124),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9126),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9124),
    [anon_sym_COLON_QMARK] = ACTIONS(9124),
    [anon_sym_COLON_DASH] = ACTIONS(9124),
    [anon_sym_PERCENT] = ACTIONS(9124),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3812] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [sym_variable_name] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_fi] = ACTIONS(5617),
    [anon_sym_elif] = ACTIONS(5617),
    [anon_sym_else] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5617),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [3813] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9122),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3814] = {
    [sym_concatenation] = STATE(4066),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4066),
    [anon_sym_RBRACE] = ACTIONS(9118),
    [anon_sym_EQ] = ACTIONS(9128),
    [anon_sym_DASH] = ACTIONS(9128),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9130),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9128),
    [anon_sym_COLON_QMARK] = ACTIONS(9128),
    [anon_sym_COLON_DASH] = ACTIONS(9128),
    [anon_sym_PERCENT] = ACTIONS(9128),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3815] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9118),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3816] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [sym_variable_name] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_fi] = ACTIONS(5660),
    [anon_sym_elif] = ACTIONS(5660),
    [anon_sym_else] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5660),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [3817] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9132),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3818] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_fi] = ACTIONS(5566),
    [anon_sym_elif] = ACTIONS(5566),
    [anon_sym_else] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5566),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [3819] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_fi] = ACTIONS(5600),
    [anon_sym_elif] = ACTIONS(5600),
    [anon_sym_else] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5600),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [3820] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(9134),
    [sym_comment] = ACTIONS(57),
  },
  [3821] = {
    [anon_sym_RBRACE] = ACTIONS(9134),
    [sym_comment] = ACTIONS(57),
  },
  [3822] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(9136),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3823] = {
    [sym_concatenation] = STATE(4071),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4071),
    [anon_sym_RBRACE] = ACTIONS(9138),
    [anon_sym_EQ] = ACTIONS(9140),
    [anon_sym_DASH] = ACTIONS(9140),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9142),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9140),
    [anon_sym_COLON_QMARK] = ACTIONS(9140),
    [anon_sym_COLON_DASH] = ACTIONS(9140),
    [anon_sym_PERCENT] = ACTIONS(9140),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3824] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_fi] = ACTIONS(5617),
    [anon_sym_elif] = ACTIONS(5617),
    [anon_sym_else] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5617),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [3825] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9138),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3826] = {
    [sym_concatenation] = STATE(4072),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4072),
    [anon_sym_RBRACE] = ACTIONS(9134),
    [anon_sym_EQ] = ACTIONS(9144),
    [anon_sym_DASH] = ACTIONS(9144),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9146),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9144),
    [anon_sym_COLON_QMARK] = ACTIONS(9144),
    [anon_sym_COLON_DASH] = ACTIONS(9144),
    [anon_sym_PERCENT] = ACTIONS(9144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3827] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9134),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3828] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_fi] = ACTIONS(5660),
    [anon_sym_elif] = ACTIONS(5660),
    [anon_sym_else] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5660),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [3829] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9148),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3830] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_fi] = ACTIONS(7042),
    [anon_sym_elif] = ACTIONS(7042),
    [anon_sym_else] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_EQ_TILDE] = ACTIONS(7042),
    [anon_sym_EQ_EQ] = ACTIONS(7042),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [3831] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_fi] = ACTIONS(7046),
    [anon_sym_elif] = ACTIONS(7046),
    [anon_sym_else] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_EQ_TILDE] = ACTIONS(7046),
    [anon_sym_EQ_EQ] = ACTIONS(7046),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [3832] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_fi] = ACTIONS(7050),
    [anon_sym_elif] = ACTIONS(7050),
    [anon_sym_else] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_EQ_TILDE] = ACTIONS(7050),
    [anon_sym_EQ_EQ] = ACTIONS(7050),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [3833] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9150),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3834] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9152),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3835] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_fi] = ACTIONS(7084),
    [anon_sym_elif] = ACTIONS(7084),
    [anon_sym_else] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_EQ_TILDE] = ACTIONS(7084),
    [anon_sym_EQ_EQ] = ACTIONS(7084),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [3836] = {
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_esac] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [3837] = {
    [sym_concatenation] = STATE(4077),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(4077),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(9154),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [3838] = {
    [aux_sym_concatenation_repeat1] = STATE(4079),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(9156),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_esac] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [3839] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(4082),
    [anon_sym_DQUOTE] = ACTIONS(9158),
    [anon_sym_DOLLAR] = ACTIONS(9160),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [3840] = {
    [sym_string] = STATE(4084),
    [anon_sym_DASH] = ACTIONS(9162),
    [anon_sym_DQUOTE] = ACTIONS(8656),
    [anon_sym_DOLLAR] = ACTIONS(9162),
    [sym_raw_string] = ACTIONS(9164),
    [anon_sym_POUND] = ACTIONS(9162),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(9166),
    [anon_sym_STAR] = ACTIONS(9168),
    [anon_sym_AT] = ACTIONS(9168),
    [anon_sym_QMARK] = ACTIONS(9168),
    [anon_sym_0] = ACTIONS(9166),
    [anon_sym__] = ACTIONS(9166),
  },
  [3841] = {
    [aux_sym_concatenation_repeat1] = STATE(4079),
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym__concat] = ACTIONS(9156),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_esac] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [3842] = {
    [sym_subscript] = STATE(4089),
    [sym_variable_name] = ACTIONS(9170),
    [anon_sym_BANG] = ACTIONS(9172),
    [anon_sym_DASH] = ACTIONS(9174),
    [anon_sym_DOLLAR] = ACTIONS(9174),
    [anon_sym_POUND] = ACTIONS(9172),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(9176),
    [anon_sym_STAR] = ACTIONS(9178),
    [anon_sym_AT] = ACTIONS(9178),
    [anon_sym_QMARK] = ACTIONS(9178),
    [anon_sym_0] = ACTIONS(9176),
    [anon_sym__] = ACTIONS(9176),
  },
  [3843] = {
    [sym__statements] = STATE(4090),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(4091),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(367),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(369),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(369),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [3844] = {
    [sym__statements] = STATE(4092),
    [sym_redirected_statement] = STATE(225),
    [sym_for_statement] = STATE(225),
    [sym_c_style_for_statement] = STATE(225),
    [sym_while_statement] = STATE(225),
    [sym_if_statement] = STATE(225),
    [sym_case_statement] = STATE(225),
    [sym_function_definition] = STATE(225),
    [sym_compound_statement] = STATE(225),
    [sym_subshell] = STATE(225),
    [sym_pipeline] = STATE(225),
    [sym_list] = STATE(225),
    [sym_negated_command] = STATE(225),
    [sym_test_command] = STATE(225),
    [sym_declaration_command] = STATE(225),
    [sym_unset_command] = STATE(225),
    [sym_command] = STATE(225),
    [sym_command_name] = STATE(226),
    [sym_variable_assignment] = STATE(227),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(230),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(229),
    [aux_sym_command_repeat1] = STATE(230),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(377),
    [anon_sym_typeset] = ACTIONS(377),
    [anon_sym_export] = ACTIONS(377),
    [anon_sym_readonly] = ACTIONS(377),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_unset] = ACTIONS(379),
    [anon_sym_unsetenv] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [3845] = {
    [sym__statements] = STATE(4093),
    [sym_redirected_statement] = STATE(105),
    [sym_for_statement] = STATE(105),
    [sym_c_style_for_statement] = STATE(105),
    [sym_while_statement] = STATE(105),
    [sym_if_statement] = STATE(105),
    [sym_case_statement] = STATE(105),
    [sym_function_definition] = STATE(105),
    [sym_compound_statement] = STATE(105),
    [sym_subshell] = STATE(105),
    [sym_pipeline] = STATE(105),
    [sym_list] = STATE(105),
    [sym_negated_command] = STATE(105),
    [sym_test_command] = STATE(105),
    [sym_declaration_command] = STATE(105),
    [sym_unset_command] = STATE(105),
    [sym_command] = STATE(105),
    [sym_command_name] = STATE(106),
    [sym_variable_assignment] = STATE(107),
    [sym_subscript] = STATE(108),
    [sym_file_redirect] = STATE(110),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(102),
    [sym_simple_expansion] = STATE(102),
    [sym_string_expansion] = STATE(102),
    [sym_expansion] = STATE(102),
    [sym_command_substitution] = STATE(102),
    [sym_process_substitution] = STATE(102),
    [aux_sym__statements_repeat1] = STATE(109),
    [aux_sym_command_repeat1] = STATE(110),
    [aux_sym__literal_repeat1] = STATE(111),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(161),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(163),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(165),
    [anon_sym_typeset] = ACTIONS(165),
    [anon_sym_export] = ACTIONS(165),
    [anon_sym_readonly] = ACTIONS(165),
    [anon_sym_local] = ACTIONS(165),
    [anon_sym_unset] = ACTIONS(167),
    [anon_sym_unsetenv] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(169),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(173),
  },
  [3846] = {
    [aux_sym__literal_repeat1] = STATE(4095),
    [sym__simple_heredoc_body] = ACTIONS(1444),
    [sym__heredoc_body_beginning] = ACTIONS(1444),
    [sym_file_descriptor] = ACTIONS(1444),
    [sym_variable_name] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_esac] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1446),
    [anon_sym_SEMI_SEMI] = ACTIONS(1444),
    [anon_sym_PIPE_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1446),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_AMP_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT_GT] = ACTIONS(1444),
    [anon_sym_LT_AMP] = ACTIONS(1444),
    [anon_sym_GT_AMP] = ACTIONS(1444),
    [anon_sym_LT_LT] = ACTIONS(1446),
    [anon_sym_LT_LT_DASH] = ACTIONS(1444),
    [anon_sym_LT_LT_LT] = ACTIONS(1444),
    [sym__special_character] = ACTIONS(9180),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [anon_sym_DOLLAR] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1444),
    [anon_sym_BQUOTE] = ACTIONS(1444),
    [anon_sym_LT_LPAREN] = ACTIONS(1444),
    [anon_sym_GT_LPAREN] = ACTIONS(1444),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1446),
    [anon_sym_LF] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1446),
  },
  [3847] = {
    [sym_concatenation] = STATE(4096),
    [sym_string] = STATE(4098),
    [sym_array] = STATE(4096),
    [sym_simple_expansion] = STATE(4098),
    [sym_string_expansion] = STATE(4098),
    [sym_expansion] = STATE(4098),
    [sym_command_substitution] = STATE(4098),
    [sym_process_substitution] = STATE(4098),
    [aux_sym__literal_repeat1] = STATE(4099),
    [sym__empty_value] = ACTIONS(9182),
    [anon_sym_LPAREN] = ACTIONS(9184),
    [sym__special_character] = ACTIONS(7893),
    [anon_sym_DQUOTE] = ACTIONS(7895),
    [anon_sym_DOLLAR] = ACTIONS(7897),
    [sym_raw_string] = ACTIONS(9186),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7903),
    [anon_sym_BQUOTE] = ACTIONS(7905),
    [anon_sym_LT_LPAREN] = ACTIONS(7907),
    [anon_sym_GT_LPAREN] = ACTIONS(7907),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9186),
  },
  [3848] = {
    [sym_string] = STATE(4100),
    [sym_simple_expansion] = STATE(4100),
    [sym_string_expansion] = STATE(4100),
    [sym_expansion] = STATE(4100),
    [sym_command_substitution] = STATE(4100),
    [sym_process_substitution] = STATE(4100),
    [sym__special_character] = ACTIONS(9188),
    [anon_sym_DQUOTE] = ACTIONS(7895),
    [anon_sym_DOLLAR] = ACTIONS(7897),
    [sym_raw_string] = ACTIONS(9188),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7901),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7903),
    [anon_sym_BQUOTE] = ACTIONS(7905),
    [anon_sym_LT_LPAREN] = ACTIONS(7907),
    [anon_sym_GT_LPAREN] = ACTIONS(7907),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9188),
  },
  [3849] = {
    [aux_sym_concatenation_repeat1] = STATE(4101),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(8672),
    [sym_variable_name] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_esac] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1061),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [3850] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [sym_variable_name] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_esac] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [3851] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(9190),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [3852] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(9190),
    [anon_sym_DOLLAR] = ACTIONS(9192),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [3853] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_esac] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1099),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [3854] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [sym_variable_name] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_esac] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1103),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [3855] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [sym_variable_name] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_esac] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1107),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [3856] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(9194),
    [sym_comment] = ACTIONS(57),
  },
  [3857] = {
    [sym_subscript] = STATE(4107),
    [sym_variable_name] = ACTIONS(9196),
    [anon_sym_DASH] = ACTIONS(9198),
    [anon_sym_DOLLAR] = ACTIONS(9198),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(9200),
    [anon_sym_STAR] = ACTIONS(9202),
    [anon_sym_AT] = ACTIONS(9202),
    [anon_sym_QMARK] = ACTIONS(9202),
    [anon_sym_0] = ACTIONS(9200),
    [anon_sym__] = ACTIONS(9200),
  },
  [3858] = {
    [sym_concatenation] = STATE(4110),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4110),
    [anon_sym_RBRACE] = ACTIONS(9204),
    [anon_sym_EQ] = ACTIONS(9206),
    [anon_sym_DASH] = ACTIONS(9206),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9208),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(9210),
    [anon_sym_COLON] = ACTIONS(9206),
    [anon_sym_COLON_QMARK] = ACTIONS(9206),
    [anon_sym_COLON_DASH] = ACTIONS(9206),
    [anon_sym_PERCENT] = ACTIONS(9206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3859] = {
    [sym_concatenation] = STATE(4113),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4113),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9214),
    [anon_sym_DASH] = ACTIONS(9214),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9216),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(9218),
    [anon_sym_COLON] = ACTIONS(9214),
    [anon_sym_COLON_QMARK] = ACTIONS(9214),
    [anon_sym_COLON_DASH] = ACTIONS(9214),
    [anon_sym_PERCENT] = ACTIONS(9214),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3860] = {
    [anon_sym_RPAREN] = ACTIONS(9220),
    [sym_comment] = ACTIONS(57),
  },
  [3861] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(9220),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [3862] = {
    [anon_sym_BQUOTE] = ACTIONS(9220),
    [sym_comment] = ACTIONS(57),
  },
  [3863] = {
    [anon_sym_RPAREN] = ACTIONS(9222),
    [sym_comment] = ACTIONS(57),
  },
  [3864] = {
    [sym_variable_assignment] = STATE(3864),
    [sym_subscript] = STATE(3505),
    [sym_concatenation] = STATE(3864),
    [sym_string] = STATE(3500),
    [sym_simple_expansion] = STATE(3500),
    [sym_string_expansion] = STATE(3500),
    [sym_expansion] = STATE(3500),
    [sym_command_substitution] = STATE(3500),
    [sym_process_substitution] = STATE(3500),
    [aux_sym_declaration_command_repeat1] = STATE(3864),
    [aux_sym__literal_repeat1] = STATE(3507),
    [sym__simple_heredoc_body] = ACTIONS(2192),
    [sym__heredoc_body_beginning] = ACTIONS(2192),
    [sym_file_descriptor] = ACTIONS(2192),
    [sym_variable_name] = ACTIONS(9224),
    [anon_sym_SEMI] = ACTIONS(2197),
    [anon_sym_esac] = ACTIONS(2197),
    [anon_sym_PIPE] = ACTIONS(2197),
    [anon_sym_SEMI_SEMI] = ACTIONS(2192),
    [anon_sym_PIPE_AMP] = ACTIONS(2192),
    [anon_sym_AMP_AMP] = ACTIONS(2192),
    [anon_sym_PIPE_PIPE] = ACTIONS(2192),
    [anon_sym_LT] = ACTIONS(2197),
    [anon_sym_GT] = ACTIONS(2197),
    [anon_sym_GT_GT] = ACTIONS(2192),
    [anon_sym_AMP_GT] = ACTIONS(2197),
    [anon_sym_AMP_GT_GT] = ACTIONS(2192),
    [anon_sym_LT_AMP] = ACTIONS(2192),
    [anon_sym_GT_AMP] = ACTIONS(2192),
    [anon_sym_LT_LT] = ACTIONS(2197),
    [anon_sym_LT_LT_DASH] = ACTIONS(2192),
    [anon_sym_LT_LT_LT] = ACTIONS(2192),
    [sym__special_character] = ACTIONS(9227),
    [anon_sym_DQUOTE] = ACTIONS(9230),
    [anon_sym_DOLLAR] = ACTIONS(9233),
    [sym_raw_string] = ACTIONS(9236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(9239),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(9242),
    [anon_sym_BQUOTE] = ACTIONS(9245),
    [anon_sym_LT_LPAREN] = ACTIONS(9248),
    [anon_sym_GT_LPAREN] = ACTIONS(9248),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(9251),
    [sym_word] = ACTIONS(9254),
    [anon_sym_LF] = ACTIONS(2192),
    [anon_sym_AMP] = ACTIONS(2197),
  },
  [3865] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_esac] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [3866] = {
    [aux_sym__literal_repeat1] = STATE(3866),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym_variable_name] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_esac] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(9257),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1373),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [3867] = {
    [sym_string] = STATE(4116),
    [sym_simple_expansion] = STATE(4116),
    [sym_string_expansion] = STATE(4116),
    [sym_expansion] = STATE(4116),
    [sym_command_substitution] = STATE(4116),
    [sym_process_substitution] = STATE(4116),
    [sym__special_character] = ACTIONS(9260),
    [anon_sym_DQUOTE] = ACTIONS(7915),
    [anon_sym_DOLLAR] = ACTIONS(7917),
    [sym_raw_string] = ACTIONS(9260),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7921),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7923),
    [anon_sym_BQUOTE] = ACTIONS(7925),
    [anon_sym_LT_LPAREN] = ACTIONS(7927),
    [anon_sym_GT_LPAREN] = ACTIONS(7927),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9260),
  },
  [3868] = {
    [aux_sym_concatenation_repeat1] = STATE(4117),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(8700),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_esac] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1061),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [3869] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_esac] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1065),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [3870] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(9262),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [3871] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(9262),
    [anon_sym_DOLLAR] = ACTIONS(9264),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [3872] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_esac] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1099),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [3873] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_esac] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1103),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [3874] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_esac] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1107),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [3875] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(9266),
    [sym_comment] = ACTIONS(57),
  },
  [3876] = {
    [sym_subscript] = STATE(4123),
    [sym_variable_name] = ACTIONS(9268),
    [anon_sym_DASH] = ACTIONS(9270),
    [anon_sym_DOLLAR] = ACTIONS(9270),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(9272),
    [anon_sym_STAR] = ACTIONS(9274),
    [anon_sym_AT] = ACTIONS(9274),
    [anon_sym_QMARK] = ACTIONS(9274),
    [anon_sym_0] = ACTIONS(9272),
    [anon_sym__] = ACTIONS(9272),
  },
  [3877] = {
    [sym_concatenation] = STATE(4126),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4126),
    [anon_sym_RBRACE] = ACTIONS(9276),
    [anon_sym_EQ] = ACTIONS(9278),
    [anon_sym_DASH] = ACTIONS(9278),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(9282),
    [anon_sym_COLON] = ACTIONS(9278),
    [anon_sym_COLON_QMARK] = ACTIONS(9278),
    [anon_sym_COLON_DASH] = ACTIONS(9278),
    [anon_sym_PERCENT] = ACTIONS(9278),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3878] = {
    [sym_concatenation] = STATE(4129),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4129),
    [anon_sym_RBRACE] = ACTIONS(9284),
    [anon_sym_EQ] = ACTIONS(9286),
    [anon_sym_DASH] = ACTIONS(9286),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9288),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(9290),
    [anon_sym_COLON] = ACTIONS(9286),
    [anon_sym_COLON_QMARK] = ACTIONS(9286),
    [anon_sym_COLON_DASH] = ACTIONS(9286),
    [anon_sym_PERCENT] = ACTIONS(9286),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3879] = {
    [anon_sym_RPAREN] = ACTIONS(9292),
    [sym_comment] = ACTIONS(57),
  },
  [3880] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(9292),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [3881] = {
    [anon_sym_BQUOTE] = ACTIONS(9292),
    [sym_comment] = ACTIONS(57),
  },
  [3882] = {
    [anon_sym_RPAREN] = ACTIONS(9294),
    [sym_comment] = ACTIONS(57),
  },
  [3883] = {
    [sym_concatenation] = STATE(3883),
    [sym_string] = STATE(3511),
    [sym_simple_expansion] = STATE(3511),
    [sym_string_expansion] = STATE(3511),
    [sym_expansion] = STATE(3511),
    [sym_command_substitution] = STATE(3511),
    [sym_process_substitution] = STATE(3511),
    [aux_sym_unset_command_repeat1] = STATE(3883),
    [aux_sym__literal_repeat1] = STATE(3517),
    [sym__simple_heredoc_body] = ACTIONS(2268),
    [sym__heredoc_body_beginning] = ACTIONS(2268),
    [sym_file_descriptor] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_esac] = ACTIONS(2270),
    [anon_sym_PIPE] = ACTIONS(2270),
    [anon_sym_SEMI_SEMI] = ACTIONS(2268),
    [anon_sym_PIPE_AMP] = ACTIONS(2268),
    [anon_sym_AMP_AMP] = ACTIONS(2268),
    [anon_sym_PIPE_PIPE] = ACTIONS(2268),
    [anon_sym_LT] = ACTIONS(2270),
    [anon_sym_GT] = ACTIONS(2270),
    [anon_sym_GT_GT] = ACTIONS(2268),
    [anon_sym_AMP_GT] = ACTIONS(2270),
    [anon_sym_AMP_GT_GT] = ACTIONS(2268),
    [anon_sym_LT_AMP] = ACTIONS(2268),
    [anon_sym_GT_AMP] = ACTIONS(2268),
    [anon_sym_LT_LT] = ACTIONS(2270),
    [anon_sym_LT_LT_DASH] = ACTIONS(2268),
    [anon_sym_LT_LT_LT] = ACTIONS(2268),
    [sym__special_character] = ACTIONS(9296),
    [anon_sym_DQUOTE] = ACTIONS(9299),
    [anon_sym_DOLLAR] = ACTIONS(9302),
    [sym_raw_string] = ACTIONS(9305),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(9308),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(9311),
    [anon_sym_BQUOTE] = ACTIONS(9314),
    [anon_sym_LT_LPAREN] = ACTIONS(9317),
    [anon_sym_GT_LPAREN] = ACTIONS(9317),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(9320),
    [sym_word] = ACTIONS(9323),
    [anon_sym_LF] = ACTIONS(2268),
    [anon_sym_AMP] = ACTIONS(2270),
  },
  [3884] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_esac] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(329),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [3885] = {
    [aux_sym__literal_repeat1] = STATE(3885),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_esac] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(9326),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1373),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [3886] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_esac] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2346),
    [anon_sym_EQ_EQ] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [3887] = {
    [aux_sym_concatenation_repeat1] = STATE(3887),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(9329),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_esac] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_EQ_TILDE] = ACTIONS(2346),
    [anon_sym_EQ_EQ] = ACTIONS(2346),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [3888] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_esac] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_EQ_TILDE] = ACTIONS(2353),
    [anon_sym_EQ_EQ] = ACTIONS(2353),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [3889] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(9332),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [3890] = {
    [sym_concatenation] = STATE(4135),
    [sym_string] = STATE(4134),
    [sym_simple_expansion] = STATE(4134),
    [sym_string_expansion] = STATE(4134),
    [sym_expansion] = STATE(4134),
    [sym_command_substitution] = STATE(4134),
    [sym_process_substitution] = STATE(4134),
    [aux_sym__literal_repeat1] = STATE(4136),
    [anon_sym_RBRACE] = ACTIONS(9334),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(9336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9336),
  },
  [3891] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(9338),
    [sym_comment] = ACTIONS(57),
  },
  [3892] = {
    [sym_concatenation] = STATE(4140),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4140),
    [anon_sym_RBRACE] = ACTIONS(9340),
    [anon_sym_EQ] = ACTIONS(9342),
    [anon_sym_DASH] = ACTIONS(9342),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(9346),
    [anon_sym_COLON] = ACTIONS(9342),
    [anon_sym_COLON_QMARK] = ACTIONS(9342),
    [anon_sym_COLON_DASH] = ACTIONS(9342),
    [anon_sym_PERCENT] = ACTIONS(9342),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3893] = {
    [sym_concatenation] = STATE(4142),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4142),
    [anon_sym_RBRACE] = ACTIONS(9334),
    [anon_sym_EQ] = ACTIONS(9348),
    [anon_sym_DASH] = ACTIONS(9348),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9350),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(9352),
    [anon_sym_COLON] = ACTIONS(9348),
    [anon_sym_COLON_QMARK] = ACTIONS(9348),
    [anon_sym_COLON_DASH] = ACTIONS(9348),
    [anon_sym_PERCENT] = ACTIONS(9348),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3894] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_esac] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_EQ_TILDE] = ACTIONS(2444),
    [anon_sym_EQ_EQ] = ACTIONS(2444),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [3895] = {
    [sym_concatenation] = STATE(4145),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4145),
    [sym_regex] = ACTIONS(9354),
    [anon_sym_RBRACE] = ACTIONS(9356),
    [anon_sym_EQ] = ACTIONS(9358),
    [anon_sym_DASH] = ACTIONS(9358),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9358),
    [anon_sym_COLON_QMARK] = ACTIONS(9358),
    [anon_sym_COLON_DASH] = ACTIONS(9358),
    [anon_sym_PERCENT] = ACTIONS(9358),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3896] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9356),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3897] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_esac] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_EQ_TILDE] = ACTIONS(2494),
    [anon_sym_EQ_EQ] = ACTIONS(2494),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [3898] = {
    [sym_concatenation] = STATE(4142),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4142),
    [sym_regex] = ACTIONS(9362),
    [anon_sym_RBRACE] = ACTIONS(9334),
    [anon_sym_EQ] = ACTIONS(9348),
    [anon_sym_DASH] = ACTIONS(9348),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9350),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9348),
    [anon_sym_COLON_QMARK] = ACTIONS(9348),
    [anon_sym_COLON_DASH] = ACTIONS(9348),
    [anon_sym_PERCENT] = ACTIONS(9348),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3899] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9334),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3900] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_esac] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_EQ_TILDE] = ACTIONS(2502),
    [anon_sym_EQ_EQ] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [3901] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_esac] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_EQ_TILDE] = ACTIONS(2536),
    [anon_sym_EQ_EQ] = ACTIONS(2536),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [3902] = {
    [sym_concatenation] = STATE(1318),
    [sym_string] = STATE(4147),
    [sym_simple_expansion] = STATE(4147),
    [sym_string_expansion] = STATE(4147),
    [sym_expansion] = STATE(4147),
    [sym_command_substitution] = STATE(4147),
    [sym_process_substitution] = STATE(4147),
    [aux_sym__literal_repeat1] = STATE(4148),
    [sym__special_character] = ACTIONS(8774),
    [anon_sym_DQUOTE] = ACTIONS(4914),
    [anon_sym_DOLLAR] = ACTIONS(4916),
    [sym_raw_string] = ACTIONS(9364),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4922),
    [anon_sym_BQUOTE] = ACTIONS(4924),
    [anon_sym_LT_LPAREN] = ACTIONS(4926),
    [anon_sym_GT_LPAREN] = ACTIONS(4926),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9364),
  },
  [3903] = {
    [sym_file_redirect] = STATE(3542),
    [sym_heredoc_redirect] = STATE(3542),
    [sym_herestring_redirect] = STATE(3542),
    [aux_sym_redirected_statement_repeat1] = STATE(3542),
    [sym__simple_heredoc_body] = ACTIONS(2564),
    [sym__heredoc_body_beginning] = ACTIONS(2564),
    [sym_file_descriptor] = ACTIONS(2564),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_esac] = ACTIONS(2564),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT] = ACTIONS(2566),
    [anon_sym_AMP_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_AMP] = ACTIONS(2564),
    [anon_sym_GT_AMP] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_LT_LT_DASH] = ACTIONS(2564),
    [anon_sym_LT_LT_LT] = ACTIONS(2564),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2566),
  },
  [3904] = {
    [sym_file_redirect] = STATE(3542),
    [sym_heredoc_redirect] = STATE(3542),
    [sym_herestring_redirect] = STATE(3542),
    [aux_sym_redirected_statement_repeat1] = STATE(3542),
    [sym__simple_heredoc_body] = ACTIONS(2564),
    [sym__heredoc_body_beginning] = ACTIONS(2564),
    [sym_file_descriptor] = ACTIONS(2564),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2566),
    [anon_sym_esac] = ACTIONS(2566),
    [anon_sym_PIPE] = ACTIONS(2566),
    [anon_sym_SEMI_SEMI] = ACTIONS(2564),
    [anon_sym_PIPE_AMP] = ACTIONS(2564),
    [anon_sym_AMP_AMP] = ACTIONS(2564),
    [anon_sym_PIPE_PIPE] = ACTIONS(2564),
    [anon_sym_LT] = ACTIONS(2566),
    [anon_sym_GT] = ACTIONS(2566),
    [anon_sym_GT_GT] = ACTIONS(2564),
    [anon_sym_AMP_GT] = ACTIONS(2566),
    [anon_sym_AMP_GT_GT] = ACTIONS(2564),
    [anon_sym_LT_AMP] = ACTIONS(2564),
    [anon_sym_GT_AMP] = ACTIONS(2564),
    [anon_sym_LT_LT] = ACTIONS(2566),
    [anon_sym_LT_LT_DASH] = ACTIONS(2564),
    [anon_sym_LT_LT_LT] = ACTIONS(2564),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2566),
  },
  [3905] = {
    [sym_file_redirect] = STATE(3542),
    [sym_heredoc_redirect] = STATE(3542),
    [sym_herestring_redirect] = STATE(3542),
    [aux_sym_redirected_statement_repeat1] = STATE(3542),
    [sym__simple_heredoc_body] = ACTIONS(2568),
    [sym__heredoc_body_beginning] = ACTIONS(2568),
    [sym_file_descriptor] = ACTIONS(2568),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_esac] = ACTIONS(2568),
    [anon_sym_PIPE] = ACTIONS(7965),
    [anon_sym_SEMI_SEMI] = ACTIONS(2568),
    [anon_sym_PIPE_AMP] = ACTIONS(7967),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(2570),
    [anon_sym_GT] = ACTIONS(2570),
    [anon_sym_GT_GT] = ACTIONS(2568),
    [anon_sym_AMP_GT] = ACTIONS(2570),
    [anon_sym_AMP_GT_GT] = ACTIONS(2568),
    [anon_sym_LT_AMP] = ACTIONS(2568),
    [anon_sym_GT_AMP] = ACTIONS(2568),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_LT_LT_DASH] = ACTIONS(2568),
    [anon_sym_LT_LT_LT] = ACTIONS(2568),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2570),
  },
  [3906] = {
    [sym_file_redirect] = STATE(3542),
    [sym_heredoc_redirect] = STATE(3542),
    [sym_herestring_redirect] = STATE(3542),
    [aux_sym_redirected_statement_repeat1] = STATE(3542),
    [sym__simple_heredoc_body] = ACTIONS(2568),
    [sym__heredoc_body_beginning] = ACTIONS(2568),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(2570),
    [anon_sym_esac] = ACTIONS(2570),
    [anon_sym_PIPE] = ACTIONS(7965),
    [anon_sym_SEMI_SEMI] = ACTIONS(2568),
    [anon_sym_PIPE_AMP] = ACTIONS(7967),
    [anon_sym_AMP_AMP] = ACTIONS(2568),
    [anon_sym_PIPE_PIPE] = ACTIONS(2568),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(2570),
    [anon_sym_LT_LT_DASH] = ACTIONS(2568),
    [anon_sym_LT_LT_LT] = ACTIONS(2568),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(2568),
    [anon_sym_AMP] = ACTIONS(2570),
  },
  [3907] = {
    [aux_sym_concatenation_repeat1] = STATE(4149),
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_esac] = ACTIONS(325),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [3908] = {
    [aux_sym_concatenation_repeat1] = STATE(4149),
    [sym__simple_heredoc_body] = ACTIONS(1037),
    [sym__heredoc_body_beginning] = ACTIONS(1037),
    [sym_file_descriptor] = ACTIONS(1037),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_esac] = ACTIONS(1037),
    [anon_sym_PIPE] = ACTIONS(1039),
    [anon_sym_SEMI_SEMI] = ACTIONS(1037),
    [anon_sym_PIPE_AMP] = ACTIONS(1037),
    [anon_sym_AMP_AMP] = ACTIONS(1037),
    [anon_sym_PIPE_PIPE] = ACTIONS(1037),
    [anon_sym_LT] = ACTIONS(1039),
    [anon_sym_GT] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(1037),
    [anon_sym_AMP_GT] = ACTIONS(1039),
    [anon_sym_AMP_GT_GT] = ACTIONS(1037),
    [anon_sym_LT_AMP] = ACTIONS(1037),
    [anon_sym_GT_AMP] = ACTIONS(1037),
    [anon_sym_LT_LT] = ACTIONS(1039),
    [anon_sym_LT_LT_DASH] = ACTIONS(1037),
    [anon_sym_LT_LT_LT] = ACTIONS(1037),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1037),
    [anon_sym_AMP] = ACTIONS(1039),
  },
  [3909] = {
    [aux_sym__literal_repeat1] = STATE(4150),
    [sym__simple_heredoc_body] = ACTIONS(1051),
    [sym__heredoc_body_beginning] = ACTIONS(1051),
    [sym_file_descriptor] = ACTIONS(1051),
    [anon_sym_SEMI] = ACTIONS(1053),
    [anon_sym_esac] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_SEMI_SEMI] = ACTIONS(1051),
    [anon_sym_PIPE_AMP] = ACTIONS(1051),
    [anon_sym_AMP_AMP] = ACTIONS(1051),
    [anon_sym_PIPE_PIPE] = ACTIONS(1051),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1051),
    [anon_sym_AMP_GT] = ACTIONS(1053),
    [anon_sym_AMP_GT_GT] = ACTIONS(1051),
    [anon_sym_LT_AMP] = ACTIONS(1051),
    [anon_sym_GT_AMP] = ACTIONS(1051),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_LT_LT_DASH] = ACTIONS(1051),
    [anon_sym_LT_LT_LT] = ACTIONS(1051),
    [sym__special_character] = ACTIONS(6247),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1051),
    [anon_sym_AMP] = ACTIONS(1053),
  },
  [3910] = {
    [aux_sym_concatenation_repeat1] = STATE(4149),
    [sym__simple_heredoc_body] = ACTIONS(2576),
    [sym__heredoc_body_beginning] = ACTIONS(2576),
    [sym_file_descriptor] = ACTIONS(2576),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(2578),
    [anon_sym_esac] = ACTIONS(2576),
    [anon_sym_PIPE] = ACTIONS(2578),
    [anon_sym_SEMI_SEMI] = ACTIONS(2576),
    [anon_sym_PIPE_AMP] = ACTIONS(2576),
    [anon_sym_AMP_AMP] = ACTIONS(2576),
    [anon_sym_PIPE_PIPE] = ACTIONS(2576),
    [anon_sym_LT] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2578),
    [anon_sym_GT_GT] = ACTIONS(2576),
    [anon_sym_AMP_GT] = ACTIONS(2578),
    [anon_sym_AMP_GT_GT] = ACTIONS(2576),
    [anon_sym_LT_AMP] = ACTIONS(2576),
    [anon_sym_GT_AMP] = ACTIONS(2576),
    [anon_sym_LT_LT] = ACTIONS(2578),
    [anon_sym_LT_LT_DASH] = ACTIONS(2576),
    [anon_sym_LT_LT_LT] = ACTIONS(2576),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2576),
    [anon_sym_AMP] = ACTIONS(2578),
  },
  [3911] = {
    [aux_sym__literal_repeat1] = STATE(4150),
    [sym__simple_heredoc_body] = ACTIONS(2580),
    [sym__heredoc_body_beginning] = ACTIONS(2580),
    [sym_file_descriptor] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym_esac] = ACTIONS(2580),
    [anon_sym_PIPE] = ACTIONS(2582),
    [anon_sym_SEMI_SEMI] = ACTIONS(2580),
    [anon_sym_PIPE_AMP] = ACTIONS(2580),
    [anon_sym_AMP_AMP] = ACTIONS(2580),
    [anon_sym_PIPE_PIPE] = ACTIONS(2580),
    [anon_sym_LT] = ACTIONS(2582),
    [anon_sym_GT] = ACTIONS(2582),
    [anon_sym_GT_GT] = ACTIONS(2580),
    [anon_sym_AMP_GT] = ACTIONS(2582),
    [anon_sym_AMP_GT_GT] = ACTIONS(2580),
    [anon_sym_LT_AMP] = ACTIONS(2580),
    [anon_sym_GT_AMP] = ACTIONS(2580),
    [anon_sym_LT_LT] = ACTIONS(2582),
    [anon_sym_LT_LT_DASH] = ACTIONS(2580),
    [anon_sym_LT_LT_LT] = ACTIONS(2580),
    [sym__special_character] = ACTIONS(6247),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2580),
    [anon_sym_AMP] = ACTIONS(2582),
  },
  [3912] = {
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(2584),
    [anon_sym_for] = ACTIONS(2588),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_case] = ACTIONS(2588),
    [anon_sym_esac] = ACTIONS(6249),
    [anon_sym_SEMI_SEMI] = ACTIONS(2586),
    [anon_sym_function] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2584),
    [anon_sym_declare] = ACTIONS(2588),
    [anon_sym_typeset] = ACTIONS(2588),
    [anon_sym_export] = ACTIONS(2588),
    [anon_sym_readonly] = ACTIONS(2588),
    [anon_sym_local] = ACTIONS(2588),
    [anon_sym_unset] = ACTIONS(2588),
    [anon_sym_unsetenv] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [sym__special_character] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2584),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2584),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [anon_sym_LT_LPAREN] = ACTIONS(2584),
    [anon_sym_GT_LPAREN] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
  },
  [3913] = {
    [sym_file_redirect] = STATE(3913),
    [sym_heredoc_redirect] = STATE(3913),
    [sym_herestring_redirect] = STATE(3913),
    [aux_sym_redirected_statement_repeat1] = STATE(3913),
    [sym__simple_heredoc_body] = ACTIONS(2590),
    [sym__heredoc_body_beginning] = ACTIONS(2590),
    [sym_file_descriptor] = ACTIONS(9366),
    [anon_sym_SEMI] = ACTIONS(2595),
    [anon_sym_esac] = ACTIONS(2590),
    [anon_sym_PIPE] = ACTIONS(2595),
    [anon_sym_SEMI_SEMI] = ACTIONS(2590),
    [anon_sym_PIPE_AMP] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2590),
    [anon_sym_PIPE_PIPE] = ACTIONS(2590),
    [anon_sym_LT] = ACTIONS(9369),
    [anon_sym_GT] = ACTIONS(9369),
    [anon_sym_GT_GT] = ACTIONS(9372),
    [anon_sym_AMP_GT] = ACTIONS(9369),
    [anon_sym_AMP_GT_GT] = ACTIONS(9372),
    [anon_sym_LT_AMP] = ACTIONS(9372),
    [anon_sym_GT_AMP] = ACTIONS(9372),
    [anon_sym_LT_LT] = ACTIONS(2603),
    [anon_sym_LT_LT_DASH] = ACTIONS(2606),
    [anon_sym_LT_LT_LT] = ACTIONS(9375),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2595),
  },
  [3914] = {
    [sym__simple_heredoc_body] = ACTIONS(2612),
    [sym__heredoc_body_beginning] = ACTIONS(2612),
    [sym_file_descriptor] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_esac] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(2614),
    [anon_sym_EQ_EQ] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2612),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2612),
    [anon_sym_BQUOTE] = ACTIONS(2612),
    [anon_sym_LT_LPAREN] = ACTIONS(2612),
    [anon_sym_GT_LPAREN] = ACTIONS(2612),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2614),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [3915] = {
    [aux_sym_concatenation_repeat1] = STATE(3519),
    [sym__simple_heredoc_body] = ACTIONS(2612),
    [sym__heredoc_body_beginning] = ACTIONS(2612),
    [sym_file_descriptor] = ACTIONS(2612),
    [sym__concat] = ACTIONS(7933),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_esac] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(2614),
    [anon_sym_EQ_EQ] = ACTIONS(2614),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(2612),
    [anon_sym_DQUOTE] = ACTIONS(2612),
    [anon_sym_DOLLAR] = ACTIONS(2614),
    [sym_raw_string] = ACTIONS(2612),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2612),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2612),
    [anon_sym_BQUOTE] = ACTIONS(2612),
    [anon_sym_LT_LPAREN] = ACTIONS(2612),
    [anon_sym_GT_LPAREN] = ACTIONS(2612),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2614),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [3916] = {
    [aux_sym__literal_repeat1] = STATE(3551),
    [sym__simple_heredoc_body] = ACTIONS(2616),
    [sym__heredoc_body_beginning] = ACTIONS(2616),
    [sym_file_descriptor] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(2618),
    [anon_sym_esac] = ACTIONS(2618),
    [anon_sym_PIPE] = ACTIONS(2618),
    [anon_sym_SEMI_SEMI] = ACTIONS(2616),
    [anon_sym_PIPE_AMP] = ACTIONS(2616),
    [anon_sym_AMP_AMP] = ACTIONS(2616),
    [anon_sym_PIPE_PIPE] = ACTIONS(2616),
    [anon_sym_EQ_TILDE] = ACTIONS(2618),
    [anon_sym_EQ_EQ] = ACTIONS(2618),
    [anon_sym_LT] = ACTIONS(2618),
    [anon_sym_GT] = ACTIONS(2618),
    [anon_sym_GT_GT] = ACTIONS(2616),
    [anon_sym_AMP_GT] = ACTIONS(2618),
    [anon_sym_AMP_GT_GT] = ACTIONS(2616),
    [anon_sym_LT_AMP] = ACTIONS(2616),
    [anon_sym_GT_AMP] = ACTIONS(2616),
    [anon_sym_LT_LT] = ACTIONS(2618),
    [anon_sym_LT_LT_DASH] = ACTIONS(2616),
    [anon_sym_LT_LT_LT] = ACTIONS(2616),
    [sym__special_character] = ACTIONS(7987),
    [anon_sym_DQUOTE] = ACTIONS(2616),
    [anon_sym_DOLLAR] = ACTIONS(2618),
    [sym_raw_string] = ACTIONS(2616),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2616),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2616),
    [anon_sym_BQUOTE] = ACTIONS(2616),
    [anon_sym_LT_LPAREN] = ACTIONS(2616),
    [anon_sym_GT_LPAREN] = ACTIONS(2616),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2618),
    [anon_sym_LF] = ACTIONS(2616),
    [anon_sym_AMP] = ACTIONS(2618),
  },
  [3917] = {
    [sym_concatenation] = STATE(3917),
    [sym_string] = STATE(3544),
    [sym_simple_expansion] = STATE(3544),
    [sym_string_expansion] = STATE(3544),
    [sym_expansion] = STATE(3544),
    [sym_command_substitution] = STATE(3544),
    [sym_process_substitution] = STATE(3544),
    [aux_sym_command_repeat2] = STATE(3917),
    [aux_sym__literal_repeat1] = STATE(3546),
    [sym__simple_heredoc_body] = ACTIONS(2612),
    [sym__heredoc_body_beginning] = ACTIONS(2612),
    [sym_file_descriptor] = ACTIONS(2612),
    [anon_sym_SEMI] = ACTIONS(2614),
    [anon_sym_esac] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2614),
    [anon_sym_SEMI_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE_AMP] = ACTIONS(2612),
    [anon_sym_AMP_AMP] = ACTIONS(2612),
    [anon_sym_PIPE_PIPE] = ACTIONS(2612),
    [anon_sym_EQ_TILDE] = ACTIONS(9378),
    [anon_sym_EQ_EQ] = ACTIONS(9378),
    [anon_sym_LT] = ACTIONS(2614),
    [anon_sym_GT] = ACTIONS(2614),
    [anon_sym_GT_GT] = ACTIONS(2612),
    [anon_sym_AMP_GT] = ACTIONS(2614),
    [anon_sym_AMP_GT_GT] = ACTIONS(2612),
    [anon_sym_LT_AMP] = ACTIONS(2612),
    [anon_sym_GT_AMP] = ACTIONS(2612),
    [anon_sym_LT_LT] = ACTIONS(2614),
    [anon_sym_LT_LT_DASH] = ACTIONS(2612),
    [anon_sym_LT_LT_LT] = ACTIONS(2612),
    [sym__special_character] = ACTIONS(9381),
    [anon_sym_DQUOTE] = ACTIONS(9384),
    [anon_sym_DOLLAR] = ACTIONS(9387),
    [sym_raw_string] = ACTIONS(9390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(9393),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(9396),
    [anon_sym_BQUOTE] = ACTIONS(9399),
    [anon_sym_LT_LPAREN] = ACTIONS(9402),
    [anon_sym_GT_LPAREN] = ACTIONS(9402),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9405),
    [anon_sym_LF] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
  },
  [3918] = {
    [sym_file_descriptor] = ACTIONS(1235),
    [sym_variable_name] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1239),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1239),
    [anon_sym_if] = ACTIONS(1239),
    [anon_sym_case] = ACTIONS(1239),
    [anon_sym_esac] = ACTIONS(6249),
    [anon_sym_SEMI_SEMI] = ACTIONS(2586),
    [anon_sym_function] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1239),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1235),
    [anon_sym_declare] = ACTIONS(1239),
    [anon_sym_typeset] = ACTIONS(1239),
    [anon_sym_export] = ACTIONS(1239),
    [anon_sym_readonly] = ACTIONS(1239),
    [anon_sym_local] = ACTIONS(1239),
    [anon_sym_unset] = ACTIONS(1239),
    [anon_sym_unsetenv] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_AMP_GT] = ACTIONS(1239),
    [anon_sym_AMP_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_AMP] = ACTIONS(1235),
    [anon_sym_GT_AMP] = ACTIONS(1235),
    [sym__special_character] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1235),
    [anon_sym_DOLLAR] = ACTIONS(1239),
    [sym_raw_string] = ACTIONS(1235),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1235),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1235),
    [anon_sym_BQUOTE] = ACTIONS(1235),
    [anon_sym_LT_LPAREN] = ACTIONS(1235),
    [anon_sym_GT_LPAREN] = ACTIONS(1235),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1239),
  },
  [3919] = {
    [anon_sym_SEMI] = ACTIONS(9408),
    [anon_sym_esac] = ACTIONS(2586),
    [anon_sym_SEMI_SEMI] = ACTIONS(2586),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(9410),
    [anon_sym_AMP] = ACTIONS(9410),
  },
  [3920] = {
    [sym_concatenation] = STATE(3917),
    [sym_string] = STATE(3544),
    [sym_simple_expansion] = STATE(3544),
    [sym_string_expansion] = STATE(3544),
    [sym_expansion] = STATE(3544),
    [sym_command_substitution] = STATE(3544),
    [sym_process_substitution] = STATE(3544),
    [aux_sym_command_repeat2] = STATE(3917),
    [aux_sym__literal_repeat1] = STATE(3546),
    [sym__simple_heredoc_body] = ACTIONS(2676),
    [sym__heredoc_body_beginning] = ACTIONS(2676),
    [sym_file_descriptor] = ACTIONS(2676),
    [anon_sym_SEMI] = ACTIONS(2678),
    [anon_sym_esac] = ACTIONS(2678),
    [anon_sym_PIPE] = ACTIONS(2678),
    [anon_sym_SEMI_SEMI] = ACTIONS(2676),
    [anon_sym_PIPE_AMP] = ACTIONS(2676),
    [anon_sym_AMP_AMP] = ACTIONS(2676),
    [anon_sym_PIPE_PIPE] = ACTIONS(2676),
    [anon_sym_EQ_TILDE] = ACTIONS(7979),
    [anon_sym_EQ_EQ] = ACTIONS(7979),
    [anon_sym_LT] = ACTIONS(2678),
    [anon_sym_GT] = ACTIONS(2678),
    [anon_sym_GT_GT] = ACTIONS(2676),
    [anon_sym_AMP_GT] = ACTIONS(2678),
    [anon_sym_AMP_GT_GT] = ACTIONS(2676),
    [anon_sym_LT_AMP] = ACTIONS(2676),
    [anon_sym_GT_AMP] = ACTIONS(2676),
    [anon_sym_LT_LT] = ACTIONS(2678),
    [anon_sym_LT_LT_DASH] = ACTIONS(2676),
    [anon_sym_LT_LT_LT] = ACTIONS(2676),
    [sym__special_character] = ACTIONS(7981),
    [anon_sym_DQUOTE] = ACTIONS(6718),
    [anon_sym_DOLLAR] = ACTIONS(6720),
    [sym_raw_string] = ACTIONS(7983),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(6724),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(6726),
    [anon_sym_BQUOTE] = ACTIONS(6728),
    [anon_sym_LT_LPAREN] = ACTIONS(6730),
    [anon_sym_GT_LPAREN] = ACTIONS(6730),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7985),
    [anon_sym_LF] = ACTIONS(2676),
    [anon_sym_AMP] = ACTIONS(2678),
  },
  [3921] = {
    [anon_sym_esac] = ACTIONS(9412),
    [sym__special_character] = ACTIONS(9414),
    [anon_sym_DQUOTE] = ACTIONS(9414),
    [anon_sym_DOLLAR] = ACTIONS(9416),
    [sym_raw_string] = ACTIONS(9414),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(9414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(9414),
    [anon_sym_BQUOTE] = ACTIONS(9414),
    [anon_sym_LT_LPAREN] = ACTIONS(9414),
    [anon_sym_GT_LPAREN] = ACTIONS(9414),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9416),
  },
  [3922] = {
    [sym__special_character] = ACTIONS(7887),
    [anon_sym_DQUOTE] = ACTIONS(7887),
    [anon_sym_DOLLAR] = ACTIONS(7889),
    [sym_raw_string] = ACTIONS(7887),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7887),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7887),
    [anon_sym_BQUOTE] = ACTIONS(7887),
    [anon_sym_LT_LPAREN] = ACTIONS(7887),
    [anon_sym_GT_LPAREN] = ACTIONS(7887),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7887),
  },
  [3923] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(9418),
    [sym_comment] = ACTIONS(57),
  },
  [3924] = {
    [sym_file_redirect] = STATE(1332),
    [sym_heredoc_redirect] = STATE(1332),
    [sym_heredoc_body] = STATE(4153),
    [sym_herestring_redirect] = STATE(1332),
    [aux_sym_redirected_statement_repeat1] = STATE(1332),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(2658),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(2662),
    [anon_sym_SEMI_SEMI] = ACTIONS(399),
    [anon_sym_PIPE_AMP] = ACTIONS(2666),
    [anon_sym_AMP_AMP] = ACTIONS(2668),
    [anon_sym_PIPE_PIPE] = ACTIONS(2668),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_GT] = ACTIONS(2670),
    [anon_sym_GT_GT] = ACTIONS(2672),
    [anon_sym_AMP_GT] = ACTIONS(2670),
    [anon_sym_AMP_GT_GT] = ACTIONS(2672),
    [anon_sym_LT_AMP] = ACTIONS(2672),
    [anon_sym_GT_AMP] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(2674),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(401),
  },
  [3925] = {
    [sym_file_redirect] = STATE(1332),
    [sym_heredoc_redirect] = STATE(1332),
    [sym_heredoc_body] = STATE(4153),
    [sym_herestring_redirect] = STATE(1332),
    [aux_sym_redirected_statement_repeat1] = STATE(1332),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(2662),
    [anon_sym_SEMI_SEMI] = ACTIONS(399),
    [anon_sym_PIPE_AMP] = ACTIONS(2666),
    [anon_sym_AMP_AMP] = ACTIONS(2668),
    [anon_sym_PIPE_PIPE] = ACTIONS(2668),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(2674),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(401),
  },
  [3926] = {
    [sym_redirected_statement] = STATE(4154),
    [sym_for_statement] = STATE(4154),
    [sym_c_style_for_statement] = STATE(4154),
    [sym_while_statement] = STATE(4154),
    [sym_if_statement] = STATE(4154),
    [sym_case_statement] = STATE(4154),
    [sym_function_definition] = STATE(4154),
    [sym_compound_statement] = STATE(4154),
    [sym_subshell] = STATE(4154),
    [sym_pipeline] = STATE(4154),
    [sym_list] = STATE(4154),
    [sym_negated_command] = STATE(4154),
    [sym_test_command] = STATE(4154),
    [sym_declaration_command] = STATE(4154),
    [sym_unset_command] = STATE(4154),
    [sym_command] = STATE(4154),
    [sym_command_name] = STATE(713),
    [sym_variable_assignment] = STATE(4155),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(715),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(251),
    [aux_sym_command_repeat1] = STATE(715),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4323),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4325),
    [anon_sym_typeset] = ACTIONS(4325),
    [anon_sym_export] = ACTIONS(4325),
    [anon_sym_readonly] = ACTIONS(4325),
    [anon_sym_local] = ACTIONS(4325),
    [anon_sym_unset] = ACTIONS(4327),
    [anon_sym_unsetenv] = ACTIONS(4327),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [3927] = {
    [sym__statements] = STATE(4156),
    [sym_redirected_statement] = STATE(3924),
    [sym_for_statement] = STATE(3924),
    [sym_c_style_for_statement] = STATE(3924),
    [sym_while_statement] = STATE(3924),
    [sym_if_statement] = STATE(3924),
    [sym_case_statement] = STATE(3924),
    [sym_function_definition] = STATE(3924),
    [sym_compound_statement] = STATE(3924),
    [sym_subshell] = STATE(3924),
    [sym_pipeline] = STATE(3924),
    [sym_list] = STATE(3924),
    [sym_negated_command] = STATE(3924),
    [sym_test_command] = STATE(3924),
    [sym_declaration_command] = STATE(3924),
    [sym_unset_command] = STATE(3924),
    [sym_command] = STATE(3924),
    [sym_command_name] = STATE(713),
    [sym_variable_assignment] = STATE(3925),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(715),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(3926),
    [aux_sym_command_repeat1] = STATE(715),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_SEMI_SEMI] = ACTIONS(9418),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4323),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4325),
    [anon_sym_typeset] = ACTIONS(4325),
    [anon_sym_export] = ACTIONS(4325),
    [anon_sym_readonly] = ACTIONS(4325),
    [anon_sym_local] = ACTIONS(4325),
    [anon_sym_unset] = ACTIONS(4327),
    [anon_sym_unsetenv] = ACTIONS(4327),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [3928] = {
    [sym__special_character] = ACTIONS(8002),
    [anon_sym_DQUOTE] = ACTIONS(8002),
    [anon_sym_DOLLAR] = ACTIONS(8004),
    [sym_raw_string] = ACTIONS(8002),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8002),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8002),
    [anon_sym_BQUOTE] = ACTIONS(8002),
    [anon_sym_LT_LPAREN] = ACTIONS(8002),
    [anon_sym_GT_LPAREN] = ACTIONS(8002),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8002),
  },
  [3929] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(9420),
    [sym_comment] = ACTIONS(57),
  },
  [3930] = {
    [sym__statements] = STATE(4158),
    [sym_redirected_statement] = STATE(3924),
    [sym_for_statement] = STATE(3924),
    [sym_c_style_for_statement] = STATE(3924),
    [sym_while_statement] = STATE(3924),
    [sym_if_statement] = STATE(3924),
    [sym_case_statement] = STATE(3924),
    [sym_function_definition] = STATE(3924),
    [sym_compound_statement] = STATE(3924),
    [sym_subshell] = STATE(3924),
    [sym_pipeline] = STATE(3924),
    [sym_list] = STATE(3924),
    [sym_negated_command] = STATE(3924),
    [sym_test_command] = STATE(3924),
    [sym_declaration_command] = STATE(3924),
    [sym_unset_command] = STATE(3924),
    [sym_command] = STATE(3924),
    [sym_command_name] = STATE(713),
    [sym_variable_assignment] = STATE(3925),
    [sym_subscript] = STATE(228),
    [sym_file_redirect] = STATE(715),
    [sym_concatenation] = STATE(33),
    [sym_string] = STATE(222),
    [sym_simple_expansion] = STATE(222),
    [sym_string_expansion] = STATE(222),
    [sym_expansion] = STATE(222),
    [sym_command_substitution] = STATE(222),
    [sym_process_substitution] = STATE(222),
    [aux_sym__statements_repeat1] = STATE(3926),
    [aux_sym_command_repeat1] = STATE(715),
    [aux_sym__literal_repeat1] = STATE(231),
    [sym_file_descriptor] = ACTIONS(5),
    [sym_variable_name] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(11),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(13),
    [anon_sym_while] = ACTIONS(15),
    [anon_sym_if] = ACTIONS(17),
    [anon_sym_case] = ACTIONS(19),
    [anon_sym_SEMI_SEMI] = ACTIONS(9420),
    [anon_sym_function] = ACTIONS(21),
    [anon_sym_LPAREN] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(4323),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(31),
    [anon_sym_declare] = ACTIONS(4325),
    [anon_sym_typeset] = ACTIONS(4325),
    [anon_sym_export] = ACTIONS(4325),
    [anon_sym_readonly] = ACTIONS(4325),
    [anon_sym_local] = ACTIONS(4325),
    [anon_sym_unset] = ACTIONS(4327),
    [anon_sym_unsetenv] = ACTIONS(4327),
    [anon_sym_LT] = ACTIONS(37),
    [anon_sym_GT] = ACTIONS(37),
    [anon_sym_GT_GT] = ACTIONS(39),
    [anon_sym_AMP_GT] = ACTIONS(37),
    [anon_sym_AMP_GT_GT] = ACTIONS(39),
    [anon_sym_LT_AMP] = ACTIONS(39),
    [anon_sym_GT_AMP] = ACTIONS(39),
    [sym__special_character] = ACTIONS(381),
    [anon_sym_DQUOTE] = ACTIONS(43),
    [anon_sym_DOLLAR] = ACTIONS(45),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(49),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(53),
    [anon_sym_LT_LPAREN] = ACTIONS(55),
    [anon_sym_GT_LPAREN] = ACTIONS(55),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(385),
  },
  [3931] = {
    [anon_sym_esac] = ACTIONS(9422),
    [sym__special_character] = ACTIONS(9424),
    [anon_sym_DQUOTE] = ACTIONS(9424),
    [anon_sym_DOLLAR] = ACTIONS(9426),
    [sym_raw_string] = ACTIONS(9424),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(9424),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(9424),
    [anon_sym_BQUOTE] = ACTIONS(9424),
    [anon_sym_LT_LPAREN] = ACTIONS(9424),
    [anon_sym_GT_LPAREN] = ACTIONS(9424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9426),
  },
  [3932] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [sym_variable_name] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_RBRACE] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7042),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [3933] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [sym_variable_name] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_RBRACE] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7046),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [3934] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [sym_variable_name] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_RBRACE] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7050),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [3935] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9428),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3936] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9430),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3937] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [sym_variable_name] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_RBRACE] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7084),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [3938] = {
    [sym__simple_heredoc_body] = ACTIONS(8204),
    [sym__heredoc_body_beginning] = ACTIONS(8204),
    [sym_file_descriptor] = ACTIONS(8204),
    [anon_sym_SEMI] = ACTIONS(8206),
    [anon_sym_PIPE] = ACTIONS(8206),
    [anon_sym_SEMI_SEMI] = ACTIONS(8204),
    [anon_sym_RBRACE] = ACTIONS(8204),
    [anon_sym_PIPE_AMP] = ACTIONS(8204),
    [anon_sym_AMP_AMP] = ACTIONS(8204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8204),
    [anon_sym_LT] = ACTIONS(8206),
    [anon_sym_GT] = ACTIONS(8206),
    [anon_sym_GT_GT] = ACTIONS(8204),
    [anon_sym_AMP_GT] = ACTIONS(8206),
    [anon_sym_AMP_GT_GT] = ACTIONS(8204),
    [anon_sym_LT_AMP] = ACTIONS(8204),
    [anon_sym_GT_AMP] = ACTIONS(8204),
    [anon_sym_LT_LT] = ACTIONS(8206),
    [anon_sym_LT_LT_DASH] = ACTIONS(8204),
    [anon_sym_LT_LT_LT] = ACTIONS(8204),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8204),
    [anon_sym_AMP] = ACTIONS(8206),
  },
  [3939] = {
    [sym_do_group] = STATE(4161),
    [sym_compound_statement] = STATE(4161),
    [anon_sym_do] = ACTIONS(1945),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [3940] = {
    [sym_do_group] = STATE(4161),
    [sym_compound_statement] = STATE(4161),
    [anon_sym_SEMI] = ACTIONS(9432),
    [anon_sym_do] = ACTIONS(1945),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [3941] = {
    [sym__simple_heredoc_body] = ACTIONS(8817),
    [sym__heredoc_body_beginning] = ACTIONS(8817),
    [sym_file_descriptor] = ACTIONS(8817),
    [anon_sym_SEMI] = ACTIONS(8819),
    [anon_sym_PIPE] = ACTIONS(8819),
    [anon_sym_SEMI_SEMI] = ACTIONS(8817),
    [anon_sym_RBRACE] = ACTIONS(8817),
    [anon_sym_PIPE_AMP] = ACTIONS(8817),
    [anon_sym_AMP_AMP] = ACTIONS(8817),
    [anon_sym_PIPE_PIPE] = ACTIONS(8817),
    [anon_sym_LT] = ACTIONS(8819),
    [anon_sym_GT] = ACTIONS(8819),
    [anon_sym_GT_GT] = ACTIONS(8817),
    [anon_sym_AMP_GT] = ACTIONS(8819),
    [anon_sym_AMP_GT_GT] = ACTIONS(8817),
    [anon_sym_LT_AMP] = ACTIONS(8817),
    [anon_sym_GT_AMP] = ACTIONS(8817),
    [anon_sym_LT_LT] = ACTIONS(8819),
    [anon_sym_LT_LT_DASH] = ACTIONS(8817),
    [anon_sym_LT_LT_LT] = ACTIONS(8817),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8817),
    [anon_sym_AMP] = ACTIONS(8819),
  },
  [3942] = {
    [sym__simple_heredoc_body] = ACTIONS(8821),
    [sym__heredoc_body_beginning] = ACTIONS(8821),
    [sym_file_descriptor] = ACTIONS(8821),
    [anon_sym_SEMI] = ACTIONS(8823),
    [anon_sym_PIPE] = ACTIONS(8823),
    [anon_sym_SEMI_SEMI] = ACTIONS(8821),
    [anon_sym_RBRACE] = ACTIONS(8821),
    [anon_sym_PIPE_AMP] = ACTIONS(8821),
    [anon_sym_AMP_AMP] = ACTIONS(8821),
    [anon_sym_PIPE_PIPE] = ACTIONS(8821),
    [anon_sym_LT] = ACTIONS(8823),
    [anon_sym_GT] = ACTIONS(8823),
    [anon_sym_GT_GT] = ACTIONS(8821),
    [anon_sym_AMP_GT] = ACTIONS(8823),
    [anon_sym_AMP_GT_GT] = ACTIONS(8821),
    [anon_sym_LT_AMP] = ACTIONS(8821),
    [anon_sym_GT_AMP] = ACTIONS(8821),
    [anon_sym_LT_LT] = ACTIONS(8823),
    [anon_sym_LT_LT_DASH] = ACTIONS(8821),
    [anon_sym_LT_LT_LT] = ACTIONS(8821),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8821),
    [anon_sym_AMP] = ACTIONS(8823),
  },
  [3943] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [sym_variable_name] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_RBRACE] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8146),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8146),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [3944] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [sym_variable_name] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_RBRACE] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8150),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8150),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [3945] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_RBRACE] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8146),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8146),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [3946] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_RBRACE] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8150),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8150),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [3947] = {
    [sym__concat] = ACTIONS(7040),
    [anon_sym_RBRACE] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
  },
  [3948] = {
    [sym__concat] = ACTIONS(7044),
    [anon_sym_RBRACE] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
  },
  [3949] = {
    [sym__concat] = ACTIONS(7048),
    [anon_sym_RBRACE] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
  },
  [3950] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9434),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3951] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9436),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3952] = {
    [sym__concat] = ACTIONS(7082),
    [anon_sym_RBRACE] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
  },
  [3953] = {
    [sym__concat] = ACTIONS(8144),
    [anon_sym_RBRACE] = ACTIONS(8144),
    [anon_sym_EQ] = ACTIONS(8146),
    [anon_sym_DASH] = ACTIONS(8146),
    [sym__special_character] = ACTIONS(8146),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_POUND] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_COLON] = ACTIONS(8146),
    [anon_sym_COLON_QMARK] = ACTIONS(8146),
    [anon_sym_COLON_DASH] = ACTIONS(8146),
    [anon_sym_PERCENT] = ACTIONS(8146),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(8146),
  },
  [3954] = {
    [sym__concat] = ACTIONS(8148),
    [anon_sym_RBRACE] = ACTIONS(8148),
    [anon_sym_EQ] = ACTIONS(8150),
    [anon_sym_DASH] = ACTIONS(8150),
    [sym__special_character] = ACTIONS(8150),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_POUND] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_COLON] = ACTIONS(8150),
    [anon_sym_COLON_QMARK] = ACTIONS(8150),
    [anon_sym_COLON_DASH] = ACTIONS(8150),
    [anon_sym_PERCENT] = ACTIONS(8150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(8150),
  },
  [3955] = {
    [sym__heredoc_body_middle] = ACTIONS(8144),
    [sym__heredoc_body_end] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
  },
  [3956] = {
    [sym__heredoc_body_middle] = ACTIONS(8148),
    [sym__heredoc_body_end] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
  },
  [3957] = {
    [sym__concat] = ACTIONS(8144),
    [anon_sym_RPAREN] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8144),
  },
  [3958] = {
    [sym__concat] = ACTIONS(8148),
    [anon_sym_RPAREN] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8148),
  },
  [3959] = {
    [sym__simple_heredoc_body] = ACTIONS(9438),
    [sym__heredoc_body_beginning] = ACTIONS(9438),
    [sym_file_descriptor] = ACTIONS(9438),
    [ts_builtin_sym_end] = ACTIONS(9438),
    [anon_sym_SEMI] = ACTIONS(9440),
    [anon_sym_done] = ACTIONS(9438),
    [anon_sym_fi] = ACTIONS(9438),
    [anon_sym_elif] = ACTIONS(9438),
    [anon_sym_else] = ACTIONS(9438),
    [anon_sym_esac] = ACTIONS(9438),
    [anon_sym_PIPE] = ACTIONS(9440),
    [anon_sym_RPAREN] = ACTIONS(9438),
    [anon_sym_SEMI_SEMI] = ACTIONS(9438),
    [anon_sym_PIPE_AMP] = ACTIONS(9438),
    [anon_sym_AMP_AMP] = ACTIONS(9438),
    [anon_sym_PIPE_PIPE] = ACTIONS(9438),
    [anon_sym_LT] = ACTIONS(9440),
    [anon_sym_GT] = ACTIONS(9440),
    [anon_sym_GT_GT] = ACTIONS(9438),
    [anon_sym_AMP_GT] = ACTIONS(9440),
    [anon_sym_AMP_GT_GT] = ACTIONS(9438),
    [anon_sym_LT_AMP] = ACTIONS(9438),
    [anon_sym_GT_AMP] = ACTIONS(9438),
    [anon_sym_LT_LT] = ACTIONS(9440),
    [anon_sym_LT_LT_DASH] = ACTIONS(9438),
    [anon_sym_LT_LT_LT] = ACTIONS(9438),
    [anon_sym_BQUOTE] = ACTIONS(9438),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(9438),
    [anon_sym_AMP] = ACTIONS(9440),
  },
  [3960] = {
    [sym__concat] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8144),
  },
  [3961] = {
    [sym__concat] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8148),
  },
  [3962] = {
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [sym_variable_name] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [3963] = {
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [sym_variable_name] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [3964] = {
    [sym_file_descriptor] = ACTIONS(8885),
    [anon_sym_SEMI] = ACTIONS(8887),
    [anon_sym_PIPE] = ACTIONS(8887),
    [anon_sym_SEMI_SEMI] = ACTIONS(8885),
    [anon_sym_PIPE_AMP] = ACTIONS(8885),
    [anon_sym_AMP_AMP] = ACTIONS(8885),
    [anon_sym_PIPE_PIPE] = ACTIONS(8885),
    [anon_sym_LT] = ACTIONS(8887),
    [anon_sym_GT] = ACTIONS(8887),
    [anon_sym_GT_GT] = ACTIONS(8885),
    [anon_sym_AMP_GT] = ACTIONS(8887),
    [anon_sym_AMP_GT_GT] = ACTIONS(8885),
    [anon_sym_LT_AMP] = ACTIONS(8885),
    [anon_sym_GT_AMP] = ACTIONS(8885),
    [anon_sym_LT_LT] = ACTIONS(8887),
    [anon_sym_LT_LT_DASH] = ACTIONS(8885),
    [anon_sym_LT_LT_LT] = ACTIONS(8885),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8885),
    [anon_sym_AMP] = ACTIONS(8887),
  },
  [3965] = {
    [sym_do_group] = STATE(4165),
    [sym_compound_statement] = STATE(4165),
    [anon_sym_do] = ACTIONS(1627),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_comment] = ACTIONS(57),
  },
  [3966] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [sym_variable_name] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_done] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [3967] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [sym_variable_name] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_done] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [3968] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(9442),
    [sym_comment] = ACTIONS(57),
  },
  [3969] = {
    [anon_sym_RBRACE] = ACTIONS(9442),
    [sym_comment] = ACTIONS(57),
  },
  [3970] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(9444),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3971] = {
    [sym_concatenation] = STATE(4169),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4169),
    [anon_sym_RBRACE] = ACTIONS(9446),
    [anon_sym_EQ] = ACTIONS(9448),
    [anon_sym_DASH] = ACTIONS(9448),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9450),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9448),
    [anon_sym_COLON_QMARK] = ACTIONS(9448),
    [anon_sym_COLON_DASH] = ACTIONS(9448),
    [anon_sym_PERCENT] = ACTIONS(9448),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3972] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [sym_variable_name] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_done] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [3973] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9446),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3974] = {
    [sym_concatenation] = STATE(4170),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4170),
    [anon_sym_RBRACE] = ACTIONS(9442),
    [anon_sym_EQ] = ACTIONS(9452),
    [anon_sym_DASH] = ACTIONS(9452),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9452),
    [anon_sym_COLON_QMARK] = ACTIONS(9452),
    [anon_sym_COLON_DASH] = ACTIONS(9452),
    [anon_sym_PERCENT] = ACTIONS(9452),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3975] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9442),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3976] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [sym_variable_name] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_done] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [3977] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9456),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3978] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [sym_variable_name] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_done] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7042),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [3979] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [sym_variable_name] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_done] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7046),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [3980] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [sym_variable_name] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_done] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7050),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [3981] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9458),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3982] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9460),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3983] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [sym_variable_name] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_done] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7084),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [3984] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_done] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7042),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [3985] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_done] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7046),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [3986] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_done] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7050),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [3987] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9462),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3988] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9464),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3989] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_done] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7084),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [3990] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_done] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_EQ_TILDE] = ACTIONS(8146),
    [anon_sym_EQ_EQ] = ACTIONS(8146),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [3991] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_done] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_EQ_TILDE] = ACTIONS(8150),
    [anon_sym_EQ_EQ] = ACTIONS(8150),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [3992] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_done] = ACTIONS(5564),
    [anon_sym_fi] = ACTIONS(5564),
    [anon_sym_elif] = ACTIONS(5564),
    [anon_sym_else] = ACTIONS(5564),
    [anon_sym_esac] = ACTIONS(5564),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [3993] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_done] = ACTIONS(5598),
    [anon_sym_fi] = ACTIONS(5598),
    [anon_sym_elif] = ACTIONS(5598),
    [anon_sym_else] = ACTIONS(5598),
    [anon_sym_esac] = ACTIONS(5598),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [3994] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(9466),
    [sym_comment] = ACTIONS(57),
  },
  [3995] = {
    [anon_sym_RBRACE] = ACTIONS(9466),
    [sym_comment] = ACTIONS(57),
  },
  [3996] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(9468),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [3997] = {
    [sym_concatenation] = STATE(4179),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4179),
    [anon_sym_RBRACE] = ACTIONS(9470),
    [anon_sym_EQ] = ACTIONS(9472),
    [anon_sym_DASH] = ACTIONS(9472),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9472),
    [anon_sym_COLON_QMARK] = ACTIONS(9472),
    [anon_sym_COLON_DASH] = ACTIONS(9472),
    [anon_sym_PERCENT] = ACTIONS(9472),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [3998] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_done] = ACTIONS(5615),
    [anon_sym_fi] = ACTIONS(5615),
    [anon_sym_elif] = ACTIONS(5615),
    [anon_sym_else] = ACTIONS(5615),
    [anon_sym_esac] = ACTIONS(5615),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [3999] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9470),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4000] = {
    [sym_concatenation] = STATE(4180),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4180),
    [anon_sym_RBRACE] = ACTIONS(9466),
    [anon_sym_EQ] = ACTIONS(9476),
    [anon_sym_DASH] = ACTIONS(9476),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9478),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9476),
    [anon_sym_COLON_QMARK] = ACTIONS(9476),
    [anon_sym_COLON_DASH] = ACTIONS(9476),
    [anon_sym_PERCENT] = ACTIONS(9476),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4001] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9466),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4002] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_done] = ACTIONS(5658),
    [anon_sym_fi] = ACTIONS(5658),
    [anon_sym_elif] = ACTIONS(5658),
    [anon_sym_else] = ACTIONS(5658),
    [anon_sym_esac] = ACTIONS(5658),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [4003] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9480),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4004] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [sym_variable_name] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_fi] = ACTIONS(5566),
    [anon_sym_elif] = ACTIONS(5566),
    [anon_sym_else] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [4005] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [sym_variable_name] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_fi] = ACTIONS(5600),
    [anon_sym_elif] = ACTIONS(5600),
    [anon_sym_else] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [4006] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(9482),
    [sym_comment] = ACTIONS(57),
  },
  [4007] = {
    [anon_sym_RBRACE] = ACTIONS(9482),
    [sym_comment] = ACTIONS(57),
  },
  [4008] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(9484),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [4009] = {
    [sym_concatenation] = STATE(4185),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4185),
    [anon_sym_RBRACE] = ACTIONS(9486),
    [anon_sym_EQ] = ACTIONS(9488),
    [anon_sym_DASH] = ACTIONS(9488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9488),
    [anon_sym_COLON_QMARK] = ACTIONS(9488),
    [anon_sym_COLON_DASH] = ACTIONS(9488),
    [anon_sym_PERCENT] = ACTIONS(9488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4010] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [sym_variable_name] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_fi] = ACTIONS(5617),
    [anon_sym_elif] = ACTIONS(5617),
    [anon_sym_else] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [4011] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9486),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4012] = {
    [sym_concatenation] = STATE(4186),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4186),
    [anon_sym_RBRACE] = ACTIONS(9482),
    [anon_sym_EQ] = ACTIONS(9492),
    [anon_sym_DASH] = ACTIONS(9492),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9494),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9492),
    [anon_sym_COLON_QMARK] = ACTIONS(9492),
    [anon_sym_COLON_DASH] = ACTIONS(9492),
    [anon_sym_PERCENT] = ACTIONS(9492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4013] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9482),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4014] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [sym_variable_name] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_fi] = ACTIONS(5660),
    [anon_sym_elif] = ACTIONS(5660),
    [anon_sym_else] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [4015] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9496),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4016] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [sym_variable_name] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_fi] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [4017] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [sym_variable_name] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_fi] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [4018] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(9498),
    [sym_comment] = ACTIONS(57),
  },
  [4019] = {
    [anon_sym_RBRACE] = ACTIONS(9498),
    [sym_comment] = ACTIONS(57),
  },
  [4020] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(9500),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [4021] = {
    [sym_concatenation] = STATE(4191),
    [sym_string] = STATE(4190),
    [sym_simple_expansion] = STATE(4190),
    [sym_string_expansion] = STATE(4190),
    [sym_expansion] = STATE(4190),
    [sym_command_substitution] = STATE(4190),
    [sym_process_substitution] = STATE(4190),
    [aux_sym__literal_repeat1] = STATE(4192),
    [anon_sym_RBRACE] = ACTIONS(9498),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(9502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9502),
  },
  [4022] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [sym_variable_name] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_fi] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [4023] = {
    [sym_concatenation] = STATE(4195),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4195),
    [sym_regex] = ACTIONS(9504),
    [anon_sym_RBRACE] = ACTIONS(9506),
    [anon_sym_EQ] = ACTIONS(9508),
    [anon_sym_DASH] = ACTIONS(9508),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9508),
    [anon_sym_COLON_QMARK] = ACTIONS(9508),
    [anon_sym_COLON_DASH] = ACTIONS(9508),
    [anon_sym_PERCENT] = ACTIONS(9508),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4024] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9506),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4025] = {
    [sym_concatenation] = STATE(4197),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4197),
    [sym_regex] = ACTIONS(9512),
    [anon_sym_RBRACE] = ACTIONS(9498),
    [anon_sym_EQ] = ACTIONS(9514),
    [anon_sym_DASH] = ACTIONS(9514),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9516),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9514),
    [anon_sym_COLON_QMARK] = ACTIONS(9514),
    [anon_sym_COLON_DASH] = ACTIONS(9514),
    [anon_sym_PERCENT] = ACTIONS(9514),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4026] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9498),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4027] = {
    [sym_concatenation] = STATE(4199),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4199),
    [anon_sym_RBRACE] = ACTIONS(9518),
    [anon_sym_EQ] = ACTIONS(9520),
    [anon_sym_DASH] = ACTIONS(9520),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9522),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9520),
    [anon_sym_COLON_QMARK] = ACTIONS(9520),
    [anon_sym_COLON_DASH] = ACTIONS(9520),
    [anon_sym_PERCENT] = ACTIONS(9520),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4028] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [sym_variable_name] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_fi] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [4029] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9518),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4030] = {
    [sym_concatenation] = STATE(4197),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4197),
    [anon_sym_RBRACE] = ACTIONS(9498),
    [anon_sym_EQ] = ACTIONS(9514),
    [anon_sym_DASH] = ACTIONS(9514),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9516),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9514),
    [anon_sym_COLON_QMARK] = ACTIONS(9514),
    [anon_sym_COLON_DASH] = ACTIONS(9514),
    [anon_sym_PERCENT] = ACTIONS(9514),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4031] = {
    [sym__simple_heredoc_body] = ACTIONS(4383),
    [sym__heredoc_body_beginning] = ACTIONS(4383),
    [sym_file_descriptor] = ACTIONS(4383),
    [sym_variable_name] = ACTIONS(4383),
    [anon_sym_SEMI] = ACTIONS(4385),
    [anon_sym_fi] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI_SEMI] = ACTIONS(4383),
    [anon_sym_PIPE_AMP] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_AMP_GT] = ACTIONS(4385),
    [anon_sym_AMP_GT_GT] = ACTIONS(4383),
    [anon_sym_LT_AMP] = ACTIONS(4383),
    [anon_sym_GT_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_LT_LT_DASH] = ACTIONS(4383),
    [anon_sym_LT_LT_LT] = ACTIONS(4383),
    [sym__special_character] = ACTIONS(4383),
    [anon_sym_DQUOTE] = ACTIONS(4383),
    [anon_sym_DOLLAR] = ACTIONS(4385),
    [sym_raw_string] = ACTIONS(4383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4383),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4383),
    [anon_sym_BQUOTE] = ACTIONS(4383),
    [anon_sym_LT_LPAREN] = ACTIONS(4383),
    [anon_sym_GT_LPAREN] = ACTIONS(4383),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4385),
    [sym_word] = ACTIONS(4385),
    [anon_sym_LF] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
  },
  [4032] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [sym_variable_name] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_fi] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5566),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [4033] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [sym_variable_name] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_fi] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5600),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [4034] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(9524),
    [sym_comment] = ACTIONS(57),
  },
  [4035] = {
    [anon_sym_RBRACE] = ACTIONS(9524),
    [sym_comment] = ACTIONS(57),
  },
  [4036] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(9526),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [4037] = {
    [sym_concatenation] = STATE(4203),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4203),
    [anon_sym_RBRACE] = ACTIONS(9528),
    [anon_sym_EQ] = ACTIONS(9530),
    [anon_sym_DASH] = ACTIONS(9530),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9532),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9530),
    [anon_sym_COLON_QMARK] = ACTIONS(9530),
    [anon_sym_COLON_DASH] = ACTIONS(9530),
    [anon_sym_PERCENT] = ACTIONS(9530),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4038] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [sym_variable_name] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_fi] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5617),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [4039] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9528),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4040] = {
    [sym_concatenation] = STATE(4204),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4204),
    [anon_sym_RBRACE] = ACTIONS(9524),
    [anon_sym_EQ] = ACTIONS(9534),
    [anon_sym_DASH] = ACTIONS(9534),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9536),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9534),
    [anon_sym_COLON_QMARK] = ACTIONS(9534),
    [anon_sym_COLON_DASH] = ACTIONS(9534),
    [anon_sym_PERCENT] = ACTIONS(9534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4041] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9524),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4042] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [sym_variable_name] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_fi] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5660),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [4043] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9538),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4044] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_fi] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5566),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [4045] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_fi] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5600),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [4046] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(9540),
    [sym_comment] = ACTIONS(57),
  },
  [4047] = {
    [anon_sym_RBRACE] = ACTIONS(9540),
    [sym_comment] = ACTIONS(57),
  },
  [4048] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(9542),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [4049] = {
    [sym_concatenation] = STATE(4209),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4209),
    [anon_sym_RBRACE] = ACTIONS(9544),
    [anon_sym_EQ] = ACTIONS(9546),
    [anon_sym_DASH] = ACTIONS(9546),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9546),
    [anon_sym_COLON_QMARK] = ACTIONS(9546),
    [anon_sym_COLON_DASH] = ACTIONS(9546),
    [anon_sym_PERCENT] = ACTIONS(9546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4050] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_fi] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5617),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [4051] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9544),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4052] = {
    [sym_concatenation] = STATE(4210),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4210),
    [anon_sym_RBRACE] = ACTIONS(9540),
    [anon_sym_EQ] = ACTIONS(9550),
    [anon_sym_DASH] = ACTIONS(9550),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9552),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9550),
    [anon_sym_COLON_QMARK] = ACTIONS(9550),
    [anon_sym_COLON_DASH] = ACTIONS(9550),
    [anon_sym_PERCENT] = ACTIONS(9550),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4053] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9540),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4054] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_fi] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5660),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [4055] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9554),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4056] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_fi] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_EQ_TILDE] = ACTIONS(7042),
    [anon_sym_EQ_EQ] = ACTIONS(7042),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [4057] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_fi] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_EQ_TILDE] = ACTIONS(7046),
    [anon_sym_EQ_EQ] = ACTIONS(7046),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [4058] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_fi] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_EQ_TILDE] = ACTIONS(7050),
    [anon_sym_EQ_EQ] = ACTIONS(7050),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [4059] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9556),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4060] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9558),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4061] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_fi] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_EQ_TILDE] = ACTIONS(7084),
    [anon_sym_EQ_EQ] = ACTIONS(7084),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [4062] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [sym_variable_name] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_fi] = ACTIONS(7042),
    [anon_sym_elif] = ACTIONS(7042),
    [anon_sym_else] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7042),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [4063] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [sym_variable_name] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_fi] = ACTIONS(7046),
    [anon_sym_elif] = ACTIONS(7046),
    [anon_sym_else] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7046),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [4064] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [sym_variable_name] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_fi] = ACTIONS(7050),
    [anon_sym_elif] = ACTIONS(7050),
    [anon_sym_else] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7050),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [4065] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9560),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4066] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9562),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4067] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [sym_variable_name] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_fi] = ACTIONS(7084),
    [anon_sym_elif] = ACTIONS(7084),
    [anon_sym_else] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7084),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [4068] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_fi] = ACTIONS(7042),
    [anon_sym_elif] = ACTIONS(7042),
    [anon_sym_else] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7042),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [4069] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_fi] = ACTIONS(7046),
    [anon_sym_elif] = ACTIONS(7046),
    [anon_sym_else] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7046),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [4070] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_fi] = ACTIONS(7050),
    [anon_sym_elif] = ACTIONS(7050),
    [anon_sym_else] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7050),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [4071] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9564),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4072] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9566),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4073] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_fi] = ACTIONS(7084),
    [anon_sym_elif] = ACTIONS(7084),
    [anon_sym_else] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7084),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [4074] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_fi] = ACTIONS(8146),
    [anon_sym_elif] = ACTIONS(8146),
    [anon_sym_else] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_EQ_TILDE] = ACTIONS(8146),
    [anon_sym_EQ_EQ] = ACTIONS(8146),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [4075] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_fi] = ACTIONS(8150),
    [anon_sym_elif] = ACTIONS(8150),
    [anon_sym_else] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_EQ_TILDE] = ACTIONS(8150),
    [anon_sym_EQ_EQ] = ACTIONS(8150),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [4076] = {
    [sym__simple_heredoc_body] = ACTIONS(2697),
    [sym__heredoc_body_beginning] = ACTIONS(2697),
    [sym_file_descriptor] = ACTIONS(2697),
    [sym_variable_name] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym_esac] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI_SEMI] = ACTIONS(2697),
    [anon_sym_PIPE_AMP] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_PIPE_PIPE] = ACTIONS(2697),
    [anon_sym_LT] = ACTIONS(2699),
    [anon_sym_GT] = ACTIONS(2699),
    [anon_sym_GT_GT] = ACTIONS(2697),
    [anon_sym_AMP_GT] = ACTIONS(2699),
    [anon_sym_AMP_GT_GT] = ACTIONS(2697),
    [anon_sym_LT_AMP] = ACTIONS(2697),
    [anon_sym_GT_AMP] = ACTIONS(2697),
    [anon_sym_LT_LT] = ACTIONS(2699),
    [anon_sym_LT_LT_DASH] = ACTIONS(2697),
    [anon_sym_LT_LT_LT] = ACTIONS(2697),
    [sym__special_character] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [anon_sym_DOLLAR] = ACTIONS(2699),
    [sym_raw_string] = ACTIONS(2697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2697),
    [anon_sym_BQUOTE] = ACTIONS(2697),
    [anon_sym_LT_LPAREN] = ACTIONS(2697),
    [anon_sym_GT_LPAREN] = ACTIONS(2697),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2699),
    [anon_sym_LF] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
  },
  [4077] = {
    [sym_concatenation] = STATE(1357),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(1357),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(9568),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [4078] = {
    [sym_string] = STATE(4219),
    [sym_simple_expansion] = STATE(4219),
    [sym_string_expansion] = STATE(4219),
    [sym_expansion] = STATE(4219),
    [sym_command_substitution] = STATE(4219),
    [sym_process_substitution] = STATE(4219),
    [sym__special_character] = ACTIONS(9570),
    [anon_sym_DQUOTE] = ACTIONS(8656),
    [anon_sym_DOLLAR] = ACTIONS(8658),
    [sym_raw_string] = ACTIONS(9570),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8662),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8664),
    [anon_sym_BQUOTE] = ACTIONS(8666),
    [anon_sym_LT_LPAREN] = ACTIONS(8668),
    [anon_sym_GT_LPAREN] = ACTIONS(8668),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9570),
  },
  [4079] = {
    [aux_sym_concatenation_repeat1] = STATE(4220),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(9156),
    [sym_variable_name] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_esac] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym__special_character] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1059),
    [anon_sym_DOLLAR] = ACTIONS(1061),
    [sym_raw_string] = ACTIONS(1059),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1059),
    [anon_sym_BQUOTE] = ACTIONS(1059),
    [anon_sym_LT_LPAREN] = ACTIONS(1059),
    [anon_sym_GT_LPAREN] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1061),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [4080] = {
    [sym__simple_heredoc_body] = ACTIONS(1063),
    [sym__heredoc_body_beginning] = ACTIONS(1063),
    [sym_file_descriptor] = ACTIONS(1063),
    [sym__concat] = ACTIONS(1063),
    [sym_variable_name] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_esac] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_SEMI_SEMI] = ACTIONS(1063),
    [anon_sym_PIPE_AMP] = ACTIONS(1063),
    [anon_sym_AMP_AMP] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1065),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_AMP_GT] = ACTIONS(1065),
    [anon_sym_AMP_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_AMP] = ACTIONS(1063),
    [anon_sym_GT_AMP] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1065),
    [anon_sym_LT_LT_DASH] = ACTIONS(1063),
    [anon_sym_LT_LT_LT] = ACTIONS(1063),
    [sym__special_character] = ACTIONS(1063),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [sym_raw_string] = ACTIONS(1063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1063),
    [anon_sym_BQUOTE] = ACTIONS(1063),
    [anon_sym_LT_LPAREN] = ACTIONS(1063),
    [anon_sym_GT_LPAREN] = ACTIONS(1063),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1065),
    [anon_sym_LF] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1065),
  },
  [4081] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(9572),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [4082] = {
    [sym_simple_expansion] = STATE(201),
    [sym_expansion] = STATE(201),
    [sym_command_substitution] = STATE(201),
    [aux_sym_string_repeat1] = STATE(626),
    [anon_sym_DQUOTE] = ACTIONS(9572),
    [anon_sym_DOLLAR] = ACTIONS(9574),
    [sym__string_content] = ACTIONS(335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(337),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [sym_comment] = ACTIONS(343),
  },
  [4083] = {
    [sym__simple_heredoc_body] = ACTIONS(1097),
    [sym__heredoc_body_beginning] = ACTIONS(1097),
    [sym_file_descriptor] = ACTIONS(1097),
    [sym__concat] = ACTIONS(1097),
    [sym_variable_name] = ACTIONS(1097),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_esac] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1097),
    [anon_sym_PIPE_AMP] = ACTIONS(1097),
    [anon_sym_AMP_AMP] = ACTIONS(1097),
    [anon_sym_PIPE_PIPE] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1097),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1097),
    [anon_sym_LT_AMP] = ACTIONS(1097),
    [anon_sym_GT_AMP] = ACTIONS(1097),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1097),
    [anon_sym_LT_LT_LT] = ACTIONS(1097),
    [sym__special_character] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_DOLLAR] = ACTIONS(1099),
    [sym_raw_string] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1097),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1097),
    [anon_sym_BQUOTE] = ACTIONS(1097),
    [anon_sym_LT_LPAREN] = ACTIONS(1097),
    [anon_sym_GT_LPAREN] = ACTIONS(1097),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1097),
    [anon_sym_AMP] = ACTIONS(1099),
  },
  [4084] = {
    [sym__simple_heredoc_body] = ACTIONS(1101),
    [sym__heredoc_body_beginning] = ACTIONS(1101),
    [sym_file_descriptor] = ACTIONS(1101),
    [sym__concat] = ACTIONS(1101),
    [sym_variable_name] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_esac] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1101),
    [anon_sym_PIPE_AMP] = ACTIONS(1101),
    [anon_sym_AMP_AMP] = ACTIONS(1101),
    [anon_sym_PIPE_PIPE] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1101),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1101),
    [anon_sym_LT_AMP] = ACTIONS(1101),
    [anon_sym_GT_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1101),
    [sym__special_character] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1101),
    [anon_sym_DOLLAR] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(1101),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1101),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1101),
    [anon_sym_BQUOTE] = ACTIONS(1101),
    [anon_sym_LT_LPAREN] = ACTIONS(1101),
    [anon_sym_GT_LPAREN] = ACTIONS(1101),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_AMP] = ACTIONS(1103),
  },
  [4085] = {
    [sym__simple_heredoc_body] = ACTIONS(1105),
    [sym__heredoc_body_beginning] = ACTIONS(1105),
    [sym_file_descriptor] = ACTIONS(1105),
    [sym__concat] = ACTIONS(1105),
    [sym_variable_name] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_esac] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1107),
    [anon_sym_SEMI_SEMI] = ACTIONS(1105),
    [anon_sym_PIPE_AMP] = ACTIONS(1105),
    [anon_sym_AMP_AMP] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1105),
    [anon_sym_LT] = ACTIONS(1107),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_AMP_GT] = ACTIONS(1107),
    [anon_sym_AMP_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_AMP] = ACTIONS(1105),
    [anon_sym_GT_AMP] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1107),
    [anon_sym_LT_LT_DASH] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1105),
    [sym__special_character] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1105),
    [anon_sym_DOLLAR] = ACTIONS(1107),
    [sym_raw_string] = ACTIONS(1105),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1105),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1105),
    [anon_sym_BQUOTE] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(1105),
    [anon_sym_GT_LPAREN] = ACTIONS(1105),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_AMP] = ACTIONS(1107),
  },
  [4086] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(9576),
    [sym_comment] = ACTIONS(57),
  },
  [4087] = {
    [sym_subscript] = STATE(4226),
    [sym_variable_name] = ACTIONS(9578),
    [anon_sym_DASH] = ACTIONS(9580),
    [anon_sym_DOLLAR] = ACTIONS(9580),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(9582),
    [anon_sym_STAR] = ACTIONS(9584),
    [anon_sym_AT] = ACTIONS(9584),
    [anon_sym_QMARK] = ACTIONS(9584),
    [anon_sym_0] = ACTIONS(9582),
    [anon_sym__] = ACTIONS(9582),
  },
  [4088] = {
    [sym_concatenation] = STATE(4229),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4229),
    [anon_sym_RBRACE] = ACTIONS(9586),
    [anon_sym_EQ] = ACTIONS(9588),
    [anon_sym_DASH] = ACTIONS(9588),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9590),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(9592),
    [anon_sym_COLON] = ACTIONS(9588),
    [anon_sym_COLON_QMARK] = ACTIONS(9588),
    [anon_sym_COLON_DASH] = ACTIONS(9588),
    [anon_sym_PERCENT] = ACTIONS(9588),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4089] = {
    [sym_concatenation] = STATE(4232),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4232),
    [anon_sym_RBRACE] = ACTIONS(9594),
    [anon_sym_EQ] = ACTIONS(9596),
    [anon_sym_DASH] = ACTIONS(9596),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(9600),
    [anon_sym_COLON] = ACTIONS(9596),
    [anon_sym_COLON_QMARK] = ACTIONS(9596),
    [anon_sym_COLON_DASH] = ACTIONS(9596),
    [anon_sym_PERCENT] = ACTIONS(9596),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4090] = {
    [anon_sym_RPAREN] = ACTIONS(9602),
    [sym_comment] = ACTIONS(57),
  },
  [4091] = {
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_RPAREN] = ACTIONS(9602),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(433),
  },
  [4092] = {
    [anon_sym_BQUOTE] = ACTIONS(9602),
    [sym_comment] = ACTIONS(57),
  },
  [4093] = {
    [anon_sym_RPAREN] = ACTIONS(9604),
    [sym_comment] = ACTIONS(57),
  },
  [4094] = {
    [sym__simple_heredoc_body] = ACTIONS(325),
    [sym__heredoc_body_beginning] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_SEMI] = ACTIONS(329),
    [anon_sym_esac] = ACTIONS(329),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_SEMI_SEMI] = ACTIONS(325),
    [anon_sym_PIPE_AMP] = ACTIONS(325),
    [anon_sym_AMP_AMP] = ACTIONS(325),
    [anon_sym_PIPE_PIPE] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(329),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_LT_LT_DASH] = ACTIONS(325),
    [anon_sym_LT_LT_LT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(329),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(329),
    [anon_sym_LF] = ACTIONS(325),
    [anon_sym_AMP] = ACTIONS(329),
  },
  [4095] = {
    [aux_sym__literal_repeat1] = STATE(4095),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [sym_variable_name] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_esac] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(9606),
    [anon_sym_DQUOTE] = ACTIONS(1371),
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [sym_raw_string] = ACTIONS(1371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1371),
    [anon_sym_BQUOTE] = ACTIONS(1371),
    [anon_sym_LT_LPAREN] = ACTIONS(1371),
    [anon_sym_GT_LPAREN] = ACTIONS(1371),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1373),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [4096] = {
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_esac] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1400),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [4097] = {
    [sym_concatenation] = STATE(4236),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(4236),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(9609),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [4098] = {
    [aux_sym_concatenation_repeat1] = STATE(3849),
    [sym__simple_heredoc_body] = ACTIONS(1398),
    [sym__heredoc_body_beginning] = ACTIONS(1398),
    [sym_file_descriptor] = ACTIONS(1398),
    [sym__concat] = ACTIONS(8672),
    [sym_variable_name] = ACTIONS(1398),
    [anon_sym_SEMI] = ACTIONS(1400),
    [anon_sym_esac] = ACTIONS(1400),
    [anon_sym_PIPE] = ACTIONS(1400),
    [anon_sym_SEMI_SEMI] = ACTIONS(1398),
    [anon_sym_PIPE_AMP] = ACTIONS(1398),
    [anon_sym_AMP_AMP] = ACTIONS(1398),
    [anon_sym_PIPE_PIPE] = ACTIONS(1398),
    [anon_sym_LT] = ACTIONS(1400),
    [anon_sym_GT] = ACTIONS(1400),
    [anon_sym_GT_GT] = ACTIONS(1398),
    [anon_sym_AMP_GT] = ACTIONS(1400),
    [anon_sym_AMP_GT_GT] = ACTIONS(1398),
    [anon_sym_LT_AMP] = ACTIONS(1398),
    [anon_sym_GT_AMP] = ACTIONS(1398),
    [anon_sym_LT_LT] = ACTIONS(1400),
    [anon_sym_LT_LT_DASH] = ACTIONS(1398),
    [anon_sym_LT_LT_LT] = ACTIONS(1398),
    [sym__special_character] = ACTIONS(1398),
    [anon_sym_DQUOTE] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(1400),
    [sym_raw_string] = ACTIONS(1398),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1398),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1398),
    [anon_sym_LT_LPAREN] = ACTIONS(1398),
    [anon_sym_GT_LPAREN] = ACTIONS(1398),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1400),
    [sym_word] = ACTIONS(1400),
    [anon_sym_LF] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
  },
  [4099] = {
    [aux_sym__literal_repeat1] = STATE(3866),
    [sym__simple_heredoc_body] = ACTIONS(1444),
    [sym__heredoc_body_beginning] = ACTIONS(1444),
    [sym_file_descriptor] = ACTIONS(1444),
    [sym_variable_name] = ACTIONS(1444),
    [anon_sym_SEMI] = ACTIONS(1446),
    [anon_sym_esac] = ACTIONS(1446),
    [anon_sym_PIPE] = ACTIONS(1446),
    [anon_sym_SEMI_SEMI] = ACTIONS(1444),
    [anon_sym_PIPE_AMP] = ACTIONS(1444),
    [anon_sym_AMP_AMP] = ACTIONS(1444),
    [anon_sym_PIPE_PIPE] = ACTIONS(1444),
    [anon_sym_LT] = ACTIONS(1446),
    [anon_sym_GT] = ACTIONS(1446),
    [anon_sym_GT_GT] = ACTIONS(1444),
    [anon_sym_AMP_GT] = ACTIONS(1446),
    [anon_sym_AMP_GT_GT] = ACTIONS(1444),
    [anon_sym_LT_AMP] = ACTIONS(1444),
    [anon_sym_GT_AMP] = ACTIONS(1444),
    [anon_sym_LT_LT] = ACTIONS(1446),
    [anon_sym_LT_LT_DASH] = ACTIONS(1444),
    [anon_sym_LT_LT_LT] = ACTIONS(1444),
    [sym__special_character] = ACTIONS(8698),
    [anon_sym_DQUOTE] = ACTIONS(1444),
    [anon_sym_DOLLAR] = ACTIONS(1446),
    [sym_raw_string] = ACTIONS(1444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1444),
    [anon_sym_BQUOTE] = ACTIONS(1444),
    [anon_sym_LT_LPAREN] = ACTIONS(1444),
    [anon_sym_GT_LPAREN] = ACTIONS(1444),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1446),
    [sym_word] = ACTIONS(1446),
    [anon_sym_LF] = ACTIONS(1444),
    [anon_sym_AMP] = ACTIONS(1446),
  },
  [4100] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_esac] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [4101] = {
    [aux_sym_concatenation_repeat1] = STATE(4101),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(9611),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_esac] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [4102] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [sym_variable_name] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_esac] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2353),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [4103] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(9614),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [4104] = {
    [sym_concatenation] = STATE(4240),
    [sym_string] = STATE(4239),
    [sym_simple_expansion] = STATE(4239),
    [sym_string_expansion] = STATE(4239),
    [sym_expansion] = STATE(4239),
    [sym_command_substitution] = STATE(4239),
    [sym_process_substitution] = STATE(4239),
    [aux_sym__literal_repeat1] = STATE(4241),
    [anon_sym_RBRACE] = ACTIONS(9616),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(9618),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9618),
  },
  [4105] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(9620),
    [sym_comment] = ACTIONS(57),
  },
  [4106] = {
    [sym_concatenation] = STATE(4245),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4245),
    [anon_sym_RBRACE] = ACTIONS(9622),
    [anon_sym_EQ] = ACTIONS(9624),
    [anon_sym_DASH] = ACTIONS(9624),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9626),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(9628),
    [anon_sym_COLON] = ACTIONS(9624),
    [anon_sym_COLON_QMARK] = ACTIONS(9624),
    [anon_sym_COLON_DASH] = ACTIONS(9624),
    [anon_sym_PERCENT] = ACTIONS(9624),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4107] = {
    [sym_concatenation] = STATE(4247),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4247),
    [anon_sym_RBRACE] = ACTIONS(9616),
    [anon_sym_EQ] = ACTIONS(9630),
    [anon_sym_DASH] = ACTIONS(9630),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(9634),
    [anon_sym_COLON] = ACTIONS(9630),
    [anon_sym_COLON_QMARK] = ACTIONS(9630),
    [anon_sym_COLON_DASH] = ACTIONS(9630),
    [anon_sym_PERCENT] = ACTIONS(9630),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4108] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [sym_variable_name] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_esac] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2444),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [4109] = {
    [sym_concatenation] = STATE(4250),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4250),
    [sym_regex] = ACTIONS(9636),
    [anon_sym_RBRACE] = ACTIONS(9638),
    [anon_sym_EQ] = ACTIONS(9640),
    [anon_sym_DASH] = ACTIONS(9640),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9642),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9640),
    [anon_sym_COLON_QMARK] = ACTIONS(9640),
    [anon_sym_COLON_DASH] = ACTIONS(9640),
    [anon_sym_PERCENT] = ACTIONS(9640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4110] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9638),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4111] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [sym_variable_name] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_esac] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2494),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [4112] = {
    [sym_concatenation] = STATE(4247),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4247),
    [sym_regex] = ACTIONS(9644),
    [anon_sym_RBRACE] = ACTIONS(9616),
    [anon_sym_EQ] = ACTIONS(9630),
    [anon_sym_DASH] = ACTIONS(9630),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9632),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9630),
    [anon_sym_COLON_QMARK] = ACTIONS(9630),
    [anon_sym_COLON_DASH] = ACTIONS(9630),
    [anon_sym_PERCENT] = ACTIONS(9630),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4113] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9616),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4114] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [sym_variable_name] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_esac] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2502),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [4115] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_esac] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2536),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [4116] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_esac] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [4117] = {
    [aux_sym_concatenation_repeat1] = STATE(4117),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(9646),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_esac] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2346),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [4118] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_esac] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2353),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [4119] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(9649),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [4120] = {
    [sym_concatenation] = STATE(4255),
    [sym_string] = STATE(4254),
    [sym_simple_expansion] = STATE(4254),
    [sym_string_expansion] = STATE(4254),
    [sym_expansion] = STATE(4254),
    [sym_command_substitution] = STATE(4254),
    [sym_process_substitution] = STATE(4254),
    [aux_sym__literal_repeat1] = STATE(4256),
    [anon_sym_RBRACE] = ACTIONS(9651),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(9653),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9653),
  },
  [4121] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(9655),
    [sym_comment] = ACTIONS(57),
  },
  [4122] = {
    [sym_concatenation] = STATE(4260),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4260),
    [anon_sym_RBRACE] = ACTIONS(9657),
    [anon_sym_EQ] = ACTIONS(9659),
    [anon_sym_DASH] = ACTIONS(9659),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9661),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(9663),
    [anon_sym_COLON] = ACTIONS(9659),
    [anon_sym_COLON_QMARK] = ACTIONS(9659),
    [anon_sym_COLON_DASH] = ACTIONS(9659),
    [anon_sym_PERCENT] = ACTIONS(9659),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4123] = {
    [sym_concatenation] = STATE(4262),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4262),
    [anon_sym_RBRACE] = ACTIONS(9651),
    [anon_sym_EQ] = ACTIONS(9665),
    [anon_sym_DASH] = ACTIONS(9665),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(9669),
    [anon_sym_COLON] = ACTIONS(9665),
    [anon_sym_COLON_QMARK] = ACTIONS(9665),
    [anon_sym_COLON_DASH] = ACTIONS(9665),
    [anon_sym_PERCENT] = ACTIONS(9665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4124] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_esac] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2444),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [4125] = {
    [sym_concatenation] = STATE(4265),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4265),
    [sym_regex] = ACTIONS(9671),
    [anon_sym_RBRACE] = ACTIONS(9673),
    [anon_sym_EQ] = ACTIONS(9675),
    [anon_sym_DASH] = ACTIONS(9675),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9675),
    [anon_sym_COLON_QMARK] = ACTIONS(9675),
    [anon_sym_COLON_DASH] = ACTIONS(9675),
    [anon_sym_PERCENT] = ACTIONS(9675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4126] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9673),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4127] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_esac] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2494),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [4128] = {
    [sym_concatenation] = STATE(4262),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4262),
    [sym_regex] = ACTIONS(9679),
    [anon_sym_RBRACE] = ACTIONS(9651),
    [anon_sym_EQ] = ACTIONS(9665),
    [anon_sym_DASH] = ACTIONS(9665),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9665),
    [anon_sym_COLON_QMARK] = ACTIONS(9665),
    [anon_sym_COLON_DASH] = ACTIONS(9665),
    [anon_sym_PERCENT] = ACTIONS(9665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4129] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9651),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4130] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_esac] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2502),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [4131] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_esac] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2536),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [4132] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_esac] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_EQ_TILDE] = ACTIONS(4055),
    [anon_sym_EQ_EQ] = ACTIONS(4055),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [4133] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_esac] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_EQ_TILDE] = ACTIONS(4069),
    [anon_sym_EQ_EQ] = ACTIONS(4069),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [4134] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(9681),
    [sym_comment] = ACTIONS(57),
  },
  [4135] = {
    [anon_sym_RBRACE] = ACTIONS(9681),
    [sym_comment] = ACTIONS(57),
  },
  [4136] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(9683),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [4137] = {
    [sym_concatenation] = STATE(4270),
    [sym_string] = STATE(4269),
    [sym_simple_expansion] = STATE(4269),
    [sym_string_expansion] = STATE(4269),
    [sym_expansion] = STATE(4269),
    [sym_command_substitution] = STATE(4269),
    [sym_process_substitution] = STATE(4269),
    [aux_sym__literal_repeat1] = STATE(4271),
    [anon_sym_RBRACE] = ACTIONS(9681),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(9685),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9685),
  },
  [4138] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_esac] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_EQ_TILDE] = ACTIONS(4105),
    [anon_sym_EQ_EQ] = ACTIONS(4105),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [4139] = {
    [sym_concatenation] = STATE(4274),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4274),
    [sym_regex] = ACTIONS(9687),
    [anon_sym_RBRACE] = ACTIONS(9689),
    [anon_sym_EQ] = ACTIONS(9691),
    [anon_sym_DASH] = ACTIONS(9691),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9693),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9691),
    [anon_sym_COLON_QMARK] = ACTIONS(9691),
    [anon_sym_COLON_DASH] = ACTIONS(9691),
    [anon_sym_PERCENT] = ACTIONS(9691),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4140] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9689),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4141] = {
    [sym_concatenation] = STATE(4276),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4276),
    [sym_regex] = ACTIONS(9695),
    [anon_sym_RBRACE] = ACTIONS(9681),
    [anon_sym_EQ] = ACTIONS(9697),
    [anon_sym_DASH] = ACTIONS(9697),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9697),
    [anon_sym_COLON_QMARK] = ACTIONS(9697),
    [anon_sym_COLON_DASH] = ACTIONS(9697),
    [anon_sym_PERCENT] = ACTIONS(9697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4142] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9681),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4143] = {
    [sym_concatenation] = STATE(4278),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4278),
    [anon_sym_RBRACE] = ACTIONS(9701),
    [anon_sym_EQ] = ACTIONS(9703),
    [anon_sym_DASH] = ACTIONS(9703),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9705),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9703),
    [anon_sym_COLON_QMARK] = ACTIONS(9703),
    [anon_sym_COLON_DASH] = ACTIONS(9703),
    [anon_sym_PERCENT] = ACTIONS(9703),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4144] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_esac] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_EQ_TILDE] = ACTIONS(4161),
    [anon_sym_EQ_EQ] = ACTIONS(4161),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [4145] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9701),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4146] = {
    [sym_concatenation] = STATE(4276),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4276),
    [anon_sym_RBRACE] = ACTIONS(9681),
    [anon_sym_EQ] = ACTIONS(9697),
    [anon_sym_DASH] = ACTIONS(9697),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9697),
    [anon_sym_COLON_QMARK] = ACTIONS(9697),
    [anon_sym_COLON_DASH] = ACTIONS(9697),
    [anon_sym_PERCENT] = ACTIONS(9697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4147] = {
    [aux_sym_concatenation_repeat1] = STATE(4149),
    [sym__simple_heredoc_body] = ACTIONS(1378),
    [sym__heredoc_body_beginning] = ACTIONS(1378),
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_esac] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1378),
    [anon_sym_PIPE_AMP] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_AMP] = ACTIONS(1378),
    [anon_sym_GT_AMP] = ACTIONS(1378),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1378),
    [anon_sym_LT_LT_LT] = ACTIONS(1378),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1378),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [4148] = {
    [aux_sym__literal_repeat1] = STATE(4150),
    [sym__simple_heredoc_body] = ACTIONS(1382),
    [sym__heredoc_body_beginning] = ACTIONS(1382),
    [sym_file_descriptor] = ACTIONS(1382),
    [anon_sym_SEMI] = ACTIONS(1384),
    [anon_sym_esac] = ACTIONS(1382),
    [anon_sym_PIPE] = ACTIONS(1384),
    [anon_sym_SEMI_SEMI] = ACTIONS(1382),
    [anon_sym_PIPE_AMP] = ACTIONS(1382),
    [anon_sym_AMP_AMP] = ACTIONS(1382),
    [anon_sym_PIPE_PIPE] = ACTIONS(1382),
    [anon_sym_LT] = ACTIONS(1384),
    [anon_sym_GT] = ACTIONS(1384),
    [anon_sym_GT_GT] = ACTIONS(1382),
    [anon_sym_AMP_GT] = ACTIONS(1384),
    [anon_sym_AMP_GT_GT] = ACTIONS(1382),
    [anon_sym_LT_AMP] = ACTIONS(1382),
    [anon_sym_GT_AMP] = ACTIONS(1382),
    [anon_sym_LT_LT] = ACTIONS(1384),
    [anon_sym_LT_LT_DASH] = ACTIONS(1382),
    [anon_sym_LT_LT_LT] = ACTIONS(1382),
    [sym__special_character] = ACTIONS(6247),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1382),
    [anon_sym_AMP] = ACTIONS(1384),
  },
  [4149] = {
    [aux_sym_concatenation_repeat1] = STATE(4279),
    [sym__simple_heredoc_body] = ACTIONS(1059),
    [sym__heredoc_body_beginning] = ACTIONS(1059),
    [sym_file_descriptor] = ACTIONS(1059),
    [sym__concat] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(1061),
    [anon_sym_esac] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_SEMI_SEMI] = ACTIONS(1059),
    [anon_sym_PIPE_AMP] = ACTIONS(1059),
    [anon_sym_AMP_AMP] = ACTIONS(1059),
    [anon_sym_PIPE_PIPE] = ACTIONS(1059),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1059),
    [anon_sym_AMP_GT] = ACTIONS(1061),
    [anon_sym_AMP_GT_GT] = ACTIONS(1059),
    [anon_sym_LT_AMP] = ACTIONS(1059),
    [anon_sym_GT_AMP] = ACTIONS(1059),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_LT_LT_DASH] = ACTIONS(1059),
    [anon_sym_LT_LT_LT] = ACTIONS(1059),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1059),
    [anon_sym_AMP] = ACTIONS(1061),
  },
  [4150] = {
    [aux_sym__literal_repeat1] = STATE(4150),
    [sym__simple_heredoc_body] = ACTIONS(1371),
    [sym__heredoc_body_beginning] = ACTIONS(1371),
    [sym_file_descriptor] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_esac] = ACTIONS(1371),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_SEMI_SEMI] = ACTIONS(1371),
    [anon_sym_PIPE_AMP] = ACTIONS(1371),
    [anon_sym_AMP_AMP] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_GT] = ACTIONS(1373),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_AMP_GT] = ACTIONS(1373),
    [anon_sym_AMP_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_AMP] = ACTIONS(1371),
    [anon_sym_GT_AMP] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1371),
    [anon_sym_LT_LT_LT] = ACTIONS(1371),
    [sym__special_character] = ACTIONS(7471),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1371),
    [anon_sym_AMP] = ACTIONS(1373),
  },
  [4151] = {
    [sym_file_descriptor] = ACTIONS(2584),
    [sym_variable_name] = ACTIONS(2584),
    [anon_sym_for] = ACTIONS(2588),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(2584),
    [anon_sym_while] = ACTIONS(2588),
    [anon_sym_if] = ACTIONS(2588),
    [anon_sym_case] = ACTIONS(2588),
    [anon_sym_esac] = ACTIONS(7474),
    [anon_sym_SEMI_SEMI] = ACTIONS(4317),
    [anon_sym_function] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2584),
    [anon_sym_BANG] = ACTIONS(2588),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2584),
    [anon_sym_declare] = ACTIONS(2588),
    [anon_sym_typeset] = ACTIONS(2588),
    [anon_sym_export] = ACTIONS(2588),
    [anon_sym_readonly] = ACTIONS(2588),
    [anon_sym_local] = ACTIONS(2588),
    [anon_sym_unset] = ACTIONS(2588),
    [anon_sym_unsetenv] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2584),
    [anon_sym_AMP_GT] = ACTIONS(2588),
    [anon_sym_AMP_GT_GT] = ACTIONS(2584),
    [anon_sym_LT_AMP] = ACTIONS(2584),
    [anon_sym_GT_AMP] = ACTIONS(2584),
    [sym__special_character] = ACTIONS(2588),
    [anon_sym_DQUOTE] = ACTIONS(2584),
    [anon_sym_DOLLAR] = ACTIONS(2588),
    [sym_raw_string] = ACTIONS(2584),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2584),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2584),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [anon_sym_LT_LPAREN] = ACTIONS(2584),
    [anon_sym_GT_LPAREN] = ACTIONS(2584),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2588),
  },
  [4152] = {
    [sym__special_character] = ACTIONS(8766),
    [anon_sym_DQUOTE] = ACTIONS(8766),
    [anon_sym_DOLLAR] = ACTIONS(8768),
    [sym_raw_string] = ACTIONS(8766),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8766),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8766),
    [anon_sym_BQUOTE] = ACTIONS(8766),
    [anon_sym_LT_LPAREN] = ACTIONS(8766),
    [anon_sym_GT_LPAREN] = ACTIONS(8766),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8766),
  },
  [4153] = {
    [anon_sym_SEMI] = ACTIONS(1249),
    [anon_sym_SEMI_SEMI] = ACTIONS(1237),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1251),
    [anon_sym_AMP] = ACTIONS(1251),
  },
  [4154] = {
    [sym_file_redirect] = STATE(1332),
    [sym_heredoc_redirect] = STATE(1332),
    [sym_heredoc_body] = STATE(4280),
    [sym_herestring_redirect] = STATE(1332),
    [aux_sym_redirected_statement_repeat1] = STATE(1332),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(2658),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(2662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1237),
    [anon_sym_PIPE_AMP] = ACTIONS(2666),
    [anon_sym_AMP_AMP] = ACTIONS(2668),
    [anon_sym_PIPE_PIPE] = ACTIONS(2668),
    [anon_sym_LT] = ACTIONS(2670),
    [anon_sym_GT] = ACTIONS(2670),
    [anon_sym_GT_GT] = ACTIONS(2672),
    [anon_sym_AMP_GT] = ACTIONS(2670),
    [anon_sym_AMP_GT_GT] = ACTIONS(2672),
    [anon_sym_LT_AMP] = ACTIONS(2672),
    [anon_sym_GT_AMP] = ACTIONS(2672),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(2674),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1273),
  },
  [4155] = {
    [sym_file_redirect] = STATE(1332),
    [sym_heredoc_redirect] = STATE(1332),
    [sym_heredoc_body] = STATE(4280),
    [sym_herestring_redirect] = STATE(1332),
    [aux_sym_redirected_statement_repeat1] = STATE(1332),
    [sym__simple_heredoc_body] = ACTIONS(393),
    [sym__heredoc_body_beginning] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(433),
    [sym_variable_name] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(2662),
    [anon_sym_SEMI_SEMI] = ACTIONS(1237),
    [anon_sym_PIPE_AMP] = ACTIONS(2666),
    [anon_sym_AMP_AMP] = ACTIONS(2668),
    [anon_sym_PIPE_PIPE] = ACTIONS(2668),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(435),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_AMP_GT] = ACTIONS(435),
    [anon_sym_AMP_GT_GT] = ACTIONS(433),
    [anon_sym_LT_AMP] = ACTIONS(433),
    [anon_sym_GT_AMP] = ACTIONS(433),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_LT_LT_DASH] = ACTIONS(417),
    [anon_sym_LT_LT_LT] = ACTIONS(2674),
    [sym__special_character] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(433),
    [anon_sym_DOLLAR] = ACTIONS(435),
    [sym_raw_string] = ACTIONS(433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(433),
    [anon_sym_BQUOTE] = ACTIONS(433),
    [anon_sym_LT_LPAREN] = ACTIONS(433),
    [anon_sym_GT_LPAREN] = ACTIONS(433),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(435),
    [anon_sym_LF] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1273),
  },
  [4156] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(9707),
    [sym_comment] = ACTIONS(57),
  },
  [4157] = {
    [sym__special_character] = ACTIONS(8809),
    [anon_sym_DQUOTE] = ACTIONS(8809),
    [anon_sym_DOLLAR] = ACTIONS(8811),
    [sym_raw_string] = ACTIONS(8809),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8809),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8809),
    [anon_sym_BQUOTE] = ACTIONS(8809),
    [anon_sym_LT_LPAREN] = ACTIONS(8809),
    [anon_sym_GT_LPAREN] = ACTIONS(8809),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8809),
  },
  [4158] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(9709),
    [sym_comment] = ACTIONS(57),
  },
  [4159] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [sym_variable_name] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_RBRACE] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8146),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [4160] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [sym_variable_name] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_RBRACE] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8150),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [4161] = {
    [sym__simple_heredoc_body] = ACTIONS(8885),
    [sym__heredoc_body_beginning] = ACTIONS(8885),
    [sym_file_descriptor] = ACTIONS(8885),
    [anon_sym_SEMI] = ACTIONS(8887),
    [anon_sym_PIPE] = ACTIONS(8887),
    [anon_sym_SEMI_SEMI] = ACTIONS(8885),
    [anon_sym_RBRACE] = ACTIONS(8885),
    [anon_sym_PIPE_AMP] = ACTIONS(8885),
    [anon_sym_AMP_AMP] = ACTIONS(8885),
    [anon_sym_PIPE_PIPE] = ACTIONS(8885),
    [anon_sym_LT] = ACTIONS(8887),
    [anon_sym_GT] = ACTIONS(8887),
    [anon_sym_GT_GT] = ACTIONS(8885),
    [anon_sym_AMP_GT] = ACTIONS(8887),
    [anon_sym_AMP_GT_GT] = ACTIONS(8885),
    [anon_sym_LT_AMP] = ACTIONS(8885),
    [anon_sym_GT_AMP] = ACTIONS(8885),
    [anon_sym_LT_LT] = ACTIONS(8887),
    [anon_sym_LT_LT_DASH] = ACTIONS(8885),
    [anon_sym_LT_LT_LT] = ACTIONS(8885),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8885),
    [anon_sym_AMP] = ACTIONS(8887),
  },
  [4162] = {
    [sym_do_group] = STATE(4283),
    [sym_compound_statement] = STATE(4283),
    [anon_sym_do] = ACTIONS(1945),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_comment] = ACTIONS(57),
  },
  [4163] = {
    [sym__concat] = ACTIONS(8144),
    [anon_sym_RBRACE] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
  },
  [4164] = {
    [sym__concat] = ACTIONS(8148),
    [anon_sym_RBRACE] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
  },
  [4165] = {
    [sym_file_descriptor] = ACTIONS(9438),
    [anon_sym_SEMI] = ACTIONS(9440),
    [anon_sym_PIPE] = ACTIONS(9440),
    [anon_sym_SEMI_SEMI] = ACTIONS(9438),
    [anon_sym_PIPE_AMP] = ACTIONS(9438),
    [anon_sym_AMP_AMP] = ACTIONS(9438),
    [anon_sym_PIPE_PIPE] = ACTIONS(9438),
    [anon_sym_LT] = ACTIONS(9440),
    [anon_sym_GT] = ACTIONS(9440),
    [anon_sym_GT_GT] = ACTIONS(9438),
    [anon_sym_AMP_GT] = ACTIONS(9440),
    [anon_sym_AMP_GT_GT] = ACTIONS(9438),
    [anon_sym_LT_AMP] = ACTIONS(9438),
    [anon_sym_GT_AMP] = ACTIONS(9438),
    [anon_sym_LT_LT] = ACTIONS(9440),
    [anon_sym_LT_LT_DASH] = ACTIONS(9438),
    [anon_sym_LT_LT_LT] = ACTIONS(9438),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(9438),
    [anon_sym_AMP] = ACTIONS(9440),
  },
  [4166] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [sym_variable_name] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_done] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [4167] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [sym_variable_name] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_done] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [4168] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [sym_variable_name] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_done] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [4169] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9711),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4170] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9713),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4171] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [sym_variable_name] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_done] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [4172] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [sym_variable_name] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_done] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8146),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [4173] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [sym_variable_name] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_done] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8150),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [4174] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_done] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8146),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [4175] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_done] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8150),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [4176] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_done] = ACTIONS(7040),
    [anon_sym_fi] = ACTIONS(7040),
    [anon_sym_elif] = ACTIONS(7040),
    [anon_sym_else] = ACTIONS(7040),
    [anon_sym_esac] = ACTIONS(7040),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [4177] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_done] = ACTIONS(7044),
    [anon_sym_fi] = ACTIONS(7044),
    [anon_sym_elif] = ACTIONS(7044),
    [anon_sym_else] = ACTIONS(7044),
    [anon_sym_esac] = ACTIONS(7044),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [4178] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_done] = ACTIONS(7048),
    [anon_sym_fi] = ACTIONS(7048),
    [anon_sym_elif] = ACTIONS(7048),
    [anon_sym_else] = ACTIONS(7048),
    [anon_sym_esac] = ACTIONS(7048),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [4179] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9715),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4180] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9717),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4181] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_done] = ACTIONS(7082),
    [anon_sym_fi] = ACTIONS(7082),
    [anon_sym_elif] = ACTIONS(7082),
    [anon_sym_else] = ACTIONS(7082),
    [anon_sym_esac] = ACTIONS(7082),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [4182] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [sym_variable_name] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_fi] = ACTIONS(7042),
    [anon_sym_elif] = ACTIONS(7042),
    [anon_sym_else] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [4183] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [sym_variable_name] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_fi] = ACTIONS(7046),
    [anon_sym_elif] = ACTIONS(7046),
    [anon_sym_else] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [4184] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [sym_variable_name] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_fi] = ACTIONS(7050),
    [anon_sym_elif] = ACTIONS(7050),
    [anon_sym_else] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [4185] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9719),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4186] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9721),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4187] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [sym_variable_name] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_fi] = ACTIONS(7084),
    [anon_sym_elif] = ACTIONS(7084),
    [anon_sym_else] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [4188] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [sym_variable_name] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_fi] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [4189] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [sym_variable_name] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_fi] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [4190] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(9723),
    [sym_comment] = ACTIONS(57),
  },
  [4191] = {
    [anon_sym_RBRACE] = ACTIONS(9723),
    [sym_comment] = ACTIONS(57),
  },
  [4192] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(9725),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [4193] = {
    [sym_concatenation] = STATE(4293),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4293),
    [anon_sym_RBRACE] = ACTIONS(9727),
    [anon_sym_EQ] = ACTIONS(9729),
    [anon_sym_DASH] = ACTIONS(9729),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9731),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9729),
    [anon_sym_COLON_QMARK] = ACTIONS(9729),
    [anon_sym_COLON_DASH] = ACTIONS(9729),
    [anon_sym_PERCENT] = ACTIONS(9729),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4194] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [sym_variable_name] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_fi] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [4195] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9727),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4196] = {
    [sym_concatenation] = STATE(4294),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4294),
    [anon_sym_RBRACE] = ACTIONS(9723),
    [anon_sym_EQ] = ACTIONS(9733),
    [anon_sym_DASH] = ACTIONS(9733),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9735),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9733),
    [anon_sym_COLON_QMARK] = ACTIONS(9733),
    [anon_sym_COLON_DASH] = ACTIONS(9733),
    [anon_sym_PERCENT] = ACTIONS(9733),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4197] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9723),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4198] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [sym_variable_name] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_fi] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [4199] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9737),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4200] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [sym_variable_name] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_fi] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7042),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [4201] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [sym_variable_name] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_fi] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7046),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [4202] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [sym_variable_name] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_fi] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7050),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [4203] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9739),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4204] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9741),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4205] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [sym_variable_name] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_fi] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7084),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [4206] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_fi] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7042),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [4207] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_fi] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7046),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [4208] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_fi] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7050),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [4209] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9743),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4210] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9745),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4211] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_fi] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7084),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [4212] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_fi] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_EQ_TILDE] = ACTIONS(8146),
    [anon_sym_EQ_EQ] = ACTIONS(8146),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [4213] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_fi] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_EQ_TILDE] = ACTIONS(8150),
    [anon_sym_EQ_EQ] = ACTIONS(8150),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [4214] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [sym_variable_name] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_fi] = ACTIONS(8146),
    [anon_sym_elif] = ACTIONS(8146),
    [anon_sym_else] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8146),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [4215] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [sym_variable_name] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_fi] = ACTIONS(8150),
    [anon_sym_elif] = ACTIONS(8150),
    [anon_sym_else] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8150),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [4216] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_fi] = ACTIONS(8146),
    [anon_sym_elif] = ACTIONS(8146),
    [anon_sym_else] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8146),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [4217] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_fi] = ACTIONS(8150),
    [anon_sym_elif] = ACTIONS(8150),
    [anon_sym_else] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8150),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [4218] = {
    [sym__simple_heredoc_body] = ACTIONS(4383),
    [sym__heredoc_body_beginning] = ACTIONS(4383),
    [sym_file_descriptor] = ACTIONS(4383),
    [sym_variable_name] = ACTIONS(4383),
    [anon_sym_SEMI] = ACTIONS(4385),
    [anon_sym_esac] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI_SEMI] = ACTIONS(4383),
    [anon_sym_PIPE_AMP] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_AMP_GT] = ACTIONS(4385),
    [anon_sym_AMP_GT_GT] = ACTIONS(4383),
    [anon_sym_LT_AMP] = ACTIONS(4383),
    [anon_sym_GT_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_LT_LT_DASH] = ACTIONS(4383),
    [anon_sym_LT_LT_LT] = ACTIONS(4383),
    [sym__special_character] = ACTIONS(4383),
    [anon_sym_DQUOTE] = ACTIONS(4383),
    [anon_sym_DOLLAR] = ACTIONS(4385),
    [sym_raw_string] = ACTIONS(4383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4383),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4383),
    [anon_sym_BQUOTE] = ACTIONS(4383),
    [anon_sym_LT_LPAREN] = ACTIONS(4383),
    [anon_sym_GT_LPAREN] = ACTIONS(4383),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4385),
    [anon_sym_LF] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
  },
  [4219] = {
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(2344),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_esac] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [4220] = {
    [aux_sym_concatenation_repeat1] = STATE(4220),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(9747),
    [sym_variable_name] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_esac] = ACTIONS(2346),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym__special_character] = ACTIONS(2344),
    [anon_sym_DQUOTE] = ACTIONS(2344),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [sym_raw_string] = ACTIONS(2344),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2344),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2344),
    [anon_sym_BQUOTE] = ACTIONS(2344),
    [anon_sym_LT_LPAREN] = ACTIONS(2344),
    [anon_sym_GT_LPAREN] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2346),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [4221] = {
    [sym__simple_heredoc_body] = ACTIONS(2351),
    [sym__heredoc_body_beginning] = ACTIONS(2351),
    [sym_file_descriptor] = ACTIONS(2351),
    [sym__concat] = ACTIONS(2351),
    [sym_variable_name] = ACTIONS(2351),
    [anon_sym_SEMI] = ACTIONS(2353),
    [anon_sym_esac] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(2353),
    [anon_sym_SEMI_SEMI] = ACTIONS(2351),
    [anon_sym_PIPE_AMP] = ACTIONS(2351),
    [anon_sym_AMP_AMP] = ACTIONS(2351),
    [anon_sym_PIPE_PIPE] = ACTIONS(2351),
    [anon_sym_LT] = ACTIONS(2353),
    [anon_sym_GT] = ACTIONS(2353),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_AMP_GT] = ACTIONS(2353),
    [anon_sym_AMP_GT_GT] = ACTIONS(2351),
    [anon_sym_LT_AMP] = ACTIONS(2351),
    [anon_sym_GT_AMP] = ACTIONS(2351),
    [anon_sym_LT_LT] = ACTIONS(2353),
    [anon_sym_LT_LT_DASH] = ACTIONS(2351),
    [anon_sym_LT_LT_LT] = ACTIONS(2351),
    [sym__special_character] = ACTIONS(2351),
    [anon_sym_DQUOTE] = ACTIONS(2351),
    [anon_sym_DOLLAR] = ACTIONS(2353),
    [sym_raw_string] = ACTIONS(2351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2351),
    [anon_sym_BQUOTE] = ACTIONS(2351),
    [anon_sym_LT_LPAREN] = ACTIONS(2351),
    [anon_sym_GT_LPAREN] = ACTIONS(2351),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2353),
    [anon_sym_LF] = ACTIONS(2351),
    [anon_sym_AMP] = ACTIONS(2353),
  },
  [4222] = {
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(1071),
    [sym__string_content] = ACTIONS(1073),
    [anon_sym_POUND] = ACTIONS(1067),
    [sym_comment] = ACTIONS(343),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1075),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_AT] = ACTIONS(1077),
    [anon_sym_QMARK] = ACTIONS(1077),
    [anon_sym_0] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(1075),
  },
  [4223] = {
    [sym_concatenation] = STATE(4303),
    [sym_string] = STATE(4302),
    [sym_simple_expansion] = STATE(4302),
    [sym_string_expansion] = STATE(4302),
    [sym_expansion] = STATE(4302),
    [sym_command_substitution] = STATE(4302),
    [sym_process_substitution] = STATE(4302),
    [aux_sym__literal_repeat1] = STATE(4304),
    [anon_sym_RBRACE] = ACTIONS(9752),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(9754),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9754),
  },
  [4224] = {
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_EQ] = ACTIONS(9756),
    [sym_comment] = ACTIONS(57),
  },
  [4225] = {
    [sym_concatenation] = STATE(4308),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4308),
    [anon_sym_RBRACE] = ACTIONS(9758),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_DASH] = ACTIONS(9760),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9762),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(9764),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_COLON_QMARK] = ACTIONS(9760),
    [anon_sym_COLON_DASH] = ACTIONS(9760),
    [anon_sym_PERCENT] = ACTIONS(9760),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4226] = {
    [sym_concatenation] = STATE(4310),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4310),
    [anon_sym_RBRACE] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(9766),
    [anon_sym_DASH] = ACTIONS(9766),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9768),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_SLASH] = ACTIONS(9770),
    [anon_sym_COLON] = ACTIONS(9766),
    [anon_sym_COLON_QMARK] = ACTIONS(9766),
    [anon_sym_COLON_DASH] = ACTIONS(9766),
    [anon_sym_PERCENT] = ACTIONS(9766),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4227] = {
    [sym__simple_heredoc_body] = ACTIONS(2442),
    [sym__heredoc_body_beginning] = ACTIONS(2442),
    [sym_file_descriptor] = ACTIONS(2442),
    [sym__concat] = ACTIONS(2442),
    [sym_variable_name] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_esac] = ACTIONS(2444),
    [anon_sym_PIPE] = ACTIONS(2444),
    [anon_sym_SEMI_SEMI] = ACTIONS(2442),
    [anon_sym_PIPE_AMP] = ACTIONS(2442),
    [anon_sym_AMP_AMP] = ACTIONS(2442),
    [anon_sym_PIPE_PIPE] = ACTIONS(2442),
    [anon_sym_LT] = ACTIONS(2444),
    [anon_sym_GT] = ACTIONS(2444),
    [anon_sym_GT_GT] = ACTIONS(2442),
    [anon_sym_AMP_GT] = ACTIONS(2444),
    [anon_sym_AMP_GT_GT] = ACTIONS(2442),
    [anon_sym_LT_AMP] = ACTIONS(2442),
    [anon_sym_GT_AMP] = ACTIONS(2442),
    [anon_sym_LT_LT] = ACTIONS(2444),
    [anon_sym_LT_LT_DASH] = ACTIONS(2442),
    [anon_sym_LT_LT_LT] = ACTIONS(2442),
    [sym__special_character] = ACTIONS(2442),
    [anon_sym_DQUOTE] = ACTIONS(2442),
    [anon_sym_DOLLAR] = ACTIONS(2444),
    [sym_raw_string] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2442),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2442),
    [anon_sym_BQUOTE] = ACTIONS(2442),
    [anon_sym_LT_LPAREN] = ACTIONS(2442),
    [anon_sym_GT_LPAREN] = ACTIONS(2442),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2444),
    [anon_sym_LF] = ACTIONS(2442),
    [anon_sym_AMP] = ACTIONS(2444),
  },
  [4228] = {
    [sym_concatenation] = STATE(4313),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4313),
    [sym_regex] = ACTIONS(9772),
    [anon_sym_RBRACE] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(9776),
    [anon_sym_DASH] = ACTIONS(9776),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9778),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9776),
    [anon_sym_COLON_QMARK] = ACTIONS(9776),
    [anon_sym_COLON_DASH] = ACTIONS(9776),
    [anon_sym_PERCENT] = ACTIONS(9776),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4229] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9774),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4230] = {
    [sym__simple_heredoc_body] = ACTIONS(2492),
    [sym__heredoc_body_beginning] = ACTIONS(2492),
    [sym_file_descriptor] = ACTIONS(2492),
    [sym__concat] = ACTIONS(2492),
    [sym_variable_name] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2494),
    [anon_sym_esac] = ACTIONS(2494),
    [anon_sym_PIPE] = ACTIONS(2494),
    [anon_sym_SEMI_SEMI] = ACTIONS(2492),
    [anon_sym_PIPE_AMP] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_PIPE_PIPE] = ACTIONS(2492),
    [anon_sym_LT] = ACTIONS(2494),
    [anon_sym_GT] = ACTIONS(2494),
    [anon_sym_GT_GT] = ACTIONS(2492),
    [anon_sym_AMP_GT] = ACTIONS(2494),
    [anon_sym_AMP_GT_GT] = ACTIONS(2492),
    [anon_sym_LT_AMP] = ACTIONS(2492),
    [anon_sym_GT_AMP] = ACTIONS(2492),
    [anon_sym_LT_LT] = ACTIONS(2494),
    [anon_sym_LT_LT_DASH] = ACTIONS(2492),
    [anon_sym_LT_LT_LT] = ACTIONS(2492),
    [sym__special_character] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR] = ACTIONS(2494),
    [sym_raw_string] = ACTIONS(2492),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2492),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2492),
    [anon_sym_BQUOTE] = ACTIONS(2492),
    [anon_sym_LT_LPAREN] = ACTIONS(2492),
    [anon_sym_GT_LPAREN] = ACTIONS(2492),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2494),
    [anon_sym_LF] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2494),
  },
  [4231] = {
    [sym_concatenation] = STATE(4310),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4310),
    [sym_regex] = ACTIONS(9780),
    [anon_sym_RBRACE] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(9766),
    [anon_sym_DASH] = ACTIONS(9766),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9768),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9766),
    [anon_sym_COLON_QMARK] = ACTIONS(9766),
    [anon_sym_COLON_DASH] = ACTIONS(9766),
    [anon_sym_PERCENT] = ACTIONS(9766),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4232] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4233] = {
    [sym__simple_heredoc_body] = ACTIONS(2500),
    [sym__heredoc_body_beginning] = ACTIONS(2500),
    [sym_file_descriptor] = ACTIONS(2500),
    [sym__concat] = ACTIONS(2500),
    [sym_variable_name] = ACTIONS(2500),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_esac] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2502),
    [anon_sym_SEMI_SEMI] = ACTIONS(2500),
    [anon_sym_PIPE_AMP] = ACTIONS(2500),
    [anon_sym_AMP_AMP] = ACTIONS(2500),
    [anon_sym_PIPE_PIPE] = ACTIONS(2500),
    [anon_sym_LT] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2500),
    [anon_sym_AMP_GT] = ACTIONS(2502),
    [anon_sym_AMP_GT_GT] = ACTIONS(2500),
    [anon_sym_LT_AMP] = ACTIONS(2500),
    [anon_sym_GT_AMP] = ACTIONS(2500),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LT_LT_DASH] = ACTIONS(2500),
    [anon_sym_LT_LT_LT] = ACTIONS(2500),
    [sym__special_character] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR] = ACTIONS(2502),
    [sym_raw_string] = ACTIONS(2500),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2500),
    [anon_sym_BQUOTE] = ACTIONS(2500),
    [anon_sym_LT_LPAREN] = ACTIONS(2500),
    [anon_sym_GT_LPAREN] = ACTIONS(2500),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2502),
    [anon_sym_LF] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2502),
  },
  [4234] = {
    [sym__simple_heredoc_body] = ACTIONS(2534),
    [sym__heredoc_body_beginning] = ACTIONS(2534),
    [sym_file_descriptor] = ACTIONS(2534),
    [sym__concat] = ACTIONS(2534),
    [sym_variable_name] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_esac] = ACTIONS(2536),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_SEMI_SEMI] = ACTIONS(2534),
    [anon_sym_PIPE_AMP] = ACTIONS(2534),
    [anon_sym_AMP_AMP] = ACTIONS(2534),
    [anon_sym_PIPE_PIPE] = ACTIONS(2534),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2534),
    [anon_sym_AMP_GT] = ACTIONS(2536),
    [anon_sym_AMP_GT_GT] = ACTIONS(2534),
    [anon_sym_LT_AMP] = ACTIONS(2534),
    [anon_sym_GT_AMP] = ACTIONS(2534),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_LT_LT_DASH] = ACTIONS(2534),
    [anon_sym_LT_LT_LT] = ACTIONS(2534),
    [sym__special_character] = ACTIONS(2534),
    [anon_sym_DQUOTE] = ACTIONS(2534),
    [anon_sym_DOLLAR] = ACTIONS(2536),
    [sym_raw_string] = ACTIONS(2534),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2534),
    [anon_sym_BQUOTE] = ACTIONS(2534),
    [anon_sym_LT_LPAREN] = ACTIONS(2534),
    [anon_sym_GT_LPAREN] = ACTIONS(2534),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(2536),
    [anon_sym_LF] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2536),
  },
  [4235] = {
    [sym__simple_heredoc_body] = ACTIONS(2697),
    [sym__heredoc_body_beginning] = ACTIONS(2697),
    [sym_file_descriptor] = ACTIONS(2697),
    [sym_variable_name] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym_esac] = ACTIONS(2699),
    [anon_sym_PIPE] = ACTIONS(2699),
    [anon_sym_SEMI_SEMI] = ACTIONS(2697),
    [anon_sym_PIPE_AMP] = ACTIONS(2697),
    [anon_sym_AMP_AMP] = ACTIONS(2697),
    [anon_sym_PIPE_PIPE] = ACTIONS(2697),
    [anon_sym_LT] = ACTIONS(2699),
    [anon_sym_GT] = ACTIONS(2699),
    [anon_sym_GT_GT] = ACTIONS(2697),
    [anon_sym_AMP_GT] = ACTIONS(2699),
    [anon_sym_AMP_GT_GT] = ACTIONS(2697),
    [anon_sym_LT_AMP] = ACTIONS(2697),
    [anon_sym_GT_AMP] = ACTIONS(2697),
    [anon_sym_LT_LT] = ACTIONS(2699),
    [anon_sym_LT_LT_DASH] = ACTIONS(2697),
    [anon_sym_LT_LT_LT] = ACTIONS(2697),
    [sym__special_character] = ACTIONS(2697),
    [anon_sym_DQUOTE] = ACTIONS(2697),
    [anon_sym_DOLLAR] = ACTIONS(2699),
    [sym_raw_string] = ACTIONS(2697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2697),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2697),
    [anon_sym_BQUOTE] = ACTIONS(2697),
    [anon_sym_LT_LPAREN] = ACTIONS(2697),
    [anon_sym_GT_LPAREN] = ACTIONS(2697),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2699),
    [sym_word] = ACTIONS(2699),
    [anon_sym_LF] = ACTIONS(2697),
    [anon_sym_AMP] = ACTIONS(2699),
  },
  [4236] = {
    [sym_concatenation] = STATE(1357),
    [sym_string] = STATE(729),
    [sym_simple_expansion] = STATE(729),
    [sym_string_expansion] = STATE(729),
    [sym_expansion] = STATE(729),
    [sym_command_substitution] = STATE(729),
    [sym_process_substitution] = STATE(729),
    [aux_sym_for_statement_repeat1] = STATE(1357),
    [aux_sym__literal_repeat1] = STATE(735),
    [anon_sym_RPAREN] = ACTIONS(9782),
    [sym__special_character] = ACTIONS(1404),
    [anon_sym_DQUOTE] = ACTIONS(1406),
    [anon_sym_DOLLAR] = ACTIONS(1408),
    [sym_raw_string] = ACTIONS(1410),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1412),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [anon_sym_LT_LPAREN] = ACTIONS(1418),
    [anon_sym_GT_LPAREN] = ACTIONS(1418),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(1410),
  },
  [4237] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [sym_variable_name] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_esac] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4055),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [4238] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [sym_variable_name] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_esac] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4069),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [4239] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(9784),
    [sym_comment] = ACTIONS(57),
  },
  [4240] = {
    [anon_sym_RBRACE] = ACTIONS(9784),
    [sym_comment] = ACTIONS(57),
  },
  [4241] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(9786),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [4242] = {
    [sym_concatenation] = STATE(4319),
    [sym_string] = STATE(4318),
    [sym_simple_expansion] = STATE(4318),
    [sym_string_expansion] = STATE(4318),
    [sym_expansion] = STATE(4318),
    [sym_command_substitution] = STATE(4318),
    [sym_process_substitution] = STATE(4318),
    [aux_sym__literal_repeat1] = STATE(4320),
    [anon_sym_RBRACE] = ACTIONS(9784),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(9788),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9788),
  },
  [4243] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [sym_variable_name] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_esac] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4105),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [4244] = {
    [sym_concatenation] = STATE(4323),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4323),
    [sym_regex] = ACTIONS(9790),
    [anon_sym_RBRACE] = ACTIONS(9792),
    [anon_sym_EQ] = ACTIONS(9794),
    [anon_sym_DASH] = ACTIONS(9794),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9794),
    [anon_sym_COLON_QMARK] = ACTIONS(9794),
    [anon_sym_COLON_DASH] = ACTIONS(9794),
    [anon_sym_PERCENT] = ACTIONS(9794),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4245] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9792),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4246] = {
    [sym_concatenation] = STATE(4325),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4325),
    [sym_regex] = ACTIONS(9798),
    [anon_sym_RBRACE] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_DASH] = ACTIONS(9800),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9802),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_COLON_QMARK] = ACTIONS(9800),
    [anon_sym_COLON_DASH] = ACTIONS(9800),
    [anon_sym_PERCENT] = ACTIONS(9800),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4247] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4248] = {
    [sym_concatenation] = STATE(4327),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4327),
    [anon_sym_RBRACE] = ACTIONS(9804),
    [anon_sym_EQ] = ACTIONS(9806),
    [anon_sym_DASH] = ACTIONS(9806),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9808),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9806),
    [anon_sym_COLON_QMARK] = ACTIONS(9806),
    [anon_sym_COLON_DASH] = ACTIONS(9806),
    [anon_sym_PERCENT] = ACTIONS(9806),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4249] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [sym_variable_name] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_esac] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4161),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [4250] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9804),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4251] = {
    [sym_concatenation] = STATE(4325),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4325),
    [anon_sym_RBRACE] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_DASH] = ACTIONS(9800),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9802),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_COLON_QMARK] = ACTIONS(9800),
    [anon_sym_COLON_DASH] = ACTIONS(9800),
    [anon_sym_PERCENT] = ACTIONS(9800),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4252] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_esac] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4055),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [4253] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_esac] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4069),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [4254] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(9810),
    [sym_comment] = ACTIONS(57),
  },
  [4255] = {
    [anon_sym_RBRACE] = ACTIONS(9810),
    [sym_comment] = ACTIONS(57),
  },
  [4256] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(9812),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [4257] = {
    [sym_concatenation] = STATE(4331),
    [sym_string] = STATE(4330),
    [sym_simple_expansion] = STATE(4330),
    [sym_string_expansion] = STATE(4330),
    [sym_expansion] = STATE(4330),
    [sym_command_substitution] = STATE(4330),
    [sym_process_substitution] = STATE(4330),
    [aux_sym__literal_repeat1] = STATE(4332),
    [anon_sym_RBRACE] = ACTIONS(9810),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(9814),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9814),
  },
  [4258] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_esac] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4105),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [4259] = {
    [sym_concatenation] = STATE(4335),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4335),
    [sym_regex] = ACTIONS(9816),
    [anon_sym_RBRACE] = ACTIONS(9818),
    [anon_sym_EQ] = ACTIONS(9820),
    [anon_sym_DASH] = ACTIONS(9820),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9822),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9820),
    [anon_sym_COLON_QMARK] = ACTIONS(9820),
    [anon_sym_COLON_DASH] = ACTIONS(9820),
    [anon_sym_PERCENT] = ACTIONS(9820),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4260] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9818),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4261] = {
    [sym_concatenation] = STATE(4337),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4337),
    [sym_regex] = ACTIONS(9824),
    [anon_sym_RBRACE] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(9826),
    [anon_sym_DASH] = ACTIONS(9826),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9828),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9826),
    [anon_sym_COLON_QMARK] = ACTIONS(9826),
    [anon_sym_COLON_DASH] = ACTIONS(9826),
    [anon_sym_PERCENT] = ACTIONS(9826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4262] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4263] = {
    [sym_concatenation] = STATE(4339),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4339),
    [anon_sym_RBRACE] = ACTIONS(9830),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_DASH] = ACTIONS(9832),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_COLON_QMARK] = ACTIONS(9832),
    [anon_sym_COLON_DASH] = ACTIONS(9832),
    [anon_sym_PERCENT] = ACTIONS(9832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4264] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_esac] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4161),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [4265] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9830),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4266] = {
    [sym_concatenation] = STATE(4337),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4337),
    [anon_sym_RBRACE] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(9826),
    [anon_sym_DASH] = ACTIONS(9826),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9828),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9826),
    [anon_sym_COLON_QMARK] = ACTIONS(9826),
    [anon_sym_COLON_DASH] = ACTIONS(9826),
    [anon_sym_PERCENT] = ACTIONS(9826),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4267] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_esac] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_EQ_TILDE] = ACTIONS(5566),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [4268] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_esac] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_EQ_TILDE] = ACTIONS(5600),
    [anon_sym_EQ_EQ] = ACTIONS(5600),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [4269] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(9836),
    [sym_comment] = ACTIONS(57),
  },
  [4270] = {
    [anon_sym_RBRACE] = ACTIONS(9836),
    [sym_comment] = ACTIONS(57),
  },
  [4271] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(9838),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [4272] = {
    [sym_concatenation] = STATE(4343),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4343),
    [anon_sym_RBRACE] = ACTIONS(9840),
    [anon_sym_EQ] = ACTIONS(9842),
    [anon_sym_DASH] = ACTIONS(9842),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9844),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9842),
    [anon_sym_COLON_QMARK] = ACTIONS(9842),
    [anon_sym_COLON_DASH] = ACTIONS(9842),
    [anon_sym_PERCENT] = ACTIONS(9842),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4273] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_esac] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_EQ_TILDE] = ACTIONS(5617),
    [anon_sym_EQ_EQ] = ACTIONS(5617),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [4274] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9840),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4275] = {
    [sym_concatenation] = STATE(4344),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4344),
    [anon_sym_RBRACE] = ACTIONS(9836),
    [anon_sym_EQ] = ACTIONS(9846),
    [anon_sym_DASH] = ACTIONS(9846),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9848),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9846),
    [anon_sym_COLON_QMARK] = ACTIONS(9846),
    [anon_sym_COLON_DASH] = ACTIONS(9846),
    [anon_sym_PERCENT] = ACTIONS(9846),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4276] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9836),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4277] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_esac] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_EQ_TILDE] = ACTIONS(5660),
    [anon_sym_EQ_EQ] = ACTIONS(5660),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [4278] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9850),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4279] = {
    [aux_sym_concatenation_repeat1] = STATE(4279),
    [sym__simple_heredoc_body] = ACTIONS(2344),
    [sym__heredoc_body_beginning] = ACTIONS(2344),
    [sym_file_descriptor] = ACTIONS(2344),
    [sym__concat] = ACTIONS(8371),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_esac] = ACTIONS(2344),
    [anon_sym_PIPE] = ACTIONS(2346),
    [anon_sym_SEMI_SEMI] = ACTIONS(2344),
    [anon_sym_PIPE_AMP] = ACTIONS(2344),
    [anon_sym_AMP_AMP] = ACTIONS(2344),
    [anon_sym_PIPE_PIPE] = ACTIONS(2344),
    [anon_sym_LT] = ACTIONS(2346),
    [anon_sym_GT] = ACTIONS(2346),
    [anon_sym_GT_GT] = ACTIONS(2344),
    [anon_sym_AMP_GT] = ACTIONS(2346),
    [anon_sym_AMP_GT_GT] = ACTIONS(2344),
    [anon_sym_LT_AMP] = ACTIONS(2344),
    [anon_sym_GT_AMP] = ACTIONS(2344),
    [anon_sym_LT_LT] = ACTIONS(2346),
    [anon_sym_LT_LT_DASH] = ACTIONS(2344),
    [anon_sym_LT_LT_LT] = ACTIONS(2344),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2344),
    [anon_sym_AMP] = ACTIONS(2346),
  },
  [4280] = {
    [anon_sym_SEMI] = ACTIONS(2650),
    [anon_sym_SEMI_SEMI] = ACTIONS(2586),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(2652),
    [anon_sym_AMP] = ACTIONS(2652),
  },
  [4281] = {
    [sym__special_character] = ACTIONS(9414),
    [anon_sym_DQUOTE] = ACTIONS(9414),
    [anon_sym_DOLLAR] = ACTIONS(9416),
    [sym_raw_string] = ACTIONS(9414),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(9414),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(9414),
    [anon_sym_BQUOTE] = ACTIONS(9414),
    [anon_sym_LT_LPAREN] = ACTIONS(9414),
    [anon_sym_GT_LPAREN] = ACTIONS(9414),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9414),
  },
  [4282] = {
    [sym__special_character] = ACTIONS(9424),
    [anon_sym_DQUOTE] = ACTIONS(9424),
    [anon_sym_DOLLAR] = ACTIONS(9426),
    [sym_raw_string] = ACTIONS(9424),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(9424),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(9424),
    [anon_sym_BQUOTE] = ACTIONS(9424),
    [anon_sym_LT_LPAREN] = ACTIONS(9424),
    [anon_sym_GT_LPAREN] = ACTIONS(9424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9424),
  },
  [4283] = {
    [sym__simple_heredoc_body] = ACTIONS(9438),
    [sym__heredoc_body_beginning] = ACTIONS(9438),
    [sym_file_descriptor] = ACTIONS(9438),
    [anon_sym_SEMI] = ACTIONS(9440),
    [anon_sym_PIPE] = ACTIONS(9440),
    [anon_sym_SEMI_SEMI] = ACTIONS(9438),
    [anon_sym_RBRACE] = ACTIONS(9438),
    [anon_sym_PIPE_AMP] = ACTIONS(9438),
    [anon_sym_AMP_AMP] = ACTIONS(9438),
    [anon_sym_PIPE_PIPE] = ACTIONS(9438),
    [anon_sym_LT] = ACTIONS(9440),
    [anon_sym_GT] = ACTIONS(9440),
    [anon_sym_GT_GT] = ACTIONS(9438),
    [anon_sym_AMP_GT] = ACTIONS(9440),
    [anon_sym_AMP_GT_GT] = ACTIONS(9438),
    [anon_sym_LT_AMP] = ACTIONS(9438),
    [anon_sym_GT_AMP] = ACTIONS(9438),
    [anon_sym_LT_LT] = ACTIONS(9440),
    [anon_sym_LT_LT_DASH] = ACTIONS(9438),
    [anon_sym_LT_LT_LT] = ACTIONS(9438),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(9438),
    [anon_sym_AMP] = ACTIONS(9440),
  },
  [4284] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [sym_variable_name] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_done] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [4285] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [sym_variable_name] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_done] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [4286] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_done] = ACTIONS(8144),
    [anon_sym_fi] = ACTIONS(8144),
    [anon_sym_elif] = ACTIONS(8144),
    [anon_sym_else] = ACTIONS(8144),
    [anon_sym_esac] = ACTIONS(8144),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [4287] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_done] = ACTIONS(8148),
    [anon_sym_fi] = ACTIONS(8148),
    [anon_sym_elif] = ACTIONS(8148),
    [anon_sym_else] = ACTIONS(8148),
    [anon_sym_esac] = ACTIONS(8148),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [4288] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [sym_variable_name] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_fi] = ACTIONS(8146),
    [anon_sym_elif] = ACTIONS(8146),
    [anon_sym_else] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [4289] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [sym_variable_name] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_fi] = ACTIONS(8150),
    [anon_sym_elif] = ACTIONS(8150),
    [anon_sym_else] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [4290] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [sym_variable_name] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_fi] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [4291] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [sym_variable_name] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_fi] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [4292] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [sym_variable_name] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_fi] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [4293] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9852),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4294] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9854),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4295] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [sym_variable_name] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_fi] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [4296] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [sym_variable_name] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_fi] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8146),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [4297] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [sym_variable_name] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_fi] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8150),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [4298] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_fi] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8146),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [4299] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_fi] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8150),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [4300] = {
    [sym__simple_heredoc_body] = ACTIONS(4053),
    [sym__heredoc_body_beginning] = ACTIONS(4053),
    [sym_file_descriptor] = ACTIONS(4053),
    [sym__concat] = ACTIONS(4053),
    [sym_variable_name] = ACTIONS(4053),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_esac] = ACTIONS(4055),
    [anon_sym_PIPE] = ACTIONS(4055),
    [anon_sym_SEMI_SEMI] = ACTIONS(4053),
    [anon_sym_PIPE_AMP] = ACTIONS(4053),
    [anon_sym_AMP_AMP] = ACTIONS(4053),
    [anon_sym_PIPE_PIPE] = ACTIONS(4053),
    [anon_sym_LT] = ACTIONS(4055),
    [anon_sym_GT] = ACTIONS(4055),
    [anon_sym_GT_GT] = ACTIONS(4053),
    [anon_sym_AMP_GT] = ACTIONS(4055),
    [anon_sym_AMP_GT_GT] = ACTIONS(4053),
    [anon_sym_LT_AMP] = ACTIONS(4053),
    [anon_sym_GT_AMP] = ACTIONS(4053),
    [anon_sym_LT_LT] = ACTIONS(4055),
    [anon_sym_LT_LT_DASH] = ACTIONS(4053),
    [anon_sym_LT_LT_LT] = ACTIONS(4053),
    [sym__special_character] = ACTIONS(4053),
    [anon_sym_DQUOTE] = ACTIONS(4053),
    [anon_sym_DOLLAR] = ACTIONS(4055),
    [sym_raw_string] = ACTIONS(4053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4053),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4053),
    [anon_sym_BQUOTE] = ACTIONS(4053),
    [anon_sym_LT_LPAREN] = ACTIONS(4053),
    [anon_sym_GT_LPAREN] = ACTIONS(4053),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4055),
    [anon_sym_LF] = ACTIONS(4053),
    [anon_sym_AMP] = ACTIONS(4055),
  },
  [4301] = {
    [sym__simple_heredoc_body] = ACTIONS(4067),
    [sym__heredoc_body_beginning] = ACTIONS(4067),
    [sym_file_descriptor] = ACTIONS(4067),
    [sym__concat] = ACTIONS(4067),
    [sym_variable_name] = ACTIONS(4067),
    [anon_sym_SEMI] = ACTIONS(4069),
    [anon_sym_esac] = ACTIONS(4069),
    [anon_sym_PIPE] = ACTIONS(4069),
    [anon_sym_SEMI_SEMI] = ACTIONS(4067),
    [anon_sym_PIPE_AMP] = ACTIONS(4067),
    [anon_sym_AMP_AMP] = ACTIONS(4067),
    [anon_sym_PIPE_PIPE] = ACTIONS(4067),
    [anon_sym_LT] = ACTIONS(4069),
    [anon_sym_GT] = ACTIONS(4069),
    [anon_sym_GT_GT] = ACTIONS(4067),
    [anon_sym_AMP_GT] = ACTIONS(4069),
    [anon_sym_AMP_GT_GT] = ACTIONS(4067),
    [anon_sym_LT_AMP] = ACTIONS(4067),
    [anon_sym_GT_AMP] = ACTIONS(4067),
    [anon_sym_LT_LT] = ACTIONS(4069),
    [anon_sym_LT_LT_DASH] = ACTIONS(4067),
    [anon_sym_LT_LT_LT] = ACTIONS(4067),
    [sym__special_character] = ACTIONS(4067),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(4069),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4067),
    [anon_sym_BQUOTE] = ACTIONS(4067),
    [anon_sym_LT_LPAREN] = ACTIONS(4067),
    [anon_sym_GT_LPAREN] = ACTIONS(4067),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4069),
    [anon_sym_LF] = ACTIONS(4067),
    [anon_sym_AMP] = ACTIONS(4069),
  },
  [4302] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(9856),
    [sym_comment] = ACTIONS(57),
  },
  [4303] = {
    [anon_sym_RBRACE] = ACTIONS(9856),
    [sym_comment] = ACTIONS(57),
  },
  [4304] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(9858),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [4305] = {
    [sym_concatenation] = STATE(4351),
    [sym_string] = STATE(4350),
    [sym_simple_expansion] = STATE(4350),
    [sym_string_expansion] = STATE(4350),
    [sym_expansion] = STATE(4350),
    [sym_command_substitution] = STATE(4350),
    [sym_process_substitution] = STATE(4350),
    [aux_sym__literal_repeat1] = STATE(4352),
    [anon_sym_RBRACE] = ACTIONS(9856),
    [sym__special_character] = ACTIONS(2410),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR] = ACTIONS(2414),
    [sym_raw_string] = ACTIONS(9860),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2418),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2420),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LT_LPAREN] = ACTIONS(2424),
    [anon_sym_GT_LPAREN] = ACTIONS(2424),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(9860),
  },
  [4306] = {
    [sym__simple_heredoc_body] = ACTIONS(4103),
    [sym__heredoc_body_beginning] = ACTIONS(4103),
    [sym_file_descriptor] = ACTIONS(4103),
    [sym__concat] = ACTIONS(4103),
    [sym_variable_name] = ACTIONS(4103),
    [anon_sym_SEMI] = ACTIONS(4105),
    [anon_sym_esac] = ACTIONS(4105),
    [anon_sym_PIPE] = ACTIONS(4105),
    [anon_sym_SEMI_SEMI] = ACTIONS(4103),
    [anon_sym_PIPE_AMP] = ACTIONS(4103),
    [anon_sym_AMP_AMP] = ACTIONS(4103),
    [anon_sym_PIPE_PIPE] = ACTIONS(4103),
    [anon_sym_LT] = ACTIONS(4105),
    [anon_sym_GT] = ACTIONS(4105),
    [anon_sym_GT_GT] = ACTIONS(4103),
    [anon_sym_AMP_GT] = ACTIONS(4105),
    [anon_sym_AMP_GT_GT] = ACTIONS(4103),
    [anon_sym_LT_AMP] = ACTIONS(4103),
    [anon_sym_GT_AMP] = ACTIONS(4103),
    [anon_sym_LT_LT] = ACTIONS(4105),
    [anon_sym_LT_LT_DASH] = ACTIONS(4103),
    [anon_sym_LT_LT_LT] = ACTIONS(4103),
    [sym__special_character] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(4103),
    [anon_sym_DOLLAR] = ACTIONS(4105),
    [sym_raw_string] = ACTIONS(4103),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4103),
    [anon_sym_BQUOTE] = ACTIONS(4103),
    [anon_sym_LT_LPAREN] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(4103),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4105),
    [anon_sym_LF] = ACTIONS(4103),
    [anon_sym_AMP] = ACTIONS(4105),
  },
  [4307] = {
    [sym_concatenation] = STATE(4355),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4355),
    [sym_regex] = ACTIONS(9862),
    [anon_sym_RBRACE] = ACTIONS(9864),
    [anon_sym_EQ] = ACTIONS(9866),
    [anon_sym_DASH] = ACTIONS(9866),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9868),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9866),
    [anon_sym_COLON_QMARK] = ACTIONS(9866),
    [anon_sym_COLON_DASH] = ACTIONS(9866),
    [anon_sym_PERCENT] = ACTIONS(9866),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4308] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9864),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4309] = {
    [sym_concatenation] = STATE(4357),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4357),
    [sym_regex] = ACTIONS(9870),
    [anon_sym_RBRACE] = ACTIONS(9856),
    [anon_sym_EQ] = ACTIONS(9872),
    [anon_sym_DASH] = ACTIONS(9872),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9872),
    [anon_sym_COLON_QMARK] = ACTIONS(9872),
    [anon_sym_COLON_DASH] = ACTIONS(9872),
    [anon_sym_PERCENT] = ACTIONS(9872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4310] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9856),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4311] = {
    [sym_concatenation] = STATE(4359),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4359),
    [anon_sym_RBRACE] = ACTIONS(9876),
    [anon_sym_EQ] = ACTIONS(9878),
    [anon_sym_DASH] = ACTIONS(9878),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9878),
    [anon_sym_COLON_QMARK] = ACTIONS(9878),
    [anon_sym_COLON_DASH] = ACTIONS(9878),
    [anon_sym_PERCENT] = ACTIONS(9878),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4312] = {
    [sym__simple_heredoc_body] = ACTIONS(4159),
    [sym__heredoc_body_beginning] = ACTIONS(4159),
    [sym_file_descriptor] = ACTIONS(4159),
    [sym__concat] = ACTIONS(4159),
    [sym_variable_name] = ACTIONS(4159),
    [anon_sym_SEMI] = ACTIONS(4161),
    [anon_sym_esac] = ACTIONS(4161),
    [anon_sym_PIPE] = ACTIONS(4161),
    [anon_sym_SEMI_SEMI] = ACTIONS(4159),
    [anon_sym_PIPE_AMP] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4159),
    [anon_sym_PIPE_PIPE] = ACTIONS(4159),
    [anon_sym_LT] = ACTIONS(4161),
    [anon_sym_GT] = ACTIONS(4161),
    [anon_sym_GT_GT] = ACTIONS(4159),
    [anon_sym_AMP_GT] = ACTIONS(4161),
    [anon_sym_AMP_GT_GT] = ACTIONS(4159),
    [anon_sym_LT_AMP] = ACTIONS(4159),
    [anon_sym_GT_AMP] = ACTIONS(4159),
    [anon_sym_LT_LT] = ACTIONS(4161),
    [anon_sym_LT_LT_DASH] = ACTIONS(4159),
    [anon_sym_LT_LT_LT] = ACTIONS(4159),
    [sym__special_character] = ACTIONS(4159),
    [anon_sym_DQUOTE] = ACTIONS(4159),
    [anon_sym_DOLLAR] = ACTIONS(4161),
    [sym_raw_string] = ACTIONS(4159),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4159),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4159),
    [anon_sym_BQUOTE] = ACTIONS(4159),
    [anon_sym_LT_LPAREN] = ACTIONS(4159),
    [anon_sym_GT_LPAREN] = ACTIONS(4159),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(4161),
    [anon_sym_LF] = ACTIONS(4159),
    [anon_sym_AMP] = ACTIONS(4161),
  },
  [4313] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9876),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4314] = {
    [sym_concatenation] = STATE(4357),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4357),
    [anon_sym_RBRACE] = ACTIONS(9856),
    [anon_sym_EQ] = ACTIONS(9872),
    [anon_sym_DASH] = ACTIONS(9872),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9874),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9872),
    [anon_sym_COLON_QMARK] = ACTIONS(9872),
    [anon_sym_COLON_DASH] = ACTIONS(9872),
    [anon_sym_PERCENT] = ACTIONS(9872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4315] = {
    [sym__simple_heredoc_body] = ACTIONS(4383),
    [sym__heredoc_body_beginning] = ACTIONS(4383),
    [sym_file_descriptor] = ACTIONS(4383),
    [sym_variable_name] = ACTIONS(4383),
    [anon_sym_SEMI] = ACTIONS(4385),
    [anon_sym_esac] = ACTIONS(4385),
    [anon_sym_PIPE] = ACTIONS(4385),
    [anon_sym_SEMI_SEMI] = ACTIONS(4383),
    [anon_sym_PIPE_AMP] = ACTIONS(4383),
    [anon_sym_AMP_AMP] = ACTIONS(4383),
    [anon_sym_PIPE_PIPE] = ACTIONS(4383),
    [anon_sym_LT] = ACTIONS(4385),
    [anon_sym_GT] = ACTIONS(4385),
    [anon_sym_GT_GT] = ACTIONS(4383),
    [anon_sym_AMP_GT] = ACTIONS(4385),
    [anon_sym_AMP_GT_GT] = ACTIONS(4383),
    [anon_sym_LT_AMP] = ACTIONS(4383),
    [anon_sym_GT_AMP] = ACTIONS(4383),
    [anon_sym_LT_LT] = ACTIONS(4385),
    [anon_sym_LT_LT_DASH] = ACTIONS(4383),
    [anon_sym_LT_LT_LT] = ACTIONS(4383),
    [sym__special_character] = ACTIONS(4383),
    [anon_sym_DQUOTE] = ACTIONS(4383),
    [anon_sym_DOLLAR] = ACTIONS(4385),
    [sym_raw_string] = ACTIONS(4383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4383),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4383),
    [anon_sym_BQUOTE] = ACTIONS(4383),
    [anon_sym_LT_LPAREN] = ACTIONS(4383),
    [anon_sym_GT_LPAREN] = ACTIONS(4383),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4385),
    [sym_word] = ACTIONS(4385),
    [anon_sym_LF] = ACTIONS(4383),
    [anon_sym_AMP] = ACTIONS(4385),
  },
  [4316] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [sym_variable_name] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_esac] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5566),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [4317] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [sym_variable_name] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_esac] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5600),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [4318] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(9882),
    [sym_comment] = ACTIONS(57),
  },
  [4319] = {
    [anon_sym_RBRACE] = ACTIONS(9882),
    [sym_comment] = ACTIONS(57),
  },
  [4320] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(9884),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [4321] = {
    [sym_concatenation] = STATE(4363),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4363),
    [anon_sym_RBRACE] = ACTIONS(9886),
    [anon_sym_EQ] = ACTIONS(9888),
    [anon_sym_DASH] = ACTIONS(9888),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9888),
    [anon_sym_COLON_QMARK] = ACTIONS(9888),
    [anon_sym_COLON_DASH] = ACTIONS(9888),
    [anon_sym_PERCENT] = ACTIONS(9888),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4322] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [sym_variable_name] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_esac] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5617),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [4323] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9886),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4324] = {
    [sym_concatenation] = STATE(4364),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4364),
    [anon_sym_RBRACE] = ACTIONS(9882),
    [anon_sym_EQ] = ACTIONS(9892),
    [anon_sym_DASH] = ACTIONS(9892),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9894),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9892),
    [anon_sym_COLON_QMARK] = ACTIONS(9892),
    [anon_sym_COLON_DASH] = ACTIONS(9892),
    [anon_sym_PERCENT] = ACTIONS(9892),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4325] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9882),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4326] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [sym_variable_name] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_esac] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5660),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [4327] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9896),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4328] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_esac] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5566),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [4329] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_esac] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5600),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [4330] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(9898),
    [sym_comment] = ACTIONS(57),
  },
  [4331] = {
    [anon_sym_RBRACE] = ACTIONS(9898),
    [sym_comment] = ACTIONS(57),
  },
  [4332] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(9900),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [4333] = {
    [sym_concatenation] = STATE(4369),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4369),
    [anon_sym_RBRACE] = ACTIONS(9902),
    [anon_sym_EQ] = ACTIONS(9904),
    [anon_sym_DASH] = ACTIONS(9904),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9906),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9904),
    [anon_sym_COLON_QMARK] = ACTIONS(9904),
    [anon_sym_COLON_DASH] = ACTIONS(9904),
    [anon_sym_PERCENT] = ACTIONS(9904),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4334] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_esac] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5617),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [4335] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9902),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4336] = {
    [sym_concatenation] = STATE(4370),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4370),
    [anon_sym_RBRACE] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9908),
    [anon_sym_DASH] = ACTIONS(9908),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9910),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9908),
    [anon_sym_COLON_QMARK] = ACTIONS(9908),
    [anon_sym_COLON_DASH] = ACTIONS(9908),
    [anon_sym_PERCENT] = ACTIONS(9908),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4337] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4338] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_esac] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(5660),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [4339] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4340] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_esac] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_EQ_TILDE] = ACTIONS(7042),
    [anon_sym_EQ_EQ] = ACTIONS(7042),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [4341] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_esac] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_EQ_TILDE] = ACTIONS(7046),
    [anon_sym_EQ_EQ] = ACTIONS(7046),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [4342] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_esac] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_EQ_TILDE] = ACTIONS(7050),
    [anon_sym_EQ_EQ] = ACTIONS(7050),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [4343] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9914),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4344] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4345] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_esac] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_EQ_TILDE] = ACTIONS(7084),
    [anon_sym_EQ_EQ] = ACTIONS(7084),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [4346] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [sym_variable_name] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_fi] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [4347] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [sym_variable_name] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_fi] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [4348] = {
    [sym__simple_heredoc_body] = ACTIONS(5564),
    [sym__heredoc_body_beginning] = ACTIONS(5564),
    [sym_file_descriptor] = ACTIONS(5564),
    [sym__concat] = ACTIONS(5564),
    [sym_variable_name] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym_esac] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5566),
    [anon_sym_SEMI_SEMI] = ACTIONS(5564),
    [anon_sym_PIPE_AMP] = ACTIONS(5564),
    [anon_sym_AMP_AMP] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_AMP_GT] = ACTIONS(5566),
    [anon_sym_AMP_GT_GT] = ACTIONS(5564),
    [anon_sym_LT_AMP] = ACTIONS(5564),
    [anon_sym_GT_AMP] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_LT_LT_DASH] = ACTIONS(5564),
    [anon_sym_LT_LT_LT] = ACTIONS(5564),
    [sym__special_character] = ACTIONS(5564),
    [anon_sym_DQUOTE] = ACTIONS(5564),
    [anon_sym_DOLLAR] = ACTIONS(5566),
    [sym_raw_string] = ACTIONS(5564),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5564),
    [anon_sym_BQUOTE] = ACTIONS(5564),
    [anon_sym_LT_LPAREN] = ACTIONS(5564),
    [anon_sym_GT_LPAREN] = ACTIONS(5564),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5566),
    [anon_sym_LF] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5566),
  },
  [4349] = {
    [sym__simple_heredoc_body] = ACTIONS(5598),
    [sym__heredoc_body_beginning] = ACTIONS(5598),
    [sym_file_descriptor] = ACTIONS(5598),
    [sym__concat] = ACTIONS(5598),
    [sym_variable_name] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_esac] = ACTIONS(5600),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_SEMI_SEMI] = ACTIONS(5598),
    [anon_sym_PIPE_AMP] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_AMP_GT] = ACTIONS(5600),
    [anon_sym_AMP_GT_GT] = ACTIONS(5598),
    [anon_sym_LT_AMP] = ACTIONS(5598),
    [anon_sym_GT_AMP] = ACTIONS(5598),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_LT_LT_DASH] = ACTIONS(5598),
    [anon_sym_LT_LT_LT] = ACTIONS(5598),
    [sym__special_character] = ACTIONS(5598),
    [anon_sym_DQUOTE] = ACTIONS(5598),
    [anon_sym_DOLLAR] = ACTIONS(5600),
    [sym_raw_string] = ACTIONS(5598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5598),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5598),
    [anon_sym_BQUOTE] = ACTIONS(5598),
    [anon_sym_LT_LPAREN] = ACTIONS(5598),
    [anon_sym_GT_LPAREN] = ACTIONS(5598),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5600),
    [anon_sym_LF] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5600),
  },
  [4350] = {
    [aux_sym_concatenation_repeat1] = STATE(1903),
    [sym__concat] = ACTIONS(4071),
    [anon_sym_RBRACE] = ACTIONS(9918),
    [sym_comment] = ACTIONS(57),
  },
  [4351] = {
    [anon_sym_RBRACE] = ACTIONS(9918),
    [sym_comment] = ACTIONS(57),
  },
  [4352] = {
    [aux_sym__literal_repeat1] = STATE(1921),
    [anon_sym_RBRACE] = ACTIONS(9920),
    [sym__special_character] = ACTIONS(4099),
    [sym_comment] = ACTIONS(57),
  },
  [4353] = {
    [sym_concatenation] = STATE(4377),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4377),
    [anon_sym_RBRACE] = ACTIONS(9922),
    [anon_sym_EQ] = ACTIONS(9924),
    [anon_sym_DASH] = ACTIONS(9924),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9926),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9924),
    [anon_sym_COLON_QMARK] = ACTIONS(9924),
    [anon_sym_COLON_DASH] = ACTIONS(9924),
    [anon_sym_PERCENT] = ACTIONS(9924),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4354] = {
    [sym__simple_heredoc_body] = ACTIONS(5615),
    [sym__heredoc_body_beginning] = ACTIONS(5615),
    [sym_file_descriptor] = ACTIONS(5615),
    [sym__concat] = ACTIONS(5615),
    [sym_variable_name] = ACTIONS(5615),
    [anon_sym_SEMI] = ACTIONS(5617),
    [anon_sym_esac] = ACTIONS(5617),
    [anon_sym_PIPE] = ACTIONS(5617),
    [anon_sym_SEMI_SEMI] = ACTIONS(5615),
    [anon_sym_PIPE_AMP] = ACTIONS(5615),
    [anon_sym_AMP_AMP] = ACTIONS(5615),
    [anon_sym_PIPE_PIPE] = ACTIONS(5615),
    [anon_sym_LT] = ACTIONS(5617),
    [anon_sym_GT] = ACTIONS(5617),
    [anon_sym_GT_GT] = ACTIONS(5615),
    [anon_sym_AMP_GT] = ACTIONS(5617),
    [anon_sym_AMP_GT_GT] = ACTIONS(5615),
    [anon_sym_LT_AMP] = ACTIONS(5615),
    [anon_sym_GT_AMP] = ACTIONS(5615),
    [anon_sym_LT_LT] = ACTIONS(5617),
    [anon_sym_LT_LT_DASH] = ACTIONS(5615),
    [anon_sym_LT_LT_LT] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(5617),
    [sym_raw_string] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5615),
    [anon_sym_BQUOTE] = ACTIONS(5615),
    [anon_sym_LT_LPAREN] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(5615),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5617),
    [anon_sym_LF] = ACTIONS(5615),
    [anon_sym_AMP] = ACTIONS(5617),
  },
  [4355] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9922),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4356] = {
    [sym_concatenation] = STATE(4378),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(4378),
    [anon_sym_RBRACE] = ACTIONS(9918),
    [anon_sym_EQ] = ACTIONS(9928),
    [anon_sym_DASH] = ACTIONS(9928),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(9930),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(9928),
    [anon_sym_COLON_QMARK] = ACTIONS(9928),
    [anon_sym_COLON_DASH] = ACTIONS(9928),
    [anon_sym_PERCENT] = ACTIONS(9928),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4357] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9918),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4358] = {
    [sym__simple_heredoc_body] = ACTIONS(5658),
    [sym__heredoc_body_beginning] = ACTIONS(5658),
    [sym_file_descriptor] = ACTIONS(5658),
    [sym__concat] = ACTIONS(5658),
    [sym_variable_name] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_esac] = ACTIONS(5660),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_SEMI_SEMI] = ACTIONS(5658),
    [anon_sym_PIPE_AMP] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_AMP_GT] = ACTIONS(5660),
    [anon_sym_AMP_GT_GT] = ACTIONS(5658),
    [anon_sym_LT_AMP] = ACTIONS(5658),
    [anon_sym_GT_AMP] = ACTIONS(5658),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_LT_LT_DASH] = ACTIONS(5658),
    [anon_sym_LT_LT_LT] = ACTIONS(5658),
    [sym__special_character] = ACTIONS(5658),
    [anon_sym_DQUOTE] = ACTIONS(5658),
    [anon_sym_DOLLAR] = ACTIONS(5660),
    [sym_raw_string] = ACTIONS(5658),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(5658),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(5658),
    [anon_sym_BQUOTE] = ACTIONS(5658),
    [anon_sym_LT_LPAREN] = ACTIONS(5658),
    [anon_sym_GT_LPAREN] = ACTIONS(5658),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(5660),
    [anon_sym_LF] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5660),
  },
  [4359] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9932),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4360] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [sym_variable_name] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_esac] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7042),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [4361] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [sym_variable_name] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_esac] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7046),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [4362] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [sym_variable_name] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_esac] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7050),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [4363] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9934),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4364] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9936),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4365] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [sym_variable_name] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_esac] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7084),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [4366] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_esac] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7042),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [4367] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_esac] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7046),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [4368] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_esac] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7050),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [4369] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9938),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4370] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9940),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4371] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_esac] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(7084),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [4372] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_esac] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_EQ_TILDE] = ACTIONS(8146),
    [anon_sym_EQ_EQ] = ACTIONS(8146),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [4373] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_esac] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_EQ_TILDE] = ACTIONS(8150),
    [anon_sym_EQ_EQ] = ACTIONS(8150),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [4374] = {
    [sym__simple_heredoc_body] = ACTIONS(7040),
    [sym__heredoc_body_beginning] = ACTIONS(7040),
    [sym_file_descriptor] = ACTIONS(7040),
    [sym__concat] = ACTIONS(7040),
    [sym_variable_name] = ACTIONS(7040),
    [anon_sym_SEMI] = ACTIONS(7042),
    [anon_sym_esac] = ACTIONS(7042),
    [anon_sym_PIPE] = ACTIONS(7042),
    [anon_sym_SEMI_SEMI] = ACTIONS(7040),
    [anon_sym_PIPE_AMP] = ACTIONS(7040),
    [anon_sym_AMP_AMP] = ACTIONS(7040),
    [anon_sym_PIPE_PIPE] = ACTIONS(7040),
    [anon_sym_LT] = ACTIONS(7042),
    [anon_sym_GT] = ACTIONS(7042),
    [anon_sym_GT_GT] = ACTIONS(7040),
    [anon_sym_AMP_GT] = ACTIONS(7042),
    [anon_sym_AMP_GT_GT] = ACTIONS(7040),
    [anon_sym_LT_AMP] = ACTIONS(7040),
    [anon_sym_GT_AMP] = ACTIONS(7040),
    [anon_sym_LT_LT] = ACTIONS(7042),
    [anon_sym_LT_LT_DASH] = ACTIONS(7040),
    [anon_sym_LT_LT_LT] = ACTIONS(7040),
    [sym__special_character] = ACTIONS(7040),
    [anon_sym_DQUOTE] = ACTIONS(7040),
    [anon_sym_DOLLAR] = ACTIONS(7042),
    [sym_raw_string] = ACTIONS(7040),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7040),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7040),
    [anon_sym_BQUOTE] = ACTIONS(7040),
    [anon_sym_LT_LPAREN] = ACTIONS(7040),
    [anon_sym_GT_LPAREN] = ACTIONS(7040),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7042),
    [anon_sym_LF] = ACTIONS(7040),
    [anon_sym_AMP] = ACTIONS(7042),
  },
  [4375] = {
    [sym__simple_heredoc_body] = ACTIONS(7044),
    [sym__heredoc_body_beginning] = ACTIONS(7044),
    [sym_file_descriptor] = ACTIONS(7044),
    [sym__concat] = ACTIONS(7044),
    [sym_variable_name] = ACTIONS(7044),
    [anon_sym_SEMI] = ACTIONS(7046),
    [anon_sym_esac] = ACTIONS(7046),
    [anon_sym_PIPE] = ACTIONS(7046),
    [anon_sym_SEMI_SEMI] = ACTIONS(7044),
    [anon_sym_PIPE_AMP] = ACTIONS(7044),
    [anon_sym_AMP_AMP] = ACTIONS(7044),
    [anon_sym_PIPE_PIPE] = ACTIONS(7044),
    [anon_sym_LT] = ACTIONS(7046),
    [anon_sym_GT] = ACTIONS(7046),
    [anon_sym_GT_GT] = ACTIONS(7044),
    [anon_sym_AMP_GT] = ACTIONS(7046),
    [anon_sym_AMP_GT_GT] = ACTIONS(7044),
    [anon_sym_LT_AMP] = ACTIONS(7044),
    [anon_sym_GT_AMP] = ACTIONS(7044),
    [anon_sym_LT_LT] = ACTIONS(7046),
    [anon_sym_LT_LT_DASH] = ACTIONS(7044),
    [anon_sym_LT_LT_LT] = ACTIONS(7044),
    [sym__special_character] = ACTIONS(7044),
    [anon_sym_DQUOTE] = ACTIONS(7044),
    [anon_sym_DOLLAR] = ACTIONS(7046),
    [sym_raw_string] = ACTIONS(7044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7044),
    [anon_sym_BQUOTE] = ACTIONS(7044),
    [anon_sym_LT_LPAREN] = ACTIONS(7044),
    [anon_sym_GT_LPAREN] = ACTIONS(7044),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7046),
    [anon_sym_LF] = ACTIONS(7044),
    [anon_sym_AMP] = ACTIONS(7046),
  },
  [4376] = {
    [sym__simple_heredoc_body] = ACTIONS(7048),
    [sym__heredoc_body_beginning] = ACTIONS(7048),
    [sym_file_descriptor] = ACTIONS(7048),
    [sym__concat] = ACTIONS(7048),
    [sym_variable_name] = ACTIONS(7048),
    [anon_sym_SEMI] = ACTIONS(7050),
    [anon_sym_esac] = ACTIONS(7050),
    [anon_sym_PIPE] = ACTIONS(7050),
    [anon_sym_SEMI_SEMI] = ACTIONS(7048),
    [anon_sym_PIPE_AMP] = ACTIONS(7048),
    [anon_sym_AMP_AMP] = ACTIONS(7048),
    [anon_sym_PIPE_PIPE] = ACTIONS(7048),
    [anon_sym_LT] = ACTIONS(7050),
    [anon_sym_GT] = ACTIONS(7050),
    [anon_sym_GT_GT] = ACTIONS(7048),
    [anon_sym_AMP_GT] = ACTIONS(7050),
    [anon_sym_AMP_GT_GT] = ACTIONS(7048),
    [anon_sym_LT_AMP] = ACTIONS(7048),
    [anon_sym_GT_AMP] = ACTIONS(7048),
    [anon_sym_LT_LT] = ACTIONS(7050),
    [anon_sym_LT_LT_DASH] = ACTIONS(7048),
    [anon_sym_LT_LT_LT] = ACTIONS(7048),
    [sym__special_character] = ACTIONS(7048),
    [anon_sym_DQUOTE] = ACTIONS(7048),
    [anon_sym_DOLLAR] = ACTIONS(7050),
    [sym_raw_string] = ACTIONS(7048),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7048),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7048),
    [anon_sym_BQUOTE] = ACTIONS(7048),
    [anon_sym_LT_LPAREN] = ACTIONS(7048),
    [anon_sym_GT_LPAREN] = ACTIONS(7048),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7050),
    [anon_sym_LF] = ACTIONS(7048),
    [anon_sym_AMP] = ACTIONS(7050),
  },
  [4377] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9942),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4378] = {
    [sym_concatenation] = STATE(1270),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_string_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [aux_sym__literal_repeat1] = STATE(642),
    [aux_sym_expansion_repeat1] = STATE(1270),
    [anon_sym_RBRACE] = ACTIONS(9944),
    [anon_sym_EQ] = ACTIONS(2488),
    [anon_sym_DASH] = ACTIONS(2488),
    [sym__special_character] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_DOLLAR] = ACTIONS(1129),
    [sym_raw_string] = ACTIONS(1131),
    [anon_sym_POUND] = ACTIONS(2490),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1135),
    [anon_sym_COLON] = ACTIONS(2488),
    [anon_sym_COLON_QMARK] = ACTIONS(2488),
    [anon_sym_COLON_DASH] = ACTIONS(2488),
    [anon_sym_PERCENT] = ACTIONS(2488),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1139),
    [anon_sym_BQUOTE] = ACTIONS(1141),
    [anon_sym_LT_LPAREN] = ACTIONS(1143),
    [anon_sym_GT_LPAREN] = ACTIONS(1143),
    [sym_comment] = ACTIONS(343),
    [sym_word] = ACTIONS(1145),
  },
  [4379] = {
    [sym__simple_heredoc_body] = ACTIONS(7082),
    [sym__heredoc_body_beginning] = ACTIONS(7082),
    [sym_file_descriptor] = ACTIONS(7082),
    [sym__concat] = ACTIONS(7082),
    [sym_variable_name] = ACTIONS(7082),
    [anon_sym_SEMI] = ACTIONS(7084),
    [anon_sym_esac] = ACTIONS(7084),
    [anon_sym_PIPE] = ACTIONS(7084),
    [anon_sym_SEMI_SEMI] = ACTIONS(7082),
    [anon_sym_PIPE_AMP] = ACTIONS(7082),
    [anon_sym_AMP_AMP] = ACTIONS(7082),
    [anon_sym_PIPE_PIPE] = ACTIONS(7082),
    [anon_sym_LT] = ACTIONS(7084),
    [anon_sym_GT] = ACTIONS(7084),
    [anon_sym_GT_GT] = ACTIONS(7082),
    [anon_sym_AMP_GT] = ACTIONS(7084),
    [anon_sym_AMP_GT_GT] = ACTIONS(7082),
    [anon_sym_LT_AMP] = ACTIONS(7082),
    [anon_sym_GT_AMP] = ACTIONS(7082),
    [anon_sym_LT_LT] = ACTIONS(7084),
    [anon_sym_LT_LT_DASH] = ACTIONS(7082),
    [anon_sym_LT_LT_LT] = ACTIONS(7082),
    [sym__special_character] = ACTIONS(7082),
    [anon_sym_DQUOTE] = ACTIONS(7082),
    [anon_sym_DOLLAR] = ACTIONS(7084),
    [sym_raw_string] = ACTIONS(7082),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(7082),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(7082),
    [anon_sym_BQUOTE] = ACTIONS(7082),
    [anon_sym_LT_LPAREN] = ACTIONS(7082),
    [anon_sym_GT_LPAREN] = ACTIONS(7082),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(7084),
    [anon_sym_LF] = ACTIONS(7082),
    [anon_sym_AMP] = ACTIONS(7084),
  },
  [4380] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [sym_variable_name] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_esac] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8146),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [4381] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [sym_variable_name] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_esac] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8150),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [4382] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_esac] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8146),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [4383] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_esac] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(8150),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
  [4384] = {
    [sym__simple_heredoc_body] = ACTIONS(8144),
    [sym__heredoc_body_beginning] = ACTIONS(8144),
    [sym_file_descriptor] = ACTIONS(8144),
    [sym__concat] = ACTIONS(8144),
    [sym_variable_name] = ACTIONS(8144),
    [anon_sym_SEMI] = ACTIONS(8146),
    [anon_sym_esac] = ACTIONS(8146),
    [anon_sym_PIPE] = ACTIONS(8146),
    [anon_sym_SEMI_SEMI] = ACTIONS(8144),
    [anon_sym_PIPE_AMP] = ACTIONS(8144),
    [anon_sym_AMP_AMP] = ACTIONS(8144),
    [anon_sym_PIPE_PIPE] = ACTIONS(8144),
    [anon_sym_LT] = ACTIONS(8146),
    [anon_sym_GT] = ACTIONS(8146),
    [anon_sym_GT_GT] = ACTIONS(8144),
    [anon_sym_AMP_GT] = ACTIONS(8146),
    [anon_sym_AMP_GT_GT] = ACTIONS(8144),
    [anon_sym_LT_AMP] = ACTIONS(8144),
    [anon_sym_GT_AMP] = ACTIONS(8144),
    [anon_sym_LT_LT] = ACTIONS(8146),
    [anon_sym_LT_LT_DASH] = ACTIONS(8144),
    [anon_sym_LT_LT_LT] = ACTIONS(8144),
    [sym__special_character] = ACTIONS(8144),
    [anon_sym_DQUOTE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(8146),
    [sym_raw_string] = ACTIONS(8144),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8144),
    [anon_sym_BQUOTE] = ACTIONS(8144),
    [anon_sym_LT_LPAREN] = ACTIONS(8144),
    [anon_sym_GT_LPAREN] = ACTIONS(8144),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8146),
    [anon_sym_LF] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
  },
  [4385] = {
    [sym__simple_heredoc_body] = ACTIONS(8148),
    [sym__heredoc_body_beginning] = ACTIONS(8148),
    [sym_file_descriptor] = ACTIONS(8148),
    [sym__concat] = ACTIONS(8148),
    [sym_variable_name] = ACTIONS(8148),
    [anon_sym_SEMI] = ACTIONS(8150),
    [anon_sym_esac] = ACTIONS(8150),
    [anon_sym_PIPE] = ACTIONS(8150),
    [anon_sym_SEMI_SEMI] = ACTIONS(8148),
    [anon_sym_PIPE_AMP] = ACTIONS(8148),
    [anon_sym_AMP_AMP] = ACTIONS(8148),
    [anon_sym_PIPE_PIPE] = ACTIONS(8148),
    [anon_sym_LT] = ACTIONS(8150),
    [anon_sym_GT] = ACTIONS(8150),
    [anon_sym_GT_GT] = ACTIONS(8148),
    [anon_sym_AMP_GT] = ACTIONS(8150),
    [anon_sym_AMP_GT_GT] = ACTIONS(8148),
    [anon_sym_LT_AMP] = ACTIONS(8148),
    [anon_sym_GT_AMP] = ACTIONS(8148),
    [anon_sym_LT_LT] = ACTIONS(8150),
    [anon_sym_LT_LT_DASH] = ACTIONS(8148),
    [anon_sym_LT_LT_LT] = ACTIONS(8148),
    [sym__special_character] = ACTIONS(8148),
    [anon_sym_DQUOTE] = ACTIONS(8148),
    [anon_sym_DOLLAR] = ACTIONS(8150),
    [sym_raw_string] = ACTIONS(8148),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(8148),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(8148),
    [anon_sym_BQUOTE] = ACTIONS(8148),
    [anon_sym_LT_LPAREN] = ACTIONS(8148),
    [anon_sym_GT_LPAREN] = ACTIONS(8148),
    [sym_comment] = ACTIONS(57),
    [sym_word] = ACTIONS(8150),
    [anon_sym_LF] = ACTIONS(8148),
    [anon_sym_AMP] = ACTIONS(8150),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = true}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, RECOVER(),
  [5] = {.count = 1, .reusable = true}, SHIFT(2),
  [7] = {.count = 1, .reusable = true}, SHIFT(3),
  [9] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [11] = {.count = 1, .reusable = false}, SHIFT(4),
  [13] = {.count = 1, .reusable = true}, SHIFT(5),
  [15] = {.count = 1, .reusable = false}, SHIFT(6),
  [17] = {.count = 1, .reusable = false}, SHIFT(7),
  [19] = {.count = 1, .reusable = false}, SHIFT(8),
  [21] = {.count = 1, .reusable = false}, SHIFT(9),
  [23] = {.count = 1, .reusable = false}, SHIFT(10),
  [25] = {.count = 1, .reusable = true}, SHIFT(11),
  [27] = {.count = 1, .reusable = false}, SHIFT(12),
  [29] = {.count = 1, .reusable = false}, SHIFT(13),
  [31] = {.count = 1, .reusable = true}, SHIFT(14),
  [33] = {.count = 1, .reusable = false}, SHIFT(15),
  [35] = {.count = 1, .reusable = false}, SHIFT(16),
  [37] = {.count = 1, .reusable = false}, SHIFT(17),
  [39] = {.count = 1, .reusable = true}, SHIFT(17),
  [41] = {.count = 1, .reusable = false}, SHIFT(18),
  [43] = {.count = 1, .reusable = true}, SHIFT(19),
  [45] = {.count = 1, .reusable = false}, SHIFT(20),
  [47] = {.count = 1, .reusable = true}, SHIFT(21),
  [49] = {.count = 1, .reusable = true}, SHIFT(22),
  [51] = {.count = 1, .reusable = true}, SHIFT(23),
  [53] = {.count = 1, .reusable = true}, SHIFT(24),
  [55] = {.count = 1, .reusable = true}, SHIFT(25),
  [57] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [59] = {.count = 1, .reusable = false}, SHIFT(26),
  [61] = {.count = 1, .reusable = false}, SHIFT(37),
  [63] = {.count = 1, .reusable = true}, SHIFT(37),
  [65] = {.count = 1, .reusable = true}, SHIFT(38),
  [67] = {.count = 1, .reusable = true}, SHIFT(39),
  [69] = {.count = 1, .reusable = true}, SHIFT(40),
  [71] = {.count = 1, .reusable = true}, SHIFT(41),
  [73] = {.count = 1, .reusable = true}, SHIFT(42),
  [75] = {.count = 1, .reusable = false}, SHIFT(43),
  [77] = {.count = 1, .reusable = true}, SHIFT(44),
  [79] = {.count = 1, .reusable = true}, SHIFT(45),
  [81] = {.count = 1, .reusable = false}, SHIFT(46),
  [83] = {.count = 1, .reusable = true}, SHIFT(47),
  [85] = {.count = 1, .reusable = true}, SHIFT(48),
  [87] = {.count = 1, .reusable = true}, SHIFT(49),
  [89] = {.count = 1, .reusable = true}, SHIFT(50),
  [91] = {.count = 1, .reusable = true}, SHIFT(51),
  [93] = {.count = 1, .reusable = false}, SHIFT(47),
  [95] = {.count = 1, .reusable = true}, SHIFT(43),
  [97] = {.count = 1, .reusable = true}, SHIFT(54),
  [99] = {.count = 1, .reusable = false}, SHIFT(55),
  [101] = {.count = 1, .reusable = true}, SHIFT(56),
  [103] = {.count = 1, .reusable = false}, SHIFT(57),
  [105] = {.count = 1, .reusable = false}, SHIFT(58),
  [107] = {.count = 1, .reusable = false}, SHIFT(59),
  [109] = {.count = 1, .reusable = false}, SHIFT(60),
  [111] = {.count = 1, .reusable = false}, SHIFT(61),
  [113] = {.count = 1, .reusable = true}, SHIFT(62),
  [115] = {.count = 1, .reusable = false}, SHIFT(63),
  [117] = {.count = 1, .reusable = false}, SHIFT(64),
  [119] = {.count = 1, .reusable = true}, SHIFT(65),
  [121] = {.count = 1, .reusable = false}, SHIFT(66),
  [123] = {.count = 1, .reusable = false}, SHIFT(67),
  [125] = {.count = 1, .reusable = false}, SHIFT(68),
  [127] = {.count = 1, .reusable = true}, SHIFT(69),
  [129] = {.count = 1, .reusable = false}, SHIFT(70),
  [131] = {.count = 1, .reusable = true}, SHIFT(71),
  [133] = {.count = 1, .reusable = true}, SHIFT(72),
  [135] = {.count = 1, .reusable = true}, SHIFT(73),
  [137] = {.count = 1, .reusable = true}, SHIFT(74),
  [139] = {.count = 1, .reusable = true}, SHIFT(75),
  [141] = {.count = 1, .reusable = false}, SHIFT(76),
  [143] = {.count = 1, .reusable = true}, SHIFT(86),
  [145] = {.count = 1, .reusable = true}, SHIFT(87),
  [147] = {.count = 1, .reusable = false}, SHIFT(88),
  [149] = {.count = 1, .reusable = true}, SHIFT(89),
  [151] = {.count = 1, .reusable = true}, SHIFT(90),
  [153] = {.count = 1, .reusable = true}, SHIFT(91),
  [155] = {.count = 1, .reusable = true}, SHIFT(92),
  [157] = {.count = 1, .reusable = true}, SHIFT(93),
  [159] = {.count = 1, .reusable = true}, SHIFT(96),
  [161] = {.count = 1, .reusable = true}, SHIFT(97),
  [163] = {.count = 1, .reusable = false}, SHIFT(98),
  [165] = {.count = 1, .reusable = false}, SHIFT(99),
  [167] = {.count = 1, .reusable = false}, SHIFT(100),
  [169] = {.count = 1, .reusable = false}, SHIFT(101),
  [171] = {.count = 1, .reusable = true}, SHIFT(102),
  [173] = {.count = 1, .reusable = false}, SHIFT(103),
  [175] = {.count = 1, .reusable = true}, SHIFT(112),
  [177] = {.count = 1, .reusable = false}, SHIFT(113),
  [179] = {.count = 1, .reusable = true}, SHIFT(114),
  [181] = {.count = 1, .reusable = false}, SHIFT(115),
  [183] = {.count = 1, .reusable = false}, SHIFT(116),
  [185] = {.count = 1, .reusable = false}, SHIFT(117),
  [187] = {.count = 1, .reusable = false}, SHIFT(118),
  [189] = {.count = 1, .reusable = false}, SHIFT(119),
  [191] = {.count = 1, .reusable = true}, SHIFT(120),
  [193] = {.count = 1, .reusable = true}, SHIFT(121),
  [195] = {.count = 1, .reusable = false}, SHIFT(122),
  [197] = {.count = 1, .reusable = false}, SHIFT(123),
  [199] = {.count = 1, .reusable = true}, SHIFT(124),
  [201] = {.count = 1, .reusable = false}, SHIFT(125),
  [203] = {.count = 1, .reusable = false}, SHIFT(126),
  [205] = {.count = 1, .reusable = false}, SHIFT(127),
  [207] = {.count = 1, .reusable = true}, SHIFT(128),
  [209] = {.count = 1, .reusable = false}, SHIFT(129),
  [211] = {.count = 1, .reusable = true}, SHIFT(130),
  [213] = {.count = 1, .reusable = true}, SHIFT(131),
  [215] = {.count = 1, .reusable = true}, SHIFT(132),
  [217] = {.count = 1, .reusable = true}, SHIFT(133),
  [219] = {.count = 1, .reusable = true}, SHIFT(134),
  [221] = {.count = 1, .reusable = false}, SHIFT(135),
  [223] = {.count = 1, .reusable = true}, SHIFT(145),
  [225] = {.count = 1, .reusable = true}, SHIFT(148),
  [227] = {.count = 1, .reusable = false}, SHIFT(149),
  [229] = {.count = 1, .reusable = true}, SHIFT(150),
  [231] = {.count = 1, .reusable = true}, SHIFT(151),
  [233] = {.count = 1, .reusable = false}, SHIFT(152),
  [235] = {.count = 1, .reusable = true}, SHIFT(153),
  [237] = {.count = 1, .reusable = true}, SHIFT(154),
  [239] = {.count = 1, .reusable = true}, SHIFT(155),
  [241] = {.count = 1, .reusable = true}, SHIFT(156),
  [243] = {.count = 1, .reusable = true}, SHIFT(157),
  [245] = {.count = 1, .reusable = false}, SHIFT(153),
  [247] = {.count = 1, .reusable = true}, SHIFT(149),
  [249] = {.count = 1, .reusable = false}, SHIFT(160),
  [251] = {.count = 1, .reusable = true}, SHIFT(161),
  [253] = {.count = 1, .reusable = true}, SHIFT(162),
  [255] = {.count = 1, .reusable = false}, SHIFT(162),
  [257] = {.count = 1, .reusable = true}, SHIFT(160),
  [259] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 1),
  [261] = {.count = 1, .reusable = true}, SHIFT(165),
  [263] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 1),
  [265] = {.count = 1, .reusable = true}, SHIFT(166),
  [267] = {.count = 1, .reusable = true}, SHIFT(167),
  [269] = {.count = 1, .reusable = false}, SHIFT(168),
  [271] = {.count = 1, .reusable = true}, SHIFT(169),
  [273] = {.count = 1, .reusable = true}, SHIFT(170),
  [275] = {.count = 1, .reusable = true}, SHIFT(171),
  [277] = {.count = 1, .reusable = true}, SHIFT(172),
  [279] = {.count = 1, .reusable = true}, SHIFT(173),
  [281] = {.count = 1, .reusable = false}, SHIFT(175),
  [283] = {.count = 1, .reusable = false}, SHIFT(169),
  [285] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 1),
  [287] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 1),
  [289] = {.count = 1, .reusable = true}, SHIFT(177),
  [291] = {.count = 1, .reusable = true}, SHIFT(178),
  [293] = {.count = 1, .reusable = false}, SHIFT(179),
  [295] = {.count = 1, .reusable = true}, SHIFT(180),
  [297] = {.count = 1, .reusable = true}, SHIFT(181),
  [299] = {.count = 1, .reusable = true}, SHIFT(182),
  [301] = {.count = 1, .reusable = true}, SHIFT(183),
  [303] = {.count = 1, .reusable = true}, SHIFT(184),
  [305] = {.count = 1, .reusable = false}, SHIFT(185),
  [307] = {.count = 1, .reusable = false}, SHIFT(180),
  [309] = {.count = 1, .reusable = true}, SHIFT(187),
  [311] = {.count = 1, .reusable = true}, SHIFT(188),
  [313] = {.count = 1, .reusable = false}, SHIFT(189),
  [315] = {.count = 1, .reusable = true}, SHIFT(190),
  [317] = {.count = 1, .reusable = true}, SHIFT(191),
  [319] = {.count = 1, .reusable = true}, SHIFT(192),
  [321] = {.count = 1, .reusable = true}, SHIFT(193),
  [323] = {.count = 1, .reusable = true}, SHIFT(194),
  [325] = {.count = 1, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 1),
  [327] = {.count = 1, .reusable = true}, SHIFT(197),
  [329] = {.count = 1, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 1),
  [331] = {.count = 1, .reusable = false}, SHIFT(199),
  [333] = {.count = 1, .reusable = false}, SHIFT(200),
  [335] = {.count = 1, .reusable = true}, SHIFT(201),
  [337] = {.count = 1, .reusable = false}, SHIFT(202),
  [339] = {.count = 1, .reusable = false}, SHIFT(203),
  [341] = {.count = 1, .reusable = false}, SHIFT(204),
  [343] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [345] = {.count = 1, .reusable = true}, SHIFT(206),
  [347] = {.count = 1, .reusable = true}, SHIFT(207),
  [349] = {.count = 1, .reusable = false}, SHIFT(208),
  [351] = {.count = 1, .reusable = true}, SHIFT(208),
  [353] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1),
  [355] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1),
  [357] = {.count = 1, .reusable = true}, SHIFT(209),
  [359] = {.count = 1, .reusable = true}, SHIFT(210),
  [361] = {.count = 1, .reusable = true}, SHIFT(211),
  [363] = {.count = 1, .reusable = false}, SHIFT(212),
  [365] = {.count = 1, .reusable = true}, SHIFT(212),
  [367] = {.count = 1, .reusable = true}, SHIFT(213),
  [369] = {.count = 1, .reusable = false}, SHIFT(214),
  [371] = {.count = 1, .reusable = true}, SHIFT(214),
  [373] = {.count = 1, .reusable = true}, SHIFT(217),
  [375] = {.count = 1, .reusable = false}, SHIFT(218),
  [377] = {.count = 1, .reusable = false}, SHIFT(219),
  [379] = {.count = 1, .reusable = false}, SHIFT(220),
  [381] = {.count = 1, .reusable = false}, SHIFT(221),
  [383] = {.count = 1, .reusable = true}, SHIFT(222),
  [385] = {.count = 1, .reusable = false}, SHIFT(223),
  [387] = {.count = 1, .reusable = true}, SHIFT(233),
  [389] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [391] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [393] = {.count = 1, .reusable = true}, SHIFT(234),
  [395] = {.count = 1, .reusable = true}, SHIFT(235),
  [397] = {.count = 1, .reusable = true}, SHIFT(236),
  [399] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 1),
  [401] = {.count = 1, .reusable = false}, SHIFT(237),
  [403] = {.count = 1, .reusable = false}, SHIFT(238),
  [405] = {.count = 1, .reusable = true}, SHIFT(237),
  [407] = {.count = 1, .reusable = true}, SHIFT(238),
  [409] = {.count = 1, .reusable = true}, SHIFT(239),
  [411] = {.count = 1, .reusable = false}, SHIFT(240),
  [413] = {.count = 1, .reusable = true}, SHIFT(240),
  [415] = {.count = 1, .reusable = false}, SHIFT(241),
  [417] = {.count = 1, .reusable = true}, SHIFT(241),
  [419] = {.count = 1, .reusable = true}, SHIFT(242),
  [421] = {.count = 1, .reusable = true}, REDUCE(sym_command, 1),
  [423] = {.count = 1, .reusable = false}, REDUCE(sym_command, 1),
  [425] = {.count = 1, .reusable = false}, SHIFT(245),
  [427] = {.count = 1, .reusable = true}, SHIFT(18),
  [429] = {.count = 1, .reusable = true}, SHIFT(246),
  [431] = {.count = 1, .reusable = false}, SHIFT(246),
  [433] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 1),
  [435] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 1),
  [437] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [439] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [441] = {.count = 1, .reusable = true}, SHIFT(254),
  [443] = {.count = 1, .reusable = true}, SHIFT(256),
  [445] = {.count = 1, .reusable = true}, SHIFT(259),
  [447] = {.count = 1, .reusable = true}, SHIFT(260),
  [449] = {.count = 1, .reusable = true}, SHIFT(263),
  [451] = {.count = 1, .reusable = true}, SHIFT(264),
  [453] = {.count = 1, .reusable = true}, SHIFT(265),
  [455] = {.count = 1, .reusable = true}, SHIFT(266),
  [457] = {.count = 1, .reusable = false}, SHIFT(267),
  [459] = {.count = 1, .reusable = true}, SHIFT(268),
  [461] = {.count = 1, .reusable = true}, SHIFT(269),
  [463] = {.count = 1, .reusable = true}, SHIFT(270),
  [465] = {.count = 1, .reusable = true}, SHIFT(271),
  [467] = {.count = 1, .reusable = true}, SHIFT(272),
  [469] = {.count = 1, .reusable = false}, SHIFT(274),
  [471] = {.count = 1, .reusable = true}, SHIFT(274),
  [473] = {.count = 1, .reusable = true}, SHIFT(275),
  [475] = {.count = 1, .reusable = false}, SHIFT(276),
  [477] = {.count = 1, .reusable = true}, SHIFT(277),
  [479] = {.count = 1, .reusable = true}, SHIFT(278),
  [481] = {.count = 1, .reusable = false}, SHIFT(279),
  [483] = {.count = 1, .reusable = true}, SHIFT(280),
  [485] = {.count = 1, .reusable = true}, SHIFT(281),
  [487] = {.count = 1, .reusable = true}, SHIFT(282),
  [489] = {.count = 1, .reusable = true}, SHIFT(283),
  [491] = {.count = 1, .reusable = true}, SHIFT(284),
  [493] = {.count = 1, .reusable = false}, SHIFT(280),
  [495] = {.count = 1, .reusable = true}, SHIFT(276),
  [497] = {.count = 1, .reusable = true}, SHIFT(287),
  [499] = {.count = 1, .reusable = false}, SHIFT(288),
  [501] = {.count = 1, .reusable = true}, SHIFT(288),
  [503] = {.count = 1, .reusable = true}, SHIFT(289),
  [505] = {.count = 1, .reusable = false}, SHIFT(290),
  [507] = {.count = 1, .reusable = true}, SHIFT(291),
  [509] = {.count = 1, .reusable = true}, SHIFT(292),
  [511] = {.count = 1, .reusable = false}, SHIFT(293),
  [513] = {.count = 1, .reusable = true}, SHIFT(294),
  [515] = {.count = 1, .reusable = true}, SHIFT(295),
  [517] = {.count = 1, .reusable = true}, SHIFT(296),
  [519] = {.count = 1, .reusable = true}, SHIFT(297),
  [521] = {.count = 1, .reusable = true}, SHIFT(298),
  [523] = {.count = 1, .reusable = false}, SHIFT(294),
  [525] = {.count = 1, .reusable = true}, SHIFT(290),
  [527] = {.count = 1, .reusable = true}, SHIFT(302),
  [529] = {.count = 1, .reusable = false}, SHIFT(304),
  [531] = {.count = 1, .reusable = false}, SHIFT(305),
  [533] = {.count = 1, .reusable = true}, SHIFT(307),
  [535] = {.count = 1, .reusable = true}, SHIFT(308),
  [537] = {.count = 1, .reusable = false}, SHIFT(309),
  [539] = {.count = 1, .reusable = true}, SHIFT(309),
  [541] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [543] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [545] = {.count = 1, .reusable = true}, SHIFT(310),
  [547] = {.count = 1, .reusable = true}, SHIFT(311),
  [549] = {.count = 1, .reusable = true}, SHIFT(312),
  [551] = {.count = 1, .reusable = false}, SHIFT(313),
  [553] = {.count = 1, .reusable = true}, SHIFT(313),
  [555] = {.count = 1, .reusable = true}, SHIFT(318),
  [557] = {.count = 1, .reusable = true}, SHIFT(319),
  [559] = {.count = 1, .reusable = true}, SHIFT(320),
  [561] = {.count = 1, .reusable = false}, SHIFT(319),
  [563] = {.count = 1, .reusable = true}, SHIFT(321),
  [565] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [567] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .alias_sequence_id = 1),
  [569] = {.count = 1, .reusable = true}, SHIFT(322),
  [571] = {.count = 1, .reusable = true}, SHIFT(324),
  [573] = {.count = 1, .reusable = true}, SHIFT(325),
  [575] = {.count = 1, .reusable = true}, SHIFT(326),
  [577] = {.count = 1, .reusable = true}, SHIFT(330),
  [579] = {.count = 1, .reusable = true}, SHIFT(333),
  [581] = {.count = 1, .reusable = true}, SHIFT(335),
  [583] = {.count = 1, .reusable = true}, SHIFT(340),
  [585] = {.count = 1, .reusable = true}, SHIFT(341),
  [587] = {.count = 1, .reusable = true}, SHIFT(342),
  [589] = {.count = 1, .reusable = false}, SHIFT(343),
  [591] = {.count = 1, .reusable = true}, SHIFT(344),
  [593] = {.count = 1, .reusable = true}, SHIFT(345),
  [595] = {.count = 1, .reusable = true}, SHIFT(346),
  [597] = {.count = 1, .reusable = true}, SHIFT(347),
  [599] = {.count = 1, .reusable = true}, SHIFT(348),
  [601] = {.count = 1, .reusable = false}, SHIFT(350),
  [603] = {.count = 1, .reusable = false}, SHIFT(344),
  [605] = {.count = 1, .reusable = true}, SHIFT(352),
  [607] = {.count = 1, .reusable = true}, SHIFT(353),
  [609] = {.count = 1, .reusable = false}, SHIFT(354),
  [611] = {.count = 1, .reusable = true}, SHIFT(355),
  [613] = {.count = 1, .reusable = true}, SHIFT(356),
  [615] = {.count = 1, .reusable = true}, SHIFT(357),
  [617] = {.count = 1, .reusable = true}, SHIFT(358),
  [619] = {.count = 1, .reusable = true}, SHIFT(359),
  [621] = {.count = 1, .reusable = false}, SHIFT(360),
  [623] = {.count = 1, .reusable = false}, SHIFT(355),
  [625] = {.count = 1, .reusable = true}, SHIFT(362),
  [627] = {.count = 1, .reusable = false}, SHIFT(364),
  [629] = {.count = 1, .reusable = false}, SHIFT(365),
  [631] = {.count = 1, .reusable = true}, SHIFT(367),
  [633] = {.count = 1, .reusable = true}, SHIFT(368),
  [635] = {.count = 1, .reusable = false}, SHIFT(369),
  [637] = {.count = 1, .reusable = true}, SHIFT(369),
  [639] = {.count = 1, .reusable = true}, SHIFT(370),
  [641] = {.count = 1, .reusable = true}, SHIFT(371),
  [643] = {.count = 1, .reusable = true}, SHIFT(372),
  [645] = {.count = 1, .reusable = false}, SHIFT(373),
  [647] = {.count = 1, .reusable = true}, SHIFT(373),
  [649] = {.count = 1, .reusable = true}, SHIFT(378),
  [651] = {.count = 1, .reusable = true}, SHIFT(379),
  [653] = {.count = 1, .reusable = true}, SHIFT(381),
  [655] = {.count = 1, .reusable = false}, SHIFT(382),
  [657] = {.count = 1, .reusable = false}, SHIFT(383),
  [659] = {.count = 1, .reusable = true}, SHIFT(382),
  [661] = {.count = 1, .reusable = true}, SHIFT(383),
  [663] = {.count = 1, .reusable = true}, SHIFT(384),
  [665] = {.count = 1, .reusable = false}, SHIFT(385),
  [667] = {.count = 1, .reusable = true}, SHIFT(385),
  [669] = {.count = 1, .reusable = false}, SHIFT(386),
  [671] = {.count = 1, .reusable = true}, SHIFT(386),
  [673] = {.count = 1, .reusable = true}, SHIFT(387),
  [675] = {.count = 1, .reusable = false}, SHIFT(389),
  [677] = {.count = 1, .reusable = true}, SHIFT(68),
  [679] = {.count = 1, .reusable = true}, SHIFT(390),
  [681] = {.count = 1, .reusable = false}, SHIFT(390),
  [683] = {.count = 1, .reusable = true}, SHIFT(394),
  [685] = {.count = 1, .reusable = true}, SHIFT(396),
  [687] = {.count = 1, .reusable = true}, SHIFT(397),
  [689] = {.count = 1, .reusable = false}, SHIFT(399),
  [691] = {.count = 1, .reusable = false}, SHIFT(400),
  [693] = {.count = 1, .reusable = true}, SHIFT(402),
  [695] = {.count = 1, .reusable = true}, SHIFT(403),
  [697] = {.count = 1, .reusable = false}, SHIFT(404),
  [699] = {.count = 1, .reusable = true}, SHIFT(404),
  [701] = {.count = 1, .reusable = true}, SHIFT(405),
  [703] = {.count = 1, .reusable = false}, SHIFT(406),
  [705] = {.count = 1, .reusable = true}, SHIFT(406),
  [707] = {.count = 1, .reusable = true}, SHIFT(407),
  [709] = {.count = 1, .reusable = true}, SHIFT(408),
  [711] = {.count = 1, .reusable = true}, SHIFT(409),
  [713] = {.count = 1, .reusable = false}, SHIFT(410),
  [715] = {.count = 1, .reusable = true}, SHIFT(410),
  [717] = {.count = 1, .reusable = true}, SHIFT(415),
  [719] = {.count = 1, .reusable = false}, SHIFT(416),
  [721] = {.count = 1, .reusable = true}, SHIFT(416),
  [723] = {.count = 1, .reusable = true}, SHIFT(417),
  [725] = {.count = 1, .reusable = true}, SHIFT(419),
  [727] = {.count = 1, .reusable = true}, SHIFT(421),
  [729] = {.count = 1, .reusable = true}, SHIFT(422),
  [731] = {.count = 1, .reusable = true}, SHIFT(423),
  [733] = {.count = 1, .reusable = true}, SHIFT(424),
  [735] = {.count = 1, .reusable = false}, SHIFT(426),
  [737] = {.count = 1, .reusable = false}, SHIFT(424),
  [739] = {.count = 1, .reusable = true}, SHIFT(428),
  [741] = {.count = 1, .reusable = true}, SHIFT(429),
  [743] = {.count = 1, .reusable = false}, SHIFT(430),
  [745] = {.count = 1, .reusable = false}, SHIFT(429),
  [747] = {.count = 1, .reusable = true}, SHIFT(433),
  [749] = {.count = 1, .reusable = true}, SHIFT(434),
  [751] = {.count = 1, .reusable = false}, SHIFT(435),
  [753] = {.count = 1, .reusable = true}, SHIFT(435),
  [755] = {.count = 1, .reusable = true}, SHIFT(436),
  [757] = {.count = 1, .reusable = false}, SHIFT(437),
  [759] = {.count = 1, .reusable = true}, SHIFT(437),
  [761] = {.count = 1, .reusable = true}, SHIFT(438),
  [763] = {.count = 1, .reusable = false}, SHIFT(440),
  [765] = {.count = 1, .reusable = true}, SHIFT(101),
  [767] = {.count = 1, .reusable = true}, SHIFT(441),
  [769] = {.count = 1, .reusable = false}, SHIFT(441),
  [771] = {.count = 1, .reusable = true}, SHIFT(448),
  [773] = {.count = 1, .reusable = true}, SHIFT(449),
  [775] = {.count = 1, .reusable = true}, SHIFT(450),
  [777] = {.count = 1, .reusable = true}, SHIFT(454),
  [779] = {.count = 1, .reusable = true}, SHIFT(457),
  [781] = {.count = 1, .reusable = true}, SHIFT(459),
  [783] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 2),
  [785] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 2),
  [787] = {.count = 1, .reusable = true}, SHIFT(464),
  [789] = {.count = 1, .reusable = false}, SHIFT(465),
  [791] = {.count = 1, .reusable = true}, SHIFT(466),
  [793] = {.count = 1, .reusable = false}, SHIFT(467),
  [795] = {.count = 1, .reusable = true}, SHIFT(468),
  [797] = {.count = 1, .reusable = true}, SHIFT(469),
  [799] = {.count = 1, .reusable = true}, SHIFT(470),
  [801] = {.count = 1, .reusable = true}, SHIFT(471),
  [803] = {.count = 1, .reusable = true}, SHIFT(472),
  [805] = {.count = 1, .reusable = false}, SHIFT(474),
  [807] = {.count = 1, .reusable = false}, SHIFT(468),
  [809] = {.count = 1, .reusable = false}, SHIFT(476),
  [811] = {.count = 1, .reusable = true}, SHIFT(477),
  [813] = {.count = 1, .reusable = false}, SHIFT(478),
  [815] = {.count = 1, .reusable = true}, SHIFT(479),
  [817] = {.count = 1, .reusable = true}, SHIFT(480),
  [819] = {.count = 1, .reusable = true}, SHIFT(481),
  [821] = {.count = 1, .reusable = true}, SHIFT(482),
  [823] = {.count = 1, .reusable = true}, SHIFT(483),
  [825] = {.count = 1, .reusable = false}, SHIFT(484),
  [827] = {.count = 1, .reusable = false}, SHIFT(479),
  [829] = {.count = 1, .reusable = true}, SHIFT(486),
  [831] = {.count = 1, .reusable = false}, SHIFT(488),
  [833] = {.count = 1, .reusable = false}, SHIFT(489),
  [835] = {.count = 1, .reusable = true}, SHIFT(491),
  [837] = {.count = 1, .reusable = true}, SHIFT(492),
  [839] = {.count = 1, .reusable = false}, SHIFT(493),
  [841] = {.count = 1, .reusable = true}, SHIFT(493),
  [843] = {.count = 1, .reusable = true}, SHIFT(494),
  [845] = {.count = 1, .reusable = true}, SHIFT(495),
  [847] = {.count = 1, .reusable = true}, SHIFT(496),
  [849] = {.count = 1, .reusable = false}, SHIFT(497),
  [851] = {.count = 1, .reusable = true}, SHIFT(497),
  [853] = {.count = 1, .reusable = true}, SHIFT(502),
  [855] = {.count = 1, .reusable = true}, SHIFT(503),
  [857] = {.count = 1, .reusable = true}, SHIFT(504),
  [859] = {.count = 1, .reusable = true}, SHIFT(505),
  [861] = {.count = 1, .reusable = true}, SHIFT(506),
  [863] = {.count = 1, .reusable = false}, SHIFT(507),
  [865] = {.count = 1, .reusable = false}, SHIFT(508),
  [867] = {.count = 1, .reusable = true}, SHIFT(507),
  [869] = {.count = 1, .reusable = true}, SHIFT(508),
  [871] = {.count = 1, .reusable = true}, SHIFT(509),
  [873] = {.count = 1, .reusable = false}, SHIFT(510),
  [875] = {.count = 1, .reusable = true}, SHIFT(510),
  [877] = {.count = 1, .reusable = false}, SHIFT(511),
  [879] = {.count = 1, .reusable = true}, SHIFT(511),
  [881] = {.count = 1, .reusable = true}, SHIFT(512),
  [883] = {.count = 1, .reusable = false}, SHIFT(515),
  [885] = {.count = 1, .reusable = true}, SHIFT(516),
  [887] = {.count = 1, .reusable = false}, SHIFT(516),
  [889] = {.count = 1, .reusable = true}, SHIFT(127),
  [891] = {.count = 1, .reusable = false}, SHIFT(522),
  [893] = {.count = 1, .reusable = true}, SHIFT(524),
  [895] = {.count = 1, .reusable = true}, REDUCE(sym_negated_command, 2),
  [897] = {.count = 1, .reusable = false}, REDUCE(sym_negated_command, 2),
  [899] = {.count = 1, .reusable = true}, SHIFT(527),
  [901] = {.count = 1, .reusable = false}, SHIFT(529),
  [903] = {.count = 1, .reusable = false}, SHIFT(530),
  [905] = {.count = 1, .reusable = true}, SHIFT(532),
  [907] = {.count = 1, .reusable = true}, SHIFT(533),
  [909] = {.count = 1, .reusable = false}, SHIFT(534),
  [911] = {.count = 1, .reusable = true}, SHIFT(534),
  [913] = {.count = 1, .reusable = true}, SHIFT(535),
  [915] = {.count = 1, .reusable = true}, SHIFT(536),
  [917] = {.count = 1, .reusable = true}, SHIFT(537),
  [919] = {.count = 1, .reusable = false}, SHIFT(538),
  [921] = {.count = 1, .reusable = true}, SHIFT(538),
  [923] = {.count = 1, .reusable = true}, SHIFT(543),
  [925] = {.count = 1, .reusable = true}, SHIFT(544),
  [927] = {.count = 1, .reusable = false}, SHIFT(543),
  [929] = {.count = 1, .reusable = true}, SHIFT(545),
  [931] = {.count = 1, .reusable = false}, SHIFT(546),
  [933] = {.count = 1, .reusable = true}, SHIFT(550),
  [935] = {.count = 1, .reusable = true}, SHIFT(551),
  [937] = {.count = 1, .reusable = false}, SHIFT(550),
  [939] = {.count = 1, .reusable = false}, SHIFT(552),
  [941] = {.count = 1, .reusable = true}, SHIFT(554),
  [943] = {.count = 1, .reusable = true}, SHIFT(555),
  [945] = {.count = 1, .reusable = false}, SHIFT(557),
  [947] = {.count = 1, .reusable = false}, SHIFT(558),
  [949] = {.count = 1, .reusable = true}, SHIFT(560),
  [951] = {.count = 1, .reusable = true}, SHIFT(561),
  [953] = {.count = 1, .reusable = false}, SHIFT(562),
  [955] = {.count = 1, .reusable = true}, SHIFT(562),
  [957] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [959] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [961] = {.count = 1, .reusable = true}, SHIFT(563),
  [963] = {.count = 1, .reusable = true}, SHIFT(564),
  [965] = {.count = 1, .reusable = true}, SHIFT(565),
  [967] = {.count = 1, .reusable = false}, SHIFT(566),
  [969] = {.count = 1, .reusable = true}, SHIFT(566),
  [971] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 2),
  [973] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 2),
  [975] = {.count = 1, .reusable = false}, SHIFT(571),
  [977] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [979] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [981] = {.count = 1, .reusable = true}, SHIFT(572),
  [983] = {.count = 1, .reusable = true}, SHIFT(574),
  [985] = {.count = 1, .reusable = false}, SHIFT(576),
  [987] = {.count = 1, .reusable = false}, SHIFT(577),
  [989] = {.count = 1, .reusable = true}, SHIFT(579),
  [991] = {.count = 1, .reusable = true}, SHIFT(580),
  [993] = {.count = 1, .reusable = false}, SHIFT(581),
  [995] = {.count = 1, .reusable = true}, SHIFT(581),
  [997] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [999] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [1001] = {.count = 1, .reusable = true}, SHIFT(582),
  [1003] = {.count = 1, .reusable = true}, SHIFT(583),
  [1005] = {.count = 1, .reusable = true}, SHIFT(584),
  [1007] = {.count = 1, .reusable = false}, SHIFT(585),
  [1009] = {.count = 1, .reusable = true}, SHIFT(585),
  [1011] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 2),
  [1013] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 2),
  [1015] = {.count = 1, .reusable = false}, SHIFT(590),
  [1017] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 1),
  [1019] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1, .alias_sequence_id = 1),
  [1021] = {.count = 1, .reusable = true}, SHIFT(591),
  [1023] = {.count = 1, .reusable = true}, SHIFT(593),
  [1025] = {.count = 1, .reusable = false}, SHIFT(595),
  [1027] = {.count = 1, .reusable = false}, SHIFT(596),
  [1029] = {.count = 1, .reusable = true}, SHIFT(598),
  [1031] = {.count = 1, .reusable = true}, SHIFT(599),
  [1033] = {.count = 1, .reusable = false}, SHIFT(600),
  [1035] = {.count = 1, .reusable = true}, SHIFT(600),
  [1037] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2),
  [1039] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2),
  [1041] = {.count = 1, .reusable = true}, SHIFT(601),
  [1043] = {.count = 1, .reusable = true}, SHIFT(602),
  [1045] = {.count = 1, .reusable = true}, SHIFT(603),
  [1047] = {.count = 1, .reusable = false}, SHIFT(604),
  [1049] = {.count = 1, .reusable = true}, SHIFT(604),
  [1051] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 2),
  [1053] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 2),
  [1055] = {.count = 1, .reusable = true}, SHIFT(609),
  [1057] = {.count = 1, .reusable = true}, SHIFT(611),
  [1059] = {.count = 1, .reusable = true}, REDUCE(sym_concatenation, 2),
  [1061] = {.count = 1, .reusable = false}, REDUCE(sym_concatenation, 2),
  [1063] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [1065] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [1067] = {.count = 1, .reusable = true}, SHIFT(613),
  [1069] = {.count = 1, .reusable = false}, SHIFT(614),
  [1071] = {.count = 1, .reusable = false}, SHIFT(613),
  [1073] = {.count = 1, .reusable = false}, SHIFT(615),
  [1075] = {.count = 1, .reusable = false}, SHIFT(616),
  [1077] = {.count = 1, .reusable = true}, SHIFT(616),
  [1079] = {.count = 1, .reusable = true}, SHIFT(617),
  [1081] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 1),
  [1083] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 1),
  [1085] = {.count = 1, .reusable = true}, SHIFT(618),
  [1087] = {.count = 1, .reusable = true}, SHIFT(619),
  [1089] = {.count = 1, .reusable = true}, SHIFT(620),
  [1091] = {.count = 1, .reusable = false}, SHIFT(621),
  [1093] = {.count = 1, .reusable = true}, SHIFT(621),
  [1095] = {.count = 1, .reusable = false}, SHIFT(625),
  [1097] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 3),
  [1099] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 3),
  [1101] = {.count = 1, .reusable = true}, REDUCE(sym_string_expansion, 2),
  [1103] = {.count = 1, .reusable = false}, REDUCE(sym_string_expansion, 2),
  [1105] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2),
  [1107] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2),
  [1109] = {.count = 1, .reusable = true}, SHIFT(627),
  [1111] = {.count = 1, .reusable = true}, SHIFT(628),
  [1113] = {.count = 1, .reusable = true}, SHIFT(629),
  [1115] = {.count = 1, .reusable = true}, SHIFT(630),
  [1117] = {.count = 1, .reusable = false}, SHIFT(631),
  [1119] = {.count = 1, .reusable = true}, SHIFT(631),
  [1121] = {.count = 1, .reusable = true}, SHIFT(632),
  [1123] = {.count = 1, .reusable = false}, SHIFT(643),
  [1125] = {.count = 1, .reusable = false}, SHIFT(633),
  [1127] = {.count = 1, .reusable = true}, SHIFT(634),
  [1129] = {.count = 1, .reusable = false}, SHIFT(635),
  [1131] = {.count = 1, .reusable = true}, SHIFT(636),
  [1133] = {.count = 1, .reusable = true}, SHIFT(643),
  [1135] = {.count = 1, .reusable = true}, SHIFT(637),
  [1137] = {.count = 1, .reusable = true}, SHIFT(638),
  [1139] = {.count = 1, .reusable = true}, SHIFT(639),
  [1141] = {.count = 1, .reusable = true}, SHIFT(640),
  [1143] = {.count = 1, .reusable = true}, SHIFT(641),
  [1145] = {.count = 1, .reusable = false}, SHIFT(636),
  [1147] = {.count = 1, .reusable = true}, SHIFT(644),
  [1149] = {.count = 1, .reusable = false}, SHIFT(646),
  [1151] = {.count = 1, .reusable = true}, SHIFT(646),
  [1153] = {.count = 1, .reusable = true}, SHIFT(645),
  [1155] = {.count = 1, .reusable = false}, SHIFT(647),
  [1157] = {.count = 1, .reusable = true}, SHIFT(647),
  [1159] = {.count = 1, .reusable = true}, SHIFT(648),
  [1161] = {.count = 1, .reusable = true}, SHIFT(649),
  [1163] = {.count = 1, .reusable = true}, SHIFT(651),
  [1165] = {.count = 1, .reusable = true}, SHIFT(652),
  [1167] = {.count = 1, .reusable = true}, SHIFT(653),
  [1169] = {.count = 1, .reusable = true}, SHIFT(654),
  [1171] = {.count = 1, .reusable = true}, SHIFT(655),
  [1173] = {.count = 1, .reusable = false}, SHIFT(657),
  [1175] = {.count = 1, .reusable = false}, SHIFT(655),
  [1177] = {.count = 1, .reusable = true}, SHIFT(659),
  [1179] = {.count = 1, .reusable = true}, SHIFT(660),
  [1181] = {.count = 1, .reusable = false}, SHIFT(661),
  [1183] = {.count = 1, .reusable = false}, SHIFT(660),
  [1185] = {.count = 1, .reusable = true}, SHIFT(664),
  [1187] = {.count = 1, .reusable = false}, SHIFT(665),
  [1189] = {.count = 1, .reusable = false}, SHIFT(666),
  [1191] = {.count = 1, .reusable = true}, SHIFT(665),
  [1193] = {.count = 1, .reusable = true}, SHIFT(666),
  [1195] = {.count = 1, .reusable = true}, SHIFT(667),
  [1197] = {.count = 1, .reusable = false}, SHIFT(668),
  [1199] = {.count = 1, .reusable = true}, SHIFT(668),
  [1201] = {.count = 1, .reusable = true}, SHIFT(669),
  [1203] = {.count = 1, .reusable = false}, SHIFT(672),
  [1205] = {.count = 1, .reusable = true}, SHIFT(221),
  [1207] = {.count = 1, .reusable = true}, SHIFT(673),
  [1209] = {.count = 1, .reusable = false}, SHIFT(673),
  [1211] = {.count = 1, .reusable = true}, SHIFT(680),
  [1213] = {.count = 1, .reusable = true}, SHIFT(681),
  [1215] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 1),
  [1217] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 1),
  [1219] = {.count = 1, .reusable = true}, SHIFT(687),
  [1221] = {.count = 1, .reusable = true}, SHIFT(682),
  [1223] = {.count = 1, .reusable = false}, SHIFT(683),
  [1225] = {.count = 1, .reusable = true}, SHIFT(684),
  [1227] = {.count = 1, .reusable = true}, SHIFT(685),
  [1229] = {.count = 1, .reusable = true}, SHIFT(686),
  [1231] = {.count = 1, .reusable = false}, SHIFT(688),
  [1233] = {.count = 1, .reusable = true}, SHIFT(688),
  [1235] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2),
  [1237] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 2),
  [1239] = {.count = 1, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2),
  [1241] = {.count = 1, .reusable = true}, SHIFT(693),
  [1243] = {.count = 1, .reusable = true}, SHIFT(694),
  [1245] = {.count = 1, .reusable = true}, SHIFT(697),
  [1247] = {.count = 1, .reusable = true}, SHIFT(698),
  [1249] = {.count = 1, .reusable = false}, SHIFT(701),
  [1251] = {.count = 1, .reusable = true}, SHIFT(701),
  [1253] = {.count = 1, .reusable = true}, REDUCE(sym_redirected_statement, 2),
  [1255] = {.count = 1, .reusable = false}, REDUCE(sym_redirected_statement, 2),
  [1257] = {.count = 1, .reusable = true}, SHIFT(703),
  [1259] = {.count = 1, .reusable = true}, SHIFT(704),
  [1261] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1),
  [1263] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1),
  [1265] = {.count = 1, .reusable = true}, REDUCE(sym_command, 2),
  [1267] = {.count = 1, .reusable = false}, REDUCE(sym_command, 2),
  [1269] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1, .alias_sequence_id = 1),
  [1271] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1, .alias_sequence_id = 1),
  [1273] = {.count = 1, .reusable = false}, SHIFT(707),
  [1275] = {.count = 1, .reusable = true}, SHIFT(707),
  [1277] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2),
  [1280] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(217),
  [1283] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(4),
  [1286] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(5),
  [1289] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(6),
  [1292] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(7),
  [1295] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(8),
  [1298] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(9),
  [1301] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(10),
  [1304] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(11),
  [1307] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(709),
  [1310] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(13),
  [1313] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(14),
  [1316] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(710),
  [1319] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(711),
  [1322] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(17),
  [1325] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(17),
  [1328] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(221),
  [1331] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(19),
  [1334] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(20),
  [1337] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(222),
  [1340] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(22),
  [1343] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(23),
  [1346] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(24),
  [1349] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(25),
  [1352] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(223),
  [1355] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(2),
  [1358] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(145),
  [1361] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(17),
  [1364] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(17),
  [1367] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2),
  [1369] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2),
  [1371] = {.count = 1, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2),
  [1373] = {.count = 1, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2),
  [1375] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(254),
  [1378] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3),
  [1380] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3),
  [1382] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 4),
  [1384] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 4),
  [1386] = {.count = 1, .reusable = true}, SHIFT(718),
  [1388] = {.count = 1, .reusable = true}, SHIFT(719),
  [1390] = {.count = 1, .reusable = true}, SHIFT(720),
  [1392] = {.count = 1, .reusable = true}, SHIFT(721),
  [1394] = {.count = 1, .reusable = true}, SHIFT(722),
  [1396] = {.count = 1, .reusable = false}, SHIFT(723),
  [1398] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment, 3),
  [1400] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment, 3),
  [1402] = {.count = 1, .reusable = true}, SHIFT(725),
  [1404] = {.count = 1, .reusable = true}, SHIFT(726),
  [1406] = {.count = 1, .reusable = true}, SHIFT(727),
  [1408] = {.count = 1, .reusable = false}, SHIFT(728),
  [1410] = {.count = 1, .reusable = true}, SHIFT(729),
  [1412] = {.count = 1, .reusable = true}, SHIFT(730),
  [1414] = {.count = 1, .reusable = true}, SHIFT(731),
  [1416] = {.count = 1, .reusable = true}, SHIFT(732),
  [1418] = {.count = 1, .reusable = true}, SHIFT(733),
  [1420] = {.count = 1, .reusable = true}, SHIFT(736),
  [1422] = {.count = 1, .reusable = false}, SHIFT(738),
  [1424] = {.count = 1, .reusable = false}, SHIFT(739),
  [1426] = {.count = 1, .reusable = true}, SHIFT(741),
  [1428] = {.count = 1, .reusable = true}, SHIFT(742),
  [1430] = {.count = 1, .reusable = false}, SHIFT(743),
  [1432] = {.count = 1, .reusable = true}, SHIFT(743),
  [1434] = {.count = 1, .reusable = true}, SHIFT(744),
  [1436] = {.count = 1, .reusable = true}, SHIFT(745),
  [1438] = {.count = 1, .reusable = true}, SHIFT(746),
  [1440] = {.count = 1, .reusable = false}, SHIFT(747),
  [1442] = {.count = 1, .reusable = true}, SHIFT(747),
  [1444] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment, 3, .alias_sequence_id = 4),
  [1446] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment, 3, .alias_sequence_id = 4),
  [1448] = {.count = 1, .reusable = true}, SHIFT(752),
  [1450] = {.count = 1, .reusable = false}, SHIFT(754),
  [1452] = {.count = 1, .reusable = true}, SHIFT(754),
  [1454] = {.count = 1, .reusable = true}, SHIFT(758),
  [1456] = {.count = 1, .reusable = false}, SHIFT(760),
  [1458] = {.count = 1, .reusable = false}, SHIFT(761),
  [1460] = {.count = 1, .reusable = true}, SHIFT(763),
  [1462] = {.count = 1, .reusable = true}, SHIFT(764),
  [1464] = {.count = 1, .reusable = false}, SHIFT(765),
  [1466] = {.count = 1, .reusable = true}, SHIFT(765),
  [1468] = {.count = 1, .reusable = true}, SHIFT(766),
  [1470] = {.count = 1, .reusable = true}, SHIFT(767),
  [1472] = {.count = 1, .reusable = true}, SHIFT(768),
  [1474] = {.count = 1, .reusable = false}, SHIFT(769),
  [1476] = {.count = 1, .reusable = true}, SHIFT(769),
  [1478] = {.count = 1, .reusable = false}, SHIFT(774),
  [1480] = {.count = 1, .reusable = true}, SHIFT(774),
  [1482] = {.count = 1, .reusable = true}, SHIFT(775),
  [1484] = {.count = 1, .reusable = true}, SHIFT(776),
  [1486] = {.count = 1, .reusable = false}, SHIFT(775),
  [1488] = {.count = 1, .reusable = true}, SHIFT(777),
  [1490] = {.count = 1, .reusable = true}, SHIFT(778),
  [1492] = {.count = 1, .reusable = true}, SHIFT(780),
  [1494] = {.count = 1, .reusable = true}, SHIFT(781),
  [1496] = {.count = 1, .reusable = false}, SHIFT(782),
  [1498] = {.count = 1, .reusable = true}, SHIFT(783),
  [1500] = {.count = 1, .reusable = true}, SHIFT(784),
  [1502] = {.count = 1, .reusable = true}, SHIFT(785),
  [1504] = {.count = 1, .reusable = true}, SHIFT(786),
  [1506] = {.count = 1, .reusable = true}, SHIFT(787),
  [1508] = {.count = 1, .reusable = true}, SHIFT(793),
  [1510] = {.count = 1, .reusable = false}, SHIFT(795),
  [1512] = {.count = 1, .reusable = false}, SHIFT(796),
  [1514] = {.count = 1, .reusable = true}, SHIFT(798),
  [1516] = {.count = 1, .reusable = true}, SHIFT(799),
  [1518] = {.count = 1, .reusable = false}, SHIFT(800),
  [1520] = {.count = 1, .reusable = true}, SHIFT(800),
  [1522] = {.count = 1, .reusable = true}, SHIFT(801),
  [1524] = {.count = 1, .reusable = true}, SHIFT(802),
  [1526] = {.count = 1, .reusable = true}, SHIFT(803),
  [1528] = {.count = 1, .reusable = false}, SHIFT(804),
  [1530] = {.count = 1, .reusable = true}, SHIFT(804),
  [1532] = {.count = 1, .reusable = true}, SHIFT(809),
  [1534] = {.count = 1, .reusable = true}, SHIFT(810),
  [1536] = {.count = 1, .reusable = true}, SHIFT(811),
  [1538] = {.count = 1, .reusable = false}, SHIFT(810),
  [1540] = {.count = 1, .reusable = true}, SHIFT(812),
  [1542] = {.count = 1, .reusable = true}, SHIFT(813),
  [1544] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2),
  [1546] = {.count = 1, .reusable = true}, SHIFT(815),
  [1548] = {.count = 1, .reusable = false}, SHIFT(817),
  [1550] = {.count = 1, .reusable = false}, SHIFT(818),
  [1552] = {.count = 1, .reusable = true}, SHIFT(819),
  [1554] = {.count = 1, .reusable = true}, SHIFT(820),
  [1556] = {.count = 1, .reusable = true}, SHIFT(821),
  [1558] = {.count = 1, .reusable = false}, SHIFT(822),
  [1560] = {.count = 1, .reusable = true}, SHIFT(822),
  [1562] = {.count = 1, .reusable = true}, SHIFT(823),
  [1564] = {.count = 1, .reusable = false}, SHIFT(825),
  [1566] = {.count = 1, .reusable = true}, SHIFT(825),
  [1568] = {.count = 1, .reusable = true}, SHIFT(824),
  [1570] = {.count = 1, .reusable = true}, SHIFT(826),
  [1572] = {.count = 1, .reusable = false}, SHIFT(828),
  [1574] = {.count = 1, .reusable = true}, SHIFT(828),
  [1576] = {.count = 1, .reusable = true}, SHIFT(827),
  [1578] = {.count = 1, .reusable = true}, SHIFT(829),
  [1580] = {.count = 1, .reusable = true}, SHIFT(830),
  [1582] = {.count = 1, .reusable = true}, REDUCE(sym_test_command, 3),
  [1584] = {.count = 1, .reusable = false}, REDUCE(sym_test_command, 3),
  [1586] = {.count = 1, .reusable = true}, SHIFT(832),
  [1588] = {.count = 1, .reusable = true}, REDUCE(sym_postfix_expression, 2),
  [1590] = {.count = 1, .reusable = false}, REDUCE(sym_postfix_expression, 2),
  [1592] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(322),
  [1595] = {.count = 1, .reusable = true}, SHIFT(833),
  [1597] = {.count = 1, .reusable = true}, SHIFT(834),
  [1599] = {.count = 1, .reusable = true}, SHIFT(835),
  [1601] = {.count = 1, .reusable = true}, SHIFT(836),
  [1603] = {.count = 1, .reusable = false}, SHIFT(837),
  [1605] = {.count = 1, .reusable = true}, SHIFT(838),
  [1607] = {.count = 1, .reusable = true}, SHIFT(839),
  [1609] = {.count = 1, .reusable = true}, SHIFT(840),
  [1611] = {.count = 1, .reusable = true}, SHIFT(841),
  [1613] = {.count = 1, .reusable = true}, SHIFT(842),
  [1615] = {.count = 1, .reusable = false}, SHIFT(844),
  [1617] = {.count = 1, .reusable = true}, SHIFT(844),
  [1619] = {.count = 1, .reusable = true}, SHIFT(846),
  [1621] = {.count = 1, .reusable = false}, SHIFT(847),
  [1623] = {.count = 1, .reusable = true}, SHIFT(847),
  [1625] = {.count = 1, .reusable = true}, SHIFT(848),
  [1627] = {.count = 1, .reusable = true}, SHIFT(849),
  [1629] = {.count = 1, .reusable = true}, SHIFT(851),
  [1631] = {.count = 1, .reusable = true}, SHIFT(852),
  [1633] = {.count = 1, .reusable = false}, SHIFT(853),
  [1635] = {.count = 1, .reusable = true}, SHIFT(853),
  [1637] = {.count = 1, .reusable = true}, SHIFT(854),
  [1639] = {.count = 1, .reusable = false}, SHIFT(855),
  [1641] = {.count = 1, .reusable = true}, SHIFT(855),
  [1643] = {.count = 1, .reusable = true}, SHIFT(856),
  [1645] = {.count = 1, .reusable = true}, SHIFT(858),
  [1647] = {.count = 1, .reusable = true}, SHIFT(859),
  [1649] = {.count = 1, .reusable = true}, SHIFT(860),
  [1651] = {.count = 1, .reusable = true}, SHIFT(861),
  [1653] = {.count = 1, .reusable = false}, SHIFT(863),
  [1655] = {.count = 1, .reusable = false}, SHIFT(864),
  [1657] = {.count = 1, .reusable = true}, SHIFT(866),
  [1659] = {.count = 1, .reusable = true}, SHIFT(867),
  [1661] = {.count = 1, .reusable = false}, SHIFT(868),
  [1663] = {.count = 1, .reusable = true}, SHIFT(868),
  [1665] = {.count = 1, .reusable = true}, SHIFT(869),
  [1667] = {.count = 1, .reusable = true}, SHIFT(870),
  [1669] = {.count = 1, .reusable = true}, SHIFT(871),
  [1671] = {.count = 1, .reusable = false}, SHIFT(872),
  [1673] = {.count = 1, .reusable = true}, SHIFT(872),
  [1675] = {.count = 1, .reusable = false}, SHIFT(877),
  [1677] = {.count = 1, .reusable = true}, SHIFT(878),
  [1679] = {.count = 1, .reusable = true}, SHIFT(880),
  [1681] = {.count = 1, .reusable = false}, SHIFT(882),
  [1683] = {.count = 1, .reusable = false}, SHIFT(883),
  [1685] = {.count = 1, .reusable = true}, SHIFT(885),
  [1687] = {.count = 1, .reusable = true}, SHIFT(886),
  [1689] = {.count = 1, .reusable = false}, SHIFT(887),
  [1691] = {.count = 1, .reusable = true}, SHIFT(887),
  [1693] = {.count = 1, .reusable = true}, SHIFT(888),
  [1695] = {.count = 1, .reusable = true}, SHIFT(889),
  [1697] = {.count = 1, .reusable = true}, SHIFT(890),
  [1699] = {.count = 1, .reusable = false}, SHIFT(891),
  [1701] = {.count = 1, .reusable = true}, SHIFT(891),
  [1703] = {.count = 1, .reusable = false}, SHIFT(896),
  [1705] = {.count = 1, .reusable = true}, SHIFT(897),
  [1707] = {.count = 1, .reusable = true}, SHIFT(899),
  [1709] = {.count = 1, .reusable = false}, SHIFT(901),
  [1711] = {.count = 1, .reusable = false}, SHIFT(902),
  [1713] = {.count = 1, .reusable = true}, SHIFT(903),
  [1715] = {.count = 1, .reusable = true}, SHIFT(904),
  [1717] = {.count = 1, .reusable = true}, SHIFT(905),
  [1719] = {.count = 1, .reusable = false}, SHIFT(906),
  [1721] = {.count = 1, .reusable = true}, SHIFT(906),
  [1723] = {.count = 1, .reusable = true}, SHIFT(907),
  [1725] = {.count = 1, .reusable = false}, SHIFT(909),
  [1727] = {.count = 1, .reusable = true}, SHIFT(909),
  [1729] = {.count = 1, .reusable = true}, SHIFT(908),
  [1731] = {.count = 1, .reusable = true}, SHIFT(910),
  [1733] = {.count = 1, .reusable = false}, SHIFT(912),
  [1735] = {.count = 1, .reusable = true}, SHIFT(912),
  [1737] = {.count = 1, .reusable = true}, SHIFT(911),
  [1739] = {.count = 1, .reusable = true}, SHIFT(913),
  [1741] = {.count = 1, .reusable = true}, SHIFT(914),
  [1743] = {.count = 1, .reusable = true}, SHIFT(915),
  [1745] = {.count = 1, .reusable = true}, SHIFT(916),
  [1747] = {.count = 1, .reusable = false}, SHIFT(917),
  [1749] = {.count = 1, .reusable = false}, SHIFT(918),
  [1751] = {.count = 1, .reusable = false}, SHIFT(919),
  [1753] = {.count = 1, .reusable = false}, SHIFT(920),
  [1755] = {.count = 1, .reusable = false}, SHIFT(921),
  [1757] = {.count = 1, .reusable = true}, SHIFT(922),
  [1759] = {.count = 1, .reusable = false}, SHIFT(923),
  [1761] = {.count = 1, .reusable = true}, SHIFT(924),
  [1763] = {.count = 1, .reusable = true}, SHIFT(925),
  [1765] = {.count = 1, .reusable = true}, SHIFT(926),
  [1767] = {.count = 1, .reusable = true}, SHIFT(927),
  [1769] = {.count = 1, .reusable = true}, SHIFT(928),
  [1771] = {.count = 1, .reusable = false}, SHIFT(929),
  [1773] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3),
  [1775] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3),
  [1777] = {.count = 1, .reusable = false}, SHIFT(939),
  [1779] = {.count = 1, .reusable = true}, SHIFT(939),
  [1781] = {.count = 1, .reusable = true}, REDUCE(sym__terminated_statement, 2),
  [1783] = {.count = 1, .reusable = true}, SHIFT(944),
  [1785] = {.count = 1, .reusable = true}, SHIFT(945),
  [1787] = {.count = 1, .reusable = true}, SHIFT(948),
  [1789] = {.count = 1, .reusable = true}, SHIFT(949),
  [1791] = {.count = 1, .reusable = true}, SHIFT(953),
  [1793] = {.count = 1, .reusable = true}, SHIFT(954),
  [1795] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(394),
  [1798] = {.count = 1, .reusable = true}, SHIFT(958),
  [1800] = {.count = 1, .reusable = false}, SHIFT(959),
  [1802] = {.count = 1, .reusable = false}, SHIFT(960),
  [1804] = {.count = 1, .reusable = false}, SHIFT(961),
  [1806] = {.count = 1, .reusable = false}, SHIFT(962),
  [1808] = {.count = 1, .reusable = false}, SHIFT(963),
  [1810] = {.count = 1, .reusable = false}, SHIFT(964),
  [1812] = {.count = 1, .reusable = false}, SHIFT(965),
  [1814] = {.count = 1, .reusable = true}, SHIFT(966),
  [1816] = {.count = 1, .reusable = false}, SHIFT(967),
  [1818] = {.count = 1, .reusable = true}, SHIFT(968),
  [1820] = {.count = 1, .reusable = true}, SHIFT(969),
  [1822] = {.count = 1, .reusable = true}, SHIFT(970),
  [1824] = {.count = 1, .reusable = true}, SHIFT(971),
  [1826] = {.count = 1, .reusable = true}, SHIFT(972),
  [1828] = {.count = 1, .reusable = false}, SHIFT(973),
  [1830] = {.count = 1, .reusable = true}, SHIFT(985),
  [1832] = {.count = 1, .reusable = false}, SHIFT(987),
  [1834] = {.count = 1, .reusable = false}, SHIFT(988),
  [1836] = {.count = 1, .reusable = false}, SHIFT(989),
  [1838] = {.count = 1, .reusable = true}, SHIFT(989),
  [1840] = {.count = 1, .reusable = true}, SHIFT(990),
  [1842] = {.count = 1, .reusable = true}, SHIFT(991),
  [1844] = {.count = 1, .reusable = true}, SHIFT(992),
  [1846] = {.count = 1, .reusable = true}, SHIFT(993),
  [1848] = {.count = 1, .reusable = false}, SHIFT(994),
  [1850] = {.count = 1, .reusable = true}, SHIFT(994),
  [1852] = {.count = 1, .reusable = true}, SHIFT(995),
  [1854] = {.count = 1, .reusable = false}, SHIFT(997),
  [1856] = {.count = 1, .reusable = true}, SHIFT(997),
  [1858] = {.count = 1, .reusable = true}, SHIFT(996),
  [1860] = {.count = 1, .reusable = true}, SHIFT(998),
  [1862] = {.count = 1, .reusable = false}, SHIFT(1000),
  [1864] = {.count = 1, .reusable = true}, SHIFT(1000),
  [1866] = {.count = 1, .reusable = true}, SHIFT(999),
  [1868] = {.count = 1, .reusable = true}, SHIFT(1001),
  [1870] = {.count = 1, .reusable = true}, SHIFT(1002),
  [1872] = {.count = 1, .reusable = false}, SHIFT(1003),
  [1874] = {.count = 1, .reusable = true}, SHIFT(1003),
  [1876] = {.count = 1, .reusable = true}, SHIFT(1004),
  [1878] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(417),
  [1881] = {.count = 1, .reusable = true}, SHIFT(1005),
  [1883] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 3),
  [1885] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 3),
  [1887] = {.count = 1, .reusable = true}, SHIFT(1006),
  [1889] = {.count = 1, .reusable = true}, SHIFT(1007),
  [1891] = {.count = 1, .reusable = true}, SHIFT(1009),
  [1893] = {.count = 1, .reusable = false}, SHIFT(1011),
  [1895] = {.count = 1, .reusable = false}, SHIFT(1014),
  [1897] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 3),
  [1899] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 3),
  [1901] = {.count = 1, .reusable = false}, SHIFT(1017),
  [1903] = {.count = 1, .reusable = true}, SHIFT(1017),
  [1905] = {.count = 1, .reusable = true}, SHIFT(1022),
  [1907] = {.count = 1, .reusable = true}, SHIFT(1023),
  [1909] = {.count = 1, .reusable = true}, SHIFT(1025),
  [1911] = {.count = 1, .reusable = true}, SHIFT(1028),
  [1913] = {.count = 1, .reusable = true}, SHIFT(1032),
  [1915] = {.count = 1, .reusable = true}, SHIFT(1033),
  [1917] = {.count = 1, .reusable = true}, SHIFT(1034),
  [1919] = {.count = 1, .reusable = true}, SHIFT(1035),
  [1921] = {.count = 1, .reusable = false}, SHIFT(1036),
  [1923] = {.count = 1, .reusable = true}, SHIFT(1037),
  [1925] = {.count = 1, .reusable = true}, SHIFT(1038),
  [1927] = {.count = 1, .reusable = true}, SHIFT(1039),
  [1929] = {.count = 1, .reusable = true}, SHIFT(1040),
  [1931] = {.count = 1, .reusable = true}, SHIFT(1041),
  [1933] = {.count = 1, .reusable = false}, SHIFT(1043),
  [1935] = {.count = 1, .reusable = true}, SHIFT(1043),
  [1937] = {.count = 1, .reusable = true}, SHIFT(1045),
  [1939] = {.count = 1, .reusable = false}, SHIFT(1046),
  [1941] = {.count = 1, .reusable = true}, SHIFT(1046),
  [1943] = {.count = 1, .reusable = true}, SHIFT(1047),
  [1945] = {.count = 1, .reusable = true}, SHIFT(1048),
  [1947] = {.count = 1, .reusable = true}, SHIFT(1050),
  [1949] = {.count = 1, .reusable = true}, SHIFT(1051),
  [1951] = {.count = 1, .reusable = false}, SHIFT(1052),
  [1953] = {.count = 1, .reusable = true}, SHIFT(1052),
  [1955] = {.count = 1, .reusable = true}, SHIFT(1053),
  [1957] = {.count = 1, .reusable = false}, SHIFT(1054),
  [1959] = {.count = 1, .reusable = true}, SHIFT(1054),
  [1961] = {.count = 1, .reusable = true}, SHIFT(1055),
  [1963] = {.count = 1, .reusable = true}, SHIFT(1057),
  [1965] = {.count = 1, .reusable = true}, SHIFT(1058),
  [1967] = {.count = 1, .reusable = true}, SHIFT(1059),
  [1969] = {.count = 1, .reusable = true}, SHIFT(1060),
  [1971] = {.count = 1, .reusable = false}, SHIFT(1062),
  [1973] = {.count = 1, .reusable = false}, SHIFT(1063),
  [1975] = {.count = 1, .reusable = true}, SHIFT(1065),
  [1977] = {.count = 1, .reusable = true}, SHIFT(1066),
  [1979] = {.count = 1, .reusable = false}, SHIFT(1067),
  [1981] = {.count = 1, .reusable = true}, SHIFT(1067),
  [1983] = {.count = 1, .reusable = true}, SHIFT(1068),
  [1985] = {.count = 1, .reusable = true}, SHIFT(1069),
  [1987] = {.count = 1, .reusable = true}, SHIFT(1070),
  [1989] = {.count = 1, .reusable = false}, SHIFT(1071),
  [1991] = {.count = 1, .reusable = true}, SHIFT(1071),
  [1993] = {.count = 1, .reusable = false}, SHIFT(1076),
  [1995] = {.count = 1, .reusable = false}, SHIFT(1077),
  [1997] = {.count = 1, .reusable = true}, SHIFT(1079),
  [1999] = {.count = 1, .reusable = false}, SHIFT(1081),
  [2001] = {.count = 1, .reusable = false}, SHIFT(1082),
  [2003] = {.count = 1, .reusable = true}, SHIFT(1084),
  [2005] = {.count = 1, .reusable = true}, SHIFT(1085),
  [2007] = {.count = 1, .reusable = false}, SHIFT(1086),
  [2009] = {.count = 1, .reusable = true}, SHIFT(1086),
  [2011] = {.count = 1, .reusable = true}, SHIFT(1087),
  [2013] = {.count = 1, .reusable = true}, SHIFT(1088),
  [2015] = {.count = 1, .reusable = true}, SHIFT(1089),
  [2017] = {.count = 1, .reusable = false}, SHIFT(1090),
  [2019] = {.count = 1, .reusable = true}, SHIFT(1090),
  [2021] = {.count = 1, .reusable = false}, SHIFT(1095),
  [2023] = {.count = 1, .reusable = false}, SHIFT(1096),
  [2025] = {.count = 1, .reusable = true}, SHIFT(1098),
  [2027] = {.count = 1, .reusable = false}, SHIFT(1100),
  [2029] = {.count = 1, .reusable = false}, SHIFT(1101),
  [2031] = {.count = 1, .reusable = true}, SHIFT(1102),
  [2033] = {.count = 1, .reusable = true}, SHIFT(1103),
  [2035] = {.count = 1, .reusable = true}, SHIFT(1104),
  [2037] = {.count = 1, .reusable = false}, SHIFT(1105),
  [2039] = {.count = 1, .reusable = true}, SHIFT(1105),
  [2041] = {.count = 1, .reusable = true}, SHIFT(1106),
  [2043] = {.count = 1, .reusable = false}, SHIFT(1108),
  [2045] = {.count = 1, .reusable = true}, SHIFT(1108),
  [2047] = {.count = 1, .reusable = true}, SHIFT(1107),
  [2049] = {.count = 1, .reusable = true}, SHIFT(1109),
  [2051] = {.count = 1, .reusable = false}, SHIFT(1111),
  [2053] = {.count = 1, .reusable = true}, SHIFT(1111),
  [2055] = {.count = 1, .reusable = true}, SHIFT(1110),
  [2057] = {.count = 1, .reusable = true}, SHIFT(1112),
  [2059] = {.count = 1, .reusable = true}, SHIFT(1113),
  [2061] = {.count = 1, .reusable = true}, SHIFT(1114),
  [2063] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 3),
  [2065] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 3),
  [2067] = {.count = 1, .reusable = true}, SHIFT(1116),
  [2069] = {.count = 1, .reusable = true}, SHIFT(1115),
  [2071] = {.count = 1, .reusable = false}, SHIFT(1117),
  [2073] = {.count = 1, .reusable = true}, SHIFT(1117),
  [2075] = {.count = 1, .reusable = true}, SHIFT(1122),
  [2077] = {.count = 1, .reusable = true}, SHIFT(1123),
  [2079] = {.count = 1, .reusable = true}, SHIFT(1126),
  [2081] = {.count = 1, .reusable = true}, SHIFT(1127),
  [2083] = {.count = 1, .reusable = false}, SHIFT(1130),
  [2085] = {.count = 1, .reusable = true}, SHIFT(1130),
  [2087] = {.count = 1, .reusable = true}, SHIFT(1132),
  [2089] = {.count = 1, .reusable = true}, SHIFT(1133),
  [2091] = {.count = 1, .reusable = false}, SHIFT(1136),
  [2093] = {.count = 1, .reusable = true}, SHIFT(1136),
  [2095] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(522),
  [2098] = {.count = 1, .reusable = true}, SHIFT(1139),
  [2100] = {.count = 1, .reusable = true}, SHIFT(1140),
  [2102] = {.count = 1, .reusable = true}, SHIFT(1141),
  [2104] = {.count = 1, .reusable = true}, SHIFT(1143),
  [2106] = {.count = 1, .reusable = true}, SHIFT(1144),
  [2108] = {.count = 1, .reusable = false}, SHIFT(1146),
  [2110] = {.count = 1, .reusable = false}, SHIFT(1147),
  [2112] = {.count = 1, .reusable = true}, SHIFT(1148),
  [2114] = {.count = 1, .reusable = true}, SHIFT(1149),
  [2116] = {.count = 1, .reusable = true}, SHIFT(1150),
  [2118] = {.count = 1, .reusable = false}, SHIFT(1151),
  [2120] = {.count = 1, .reusable = true}, SHIFT(1151),
  [2122] = {.count = 1, .reusable = true}, SHIFT(1152),
  [2124] = {.count = 1, .reusable = false}, SHIFT(1154),
  [2126] = {.count = 1, .reusable = true}, SHIFT(1154),
  [2128] = {.count = 1, .reusable = true}, SHIFT(1153),
  [2130] = {.count = 1, .reusable = true}, SHIFT(1155),
  [2132] = {.count = 1, .reusable = false}, SHIFT(1157),
  [2134] = {.count = 1, .reusable = true}, SHIFT(1157),
  [2136] = {.count = 1, .reusable = true}, SHIFT(1156),
  [2138] = {.count = 1, .reusable = true}, SHIFT(1158),
  [2140] = {.count = 1, .reusable = true}, SHIFT(1159),
  [2142] = {.count = 1, .reusable = true}, SHIFT(1161),
  [2144] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(546),
  [2147] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(552),
  [2150] = {.count = 1, .reusable = true}, SHIFT(1163),
  [2152] = {.count = 1, .reusable = true}, SHIFT(1164),
  [2154] = {.count = 1, .reusable = true}, SHIFT(1165),
  [2156] = {.count = 1, .reusable = true}, SHIFT(1167),
  [2158] = {.count = 1, .reusable = false}, SHIFT(1169),
  [2160] = {.count = 1, .reusable = false}, SHIFT(1170),
  [2162] = {.count = 1, .reusable = true}, SHIFT(1171),
  [2164] = {.count = 1, .reusable = true}, SHIFT(1172),
  [2166] = {.count = 1, .reusable = true}, SHIFT(1173),
  [2168] = {.count = 1, .reusable = false}, SHIFT(1174),
  [2170] = {.count = 1, .reusable = true}, SHIFT(1174),
  [2172] = {.count = 1, .reusable = true}, SHIFT(1175),
  [2174] = {.count = 1, .reusable = false}, SHIFT(1177),
  [2176] = {.count = 1, .reusable = true}, SHIFT(1177),
  [2178] = {.count = 1, .reusable = true}, SHIFT(1176),
  [2180] = {.count = 1, .reusable = true}, SHIFT(1178),
  [2182] = {.count = 1, .reusable = false}, SHIFT(1180),
  [2184] = {.count = 1, .reusable = true}, SHIFT(1180),
  [2186] = {.count = 1, .reusable = true}, SHIFT(1179),
  [2188] = {.count = 1, .reusable = true}, SHIFT(1181),
  [2190] = {.count = 1, .reusable = true}, SHIFT(1182),
  [2192] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [2194] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(165),
  [2197] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [2199] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(166),
  [2202] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(167),
  [2205] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(168),
  [2208] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(169),
  [2211] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(170),
  [2214] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(171),
  [2217] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(172),
  [2220] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(173),
  [2223] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(571),
  [2226] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(169),
  [2229] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(572),
  [2232] = {.count = 1, .reusable = true}, SHIFT(1183),
  [2234] = {.count = 1, .reusable = false}, SHIFT(1185),
  [2236] = {.count = 1, .reusable = false}, SHIFT(1186),
  [2238] = {.count = 1, .reusable = true}, SHIFT(1187),
  [2240] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2242] = {.count = 1, .reusable = true}, SHIFT(1189),
  [2244] = {.count = 1, .reusable = false}, SHIFT(1190),
  [2246] = {.count = 1, .reusable = true}, SHIFT(1190),
  [2248] = {.count = 1, .reusable = true}, SHIFT(1191),
  [2250] = {.count = 1, .reusable = false}, SHIFT(1193),
  [2252] = {.count = 1, .reusable = true}, SHIFT(1193),
  [2254] = {.count = 1, .reusable = true}, SHIFT(1192),
  [2256] = {.count = 1, .reusable = true}, SHIFT(1194),
  [2258] = {.count = 1, .reusable = false}, SHIFT(1196),
  [2260] = {.count = 1, .reusable = true}, SHIFT(1196),
  [2262] = {.count = 1, .reusable = true}, SHIFT(1195),
  [2264] = {.count = 1, .reusable = true}, SHIFT(1197),
  [2266] = {.count = 1, .reusable = true}, SHIFT(1198),
  [2268] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [2270] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [2272] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(177),
  [2275] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(178),
  [2278] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(179),
  [2281] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(180),
  [2284] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(181),
  [2287] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(182),
  [2290] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(183),
  [2293] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(184),
  [2296] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(590),
  [2299] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(180),
  [2302] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(591),
  [2305] = {.count = 1, .reusable = true}, SHIFT(1199),
  [2307] = {.count = 1, .reusable = false}, SHIFT(1201),
  [2309] = {.count = 1, .reusable = false}, SHIFT(1202),
  [2311] = {.count = 1, .reusable = true}, SHIFT(1203),
  [2313] = {.count = 1, .reusable = true}, SHIFT(1204),
  [2315] = {.count = 1, .reusable = true}, SHIFT(1205),
  [2317] = {.count = 1, .reusable = false}, SHIFT(1206),
  [2319] = {.count = 1, .reusable = true}, SHIFT(1206),
  [2321] = {.count = 1, .reusable = true}, SHIFT(1207),
  [2323] = {.count = 1, .reusable = false}, SHIFT(1209),
  [2325] = {.count = 1, .reusable = true}, SHIFT(1209),
  [2327] = {.count = 1, .reusable = true}, SHIFT(1208),
  [2329] = {.count = 1, .reusable = true}, SHIFT(1210),
  [2331] = {.count = 1, .reusable = false}, SHIFT(1212),
  [2333] = {.count = 1, .reusable = true}, SHIFT(1212),
  [2335] = {.count = 1, .reusable = true}, SHIFT(1211),
  [2337] = {.count = 1, .reusable = true}, SHIFT(1213),
  [2339] = {.count = 1, .reusable = true}, SHIFT(1214),
  [2341] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(609),
  [2344] = {.count = 1, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [2346] = {.count = 1, .reusable = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [2348] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(197),
  [2351] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [2353] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [2355] = {.count = 1, .reusable = true}, SHIFT(1215),
  [2357] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [2359] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2),
  [2361] = {.count = 1, .reusable = true}, SHIFT(1216),
  [2363] = {.count = 1, .reusable = true}, SHIFT(1217),
  [2365] = {.count = 1, .reusable = true}, SHIFT(1218),
  [2367] = {.count = 1, .reusable = false}, SHIFT(1219),
  [2369] = {.count = 1, .reusable = true}, SHIFT(1219),
  [2371] = {.count = 1, .reusable = true}, SHIFT(1220),
  [2373] = {.count = 1, .reusable = false}, SHIFT(1222),
  [2375] = {.count = 1, .reusable = true}, SHIFT(1222),
  [2377] = {.count = 1, .reusable = true}, SHIFT(1221),
  [2379] = {.count = 1, .reusable = true}, SHIFT(1223),
  [2381] = {.count = 1, .reusable = false}, SHIFT(1225),
  [2383] = {.count = 1, .reusable = true}, SHIFT(1225),
  [2385] = {.count = 1, .reusable = true}, SHIFT(1224),
  [2387] = {.count = 1, .reusable = true}, SHIFT(1226),
  [2389] = {.count = 1, .reusable = false}, SHIFT(1227),
  [2391] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(1228),
  [2394] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(201),
  [2397] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(202),
  [2400] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(203),
  [2403] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(204),
  [2406] = {.count = 1, .reusable = true}, SHIFT(1229),
  [2408] = {.count = 1, .reusable = true}, SHIFT(1232),
  [2410] = {.count = 1, .reusable = false}, SHIFT(1233),
  [2412] = {.count = 1, .reusable = true}, SHIFT(1234),
  [2414] = {.count = 1, .reusable = false}, SHIFT(1235),
  [2416] = {.count = 1, .reusable = true}, SHIFT(1236),
  [2418] = {.count = 1, .reusable = true}, SHIFT(1237),
  [2420] = {.count = 1, .reusable = true}, SHIFT(1238),
  [2422] = {.count = 1, .reusable = true}, SHIFT(1239),
  [2424] = {.count = 1, .reusable = true}, SHIFT(1240),
  [2426] = {.count = 1, .reusable = true}, SHIFT(1243),
  [2428] = {.count = 1, .reusable = true}, SHIFT(1244),
  [2430] = {.count = 1, .reusable = false}, SHIFT(1246),
  [2432] = {.count = 1, .reusable = true}, SHIFT(1246),
  [2434] = {.count = 1, .reusable = true}, SHIFT(1245),
  [2436] = {.count = 1, .reusable = false}, SHIFT(1248),
  [2438] = {.count = 1, .reusable = true}, SHIFT(1248),
  [2440] = {.count = 1, .reusable = true}, SHIFT(1247),
  [2442] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3, .alias_sequence_id = 3),
  [2444] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 3),
  [2446] = {.count = 1, .reusable = true}, SHIFT(1249),
  [2448] = {.count = 1, .reusable = false}, SHIFT(1251),
  [2450] = {.count = 1, .reusable = false}, SHIFT(1252),
  [2452] = {.count = 1, .reusable = true}, SHIFT(1254),
  [2454] = {.count = 1, .reusable = true}, SHIFT(1255),
  [2456] = {.count = 1, .reusable = false}, SHIFT(1256),
  [2458] = {.count = 1, .reusable = true}, SHIFT(1256),
  [2460] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1),
  [2462] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1),
  [2464] = {.count = 1, .reusable = true}, SHIFT(1257),
  [2466] = {.count = 1, .reusable = true}, SHIFT(1258),
  [2468] = {.count = 1, .reusable = true}, SHIFT(1259),
  [2470] = {.count = 1, .reusable = false}, SHIFT(1260),
  [2472] = {.count = 1, .reusable = true}, SHIFT(1260),
  [2474] = {.count = 1, .reusable = true}, SHIFT(1261),
  [2476] = {.count = 1, .reusable = true}, SHIFT(1262),
  [2478] = {.count = 1, .reusable = false}, SHIFT(1263),
  [2480] = {.count = 1, .reusable = true}, SHIFT(1263),
  [2482] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [2484] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [2486] = {.count = 1, .reusable = false}, SHIFT(1268),
  [2488] = {.count = 1, .reusable = false}, SHIFT(1270),
  [2490] = {.count = 1, .reusable = true}, SHIFT(1270),
  [2492] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3),
  [2494] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3),
  [2496] = {.count = 1, .reusable = true}, SHIFT(1271),
  [2498] = {.count = 1, .reusable = true}, SHIFT(1272),
  [2500] = {.count = 1, .reusable = true}, REDUCE(sym_command_substitution, 3),
  [2502] = {.count = 1, .reusable = false}, REDUCE(sym_command_substitution, 3),
  [2504] = {.count = 1, .reusable = true}, SHIFT(1276),
  [2506] = {.count = 1, .reusable = true}, SHIFT(1277),
  [2508] = {.count = 1, .reusable = true}, SHIFT(1279),
  [2510] = {.count = 1, .reusable = false}, SHIFT(1281),
  [2512] = {.count = 1, .reusable = false}, SHIFT(1284),
  [2514] = {.count = 1, .reusable = false}, SHIFT(1287),
  [2516] = {.count = 1, .reusable = true}, SHIFT(1287),
  [2518] = {.count = 1, .reusable = true}, SHIFT(1292),
  [2520] = {.count = 1, .reusable = true}, SHIFT(1293),
  [2522] = {.count = 1, .reusable = true}, SHIFT(1295),
  [2524] = {.count = 1, .reusable = false}, SHIFT(1297),
  [2526] = {.count = 1, .reusable = true}, SHIFT(1297),
  [2528] = {.count = 1, .reusable = true}, SHIFT(1299),
  [2530] = {.count = 1, .reusable = false}, SHIFT(1302),
  [2532] = {.count = 1, .reusable = true}, SHIFT(1302),
  [2534] = {.count = 1, .reusable = true}, REDUCE(sym_process_substitution, 3),
  [2536] = {.count = 1, .reusable = false}, REDUCE(sym_process_substitution, 3),
  [2538] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 2),
  [2540] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 2),
  [2542] = {.count = 1, .reusable = true}, SHIFT(1306),
  [2544] = {.count = 1, .reusable = false}, SHIFT(1307),
  [2546] = {.count = 1, .reusable = true}, SHIFT(1307),
  [2548] = {.count = 1, .reusable = true}, SHIFT(1308),
  [2550] = {.count = 1, .reusable = true}, SHIFT(1309),
  [2552] = {.count = 1, .reusable = true}, SHIFT(1310),
  [2554] = {.count = 1, .reusable = false}, SHIFT(1311),
  [2556] = {.count = 1, .reusable = true}, SHIFT(1311),
  [2558] = {.count = 1, .reusable = true}, SHIFT(1316),
  [2560] = {.count = 1, .reusable = true}, SHIFT(1315),
  [2562] = {.count = 1, .reusable = true}, SHIFT(1317),
  [2564] = {.count = 1, .reusable = true}, REDUCE(sym_pipeline, 3),
  [2566] = {.count = 1, .reusable = false}, REDUCE(sym_pipeline, 3),
  [2568] = {.count = 1, .reusable = true}, REDUCE(sym_list, 3),
  [2570] = {.count = 1, .reusable = false}, REDUCE(sym_list, 3),
  [2572] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_redirect, 2),
  [2574] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_redirect, 2),
  [2576] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2),
  [2578] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2),
  [2580] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 2),
  [2582] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 2),
  [2584] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 3),
  [2586] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 3),
  [2588] = {.count = 1, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 3),
  [2590] = {.count = 1, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2),
  [2592] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(236),
  [2595] = {.count = 1, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2),
  [2597] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(240),
  [2600] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(240),
  [2603] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(241),
  [2606] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(241),
  [2609] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(242),
  [2612] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2),
  [2614] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2),
  [2616] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2, .alias_sequence_id = 2),
  [2618] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2, .alias_sequence_id = 2),
  [2620] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(245),
  [2623] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(18),
  [2626] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(19),
  [2629] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(20),
  [2632] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(246),
  [2635] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(22),
  [2638] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(23),
  [2641] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(24),
  [2644] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(25),
  [2647] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(246),
  [2650] = {.count = 1, .reusable = false}, SHIFT(1322),
  [2652] = {.count = 1, .reusable = true}, SHIFT(1322),
  [2654] = {.count = 1, .reusable = false}, SHIFT(1323),
  [2656] = {.count = 1, .reusable = false}, SHIFT(1324),
  [2658] = {.count = 1, .reusable = true}, SHIFT(1325),
  [2660] = {.count = 1, .reusable = false}, SHIFT(1326),
  [2662] = {.count = 1, .reusable = false}, SHIFT(1327),
  [2664] = {.count = 1, .reusable = true}, SHIFT(1326),
  [2666] = {.count = 1, .reusable = true}, SHIFT(1327),
  [2668] = {.count = 1, .reusable = true}, SHIFT(1328),
  [2670] = {.count = 1, .reusable = false}, SHIFT(1329),
  [2672] = {.count = 1, .reusable = true}, SHIFT(1329),
  [2674] = {.count = 1, .reusable = true}, SHIFT(1330),
  [2676] = {.count = 1, .reusable = true}, REDUCE(sym_command, 3),
  [2678] = {.count = 1, .reusable = false}, REDUCE(sym_command, 3),
  [2680] = {.count = 1, .reusable = true}, SHIFT(1336),
  [2682] = {.count = 1, .reusable = false}, SHIFT(1144),
  [2684] = {.count = 1, .reusable = true}, SHIFT(1337),
  [2686] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4),
  [2688] = {.count = 1, .reusable = true}, SHIFT(1338),
  [2690] = {.count = 1, .reusable = true}, SHIFT(1339),
  [2692] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4, .alias_sequence_id = 4),
  [2694] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(723),
  [2697] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [2699] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [2701] = {.count = 1, .reusable = true}, SHIFT(1340),
  [2703] = {.count = 1, .reusable = false}, SHIFT(1342),
  [2705] = {.count = 1, .reusable = false}, SHIFT(1343),
  [2707] = {.count = 1, .reusable = true}, SHIFT(1345),
  [2709] = {.count = 1, .reusable = true}, SHIFT(1346),
  [2711] = {.count = 1, .reusable = false}, SHIFT(1347),
  [2713] = {.count = 1, .reusable = true}, SHIFT(1347),
  [2715] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [2717] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [2719] = {.count = 1, .reusable = true}, SHIFT(1348),
  [2721] = {.count = 1, .reusable = true}, SHIFT(1349),
  [2723] = {.count = 1, .reusable = true}, SHIFT(1350),
  [2725] = {.count = 1, .reusable = false}, SHIFT(1351),
  [2727] = {.count = 1, .reusable = true}, SHIFT(1351),
  [2729] = {.count = 1, .reusable = true}, SHIFT(1356),
  [2731] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [2733] = {.count = 1, .reusable = true}, SHIFT(1358),
  [2735] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [2737] = {.count = 1, .reusable = true}, SHIFT(1360),
  [2739] = {.count = 1, .reusable = false}, SHIFT(1362),
  [2741] = {.count = 1, .reusable = false}, SHIFT(1363),
  [2743] = {.count = 1, .reusable = true}, SHIFT(1364),
  [2745] = {.count = 1, .reusable = true}, SHIFT(1365),
  [2747] = {.count = 1, .reusable = true}, SHIFT(1366),
  [2749] = {.count = 1, .reusable = false}, SHIFT(1367),
  [2751] = {.count = 1, .reusable = true}, SHIFT(1367),
  [2753] = {.count = 1, .reusable = true}, SHIFT(1368),
  [2755] = {.count = 1, .reusable = false}, SHIFT(1370),
  [2757] = {.count = 1, .reusable = true}, SHIFT(1370),
  [2759] = {.count = 1, .reusable = true}, SHIFT(1369),
  [2761] = {.count = 1, .reusable = true}, SHIFT(1371),
  [2763] = {.count = 1, .reusable = false}, SHIFT(1373),
  [2765] = {.count = 1, .reusable = true}, SHIFT(1373),
  [2767] = {.count = 1, .reusable = true}, SHIFT(1372),
  [2769] = {.count = 1, .reusable = true}, SHIFT(1374),
  [2771] = {.count = 1, .reusable = true}, SHIFT(1375),
  [2773] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(752),
  [2776] = {.count = 1, .reusable = true}, SHIFT(1376),
  [2778] = {.count = 1, .reusable = false}, SHIFT(1378),
  [2780] = {.count = 1, .reusable = true}, SHIFT(1378),
  [2782] = {.count = 1, .reusable = true}, SHIFT(1379),
  [2784] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2),
  [2786] = {.count = 1, .reusable = true}, SHIFT(1380),
  [2788] = {.count = 1, .reusable = false}, SHIFT(1382),
  [2790] = {.count = 1, .reusable = false}, SHIFT(1383),
  [2792] = {.count = 1, .reusable = true}, SHIFT(1384),
  [2794] = {.count = 1, .reusable = true}, SHIFT(1385),
  [2796] = {.count = 1, .reusable = true}, SHIFT(1386),
  [2798] = {.count = 1, .reusable = false}, SHIFT(1387),
  [2800] = {.count = 1, .reusable = true}, SHIFT(1387),
  [2802] = {.count = 1, .reusable = true}, SHIFT(1388),
  [2804] = {.count = 1, .reusable = false}, SHIFT(1390),
  [2806] = {.count = 1, .reusable = true}, SHIFT(1390),
  [2808] = {.count = 1, .reusable = true}, SHIFT(1389),
  [2810] = {.count = 1, .reusable = true}, SHIFT(1391),
  [2812] = {.count = 1, .reusable = false}, SHIFT(1393),
  [2814] = {.count = 1, .reusable = true}, SHIFT(1393),
  [2816] = {.count = 1, .reusable = true}, SHIFT(1392),
  [2818] = {.count = 1, .reusable = true}, SHIFT(1394),
  [2820] = {.count = 1, .reusable = true}, SHIFT(1395),
  [2822] = {.count = 1, .reusable = true}, SHIFT(1398),
  [2824] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(778),
  [2827] = {.count = 1, .reusable = true}, SHIFT(1399),
  [2829] = {.count = 1, .reusable = false}, SHIFT(1401),
  [2831] = {.count = 1, .reusable = false}, SHIFT(1402),
  [2833] = {.count = 1, .reusable = true}, SHIFT(1404),
  [2835] = {.count = 1, .reusable = true}, SHIFT(1405),
  [2837] = {.count = 1, .reusable = false}, SHIFT(1406),
  [2839] = {.count = 1, .reusable = true}, SHIFT(1406),
  [2841] = {.count = 1, .reusable = true}, SHIFT(1407),
  [2843] = {.count = 1, .reusable = true}, SHIFT(1408),
  [2845] = {.count = 1, .reusable = true}, SHIFT(1409),
  [2847] = {.count = 1, .reusable = false}, SHIFT(1410),
  [2849] = {.count = 1, .reusable = true}, SHIFT(1410),
  [2851] = {.count = 1, .reusable = false}, SHIFT(1415),
  [2853] = {.count = 1, .reusable = true}, SHIFT(1415),
  [2855] = {.count = 1, .reusable = false}, SHIFT(783),
  [2857] = {.count = 1, .reusable = true}, SHIFT(1417),
  [2859] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 4),
  [2861] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 4),
  [2863] = {.count = 1, .reusable = true}, SHIFT(1419),
  [2865] = {.count = 1, .reusable = true}, SHIFT(1420),
  [2867] = {.count = 1, .reusable = false}, SHIFT(1422),
  [2869] = {.count = 1, .reusable = false}, SHIFT(1423),
  [2871] = {.count = 1, .reusable = true}, SHIFT(1424),
  [2873] = {.count = 1, .reusable = true}, SHIFT(1425),
  [2875] = {.count = 1, .reusable = true}, SHIFT(1426),
  [2877] = {.count = 1, .reusable = false}, SHIFT(1427),
  [2879] = {.count = 1, .reusable = true}, SHIFT(1427),
  [2881] = {.count = 1, .reusable = true}, SHIFT(1428),
  [2883] = {.count = 1, .reusable = false}, SHIFT(1430),
  [2885] = {.count = 1, .reusable = true}, SHIFT(1430),
  [2887] = {.count = 1, .reusable = true}, SHIFT(1429),
  [2889] = {.count = 1, .reusable = true}, SHIFT(1431),
  [2891] = {.count = 1, .reusable = false}, SHIFT(1433),
  [2893] = {.count = 1, .reusable = true}, SHIFT(1433),
  [2895] = {.count = 1, .reusable = true}, SHIFT(1432),
  [2897] = {.count = 1, .reusable = true}, SHIFT(1434),
  [2899] = {.count = 1, .reusable = true}, SHIFT(1435),
  [2901] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [2903] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [2905] = {.count = 1, .reusable = true}, SHIFT(1437),
  [2907] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(813),
  [2910] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(302),
  [2913] = {.count = 1, .reusable = false}, SHIFT(1438),
  [2915] = {.count = 1, .reusable = true}, SHIFT(1439),
  [2917] = {.count = 1, .reusable = true}, SHIFT(1440),
  [2919] = {.count = 1, .reusable = true}, SHIFT(1443),
  [2921] = {.count = 1, .reusable = true}, SHIFT(1444),
  [2923] = {.count = 1, .reusable = false}, SHIFT(1446),
  [2925] = {.count = 1, .reusable = true}, SHIFT(1446),
  [2927] = {.count = 1, .reusable = true}, SHIFT(1445),
  [2929] = {.count = 1, .reusable = false}, SHIFT(1448),
  [2931] = {.count = 1, .reusable = true}, SHIFT(1448),
  [2933] = {.count = 1, .reusable = true}, SHIFT(1447),
  [2935] = {.count = 1, .reusable = true}, SHIFT(1449),
  [2937] = {.count = 1, .reusable = true}, SHIFT(1450),
  [2939] = {.count = 1, .reusable = false}, SHIFT(1451),
  [2941] = {.count = 1, .reusable = true}, SHIFT(1451),
  [2943] = {.count = 1, .reusable = true}, SHIFT(1452),
  [2945] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3),
  [2947] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3),
  [2949] = {.count = 1, .reusable = true}, SHIFT(1453),
  [2951] = {.count = 1, .reusable = true}, SHIFT(1455),
  [2953] = {.count = 1, .reusable = false}, SHIFT(1457),
  [2955] = {.count = 1, .reusable = false}, SHIFT(1458),
  [2957] = {.count = 1, .reusable = true}, SHIFT(1460),
  [2959] = {.count = 1, .reusable = true}, SHIFT(1461),
  [2961] = {.count = 1, .reusable = false}, SHIFT(1462),
  [2963] = {.count = 1, .reusable = true}, SHIFT(1462),
  [2965] = {.count = 1, .reusable = true}, SHIFT(1463),
  [2967] = {.count = 1, .reusable = true}, SHIFT(1464),
  [2969] = {.count = 1, .reusable = true}, SHIFT(1465),
  [2971] = {.count = 1, .reusable = false}, SHIFT(1466),
  [2973] = {.count = 1, .reusable = true}, SHIFT(1466),
  [2975] = {.count = 1, .reusable = true}, SHIFT(1471),
  [2977] = {.count = 1, .reusable = false}, SHIFT(1473),
  [2979] = {.count = 1, .reusable = true}, SHIFT(1473),
  [2981] = {.count = 1, .reusable = false}, SHIFT(1475),
  [2983] = {.count = 1, .reusable = true}, SHIFT(1475),
  [2985] = {.count = 1, .reusable = false}, SHIFT(1478),
  [2987] = {.count = 1, .reusable = false}, SHIFT(1480),
  [2989] = {.count = 1, .reusable = false}, SHIFT(1484),
  [2991] = {.count = 1, .reusable = true}, SHIFT(1484),
  [2993] = {.count = 1, .reusable = true}, SHIFT(1485),
  [2995] = {.count = 1, .reusable = false}, SHIFT(1486),
  [2997] = {.count = 1, .reusable = true}, SHIFT(1486),
  [2999] = {.count = 1, .reusable = true}, SHIFT(1487),
  [3001] = {.count = 1, .reusable = true}, SHIFT(1488),
  [3003] = {.count = 1, .reusable = true}, SHIFT(1489),
  [3005] = {.count = 1, .reusable = true}, SHIFT(1490),
  [3007] = {.count = 1, .reusable = true}, SHIFT(1491),
  [3009] = {.count = 1, .reusable = true}, SHIFT(1493),
  [3011] = {.count = 1, .reusable = false}, SHIFT(1495),
  [3013] = {.count = 1, .reusable = false}, SHIFT(1496),
  [3015] = {.count = 1, .reusable = true}, SHIFT(1497),
  [3017] = {.count = 1, .reusable = true}, SHIFT(1498),
  [3019] = {.count = 1, .reusable = true}, SHIFT(1499),
  [3021] = {.count = 1, .reusable = false}, SHIFT(1500),
  [3023] = {.count = 1, .reusable = true}, SHIFT(1500),
  [3025] = {.count = 1, .reusable = true}, SHIFT(1501),
  [3027] = {.count = 1, .reusable = false}, SHIFT(1503),
  [3029] = {.count = 1, .reusable = true}, SHIFT(1503),
  [3031] = {.count = 1, .reusable = true}, SHIFT(1502),
  [3033] = {.count = 1, .reusable = true}, SHIFT(1504),
  [3035] = {.count = 1, .reusable = false}, SHIFT(1506),
  [3037] = {.count = 1, .reusable = true}, SHIFT(1506),
  [3039] = {.count = 1, .reusable = true}, SHIFT(1505),
  [3041] = {.count = 1, .reusable = true}, SHIFT(1507),
  [3043] = {.count = 1, .reusable = true}, SHIFT(1508),
  [3045] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(340),
  [3048] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(341),
  [3051] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(342),
  [3054] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(343),
  [3057] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(344),
  [3060] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(345),
  [3063] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(346),
  [3066] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(347),
  [3069] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(348),
  [3072] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(877),
  [3075] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(344),
  [3078] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(878),
  [3081] = {.count = 1, .reusable = true}, SHIFT(1509),
  [3083] = {.count = 1, .reusable = false}, SHIFT(1511),
  [3085] = {.count = 1, .reusable = false}, SHIFT(1512),
  [3087] = {.count = 1, .reusable = true}, SHIFT(1513),
  [3089] = {.count = 1, .reusable = true}, SHIFT(1514),
  [3091] = {.count = 1, .reusable = true}, SHIFT(1515),
  [3093] = {.count = 1, .reusable = false}, SHIFT(1516),
  [3095] = {.count = 1, .reusable = true}, SHIFT(1516),
  [3097] = {.count = 1, .reusable = true}, SHIFT(1517),
  [3099] = {.count = 1, .reusable = false}, SHIFT(1519),
  [3101] = {.count = 1, .reusable = true}, SHIFT(1519),
  [3103] = {.count = 1, .reusable = true}, SHIFT(1518),
  [3105] = {.count = 1, .reusable = true}, SHIFT(1520),
  [3107] = {.count = 1, .reusable = false}, SHIFT(1522),
  [3109] = {.count = 1, .reusable = true}, SHIFT(1522),
  [3111] = {.count = 1, .reusable = true}, SHIFT(1521),
  [3113] = {.count = 1, .reusable = true}, SHIFT(1523),
  [3115] = {.count = 1, .reusable = true}, SHIFT(1524),
  [3117] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(352),
  [3120] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(353),
  [3123] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(354),
  [3126] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(355),
  [3129] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(356),
  [3132] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(357),
  [3135] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(358),
  [3138] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(359),
  [3141] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(896),
  [3144] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(355),
  [3147] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(897),
  [3150] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(362),
  [3153] = {.count = 1, .reusable = false}, SHIFT(1525),
  [3155] = {.count = 1, .reusable = true}, SHIFT(1526),
  [3157] = {.count = 1, .reusable = true}, SHIFT(1527),
  [3159] = {.count = 1, .reusable = true}, SHIFT(1530),
  [3161] = {.count = 1, .reusable = true}, SHIFT(1531),
  [3163] = {.count = 1, .reusable = false}, SHIFT(1533),
  [3165] = {.count = 1, .reusable = true}, SHIFT(1533),
  [3167] = {.count = 1, .reusable = true}, SHIFT(1532),
  [3169] = {.count = 1, .reusable = false}, SHIFT(1535),
  [3171] = {.count = 1, .reusable = true}, SHIFT(1535),
  [3173] = {.count = 1, .reusable = true}, SHIFT(1534),
  [3175] = {.count = 1, .reusable = true}, SHIFT(1536),
  [3177] = {.count = 1, .reusable = true}, SHIFT(1537),
  [3179] = {.count = 1, .reusable = false}, SHIFT(1538),
  [3181] = {.count = 1, .reusable = true}, SHIFT(1538),
  [3183] = {.count = 1, .reusable = true}, SHIFT(1539),
  [3185] = {.count = 1, .reusable = true}, SHIFT(1541),
  [3187] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 2),
  [3189] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 2),
  [3191] = {.count = 1, .reusable = true}, SHIFT(1542),
  [3193] = {.count = 1, .reusable = true}, SHIFT(1543),
  [3195] = {.count = 1, .reusable = true}, SHIFT(1544),
  [3197] = {.count = 1, .reusable = false}, SHIFT(1545),
  [3199] = {.count = 1, .reusable = true}, SHIFT(1546),
  [3201] = {.count = 1, .reusable = true}, SHIFT(1547),
  [3203] = {.count = 1, .reusable = true}, SHIFT(1548),
  [3205] = {.count = 1, .reusable = true}, SHIFT(1549),
  [3207] = {.count = 1, .reusable = true}, SHIFT(1550),
  [3209] = {.count = 1, .reusable = false}, SHIFT(1552),
  [3211] = {.count = 1, .reusable = false}, SHIFT(1546),
  [3213] = {.count = 1, .reusable = true}, SHIFT(1554),
  [3215] = {.count = 1, .reusable = true}, SHIFT(1555),
  [3217] = {.count = 1, .reusable = false}, SHIFT(1556),
  [3219] = {.count = 1, .reusable = true}, SHIFT(1557),
  [3221] = {.count = 1, .reusable = true}, SHIFT(1558),
  [3223] = {.count = 1, .reusable = true}, SHIFT(1559),
  [3225] = {.count = 1, .reusable = true}, SHIFT(1560),
  [3227] = {.count = 1, .reusable = true}, SHIFT(1561),
  [3229] = {.count = 1, .reusable = false}, SHIFT(1562),
  [3231] = {.count = 1, .reusable = false}, SHIFT(1557),
  [3233] = {.count = 1, .reusable = true}, SHIFT(1564),
  [3235] = {.count = 1, .reusable = false}, SHIFT(1566),
  [3237] = {.count = 1, .reusable = false}, SHIFT(1567),
  [3239] = {.count = 1, .reusable = true}, SHIFT(1569),
  [3241] = {.count = 1, .reusable = true}, SHIFT(1570),
  [3243] = {.count = 1, .reusable = false}, SHIFT(1571),
  [3245] = {.count = 1, .reusable = true}, SHIFT(1571),
  [3247] = {.count = 1, .reusable = true}, SHIFT(1572),
  [3249] = {.count = 1, .reusable = true}, SHIFT(1573),
  [3251] = {.count = 1, .reusable = true}, SHIFT(1574),
  [3253] = {.count = 1, .reusable = false}, SHIFT(1575),
  [3255] = {.count = 1, .reusable = true}, SHIFT(1575),
  [3257] = {.count = 1, .reusable = true}, SHIFT(1580),
  [3259] = {.count = 1, .reusable = true}, SHIFT(1581),
  [3261] = {.count = 1, .reusable = false}, SHIFT(1582),
  [3263] = {.count = 1, .reusable = false}, SHIFT(1583),
  [3265] = {.count = 1, .reusable = true}, SHIFT(1582),
  [3267] = {.count = 1, .reusable = true}, SHIFT(1583),
  [3269] = {.count = 1, .reusable = true}, SHIFT(1584),
  [3271] = {.count = 1, .reusable = false}, SHIFT(1585),
  [3273] = {.count = 1, .reusable = true}, SHIFT(1585),
  [3275] = {.count = 1, .reusable = true}, SHIFT(1586),
  [3277] = {.count = 1, .reusable = false}, SHIFT(1589),
  [3279] = {.count = 1, .reusable = true}, SHIFT(921),
  [3281] = {.count = 1, .reusable = true}, SHIFT(1590),
  [3283] = {.count = 1, .reusable = false}, SHIFT(1590),
  [3285] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 1),
  [3287] = {.count = 1, .reusable = true}, SHIFT(1596),
  [3289] = {.count = 1, .reusable = true}, SHIFT(1598),
  [3291] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(381),
  [3294] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(385),
  [3297] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(385),
  [3300] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(386),
  [3303] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(386),
  [3306] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(387),
  [3309] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(389),
  [3312] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(68),
  [3315] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(69),
  [3318] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(70),
  [3321] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(390),
  [3324] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(72),
  [3327] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(73),
  [3330] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(74),
  [3333] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(75),
  [3336] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(390),
  [3339] = {.count = 1, .reusable = true}, SHIFT(1603),
  [3341] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 4),
  [3343] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 4),
  [3345] = {.count = 1, .reusable = true}, SHIFT(1605),
  [3347] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 1),
  [3349] = {.count = 1, .reusable = false}, SHIFT(1606),
  [3351] = {.count = 1, .reusable = false}, SHIFT(1607),
  [3353] = {.count = 1, .reusable = false}, SHIFT(1608),
  [3355] = {.count = 1, .reusable = false}, SHIFT(1609),
  [3357] = {.count = 1, .reusable = true}, SHIFT(1610),
  [3359] = {.count = 1, .reusable = false}, SHIFT(1611),
  [3361] = {.count = 1, .reusable = true}, SHIFT(1612),
  [3363] = {.count = 1, .reusable = true}, SHIFT(1613),
  [3365] = {.count = 1, .reusable = true}, SHIFT(1614),
  [3367] = {.count = 1, .reusable = true}, SHIFT(1615),
  [3369] = {.count = 1, .reusable = true}, SHIFT(1616),
  [3371] = {.count = 1, .reusable = false}, SHIFT(1617),
  [3373] = {.count = 1, .reusable = true}, SHIFT(1627),
  [3375] = {.count = 1, .reusable = true}, SHIFT(1628),
  [3377] = {.count = 1, .reusable = true}, SHIFT(1629),
  [3379] = {.count = 1, .reusable = false}, SHIFT(1630),
  [3381] = {.count = 1, .reusable = true}, SHIFT(1631),
  [3383] = {.count = 1, .reusable = true}, SHIFT(1632),
  [3385] = {.count = 1, .reusable = true}, SHIFT(1633),
  [3387] = {.count = 1, .reusable = true}, SHIFT(1634),
  [3389] = {.count = 1, .reusable = true}, SHIFT(1635),
  [3391] = {.count = 1, .reusable = false}, SHIFT(1637),
  [3393] = {.count = 1, .reusable = false}, SHIFT(1631),
  [3395] = {.count = 1, .reusable = true}, SHIFT(1639),
  [3397] = {.count = 1, .reusable = true}, SHIFT(1640),
  [3399] = {.count = 1, .reusable = false}, SHIFT(1641),
  [3401] = {.count = 1, .reusable = true}, SHIFT(1642),
  [3403] = {.count = 1, .reusable = true}, SHIFT(1643),
  [3405] = {.count = 1, .reusable = true}, SHIFT(1644),
  [3407] = {.count = 1, .reusable = true}, SHIFT(1645),
  [3409] = {.count = 1, .reusable = true}, SHIFT(1646),
  [3411] = {.count = 1, .reusable = false}, SHIFT(1647),
  [3413] = {.count = 1, .reusable = false}, SHIFT(1642),
  [3415] = {.count = 1, .reusable = true}, SHIFT(1649),
  [3417] = {.count = 1, .reusable = false}, SHIFT(1651),
  [3419] = {.count = 1, .reusable = false}, SHIFT(1652),
  [3421] = {.count = 1, .reusable = true}, SHIFT(1654),
  [3423] = {.count = 1, .reusable = true}, SHIFT(1655),
  [3425] = {.count = 1, .reusable = false}, SHIFT(1656),
  [3427] = {.count = 1, .reusable = true}, SHIFT(1656),
  [3429] = {.count = 1, .reusable = true}, SHIFT(1657),
  [3431] = {.count = 1, .reusable = true}, SHIFT(1658),
  [3433] = {.count = 1, .reusable = true}, SHIFT(1659),
  [3435] = {.count = 1, .reusable = false}, SHIFT(1660),
  [3437] = {.count = 1, .reusable = true}, SHIFT(1660),
  [3439] = {.count = 1, .reusable = true}, SHIFT(1665),
  [3441] = {.count = 1, .reusable = true}, SHIFT(960),
  [3443] = {.count = 1, .reusable = true}, SHIFT(961),
  [3445] = {.count = 1, .reusable = true}, SHIFT(1668),
  [3447] = {.count = 1, .reusable = false}, SHIFT(1669),
  [3449] = {.count = 1, .reusable = false}, SHIFT(1670),
  [3451] = {.count = 1, .reusable = true}, SHIFT(1669),
  [3453] = {.count = 1, .reusable = true}, SHIFT(1670),
  [3455] = {.count = 1, .reusable = true}, SHIFT(1671),
  [3457] = {.count = 1, .reusable = false}, SHIFT(1672),
  [3459] = {.count = 1, .reusable = true}, SHIFT(1672),
  [3461] = {.count = 1, .reusable = true}, SHIFT(1673),
  [3463] = {.count = 1, .reusable = false}, SHIFT(1676),
  [3465] = {.count = 1, .reusable = true}, SHIFT(965),
  [3467] = {.count = 1, .reusable = true}, SHIFT(1677),
  [3469] = {.count = 1, .reusable = false}, SHIFT(1677),
  [3471] = {.count = 1, .reusable = true}, SHIFT(1684),
  [3473] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(397),
  [3476] = {.count = 1, .reusable = false}, SHIFT(1686),
  [3478] = {.count = 1, .reusable = false}, SHIFT(1687),
  [3480] = {.count = 1, .reusable = true}, SHIFT(1688),
  [3482] = {.count = 1, .reusable = true}, SHIFT(1689),
  [3484] = {.count = 1, .reusable = false}, SHIFT(1689),
  [3486] = {.count = 1, .reusable = false}, SHIFT(1694),
  [3488] = {.count = 1, .reusable = true}, SHIFT(1694),
  [3490] = {.count = 1, .reusable = true}, SHIFT(1695),
  [3492] = {.count = 1, .reusable = true}, SHIFT(1696),
  [3494] = {.count = 1, .reusable = true}, SHIFT(1699),
  [3496] = {.count = 1, .reusable = true}, SHIFT(1700),
  [3498] = {.count = 1, .reusable = false}, SHIFT(1702),
  [3500] = {.count = 1, .reusable = true}, SHIFT(1702),
  [3502] = {.count = 1, .reusable = true}, SHIFT(1701),
  [3504] = {.count = 1, .reusable = false}, SHIFT(1704),
  [3506] = {.count = 1, .reusable = true}, SHIFT(1704),
  [3508] = {.count = 1, .reusable = true}, SHIFT(1703),
  [3510] = {.count = 1, .reusable = true}, SHIFT(1705),
  [3512] = {.count = 1, .reusable = true}, SHIFT(1706),
  [3514] = {.count = 1, .reusable = false}, SHIFT(1707),
  [3516] = {.count = 1, .reusable = true}, SHIFT(1707),
  [3518] = {.count = 1, .reusable = true}, SHIFT(1708),
  [3520] = {.count = 1, .reusable = false}, SHIFT(1709),
  [3522] = {.count = 1, .reusable = false}, SHIFT(1712),
  [3524] = {.count = 1, .reusable = true}, SHIFT(1712),
  [3526] = {.count = 1, .reusable = true}, SHIFT(1716),
  [3528] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(422),
  [3531] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(423),
  [3534] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(424),
  [3537] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1011),
  [3540] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(424),
  [3543] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(428),
  [3546] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(429),
  [3549] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1014),
  [3552] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(429),
  [3555] = {.count = 1, .reusable = true}, SHIFT(1720),
  [3557] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(434),
  [3560] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(437),
  [3563] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(437),
  [3566] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(438),
  [3569] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(440),
  [3572] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(101),
  [3575] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(441),
  [3578] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(441),
  [3581] = {.count = 1, .reusable = true}, SHIFT(1724),
  [3583] = {.count = 1, .reusable = true}, SHIFT(1726),
  [3585] = {.count = 1, .reusable = false}, SHIFT(1728),
  [3587] = {.count = 1, .reusable = false}, SHIFT(1729),
  [3589] = {.count = 1, .reusable = true}, SHIFT(1731),
  [3591] = {.count = 1, .reusable = true}, SHIFT(1732),
  [3593] = {.count = 1, .reusable = false}, SHIFT(1733),
  [3595] = {.count = 1, .reusable = true}, SHIFT(1733),
  [3597] = {.count = 1, .reusable = true}, SHIFT(1734),
  [3599] = {.count = 1, .reusable = true}, SHIFT(1735),
  [3601] = {.count = 1, .reusable = true}, SHIFT(1736),
  [3603] = {.count = 1, .reusable = false}, SHIFT(1737),
  [3605] = {.count = 1, .reusable = true}, SHIFT(1737),
  [3607] = {.count = 1, .reusable = false}, SHIFT(1742),
  [3609] = {.count = 1, .reusable = false}, SHIFT(1744),
  [3611] = {.count = 1, .reusable = true}, SHIFT(1744),
  [3613] = {.count = 1, .reusable = false}, SHIFT(1746),
  [3615] = {.count = 1, .reusable = true}, SHIFT(1746),
  [3617] = {.count = 1, .reusable = false}, SHIFT(1749),
  [3619] = {.count = 1, .reusable = false}, SHIFT(1751),
  [3621] = {.count = 1, .reusable = false}, SHIFT(1755),
  [3623] = {.count = 1, .reusable = true}, SHIFT(1755),
  [3625] = {.count = 1, .reusable = true}, SHIFT(1756),
  [3627] = {.count = 1, .reusable = false}, SHIFT(1757),
  [3629] = {.count = 1, .reusable = true}, SHIFT(1757),
  [3631] = {.count = 1, .reusable = true}, SHIFT(1758),
  [3633] = {.count = 1, .reusable = true}, SHIFT(1759),
  [3635] = {.count = 1, .reusable = true}, SHIFT(1760),
  [3637] = {.count = 1, .reusable = true}, SHIFT(1761),
  [3639] = {.count = 1, .reusable = true}, SHIFT(465),
  [3641] = {.count = 1, .reusable = true}, SHIFT(1762),
  [3643] = {.count = 1, .reusable = true}, SHIFT(1764),
  [3645] = {.count = 1, .reusable = false}, SHIFT(1766),
  [3647] = {.count = 1, .reusable = false}, SHIFT(1767),
  [3649] = {.count = 1, .reusable = true}, SHIFT(1768),
  [3651] = {.count = 1, .reusable = true}, SHIFT(1769),
  [3653] = {.count = 1, .reusable = true}, SHIFT(1770),
  [3655] = {.count = 1, .reusable = false}, SHIFT(1771),
  [3657] = {.count = 1, .reusable = true}, SHIFT(1771),
  [3659] = {.count = 1, .reusable = true}, SHIFT(1772),
  [3661] = {.count = 1, .reusable = false}, SHIFT(1774),
  [3663] = {.count = 1, .reusable = true}, SHIFT(1774),
  [3665] = {.count = 1, .reusable = true}, SHIFT(1773),
  [3667] = {.count = 1, .reusable = true}, SHIFT(1775),
  [3669] = {.count = 1, .reusable = false}, SHIFT(1777),
  [3671] = {.count = 1, .reusable = true}, SHIFT(1777),
  [3673] = {.count = 1, .reusable = true}, SHIFT(1776),
  [3675] = {.count = 1, .reusable = true}, SHIFT(1778),
  [3677] = {.count = 1, .reusable = true}, SHIFT(1779),
  [3679] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(464),
  [3682] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(465),
  [3685] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(466),
  [3688] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(467),
  [3691] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(468),
  [3694] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(469),
  [3697] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(470),
  [3700] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(471),
  [3703] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(472),
  [3706] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1076),
  [3709] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(468),
  [3712] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1077),
  [3715] = {.count = 1, .reusable = true}, SHIFT(1780),
  [3717] = {.count = 1, .reusable = false}, SHIFT(1782),
  [3719] = {.count = 1, .reusable = false}, SHIFT(1783),
  [3721] = {.count = 1, .reusable = true}, SHIFT(1784),
  [3723] = {.count = 1, .reusable = true}, SHIFT(1785),
  [3725] = {.count = 1, .reusable = true}, SHIFT(1786),
  [3727] = {.count = 1, .reusable = false}, SHIFT(1787),
  [3729] = {.count = 1, .reusable = true}, SHIFT(1787),
  [3731] = {.count = 1, .reusable = true}, SHIFT(1788),
  [3733] = {.count = 1, .reusable = false}, SHIFT(1790),
  [3735] = {.count = 1, .reusable = true}, SHIFT(1790),
  [3737] = {.count = 1, .reusable = true}, SHIFT(1789),
  [3739] = {.count = 1, .reusable = true}, SHIFT(1791),
  [3741] = {.count = 1, .reusable = false}, SHIFT(1793),
  [3743] = {.count = 1, .reusable = true}, SHIFT(1793),
  [3745] = {.count = 1, .reusable = true}, SHIFT(1792),
  [3747] = {.count = 1, .reusable = true}, SHIFT(1794),
  [3749] = {.count = 1, .reusable = true}, SHIFT(1795),
  [3751] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(476),
  [3754] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(477),
  [3757] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(478),
  [3760] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(479),
  [3763] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(480),
  [3766] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(481),
  [3769] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(482),
  [3772] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(483),
  [3775] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1095),
  [3778] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(479),
  [3781] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1096),
  [3784] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(486),
  [3787] = {.count = 1, .reusable = false}, SHIFT(1796),
  [3789] = {.count = 1, .reusable = true}, SHIFT(1797),
  [3791] = {.count = 1, .reusable = true}, SHIFT(1798),
  [3793] = {.count = 1, .reusable = true}, SHIFT(1801),
  [3795] = {.count = 1, .reusable = true}, SHIFT(1802),
  [3797] = {.count = 1, .reusable = false}, SHIFT(1804),
  [3799] = {.count = 1, .reusable = true}, SHIFT(1804),
  [3801] = {.count = 1, .reusable = true}, SHIFT(1803),
  [3803] = {.count = 1, .reusable = false}, SHIFT(1806),
  [3805] = {.count = 1, .reusable = true}, SHIFT(1806),
  [3807] = {.count = 1, .reusable = true}, SHIFT(1805),
  [3809] = {.count = 1, .reusable = true}, SHIFT(1807),
  [3811] = {.count = 1, .reusable = true}, SHIFT(1808),
  [3813] = {.count = 1, .reusable = false}, SHIFT(1809),
  [3815] = {.count = 1, .reusable = true}, SHIFT(1809),
  [3817] = {.count = 1, .reusable = true}, SHIFT(1810),
  [3819] = {.count = 1, .reusable = true}, SHIFT(1812),
  [3821] = {.count = 1, .reusable = true}, SHIFT(1813),
  [3823] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(506),
  [3826] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(510),
  [3829] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(510),
  [3832] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(511),
  [3835] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(511),
  [3838] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(512),
  [3841] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(515),
  [3844] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(127),
  [3847] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(128),
  [3850] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(129),
  [3853] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(516),
  [3856] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(131),
  [3859] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(132),
  [3862] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(133),
  [3865] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(134),
  [3868] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(516),
  [3871] = {.count = 1, .reusable = false}, SHIFT(1818),
  [3873] = {.count = 1, .reusable = true}, SHIFT(1818),
  [3875] = {.count = 1, .reusable = true}, SHIFT(1819),
  [3877] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(527),
  [3880] = {.count = 1, .reusable = false}, SHIFT(1821),
  [3882] = {.count = 1, .reusable = true}, SHIFT(1822),
  [3884] = {.count = 1, .reusable = true}, SHIFT(1823),
  [3886] = {.count = 1, .reusable = true}, SHIFT(1826),
  [3888] = {.count = 1, .reusable = true}, SHIFT(1827),
  [3890] = {.count = 1, .reusable = false}, SHIFT(1829),
  [3892] = {.count = 1, .reusable = true}, SHIFT(1829),
  [3894] = {.count = 1, .reusable = true}, SHIFT(1828),
  [3896] = {.count = 1, .reusable = false}, SHIFT(1831),
  [3898] = {.count = 1, .reusable = true}, SHIFT(1831),
  [3900] = {.count = 1, .reusable = true}, SHIFT(1830),
  [3902] = {.count = 1, .reusable = true}, SHIFT(1832),
  [3904] = {.count = 1, .reusable = true}, SHIFT(1833),
  [3906] = {.count = 1, .reusable = false}, SHIFT(1834),
  [3908] = {.count = 1, .reusable = true}, SHIFT(1834),
  [3910] = {.count = 1, .reusable = true}, SHIFT(1835),
  [3912] = {.count = 1, .reusable = true}, SHIFT(1836),
  [3914] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(555),
  [3917] = {.count = 1, .reusable = false}, SHIFT(1838),
  [3919] = {.count = 1, .reusable = true}, SHIFT(1839),
  [3921] = {.count = 1, .reusable = true}, SHIFT(1840),
  [3923] = {.count = 1, .reusable = true}, SHIFT(1843),
  [3925] = {.count = 1, .reusable = true}, SHIFT(1844),
  [3927] = {.count = 1, .reusable = false}, SHIFT(1846),
  [3929] = {.count = 1, .reusable = true}, SHIFT(1846),
  [3931] = {.count = 1, .reusable = true}, SHIFT(1845),
  [3933] = {.count = 1, .reusable = false}, SHIFT(1848),
  [3935] = {.count = 1, .reusable = true}, SHIFT(1848),
  [3937] = {.count = 1, .reusable = true}, SHIFT(1847),
  [3939] = {.count = 1, .reusable = true}, SHIFT(1849),
  [3941] = {.count = 1, .reusable = true}, SHIFT(1850),
  [3943] = {.count = 1, .reusable = false}, SHIFT(1851),
  [3945] = {.count = 1, .reusable = true}, SHIFT(1851),
  [3947] = {.count = 1, .reusable = true}, SHIFT(1852),
  [3949] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(574),
  [3952] = {.count = 1, .reusable = false}, SHIFT(1853),
  [3954] = {.count = 1, .reusable = true}, SHIFT(1854),
  [3956] = {.count = 1, .reusable = true}, SHIFT(1855),
  [3958] = {.count = 1, .reusable = true}, SHIFT(1858),
  [3960] = {.count = 1, .reusable = true}, SHIFT(1859),
  [3962] = {.count = 1, .reusable = false}, SHIFT(1861),
  [3964] = {.count = 1, .reusable = true}, SHIFT(1861),
  [3966] = {.count = 1, .reusable = true}, SHIFT(1860),
  [3968] = {.count = 1, .reusable = false}, SHIFT(1863),
  [3970] = {.count = 1, .reusable = true}, SHIFT(1863),
  [3972] = {.count = 1, .reusable = true}, SHIFT(1862),
  [3974] = {.count = 1, .reusable = true}, SHIFT(1864),
  [3976] = {.count = 1, .reusable = true}, SHIFT(1865),
  [3978] = {.count = 1, .reusable = false}, SHIFT(1866),
  [3980] = {.count = 1, .reusable = true}, SHIFT(1866),
  [3982] = {.count = 1, .reusable = true}, SHIFT(1867),
  [3984] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(593),
  [3987] = {.count = 1, .reusable = false}, SHIFT(1868),
  [3989] = {.count = 1, .reusable = true}, SHIFT(1869),
  [3991] = {.count = 1, .reusable = true}, SHIFT(1870),
  [3993] = {.count = 1, .reusable = true}, SHIFT(1873),
  [3995] = {.count = 1, .reusable = true}, SHIFT(1874),
  [3997] = {.count = 1, .reusable = false}, SHIFT(1876),
  [3999] = {.count = 1, .reusable = true}, SHIFT(1876),
  [4001] = {.count = 1, .reusable = true}, SHIFT(1875),
  [4003] = {.count = 1, .reusable = false}, SHIFT(1878),
  [4005] = {.count = 1, .reusable = true}, SHIFT(1878),
  [4007] = {.count = 1, .reusable = true}, SHIFT(1877),
  [4009] = {.count = 1, .reusable = true}, SHIFT(1879),
  [4011] = {.count = 1, .reusable = true}, SHIFT(1880),
  [4013] = {.count = 1, .reusable = false}, SHIFT(1881),
  [4015] = {.count = 1, .reusable = true}, SHIFT(1881),
  [4017] = {.count = 1, .reusable = true}, SHIFT(1882),
  [4019] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 3),
  [4021] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 3),
  [4023] = {.count = 1, .reusable = true}, SHIFT(1883),
  [4025] = {.count = 1, .reusable = true}, SHIFT(1884),
  [4027] = {.count = 1, .reusable = true}, SHIFT(1887),
  [4029] = {.count = 1, .reusable = true}, SHIFT(1888),
  [4031] = {.count = 1, .reusable = false}, SHIFT(1890),
  [4033] = {.count = 1, .reusable = true}, SHIFT(1890),
  [4035] = {.count = 1, .reusable = true}, SHIFT(1889),
  [4037] = {.count = 1, .reusable = false}, SHIFT(1892),
  [4039] = {.count = 1, .reusable = true}, SHIFT(1892),
  [4041] = {.count = 1, .reusable = true}, SHIFT(1891),
  [4043] = {.count = 1, .reusable = true}, SHIFT(1893),
  [4045] = {.count = 1, .reusable = true}, SHIFT(1894),
  [4047] = {.count = 1, .reusable = false}, SHIFT(1895),
  [4049] = {.count = 1, .reusable = true}, SHIFT(1895),
  [4051] = {.count = 1, .reusable = true}, SHIFT(1896),
  [4053] = {.count = 1, .reusable = true}, REDUCE(sym_string, 4),
  [4055] = {.count = 1, .reusable = false}, REDUCE(sym_string, 4),
  [4057] = {.count = 1, .reusable = true}, SHIFT(1897),
  [4059] = {.count = 1, .reusable = true}, SHIFT(1898),
  [4061] = {.count = 1, .reusable = true}, SHIFT(1899),
  [4063] = {.count = 1, .reusable = true}, SHIFT(1900),
  [4065] = {.count = 1, .reusable = true}, SHIFT(1901),
  [4067] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4),
  [4069] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4),
  [4071] = {.count = 1, .reusable = true}, SHIFT(1902),
  [4073] = {.count = 1, .reusable = false}, SHIFT(1904),
  [4075] = {.count = 1, .reusable = false}, SHIFT(1905),
  [4077] = {.count = 1, .reusable = true}, SHIFT(1907),
  [4079] = {.count = 1, .reusable = true}, SHIFT(1908),
  [4081] = {.count = 1, .reusable = false}, SHIFT(1909),
  [4083] = {.count = 1, .reusable = true}, SHIFT(1909),
  [4085] = {.count = 1, .reusable = true}, SHIFT(1910),
  [4087] = {.count = 1, .reusable = true}, SHIFT(1911),
  [4089] = {.count = 1, .reusable = true}, SHIFT(1912),
  [4091] = {.count = 1, .reusable = true}, SHIFT(1913),
  [4093] = {.count = 1, .reusable = false}, SHIFT(1914),
  [4095] = {.count = 1, .reusable = true}, SHIFT(1914),
  [4097] = {.count = 1, .reusable = true}, SHIFT(1919),
  [4099] = {.count = 1, .reusable = false}, SHIFT(1920),
  [4101] = {.count = 1, .reusable = true}, SHIFT(1922),
  [4103] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [4105] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [4107] = {.count = 1, .reusable = true}, SHIFT(1925),
  [4109] = {.count = 1, .reusable = true}, SHIFT(1926),
  [4111] = {.count = 1, .reusable = false}, SHIFT(1927),
  [4113] = {.count = 1, .reusable = true}, SHIFT(1927),
  [4115] = {.count = 1, .reusable = true}, SHIFT(1928),
  [4117] = {.count = 1, .reusable = false}, SHIFT(1929),
  [4119] = {.count = 1, .reusable = true}, SHIFT(1929),
  [4121] = {.count = 1, .reusable = true}, SHIFT(1930),
  [4123] = {.count = 1, .reusable = false}, SHIFT(1932),
  [4125] = {.count = 1, .reusable = false}, SHIFT(1933),
  [4127] = {.count = 1, .reusable = true}, SHIFT(1934),
  [4129] = {.count = 1, .reusable = true}, SHIFT(1935),
  [4131] = {.count = 1, .reusable = true}, SHIFT(1936),
  [4133] = {.count = 1, .reusable = false}, SHIFT(1937),
  [4135] = {.count = 1, .reusable = true}, SHIFT(1937),
  [4137] = {.count = 1, .reusable = true}, SHIFT(1938),
  [4139] = {.count = 1, .reusable = false}, SHIFT(1940),
  [4141] = {.count = 1, .reusable = true}, SHIFT(1940),
  [4143] = {.count = 1, .reusable = true}, SHIFT(1939),
  [4145] = {.count = 1, .reusable = true}, SHIFT(1941),
  [4147] = {.count = 1, .reusable = false}, SHIFT(1943),
  [4149] = {.count = 1, .reusable = true}, SHIFT(1943),
  [4151] = {.count = 1, .reusable = true}, SHIFT(1942),
  [4153] = {.count = 1, .reusable = true}, SHIFT(1944),
  [4155] = {.count = 1, .reusable = false}, SHIFT(1945),
  [4157] = {.count = 1, .reusable = true}, SHIFT(1945),
  [4159] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 3),
  [4161] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 3),
  [4163] = {.count = 1, .reusable = true}, SHIFT(1946),
  [4165] = {.count = 1, .reusable = true}, SHIFT(1947),
  [4167] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1268),
  [4170] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2),
  [4172] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(1270),
  [4175] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(633),
  [4178] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(634),
  [4181] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(635),
  [4184] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(636),
  [4187] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(1270),
  [4190] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(637),
  [4193] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(639),
  [4196] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(640),
  [4199] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(641),
  [4202] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(636),
  [4205] = {.count = 1, .reusable = true}, SHIFT(1951),
  [4207] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(653),
  [4210] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(654),
  [4213] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(655),
  [4216] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1281),
  [4219] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(655),
  [4222] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(659),
  [4225] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(660),
  [4228] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1284),
  [4231] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(660),
  [4234] = {.count = 1, .reusable = true}, SHIFT(1955),
  [4236] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(664),
  [4239] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(668),
  [4242] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(668),
  [4245] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(669),
  [4248] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(672),
  [4251] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(221),
  [4254] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(673),
  [4257] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(673),
  [4260] = {.count = 1, .reusable = false}, SHIFT(1959),
  [4262] = {.count = 1, .reusable = true}, SHIFT(1959),
  [4264] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 4),
  [4266] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 4),
  [4268] = {.count = 1, .reusable = true}, SHIFT(1960),
  [4270] = {.count = 1, .reusable = true}, SHIFT(1961),
  [4272] = {.count = 1, .reusable = true}, SHIFT(1962),
  [4274] = {.count = 1, .reusable = false}, SHIFT(1963),
  [4276] = {.count = 1, .reusable = true}, SHIFT(1963),
  [4278] = {.count = 1, .reusable = true}, SHIFT(1964),
  [4280] = {.count = 1, .reusable = false}, SHIFT(1966),
  [4282] = {.count = 1, .reusable = true}, SHIFT(1966),
  [4284] = {.count = 1, .reusable = true}, SHIFT(1965),
  [4286] = {.count = 1, .reusable = true}, SHIFT(1967),
  [4288] = {.count = 1, .reusable = false}, SHIFT(1969),
  [4290] = {.count = 1, .reusable = true}, SHIFT(1969),
  [4292] = {.count = 1, .reusable = true}, SHIFT(1968),
  [4294] = {.count = 1, .reusable = true}, SHIFT(1970),
  [4296] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 3),
  [4298] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 3),
  [4300] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1316),
  [4303] = {.count = 1, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2),
  [4305] = {.count = 2, .reusable = false}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(683),
  [4308] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(684),
  [4311] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(685),
  [4314] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(686),
  [4317] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 4),
  [4319] = {.count = 1, .reusable = false}, SHIFT(1972),
  [4321] = {.count = 1, .reusable = true}, SHIFT(1972),
  [4323] = {.count = 1, .reusable = false}, SHIFT(709),
  [4325] = {.count = 1, .reusable = false}, SHIFT(710),
  [4327] = {.count = 1, .reusable = false}, SHIFT(711),
  [4329] = {.count = 1, .reusable = true}, SHIFT(1977),
  [4331] = {.count = 1, .reusable = true}, SHIFT(1978),
  [4333] = {.count = 1, .reusable = true}, SHIFT(1980),
  [4335] = {.count = 1, .reusable = false}, SHIFT(1982),
  [4337] = {.count = 1, .reusable = true}, SHIFT(1982),
  [4339] = {.count = 1, .reusable = true}, SHIFT(1985),
  [4341] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5),
  [4343] = {.count = 1, .reusable = true}, SHIFT(1986),
  [4345] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5, .alias_sequence_id = 4),
  [4347] = {.count = 1, .reusable = true}, SHIFT(1987),
  [4349] = {.count = 1, .reusable = false}, SHIFT(1989),
  [4351] = {.count = 1, .reusable = false}, SHIFT(1990),
  [4353] = {.count = 1, .reusable = true}, SHIFT(1991),
  [4355] = {.count = 1, .reusable = true}, SHIFT(1992),
  [4357] = {.count = 1, .reusable = true}, SHIFT(1993),
  [4359] = {.count = 1, .reusable = false}, SHIFT(1994),
  [4361] = {.count = 1, .reusable = true}, SHIFT(1994),
  [4363] = {.count = 1, .reusable = true}, SHIFT(1995),
  [4365] = {.count = 1, .reusable = false}, SHIFT(1997),
  [4367] = {.count = 1, .reusable = true}, SHIFT(1997),
  [4369] = {.count = 1, .reusable = true}, SHIFT(1996),
  [4371] = {.count = 1, .reusable = true}, SHIFT(1998),
  [4373] = {.count = 1, .reusable = false}, SHIFT(2000),
  [4375] = {.count = 1, .reusable = true}, SHIFT(2000),
  [4377] = {.count = 1, .reusable = true}, SHIFT(1999),
  [4379] = {.count = 1, .reusable = true}, SHIFT(2001),
  [4381] = {.count = 1, .reusable = true}, SHIFT(2002),
  [4383] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [4385] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [4387] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [4389] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(726),
  [4392] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(727),
  [4395] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(728),
  [4398] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(729),
  [4401] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(730),
  [4404] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(731),
  [4407] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(732),
  [4410] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(733),
  [4413] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1358),
  [4416] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(736),
  [4419] = {.count = 1, .reusable = false}, SHIFT(2003),
  [4421] = {.count = 1, .reusable = true}, SHIFT(2004),
  [4423] = {.count = 1, .reusable = true}, SHIFT(2005),
  [4425] = {.count = 1, .reusable = true}, SHIFT(2008),
  [4427] = {.count = 1, .reusable = true}, SHIFT(2009),
  [4429] = {.count = 1, .reusable = false}, SHIFT(2011),
  [4431] = {.count = 1, .reusable = true}, SHIFT(2011),
  [4433] = {.count = 1, .reusable = true}, SHIFT(2010),
  [4435] = {.count = 1, .reusable = false}, SHIFT(2013),
  [4437] = {.count = 1, .reusable = true}, SHIFT(2013),
  [4439] = {.count = 1, .reusable = true}, SHIFT(2012),
  [4441] = {.count = 1, .reusable = true}, SHIFT(2014),
  [4443] = {.count = 1, .reusable = true}, SHIFT(2015),
  [4445] = {.count = 1, .reusable = false}, SHIFT(2016),
  [4447] = {.count = 1, .reusable = true}, SHIFT(2016),
  [4449] = {.count = 1, .reusable = true}, SHIFT(2017),
  [4451] = {.count = 1, .reusable = true}, SHIFT(2018),
  [4453] = {.count = 1, .reusable = true}, SHIFT(2020),
  [4455] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(758),
  [4458] = {.count = 1, .reusable = false}, SHIFT(2022),
  [4460] = {.count = 1, .reusable = true}, SHIFT(2023),
  [4462] = {.count = 1, .reusable = true}, SHIFT(2024),
  [4464] = {.count = 1, .reusable = true}, SHIFT(2027),
  [4466] = {.count = 1, .reusable = true}, SHIFT(2028),
  [4468] = {.count = 1, .reusable = false}, SHIFT(2030),
  [4470] = {.count = 1, .reusable = true}, SHIFT(2030),
  [4472] = {.count = 1, .reusable = true}, SHIFT(2029),
  [4474] = {.count = 1, .reusable = false}, SHIFT(2032),
  [4476] = {.count = 1, .reusable = true}, SHIFT(2032),
  [4478] = {.count = 1, .reusable = true}, SHIFT(2031),
  [4480] = {.count = 1, .reusable = true}, SHIFT(2033),
  [4482] = {.count = 1, .reusable = true}, SHIFT(2034),
  [4484] = {.count = 1, .reusable = false}, SHIFT(2035),
  [4486] = {.count = 1, .reusable = true}, SHIFT(2035),
  [4488] = {.count = 1, .reusable = true}, SHIFT(2036),
  [4490] = {.count = 1, .reusable = false}, SHIFT(2037),
  [4492] = {.count = 1, .reusable = true}, SHIFT(2037),
  [4494] = {.count = 1, .reusable = true}, SHIFT(2038),
  [4496] = {.count = 1, .reusable = false}, SHIFT(2040),
  [4498] = {.count = 1, .reusable = false}, SHIFT(2041),
  [4500] = {.count = 1, .reusable = true}, SHIFT(2042),
  [4502] = {.count = 1, .reusable = true}, SHIFT(2043),
  [4504] = {.count = 1, .reusable = true}, SHIFT(2044),
  [4506] = {.count = 1, .reusable = false}, SHIFT(2045),
  [4508] = {.count = 1, .reusable = true}, SHIFT(2045),
  [4510] = {.count = 1, .reusable = true}, SHIFT(2046),
  [4512] = {.count = 1, .reusable = false}, SHIFT(2048),
  [4514] = {.count = 1, .reusable = true}, SHIFT(2048),
  [4516] = {.count = 1, .reusable = true}, SHIFT(2047),
  [4518] = {.count = 1, .reusable = true}, SHIFT(2049),
  [4520] = {.count = 1, .reusable = false}, SHIFT(2051),
  [4522] = {.count = 1, .reusable = true}, SHIFT(2051),
  [4524] = {.count = 1, .reusable = true}, SHIFT(2050),
  [4526] = {.count = 1, .reusable = true}, SHIFT(2052),
  [4528] = {.count = 1, .reusable = true}, SHIFT(2053),
  [4530] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [4532] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(780),
  [4535] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(781),
  [4538] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(782),
  [4541] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(783),
  [4544] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(784),
  [4547] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(785),
  [4550] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(786),
  [4553] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(787),
  [4556] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(783),
  [4559] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1417),
  [4562] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(793),
  [4565] = {.count = 1, .reusable = false}, SHIFT(2055),
  [4567] = {.count = 1, .reusable = true}, SHIFT(2056),
  [4569] = {.count = 1, .reusable = true}, SHIFT(2057),
  [4571] = {.count = 1, .reusable = true}, SHIFT(2060),
  [4573] = {.count = 1, .reusable = true}, SHIFT(2061),
  [4575] = {.count = 1, .reusable = false}, SHIFT(2063),
  [4577] = {.count = 1, .reusable = true}, SHIFT(2063),
  [4579] = {.count = 1, .reusable = true}, SHIFT(2062),
  [4581] = {.count = 1, .reusable = false}, SHIFT(2065),
  [4583] = {.count = 1, .reusable = true}, SHIFT(2065),
  [4585] = {.count = 1, .reusable = true}, SHIFT(2064),
  [4587] = {.count = 1, .reusable = true}, SHIFT(2066),
  [4589] = {.count = 1, .reusable = true}, SHIFT(2067),
  [4591] = {.count = 1, .reusable = false}, SHIFT(2068),
  [4593] = {.count = 1, .reusable = true}, SHIFT(2068),
  [4595] = {.count = 1, .reusable = true}, SHIFT(2069),
  [4597] = {.count = 1, .reusable = true}, SHIFT(2070),
  [4599] = {.count = 1, .reusable = true}, SHIFT(2071),
  [4601] = {.count = 1, .reusable = true}, SHIFT(2072),
  [4603] = {.count = 1, .reusable = true}, SHIFT(2075),
  [4605] = {.count = 1, .reusable = true}, SHIFT(2076),
  [4607] = {.count = 1, .reusable = false}, SHIFT(2077),
  [4609] = {.count = 1, .reusable = true}, SHIFT(2077),
  [4611] = {.count = 1, .reusable = true}, SHIFT(2078),
  [4613] = {.count = 1, .reusable = false}, SHIFT(2079),
  [4615] = {.count = 1, .reusable = true}, SHIFT(2079),
  [4617] = {.count = 1, .reusable = true}, SHIFT(2080),
  [4619] = {.count = 1, .reusable = false}, SHIFT(2081),
  [4621] = {.count = 1, .reusable = true}, SHIFT(2081),
  [4623] = {.count = 1, .reusable = true}, SHIFT(2082),
  [4625] = {.count = 1, .reusable = true}, SHIFT(2083),
  [4627] = {.count = 1, .reusable = false}, SHIFT(2085),
  [4629] = {.count = 1, .reusable = false}, SHIFT(2086),
  [4631] = {.count = 1, .reusable = true}, SHIFT(2087),
  [4633] = {.count = 1, .reusable = true}, SHIFT(2088),
  [4635] = {.count = 1, .reusable = true}, SHIFT(2089),
  [4637] = {.count = 1, .reusable = false}, SHIFT(2090),
  [4639] = {.count = 1, .reusable = true}, SHIFT(2090),
  [4641] = {.count = 1, .reusable = true}, SHIFT(2091),
  [4643] = {.count = 1, .reusable = false}, SHIFT(2093),
  [4645] = {.count = 1, .reusable = true}, SHIFT(2093),
  [4647] = {.count = 1, .reusable = true}, SHIFT(2092),
  [4649] = {.count = 1, .reusable = true}, SHIFT(2094),
  [4651] = {.count = 1, .reusable = false}, SHIFT(2096),
  [4653] = {.count = 1, .reusable = true}, SHIFT(2096),
  [4655] = {.count = 1, .reusable = true}, SHIFT(2095),
  [4657] = {.count = 1, .reusable = true}, SHIFT(2097),
  [4659] = {.count = 1, .reusable = true}, SHIFT(2098),
  [4661] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1471),
  [4664] = {.count = 1, .reusable = true}, SHIFT(2099),
  [4666] = {.count = 1, .reusable = false}, SHIFT(2101),
  [4668] = {.count = 1, .reusable = true}, SHIFT(2101),
  [4670] = {.count = 1, .reusable = false}, SHIFT(2103),
  [4672] = {.count = 1, .reusable = true}, SHIFT(2103),
  [4674] = {.count = 1, .reusable = true}, SHIFT(2104),
  [4676] = {.count = 1, .reusable = true}, SHIFT(2105),
  [4678] = {.count = 1, .reusable = false}, SHIFT(2108),
  [4680] = {.count = 1, .reusable = false}, SHIFT(2111),
  [4682] = {.count = 1, .reusable = true}, SHIFT(2111),
  [4684] = {.count = 1, .reusable = false}, SHIFT(2112),
  [4686] = {.count = 1, .reusable = false}, SHIFT(2115),
  [4688] = {.count = 1, .reusable = true}, SHIFT(2115),
  [4690] = {.count = 1, .reusable = true}, SHIFT(2117),
  [4692] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(861),
  [4695] = {.count = 1, .reusable = false}, SHIFT(2119),
  [4697] = {.count = 1, .reusable = true}, SHIFT(2120),
  [4699] = {.count = 1, .reusable = true}, SHIFT(2121),
  [4701] = {.count = 1, .reusable = true}, SHIFT(2124),
  [4703] = {.count = 1, .reusable = true}, SHIFT(2125),
  [4705] = {.count = 1, .reusable = false}, SHIFT(2127),
  [4707] = {.count = 1, .reusable = true}, SHIFT(2127),
  [4709] = {.count = 1, .reusable = true}, SHIFT(2126),
  [4711] = {.count = 1, .reusable = false}, SHIFT(2129),
  [4713] = {.count = 1, .reusable = true}, SHIFT(2129),
  [4715] = {.count = 1, .reusable = true}, SHIFT(2128),
  [4717] = {.count = 1, .reusable = true}, SHIFT(2130),
  [4719] = {.count = 1, .reusable = true}, SHIFT(2131),
  [4721] = {.count = 1, .reusable = false}, SHIFT(2132),
  [4723] = {.count = 1, .reusable = true}, SHIFT(2132),
  [4725] = {.count = 1, .reusable = true}, SHIFT(2133),
  [4727] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(880),
  [4730] = {.count = 1, .reusable = false}, SHIFT(2134),
  [4732] = {.count = 1, .reusable = true}, SHIFT(2135),
  [4734] = {.count = 1, .reusable = true}, SHIFT(2136),
  [4736] = {.count = 1, .reusable = true}, SHIFT(2139),
  [4738] = {.count = 1, .reusable = true}, SHIFT(2140),
  [4740] = {.count = 1, .reusable = false}, SHIFT(2142),
  [4742] = {.count = 1, .reusable = true}, SHIFT(2142),
  [4744] = {.count = 1, .reusable = true}, SHIFT(2141),
  [4746] = {.count = 1, .reusable = false}, SHIFT(2144),
  [4748] = {.count = 1, .reusable = true}, SHIFT(2144),
  [4750] = {.count = 1, .reusable = true}, SHIFT(2143),
  [4752] = {.count = 1, .reusable = true}, SHIFT(2145),
  [4754] = {.count = 1, .reusable = true}, SHIFT(2146),
  [4756] = {.count = 1, .reusable = false}, SHIFT(2147),
  [4758] = {.count = 1, .reusable = true}, SHIFT(2147),
  [4760] = {.count = 1, .reusable = true}, SHIFT(2148),
  [4762] = {.count = 1, .reusable = true}, SHIFT(2149),
  [4764] = {.count = 1, .reusable = true}, SHIFT(2150),
  [4766] = {.count = 1, .reusable = true}, SHIFT(2151),
  [4768] = {.count = 1, .reusable = true}, SHIFT(2154),
  [4770] = {.count = 1, .reusable = true}, SHIFT(2155),
  [4772] = {.count = 1, .reusable = false}, SHIFT(2156),
  [4774] = {.count = 1, .reusable = true}, SHIFT(2156),
  [4776] = {.count = 1, .reusable = true}, SHIFT(2157),
  [4778] = {.count = 1, .reusable = false}, SHIFT(2158),
  [4780] = {.count = 1, .reusable = true}, SHIFT(2158),
  [4782] = {.count = 1, .reusable = true}, SHIFT(2159),
  [4784] = {.count = 1, .reusable = false}, SHIFT(2160),
  [4786] = {.count = 1, .reusable = true}, SHIFT(2160),
  [4788] = {.count = 1, .reusable = true}, SHIFT(2161),
  [4790] = {.count = 1, .reusable = true}, SHIFT(2162),
  [4792] = {.count = 1, .reusable = true}, SHIFT(2163),
  [4794] = {.count = 1, .reusable = true}, SHIFT(2164),
  [4796] = {.count = 1, .reusable = false}, SHIFT(2165),
  [4798] = {.count = 1, .reusable = true}, SHIFT(2166),
  [4800] = {.count = 1, .reusable = true}, SHIFT(2167),
  [4802] = {.count = 1, .reusable = true}, SHIFT(2168),
  [4804] = {.count = 1, .reusable = true}, SHIFT(2169),
  [4806] = {.count = 1, .reusable = true}, SHIFT(2170),
  [4808] = {.count = 1, .reusable = true}, SHIFT(2172),
  [4810] = {.count = 1, .reusable = true}, SHIFT(2173),
  [4812] = {.count = 1, .reusable = false}, SHIFT(2175),
  [4814] = {.count = 1, .reusable = false}, SHIFT(2176),
  [4816] = {.count = 1, .reusable = true}, SHIFT(2178),
  [4818] = {.count = 1, .reusable = true}, SHIFT(2179),
  [4820] = {.count = 1, .reusable = false}, SHIFT(2180),
  [4822] = {.count = 1, .reusable = true}, SHIFT(2180),
  [4824] = {.count = 1, .reusable = true}, SHIFT(2181),
  [4826] = {.count = 1, .reusable = true}, SHIFT(2182),
  [4828] = {.count = 1, .reusable = true}, SHIFT(2183),
  [4830] = {.count = 1, .reusable = false}, SHIFT(2184),
  [4832] = {.count = 1, .reusable = true}, SHIFT(2184),
  [4834] = {.count = 1, .reusable = false}, SHIFT(2189),
  [4836] = {.count = 1, .reusable = true}, SHIFT(2190),
  [4838] = {.count = 1, .reusable = true}, SHIFT(2192),
  [4840] = {.count = 1, .reusable = false}, SHIFT(2194),
  [4842] = {.count = 1, .reusable = false}, SHIFT(2195),
  [4844] = {.count = 1, .reusable = true}, SHIFT(2197),
  [4846] = {.count = 1, .reusable = true}, SHIFT(2198),
  [4848] = {.count = 1, .reusable = false}, SHIFT(2199),
  [4850] = {.count = 1, .reusable = true}, SHIFT(2199),
  [4852] = {.count = 1, .reusable = true}, SHIFT(2200),
  [4854] = {.count = 1, .reusable = true}, SHIFT(2201),
  [4856] = {.count = 1, .reusable = true}, SHIFT(2202),
  [4858] = {.count = 1, .reusable = false}, SHIFT(2203),
  [4860] = {.count = 1, .reusable = true}, SHIFT(2203),
  [4862] = {.count = 1, .reusable = false}, SHIFT(2208),
  [4864] = {.count = 1, .reusable = true}, SHIFT(2209),
  [4866] = {.count = 1, .reusable = true}, SHIFT(2211),
  [4868] = {.count = 1, .reusable = false}, SHIFT(2213),
  [4870] = {.count = 1, .reusable = false}, SHIFT(2214),
  [4872] = {.count = 1, .reusable = true}, SHIFT(2215),
  [4874] = {.count = 1, .reusable = true}, SHIFT(2216),
  [4876] = {.count = 1, .reusable = true}, SHIFT(2217),
  [4878] = {.count = 1, .reusable = false}, SHIFT(2218),
  [4880] = {.count = 1, .reusable = true}, SHIFT(2218),
  [4882] = {.count = 1, .reusable = true}, SHIFT(2219),
  [4884] = {.count = 1, .reusable = false}, SHIFT(2221),
  [4886] = {.count = 1, .reusable = true}, SHIFT(2221),
  [4888] = {.count = 1, .reusable = true}, SHIFT(2220),
  [4890] = {.count = 1, .reusable = true}, SHIFT(2222),
  [4892] = {.count = 1, .reusable = false}, SHIFT(2224),
  [4894] = {.count = 1, .reusable = true}, SHIFT(2224),
  [4896] = {.count = 1, .reusable = true}, SHIFT(2223),
  [4898] = {.count = 1, .reusable = true}, SHIFT(2225),
  [4900] = {.count = 1, .reusable = true}, SHIFT(2226),
  [4902] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 3),
  [4904] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 3),
  [4906] = {.count = 1, .reusable = false}, SHIFT(2227),
  [4908] = {.count = 1, .reusable = true}, SHIFT(2227),
  [4910] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 2),
  [4912] = {.count = 1, .reusable = true}, SHIFT(2232),
  [4914] = {.count = 1, .reusable = true}, SHIFT(2233),
  [4916] = {.count = 1, .reusable = false}, SHIFT(2234),
  [4918] = {.count = 1, .reusable = true}, SHIFT(2235),
  [4920] = {.count = 1, .reusable = true}, SHIFT(2236),
  [4922] = {.count = 1, .reusable = true}, SHIFT(2237),
  [4924] = {.count = 1, .reusable = true}, SHIFT(2238),
  [4926] = {.count = 1, .reusable = true}, SHIFT(2239),
  [4928] = {.count = 1, .reusable = true}, SHIFT(2241),
  [4930] = {.count = 1, .reusable = false}, SHIFT(2243),
  [4932] = {.count = 1, .reusable = true}, SHIFT(2243),
  [4934] = {.count = 1, .reusable = true}, SHIFT(2245),
  [4936] = {.count = 1, .reusable = true}, SHIFT(2246),
  [4938] = {.count = 1, .reusable = false}, SHIFT(2249),
  [4940] = {.count = 1, .reusable = true}, SHIFT(2249),
  [4942] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1596),
  [4945] = {.count = 1, .reusable = true}, SHIFT(2253),
  [4947] = {.count = 1, .reusable = true}, SHIFT(2254),
  [4949] = {.count = 1, .reusable = true}, SHIFT(2255),
  [4951] = {.count = 1, .reusable = true}, SHIFT(2256),
  [4953] = {.count = 1, .reusable = false}, SHIFT(2257),
  [4955] = {.count = 1, .reusable = true}, SHIFT(2258),
  [4957] = {.count = 1, .reusable = true}, SHIFT(2259),
  [4959] = {.count = 1, .reusable = true}, SHIFT(2260),
  [4961] = {.count = 1, .reusable = true}, SHIFT(2261),
  [4963] = {.count = 1, .reusable = true}, SHIFT(2262),
  [4965] = {.count = 1, .reusable = true}, SHIFT(2264),
  [4967] = {.count = 1, .reusable = true}, SHIFT(2265),
  [4969] = {.count = 1, .reusable = true}, SHIFT(2266),
  [4971] = {.count = 1, .reusable = true}, SHIFT(2267),
  [4973] = {.count = 1, .reusable = true}, SHIFT(2268),
  [4975] = {.count = 1, .reusable = false}, SHIFT(2269),
  [4977] = {.count = 1, .reusable = true}, SHIFT(2270),
  [4979] = {.count = 1, .reusable = true}, SHIFT(2271),
  [4981] = {.count = 1, .reusable = true}, SHIFT(2272),
  [4983] = {.count = 1, .reusable = true}, SHIFT(2273),
  [4985] = {.count = 1, .reusable = true}, SHIFT(2274),
  [4987] = {.count = 1, .reusable = false}, SHIFT(2276),
  [4989] = {.count = 1, .reusable = false}, SHIFT(2270),
  [4991] = {.count = 1, .reusable = true}, SHIFT(2278),
  [4993] = {.count = 1, .reusable = true}, SHIFT(2279),
  [4995] = {.count = 1, .reusable = false}, SHIFT(2280),
  [4997] = {.count = 1, .reusable = true}, SHIFT(2281),
  [4999] = {.count = 1, .reusable = true}, SHIFT(2282),
  [5001] = {.count = 1, .reusable = true}, SHIFT(2283),
  [5003] = {.count = 1, .reusable = true}, SHIFT(2284),
  [5005] = {.count = 1, .reusable = true}, SHIFT(2285),
  [5007] = {.count = 1, .reusable = false}, SHIFT(2286),
  [5009] = {.count = 1, .reusable = false}, SHIFT(2281),
  [5011] = {.count = 1, .reusable = true}, SHIFT(2288),
  [5013] = {.count = 1, .reusable = false}, SHIFT(2290),
  [5015] = {.count = 1, .reusable = false}, SHIFT(2291),
  [5017] = {.count = 1, .reusable = true}, SHIFT(2293),
  [5019] = {.count = 1, .reusable = true}, SHIFT(2294),
  [5021] = {.count = 1, .reusable = false}, SHIFT(2295),
  [5023] = {.count = 1, .reusable = true}, SHIFT(2295),
  [5025] = {.count = 1, .reusable = true}, SHIFT(2296),
  [5027] = {.count = 1, .reusable = true}, SHIFT(2297),
  [5029] = {.count = 1, .reusable = true}, SHIFT(2298),
  [5031] = {.count = 1, .reusable = false}, SHIFT(2299),
  [5033] = {.count = 1, .reusable = true}, SHIFT(2299),
  [5035] = {.count = 1, .reusable = true}, REDUCE(sym_else_clause, 2),
  [5037] = {.count = 1, .reusable = true}, SHIFT(2304),
  [5039] = {.count = 1, .reusable = false}, SHIFT(2305),
  [5041] = {.count = 1, .reusable = false}, SHIFT(2306),
  [5043] = {.count = 1, .reusable = true}, SHIFT(2305),
  [5045] = {.count = 1, .reusable = true}, SHIFT(2306),
  [5047] = {.count = 1, .reusable = true}, SHIFT(2307),
  [5049] = {.count = 1, .reusable = false}, SHIFT(2308),
  [5051] = {.count = 1, .reusable = true}, SHIFT(2308),
  [5053] = {.count = 1, .reusable = true}, SHIFT(2309),
  [5055] = {.count = 1, .reusable = false}, SHIFT(2312),
  [5057] = {.count = 1, .reusable = true}, SHIFT(1609),
  [5059] = {.count = 1, .reusable = true}, SHIFT(2313),
  [5061] = {.count = 1, .reusable = false}, SHIFT(2313),
  [5063] = {.count = 1, .reusable = true}, SHIFT(2319),
  [5065] = {.count = 1, .reusable = true}, SHIFT(2321),
  [5067] = {.count = 1, .reusable = true}, SHIFT(2322),
  [5069] = {.count = 1, .reusable = false}, SHIFT(2324),
  [5071] = {.count = 1, .reusable = false}, SHIFT(2325),
  [5073] = {.count = 1, .reusable = true}, SHIFT(2327),
  [5075] = {.count = 1, .reusable = true}, SHIFT(2328),
  [5077] = {.count = 1, .reusable = false}, SHIFT(2329),
  [5079] = {.count = 1, .reusable = true}, SHIFT(2329),
  [5081] = {.count = 1, .reusable = true}, SHIFT(2330),
  [5083] = {.count = 1, .reusable = true}, SHIFT(2331),
  [5085] = {.count = 1, .reusable = true}, SHIFT(2332),
  [5087] = {.count = 1, .reusable = false}, SHIFT(2333),
  [5089] = {.count = 1, .reusable = true}, SHIFT(2333),
  [5091] = {.count = 1, .reusable = false}, SHIFT(2338),
  [5093] = {.count = 1, .reusable = true}, SHIFT(2339),
  [5095] = {.count = 1, .reusable = true}, SHIFT(2341),
  [5097] = {.count = 1, .reusable = false}, SHIFT(2343),
  [5099] = {.count = 1, .reusable = false}, SHIFT(2344),
  [5101] = {.count = 1, .reusable = true}, SHIFT(2346),
  [5103] = {.count = 1, .reusable = true}, SHIFT(2347),
  [5105] = {.count = 1, .reusable = false}, SHIFT(2348),
  [5107] = {.count = 1, .reusable = true}, SHIFT(2348),
  [5109] = {.count = 1, .reusable = true}, SHIFT(2349),
  [5111] = {.count = 1, .reusable = true}, SHIFT(2350),
  [5113] = {.count = 1, .reusable = true}, SHIFT(2351),
  [5115] = {.count = 1, .reusable = false}, SHIFT(2352),
  [5117] = {.count = 1, .reusable = true}, SHIFT(2352),
  [5119] = {.count = 1, .reusable = false}, SHIFT(2357),
  [5121] = {.count = 1, .reusable = true}, SHIFT(2358),
  [5123] = {.count = 1, .reusable = true}, SHIFT(2360),
  [5125] = {.count = 1, .reusable = false}, SHIFT(2362),
  [5127] = {.count = 1, .reusable = false}, SHIFT(2363),
  [5129] = {.count = 1, .reusable = true}, SHIFT(2364),
  [5131] = {.count = 1, .reusable = true}, SHIFT(2365),
  [5133] = {.count = 1, .reusable = true}, SHIFT(2366),
  [5135] = {.count = 1, .reusable = false}, SHIFT(2367),
  [5137] = {.count = 1, .reusable = true}, SHIFT(2367),
  [5139] = {.count = 1, .reusable = true}, SHIFT(2368),
  [5141] = {.count = 1, .reusable = false}, SHIFT(2370),
  [5143] = {.count = 1, .reusable = true}, SHIFT(2370),
  [5145] = {.count = 1, .reusable = true}, SHIFT(2369),
  [5147] = {.count = 1, .reusable = true}, SHIFT(2371),
  [5149] = {.count = 1, .reusable = false}, SHIFT(2373),
  [5151] = {.count = 1, .reusable = true}, SHIFT(2373),
  [5153] = {.count = 1, .reusable = true}, SHIFT(2372),
  [5155] = {.count = 1, .reusable = true}, SHIFT(2374),
  [5157] = {.count = 1, .reusable = true}, SHIFT(2375),
  [5159] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [5161] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [5163] = {.count = 1, .reusable = true}, SHIFT(2376),
  [5165] = {.count = 1, .reusable = false}, SHIFT(2378),
  [5167] = {.count = 1, .reusable = true}, SHIFT(2378),
  [5169] = {.count = 1, .reusable = true}, SHIFT(2383),
  [5171] = {.count = 1, .reusable = true}, SHIFT(2384),
  [5173] = {.count = 1, .reusable = true}, SHIFT(2386),
  [5175] = {.count = 1, .reusable = false}, SHIFT(2388),
  [5177] = {.count = 1, .reusable = true}, SHIFT(2388),
  [5179] = {.count = 1, .reusable = true}, SHIFT(2390),
  [5181] = {.count = 1, .reusable = true}, SHIFT(2391),
  [5183] = {.count = 1, .reusable = false}, SHIFT(2394),
  [5185] = {.count = 1, .reusable = true}, SHIFT(2394),
  [5187] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [5189] = {.count = 2, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(960),
  [5192] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1684),
  [5195] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5),
  [5197] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5),
  [5199] = {.count = 1, .reusable = true}, SHIFT(2398),
  [5201] = {.count = 1, .reusable = true}, SHIFT(2399),
  [5203] = {.count = 1, .reusable = true}, SHIFT(2401),
  [5205] = {.count = 1, .reusable = true}, SHIFT(2404),
  [5207] = {.count = 1, .reusable = false}, SHIFT(2401),
  [5209] = {.count = 1, .reusable = true}, SHIFT(2408),
  [5211] = {.count = 1, .reusable = true}, SHIFT(2409),
  [5213] = {.count = 1, .reusable = true}, SHIFT(2410),
  [5215] = {.count = 1, .reusable = true}, SHIFT(2413),
  [5217] = {.count = 1, .reusable = true}, SHIFT(2414),
  [5219] = {.count = 1, .reusable = false}, SHIFT(2415),
  [5221] = {.count = 1, .reusable = true}, SHIFT(2415),
  [5223] = {.count = 1, .reusable = true}, SHIFT(2416),
  [5225] = {.count = 1, .reusable = false}, SHIFT(2417),
  [5227] = {.count = 1, .reusable = true}, SHIFT(2417),
  [5229] = {.count = 1, .reusable = true}, SHIFT(2418),
  [5231] = {.count = 1, .reusable = false}, SHIFT(2419),
  [5233] = {.count = 1, .reusable = true}, SHIFT(2419),
  [5235] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 2),
  [5237] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 2),
  [5239] = {.count = 1, .reusable = true}, SHIFT(2420),
  [5241] = {.count = 1, .reusable = false}, SHIFT(2420),
  [5243] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 5),
  [5245] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 5),
  [5247] = {.count = 1, .reusable = true}, SHIFT(2425),
  [5249] = {.count = 1, .reusable = true}, SHIFT(2426),
  [5251] = {.count = 1, .reusable = false}, SHIFT(2428),
  [5253] = {.count = 1, .reusable = false}, SHIFT(2429),
  [5255] = {.count = 1, .reusable = true}, SHIFT(2430),
  [5257] = {.count = 1, .reusable = true}, SHIFT(2431),
  [5259] = {.count = 1, .reusable = true}, SHIFT(2432),
  [5261] = {.count = 1, .reusable = false}, SHIFT(2433),
  [5263] = {.count = 1, .reusable = true}, SHIFT(2433),
  [5265] = {.count = 1, .reusable = true}, SHIFT(2434),
  [5267] = {.count = 1, .reusable = false}, SHIFT(2436),
  [5269] = {.count = 1, .reusable = true}, SHIFT(2436),
  [5271] = {.count = 1, .reusable = true}, SHIFT(2435),
  [5273] = {.count = 1, .reusable = true}, SHIFT(2437),
  [5275] = {.count = 1, .reusable = false}, SHIFT(2439),
  [5277] = {.count = 1, .reusable = true}, SHIFT(2439),
  [5279] = {.count = 1, .reusable = true}, SHIFT(2438),
  [5281] = {.count = 1, .reusable = true}, SHIFT(2440),
  [5283] = {.count = 1, .reusable = true}, SHIFT(2441),
  [5285] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1742),
  [5288] = {.count = 1, .reusable = true}, SHIFT(2442),
  [5290] = {.count = 1, .reusable = false}, SHIFT(2444),
  [5292] = {.count = 1, .reusable = true}, SHIFT(2444),
  [5294] = {.count = 1, .reusable = false}, SHIFT(2446),
  [5296] = {.count = 1, .reusable = true}, SHIFT(2446),
  [5298] = {.count = 1, .reusable = true}, SHIFT(2447),
  [5300] = {.count = 1, .reusable = true}, SHIFT(2448),
  [5302] = {.count = 1, .reusable = false}, SHIFT(2451),
  [5304] = {.count = 1, .reusable = false}, SHIFT(2454),
  [5306] = {.count = 1, .reusable = true}, SHIFT(2454),
  [5308] = {.count = 1, .reusable = false}, SHIFT(2455),
  [5310] = {.count = 1, .reusable = false}, SHIFT(2458),
  [5312] = {.count = 1, .reusable = true}, SHIFT(2458),
  [5314] = {.count = 1, .reusable = true}, SHIFT(2460),
  [5316] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1060),
  [5319] = {.count = 1, .reusable = false}, SHIFT(2462),
  [5321] = {.count = 1, .reusable = true}, SHIFT(2463),
  [5323] = {.count = 1, .reusable = true}, SHIFT(2464),
  [5325] = {.count = 1, .reusable = true}, SHIFT(2467),
  [5327] = {.count = 1, .reusable = true}, SHIFT(2468),
  [5329] = {.count = 1, .reusable = false}, SHIFT(2470),
  [5331] = {.count = 1, .reusable = true}, SHIFT(2470),
  [5333] = {.count = 1, .reusable = true}, SHIFT(2469),
  [5335] = {.count = 1, .reusable = false}, SHIFT(2472),
  [5337] = {.count = 1, .reusable = true}, SHIFT(2472),
  [5339] = {.count = 1, .reusable = true}, SHIFT(2471),
  [5341] = {.count = 1, .reusable = true}, SHIFT(2473),
  [5343] = {.count = 1, .reusable = true}, SHIFT(2474),
  [5345] = {.count = 1, .reusable = false}, SHIFT(2475),
  [5347] = {.count = 1, .reusable = true}, SHIFT(2475),
  [5349] = {.count = 1, .reusable = true}, SHIFT(2476),
  [5351] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1079),
  [5354] = {.count = 1, .reusable = false}, SHIFT(2477),
  [5356] = {.count = 1, .reusable = true}, SHIFT(2478),
  [5358] = {.count = 1, .reusable = true}, SHIFT(2479),
  [5360] = {.count = 1, .reusable = true}, SHIFT(2482),
  [5362] = {.count = 1, .reusable = true}, SHIFT(2483),
  [5364] = {.count = 1, .reusable = false}, SHIFT(2485),
  [5366] = {.count = 1, .reusable = true}, SHIFT(2485),
  [5368] = {.count = 1, .reusable = true}, SHIFT(2484),
  [5370] = {.count = 1, .reusable = false}, SHIFT(2487),
  [5372] = {.count = 1, .reusable = true}, SHIFT(2487),
  [5374] = {.count = 1, .reusable = true}, SHIFT(2486),
  [5376] = {.count = 1, .reusable = true}, SHIFT(2488),
  [5378] = {.count = 1, .reusable = true}, SHIFT(2489),
  [5380] = {.count = 1, .reusable = false}, SHIFT(2490),
  [5382] = {.count = 1, .reusable = true}, SHIFT(2490),
  [5384] = {.count = 1, .reusable = true}, SHIFT(2491),
  [5386] = {.count = 1, .reusable = true}, SHIFT(2492),
  [5388] = {.count = 1, .reusable = true}, SHIFT(2493),
  [5390] = {.count = 1, .reusable = true}, SHIFT(2494),
  [5392] = {.count = 1, .reusable = true}, SHIFT(2497),
  [5394] = {.count = 1, .reusable = true}, SHIFT(2498),
  [5396] = {.count = 1, .reusable = false}, SHIFT(2499),
  [5398] = {.count = 1, .reusable = true}, SHIFT(2499),
  [5400] = {.count = 1, .reusable = true}, SHIFT(2500),
  [5402] = {.count = 1, .reusable = false}, SHIFT(2501),
  [5404] = {.count = 1, .reusable = true}, SHIFT(2501),
  [5406] = {.count = 1, .reusable = true}, SHIFT(2502),
  [5408] = {.count = 1, .reusable = false}, SHIFT(2503),
  [5410] = {.count = 1, .reusable = true}, SHIFT(2503),
  [5412] = {.count = 1, .reusable = true}, SHIFT(2505),
  [5414] = {.count = 1, .reusable = true}, SHIFT(2506),
  [5416] = {.count = 1, .reusable = true}, SHIFT(2507),
  [5418] = {.count = 1, .reusable = true}, SHIFT(2508),
  [5420] = {.count = 1, .reusable = true}, SHIFT(2511),
  [5422] = {.count = 1, .reusable = true}, SHIFT(2512),
  [5424] = {.count = 1, .reusable = false}, SHIFT(2513),
  [5426] = {.count = 1, .reusable = true}, SHIFT(2513),
  [5428] = {.count = 1, .reusable = true}, SHIFT(2514),
  [5430] = {.count = 1, .reusable = false}, SHIFT(2515),
  [5432] = {.count = 1, .reusable = true}, SHIFT(2515),
  [5434] = {.count = 1, .reusable = true}, SHIFT(2516),
  [5436] = {.count = 1, .reusable = false}, SHIFT(2517),
  [5438] = {.count = 1, .reusable = true}, SHIFT(2517),
  [5440] = {.count = 1, .reusable = true}, SHIFT(2518),
  [5442] = {.count = 1, .reusable = true}, SHIFT(2519),
  [5444] = {.count = 1, .reusable = true}, SHIFT(2520),
  [5446] = {.count = 1, .reusable = true}, SHIFT(2521),
  [5448] = {.count = 1, .reusable = true}, SHIFT(2524),
  [5450] = {.count = 1, .reusable = true}, SHIFT(2525),
  [5452] = {.count = 1, .reusable = false}, SHIFT(2526),
  [5454] = {.count = 1, .reusable = true}, SHIFT(2526),
  [5456] = {.count = 1, .reusable = true}, SHIFT(2527),
  [5458] = {.count = 1, .reusable = false}, SHIFT(2528),
  [5460] = {.count = 1, .reusable = true}, SHIFT(2528),
  [5462] = {.count = 1, .reusable = true}, SHIFT(2529),
  [5464] = {.count = 1, .reusable = false}, SHIFT(2530),
  [5466] = {.count = 1, .reusable = true}, SHIFT(2530),
  [5468] = {.count = 1, .reusable = true}, SHIFT(2531),
  [5470] = {.count = 1, .reusable = true}, SHIFT(2532),
  [5472] = {.count = 1, .reusable = true}, SHIFT(2533),
  [5474] = {.count = 1, .reusable = true}, SHIFT(2536),
  [5476] = {.count = 1, .reusable = true}, SHIFT(2537),
  [5478] = {.count = 1, .reusable = false}, SHIFT(2538),
  [5480] = {.count = 1, .reusable = true}, SHIFT(2538),
  [5482] = {.count = 1, .reusable = true}, SHIFT(2539),
  [5484] = {.count = 1, .reusable = false}, SHIFT(2540),
  [5486] = {.count = 1, .reusable = true}, SHIFT(2540),
  [5488] = {.count = 1, .reusable = true}, SHIFT(2541),
  [5490] = {.count = 1, .reusable = false}, SHIFT(2542),
  [5492] = {.count = 1, .reusable = true}, SHIFT(2542),
  [5494] = {.count = 1, .reusable = true}, SHIFT(2543),
  [5496] = {.count = 1, .reusable = true}, SHIFT(2544),
  [5498] = {.count = 1, .reusable = true}, SHIFT(2545),
  [5500] = {.count = 1, .reusable = true}, SHIFT(2548),
  [5502] = {.count = 1, .reusable = true}, SHIFT(2549),
  [5504] = {.count = 1, .reusable = false}, SHIFT(2550),
  [5506] = {.count = 1, .reusable = true}, SHIFT(2550),
  [5508] = {.count = 1, .reusable = true}, SHIFT(2551),
  [5510] = {.count = 1, .reusable = false}, SHIFT(2552),
  [5512] = {.count = 1, .reusable = true}, SHIFT(2552),
  [5514] = {.count = 1, .reusable = true}, SHIFT(2553),
  [5516] = {.count = 1, .reusable = false}, SHIFT(2554),
  [5518] = {.count = 1, .reusable = true}, SHIFT(2554),
  [5520] = {.count = 1, .reusable = true}, SHIFT(2555),
  [5522] = {.count = 1, .reusable = true}, SHIFT(2556),
  [5524] = {.count = 1, .reusable = true}, SHIFT(2557),
  [5526] = {.count = 1, .reusable = true}, SHIFT(2560),
  [5528] = {.count = 1, .reusable = true}, SHIFT(2561),
  [5530] = {.count = 1, .reusable = false}, SHIFT(2562),
  [5532] = {.count = 1, .reusable = true}, SHIFT(2562),
  [5534] = {.count = 1, .reusable = true}, SHIFT(2563),
  [5536] = {.count = 1, .reusable = false}, SHIFT(2564),
  [5538] = {.count = 1, .reusable = true}, SHIFT(2564),
  [5540] = {.count = 1, .reusable = true}, SHIFT(2565),
  [5542] = {.count = 1, .reusable = false}, SHIFT(2566),
  [5544] = {.count = 1, .reusable = true}, SHIFT(2566),
  [5546] = {.count = 1, .reusable = true}, SHIFT(2567),
  [5548] = {.count = 1, .reusable = true}, SHIFT(2568),
  [5550] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4),
  [5552] = {.count = 1, .reusable = true}, SHIFT(2569),
  [5554] = {.count = 1, .reusable = true}, SHIFT(2570),
  [5556] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4, .alias_sequence_id = 4),
  [5558] = {.count = 1, .reusable = true}, SHIFT(2571),
  [5560] = {.count = 1, .reusable = false}, SHIFT(2573),
  [5562] = {.count = 1, .reusable = false}, SHIFT(2574),
  [5564] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5),
  [5566] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5),
  [5568] = {.count = 1, .reusable = true}, SHIFT(2575),
  [5570] = {.count = 1, .reusable = true}, SHIFT(2576),
  [5572] = {.count = 1, .reusable = true}, SHIFT(2577),
  [5574] = {.count = 1, .reusable = false}, SHIFT(2578),
  [5576] = {.count = 1, .reusable = true}, SHIFT(2578),
  [5578] = {.count = 1, .reusable = true}, SHIFT(2579),
  [5580] = {.count = 1, .reusable = false}, SHIFT(2581),
  [5582] = {.count = 1, .reusable = true}, SHIFT(2581),
  [5584] = {.count = 1, .reusable = true}, SHIFT(2580),
  [5586] = {.count = 1, .reusable = true}, SHIFT(2582),
  [5588] = {.count = 1, .reusable = false}, SHIFT(2584),
  [5590] = {.count = 1, .reusable = true}, SHIFT(2584),
  [5592] = {.count = 1, .reusable = true}, SHIFT(2583),
  [5594] = {.count = 1, .reusable = true}, SHIFT(2585),
  [5596] = {.count = 1, .reusable = true}, SHIFT(2586),
  [5598] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 6),
  [5600] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 6),
  [5602] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1920),
  [5605] = {.count = 1, .reusable = true}, SHIFT(2587),
  [5607] = {.count = 1, .reusable = true}, SHIFT(2588),
  [5609] = {.count = 1, .reusable = true}, SHIFT(2589),
  [5611] = {.count = 1, .reusable = false}, SHIFT(2590),
  [5613] = {.count = 1, .reusable = true}, SHIFT(2590),
  [5615] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 5),
  [5617] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 5),
  [5619] = {.count = 1, .reusable = false}, SHIFT(2591),
  [5621] = {.count = 1, .reusable = true}, SHIFT(2591),
  [5623] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1249),
  [5626] = {.count = 1, .reusable = false}, SHIFT(2592),
  [5628] = {.count = 1, .reusable = true}, SHIFT(2593),
  [5630] = {.count = 1, .reusable = true}, SHIFT(2594),
  [5632] = {.count = 1, .reusable = true}, SHIFT(2597),
  [5634] = {.count = 1, .reusable = true}, SHIFT(2598),
  [5636] = {.count = 1, .reusable = false}, SHIFT(2600),
  [5638] = {.count = 1, .reusable = true}, SHIFT(2600),
  [5640] = {.count = 1, .reusable = true}, SHIFT(2599),
  [5642] = {.count = 1, .reusable = false}, SHIFT(2602),
  [5644] = {.count = 1, .reusable = true}, SHIFT(2602),
  [5646] = {.count = 1, .reusable = true}, SHIFT(2601),
  [5648] = {.count = 1, .reusable = true}, SHIFT(2603),
  [5650] = {.count = 1, .reusable = true}, SHIFT(2604),
  [5652] = {.count = 1, .reusable = false}, SHIFT(2605),
  [5654] = {.count = 1, .reusable = true}, SHIFT(2605),
  [5656] = {.count = 1, .reusable = true}, SHIFT(2606),
  [5658] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 3),
  [5660] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 3),
  [5662] = {.count = 1, .reusable = true}, SHIFT(2607),
  [5664] = {.count = 1, .reusable = true}, SHIFT(2610),
  [5666] = {.count = 1, .reusable = true}, SHIFT(2611),
  [5668] = {.count = 1, .reusable = true}, SHIFT(2614),
  [5670] = {.count = 1, .reusable = true}, SHIFT(2615),
  [5672] = {.count = 1, .reusable = false}, SHIFT(2617),
  [5674] = {.count = 1, .reusable = true}, SHIFT(2617),
  [5676] = {.count = 1, .reusable = true}, SHIFT(2616),
  [5678] = {.count = 1, .reusable = false}, SHIFT(2619),
  [5680] = {.count = 1, .reusable = true}, SHIFT(2619),
  [5682] = {.count = 1, .reusable = true}, SHIFT(2618),
  [5684] = {.count = 1, .reusable = true}, SHIFT(2620),
  [5686] = {.count = 1, .reusable = true}, SHIFT(2621),
  [5688] = {.count = 1, .reusable = false}, SHIFT(2622),
  [5690] = {.count = 1, .reusable = true}, SHIFT(2622),
  [5692] = {.count = 1, .reusable = true}, SHIFT(2623),
  [5694] = {.count = 1, .reusable = true}, SHIFT(2624),
  [5696] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1325),
  [5699] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1329),
  [5702] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1329),
  [5705] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1330),
  [5708] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6),
  [5710] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6, .alias_sequence_id = 4),
  [5712] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1340),
  [5715] = {.count = 1, .reusable = false}, SHIFT(2628),
  [5717] = {.count = 1, .reusable = true}, SHIFT(2629),
  [5719] = {.count = 1, .reusable = true}, SHIFT(2630),
  [5721] = {.count = 1, .reusable = true}, SHIFT(2633),
  [5723] = {.count = 1, .reusable = true}, SHIFT(2634),
  [5725] = {.count = 1, .reusable = false}, SHIFT(2636),
  [5727] = {.count = 1, .reusable = true}, SHIFT(2636),
  [5729] = {.count = 1, .reusable = true}, SHIFT(2635),
  [5731] = {.count = 1, .reusable = false}, SHIFT(2638),
  [5733] = {.count = 1, .reusable = true}, SHIFT(2638),
  [5735] = {.count = 1, .reusable = true}, SHIFT(2637),
  [5737] = {.count = 1, .reusable = true}, SHIFT(2639),
  [5739] = {.count = 1, .reusable = true}, SHIFT(2640),
  [5741] = {.count = 1, .reusable = false}, SHIFT(2641),
  [5743] = {.count = 1, .reusable = true}, SHIFT(2641),
  [5745] = {.count = 1, .reusable = true}, SHIFT(2642),
  [5747] = {.count = 1, .reusable = true}, SHIFT(2643),
  [5749] = {.count = 1, .reusable = true}, SHIFT(2644),
  [5751] = {.count = 1, .reusable = true}, SHIFT(2645),
  [5753] = {.count = 1, .reusable = true}, SHIFT(2648),
  [5755] = {.count = 1, .reusable = true}, SHIFT(2649),
  [5757] = {.count = 1, .reusable = false}, SHIFT(2650),
  [5759] = {.count = 1, .reusable = true}, SHIFT(2650),
  [5761] = {.count = 1, .reusable = true}, SHIFT(2651),
  [5763] = {.count = 1, .reusable = false}, SHIFT(2652),
  [5765] = {.count = 1, .reusable = true}, SHIFT(2652),
  [5767] = {.count = 1, .reusable = true}, SHIFT(2653),
  [5769] = {.count = 1, .reusable = false}, SHIFT(2654),
  [5771] = {.count = 1, .reusable = true}, SHIFT(2654),
  [5773] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 6),
  [5775] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 6),
  [5777] = {.count = 1, .reusable = true}, SHIFT(2656),
  [5779] = {.count = 1, .reusable = true}, SHIFT(2657),
  [5781] = {.count = 1, .reusable = true}, SHIFT(2658),
  [5783] = {.count = 1, .reusable = true}, SHIFT(2659),
  [5785] = {.count = 1, .reusable = true}, SHIFT(2660),
  [5787] = {.count = 1, .reusable = true}, SHIFT(2663),
  [5789] = {.count = 1, .reusable = true}, SHIFT(2664),
  [5791] = {.count = 1, .reusable = false}, SHIFT(2665),
  [5793] = {.count = 1, .reusable = true}, SHIFT(2665),
  [5795] = {.count = 1, .reusable = true}, SHIFT(2666),
  [5797] = {.count = 1, .reusable = false}, SHIFT(2667),
  [5799] = {.count = 1, .reusable = true}, SHIFT(2667),
  [5801] = {.count = 1, .reusable = true}, SHIFT(2668),
  [5803] = {.count = 1, .reusable = false}, SHIFT(2669),
  [5805] = {.count = 1, .reusable = true}, SHIFT(2669),
  [5807] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1399),
  [5810] = {.count = 1, .reusable = false}, SHIFT(2671),
  [5812] = {.count = 1, .reusable = true}, SHIFT(2672),
  [5814] = {.count = 1, .reusable = true}, SHIFT(2673),
  [5816] = {.count = 1, .reusable = true}, SHIFT(2676),
  [5818] = {.count = 1, .reusable = true}, SHIFT(2677),
  [5820] = {.count = 1, .reusable = false}, SHIFT(2679),
  [5822] = {.count = 1, .reusable = true}, SHIFT(2679),
  [5824] = {.count = 1, .reusable = true}, SHIFT(2678),
  [5826] = {.count = 1, .reusable = false}, SHIFT(2681),
  [5828] = {.count = 1, .reusable = true}, SHIFT(2681),
  [5830] = {.count = 1, .reusable = true}, SHIFT(2680),
  [5832] = {.count = 1, .reusable = true}, SHIFT(2682),
  [5834] = {.count = 1, .reusable = true}, SHIFT(2683),
  [5836] = {.count = 1, .reusable = false}, SHIFT(2684),
  [5838] = {.count = 1, .reusable = true}, SHIFT(2684),
  [5840] = {.count = 1, .reusable = true}, SHIFT(2685),
  [5842] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6),
  [5844] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6),
  [5846] = {.count = 1, .reusable = true}, SHIFT(2686),
  [5848] = {.count = 1, .reusable = true}, SHIFT(2687),
  [5850] = {.count = 1, .reusable = true}, SHIFT(2688),
  [5852] = {.count = 1, .reusable = true}, SHIFT(2691),
  [5854] = {.count = 1, .reusable = true}, SHIFT(2692),
  [5856] = {.count = 1, .reusable = false}, SHIFT(2693),
  [5858] = {.count = 1, .reusable = true}, SHIFT(2693),
  [5860] = {.count = 1, .reusable = true}, SHIFT(2694),
  [5862] = {.count = 1, .reusable = false}, SHIFT(2695),
  [5864] = {.count = 1, .reusable = true}, SHIFT(2695),
  [5866] = {.count = 1, .reusable = true}, SHIFT(2696),
  [5868] = {.count = 1, .reusable = false}, SHIFT(2697),
  [5870] = {.count = 1, .reusable = true}, SHIFT(2697),
  [5872] = {.count = 1, .reusable = true}, SHIFT(2698),
  [5874] = {.count = 1, .reusable = true}, SHIFT(2699),
  [5876] = {.count = 1, .reusable = true}, SHIFT(2700),
  [5878] = {.count = 1, .reusable = false}, SHIFT(2701),
  [5880] = {.count = 1, .reusable = true}, SHIFT(2701),
  [5882] = {.count = 1, .reusable = false}, SHIFT(2702),
  [5884] = {.count = 1, .reusable = true}, SHIFT(2702),
  [5886] = {.count = 1, .reusable = true}, SHIFT(2703),
  [5888] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1455),
  [5891] = {.count = 1, .reusable = false}, SHIFT(2704),
  [5893] = {.count = 1, .reusable = true}, SHIFT(2705),
  [5895] = {.count = 1, .reusable = true}, SHIFT(2706),
  [5897] = {.count = 1, .reusable = true}, SHIFT(2709),
  [5899] = {.count = 1, .reusable = true}, SHIFT(2710),
  [5901] = {.count = 1, .reusable = false}, SHIFT(2712),
  [5903] = {.count = 1, .reusable = true}, SHIFT(2712),
  [5905] = {.count = 1, .reusable = true}, SHIFT(2711),
  [5907] = {.count = 1, .reusable = false}, SHIFT(2714),
  [5909] = {.count = 1, .reusable = true}, SHIFT(2714),
  [5911] = {.count = 1, .reusable = true}, SHIFT(2713),
  [5913] = {.count = 1, .reusable = true}, SHIFT(2715),
  [5915] = {.count = 1, .reusable = true}, SHIFT(2716),
  [5917] = {.count = 1, .reusable = false}, SHIFT(2717),
  [5919] = {.count = 1, .reusable = true}, SHIFT(2717),
  [5921] = {.count = 1, .reusable = true}, SHIFT(2718),
  [5923] = {.count = 1, .reusable = true}, SHIFT(2719),
  [5925] = {.count = 1, .reusable = true}, SHIFT(2721),
  [5927] = {.count = 1, .reusable = false}, SHIFT(2723),
  [5929] = {.count = 1, .reusable = true}, SHIFT(2723),
  [5931] = {.count = 1, .reusable = true}, SHIFT(2725),
  [5933] = {.count = 1, .reusable = true}, SHIFT(2727),
  [5935] = {.count = 1, .reusable = false}, SHIFT(2727),
  [5937] = {.count = 1, .reusable = true}, SHIFT(2730),
  [5939] = {.count = 1, .reusable = false}, SHIFT(2730),
  [5941] = {.count = 1, .reusable = true}, SHIFT(2733),
  [5943] = {.count = 1, .reusable = true}, SHIFT(2734),
  [5945] = {.count = 1, .reusable = true}, SHIFT(2735),
  [5947] = {.count = 1, .reusable = true}, SHIFT(2736),
  [5949] = {.count = 1, .reusable = true}, SHIFT(2739),
  [5951] = {.count = 1, .reusable = true}, SHIFT(2740),
  [5953] = {.count = 1, .reusable = false}, SHIFT(2741),
  [5955] = {.count = 1, .reusable = true}, SHIFT(2741),
  [5957] = {.count = 1, .reusable = true}, SHIFT(2742),
  [5959] = {.count = 1, .reusable = false}, SHIFT(2743),
  [5961] = {.count = 1, .reusable = true}, SHIFT(2743),
  [5963] = {.count = 1, .reusable = true}, SHIFT(2744),
  [5965] = {.count = 1, .reusable = false}, SHIFT(2745),
  [5967] = {.count = 1, .reusable = true}, SHIFT(2745),
  [5969] = {.count = 1, .reusable = true}, SHIFT(2746),
  [5971] = {.count = 1, .reusable = true}, SHIFT(2747),
  [5973] = {.count = 1, .reusable = true}, SHIFT(2748),
  [5975] = {.count = 1, .reusable = true}, SHIFT(2751),
  [5977] = {.count = 1, .reusable = true}, SHIFT(2752),
  [5979] = {.count = 1, .reusable = false}, SHIFT(2753),
  [5981] = {.count = 1, .reusable = true}, SHIFT(2753),
  [5983] = {.count = 1, .reusable = true}, SHIFT(2754),
  [5985] = {.count = 1, .reusable = false}, SHIFT(2755),
  [5987] = {.count = 1, .reusable = true}, SHIFT(2755),
  [5989] = {.count = 1, .reusable = true}, SHIFT(2756),
  [5991] = {.count = 1, .reusable = false}, SHIFT(2757),
  [5993] = {.count = 1, .reusable = true}, SHIFT(2757),
  [5995] = {.count = 1, .reusable = true}, SHIFT(2758),
  [5997] = {.count = 1, .reusable = true}, SHIFT(2759),
  [5999] = {.count = 1, .reusable = true}, SHIFT(2760),
  [6001] = {.count = 1, .reusable = false}, SHIFT(2761),
  [6003] = {.count = 1, .reusable = true}, SHIFT(2761),
  [6005] = {.count = 1, .reusable = false}, SHIFT(2762),
  [6007] = {.count = 1, .reusable = true}, SHIFT(2762),
  [6009] = {.count = 1, .reusable = true}, SHIFT(2763),
  [6011] = {.count = 1, .reusable = true}, SHIFT(2764),
  [6013] = {.count = 1, .reusable = true}, SHIFT(2766),
  [6015] = {.count = 1, .reusable = false}, SHIFT(2768),
  [6017] = {.count = 1, .reusable = false}, SHIFT(2769),
  [6019] = {.count = 1, .reusable = true}, SHIFT(2771),
  [6021] = {.count = 1, .reusable = true}, SHIFT(2772),
  [6023] = {.count = 1, .reusable = false}, SHIFT(2773),
  [6025] = {.count = 1, .reusable = true}, SHIFT(2773),
  [6027] = {.count = 1, .reusable = true}, SHIFT(2774),
  [6029] = {.count = 1, .reusable = true}, SHIFT(2775),
  [6031] = {.count = 1, .reusable = true}, SHIFT(2776),
  [6033] = {.count = 1, .reusable = false}, SHIFT(2777),
  [6035] = {.count = 1, .reusable = true}, SHIFT(2777),
  [6037] = {.count = 1, .reusable = true}, SHIFT(2782),
  [6039] = {.count = 1, .reusable = true}, SHIFT(2784),
  [6041] = {.count = 1, .reusable = true}, SHIFT(2785),
  [6043] = {.count = 1, .reusable = true}, SHIFT(2786),
  [6045] = {.count = 1, .reusable = true}, SHIFT(2788),
  [6047] = {.count = 1, .reusable = false}, SHIFT(2790),
  [6049] = {.count = 1, .reusable = false}, SHIFT(2791),
  [6051] = {.count = 1, .reusable = true}, SHIFT(2792),
  [6053] = {.count = 1, .reusable = true}, SHIFT(2793),
  [6055] = {.count = 1, .reusable = true}, SHIFT(2794),
  [6057] = {.count = 1, .reusable = false}, SHIFT(2795),
  [6059] = {.count = 1, .reusable = true}, SHIFT(2795),
  [6061] = {.count = 1, .reusable = true}, SHIFT(2796),
  [6063] = {.count = 1, .reusable = false}, SHIFT(2798),
  [6065] = {.count = 1, .reusable = true}, SHIFT(2798),
  [6067] = {.count = 1, .reusable = true}, SHIFT(2797),
  [6069] = {.count = 1, .reusable = true}, SHIFT(2799),
  [6071] = {.count = 1, .reusable = false}, SHIFT(2801),
  [6073] = {.count = 1, .reusable = true}, SHIFT(2801),
  [6075] = {.count = 1, .reusable = true}, SHIFT(2800),
  [6077] = {.count = 1, .reusable = true}, SHIFT(2802),
  [6079] = {.count = 1, .reusable = true}, SHIFT(2803),
  [6081] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1542),
  [6084] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1543),
  [6087] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1544),
  [6090] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1545),
  [6093] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1546),
  [6096] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1547),
  [6099] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1548),
  [6102] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1549),
  [6105] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1550),
  [6108] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2189),
  [6111] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1546),
  [6114] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2190),
  [6117] = {.count = 1, .reusable = true}, SHIFT(2804),
  [6119] = {.count = 1, .reusable = false}, SHIFT(2806),
  [6121] = {.count = 1, .reusable = false}, SHIFT(2807),
  [6123] = {.count = 1, .reusable = true}, SHIFT(2808),
  [6125] = {.count = 1, .reusable = true}, SHIFT(2809),
  [6127] = {.count = 1, .reusable = true}, SHIFT(2810),
  [6129] = {.count = 1, .reusable = false}, SHIFT(2811),
  [6131] = {.count = 1, .reusable = true}, SHIFT(2811),
  [6133] = {.count = 1, .reusable = true}, SHIFT(2812),
  [6135] = {.count = 1, .reusable = false}, SHIFT(2814),
  [6137] = {.count = 1, .reusable = true}, SHIFT(2814),
  [6139] = {.count = 1, .reusable = true}, SHIFT(2813),
  [6141] = {.count = 1, .reusable = true}, SHIFT(2815),
  [6143] = {.count = 1, .reusable = false}, SHIFT(2817),
  [6145] = {.count = 1, .reusable = true}, SHIFT(2817),
  [6147] = {.count = 1, .reusable = true}, SHIFT(2816),
  [6149] = {.count = 1, .reusable = true}, SHIFT(2818),
  [6151] = {.count = 1, .reusable = true}, SHIFT(2819),
  [6153] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1554),
  [6156] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1555),
  [6159] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1556),
  [6162] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1557),
  [6165] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1558),
  [6168] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1559),
  [6171] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1560),
  [6174] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1561),
  [6177] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2208),
  [6180] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1557),
  [6183] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2209),
  [6186] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1564),
  [6189] = {.count = 1, .reusable = false}, SHIFT(2820),
  [6191] = {.count = 1, .reusable = true}, SHIFT(2821),
  [6193] = {.count = 1, .reusable = true}, SHIFT(2822),
  [6195] = {.count = 1, .reusable = true}, SHIFT(2825),
  [6197] = {.count = 1, .reusable = true}, SHIFT(2826),
  [6199] = {.count = 1, .reusable = false}, SHIFT(2828),
  [6201] = {.count = 1, .reusable = true}, SHIFT(2828),
  [6203] = {.count = 1, .reusable = true}, SHIFT(2827),
  [6205] = {.count = 1, .reusable = false}, SHIFT(2830),
  [6207] = {.count = 1, .reusable = true}, SHIFT(2830),
  [6209] = {.count = 1, .reusable = true}, SHIFT(2829),
  [6211] = {.count = 1, .reusable = true}, SHIFT(2831),
  [6213] = {.count = 1, .reusable = true}, SHIFT(2832),
  [6215] = {.count = 1, .reusable = false}, SHIFT(2833),
  [6217] = {.count = 1, .reusable = true}, SHIFT(2833),
  [6219] = {.count = 1, .reusable = true}, SHIFT(2834),
  [6221] = {.count = 1, .reusable = true}, SHIFT(2835),
  [6223] = {.count = 1, .reusable = true}, SHIFT(2837),
  [6225] = {.count = 1, .reusable = false}, SHIFT(2839),
  [6227] = {.count = 1, .reusable = false}, SHIFT(2840),
  [6229] = {.count = 1, .reusable = true}, SHIFT(2842),
  [6231] = {.count = 1, .reusable = true}, SHIFT(2843),
  [6233] = {.count = 1, .reusable = false}, SHIFT(2844),
  [6235] = {.count = 1, .reusable = true}, SHIFT(2844),
  [6237] = {.count = 1, .reusable = true}, SHIFT(2845),
  [6239] = {.count = 1, .reusable = true}, SHIFT(2846),
  [6241] = {.count = 1, .reusable = true}, SHIFT(2847),
  [6243] = {.count = 1, .reusable = false}, SHIFT(2848),
  [6245] = {.count = 1, .reusable = true}, SHIFT(2848),
  [6247] = {.count = 1, .reusable = true}, SHIFT(2853),
  [6249] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 3),
  [6251] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1581),
  [6254] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1585),
  [6257] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1585),
  [6260] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1586),
  [6263] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1589),
  [6266] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(921),
  [6269] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(922),
  [6272] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(923),
  [6275] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1590),
  [6278] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(925),
  [6281] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(926),
  [6284] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(927),
  [6287] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(928),
  [6290] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1590),
  [6293] = {.count = 1, .reusable = false}, SHIFT(2855),
  [6295] = {.count = 1, .reusable = true}, SHIFT(2855),
  [6297] = {.count = 1, .reusable = true}, SHIFT(2856),
  [6299] = {.count = 1, .reusable = true}, SHIFT(2858),
  [6301] = {.count = 1, .reusable = false}, SHIFT(2860),
  [6303] = {.count = 1, .reusable = false}, SHIFT(2861),
  [6305] = {.count = 1, .reusable = true}, SHIFT(2863),
  [6307] = {.count = 1, .reusable = true}, SHIFT(2864),
  [6309] = {.count = 1, .reusable = false}, SHIFT(2865),
  [6311] = {.count = 1, .reusable = true}, SHIFT(2865),
  [6313] = {.count = 1, .reusable = true}, SHIFT(2866),
  [6315] = {.count = 1, .reusable = true}, SHIFT(2867),
  [6317] = {.count = 1, .reusable = true}, SHIFT(2868),
  [6319] = {.count = 1, .reusable = false}, SHIFT(2869),
  [6321] = {.count = 1, .reusable = true}, SHIFT(2869),
  [6323] = {.count = 1, .reusable = true}, SHIFT(2874),
  [6325] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 3),
  [6327] = {.count = 1, .reusable = true}, SHIFT(2877),
  [6329] = {.count = 1, .reusable = true}, SHIFT(2878),
  [6331] = {.count = 1, .reusable = true}, SHIFT(2879),
  [6333] = {.count = 1, .reusable = true}, SHIFT(2880),
  [6335] = {.count = 1, .reusable = false}, SHIFT(2881),
  [6337] = {.count = 1, .reusable = true}, SHIFT(2882),
  [6339] = {.count = 1, .reusable = true}, SHIFT(2883),
  [6341] = {.count = 1, .reusable = true}, SHIFT(2884),
  [6343] = {.count = 1, .reusable = true}, SHIFT(2885),
  [6345] = {.count = 1, .reusable = true}, SHIFT(2886),
  [6347] = {.count = 1, .reusable = true}, SHIFT(2888),
  [6349] = {.count = 1, .reusable = true}, SHIFT(2889),
  [6351] = {.count = 1, .reusable = false}, SHIFT(2891),
  [6353] = {.count = 1, .reusable = false}, SHIFT(2892),
  [6355] = {.count = 1, .reusable = true}, SHIFT(2894),
  [6357] = {.count = 1, .reusable = true}, SHIFT(2895),
  [6359] = {.count = 1, .reusable = false}, SHIFT(2896),
  [6361] = {.count = 1, .reusable = true}, SHIFT(2896),
  [6363] = {.count = 1, .reusable = true}, SHIFT(2897),
  [6365] = {.count = 1, .reusable = true}, SHIFT(2898),
  [6367] = {.count = 1, .reusable = true}, SHIFT(2899),
  [6369] = {.count = 1, .reusable = false}, SHIFT(2900),
  [6371] = {.count = 1, .reusable = true}, SHIFT(2900),
  [6373] = {.count = 1, .reusable = false}, SHIFT(2905),
  [6375] = {.count = 1, .reusable = true}, SHIFT(2906),
  [6377] = {.count = 1, .reusable = true}, SHIFT(2908),
  [6379] = {.count = 1, .reusable = false}, SHIFT(2910),
  [6381] = {.count = 1, .reusable = false}, SHIFT(2911),
  [6383] = {.count = 1, .reusable = true}, SHIFT(2913),
  [6385] = {.count = 1, .reusable = true}, SHIFT(2914),
  [6387] = {.count = 1, .reusable = false}, SHIFT(2915),
  [6389] = {.count = 1, .reusable = true}, SHIFT(2915),
  [6391] = {.count = 1, .reusable = true}, SHIFT(2916),
  [6393] = {.count = 1, .reusable = true}, SHIFT(2917),
  [6395] = {.count = 1, .reusable = true}, SHIFT(2918),
  [6397] = {.count = 1, .reusable = false}, SHIFT(2919),
  [6399] = {.count = 1, .reusable = true}, SHIFT(2919),
  [6401] = {.count = 1, .reusable = false}, SHIFT(2924),
  [6403] = {.count = 1, .reusable = true}, SHIFT(2925),
  [6405] = {.count = 1, .reusable = true}, SHIFT(2927),
  [6407] = {.count = 1, .reusable = false}, SHIFT(2929),
  [6409] = {.count = 1, .reusable = false}, SHIFT(2930),
  [6411] = {.count = 1, .reusable = true}, SHIFT(2931),
  [6413] = {.count = 1, .reusable = true}, SHIFT(2932),
  [6415] = {.count = 1, .reusable = true}, SHIFT(2933),
  [6417] = {.count = 1, .reusable = false}, SHIFT(2934),
  [6419] = {.count = 1, .reusable = true}, SHIFT(2934),
  [6421] = {.count = 1, .reusable = true}, SHIFT(2935),
  [6423] = {.count = 1, .reusable = false}, SHIFT(2937),
  [6425] = {.count = 1, .reusable = true}, SHIFT(2937),
  [6427] = {.count = 1, .reusable = true}, SHIFT(2936),
  [6429] = {.count = 1, .reusable = true}, SHIFT(2938),
  [6431] = {.count = 1, .reusable = false}, SHIFT(2940),
  [6433] = {.count = 1, .reusable = true}, SHIFT(2940),
  [6435] = {.count = 1, .reusable = true}, SHIFT(2939),
  [6437] = {.count = 1, .reusable = true}, SHIFT(2941),
  [6439] = {.count = 1, .reusable = true}, SHIFT(2942),
  [6441] = {.count = 1, .reusable = false}, SHIFT(2943),
  [6443] = {.count = 1, .reusable = true}, SHIFT(2943),
  [6445] = {.count = 1, .reusable = true}, SHIFT(2948),
  [6447] = {.count = 1, .reusable = true}, SHIFT(2949),
  [6449] = {.count = 1, .reusable = true}, SHIFT(2951),
  [6451] = {.count = 1, .reusable = false}, SHIFT(2953),
  [6453] = {.count = 1, .reusable = true}, SHIFT(2953),
  [6455] = {.count = 1, .reusable = true}, SHIFT(2955),
  [6457] = {.count = 1, .reusable = true}, SHIFT(2956),
  [6459] = {.count = 1, .reusable = false}, SHIFT(2959),
  [6461] = {.count = 1, .reusable = true}, SHIFT(2959),
  [6463] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2319),
  [6466] = {.count = 1, .reusable = true}, SHIFT(2962),
  [6468] = {.count = 1, .reusable = true}, SHIFT(2963),
  [6470] = {.count = 1, .reusable = true}, SHIFT(2964),
  [6472] = {.count = 1, .reusable = true}, SHIFT(2966),
  [6474] = {.count = 1, .reusable = false}, SHIFT(2968),
  [6476] = {.count = 1, .reusable = false}, SHIFT(2969),
  [6478] = {.count = 1, .reusable = true}, SHIFT(2970),
  [6480] = {.count = 1, .reusable = true}, SHIFT(2971),
  [6482] = {.count = 1, .reusable = true}, SHIFT(2972),
  [6484] = {.count = 1, .reusable = false}, SHIFT(2973),
  [6486] = {.count = 1, .reusable = true}, SHIFT(2973),
  [6488] = {.count = 1, .reusable = true}, SHIFT(2974),
  [6490] = {.count = 1, .reusable = false}, SHIFT(2976),
  [6492] = {.count = 1, .reusable = true}, SHIFT(2976),
  [6494] = {.count = 1, .reusable = true}, SHIFT(2975),
  [6496] = {.count = 1, .reusable = true}, SHIFT(2977),
  [6498] = {.count = 1, .reusable = false}, SHIFT(2979),
  [6500] = {.count = 1, .reusable = true}, SHIFT(2979),
  [6502] = {.count = 1, .reusable = true}, SHIFT(2978),
  [6504] = {.count = 1, .reusable = true}, SHIFT(2980),
  [6506] = {.count = 1, .reusable = true}, SHIFT(2981),
  [6508] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1627),
  [6511] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1628),
  [6514] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1629),
  [6517] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1630),
  [6520] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1631),
  [6523] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1632),
  [6526] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1633),
  [6529] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1634),
  [6532] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1635),
  [6535] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2338),
  [6538] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1631),
  [6541] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2339),
  [6544] = {.count = 1, .reusable = true}, SHIFT(2982),
  [6546] = {.count = 1, .reusable = false}, SHIFT(2984),
  [6548] = {.count = 1, .reusable = false}, SHIFT(2985),
  [6550] = {.count = 1, .reusable = true}, SHIFT(2986),
  [6552] = {.count = 1, .reusable = true}, SHIFT(2987),
  [6554] = {.count = 1, .reusable = true}, SHIFT(2988),
  [6556] = {.count = 1, .reusable = false}, SHIFT(2989),
  [6558] = {.count = 1, .reusable = true}, SHIFT(2989),
  [6560] = {.count = 1, .reusable = true}, SHIFT(2990),
  [6562] = {.count = 1, .reusable = false}, SHIFT(2992),
  [6564] = {.count = 1, .reusable = true}, SHIFT(2992),
  [6566] = {.count = 1, .reusable = true}, SHIFT(2991),
  [6568] = {.count = 1, .reusable = true}, SHIFT(2993),
  [6570] = {.count = 1, .reusable = false}, SHIFT(2995),
  [6572] = {.count = 1, .reusable = true}, SHIFT(2995),
  [6574] = {.count = 1, .reusable = true}, SHIFT(2994),
  [6576] = {.count = 1, .reusable = true}, SHIFT(2996),
  [6578] = {.count = 1, .reusable = true}, SHIFT(2997),
  [6580] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1639),
  [6583] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1640),
  [6586] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1641),
  [6589] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1642),
  [6592] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1643),
  [6595] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1644),
  [6598] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1645),
  [6601] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1646),
  [6604] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2357),
  [6607] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1642),
  [6610] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2358),
  [6613] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1649),
  [6616] = {.count = 1, .reusable = false}, SHIFT(2998),
  [6618] = {.count = 1, .reusable = true}, SHIFT(2999),
  [6620] = {.count = 1, .reusable = true}, SHIFT(3000),
  [6622] = {.count = 1, .reusable = true}, SHIFT(3003),
  [6624] = {.count = 1, .reusable = true}, SHIFT(3004),
  [6626] = {.count = 1, .reusable = false}, SHIFT(3006),
  [6628] = {.count = 1, .reusable = true}, SHIFT(3006),
  [6630] = {.count = 1, .reusable = true}, SHIFT(3005),
  [6632] = {.count = 1, .reusable = false}, SHIFT(3008),
  [6634] = {.count = 1, .reusable = true}, SHIFT(3008),
  [6636] = {.count = 1, .reusable = true}, SHIFT(3007),
  [6638] = {.count = 1, .reusable = true}, SHIFT(3009),
  [6640] = {.count = 1, .reusable = true}, SHIFT(3010),
  [6642] = {.count = 1, .reusable = false}, SHIFT(3011),
  [6644] = {.count = 1, .reusable = true}, SHIFT(3011),
  [6646] = {.count = 1, .reusable = true}, SHIFT(3012),
  [6648] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6),
  [6650] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6),
  [6652] = {.count = 1, .reusable = true}, SHIFT(3013),
  [6654] = {.count = 1, .reusable = true}, SHIFT(3014),
  [6656] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1668),
  [6659] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1672),
  [6662] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1672),
  [6665] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1673),
  [6668] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1676),
  [6671] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(965),
  [6674] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(966),
  [6677] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(967),
  [6680] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1677),
  [6683] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(969),
  [6686] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(970),
  [6689] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(971),
  [6692] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(972),
  [6695] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1677),
  [6698] = {.count = 1, .reusable = false}, SHIFT(3018),
  [6700] = {.count = 1, .reusable = true}, SHIFT(3018),
  [6702] = {.count = 1, .reusable = true}, SHIFT(3020),
  [6704] = {.count = 1, .reusable = true}, SHIFT(3023),
  [6706] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2),
  [6708] = {.count = 1, .reusable = true}, SHIFT(3024),
  [6710] = {.count = 1, .reusable = false}, SHIFT(3025),
  [6712] = {.count = 1, .reusable = false}, SHIFT(3026),
  [6714] = {.count = 1, .reusable = false}, SHIFT(3027),
  [6716] = {.count = 1, .reusable = false}, SHIFT(3028),
  [6718] = {.count = 1, .reusable = true}, SHIFT(3029),
  [6720] = {.count = 1, .reusable = false}, SHIFT(3030),
  [6722] = {.count = 1, .reusable = true}, SHIFT(3031),
  [6724] = {.count = 1, .reusable = true}, SHIFT(3032),
  [6726] = {.count = 1, .reusable = true}, SHIFT(3033),
  [6728] = {.count = 1, .reusable = true}, SHIFT(3034),
  [6730] = {.count = 1, .reusable = true}, SHIFT(3035),
  [6732] = {.count = 1, .reusable = false}, SHIFT(3036),
  [6734] = {.count = 1, .reusable = true}, SHIFT(3046),
  [6736] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6),
  [6738] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6),
  [6740] = {.count = 1, .reusable = true}, SHIFT(3048),
  [6742] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1688),
  [6745] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(292),
  [6748] = {.count = 2, .reusable = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(293),
  [6751] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(3049),
  [6754] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(295),
  [6757] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(296),
  [6760] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(297),
  [6763] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(298),
  [6766] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2, .alias_sequence_id = 1),
  [6768] = {.count = 1, .reusable = true}, SHIFT(3052),
  [6770] = {.count = 1, .reusable = true}, SHIFT(3054),
  [6772] = {.count = 1, .reusable = true}, SHIFT(3056),
  [6774] = {.count = 1, .reusable = true}, SHIFT(3057),
  [6776] = {.count = 1, .reusable = true}, SHIFT(3058),
  [6778] = {.count = 1, .reusable = false}, SHIFT(3059),
  [6780] = {.count = 1, .reusable = true}, SHIFT(3059),
  [6782] = {.count = 1, .reusable = false}, SHIFT(3060),
  [6784] = {.count = 1, .reusable = true}, SHIFT(3060),
  [6786] = {.count = 1, .reusable = true}, SHIFT(3061),
  [6788] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 2),
  [6790] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 2),
  [6792] = {.count = 1, .reusable = true}, SHIFT(3062),
  [6794] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1726),
  [6797] = {.count = 1, .reusable = false}, SHIFT(3064),
  [6799] = {.count = 1, .reusable = true}, SHIFT(3065),
  [6801] = {.count = 1, .reusable = true}, SHIFT(3066),
  [6803] = {.count = 1, .reusable = true}, SHIFT(3069),
  [6805] = {.count = 1, .reusable = true}, SHIFT(3070),
  [6807] = {.count = 1, .reusable = false}, SHIFT(3072),
  [6809] = {.count = 1, .reusable = true}, SHIFT(3072),
  [6811] = {.count = 1, .reusable = true}, SHIFT(3071),
  [6813] = {.count = 1, .reusable = false}, SHIFT(3074),
  [6815] = {.count = 1, .reusable = true}, SHIFT(3074),
  [6817] = {.count = 1, .reusable = true}, SHIFT(3073),
  [6819] = {.count = 1, .reusable = true}, SHIFT(3075),
  [6821] = {.count = 1, .reusable = true}, SHIFT(3076),
  [6823] = {.count = 1, .reusable = false}, SHIFT(3077),
  [6825] = {.count = 1, .reusable = true}, SHIFT(3077),
  [6827] = {.count = 1, .reusable = true}, SHIFT(3078),
  [6829] = {.count = 1, .reusable = true}, SHIFT(3079),
  [6831] = {.count = 1, .reusable = true}, SHIFT(3081),
  [6833] = {.count = 1, .reusable = false}, SHIFT(3083),
  [6835] = {.count = 1, .reusable = true}, SHIFT(3083),
  [6837] = {.count = 1, .reusable = true}, SHIFT(3085),
  [6839] = {.count = 1, .reusable = true}, SHIFT(3087),
  [6841] = {.count = 1, .reusable = false}, SHIFT(3087),
  [6843] = {.count = 1, .reusable = true}, SHIFT(3090),
  [6845] = {.count = 1, .reusable = false}, SHIFT(3090),
  [6847] = {.count = 1, .reusable = true}, SHIFT(3093),
  [6849] = {.count = 1, .reusable = true}, SHIFT(3094),
  [6851] = {.count = 1, .reusable = true}, SHIFT(3095),
  [6853] = {.count = 1, .reusable = true}, SHIFT(3096),
  [6855] = {.count = 1, .reusable = true}, SHIFT(3099),
  [6857] = {.count = 1, .reusable = true}, SHIFT(3100),
  [6859] = {.count = 1, .reusable = false}, SHIFT(3101),
  [6861] = {.count = 1, .reusable = true}, SHIFT(3101),
  [6863] = {.count = 1, .reusable = true}, SHIFT(3102),
  [6865] = {.count = 1, .reusable = false}, SHIFT(3103),
  [6867] = {.count = 1, .reusable = true}, SHIFT(3103),
  [6869] = {.count = 1, .reusable = true}, SHIFT(3104),
  [6871] = {.count = 1, .reusable = false}, SHIFT(3105),
  [6873] = {.count = 1, .reusable = true}, SHIFT(3105),
  [6875] = {.count = 1, .reusable = true}, SHIFT(3106),
  [6877] = {.count = 1, .reusable = true}, SHIFT(3107),
  [6879] = {.count = 1, .reusable = true}, SHIFT(3108),
  [6881] = {.count = 1, .reusable = true}, SHIFT(3111),
  [6883] = {.count = 1, .reusable = true}, SHIFT(3112),
  [6885] = {.count = 1, .reusable = false}, SHIFT(3113),
  [6887] = {.count = 1, .reusable = true}, SHIFT(3113),
  [6889] = {.count = 1, .reusable = true}, SHIFT(3114),
  [6891] = {.count = 1, .reusable = false}, SHIFT(3115),
  [6893] = {.count = 1, .reusable = true}, SHIFT(3115),
  [6895] = {.count = 1, .reusable = true}, SHIFT(3116),
  [6897] = {.count = 1, .reusable = false}, SHIFT(3117),
  [6899] = {.count = 1, .reusable = true}, SHIFT(3117),
  [6901] = {.count = 1, .reusable = true}, SHIFT(3118),
  [6903] = {.count = 1, .reusable = true}, SHIFT(3119),
  [6905] = {.count = 1, .reusable = true}, SHIFT(3120),
  [6907] = {.count = 1, .reusable = false}, SHIFT(3121),
  [6909] = {.count = 1, .reusable = true}, SHIFT(3121),
  [6911] = {.count = 1, .reusable = false}, SHIFT(3122),
  [6913] = {.count = 1, .reusable = true}, SHIFT(3122),
  [6915] = {.count = 1, .reusable = true}, SHIFT(3123),
  [6917] = {.count = 1, .reusable = true}, SHIFT(3124),
  [6919] = {.count = 1, .reusable = true}, SHIFT(3125),
  [6921] = {.count = 1, .reusable = true}, SHIFT(3126),
  [6923] = {.count = 1, .reusable = false}, SHIFT(3127),
  [6925] = {.count = 1, .reusable = true}, SHIFT(3127),
  [6927] = {.count = 1, .reusable = false}, SHIFT(3128),
  [6929] = {.count = 1, .reusable = true}, SHIFT(3128),
  [6931] = {.count = 1, .reusable = true}, SHIFT(3129),
  [6933] = {.count = 1, .reusable = true}, SHIFT(3130),
  [6935] = {.count = 1, .reusable = true}, SHIFT(3131),
  [6937] = {.count = 1, .reusable = true}, SHIFT(3132),
  [6939] = {.count = 1, .reusable = false}, SHIFT(3133),
  [6941] = {.count = 1, .reusable = true}, SHIFT(3133),
  [6943] = {.count = 1, .reusable = false}, SHIFT(3134),
  [6945] = {.count = 1, .reusable = true}, SHIFT(3134),
  [6947] = {.count = 1, .reusable = true}, SHIFT(3135),
  [6949] = {.count = 1, .reusable = true}, SHIFT(3136),
  [6951] = {.count = 1, .reusable = true}, SHIFT(3137),
  [6953] = {.count = 1, .reusable = true}, SHIFT(3138),
  [6955] = {.count = 1, .reusable = false}, SHIFT(3139),
  [6957] = {.count = 1, .reusable = true}, SHIFT(3139),
  [6959] = {.count = 1, .reusable = false}, SHIFT(3140),
  [6961] = {.count = 1, .reusable = true}, SHIFT(3140),
  [6963] = {.count = 1, .reusable = true}, SHIFT(3141),
  [6965] = {.count = 1, .reusable = true}, SHIFT(3142),
  [6967] = {.count = 1, .reusable = true}, SHIFT(3143),
  [6969] = {.count = 1, .reusable = true}, SHIFT(3144),
  [6971] = {.count = 1, .reusable = false}, SHIFT(3145),
  [6973] = {.count = 1, .reusable = true}, SHIFT(3145),
  [6975] = {.count = 1, .reusable = false}, SHIFT(3146),
  [6977] = {.count = 1, .reusable = true}, SHIFT(3146),
  [6979] = {.count = 1, .reusable = true}, SHIFT(3147),
  [6981] = {.count = 1, .reusable = true}, SHIFT(3148),
  [6983] = {.count = 1, .reusable = true}, SHIFT(3149),
  [6985] = {.count = 1, .reusable = true}, SHIFT(3150),
  [6987] = {.count = 1, .reusable = false}, SHIFT(3151),
  [6989] = {.count = 1, .reusable = true}, SHIFT(3151),
  [6991] = {.count = 1, .reusable = false}, SHIFT(3152),
  [6993] = {.count = 1, .reusable = true}, SHIFT(3152),
  [6995] = {.count = 1, .reusable = true}, SHIFT(3153),
  [6997] = {.count = 1, .reusable = true}, SHIFT(3154),
  [6999] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5),
  [7001] = {.count = 1, .reusable = true}, SHIFT(3155),
  [7003] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5, .alias_sequence_id = 4),
  [7005] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1902),
  [7008] = {.count = 1, .reusable = false}, SHIFT(3156),
  [7010] = {.count = 1, .reusable = true}, SHIFT(3157),
  [7012] = {.count = 1, .reusable = true}, SHIFT(3158),
  [7014] = {.count = 1, .reusable = true}, SHIFT(3161),
  [7016] = {.count = 1, .reusable = true}, SHIFT(3162),
  [7018] = {.count = 1, .reusable = false}, SHIFT(3164),
  [7020] = {.count = 1, .reusable = true}, SHIFT(3164),
  [7022] = {.count = 1, .reusable = true}, SHIFT(3163),
  [7024] = {.count = 1, .reusable = false}, SHIFT(3166),
  [7026] = {.count = 1, .reusable = true}, SHIFT(3166),
  [7028] = {.count = 1, .reusable = true}, SHIFT(3165),
  [7030] = {.count = 1, .reusable = true}, SHIFT(3167),
  [7032] = {.count = 1, .reusable = true}, SHIFT(3168),
  [7034] = {.count = 1, .reusable = false}, SHIFT(3169),
  [7036] = {.count = 1, .reusable = true}, SHIFT(3169),
  [7038] = {.count = 1, .reusable = true}, SHIFT(3170),
  [7040] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6),
  [7042] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6),
  [7044] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 7),
  [7046] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 7),
  [7048] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 5),
  [7050] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 5),
  [7052] = {.count = 1, .reusable = true}, SHIFT(3171),
  [7054] = {.count = 1, .reusable = true}, SHIFT(3172),
  [7056] = {.count = 1, .reusable = true}, SHIFT(3173),
  [7058] = {.count = 1, .reusable = true}, SHIFT(3174),
  [7060] = {.count = 1, .reusable = true}, SHIFT(3175),
  [7062] = {.count = 1, .reusable = true}, SHIFT(3178),
  [7064] = {.count = 1, .reusable = true}, SHIFT(3179),
  [7066] = {.count = 1, .reusable = false}, SHIFT(3180),
  [7068] = {.count = 1, .reusable = true}, SHIFT(3180),
  [7070] = {.count = 1, .reusable = true}, SHIFT(3181),
  [7072] = {.count = 1, .reusable = false}, SHIFT(3182),
  [7074] = {.count = 1, .reusable = true}, SHIFT(3182),
  [7076] = {.count = 1, .reusable = true}, SHIFT(3183),
  [7078] = {.count = 1, .reusable = false}, SHIFT(3184),
  [7080] = {.count = 1, .reusable = true}, SHIFT(3184),
  [7082] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 3),
  [7084] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 3),
  [7086] = {.count = 1, .reusable = true}, SHIFT(3185),
  [7088] = {.count = 1, .reusable = true}, SHIFT(3186),
  [7090] = {.count = 1, .reusable = true}, SHIFT(3187),
  [7092] = {.count = 1, .reusable = true}, SHIFT(3190),
  [7094] = {.count = 1, .reusable = true}, SHIFT(3191),
  [7096] = {.count = 1, .reusable = false}, SHIFT(3192),
  [7098] = {.count = 1, .reusable = true}, SHIFT(3192),
  [7100] = {.count = 1, .reusable = true}, SHIFT(3193),
  [7102] = {.count = 1, .reusable = false}, SHIFT(3194),
  [7104] = {.count = 1, .reusable = true}, SHIFT(3194),
  [7106] = {.count = 1, .reusable = true}, SHIFT(3195),
  [7108] = {.count = 1, .reusable = false}, SHIFT(3196),
  [7110] = {.count = 1, .reusable = true}, SHIFT(3196),
  [7112] = {.count = 1, .reusable = true}, SHIFT(3198),
  [7114] = {.count = 1, .reusable = true}, SHIFT(3199),
  [7116] = {.count = 1, .reusable = true}, SHIFT(3200),
  [7118] = {.count = 1, .reusable = true}, SHIFT(3203),
  [7120] = {.count = 1, .reusable = true}, SHIFT(3204),
  [7122] = {.count = 1, .reusable = false}, SHIFT(3205),
  [7124] = {.count = 1, .reusable = true}, SHIFT(3205),
  [7126] = {.count = 1, .reusable = true}, SHIFT(3206),
  [7128] = {.count = 1, .reusable = false}, SHIFT(3207),
  [7130] = {.count = 1, .reusable = true}, SHIFT(3207),
  [7132] = {.count = 1, .reusable = true}, SHIFT(3208),
  [7134] = {.count = 1, .reusable = false}, SHIFT(3209),
  [7136] = {.count = 1, .reusable = true}, SHIFT(3209),
  [7138] = {.count = 1, .reusable = true}, SHIFT(3210),
  [7140] = {.count = 1, .reusable = true}, SHIFT(3211),
  [7142] = {.count = 1, .reusable = true}, SHIFT(3212),
  [7144] = {.count = 1, .reusable = false}, SHIFT(3213),
  [7146] = {.count = 1, .reusable = true}, SHIFT(3213),
  [7148] = {.count = 1, .reusable = false}, SHIFT(3214),
  [7150] = {.count = 1, .reusable = true}, SHIFT(3214),
  [7152] = {.count = 1, .reusable = true}, SHIFT(3215),
  [7154] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 7),
  [7156] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 7),
  [7158] = {.count = 1, .reusable = true}, SHIFT(3217),
  [7160] = {.count = 1, .reusable = true}, SHIFT(3218),
  [7162] = {.count = 1, .reusable = true}, SHIFT(3219),
  [7164] = {.count = 1, .reusable = true}, SHIFT(3220),
  [7166] = {.count = 1, .reusable = false}, SHIFT(3221),
  [7168] = {.count = 1, .reusable = true}, SHIFT(3221),
  [7170] = {.count = 1, .reusable = false}, SHIFT(3222),
  [7172] = {.count = 1, .reusable = true}, SHIFT(3222),
  [7174] = {.count = 1, .reusable = true}, SHIFT(3223),
  [7176] = {.count = 1, .reusable = true}, SHIFT(3224),
  [7178] = {.count = 1, .reusable = true}, SHIFT(3225),
  [7180] = {.count = 1, .reusable = true}, SHIFT(3226),
  [7182] = {.count = 1, .reusable = true}, SHIFT(3227),
  [7184] = {.count = 1, .reusable = true}, SHIFT(3230),
  [7186] = {.count = 1, .reusable = true}, SHIFT(3231),
  [7188] = {.count = 1, .reusable = false}, SHIFT(3232),
  [7190] = {.count = 1, .reusable = true}, SHIFT(3232),
  [7192] = {.count = 1, .reusable = true}, SHIFT(3233),
  [7194] = {.count = 1, .reusable = false}, SHIFT(3234),
  [7196] = {.count = 1, .reusable = true}, SHIFT(3234),
  [7198] = {.count = 1, .reusable = true}, SHIFT(3235),
  [7200] = {.count = 1, .reusable = false}, SHIFT(3236),
  [7202] = {.count = 1, .reusable = true}, SHIFT(3236),
  [7204] = {.count = 1, .reusable = true}, SHIFT(3237),
  [7206] = {.count = 1, .reusable = true}, SHIFT(3238),
  [7208] = {.count = 1, .reusable = true}, SHIFT(3239),
  [7210] = {.count = 1, .reusable = false}, SHIFT(3240),
  [7212] = {.count = 1, .reusable = true}, SHIFT(3240),
  [7214] = {.count = 1, .reusable = false}, SHIFT(3241),
  [7216] = {.count = 1, .reusable = true}, SHIFT(3241),
  [7218] = {.count = 1, .reusable = true}, SHIFT(3242),
  [7220] = {.count = 1, .reusable = true}, SHIFT(3243),
  [7222] = {.count = 1, .reusable = true}, SHIFT(3244),
  [7224] = {.count = 1, .reusable = true}, SHIFT(3245),
  [7226] = {.count = 1, .reusable = true}, SHIFT(3246),
  [7228] = {.count = 1, .reusable = true}, SHIFT(3247),
  [7230] = {.count = 1, .reusable = true}, SHIFT(3250),
  [7232] = {.count = 1, .reusable = true}, SHIFT(3251),
  [7234] = {.count = 1, .reusable = false}, SHIFT(3252),
  [7236] = {.count = 1, .reusable = true}, SHIFT(3252),
  [7238] = {.count = 1, .reusable = true}, SHIFT(3253),
  [7240] = {.count = 1, .reusable = false}, SHIFT(3254),
  [7242] = {.count = 1, .reusable = true}, SHIFT(3254),
  [7244] = {.count = 1, .reusable = true}, SHIFT(3255),
  [7246] = {.count = 1, .reusable = false}, SHIFT(3256),
  [7248] = {.count = 1, .reusable = true}, SHIFT(3256),
  [7250] = {.count = 1, .reusable = true}, SHIFT(3258),
  [7252] = {.count = 1, .reusable = true}, SHIFT(3259),
  [7254] = {.count = 1, .reusable = true}, SHIFT(3261),
  [7256] = {.count = 1, .reusable = true}, SHIFT(3262),
  [7258] = {.count = 1, .reusable = true}, SHIFT(3264),
  [7260] = {.count = 1, .reusable = true}, SHIFT(3266),
  [7262] = {.count = 1, .reusable = true}, SHIFT(3267),
  [7264] = {.count = 1, .reusable = true}, SHIFT(3268),
  [7266] = {.count = 1, .reusable = false}, SHIFT(3269),
  [7268] = {.count = 1, .reusable = true}, SHIFT(3269),
  [7270] = {.count = 1, .reusable = false}, SHIFT(3270),
  [7272] = {.count = 1, .reusable = true}, SHIFT(3270),
  [7274] = {.count = 1, .reusable = true}, SHIFT(3271),
  [7276] = {.count = 1, .reusable = true}, SHIFT(3272),
  [7278] = {.count = 1, .reusable = true}, SHIFT(3273),
  [7280] = {.count = 1, .reusable = true}, SHIFT(3274),
  [7282] = {.count = 1, .reusable = false}, SHIFT(3275),
  [7284] = {.count = 1, .reusable = true}, SHIFT(3275),
  [7286] = {.count = 1, .reusable = false}, SHIFT(3276),
  [7288] = {.count = 1, .reusable = true}, SHIFT(3276),
  [7290] = {.count = 1, .reusable = true}, SHIFT(3277),
  [7292] = {.count = 1, .reusable = true}, SHIFT(3278),
  [7294] = {.count = 1, .reusable = true}, SHIFT(3279),
  [7296] = {.count = 1, .reusable = true}, SHIFT(3280),
  [7298] = {.count = 1, .reusable = true}, SHIFT(3281),
  [7300] = {.count = 1, .reusable = false}, SHIFT(3283),
  [7302] = {.count = 1, .reusable = false}, SHIFT(3284),
  [7304] = {.count = 1, .reusable = true}, SHIFT(3285),
  [7306] = {.count = 1, .reusable = true}, SHIFT(3286),
  [7308] = {.count = 1, .reusable = true}, SHIFT(3287),
  [7310] = {.count = 1, .reusable = false}, SHIFT(3288),
  [7312] = {.count = 1, .reusable = true}, SHIFT(3288),
  [7314] = {.count = 1, .reusable = true}, SHIFT(3289),
  [7316] = {.count = 1, .reusable = false}, SHIFT(3291),
  [7318] = {.count = 1, .reusable = true}, SHIFT(3291),
  [7320] = {.count = 1, .reusable = true}, SHIFT(3290),
  [7322] = {.count = 1, .reusable = true}, SHIFT(3292),
  [7324] = {.count = 1, .reusable = false}, SHIFT(3294),
  [7326] = {.count = 1, .reusable = true}, SHIFT(3294),
  [7328] = {.count = 1, .reusable = true}, SHIFT(3293),
  [7330] = {.count = 1, .reusable = true}, SHIFT(3295),
  [7332] = {.count = 1, .reusable = true}, SHIFT(3296),
  [7334] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2782),
  [7337] = {.count = 1, .reusable = true}, SHIFT(3297),
  [7339] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2173),
  [7342] = {.count = 1, .reusable = false}, SHIFT(3299),
  [7344] = {.count = 1, .reusable = true}, SHIFT(3300),
  [7346] = {.count = 1, .reusable = true}, SHIFT(3301),
  [7348] = {.count = 1, .reusable = true}, SHIFT(3304),
  [7350] = {.count = 1, .reusable = true}, SHIFT(3305),
  [7352] = {.count = 1, .reusable = false}, SHIFT(3307),
  [7354] = {.count = 1, .reusable = true}, SHIFT(3307),
  [7356] = {.count = 1, .reusable = true}, SHIFT(3306),
  [7358] = {.count = 1, .reusable = false}, SHIFT(3309),
  [7360] = {.count = 1, .reusable = true}, SHIFT(3309),
  [7362] = {.count = 1, .reusable = true}, SHIFT(3308),
  [7364] = {.count = 1, .reusable = true}, SHIFT(3310),
  [7366] = {.count = 1, .reusable = true}, SHIFT(3311),
  [7368] = {.count = 1, .reusable = false}, SHIFT(3312),
  [7370] = {.count = 1, .reusable = true}, SHIFT(3312),
  [7372] = {.count = 1, .reusable = true}, SHIFT(3313),
  [7374] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2192),
  [7377] = {.count = 1, .reusable = false}, SHIFT(3314),
  [7379] = {.count = 1, .reusable = true}, SHIFT(3315),
  [7381] = {.count = 1, .reusable = true}, SHIFT(3316),
  [7383] = {.count = 1, .reusable = true}, SHIFT(3319),
  [7385] = {.count = 1, .reusable = true}, SHIFT(3320),
  [7387] = {.count = 1, .reusable = false}, SHIFT(3322),
  [7389] = {.count = 1, .reusable = true}, SHIFT(3322),
  [7391] = {.count = 1, .reusable = true}, SHIFT(3321),
  [7393] = {.count = 1, .reusable = false}, SHIFT(3324),
  [7395] = {.count = 1, .reusable = true}, SHIFT(3324),
  [7397] = {.count = 1, .reusable = true}, SHIFT(3323),
  [7399] = {.count = 1, .reusable = true}, SHIFT(3325),
  [7401] = {.count = 1, .reusable = true}, SHIFT(3326),
  [7403] = {.count = 1, .reusable = false}, SHIFT(3327),
  [7405] = {.count = 1, .reusable = true}, SHIFT(3327),
  [7407] = {.count = 1, .reusable = true}, SHIFT(3328),
  [7409] = {.count = 1, .reusable = true}, SHIFT(3329),
  [7411] = {.count = 1, .reusable = true}, SHIFT(3330),
  [7413] = {.count = 1, .reusable = true}, SHIFT(3331),
  [7415] = {.count = 1, .reusable = true}, SHIFT(3334),
  [7417] = {.count = 1, .reusable = true}, SHIFT(3335),
  [7419] = {.count = 1, .reusable = false}, SHIFT(3336),
  [7421] = {.count = 1, .reusable = true}, SHIFT(3336),
  [7423] = {.count = 1, .reusable = true}, SHIFT(3337),
  [7425] = {.count = 1, .reusable = false}, SHIFT(3338),
  [7427] = {.count = 1, .reusable = true}, SHIFT(3338),
  [7429] = {.count = 1, .reusable = true}, SHIFT(3339),
  [7431] = {.count = 1, .reusable = false}, SHIFT(3340),
  [7433] = {.count = 1, .reusable = true}, SHIFT(3340),
  [7435] = {.count = 1, .reusable = true}, SHIFT(3341),
  [7437] = {.count = 1, .reusable = false}, SHIFT(3343),
  [7439] = {.count = 1, .reusable = false}, SHIFT(3344),
  [7441] = {.count = 1, .reusable = true}, SHIFT(3345),
  [7443] = {.count = 1, .reusable = true}, SHIFT(3346),
  [7445] = {.count = 1, .reusable = true}, SHIFT(3347),
  [7447] = {.count = 1, .reusable = false}, SHIFT(3348),
  [7449] = {.count = 1, .reusable = true}, SHIFT(3348),
  [7451] = {.count = 1, .reusable = true}, SHIFT(3349),
  [7453] = {.count = 1, .reusable = false}, SHIFT(3351),
  [7455] = {.count = 1, .reusable = true}, SHIFT(3351),
  [7457] = {.count = 1, .reusable = true}, SHIFT(3350),
  [7459] = {.count = 1, .reusable = true}, SHIFT(3352),
  [7461] = {.count = 1, .reusable = false}, SHIFT(3354),
  [7463] = {.count = 1, .reusable = true}, SHIFT(3354),
  [7465] = {.count = 1, .reusable = true}, SHIFT(3353),
  [7467] = {.count = 1, .reusable = true}, SHIFT(3355),
  [7469] = {.count = 1, .reusable = true}, SHIFT(3356),
  [7471] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2853),
  [7474] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 4),
  [7476] = {.count = 1, .reusable = true}, SHIFT(3357),
  [7478] = {.count = 1, .reusable = true}, SHIFT(3358),
  [7480] = {.count = 1, .reusable = false}, SHIFT(3360),
  [7482] = {.count = 1, .reusable = false}, SHIFT(3361),
  [7484] = {.count = 1, .reusable = true}, SHIFT(3362),
  [7486] = {.count = 1, .reusable = true}, SHIFT(3363),
  [7488] = {.count = 1, .reusable = true}, SHIFT(3364),
  [7490] = {.count = 1, .reusable = false}, SHIFT(3365),
  [7492] = {.count = 1, .reusable = true}, SHIFT(3365),
  [7494] = {.count = 1, .reusable = true}, SHIFT(3366),
  [7496] = {.count = 1, .reusable = false}, SHIFT(3368),
  [7498] = {.count = 1, .reusable = true}, SHIFT(3368),
  [7500] = {.count = 1, .reusable = true}, SHIFT(3367),
  [7502] = {.count = 1, .reusable = true}, SHIFT(3369),
  [7504] = {.count = 1, .reusable = false}, SHIFT(3371),
  [7506] = {.count = 1, .reusable = true}, SHIFT(3371),
  [7508] = {.count = 1, .reusable = true}, SHIFT(3370),
  [7510] = {.count = 1, .reusable = true}, SHIFT(3372),
  [7512] = {.count = 1, .reusable = true}, SHIFT(3373),
  [7514] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2874),
  [7517] = {.count = 1, .reusable = true}, REDUCE(sym_elif_clause, 4),
  [7519] = {.count = 1, .reusable = true}, SHIFT(3374),
  [7521] = {.count = 1, .reusable = true}, SHIFT(3376),
  [7523] = {.count = 1, .reusable = false}, SHIFT(3378),
  [7525] = {.count = 1, .reusable = false}, SHIFT(3379),
  [7527] = {.count = 1, .reusable = true}, SHIFT(3381),
  [7529] = {.count = 1, .reusable = true}, SHIFT(3382),
  [7531] = {.count = 1, .reusable = false}, SHIFT(3383),
  [7533] = {.count = 1, .reusable = true}, SHIFT(3383),
  [7535] = {.count = 1, .reusable = true}, SHIFT(3384),
  [7537] = {.count = 1, .reusable = true}, SHIFT(3385),
  [7539] = {.count = 1, .reusable = true}, SHIFT(3386),
  [7541] = {.count = 1, .reusable = false}, SHIFT(3387),
  [7543] = {.count = 1, .reusable = true}, SHIFT(3387),
  [7545] = {.count = 1, .reusable = true}, SHIFT(3392),
  [7547] = {.count = 1, .reusable = true}, SHIFT(3394),
  [7549] = {.count = 1, .reusable = true}, SHIFT(3395),
  [7551] = {.count = 1, .reusable = true}, SHIFT(3396),
  [7553] = {.count = 1, .reusable = true}, SHIFT(3398),
  [7555] = {.count = 1, .reusable = false}, SHIFT(3400),
  [7557] = {.count = 1, .reusable = false}, SHIFT(3401),
  [7559] = {.count = 1, .reusable = true}, SHIFT(3402),
  [7561] = {.count = 1, .reusable = true}, SHIFT(3403),
  [7563] = {.count = 1, .reusable = true}, SHIFT(3404),
  [7565] = {.count = 1, .reusable = false}, SHIFT(3405),
  [7567] = {.count = 1, .reusable = true}, SHIFT(3405),
  [7569] = {.count = 1, .reusable = true}, SHIFT(3406),
  [7571] = {.count = 1, .reusable = false}, SHIFT(3408),
  [7573] = {.count = 1, .reusable = true}, SHIFT(3408),
  [7575] = {.count = 1, .reusable = true}, SHIFT(3407),
  [7577] = {.count = 1, .reusable = true}, SHIFT(3409),
  [7579] = {.count = 1, .reusable = false}, SHIFT(3411),
  [7581] = {.count = 1, .reusable = true}, SHIFT(3411),
  [7583] = {.count = 1, .reusable = true}, SHIFT(3410),
  [7585] = {.count = 1, .reusable = true}, SHIFT(3412),
  [7587] = {.count = 1, .reusable = true}, SHIFT(3413),
  [7589] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2266),
  [7592] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2267),
  [7595] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2268),
  [7598] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2269),
  [7601] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2270),
  [7604] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2271),
  [7607] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2272),
  [7610] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2273),
  [7613] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2274),
  [7616] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2905),
  [7619] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2270),
  [7622] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2906),
  [7625] = {.count = 1, .reusable = true}, SHIFT(3414),
  [7627] = {.count = 1, .reusable = false}, SHIFT(3416),
  [7629] = {.count = 1, .reusable = false}, SHIFT(3417),
  [7631] = {.count = 1, .reusable = true}, SHIFT(3418),
  [7633] = {.count = 1, .reusable = true}, SHIFT(3419),
  [7635] = {.count = 1, .reusable = true}, SHIFT(3420),
  [7637] = {.count = 1, .reusable = false}, SHIFT(3421),
  [7639] = {.count = 1, .reusable = true}, SHIFT(3421),
  [7641] = {.count = 1, .reusable = true}, SHIFT(3422),
  [7643] = {.count = 1, .reusable = false}, SHIFT(3424),
  [7645] = {.count = 1, .reusable = true}, SHIFT(3424),
  [7647] = {.count = 1, .reusable = true}, SHIFT(3423),
  [7649] = {.count = 1, .reusable = true}, SHIFT(3425),
  [7651] = {.count = 1, .reusable = false}, SHIFT(3427),
  [7653] = {.count = 1, .reusable = true}, SHIFT(3427),
  [7655] = {.count = 1, .reusable = true}, SHIFT(3426),
  [7657] = {.count = 1, .reusable = true}, SHIFT(3428),
  [7659] = {.count = 1, .reusable = true}, SHIFT(3429),
  [7661] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2278),
  [7664] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2279),
  [7667] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2280),
  [7670] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2281),
  [7673] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2282),
  [7676] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2283),
  [7679] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2284),
  [7682] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2285),
  [7685] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2924),
  [7688] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2281),
  [7691] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(2925),
  [7694] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2288),
  [7697] = {.count = 1, .reusable = false}, SHIFT(3430),
  [7699] = {.count = 1, .reusable = true}, SHIFT(3431),
  [7701] = {.count = 1, .reusable = true}, SHIFT(3432),
  [7703] = {.count = 1, .reusable = true}, SHIFT(3435),
  [7705] = {.count = 1, .reusable = true}, SHIFT(3436),
  [7707] = {.count = 1, .reusable = false}, SHIFT(3438),
  [7709] = {.count = 1, .reusable = true}, SHIFT(3438),
  [7711] = {.count = 1, .reusable = true}, SHIFT(3437),
  [7713] = {.count = 1, .reusable = false}, SHIFT(3440),
  [7715] = {.count = 1, .reusable = true}, SHIFT(3440),
  [7717] = {.count = 1, .reusable = true}, SHIFT(3439),
  [7719] = {.count = 1, .reusable = true}, SHIFT(3441),
  [7721] = {.count = 1, .reusable = true}, SHIFT(3442),
  [7723] = {.count = 1, .reusable = false}, SHIFT(3443),
  [7725] = {.count = 1, .reusable = true}, SHIFT(3443),
  [7727] = {.count = 1, .reusable = true}, SHIFT(3444),
  [7729] = {.count = 1, .reusable = true}, SHIFT(3445),
  [7731] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(2304),
  [7734] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(2308),
  [7737] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(2308),
  [7740] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(2309),
  [7743] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2312),
  [7746] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1609),
  [7749] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1610),
  [7752] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1611),
  [7755] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2313),
  [7758] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1613),
  [7761] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1614),
  [7764] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1615),
  [7767] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1616),
  [7770] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2313),
  [7773] = {.count = 1, .reusable = false}, SHIFT(3449),
  [7775] = {.count = 1, .reusable = true}, SHIFT(3449),
  [7777] = {.count = 1, .reusable = true}, SHIFT(3450),
  [7779] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2322),
  [7782] = {.count = 1, .reusable = false}, SHIFT(3452),
  [7784] = {.count = 1, .reusable = true}, SHIFT(3453),
  [7786] = {.count = 1, .reusable = true}, SHIFT(3454),
  [7788] = {.count = 1, .reusable = true}, SHIFT(3457),
  [7790] = {.count = 1, .reusable = true}, SHIFT(3458),
  [7792] = {.count = 1, .reusable = false}, SHIFT(3460),
  [7794] = {.count = 1, .reusable = true}, SHIFT(3460),
  [7796] = {.count = 1, .reusable = true}, SHIFT(3459),
  [7798] = {.count = 1, .reusable = false}, SHIFT(3462),
  [7800] = {.count = 1, .reusable = true}, SHIFT(3462),
  [7802] = {.count = 1, .reusable = true}, SHIFT(3461),
  [7804] = {.count = 1, .reusable = true}, SHIFT(3463),
  [7806] = {.count = 1, .reusable = true}, SHIFT(3464),
  [7808] = {.count = 1, .reusable = false}, SHIFT(3465),
  [7810] = {.count = 1, .reusable = true}, SHIFT(3465),
  [7812] = {.count = 1, .reusable = true}, SHIFT(3466),
  [7814] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2341),
  [7817] = {.count = 1, .reusable = false}, SHIFT(3467),
  [7819] = {.count = 1, .reusable = true}, SHIFT(3468),
  [7821] = {.count = 1, .reusable = true}, SHIFT(3469),
  [7823] = {.count = 1, .reusable = true}, SHIFT(3472),
  [7825] = {.count = 1, .reusable = true}, SHIFT(3473),
  [7827] = {.count = 1, .reusable = false}, SHIFT(3475),
  [7829] = {.count = 1, .reusable = true}, SHIFT(3475),
  [7831] = {.count = 1, .reusable = true}, SHIFT(3474),
  [7833] = {.count = 1, .reusable = false}, SHIFT(3477),
  [7835] = {.count = 1, .reusable = true}, SHIFT(3477),
  [7837] = {.count = 1, .reusable = true}, SHIFT(3476),
  [7839] = {.count = 1, .reusable = true}, SHIFT(3478),
  [7841] = {.count = 1, .reusable = true}, SHIFT(3479),
  [7843] = {.count = 1, .reusable = false}, SHIFT(3480),
  [7845] = {.count = 1, .reusable = true}, SHIFT(3480),
  [7847] = {.count = 1, .reusable = true}, SHIFT(3481),
  [7849] = {.count = 1, .reusable = true}, SHIFT(3482),
  [7851] = {.count = 1, .reusable = true}, SHIFT(3483),
  [7853] = {.count = 1, .reusable = true}, SHIFT(3484),
  [7855] = {.count = 1, .reusable = true}, SHIFT(3487),
  [7857] = {.count = 1, .reusable = true}, SHIFT(3488),
  [7859] = {.count = 1, .reusable = false}, SHIFT(3489),
  [7861] = {.count = 1, .reusable = true}, SHIFT(3489),
  [7863] = {.count = 1, .reusable = true}, SHIFT(3490),
  [7865] = {.count = 1, .reusable = false}, SHIFT(3491),
  [7867] = {.count = 1, .reusable = true}, SHIFT(3491),
  [7869] = {.count = 1, .reusable = true}, SHIFT(3492),
  [7871] = {.count = 1, .reusable = false}, SHIFT(3493),
  [7873] = {.count = 1, .reusable = true}, SHIFT(3493),
  [7875] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 7),
  [7877] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 7),
  [7879] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2),
  [7881] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2, .alias_sequence_id = 2),
  [7883] = {.count = 1, .reusable = true}, SHIFT(3495),
  [7885] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3),
  [7887] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3),
  [7889] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3),
  [7891] = {.count = 1, .reusable = true}, SHIFT(3496),
  [7893] = {.count = 1, .reusable = true}, SHIFT(3497),
  [7895] = {.count = 1, .reusable = true}, SHIFT(3498),
  [7897] = {.count = 1, .reusable = false}, SHIFT(3499),
  [7899] = {.count = 1, .reusable = true}, SHIFT(3500),
  [7901] = {.count = 1, .reusable = true}, SHIFT(3501),
  [7903] = {.count = 1, .reusable = true}, SHIFT(3502),
  [7905] = {.count = 1, .reusable = true}, SHIFT(3503),
  [7907] = {.count = 1, .reusable = true}, SHIFT(3504),
  [7909] = {.count = 1, .reusable = false}, SHIFT(3506),
  [7911] = {.count = 1, .reusable = false}, SHIFT(3500),
  [7913] = {.count = 1, .reusable = true}, SHIFT(3508),
  [7915] = {.count = 1, .reusable = true}, SHIFT(3509),
  [7917] = {.count = 1, .reusable = false}, SHIFT(3510),
  [7919] = {.count = 1, .reusable = true}, SHIFT(3511),
  [7921] = {.count = 1, .reusable = true}, SHIFT(3512),
  [7923] = {.count = 1, .reusable = true}, SHIFT(3513),
  [7925] = {.count = 1, .reusable = true}, SHIFT(3514),
  [7927] = {.count = 1, .reusable = true}, SHIFT(3515),
  [7929] = {.count = 1, .reusable = false}, SHIFT(3516),
  [7931] = {.count = 1, .reusable = false}, SHIFT(3511),
  [7933] = {.count = 1, .reusable = true}, SHIFT(3518),
  [7935] = {.count = 1, .reusable = false}, SHIFT(3520),
  [7937] = {.count = 1, .reusable = false}, SHIFT(3521),
  [7939] = {.count = 1, .reusable = true}, SHIFT(3523),
  [7941] = {.count = 1, .reusable = true}, SHIFT(3524),
  [7943] = {.count = 1, .reusable = false}, SHIFT(3525),
  [7945] = {.count = 1, .reusable = true}, SHIFT(3525),
  [7947] = {.count = 1, .reusable = true}, SHIFT(3526),
  [7949] = {.count = 1, .reusable = true}, SHIFT(3527),
  [7951] = {.count = 1, .reusable = true}, SHIFT(3528),
  [7953] = {.count = 1, .reusable = false}, SHIFT(3529),
  [7955] = {.count = 1, .reusable = true}, SHIFT(3529),
  [7957] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 3),
  [7959] = {.count = 1, .reusable = true}, SHIFT(3534),
  [7961] = {.count = 1, .reusable = true}, SHIFT(3535),
  [7963] = {.count = 1, .reusable = false}, SHIFT(3536),
  [7965] = {.count = 1, .reusable = false}, SHIFT(3537),
  [7967] = {.count = 1, .reusable = true}, SHIFT(3537),
  [7969] = {.count = 1, .reusable = true}, SHIFT(3538),
  [7971] = {.count = 1, .reusable = false}, SHIFT(3539),
  [7973] = {.count = 1, .reusable = true}, SHIFT(3539),
  [7975] = {.count = 1, .reusable = true}, SHIFT(3540),
  [7977] = {.count = 1, .reusable = true}, SHIFT(3536),
  [7979] = {.count = 1, .reusable = false}, SHIFT(3543),
  [7981] = {.count = 1, .reusable = true}, SHIFT(3028),
  [7983] = {.count = 1, .reusable = true}, SHIFT(3544),
  [7985] = {.count = 1, .reusable = false}, SHIFT(3544),
  [7987] = {.count = 1, .reusable = true}, SHIFT(3550),
  [7989] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2), SHIFT_REPEAT(2398),
  [7992] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7),
  [7994] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7),
  [7996] = {.count = 1, .reusable = true}, SHIFT(3553),
  [7998] = {.count = 1, .reusable = true}, SHIFT(3555),
  [8000] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3, .alias_sequence_id = 1),
  [8002] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [8004] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [8006] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 3, .alias_sequence_id = 1),
  [8008] = {.count = 1, .reusable = true}, SHIFT(3557),
  [8010] = {.count = 1, .reusable = true}, SHIFT(3559),
  [8012] = {.count = 1, .reusable = true}, SHIFT(3560),
  [8014] = {.count = 1, .reusable = true}, SHIFT(3561),
  [8016] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 2),
  [8018] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 2),
  [8020] = {.count = 1, .reusable = true}, SHIFT(3562),
  [8022] = {.count = 1, .reusable = true}, SHIFT(3563),
  [8024] = {.count = 1, .reusable = true}, SHIFT(3564),
  [8026] = {.count = 1, .reusable = true}, SHIFT(3565),
  [8028] = {.count = 1, .reusable = true}, SHIFT(3568),
  [8030] = {.count = 1, .reusable = true}, SHIFT(3569),
  [8032] = {.count = 1, .reusable = false}, SHIFT(3570),
  [8034] = {.count = 1, .reusable = true}, SHIFT(3570),
  [8036] = {.count = 1, .reusable = true}, SHIFT(3571),
  [8038] = {.count = 1, .reusable = false}, SHIFT(3572),
  [8040] = {.count = 1, .reusable = true}, SHIFT(3572),
  [8042] = {.count = 1, .reusable = true}, SHIFT(3573),
  [8044] = {.count = 1, .reusable = false}, SHIFT(3574),
  [8046] = {.count = 1, .reusable = true}, SHIFT(3574),
  [8048] = {.count = 1, .reusable = true}, SHIFT(3576),
  [8050] = {.count = 1, .reusable = true}, SHIFT(3577),
  [8052] = {.count = 1, .reusable = true}, SHIFT(3579),
  [8054] = {.count = 1, .reusable = true}, SHIFT(3580),
  [8056] = {.count = 1, .reusable = true}, SHIFT(3582),
  [8058] = {.count = 1, .reusable = true}, SHIFT(3584),
  [8060] = {.count = 1, .reusable = true}, SHIFT(3585),
  [8062] = {.count = 1, .reusable = true}, SHIFT(3586),
  [8064] = {.count = 1, .reusable = false}, SHIFT(3587),
  [8066] = {.count = 1, .reusable = true}, SHIFT(3587),
  [8068] = {.count = 1, .reusable = false}, SHIFT(3588),
  [8070] = {.count = 1, .reusable = true}, SHIFT(3588),
  [8072] = {.count = 1, .reusable = true}, SHIFT(3589),
  [8074] = {.count = 1, .reusable = true}, SHIFT(3590),
  [8076] = {.count = 1, .reusable = true}, SHIFT(3591),
  [8078] = {.count = 1, .reusable = true}, SHIFT(3592),
  [8080] = {.count = 1, .reusable = false}, SHIFT(3593),
  [8082] = {.count = 1, .reusable = true}, SHIFT(3593),
  [8084] = {.count = 1, .reusable = false}, SHIFT(3594),
  [8086] = {.count = 1, .reusable = true}, SHIFT(3594),
  [8088] = {.count = 1, .reusable = true}, SHIFT(3595),
  [8090] = {.count = 1, .reusable = true}, SHIFT(3596),
  [8092] = {.count = 1, .reusable = true}, SHIFT(3597),
  [8094] = {.count = 1, .reusable = true}, SHIFT(3598),
  [8096] = {.count = 1, .reusable = true}, SHIFT(3599),
  [8098] = {.count = 1, .reusable = true}, SHIFT(3600),
  [8100] = {.count = 1, .reusable = true}, SHIFT(3601),
  [8102] = {.count = 1, .reusable = true}, SHIFT(3602),
  [8104] = {.count = 1, .reusable = true}, SHIFT(3603),
  [8106] = {.count = 1, .reusable = true}, SHIFT(3604),
  [8108] = {.count = 1, .reusable = true}, SHIFT(3605),
  [8110] = {.count = 1, .reusable = true}, SHIFT(3606),
  [8112] = {.count = 1, .reusable = true}, SHIFT(3607),
  [8114] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6),
  [8116] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6, .alias_sequence_id = 4),
  [8118] = {.count = 1, .reusable = true}, SHIFT(3608),
  [8120] = {.count = 1, .reusable = true}, SHIFT(3609),
  [8122] = {.count = 1, .reusable = true}, SHIFT(3610),
  [8124] = {.count = 1, .reusable = true}, SHIFT(3613),
  [8126] = {.count = 1, .reusable = true}, SHIFT(3614),
  [8128] = {.count = 1, .reusable = false}, SHIFT(3615),
  [8130] = {.count = 1, .reusable = true}, SHIFT(3615),
  [8132] = {.count = 1, .reusable = true}, SHIFT(3616),
  [8134] = {.count = 1, .reusable = false}, SHIFT(3617),
  [8136] = {.count = 1, .reusable = true}, SHIFT(3617),
  [8138] = {.count = 1, .reusable = true}, SHIFT(3618),
  [8140] = {.count = 1, .reusable = false}, SHIFT(3619),
  [8142] = {.count = 1, .reusable = true}, SHIFT(3619),
  [8144] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7, .alias_sequence_id = 5),
  [8146] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7, .alias_sequence_id = 5),
  [8148] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7),
  [8150] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7),
  [8152] = {.count = 1, .reusable = true}, SHIFT(3620),
  [8154] = {.count = 1, .reusable = true}, SHIFT(3621),
  [8156] = {.count = 1, .reusable = true}, SHIFT(3622),
  [8158] = {.count = 1, .reusable = false}, SHIFT(3623),
  [8160] = {.count = 1, .reusable = true}, SHIFT(3623),
  [8162] = {.count = 1, .reusable = false}, SHIFT(3624),
  [8164] = {.count = 1, .reusable = true}, SHIFT(3624),
  [8166] = {.count = 1, .reusable = true}, SHIFT(3625),
  [8168] = {.count = 1, .reusable = true}, SHIFT(3626),
  [8170] = {.count = 1, .reusable = true}, SHIFT(3627),
  [8172] = {.count = 1, .reusable = true}, SHIFT(3628),
  [8174] = {.count = 1, .reusable = false}, SHIFT(3629),
  [8176] = {.count = 1, .reusable = true}, SHIFT(3629),
  [8178] = {.count = 1, .reusable = false}, SHIFT(3630),
  [8180] = {.count = 1, .reusable = true}, SHIFT(3630),
  [8182] = {.count = 1, .reusable = true}, SHIFT(3631),
  [8184] = {.count = 1, .reusable = true}, SHIFT(3632),
  [8186] = {.count = 1, .reusable = true}, SHIFT(3633),
  [8188] = {.count = 1, .reusable = true}, SHIFT(3634),
  [8190] = {.count = 1, .reusable = false}, SHIFT(3635),
  [8192] = {.count = 1, .reusable = true}, SHIFT(3635),
  [8194] = {.count = 1, .reusable = false}, SHIFT(3636),
  [8196] = {.count = 1, .reusable = true}, SHIFT(3636),
  [8198] = {.count = 1, .reusable = true}, SHIFT(3637),
  [8200] = {.count = 1, .reusable = true}, SHIFT(3638),
  [8202] = {.count = 1, .reusable = true}, SHIFT(3639),
  [8204] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 8),
  [8206] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 8),
  [8208] = {.count = 1, .reusable = true}, SHIFT(3641),
  [8210] = {.count = 1, .reusable = true}, SHIFT(3642),
  [8212] = {.count = 1, .reusable = true}, SHIFT(3643),
  [8214] = {.count = 1, .reusable = true}, SHIFT(3644),
  [8216] = {.count = 1, .reusable = true}, SHIFT(3645),
  [8218] = {.count = 1, .reusable = true}, SHIFT(3646),
  [8220] = {.count = 1, .reusable = false}, SHIFT(3647),
  [8222] = {.count = 1, .reusable = true}, SHIFT(3647),
  [8224] = {.count = 1, .reusable = false}, SHIFT(3648),
  [8226] = {.count = 1, .reusable = true}, SHIFT(3648),
  [8228] = {.count = 1, .reusable = true}, SHIFT(3649),
  [8230] = {.count = 1, .reusable = true}, SHIFT(3650),
  [8232] = {.count = 1, .reusable = true}, SHIFT(3651),
  [8234] = {.count = 1, .reusable = true}, SHIFT(3652),
  [8236] = {.count = 1, .reusable = true}, SHIFT(3653),
  [8238] = {.count = 1, .reusable = true}, SHIFT(3654),
  [8240] = {.count = 1, .reusable = false}, SHIFT(3655),
  [8242] = {.count = 1, .reusable = true}, SHIFT(3655),
  [8244] = {.count = 1, .reusable = false}, SHIFT(3656),
  [8246] = {.count = 1, .reusable = true}, SHIFT(3656),
  [8248] = {.count = 1, .reusable = true}, SHIFT(3657),
  [8250] = {.count = 1, .reusable = true}, SHIFT(3659),
  [8252] = {.count = 1, .reusable = true}, SHIFT(3660),
  [8254] = {.count = 1, .reusable = true}, SHIFT(3661),
  [8256] = {.count = 1, .reusable = true}, SHIFT(3662),
  [8258] = {.count = 1, .reusable = true}, SHIFT(3663),
  [8260] = {.count = 1, .reusable = true}, SHIFT(3664),
  [8262] = {.count = 1, .reusable = true}, SHIFT(3665),
  [8264] = {.count = 1, .reusable = true}, SHIFT(3666),
  [8266] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2766),
  [8269] = {.count = 1, .reusable = false}, SHIFT(3667),
  [8271] = {.count = 1, .reusable = true}, SHIFT(3668),
  [8273] = {.count = 1, .reusable = true}, SHIFT(3669),
  [8275] = {.count = 1, .reusable = true}, SHIFT(3672),
  [8277] = {.count = 1, .reusable = true}, SHIFT(3673),
  [8279] = {.count = 1, .reusable = false}, SHIFT(3675),
  [8281] = {.count = 1, .reusable = true}, SHIFT(3675),
  [8283] = {.count = 1, .reusable = true}, SHIFT(3674),
  [8285] = {.count = 1, .reusable = false}, SHIFT(3677),
  [8287] = {.count = 1, .reusable = true}, SHIFT(3677),
  [8289] = {.count = 1, .reusable = true}, SHIFT(3676),
  [8291] = {.count = 1, .reusable = true}, SHIFT(3678),
  [8293] = {.count = 1, .reusable = true}, SHIFT(3679),
  [8295] = {.count = 1, .reusable = false}, SHIFT(3680),
  [8297] = {.count = 1, .reusable = true}, SHIFT(3680),
  [8299] = {.count = 1, .reusable = true}, SHIFT(3681),
  [8301] = {.count = 1, .reusable = true}, SHIFT(3682),
  [8303] = {.count = 1, .reusable = true}, SHIFT(3683),
  [8305] = {.count = 1, .reusable = true}, SHIFT(3684),
  [8307] = {.count = 1, .reusable = true}, SHIFT(3685),
  [8309] = {.count = 1, .reusable = true}, SHIFT(3688),
  [8311] = {.count = 1, .reusable = true}, SHIFT(3689),
  [8313] = {.count = 1, .reusable = false}, SHIFT(3690),
  [8315] = {.count = 1, .reusable = true}, SHIFT(3690),
  [8317] = {.count = 1, .reusable = true}, SHIFT(3691),
  [8319] = {.count = 1, .reusable = false}, SHIFT(3692),
  [8321] = {.count = 1, .reusable = true}, SHIFT(3692),
  [8323] = {.count = 1, .reusable = true}, SHIFT(3693),
  [8325] = {.count = 1, .reusable = false}, SHIFT(3694),
  [8327] = {.count = 1, .reusable = true}, SHIFT(3694),
  [8329] = {.count = 1, .reusable = true}, SHIFT(3695),
  [8331] = {.count = 1, .reusable = true}, SHIFT(3696),
  [8333] = {.count = 1, .reusable = true}, SHIFT(3697),
  [8335] = {.count = 1, .reusable = true}, SHIFT(3700),
  [8337] = {.count = 1, .reusable = true}, SHIFT(3701),
  [8339] = {.count = 1, .reusable = false}, SHIFT(3702),
  [8341] = {.count = 1, .reusable = true}, SHIFT(3702),
  [8343] = {.count = 1, .reusable = true}, SHIFT(3703),
  [8345] = {.count = 1, .reusable = false}, SHIFT(3704),
  [8347] = {.count = 1, .reusable = true}, SHIFT(3704),
  [8349] = {.count = 1, .reusable = true}, SHIFT(3705),
  [8351] = {.count = 1, .reusable = false}, SHIFT(3706),
  [8353] = {.count = 1, .reusable = true}, SHIFT(3706),
  [8355] = {.count = 1, .reusable = true}, SHIFT(3707),
  [8357] = {.count = 1, .reusable = true}, SHIFT(3708),
  [8359] = {.count = 1, .reusable = true}, SHIFT(3709),
  [8361] = {.count = 1, .reusable = false}, SHIFT(3710),
  [8363] = {.count = 1, .reusable = true}, SHIFT(3710),
  [8365] = {.count = 1, .reusable = false}, SHIFT(3711),
  [8367] = {.count = 1, .reusable = true}, SHIFT(3711),
  [8369] = {.count = 1, .reusable = true}, SHIFT(3712),
  [8371] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2837),
  [8374] = {.count = 1, .reusable = false}, SHIFT(3713),
  [8376] = {.count = 1, .reusable = true}, SHIFT(3714),
  [8378] = {.count = 1, .reusable = true}, SHIFT(3715),
  [8380] = {.count = 1, .reusable = true}, SHIFT(3718),
  [8382] = {.count = 1, .reusable = true}, SHIFT(3719),
  [8384] = {.count = 1, .reusable = false}, SHIFT(3721),
  [8386] = {.count = 1, .reusable = true}, SHIFT(3721),
  [8388] = {.count = 1, .reusable = true}, SHIFT(3720),
  [8390] = {.count = 1, .reusable = false}, SHIFT(3723),
  [8392] = {.count = 1, .reusable = true}, SHIFT(3723),
  [8394] = {.count = 1, .reusable = true}, SHIFT(3722),
  [8396] = {.count = 1, .reusable = true}, SHIFT(3724),
  [8398] = {.count = 1, .reusable = true}, SHIFT(3725),
  [8400] = {.count = 1, .reusable = false}, SHIFT(3726),
  [8402] = {.count = 1, .reusable = true}, SHIFT(3726),
  [8404] = {.count = 1, .reusable = true}, SHIFT(3727),
  [8406] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2858),
  [8409] = {.count = 1, .reusable = false}, SHIFT(3728),
  [8411] = {.count = 1, .reusable = true}, SHIFT(3729),
  [8413] = {.count = 1, .reusable = true}, SHIFT(3730),
  [8415] = {.count = 1, .reusable = true}, SHIFT(3733),
  [8417] = {.count = 1, .reusable = true}, SHIFT(3734),
  [8419] = {.count = 1, .reusable = false}, SHIFT(3736),
  [8421] = {.count = 1, .reusable = true}, SHIFT(3736),
  [8423] = {.count = 1, .reusable = true}, SHIFT(3735),
  [8425] = {.count = 1, .reusable = false}, SHIFT(3738),
  [8427] = {.count = 1, .reusable = true}, SHIFT(3738),
  [8429] = {.count = 1, .reusable = true}, SHIFT(3737),
  [8431] = {.count = 1, .reusable = true}, SHIFT(3739),
  [8433] = {.count = 1, .reusable = true}, SHIFT(3740),
  [8435] = {.count = 1, .reusable = false}, SHIFT(3741),
  [8437] = {.count = 1, .reusable = true}, SHIFT(3741),
  [8439] = {.count = 1, .reusable = true}, SHIFT(3742),
  [8441] = {.count = 1, .reusable = true}, SHIFT(3743),
  [8443] = {.count = 1, .reusable = true}, SHIFT(3744),
  [8445] = {.count = 1, .reusable = false}, SHIFT(3746),
  [8447] = {.count = 1, .reusable = false}, SHIFT(3747),
  [8449] = {.count = 1, .reusable = true}, SHIFT(3748),
  [8451] = {.count = 1, .reusable = true}, SHIFT(3749),
  [8453] = {.count = 1, .reusable = true}, SHIFT(3750),
  [8455] = {.count = 1, .reusable = false}, SHIFT(3751),
  [8457] = {.count = 1, .reusable = true}, SHIFT(3751),
  [8459] = {.count = 1, .reusable = true}, SHIFT(3752),
  [8461] = {.count = 1, .reusable = false}, SHIFT(3754),
  [8463] = {.count = 1, .reusable = true}, SHIFT(3754),
  [8465] = {.count = 1, .reusable = true}, SHIFT(3753),
  [8467] = {.count = 1, .reusable = true}, SHIFT(3755),
  [8469] = {.count = 1, .reusable = false}, SHIFT(3757),
  [8471] = {.count = 1, .reusable = true}, SHIFT(3757),
  [8473] = {.count = 1, .reusable = true}, SHIFT(3756),
  [8475] = {.count = 1, .reusable = true}, SHIFT(3758),
  [8477] = {.count = 1, .reusable = true}, SHIFT(3759),
  [8479] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(3392),
  [8482] = {.count = 1, .reusable = true}, SHIFT(3760),
  [8484] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2889),
  [8487] = {.count = 1, .reusable = false}, SHIFT(3762),
  [8489] = {.count = 1, .reusable = true}, SHIFT(3763),
  [8491] = {.count = 1, .reusable = true}, SHIFT(3764),
  [8493] = {.count = 1, .reusable = true}, SHIFT(3767),
  [8495] = {.count = 1, .reusable = true}, SHIFT(3768),
  [8497] = {.count = 1, .reusable = false}, SHIFT(3770),
  [8499] = {.count = 1, .reusable = true}, SHIFT(3770),
  [8501] = {.count = 1, .reusable = true}, SHIFT(3769),
  [8503] = {.count = 1, .reusable = false}, SHIFT(3772),
  [8505] = {.count = 1, .reusable = true}, SHIFT(3772),
  [8507] = {.count = 1, .reusable = true}, SHIFT(3771),
  [8509] = {.count = 1, .reusable = true}, SHIFT(3773),
  [8511] = {.count = 1, .reusable = true}, SHIFT(3774),
  [8513] = {.count = 1, .reusable = false}, SHIFT(3775),
  [8515] = {.count = 1, .reusable = true}, SHIFT(3775),
  [8517] = {.count = 1, .reusable = true}, SHIFT(3776),
  [8519] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2908),
  [8522] = {.count = 1, .reusable = false}, SHIFT(3777),
  [8524] = {.count = 1, .reusable = true}, SHIFT(3778),
  [8526] = {.count = 1, .reusable = true}, SHIFT(3779),
  [8528] = {.count = 1, .reusable = true}, SHIFT(3782),
  [8530] = {.count = 1, .reusable = true}, SHIFT(3783),
  [8532] = {.count = 1, .reusable = false}, SHIFT(3785),
  [8534] = {.count = 1, .reusable = true}, SHIFT(3785),
  [8536] = {.count = 1, .reusable = true}, SHIFT(3784),
  [8538] = {.count = 1, .reusable = false}, SHIFT(3787),
  [8540] = {.count = 1, .reusable = true}, SHIFT(3787),
  [8542] = {.count = 1, .reusable = true}, SHIFT(3786),
  [8544] = {.count = 1, .reusable = true}, SHIFT(3788),
  [8546] = {.count = 1, .reusable = true}, SHIFT(3789),
  [8548] = {.count = 1, .reusable = false}, SHIFT(3790),
  [8550] = {.count = 1, .reusable = true}, SHIFT(3790),
  [8552] = {.count = 1, .reusable = true}, SHIFT(3791),
  [8554] = {.count = 1, .reusable = true}, SHIFT(3792),
  [8556] = {.count = 1, .reusable = true}, SHIFT(3793),
  [8558] = {.count = 1, .reusable = true}, SHIFT(3794),
  [8560] = {.count = 1, .reusable = true}, SHIFT(3797),
  [8562] = {.count = 1, .reusable = true}, SHIFT(3798),
  [8564] = {.count = 1, .reusable = false}, SHIFT(3799),
  [8566] = {.count = 1, .reusable = true}, SHIFT(3799),
  [8568] = {.count = 1, .reusable = true}, SHIFT(3800),
  [8570] = {.count = 1, .reusable = false}, SHIFT(3801),
  [8572] = {.count = 1, .reusable = true}, SHIFT(3801),
  [8574] = {.count = 1, .reusable = true}, SHIFT(3802),
  [8576] = {.count = 1, .reusable = false}, SHIFT(3803),
  [8578] = {.count = 1, .reusable = true}, SHIFT(3803),
  [8580] = {.count = 1, .reusable = true}, SHIFT(3805),
  [8582] = {.count = 1, .reusable = true}, SHIFT(3806),
  [8584] = {.count = 1, .reusable = true}, SHIFT(3807),
  [8586] = {.count = 1, .reusable = true}, SHIFT(3808),
  [8588] = {.count = 1, .reusable = true}, SHIFT(3811),
  [8590] = {.count = 1, .reusable = true}, SHIFT(3812),
  [8592] = {.count = 1, .reusable = false}, SHIFT(3813),
  [8594] = {.count = 1, .reusable = true}, SHIFT(3813),
  [8596] = {.count = 1, .reusable = true}, SHIFT(3814),
  [8598] = {.count = 1, .reusable = false}, SHIFT(3815),
  [8600] = {.count = 1, .reusable = true}, SHIFT(3815),
  [8602] = {.count = 1, .reusable = true}, SHIFT(3816),
  [8604] = {.count = 1, .reusable = false}, SHIFT(3817),
  [8606] = {.count = 1, .reusable = true}, SHIFT(3817),
  [8608] = {.count = 1, .reusable = true}, SHIFT(3818),
  [8610] = {.count = 1, .reusable = true}, SHIFT(3819),
  [8612] = {.count = 1, .reusable = true}, SHIFT(3820),
  [8614] = {.count = 1, .reusable = true}, SHIFT(3823),
  [8616] = {.count = 1, .reusable = true}, SHIFT(3824),
  [8618] = {.count = 1, .reusable = false}, SHIFT(3825),
  [8620] = {.count = 1, .reusable = true}, SHIFT(3825),
  [8622] = {.count = 1, .reusable = true}, SHIFT(3826),
  [8624] = {.count = 1, .reusable = false}, SHIFT(3827),
  [8626] = {.count = 1, .reusable = true}, SHIFT(3827),
  [8628] = {.count = 1, .reusable = true}, SHIFT(3828),
  [8630] = {.count = 1, .reusable = false}, SHIFT(3829),
  [8632] = {.count = 1, .reusable = true}, SHIFT(3829),
  [8634] = {.count = 1, .reusable = true}, SHIFT(3830),
  [8636] = {.count = 1, .reusable = true}, SHIFT(3831),
  [8638] = {.count = 1, .reusable = true}, SHIFT(3832),
  [8640] = {.count = 1, .reusable = false}, SHIFT(3833),
  [8642] = {.count = 1, .reusable = true}, SHIFT(3833),
  [8644] = {.count = 1, .reusable = false}, SHIFT(3834),
  [8646] = {.count = 1, .reusable = true}, SHIFT(3834),
  [8648] = {.count = 1, .reusable = true}, SHIFT(3835),
  [8650] = {.count = 1, .reusable = true}, SHIFT(3836),
  [8652] = {.count = 1, .reusable = true}, SHIFT(3837),
  [8654] = {.count = 1, .reusable = true}, SHIFT(3838),
  [8656] = {.count = 1, .reusable = true}, SHIFT(3839),
  [8658] = {.count = 1, .reusable = false}, SHIFT(3840),
  [8660] = {.count = 1, .reusable = true}, SHIFT(3841),
  [8662] = {.count = 1, .reusable = true}, SHIFT(3842),
  [8664] = {.count = 1, .reusable = true}, SHIFT(3843),
  [8666] = {.count = 1, .reusable = true}, SHIFT(3844),
  [8668] = {.count = 1, .reusable = true}, SHIFT(3845),
  [8670] = {.count = 1, .reusable = true}, SHIFT(3847),
  [8672] = {.count = 1, .reusable = true}, SHIFT(3848),
  [8674] = {.count = 1, .reusable = false}, SHIFT(3850),
  [8676] = {.count = 1, .reusable = false}, SHIFT(3851),
  [8678] = {.count = 1, .reusable = true}, SHIFT(3853),
  [8680] = {.count = 1, .reusable = true}, SHIFT(3854),
  [8682] = {.count = 1, .reusable = false}, SHIFT(3855),
  [8684] = {.count = 1, .reusable = true}, SHIFT(3855),
  [8686] = {.count = 1, .reusable = true}, SHIFT(3856),
  [8688] = {.count = 1, .reusable = true}, SHIFT(3857),
  [8690] = {.count = 1, .reusable = true}, SHIFT(3858),
  [8692] = {.count = 1, .reusable = false}, SHIFT(3859),
  [8694] = {.count = 1, .reusable = true}, SHIFT(3859),
  [8696] = {.count = 1, .reusable = false}, SHIFT(3864),
  [8698] = {.count = 1, .reusable = true}, SHIFT(3865),
  [8700] = {.count = 1, .reusable = true}, SHIFT(3867),
  [8702] = {.count = 1, .reusable = false}, SHIFT(3869),
  [8704] = {.count = 1, .reusable = false}, SHIFT(3870),
  [8706] = {.count = 1, .reusable = true}, SHIFT(3872),
  [8708] = {.count = 1, .reusable = true}, SHIFT(3873),
  [8710] = {.count = 1, .reusable = false}, SHIFT(3874),
  [8712] = {.count = 1, .reusable = true}, SHIFT(3874),
  [8714] = {.count = 1, .reusable = true}, SHIFT(3875),
  [8716] = {.count = 1, .reusable = true}, SHIFT(3876),
  [8718] = {.count = 1, .reusable = true}, SHIFT(3877),
  [8720] = {.count = 1, .reusable = false}, SHIFT(3878),
  [8722] = {.count = 1, .reusable = true}, SHIFT(3878),
  [8724] = {.count = 1, .reusable = false}, SHIFT(3883),
  [8726] = {.count = 1, .reusable = true}, SHIFT(3884),
  [8728] = {.count = 1, .reusable = true}, SHIFT(3886),
  [8730] = {.count = 1, .reusable = false}, SHIFT(3888),
  [8732] = {.count = 1, .reusable = false}, SHIFT(3889),
  [8734] = {.count = 1, .reusable = true}, SHIFT(3890),
  [8736] = {.count = 1, .reusable = true}, SHIFT(3891),
  [8738] = {.count = 1, .reusable = true}, SHIFT(3892),
  [8740] = {.count = 1, .reusable = false}, SHIFT(3893),
  [8742] = {.count = 1, .reusable = true}, SHIFT(3893),
  [8744] = {.count = 1, .reusable = true}, SHIFT(3894),
  [8746] = {.count = 1, .reusable = false}, SHIFT(3896),
  [8748] = {.count = 1, .reusable = true}, SHIFT(3896),
  [8750] = {.count = 1, .reusable = true}, SHIFT(3895),
  [8752] = {.count = 1, .reusable = true}, SHIFT(3897),
  [8754] = {.count = 1, .reusable = false}, SHIFT(3899),
  [8756] = {.count = 1, .reusable = true}, SHIFT(3899),
  [8758] = {.count = 1, .reusable = true}, SHIFT(3898),
  [8760] = {.count = 1, .reusable = true}, SHIFT(3900),
  [8762] = {.count = 1, .reusable = true}, SHIFT(3901),
  [8764] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4),
  [8766] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4),
  [8768] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4),
  [8770] = {.count = 1, .reusable = false}, SHIFT(3902),
  [8772] = {.count = 1, .reusable = true}, SHIFT(3902),
  [8774] = {.count = 1, .reusable = true}, SHIFT(3907),
  [8776] = {.count = 1, .reusable = true}, SHIFT(3908),
  [8778] = {.count = 1, .reusable = true}, SHIFT(3910),
  [8780] = {.count = 1, .reusable = false}, SHIFT(3912),
  [8782] = {.count = 1, .reusable = true}, SHIFT(3912),
  [8784] = {.count = 1, .reusable = true}, SHIFT(3914),
  [8786] = {.count = 1, .reusable = true}, SHIFT(3915),
  [8788] = {.count = 1, .reusable = false}, SHIFT(3918),
  [8790] = {.count = 1, .reusable = true}, SHIFT(3918),
  [8792] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(3550),
  [8795] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 4),
  [8797] = {.count = 1, .reusable = true}, SHIFT(3921),
  [8799] = {.count = 1, .reusable = true}, SHIFT(3922),
  [8801] = {.count = 1, .reusable = true}, SHIFT(3927),
  [8803] = {.count = 1, .reusable = true}, SHIFT(3928),
  [8805] = {.count = 1, .reusable = true}, SHIFT(3930),
  [8807] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4, .alias_sequence_id = 1),
  [8809] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [8811] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [8813] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 4, .alias_sequence_id = 1),
  [8815] = {.count = 1, .reusable = true}, SHIFT(3931),
  [8817] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8),
  [8819] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8),
  [8821] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 2),
  [8823] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 2),
  [8825] = {.count = 1, .reusable = true}, SHIFT(3932),
  [8827] = {.count = 1, .reusable = true}, SHIFT(3933),
  [8829] = {.count = 1, .reusable = true}, SHIFT(3934),
  [8831] = {.count = 1, .reusable = false}, SHIFT(3935),
  [8833] = {.count = 1, .reusable = true}, SHIFT(3935),
  [8835] = {.count = 1, .reusable = false}, SHIFT(3936),
  [8837] = {.count = 1, .reusable = true}, SHIFT(3936),
  [8839] = {.count = 1, .reusable = true}, SHIFT(3937),
  [8841] = {.count = 1, .reusable = true}, SHIFT(3939),
  [8843] = {.count = 1, .reusable = true}, SHIFT(3940),
  [8845] = {.count = 1, .reusable = true}, SHIFT(3941),
  [8847] = {.count = 1, .reusable = true}, SHIFT(3942),
  [8849] = {.count = 1, .reusable = true}, SHIFT(3943),
  [8851] = {.count = 1, .reusable = true}, SHIFT(3944),
  [8853] = {.count = 1, .reusable = true}, SHIFT(3945),
  [8855] = {.count = 1, .reusable = true}, SHIFT(3946),
  [8857] = {.count = 1, .reusable = true}, SHIFT(3947),
  [8859] = {.count = 1, .reusable = true}, SHIFT(3948),
  [8861] = {.count = 1, .reusable = true}, SHIFT(3949),
  [8863] = {.count = 1, .reusable = false}, SHIFT(3950),
  [8865] = {.count = 1, .reusable = true}, SHIFT(3950),
  [8867] = {.count = 1, .reusable = false}, SHIFT(3951),
  [8869] = {.count = 1, .reusable = true}, SHIFT(3951),
  [8871] = {.count = 1, .reusable = true}, SHIFT(3952),
  [8873] = {.count = 1, .reusable = true}, SHIFT(3953),
  [8875] = {.count = 1, .reusable = true}, SHIFT(3954),
  [8877] = {.count = 1, .reusable = true}, SHIFT(3955),
  [8879] = {.count = 1, .reusable = true}, SHIFT(3956),
  [8881] = {.count = 1, .reusable = true}, SHIFT(3957),
  [8883] = {.count = 1, .reusable = true}, SHIFT(3958),
  [8885] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 9),
  [8887] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 9),
  [8889] = {.count = 1, .reusable = true}, SHIFT(3960),
  [8891] = {.count = 1, .reusable = true}, SHIFT(3961),
  [8893] = {.count = 1, .reusable = true}, SHIFT(3962),
  [8895] = {.count = 1, .reusable = true}, SHIFT(3963),
  [8897] = {.count = 1, .reusable = true}, SHIFT(3965),
  [8899] = {.count = 1, .reusable = true}, SHIFT(3966),
  [8901] = {.count = 1, .reusable = true}, SHIFT(3967),
  [8903] = {.count = 1, .reusable = true}, SHIFT(3968),
  [8905] = {.count = 1, .reusable = true}, SHIFT(3971),
  [8907] = {.count = 1, .reusable = true}, SHIFT(3972),
  [8909] = {.count = 1, .reusable = false}, SHIFT(3973),
  [8911] = {.count = 1, .reusable = true}, SHIFT(3973),
  [8913] = {.count = 1, .reusable = true}, SHIFT(3974),
  [8915] = {.count = 1, .reusable = false}, SHIFT(3975),
  [8917] = {.count = 1, .reusable = true}, SHIFT(3975),
  [8919] = {.count = 1, .reusable = true}, SHIFT(3976),
  [8921] = {.count = 1, .reusable = false}, SHIFT(3977),
  [8923] = {.count = 1, .reusable = true}, SHIFT(3977),
  [8925] = {.count = 1, .reusable = true}, SHIFT(3978),
  [8927] = {.count = 1, .reusable = true}, SHIFT(3979),
  [8929] = {.count = 1, .reusable = true}, SHIFT(3980),
  [8931] = {.count = 1, .reusable = false}, SHIFT(3981),
  [8933] = {.count = 1, .reusable = true}, SHIFT(3981),
  [8935] = {.count = 1, .reusable = false}, SHIFT(3982),
  [8937] = {.count = 1, .reusable = true}, SHIFT(3982),
  [8939] = {.count = 1, .reusable = true}, SHIFT(3983),
  [8941] = {.count = 1, .reusable = true}, SHIFT(3984),
  [8943] = {.count = 1, .reusable = true}, SHIFT(3985),
  [8945] = {.count = 1, .reusable = true}, SHIFT(3986),
  [8947] = {.count = 1, .reusable = false}, SHIFT(3987),
  [8949] = {.count = 1, .reusable = true}, SHIFT(3987),
  [8951] = {.count = 1, .reusable = false}, SHIFT(3988),
  [8953] = {.count = 1, .reusable = true}, SHIFT(3988),
  [8955] = {.count = 1, .reusable = true}, SHIFT(3989),
  [8957] = {.count = 1, .reusable = true}, SHIFT(3990),
  [8959] = {.count = 1, .reusable = true}, SHIFT(3991),
  [8961] = {.count = 1, .reusable = true}, SHIFT(3992),
  [8963] = {.count = 1, .reusable = true}, SHIFT(3993),
  [8965] = {.count = 1, .reusable = true}, SHIFT(3994),
  [8967] = {.count = 1, .reusable = true}, SHIFT(3997),
  [8969] = {.count = 1, .reusable = true}, SHIFT(3998),
  [8971] = {.count = 1, .reusable = false}, SHIFT(3999),
  [8973] = {.count = 1, .reusable = true}, SHIFT(3999),
  [8975] = {.count = 1, .reusable = true}, SHIFT(4000),
  [8977] = {.count = 1, .reusable = false}, SHIFT(4001),
  [8979] = {.count = 1, .reusable = true}, SHIFT(4001),
  [8981] = {.count = 1, .reusable = true}, SHIFT(4002),
  [8983] = {.count = 1, .reusable = false}, SHIFT(4003),
  [8985] = {.count = 1, .reusable = true}, SHIFT(4003),
  [8987] = {.count = 1, .reusable = true}, SHIFT(4004),
  [8989] = {.count = 1, .reusable = true}, SHIFT(4005),
  [8991] = {.count = 1, .reusable = true}, SHIFT(4006),
  [8993] = {.count = 1, .reusable = true}, SHIFT(4009),
  [8995] = {.count = 1, .reusable = true}, SHIFT(4010),
  [8997] = {.count = 1, .reusable = false}, SHIFT(4011),
  [8999] = {.count = 1, .reusable = true}, SHIFT(4011),
  [9001] = {.count = 1, .reusable = true}, SHIFT(4012),
  [9003] = {.count = 1, .reusable = false}, SHIFT(4013),
  [9005] = {.count = 1, .reusable = true}, SHIFT(4013),
  [9007] = {.count = 1, .reusable = true}, SHIFT(4014),
  [9009] = {.count = 1, .reusable = false}, SHIFT(4015),
  [9011] = {.count = 1, .reusable = true}, SHIFT(4015),
  [9013] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(3376),
  [9016] = {.count = 1, .reusable = false}, SHIFT(4016),
  [9018] = {.count = 1, .reusable = true}, SHIFT(4017),
  [9020] = {.count = 1, .reusable = true}, SHIFT(4018),
  [9022] = {.count = 1, .reusable = true}, SHIFT(4021),
  [9024] = {.count = 1, .reusable = true}, SHIFT(4022),
  [9026] = {.count = 1, .reusable = false}, SHIFT(4024),
  [9028] = {.count = 1, .reusable = true}, SHIFT(4024),
  [9030] = {.count = 1, .reusable = true}, SHIFT(4023),
  [9032] = {.count = 1, .reusable = false}, SHIFT(4026),
  [9034] = {.count = 1, .reusable = true}, SHIFT(4026),
  [9036] = {.count = 1, .reusable = true}, SHIFT(4025),
  [9038] = {.count = 1, .reusable = true}, SHIFT(4027),
  [9040] = {.count = 1, .reusable = true}, SHIFT(4028),
  [9042] = {.count = 1, .reusable = false}, SHIFT(4029),
  [9044] = {.count = 1, .reusable = true}, SHIFT(4029),
  [9046] = {.count = 1, .reusable = true}, SHIFT(4030),
  [9048] = {.count = 1, .reusable = true}, SHIFT(4031),
  [9050] = {.count = 1, .reusable = true}, SHIFT(4032),
  [9052] = {.count = 1, .reusable = true}, SHIFT(4033),
  [9054] = {.count = 1, .reusable = true}, SHIFT(4034),
  [9056] = {.count = 1, .reusable = true}, SHIFT(4037),
  [9058] = {.count = 1, .reusable = true}, SHIFT(4038),
  [9060] = {.count = 1, .reusable = false}, SHIFT(4039),
  [9062] = {.count = 1, .reusable = true}, SHIFT(4039),
  [9064] = {.count = 1, .reusable = true}, SHIFT(4040),
  [9066] = {.count = 1, .reusable = false}, SHIFT(4041),
  [9068] = {.count = 1, .reusable = true}, SHIFT(4041),
  [9070] = {.count = 1, .reusable = true}, SHIFT(4042),
  [9072] = {.count = 1, .reusable = false}, SHIFT(4043),
  [9074] = {.count = 1, .reusable = true}, SHIFT(4043),
  [9076] = {.count = 1, .reusable = true}, SHIFT(4044),
  [9078] = {.count = 1, .reusable = true}, SHIFT(4045),
  [9080] = {.count = 1, .reusable = true}, SHIFT(4046),
  [9082] = {.count = 1, .reusable = true}, SHIFT(4049),
  [9084] = {.count = 1, .reusable = true}, SHIFT(4050),
  [9086] = {.count = 1, .reusable = false}, SHIFT(4051),
  [9088] = {.count = 1, .reusable = true}, SHIFT(4051),
  [9090] = {.count = 1, .reusable = true}, SHIFT(4052),
  [9092] = {.count = 1, .reusable = false}, SHIFT(4053),
  [9094] = {.count = 1, .reusable = true}, SHIFT(4053),
  [9096] = {.count = 1, .reusable = true}, SHIFT(4054),
  [9098] = {.count = 1, .reusable = false}, SHIFT(4055),
  [9100] = {.count = 1, .reusable = true}, SHIFT(4055),
  [9102] = {.count = 1, .reusable = true}, SHIFT(4056),
  [9104] = {.count = 1, .reusable = true}, SHIFT(4057),
  [9106] = {.count = 1, .reusable = true}, SHIFT(4058),
  [9108] = {.count = 1, .reusable = false}, SHIFT(4059),
  [9110] = {.count = 1, .reusable = true}, SHIFT(4059),
  [9112] = {.count = 1, .reusable = false}, SHIFT(4060),
  [9114] = {.count = 1, .reusable = true}, SHIFT(4060),
  [9116] = {.count = 1, .reusable = true}, SHIFT(4061),
  [9118] = {.count = 1, .reusable = true}, SHIFT(4062),
  [9120] = {.count = 1, .reusable = true}, SHIFT(4063),
  [9122] = {.count = 1, .reusable = true}, SHIFT(4064),
  [9124] = {.count = 1, .reusable = false}, SHIFT(4065),
  [9126] = {.count = 1, .reusable = true}, SHIFT(4065),
  [9128] = {.count = 1, .reusable = false}, SHIFT(4066),
  [9130] = {.count = 1, .reusable = true}, SHIFT(4066),
  [9132] = {.count = 1, .reusable = true}, SHIFT(4067),
  [9134] = {.count = 1, .reusable = true}, SHIFT(4068),
  [9136] = {.count = 1, .reusable = true}, SHIFT(4069),
  [9138] = {.count = 1, .reusable = true}, SHIFT(4070),
  [9140] = {.count = 1, .reusable = false}, SHIFT(4071),
  [9142] = {.count = 1, .reusable = true}, SHIFT(4071),
  [9144] = {.count = 1, .reusable = false}, SHIFT(4072),
  [9146] = {.count = 1, .reusable = true}, SHIFT(4072),
  [9148] = {.count = 1, .reusable = true}, SHIFT(4073),
  [9150] = {.count = 1, .reusable = true}, SHIFT(4074),
  [9152] = {.count = 1, .reusable = true}, SHIFT(4075),
  [9154] = {.count = 1, .reusable = true}, SHIFT(4076),
  [9156] = {.count = 1, .reusable = true}, SHIFT(4078),
  [9158] = {.count = 1, .reusable = false}, SHIFT(4080),
  [9160] = {.count = 1, .reusable = false}, SHIFT(4081),
  [9162] = {.count = 1, .reusable = true}, SHIFT(4083),
  [9164] = {.count = 1, .reusable = true}, SHIFT(4084),
  [9166] = {.count = 1, .reusable = false}, SHIFT(4085),
  [9168] = {.count = 1, .reusable = true}, SHIFT(4085),
  [9170] = {.count = 1, .reusable = true}, SHIFT(4086),
  [9172] = {.count = 1, .reusable = true}, SHIFT(4087),
  [9174] = {.count = 1, .reusable = true}, SHIFT(4088),
  [9176] = {.count = 1, .reusable = false}, SHIFT(4089),
  [9178] = {.count = 1, .reusable = true}, SHIFT(4089),
  [9180] = {.count = 1, .reusable = true}, SHIFT(4094),
  [9182] = {.count = 1, .reusable = true}, SHIFT(4096),
  [9184] = {.count = 1, .reusable = true}, SHIFT(4097),
  [9186] = {.count = 1, .reusable = true}, SHIFT(4098),
  [9188] = {.count = 1, .reusable = true}, SHIFT(4100),
  [9190] = {.count = 1, .reusable = false}, SHIFT(4102),
  [9192] = {.count = 1, .reusable = false}, SHIFT(4103),
  [9194] = {.count = 1, .reusable = true}, SHIFT(4104),
  [9196] = {.count = 1, .reusable = true}, SHIFT(4105),
  [9198] = {.count = 1, .reusable = true}, SHIFT(4106),
  [9200] = {.count = 1, .reusable = false}, SHIFT(4107),
  [9202] = {.count = 1, .reusable = true}, SHIFT(4107),
  [9204] = {.count = 1, .reusable = true}, SHIFT(4108),
  [9206] = {.count = 1, .reusable = false}, SHIFT(4110),
  [9208] = {.count = 1, .reusable = true}, SHIFT(4110),
  [9210] = {.count = 1, .reusable = true}, SHIFT(4109),
  [9212] = {.count = 1, .reusable = true}, SHIFT(4111),
  [9214] = {.count = 1, .reusable = false}, SHIFT(4113),
  [9216] = {.count = 1, .reusable = true}, SHIFT(4113),
  [9218] = {.count = 1, .reusable = true}, SHIFT(4112),
  [9220] = {.count = 1, .reusable = true}, SHIFT(4114),
  [9222] = {.count = 1, .reusable = true}, SHIFT(4115),
  [9224] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3496),
  [9227] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3497),
  [9230] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3498),
  [9233] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3499),
  [9236] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3500),
  [9239] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3501),
  [9242] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3502),
  [9245] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3503),
  [9248] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3504),
  [9251] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3864),
  [9254] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(3500),
  [9257] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(3865),
  [9260] = {.count = 1, .reusable = true}, SHIFT(4116),
  [9262] = {.count = 1, .reusable = false}, SHIFT(4118),
  [9264] = {.count = 1, .reusable = false}, SHIFT(4119),
  [9266] = {.count = 1, .reusable = true}, SHIFT(4120),
  [9268] = {.count = 1, .reusable = true}, SHIFT(4121),
  [9270] = {.count = 1, .reusable = true}, SHIFT(4122),
  [9272] = {.count = 1, .reusable = false}, SHIFT(4123),
  [9274] = {.count = 1, .reusable = true}, SHIFT(4123),
  [9276] = {.count = 1, .reusable = true}, SHIFT(4124),
  [9278] = {.count = 1, .reusable = false}, SHIFT(4126),
  [9280] = {.count = 1, .reusable = true}, SHIFT(4126),
  [9282] = {.count = 1, .reusable = true}, SHIFT(4125),
  [9284] = {.count = 1, .reusable = true}, SHIFT(4127),
  [9286] = {.count = 1, .reusable = false}, SHIFT(4129),
  [9288] = {.count = 1, .reusable = true}, SHIFT(4129),
  [9290] = {.count = 1, .reusable = true}, SHIFT(4128),
  [9292] = {.count = 1, .reusable = true}, SHIFT(4130),
  [9294] = {.count = 1, .reusable = true}, SHIFT(4131),
  [9296] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3508),
  [9299] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3509),
  [9302] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3510),
  [9305] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3511),
  [9308] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3512),
  [9311] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3513),
  [9314] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3514),
  [9317] = {.count = 2, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3515),
  [9320] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3883),
  [9323] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(3511),
  [9326] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(3884),
  [9329] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(3518),
  [9332] = {.count = 1, .reusable = false}, SHIFT(4132),
  [9334] = {.count = 1, .reusable = true}, SHIFT(4133),
  [9336] = {.count = 1, .reusable = true}, SHIFT(4134),
  [9338] = {.count = 1, .reusable = true}, SHIFT(4137),
  [9340] = {.count = 1, .reusable = true}, SHIFT(4138),
  [9342] = {.count = 1, .reusable = false}, SHIFT(4140),
  [9344] = {.count = 1, .reusable = true}, SHIFT(4140),
  [9346] = {.count = 1, .reusable = true}, SHIFT(4139),
  [9348] = {.count = 1, .reusable = false}, SHIFT(4142),
  [9350] = {.count = 1, .reusable = true}, SHIFT(4142),
  [9352] = {.count = 1, .reusable = true}, SHIFT(4141),
  [9354] = {.count = 1, .reusable = true}, SHIFT(4143),
  [9356] = {.count = 1, .reusable = true}, SHIFT(4144),
  [9358] = {.count = 1, .reusable = false}, SHIFT(4145),
  [9360] = {.count = 1, .reusable = true}, SHIFT(4145),
  [9362] = {.count = 1, .reusable = true}, SHIFT(4146),
  [9364] = {.count = 1, .reusable = true}, SHIFT(4147),
  [9366] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(3535),
  [9369] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(3539),
  [9372] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(3539),
  [9375] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(3540),
  [9378] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3543),
  [9381] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3028),
  [9384] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3029),
  [9387] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3030),
  [9390] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3544),
  [9393] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3032),
  [9396] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3033),
  [9399] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3034),
  [9402] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3035),
  [9405] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(3544),
  [9408] = {.count = 1, .reusable = false}, SHIFT(4151),
  [9410] = {.count = 1, .reusable = true}, SHIFT(4151),
  [9412] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5),
  [9414] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5),
  [9416] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5),
  [9418] = {.count = 1, .reusable = true}, SHIFT(4152),
  [9420] = {.count = 1, .reusable = true}, SHIFT(4157),
  [9422] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5, .alias_sequence_id = 1),
  [9424] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [9426] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [9428] = {.count = 1, .reusable = true}, SHIFT(4159),
  [9430] = {.count = 1, .reusable = true}, SHIFT(4160),
  [9432] = {.count = 1, .reusable = true}, SHIFT(4162),
  [9434] = {.count = 1, .reusable = true}, SHIFT(4163),
  [9436] = {.count = 1, .reusable = true}, SHIFT(4164),
  [9438] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 10),
  [9440] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 10),
  [9442] = {.count = 1, .reusable = true}, SHIFT(4166),
  [9444] = {.count = 1, .reusable = true}, SHIFT(4167),
  [9446] = {.count = 1, .reusable = true}, SHIFT(4168),
  [9448] = {.count = 1, .reusable = false}, SHIFT(4169),
  [9450] = {.count = 1, .reusable = true}, SHIFT(4169),
  [9452] = {.count = 1, .reusable = false}, SHIFT(4170),
  [9454] = {.count = 1, .reusable = true}, SHIFT(4170),
  [9456] = {.count = 1, .reusable = true}, SHIFT(4171),
  [9458] = {.count = 1, .reusable = true}, SHIFT(4172),
  [9460] = {.count = 1, .reusable = true}, SHIFT(4173),
  [9462] = {.count = 1, .reusable = true}, SHIFT(4174),
  [9464] = {.count = 1, .reusable = true}, SHIFT(4175),
  [9466] = {.count = 1, .reusable = true}, SHIFT(4176),
  [9468] = {.count = 1, .reusable = true}, SHIFT(4177),
  [9470] = {.count = 1, .reusable = true}, SHIFT(4178),
  [9472] = {.count = 1, .reusable = false}, SHIFT(4179),
  [9474] = {.count = 1, .reusable = true}, SHIFT(4179),
  [9476] = {.count = 1, .reusable = false}, SHIFT(4180),
  [9478] = {.count = 1, .reusable = true}, SHIFT(4180),
  [9480] = {.count = 1, .reusable = true}, SHIFT(4181),
  [9482] = {.count = 1, .reusable = true}, SHIFT(4182),
  [9484] = {.count = 1, .reusable = true}, SHIFT(4183),
  [9486] = {.count = 1, .reusable = true}, SHIFT(4184),
  [9488] = {.count = 1, .reusable = false}, SHIFT(4185),
  [9490] = {.count = 1, .reusable = true}, SHIFT(4185),
  [9492] = {.count = 1, .reusable = false}, SHIFT(4186),
  [9494] = {.count = 1, .reusable = true}, SHIFT(4186),
  [9496] = {.count = 1, .reusable = true}, SHIFT(4187),
  [9498] = {.count = 1, .reusable = true}, SHIFT(4188),
  [9500] = {.count = 1, .reusable = true}, SHIFT(4189),
  [9502] = {.count = 1, .reusable = true}, SHIFT(4190),
  [9504] = {.count = 1, .reusable = true}, SHIFT(4193),
  [9506] = {.count = 1, .reusable = true}, SHIFT(4194),
  [9508] = {.count = 1, .reusable = false}, SHIFT(4195),
  [9510] = {.count = 1, .reusable = true}, SHIFT(4195),
  [9512] = {.count = 1, .reusable = true}, SHIFT(4196),
  [9514] = {.count = 1, .reusable = false}, SHIFT(4197),
  [9516] = {.count = 1, .reusable = true}, SHIFT(4197),
  [9518] = {.count = 1, .reusable = true}, SHIFT(4198),
  [9520] = {.count = 1, .reusable = false}, SHIFT(4199),
  [9522] = {.count = 1, .reusable = true}, SHIFT(4199),
  [9524] = {.count = 1, .reusable = true}, SHIFT(4200),
  [9526] = {.count = 1, .reusable = true}, SHIFT(4201),
  [9528] = {.count = 1, .reusable = true}, SHIFT(4202),
  [9530] = {.count = 1, .reusable = false}, SHIFT(4203),
  [9532] = {.count = 1, .reusable = true}, SHIFT(4203),
  [9534] = {.count = 1, .reusable = false}, SHIFT(4204),
  [9536] = {.count = 1, .reusable = true}, SHIFT(4204),
  [9538] = {.count = 1, .reusable = true}, SHIFT(4205),
  [9540] = {.count = 1, .reusable = true}, SHIFT(4206),
  [9542] = {.count = 1, .reusable = true}, SHIFT(4207),
  [9544] = {.count = 1, .reusable = true}, SHIFT(4208),
  [9546] = {.count = 1, .reusable = false}, SHIFT(4209),
  [9548] = {.count = 1, .reusable = true}, SHIFT(4209),
  [9550] = {.count = 1, .reusable = false}, SHIFT(4210),
  [9552] = {.count = 1, .reusable = true}, SHIFT(4210),
  [9554] = {.count = 1, .reusable = true}, SHIFT(4211),
  [9556] = {.count = 1, .reusable = true}, SHIFT(4212),
  [9558] = {.count = 1, .reusable = true}, SHIFT(4213),
  [9560] = {.count = 1, .reusable = true}, SHIFT(4214),
  [9562] = {.count = 1, .reusable = true}, SHIFT(4215),
  [9564] = {.count = 1, .reusable = true}, SHIFT(4216),
  [9566] = {.count = 1, .reusable = true}, SHIFT(4217),
  [9568] = {.count = 1, .reusable = true}, SHIFT(4218),
  [9570] = {.count = 1, .reusable = true}, SHIFT(4219),
  [9572] = {.count = 1, .reusable = false}, SHIFT(4221),
  [9574] = {.count = 1, .reusable = false}, SHIFT(4222),
  [9576] = {.count = 1, .reusable = true}, SHIFT(4223),
  [9578] = {.count = 1, .reusable = true}, SHIFT(4224),
  [9580] = {.count = 1, .reusable = true}, SHIFT(4225),
  [9582] = {.count = 1, .reusable = false}, SHIFT(4226),
  [9584] = {.count = 1, .reusable = true}, SHIFT(4226),
  [9586] = {.count = 1, .reusable = true}, SHIFT(4227),
  [9588] = {.count = 1, .reusable = false}, SHIFT(4229),
  [9590] = {.count = 1, .reusable = true}, SHIFT(4229),
  [9592] = {.count = 1, .reusable = true}, SHIFT(4228),
  [9594] = {.count = 1, .reusable = true}, SHIFT(4230),
  [9596] = {.count = 1, .reusable = false}, SHIFT(4232),
  [9598] = {.count = 1, .reusable = true}, SHIFT(4232),
  [9600] = {.count = 1, .reusable = true}, SHIFT(4231),
  [9602] = {.count = 1, .reusable = true}, SHIFT(4233),
  [9604] = {.count = 1, .reusable = true}, SHIFT(4234),
  [9606] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(4094),
  [9609] = {.count = 1, .reusable = true}, SHIFT(4235),
  [9611] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(3848),
  [9614] = {.count = 1, .reusable = false}, SHIFT(4237),
  [9616] = {.count = 1, .reusable = true}, SHIFT(4238),
  [9618] = {.count = 1, .reusable = true}, SHIFT(4239),
  [9620] = {.count = 1, .reusable = true}, SHIFT(4242),
  [9622] = {.count = 1, .reusable = true}, SHIFT(4243),
  [9624] = {.count = 1, .reusable = false}, SHIFT(4245),
  [9626] = {.count = 1, .reusable = true}, SHIFT(4245),
  [9628] = {.count = 1, .reusable = true}, SHIFT(4244),
  [9630] = {.count = 1, .reusable = false}, SHIFT(4247),
  [9632] = {.count = 1, .reusable = true}, SHIFT(4247),
  [9634] = {.count = 1, .reusable = true}, SHIFT(4246),
  [9636] = {.count = 1, .reusable = true}, SHIFT(4248),
  [9638] = {.count = 1, .reusable = true}, SHIFT(4249),
  [9640] = {.count = 1, .reusable = false}, SHIFT(4250),
  [9642] = {.count = 1, .reusable = true}, SHIFT(4250),
  [9644] = {.count = 1, .reusable = true}, SHIFT(4251),
  [9646] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(3867),
  [9649] = {.count = 1, .reusable = false}, SHIFT(4252),
  [9651] = {.count = 1, .reusable = true}, SHIFT(4253),
  [9653] = {.count = 1, .reusable = true}, SHIFT(4254),
  [9655] = {.count = 1, .reusable = true}, SHIFT(4257),
  [9657] = {.count = 1, .reusable = true}, SHIFT(4258),
  [9659] = {.count = 1, .reusable = false}, SHIFT(4260),
  [9661] = {.count = 1, .reusable = true}, SHIFT(4260),
  [9663] = {.count = 1, .reusable = true}, SHIFT(4259),
  [9665] = {.count = 1, .reusable = false}, SHIFT(4262),
  [9667] = {.count = 1, .reusable = true}, SHIFT(4262),
  [9669] = {.count = 1, .reusable = true}, SHIFT(4261),
  [9671] = {.count = 1, .reusable = true}, SHIFT(4263),
  [9673] = {.count = 1, .reusable = true}, SHIFT(4264),
  [9675] = {.count = 1, .reusable = false}, SHIFT(4265),
  [9677] = {.count = 1, .reusable = true}, SHIFT(4265),
  [9679] = {.count = 1, .reusable = true}, SHIFT(4266),
  [9681] = {.count = 1, .reusable = true}, SHIFT(4267),
  [9683] = {.count = 1, .reusable = true}, SHIFT(4268),
  [9685] = {.count = 1, .reusable = true}, SHIFT(4269),
  [9687] = {.count = 1, .reusable = true}, SHIFT(4272),
  [9689] = {.count = 1, .reusable = true}, SHIFT(4273),
  [9691] = {.count = 1, .reusable = false}, SHIFT(4274),
  [9693] = {.count = 1, .reusable = true}, SHIFT(4274),
  [9695] = {.count = 1, .reusable = true}, SHIFT(4275),
  [9697] = {.count = 1, .reusable = false}, SHIFT(4276),
  [9699] = {.count = 1, .reusable = true}, SHIFT(4276),
  [9701] = {.count = 1, .reusable = true}, SHIFT(4277),
  [9703] = {.count = 1, .reusable = false}, SHIFT(4278),
  [9705] = {.count = 1, .reusable = true}, SHIFT(4278),
  [9707] = {.count = 1, .reusable = true}, SHIFT(4281),
  [9709] = {.count = 1, .reusable = true}, SHIFT(4282),
  [9711] = {.count = 1, .reusable = true}, SHIFT(4284),
  [9713] = {.count = 1, .reusable = true}, SHIFT(4285),
  [9715] = {.count = 1, .reusable = true}, SHIFT(4286),
  [9717] = {.count = 1, .reusable = true}, SHIFT(4287),
  [9719] = {.count = 1, .reusable = true}, SHIFT(4288),
  [9721] = {.count = 1, .reusable = true}, SHIFT(4289),
  [9723] = {.count = 1, .reusable = true}, SHIFT(4290),
  [9725] = {.count = 1, .reusable = true}, SHIFT(4291),
  [9727] = {.count = 1, .reusable = true}, SHIFT(4292),
  [9729] = {.count = 1, .reusable = false}, SHIFT(4293),
  [9731] = {.count = 1, .reusable = true}, SHIFT(4293),
  [9733] = {.count = 1, .reusable = false}, SHIFT(4294),
  [9735] = {.count = 1, .reusable = true}, SHIFT(4294),
  [9737] = {.count = 1, .reusable = true}, SHIFT(4295),
  [9739] = {.count = 1, .reusable = true}, SHIFT(4296),
  [9741] = {.count = 1, .reusable = true}, SHIFT(4297),
  [9743] = {.count = 1, .reusable = true}, SHIFT(4298),
  [9745] = {.count = 1, .reusable = true}, SHIFT(4299),
  [9747] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(4078),
  [9750] = {.count = 1, .reusable = false}, SHIFT(4300),
  [9752] = {.count = 1, .reusable = true}, SHIFT(4301),
  [9754] = {.count = 1, .reusable = true}, SHIFT(4302),
  [9756] = {.count = 1, .reusable = true}, SHIFT(4305),
  [9758] = {.count = 1, .reusable = true}, SHIFT(4306),
  [9760] = {.count = 1, .reusable = false}, SHIFT(4308),
  [9762] = {.count = 1, .reusable = true}, SHIFT(4308),
  [9764] = {.count = 1, .reusable = true}, SHIFT(4307),
  [9766] = {.count = 1, .reusable = false}, SHIFT(4310),
  [9768] = {.count = 1, .reusable = true}, SHIFT(4310),
  [9770] = {.count = 1, .reusable = true}, SHIFT(4309),
  [9772] = {.count = 1, .reusable = true}, SHIFT(4311),
  [9774] = {.count = 1, .reusable = true}, SHIFT(4312),
  [9776] = {.count = 1, .reusable = false}, SHIFT(4313),
  [9778] = {.count = 1, .reusable = true}, SHIFT(4313),
  [9780] = {.count = 1, .reusable = true}, SHIFT(4314),
  [9782] = {.count = 1, .reusable = true}, SHIFT(4315),
  [9784] = {.count = 1, .reusable = true}, SHIFT(4316),
  [9786] = {.count = 1, .reusable = true}, SHIFT(4317),
  [9788] = {.count = 1, .reusable = true}, SHIFT(4318),
  [9790] = {.count = 1, .reusable = true}, SHIFT(4321),
  [9792] = {.count = 1, .reusable = true}, SHIFT(4322),
  [9794] = {.count = 1, .reusable = false}, SHIFT(4323),
  [9796] = {.count = 1, .reusable = true}, SHIFT(4323),
  [9798] = {.count = 1, .reusable = true}, SHIFT(4324),
  [9800] = {.count = 1, .reusable = false}, SHIFT(4325),
  [9802] = {.count = 1, .reusable = true}, SHIFT(4325),
  [9804] = {.count = 1, .reusable = true}, SHIFT(4326),
  [9806] = {.count = 1, .reusable = false}, SHIFT(4327),
  [9808] = {.count = 1, .reusable = true}, SHIFT(4327),
  [9810] = {.count = 1, .reusable = true}, SHIFT(4328),
  [9812] = {.count = 1, .reusable = true}, SHIFT(4329),
  [9814] = {.count = 1, .reusable = true}, SHIFT(4330),
  [9816] = {.count = 1, .reusable = true}, SHIFT(4333),
  [9818] = {.count = 1, .reusable = true}, SHIFT(4334),
  [9820] = {.count = 1, .reusable = false}, SHIFT(4335),
  [9822] = {.count = 1, .reusable = true}, SHIFT(4335),
  [9824] = {.count = 1, .reusable = true}, SHIFT(4336),
  [9826] = {.count = 1, .reusable = false}, SHIFT(4337),
  [9828] = {.count = 1, .reusable = true}, SHIFT(4337),
  [9830] = {.count = 1, .reusable = true}, SHIFT(4338),
  [9832] = {.count = 1, .reusable = false}, SHIFT(4339),
  [9834] = {.count = 1, .reusable = true}, SHIFT(4339),
  [9836] = {.count = 1, .reusable = true}, SHIFT(4340),
  [9838] = {.count = 1, .reusable = true}, SHIFT(4341),
  [9840] = {.count = 1, .reusable = true}, SHIFT(4342),
  [9842] = {.count = 1, .reusable = false}, SHIFT(4343),
  [9844] = {.count = 1, .reusable = true}, SHIFT(4343),
  [9846] = {.count = 1, .reusable = false}, SHIFT(4344),
  [9848] = {.count = 1, .reusable = true}, SHIFT(4344),
  [9850] = {.count = 1, .reusable = true}, SHIFT(4345),
  [9852] = {.count = 1, .reusable = true}, SHIFT(4346),
  [9854] = {.count = 1, .reusable = true}, SHIFT(4347),
  [9856] = {.count = 1, .reusable = true}, SHIFT(4348),
  [9858] = {.count = 1, .reusable = true}, SHIFT(4349),
  [9860] = {.count = 1, .reusable = true}, SHIFT(4350),
  [9862] = {.count = 1, .reusable = true}, SHIFT(4353),
  [9864] = {.count = 1, .reusable = true}, SHIFT(4354),
  [9866] = {.count = 1, .reusable = false}, SHIFT(4355),
  [9868] = {.count = 1, .reusable = true}, SHIFT(4355),
  [9870] = {.count = 1, .reusable = true}, SHIFT(4356),
  [9872] = {.count = 1, .reusable = false}, SHIFT(4357),
  [9874] = {.count = 1, .reusable = true}, SHIFT(4357),
  [9876] = {.count = 1, .reusable = true}, SHIFT(4358),
  [9878] = {.count = 1, .reusable = false}, SHIFT(4359),
  [9880] = {.count = 1, .reusable = true}, SHIFT(4359),
  [9882] = {.count = 1, .reusable = true}, SHIFT(4360),
  [9884] = {.count = 1, .reusable = true}, SHIFT(4361),
  [9886] = {.count = 1, .reusable = true}, SHIFT(4362),
  [9888] = {.count = 1, .reusable = false}, SHIFT(4363),
  [9890] = {.count = 1, .reusable = true}, SHIFT(4363),
  [9892] = {.count = 1, .reusable = false}, SHIFT(4364),
  [9894] = {.count = 1, .reusable = true}, SHIFT(4364),
  [9896] = {.count = 1, .reusable = true}, SHIFT(4365),
  [9898] = {.count = 1, .reusable = true}, SHIFT(4366),
  [9900] = {.count = 1, .reusable = true}, SHIFT(4367),
  [9902] = {.count = 1, .reusable = true}, SHIFT(4368),
  [9904] = {.count = 1, .reusable = false}, SHIFT(4369),
  [9906] = {.count = 1, .reusable = true}, SHIFT(4369),
  [9908] = {.count = 1, .reusable = false}, SHIFT(4370),
  [9910] = {.count = 1, .reusable = true}, SHIFT(4370),
  [9912] = {.count = 1, .reusable = true}, SHIFT(4371),
  [9914] = {.count = 1, .reusable = true}, SHIFT(4372),
  [9916] = {.count = 1, .reusable = true}, SHIFT(4373),
  [9918] = {.count = 1, .reusable = true}, SHIFT(4374),
  [9920] = {.count = 1, .reusable = true}, SHIFT(4375),
  [9922] = {.count = 1, .reusable = true}, SHIFT(4376),
  [9924] = {.count = 1, .reusable = false}, SHIFT(4377),
  [9926] = {.count = 1, .reusable = true}, SHIFT(4377),
  [9928] = {.count = 1, .reusable = false}, SHIFT(4378),
  [9930] = {.count = 1, .reusable = true}, SHIFT(4378),
  [9932] = {.count = 1, .reusable = true}, SHIFT(4379),
  [9934] = {.count = 1, .reusable = true}, SHIFT(4380),
  [9936] = {.count = 1, .reusable = true}, SHIFT(4381),
  [9938] = {.count = 1, .reusable = true}, SHIFT(4382),
  [9940] = {.count = 1, .reusable = true}, SHIFT(4383),
  [9942] = {.count = 1, .reusable = true}, SHIFT(4384),
  [9944] = {.count = 1, .reusable = true}, SHIFT(4385),
};

void *tree_sitter_bash_external_scanner_create();
void tree_sitter_bash_external_scanner_destroy(void *);
bool tree_sitter_bash_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_bash_external_scanner_serialize(void *, char *);
void tree_sitter_bash_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_bash() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_word,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_bash_external_scanner_create,
      tree_sitter_bash_external_scanner_destroy,
      tree_sitter_bash_external_scanner_scan,
      tree_sitter_bash_external_scanner_serialize,
      tree_sitter_bash_external_scanner_deserialize,
    },
  };
  return &language;
}
